CityUILayer   = class("CityUILayer")
CityUILayer._name = "CityUILayer"
CityUILayer._state= {}
CityUILayer.playMsg = false
CityUILayer._lastMusic = 0
CityUILayer._lastMusicID = 912

CityUILayer._gold = nil
CityUILayer._goldbtn = nil
CityUILayer._hxd = nil
CityUILayer._TipsAction = nil
CityUILayer._TipsAction2 = nil

require "city/dealQue"
require "city/popLayer"
require "city/dealChat"
require "world/worldControl"
require "city/dealGiftNotice"
if ff.platform ~= 1 then
    if ff.apk_version >= 1220 then
        require "ui/gamebing"
    end
end

function CityUILayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, CityUILayer)
    return target
end
--测试
local test = 1
function CityUILayer.onTest(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     

        
        local function callback()
            cclog("callback")
        end
        platform_showDialog("测试标题","测试java窗体。。。。。。",1,callback)
    end 
end
--消息
function CityUILayer:initEvent()
    ff.net:bindProperty(101,"power",self.updatePower)
    ff.net:bindProperty(101,"vip",self.updateVip)
    ff.net:bindProperty(101,"wood",self.updateWood)
    ff.net:bindProperty(101,"stone",self.updateStone)    
    ff.net:bindProperty(101,"iron",self.updateIron)    
    ff.net:bindProperty(101,"food",self.updateFood)    
    ff.net:bindProperty(101,"silver",self.updateSilver)    
    ff.net:bindProperty(101,"gold",self.updateGold)    
    ff.net:bindProperty(101,"face",self.updateFace)    
    --监控mylists被删除
    ff.net:bindDelTable(101,1001,self.delQueue)        

    --注册消息
    ff.net:registerEvent(1,dd.Tjf_CHAT_GETMESSAGE,self.onChatMessage)
    ff.net:registerEvent(3,dd.Tjf_task_take_bonus,self.onUpdateTask)
    ff.net:registerEvent(3,dd.Tjf_notify_SNTaskNewbie,self.onUpdateTask)
    ff.net:registerEvent(1,dd.Tjf_GetLuckyGoldDetail,function (message)self:onGetLuckyGoldDetail(message)end)
    
    --ff.net:registerEvent(3,dd.Tjf_ItemExchange,self.onItemExchange)
    
    


    --几个系统按钮的事件
    local listener = cc.EventListenerKeyboard:create()
    listener:registerScriptHandler(dd.onReleasKey, cc.Handler.EVENT_KEYBOARD_RELEASED )

    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener, self)    
end
function CityUILayer:initIco(  )
    local btn = self:getChildByName("bottom"):getChildByName("btns")
    if btn ~= nil then
        if dd.HolidayAppearance == 5 then
            btn:getChildByName("quests"):getChildByName("icon"):loadTexture("images/active/menu01.png",0)
            btn:getChildByName("items"):getChildByName("icon"):loadTexture("images/active/menu02.png",0)
            btn:getChildByName("alliance"):getChildByName("icon"):loadTexture("images/active/menu03.png",0)
            btn:getChildByName("mail"):getChildByName("icon"):loadTexture("images/active/menu04.png",0)
            btn:getChildByName("setting"):getChildByName("icon"):loadTexture("images/active/menu05.png",0)
            --btn:getChildByName("rank"):getChildByName("icon"):loadTexture("images/active/menu07.png",0)
            --self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("ico"):loadTexture("images/active/ico.png",0)
            local sp = cc.Sprite:create("images/active/tengman1.png") 
            sp:setPosition(cc.p(0,160))
            sp:setAnchorPoint(0, 0)
            if self:getChildByName("bottom"):getChildByTag(88888) == nil then
                self:getChildByName("bottom"):addChild(sp,99,88888)
            end
            local sp1 = cc.Sprite:create("images/active/tengman2.png") 
            sp1:setPosition(cc.p(0,73))
            sp1:setAnchorPoint(0, 0)
            if self:getChildByName("bottom"):getChildByTag(88887) == nil then
               
                self:getChildByName("bottom"):addChild(sp1,99,88887)
            end
        elseif dd.HolidayAppearance == 2 then
            btn:getChildByName("quests"):getChildByName("icon"):loadTexture("images/active/menu01.png",0)
            btn:getChildByName("items"):getChildByName("icon"):loadTexture("images/active/menu02.png",0)
            btn:getChildByName("alliance"):getChildByName("icon"):loadTexture("images/active/menu03.png",0)
            btn:getChildByName("mail"):getChildByName("icon"):loadTexture("images/active/menu04.png",0)
            btn:getChildByName("setting"):getChildByName("icon"):loadTexture("images/active/menu05.png",0)
            btn:getChildByName("rank"):getChildByName("icon"):loadTexture("images/active/menu07.png",0)
            local snow = cc.ParticleSnow:create()
            snow:setPosition(cc.p(360,dd.mainUI:getChildByName("mapArea"):getContentSize().height+150));
            snow:setTextureWithRect("images/active/snow.png",cc.rect(0,0,32,32))
            dd.mainUI:getChildByName("mapArea"):addChild(snow)
            local sp = cc.Sprite:create("images/active/xue1.png") 
            sp:setPosition(cc.p(0,178))
            sp:setAnchorPoint(0, 0)
            if self:getChildByName("bottom"):getChildByTag(88888) == nil then
                self:getChildByName("bottom"):addChild(sp,99,88888)
            end
            local sp1 = cc.Sprite:create("images/active/xue2.png") 
            sp1:setPosition(cc.p(0,110))
            sp1:setAnchorPoint(0, 0)
            if self:getChildByName("bottom"):getChildByTag(88887) == nil then
               
                self:getChildByName("bottom"):addChild(sp1,99,88887)
            end
            local sp2 = cc.Sprite:create("images/active/xue3.png") 
            sp2:setPosition(cc.p(612,127))
            sp2:setAnchorPoint(0, 0)
            if self:getChildByName("action"):getChildByTag(88886) == nil then
               
                self:getChildByName("action"):addChild(sp2,99,88886)
            end
            local sp3 = cc.Sprite:create("images/active/xue4.png") 
            sp3:setPosition(cc.p(13,-10))
            sp3:setAnchorPoint(0, 0)
            if self:getChildByName("action"):getChildByName("navi"):getChildByName("queue1"):getChildByTag(88886) == nil then
               
                self:getChildByName("action"):getChildByName("navi"):getChildByName("queue1"):addChild(sp3,99,88886)
            end
            local sp4 = cc.Sprite:create("images/active/xue4.png") 
            sp4:setPosition(cc.p(13,-10))
            sp4:setAnchorPoint(0, 0)
            if self:getChildByName("action"):getChildByName("navi"):getChildByName("queue2"):getChildByTag(88886) == nil then
               
                self:getChildByName("action"):getChildByName("navi"):getChildByName("queue2"):addChild(sp4,99,88886)
            end
            local sp5 = cc.Sprite:create("images/active/xue4.png") 
            sp5:setPosition(cc.p(13,-10))
            sp5:setAnchorPoint(0, 0)
            if self:getChildByName("action"):getChildByName("navi"):getChildByName("queue3"):getChildByTag(88886) == nil then
               
                self:getChildByName("action"):getChildByName("navi"):getChildByName("queue3"):addChild(sp5,99,88886)
            end
         
        elseif dd.HolidayAppearance == 3 then
            btn:getChildByName("quests"):getChildByName("icon"):loadTexture("images/active/menu014.png",0)
            btn:getChildByName("items"):getChildByName("icon"):loadTexture("images/active/menu024.png",0)
            btn:getChildByName("alliance"):getChildByName("icon"):loadTexture("images/active/menu034.png",0)
            btn:getChildByName("mail"):getChildByName("icon"):loadTexture("images/active/menu044.png",0)
            btn:getChildByName("setting"):getChildByName("icon"):loadTexture("images/active/menu054.png",0)
           -- btn:getChildByName("rank"):getChildByName("icon"):loadTexture("images/active/menu073.png",0)

            local sp = cc.Sprite:create("images/active/fuhuo1.png") 
            sp:setPosition(cc.p(0,165))
            sp:setAnchorPoint(0, 0)
            if self:getChildByName("bottom"):getChildByTag(88888) == nil then
                self:getChildByName("bottom"):addChild(sp,99,88888)
            end
            local sp1 = cc.Sprite:create("images/active/fuhuo2.png") 
            sp1:setPosition(cc.p(0,40))
            sp1:setAnchorPoint(0, 0)
            if self:getChildByName("bottom"):getChildByTag(88887) == nil then
               
                self:getChildByName("bottom"):addChild(sp1,99,88887)
            end
           -- btn:getChildByName("quests"):getChildByName("icon"):loadTexture("images/active/menu013.png",0)
           --  btn:getChildByName("items"):getChildByName("icon"):loadTexture("images/active/menu023.png",0)
           --  btn:getChildByName("alliance"):getChildByName("icon"):loadTexture("images/active/menu033.png",0)
           --  btn:getChildByName("mail"):getChildByName("icon"):loadTexture("images/active/menu043.png",0)
           --  btn:getChildByName("setting"):getChildByName("icon"):loadTexture("images/active/menu053.png",0)
           -- -- btn:getChildByName("rank"):getChildByName("icon"):loadTexture("images/active/menu073.png",0)

           --  local sp = cc.Sprite:create("images/active/love1.png") 
           --  sp:setPosition(cc.p(0,160))
           --  sp:setAnchorPoint(0, 0)
           --  if self:getChildByName("bottom"):getChildByTag(88888) == nil then
           --      self:getChildByName("bottom"):addChild(sp,99,88888)
           --  end
           --  local sp1 = cc.Sprite:create("images/active/love2.png") 
           --  sp1:setPosition(cc.p(0,73))
           --  sp1:setAnchorPoint(0, 0)
           --  if self:getChildByName("bottom"):getChildByTag(88887) == nil then
               
           --      self:getChildByName("bottom"):addChild(sp1,99,88887)
           --  end
            -- btn:getChildByName("quests"):getChildByName("icon"):loadTexture("images/active/menu01.png",0)
            -- btn:getChildByName("items"):getChildByName("icon"):loadTexture("images/active/menu02.png",0)
            -- btn:getChildByName("alliance"):getChildByName("icon"):loadTexture("images/active/menu03.png",0)
            -- btn:getChildByName("mail"):getChildByName("icon"):loadTexture("images/active/menu04.png",0)
            -- btn:getChildByName("setting"):getChildByName("icon"):loadTexture("images/active/menu05.png",0)
            -- --btn:getChildByName("rank"):getChildByName("icon"):loadTexture("images/active/menu07.png",0)
            -- --self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("ico"):loadTexture("images/active/ico.png",0)
            -- local sp = cc.Sprite:create("images/active/tengman1.png") 
            -- sp:setPosition(cc.p(0,160))
            -- sp:setAnchorPoint(0, 0)
            -- if self:getChildByName("bottom"):getChildByTag(88888) == nil then
            --     self:getChildByName("bottom"):addChild(sp,99,88888)
            -- end
            -- local sp1 = cc.Sprite:create("images/active/tengman2.png") 
            -- sp1:setPosition(cc.p(0,40))
            -- sp1:setAnchorPoint(0, 0)
            -- if self:getChildByName("bottom"):getChildByTag(88887) == nil then
               
            --     self:getChildByName("bottom"):addChild(sp1,99,88887)
            -- end
        elseif dd.HolidayAppearance == 4 then
            btn:getChildByName("quests"):getChildByName("icon"):loadTexture("images/active/menu015.png",0)
            btn:getChildByName("items"):getChildByName("icon"):loadTexture("images/active/menu025.png",0)
            btn:getChildByName("alliance"):getChildByName("icon"):loadTexture("images/active/menu035.png",0)
            btn:getChildByName("mail"):getChildByName("icon"):loadTexture("images/active/menu045.png",0)
            btn:getChildByName("setting"):getChildByName("icon"):loadTexture("images/active/menu055.png",0)
           
            local sp = cc.Sprite:create("images/active/mather1.png") 
            sp:setPosition(cc.p(0,165))
            sp:setAnchorPoint(0, 0)
            if self:getChildByName("bottom"):getChildByTag(88888) == nil then
                self:getChildByName("bottom"):addChild(sp,99,88888)
            end
            local sp1 = cc.Sprite:create("images/active/mather2.png") 
            sp1:setPosition(cc.p(0,73))
            sp1:setAnchorPoint(0, 0)
            if self:getChildByName("bottom"):getChildByTag(88887) == nil then
                self:getChildByName("bottom"):addChild(sp1,99,88887)
            end
            --local snow = cc.ParticleRain:create()
            --snow:setPosition(cc.p(360,dd.mainUI:getChildByName("mapArea"):getContentSize().height+150));
            --snow:setTextureWithRect("images/active/snow.png",cc.rect(0,0,25,25))
            --snow:setGravity(cc.p(0, -240))
            --snow:setTotalParticles(500)
            --dd.mainUI:getChildByName("mapArea"):addChild(snow)
        end
    end
    -- body
end
--资源部分
function CityUILayer:updateRes()
    self:setFood()
    self:setIron()
    self:setStone()
    self:setWood()
    self:setGold()
    self:setSilver()
    self:setPower()
    self:setVip()
    self:setFace()
    self:setHP()
end

function CityUILayer:setHP()
    local actice = 0
    local show = false
    local plus_552 = 0
    for i=1,dd.myeffect:rowCount() do
        --cclog("=111111111112=="..dd.myplus:getLong(i,"id"))
        if dd.myeffect:getLong(i,"id") == 552 then
            plus_552 = dd.myeffect:getLong(i,"param")
            show = true
            break
        end
    end
    local time = 360
    if show == true then
        time =  time / (1 + plus_552 / 1000)
    end
    --cclog("=12222233=="..time.."=="..plus_552)
    local point = (dd.getServerTime() -  dd.myinfo:getLong(1,"ActiveTime")) / time

    actice =math.floor(point)+ dd.myinfo:getLong(1,"NowActive")
    if actice > dd.myinfo:getLong(1,"MaxActive") then
        if dd.myinfo:getLong(1,"NowActive") > dd.myinfo:getLong(1,"MaxActive")  then
            actice = dd.myinfo:getLong(1,"NowActive") 
        else
            actice = dd.myinfo:getLong(1,"MaxActive") 
        end
    end

    local per = actice * 100 / dd.myinfo:getLong(1,"MaxActive")
    if per > 100 then
        per = 100
    end 
    self:getChildByName("top"):getChildByName("header"):getChildByName("hp_bar"):setPercent(per)
    
end

function CityUILayer:setFood(num)
    if num == nil then
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("food"):setString(dd.showKM(dd.food(),5))
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("food"):setColor(cc.c3b(255,255,255))
    else
        local item = self:getChildByName("top"):getChildByName("resArea"):getChildByName("food")
        if item.value == nil then
            item.value = num
        else
            item.value = item.value + num
        end
        item.step = math.ceil(item.value/10)
        item.color= 1
        cclog("step:"..item.step)
        local function update()
            cclog("update food")
            local temp = item.value
            local step = item.step
            local color= item.color
            if item.color == 0 then
                item.color = 1
            else
                item.color = 0
            end
            if step > 0 then
                local value = temp - step
                if value <= 0 then
                    item.color = 0
                    item:stopAllActions()
                    item:setString(dd.showKM(dd.food(),5))        
                else
                    item.value = value
                    item:setString(dd.showKM(dd.food() - value,5))                                                
                end
            else
                item.color = 0
                item:stopAllActions()
                item:setString(dd.showKM(dd.food(),5))        
            end

            if item.color == 1 then
                item:setColor(cc.c3b(7,159,0))
            else
                item:setColor(cc.c3b(255,255,255))
            end
        end
        item:stopAllActions()
        schedule(item,update,0.1)
        self:addResLabel(26,num)
    end
end
function CityUILayer:setIron(num)
    if num == nil then
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("iron"):setString(dd.showKM(dd.iron(),5))
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("iron"):setColor(cc.c3b(255,255,255))
    else
        local item = self:getChildByName("top"):getChildByName("resArea"):getChildByName("iron")
        if item.value == nil then
            item.value = num
        else
            item.value = item.value + num
        end
        item.step = math.ceil(item.value/10)
        item.color= 1
        cclog("step:"..item.step)
        local function update()
            cclog("update iron")
            local temp = item.value
            local step = item.step
            local color= item.color
            if item.color == 0 then
                item.color = 1
            else
                item.color = 0
            end
            if step > 0 then
                local value = temp - step
                if value <= 0 then
                    item.color = 0
                    item:stopAllActions()
                    item:setString(dd.showKM(dd.iron(),5))        
                else
                    item.value = value
                    item:setString(dd.showKM(dd.iron() - value,5))                                                
                end
            else
                item.color = 0
                item:stopAllActions()
                item:setString(dd.showKM(dd.iron(),5))        
            end

            if item.color == 1 then
                item:setColor(cc.c3b(7,159,0))
            else
                item:setColor(cc.c3b(255,255,255))
            end
        end
        item:stopAllActions()
        schedule(item,update,0.1)
        self:addResLabel(25,num)
    end
end
function CityUILayer:setStone(num)
    if num == nil then
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("stone"):setString(dd.showKM(dd.stone(),5))
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("stone"):setColor(cc.c3b(255,255,255))
    else
        local item = self:getChildByName("top"):getChildByName("resArea"):getChildByName("stone")
        if item.value == nil then
            item.value = num
        else
            item.value = item.value + num
        end
        item.step = math.ceil(item.value/10)
        item.color= 1
        cclog("step:"..item.step)
        local function update()
            cclog("update stone")
            local temp = item.value
            local step = item.step
            local color= item.color
            if item.color == 0 then
                item.color = 1
            else
                item.color = 0
            end
            if step > 0 then
                local value = temp - step
                if value <= 0 then
                    item.color = 0
                    item:stopAllActions()
                    item:setString(dd.showKM(dd.stone(),5))        
                else
                    item.value = value
                    item:setString(dd.showKM(dd.stone() - value,5))                                                
                end
            else
                item.color = 0
                item:stopAllActions()
                item:setString(dd.showKM(dd.stone(),5))        
            end

            if item.color == 1 then
                item:setColor(cc.c3b(7,159,0))
            else
                item:setColor(cc.c3b(255,255,255))
            end
        end
        item:stopAllActions()
        schedule(item,update,0.1)
        self:addResLabel(23,num)
    end
end
function CityUILayer:setWood(num)
    if num == nil then
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("wood"):setString(dd.showKM(dd.wood(),5))
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("wood"):setColor(cc.c3b(255,255,255))
    else
        local item = self:getChildByName("top"):getChildByName("resArea"):getChildByName("wood")
        if item.value == nil then
            item.value = num
        else
            item.value = item.value + num
        end
        item.step = math.ceil(item.value/10)
        item.color= 1
        cclog("step:"..item.step)
        local function update()
            cclog("update wood")
            local temp = item.value
            local step = item.step
            local color= item.color
            if item.color == 0 then
                item.color = 1
            else
                item.color = 0
            end
            if step > 0 then
                local value = temp - step
                if value <= 0 then
                    item.color = 0
                    item:stopAllActions()
                    item:setString(dd.showKM(dd.wood(),5))        
                else
                    item.value = value
                    item:setString(dd.showKM(dd.wood() - value,5))                                                
                end
            else
                item.color = 0
                item:stopAllActions()
                item:setString(dd.showKM(dd.wood(),5))        
            end

            if item.color == 1 then
                item:setColor(cc.c3b(7,159,0))
            else
                item:setColor(cc.c3b(255,255,255))
            end
        end
        item:stopAllActions()
        schedule(item,update,0.1)
        self:addResLabel(24,num)
    end
end
function CityUILayer:setSilver(num)
    if num == nil then
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("silver"):setString(dd.showKM(dd.silver(),5))
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("silver"):setColor(cc.c3b(255,255,255))
    else
        local item = self:getChildByName("top"):getChildByName("resArea"):getChildByName("silver")
        if item.value == nil then
            item.value = num
        else
            item.value = item.value + num
        end
        item.step = math.ceil(item.value/10)
        item.color= 1
        cclog("step:"..item.step)
        local function update()
            cclog("update silver")
            local temp = item.value
            local step = item.step
            local color= item.color
            if item.color == 0 then
                item.color = 1
            else
                item.color = 0
            end
            if step > 0 then
                local value = temp - step
                if value <= 0 then
                    item.color = 0
                    item:stopAllActions()
                    item:setString(dd.showKM(dd.silver(),5))        
                else
                    item.value = value
                    item:setString(dd.showKM(dd.silver() - value,5))                                                
                end
            else
                item.color = 0
                item:stopAllActions()
                item:setString(dd.showKM(dd.silver(),5))        
            end

            if item.color == 1 then
                item:setColor(cc.c3b(7,159,0))
            else
                item:setColor(cc.c3b(255,255,255))
            end
        end
        item:stopAllActions()
        schedule(item,update,0.1)
        self:addResLabel(27,num)
    end
end
function CityUILayer:setGold(addnum)
    self:getChildByName("top"):getChildByName("gold"):getChildByName("label"):setString(dd.gold())
    self:getChildByName("top"):getChildByName("gold"):requestDoLayout()
    if addnum ~= nil then
        self:addResLabel(0,addnum)
    end
end

function CityUILayer:setPower()
    if dd.myinfo:getLong(1,"power") < 0 then
        self:getChildByName("top"):getChildByName("power"):getChildByName("label"):setString(0)
    else        
        self:getChildByName("top"):getChildByName("power"):getChildByName("label"):setString(dd.showKM(dd.myinfo:getLong(1,"power"),6))
    end        
end
function CityUILayer:setVip()
    self:getChildByName("top"):getChildByName("notice"):getChildByName("vip"):getChildByName("label"):setString(dd.myinfo:getLong(1,"vip"))
end
function CityUILayer:setFace()
    self:getChildByName("top"):getChildByName("header"):getChildByName("header"):loadTexture(dd.getPlayerIcon(dd.myinfo:getLong(1,"face")),0)
end
function CityUILayer:showGetItem(id)
   
    local endPos = cc.p(ff.width/2,0)

    local icon = cc.Sprite:create(dd.getToolsIcon(id)) 
    icon:setScale(0.6)
    local pos  = cc.p(ff.width/2,ff.height/2)
    dd.mainUI:getChildByName("effect"):addChild(icon)
    icon:setPosition(cc.p(pos.x,pos.y))
    local moveup  = cc.EaseExponentialOut:create( cc.MoveTo:create(0.1, cc.p(pos.x,pos.y + 30)) )
    --local movedown = cc.MoveTo:create(0.8,endPos)
    local movedown = cc.EaseExponentialIn:create(cc.MoveTo:create(0.8,endPos))
    local seq  = cc.Sequence:create(cc.DelayTime:create(0.5),cc.FadeOut:create(0.3))
    local spaw = cc.Spawn:create(movedown,seq)
    local sequence = cc.Sequence:create(moveup,spaw,cc.RemoveSelf:create())
    icon:runAction(sequence)
end
function CityUILayer.updateWood(name,row,old,value,effect)
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        dd.currentLayer._widget:setWood()
        
    end    
end
function CityUILayer.updateStone(name,row,old,value,effect)
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        dd.currentLayer._widget:setStone()
        
    end    
end
function CityUILayer.updateIron(name,row,old,value,effect)
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        dd.currentLayer._widget:setIron()
        
    end    
end
function CityUILayer.updateFood(name,row,old,value,effect)
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        dd.currentLayer._widget:setFood()
        
    end    
end
function CityUILayer.updateSilver(name,row,old,value,effect)
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        dd.currentLayer._widget:setSilver()
        
    end    
end
function CityUILayer.updateGold(name,row,old,value)
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        dd.currentLayer._widget:setGold()
    end    
end
function CityUILayer.updatePower(name,row,old,value)
    local function theEnd()
        dd.mainUI:getChildByName("power"):setVisible(false)
    end
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        cclog("old:"..old..",value:"..value)
        if old < value then
            if dd.mainUI:getChildByName("power"):getTag() ~= 1 then
                local sprite = sp.SkeletonAnimation:create("images/city/power/power.json", "images/city/power/power.atlas")
                sprite:setPositionX(230)
                sprite:setPositionY(165)
                --sprite:setAnimation(0,"Power growth_animation",true)
                dd.mainUI:getChildByName("power"):addChild(sprite,1,1)
                dd.mainUI:getChildByName("power"):setPositionY(ff.height/2 + 80)
                dd.mainUI:getChildByName("power"):setTag(1)
            end
            dd.mainUI:getChildByName("power"):getChildByName("count"):setString(value - old)
            if dd.mainUI:getChildByName("power"):isVisible() == false then
                dd.mainUI:getChildByName("power"):getChildByTag(1):setAnimation(0,"Power growth_animation",false)
                dd.mainUI:getChildByName("power"):setVisible(true)
                dd.mainUI:getChildByName("power"):runAction(cc.Sequence:create(cc.DelayTime:create(1.5),cc.CallFunc:create(theEnd)))
            end
        end
        dd.currentLayer._widget:setPower()
    end    
end
function CityUILayer.updateVip(name,row,old,value)
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        dd.currentLayer._widget:setVip()
    end    
end
function CityUILayer.updateFace(name,row,old,value)
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        dd.currentLayer._widget:setFace()
    end  
end

function CityUILayer.delQueue(tableid,value)
    cclog("tableid:"..tableid..",value:"..value)
    if tableid == 1001 then
        if dd.currentLayer._widget ~= nil then
            local lists = dd.currentLayer._widget:getChildByName("action"):getChildByName("quelist"):getChildByName("list")
            if lists ~= nil then
                local item = lists:getChildByTag(value)
                if item ~= nil then
                    cclog("delQueue")
                    item:removeFromParent(true)
                end
            end                        
        end            
    end
end

--删除建筑
function CityUILayer.removeBuild(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local pos = math.floor((sender:getTag() - 30000000)/1000)
        local bid = sender:getTag() - 30000000 - pos * 1000
    end  
end
--加速队列
function CityUILayer.accQueue(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local id = sender:getParent():getTag()

        local qtype  = math.floor(id / 100000)
        local param1 = math.floor(id % 100000)
        for i=1,dd.mylists:rowCount() do
            if dd.mylists:getLong(i,"type") == qtype and dd.mylists:getLong(i,"param1") == param1 then
                break
            end
        end
    end  
end

function CityUILayer:onClose()
    --上下
    if dd.currentLayer._name == "CityLayer" or dd.currentLayer._name == "pve" then
        local target = self:getChildByName("top")
        local xx = self._state['top'][1]
        target:runAction(cc.EaseBackOut:create(cc.MoveTo:create(1, cc.p(xx,ff.height + 50))))
    else
        local target = self:getChildByName("top")
        local xx = self._state['top'][1]
        target:runAction(cc.EaseBackOut:create(cc.MoveTo:create(1, cc.p(xx,ff.height))))
    end
    target = self:getChildByName("action")
    local xx = self._state['action'][1]
    target:runAction(cc.EaseBackOut:create(cc.MoveTo:create(1, cc.p(xx,-255))))


    target = self:getChildByName("bottom")
    local xx = self._state['bottom'][1]
    target:runAction(cc.EaseBackOut:create(cc.MoveTo:create(1, cc.p(xx,-471))))

    self:getChildByName("mainBtns"):setVisible(false)
    self:getChildByName("battle"):setVisible(false)

    --立即关闭所有窗体
    self:closeBuildsNow()
    pop.CloseAll()
end

function CityUILayer:closeBuilds()
    pop.onCloseEffect(7,self:getChildByName("builds"))
end
function CityUILayer:closeBuildsNow()
    if dd.currentLayer._pop ~= nil then
        dd.currentLayer._pop:closeNow()
    end
end

function CityUILayer.selectQue(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local name = sender:getName()
        local index = 0
        if name == "queue1" then
            index = 1
        elseif name == "queue2" then
            index = 2
        elseif name == "queue3" then
            index = 3
        elseif name == "queue4" then
            index = 4
        end
        if dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:queShow(index)
        end        
    end
end
function CityUILayer.selectTroopsQue(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        if dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:queTroopsShow(sender:getTag())
        end        
    end
end

function CityUILayer.showWmp(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        pop.onShowPopDialog("worldmap")
    end
end
function CityUILayer.showkfpaihang(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        pop.onShowPopDialog("personRank",2)
    end
end
function CityUILayer.showCol(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        pop.onShowPopDialog("collect")
        if dd.mainUI ~= nil then
            if dd.currentLayer._name ~= "CityLayer" then                
                WorldControl:getInstance():closePannel()
            end
         end        
    end
end
function CityUILayer.showBUFFS( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then
        pop.onShowPopDialog("powerInfo",1)
    end
end
function CityUILayer.showHelpList( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        --pop.onShowPopDialog("helpList")
        local function call()
            platform_helpShift(1)
        end
        performWithDelay(sender, call, 0.1)
    end
end
function CityUILayer.showExpiredItem( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        pop.onShowPopDialog("resources",2)
    end
end
function CityUILayer.showQueLists(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = dd.currentLayer._widget
        if widget ~= nil then
            if widget._state['queshow'] == false then
                widget:queShow(widget:getQueIndex(),true)
            else    
                widget:queShow(widget:getQueIndex(),false)
            end    
        end    
    end
end


function CityUILayer:getQueIndex()
    if self:getChildByName("action"):getChildByName("navi"):getChildByName("queue1"):getSelectedState() == true then
        return 1
    elseif self:getChildByName("action"):getChildByName("navi"):getChildByName("queue2"):getSelectedState() == true then 
        return 2
    elseif self:getChildByName("action"):getChildByName("navi"):getChildByName("queue3"):getSelectedState() == true then 
        return 3
    end    
    return 0
end
function CityUILayer:queShow(index,force,guide)
    if guide == nil then
        guide = true
    end

    self:getChildByName("action"):stopAllActions()
    self:getChildByName("action"):getChildByName("navi"):getChildByName("queue1"):setSelectedState(false)    
    self:getChildByName("action"):getChildByName("navi"):getChildByName("queue2"):setSelectedState(false)    
    self:getChildByName("action"):getChildByName("navi"):getChildByName("queue3"):setSelectedState(false)    

    local function unShow()
        self:getChildByName("action"):getChildByName("quelist"):setVisible(false)
        self:getChildByName("action"):getChildByName("navi"):getChildByName("show"):loadTextureNormal(dd.getPathFromUI("public/v2/arrow_up.png",1))
    end

    if force ~= nil then
        self._state['queshow'] = force
        if force == false then
            self:getChildByName("action"):getChildByName("navi"):getChildByName("show"):loadTextureNormal(dd.getPathFromUI("public/v2/arrow_up.png",1))
            action = self:getChildByName("action"):runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,53))),cc.CallFunc:create(unShow)))
        else
            self:getChildByName("action"):getChildByName("navi"):getChildByName("show"):loadTextureNormal(dd.getPathFromUI("public/v2/arrow_down.png",1))
            self:getChildByName("action"):getChildByName("quelist"):setVisible(true)
            action = self:getChildByName("action"):runAction(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,209))))
            if guide == true then
                GuideControl:GuideCheck()
            end
        end
        if action ~= nil then
            action:setTag(89)
        end
        if force == false then
            return            
        end
    else
        if self._state['queshow'] == nil or self._state['queshow'] == false then
            self._state['queshow'] = true
            self:getChildByName("action"):getChildByName("navi"):getChildByName("show"):loadTextureNormal(dd.getPathFromUI("public/v2/arrow_down.png",1))
            self:getChildByName("action"):getChildByName("quelist"):setVisible(true)
            action = self:getChildByName("action"):runAction(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,209))))
            if guide == true then
                GuideControl:GuideCheck()
            end
        end
    end
    if index == 0 then
        if dd.mylists:rowCount() >= 1 then
            local type = dd.mylists:getLong(1,"type")
            if type == 1 or type == 2 or type == 5 or type == 13 then
                index = 1
            elseif type == 3 or type == 4 or type == 9 or type == 11 then
                index = 2
            elseif type == 8 then
                index = 3
            else
                index = 1
            end        
        else
            index = 1
        end    
    end
    if force == true then
        if index == 1 then
            self:getChildByName("action"):getChildByName("navi"):getChildByName("queue1"):setSelectedState(true)    
        elseif index == 2 then
            self:getChildByName("action"):getChildByName("navi"):getChildByName("queue2"):setSelectedState(true)    
        else
            self:getChildByName("action"):getChildByName("navi"):getChildByName("queue3"):setSelectedState(true)    
        end
    end
    self:getChildByName("action"):getChildByName("quelist"):jumpToLeft()
    self:updateQueDetail(index)
end
function CityUILayer.onGoldSpeed(sender,eventType)
    local function speedUp()
        local message = ff.net:createMessage()
        message:addCmd(0x00000104)
        message:addLong(dd.uid)
        message:addLong(8)
        message:addLong(0)
        message:addLong(sender:getTag())
        ff.net:rpc(message,false)
    end

    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then     
        doaction = true
    end
    if doaction == true then
        local type = sender:getTag()
        if type > 100 then
            dd.mainUI:onTroop(type - 100 ,3)
        else
            dd.currentLayer._widget.closeSameWarning()
            dd.currentLayer._widget:onShowBuyTime(type,speedUp)
        end
    end 
end
function CityUILayer.onFree(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then     
        doaction = true
    end
    if doaction == true then
        local message = ff.net:createMessage()
        message:addCmd(0x104)
        message:addLong(dd.uid)
        message:addLong(0)
        message:addLong(0)
        message:addLong(sender:getTag())
        ff.net:rpc(message,false)
        local have = false
        for i=1,dd.mylists:rowCount() do
            local type = dd.mylists:getLong(i,"type")
            if type ~= sender:getTag() then
                if type == 1 or type == 13 or type == 2 then
                    if dd.mylists:getLong(i,"end") - dd.getServerTime() <= dd.getRealFreeTick() then
                        have = true
                        break
                    end
                end
            end
        end
        if have == false then
            dd.mainUI:queShow(dd.mainUI:getQueIndex(),false)
        end
        
    end 
end
function CityUILayer.onUnionHelp(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then     
        doaction = true
    end
    if doaction == true then
        local message = ff.net:createMessage()
        message:addCmd(0x11c)
        message:addLong(dd.uid)
        message:addLong(sender:getTag())
        ff.net:rpc(message,false)
    end 
end
function CityUILayer.onGoAction(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then     
        doaction = true
    end
    if doaction == true then   
        if sender:getTag() > 100 then
            cclog("troopid............:"..sender:getTag())
            dd.mainUI:onTroop(sender:getTag() - 100,1)
            
        else
            if dd.currentLayer == dd.cityLayer then
                dd.mainUI.goAction(sender:getTag())
            else
                dd.regCallBack(1,101,dd.mainUI.goAction,sender:getTag())
                dd.yunClose(1)
            end
        end
    end
end
function CityUILayer.goAction(type)
    if type == 1 or type == 13 then
        local vip = false
        if type == 13 then
            for i=1,dd.mylists:rowCount() do
                if dd.mylists:getLong(i,"type") == 12 then
                    cclog("GuideControl.curId:"..GuideControl.curId)
                    if GuideControl.curId ~= 6040 then
                        vip = true
                    end
                    break
                end
            end
            if vip == false then
                pop.onShowPopDialog("vip",1)
                return
            end
        end
        local count = 0
        for i=1,dd.mylists:rowCount() do
            if dd.mylists:getLong(i,"type") == 1 or dd.mylists:getLong(i,"type") == 13 then
                count = count + 1
            end
        end
        for i=1,dd.mylists:rowCount() do
            if dd.mylists:getLong(i,"type") == type then
                if vip == true and count >= 2 then
                    onShowBuildsList(dd.currentLayer._widget,dd.mylists:getLong(i,"param1"),true)
                    return
                end
                if vip == false and count == 1 then
                    onShowBuildsList(dd.currentLayer._widget,dd.mylists:getLong(i,"param1"),true)
                    return
                end
            end
        end
        local taskbid = dd.myTasks:getLong(1,"builds")
        taskbid = tonumber(ff.dbmanager:sql_fetch_one_cell("select `value1` from cfg_basetask where `taskid`='"..taskbid.."'"))
        local state   = dd.myTasks:getLong(1,"buildsState")            
        local doing = false
        for i=1,dd.mylists:rowCount() do
            if dd.mylists:getLong(i,"type") == 1 or dd.mylists:getLong(i,"type") == 13 then
                local bid = 0
                for j=1,dd.mybuilds:rowCount() do
                    if dd.mybuilds:getLong(j,"pos") == dd.mylists:getLong(i,"param1") then
                        bid = dd.mybuilds:getLong(j,"bid")
                        break
                    end
                end
                if bid == taskbid and bid > 0 then
                    doing = true
                end
            end
        end

        if state == 0 and doing == false then
            local target = 0
            local maxlv = 0
            for i=1,dd.mybuilds:rowCount() do
                if dd.mybuilds:getLong(i,"bid") == taskbid then
                    if dd.mybuilds:getLong(i,"level") > maxlv then
                        target = dd.mybuilds:getLong(i,"pos")
                        maxlv = dd.mybuilds:getLong(i,"level")
                    end
                end
            end
            if target > 0 and dd.cityLayer ~= nil and dd.cityLayer._level ~= nil then
                local uplv = dd.cityLayer._level:getChildByTag(target * 1000 + 2)
                if uplv ~= nil and uplv:isVisible() == true then
                    onShowBuildsList(dd.currentLayer._widget,target,true)
                    return
                end                    
            end
            --表示没造，推荐地块
            if target == 0 then
                if dd.myinfo:getLong(1,"level") >= dd.cfgBuildingUp[taskbid][1]['level1'] then
                    skipCreateBuildLayer({taskbid})
                    return
                end
            end
        end
        --如果已经有该队列，显示
        for i=1,dd.mylists:rowCount() do
            if dd.mylists:getLong(i,"type") == type then
                onShowBuildsList(dd.currentLayer._widget,dd.mylists:getLong(i,"param1"),true)
                return
            end
        end
        if dd.cityLayer ~= nil and dd.cityLayer._level ~= nil then
            --推荐可以升级的建筑
            for i=1,dd.mybuilds:rowCount() do
                local pos = dd.mybuilds:getLong(i,"pos")
                local uplv = dd.cityLayer._level:getChildByTag(pos * 1000 + 2)
                local have = false
                for j=1,dd.mylists:rowCount() do
                    if dd.mylists:getLong(j,"type") == 1 or dd.mylists:getLong(j,"type") == 13 then
                        if dd.mylists:getLong(j,"param1") == pos then
                            have = true
                            break
                        end
                    end
                end
                if have == false then
                    if uplv ~= nil and uplv:isVisible() == true then
                        onShowBuildsList(dd.currentLayer._widget,pos,true)
                        return
                    end
                end
            end
            --满足前置建筑只缺资源的建筑
            for i=1,dd.mybuilds:rowCount() do
                local bid = dd.mybuilds:getLong(i,"bid")
                local pos = dd.mybuilds:getLong(i,"pos")
                local level = dd.mybuilds:getLong(i,"level")
                if level < dd.cfgBuilding[bid]['maxlevel'] then
                    local bid1   = dd.cfgBuildingUp[bid][level]["bid1"]
                    local level1 = dd.cfgBuildingUp[bid][level]["level1"]
                    local bid2   = dd.cfgBuildingUp[bid][level]["bid2"]
                    local level2 = dd.cfgBuildingUp[bid][level]["level2"]

                    local have = 0
                    if bid1 > 0 then
                        for j=1,dd.mybuilds:rowCount() do
                            if bid1 == dd.mybuilds:getLong(j,"bid") then
                                if dd.mybuilds:getLong(j,"level") >= level1 then
                                    have = 1
                                    break
                                end 
                            end
                        end
                    end
                    if bid2 > 0 then
                        for j=1,dd.mybuilds:rowCount() do
                            if bid2 == dd.mybuilds:getLong(j,"bid") then
                                if dd.mybuilds:getLong(j,"level") >= level2 then
                                    have = have + 1
                                    break
                                end 
                            end
                        end
                    end
                    if have == 2 then
                        onShowBuildsList(dd.currentLayer._widget,pos,true)
                        return
                    end
                end
            end
            --指向司令部
            onShowBuildsList(dd.currentLayer._widget,101,true)
            return
        end
    else
        if type == 3 or type == 4 or type == 11 then
            for i=1,dd.mylists:rowCount() do
                if type == dd.mylists:getLong(i,"type") and dd.mylists:getLong(i,"param3") == 1 then
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000104)
                    message:addLong(dd.uid)
                    message:addLong(7)
                    message:addLong(0)
                    message:addLong(type)
                    ff.net:rpc(message,false)      
                    if type == 3 then
                        AudioEngine.playEffect(ff.sounds[230]) 
                    else
                        AudioEngine.playEffect(ff.sounds[231]) 
                    end
                    return
                end
            end
        end
        local bid  = 1
        if type == 2 then
            bid = 11
        elseif type == 3 then
            bid = 21
        elseif type == 4 then
            bid = 5
        elseif type == 5 then
            bid = 16
        elseif type == 8 then
            bid = 4
        elseif type == 9 then
            bid = 22
        elseif type == 11 then
            bid = 32
        end

        cclog("type:"..type)
        for i=1,dd.mybuilds:rowCount() do
            if type == 1 and dd.mybuilds:getLong(i,"bid") == 1 then
                onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"),true)
                return
            elseif type == 2 and dd.mybuilds:getLong(i,"bid") == 11 then
                onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"))
                return
            elseif type == 3 and dd.mybuilds:getLong(i,"bid") == 21 then
                onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"))
                return
            elseif type == 4 and dd.mybuilds:getLong(i,"bid") == 5 then
                onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"))
                return
            elseif type == 5 and dd.mybuilds:getLong(i,"bid") == 16 then
                onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"))
                return
            elseif type == 8 and dd.mybuilds:getLong(i,"bid") == 4 then
                onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"))
                return
            elseif type == 9 and dd.mybuilds:getLong(i,"bid") == 22 then
                onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"))
                return
            elseif type == 11 and dd.mybuilds:getLong(i,"bid") == 32 then
                onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"))
                return
            end
        end

        if type == 15 then
            dd.yunClose(3)
            return
        end
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("你需要建造一个 {0}",{ff.langString(dd.cfgBuilding[bid]['name'])}))
    end
end

function CityUILayer.onFinish(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        for i=1,dd.mylists:rowCount() do
            if dd.mylists:getLong(i,"type") == sender:getTag() and dd.mylists:getLong(i,"param3") == 1 then
                local message = ff.net:createMessage()
                message:addCmd(0x00000104)
                message:addLong(dd.uid)
                message:addLong(7)
                message:addLong(0)
                message:addLong(sender:getTag())
                ff.net:postMessage(message)   
                if dd.mylists:getLong(i,"type") == 3 or dd.mylists:getLong(i,"type") == 4 or dd.mylists:getLong(i,"type") == 11 then
                    if dd.mylists:getLong(i,"type") == 3 then
                        AudioEngine.playEffect(ff.sounds[230])
                    else
                        AudioEngine.playEffect(ff.sounds[231])
                    end
                end
                local type = dd.mybuilds:getLong(i,"type")
                if type == 3 or type == 11 then
                    local pos = 0
                    for j=1,dd.mybuilds:rowCount() do
                        if type == 3 and dd.mybuilds:getLong(j,"bid") == 21 then
                            pos = dd.mybuilds:getLong(j,"pos")
                            break
                        end
                        if type == 11 and dd.mybuilds:getLong(j,"bid") == 22 then
                            pos = dd.mybuilds:getLong(j,"pos")
                            break
                        end
                    end
                    if pos > 0 and dd.cityLayer ~= nil then
                        dd.cityLayer:playArmysEffect(pos,dd.mylists:getLong(i,"param2"),dd.cfgSoldier[dd.mylists:getLong(i,"param1")]['type'])
                    end
                end
                return
            end
        end
    end 
end
function CityUILayer.onArmysStop(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local qtype = sender:getTag()
        if qtype ~= 3 and qtype ~= 4 and qtype ~= 11 then
            return
        end        
        for i=1,dd.mylists:rowCount() do
            if dd.mylists:getLong(i,"type") == qtype and dd.mylists:getLong(i,"param3") ~= 1 then
                local message = ff.net:createMessage()
                message:addCmd(0x104)
                message:addLong(dd.uid)
                message:addLong(9)
                message:addLong(0)
                message:addLong(qtype)
                ff.net:rpc(message,false)        
                return
            end
        end
    end 
end
function CityUILayer.onStopBuilding(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local qtype = sender:getTag()
        if qtype ~= 1 and qtype ~= 13 and qtype ~= 2 then
            return
        end

        if qtype ==1 or qtype == 13 then
            local function callback()
                for i=1,dd.mylists:rowCount() do
                    if dd.mylists:getLong(i,"type") == qtype then
                        local message = ff.net:createMessage()
                        message:addCmd(0x104)
                        message:addLong(dd.uid)
                        message:addLong(9)
                        message:addLong(0)
                        message:addLong(qtype)
                        ff.net:rpc(message,false)
                        return
                    end
                end
            end
            dd.currentLayer._widget:onShowSure(ff.langString("建造取消确认"),ff.langString("您确认要取消本次操作吗？\n取消建造不会返还任何资源"),callback,true,2)
        else
            for i=1,dd.mylists:rowCount() do
                if dd.mylists:getLong(i,"type") == qtype then
                    local message = ff.net:createMessage()
                    message:addCmd(0x104)
                    message:addLong(dd.uid)
                    message:addLong(9)
                    message:addLong(0)
                    message:addLong(qtype)
                    ff.net:rpc(message,false)
                    return
                end
            end
        end
        
    end 
end
--非
function CityUILayer.onStop(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local qtype = sender:getTag()
        if qtype == 8 or qtype == 9 or qtype == 5 then
            for i=1,dd.mylists:rowCount() do
                if dd.mylists:getLong(i,"type") == qtype then
                    local message = ff.net:createMessage()
                    message:addCmd(0x104)
                    message:addLong(dd.uid)
                    message:addLong(9)
                    message:addLong(0)
                    message:addLong(qtype)
                    ff.net:rpc(message,false)
                    return
                end
            end
        end
    end 
end
function CityUILayer.showRes(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        pop.onShowPopDialog("resources",1)
    end    
end
function CityUILayer.showVip(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        pop.onShowPopDialog("vip")
    end    
end

function CityUILayer.onChangeFace(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        pop.onShowPopDialog("changeHead")
    end  
end
function CityUILayer.showPower(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        AudioEngine.playEffect(ff.sounds[101])
        pop.onShowPopDialog("powerInfo")
    end  
end
function CityUILayer.onPay(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        pop.onShowPopDialog("charge")
    end  
end

function CityUILayer:setCidTips(curCenterGid)
    local x = (curCenterGid-1)%ff.world_maplayerSize.width
    local y = math.floor((curCenterGid-1-x)/ff.world_maplayerSize.width)
    x = x + 1
    y = y + 1
    if x <= 0 then
        x = 1
    end
    if x > ff.world_maplayerSize.width then
        x = ff.world_maplayerSize.width
    end
    if y <= 0 then
        y = 1
    end
    if y > ff.world_maplayerSize.width then
        y = ff.world_maplayerSize.width
    end

    self:getChildByName("top"):getChildByName("topworld"):getChildByName('cid'):setString("X:"..x.." Y:"..y)
    self:getChildByName("top"):getChildByName("topworld"):requestDoLayout()
end

--按钮区
function CityUILayer.goChange(sender,eventType)
    if eventType==ccui.TouchEventType.ended then    
        if dd.mainUI ~= nil then
            local function updateScene()
                dd.mainUI:getChildByName("builds"):setVisible(false)
                --队列关闭
                --dd.mainUI:queShow(dd.mainUI:getQueIndex(),false)
                if dd.currentLayer._name == "CityLayer" then
                    dd.yunClose(2)
                else
                    dd.yunClose(1)
                end        
            end
            --dd.mainUI:onClose()
            dd.mainUI:getChildByName("mask"):setVisible(true)
            local sequence = cc.Sequence:create(cc.DelayTime:create(0.1),cc.CallFunc:create(updateScene))
            dd.mainUI:runAction(sequence)
        end    
    end
end

function CityUILayer.onRemoveByTools(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        local pos = sender:getTag()
        for i=1,dd.mybuilds:rowCount() do
            if dd.mybuilds:getLong(i,"pos") == pos then
                dd.currentLayer._widget.closeRemove()                
                local message = ff.net:createMessage()
                message:addCmd(0x103)
                message:addLong(dd.uid)
                message:addLong(92)
                message:addLong(pos)
                message:addLong(dd.mybuilds:getLong(i,"bid"))
                ff.net:rpc(message,false)
                break
            end
        end
    end
end
function CityUILayer.onRemoveByTime(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        local pos = sender:getTag()
        for i=1,dd.mybuilds:rowCount() do
            if dd.mybuilds:getLong(i,"pos") == pos then
                dd.currentLayer._widget.closeRemove()                
                local message = ff.net:createMessage()
                message:addCmd(0x103)
                message:addLong(dd.uid)
                message:addLong(91)
                message:addLong(pos)
                message:addLong(dd.mybuilds:getLong(i,"bid"))
                ff.net:rpc(message,false)
                break
            end
        end
    end
end
--战场
function CityUILayer.outBattle(sender,eventType)
    AudioEngine.playEffect(ff.sounds[101]) 
    if eventType==ccui.TouchEventType.ended then
        if dd.currentLayer._widget ~= nil then
            cclog(dd.currentLayer._widget._state['gobattle'])
            if dd.currentLayer._widget._state['gobattle'] == "CityLayer" then
                dd.yunClose(11)
            else
                dd.yunClose(12)
            end
        end
    end
end

--spine按钮
function CityUILayer:clearSpineBtns()
    local mainBtns = self:getChildByName("mainBtns")
    
    local heals = mainBtns:getChildByName("buttonlist"):getChildByTag(1)
    if heals ~= nil then
        heals:getChildByTag(1):removeFromParent(true)
        heals:removeFromParent(true)
    end

    local warnning = mainBtns:getChildByName("buttonlist"):getChildByTag(5)
    if warnning ~= nil then
        warnning:getChildByTag(1):removeFromParent(true)
        warnning:removeFromParent(true)
    end
    local help = mainBtns:getChildByName("buttonlist"):getChildByTag(3)
    if help ~= nil then
        help:getChildByTag(1):removeFromParent(true)
        help:removeFromParent(true)
    end
    
    local ItemWaring = mainBtns:getChildByName("buttonlist"):getChildByTag(6)
    if ItemWaring ~= nil then
        ItemWaring:getChildByTag(1):removeFromParent(true)
        ItemWaring:removeFromParent(true)
    end
   
    local Attendance = mainBtns:getChildByName("buttonlist"):getChildByTag(7)
    if Attendance ~= nil then
        Attendance:getChildByTag(1):removeFromParent(true)
        Attendance:removeFromParent(true)
    end

    local SurpriseRecharge = mainBtns:getChildByName("buttonlist"):getChildByTag(8)
    if SurpriseRecharge ~= nil then
        SurpriseRecharge:getChildByTag(1):removeFromParent(true)
        SurpriseRecharge:removeFromParent(true)
    end  
    local SurpriseRechargeEx = mainBtns:getChildByName("buttonlist"):getChildByTag(9)
    if SurpriseRechargeEx ~= nil then
        SurpriseRechargeEx:getChildByTag(1):removeFromParent(true)
        SurpriseRechargeEx:removeFromParent(true)
    end  
    local RestrictedGift = mainBtns:getChildByName("buttonlist"):getChildByTag(11)
    if RestrictedGift ~= nil then
        RestrictedGift:getChildByTag(1):removeFromParent(true)
        RestrictedGift:removeFromParent(true)
    end  
end

function CityUILayer:initButton()
    self:getChildByName("bottom"):getChildByName("btn01World"):addTouchEventListener(self.goChange)
    --错误提示框
    --self:getChildByName("warning"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onCloseWarning)
    self:getChildByName("remove"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onCloseRemove)
    self:getChildByName("addspeed"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onCloseAddSpeed)
    self:getChildByName("sameWarning"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onCloseSameWarning)
    self:getChildByName("usetools"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onCloseUseTools)
    
    self:getChildByName("remove"):getChildByName("view"):getChildByName("tools"):getChildByName("sure"):addTouchEventListener(self.onRemoveByTools)
    self:getChildByName("remove"):getChildByName("view"):getChildByName("normal"):getChildByName("sure"):addTouchEventListener(self.onRemoveByTime)

    self:getChildByName("share"):getChildByName("close"):addTouchEventListener(self.onCloseShare)
    

    self:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("world"):addTouchEventListener(self.selectChannel)
    self:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("union"):addTouchEventListener(self.selectChannel)
    self:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("friend"):addTouchEventListener(self.selectChannel)
    self:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("mail"):addTouchEventListener(self.selectChannel)
    self:getChildByName("besureEx"):getChildByName("root"):getChildByName("chu_name_text"):setString(ff.langString("列表"))
    self:getChildByName("besureEx"):getChildByName("root"):getChildByName("title"):getChildByName("chu_Label_9"):setString(ff.langString("玩家名字"))
    self:getChildByName("besureEx"):getChildByName("root"):getChildByName("title"):getChildByName("chu_effect_text_1"):setString(ff.langString("金额"))

    self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):addTouchEventListener(self.onPopCancel)
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("sure"):addTouchEventListener(self.onPopSure)

    self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("cacel"):addTouchEventListener(self.onPopExCancel)
    self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("sure"):addTouchEventListener(self.onPopExCancel)

    self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("sure1"):addTouchEventListener(self.onPopGoCancel)
    self:getChildByName("besureEx"):getChildByName("root"):getChildByName("close"):addTouchEventListener(self.onPopEx2Cancel)

    self:getChildByName("hecheng"):getChildByName("warning"):getChildByName("cacel"):addTouchEventListener(self.onHeChengPopCancel)
    self:getChildByName("hecheng"):getChildByName("warning"):getChildByName("sure"):addTouchEventListener(self.onHeChengPopSure)

    self:getChildByName("top"):getChildByName("resArea"):addTouchEventListener(self.showRes)
    self:getChildByName("top"):getChildByName("notice"):getChildByName("vip"):addTouchEventListener(self.showVip)
    self:getChildByName("top"):getChildByName("notice"):getChildByName("move"):addTouchEventListener(self.showNotice)
    self:getChildByName("top"):getChildByName("header"):getChildByName("header"):addTouchEventListener(self.showPower)
    self:getChildByName("top"):getChildByName("power"):addTouchEventListener(self.showPower)

    self:getChildByName("top"):getChildByName("gold"):getChildByName("addgold"):addTouchEventListener(self.onPay)
    self:getChildByName("top"):getChildByName("gold"):addTouchEventListener(self.onPay)



    self:getChildByName("top"):getChildByName("topworld"):getChildByName("search"):addTouchEventListener(self.onSearch)
    self:getChildByName("top"):getChildByName("topworld"):getChildByName("judian"):addTouchEventListener(self.onJudian)
    self:getChildByName("top"):getChildByName("topworld"):getChildByName("lianjinsuo"):addTouchEventListener(self.onLianjinsuo)
    self:getChildByName("top"):getChildByName("topworld"):getChildByName("col"):addTouchEventListener(self.showCol)
    self:getChildByName("top"):getChildByName("topworld"):getChildByName("wmp"):addTouchEventListener(self.showWmp)
    self:getChildByName("top"):getChildByName("topworld"):getChildByName("kfpaihang"):addTouchEventListener(self.showkfpaihang)

    self:getChildByName("search"):getChildByName("search"):getChildByName("close"):addTouchEventListener(self.onCloseSearch)
    self:getChildByName("search"):getChildByName("search"):getChildByName("btn1"):addTouchEventListener(self.onWorldGo)
    

    --主按钮
    self:getChildByName("bottom"):getChildByName("btns"):getChildByName("quests"):addTouchEventListener(self.onTask)
    self:getChildByName("bottom"):getChildByName("btns"):getChildByName("mail"):addTouchEventListener(self.onMail)
    self:getChildByName("bottom"):getChildByName("btns"):getChildByName("alliance"):addTouchEventListener(self.onAlliance)
    self:getChildByName("bottom"):getChildByName("btns"):getChildByName("items"):addTouchEventListener(self.onItems)
    self:getChildByName("bottom"):getChildByName("btns"):getChildByName("setting"):addTouchEventListener(self.onSet)
    --self:getChildByName("bottom"):getChildByName("btns"):getChildByName("cid"):addTouchEventListener(self.onCid)
    --self:getChildByName("bottom"):getChildByName("btns"):getChildByName("lottery"):addTouchEventListener(self.onLottery)
    
    --mainbtns下按钮
    self:getChildByName("mainBtns"):getChildByName("rand"):addTouchEventListener(self.showHelpList)
    self:getChildByName("mainBtns"):getChildByName("expireditem"):addTouchEventListener(self.showExpiredItem)
    self:getChildByName("mainBtns"):getChildByName("buttonlist"):getChildByName("login"):addTouchEventListener(self.onLogin)
    self:getChildByName("mainBtns"):getChildByName("fuben"):addTouchEventListener(self.onFuben)
    self:getChildByName("mainBtns"):getChildByName("lianxu"):addTouchEventListener(self.onLianxu)
    self:getChildByName("mainBtns"):getChildByName("leiji"):addTouchEventListener(self.onLeiji)
    self:getChildByName("mainBtns"):getChildByName("heals"):addTouchEventListener(self.onHeals)
    self:getChildByName("mainBtns"):getChildByName("Bonus"):addTouchEventListener(self.onBonus)
    self:getChildByName("mainBtns"):getChildByName("warnning"):addTouchEventListener(self.onTower)
    self:getChildByName("mainBtns"):getChildByName("ActiveCharge"):addTouchEventListener(self.onCards)
    self:getChildByName("mainBtns"):getChildByName("Attendance"):addTouchEventListener(self.onAttendance)
    self:getChildByName("mainBtns"):getChildByName("SurpriseRecharge"):addTouchEventListener(self.onSurpriseRecharge)
    self:getChildByName("mainBtns"):getChildByName("SurpriseRechargeEx"):addTouchEventListener(self.onSurpriseRechargeEx)
    self:getChildByName("mainBtns"):getChildByName("RestrictedGift"):addTouchEventListener(self.onRestrictedGift)
    self:getChildByName("mainBtns"):getChildByName("Once"):addTouchEventListener(self.onOnce)
    self:getChildByName("mainBtns"):getChildByName("kfevent"):addTouchEventListener(self.onkfevent)
    self:getChildByName("tool"):setVisible(false)
    self:getChildByName("tool"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onCloseTool)
    self:getChildByName("tool"):getChildByName("view"):getChildByName("sure"):addTouchEventListener(self.onToolSure)
    --self:getChildByName("mainBtns"):getChildByName("buttonlist"):setItemsMargin(15)

    self:getChildByName("bottom"):getChildByName("btn01Friend"):addTouchEventListener(self.onChat)
    

    self:getChildByName("action"):getChildByName("navi"):getChildByName("queue1"):addTouchEventListener(self.selectQue)
    self:getChildByName("action"):getChildByName("navi"):getChildByName("queue2"):addTouchEventListener(self.selectQue)
    self:getChildByName("action"):getChildByName("navi"):getChildByName("queue3"):addTouchEventListener(self.selectQue)
    self:getChildByName("action"):getChildByName("navi"):getChildByName("show"):addTouchEventListener(self.showQueLists)
    
    self:getChildByName("action"):getChildByName("quelist"):setVisible(false)    

    for i=1,5 do
        self:getChildByName("action"):getChildByName("quelist"):getChildByName("item"..i):getChildByName("speedup"):addTouchEventListener(self.onGoldSpeed)
        self:getChildByName("action"):getChildByName("quelist"):getChildByName("item"..i):getChildByName("Free"):addTouchEventListener(self.onFree)            
        self:getChildByName("action"):getChildByName("quelist"):getChildByName("item"..i):getChildByName("Help"):addTouchEventListener(self.onUnionHelp)
        self:getChildByName("action"):getChildByName("quelist"):getChildByName("item"..i):getChildByName("enlist"):addTouchEventListener(self.onGoAction)
        --self:getChildByName("action"):getChildByName("quelist"):getChildByName("item"..i):getChildByName("btn"):addTouchEventListener(self.onGoAction)
        self:getChildByName("action"):getChildByName("quelist"):getChildByName("item"..i):getChildByName("icon"):getChildByName("icon"):addTouchEventListener(self.onGoAction)
    end


    self:getChildByName("bottom"):getChildByName("btns"):getChildByName("rank"):addTouchEventListener(self.showPeronRank)

    self:getChildByName("bottom"):getChildByName("chat"):addTouchEventListener(self.onChangeChannel)
    self:getChildByName("battle"):getChildByName("close"):setVisible(false)
    --self:getChildByName("battle"):getChildByName("close"):addTouchEventListener(self.outBattle)

    self:getChildByName("mainBtns"):getChildByName("task"):getChildByName("doing"):setVisible(true)
    self:getChildByName("mainBtns"):getChildByName("task"):getChildByName("tips"):getChildByName("label"):addTouchEventListener(self.onCompleteTask)
    self:getChildByName("mainBtns"):getChildByName("task"):getChildByName("tips"):addTouchEventListener(self.onCompleteTask)
    self:getChildByName("mainBtns"):getChildByName("task"):getChildByName("icon"):addTouchEventListener(self.onCompleteTask)
    
    self:getChildByName("mainBtns"):getChildByName("buttonlist"):getChildByName("login"):getChildByName("time"):setVisible(false)

    local function showUnionHelp(sender,eventType)
        if eventType==ccui.TouchEventType.ended then  
            local widget = pop.getDialog("union")
            if widget ~= nil then                
                widget:selectPoints()
            else
                pop.onShowPopDialog("unionHelp")  
            end
        end
    end
    local mbtns = self:getChildByName("mainBtns")
    mbtns:getChildByName("help_btn"):addTouchEventListener(showUnionHelp)


    if ff.platform ~= 1 then
        if ff.apk_version >= 1220 then
            if self:getChildByName("mainBtns"):getChildByName("gamebing") ~= nil then
                --local gamebing = self:getChildByName("mainBtns"):getChildByName("gamebing"):getChildByName("gamebing")
                --if gamebing == nil then
                --    gamebing = GameBing.new()
                --    gamebing:setPosition(cc.p(0,0))
                --    self:getChildByName("mainBtns"):getChildByName("gamebing"):addChild(gamebing)
                --end
            end
        end
    end
    --mbtns:getChildByName("boosts"):addTouchEventListener(self.showBUFFS)
end
function CityUILayer:onShow(mov)
    --if self:getChildByName("bottom"):isVisible() == true and self:getChildByName("bottom"):getPositionY() == 0 then
    --    return
    --end
    self:getChildByName("effect"):removeAllChildren(true)

    self:getChildByName("pop2"):setVisible(true)
    self:getChildByName("pop3"):setVisible(true)
    self:getChildByName("pop4"):setVisible(true)

    dd.initGoldSpine(dd.mainUI:getChildByName("top"):getChildByName("gold"):getChildByName("icon"),dd.mainUI:getChildByName("top"):getChildByName("gold"):getChildByName("addgold"))
    dd.initGoldSpine(dd.mainUI:getChildByName("builds"):getChildByName("topArea"):getChildByName("icon"),dd.mainUI:getChildByName("builds"):getChildByName("topArea"):getChildByName("addgold"))
    
    cclog("name........:"..dd.currentLayer._name)
    if dd.currentLayer._name == "CityLayer" then
        self:getChildByName("mainBtns"):setVisible(true)
        self:getChildByName("action"):setVisible(true)
        self:updateTask(false)
    elseif dd.currentLayer._name == "pve" then
        self:getChildByName("mainBtns"):setVisible(false)
        self:getChildByName("action"):setVisible(false)
    elseif dd.currentLayer._name == "battle" then
        self:getChildByName("mainBtns"):setVisible(false)
        self:getChildByName("action"):setVisible(false)
    else
        self:getChildByName("mainBtns"):setVisible(false)
        self:getChildByName("action"):setVisible(true)
    end
    if dd.currentLayer._name == "battle" then
        self:getChildByName("top"):setVisible(false)
        self:getChildByName("bottom"):setVisible(false)
        self:getChildByName("action"):setVisible(false)
        self:getChildByName("battle"):setVisible(true)
    else
        --上下
        self:getChildByName("battle"):setVisible(false)
        if dd.currentLayer._name == "CityLayer" or dd.currentLayer._name == "pve" then
            local target = self:getChildByName("top")
            target:getChildByName("notice"):setVisible(true)
            target:getChildByName("topworld"):setVisible(false)
            local xx = 0
            local yy = 0
            if self._state['top'] ~= nil then
                xx = self._state['top'][1]
                yy = self._state['top'][2]
            else    
                self._state['top'] = {0,ff.height - 112}
                xx = 0
                yy = ff.height - 112
            end    
            target:stopAllActions()
            target:setVisible(true)
            if mov ~= false then
                target:setPositionY(ff.height)
                target:runAction(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(xx,yy))))
            else
                target:setPositionY(yy)
            end
        else   
            local target = self:getChildByName("top")
            target:getChildByName("notice"):setVisible(false)
            target:getChildByName("topworld"):setVisible(true)
            local xx = 0
            local yy = 0
            if self._state['top'] ~= nil then
                xx = self._state['top'][1]
                yy = self._state['top'][2]
            else    
                self._state['top'] = {0,ff.height - 112}
                xx = 0
                yy = ff.height - 112
            end    
            target:stopAllActions()
            target:setVisible(true)
            if mov ~= false then
                target:setPositionY(ff.height)
                target:runAction(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(xx,yy))))
            else
                target:setPositionY(yy)
            end
        end

        --下上
        target = self:getChildByName("bottom")
        target:setVisible(true)    
        local xx,yy = target:getPosition()
        if self._state['bottom'] ~= nil then
            xx = self._state['bottom'][1]
            yy = self._state['bottom'][2]
        else    
            self._state['bottom'] = {xx,yy}
        end    
        if mov ~= false then
            target:setPositionY(-214)
            target:runAction(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(xx,yy))))
        end

        target:getChildByName("chatArea"):getChildByName("lists"):scrollToBottom(0.5,true)
        --下上
        if dd.currentLayer._name == "CityLayer" then
            target = self:getChildByName("action")
            local xx,yy = target:getPosition()
            if self._state['action'] ~= nil then
                xx = self._state['action'][1]
                yy = self._state['action'][2]
            else    
                self._state['action'] = {xx,yy}
            end    
            target:stopAllActions()
            if mov ~= false then
                target:setPositionY(-255)
                target:runAction(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(xx,yy))))
            end
        end

        if dd.currentLayer._name == "CityLayer" then
            if dd.HolidayAppearance == 0 then
                self:getChildByName("bottom"):getChildByName("btn01World"):loadTextureNormal(dd.getPathFromUI("v2/world.png",1))
            elseif dd.HolidayAppearance == 1 then
                self:getChildByName("bottom"):getChildByName("btn01World"):loadTextureNormal("images/active/world.png",0)
            elseif dd.HolidayAppearance == 2 then
                self:getChildByName("bottom"):getChildByName("btn01World"):loadTextureNormal("images/active/world.png",0)
            elseif dd.HolidayAppearance == 3 then
                self:getChildByName("bottom"):getChildByName("btn01World"):loadTextureNormal("images/active/world4.png",0)
            elseif dd.HolidayAppearance == 4 then
                self:getChildByName("bottom"):getChildByName("btn01World"):loadTextureNormal("images/active/world5.png",0)
            elseif dd.HolidayAppearance == 5 then
                self:getChildByName("bottom"):getChildByName("btn01World"):loadTextureNormal("images/active/world.png",0)
            end
            --self:getChildByName("bottom"):getChildByName("btn01World"):getChildByName("icon"):loadTexture(dd.getPathFromUI("img01_world.png",1))
            --self:getChildByName("bottom"):getChildByName("btn01World"):getChildByName("label"):setString("World")
        else
            if dd.HolidayAppearance == 0 then
                self:getChildByName("bottom"):getChildByName("btn01World"):loadTextureNormal(dd.getPathFromUI("v2/city.png",1))
            elseif dd.HolidayAppearance == 1 then
                self:getChildByName("bottom"):getChildByName("btn01World"):loadTextureNormal("images/active/city.png",0)
            elseif dd.HolidayAppearance == 2 then
                self:getChildByName("bottom"):getChildByName("btn01World"):loadTextureNormal("images/active/city.png",0)
            elseif dd.HolidayAppearance == 3 then
                self:getChildByName("bottom"):getChildByName("btn01World"):loadTextureNormal("images/active/city4.png",0)
            elseif dd.HolidayAppearance == 4 then
                self:getChildByName("bottom"):getChildByName("btn01World"):loadTextureNormal("images/active/city5.png",0)
            elseif dd.HolidayAppearance == 5 then
                self:getChildByName("bottom"):getChildByName("btn01World"):loadTextureNormal("images/active/city.png",0)
            end
            --self:getChildByName("bottom"):getChildByName("btn01World"):getChildByName("icon"):loadTexture(dd.getPathFromUI("img02_world.png",1))
            --self:getChildByName("bottom"):getChildByName("btn01World"):getChildByName("label"):setString("City")
        end

        if self._state ~= nil then
            if self._state['queshow'] == nil then
                self._state['queshow'] = false
            end    
            if self._state['troopque'] == nil then
                self._state['troopque'] = false
            end    
        end

        --self:getChildByName("action"):setVisible(true)
        self:updateRes()
    end
end
function CityUILayer:onInit()
    --必须在播放onshow之前先显示，布局有BUG
    self:setVisible(true)
    local target = self:getChildByName("top")
    target:stopAllActions()
    target:setVisible(false)

    

    --local target = self:getChildByName("topWorld")
    --target:stopAllActions()
    --target:setVisible(false)    

    target = self:getChildByName("bottom")
    target:stopAllActions()
    self:getChildByName("bottom"):setVisible(false)

    target = self:getChildByName("action")
    target:stopAllActions()
    self:getChildByName("action"):setVisible(false)

    target = self:getChildByName("map")
    target:stopAllActions()
    target:setVisible(false)

    target = self:getChildByName("battle")
    target:stopAllActions()
    target:setVisible(false)
end
function CityUILayer:initUI()
    local maph = ff.height - (self:getChildByName("top"):getContentSize().height +  self:getChildByName("bottom"):getContentSize().height)
    self:getChildByName("mapArea"):setContentSize(cc.size(ff.width,maph))
    self:getChildByName("mapArea"):setPositionY(214)

    local builds = self:getChildByName("builds")
    builds:setContentSize(cc.size(ff.width,ff.height - self:getChildByName("bottom"):getContentSize().height))

    local listh = ff.height - self:getChildByName("bottom"):getContentSize().height - builds:getChildByName("topArea"):getContentSize().height
    builds:getChildByName("lists"):setContentSize(cc.size(ff.width,listh))
    builds:getChildByName("upgrade"):setContentSize(cc.size(ff.width,listh))
    builds:getChildByName("upgrade"):getChildByName("mainArea"):setContentSize(cc.size(ff.width,listh - 205))
    builds:getChildByName("upgrade"):getChildByName("mainArea"):getChildByName("needs"):setContentSize(cc.size(698,listh - 305))

    self:getChildByName("top"):getChildByName("notice"):getChildByName("vip"):setBright(false)
    builds:getChildByName("mask"):setContentSize(cc.size(ff.width,ff.height))
    builds:getChildByName("mask"):setVisible(false)
    builds:getChildByName("mask"):setPositionY(0)    
    
    builds:getChildByName("item"):getChildByName("base"):getChildByName("tips"):getVirtualRenderer():setDimensions(520,0)
    builds:getChildByName("item"):getChildByName("base"):getChildByName("reqs"):getVirtualRenderer():setDimensions(520,0)
    
    self:getChildByName("search"):setContentSize(cc.size(ff.width,ff.height))
    self:getChildByName("search"):getChildByName("search"):setPositionY(ff.height/2 + 200)
    --确认框
    self:getChildByName("besure"):setContentSize(cc.size(ff.width,ff.height))
    self:getChildByName("besure"):setPositionY(0)
    self:getChildByName("besure"):getChildByName("warning"):setPositionY(ff.height/2)

    self:getChildByName("besureEx"):setContentSize(cc.size(ff.width,ff.height))
    self:getChildByName("besureEx"):setPositionY(0)
    self:getChildByName("besureEx"):getChildByName("warning"):setPositionY(ff.height/2)

    self:getChildByName("hecheng"):setContentSize(cc.size(ff.width,ff.height))
    self:getChildByName("hecheng"):setPositionY(0)
    self:getChildByName("hecheng"):getChildByName("warning"):setPositionY(0)
    self:getChildByName("hecheng"):getChildByName("warning"):getChildByName("label"):setString(ff.langString("合成"))
    self:getChildByName("hecheng"):getChildByName("warning"):getChildByName("Label_754"):setString(ff.langString("合成所需材料"))

    --战斗UI
    self:getChildByName("battle"):setContentSize(cc.size(ff.width,ff.height))
    self:getChildByName("battle"):setPositionY(0)
    --按钮面板
    self:getChildByName("mainBtns"):setContentSize(cc.size(ff.width,ff.height - 112 - 31 - 214))
    self:getChildByName("mainBtns"):setPositionY(214)
    self:getChildByName("mainBtns"):getChildByName("help_btn"):setVisible(false)

    self:getChildByName("Bonus"):setPositionY(519)

    --effect
    self:getChildByName("effect"):setContentSize(cc.size(ff.width,ff.height))
    self:getChildByName("effect"):setPositionY(0)
    
    
    --频道限制行数
    self:getChildByName("bottom"):getChildByName("chatArea"):getChildByName("lists"):setMaxLine(4)
    self:getChildByName("bottom"):getChildByName("chatArea"):getChildByName("lists"):addTouchEventListener(self.showChatDialog)

    self:initEvent()
    self:initButton()
    self:initIco()

    self:getChildByName("warning_1"):setVisible(false)
    self:getChildByName("warning_2"):setVisible(false)

    self._state['quelist'] = dd.mylists:rowCount()
    self._state['chattype']= 1
    self._state['worldid']=0
    self._state['unionid']=0
    self._state['listclick']=0
    self._state['city_moveui'] = 1
    self._state['world_moveui'] = 1
end
function CityUILayer:startNoticeMove(msg,ifTitle)
    self.playMsg = true
    local mov = self:getChildByName("top"):getChildByName("notice"):getChildByName("move"):getChildByName("noticeText")
    local dealMsg,num = string.gsub(msg,"/n"," ")
    mov:setString(dealMsg)
    mov:stopAllActions()
    local function again(sender)
       self.playMsg = false
       mov:setString("")
    end

    mov:setPositionX(520)
    local tick = 10 --标题从左到右10秒
    local speed = 50 --每秒50像素
    local tick1 = math.ceil(mov:getContentSize().width/speed)
--    cclog("tick:"..tick.." speed:"..speed.." tick1:"..tick1)
    if ifTitle == true then
        mov:runAction(cc.Sequence:create(cc.DelayTime:create(0.5),cc.MoveTo:create(tick,cc.p(0,1)),cc.DelayTime:create(5),cc.MoveTo:create(tick1,cc.p(-mov:getContentSize().width,1)),cc.CallFunc:create(again)))
    else
        mov:runAction(cc.Sequence:create(cc.DelayTime:create(0.5),cc.MoveTo:create(tick + tick1,cc.p(-mov:getContentSize().width,1)),cc.CallFunc:create(again)))
    end
end
--检查资源区按钮显示
function CityUILayer:checkResIcon()
    local level = dd.myinfo:getLong(1,"level")
    if level <= 10 then
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("icon_iron"):setVisible(false)
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("stone_icon"):setVisible(false)
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("iron"):setVisible(false)
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("stone"):setVisible(false)
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("silver_icon"):setPositionX(269)
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("silver"):setPositionX(293)
    elseif level <= 14 then
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("stone_icon"):setVisible(true)
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("icon_iron"):setVisible(false)
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("iron"):setVisible(false)
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("stone"):setVisible(true)
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("silver_icon"):setPositionX(389)
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("silver"):setPositionX(413)
    else
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("icon_iron"):setVisible(true)
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("stone_icon"):setVisible(true)
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("iron"):setVisible(true)
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("stone"):setVisible(true)
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("silver_icon"):setPositionX(508)
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("silver"):setPositionX(531)
    end
    self:getChildByName("top"):getChildByName("resArea"):requestDoLayout()
end

function CityUILayer:checkResBuffIcon()
    -- body
    --cclog("------------")
    local buffs = {0,0,0,0,0}
    for j=1,dd.myplus:rowCount() do
        --cclog("==="..j.."=="..dd.myplus:getLong(j,"id"))
        if dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[8]['effect']) then
              buffs[1] = 1 
        elseif dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[9]['effect']) then
            buffs[2] = 1 
        elseif dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[10]['effect']) then
            buffs[3] = 1 
        elseif dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[11]['effect']) then
            buffs[4] = 1 
        elseif dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[12]['effect']) then
            buffs[5] = 1 
        end   
    end
    if buffs[1] == 1 then
        if self:getChildByName("top"):getChildByName("resArea"):getChildByName("wood_icon"):isVisible() == true then
            if self:getChildByName("top"):getChildByName("resArea"):getChildByName("wood_icon"):getChildByName("buff"):isVisible() == false then
                self:getChildByName("top"):getChildByName("resArea"):getChildByName("wood_icon"):getChildByName("buff"):setVisible(true)
            end
        end
    else
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("wood_icon"):getChildByName("buff"):setVisible(false)
    end
    if buffs[2] == 1 then
        if self:getChildByName("top"):getChildByName("resArea"):getChildByName("food_icon"):isVisible() == true then
            if self:getChildByName("top"):getChildByName("resArea"):getChildByName("food_icon"):getChildByName("buff"):isVisible() == false then
                self:getChildByName("top"):getChildByName("resArea"):getChildByName("food_icon"):getChildByName("buff"):setVisible(true)
            end
        end
    else
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("food_icon"):getChildByName("buff"):setVisible(false)
    end
    if buffs[3] == 1 then
        if self:getChildByName("top"):getChildByName("resArea"):getChildByName("stone_icon"):isVisible() == true then
            if self:getChildByName("top"):getChildByName("resArea"):getChildByName("stone_icon"):getChildByName("buff"):isVisible() == false then
                self:getChildByName("top"):getChildByName("resArea"):getChildByName("stone_icon"):getChildByName("buff"):setVisible(true)
            end
        end
    else
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("stone_icon"):getChildByName("buff"):setVisible(false)
    end
    if buffs[4] == 1 then
        if self:getChildByName("top"):getChildByName("resArea"):getChildByName("icon_iron"):isVisible() == true then
            if self:getChildByName("top"):getChildByName("resArea"):getChildByName("icon_iron"):getChildByName("buff"):isVisible() == false then
                self:getChildByName("top"):getChildByName("resArea"):getChildByName("icon_iron"):getChildByName("buff"):setVisible(true)
            end
        end
    else
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("icon_iron"):getChildByName("buff"):setVisible(false)
    end
    if buffs[5] == 1 then
        if self:getChildByName("top"):getChildByName("resArea"):getChildByName("silver_icon"):isVisible() == true then
            if self:getChildByName("top"):getChildByName("resArea"):getChildByName("silver_icon"):getChildByName("buff"):isVisible() == false then
                self:getChildByName("top"):getChildByName("resArea"):getChildByName("silver_icon"):getChildByName("buff"):setVisible(true)
            end
        end
    else
        self:getChildByName("top"):getChildByName("resArea"):getChildByName("silver_icon"):getChildByName("buff"):setVisible(false)
    end
end

function CityUILayer:addResLabel(type,num)
    local function tagMove(sender)
        if sender.move ~= nil then
            sender.move = true
        end
    end
    if dd.cityLayer ~= nil and dd.cityLayer._pop ~= nil and dd.cityLayer._pop._upgrade ~= nil and dd.cityLayer._pop._upgrade:isVisible() == true then
        return
    end    
    if pop.isLevelShowing(4) or pop.isLevelShowing(1)  then
        return
    else
        cclog("here:"..type)
        local lab = dd.mainUI:getChildByName("effect"):getChildByTag(type)
        if lab ~= nil then
            if lab.move ~= nil and lab.move == false then
                lab:stopAllActions()
                local action = cc.Spawn:create(
                            cc.MoveBy:create(1, cc.p(0,40)),
                            cc.FadeOut:create(1)
                            )
                lab.move = true
                lab:runAction(cc.Sequence:create(cc.ScaleTo:create(0.125, 1),action,cc.RemoveSelf:create()))        
            end
            lab:setTag(0)
        end
        lab = cc.Label:createWithSystemFont("+"..num, "", 22)
        lab:enableBold(true)
        lab:enableOutline(cc.c4b(0,0,0,255),3)
        lab:setColor(cc.c3b(7,159,0))
        lab:setTag(type)
        lab.move = false
        dd.mainUI:getChildByName("effect"):addChild(lab)

        --木材
        if type == 24 then
            lab:setPosition(175,ff.height - 100)
        elseif type == 26 then
            lab:setPosition(300,ff.height - 100)
        elseif type == 23 then
            lab:setPosition(420,ff.height - 100)
        elseif type == 25 then
            lab:setPosition(535,ff.height - 100)
        elseif type == 0 then
            lab:setPosition(600,ff.height - 60)
        else
            if dd.myinfo:getLong(1,"level") <= 10 then
                lab:setPosition(420,ff.height - 100)
            elseif dd.myinfo:getLong(1,"level") <= 14 then
                lab:setPosition(535,ff.height - 100)
            else
                lab:setPosition(655,ff.height - 100)
            end 
        end         

        local action = cc.Spawn:create(
                    cc.MoveBy:create(1, cc.p(0,40)),
                    cc.FadeOut:create(1)
                    )
        lab:runAction(cc.Sequence:create(cc.ScaleBy:create(0.05,1.25),cc.ScaleTo:create(0.125, 1),cc.DelayTime:create(2),cc.CallFunc:create(tagMove),action,cc.RemoveSelf:create()))        
    end
end

function CityUILayer:showTaskArrow(show)
    local arrow = self:getChildByName("mainBtns"):getChildByName("task"):getChildByTag(199)
    if GuideControl._isOver == false then       
        if GuideControl._curGuideLayer ~= nil and GuideControl._curGuideLayer:isVisible() then
            if arrow ~= nil then
                arrow:setVisible(false)
            end
            return
        end
    else
        if arrow ~= nil then
            arrow:setVisible(false)
        end
        return
    end
    if GuideControl.curId >= 6090 or dd.myinfo:getLong(1,"level") >= 6 then
        if arrow ~= nil then
            arrow:setVisible(false)
        end
        return
    end


    if arrow == nil and show == true then
        arrow = cc.Sprite:create("images/guide/task_arrow.png")
        arrow:setRotation(90)
        arrow:setPosition(cc.p(400,135)) 
        self:getChildByName("mainBtns"):getChildByName("task"):addChild(arrow, 199,199)
    end
    if show == true then
        if arrow ~= nil then
            if arrow:isVisible() == false then
                arrow:stopAllActions()
                local ww = self:getChildByName("mainBtns"):getChildByName("task"):getChildByName("tips"):getContentSize().width
                arrow:setPositionX(400 + ww - 260)
                local action = arrow:runAction(cc.RepeatForever:create(cc.Sequence:create(
                cc.CallFunc:create(function () arrow:setPositionX(arrow:getPositionX() + 80) end),
                cc.MoveBy:create(0.6, cc.p(-80, 0)),
                cc.DelayTime:create(0.6)
                )))
                action:setTag(99)
            else
                if arrow:getActionByTag(99) == nil then
                    arrow:stopAllActions()
                    local ww = self:getChildByName("mainBtns"):getChildByName("task"):getChildByName("tips"):getContentSize().width
                    arrow:setPositionX(400 + ww - 260)
                    local action = arrow:runAction(cc.RepeatForever:create(cc.Sequence:create(
                    cc.CallFunc:create(function () arrow:setPositionX(arrow:getPositionX() + 80) end),
                    cc.MoveBy:create(0.6, cc.p(-80, 0)),
                    cc.DelayTime:create(0.6)
                    )))
                    action:setTag(99)
                end
            end
            arrow:setVisible(true)
        end
    else
        if arrow ~= nil then
            arrow:stopAllActions()
            arrow:setVisible(false)
        end
    end
end

function addCityUI(parent)
    local widget = nil
    if dd.mainUI == nil then
        if pop.jsons['lan_city'][1] == 1 then
            cc.SpriteFrameCache:getInstance():addSpriteFrames("images/ui/"..pop.jsons['lan_city'][pop._index_plist]..".plist")
            ff.gameCore:updateJson(pop.getJsonPath(pop.jsons['lan_city'][pop._index_json]),pop.jsons['lan_city'][pop._index_type])  
            ff.gameCore:updateText("images/ui/city.ExportJson")
            widget = CityUILayer.extend(ff.gameCore:getWidget(pop.getJsonPath(pop.jsons['lan_city'][pop._index_json],pop.jsons['lan_city'][pop._index_type])))
        else
            widget = CityUILayer.extend(dd.loadUi("images/ui/city.json"))
            --cclog("city.json...1")
            --widget = CityUILayer.extend(ccs.GUIReader:getInstance():widgetFromBinaryFile("images/ui/city.csb"))
            --cclog("city.json...2")
        end
        dd.mainUI = widget
        dd.mainUI:retain()
        widget:initUI()
        widget._state['city'] = {-2048,-1104}
        cclog("new cityui")
    else
        widget = dd.mainUI
    end        
    widget._parent = parent
    return widget
end

function aycnImageLoading()
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/block01_top.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/ic03.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/block01_top.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/buff_up.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/ic02.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/ic01.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/ic04.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/ic05.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/top01_zz.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/VIP.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/search_back.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/menu08.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/menu06.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/tag10.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/menu01.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/menu02.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/menu03.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/menu04.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/menu05.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/menu07.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/bg01.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/alpha.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/blood.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/title1.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/title2.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/title3.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/fuhe.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/img01_dead.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/progress_back.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/top_back.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/block04.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/que_bback.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/navi_pg05.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/que_b.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/que_mid.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/que_back.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/que_btn_topa.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/que_pro_back.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/remove.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/que_back.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/buttom.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/top.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/pannel.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/pannel2.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/num_bg.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/select_normal.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/ic02_time.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/ic32.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/global_tips_arrow.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/tag01.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/pg17_bg.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/vs02.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/bg01_task.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/bg01_task3.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/tag10.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/name_bg01.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/block01_map.png",function (texture) end)

    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/bg03_tips.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/tips_line.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/bg02_tips.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/tips_line2.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/city_uplevel.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/bar01_map.png",function (texture) end)

    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/chat_world.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/chat_union.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/chat_friend.png",function (texture) end)

    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/2_tab_btn.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/2_tab_btn_on.png",function (texture) end)

    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/ic_bg01.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/progress_precent.png",function (texture) end)

    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/res_ic06.png",function (texture) end)

    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/back.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/back_vip.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/back_vip_on.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/ic01_map.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/navi01_round.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/block01_round.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/block03_round.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/itemmask.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/head_di.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/public/v2/select_on.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/select.png",function (texture) end)
    cc.Director:getInstance():getTextureCache():addImageAsync("images/ui/v2/map_menu.png",function (texture) initCity() end)
end


