CityLayer._armysAmotions = nil
CityLayer._armysPath = nil
CityLayer._armysPos=nil
CityLayer._flowEye = false
--初始化，城墙，兵

function CityLayer:initStaging()
    if self._show == nil then
        local rows = ff.dbmanager:sql_fetch_rows("select * from client_army_show")
        self._show = {}
        local total = rows:rowCount()
        for i=1,total do
            local _type = rows:getString(i,"type")
            local _pos = tonumber(rows:getString(i,"pos"))
            _type = math.floor((_pos-1)/5)+1
            _pos = _pos - (_type-1)*5
            if self._show[_type] == nil then
                self._show[_type] = {}
            end
            self._show[_type][_pos] = {}
            self._show[_type][_pos]['x'] = tonumber(rows:getString(i,"x"))
            self._show[_type][_pos]['y'] = tonumber(rows:getString(i,"y"))
        end

        rows:clear()
    end
    if self._staging == nil then
        local rows = ff.dbmanager:sql_fetch_rows("select * from client_staging")
        self._staging = {}
        self._staging[1] = {}
        self._staging[2] = {} 
        self._staging[3] = {} 
        self._staging[4] = {} 
        local total = rows:rowCount()
        for i=1,total do
            self._staging[1][i] = tonumber(rows:getString(i,"Infantry"))
            self._staging[2][i] = tonumber(rows:getString(i,"The_cavalry"))
            self._staging[3][i] = tonumber(rows:getString(i,"Archer"))
        end
        rows:clear()
    end

end

function CityLayer:initCityArmys()
    self:initStaging()
	local w1 = nil
	if dd.HolidayAppearance == 2 then
		w1 = cc.Sprite:createWithSpriteFrameName("wall12.png")
	else
		w1 = cc.Sprite:createWithSpriteFrameName("wall1.png")
	end
	w1:setAnchorPoint(cc.p(0,0))	
	self._cityarmys:addChild(w1,1)
	w1:setPosition(cc.p(950,2210 - 2020))

	local w2 = nil
	if dd.HolidayAppearance == 2 then
		w2 = cc.Sprite:createWithSpriteFrameName("wall22.png")
	else
		w2 = cc.Sprite:createWithSpriteFrameName("wall2.png")
	end
	w2:setAnchorPoint(cc.p(0,0))	
	self._cityarmys:addChild(w2,1)
	w2:setPosition(cc.p(950 + 516,2210 - 2020 + 260))

	local w3 = nil
	if dd.HolidayAppearance == 2 then
		w3 = cc.Sprite:createWithSpriteFrameName("wall32.png")
	else
		w3 = cc.Sprite:createWithSpriteFrameName("wall3.png")
	end
	w3:setAnchorPoint(cc.p(0,0))	
	self._cityarmys:addChild(w3,1)
	w3:setPosition(cc.p(950+512+398,2210 - 2020 + 470))

	--初始化兵
	if self._armysAmotions == nil then
		self._armysAmotions  = {}
		self._armysAmotions[1] = {}
		self._armysAmotions[2] = {}
		self._armysAmotions[3] = {}

		self._armysAmotions[1][1] = {} 
	    for j = 1, 8 do
	        local frame = cc.SpriteFrameCache:getInstance():getSpriteFrame("cit_20000_"..j..".png")
	        self._armysAmotions[1][1][j] = frame
	    end
		self._armysAmotions[1][2] = {} 
	    for j = 1, 12 do
	        local frame = cc.SpriteFrameCache:getInstance():getSpriteFrame("cit_20001_"..j..".png")
	        self._armysAmotions[1][2][j] = frame
	    end
		self._armysAmotions[1][3] = {} 
	    for j = 1, 12 do
	        local frame = cc.SpriteFrameCache:getInstance():getSpriteFrame("cit_20002_"..j..".png")
	        self._armysAmotions[1][3][j] = frame
	    end

		self._armysAmotions[2][1] = {} 
		self._armysAmotions[2][2] = {} 
		self._armysAmotions[2][3] = {} 
	    for j = 1, 12 do
	        self._armysAmotions[2][1][j] = cc.SpriteFrameCache:getInstance():getSpriteFrame("cit_10000_"..j..".png")
	        self._armysAmotions[2][2][j] = cc.SpriteFrameCache:getInstance():getSpriteFrame("cit_10001_"..j..".png")
	        self._armysAmotions[2][3][j] = cc.SpriteFrameCache:getInstance():getSpriteFrame("cit_10002_"..j..".png")
	    end

		self._armysAmotions[3][1] = {} 
		self._armysAmotions[3][2] = {} 
		self._armysAmotions[3][3] = {} 
		self._armysAmotions[3][1][1] = cc.SpriteFrameCache:getInstance():getSpriteFrame("cit_30000_1.png")
	    for j = 1, 12 do
	        self._armysAmotions[3][2][j] = cc.SpriteFrameCache:getInstance():getSpriteFrame("cit_30001_"..j..".png")
	        self._armysAmotions[3][3][j] = cc.SpriteFrameCache:getInstance():getSpriteFrame("cit_30002_"..j..".png")
	    end
	end
    
	if self._armysPath == nil then
		self._armysPath = {}
		self._armysPos = {}
		local row = ff.dbmanager:sql_fetch_rows("select * from client_army_pos")
		local path = ff.dbmanager:sql_fetch_rows("select * from client_army_path")
		if row ~= nil and path ~= nil then
			for i=1,path:rowCount() do
				local ids = tonumber(path:getString(i,"ids"))
				self._armysPath[ids] = {}
				local str = Split(path:getString(i,"path"),",")
				local dir = Split(path:getString(i,"dir"),",")
				local dis = Split(path:getString(i,"dis"),",")
				for j=1,table.getn(str) do
					self._armysPath[ids][j]={tonumber(str[j]),tonumber(dir[j]),tonumber(dis[j])}
				end
			end
			for i=1,row:rowCount() do
				local id = tonumber(row:getString(i,"id"))
				self._armysPos[id] = {tonumber(row:getString(i,"x")),tonumber(row:getString(i,"y")),tonumber(row:getString(i,"pos"))}
			end
			row:clear()
			path:clear()
		end
	end
end
function CityLayer:playArmysEffect(pos,num,type)
	--新手引导
	if GuideControl.curId == 670 then
		self._flowEye = true
	end
	cclog("playArmysEffect pos:"..pos..","..type)
	if type > 3 then
		type = 3
	end
    if type == 1 then
    	AudioEngine.playEffect(ff.sounds['p001'])   
    elseif type == 2 then
    	AudioEngine.playEffect(ff.sounds['p002'])   
    elseif type == 3 then
    	AudioEngine.playEffect(ff.sounds['p003'])   
    end	
	--找出起始点
	local ids = 0
	for k,v in pairs(self._armysPos) do
		if v[3] == pos then
			local effect = cc.Sprite:createWithSpriteFrameName("cityalpha.png")
			effect:setVisible(false)
			effect:setAnchorPoint(cc.p(0.5,0.5))			
			self._cityarmys:addChild(effect)
			local count = 3
			if type == 3 then
				count = 1
			end
			if num < count then
				count = num
			end
			for i=1,count do				
				local sprite = cc.Sprite:createWithSpriteFrameName("cit_10000_1.png")
				sprite:setVisible(false)
				sprite:setAnchorPoint(cc.p(0.5,0.5))			
				sprite:setTag(i)
				effect:addChild(sprite,3 - i)
			end
			effect:setTag(1)
			cclog("k:"..k)
			effect._id = k
			effect._type = type
			self:beginPlayArmys(effect)
			break
		end
	end
end
--动画出生
function CityLayer:beginPlayArmys(sender)
	local index = sender:getTag()
	local ids = sender._id
	cclog("ids:"..ids..","..index)

	local tid = self._armysPath[ids][index][1]
	local dir = self._armysPath[ids][index][2]
	local dis = self._armysPath[ids][index][3]
	local x = self._armysPos[ids][1]
	local y = self._armysPos[ids][2]
	local tx = self._armysPos[tid][1]
	local ty = self._armysPos[tid][2]
	local type = sender._type

	--1,1,1,4,1480,848
	cclog(index..","..ids..","..dir..","..dis..","..tx..","..ty..","..tid)
	local animation = nil
	for i=1,3 do
		local item = sender:getChildByTag(i)
		if item ~= nil then
			if dir == 1 then
				item:setFlippedX(true)
			    animation = cc.Animation:createWithSpriteFrames(self._armysAmotions[type][3], 0.1)
			elseif dir == 2 then
				item:setFlippedX(true)
			    animation = cc.Animation:createWithSpriteFrames(self._armysAmotions[type][2], 0.1)
			elseif dir == 3 then
				item:setFlippedX(false)
			    animation = cc.Animation:createWithSpriteFrames(self._armysAmotions[type][2], 0.1)
			else
				item:setFlippedX(false)
			    animation = cc.Animation:createWithSpriteFrames(self._armysAmotions[type][3], 0.1)
			end
			item:stopAllActions()
			item:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
		end
	end
	local function nextEffect()
		if tid == 999 then
			sender:removeFromParent(true)
			AudioEngine.playEffect(ff.sounds[207])   
			self:updateCityArmys()
		else
			sender:setTag(index + 1)
			self:beginPlayArmys(sender)
		end
	end
	
	if sender:getChildrenCount() == 1 then
		sender:getChildByTag(1):setPosition(cc.p(0,0))
	elseif sender:getChildrenCount() == 2 then
		if dir == 1 then
			sender:getChildByTag(1):setPosition(cc.p(-10,10))
			sender:getChildByTag(2):setPosition(cc.p(10,-10))
		elseif dir == 3 then
			sender:getChildByTag(2):setPosition(cc.p(-10,10))
			sender:getChildByTag(1):setPosition(cc.p(10,-10))
		else
			sender:getChildByTag(2):setPosition(cc.p(10,10))
			sender:getChildByTag(1):setPosition(cc.p(-10,-10))
		end
	else		
		if dir == 1 then
			sender:getChildByTag(2):setPosition(cc.p(0,0))
			sender:getChildByTag(1):setPosition(cc.p(-20,10))
			sender:getChildByTag(3):setPosition(cc.p(10,20))
		elseif dir == 2 then
			sender:getChildByTag(1):setPosition(cc.p(0,0))
			sender:getChildByTag(2):setPosition(cc.p(-20,10))
			sender:getChildByTag(3):setPosition(cc.p(10,20))
		elseif dir == 3 then
			sender:getChildByTag(1):setPosition(cc.p(0,0))
			sender:getChildByTag(3):setPosition(cc.p(10,20))
			sender:getChildByTag(2):setPosition(cc.p(30,-10))
		else
			sender:getChildByTag(1):setPosition(cc.p(0,-20))
			sender:getChildByTag(3):setPosition(cc.p(0,0))
			sender:getChildByTag(2):setPosition(cc.p(30,-10))
		end
	end

	if index == 1 then
		for i=1,3 do
			local item = sender:getChildByTag(i)		
			if item ~= nil then
				item:setOpacity(0)
				item:setVisible(true)
		        item:runAction(cc.FadeIn:create(0.5))
			end
		end

        if self._flowEye == true then
        	local xyScale = self._map:getScale()

		    local w = ff.width / 2 
		    local h = dd.mainUI:getChildByName("mapArea"):getContentSize().height / 2

		    local xx = -(x*xyScale - w)
		    local yy = -(y*xyScale - h)

		    if xx > 0 then
		        xx = 0
		    end
		    if yy > 0 then
		        yy = 0
		    end
		    --4096, 2208
		    if xx < (-4096 * xyScale + ff.width) then
		        xx = (-4096 * xyScale + ff.width)
		    end
		    if yy < (-2208 * xyScale + dd.mainUI:getChildByName("mapArea"):getContentSize().height) then
		        yy = (-2208 * xyScale + dd.mainUI:getChildByName("mapArea"):getContentSize().height)
		    end
		    self._scroll:getInnerContainer():setPosition(cc.p(xx,yy))
		    dd.MoveMapTo(cc.p(tx,ty), dis,xyScale)
        end
		sender:setVisible(true)
		sender:setPosition(cc.p(x,y))
        sender:runAction(cc.Sequence:create(cc.MoveTo:create(dis, cc.p(tx,ty)),cc.CallFunc:create(nextEffect)))
	else
		local xyScale = self._map:getScale()
		if tid == 999 then
			for i=1,3 do
				local item = sender:getChildByTag(i)		
				if item ~= nil then
			        item:runAction(cc.FadeOut:create(0.5))
				end
			end			
			if self._flowEye == true then
				dd.MoveMapTo(cc.p(2750,2208-1300), 1,xyScale)
			end
			sender:runAction(cc.Sequence:create(cc.MoveTo:create(1, cc.p(2750,2208-1300)),cc.CallFunc:create(nextEffect)))
		else
			if self._flowEye == true then
				if tid == 19 then
					dd.MoveMapTo(cc.p(tx,ty), dis,0.8)
				else
					dd.MoveMapTo(cc.p(tx,ty), dis,xyScale)
				end
			end
			sender:runAction(cc.Sequence:create(cc.MoveTo:create(dis, cc.p(tx,ty)),cc.CallFunc:create(nextEffect)))
		end
	end
end

function CityLayer:getPos2(pos, i)
    local dx = 23*3/4
    local dy = 9*3/4
    local reasult = nil
    if i == 1 then
        reasult =  cc.p(pos.x+dx,  pos.y-dy)
    elseif i == 2 then
        reasult =  cc.p(pos.x-dx,  pos.y+dy)
    end
    return cc.p(reasult.x, 2208 - reasult.y)
end
function CityLayer:getPos(pos, i)
    local len = 100
    local d = len * math.sin(math.rad(45))
    local dx = 23
    local dy = 9
    local reasult = nil
    if i ==1 then
        reasult =  cc.p(pos.x,  pos.y)
    elseif i == 2 then
        reasult = cc.p(pos.x-dx,  pos.y+dy)
    elseif i == 3 then
        reasult = cc.p(pos.x+dx,  pos.y-dy)
    elseif i == 4 then
        reasult =  cc.p(pos.x-dx,  pos.y-dy)
    elseif i == 5 then
        reasult = cc.p(pos.x-2*dx,  pos.y)
    elseif i == 6 then
        reasult = cc.p(pos.x,  pos.y-2*dy)
    elseif i == 7 then
        reasult = cc.p(pos.x+dx,  pos.y+dy)
    elseif i == 8 then
        reasult = cc.p(pos.x,  pos.y+2*dy)
    elseif i == 9 then
        reasult = cc.p(pos.x+2*dx,  pos.y)
    end
    return cc.p(reasult.x, 2208 - reasult.y)
end

function CityLayer:getZ(_type, n, idx)
    local pos = {5, 8, 2, 4, 7, 1, 6, 9, 3}
    local x, y
    return (_type + n * 3)*1000 + pos[idx]
end



function CityLayer:updateCityArmys()
    if dd.soliders == nil then
    	return
    end	
	--新手引导
	if GuideControl.curId == 670 and GuideControl._curGuideLayer ~= nil then
        GuideControl._curGuideLayer:goNextGuide()
        GuideControl:GuideCheck()	
    end
    self._flowEye = false
    if self._lastArmy == nil then
        self._lastArmy = {}
    end
    local nowArmy = {}
    
    local solider = {}
    solider[1] = 0
    solider[2] = 0
    solider[3] = 0
    for i=1,dd.soliders:rowCount() do
        local soldierid = dd.soliders:getLong(i,"soldierid")
        if soldierid <= 10 then
            solider[1] = solider[1]+dd.soliders:getLong(i,"count")
        elseif soldierid > 10 and soldierid < 21 then
            solider[2] = solider[2]+dd.soliders:getLong(i,"count")
        elseif soldierid >= 21 then
            solider[3] = solider[3]+dd.soliders:getLong(i,"count")
        else
            solider[3] = solider[3]+dd.soliders:getLong(i,"count")
        end
    end

    for i, v in pairs(solider) do
        local pos = v == 0 and 0 or 1
        for p, num in pairs(self._staging[i]) do
            if v >= num and num ~= 0 then
                pos = p
            else
                break
            end
        end

        local r = math.floor(pos / 5) --每块多少个
        local c = math.mod(pos, 5) 

        for k=1, 5 do 
            local n = r+ (c >= k and 1 or 0)

            if n == 0 then
                break
            end
            for m=1, n do 
                local tag = self:getZ(i, k, m)
                local j = self._show[i][k]
                local item = self._cityarmys:getChildByTag(tag)
                nowArmy[tag] = true
	            if item == nil then
		            local sprite = cc.Sprite:createWithSpriteFrameName("cit_".. i .."0000_1.png")
		            sprite:setVisible(true)
		            sprite:setAnchorPoint(cc.p(0.5,0.5))			
		            sprite:setTag(tag)
                    if i == 3 then
                        sprite:setPosition(self:getPos2(cc.p(j.x, j.y), m))
                    else
                        sprite:setPosition(self:getPos(cc.p(j.x, j.y), m))
                    end                     
                    
		            self._cityarmys:addChild(sprite, tag)
                    local x,y = sprite:getPosition()

	                local animation = cc.Animation:createWithSpriteFrames(self._armysAmotions[i][1], 0.1)
		            sprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
		            sprite:setOpacity(0)
                    sprite:runAction(cc.FadeIn:create(0.5))
	            end
            end
        end
    end
    for i, v in pairs(self._lastArmy) do 
       if nowArmy[i] == nil then
            local item = self._cityarmys:getChildByTag(i)
            if item ~= nil then
                item:runAction(cc.Sequence:create(cc.FadeOut:create(0.5), cc.CallFunc:create(function() item:removeFromParent()end), nil))
            end
        end
    end
    self._lastArmy = nowArmy
end
