function CityLayer:buildEvent_init()
    
end
function CityLayer:buildEvent_clear()
    ff.net:removeEvent(1,dd.Tjf_rpc_BuildingAction)
end


function CityLayer.onBuilding(params)
    local code = params[1]
    if code == 0 then
        local action = params[2]
        local pos    = params[3]
        if dd.cityLayer ~= nil then
            if action == 11 or action == 13 or action==21 or action==23 or action == 91 then
                local mod = 1
                for i=1,dd.mybuilds:rowCount() do
                    if dd.mybuilds:getLong(i,"pos") == pos then
                        mod = dd.cfgBuilding[dd.mybuilds:getLong(i,"bid")]['mod']
                        break
                    end
                end

                local isVIP = false
                for i=1,dd.mylists:rowCount() do
                    if dd.mylists:getLong(i,"type") == 13 and dd.mylists:getLong(i,"param1") == pos then
                        isVIP = true
                        break
                    end
                end
                if isVIP == true then
                    if dd.cityLayer._buildingEffectEx ~= nil then
                        dd.cityLayer._buildingEffectEx:removeFromParent(true)
                        dd.cityLayer._buildingEffectEx = nil
                    end
                else 
                    if dd.cityLayer._buildingEffect ~= nil then
                        dd.cityLayer._buildingEffect:removeFromParent(true)
                        dd.cityLayer._buildingEffect = nil
                    end                    
                end  
                     

                if pos ~= 301 then
                    local build = dd.cityLayer._building:getChildByTag(pos)
                    if build ~= nil then
                        local temp = nil
                        if isVIP == true then
                            dd.cityLayer._buildingEffectEx = sp.SkeletonAnimation:create("images/city/dust.json", "images/city/dust.atlas")
                            temp = dd.cityLayer._buildingEffectEx
                        else
                            dd.cityLayer._buildingEffect = sp.SkeletonAnimation:create("images/city/dust.json", "images/city/dust.atlas")
                            temp = dd.cityLayer._buildingEffect
                        end
                        if mod == 1 then
                            temp:setAnimation(0,"dustLARGE",true)
                        elseif mod == 2 then                    
                            temp:setAnimation(0,"dustSMALL",true)
                        else                    
                            temp:setAnimation(0,"dustMEDIUM",true)
                        end              
                        dd.cityLayer:updateBuilding()
                        temp:setVisible(true)

                        local xx,yy = build:getPosition()
                        xx = xx - dd.cityLayer._pos[pos][1]
                        yy = yy - dd.cityLayer._pos[pos][2]   

                        if mod == 2 then
                            if pos == 117 or pos == 112 then
                                temp:setPosition(cc.p(115 - xx,90 - yy))
                            else
                                temp:setPosition(cc.p(127 - xx,128 - yy))
                            end                            
                        elseif mod == 1 then
                            temp:setPosition(cc.p(324 - xx,275 - yy))
                        else
                            temp:setPosition(cc.p(225 - xx,178 - yy))
                        end                                
                        build:addChild(temp,18,pos)
                    end                    


                else
                    local temp = nil
                    if isVIP == true then
                        dd.cityLayer._buildingEffectEx = sp.SkeletonAnimation:create("images/city/cq.json", "images/city/cq.atlas")
                        temp = dd.cityLayer._buildingEffectEx
                    else
                        dd.cityLayer._buildingEffect = sp.SkeletonAnimation:create("images/city/cq.json", "images/city/cq.atlas")
                        temp = dd.cityLayer._buildingEffect
                    end
                    temp:setAnimation(0,"dustCQ_animation",true)

                    dd.cityLayer:updateBuilding()
                    temp:setVisible(true)
                    dd.cityLayer._map:addChild(temp,dd.cityLayer._wallEffectIndex)
                    temp:setPosition(cc.p(2350,958))
                end
                AudioEngine.playEffect(ff.sounds[204])                
            else
                if dd.cityLayer ~= nil then
                    if action == 92 then
                        dd.cityLayer:updateRemove(pos)
                    else
                        AudioEngine.playEffect(ff.sounds['b002'])    
                    end    
                    dd.cityLayer:updateBuilding() 
                end
            end 
        end    
        --特殊处理
        if GuideControl.curId == 800 or GuideControl.curId == 770 then
            if dd.getBuildLevel(1) >= 3 then
                if GuideControl.curId == 770 then
                    if pos == 101 then
                        GuideControl.curId = 785
                    else
                        GuideControl.curId = 795
                    end
                    GuideControl:GuideCheck()   
                end
            else
                if dd.gold() >= 8 then
                    GuideControl.curId = 770
                    GuideControl:GuideCheck()   
                else 
                    GuideControl.curId = 800
                end
            end
        end
        if (GuideControl.curId == 780 or GuideControl.curId == 775) and dd.getBuildLevel(1) >= 3 then
            GuideControl.curId = 785
            GuideControl:GuideCheck()  
        end
        --如果引导被跳过，这里修正后续引导
        if GuideControl.curId == 2000 and dd.getBuildLevel(12) >= 2 then
            GuideControl.curId = 2001
            if GuideControl:GuideCheck() == false then
                GuideControl.curId = 2000
            end
        end
        if dd.getBuildLevel(1) >= 4 and (GuideControl.curId >=1200 and GuideControl.curId < 1400) then
            GuideControl.curId = 1400
        end
        if dd.getBuildLevel(5) >= 4 and (GuideControl.curId >=1400 and GuideControl.curId < 1440) then
            GuideControl.curId = 2000
        end
        if dd.getBuildLevel(1) >= 5 and (GuideControl.curId >=5000 and GuideControl.curId < 5060) then
            GuideControl.curId = 5060
        end
        if GuideControl.curId == 1200 or GuideControl.curId == 1350 or GuideControl.curId == 1400 or GuideControl.curId == 5000 then
            GuideControl:GuideCheck()
        end        
    else
        if code == 111 then
            local function callback()
                pop.onShowPopDialog("vip",1)
            end
            dd.currentLayer._widget:onShowSure(ff.langString("VIP时间不足"),dd.errorCode(code),callback,true,2)
        else
            dd.currentLayer._widget:onShowCodeTips(code)  
        end
        
    end    
end

function CityLayer:onInitBuilds()
    local rows = ff.dbmanager:sql_fetch_rows("select * from cfg_build_pos order by `order`")
    for i=1,rows:rowCount() do
        local item = initBuilding(rows,i)
        self._pos[item._pos] = {tonumber(rows:getString(i,"x")),2208 - tonumber(rows:getString(i,"y")),item._mod}
        self._building:addChild(item,item._order,item._pos)
        item:setPlace(self._pos[item._pos],dd.cfgPos[item._pos]['mod'],dd.cfgPos[item._pos]['lv'])
    end
    rows:clear()
    self:updateBuilding()
end
function CityLayer.onUnLock(params)
    local code = params[1]
    if code == 0 then
        local pos = params[2]
        if dd.cityLayer ~= nil and dd.cityLayer._building ~= nil then
            local build = dd.cityLayer._building:getChildByTag(pos)
            if build ~= nil then
                build:unLock()
            end
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
--更新建筑和建造列表
function CityLayer:updateBuilding(frist)
    for i=1,dd.mybuilds:rowCount() do
        local pos   = dd.mybuilds:getLong(i,"pos")
        local state = dd.mybuilds:getLong(i,"state")
        local bid   = dd.mybuilds:getLong(i,"bid")
        local build = self._building:getChildByTag(pos)
        if build ~= nil then
            local state = dd.mybuilds:getLong(i,"state")
            local level = dd.mybuilds:getLong(i,"level")
            build:setBuildingFrame(bid,state,level,self._pos[pos],true)
        end    
    end
    --移除垃圾石头(前提等级>0并且已经解锁的)
    for i,v in ipairs(self._building:getChildren()) do
        v:addLock(frist)
    end
end
--建筑控制按钮面板
function CityLayer:onBuildClick(pos,point)
    onShowBuildsList(self._widget,pos)
end
--移除建筑
function CityLayer:updateRemove(pos)
    cclog("pos:"..pos)
    local item  = self._building:getChildByTag(pos)
    if item ~= nil then
        item:updateRemove(self._pos[pos])
    end    
end
--建造界面
--建造、升级
function CityLayer.createBuild(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        if dd.cityLayer ~= nil then
            dd.cityLayer._widget:getChildByName("btns"):setVisible(false)
            --dd.cityLayer._widget:getChildByName("btns"):setTouchEnabled(false)
        end    
        local pos = sender:getTag()
        pop.onShowPopDialog('building',pos)
    end    
end
--升级
function CityLayer.updateBuild(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local pos = sender:getTag()
        for i=1,dd.mybuilds:rowCount() do
            if dd.mybuilds:getLong(i,"pos") == pos then
                local bid = dd.mybuilds:getLong(i,"bid")
                if pop.builds[bid] ~= nil then
                    if dd.cityLayer ~= nil then
                        dd.cityLayer._widget:getChildByName("btns"):setVisible(false)
                    end    
                    if pop.builds[bid][4] ~= '' then
                        pop.onShowPopDialog(pop.builds[bid][4],pos)
                    else
                        --pop.popDialog("warnning","","|r\t该界面尚未注册|\n|","确认")
                    end    
                else
                    --pop.popDialog("warnning","","|r\t该界面尚未注册|\n|","确认")
                end    

                break
            end
        end
    end
end

--加速
function CityLayer.onAddSpeed(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local pos = sender:getParent():getParent():getTag()
        for i=1,dd.mybuilds:rowCount() do
            if dd.mybuilds:getLong(i,"pos") == pos and dd.mybuilds:getLong(i,"state") == 1 then
                local message = ff.net:createMessage()
                message:addCmd(0x104)
                message:addLong(dd.uid)
                message:addLong(11)
                message:addLong(0)
                message:addLong(1)
                ff.net:rpc(message,false)
            end    
        end
    end    
end
--拆除
function CityLayer.removeBuild(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local pos = sender:getTag()
        for i=1,dd.mybuilds:rowCount() do
            if dd.mybuilds:getLong(i,"pos") == pos and dd.mybuilds:getLong(i,"state") == 0 then
                if dd.cityLayer ~= nil then
                    dd.cityLayer._widget:getChildByName("btns"):setVisible(false)
                end                 
                local bid = dd.mybuilds:getLong(i,"bid")
                local message = ff.net:createMessage()
                message:addCmd(0x103)
                message:addLong(dd.uid)
                message:addLong(91)
                message:addLong(pos)
                message:addLong(bid)
                --金币补足
                message:addLong(0)
                ff.net:rpc(message,false,dialog)
                break
            end
        end        
    end
end

function CityLayer.onRemoveBuild()
end
--处理建筑排程
function CityLayer:dealBuildScript(nt,row)
    local pos = nt:getLong(row,"param1")
    local info = self._map:getChildByTag(10):getChildByTag(pos):getChildByName("info")
    local starttime = nt:getLong(row,"start")
    local endtime   = nt:getLong(row,"end")
    local curtime   = dd.getServerTime()
    local total     = endtime - starttime
    if total == 0 then
        return
    end    
    local now       = curtime - starttime
    local progress  = math.floor(now * 100 / total)
    if progress > 100 then
        progress = 100
    end
    if progress < 0 then
        progress = 0
    end
    info:getChildByName("progress"):getChildByName("progress"):setPercent(progress)    
    info:setVisible(true)
end

function CityLayer:showBuildingUpLevel(pos)
    local isVIP = false
    local isNormal = false
    for row=1,dd.mylists:rowCount() do   
        if dd.mylists:getLong(row,"type") == 1 then
            isNormal = true
        end
        if dd.mylists:getLong(row,"type") == 13 then
            isVIP = true
        end
    end
    if isVIP==false then
        if self._buildingEffectEx ~= nil then
            self._buildingEffectEx:setVisible(false)
        end
    end
    if isNormal==false then
        if self._buildingEffect ~= nil then
            self._buildingEffect:setVisible(false)
        end
    end    
    
    local bid = 0
    local mod = 1
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"pos") == pos then
            mod = dd.cfgBuilding[dd.mybuilds:getLong(i,"bid")]['mod']
            bid = dd.mybuilds:getLong(i,"bid")
            break
        end
    end
    if self._buildingUpLevel == nil then
        dd.cityLayer._buildingUpLevel = sp.SkeletonAnimation:create("images/city/bsj.json", "images/city/bsj.atlas")
        dd.cityLayer._map:addChild(dd.cityLayer._buildingUpLevel,dd.cityLayer._buildingIndex)
    end
    if mod == 1 then
        dd.cityLayer._buildingUpLevel:setAnimation(0,"sjLARGE",false)
    elseif mod == 2 then                    
        dd.cityLayer._buildingUpLevel:setAnimation(0,"sjSMALL",false)
    else                    
        dd.cityLayer._buildingUpLevel:setAnimation(0,"sjMEDIUM",false)
    end              

    if bid == 1 then
        AudioEngine.playEffect(ff.sounds[205])
    else
        AudioEngine.playEffect(ff.sounds[203])
    end
    dd.cityLayer._buildingUpLevel:setVisible(true)
    if mod == 2 then
        dd.cityLayer._buildingUpLevel:setPosition(cc.p(dd.cityLayer._pos[pos][1]+127,dd.cityLayer._pos[pos][2] + 128))
    elseif mod == 1 then                    
        dd.cityLayer._buildingUpLevel:setPosition(cc.p(dd.cityLayer._pos[pos][1]+324,dd.cityLayer._pos[pos][2] + 275))
    else
        dd.cityLayer._buildingUpLevel:setPosition(cc.p(dd.cityLayer._pos[pos][1]+225,dd.cityLayer._pos[pos][2] + 178))
    end      
    local function show()
        local build = dd.currentLayer._building:getChildByTag(pos)
        if build ~= nil then
            build:flash(true)
        end
    end
    local function unshow()
        local build = dd.currentLayer._building:getChildByTag(pos)
        if build ~= nil then
            build:flash(false)
        end        
        if self._buildingUpLevel ~= nil then
            self._buildingUpLevel:removeFromParent(true)
            self._buildingUpLevel = nil
        end
    end
    self._buildingUpLevel:runAction(cc.Sequence:create(cc.DelayTime:create(0.3),cc.CallFunc:create(show),cc.DelayTime:create(0.2),cc.CallFunc:create(unshow)))    
end

