CityLayer._sjeffect = nil
CityLayer._buffeffect = nil

--等级<=1000
--pos * 1000 + 1 = 建筑名
--pos * 1000 + 2 = 是否可以升级
--pos * 1000 + 3 = 等级
--pos * 1000 + 4 = 资源标签
--pos * 1000 + 5 = buff标签
function CityLayer:addLevel(pos,level,x,y)
	if pos == 206 then
		return
	end
	self:initLevel()
	local item = self._level:getChildByTag(pos * 1000 + 3)
	if item == nil then
		--底图
		item = dd.safeCreateWithSpriteFrameName("sjlevel.png","images/city/effect/sjlayer.plist")
		item:setContentSize(cc.size(32,35))
		item:setAnchorPoint(cc.p(0.5,0.5))	
		self._level:addChild(item,pos*1000 + 3,pos*1000 + 3)
	    local xx = tonumber(dd.cfgPos[pos]['x']) + x
	    local yy = 2208 - tonumber(dd.cfgPos[pos]['y']) + y
	    if pos == 301 then
	    	xx = 2220
	    	yy = 880
	    end

	    item:setPosition(cc.p(xx,yy))
		item:setVisible(true)	
	end
	local num1 = item:getChildByName("level")
	if num1 ~= nil then
		if num1:getTag() == level then
			return
		end
		item:removeAllChildren(true)
	end
	if level > 9 then
		num1 = dd.safeCreateWithSpriteFrameName("sjjt_num"..math.floor(level/10)..".png","images/city/effect/sjlayer.plist")
		num1:setContentSize(cc.size(15,35))
		num1:setAnchorPoint(cc.p(0.5,0.5))	
		num1:setTag(level)
		num1:setName("level")
		item:addChild(num1)
	    num1:setPosition(cc.p(10,18))

		local num2 = dd.safeCreateWithSpriteFrameName("sjjt_num"..(level%10)..".png","images/city/effect/sjlayer.plist")
		num2:setContentSize(cc.size(15,35))
		num2:setAnchorPoint(cc.p(0.5,0.5))	
		num2:setTag(level)
		item:addChild(num2)
	    num2:setPosition(cc.p(20,18))
	else
		num1 = dd.safeCreateWithSpriteFrameName("sjjt_num"..level..".png","images/city/effect/sjlayer.plist")
		num1:setContentSize(cc.size(15,35))
		num1:setAnchorPoint(cc.p(0.5,0.5))	
		num1:setTag(level)
		num1:setName("level")
		item:addChild(num1)
	    num1:setPosition(cc.p(16,18))
	end
end
function CityLayer:isLevelShow(pos)
	if self._level == nil then
		return false
	end
	local item = self._level:getChildByTag(pos * 1000 + 3)
	if item == nil then
		return false
	end
	return true
end
function CityLayer:removeLevel(pos)
	self:initLevel()
	local item = self._level:getChildByTag(pos * 1000 + 3)
	if item ~= nil then
		item:removeFromParent(true)
	end
end
function CityLayer:showUpLevel(tag,pos,x,y)
	self:initLevel()
	local item = self._level:getChildByTag(pos * 1000 + 2)
	if tag == true then
		if item == nil then
			item = dd.safeCreateWithSpriteFrameName("sjjt_1.png","images/city/effect/sjlayer.plist")
			item:setContentSize(cc.size(34,42))
			item:setAnchorPoint(cc.p(0.5,0.5))	
			self._level:addChild(item,pos*1000 + 2,pos*1000 + 2)
			item:setVisible(true)
		    local animation = cc.Animation:createWithSpriteFrames(self._sjeffect, 60/1000)
		    item:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))

		    local xx = tonumber(dd.cfgPos[pos]['x']) + x
		    local yy = 2208 - tonumber(dd.cfgPos[pos]['y']) + y
		    item:setPosition(cc.p(xx,yy))
		end
	else
		if item ~= nil then
			item:removeFromParent(true)
		end
	end
end
function CityLayer:showResBuff(tag,pos,x,y)
	self:initLevel()
	local item = self._level:getChildByTag(pos * 1000 + 5)
	if tag == true then
		if item == nil then
			item = dd.safeCreateWithSpriteFrameName("skeleton-jiasuSMALL_animation_0.png","images/city/effect/sjlayer.plist")
			--item:setContentSize(cc.size(34,42))
			item:setAnchorPoint(cc.p(0.5,0.5))	
			item:setScale(2)
			self._level:addChild(item,pos*1000 + 5,pos*1000 + 5)
			item:setVisible(true)
		    local animation = cc.Animation:createWithSpriteFrames(self._buffeffect, 60/600)
		    item:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))

		    local xx = tonumber(dd.cfgPos[pos]['x']) + x
		    local yy = 2208 - tonumber(dd.cfgPos[pos]['y']) + y
		    item:setPosition(cc.p(xx,yy))
		end
	else
		if item ~= nil then
			item:removeFromParent(true)
		end
	end
end
function CityLayer:addLevelName(pos,bid,x)
	if pos == 206 or bid == 37 or bid == 38 or bid == 39 then
		return
	end
	self:removeLevelName(pos)
	--local item = nil 
	local lan = ff.lang
	if lan ~= 1 then
		lan = 0
	end
	local item = dd.safeCreateWithSpriteFrameName("l"..lan.."_"..bid..".png","images/city/effect/sjlayer.plist")
	item:setAnchorPoint(cc.p(0,0.5))	
	self._level:addChild(item,pos*1000 + 1,pos*1000 + 1)

    local xx = tonumber(dd.cfgPos[pos]['x']) + x
    local yy = 2208 - tonumber(dd.cfgPos[pos]['y']) + 34
    item:setPosition(cc.p(xx,yy))
    item:setOpacity(0)
	item:setVisible(true)	
    item:runAction(cc.FadeIn:create(1))
end
function CityLayer:removeLevelName(pos)
	self:initLevel()
	local item = self._level:getChildByTag(pos*1000 + 1)
	if item ~= nil then
		item:removeFromParent(true)
	end
end
function CityLayer:initLevel()
	if self._level == nil then
		--加载png图片，不用palpha
		ff.gameCore:addImageFile("images/city/effect/sjlayer.png")
	    local cache = cc.SpriteFrameCache:getInstance()
	    cache:addSpriteFrames("images/city/effect/sjlayer.plist")

		self._level = cc.SpriteBatchNode:create("images/city/effect/sjlayer.png",300)
	    self._map:addChild(self._level,self._levelIndex)
	    self._level:setPosition(cc.p(0,0))

	    --升级特效
	    local index = 1
	    if self._sjeffect == nil then
	    	self._sjeffect = {}
		    for j = 1, 3 do
		    	for i=1,6 do
		    		local frame = cache:getSpriteFrame("sjjt_"..i..".png")
		    		self._sjeffect[index] = frame
		    		self._sjeffect[index+1] = frame
		    		self._sjeffect[index+2] = frame
		    		index = index + 3
		    	end
	    	end
	    	local frame = cache:getSpriteFrame("sjjt_6.png")
	    	for i=1,20 do
	    		self._sjeffect[table.getn(self._sjeffect) + 1] = frame
	    	end
	    end	 
	    if self._buffeffect == nil then
	    	self._buffeffect = {}
	    	for i=1,25 do
	    		local frame = cache:getSpriteFrame("skeleton-jiasuSMALL_animation_"..i..".png")
	    		self._buffeffect[i] = frame
	    	end
	    end   
	    local function onTouchBegan(touch, event)
	    	local temp = touch:getLocation()
		    for i,v in ipairs(self._level:getChildren()) do
		    	local tag = v:getTag()
		    	if tag > 1000 and tag%10 == 4 and v:isVisible() == true then
			        local location = v:convertToNodeSpace(touch:getLocation())
			        local size = v:getContentSize()
			        local rect = cc.rect(0, 0, size.width, size.height)
			        if cc.rectContainsPoint(rect, location) then
			        	if dd.cityLayer ~= nil then
			        		return true
				        end
			    	end		    		
		    	end
		    end	
		    return false
	    end

	    local function onTouchMoved(touch, event)
	    	local temp = touch:getLocation()
		    for i,v in ipairs(self._level:getChildren()) do
		    	local tag = v:getTag()
		    	if tag > 1000 and tag%10 == 4 and v:isVisible() == true then
			        local location = v:convertToNodeSpace(touch:getLocation())
			        local size = v:getContentSize()
			        local rect = cc.rect(0, 0, size.width, size.height)
			        if cc.rectContainsPoint(rect, location) then
			        	if dd.cityLayer ~= nil then
				        	dd.cityLayer:makeEffects(math.floor(tag/1000),touch:getLocation())
				        end
			    	end		    		
		    	end
		    end	
	    end
	    local function onTouchEnded(touch, event)
		    for i,v in ipairs(self._level:getChildren()) do
		    	local tag = v:getTag()
		    	if tag > 1000 and tag%10 == 4 and v:isVisible() == true then
			        local location = v:convertToNodeSpace(touch:getLocation())
			        local size = v:getContentSize()
			        local rect = cc.rect(0, 0, size.width, size.height)
			        if cc.rectContainsPoint(rect, location) then
			        	if dd.cityLayer ~= nil then
				        	dd.cityLayer:makeEffects(math.floor(tag/1000),touch:getLocation())
				        end
			    	end		    		
		    	end
		    end	
	    end
        local listener = cc.EventListenerTouchOneByOne:create()
        listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
        listener:registerScriptHandler(onTouchMoved,cc.Handler.EVENT_TOUCH_MOVED)
        listener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED)
        listener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_CANCELLED )
        listener:setSwallowTouches(true)
        self:getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self._level)
	end
end

function CityLayer:makeEffects(pos,positon)
	cclog("makeEffects:"..pos)
    local bid = 0
	for i=1,dd.mybuilds:rowCount() do
		if dd.mybuilds:getLong(i,"pos") == pos then
			bid = dd.mybuilds:getLong(i,"bid")
			break
		end
	end
	if bid <= 0 then
		return
	end
	if bid >= 23 and bid <= 27 then
		self:showEffects1(pos,bid,positon)
	else
		self:showEffects2(pos,bid,positon)
	end
end
function CityLayer:showEffects1(pos,bid,positon)
    local function callback(sender)
    	if sender:getTag() == 23 then
    		dd.shake3(dd.mainUI:getChildByName("top"):getChildByName("resArea"):getChildByName("stone_icon"))
    	elseif sender:getTag() == 24 then
	    	dd.shake3(dd.mainUI:getChildByName("top"):getChildByName("resArea"):getChildByName("wood_icon"))
    	elseif sender:getTag() == 25 then
	    	dd.shake3(dd.mainUI:getChildByName("top"):getChildByName("resArea"):getChildByName("icon_iron"))
    	elseif sender:getTag() == 26 then
	    	dd.shake3(dd.mainUI:getChildByName("top"):getChildByName("resArea"):getChildByName("food_icon"))
    	elseif sender:getTag() == 27 then
	    	dd.shake3(dd.mainUI:getChildByName("top"):getChildByName("resArea"):getChildByName("silver_icon"))
	    end
    end	    
	local item = self._level:getChildByTag(pos*1000 + 4)
	if item == nil then
		return
	end

	local count = 1
    local canget = dd.myResInfo[pos]['nowNum'] + dd.myResInfo[pos]['pro'] * (dd.getServerTime() - dd.myResInfo[pos]['lastUpdate'])/3600
	count  = math.ceil(canget *	10/dd.myResInfo[pos]['limit'])
	if count > 10 then
		count = 10
	end       
	if count < 2 then
		count = 2
	end   

	if ff.platform == 1 then
		cc.SpriteFrameCache:getInstance():addSpriteFrames("images/city/effect/sjlayer.plist")  
	end 

	--count = 10
	cclog("count:"..count..","..canget..","..dd.myResInfo[pos]['limit'])
	for i=1,count do
		local tox = 0
		local toy = ff.height - 80
		local sprite = dd.newSpriteFromUI("public/ic0"..(bid-22)..".png")					
		if bid == 23 then
			local anims = {}
			for j=1,10 do
				local cache = cc.SpriteFrameCache:getInstance()
				local str = j - 1
				local frame = cache:getSpriteFrame("youtong_"..str..".png")
				anims[j] = frame
			end
			sprite:setContentSize(cc.size(40,40))
		    local animation = cc.Animation:createWithSpriteFrames(anims, 0.03)
		    sprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
			sprite:setContentSize(cc.size(40,40))
			tox = 104 + 269				
		elseif bid == 24 then
			local anims = {}
			for j=1,10 do
				local cache = cc.SpriteFrameCache:getInstance()
				local str = j - 1
				local frame = cache:getSpriteFrame("muban_"..str..".png")
				anims[j] = frame
			end
		    local animation = cc.Animation:createWithSpriteFrames(anims, 0.03)
		    sprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
			sprite:setContentSize(cc.size(40,40))
			tox = 104 + 29
		elseif bid == 25 then
			local anims = {}
			for j=1,10 do
				local cache = cc.SpriteFrameCache:getInstance()
				local str = j - 1
				local frame = cache:getSpriteFrame("gangtie_"..str..".png")
				anims[j] = frame
			end
		    local animation = cc.Animation:createWithSpriteFrames(anims, 0.03)
		    sprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
			sprite:setContentSize(cc.size(40,40))
			tox = 104 + 389
		elseif bid == 26 then
			local anims = {}
			for j=1,10 do
				local cache = cc.SpriteFrameCache:getInstance()
				local str = j - 1
				local frame = cache:getSpriteFrame("mianbao_"..str..".png")
				anims[j] = frame
			end
		    local animation = cc.Animation:createWithSpriteFrames(anims, 0.03)
		    sprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
			sprite:setContentSize(cc.size(40,40))
			tox = 104 + 150
		else
			local anims = {}
			for j=1,10 do
				local cache = cc.SpriteFrameCache:getInstance()
				local str = j - 1
				local frame = cache:getSpriteFrame("yinbi_"..str..".png")
				anims[j] = frame
			end
		    local animation = cc.Animation:createWithSpriteFrames(anims, 0.03)
		    sprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
			sprite:setContentSize(cc.size(40,40))
			if dd.myinfo:getLong(1,"level") <= 10 then
				tox = 104 + 269				
			elseif dd.myinfo:getLong(1,"level") <= 14 then
				tox = 104 + 389
			else
				tox = 104 + 508
			end
		end
		sprite:setAnchorPoint(cc.p(0.5,0.5))	
		dd.mainUI:getChildByName("effect"):addChild(sprite)
		local location = dd.mainUI:convertToNodeSpace(positon)
	    sprite:setPosition(cc.p(location.x,location.y))


	    local fix = math.floor(math.random() * 160 - 80)
	    local fiy = math.floor(math.random() * 40 - 80)
        local array = {
               cc.p(0, 0),
               cc.p(fix, fiy),
               cc.p(tox - location.x,toy - location.y),
        }
        local action = cc.CatmullRomBy:create(1 + i * 0.2, array)

        sprite:setTag(bid)
        local sequence = cc.Sequence:create(action, cc.RemoveSelf:create(), cc.CallFunc:create(callback))
        sprite:runAction(sequence)
		sprite:setVisible(true)	
	end
	if bid == 23 then
		AudioEngine.playEffect(ff.sounds[805])		
	elseif bid == 24 then
		AudioEngine.playEffect(ff.sounds[802])		
	elseif bid == 25 then
		AudioEngine.playEffect(ff.sounds[804])		
	elseif bid == 26 then
		AudioEngine.playEffect(ff.sounds[803])		
	else		
		AudioEngine.playEffect(ff.sounds[806])		
	end
    local message = ff.net:createMessage()
    message:addCmd(0x0000016a)
    message:addLong(dd.uid)
    message:addLong(pos)
    ff.net:postMessage(message)      
    item:setVisible(false)
    item._tick = dd.getServerTime()
    GuideControl:GuideCheck()
end
function CityLayer:showEffects2(pos,bid,positon)
    local function callback(sender)
   		dd.shake3(dd.mainUI:getChildByName("top"):getChildByName("power"))
    end	    
	local item = self._level:getChildByTag(pos*1000 + 4)
	if item == nil then
		return
	end

	local count = 6
	for i=1,count do
		local tox = 0
		local toy = ff.height - 80 + 30
		local sprite = dd.safeCreateWithSpriteFrameName("power_star.png","images/city/effect/sjlayer.plist")				
		sprite:setContentSize(cc.size(100,120))
		tox = 190						

		sprite:setAnchorPoint(cc.p(0.5,0.5))	
		dd.mainUI:getChildByName("effect"):addChild(sprite)
		local location = dd.mainUI:convertToNodeSpace(positon)
	    sprite:setPosition(cc.p(location.x,location.y))
        sprite:setTag(bid)

        local action = cc.Spawn:create(
                    cc.EaseIn:create(cc.MoveTo:create(1 + i * 0.1, cc.p(tox,ff.height - 80)),1 + i * 0.1),
                    cc.ScaleTo:create(1+ i * 0.1, 0.5),
                    cc.FadeOut:create(1+ i * 0.1)
                    )
        local sequence = cc.Sequence:create(action,cc.RemoveSelf:create(), cc.CallFunc:create(callback))
        sprite:runAction(sequence)
		sprite:setVisible(true)	
	end
	local que = 0
	if bid == 5 then
		que = 4
	elseif bid == 21 then
		que = 3
	else
		que = 11
	end
	for i=1,dd.mylists:rowCount() do
		if dd.mylists:getLong(i,"type") == que then
		    local message = ff.net:createMessage()
		    message:addCmd(0x00000104)
		    message:addLong(dd.uid)
		    message:addLong(7)
		    message:addLong(pos)
		    message:addLong(que)
		    ff.net:postMessage(message)   
		    AudioEngine.playEffect(ff.sounds[231])   
		    break
		end
	end
    item:setVisible(false)
    item._tick = dd.getServerTime()

end
function CityLayer:addResTag(pos,bid,x,y)
	self:initLevel()
	local item = self._level:getChildByTag(pos * 1000 + 4)
	if item == nil then

		item = dd.safeCreateWithSpriteFrameName("sjjt_res_"..bid..".png","images/city/effect/sjlayer.plist")
		item._tick = 0
		item:setContentSize(cc.size(65,74))
		item:setAnchorPoint(cc.p(0.5,0.5))	
		self._level:addChild(item,pos*1000 + 4,pos*1000 + 4)

	    local xx = 0
	    local yy = 0

	    if bid == 5 then
		    xx = 2300
		    yy = 2208 - 1220
	    else
		    xx = tonumber(dd.cfgPos[pos]['x']) + x
		    yy = 2208 - tonumber(dd.cfgPos[pos]['y']) + y
		end
	    item:setPosition(cc.p(xx,yy))
		item:setVisible(true)	

        local action = cc.MoveBy:create(1+math.random(),cc.p(0,-20))
        local back = action:reverse()
        item:runAction(cc.RepeatForever:create(cc.Sequence:create(action,back)))
    else
    	if item._tick > 0 and dd.getServerTime() - item._tick >= 10 then
    		item:setVisible(true)
    	end
	end
end
function CityLayer.onResourceGain(params)
	--return {code,pos,type,num}
	local code = params[1]
	local pos = params[2]
	cclog("code:"..code..",pos:"..pos)
	if code == 0 then
		local type = params[3]
		local num  = params[4]
		if num > 0 then
		    if dd.cityLayer ~= nil and dd.cityLayer._building ~= nil then
		    	local build = dd.cityLayer._building:getChildByTag(pos)
		    	if build ~= nil then
		    		build:showGetRes(num)
		    		
		    	end
			end
		end
		if params[5] > 0 then
			dd.mainUI:showGetItem(params[5])
		end
		cclog("num:"..num..","..type)
		if type == 26 then
			dd.mainUI:setFood(num)
		elseif type == 27 then
			dd.mainUI:setSilver(num)
		elseif type == 23 then
			dd.mainUI:setStone(num)
		elseif type == 24 then
			dd.mainUI:setWood(num)
		elseif type == 25 then
			dd.mainUI:setIron(num)
		end	
	else
		dd.mainUI:onShowCodeTips(code)
		if dd.cityLayer ~= nil and dd.cityLayer._level ~= nil then
			local item = dd.cityLayer._level:getChildByTag(pos * 1000 + 4)
			if item ~= nil then
				item._tick = 0
				item:setVisible(true)
			end
		end
	end
end

function CityLayer:removeResTag(pos)
	self:initLevel()
	local item = self._level:getChildByTag(pos * 1000 + 4)
	if item ~= nil then
		item:removeFromParent(true)
	end
end

--收集动画
function CityLayer:showEffects3(bid,positon,num,addnum)
    local function callback(sender)
    	if sender:getTag() == 2 then
    		dd.shake3(dd.mainUI:getChildByName("top"):getChildByName("resArea"):getChildByName("stone_icon"))
    	elseif sender:getTag() == 3 then
	    	dd.shake3(dd.mainUI:getChildByName("top"):getChildByName("resArea"):getChildByName("wood_icon"))
    	elseif sender:getTag() == 4 then
	    	dd.shake3(dd.mainUI:getChildByName("top"):getChildByName("resArea"):getChildByName("icon_iron"))
    	elseif sender:getTag() == 5 then
	    	dd.shake3(dd.mainUI:getChildByName("top"):getChildByName("resArea"):getChildByName("food_icon"))
    	elseif sender:getTag() == 6 then
	    	dd.shake3(dd.mainUI:getChildByName("top"):getChildByName("resArea"):getChildByName("silver_icon"))
	    else
		    dd.shake3(dd.mainUI:getChildByName("top"):getChildByName("gold"):getChildByName("icon"))
	    end
    end	    
	local count = num
	for i=1,count do
		local tox = 0
		local toy = ff.height - 80
		local sprite = dd.newSpriteFromUI("public/ic02.png")					
		if bid == 2 then
			local anims = {}
			for j=1,10 do
				local cache = cc.SpriteFrameCache:getInstance()
				local str = j - 1
				local frame = cache:getSpriteFrame("youtong_"..str..".png")
				anims[j] = frame
			end
			sprite:setContentSize(cc.size(40,40))
		    local animation = cc.Animation:createWithSpriteFrames(anims, 0.03)
		    sprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
			sprite:setContentSize(cc.size(40,40))
			tox = 104 + 269				
		elseif bid == 3 then
			local anims = {}
			for j=1,10 do
				local cache = cc.SpriteFrameCache:getInstance()
				local str = j - 1
				local frame = cache:getSpriteFrame("muban_"..str..".png")
				anims[j] = frame
			end
		    local animation = cc.Animation:createWithSpriteFrames(anims, 0.03)
		    sprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
			sprite:setContentSize(cc.size(40,40))
			tox = 104 + 29
		elseif bid == 4 then
			local anims = {}
			for j=1,10 do
				local cache = cc.SpriteFrameCache:getInstance()
				local str = j - 1
				local frame = cache:getSpriteFrame("gangtie_"..str..".png")
				anims[j] = frame
			end
		    local animation = cc.Animation:createWithSpriteFrames(anims, 0.03)
		    sprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
			sprite:setContentSize(cc.size(40,40))
			tox = 104 + 389
		elseif bid == 5 then
			local anims = {}
			for j=1,10 do
				local cache = cc.SpriteFrameCache:getInstance()
				local str = j - 1
				local frame = cache:getSpriteFrame("mianbao_"..str..".png")
				anims[j] = frame
			end
		    local animation = cc.Animation:createWithSpriteFrames(anims, 0.03)
		    sprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
			sprite:setContentSize(cc.size(40,40))
			tox = 104 + 150
		elseif bid == 6 then
			local anims = {}
			for j=1,10 do
				local cache = cc.SpriteFrameCache:getInstance()
				local str = j - 1
				local frame = cache:getSpriteFrame("yinbi_"..str..".png")
				anims[j] = frame
			end
		    local animation = cc.Animation:createWithSpriteFrames(anims, 0.03)
		    sprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
			sprite:setContentSize(cc.size(40,40))
			if dd.myinfo:getLong(1,"level") <= 10 then
				tox = 104 + 269				
			elseif dd.myinfo:getLong(1,"level") <= 14 then
				tox = 104 + 389
			else
				tox = 104 + 508
			end
		elseif bid == 7 then
			local anims = {}
			for j=1,10 do
				local cache = cc.SpriteFrameCache:getInstance()
				local str = j - 1
				local frame = cache:getSpriteFrame("charge_jinbi_"..str..".png")
				anims[j] = frame
			end
		    local animation = cc.Animation:createWithSpriteFrames(anims, 0.03)
		    sprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
			--sprite:setContentSize(cc.size(60,60))
			sprite:setScale(0.5)
			tox = dd.mainUI:getChildByName("top"):getChildByName("gold"):getPositionX() + 35
			toy = toy + 20
		end
		sprite:setAnchorPoint(cc.p(0.5,0.5))	
		sprite:setPosition(positon)
		dd.mainUI:getChildByName("effect"):addChild(sprite)
        sprite:setTag(bid)
        local tick = 0.1 * i
        local sequence = cc.Sequence:create(cc.DelayTime:create(tick),cc.MoveTo:create(0.5,cc.p(tox,toy)), cc.CallFunc:create(callback),cc.RemoveSelf:create())
        sprite:runAction(sequence)
		sprite:setVisible(true)	
	end
	if bid == 2 then
		AudioEngine.playEffect(ff.sounds[805])		
		dd.mainUI:setStone(addnum)
	elseif bid == 3 then
		AudioEngine.playEffect(ff.sounds[802])		
		dd.mainUI:setWood(addnum)
	elseif bid == 4 then
		AudioEngine.playEffect(ff.sounds[804])	
		dd.mainUI:setIron(addnum)	
	elseif bid == 5 then
		AudioEngine.playEffect(ff.sounds[803])		
		dd.mainUI:setFood(addnum)
	elseif bid == 6 then		
		AudioEngine.playEffect(ff.sounds[806])		
		dd.mainUI:setSilver(addnum)
	elseif bid == 7 then	
		AudioEngine.playEffect(ff.sounds[213])		
		dd.mainUI:setGold(addnum)
	end
end
function CityLayer:showResRews(rews)
	local function startAction(sender)
		if sender.type == 7 then
	        local cache = cc.SpriteFrameCache:getInstance()
	        cache:addSpriteFrames("images/effect/charge/goldroll.plist")
		end		
		local positon = cc.p(100 + (sender.index - 1) * 60,ff.height - 280)
		self:showEffects3(sender.type,positon,5,sender.count)
	end
	local items = Split(rews,"%|")
	if items == nil or table.getn(items) <= 0 then
		return
	end
	local index = 1
	for i=1,table.getn(items) do
		local item = Split(items[i],"%^")
		if table.getn(item) == 3 then
            local sprite = nil
            index = index + 1
			local type = tonumber(item[1])
			local id   = tonumber(item[2])
			local count= tonumber(item[3])
			if type == 1 then

			elseif type >= 2 and type <= 7 then
				if type == 2 then
					sprite = dd.newSpriteFromUI("public/ic01.png")
				elseif type == 3 then
					sprite = dd.newSpriteFromUI("public/ic02.png")
				elseif type == 4 then
					sprite = dd.newSpriteFromUI("public/ic03.png")
				elseif type == 5 then
					sprite = dd.newSpriteFromUI("public/ic04.png")
				elseif type == 6 then
					sprite = dd.newSpriteFromUI("public/ic05.png")
				else
					sprite = dd.newSpriteFromUI("public/ic06.png")
				end					
			end
            sprite:setPosition(cc.p(100 + (index - 1) * 60,ff.height - 220))
            sprite:setOpacity(100)
	        local action = cc.Spawn:create(
	                    cc.EaseBackOut:create(cc.MoveTo:create(1,cc.p(100 + (index - 1) * 60,ff.height - 280))),
	                    cc.FadeIn:create(0.5)
	                    )
	        sprite.type = type
	        sprite.count= count
	        sprite.tid  = id
	        sprite.index = index
	        sprite:runAction(cc.Sequence:create(action,cc.CallFunc:create(startAction),cc.RemoveSelf:create()))
            dd.mainUI:getChildByName("effect"):addChild(sprite)
		end
	end
end