joinMsgLayer = class("joinMsgLayer")
joinMsgLayer._name = "joinMsg"
joinMsgLayer._init = false


function joinMsgLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,joinMsgLayer)
	return target
end

function joinMsgLayer:onInit(  )
	-- body
	if self._init == false then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		self:setPositionY(0)
		self:getChildByName("back"):setContentSize(cc.size(720,hh))
		self:getChildByName("back"):addTouchEventListener(self.onReturn)
		self:getChildByName("back"):getChildByName("join"):addTouchEventListener(self.onJoin)
		--self:getChildByName("back"):getChildByName("img_arrow"):addTouchEventListener(self.onNothing)
		--self:getChildByName("back"):getChildByName("img_arrow"):getChildByName("title"):setString(ff.langString("加入联盟"))

		self._init = true
	end
end

function joinMsgLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("joinMsg")
		if widget == nil then
			return
		end
        pop.onClosePopDialog("joinMsg")
    end
end

function joinMsgLayer.onJoin( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then  
    	
        pop.onClosePopDialog("joinMsg")
        pop.onShowPopDialog("noUnion",2) 
    end
end

function joinMsgLayer.onEnd( sender )
    -- body
    dd.joinUnionShow = 3
    dd.delBackEvent()
end

function onShowJoinMsg(widget)
	-- body
	local layer = joinMsgLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end