---资源界面
resourcesLayer = class("resourcesLayer")
resourcesLayer._name = "resources"
resourcesLayer._init = false
resourcesLayer._type = 1

function resourcesLayer.extend( target )
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,resourcesLayer)
	return target
	-- body
end

function resourcesLayer:onAutoSize()
    local hh = ff.height
    self:setContentSize(cc.size(720,hh-214))
    self:getChildByName("back"):setContentSize(cc.size(720,hh-214))
    self:getChildByName("topArea"):setPositionY(self:getContentSize().height - 105)
    --self:getChildByName("topArea"):getChildByName("chu_title"):setString(ff.langString("资源汇总"))
    self:getChildByName("topArea"):getChildByName("return"):addTouchEventListener(self.onReturn)
    self:getChildByName("topArea"):getChildByName("addgold"):addTouchEventListener(dd.onPay)

    self:getChildByName("resources"):setContentSize(cc.size(720,hh-214-110))
    self:getChildByName("resources"):setPositionY(0)
end

function resourcesLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("resources")
		if widget == nil then
			return
		end
        pop.onClosePopDialog("resources")
    end
end

function resourcesLayer:onInit( type )
	-- body
    if self._init == false then
        self:onAutoSize()
        self._init = true
    end
    self._type = type 
    if type ~= 1 then
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("道具")) 
    else
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("资源汇总")) 
    end
    self:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
    self:getChildByName("topArea"):requestDoLayout()
    self.updategold()

end

function resourcesLayer.onStart( sender )
    -- body
    sender:InitData()
    
    schedule(sender, sender.updateList,1)
    ff.net:bindProperty(2622,"gold",sender.updategold)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addgold"))
end

function resourcesLayer.updateList( sender )
    -- body
    if sender._type ~= 1 then
        return
    end
    for i=10000,10004 do
        local item = sender:getChildByName("resources"):getChildByTag(i)

        if i == 10001 then
            item:getChildByName("total"):setString(ff.langString("总量").."："..dd.showKM(dd.food(),6))
            item:getChildByName("production"):setString(ff.langString("产量").."："..dd.myResOut:getLong(1,"food"))
            item:getChildByName("upperlimit"):setString(ff.langString("生产上限").."："..dd.myResOut:getLong(1,"food_max"))
            if dd.myResOut:getLong(1,"keepfood") > dd.myResOut:getLong(1,"food") then
                item:getChildByName("keep"):setColor(cc.c3b(255,0,0))
            else
                item:getChildByName("keep"):setColor(cc.c3b(161,175,175))
            end
            item:getChildByName("keep"):setString(ff.langString("维持").."："..dd.myResOut:getLong(1,"keepfood"))
            local add = 0
            local time = 0
            for var=1, dd.myeffect:rowCount() do
                if dd.myeffect:getLong(var,'id') == 514 then
                    add = dd.myeffect:getLong(var,'param')
                    break
                end
            end
            if add > 0 then
                item:getChildByName("forgeinfo"):setVisible(true)
                --item:getChildByName("time"):setVisible(true)
                local per = 0
                    for i=1,dd.myplus:rowCount() do
                        if dd.myplus:getLong(i,"id") == 514 then
                            local start = dd.myplus:getLong(i,"start")
                            local endtime   = dd.myplus:getLong(i,"end")
                            if (endtime - start )>0 then
                                per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                            end
                            time = dd.myplus:getLong(i,"end") - dd.getServerTime()
                            break
                        end
                    end
                item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
                item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("buffer"):setString(ff.langString("增效").."："..(add/10).."%")
                item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("showtime"):setString(ff.getLeftTime(time,":"))
            else
                item:getChildByName("forgeinfo"):setVisible(false)
                --item:getChildByName("time"):setVisible(false)
            end
        elseif i== 10002 then
            local level = dd.myinfo:getLong(1,"level")
            if level > 10 then
                if item == nil then
                    local item = sender:getChildByName("item"):clone()
                    item:setTag(i)
                    sender:getChildByName("resources"):insertCustomItem(item,3)
                    item:setVisible(true)
                    item:getChildByName("supplement"):addTouchEventListener(sender.onOpenMulTools)
                    item:getChildByName("buff"):addTouchEventListener(sender.onOpenMulTools)
                end
                item:getChildByName("total"):setString(ff.langString("总量").."："..dd.showKM(dd.stone(),6))
                item:getChildByName("production"):setString(ff.langString("产量").."："..dd.myResOut:getLong(1,"stone"))
                item:getChildByName("upperlimit"):setString(ff.langString("生产上限").."："..dd.myResOut:getLong(1,"stone_max"))
                item:getChildByName("keep"):setVisible(false)
                local add = 0
                local time = 0
                for var=1, dd.myeffect:rowCount() do
                    if dd.myeffect:getLong(var,'id') == 511 then
                        add = dd.myeffect:getLong(var,'param')
                        break
                    end
                end
                if add > 0 then
                    item:getChildByName("forgeinfo"):setVisible(true)
                    --item:getChildByName("time"):setVisible(true)
                    local per = 0
                        for i=1,dd.myplus:rowCount() do
                            if dd.myplus:getLong(i,"id") == 511 then
                                local start = dd.myplus:getLong(i,"start")
                                local endtime   = dd.myplus:getLong(i,"end")
                                if (endtime - start )>0 then
                                    per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                                end
                                time = dd.myplus:getLong(i,"end") - dd.getServerTime()
                                break
                            end
                        end
                    item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
                    item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("buffer"):setString(ff.langString("增效").."："..(add/10).."%")
                    item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("showtime"):setString(ff.getLeftTime(time,":"))
                else
                    item:getChildByName("forgeinfo"):setVisible(false)
                    --item:getChildByName("time"):setVisible(false)
                end
            end
        elseif i== 10003 then
            local level = dd.myinfo:getLong(1,"level")
            if level > 14 then
                if item == nil then
                    local item = sender:getChildByName("item"):clone()
                    item:setTag(i)
                    sender:getChildByName("resources"):insertCustomItem(item,4)
                    item:setVisible(true)
                    item:getChildByName("supplement"):addTouchEventListener(sender.onOpenMulTools)
                    item:getChildByName("buff"):addTouchEventListener(sender.onOpenMulTools)
                    sender:getChildByName("resources"):refreshView()
                end
                item:getChildByName("total"):setString(ff.langString("总量").."："..dd.showKM(dd.iron(),6))
                item:getChildByName("production"):setString(ff.langString("产量").."："..dd.myResOut:getLong(1,"iron"))
                item:getChildByName("upperlimit"):setString(ff.langString("生产上限").."："..dd.myResOut:getLong(1,"iron_max"))
                item:getChildByName("keep"):setVisible(false)
                local add = 0
                local time = 0
                for var=1, dd.myeffect:rowCount() do
                    if dd.myeffect:getLong(var,'id') == 513 then
                        add =  dd.myeffect:getLong(var,'param')
                        break
                    end
                end
                if add > 0 then
                    item:getChildByName("forgeinfo"):setVisible(true)
                    --item:getChildByName("time"):setVisible(true)
                    local per = 0
                        for i=1,dd.myplus:rowCount() do
                            if dd.myplus:getLong(i,"id") == 513 then
                                local start = dd.myplus:getLong(i,"start")
                                local endtime   = dd.myplus:getLong(i,"end")
                                if (endtime - start )>0 then
                                    per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                                end
                                time = dd.myplus:getLong(i,"end") - dd.getServerTime()
                                break
                            end
                        end
                    item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
                    item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("buffer"):setString(ff.langString("增效").."："..(add/10).."%")
                    item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("showtime"):setString(ff.getLeftTime(time,":"))
                else
                    item:getChildByName("forgeinfo"):setVisible(false)
                    --item:getChildByName("time"):setVisible(false)
                end
            end
        elseif i== 10000 then
            item:getChildByName("total"):setString(ff.langString("总量").."："..dd.showKM(dd.wood(),6))
            item:getChildByName("production"):setString(ff.langString("产量").."："..dd.myResOut:getLong(1,"wood"))
            item:getChildByName("upperlimit"):setString(ff.langString("生产上限").."："..dd.myResOut:getLong(1,"wood_max"))
            item:getChildByName("keep"):setVisible(false)
            local add = 0
            local time = 0
            for var=1, dd.myeffect:rowCount() do
                if dd.myeffect:getLong(var,'id') == 512 then
                    add =  dd.myeffect:getLong(var,'param')
                    break
                end
            end
            if add > 0 then
                item:getChildByName("forgeinfo"):setVisible(true)
                --item:getChildByName("time"):setVisible(true)
                local per = 0
                    for i=1,dd.myplus:rowCount() do
                        if dd.myplus:getLong(i,"id") == 512 then
                            local start = dd.myplus:getLong(i,"start")
                            local endtime   = dd.myplus:getLong(i,"end")
                            if (endtime - start )>0 then
                                per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                            end
                            time = dd.myplus:getLong(i,"end") - dd.getServerTime()
                            break
                        end
                    end
                item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
                item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("buffer"):setString(ff.langString("增效").."："..(add/10).."%")
                item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("showtime"):setString(ff.getLeftTime(time,":"))
            else
                item:getChildByName("forgeinfo"):setVisible(false)
                --item:getChildByName("time"):setVisible(false)
            end
        elseif i== 10004 then
            item:getChildByName("total"):setString(ff.langString("总量").."："..dd.showKM(dd.silver(),6))
            item:getChildByName("production"):setString(ff.langString("产量").."："..dd.myResOut:getLong(1,"silver"))
            item:getChildByName("upperlimit"):setString(ff.langString("生产上限").."："..dd.myResOut:getLong(1,"silver_max"))
            item:getChildByName("keep"):setVisible(false)
            local add = 0
            local time = 0
            for var=1, dd.myeffect:rowCount() do
                if dd.myeffect:getLong(var,'id') == 515 then
                    add =  dd.myeffect:getLong(var,'param')
                    break
                end
            end
            if add > 0 then
                item:getChildByName("forgeinfo"):setVisible(true)
                --item:getChildByName("time"):setVisible(true)
                local per = 0
                    for i=1,dd.myplus:rowCount() do
                        if dd.myplus:getLong(i,"id") == 515 then
                            local start = dd.myplus:getLong(i,"start")
                            local endtime   = dd.myplus:getLong(i,"end")
                            if (endtime - start )>0 then
                                per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                            end
                            time = dd.myplus:getLong(i,"end") - dd.getServerTime()
                            break
                        end
                    end
                item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
                item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("buffer"):setString(ff.langString("增效").."："..(add/10).."%")
                item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("showtime"):setString(ff.getLeftTime(time,":"))
            else
                item:getChildByName("forgeinfo"):setVisible(false)
                --item:getChildByName("time"):setVisible(false)
            end
        elseif i== 10005 then
            item:getChildByName("total"):setString(ff.langString("总量").."："..dd.showKM(dd.food(),6))
            item:getChildByName("production"):setString(ff.langString("产量").."："..dd.myResOut:getLong(1,"food"))
            item:getChildByName("upperlimit"):setString(ff.langString("生产上限").."："..dd.myResOut:getLong(1,"food_max"))
            item:getChildByName("keep"):setVisible(false)
        end
    end
end

function onShowResources( widget ,type)
	-- body
    local layer = resourcesLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit(type)
    return layer
end

function resourcesLayer.onEnd( sender )
    -- body
    dd.delBackEvent(sender.onReturn)
    ff.net:unbindProperty("gold",2622)
    sender:stopAllActions()
    sender:getChildByName("resources"):removeAllChildren(true)
end

function resourcesLayer.updategold()
    local widget = pop.getDialog("resources")
    if widget ~= nil then

        widget:getChildByName("topArea"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("topArea"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("topArea"):requestDoLayout()
    end
end

function resourcesLayer.onOpenMulTools( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then   
        local tag = sender:getTag()
        dd.currentLayer._widget:onShowMulTools(tag,0,nil,true)
    end
end

function resourcesLayer:InitData(  )
    -- body
    self:getChildByName("resources"):removeAllChildren(true)
    if self._type == 1 then
        for i=10000,10004 do
            local item = self:getChildByName("item"):clone()
            item:setTag(i)
            
            item:setVisible(true)
            item:getChildByName("supplement"):addTouchEventListener(self.onOpenMulTools)
            item:getChildByName("buff"):addTouchEventListener(self.onOpenMulTools)

            if i == 10001 then
                
                item:getChildByName("supplement"):setTag(4)
                item:getChildByName("buff"):setTag(14)
                item:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/res/ic04_bk.png",0)
                item:getChildByName("name"):setString(ff.langString("粮食"))
                item:getChildByName("total"):setString(ff.langString("总量").."："..dd.showKM(dd.food(),6))
                item:getChildByName("production"):setString(ff.langString("产量").."："..dd.myResOut:getLong(1,"food"))
                item:getChildByName("upperlimit"):setString(ff.langString("生产上限").."："..dd.myResOut:getLong(1,"food_max"))
                item:getChildByName("keep"):setString(ff.langString("维持").."："..dd.myResOut:getLong(1,"keepfood"))
                self:getChildByName("resources"):pushBackCustomItem(item)
                local add = 0
                local time = 0
                for var=1, dd.myeffect:rowCount() do
                    if dd.myeffect:getLong(var,'id') == 514 then
                        add = dd.myeffect:getLong(var,'param')
                        break
                    end
                end
                if add > 0 then
                    item:getChildByName("forgeinfo"):setVisible(true)
                    --item:getChildByName("time"):setVisible(true)
                    local per = 0
                        for i=1,dd.myplus:rowCount() do
                            if dd.myplus:getLong(i,"id") == 514 then
                                local start = dd.myplus:getLong(i,"start")
                                local endtime   = dd.myplus:getLong(i,"end")
                                if (endtime - start )>0 then
                                    per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                                end
                                time = dd.myplus:getLong(i,"end") - dd.getServerTime()
                                break
                            end
                        end
                    item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
                    item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("buffer"):setString(ff.langString("增效").."："..(add/10).."%")
                    item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("showtime"):setString(ff.getLeftTime(time,":"))
                else
                    item:getChildByName("forgeinfo"):setVisible(false)
                    
                end
            elseif i== 10003 then
                local level = dd.myinfo:getLong(1,"level")
                if level > 14 then
                    item:getChildByName("supplement"):setTag(3)
                    item:getChildByName("buff"):setTag(13)
                    item:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/res/ic03_bk.png",0)
                    item:getChildByName("name"):setString(ff.langString("钢铁"))
                    item:getChildByName("total"):setString(ff.langString("总量").."："..dd.showKM(dd.iron(),6))
                    item:getChildByName("production"):setString(ff.langString("产量").."："..dd.myResOut:getLong(1,"iron"))
                    item:getChildByName("upperlimit"):setString(ff.langString("生产上限").."："..dd.myResOut:getLong(1,"iron_max"))
                    item:getChildByName("keep"):setVisible(false)
                    self:getChildByName("resources"):pushBackCustomItem(item)
                    local add = 0
                    local time = 0
                    for var=1, dd.myeffect:rowCount() do
                        if dd.myeffect:getLong(var,'id') == 513 then
                            add =  dd.myeffect:getLong(var,'param')
                            break
                        end
                    end
                    if add > 0 then
                        item:getChildByName("forgeinfo"):setVisible(true)
                        --item:getChildByName("time"):setVisible(true)
                        local per = 0
                            for i=1,dd.myplus:rowCount() do
                                if dd.myplus:getLong(i,"id") == 513 then
                                    local start = dd.myplus:getLong(i,"start")
                                    local endtime   = dd.myplus:getLong(i,"end")
                                    if (endtime - start )>0 then
                                        per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                                    end
                                    time = dd.myplus:getLong(i,"end") - dd.getServerTime()
                                    break
                                end
                            end
                        item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
                        item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("buffer"):setString(ff.langString("增效").."："..(add/10).."%")
                        item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("showtime"):setString(ff.getLeftTime(time,":"))
                    else
                        item:getChildByName("forgeinfo"):setVisible(false)
                        --item:getChildByName("time"):setVisible(false)
                    end
                end
                
            elseif i== 10002 then
                local level = dd.myinfo:getLong(1,"level")
                if level > 10 then
                    item:getChildByName("supplement"):setTag(1)
                    item:getChildByName("buff"):setTag(11)
                    item:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/res/ic01_bk.png",0)
                    item:getChildByName("name"):setString(ff.langString("石油"))
                    item:getChildByName("total"):setString(ff.langString("总量").."："..dd.showKM(dd.stone(),6))
                    item:getChildByName("production"):setString(ff.langString("产量").."："..dd.myResOut:getLong(1,"stone"))
                    item:getChildByName("upperlimit"):setString(ff.langString("生产上限").."："..dd.myResOut:getLong(1,"stone_max"))
                    item:getChildByName("keep"):setVisible(false)
                    self:getChildByName("resources"):pushBackCustomItem(item)
                    local add = 0
                    local time = 0
                    for var=1, dd.myeffect:rowCount() do
                        if dd.myeffect:getLong(var,'id') == 511 then
                            add = dd.myeffect:getLong(var,'param')
                            break
                        end
                    end
                    if add > 0 then
                        item:getChildByName("forgeinfo"):setVisible(true)
                        --item:getChildByName("time"):setVisible(true)
                        local per = 0
                            for i=1,dd.myplus:rowCount() do
                                if dd.myplus:getLong(i,"id") == 511 then
                                    local start = dd.myplus:getLong(i,"start")
                                    local endtime   = dd.myplus:getLong(i,"end")
                                    if (endtime - start )>0 then
                                        per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                                    end
                                    time = dd.myplus:getLong(i,"end") - dd.getServerTime()
                                    break
                                end
                            end
                        item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
                        item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("buffer"):setString(ff.langString("增效").."："..(add/10).."%")
                        item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("showtime"):setString(ff.getLeftTime(time,":"))
                    else
                        item:getChildByName("forgeinfo"):setVisible(false)
                        --item:getChildByName("time"):setVisible(false)
                    end
                end
            elseif i== 10000 then
                item:getChildByName("supplement"):setTag(2)
                item:getChildByName("buff"):setTag(12)
                item:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/res/ic02_bk.png",0)
                item:getChildByName("name"):setString(ff.langString("木材"))
                item:getChildByName("total"):setString(ff.langString("总量").."："..dd.showKM(dd.wood(),6))
                item:getChildByName("production"):setString(ff.langString("产量").."："..dd.myResOut:getLong(1,"wood"))
                item:getChildByName("upperlimit"):setString(ff.langString("生产上限").."："..dd.myResOut:getLong(1,"wood_max"))
                item:getChildByName("keep"):setVisible(false)
                self:getChildByName("resources"):pushBackCustomItem(item)
                local add = 0
                local time = 0
                for var=1, dd.myeffect:rowCount() do
                    if dd.myeffect:getLong(var,'id') == 512 then
                        add =  dd.myeffect:getLong(var,'param')
                        break
                    end
                end
                if add > 0 then
                    item:getChildByName("forgeinfo"):setVisible(true)
                    --item:getChildByName("time"):setVisible(true)
                    local per = 0
                        for i=1,dd.myplus:rowCount() do
                            if dd.myplus:getLong(i,"id") == 512 then
                                local start = dd.myplus:getLong(i,"start")
                                local endtime   = dd.myplus:getLong(i,"end")
                                if (endtime - start )>0 then
                                    per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                                end
                                time = dd.myplus:getLong(i,"end") - dd.getServerTime()
                                break
                            end
                        end
                    item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
                    item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("buffer"):setString(ff.langString("增效").."："..(add/10).."%")
                    item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("showtime"):setString(ff.getLeftTime(time,":"))
                else
                    item:getChildByName("forgeinfo"):setVisible(false)
                    --item:getChildByName("time"):setVisible(false)
                end
            elseif i== 10004 then
                item:getChildByName("supplement"):setTag(5)
                item:getChildByName("buff"):setTag(15)
                item:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/res/ic05_bk.png",0)
                item:getChildByName("name"):setString(ff.langString("银币"))
                item:getChildByName("total"):setString(ff.langString("总量").."："..dd.showKM(dd.silver(),6))
                item:getChildByName("production"):setString(ff.langString("产量").."："..dd.myResOut:getLong(1,"silver"))
                item:getChildByName("upperlimit"):setString(ff.langString("生产上限").."："..dd.myResOut:getLong(1,"silver_max"))
                item:getChildByName("keep"):setVisible(false)
                self:getChildByName("resources"):pushBackCustomItem(item)
                local add = 0
                local time = 0
                for var=1, dd.myeffect:rowCount() do
                    if dd.myeffect:getLong(var,'id') == 515 then
                        add =  dd.myeffect:getLong(var,'param')
                        break
                    end
                end
                if add > 0 then
                    item:getChildByName("forgeinfo"):setVisible(true)
                    --item:getChildByName("time"):setVisible(true)
                    local per = 0
                        for i=1,dd.myplus:rowCount() do
                            if dd.myplus:getLong(i,"id") == 515 then
                                local start = dd.myplus:getLong(i,"start")
                                local endtime   = dd.myplus:getLong(i,"end")
                                if (endtime - start )>0 then
                                    per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                                end
                                time = dd.myplus:getLong(i,"end") - dd.getServerTime()
                                break
                            end
                        end
                    item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
                    item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("buffer"):setString(ff.langString("增效").."："..(add/10).."%")
                    item:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("showtime"):setString(ff.getLeftTime(time,":"))
                else
                    item:getChildByName("forgeinfo"):setVisible(false)
                    --item:getChildByName("time"):setVisible(false)
                end
            elseif i== 10005 then
                self:getChildByName("resources"):pushBackCustomItem(item)
                item:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/res/ic03_bk.png",0)
                item:getChildByName("name"):setString(ff.langString("粮食"))
                item:getChildByName("total"):setString(ff.langString("总量")..dd.showKM(dd.food(),6))
                item:getChildByName("production"):setString(ff.langString("产量").."："..dd.myResOut:getLong(1,"food"))
                item:getChildByName("upperlimit"):setString(ff.langString("生产上限").."："..dd.myResOut:getLong(1,"food_max"))
                item:getChildByName("keep"):setVisible(false)
            end
            --self:getChildByName("resources"):pushBackCustomItem(item)
        end
    else
        local level = dd.myinfo:getLong(1,"level") + 1
        for i=1,dd.mytools:rowCount() do
            if dd.cfgProp[dd.mytools:getLong(i,"tid")] ~= nil and dd.cfgProp[dd.mytools:getLong(i,"tid")]["vanish"] == level then
                local item = self:getChildByName("ExpiredItem"):clone()
                item:setTag(dd.mytools:getLong(i,"tid"))
                
                item:setVisible(true)
                item:getChildByName("name"):setString(ff.langString(dd.cfgProp[dd.mytools:getLong(i,"tid")]["name"],{dd.cfgProp[dd.mytools:getLong(i,"tid")]["name1_lan"]}))
                item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getToolsIcon(dd.mytools:getLong(i,"tid")),0)
                item:getChildByName("count"):setString(dd.mytools:getLong(i,"count"))
                item:getChildByName("info"):setString(ff.langString(dd.cfgProp[dd.mytools:getLong(i,"tid")]['tips'],{dd.cfgProp[dd.mytools:getLong(i,"tid")]['tips1_lan']}))
                self:getChildByName("resources"):pushBackCustomItem(item)
            end
        end
    end
    self:getChildByName("resources"):jumpToTop()
    --self:getChildByName("resources"):setItemsMargin(5)
end