--region NewFile_1.lua
--Author : tjfa
--Date   : 2015/3/13

local GuideMaskLayer = class("GuideMaskLayer")  

GuideMaskLayer._name = "GuideMaskLayer"
GuideMaskLayer.swallow = true
GuideMaskLayer.closeBtn = nil

function GuideMaskLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, GuideMaskLayer)
    return target
end

function GuideMaskLayer:init()
	local function onTouchBegan(touch, event)
        if self.swallow then
            cclog(">>>>>>触摸事件：新手引导遮罩层<<<<<")
        end
		return self.swallow
    end

    local function onTouchEnd(touch, event)
        
    end

	local listener = cc.EventListenerTouchOneByOne:create()
    listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
    listener:registerScriptHandler(onTouchEnd,cc.Handler.EVENT_TOUCH_ENDED)
    listener:setSwallowTouches(true)
    self:getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self)


    function closeBtn(sender,eventType)
        if eventType==ccui.TouchEventType.ended then   
            if GuideControl._curGuideLayer == nil then
                GuideControl:ShowMaskLayer(false)  
                return
            end    	        
            local message = ff.net:createMessage()
            message:addCmd(0x00000149)
            message:addLong(dd.uid)
            message:addLong(-999)
            ff.net:postMessage(message)

            GuideControl._isOver = true
            GuideControl.curId = -999
            platform_taskFinish("skip",0)  
            --GuideControl.curId = GuideControl.cfg_guideData[GuideControl.curId]['skipid']
            --GuideControl.curGuidData = GuideControl.cfg_guideData[GuideControl.cfg_guideData[GuideControl.curId]['skipid']]
            dd.myinfo:setLong(1,"newbie", GuideControl.curId)
            GuideControl:ShowMaskLayer(false)
            cc.Director:getInstance():getOpenGLView():enableTouchMove(true)
            if GuideControl._curGuideLayer ~= nil then
                GuideControl._curGuideLayer:setVisible(false)
                if dd.mainUI ~= nil then
                    dd.mainUI:checkGuide()
                end
            end      
        end
    end
    --if ff.debug == true then
    --if cc.PLATFORM_OS_ANDROID ~= cc.Application:getInstance():getTargetPlatform() then
        local close = ccui.Button:create("images/ui/guideClose.png")
        close:setPosition(90, 140)
        close:addTouchEventListener(closeBtn)--
        if GuideControl._curGuideLayer ~= nil then
            GuideControl._curGuideLayer:getChildByName("infoview"):addChild(close)
        end
        self.closeBtn = close
    --end
end

function createGuideMaskLayer()
    local target = GuideMaskLayer.extend(cc.Layer:create())
    target:init()
    return target
end

--endregion
