--登录失败，在这里处理
function login_error(code,call)
	if call ~= nil then
		cclog2("login_error:"..code..",call:"..call)
	else	
		cclog2("login_error:"..code)
	end	
    platform_showDialog("Login Error "..code,"Network connection error",2,0)
end

--测试接口,创建帐号
function login_getuid()
    local message = ff.net:createMessage()
    message:addCmd(0x00000001)
    message:addLong(0)
    message:addLong(0)
    message:addLong(ff.partner)
    message:addString(tostring(ff.acount),64)
    message:addLong(ff.serverid)
    message:addString(ff.gameKey,32)
    message:addString(tostring(ff.acount),15)
    message:addLong(1010)

    print(tostring(ff.acount))
    cclog("ff.acount:"..ff.acount)
    --同步调用，直接收到返回
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then
            dd.uid = result:getLong()
        else
            dd.uid = 0
        end
        result:clear()
    else
        local code = message:getErrorCode()
        cclog3("login_getuid compress error:"..code)
    end        
    message:clear()
    if dd.uid > 0 then
        login_start()
    else
        cclog("登录错误:"..ret)    
        platform_showLoadingBar(99)
        dd.loadingLayer:setLabelColor(cc.c3b(255,0,0))
        dd.loadingLayer:setTips(ff.langString("服务忙，请稍后再试。"))
    end
end

--清理缓冲
function clearDB()
    ff.dbmanager:sql_query("delete from client_chat_history")--清空清除历史记录 不然换账号会查询别人的历史记录

    --ff.dbmanager:sql_query("delete from client_send_mail")
    --ff.dbmanager:sql_query("delete from client_recv_mail")
    --ff.dbmanager:sql_query("delete from client_recv_user_mail")
    --ff.dbmanager:sql_query("delete from client_recv_union_mail")
end

--登录部分
function login_begin()
    ff.gameCore:addImageAsync("images/pve/back.jpg","","images/pve/back.png",1)
    --ff.gameCore:addImageAsync("images/world/move.jpg","images/world/move_mask.jpg","images/world/move.png",2)
    --ff.gameCore:addImageAsync("images/battle/battle.jpg","","images/battle/battle.png",3)
    if ff.gameCore:startInitImages() == 0 then
        dd.initImages = true
    end    

    --预读jsons文件
    if ff.platform == 0 then
        --cc.SpriteFrameCache:getInstance():addSpriteFrames("images/ui/ui1.plist")
        cc.SpriteFrameCache:getInstance():addSpriteFrames("images/ui/ui.plist")
    end
    ff.gameCore:initJsonTexture("public/","alpha.png")
    pop.initPublicPop()
    pop.initInnerCityPop()
    dd.loadingLayer:beginJsons()
    initWating()

    local starttick = ff.gameCore:getTick()
    ff.initNet()
    local function checkConnect()
        if ff.net ~= nil and ff.net:isConnect() == true then
            dd.loadingLayer:setProgress(30)
            dd.loadingLayer:setTips(ff.langString("服务器连接成功。"))
            dd.loadingLayer:stopAllActions()
            login_start()
        else
            if ff.gameCore:getTick() - starttick > 60 * 1000 then
                dd.loadingLayer:setProgress(30)
                platform_showDialog("Network connection error","Connection Error.Please check your wifi or data network and re-login.",2,0)
                dd.loadingLayer:setTips("Connection Error.Please check your wifi or data network")
                dd.loadingLayer:stopAllActions()
            end    
        end 
    end
    schedule(dd.loadingLayer,checkConnect,0.1)
end

function login_start()
    --注册登录
    local message = ff.net:createMessage()
    message:addCmd(0x00000052)
    --uid
    message:addLong(0)
    message:addLong(0)
    message:addLong(ff.partner)
    --szPassportID len:64
    message:addString(ff.acount,64)
    message:addLong(ff.serverid)
    cclog("ff.serverid:"..ff.serverid..","..ff.acount)
    message:addString(ff.gameKey,32)
    cclog("gamekey:"..ff.gameKey)
    cclog("apk_version:"..ff.apk_version..","..cc.UserDefault:getInstance():getIntegerForKey("version"))
    message:addLong(ff.apk_version)
    message:addLong(cc.UserDefault:getInstance():getIntegerForKey("version"))

    --bluestack
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local blue = cc.UserDefault:getInstance():getIntegerForKey("blue",0)
        if blue == 1 then
            message:addLong(2)
        else
            message:addLong(ff.platform)
        end
    else
        message:addLong(ff.platform)
    end
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)

    ff.net:postMessage(message)
    ff.net:setSession(1)

    local function checkMessage_52()
        cclog("here.....52")
        local result = ff.net:getMessage(0x00001052)
        if result ~= nil then
            dd.loadingLayer:stopAllActions()
            login_startResult(result)
        end
    end
    schedule(dd.loadingLayer,checkMessage_52,0.1)
end
function login_startResult(result)
    if result ~= nil then
        --cclog("new code:"..message:getErrorCode())
        local ret = result:getLong()
        if ret == 0 then
            dd.uid = result:getLong()
            if ff.platform ~= 1 then
                if ff.apk_version > 1260 then
                    platform_joinPush(hif.onPush)
                end
            end
            platform_initPay(hif.onPay,getBuyItems())
            

            local lastuid = cc.UserDefault:getInstance():getIntegerForKey("lastuid")
            if lastuid ~= dd.uid then
                clearDB()
                cc.UserDefault:getInstance():setIntegerForKey("lastuid",dd.uid)
            end    
            dd.serverTime.zone = result:getLong()
            dd.serverTime.time = result:getLong() - os.time()
            dd.serverTime.zero = result:getLong()
            cclog("User base info=>uid:"..dd.uid..",time:"..dd.serverTime.time..",zone:"..dd.serverTime.zone)


            if ff.platform == 1 then
                dd.loadingLayer:setProgress(80)
            else 
                dd.loadingLayer:setProgress(30)
            end
            dd.loadingLayer:setTips(ff.langString("登录成功，开始初始化游戏。"))

            result:getLong()
            local push = result:getLong()
            ff.set_battle = push%2
            push = push - push%2

            if push == 2 or push == 6 or push == 14 then
                ff.set_schedule = 1
                push = push - 2
            else
                ff.set_schedule = 0
            end

            if push == 4 or push == 12 then
                ff.set_alliance = 1
                push = push - 4
            else
                ff.set_alliance = 0
            end
            if push == 8 then
                ff.set_system = 1
            else
                ff.set_system = 0
            end
            local HolidayAppearance = result:getLong()
            if HolidayAppearance < 0 then
                dd.HolidayAppearance = 0
            else
                dd.HolidayAppearance = HolidayAppearance
            end

            local KSRoom = result:getLong()
            if KSRoom <= 0 then
                dd.KSRoom = 0
                ff.world_maplayerSize.width = 640   --地图格子数
                ff.world_maplayerSize.height = 640
                dd.StrongholdCnt = 12
            else
                dd.KSRoom = KSRoom
                ff.world_maplayerSize.width = 200   --地图格子数
                ff.world_maplayerSize.height = 200
                dd.StrongholdCnt = 5
            end

            result:clear()

            --提交语言，初始化用户信息
            platform_initUser(dd.uid)
            local lanm = ff.net:createMessage()
            lanm:addCmd(0x14d)
            lanm:addLong(dd.uid)
            lanm:addLong(ff.lang)
            
            print("platform_getCountryCode1:"..ff.apk_version)
            if ff.apk_version >= 1100 then
                lanm:addString(platform_getCountryCode(),15)
                print("platform_getCountryCode2:"..ff.apk_version)
            else
                lanm:addString(dd.languageCode[ff.lang + 1],15)
            end

            lanm:addString(dd.languageCode[ff.set_trans_lan + 1],15)
            ff.net:postMessage(lanm)

            --初始化信息
            login_initHeros()
            login_login_ex(dd.loadingLayer,{40,ff.langString("登录成功，开始初始化游戏。")})
        else
            if ret == 2 then
                result:clear()
                login_getuid()
                return
            else
                dd.loadingLayer:setLabelColor(cc.c3b(255,0,0))
                dd.loadingLayer:setTips(ff.langString("服务忙，请稍后再试。"),false)
                platform_showDialog(ff.langString("网络连接错误"),ff.langString("服务忙，请稍后再试。"),2)    
                result:clear()
            end
        end  
    else
        platform_showDialog(ff.langString("网络连接错误"),ff.langString("服务忙，请稍后再试。"),2)    
    end   
end    

--解析英雄信息
function login_heroInfo(sender,param)
    local message = ff.net:createMessage()
    message:addCmd(0x00000005)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        result:clear()
    end     
    message:clear()
end

function login_initHeros()
    if dd.heros ~= nil then
        dd.heros:clear()
    end
    dd.heros = ff.NetTable:create()
    dd.heros:addStreamCol("hid",ff.NET_LONG)
    dd.heros:addStreamCol("id",ff.NET_LONG)
    dd.heros:addStreamCol("name",ff.NET_STRING,15)
    dd.heros:addStreamCol("level",ff.NET_LONG)
    dd.heros:addStreamCol("heroexp",ff.NET_LONG)
    dd.heros:addStreamCol("status",ff.NET_LONG)
    dd.heros:addStreamCol("type",ff.NET_LONG)
    dd.heros:addStreamCol("power",ff.NET_LONG)

    dd.heros:addStreamCol("arms1",ff.NET_LONG)
    dd.heros:addStreamCol("arms2",ff.NET_LONG)
    dd.heros:addStreamCol("arms3",ff.NET_LONG)
    dd.heros:addStreamCol("arms4",ff.NET_LONG)
    dd.heros:addStreamCol("arms5",ff.NET_LONG)
    dd.heros:addStreamCol("arms6",ff.NET_LONG)

    dd.heros:addStreamCol("tools1",ff.NET_LONG)
    dd.heros:addStreamCol("tools2",ff.NET_LONG)
    dd.heros:addStreamCol("tools3",ff.NET_LONG)
    dd.heros:addStreamCol("tools4",ff.NET_LONG)
    dd.heros:addStreamCol("tools5",ff.NET_LONG)
    dd.heros:addStreamCol("tools6",ff.NET_LONG)
    dd.heros:addStreamCol("tools7",ff.NET_LONG)
    dd.heros:addStreamCol("tools8",ff.NET_LONG)
    dd.heros:addStreamCol("skills",ff.NET_TABLE)
    dd.heros:addStreamCol("PVETotle",ff.NET_LONG)
    dd.heros:addStreamCol("PVEAct",ff.NET_LONG)
    dd.heros:addStreamCol("PVEDfc",ff.NET_LONG)
    dd.heros:addStreamCol("PVEHp",ff.NET_LONG)
    dd.heros:addStreamCol("PVEHpMax",ff.NET_LONG)
    dd.heros:addStreamCol("PVEHpNow",ff.NET_LONG)
    dd.heros:addStreamCol("PVEHpTime",ff.NET_LONG)
    dd.heros:addStreamCol("prisonStatus",ff.NET_LONG)
    dd.heros:addStreamCol("pos",ff.NET_LONG)
    dd.heros:addStreamCol("executestart",ff.NET_LONG)
    dd.heros:addStreamCol("executeTime",ff.NET_LONG)
    dd.heros:addStreamCol("releaseTime",ff.NET_LONG)
    dd.heros:addStreamCol("haveWord",ff.NET_LONG)

end

--6.1.3.	查询个人主公信息
function login_mydata(sender,param)
	cclog("login_mydata")
    local message = ff.net:createMessage()
    message:addCmd(0x00000003)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then
		    if dd.myinfo ~= nil then
		        dd.myinfo:clear()
		    end    
		    dd.myinfo = ff.NetTable:create(true)
		    dd.myinfo:addStreamCol("uid",ff.NET_LONG)
		    dd.myinfo:addStreamCol("name",ff.NET_STRING,15)
		    dd.myinfo:addStreamCol("face",ff.NET_LONG)
		    dd.myinfo:addStreamCol("born",ff.NET_LONG)
		    dd.myinfo:addStreamCol("state",ff.NET_LONG)
		    dd.myinfo:addStreamCol("gold",ff.NET_LONG)
		    dd.myinfo:addStreamCol("vippoint",ff.NET_LONG)
		    dd.myinfo:addStreamCol("power",ff.NET_LONG)
		    dd.myinfo:addStreamCol("kills",ff.NET_LONG)
		    result:getData(1, dd.myinfo)
            cclog("dd.name="..dd.myinfo:getString(1,"name"))

		    dd.myinfo:addStreamCol("vip",ff.NET_LONG)
		    dd.myinfo:addStreamCol("nAllyTitle",ff.NET_LONG)
		    dd.myinfo:addStreamCol("market",ff.NET_LONG)
            dd.myinfo:addStreamCol("tzl",ff.NET_LONG)

            dd.myinfo:addStreamCol("urumail",ff.NET_LONG)
            dd.myinfo:addStreamCol("ursmail",ff.NET_LONG)
            dd.myinfo:addStreamCol("ursys",ff.NET_LONG)
            dd.myinfo:addStreamCol("urreport",ff.NET_LONG)
            dd.myinfo:addStreamCol("urpve",ff.NET_LONG)
            dd.myinfo:addStreamCol("urcj",ff.NET_LONG)
            dd.myinfo:addStreamCol("uryg",ff.NET_LONG)

            dd.myinfo:addStreamCol("chat_unread",ff.NET_LONG)
            dd.myinfo:addStreamCol("chat_friends",ff.NET_LONG)
            dd.myinfo:addStreamCol("chat_union",ff.NET_LONG)

            dd.myinfo:addStreamCol("lucky",ff.NET_LONG)
            dd.myinfo:addStreamCol("applys",ff.NET_LONG)
            dd.myinfo:addStreamCol("newbie",ff.NET_LONG)

            --玩家议会等级
            dd.myinfo:addStreamCol("level",ff.NET_LONG)
            --可以攻击的NPCLEVEL
            dd.myinfo:addStreamCol("npclevel",ff.NET_LONG)

            dd.myinfo:addStreamCol("MaxActive",ff.NET_LONG)
            dd.myinfo:addStreamCol("NowActive",ff.NET_LONG)
            dd.myinfo:addStreamCol("ActiveTime",ff.NET_LONG)

            dd.myinfo:addStreamCol("ActiveType",ff.NET_LONG)

            dd.myinfo:addStreamCol("ActiveID",ff.NET_LONG)
            dd.myinfo:addStreamCol("ActiveBegin",ff.NET_LONG)
            dd.myinfo:addStreamCol("ActiveEnd",ff.NET_LONG)
		    --联盟
		    if dd.myUnion ~= nil then
		        dd.myUnion:clear()
		    end        
		    dd.myUnion = ff.NetTable:create(true)
		    --联盟ID
		    dd.myUnion:addStreamCol("unionid",ff.NET_LONG)
		    --联盟名
		    dd.myUnion:addStreamCol("unionname",ff.NET_STRING,15)        
		    --联盟官职
		    dd.myUnion:addStreamCol("unionofficial",ff.NET_LONG)
		    --联盟贡献
		    dd.myUnion:addStreamCol("unionpoint",ff.NET_LONG)
		    --联盟简称
		    dd.myUnion:addStreamCol("unionflag",ff.NET_STRING,3)
		    --联盟图腾
		    dd.myUnion:addStreamCol("totem",ff.NET_LONG)
		    result:getData(1, dd.myUnion)

		    dd.myinfo:setLong(1,"vip",result:getLong())

		    --礼包数量
		    dd.myUnion:addStreamCol("boxcount",ff.NET_LONG)
            dd.myUnion:addStreamCol("boxlevel",ff.NET_LONG)
            dd.myUnion:addStreamCol("boxexp",ff.NET_LONG)
            dd.myUnion:addStreamCol("boxtotal",ff.NET_LONG)
		    --盟主
		    dd.myUnion:addStreamCol("master",ff.NET_STRING,32)
		    --成员数
		    dd.myUnion:addStreamCol("member",ff.NET_LONG)
            dd.myUnion:addStreamCol("memberMax",ff.NET_LONG)
		    --排名
		    dd.myUnion:addStreamCol("rank",ff.NET_LONG)
		    --战力
		    dd.myUnion:addStreamCol("power",ff.NET_SUPER_LONG)
		    --基金
		    dd.myUnion:addStreamCol("nAllyFunds",ff.NET_LONG)
		    --公告
		    dd.myUnion:addStreamCol("nAllyBBS",ff.NET_STRING,256)  

		    --角标数据
		    --战争
		    dd.myUnion:addStreamCol("battles",ff.NET_LONG)
		    --据点
		    dd.myUnion:addStreamCol("points",ff.NET_LONG)
		    --帮助
		    dd.myUnion:addStreamCol("helpers",ff.NET_LONG)
		    --报告
		    dd.myUnion:addStreamCol("report",ff.NET_LONG)
		    --留言
		    dd.myUnion:addStreamCol("unread",ff.NET_LONG)
		    --征服者
		    dd.myUnion:addStreamCol("nIsKingAlly",ff.NET_LONG)
		    --语言
		    dd.myUnion:addStreamCol("lan",ff.NET_LONG)
            --偏向
            dd.myUnion:addStreamCol("rule",ff.NET_LONG)
            --时区
            dd.myUnion:addStreamCol("time",ff.NET_LONG)
		    --活跃度
		    dd.myUnion:addStreamCol("act",ff.NET_LONG)
            --联盟科技
            dd.myUnion:addStreamCol("level",ff.NET_LONG)
            dd.myUnion:addStreamCol("tec1",ff.NET_LONG)
            dd.myUnion:addStreamCol("tec2",ff.NET_LONG)
            dd.myUnion:addStreamCol("tec3",ff.NET_LONG)
            --待审核记录
            dd.myUnion:addStreamCol("apply",ff.NET_LONG)

            if dd.myUnionTecs ~= nil then
                dd.myUnionTecs:clear()
            end
            dd.myUnionTecs = ff.NetTable:create(true)
            dd.myUnionTecs:addStreamCol("id",ff.NET_LONG)
            dd.myUnionTecs:addStreamCol("level",ff.NET_LONG)
            dd.myUnionTecs:addStreamCol("exp",ff.NET_LONG)  
            dd.myUnionTecs:addStreamCol("startime",ff.NET_LONG)
            dd.myUnionTecs:addStreamCol("endtime",ff.NET_LONG)    

		    --礼包
		    if dd.mygifts ~= nil then
		    	dd.mygifts:clear()
		    end	
			dd.mygifts = ff.NetTable:create(true)

		    --nOnlinePackTime
		    dd.mygifts:addStreamCol("onlinepack",ff.NET_LONG)
		    dd.mygifts:addStreamCol("onlinepackid",ff.NET_LONG)
		    dd.mygifts:addStreamCol("topuppoint",ff.NET_LONG)
		    --接收到的联盟邀请数
		    dd.mygifts:addStreamCol("inviteNum",ff.NET_LONG)
		    --连续登录天数
		    dd.mygifts:addStreamCol("gameage",ff.NET_LONG)
		    --奖励是否领取
		    dd.mygifts:addStreamCol("nAttendancedDay",ff.NET_LONG)
		    --是否已经充值	nHasTopuped	int	4	
		    dd.mygifts:addStreamCol("nHasTopuped",ff.NET_LONG)
		    --email绑定奖励是否发放	nIsEmailBinded	int	4	
		    dd.mygifts:addStreamCol("nIsEmailBinded",ff.NET_LONG)
		    --facebook绑定奖励是否发放	nIsFacebookBinded	int	4	
		    dd.mygifts:addStreamCol("nIsFacebookBinded",ff.NET_LONG)
		    --今日已攻击次数	nTdyAttack	int	4	战役推图
		    dd.mygifts:addStreamCol("nTdyAttack",ff.NET_LONG)
			--可攻击次数上限	nMaxAttack	int	4	战役推图
			dd.mygifts:addStreamCol("nMaxAttack",ff.NET_LONG)
			--Facebook Like奖励是否发放	nIsFBLiked	int	4	
			dd.mygifts:addStreamCol("nIsFBLiked",ff.NET_LONG)
			result:getData(1, dd.mygifts)
			dd.myinfo:setLong(1,"nAllyTitle",result:getLong())

            if dd.mygifts ~= nil and dd.mygifts:rowCount() == 1 then
                if dd.mygifts:getLong(1,"nIsEmailBinded") == 0 and string.len(ff.email) > 0 then
                    local message = ff.net:createMessage()
                    message:addCmd(0x0000013c)
                    message:addLong(dd.uid)
                    message:addLong(1)
                    ff.net:postMessage(message)   
                end

                local facebook   = cc.UserDefault:getInstance():getStringForKey("facebook","")
                if dd.mygifts:getLong(1,"nIsFacebookBinded") == 0 and string.len(facebook) == 32 then
                    local message = ff.net:createMessage()
                    message:addCmd(0x0000013c)
                    message:addLong(dd.uid)
                    message:addLong(2)
                    ff.net:postMessage(message)   
                end
            end


            dd.myinfo:setLong(1,"lucky",result:getLong())
            dd.myinfo:setLong(1,"applys",result:getLong())
            dd.myinfo:setLong(1,"newbie",result:getLong())

            dd.myUnion:setLong(1,"rank",result:getLong())
            dd.myUnion:setSuperLong(1,"power",result:getSuperLong())
            dd.myinfo:setLong(1,"npclevel",result:getLong())
            dd.myinfo:setLong(1,"MaxActive",result:getLong())
            dd.myinfo:setLong(1,"NowActive",result:getLong())
            dd.myinfo:setLong(1,"ActiveTime",result:getLong())
            --cclog("=============2============"..dd.myinfo:getLong(1,"NowActive"))
            
		    if param ~= nil then
		    	dd.setProgress(param[1],param[2])
		    end
        else
        	login_error(ret)
        end	
    	result:clear()
    else
    	login_error(0)    
	end    
	message:clear()
end
function login_city(sender,param)
	cclog("login_city")
    local message = ff.net:createMessage()
    message:addCmd(0x00000004)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then
        	if dd.mycity ~= nil then
        		dd.mycity:clear()
        	end	
		    dd.mycity = ff.NetTable:create(true)
		    dd.mycity:addStreamCol("name",ff.NET_STRING,15)
		    dd.mycity:addStreamCol("cid",ff.NET_LONG)
		    dd.mycity:addStreamCol("avatar",ff.NET_LONG)
		    dd.mycity:addStreamCol("stone",ff.NET_LONG)
		    dd.mycity:addStreamCol("wood",ff.NET_LONG)
		    dd.mycity:addStreamCol("iron",ff.NET_LONG)
		    dd.mycity:addStreamCol("food",ff.NET_LONG)
		    dd.mycity:addStreamCol("silver",ff.NET_LONG)
		    result:getData(1, dd.mycity)
		    dd.mycity:addStreamCol("buff",ff.NET_LONG)
		    dd.mycity:addStreamCol("lastupdate",ff.NET_LONG)
		    dd.mycity:addStreamCol("localupdate",ff.NET_LONG)
		    dd.mycity:setLong(1,"localupdate",dd.getServerTime())
		    
		    local row = result:getLong()
        	if dd.mybuilds ~= nil then
        		dd.mybuilds:clear()
        	end	
		    dd.mybuilds = ff.NetTable:create(true)
		    dd.mybuilds:addStreamCol("pos",ff.NET_LONG)
		    dd.mybuilds:addStreamCol("bid",ff.NET_LONG)
		    dd.mybuilds:addStreamCol("level",ff.NET_LONG)
		    dd.mybuilds:addStreamCol("state",ff.NET_LONG)        
		    if row > 0 then
			    result:getData(row, dd.mybuilds)
                for i=1,dd.mybuilds:rowCount() do
                    if dd.mybuilds:getLong(i,"bid") == 1 then
                        dd.myinfo:setLong(1,"level",dd.mybuilds:getLong(i,"level"))
                    end                        
                end
			end
		    if param ~= nil then
		    	dd.setProgress(param[1],param[2])
		    end
		else
	    	login_error(ret)    
		end
		result:clear()
    else
    	login_error(0)    
	end     	
	message:clear()
end
function Troops_Info(sender,param)
    cclog("Troops_Info")
    local message = ff.net:createMessage()
    message:addCmd(0x00000010)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then            
            if dd.myTroops ~= nil then
                dd.myTroops:clear()
            end    
            dd.myTroops = ff.NetTable:create()    
            dd.myTroops:addStreamCol("id",ff.NET_LONG)
            dd.myTroops:addStreamCol("type",ff.NET_LONG)
            dd.myTroops:addStreamCol("state",ff.NET_LONG)

            dd.myTroops:addStreamCol("from",ff.NET_LONG)
            dd.myTroops:addStreamCol("to",ff.NET_LONG)
            dd.myTroops:addStreamCol("start",ff.NET_LONG)
            dd.myTroops:addStreamCol("arrival",ff.NET_LONG)
            dd.myTroops:addStreamCol("hid",ff.NET_LONG)

            dd.myTroops:addStreamCol("b1",ff.NET_LONG)
            dd.myTroops:addStreamCol("b2",ff.NET_LONG)
            dd.myTroops:addStreamCol("b3",ff.NET_LONG)
            dd.myTroops:addStreamCol("b4",ff.NET_LONG)
            dd.myTroops:addStreamCol("b5",ff.NET_LONG)
            dd.myTroops:addStreamCol("b6",ff.NET_LONG)            

            dd.myTroops:addStreamCol("q1",ff.NET_LONG)
            dd.myTroops:addStreamCol("q2",ff.NET_LONG)
            dd.myTroops:addStreamCol("q3",ff.NET_LONG)
            dd.myTroops:addStreamCol("q4",ff.NET_LONG)
            dd.myTroops:addStreamCol("q5",ff.NET_LONG)
            dd.myTroops:addStreamCol("q6",ff.NET_LONG)            

            dd.myTroops:addStreamCol("g1",ff.NET_LONG)
            dd.myTroops:addStreamCol("g2",ff.NET_LONG)
            dd.myTroops:addStreamCol("g3",ff.NET_LONG)
            dd.myTroops:addStreamCol("g4",ff.NET_LONG)
            dd.myTroops:addStreamCol("g5",ff.NET_LONG)
            dd.myTroops:addStreamCol("g6",ff.NET_LONG)            

            dd.myTroops:addStreamCol("w1",ff.NET_LONG)
            dd.myTroops:addStreamCol("w2",ff.NET_LONG)
            dd.myTroops:addStreamCol("w3",ff.NET_LONG)
            dd.myTroops:addStreamCol("w4",ff.NET_LONG)
            dd.myTroops:addStreamCol("w5",ff.NET_LONG)
            dd.myTroops:addStreamCol("w6",ff.NET_LONG)            

            dd.myTroops:addStreamCol("s1",ff.NET_LONG)
            dd.myTroops:addStreamCol("s2",ff.NET_LONG)
            dd.myTroops:addStreamCol("s3",ff.NET_LONG)            

            dd.myTroops:addStreamCol("param1",ff.NET_LONG)            
            dd.myTroops:addStreamCol("param2",ff.NET_LONG)            
            dd.myTroops:addStreamCol("param3",ff.NET_LONG)            
            dd.myTroops:addStreamCol("param4",ff.NET_LONG)            

            local row = result:getLong()
            if row > 0 then
                result:getData(row, dd.myTroops)
            end
            if param ~= nil then
                dd.setProgress(param[1],param[2])
            end
        else
            login_error(ret)    
        end
        result:clear()
    else
        login_error(0)
    end
    message:clear() 
end
--排程
function login_queueInfo(sender,param)
	cclog("login_queueInfo")
    local message = ff.net:createMessage()
    message:addCmd(0x00000006)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then
		    if dd.mylists ~= nil then
		        dd.mylists:clear()
		    end    
		    dd.mylists = ff.NetTable:create(true,1001)
		    dd.mylists:addStreamCol("type",ff.NET_LONG)
		    dd.mylists:addStreamCol("start",ff.NET_LONG)
		    dd.mylists:addStreamCol("end",ff.NET_LONG)
		    dd.mylists:addStreamCol("param1",ff.NET_LONG)
		    dd.mylists:addStreamCol("param2",ff.NET_LONG)
		    dd.mylists:addStreamCol("param3",ff.NET_LONG)
		    dd.mylists:addStreamCol("param4",ff.NET_LONG)
		    local row = result:getLong()
		    if row > 0 then
		    	result:getData(row,dd.mylists)
		    end
            dd.mylists:addStreamCol("param5",ff.NET_LONG)
		    if param ~= nil then
		    	dd.setProgress(param[1],param[2])
		    end
		else
	    	login_error(ret)    
		end
		result:clear()
	else
    	login_error(0)    
	end
	message:clear()
end
--科技
function tec_Info(sender,param)
	cclog("tec_Info")
    local message = ff.net:createMessage()
    message:addCmd(0x00000007)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then
		    if dd.myTec ~= nil then
		        dd.myTec:clear()
		    end    
		    dd.myTec = ff.NetTable:create(true)
		    dd.myTec:addStreamCol("tec_id",ff.NET_LONG)
		    dd.myTec:addStreamCol("lv",ff.NET_LONG)

		    local row = result:getLong()
		    if row > 0 then
		        result:getData(row, dd.myTec)
		    end   
		    if param ~= nil then
		    	dd.setProgress(param[1],param[2])
		    end
		else
	    	login_error(ret)    
		end
		result:clear()
	else
    	login_error(0)    
	end	
	message:clear()
end
--瞭望塔
function tower_Info( sender,param )
    -- body
    cclog("tower_Info")
    local message = ff.net:createMessage()
    message:addCmd(0x0000001d)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then
            if dd.myTower ~= nil then
                dd.myTower:clear()
            end    
            dd.myTower = ff.NetTable:create(true)
            --dd.myTower:addStreamCol("uid_id",ff.NET_LONG)
            dd.myTower:addStreamCol("army_id",ff.NET_LONG)
            dd.myTower:addStreamCol("type",ff.NET_LONG)
            dd.myTower:addStreamCol("from",ff.NET_LONG)
            dd.myTower:addStreamCol("to",ff.NET_LONG)
            dd.myTower:addStreamCol("start",ff.NET_LONG)
            dd.myTower:addStreamCol("arrival",ff.NET_LONG)
            dd.myTower:addStreamCol("allyFlag",ff.NET_STRING,3)
            dd.myTower:addStreamCol("playerID",ff.NET_LONG)
            dd.myTower:addStreamCol("loginName",ff.NET_STRING,15)
            local row = result:getLong()
            if row > 0 then
                result:getData(row, dd.myTower)
            end   
            if param ~= nil then
                dd.setProgress(param[1],param[2])
            end
        else
            login_error(ret)    
        end
        result:clear()
    else
        login_error(0)    
    end 
    message:clear()
end
--部队
function solider_Info(sender,param)
	cclog("solider_Info")
    local message = ff.net:createMessage()
    message:addCmd(0x00000008)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then        	
		    if dd.soliders ~= nil then
		        dd.soliders:clear()
		    end    
		    dd.soliders = ff.NetTable:create()    
		    dd.soliders:addStreamCol("soldierid",ff.NET_LONG)--兵种
		    dd.soliders:addStreamCol("count",ff.NET_LONG)--数量
		    dd.soliders:addStreamCol("hurtcount",ff.NET_LONG)--伤病数量
		    local row = result:getLong()
		    if row > 0 then
		        result:getData(row, dd.soliders)
		    end
		    if param ~= nil then
		    	dd.setProgress(param[1],param[2])
		    end
		else
			login_error(ret)    
		end
		result:clear()
	else
		login_error(0)
	end
	message:clear()	
end
--部队
function wall_Info(sender,param)
	cclog("wall_Info")
    local message = ff.net:createMessage()
    message:addCmd(0x00000009)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then        	
		    if dd.myWall ~= nil then
		        dd.myWall:clear()
		    end    
		    dd.myWall = ff.NetTable:create()
		    dd.myWall:addStreamCol("wallid",ff.NET_LONG)
		    dd.myWall:addStreamCol("count",ff.NET_LONG)
		    local row = result:getLong()
		    if row > 0 then
		        result:getData(row, dd.myWall)
		    end   
		else
			login_error(ret)    
		end
		result:clear()
	    if param ~= nil then
	    	dd.setProgress(param[1],param[2])
	    end
	else
		login_error(0)
	end
	message:clear()	
end

--道具
function login_tools(sender,param)
	cclog("login_tools")
    local message = ff.net:createMessage()
    message:addCmd(0x0000000a)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then        	
		    if dd.mytools ~= nil then
		        dd.mytools:clear()
		    end    
		    dd.mytools = ff.NetTable:create(true)
		    dd.mytools:addStreamCol("tid",ff.NET_LONG)
		    dd.mytools:addStreamCol("count",ff.NET_LONG)
		    local rows = result:getLong()
		    if rows > 0 then
		        result:getData(rows,dd.mytools)
		    end
		else
			login_error(ret)    
		end
		result:clear()
	    if param ~= nil then
	    	dd.setProgress(param[1],param[2])
	    end
	else
		login_error(0)
	end
	message:clear()	
end
--加成
function login_plus(sender,param)
	cclog("login_plus")
    local message = ff.net:createMessage()
    message:addCmd(0x0000001f)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then        	
		    if dd.myplus ~= nil then
		        dd.myplus:clear()
		    end    
		    dd.myplus = ff.NetTable:create(true)
		    dd.myplus:addStreamCol("id",ff.NET_LONG)
		    dd.myplus:addStreamCol("param",ff.NET_LONG)
		    dd.myplus:addStreamCol("start",ff.NET_LONG)
		    dd.myplus:addStreamCol("end",ff.NET_LONG)
		    
		    local rows = result:getLong()
		    if rows > 0 then
		        result:getData(rows,dd.myplus)
		    end
		else
			login_error(ret,"login_plus")    
		end
		result:clear()
	    if param ~= nil then
	    	dd.setProgress(param[1],param[2])
	    end
	else
		login_error(0,"login_plus")
	end
	message:clear()	
end
--效果login_effect
function login_effect(sender,param)
    local message = ff.net:createMessage()
    message:addCmd(0x00000020)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then        	
		    if dd.myeffect ~= nil then
		        dd.myeffect:clear()
		    end    
		    dd.myeffect = ff.NetTable:create(true)
		    dd.myeffect:addStreamCol("id",ff.NET_LONG)
		    dd.myeffect:addStreamCol("param",ff.NET_LONG)
		    
		    local rows = result:getLong()
		    if rows > 0 then
		        result:getData(rows,dd.myeffect)
		    end
		else
			login_error(ret,"login_effect")    
		end
		result:clear()
	    if param ~= nil then
	    	dd.setProgress(param[1],param[2])
	    end
	else
		login_error(0,"login_effect")
	end
	message:clear()	
end
--6.1.50

function login_unionHelper(sender,param)
    local message = ff.net:createMessage()
    message:addCmd(0x00000016)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        onGetAllyHelpLists(result)
    else
        login_error(0,"0x00000016")    
    end
    message:clear()
end

function login_UnionGifts(sender,param)
    local message = ff.net:createMessage()
    message:addCmd(0x00000032)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then            
            dd.myUnion:setLong(1,"boxlevel",result:getLong())
            dd.myUnion:setLong(1,"boxexp",result:getLong())
            dd.myUnion:setLong(1,"boxtotal",result:getLong())

            if dd.myUnionGifts ~= nil then
                dd.myUnionGifts:clear()
            end
            dd.myUnionGifts = ff.NetTable:create(true) 
            dd.myUnionGifts:addStreamCol("id",ff.NET_LONG)
            dd.myUnionGifts:addStreamCol("tid",ff.NET_LONG)
            dd.myUnionGifts:addStreamCol("endtime",ff.NET_LONG)
            dd.myUnionGifts:addStreamCol("start",ff.NET_LONG)
            dd.myUnionGifts:addStreamCol("type",ff.NET_LONG)
            dd.myUnionGifts:addStreamCol("dropid",ff.NET_LONG)
            dd.myUnionGifts:addStreamCol("count",ff.NET_LONG)
            dd.myUnionGifts:addStreamCol("gold",ff.NET_LONG)

            local rows = result:getLong()
            if rows > 0 then
                result:getData(rows,dd.myUnionGifts)
            end
        else
            login_error(ret,"0x0000001a")    
        end
        result:clear()
        if param ~= nil then
            dd.setProgress(param[1],param[2])
        end
    else
        login_error(0,"0x0000001a")    
    end
    message:clear() 
end
--价格
function login_MallList(sender,param)
    local message = ff.net:createMessage()
    message:addCmd(0x00000017)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then            
            local rows = result:getLong()
            for i=1,rows do
                local tid = result:getLong()
                local value = result:getLong()
                if dd.cfgProp[tid] == nil then
                    dd.cfgProp[tid] = {}
                end
                dd.cfgProp[tid]['shop']  = 1
                dd.cfgProp[tid]['value'] = value    
            end
        else
            login_error(ret,"0x00000017")    
        end
        result:clear()
        if param ~= nil then
            dd.setProgress(param[1],param[2])
        end
    else
        login_error(0,"0x00000017")    
    end
    message:clear() 
end
--装备
function login_arms(sender,param)
    local message = ff.net:createMessage()
    message:addCmd(0x00000025)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then            
            local rows = result:getLong()
            if dd.myArms ~= nil then
                dd.myArms:clear()
            end    
            dd.myArms = ff.NetTable:create()
            dd.myArms:addStreamCol("tid",ff.NET_LONG)
            dd.myArms:addStreamCol("aid",ff.NET_LONG)
            dd.myArms:addStreamCol("heroid",ff.NET_LONG)
            dd.myArms:addStreamCol("gem1",ff.NET_LONG)
            dd.myArms:addStreamCol("gem2",ff.NET_LONG)
            dd.myArms:addStreamCol("gem3",ff.NET_LONG)
            dd.myArms:addStreamCol("gem4",ff.NET_LONG)
            if rows > 0 then
                result:getData(rows, dd.myArms)
                dd.myArms:addStreamCol("power",ff.NET_LONG)
                for i=1,dd.myArms:rowCount() do
                    local power = dd.cfgArms[dd.myArms:getLong(i,"aid")]['power']
                    if dd.myArms:getLong(i,"gem1") > 0 then
                        power = power + dd.cfgGems[dd.myArms:getLong(i,"gem1")]['power']
                    end
                    if dd.myArms:getLong(i,"gem2") > 0 then
                        power = power + dd.cfgGems[dd.myArms:getLong(i,"gem2")]['power']
                    end
                    if dd.myArms:getLong(i,"gem3") > 0 then
                        power = power + dd.cfgGems[dd.myArms:getLong(i,"gem3")]['power']
                    end
                    if dd.myArms:getLong(i,"gem4") > 0 then
                        power = power + dd.cfgGems[dd.myArms:getLong(i,"gem4")]['power']
                    end
                    dd.myArms:setLong(i,"power",power)
                end
            else
                dd.myArms:addStreamCol("power",ff.NET_LONG)
            end  
        else
            login_error(ret,"0x00000025")    
        end
        result:clear()
        if param ~= nil then
            dd.setProgress(param[1],param[2])
        end
    else
        login_error(0,"0x00000025")    
    end
    message:clear() 
end
--联合作战
function login_UnionBattle(sender,param)
    local message = ff.net:createMessage()
    message:addCmd(0x00000022)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then            
            if dd.myUnionBattle ~= nil then
                dd.myUnionBattle:clear()
                dd.myUnionBattle = nil
            end    
            dd.myUnionBattle = ff.NetTable:create()
            dd.myUnionBattle:addStreamCol("type",ff.NET_LONG)
            dd.myUnionBattle:addStreamCol("status",ff.NET_LONG)--0=正在集结 1=集结后出征
            dd.myUnionBattle:addStreamCol("statusStart",ff.NET_LONG)--状态开始时间
            dd.myUnionBattle:addStreamCol("statusEnd",ff.NET_LONG)--状态结束时间

            dd.myUnionBattle:addStreamCol("attackUid",ff.NET_LONG)
            dd.myUnionBattle:addStreamCol("attackServerid",ff.NET_LONG)--发起者服务器
            dd.myUnionBattle:addStreamCol("site",ff.NET_LONG)--发起者坐标

            dd.myUnionBattle:addStreamCol("unionid",ff.NET_LONG)
            dd.myUnionBattle:addStreamCol("attackUnionFlag",ff.NET_STRING,3)
            dd.myUnionBattle:addStreamCol("attackUname",ff.NET_STRING,15)--发起者主公名称
            dd.myUnionBattle:addStreamCol("unionOffical",ff.NET_LONG)
            dd.myUnionBattle:addStreamCol("targetType",ff.NET_LONG)--目标类型
            dd.myUnionBattle:addStreamCol("attackedUid",ff.NET_LONG)--被攻击者编号

            dd.myUnionBattle:addStreamCol("attackedServerid",ff.NET_LONG)--被攻击者服务器
            dd.myUnionBattle:addStreamCol("attackedSite",ff.NET_LONG)--被攻击者坐标
            dd.myUnionBattle:addStreamCol("attackedUnionid",ff.NET_LONG)
            dd.myUnionBattle:addStreamCol("attackedUnionFlag",ff.NET_STRING,3)
            dd.myUnionBattle:addStreamCol("attackedUname",ff.NET_STRING,15)
            dd.myUnionBattle:addStreamCol("attackedUnionOffical",ff.NET_LONG)

            dd.myUnionBattle:addStreamCol("currentSoldiers",ff.NET_LONG)--当前兵力  类型=1时：攻方总兵力 类型=2时：防方总兵力
            dd.myUnionBattle:addStreamCol("maxSoldiers",ff.NET_LONG)--兵力上限
            local nums=result:getLong()
            if nums > 0 then
                result:getData(nums,dd.myUnionBattle)
                cclog("myUnionBattle:"..nums..",uid:"..dd.myUnionBattle:getLong(1,"attackUid"))
            end
        else
            login_error(ret,"0x00000022")    
        end
        result:clear()
        if param ~= nil then
            dd.setProgress(param[1],param[2])
        end
    else
        login_error(0,"0x00000022")    
    end
    message:clear() 
end

--晶体
function login_Crystals(sender,param)
    local message = ff.net:createMessage()
    message:addCmd(0x00000044)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then            
            local rows = result:getLong()
            if dd.myCrystals ~= nil then
                dd.myCrystals:clear()
            end    
            dd.myCrystals = ff.NetTable:create(true)
            dd.myCrystals:addStreamCol("cid",ff.NET_LONG)
            dd.myCrystals:addStreamCol("id",ff.NET_LONG)
            dd.myCrystals:addStreamCol("level",ff.NET_LONG)
            dd.myCrystals:addStreamCol("curexp",ff.NET_LONG)
            dd.myCrystals:addStreamCol("heroid",ff.NET_LONG)
            dd.myCrystals:addStreamCol("pos",ff.NET_LONG)
            
            if rows > 0 then
                result:getData(rows, dd.myCrystals)
            end  
        else
            login_error(ret,"0x00000044")    
        end
        result:clear()
        if param ~= nil then
            dd.setProgress(param[1],param[2])
        end
    else
        login_error(0,"0x00000044")    
    end
    message:clear() 
end

--联盟科技
function login_UnionTec(sender,param)
    local message = ff.net:createMessage()
    message:addCmd(0x00000035)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then            
            local rows = result:getLong()
            if dd.myUnionTecs ~= nil then
                dd.myUnionTecs:clear()
            end
            dd.myUnionTecs = ff.NetTable:create(true)
            dd.myUnionTecs:addStreamCol("id",ff.NET_LONG)
            dd.myUnionTecs:addStreamCol("level",ff.NET_LONG)
            dd.myUnionTecs:addStreamCol("exp",ff.NET_LONG)  
            dd.myUnionTecs:addStreamCol("startime",ff.NET_LONG)
            dd.myUnionTecs:addStreamCol("endtime",ff.NET_LONG)  
            
            if rows > 0 then
                result:getData(rows, dd.myUnionTecs)
            end  
        else
            login_error(ret,"0x00000035")    
        end
        result:clear()
        if param ~= nil then
            dd.setProgress(param[1],param[2])
        end
    else
        login_error(0,"0x00000035")    
    end
    message:clear() 
end

--特产（已经作废）
function login_SpecialtyInfo(sender,param)
    local message = ff.net:createMessage()
    message:addCmd(0x0000001a)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then        	
			if dd.mySpecial ~= nil then
				dd.mySpecial:clear()
			end
			dd.mySpecial = ff.NetTable:create(true)	
		    dd.mySpecial:addStreamCol("pos",ff.NET_LONG)
		    dd.mySpecial:addStreamCol("count",ff.NET_LONG)
		    dd.mySpecial:addStreamCol("max",ff.NET_LONG)

		    local rows = result:getLong()
		    if rows > 0 then
		        result:getData(rows,dd.mySpecial)
		    end
		else
			login_error(ret,"0x0000001a")    
		end
		result:clear()
	    if param ~= nil then
	    	dd.setProgress(param[1],param[2])
	    end
	else
		login_error(0,"0x0000001a")    
	end
	message:clear()	
end

function login_sounds(sender,param)
    ff.sounds[911] = ff.getSounds(911) 
    ff.sounds[912] = ff.getSounds(912) 
    ff.sounds[913] = ff.getSounds(913) 
    ff.sounds[914] = ff.getSounds(914) 

    --ff.sounds[903] = ff.getSounds(903,true)

    ff.sounds[101] = ff.getSounds(101)
    ff.sounds[102] = ff.getSounds(102)
    ff.sounds[103] = ff.getSounds(103)
    ff.sounds[104] = ff.getSounds(104)
    ff.sounds[105] = ff.getSounds(105)
    ff.sounds[106] = ff.getSounds(106)
    ff.sounds[107] = ff.getSounds(107)
    ff.sounds[108] = ff.getSounds(108)
    ff.sounds[109] = ff.getSounds(109)
    ff.sounds[110] = ff.getSounds(110)
    ff.sounds[111] = ff.getSounds(111)
    

    ff.sounds[200] = ff.getSounds(200)
    ff.sounds[201] = ff.getSounds(201)
    ff.sounds[202] = ff.getSounds(202)
    ff.sounds[203] = ff.getSounds(203)
    ff.sounds[204] = ff.getSounds(204)
    ff.sounds[205] = ff.getSounds(205)
    ff.sounds[206] = ff.getSounds(206)
    ff.sounds[207] = ff.getSounds(207)
    ff.sounds[208] = ff.getSounds(208)
    ff.sounds[209] = ff.getSounds(209)
    ff.sounds[210] = ff.getSounds(210)
    ff.sounds[211] = ff.getSounds(211)
    ff.sounds[212] = ff.getSounds(212)
    ff.sounds[213] = ff.getSounds(213)
    ff.sounds[214] = ff.getSounds(214)    
    ff.sounds[215] = ff.getSounds(215)    
    ff.sounds[221] = ff.getSounds(221)    
    ff.sounds[230] = ff.getSounds(230)    
    ff.sounds[231] = ff.getSounds(231)    
    

    ff.sounds[301] = ff.getSounds(301)
    ff.sounds[302] = ff.getSounds(302)
    ff.sounds[303] = ff.getSounds(303)
    ff.sounds[304] = ff.getSounds(304)
    ff.sounds[305] = ff.getSounds(305)
    ff.sounds[306] = ff.getSounds(306)

    ff.sounds[401] = ff.getSounds(401)
    ff.sounds[402] = ff.getSounds(402)
    ff.sounds[403] = ff.getSounds(403)
    ff.sounds[404] = ff.getSounds(404)
    ff.sounds[406] = ff.getSounds(406)

    ff.sounds[411] = ff.getSounds(411)
    ff.sounds[412] = ff.getSounds(412)
    

    ff.sounds[501] = ff.getSounds(501)
    ff.sounds[601] = ff.getSounds(601)
    ff.sounds[602] = ff.getSounds(602)
    ff.sounds[603] = ff.getSounds(603)
    ff.sounds[604] = ff.getSounds(604)

    ff.sounds[802] = ff.getSounds(802)
    ff.sounds[803] = ff.getSounds(803)
    ff.sounds[804] = ff.getSounds(804)
    ff.sounds[805] = ff.getSounds(805)
    ff.sounds[806] = ff.getSounds(806)
    ff.sounds[915] = ff.getSounds(915)
    ff.sounds[916] = ff.getSounds(916)
    ff.sounds[917] = ff.getSounds(917)
    ff.sounds[918] = ff.getSounds(918)
    ff.sounds[919] = ff.getSounds(919)
    
    ff.sounds[921] = ff.getSounds(921)
    ff.sounds[920] = ff.getSounds(920)

    ff.sounds[922] = ff.getSounds(922)
    ff.sounds[923] = ff.getSounds(923)

    ff.sounds["p001"] = ff.getSounds("p001")
    ff.sounds["p002"] = ff.getSounds("p002")
    ff.sounds["p003"] = ff.getSounds("p003")

    ff.sounds["p004"] = ff.getSounds("p004")
    ff.sounds["p005"] = ff.getSounds("p005")

    ff.sounds["b001"] = ff.getSounds("b001")
    ff.sounds["b002"] = ff.getSounds("b002")

    ff.sounds["t001"] = ff.getSounds("t001")
    ff.sounds["t002"] = ff.getSounds("t002")

    ff.sounds["r001"] = ff.getSounds("r001")
    ff.sounds["r002"] = ff.getSounds("r002")
    ff.sounds["zadan2"] = ff.getSounds("zadan2")
    

    if param ~= nil then
        dd.setProgress(param[1],param[2])
    end    
end
function login_ok(sender,param)
    if param ~= nil then
        dd.setProgress(param[1],param[2])
    end

    if dd.loadingLayer ~= nil then
        if ff.platform == 1 then
            cclog("new loading....")
            ff.loadingLayer:setTips(ff.langString("初始化UI..."))
            aycnImageLoading()
        else
            dd.loadingLayer:onShowAsync(initCity,ff.langString("初始化UI..."))
        end
    end   
end    
--进入城市场景
function initCity(...)
    --清理临时数据
    --生成字典
    --platform_langTable()
    --cclog("生成UI字典OK")

    dd.initImages = ff.gameCore:isImagesInited() 
	if dd.initImages == true then
        if dd.mainUI == nil then
            dd.mainUI = addCityUI()
        end        
        --预读资源
        if ff.set_power > 1 then
            local cache = cc.SpriteFrameCache:getInstance()
            cache:addSpriteFrames("images/builds.plist")
            cache:addSpriteFrames("images/mv/citymov.plist")
            cache:addSpriteFrames("images/city/city_armys.plist")
        end    
        --dd.setProgress(60)
        if ff.restart == true then
            runCityScene(false)
        else
        	runCityScene(true)
        end
        pop.initAllDialog()
        --提交上一次崩溃的信息，如果有的话
        platform_getLastError()
    else
    	cclog("delay initCity")
    	performWithDelay(dd.currentLayer, initCity, 0.1)
    end	
end

function login_task(sender,param)
    local message = ff.net:createMessage()
    message:addCmd(0x00000048)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then            
            if dd.myTasks ~= nil then
                dd.myTasks:clear()
            end
            dd.myTasks = ff.NetTable:create(true) 
            dd.myTasks:addStreamCol("builds",ff.NET_LONG)
            dd.myTasks:addStreamCol("buildsState",ff.NET_LONG)
            dd.myTasks:addStreamCol("tec",ff.NET_LONG)
            dd.myTasks:addStreamCol("tecState",ff.NET_LONG)
            dd.myTasks:addStreamCol("heros",ff.NET_LONG)
            dd.myTasks:addStreamCol("herosState",ff.NET_LONG)
            dd.myTasks:addStreamCol("others",ff.NET_LONG)
            dd.myTasks:addStreamCol("othersState",ff.NET_LONG)

            dd.myTasks:addStreamCol("buildsPro",ff.NET_LONG)
            dd.myTasks:addStreamCol("tecPro",ff.NET_LONG)
            dd.myTasks:addStreamCol("herosPro",ff.NET_LONG)
            dd.myTasks:addStreamCol("othersPro",ff.NET_LONG)

            dd.myTasks:addStreamCol("recommendTask",ff.NET_LONG)
            local index = dd.myTasks:addRow()
            dd.myTasks:setLong(index,"builds",result:getLong())
            dd.myTasks:setLong(index,"buildsState",result:getLong())
            dd.myTasks:setLong(index,"tec",result:getLong())
            dd.myTasks:setLong(index,"tecState",result:getLong())
            dd.myTasks:setLong(index,"heros",result:getLong())
            dd.myTasks:setLong(index,"herosState",result:getLong())
            dd.myTasks:setLong(index,"others",result:getLong())
            dd.myTasks:setLong(index,"othersState",result:getLong())

            dd.myTasks:setLong(index,"buildsPro",result:getLong())
            dd.myTasks:setLong(index,"tecPro",result:getLong())
            dd.myTasks:setLong(index,"herosPro",result:getLong())
            dd.myTasks:setLong(index,"othersPro",result:getLong())
            dd.myTasks:setLong(index,"recommendTask",result:getLong())
        else
            login_error(ret,"0x00000048")    
        end
        result:clear()
        if param ~= nil then
            dd.setProgress(param[1],param[2])
        end
    else
        login_error(0,"0x00000048")    
    end
    message:clear()
end
--金币任务
function login_goldTask(sender, param)
    local message = ff.net:createMessage()
    message:addCmd(0x00000049)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then            
            local rows = result:getLong()
            if dd.myGoldTasks ~= nil then
                dd.myGoldTasks:clear()
            end
            dd.myGoldTasks = ff.NetTable:create(true) 
            dd.myGoldTasks:addStreamCol("id",ff.NET_LONG)
            dd.myGoldTasks:addStreamCol("state",ff.NET_LONG)
            dd.myGoldTasks:addStreamCol("starttime",ff.NET_LONG)
            dd.myGoldTasks:addStreamCol("endtime",ff.NET_LONG)
            dd.myGoldTasks:addStreamCol("progress1",ff.NET_LONG)
            dd.myGoldTasks:addStreamCol("progress2",ff.NET_LONG)
            dd.myGoldTasks:addStreamCol("progress3",ff.NET_LONG)
            dd.myGoldTasks:addStreamCol("param1",ff.NET_LONG)
            dd.myGoldTasks:addStreamCol("param2",ff.NET_LONG)
            dd.myGoldTasks:addStreamCol("param3",ff.NET_LONG)
            dd.myGoldTasks:addStreamCol("param4",ff.NET_LONG)
            dd.myGoldTasks:addStreamCol("param5",ff.NET_LONG)
            
            if rows > 0 then
                result:getData(rows,dd.myGoldTasks)
            end
        else
            login_error(ret,"0x00000049")    
        end
        result:clear()
        if param ~= nil then
            dd.setProgress(param[1],param[2])
        end
    else
        login_error(0,"0x00000049")    
    end
    message:clear() 
end
--解锁地块
function login_LockPos(sender, param)
    local message = ff.net:createMessage()
    message:addCmd(0x0000004d)
    message:addLong(dd.uid)
    local result = ff.net:call(message)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then            
            local rows = result:getLong()
            if dd.myLocks ~= nil then
                dd.myLocks:clear()
            end
            dd.myLocks = ff.NetTable:create() 
            dd.myLocks:addStreamCol("pos",ff.NET_LONG)
            
            if rows > 0 then
                result:getData(rows,dd.myLocks)
            end
        else
            login_error(ret,"0x0000004d")    
        end
        result:clear()
        if param ~= nil then
            dd.setProgress(param[1],param[2])
        end
    else
        login_error(0,"0x0000004d")    
    end
    message:clear() 
end
