
dd.Tjf_User_ChangeName = 0x0000110b   --主公改名
dd.Tjf_vip_Activation = 0x00001139   --vip激活
dd.Tjf_card_TakePrepaidCard = 0x00001152   --领取月卡
dd.Tjf_charge_TestCharge = 0x00001135      --模拟充值
dd.Tjf_GetRankUser = 0x0000101b      --玩家排行
dd.Tjf_GetUserRankInfo = 0x00001047      --玩家排行

dd.Tjf_charge_GetTopupLists = 0x00001043      --充值列表
dd.Tjf_online_GetReward = 0x00001132          --领取在线奖励
dd.Tjf_daytask_GetList = 0x00001053           --查询每日任务目标
dd.Tjf_daytask_GetReward = 0x0000116b         --领取每日目标奖励
dd.Tjf_daytask_GetNextBox = 0x0000116d        --领取黄金宝箱
dd.Tjf_AlchemistAction = 0x00001143
dd.Tjf_GemDecompose = 0x00001144
dd.Tjf_EquipSell = 0x0000114f
dd.Tjf_RestrictedBonusTopupTakeBonus = 0x00001180
function user_addEventListener()
    ff.net:addEventListener(dd.Tjf_User_ChangeName,onUserChangeName)
    ff.net:addEventListener(dd.Tjf_vip_Activation,onVipActivation)
    ff.net:addEventListener(dd.Tjf_card_TakePrepaidCard,onCardTakePrepaidCard)
    ff.net:addEventListener(dd.Tjf_charge_TestCharge,onTestCharge)
    ff.net:addEventListener(dd.Tjf_GetRankUser,onGetRankUser,endGetRankUser)
    ff.net:addEventListener(dd.Tjf_GetUserRankInfo,onGetUserRankInfo)
    ff.net:addEventListener(dd.Tjf_charge_GetTopupLists,onGetChargeLists)
    ff.net:addEventListener(dd.Tjf_online_GetReward,onGetReward)
    ff.net:addEventListener(dd.Tjf_daytask_GetList,onGetDaytaskList)
    ff.net:addEventListener(dd.Tjf_daytask_GetReward,onGetDaytaskReward)
    ff.net:addEventListener(dd.Tjf_daytask_GetNextBox,onGetDaytaskNext)
    ff.net:addEventListener(dd.Tjf_AlchemistAction,onAlchemistAction)
    ff.net:addEventListener(dd.Tjf_GemDecompose,onGemDecompose)
    ff.net:addEventListener(dd.Tjf_EquipSell,onEquipSell)
    ff.net:addEventListener(dd.Tjf_RestrictedBonusTopupTakeBonus,onRestrictedBonusTopupTakeBonus)
end
function onGetUserRankInfo(result)
    local code = result:getLong()
    local yuliu = result:getLong()
    if code == 0 then
        local myInfo = {}
        myInfo["fightRank"] = result:getLong()
        myInfo["killRank"] = result:getLong()
        myInfo["unionFightRank"] = result:getLong()
        myInfo["unionKillRank"] = result:getLong()  
        result:clear()  
        return {code,myInfo}
    else
        result:clear()
        return {code}
    end
end
function onGetRankUser(message)
    local code = message:getLong()
    if code == 0 then
        local myInfo = {}
        myInfo["openTime"] = message:getLong()
        myInfo["type"] = message:getLong()
        myInfo["ifLast"] = message:getLong()
        myInfo["myRank"] = message:getLong()
        local num = message:getLong()
        local info=ff.NetTable:create()
        info:addStreamCol("user_rank",ff.NET_LONG)
        info:addStreamCol("user_id",ff.NET_LONG)
        info:addStreamCol("user_pic",ff.NET_LONG)
        info:addStreamCol("user_name",ff.NET_STRING,15)
        info:addStreamCol("union_office",ff.NET_LONG)
        info:addStreamCol("union_id",ff.NET_LONG)
        info:addStreamCol("union_short",ff.NET_STRING,3)
        info:addStreamCol("union_name",ff.NET_STRING,15)
        info:addStreamCol("value",ff.NET_SUPER_LONG)
        
        message:getData(num,info)
        message:clear()  
        return {code,myInfo,info}
    else
        message:clear()
        return {code}
    end
end
function endGetRankUser(ret)
    if ret[1] == 0 and ret[3] ~= nil then
        ret[3]:clear()
        ret[3] = nil
    end
end
function onUserChangeName(message)
    cclog("onUserChangeName")
    local code = message:getLong()
    if code == 0 then
        local name = message:getString(15)
        local face = message:getLong()
        dd.myinfo:setString(1,"name",name)
        if face ~= 0 then
            dd.myinfo:setLong(1,"face",face)
        end
        --道具
        local tid    = message:getLong()
        local tcount  = message:getLong()
        if tid > 0 then
            dd.setToolCount(tid,tcount)
        end  

        --扣资源
        dd.gold(message:getLong())

        message:clear()
        return {code,name}
    end
    message:clear()
    return {code}
end

function onVipActivation(message)
    local code = message:getLong()
    if code == 0 then
        local type = message:getLong()
        local start   = message:getLong()
        local endtime = message:getLong()
        local param1 = message:getLong()
        local param2 = message:getLong()
        local param3 = message:getLong()
        local param4 = message:getLong()
        if start > 0 then
            local row = 0
            for i=1,dd.mylists:rowCount() do
                local qtype = dd.mylists:getLong(i,"type")
                if qtype == 12 then
                    row = i
                    dd.mylists:setLong(row,"type",type)
                    dd.mylists:setLong(row,"start",start)
                    dd.mylists:setLong(row,"end",endtime)
                    dd.mylists:setLong(row,"param1",param1)
                    dd.mylists:setLong(row,"param2",param2)
                    dd.mylists:setLong(row,"param3",param3)
                    dd.mylists:setLong(row,"param4",param4)
                    break
                end
            end
            
            if row == 0 then
                local row = dd.mylists:addRow()
                dd.mylists:setLong(row,"type",type)
                dd.mylists:setLong(row,"start",start)
                dd.mylists:setLong(row,"end",endtime)
                dd.mylists:setLong(row,"param1",param1)
                dd.mylists:setLong(row,"param2",param2)
                dd.mylists:setLong(row,"param3",param3)
                dd.mylists:setLong(row,"param4",param4)
            end
        end
        
        dd.gold(message:getLong())
        local tid   = message:getLong()
        local count = message:getLong()
        if tid > 0 then
            dd.setToolCount(tid,count)
        end
        
        message:clear()  
        return {code}
    else
        message:clear()
        return {code}
    end
end

function onCardTakePrepaidCard(message)
    local code = message:getLong()
    if code == 0 then
        local type = message:getLong()
        local getgold = message:getLong()  --获得金币
        dd.gold(message:getLong())
        message:clear()
        return {code, getgold}
    else
        message:clear()
        return {code}
    end
end

function onTestCharge(message)
    local code = message:getLong()
    if code == 0 then
        return {code}
    else
        message:clear()
        return {code}
    end
end

function onGetChargeLists(message)
    local code = message:getLong()
    if code == 0 then
        local viplv = message:getLong()
        local num = message:getLong()
        local SurpriseRechargeId = 0
        local SurpriseRechargeTime = 0
        local LevelRechargeId = 0
        local LevelRechargeTime = 0
        local ActiveCharg = 0
        local ActiveChargTime = 0

        local SurpriseRechargeIdEx = 0
        local SurpriseRechargeTimeEx = 0
        local ResCharge = 0
        local ResChargeTime = 0
        local BonusCharge = 0
        local BonusChargeTime = 0
        local OnceCharge = 0
        local OnceChargeTime = 0
        local have1 = false
        local have2 = false
        local info={}
        for i=1,num do
            info[i] = {}
            info[i]["id"] = message:getLong()
            info[i]["type"] = message:getLong()
            info[i]["typeparam"] = message:getLong()
            info[i]["endtime"] = message:getLong()
            --cclog("============"..info[i]["type"].."=="..info[i]["id"].."=="..dd.cfgCharge[info[i]["id"]]['type'])
            if dd.cfgCharge[info[i]["id"]] ~= nil and dd.cfgCharge[info[i]["id"]]['type'] == 11 then
                SurpriseRechargeId = info[i]["id"]
                SurpriseRechargeTime = info[i]["endtime"]
            end
            if dd.cfgCharge[info[i]["id"]] ~= nil and dd.cfgCharge[info[i]["id"]]['type'] == 100 then
                if LevelRechargeId == 0 or LevelRechargeId > info[i]["id"] then
                    LevelRechargeId = info[i]["id"]
                    LevelRechargeTime = info[i]["endtime"]
                end
            end
            if dd.cfgCharge[info[i]["id"]] ~= nil and dd.cfgCharge[info[i]["id"]]['type'] == 500 then
                ActiveCharg = info[i]["id"]
                ActiveChargTime = info[i]["endtime"]
            end
            if ActiveCharg == 0 and dd.cfgCharge[info[i]["id"]] ~= nil and dd.cfgCharge[info[i]["id"]]['type'] == 600 then
                ActiveCharg = info[i]["id"]
                ActiveChargTime = info[i]["endtime"]
            end

            if dd.cfgCharge[info[i]["id"]] ~= nil and dd.cfgCharge[info[i]["id"]]['type'] == 700 then
                
                OnceCharge = info[i]["id"]
                OnceChargeTime = info[i]["endtime"]
            end

            if dd.cfgCharge[info[i]["id"]] ~= nil and dd.cfgCharge[info[i]["id"]]['type'] == 6 then

                SurpriseRechargeIdEx = info[i]["id"]
                SurpriseRechargeTimeEx = info[i]["endtime"]
            end
            
            if dd.cfgCharge[info[i]["id"]] ~= nil and dd.cfgCharge[info[i]["id"]]['type'] == 2 then
                if LevelRechargeId == 0 then
                    LevelRechargeId = info[i]["id"]
                    LevelRechargeTime = info[i]["endtime"]
                end
            end

            if dd.cfgCharge[info[i]["id"]] ~= nil and dd.cfgCharge[info[i]["id"]]['type'] == 200 then
                ResCharge = info[i]["id"]
                ResChargeTime = info[i]["endtime"]
            end

            if dd.cfgCharge[info[i]["id"]] ~= nil and dd.cfgCharge[info[i]["id"]]['type'] == 13 then
                BonusCharge = info[i]["id"]
                BonusChargeTime = info[i]["endtime"]
            end

        end
        if SurpriseRechargeId > 0 and have1 == false then
            have1 = true
            dd.mygifts:setLong(1,"SurpriseRechargeId",SurpriseRechargeId)
            dd.mygifts:setLong(1,"SurpriseRechargeTime",SurpriseRechargeTime)
        else
            dd.mygifts:setLong(1,"SurpriseRechargeId",0)
            dd.mygifts:setLong(1,"SurpriseRechargeTime",0)
        end
        if OnceCharge > 0 and have1 == false then
            have1 = true 
            dd.mygifts:setLong(1,"OnceCharge",OnceCharge)
            dd.mygifts:setLong(1,"OnceChargeTime",OnceChargeTime)
        else
            dd.mygifts:setLong(1,"OnceCharge",0)
            dd.mygifts:setLong(1,"OnceChargeTime",0)
        end
        
        if LevelRechargeId > 0 and have1 == false then
            have1 = true
            dd.mygifts:setLong(1,"LevelRechargeId",LevelRechargeId)
            dd.mygifts:setLong(1,"LevelRechargeTime",LevelRechargeTime)
        else
            dd.mygifts:setLong(1,"LevelRechargeId",0)
            dd.mygifts:setLong(1,"LevelRechargeTime",0)
        end
        if ActiveCharg > 0 and  have1 == false then
            have1 = true
            dd.mygifts:setLong(1,"ActiveCharge",ActiveCharg)
            dd.mygifts:setLong(1,"ActiveChargeTime",ActiveChargTime)
        else
            dd.mygifts:setLong(1,"ActiveCharge",0)
            dd.mygifts:setLong(1,"ActiveChargeTime",0)
        end


        
        if SurpriseRechargeIdEx > 0 and have2 == false then
            have2 = true
            dd.mygifts:setLong(1,"SurpriseRechargeIdEx",SurpriseRechargeIdEx)
            dd.mygifts:setLong(1,"SurpriseRechargeTimeEx",SurpriseRechargeTimeEx)
        else
            dd.mygifts:setLong(1,"SurpriseRechargeIdEx",0)
            dd.mygifts:setLong(1,"SurpriseRechargeTimeEx",0)
        end
        if LevelRechargeId > 0 and have2 == false then
            have2 = true
            dd.mygifts:setLong(1,"LevelRechargeId",LevelRechargeId)
            dd.mygifts:setLong(1,"LevelRechargeTime",LevelRechargeTime)
        else
            dd.mygifts:setLong(1,"LevelRechargeId",0)
            dd.mygifts:setLong(1,"LevelRechargeTime",0)
        end
        
        dd.mygifts:setLong(1,"ResCharge",ResCharge)
        dd.mygifts:setLong(1,"ResChargeTime",ResChargeTime)
        dd.mygifts:setLong(1,"BonusCharge",BonusCharge)
        dd.mygifts:setLong(1,"BonusChargeTime",BonusChargeTime)
        

        return {code,info}
    else
        message:clear()
        return {code}
    end
end
function onGetReward(message)
    local code = message:getLong()
    if code == 0 then
        dd.mygifts:setLong(1,"onlinepack",message:getLong())
        local pid = message:getLong()
        dd.mygifts:setLong(1,"onlinepackid", pid)
        message:clear()
        return {code,pid}
    else
        message:clear()
        return {code}
    end
end
function onGetDaytaskList(message)
    local code = message:getLong()
    if code == 0 then
        local resettime = message:getLong()
        cclog("time == "..resettime)
        local level = message:getLong()                 --目标等级
        local tasks = {}
        for i=1,5 do
            tasks[i] = {}
            tasks[i]["curstar"]  = message:getLong()
            tasks[i]["progress"] = message:getLong()
            tasks[i]["curgoal"]  = message:getLong()    --当前目标 
            tasks[i]["rewardtype"] = message:getLong()  --奖励id
            tasks[i]["rewardtid"] = message:getLong()    --奖励id
            tasks[i]["rewardcount"] = message:getLong() --奖励id
        end
        local havecount = message:getLong()             --已领宝箱数量
        local time      = message:getLong()             --黄金宝箱过期时间
        local cangetbox4      = message:getLong()
        dd.myDayTask:setLong(1,"time",time)
        dd.myDayTask:setLong(1,"getStep",cangetbox4)
        local total_1 =   message:getLong()
        local total_2 =   message:getLong()
        local total_3 =   message:getLong()
        local total_4 =   message:getLong()
        local total_5 =   message:getLong()
        local total_6 =   message:getLong()
        --cclog("==========="..total_4.."=="..total_5.."=="..total_6)
        local boxs = {}
        boxs[1] = {}
        boxs[2] = {}
        boxs[3] = {}
        boxs[4] = {}
        boxs[5] = {}
        boxs[6] = {}
        for i=1,total_1 do
            boxs[1][i] = {}
            boxs[1][i]["type"] = message:getLong()
            boxs[1][i]["tid"]  = message:getLong()
            boxs[1][i]["count"]= message:getLong()
        end
        
        for i=1,total_2 do
            boxs[2][i] = {}
            boxs[2][i]["type"] = message:getLong()
            boxs[2][i]["tid"]  = message:getLong()
            boxs[2][i]["count"]= message:getLong()
        end
        
        for i=1,total_3 do
            boxs[3][i] = {}
            boxs[3][i]["type"] = message:getLong()
            boxs[3][i]["tid"]  = message:getLong()
            boxs[3][i]["count"]= message:getLong()
        end
        for i=1,total_4 do
            boxs[4][i] = {}
            boxs[4][i]["type"] = message:getLong()
            boxs[4][i]["tid"]  = message:getLong()
            boxs[4][i]["count"]= message:getLong()
        end
        for i=1,total_5 do
            boxs[5][i] = {}
            boxs[5][i]["type"] = message:getLong()
            boxs[5][i]["tid"]  = message:getLong()
            boxs[5][i]["count"]= message:getLong()
        end
        for i=1,total_6 do
            boxs[6][i] = {}
            boxs[6][i]["type"] = message:getLong()
            boxs[6][i]["tid"]  = message:getLong()
            boxs[6][i]["count"]= message:getLong()
        end
        message:clear()
        return {code,tasks,havecount,boxs,time}
    else
        message:clear()
        return {code}
    end
end
function onGetDaytaskReward(message)
    local code = message:getLong()
    if code == 0 then
        local type = message:getLong()    
        local info = {}
        info["curstar"] = message:getLong()
        info["progress"] = message:getLong()
        info["curgoal"] = message:getLong()         --当前目标
        info["rewardtype"] = message:getLong()
        info["rewardtid"] = message:getLong()
        info["rewardcount"] = message:getLong()
        local havecount = message:getLong()         --已领宝箱数量
        
        message:clear()
        return {code,type,info,havecount}
    else
        message:clear()
        return {code}
    end
end
function onGetDaytaskNext(message)
    local code = message:getLong()
    if code == 0 then
        local time = message:getLong()   --0 无黄金宝箱   1已经领取   其他为过期时间 
        local getStep  = message:getLong() 

        dd.myDayTask:setLong(1,"time",time)
        dd.myDayTask:setLong(1,"getStep",getStep)
        message:clear()
        return {code,time}
    else
        message:clear()
        return {code}
    end
end

function onAlchemistAction(message)
    local code = message:getLong()
    if code == 0 then
        local type = message:getLong()   --0 无黄金宝箱   1已经领取   其他为过期时间 
        local can1  = message:getLong() 
        local can2  = message:getLong() 
        local can3  = message:getLong() 
        local can4  = message:getLong() 
        local liu1  = message:getLong() 
        local liu2  = message:getLong() 
        local liu3  = message:getLong() 
        local liu4  = message:getLong() 
        local itemid  = message:getLong() 
        local count = message:getLong() 
        dd.gold(message:getLong())
    
        if itemid > 0 then
            dd.setToolCount(itemid,count)
        end
        if type == 6 then
            if dd.currentLayer._widget ~= nil then
              dd.currentLayer._widget:onShowTips("\t"..ff.langString("技能使用成功"),true)
            end
        end
        message:clear()
        return {code,type}
    else
        message:clear()
        dd.mainUI:onShowCodeTips(code)
        return {code}
    end
end

function onGemDecompose(message)
    local code = message:getLong()
    if code == 0 then
        local id = message:getLong()   --0 无黄金宝箱   1已经领取   其他为过期时间 
        local fenjie  = message:getLong() 
        local shengyu  = message:getLong() 
        local itemid  = message:getLong() 
        local count = message:getLong()
        local countnow = message:getLong() 
        dd.setToolCount(id,shengyu)
        if itemid > 0 then
            dd.setToolCount(itemid,countnow)
        end
        
        message:clear()
        return {code,count}
    else
        message:clear()
        dd.mainUI:onShowCodeTips(code)
        return {code}
    end
end 

function onEquipSell(message)
    local code = message:getLong()
    if code == 0 then
        local id = message:getLong()   --0 无黄金宝箱   1已经领取   其他为过期时间 
        local yinbi = message:getLong()

        dd.silver(yinbi)
        local count = message:getLong()
        for i=1,count do
            local itemid  = message:getLong() 
            local countnow = message:getLong() 
            if itemid > 0 then
                dd.setToolCount(itemid,countnow)
            end
        end
        for i=1,dd.myArms:rowCount() do
            if dd.myArms:getLong(i,"tid") == id then
                dd.myArms:delRow(i)
                break
            end  
        end
        
        
        message:clear()
        return {code,de}
    else
        message:clear()
        dd.mainUI:onShowCodeTips(code)
        return {code}
    end
end 

function onRestrictedBonusTopupTakeBonus(message)
    local code = message:getLong()
    if code == 0 then
        local id = message:getLong()   --0 无黄金宝箱   1已经领取   其他为过期时间 
        local havechong  = message:getLong() 
        local maxchong  = message:getLong() 
        local haveling  = message:getLong() 
        local maxling = message:getLong()
        local nexttime = message:getLong() 
        local stoptime = message:getLong() 
        local baoliu1 = message:getLong() 
        local baoliu2= message:getLong() 
        local baoliu3 = message:getLong() 
        local baoliu4 = message:getLong() 
        for i=1,dd.RestrictedGift:rowCount() do 
            if dd.RestrictedGift:getLong(i,"id")  == id then
                dd.RestrictedGift:setLong(i,"havechong",havechong) 
                dd.RestrictedGift:setLong(i,"maxchong",maxchong) 
                dd.RestrictedGift:setLong(i,"haveling",haveling) 
                dd.RestrictedGift:setLong(i,"maxling",maxling) 
                dd.RestrictedGift:setLong(i,"nexttime",nexttime) 
                dd.RestrictedGift:setLong(i,"stoptime",stoptime) 
                dd.RestrictedGift:setLong(i,"baoliu1",baoliu1) 
                dd.RestrictedGift:setLong(i,"baoliu2",baoliu2) 
                dd.RestrictedGift:setLong(i,"baoliu3",baoliu3) 
                dd.RestrictedGift:setLong(i,"baoliu4",baoliu4) 
            end
        end
        
        message:clear()
        return {code}
    else
        message:clear()
        dd.mainUI:onShowCodeTips(code)
        return {code}
    end
end

