dd.Tjf_User_Report_GetList = 0x00001045
dd.Tjf_User_Report_Action = 0x00001136
dd.Tjf_Get_Scout_Report = 0x00001029
dd.Tjf_Get_Fight_Report = 0x00001027
dd.Tjf_Get_Report_Get_Bonus = 0x00001161

function report_addEventListener(  )
	-- bodyonReportGetList
	ff.net:addEventListener(dd.Tjf_User_Report_GetList,onReportGetList)
	ff.net:addEventListener(dd.Tjf_User_Report_Action,onReportAction)
	ff.net:addEventListener(dd.Tjf_Get_Scout_Report,onGetScoutReport)
    ff.net:addEventListener(dd.Tjf_Get_Fight_Report,onGetFightReport)
    ff.net:addEventListener(dd.Tjf_Get_Report_Get_Bonus,onGetReportGetBonus)
end

function onGetReportGetBonus( result )
    -- body
    --cclog("=============================================================")
    local ret = result:getLong()
    if ret == 0 then
        local id = result:getSuperLong()
        --cclog("============================================================="..id)
        result:clear()
        return {ret,id}
    else 
        dd.mainUI:onShowCodeTips(ret)
        result:clear()
        return {ret,0}
    end
end

function onReportGetList( result )
	-- body
	--cclog("=============================================================")
	local ret = result:getLong()
	if ret == 0 then
		local table = {}

		table.type = result:getLong()
		table.collect = result:getLong()
        dd.myinfo:setLong(1,"ursys",result:getLong())
        dd.myinfo:setLong(1,"urreport",result:getLong())
        dd.myinfo:setLong(1,"urcj",result:getLong())
        dd.myinfo:setLong(1,"urpve",result:getLong())
		
		local num  = result:getLong()
		if num > 0 then
			local info = ff.NetTable:create()
			info:addStreamCol("id",ff.NET_SUPER_LONG)
			info:addStreamCol("time",ff.NET_LONG)
			info:addStreamCol("state",ff.NET_LONG)
			info:addStreamCol("type",ff.NET_LONG)
			info:addStreamCol("content",ff.NET_STRING,512)
			info:addStreamCol("awardTime",ff.NET_LONG)
			info:addStreamCol("awardStr",ff.NET_STRING,512)

			for i=1,num do
				local index = info:addRow()
				local id = result:getSuperLong()
				info:setSuperLong(index,"id",id)
				local time = result:getLong()
				info:setLong(index,"time",time)
				local state = result:getLong()
				info:setLong(index,"state",state)
				local type = result:getLong()
				info:setLong(index,"type",type)

				local conLong = result:getLong()-1
				local  str1 = result:getString(conLong)

				info:setString(index,"content",str1)
                --cclog("========"..str1)
				local awardTime = result:getLong()
				if awardTime == -1 then
                    local awardLong = result:getLong()
                    
					info:setLong(index,"awardTime",-1)
					info:setString(index,"awardStr","")
				else
					info:setLong(index,"awardTime",awardTime)
					local awardLong = result:getLong()-1
					local str2 = result:getString(awardLong)
					info:setString(index,"awardStr",str2)
				end
				
			end
            
			table.info = info
		else
			table.info = nil
		end
        dd.myinfo:setLong(1,"uryg",result:getLong())
        dd.myinfo:setLong(1,"urboss",result:getLong())
        dd.myinfo:setLong(1,"urgc",result:getLong())
        dd.myinfo:setLong(1,"urZB",result:getLong())
        dd.myinfo:setLong(1,"urRboss",result:getLong())
		result:clear()
		return table
	else 
		dd.mainUI:onShowCodeTips(ret)
		result:clear()
		return nil
	end
end

function onReportAction( result )
	-- body
	--cclog("sjkafhksjd================")
	local ret = result:getLong()
    if ret == 0 then
        local table = {}
        local opType = result:getLong()
        local state = result:getLong()
        local mailNum = result:getLong()
        if opType == 1  then
            cclog("标记已删除")
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("删除成功"),true)
        elseif opType == 2 then
            cclog("标记已读")
            if state == 3 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("收藏成功"),true)
            elseif state == 1 then
                --cclog("=====================")
                
            end
        end
        local info=ff.NetTable:create()
        info:addStreamCol("id",ff.NET_SUPER_LONG)
        if mailNum > 0 then
            result:getData(mailNum,info)
        end    

        table.opType = opType
        table.state = state
        table.info = info
        result:clear()
        return table
    else
        result:clear()
        return nil
    end
end

function onGetScoutReport( message )
    -- body
    local code = message:getLong()
    if code == 0 then
        local table = {}
        table.id = message:getSuperLong()
        table.time = message:getLong()
        table.pos = message:getLong()
        table.result = message:getLong()

        table.A_uid = message:getLong()
        table.A_office = message:getLong()
        table.A_union = message:getString(3)
        table.A_name = message:getString(15)
        table.A_ico = message:getLong()
        table.A_pos = message:getLong()

        table.B_uid = message:getLong()
        table.B_office = message:getLong()
        table.B_union = message:getString(3)
        table.B_name = message:getString(15)
        table.B_ico = message:getLong()
        table.B_pos = message:getLong()

        --cclog("a"..table.A_pos.."b"..table.B_pos)

        table.hero_name = message:getString(15)
        table.hero_id = message:getLong()
        table.herp_office = message:getLong()
        table.hero_level = message:getLong()
        table.hero_power = message:getLong()

        local arym = message:getLong()
        local aryminfo=ff.NetTable:create()
        if arym > 0 then
            
            aryminfo:addStreamCol("id",ff.NET_LONG)
            aryminfo:addStreamCol("count",ff.NET_LONG)
            message:getData(arym, aryminfo)

        end
        table.aryminfo = aryminfo

        local city = message:getLong()
        local cityinfo=ff.NetTable:create()
        if city > 0 then
            
            cityinfo:addStreamCol("id",ff.NET_LONG)
            cityinfo:addStreamCol("count",ff.NET_LONG)
            message:getData(city, cityinfo)

        end
        table.cityinfo = cityinfo

        local build = message:getLong()
        local buildinfo=ff.NetTable:create()
        if build > 0 then
            
            buildinfo:addStreamCol("id",ff.NET_LONG)
            buildinfo:addStreamCol("count",ff.NET_LONG)
            message:getData(build, buildinfo)

        end
        table.buildinfo = buildinfo

        local tec = message:getLong()
        local tecinfo=ff.NetTable:create()
        if tec > 0 then
            
            tecinfo:addStreamCol("id",ff.NET_LONG)
            tecinfo:addStreamCol("count",ff.NET_LONG)
            message:getData(tec, tecinfo)

        end
        table.tecinfo = tecinfo

        local res = message:getLong()
        local resinfo=ff.NetTable:create()
        if res > 0 then
            
            resinfo:addStreamCol("id",ff.NET_LONG)
            resinfo:addStreamCol("count",ff.NET_LONG)
            message:getData(res, resinfo)

        end
        

        table.resinfo = resinfo

        local item = message:getLong()
        local iteminfo=nil
        if item > 0 then
            iteminfo=ff.NetTable:create()
            iteminfo:addStreamCol("id",ff.NET_LONG)
            iteminfo:addStreamCol("count",ff.NET_LONG)
            message:getData(item, iteminfo)
        end
        table.iteminfo = iteminfo

        message:clear()  
        
        return {code,table}
    else
        message:clear()
        return {code}
    end
end
function getFightReport(id,message)
    local table = {}
    if id == 0 then
        id = dd.getServerTime()
    end
    table.id   = id
    table.time = message:getLong()
    table.pos = message:getLong()
    table.type = message:getLong()
    table.result = message:getLong()

    table.A_union_ID = message:getLong()
    table.A_union_Name = message:getString(15)
    table.A_union_Name2 = message:getString(3)
    table.A_hero_Master_ID = message:getLong()
    table.A_hero_Name = message:getString(15)
    table.A_hero_office = message:getLong()
    table.A_hero_ID = message:getLong()
    table.A_hero_level = message:getLong()
    table.A_hero_power = message:getLong()
    table.A_hero_exp = message:getLong()
    
    table.B_union_ID = message:getLong()
    table.B_union_Name = message:getString(15)
    table.B_union_Name2 = message:getString(3)
    table.B_hero_Master_ID = message:getLong()
    table.B_hero_Name = message:getString(15)
    table.B_hero_office = message:getLong()
    table.B_hero_ID = message:getLong()
    table.B_hero_level = message:getLong()
    table.B_hero_power = message:getLong()
    table.B_hero_exp = message:getLong()

    local Acount = message:getLong()

    local info = nil
    if Acount>0 then
        info=ff.NetTable:create()
        info:addStreamCol("type",ff.NET_LONG)
        info:addStreamCol("id",ff.NET_LONG)
        info:addStreamCol("office",ff.NET_LONG)
        info:addStreamCol("name",ff.NET_STRING,15)
        info:addStreamCol("level",ff.NET_LONG)
        info:addStreamCol("ico",ff.NET_LONG)
        info:addStreamCol("pos",ff.NET_LONG)
        info:addStreamCol("powerUp",ff.NET_LONG)
        info:addStreamCol("powerLose",ff.NET_LONG)

        message:getData(Acount,info)
    end

    table.Ainfo = info

    local Bcount = message:getLong()
   
    local infoB = nil
    if Bcount>0 then
        infoB=ff.NetTable:create()
        infoB:addStreamCol("type",ff.NET_LONG)
        infoB:addStreamCol("id",ff.NET_LONG)
        infoB:addStreamCol("office",ff.NET_LONG)
        infoB:addStreamCol("name",ff.NET_STRING,15)
        infoB:addStreamCol("level",ff.NET_LONG)
        infoB:addStreamCol("ico",ff.NET_LONG)
        infoB:addStreamCol("pos",ff.NET_LONG)
        infoB:addStreamCol("powerUp",ff.NET_LONG)
        infoB:addStreamCol("powerLose",ff.NET_LONG)
    
        message:getData(Bcount,infoB)
    end

    table.Binfo = infoB

    local resCnt = message:getLong()
    local resInfo = nil
  
    if resCnt > 0 then
        resInfo=ff.NetTable:create()
        resInfo:addStreamCol("playerid",ff.NET_LONG)
        resInfo:addStreamCol("itemType",ff.NET_LONG)
        resInfo:addStreamCol("itemId",ff.NET_LONG)
        resInfo:addStreamCol("itemCnt",ff.NET_LONG)
        message:getData(resCnt,resInfo)
    end

    table.resInfo = resInfo

    local amyCnt = message:getLong()

    local amyInfo = nil
    if amyCnt > 0 then
        amyInfo=ff.NetTable:create()
        amyInfo:addStreamCol("playerid",ff.NET_LONG)
        amyInfo:addStreamCol("id",ff.NET_LONG)
        amyInfo:addStreamCol("power",ff.NET_LONG)
        amyInfo:addStreamCol("powerlose",ff.NET_LONG)
        amyInfo:addStreamCol("medcnt",ff.NET_LONG)

        message:getData(amyCnt,amyInfo)
    end

    table.amyInfo = amyInfo

    local NPCCnt = message:getLong()

    local NPCInfo = nil
    if NPCCnt > 0 then
        NPCInfo=ff.NetTable:create()
        NPCInfo:addStreamCol("id",ff.NET_LONG)
        NPCInfo:addStreamCol("power",ff.NET_LONG)
        NPCInfo:addStreamCol("powerUp",ff.NET_LONG)
        NPCInfo:addStreamCol("powerStill",ff.NET_LONG)

        message:getData(NPCCnt,NPCInfo)
    end
    local compare = {}
    compare.canCompare = message:getLong()
    if compare.canCompare ~= 0 then
        compare.A_hero_level = message:getLong()
        compare.A_ALLPower = message:getSuperLong()
        compare.A_AmyCnt = message:getLong()
        compare.A_isHao = message:getLong()
        compare.A_isShen = message:getLong()
        compare.A_liao = message:getLong()
        compare.A_cheng = message:getLong()
        compare.A_dashi = message:getLong()
        compare.A_zhan = message:getLong()
        compare.A_yu1 = message:getLong()
        compare.A_yu2 = message:getLong()
        compare.A_yu3 = message:getLong()
        compare.A_yu4 = message:getLong()

        compare.B_hero_level = message:getLong()
        compare.B_ALLPower = message:getSuperLong()
        compare.B_AmyCnt = message:getLong()
        compare.B_isHao = message:getLong()
        compare.B_isShen = message:getLong()
        compare.B_liao = message:getLong()
        compare.B_cheng = message:getLong()
        compare.B_dashi = message:getLong()
        compare.B_zhan = message:getLong()
        compare.B_yu1 = message:getLong()
        compare.B_yu2 = message:getLong()
        compare.B_yu3 = message:getLong()
        compare.B_yu4 = message:getLong()

        compare.addBu = message:getLong()
        compare.addQi = message:getLong()
        compare.addGong = message:getLong()
        compare.addHPBu = message:getLong()
        compare.addHPQi = message:getLong()
        compare.addHPGong = message:getLong()
        compare.equipPower = message:getLong()
        compare.gemLevel = message:getLong()
        compare.tec1 = message:getLong()
        compare.tec2 = message:getLong()
        compare.tec3 = message:getLong()
        compare.tec4 = message:getLong()
        compare.tec5 = message:getLong()
        compare.tec6 = message:getLong()
        compare.tec7 = message:getLong()
        compare.tec8 = message:getLong()
        compare.union1 = message:getLong()
        compare.union2 = message:getLong()
        compare.union3 = message:getLong()
        compare.union4 = message:getLong()
        compare.result = table.result

        --cclog("=="..compare.A_isHao.."="..compare.B_isHao.."="..compare.A_liao.."="..compare.B_liao)
    end
    table.iflosecf = message:getLong()
    if table.iflosecf > 0 then
        table.startcf = message:getLong()
        table.losecf = message:getLong()
        table.nowcf = message:getLong()
        if table.nowcf < 1 then
            table.nowcf = 0
        end
    end
    table.zhuajiang = message:getLong()
    

    table.NPCInfo = NPCInfo
    table.compare = compare
    message:clear()  
    cclog("55555555555555555555555555555555555555555555555555555555here"..table.zhuajiang)
    return {0,table}
end
function onGetFightReport( message )
    -- body
    local code = message:getLong()
    if code == 0 then
        return getFightReport(message:getSuperLong(),message)
    else
        message:clear()
        return {code}
    end
end
