InvitationLayer = class("InvitationLayer")
InvitationLayer._name = "Invitation"
InvitationLayer._init = false
InvitationLayer._info = {}
InvitationLayer._type = 1
InvitationLayer._friendId = 0
InvitationLayer._friendDate ={}
InvitationLayer._cfg = {}
InvitationLayer._box = nil
InvitationLayer._isGet = false


function InvitationLayer.extend( target )
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target,t)
    end
    setmetatable(t,InvitationLayer)
    return target
    -- body
end

function InvitationLayer:onAutoSize()
    local hh = ff.height
    self:setContentSize(cc.size(720,hh))
    self:getChildByName("bg"):setContentSize(cc.size(720,hh))
    self:getChildByName("bg"):setPositionY(0)
    self:getChildByName("topArea"):setPositionY(hh - 105)
    self:getChildByName("topNavi"):setPositionY(hh-105-85)
    self:getChildByName("list1"):setContentSize(cc.size(720,hh-105-85-200))
    self:getChildByName("list1"):setPositionY(200)
    self:getChildByName("list2"):setContentSize(cc.size(720,hh-105-85))
    self:getChildByName("list2"):setPositionY(0)
    self:getChildByName("list2"):getChildByName("top"):setPositionY(hh-105-274-85)
    self:getChildByName("list2"):getChildByName("listview"):setContentSize(cc.size(720,hh-105-274-85))
    self:getChildByName("list2"):getChildByName("listview"):setPositionY(0)
    self:getChildByName("list2"):getChildByName("listview"):addScrollViewEventListener(self.scrollViewEvent)
    self:getChildByName("oper"):setPositionY(0)
    self:getChildByName("pop"):setContentSize(cc.size(720,hh-105))
    self:getChildByName("pop"):setPositionY(0)
    self:getChildByName("pop"):getChildByName("top"):setPositionY(hh-105-330)
    self:getChildByName("pop"):getChildByName("listview"):setContentSize(cc.size(720,hh-105-330))
    self:getChildByName("pop"):getChildByName("listview"):setPositionY(0)
    self:getChildByName("pop"):getChildByName("bg_0"):setPositionY(0)
    self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onReturn)
    self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
    self:getChildByName("topNavi"):getChildByName("navi1"):addTouchEventListener(self.onSelect)
    self:getChildByName("topNavi"):getChildByName("navi2"):addTouchEventListener(self.onSelect)
    self:getChildByName("oper"):getChildByName("view"):addTouchEventListener(self.onPop)
    self:getChildByName("list2"):getChildByName("top"):getChildByName("Label_386"):setString(ff.langString("使用了你的邀请码的玩家将自动互相添加好友，你可以在好友列表中找到他们"))
    self:getChildByName("list1"):getChildByName("dec"):getChildByName("Label_335"):setString(ff.langString("7级以下玩家可使用邀请码，每个邀请码只能被使用一次，每周你可从你邀请的好友的充值金额中获得5%的金币作为奖励。"))
    self:getChildByName("pop"):getChildByName("top"):getChildByName("Label_386"):setString(ff.langString("当HQ达到7级，9级，11级时，你将获得一枚激活码。每个激活码只能使用一次，只能被7级以下玩家使用。请珍惜。"))
    self:getChildByName("list1"):getChildByName("info"):getChildByName("Label3"):setString(ff.langString("好友HQ达到LV.{0}",{7}))
    self:getChildByName("list1"):getChildByName("info"):getChildByName("Label4"):setString(ff.langString("好友HQ达到LV.{0}",{10}))
    self:getChildByName("list1"):getChildByName("info"):getChildByName("Label5"):setString(ff.langString("好友HQ达到LV.{0}",{12}))
    self:getChildByName("list1"):getChildByName("info"):getChildByName("Label6"):setString(ff.langString("好友HQ达到LV.{0}",{14}))
    self:getChildByName("pop"):getChildByName("item"):getChildByName("copy"):addTouchEventListener(self.onCopy)
    local input      = self:getChildByName("list1"):getChildByName("chatInput"):getChildByName("input")
    local editBoxSize= input:getChildByName("input"):getContentSize()
    local function editBoxTextEventHandle(strEventName,pSender)
        if strEventName == "began" then
            pSender:setText("")
        elseif strEventName == "ended" or strEventName == "return" then
        elseif strEventName == "changed" then
        end
    end

    self._box    = dd.addEditBox(input,editBoxSize,"images/editbox.png",110101,cc.p(0,0),cc.p(5,4),cc.c3b(255,255,255),20,6,4,1,120,true,true,true)
    self._box:registerScriptEditBoxHandler(editBoxTextEventHandle)
    self:getChildByName("list1"):getChildByName("chatInput"):getChildByName("skip_send"):addTouchEventListener(self.onSend)
    for i=1,8 do
        self:getChildByName("list1"):getChildByName("top"):getChildByName("ScrollView"):getChildByName("item"..tonumber(i)):getChildByName("box"):addTouchEventListener(self.onBox)
        self:getChildByName("list1"):getChildByName("top"):getChildByName("ScrollView"):getChildByName("item"..tonumber(i)):getChildByName("box"):setTag(i)
    end
end

function InvitationLayer.onCopy(sender,eventType)
    -- body
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("Invitation") 
        local tag = sender:getTag()
        if widget._info.info[tag] ~= nil then
            local string = widget._info.info[tag]["ma"]
            platform_setClipBoard(string)

            if dd.currentLayer._widget ~= nil then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("复制成功"),true)
            end
        end
        --widget:getChildByName("pop"):setVisible(true)
    end
end

function InvitationLayer.onPop(sender,touchEventType)


    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("Invitation")
  
        widget:getChildByName("pop"):setVisible(true)
                     
    end
end

function InvitationLayer.scrollViewEvent(sender, evenType)
    if evenType == ccui.ScrollviewEventType.bounceBottom then
    
        
        local widget = pop.getDialog("Invitation")
        --cclog("===================="..widget._friendId)
        if widget._friendId ~= 0 then
            if widget._isGet == false then
                widget._isGet = true
               widget:getFriend()
            
            end
        end
    end
end

function InvitationLayer.onBox(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then 

        local function callback( )
            local message = ff.net:createMessage()
            message:addCmd(0x00000175)
            message:addLong(dd.uid)
            ff.net:rpc(message,false)
        end 

        local widget = pop.getDialog("Invitation")
        local id     = sender:getTag()

        local gifts = {}
        local giftInfo =Split(widget._cfg[id]['content'],'|')
        
        for k,v in pairs(giftInfo) do
            local gift =Split(v,'%^') 
            gifts[k] = {}
            gifts[k]["type"]  = tonumber(gift[1])
            gifts[k]["id"]    = tonumber(gift[2])
            gifts[k]["count"] = tonumber(gift[3])  
        end
        local can = false
        for k,v in pairs(widget._cfg) do
            if widget._info.nowji >= v['integral'] and widget._info.haveji < v['integral'] then
                can = true
              break
            end
        end
        if can then
            pop.onShowPopDialog("gifts",gifts,callback)    
        else
            pop.onShowPopDialog("gifts",gifts,nil)    
        end
        
        
    end
end

function InvitationLayer.onSend(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("Invitation")  
        if string.len(widget._box:getText()) > 0 then
            local message = ff.net:createMessage()
            message:addCmd(0x00000174)
            message:addLong(dd.uid)
            message:addString(widget._box:getText(),6)
            ff.net:rpc(message,false)
            widget._box:setText("")
        end
    end
end

function InvitationLayer:getInvitation()
    local message = ff.net:createMessage()
    message:addCmd(0x00000054)
    message:addLong(dd.uid)
    ff.net:rpc(message,false)
end

function InvitationLayer:getFriend()
    local message = ff.net:createMessage()
    message:addCmd(0x00000055)
    message:addLong(dd.uid)
    message:addLong(self._friendId)
    ff.net:rpc(message,false)
end

function InvitationLayer.onSelect(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("Invitation")
        if widget == nil then
            return
        end
        if sender:getSelectedState() == true then
            widget:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)
            widget:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)     
            return
        end    
        widget:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)
        widget:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)     
        if sender:getName() == "navi1" then
            widget._type = 1
            widget:onInvitation()
            widget:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
            widget:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
        else
            widget._type = 2
            widget:showFriend()
            widget:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
            widget:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
        end
    end
end    


function onShowInvitation( widget)
    -- body
    local layer = InvitationLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end

function InvitationLayer:onInit( )
    -- body
    if self._init == false then
        self:onAutoSize()
        self._init = true
    end

    self:initDate()

    self.updateGold()
    self._type = 1
    self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(true)
    self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)
    self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
    self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    if self._box ~= nil then
        self._box:setText(ff.langString("点击输入激活码"))
    end
end


function InvitationLayer:initDate(  )
    self._friendId = 0
    self._isGet = false
    self._friendDate = {}
    self._cfg = {}
    local propData1 = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_invitation` order by `id`")
    for i=1, propData1:rowCount() do
       local id = tonumber(propData1:getString(i, "id"))
       self._cfg[id]={}
       self._cfg[id]['integral'] = tonumber(propData1:getString(i, "integral"))
       self._cfg[id]['content'] = propData1:getString(i, "content")
    end
    propData1:clear()
end

function InvitationLayer.onReturn( sender,eventType )
    -- body
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("Invitation")
            if widget == nil then
                return
            end
            if widget:getChildByName("pop"):isVisible() == true then
                widget:getChildByName("pop"):setVisible(false)
                return
            end
        pop.onClosePopDialog("Invitation")
    end
end

function InvitationLayer:onInvitation(  )
    self:getChildByName("list1"):setVisible(true)
    self:getChildByName("list2"):setVisible(false)
    self:getChildByName("oper"):setVisible(true)
    local View = self:getChildByName("list1"):getChildByName("top"):getChildByName("ScrollView")
    local per = 0
 
    for k,v in pairs(self._cfg) do
        if self._info.nowji <= v['integral'] then
            if tonumber(k) > 1 then
                per = 100/8*(self._info.nowji - self._cfg[tonumber(k)-1]['integral'])/ (v['integral'] - self._cfg[tonumber(k)-1]['integral']) + 100/8*(tonumber(k)-1)
            else
                per = 100/8*self._info.nowji/ v['integral']
            end
          break
        end
    end
    if per > 100 then
        per = 100
    end
    --cclog("--------"..per)
    for k,v in pairs(self._cfg) do
        if self._info.haveji >= v['integral'] then
            if View:getChildByName("item"..tostring(k)) ~= nil then
                View:getChildByName("item"..tostring(k)):getChildByName("box"):loadTexture(dd.getPathFromUI("box_open.png",1))
            end
        else
            if View:getChildByName("item"..tostring(k)) ~= nil  then
                View:getChildByName("item"..tostring(k)):getChildByName("box"):loadTexture(dd.getPathFromUI("box_close.png",1))
            end
        end
        if View:getChildByName("item"..tostring(k)) ~= nil  then
            View:getChildByName("item"..tostring(k)):getChildByName("point"):setString(v['integral'])
        end
    end
    View:scrollToPercentHorizontal(per,0.1,false)
    self:getChildByName("list1"):getChildByName("top"):getChildByName("ScrollView"):getChildByName("forge"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
end

function InvitationLayer:DealPop(  )
    if self._info ~= nil then
        for k,v in pairs(self._info.info) do

            local item = self:getChildByName("pop"):getChildByName("listview"):getChildByTag(k)
            if item == nil then
                item = self:getChildByName("pop"):getChildByName("item"):clone()
                self:getChildByName("pop"):getChildByName("listview"):pushBackCustomItem(item)
            end
            item:setVisible(true)
            item:setTag(k)
            item:getChildByName("info"):setString(self._info.info[k]["ma"])
            if tonumber(self._info.info[k]["used"]) == 0 then
                item:getChildByName("copy"):setTag(k)
                item:getChildByName("copy"):setVisible(true)
                item:getChildByName("need"):setString("")
            else
                item:getChildByName("copy"):setVisible(false)
                item:getChildByName("need"):setString(ff.langString("已被使用"))
            end
            

        end
    end
end

function InvitationLayer:showFriend(  )
    self:getChildByName("list1"):setVisible(false)
    self:getChildByName("list2"):setVisible(true)
    self:getChildByName("oper"):setVisible(false)
    
end

function InvitationLayer.onEnd( sender )
    -- body
    sender:getChildByName("list2"):getChildByName("listview"):removeAllChildren(true)
    sender:getChildByName("pop"):getChildByName("listview"):removeAllChildren(true)
    ff.net:removeEvent(2,dd.Tjf_UseInvitationCode)
    ff.net:removeEvent(2,dd.Tjf_TakeInvitationBonus)
    ff.net:removeEvent(2,dd.Tjf_GetInvitationCodeInfo)
    ff.net:removeEvent(2,dd.Tjf_GetInviteeSnsInfo)
    dd.delBackEvent()
    ff.net:unbindProperty("gold",2322)
    sender:stopAllActions()
end

function InvitationLayer.onBefore( sender)
  -- body 
    ff.net:registerEvent(2,dd.Tjf_UseInvitationCode, function (message)sender:getUseInvitationCode(message)end)
    ff.net:registerEvent(2,dd.Tjf_TakeInvitationBonus, function (message)sender:getInvitationMessage(message)end)
    ff.net:registerEvent(2,dd.Tjf_GetInvitationCodeInfo, function (message)sender:getInvitationMessage(message)end)
    ff.net:registerEvent(2,dd.Tjf_GetInviteeSnsInfo, function (message)sender:getFriendMessage(message)end)
    
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    
end

function InvitationLayer:getInvitationMessage( message )
    if message[1] == 0 then
        self._info = message[2]
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setString(ff.langString("我的积分").."("..self._info.nowji..")")
        self:DealPop()
        if self._type == 1 then
            self:onInvitation(  )
        elseif self._type ==2 then
            self:showFriend(  )
        end
    else
        if dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(message[1]))  
        end
    end
    -- body
end

function InvitationLayer:getUseInvitationCode( message )
    if message[1] == 0 then
        for k,v in pairs(self._info.info) do
            if v["ma"] == message[3] then
                v["used"] = message[2]
                break
            end
        end
        if dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("邀请码使用成功"),true)
        end
        self:DealPop()
        if self._type == 1 then
            self:onInvitation(  )
        elseif self._type ==2 then
            self:showFriend(  )
        end
    else
        
        if dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(message[1]))  
        end
    end
    -- body
end

function InvitationLayer:DealFriend(  )
    local key_table = {}
    for key,_ in pairs(self._friendDate) do  
        table.insert(key_table,key)  
    end  
    table.sort(key_table,function(a , b)    return a > b  end)
    for k,v in pairs(key_table) do
        local item = self:getChildByName("list2"):getChildByName("listview"):getChildByTag(v)
        if item == nil then
            item = self:getChildByName("list2"):getChildByName("item"):clone()
            item:setVisible(true)
            item:setTag(v)
            self:getChildByName("list2"):getChildByName("listview"):pushBackCustomItem(item)
        end
        local dateStr = ff.showData(tonumber(self._friendDate[v]["time"]))
    
        item:getChildByName("time"):setString(dateStr)

        if tonumber(self._friendDate[v]["event"]) == 1000 then
            item:getChildByName("info"):setString(self._friendDate[v]["playername"]..ff.langString("接受了你的好友邀请"))
        else
            local level = tonumber(self._friendDate[v]["event"]) - 1000
            item:getChildByName("info"):setString(self._friendDate[v]["playername"]..ff.langString("把HQ等级提升至{0}",{level}))

        end
    end
end

function InvitationLayer:getFriendMessage( message )
    if message[1] == 0 then

        self._friendId = message[2]
        local info = message[3]
        self._isGet = false
        for k,v in pairs(info) do
            if self._friendDate[k] == nil then
                self._friendDate[k] = {}
            end
            self._friendDate[k]["id"] = k
            self._friendDate[k]["time"] = v["time"]
            self._friendDate[k]["playerid"] = v["playerid"]
            self._friendDate[k]["playername"] = v["playername"]
            self._friendDate[k]["event"] = v["event"]
            self._friendDate[k]["jifen"] = v["jifen"]
        end
        self:DealFriend()
    else
        if dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(message[1]))  
        end
    end
end

function InvitationLayer.onStart( sender )
    ff.net:bindProperty(2322,"gold",sender.updateGold)
    sender:getInvitation()
    sender:getFriend()
end

function InvitationLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("Invitation")
    if widget ~= nil then
        widget:getChildByName("topArea"):getChildByName("money"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("topArea"):requestDoLayout()
    end
end
