AlchemistLayer = class("AlchemistLayer")
AlchemistLayer._name = "Alchemist"
AlchemistLayer._init = false
AlchemistLayer._type = 1
AlchemistLayer._index = 1
AlchemistLayer._gift = {}
AlchemistLayer._edit = nil
AlchemistLayer._speed= 0
AlchemistLayer._step = 10

function AlchemistLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,AlchemistLayer)
	return target
end

function AlchemistLayer:onInit(  )
	-- body
    function sliderEvent( ref, eventType )
        if eventType == ccui.SliderEventType.percentChanged then
            if self._gift[self._index] ~= nil then
                local percent = ref:getPercent()
                local curNum = 0
                if dd.getToolsCount(self._gift[self._index]) ~= 0 then
                    curNum = math.ceil(percent / 100 * dd.getToolsCount(self._gift[self._index]))
                end
                self:setNum(curNum)
            end
        end
    end
	if self._init == false then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		self:getChildByName("back"):setContentSize(cc.size(720,hh))
		self:getChildByName("top"):setPositionY(hh - 105)
        self:getChildByName("type"):setPositionY(hh - 105 - 80 )
		self:getChildByName("list"):setContentSize(cc.size(720,hh- 105 - 80))
    	self:getChildByName("list"):setPositionY(0)
        self:getChildByName("list2"):setContentSize(cc.size(720,hh- 105 - 80))
        self:getChildByName("list2"):setPositionY(0)
        self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
        self:getChildByName("type"):getChildByName("type1"):addTouchEventListener(self.onSelectType)
        self:getChildByName("type"):getChildByName("type2"):addTouchEventListener(self.onSelectType)
        self:getChildByName("type"):getChildByName("type3"):addTouchEventListener(self.onSelectType)
        self:getChildByName("type"):getChildByName("type4"):addTouchEventListener(self.onSelectType)
        self:getChildByName("type"):getChildByName("type1"):setTag(1)
        self:getChildByName("type"):getChildByName("type2"):setTag(2)
        self:getChildByName("type"):getChildByName("type3"):setTag(3)
        self:getChildByName("type"):getChildByName("type4"):setTag(4)
        self:getChildByName("item"):getChildByName("sure"):addTouchEventListener(self.onHeCheng)
        self:getChildByName("item"):getChildByName("fsdf"):addTouchEventListener(self.onHeCheng)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("juan1"):addTouchEventListener(self.onJuan)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("juan2"):addTouchEventListener(self.onJuan)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("juan3"):addTouchEventListener(self.onJuan)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("juan4"):addTouchEventListener(self.onJuan)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("juan5"):addTouchEventListener(self.onJuan)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("juan6"):addTouchEventListener(self.onJuan)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("juan1"):setTag(1)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("juan2"):setTag(2)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("juan3"):setTag(3)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("juan4"):setTag(4)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("juan5"):setTag(5)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("juan6"):setTag(6)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("skill1"):addTouchEventListener(self.onSkill)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("skill2"):addTouchEventListener(self.onSkill)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("skill3"):addTouchEventListener(self.onSkill)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("skill4"):addTouchEventListener(self.onSkill)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("skill5"):addTouchEventListener(self.onSkill)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("skill6"):addTouchEventListener(self.onSkill)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("skill1"):setTag(1)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("skill2"):setTag(2)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("skill3"):setTag(3)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("skill4"):setTag(4)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("skill5"):setTag(5)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("skill6"):setTag(6)
        self:getChildByName("tupo"):setContentSize(cc.size(720,hh - 105))
        self:getChildByName("tupo"):setPositionY(0)
        self:getChildByName("shuxing"):setContentSize(cc.size(720,hh - 105))
        self:getChildByName("shuxing"):setPositionY(0)
        self:getChildByName("haogan"):setContentSize(cc.size(720,hh - 105))
        self:getChildByName("haogan"):setPositionY(0)
        self:getChildByName("zhanbo"):setContentSize(cc.size(720,hh - 105))
        self:getChildByName("zhanbo"):setPositionY(0)
        self:getChildByName("help"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("help"):setPositionY(0)
        self:getChildByName("help"):getChildByName("pop"):getChildByName("close"):addTouchEventListener(self.onClosePop)
        self:getChildByName("Panel"):getChildByName("wupo"):addTouchEventListener(self.onShuxing)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("pro"):getChildByName("shengji"):addTouchEventListener(self.onTupo)
        self:getChildByName("Panel"):getChildByName("haogan"):getChildByName("juan2"):addTouchEventListener(self.onHaogan)
        self:getChildByName("Panel"):getChildByName("zhanbo"):getChildByName("juan2"):addTouchEventListener(self.onZhanbo)
        self:getChildByName("Panel"):getChildByName("haogan"):getChildByName("juan1"):addTouchEventListener(self.onXingli)
        self:getChildByName("Panel"):getChildByName("haogan"):getChildByName("juan3"):addTouchEventListener(self.onFushi)
        self:getChildByName("tupo"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onCloseTu)
        self:getChildByName("tupo"):getChildByName("view"):getChildByName("gold"):addTouchEventListener(self.onTuGold)
        self:getChildByName("shuxing"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onCloseShu)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onCloseHao)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("gold"):addTouchEventListener(self.onZengsong)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("sub"):addTouchEventListener(self.onSub)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("add"):addTouchEventListener(self.onAdd)
        self:getChildByName("zhanbo"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onCloseZhan)
        self:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time1"):addTouchEventListener(self.onZhanTime)
        self:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time2"):addTouchEventListener(self.onZhanTime)
        self:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time3"):addTouchEventListener(self.onZhanTime)
        self:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time1"):setTag(1)
        self:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time2"):setTag(2)
        self:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time3"):setTag(3)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("item1"):getChildByName("Check"):addTouchEventListener(self.onCheck)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("item2"):getChildByName("Check"):addTouchEventListener(self.onCheck)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("item3"):getChildByName("Check"):addTouchEventListener(self.onCheck)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("item4"):getChildByName("Check"):addTouchEventListener(self.onCheck)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("item5"):getChildByName("Check"):addTouchEventListener(self.onCheck)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("item1"):getChildByName("Check"):setTag(1)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("item2"):getChildByName("Check"):setTag(2)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("item3"):getChildByName("Check"):setTag(3)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("item4"):getChildByName("Check"):setTag(4)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("item5"):getChildByName("Check"):setTag(5)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("juan5"):getChildByName("Image_331_0"):loadTexture(dd.getToolsIcon(1044),0)
        self:getChildByName("Panel"):getChildByName("shengji"):getChildByName("juan6"):getChildByName("Image_331_2"):loadTexture(dd.getToolsIcon(1044),0)
        self:getChildByName("type"):getChildByName("help"):addTouchEventListener(self.onHelp)
        local size = self:getChildByName("haogan"):getChildByName("view"):getChildByName("input"):getChildByName("count"):getContentSize()
        local editBox = dd.addEditBox(
             self:getChildByName("haogan"):getChildByName("view"):getChildByName("input"):getChildByName("count")
            , size
            , "images/ui/alpha.png"
            , 10
            , cc.p(0,0)
            , cc.p(0,0)
            , cc.c3b(255,255,255)
            , 20
            , 2
            , 4
            , 1
            , 5
            , true
            , true
            , true
        )
        local function editBoxTextEventHandle(strEventName,pSender)
            local edit = pSender
            local strFmt 
            if strEventName == "began" then
            elseif strEventName == "ended" or strEventName == "return" then
                local text=edit:getText()
                local count = 0
                if text == nil or text == "" then
                    count = 0
                else
                    count = tonumber(text)
                end
                if count == nil or count == "" then
                    count = 0
                end
                self:setNum(count)
            elseif strEventName == "changed" then
            end
        end
        self._edit = editBox
        editBox:registerScriptEditBoxHandler(editBoxTextEventHandle)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("progress"):getChildByName("green"):addEventListener(sliderEvent)
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("progress"):getChildByName("green"):setCorrect(25,335)


        self._init = true
	end
    self._type = 1
    self:InitData()
	self.updateGold()
end

function AlchemistLayer:setNum(count)
    count = tonumber(count)
    local max = 0
    if self._gift[self._index] ~= nil then
        max = dd.getToolsCount(self._gift[self._index])
    end
    if count > max then
        count = max
    end

    self._edit:setText(count)

    local progress = 0
    if max ~= 0 then
        progress = math.ceil(count * 100 / max)
    end
    self:getChildByName("haogan"):getChildByName("view"):getChildByName("progress"):getChildByName("green"):setPercent(progress)
end

function AlchemistLayer:InitData(  )
    local rows = nil
    self._gift = {}
    rows = ff.dbmanager:sql_fetch_rows("select `id` from cfg_props where `type`='23' order by `id` asc")
    if rows ~= nil then
        for i=1,rows:rowCount() do
            self._gift[i] = tonumber(rows:getString(i,"id"))
        end
        rows:clear()
    end
end

function AlchemistLayer.onShuxing( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("Alchemist")
        if widget == nil then
            return
        end 
        widget:showShuxing()
        widget:getChildByName("shuxing"):setVisible(true) 
    end   
end

function AlchemistLayer.onClosePop( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then    
        local widget = pop.getDialog("Alchemist")
        if widget == nil then
            return
        end
        widget:getChildByName("help"):setVisible(false)
    end
end


function AlchemistLayer:showShuxing(  )
    local level = 0
    if dd.myAlchemist ~= nil then
        level = dd.myAlchemist:getLong(1,"level")
    end
    if dd.Cfg_Alchemist_Lv[level]~= nil and  dd.Cfg_Alchemist_Lv[level+1] ~= nil then
        for i=1,4 do
            if dd.Cfg_Alchemist_Lv[level]["buff"..i.."id"] ~= 0 then
                if dd.cfgEffect[dd.Cfg_Alchemist_Lv[level]["buff"..i.."id"]] ~= nil then
                    self:getChildByName("shuxing"):getChildByName("view"):getChildByName("info"..i):getChildByName("name"):setString(ff.langString(dd.cfgEffect[dd.Cfg_Alchemist_Lv[level]["buff"..i.."id"]]['tips1'],{dd.Cfg_Alchemist_Lv[level]["buff"..i.."num"]/dd.cfgEffect[dd.Cfg_Alchemist_Lv[level]["buff"..i.."id"]]['value']}))
                end
            end
            if dd.Cfg_Alchemist_Lv[level+1]["buff"..i.."id"] ~= 0 then
                if dd.cfgEffect[dd.Cfg_Alchemist_Lv[level+1]["buff"..i.."id"]] ~= nil then
                    self:getChildByName("shuxing"):getChildByName("view"):getChildByName("info"..i):getChildByName("name1"):setString(ff.langString(dd.cfgEffect[dd.Cfg_Alchemist_Lv[level+1]["buff"..i.."id"]]['tips1'],{dd.Cfg_Alchemist_Lv[level+1]["buff"..i.."num"]/dd.cfgEffect[dd.Cfg_Alchemist_Lv[level+1]["buff"..i.."id"]]['value']}))
                end
            end
        end
    end
end

function AlchemistLayer.onTupo( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("Alchemist")
        if widget == nil then
            return
        end  
        widget:showShengji()
        widget:getChildByName("tupo"):setVisible(true)
    end   
end

function AlchemistLayer.onHelp( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("Alchemist")
        if widget == nil then
            return
        end  
        if widget._type == 1 then
            widget:getChildByName("help"):getChildByName("pop"):getChildByName("block1"):getChildByName("content"):setString(ff.langString("向炼金术士上缴炼金必须的钢铁，可增加经验值，经验值满后，消耗特殊道具水晶球进行突破。"))
            widget:getChildByName("help"):getChildByName("pop"):getChildByName("chu_title"):setString(ff.langString("炼金术士升级"))
        elseif widget._type == 2 then
            widget:getChildByName("help"):getChildByName("pop"):getChildByName("chu_title"):setString(ff.langString("好感度说明"))
            widget:getChildByName("help"):getChildByName("pop"):getChildByName("block1"):getChildByName("content"):setString(ff.langString("每1000秒下降1点好感度，出战也将消耗好感度，好感度过低则不能出战，赠送礼物可提升炼金术士的好感度。"))
        elseif widget._type == 3 then
            widget:getChildByName("help"):getChildByName("pop"):getChildByName("chu_title"):setString(ff.langString("占卜玩法说明"))
            widget:getChildByName("help"):getChildByName("pop"):getChildByName("block1"):getChildByName("content"):setString(ff.langString("占卜是获得水晶球的重要途径，同时也会获取其他道具，炼金术士的好感值越高，获得水晶球的概率越大。"))
        else
            widget:getChildByName("help"):getChildByName("pop"):getChildByName("chu_title"):setString("")
            widget:getChildByName("help"):getChildByName("pop"):getChildByName("block1"):getChildByName("content"):setString("")
        end
        widget:getChildByName("help"):setVisible(true)
    end   
end

function AlchemistLayer:showShengji(  )
    local level = 0
    if dd.myAlchemist ~= nil then
        level = dd.myAlchemist:getLong(1,"level")
    end
    if dd.Cfg_Alchemist_Lv[level]~= nil and  dd.Cfg_Alchemist_Lv[level+1] ~= nil then
        for i=1,4 do
            if dd.Cfg_Alchemist_Lv[level]["buff"..i.."id"] ~= 0 then
                if dd.cfgEffect[dd.Cfg_Alchemist_Lv[level]["buff"..i.."id"]] ~= nil then
                    self:getChildByName("tupo"):getChildByName("view"):getChildByName("info"..i):getChildByName("name"):setString(ff.langString(dd.cfgEffect[dd.Cfg_Alchemist_Lv[level]["buff"..i.."id"]]['tips1'],{dd.Cfg_Alchemist_Lv[level]["buff"..i.."num"]/dd.cfgEffect[dd.Cfg_Alchemist_Lv[level]["buff"..i.."id"]]['value']}))
                end
            end
            if dd.Cfg_Alchemist_Lv[level+1]["buff"..i.."id"] ~= 0 then
                if dd.cfgEffect[dd.Cfg_Alchemist_Lv[level+1]["buff"..i.."id"]] ~= nil then
                    self:getChildByName("tupo"):getChildByName("view"):getChildByName("info"..i):getChildByName("name1"):setString(ff.langString(dd.cfgEffect[dd.Cfg_Alchemist_Lv[level+1]["buff"..i.."id"]]['tips1'],{dd.Cfg_Alchemist_Lv[level+1]["buff"..i.."num"]/dd.cfgEffect[dd.Cfg_Alchemist_Lv[level+1]["buff"..i.."id"]]['value']}))
                end
            end
        end
        local gold = 0
        if dd.Cfg_Alchemist_Lv[level]["propnum"] > dd.getToolsCount(dd.Cfg_Alchemist_Lv[level]["propid"]) then
            gold = (dd.Cfg_Alchemist_Lv[level]["propnum"] - dd.getToolsCount(dd.Cfg_Alchemist_Lv[level]["propid"])) * 100
            self:getChildByName("tupo"):getChildByName("view"):getChildByName("gold"):getChildByName("count"):setString(gold)
            self:getChildByName("tupo"):getChildByName("view"):getChildByName("gold"):getChildByName("chu_label"):setVisible(true)
            self:getChildByName("tupo"):getChildByName("view"):getChildByName("gold"):getChildByName("count"):setVisible(true)
            self:getChildByName("tupo"):getChildByName("view"):getChildByName("gold"):getChildByName("Image_77"):setVisible(true)
            self:getChildByName("tupo"):getChildByName("view"):getChildByName("gold"):getChildByName("chu_Label_246"):setVisible(false)
        else       
            self:getChildByName("tupo"):getChildByName("view"):getChildByName("gold"):getChildByName("chu_label"):setVisible(false)
            self:getChildByName("tupo"):getChildByName("view"):getChildByName("gold"):getChildByName("count"):setVisible(false)
            self:getChildByName("tupo"):getChildByName("view"):getChildByName("gold"):getChildByName("Image_77"):setVisible(false)
            self:getChildByName("tupo"):getChildByName("view"):getChildByName("gold"):getChildByName("chu_Label_246"):setVisible(true)
        end
        
        self:getChildByName("tupo"):getChildByName("view"):getChildByName("info"):setString(ff.langString("本次突破需要消耗{0}水晶球",{dd.Cfg_Alchemist_Lv[level]["propnum"]}))
    end
end


function AlchemistLayer.onXingli( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("Alchemist")
        if widget == nil then
            return
        end  
        if dd.myAlchemist ~= nil then
            local message = ff.net:createMessage()
            message:addCmd(0x00000143)
            message:addLong(dd.uid)         
            message:addLong(3) 
            message:addLong(1)

            for i=1,7 do
                message:addLong(0)
            end
            
            ff.net:rpc(message, false)
        
        end
        
    end   
end

function AlchemistLayer.onFushi( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("Alchemist")
        if widget == nil then
            return
        end  
        if dd.myAlchemist ~= nil then
            local message = ff.net:createMessage()
            message:addCmd(0x00000143)
            message:addLong(dd.uid)         
            message:addLong(3) 
            message:addLong(2)

            for i=1,7 do
                message:addLong(0)
            end
            
            ff.net:rpc(message, false)
        
        end
        
    end   
end
 
function AlchemistLayer.onZhanbo( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("Alchemist")
        if widget == nil then
            return
        end  
        if dd.myAlchemist ~= nil and dd.myAlchemist:getLong(1,"zhanbuCD") ~= 0 and dd.myAlchemist:getLong(1,"zhanbuCD") < dd.getServerTime() then
            local message = ff.net:createMessage()
            message:addCmd(0x00000143)
            message:addLong(dd.uid)         
            message:addLong(5) 
            message:addLong(0)

            for i=1,7 do
                message:addLong(0)
            end
            
            ff.net:rpc(message, false)
        else
            widget:showZhanbo()
            widget:getChildByName("zhanbo"):setVisible(true)
        end
        
    end   
end

function AlchemistLayer:showZhanbo(  )
    if dd.myAlchemist == nil or dd.myAlchemist:getLong(1,"zhanbuCD") == 0 then
        self:getChildByName("zhanbo"):getChildByName("view"):getChildByName("info1"):setString(ff.langString("占卜是获得水晶球的重要途径，同时也会获取其他道具，炼金术士的好感值越高，获得水晶球的概率越大。"))
        self:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time1"):setVisible(true)
        self:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time2"):setVisible(true)
        self:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time3"):setVisible(true)
    else
        if dd.myAlchemist:getLong(1,"zhanbuCD") >= dd.getServerTime() then
            local time =  dd.myAlchemist:getLong(1,"zhanbuCD") - dd.getServerTime()
            self:getChildByName("zhanbo"):getChildByName("view"):getChildByName("info1"):setString(ff.langString("正在窥探你的命运……").."\n".."("..ff.getLeftTime(time,":")..")")
            self:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time1"):setVisible(false)
            self:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time2"):setVisible(false)
            self:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time3"):setVisible(false)
        end
    end
end

function AlchemistLayer.onHaogan( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("Alchemist")
        if widget == nil then
            return
        end  
        widget:showHaogan()
        widget:getChildByName("haogan"):setVisible(true)
    end   
end

function AlchemistLayer:showHaogan(  )
    for i=1,5 do
        if self._gift[i] ~= nil then
            self:getChildByName("haogan"):getChildByName("view"):getChildByName("item"..i):getChildByName("ico"):loadTexture(dd.getToolsIcon(self._gift[i]),0)
            self:getChildByName("haogan"):getChildByName("view"):getChildByName("item"..i):getChildByName("count"):setString(dd.getToolsCount(self._gift[i]))
        end
    end
    self._index = 1 
    self:unSelect()
    self:getChildByName("haogan"):getChildByName("view"):getChildByName("item1"):getChildByName("Check"):setSelectedState(true)
    self:updatesItem(self._index)
end

function AlchemistLayer.onJuan( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("Alchemist")
        if widget == nil then
            return
        end  
        local id = sender:getTag()
        if id <= 4 then
            local iron = {10000,100000,500000,1000000}
            local function sure()
                local message = ff.net:createMessage()
                message:addCmd(0x00000143)
                message:addLong(dd.uid)         
                message:addLong(1)  
                message:addLong(iron[id])
                for i=1,7 do
                    message:addLong(0)
                end
                
                ff.net:rpc(message, false)
            end
            
            if dd.iron() < iron[id] then
                local money = math.ceil((iron[id] - dd.iron())/dd.iron_lv)
                dd.mainUI:onShowSure(ff.langString("警告"),ff.langString("资源不足，是否消耗{0}金币进行补足？",{money}),sure)
            else
                sure()
            end
        else
            local iron = 1
            if id ~= 5 then
                iron = 10
            end
            local function sure()
                local message = ff.net:createMessage()
                message:addCmd(0x00000143)
                message:addLong(dd.uid)         
                message:addLong(7)  
                message:addLong(iron)
                for i=1,7 do
                    message:addLong(0)
                end
                
                ff.net:rpc(message, false)
            end
            
            if dd.getToolsCount(1044) < iron then
                dd.mainUI:onShowTips(ff.langString("材料不足！")) 
            else
                sure()
            end
        end
        
    end   
    
end

function AlchemistLayer.onSkill( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("Alchemist")
        if widget == nil then
            return
        end  
        local id = sender:getTag()
        local widget = pop.getDialog("Alchemist")
        local pos2word = widget:getWorldPos(sender)
        local pos = widget:convertToNodeSpace(pos2word) 
        if id < 4 then
            pos = cc.p(pos.x+50, pos.y+50)
        else
            pos = cc.p(pos.x-230, pos.y+50)
        end
        
        widget:showTips(id, pos)
        
    end   
    
end

function AlchemistLayer:showTips(id,pos)
    local tips = self:getChildByName("tips")
    local name = ""
    local str  = ""
    if dd.Cfg_Alchemist_Skill[id] ~= nil then
        local level = 0
        if dd.myAlchemist ~= nil then
            level = dd.myAlchemist:getLong(1,"level") /10

        end
        name = ff.langString(dd.Cfg_Alchemist_Skill[id]["name"])
        str = ff.langString(dd.Cfg_Alchemist_Skill[id]["tips"],{math.ceil(level * dd.Cfg_Alchemist_Skill[id]["xisu"])})
    end

    tips:stopAllActions()
    tips:setVisible(true)

    tips:getChildByName("name"):setString(name) 
    tips:getChildByName("info"):setString(str)
    
    tips:setPosition(pos)
    
    local function sched()
        tips:setVisible(false)
    end 

    performWithDelay(tips,sched,1.5) 
end



function AlchemistLayer.onHeCheng( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("Alchemist")
        if widget == nil then
            return
        end  
        local id = sender:getTag()
        

        dd.mainUI:showHeChengView(id)

        
    end   
end

function AlchemistLayer.onCloseTu( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("Alchemist")
        if widget ~= nil then
            widget:getChildByName("tupo"):setVisible(false)
        end
    end
end

function AlchemistLayer.onTuGold( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("Alchemist")
        if widget ~= nil then
            local level = 0
            local point = 0
            if dd.myAlchemist ~= nil then
                level = dd.myAlchemist:getLong(1,"level")
                point = dd.myAlchemist:getLong(1,"point")
            end
            if dd.Cfg_Alchemist_Lv[level]["jifen"] > point then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("炼金术士经验不足，无法突破"))
            else
                local message = ff.net:createMessage()
                message:addCmd(0x00000143)
                message:addLong(dd.uid)         
                message:addLong(2) 
                message:addLong(0)

                for i=1,7 do
                    message:addLong(0)
                end
                
                ff.net:rpc(message, false)
                widget:getChildByName("tupo"):setVisible(false)
            end
            
        end
    end
end

function AlchemistLayer.onCloseShu( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("Alchemist")
        if widget ~= nil then
            widget:getChildByName("shuxing"):setVisible(false)
        end
    end
end

function AlchemistLayer.onCloseHao( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("Alchemist")
        if widget ~= nil then
            widget:getChildByName("haogan"):setVisible(false)
        end
    end
end

function AlchemistLayer.onZengsong( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("Alchemist")
        if widget ~= nil then
            local count = tonumber(widget._edit:getText())
            if count ~= 0 then
                local message = ff.net:createMessage()
                message:addCmd(0x00000143)
                message:addLong(dd.uid)         
                message:addLong(3) 
                message:addLong(3)
                message:addLong(widget._gift[widget._index])
                message:addLong(count)
                for i=1,5 do
                    message:addLong(0)
                end
                
                ff.net:rpc(message, false)
            end
        end
    end
end
function AlchemistLayer.onSub( sender,eventType )
    local build = pop.getDialog("Alchemist")
    local function subCount(flag)
        if build._speed == build._step or flag == true then
            if build ~= nil and build._edit ~= nil then     
                local count = tonumber(build._edit:getText())
                if count == nil or count == "" then
                    count = 0
                end             
                if count < 0 then
                    count = 0
                    sender:stopAllActions()
                else
                    count = count - 1               
                end 

                build:setNum(count) 
                build._speed = 0
                build._step  = build._step - 1
                if build._step < 1 then
                    build._step = 1
                end 
            end
        end
        build._speed = build._speed + 1 
    end
    if eventType==ccui.TouchEventType.began then   
        build._speed = 0
        schedule(sender,subCount,0.01)  
    elseif eventType==ccui.TouchEventType.ended then   
        subCount(true)
        build._speed = 0
        build._step  = 10
        sender:stopAllActions() 
    elseif eventType == ccui.TouchEventType.canceled then
        build._speed = 0
        build._step  = 10
        sender:stopAllActions() 
    end
end
function AlchemistLayer.onAdd( sender,eventType )
    local build = pop.getDialog("Alchemist")
    local function addCount(flag)
        if build._speed == build._step or flag == true then
            if build ~= nil and build._edit ~= nil then     
                local count = tonumber(build._edit:getText())
                if count > dd.getToolsCount(build._gift[build._index]) then
                    count = dd.getToolsCount(build._gift[build._index])
                    sender:stopAllActions()
                else
                    count = count + 1               
                end 
                if count == nil or count == "" then
                    count = dd.getToolsCount(build._gift[build._index])
                end
                build:setNum(count) 
                build._speed = 0
                build._step  = build._step - 1
                if build._step < 1 then
                    build._step = 1
                end 
            end
        end
        build._speed = build._speed + 1 
    end
    if eventType==ccui.TouchEventType.began then   
        build._speed = 0
        schedule(sender,addCount,0.01)  
    elseif eventType==ccui.TouchEventType.ended then   
        addCount(true)
        build._speed = 0
        build._step  = 10
        sender:stopAllActions() 
    elseif eventType == ccui.TouchEventType.canceled then
        build._speed = 0
        build._step  = 10
        sender:stopAllActions() 
    end
end
function AlchemistLayer.onCloseZhan( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("Alchemist")
        if widget ~= nil then
            widget:getChildByName("zhanbo"):setVisible(false)
        end
    end
end
function AlchemistLayer.onZhanTime( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("Alchemist")
        if widget ~= nil then
            local id = sender:getTag()
        
            local message = ff.net:createMessage()
            message:addCmd(0x00000143)
            message:addLong(dd.uid)         
            message:addLong(4) 
            message:addLong(id)

            for i=1,7 do
                message:addLong(0)
            end
            
            ff.net:rpc(message, false)
        end
    end
end
function AlchemistLayer.onCheck( sender,eventType )
    local widget = pop.getDialog("Alchemist")
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            if widget ~= nil then
                if sender:getSelectedState() == true then  
                    widget:unSelect() 
                    sender:setSelectedState(true)
                    return
                end 
                widget:unSelect()
                widget:updatesItem(sender:getTag())
                sender:setSelectedState(true)
            end
            
        end
    end

    if eventType==ccui.TouchEventType.ended then  
        if widget ~= nil then
            if sender:getSelectedState() == true then  
                widget:unSelect() 
                return
            end   
            widget:unSelect()
            widget:updatesItem(sender:getTag())
        end
        
    end
end

function AlchemistLayer:updatesItem(row)
    if self._gift[row] ~= nil then
        self._index = row
        self._edit:setText(dd.getToolsCount(self._gift[self._index]))
        self:setNum(dd.getToolsCount(self._gift[self._index]))
    end
end

function AlchemistLayer.onSelectType( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("Alchemist")
        if widget ~= nil then
            local tag = sender:getTag()
            if tag ~= widget._type then
                widget._type = sender:getTag()
                widget:selectType(true)
            else
                widget:selectType(false)
            end
        end
    end
end

function AlchemistLayer:selectType( flesh,sender)
    self:getChildByName("type"):getChildByName("type1"):getChildByName("chu_Label_100"):setColor(cc.c3b(97,117,123))
    self:getChildByName("type"):getChildByName("type2"):getChildByName("chu_Label_100"):setColor(cc.c3b(97,117,123))
    self:getChildByName("type"):getChildByName("type1"):setSelectedState(false)
    self:getChildByName("type"):getChildByName("type3"):getChildByName("chu_Label_100"):setColor(cc.c3b(97,117,123))
    self:getChildByName("type"):getChildByName("type4"):getChildByName("chu_Label_100"):setColor(cc.c3b(97,117,123))
    self:getChildByName("type"):getChildByName("type3"):setSelectedState(false)
    self:getChildByName("type"):getChildByName("type2"):setSelectedState(false)
    self:getChildByName("type"):getChildByName("type4"):setSelectedState(false)
    self:getChildByName("type"):getChildByName("help"):setVisible(true)
    if self._type == 1 then
        self:getChildByName("type"):getChildByName("type1"):getChildByName("chu_Label_100"):setColor(cc.c3b(233, 239, 244))
    elseif self._type == 2 then
        self:getChildByName("type"):getChildByName("type2"):getChildByName("chu_Label_100"):setColor(cc.c3b(233, 239, 244))
    elseif self._type == 3 then
        self:getChildByName("type"):getChildByName("type3"):getChildByName("chu_Label_100"):setColor(cc.c3b(233, 239, 244))
    else
        self:getChildByName("type"):getChildByName("help"):setVisible(false)
        self:getChildByName("type"):getChildByName("type4"):getChildByName("chu_Label_100"):setColor(cc.c3b(233, 239, 244))
    end
    
    if sender ~= nil then
        sender:setSelectedState(true)
    end
    if flesh then
        if self._type == 4 then
            self:getChildByName("list"):setVisible(false)
            self:getChildByName("list2"):setVisible(true)
        else
            self:getChildByName("list2"):setVisible(false)
            self:getChildByName("list"):setVisible(true)
            local item = self:getChildByName("list"):getChildByTag(1)
            if item == nil then
                item = self:getChildByName("Panel"):clone()
                item:setTag(1)
                item:setVisible(true)
                self:getChildByName("list"):pushBackCustomItem(item)
                local wupo = sp.SkeletonAnimation:create("images/effect/Alchemist/Alchemist.json", "images/effect/Alchemist/Alchemist.atlas")
                wupo:setPosition(cc.p(110, 50))
                wupo:setAnimation(0, "lianjinsuo_play", true)
                item:getChildByName("wupo"):addChild(wupo,1,1)
            end
            if self._type == 1 then
                item:getChildByName("shengji"):setVisible(true)
                item:getChildByName("haogan"):setVisible(false)
                item:getChildByName("zhanbo"):setVisible(false)
            elseif self._type == 2 then
                item:getChildByName("shengji"):setVisible(false)
                item:getChildByName("haogan"):setVisible(true)
                item:getChildByName("zhanbo"):setVisible(false)
            else
                item:getChildByName("shengji"):setVisible(false)
                item:getChildByName("haogan"):setVisible(false)
                item:getChildByName("zhanbo"):setVisible(true)
            end
        end
        self:showList()
    end
end

function AlchemistLayer.onStart( sender )
	ff.net:bindProperty(2338,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
    schedule(sender, sender.update,1)
end


function AlchemistLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("Alchemist")
		if widget == nil then
			return
		end
        if dd.currentLayer._widget ~= nil then
            if dd.currentLayer._widget:getChildByName("hecheng"):isVisible() == true then
                dd.currentLayer._widget:getChildByName("hecheng"):setVisible(false)
                return
            end
            if widget:getChildByName("tupo"):isVisible() == true then
                widget:getChildByName("tupo"):setVisible(false)
                return
            end
            if widget:getChildByName("shuxing"):isVisible() == true then
                widget:getChildByName("shuxing"):setVisible(false)
                return
            end
            if widget:getChildByName("haogan"):isVisible() == true then
                widget:getChildByName("haogan"):setVisible(false)
                return
            end
            if widget:getChildByName("zhanbo"):isVisible() == true then
                widget:getChildByName("zhanbo"):setVisible(false)
                return
            end
            if widget:getChildByName("help"):isVisible() == true then
                widget:getChildByName("help"):setVisible(false)
                return
            end
        end
        pop.onClosePopDialog("Alchemist")
    end
end

function AlchemistLayer.onEnd( sender )
    -- body
    dd.delBackEvent()
    ff.net:removeEvent(3,dd.Tjf_ItemExchange)
    ff.net:removeEvent(3,dd.Tjf_AlchemistAction)
    ff.net:removeEvent(2,dd.Tjf_notify_SNGetBonus)
    ff.net:removeEvent(2,dd.Tjf_notify_SNAlchemist)
    sender:stopAllActions()
    sender:getChildByName("tips"):stopAllActions()
    sender:getChildByName("tips"):setVisible(false)
    if sender:getChildByName("list"):getChildByTag(1) ~= nil and sender:getChildByName("list"):getChildByTag(1):getChildByName("wupo"):getChildByTag(1) ~= nil then
        sender:getChildByName("list"):getChildByTag(1):getChildByName("wupo"):getChildByTag(1):stopAllActions()
        sender:getChildByName("list"):getChildByTag(1):getChildByName("wupo"):getChildByTag(1):removeFromParent()
    end
    
    sender:getChildByName("list"):removeAllChildren(true)
    sender:getChildByName("list2"):removeAllChildren(true)
    ff.net:unbindProperty("gold",2338)
end

function onShowAlchemist(widget)
	-- body
	local layer = AlchemistLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end

function AlchemistLayer.onBefore( sender)
    ff.net:registerEvent(2,dd.Tjf_notify_SNAlchemist, function (message) sender:OnSNAlchemist(message) end)
    ff.net:registerEvent(2,dd.Tjf_notify_SNGetBonus, function (message) sender:popRewardDialog(message) end)
    ff.net:registerEvent(3,dd.Tjf_ItemExchange,function (message)sender:onItemExchange(message)end)
    ff.net:registerEvent(3,dd.Tjf_AlchemistAction,function (message)sender:AlchemistAction(message)end)
    sender:selectType(true,sender:getChildByName("type"):getChildByName("type1"))
end

function AlchemistLayer:onItemExchange(params)
    local code = params[1]
    if code == 0 then      
        self:showList()
        AudioEngine.playEffect(ff.sounds[601])
        if dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("合成成功！"),true)
        end
    else
        --dd.mainUI:onShowCodeTips(code)
    end
end

function AlchemistLayer:popRewardDialog(infos)
    if table.getn(infos) > 0 then
        --商店里，是购买的才提示
        if infos[1]["from"] == 24 then
            
            pop.onShowPopDialog("reward",infos)
        end
    else
        return 
    end
end

function AlchemistLayer:OnSNAlchemist(infos)
    self:showList()
end

function AlchemistLayer:AlchemistAction(params)
    local code = params[1]
    if code == 0 then
        
        if params[2] == 4 then
            if self:getChildByName("zhanbo"):isVisible() == true  then
                self:showZhanbo()
            end
        elseif  params[2] == 2 then
            if self:getChildByName("tupo"):isVisible() == true  then
                self:showShengji()
            end
        elseif params[2] == 3 then
            if self:getChildByName("haogan"):isVisible() == true  then
                self:showHaogan()
            end
        end
    else
        
    end
end


function AlchemistLayer.update( sender )
    local Panel = sender:getChildByName("list"):getChildByTag(1)
    if Panel ~= nil then
        if sender._type == 2 then
            local haogandu = 0
            if dd.myAlchemist ~= nil then
                haogandu = dd.myAlchemist:getLong(1,"love") - math.floor((dd.getServerTime() - dd.myAlchemist:getLong(1,"loveTime"))/1000)
                if haogandu < 0 then
                    haogandu = 0
                end
            end
            local pre = 0
            local level = 0
                
            if dd.myAlchemist ~= nil then
                level = dd.myAlchemist:getLong(1,"level")

            end
            if dd.Cfg_Alchemist_Lv[level] ~= nil then
                pre = haogandu / 10
            end
            if pre > 100 then
                pre = 100
            end
            Panel:getChildByName("haogan"):getChildByName("pro"):getChildByName("Progress"):setPercent(pre)
            Panel:getChildByName("haogan"):getChildByName("pro"):getChildByName("pronum"):setString(haogandu.."/1000")
            local item1 = 0
            if dd.myAlchemist ~= nil and dd.myAlchemist:getLong(1,"loveCD1") > dd.getServerTime() then
                item1 = dd.myAlchemist:getLong(1,"loveCD1") - dd.getServerTime()
            end
            Panel:getChildByName("haogan"):getChildByName("juan1"):getChildByName("time"):setString(ff.getLeftTime(item1,":"))
            local item2 = 0
            if dd.myAlchemist ~= nil and dd.myAlchemist:getLong(1,"loveCD2") > dd.getServerTime() then
                item2 = dd.myAlchemist:getLong(1,"loveCD2") - dd.getServerTime()
            end
            Panel:getChildByName("haogan"):getChildByName("juan3"):getChildByName("time"):setString(ff.getLeftTime(item2,":"))
        elseif sender._type == 3 then
            if dd.myAlchemist ~= nil and dd.myAlchemist:getLong(1,"zhanbuCD") ~= 0 and dd.myAlchemist:getLong(1,"zhanbuCD") < dd.getServerTime() then
                Panel:getChildByName("zhanbo"):getChildByName("juan2"):getChildByName("chu_Label_9"):setString(ff.langString("领奖"))
                Panel:getChildByName("zhanbo"):getChildByName("juan2"):getChildByName("time"):setString("")
            else
                Panel:getChildByName("zhanbo"):getChildByName("juan2"):getChildByName("chu_Label_9"):setString(ff.langString("占卜"))
                if dd.myAlchemist ~= nil and dd.myAlchemist:getLong(1,"zhanbuCD") >= dd.getServerTime() then
                    local time = dd.myAlchemist:getLong(1,"zhanbuCD") - dd.getServerTime() 
                    Panel:getChildByName("zhanbo"):getChildByName("juan2"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                else
                    Panel:getChildByName("zhanbo"):getChildByName("juan2"):getChildByName("time"):setString("")
                end
            end
            
        end
    end
    if sender:getChildByName("zhanbo"):isVisible() == true then
        if dd.myAlchemist == nil or dd.myAlchemist:getLong(1,"zhanbuCD") == 0 then
            sender:getChildByName("zhanbo"):getChildByName("view"):getChildByName("info1"):setString(ff.langString("占卜是获得水晶球的重要途径，同时也会获取其他道具，炼金术士的好感值越高，获得水晶球的概率越大。"))
            sender:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time1"):setVisible(true)
            sender:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time2"):setVisible(true)
            sender:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time3"):setVisible(true)
        else
            if dd.myAlchemist:getLong(1,"zhanbuCD") >= dd.getServerTime() then
                local time =  dd.myAlchemist:getLong(1,"zhanbuCD") - dd.getServerTime()
                sender:getChildByName("zhanbo"):getChildByName("view"):getChildByName("info1"):setString(ff.langString("正在窥探你的命运……").."\n".."("..ff.getLeftTime(time,":")..")")
                sender:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time1"):setVisible(false)
                sender:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time2"):setVisible(false)
                sender:getChildByName("zhanbo"):getChildByName("view"):getChildByName("time3"):setVisible(false)
            end
        end
    end
end

function AlchemistLayer:getWorldPos(node)
    local anr   = node:getAnchorPoint()
    local size  = node:getContentSize()
    local p = node:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
    return p
end

function AlchemistLayer:unSelect()
    for i=1, 5 do
        self:getChildByName("haogan"):getChildByName("view"):getChildByName("item"..i):getChildByName("Check"):setSelectedState(false)
    end
end

function AlchemistLayer:showList(  )
    if self._type == 4 then
        for k,v in pairs(dd.cfgPropsynthersis) do
            local id = v['target_id']
            if k < 100 then
                local item = self:getChildByName("list2"):getChildByTag(id)
                if item == nil then
                    item = self:getChildByName("item"):clone()
                    self:getChildByName("list2"):pushBackCustomItem(item)
                end
                if item ~= nil then
                    item:setVisible(true)
                    item:setTag(id)
                    item:getChildByName("fsdf"):setTag(k)
                    item:getChildByName("sure"):setTag(k)
                    item:getChildByName("sure"):getChildByName("chu_label"):setString(ff.langString("合成"))
                    item:getChildByName("item"):getChildByName("ico"):getChildByName("icon"):loadTexture(dd.getToolsIcon(id),0)
                    item:getChildByName("item"):getChildByName("count"):setString(dd.getToolsCount(id))
                    cclog(id.."======"..dd.getToolsCount(id))
                    item:getChildByName("name"):setString(ff.langString(dd.cfgProp[id]['name'],{dd.cfgProp[id]['name1_lan']}))
                    item:getChildByName("info"):setString(ff.langString(dd.cfgProp[id]['tips'],{dd.cfgProp[id]['tips1_lan']})) 
                end
            end
        end
    else
        local Panel = self:getChildByName("list"):getChildByTag(1)
        if Panel == nil then
            Panel = self:getChildByName("Panel"):clone()
            Panel:setTag(1)
            Panel:setVisible(true)
            self:getChildByName("list"):pushBackCustomItem(Panel)
            local wupo = sp.SkeletonAnimation:create("images/effect/Alchemist/Alchemist.json", "images/effect/Alchemist/Alchemist.atlas")
            wupo:setPosition(cc.p(110, 50))
            wupo:setAnimation(0, "lianjinsuo_play", true)
            Panel:getChildByName("wupo"):addChild(wupo,1,1)
        end
        if self._type == 1 then
            local item = Panel:getChildByName("shengji")
            if item ~= nil then
                local level = 0
                local point = 0
                if dd.myAlchemist ~= nil then
                    level = dd.myAlchemist:getLong(1,"level")
                    point = dd.myAlchemist:getLong(1,"point")
                end
                item:getChildByName("pro"):getChildByName("LV"):setString("LV."..level)
                local pre = 0
                if dd.Cfg_Alchemist_Lv[level] ~= nil then
                    pre = point / dd.Cfg_Alchemist_Lv[level]["jifen"] * 100
                end
                if pre > 100 then
                    pre = 100 
                end
                item:getChildByName("pro"):getChildByName("Progress"):setPercent(pre)
                item:getChildByName("pro"):getChildByName("pronum"):setString(point.."/"..dd.Cfg_Alchemist_Lv[level]["jifen"])
                for i=1,6 do
                    item:getChildByName("skill"..i):getChildByName("ico"):loadTexture("images/icon/tools/"..dd.Cfg_Alchemist_Skill[i]["pic"]..".png",0)
                    if level >= dd.Cfg_Alchemist_Skill[i]["kaifanglv"] then
                        item:getChildByName("skill"..i):getChildByName("Image_289"):setVisible(false)
                    else
                        item:getChildByName("skill"..i):getChildByName("Image_289"):setVisible(true)
                    end
                end
                local iron = {10000,100000,500000,1000000}
                for i=1,4 do
                    if dd.iron() < iron[i] then
                        item:getChildByName("juan"..i):getChildByName("count"):setColor(cc.c3b(233,100,100))
                    else
                        item:getChildByName("juan"..i):getChildByName("count"):setColor(cc.c3b(255,255,255))
                    end
                end
            end
        elseif self._type == 2 then
            local haogandu = 0
            if dd.myAlchemist ~= nil then

                haogandu = dd.myAlchemist:getLong(1,"love") - math.floor((dd.getServerTime() - dd.myAlchemist:getLong(1,"loveTime"))/1000)
                if haogandu < 0 then
                    haogandu = 0
                end
            end
            local pre = 0
            local level = 0
                
            if dd.myAlchemist ~= nil then
                level = dd.myAlchemist:getLong(1,"level")

            end
            if dd.Cfg_Alchemist_Lv[level] ~= nil then
                pre = haogandu / 10
            end
            if pre > 100 then
                pre = 100
            end
            Panel:getChildByName("haogan"):getChildByName("pro"):getChildByName("Progress"):setPercent(pre)
            Panel:getChildByName("haogan"):getChildByName("pro"):getChildByName("pronum"):setString(haogandu.."/1000")
            local item1 = 0
            if dd.myAlchemist ~= nil and dd.myAlchemist:getLong(1,"loveCD1") > dd.getServerTime() then
                item1 = dd.myAlchemist:getLong(1,"loveCD1") - dd.getServerTime()
            end
            Panel:getChildByName("haogan"):getChildByName("juan1"):getChildByName("time"):setString(ff.getLeftTime(item1,":"))
            local item2 = 0
            if dd.myAlchemist ~= nil and dd.myAlchemist:getLong(1,"loveCD2") > dd.getServerTime() then
                item2 = dd.myAlchemist:getLong(1,"loveCD2") - dd.getServerTime()
            end
            Panel:getChildByName("haogan"):getChildByName("juan3"):getChildByName("time"):setString(ff.getLeftTime(item2,":"))
        elseif self._type == 3 then
            if dd.myAlchemist ~= nil and dd.myAlchemist:getLong(1,"zhanbuCD") ~= 0 and dd.myAlchemist:getLong(1,"zhanbuCD") < dd.getServerTime() then
                Panel:getChildByName("zhanbo"):getChildByName("juan2"):getChildByName("chu_Label_9"):setString(ff.langString("领奖"))
                Panel:getChildByName("zhanbo"):getChildByName("juan2"):getChildByName("time"):setString("")
            else
                Panel:getChildByName("zhanbo"):getChildByName("juan2"):getChildByName("chu_Label_9"):setString(ff.langString("占卜"))
                if dd.myAlchemist ~= nil and dd.myAlchemist:getLong(1,"zhanbuCD") >= dd.getServerTime() then
                    local time = dd.myAlchemist:getLong(1,"zhanbuCD") - dd.getServerTime() 
                    Panel:getChildByName("zhanbo"):getChildByName("juan2"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                else
                    Panel:getChildByName("zhanbo"):getChildByName("juan2"):getChildByName("time"):setString("")
                end
            end
            
        end
    end
end

function AlchemistLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("Alchemist")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end