TrainingRoomLayer = class("TrainingRoomLayer")
TrainingRoomLayer._name = "TrainingRoom"
TrainingRoomLayer._init = false


function TrainingRoomLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,TrainingRoomLayer)
	return target
end

function TrainingRoomLayer:onInit(  )
	-- body
	if self._init == false then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		self:getChildByName("Image_88"):setContentSize(cc.size(720,hh))
		self:getChildByName("top"):setPositionY(hh - 105)
        self:getChildByName("bar01"):setPositionY(hh - 105 - 38 )
		self:getChildByName("ScrollView"):setContentSize(cc.size(720,hh- 105 - 38))
    	self:getChildByName("ScrollView"):setPositionY(0)
        self:getChildByName("pop"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("pop"):setPositionY(0)
        self:getChildByName("besure"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("besure"):setPositionY(0)
        self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
        self:getChildByName("pop"):getChildByName("pop"):getChildByName("close"):addTouchEventListener(self.onClosePop)
        self:getChildByName("bar01"):getChildByName("Button_21"):addTouchEventListener(self.onPop)
        self:getChildByName("ScrollView"):getChildByName("trainBlock"):getChildByName("btn02"):addTouchEventListener(self.onJuan)
        self:getChildByName("ScrollView"):getChildByName("m1 "):addTouchEventListener(self.onJuanLiang)
        self:getChildByName("ScrollView"):getChildByName("m2"):addTouchEventListener(self.onJuanMu)
        self:getChildByName("ScrollView"):getChildByName("m3"):addTouchEventListener(self.onJuanYou)
        self:getChildByName("ScrollView"):getChildByName("m4"):addTouchEventListener(self.onJuanTie)
        self:getChildByName("ScrollView"):getChildByName("m5"):addTouchEventListener(self.onJuanJin)
        self:getChildByName("ScrollView"):getChildByName("m6"):addTouchEventListener(self.onJuanYin)
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("sure"):addTouchEventListener(self.onJiasu)
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):addTouchEventListener(self.closeBesure)
        self:getChildByName("ScrollView"):getChildByName("speedArea"):getChildByName("btnSpeed"):addTouchEventListener(self.openBesure)
        self._init = true
	end
    self._type = 1
	self.updateGold()
end

function TrainingRoomLayer.closeBesure(sender, touchEventType)
    if touchEventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("TrainingRoom")
        widget:getChildByName("besure"):setVisible(false)   
    end
end

function TrainingRoomLayer.openBesure(sender, touchEventType)
    if touchEventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("TrainingRoom")
        widget:getChildByName("besure"):setVisible(true)   
    end
end

function TrainingRoomLayer.onJiasu( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then    
        local message = ff.net:createMessage()
        message:addCmd(0x0000014e)
        message:addLong(dd.uid)         
        message:addLong(9)  
        for i=1,5 do
            message:addLong(0)
        end
        ff.net:rpc(message, false)
        local widget = pop.getDialog("TrainingRoom")
        widget:getChildByName("besure"):setVisible(false)   
    end
end

function TrainingRoomLayer.onJuanYin( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then    
        local message = ff.net:createMessage()
        message:addCmd(0x0000014e)
        message:addLong(dd.uid)         
        message:addLong(1) 
        message:addLong(6) 
        for i=1,4 do
            message:addLong(0)
        end
        ff.net:rpc(message, false)
    end
end

function TrainingRoomLayer.onJuanJin( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then    
        local message = ff.net:createMessage()
        message:addCmd(0x0000014e)
        message:addLong(dd.uid)         
        message:addLong(1) 
        message:addLong(7) 
        for i=1,4 do
            message:addLong(0)
        end
        ff.net:rpc(message, false)
    end
end

function TrainingRoomLayer.onJuanTie( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then    
        local message = ff.net:createMessage()
        message:addCmd(0x0000014e)
        message:addLong(dd.uid)         
        message:addLong(1) 
        message:addLong(4) 
        for i=1,4 do
            message:addLong(0)
        end
        ff.net:rpc(message, false)
    end
end

function TrainingRoomLayer.onJuanYou( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then    
        local message = ff.net:createMessage()
        message:addCmd(0x0000014e)
        message:addLong(dd.uid)         
        message:addLong(1) 
        message:addLong(2) 
        for i=1,4 do
            message:addLong(0)
        end
        ff.net:rpc(message, false)
    end
end

function TrainingRoomLayer.onJuanMu( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then    
        local message = ff.net:createMessage()
        message:addCmd(0x0000014e)
        message:addLong(dd.uid)         
        message:addLong(1) 
        message:addLong(3) 
        for i=1,4 do
            message:addLong(0)
        end
        ff.net:rpc(message, false)
    end
end

function TrainingRoomLayer.onJuan( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then    
        local message = ff.net:createMessage()
        message:addCmd(0x0000014e)
        message:addLong(dd.uid)         
        message:addLong(2) 
        for i=1,5 do
            message:addLong(0)
        end
        ff.net:rpc(message, false)
    end
end

function TrainingRoomLayer.onJuanLiang( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then    
        local message = ff.net:createMessage()
        message:addCmd(0x0000014e)
        message:addLong(dd.uid)         
        message:addLong(1) 
        message:addLong(5) 
        for i=1,4 do
            message:addLong(0)
        end
        ff.net:rpc(message, false)
    end
end

function TrainingRoomLayer.onClosePop( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then    
        local widget = pop.getDialog("TrainingRoom")
        if widget == nil then
            return
        end
        widget:getChildByName("pop"):setVisible(false)
    end
end

function TrainingRoomLayer.onPop( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then    
        local widget = pop.getDialog("TrainingRoom")
        if widget == nil then
            return
        end

        widget:getChildByName("pop"):setVisible(true)
    end
end



function TrainingRoomLayer.onHelp( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        
    end   
end

function TrainingRoomLayer.onStart( sender )
	ff.net:bindProperty(2340,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
    schedule(sender, sender.update,1)
end

function TrainingRoomLayer.update( sender )
    if sender.info.cd > 0 then
        local curtime   = dd.getServerTime()
        local time = sender.info.cd - curtime
        local gold = math.ceil(dd.getRealGoodp(time))
        sender:getChildByName("besure"):getChildByName("warning"):getChildByName("sure"):getChildByName("count"):setString(gold)
        sender:getChildByName("ScrollView"):getChildByName("speedArea"):getChildByName("Image_97"):getChildByName("speedCD"):setString(ff.langString("捐献正在CD")..":"..ff.getLeftTime(time,":"))
        if time > 8 * 3600  then
            sender:getChildByName("ScrollView"):getChildByName("m1 "):setTouchEnabled(false)
            sender:getChildByName("ScrollView"):getChildByName("m2"):setTouchEnabled(false)            
            sender:getChildByName("ScrollView"):getChildByName("m3"):setTouchEnabled(false)
            sender:getChildByName("ScrollView"):getChildByName("m4"):setTouchEnabled(false)
            sender:getChildByName("ScrollView"):getChildByName("m5"):setTouchEnabled(false)
            sender:getChildByName("ScrollView"):getChildByName("m6"):setTouchEnabled(false)
             local effect = ff.Effect:effectGrey()    
            sender:getChildByName("ScrollView"):getChildByName("m1 "):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
            sender:getChildByName("ScrollView"):getChildByName("m2"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
            sender:getChildByName("ScrollView"):getChildByName("m3"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
            sender:getChildByName("ScrollView"):getChildByName("m4"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
            sender:getChildByName("ScrollView"):getChildByName("m5"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
            sender:getChildByName("ScrollView"):getChildByName("m6"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
            sender:getChildByName("ScrollView"):getChildByName("speedArea"):getChildByName("Image_97"):getChildByName("speedCD"):setColor(cc.c3b(255,0,0))
            sender:getChildByName("ScrollView"):getChildByName("speedArea"):getChildByName("Image_97"):getChildByName("speedBar"):setPercent(100)
        else
            sender:getChildByName("ScrollView"):getChildByName("m1 "):setTouchEnabled(true)
            sender:getChildByName("ScrollView"):getChildByName("m2"):setTouchEnabled(true)            
            sender:getChildByName("ScrollView"):getChildByName("m3"):setTouchEnabled(true)
            sender:getChildByName("ScrollView"):getChildByName("m4"):setTouchEnabled(true)
            sender:getChildByName("ScrollView"):getChildByName("m5"):setTouchEnabled(true)
            sender:getChildByName("ScrollView"):getChildByName("m6"):setTouchEnabled(true)
            sender:getChildByName("ScrollView"):getChildByName("m1 "):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            sender:getChildByName("ScrollView"):getChildByName("m2"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            sender:getChildByName("ScrollView"):getChildByName("m3"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            sender:getChildByName("ScrollView"):getChildByName("m4"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            sender:getChildByName("ScrollView"):getChildByName("m5"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            sender:getChildByName("ScrollView"):getChildByName("m6"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            sender:getChildByName("ScrollView"):getChildByName("speedArea"):getChildByName("Image_97"):getChildByName("speedCD"):setColor(cc.c3b(255,255,255))
            local  per = time / (8 * 3600 ) *100
            sender:getChildByName("ScrollView"):getChildByName("speedArea"):getChildByName("Image_97"):getChildByName("speedBar"):setPercent(per)
        end
    else
        sender:getChildByName("ScrollView"):getChildByName("m1 "):setTouchEnabled(true)
            sender:getChildByName("ScrollView"):getChildByName("m2"):setTouchEnabled(true)            
            sender:getChildByName("ScrollView"):getChildByName("m3"):setTouchEnabled(true)
            sender:getChildByName("ScrollView"):getChildByName("m4"):setTouchEnabled(true)
            sender:getChildByName("ScrollView"):getChildByName("m5"):setTouchEnabled(true)
            sender:getChildByName("ScrollView"):getChildByName("m6"):setTouchEnabled(true)
            sender:getChildByName("ScrollView"):getChildByName("m1 "):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            sender:getChildByName("ScrollView"):getChildByName("m2"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            sender:getChildByName("ScrollView"):getChildByName("m3"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            sender:getChildByName("ScrollView"):getChildByName("m4"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            sender:getChildByName("ScrollView"):getChildByName("m5"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            sender:getChildByName("ScrollView"):getChildByName("m6"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        sender:getChildByName("ScrollView"):getChildByName("speedArea"):getChildByName("Image_97"):getChildByName("speedCD"):setColor(cc.c3b(255,255,255))
        sender:getChildByName("besure"):getChildByName("warning"):getChildByName("sure"):getChildByName("count"):setString("0")
        sender:getChildByName("ScrollView"):getChildByName("speedArea"):getChildByName("Image_97"):getChildByName("speedCD"):setString("")
        sender:getChildByName("ScrollView"):getChildByName("speedArea"):getChildByName("Image_97"):getChildByName("speedBar"):setPercent(0)
    end
end

function TrainingRoomLayer:refreshUI( info )
    self:getChildByName("ScrollView"):getChildByName("trainBlock"):getChildByName("Image_106_0"):getChildByName("LuckNum"):setString(ff.langString("幸运值").."  "..info.nowLuck.."/"..info.MaxLuck)
    self:getChildByName("ScrollView"):getChildByName("trainBlock"):getChildByName("tagTrain"):getChildByName("hzNum"):setString(ff.langString("当前徽章数")..":"..info.itemCnt)
    self:getChildByName("ScrollView"):getChildByName("m1 "):getChildByName("mText1"):setString(info.liangCnt)
    self:getChildByName("ScrollView"):getChildByName("m2"):getChildByName("mText2"):setString(info.muCnt)
    self:getChildByName("ScrollView"):getChildByName("m3"):getChildByName("mText3"):setString(info.shiCnt)
    self:getChildByName("ScrollView"):getChildByName("m4"):getChildByName("mText4"):setString(info.tieCnt)
    self:getChildByName("ScrollView"):getChildByName("m5"):getChildByName("mText5"):setString(info.jinCnt)
    self:getChildByName("ScrollView"):getChildByName("m6"):getChildByName("mText6"):setString(info.yinCnt)
    print(info.effect1id)
    self:getChildByName("ScrollView"):getChildByName("td01"):getChildByName("Label_91_0"):setString(ff.langString(dd.cfgEffect[info.effect1id]['name']))
    self:getChildByName("ScrollView"):getChildByName("td02"):getChildByName("Label_91_0"):setString(info.effect1can1)
    self:getChildByName("ScrollView"):getChildByName("td02"):getChildByName("Label_91_0_1_0"):setString("Lv."..info.nowLevel)
    self:getChildByName("ScrollView"):getChildByName("td03"):getChildByName("Label_91_0_0"):setString("Lv."..info.nowLevel+1)
    self:getChildByName("ScrollView"):getChildByName("td03"):getChildByName("Label_91_0"):setString(info.effect1can2)
    self:getChildByName("ScrollView"):getChildByName("trainBlock"):getChildByName("Image_110"):getChildByName("trainLv"):setString("Lv."..info.nowLevel)
    local per = info.nowLuck/info.MaxLuck *100
    self:getChildByName("ScrollView"):getChildByName("trainBlock"):getChildByName("Image_106_0"):getChildByName("luckBar"):setPercent(per)
    if dd.cfgEffect[info.effect2id] ~= nil then
        self:getChildByName("ScrollView"):getChildByName("td01"):getChildByName("Label_91_0_1"):setString(ff.langString(dd.cfgEffect[info.effect2id]['name']))
        self:getChildByName("ScrollView"):getChildByName("td02"):getChildByName("Label_91_0_1"):setString(info.effect2can1)
        self:getChildByName("ScrollView"):getChildByName("td03"):getChildByName("Label_91_0_1"):setString(info.effect2can2)
    else
        self:getChildByName("ScrollView"):getChildByName("td01"):getChildByName("Label_91_0_1"):setString("")
        self:getChildByName("ScrollView"):getChildByName("td02"):getChildByName("Label_91_0_1"):setString("")
        self:getChildByName("ScrollView"):getChildByName("td03"):getChildByName("Label_91_0_1"):setString("")
    end
end



function TrainingRoomLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("TrainingRoom")
		if widget == nil then
			return
		end
        if widget:getChildByName("pop"):isVisible() == true then
            widget:getChildByName("pop"):setVisible(false)
            return
        end
        if widget:getChildByName("besure"):isVisible() == true then
            widget:getChildByName("besure"):setVisible(false)
            return
        end
        pop.onClosePopDialog("TrainingRoom")
    end
end

function TrainingRoomLayer.onEnd( sender )
    dd.delBackEvent()
    ff.net:removeEvent(1,dd.Tjf_TrainingRoomAction)
    ff.net:unbindProperty("gold",2340)
    sender:stopAllActions()
end

function onShowTrainingRoom(widget)
	-- body
	local layer = TrainingRoomLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end

function TrainingRoomLayer:OnTrainingRoomAction(infos)
    if infos[1] == 0 then
        self.info = infos[2]
        self:refreshUI(self.info)
        if self.info.type == 1 then
            if self.info.itemGet == 10 then
                local label = cc.Label:create()
                local function remove(sender,param)
                    sender:removeFromParent(true)
                end
                label:setSystemFontSize(30)
                label:setString("10")
                label:setAnchorPoint(cc.p(0.5,0.5))
                label:setPosition(cc.p(ff.width/2,ff.height/2 - 100))
                label:setColor(cc.c3b(255,255,255) )
                label:enableOutline(cc.c4b(0,0,0,255),3)

                local action2 = cc.Spawn:create(
                    cc.FadeOut:create(0.5),
                    cc.MoveTo:create(0.5,cc.p(ff.width/2,ff.height/2 + 100))
                )        
                local action1 = cc.Spawn:create(
                    cc.FadeIn:create(0.5),
                    cc.EaseOut:create(cc.MoveTo:create(0.5,cc.p(ff.width/2,ff.height/2)),0.5)
                )        

                label:runAction(cc.Sequence:create(action1,cc.DelayTime:create(0.2),action2,cc.CallFunc:create(remove)))
                self:addChild(label)
            else
                local label = cc.Label:create()
                local function remove(sender,param)
                    sender:removeFromParent(true)
                end
                label:setSystemFontSize(30)
                if self.info.itemGet == 20 then
                    label:setString(ff.langString("暴击").."10*2")
                    label:setColor(cc.c3b(6,255,0) )
                elseif self.info.itemGet == 30 then
                    label:setString(ff.langString("大暴击").."10*3")
                    label:setColor(cc.c3b(0,228,255) )
                else
                    label:setString(ff.langString("特大暴击").."10*5")
                    label:setColor(cc.c3b(132,0,225) )
                end
                
                label:setAnchorPoint(cc.p(0.5,0.5))
                label:setPosition(cc.p(ff.width/2,ff.height/2 - 100))
                
                label:enableOutline(cc.c4b(0,0,0,255),3)

                local action2 = cc.Spawn:create(
                    cc.FadeOut:create(0.5),
                    cc.MoveTo:create(0.5,cc.p(ff.width/2,ff.height/2 + 100))
                )        
                local action1 = cc.Spawn:create(
                    cc.FadeIn:create(0.5),
                    cc.EaseOut:create(cc.MoveTo:create(0.5,cc.p(ff.width/2,ff.height/2)),0.5)
                )        

                label:runAction(cc.Sequence:create(action1,cc.DelayTime:create(0.2),action2,cc.CallFunc:create(remove)))
                self:addChild(label)
            end
            -- dd.mainUI:onShowTips(ff.langString("军事学院等级不足"))
        elseif self.info.type == 2 then
            if self.info.nowLuck == 0 then
                dd.mainUI:onShowTips(ff.langString("捐献大成功，特训室升级，幸运值清零"),true)
            else
                dd.mainUI:onShowTips(ff.langString("捐献成功，幸运值+10"),true)
            end
        end
    end
end

function TrainingRoomLayer.onBefore( sender)
    sender:getChildByName("ScrollView"):getChildByName("speedArea"):getChildByName("Image_97"):getChildByName("speedCD"):setString("")
    sender:getChildByName("ScrollView"):getChildByName("speedArea"):getChildByName("Image_97"):getChildByName("speedBar"):setPercent(0)
    ff.net:registerEvent(1,dd.Tjf_TrainingRoomAction, function (message) sender:OnTrainingRoomAction(message) end)
    local message = ff.net:createMessage()
    message:addCmd(0x0000014e)
    message:addLong(dd.uid)         
    for i=1,6 do
        message:addLong(0)
    end
    
    ff.net:rpc(message, false)
end

function TrainingRoomLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("TrainingRoom")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end