local bankpopLayer = class("bankpopLayer")
bankpopLayer._name = "bankpopLayer"
bankpopLayer._init = false 
bankpopLayer._jjType = 1 
bankpopLayer._Cfg_growthFund = {}
bankpopLayer._lv = 0

function bankpopLayer.extend( target )
	local b = tolua.getpeer(target)
	if not b then
		b = {}
		tolua.setpeer(target,b)
	end
	setmetatable(b,bankpopLayer)
	return target
end

function onShowBankPop( widget)
	local layer = bankpopLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
	layer:onInit()
	return layer
end

function bankpopLayer:onInit(  )
	
    if self._init == false then
    	
		self:onAutoSize()

    	self._init = true
    end
    self:initDate()
    
end

function bankpopLayer:initDate(  )
	local propData1 = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_growthfund`  ORDER BY `type` ASC")
    for i=1, propData1:rowCount() do
        local type = tonumber(propData1:getString(i, "type"))
        self._Cfg_growthFund[type] = {}
        self._Cfg_growthFund[type]['banklv']   = tonumber(propData1:getString(i, "lv"))
        self._Cfg_growthFund[type]['gold'] = tonumber(propData1:getString(i, "gold"))
        self._Cfg_growthFund[type]['sum'] = tonumber(propData1:getString(i, "sum"))
        self._Cfg_growthFund[type]['hqlv1'] = tonumber(propData1:getString(i, "hqlv1"))
        self._Cfg_growthFund[type]['hqlv2'] = tonumber(propData1:getString(i, "hqlv2"))
        self._Cfg_growthFund[type]['hqlv3'] = tonumber(propData1:getString(i, "hqlv3"))
        self._Cfg_growthFund[type]['hqlv4'] = tonumber(propData1:getString(i, "hqlv4"))
        self._Cfg_growthFund[type]['reward1'] = propData1:getString(i, "reward1")
        self._Cfg_growthFund[type]['reward2'] = propData1:getString(i, "reward2")
        self._Cfg_growthFund[type]['reward3'] = propData1:getString(i, "reward3")
        self._Cfg_growthFund[type]['reward4'] = propData1:getString(i, "reward4")
    end
    propData1:clear()
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"bid") == 35 then
            self._lv = dd.mybuilds:getLong(i,"level")
            break
        end
    end
end

function bankpopLayer.buyJJ(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then 

        local widget = pop.getDialog("bankpop") 

        if widget._lv < widget._Cfg_growthFund[widget._jjType]['banklv'] then
            pop.onClosePopDialog("bankpop")
            local function sure(  )
                local pos = 0
                for i=1,dd.mybuilds:rowCount() do
                    if dd.mybuilds:getLong(i,"bid") == 35 then
                        pos = dd.mybuilds:getLong(i,"pos")
                        break
                    end
                end
                
                local param1 = 0
                local param2 = 0
                cclog("showUpdateBuilding:"..pos..",param1:"..param1)
                if dd.currentLayer._building ~= nil then
                    local build = dd.currentLayer._building:getChildByTag(pos)
                    local x = dd.cfgPos[pos]['x']
                    local y = 2208- dd.cfgPos[pos]['y']
                    --301 : 城墙 --101 ：司令部
                    if pos == 301 then
                        x = 2000
                        y = 1000
                    end

                    if param1 == 0 or param1 == 1 then
                        dd._saveparam = {pos,nil,param2}
                    else
                        dd._saveparam = {pos,2,param2}
                    end
                    dd.currentLayer:runAction(
                        cc.Sequence:create(
                            cc.CallFunc:create(function() dd.MoveMapPointToScreenCenter(cc.p(x,y),1,pos) end),
                            cc.DelayTime:create(0.5),
                            cc.CallFunc:create(function() 
                                                            build:flash(true) 
                                                       end))
                    )
                end
            end
            dd.mainUI:onShowSure(ff.langString("银行等级不足"),ff.langString("购买基金需要升级银行，是否前往？"),sure,false,2)
            return
        end
        local message = ff.net:createMessage()
        message:addCmd(0x00000133)
        message:addLong(dd.uid)
        message:addLong(widget._jjType)
        ff.net:rpc(message,false)      
     

        pop.onClosePopDialog("bankpop")
    end
end

function bankpopLayer:updatePopInfo(  )
    local view = self:getChildByName("pop"):getChildByName("view")
    if self._jjType == 1 then
        view:getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("初级成长基金"))
        view:getChildByName("info"):getChildByName("icon"):loadTexture(dd.getPathFromUI("bank_1.png",1))
        view:getChildByName("info"):getChildByName("count"):setString(self._Cfg_growthFund[1]['sum'])

        view:getChildByName("info"):getChildByName("need"):setString(ff.langString("需要银行LV.{0}",{self._Cfg_growthFund[1]['banklv']}))
        if self._lv >= self._Cfg_growthFund[1]['banklv'] then
            view:getChildByName("info"):getChildByName("need"):setColor(cc.c3b(7,159,0))
        else
            view:getChildByName("info"):getChildByName("need"):setColor(cc.c3b(237,101,101))
        end
        view:getChildByName("infoex"):getChildByName("tiao1"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[1]['hqlv1']}))
        view:getChildByName("infoex"):getChildByName("tiao2"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[1]['hqlv2']}))
        view:getChildByName("infoex"):getChildByName("tiao3"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[1]['hqlv3']}))
        view:getChildByName("infoex"):getChildByName("tiao4"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[1]['hqlv4']}))
        
        local gift = Split(self._Cfg_growthFund[1]['reward1'],'%^')
        view:getChildByName("infoex"):getChildByName("cost1"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[1]['reward2'],'%^')
        view:getChildByName("infoex"):getChildByName("cost2"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[1]['reward3'],'%^')
        view:getChildByName("infoex"):getChildByName("cost3"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[1]['reward4'],'%^')
        view:getChildByName("infoex"):getChildByName("cost4"):setString(gift[3])

            
        view:getChildByName("infoex"):getChildByName("tiao1"):setColor(cc.c3b(255,195,0))
    
        view:getChildByName("infoex"):getChildByName("tiao2"):setColor(cc.c3b(255,195,0))
    
        view:getChildByName("infoex"):getChildByName("tiao3"):setColor(cc.c3b(255,195,0))
    
        view:getChildByName("infoex"):getChildByName("tiao4"):setColor(cc.c3b(255,195,0))
    

        for i=1,dd.myGrowthFund:rowCount() do
            if dd.myGrowthFund:getLong(i,"type") == 1 then
                if dd.myGrowthFund:getLong(i,"state") > 99 then
                    local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                    view:getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    view:getChildByName("pay"):getChildByName("info1"):setVisible(true) 
                    view:getChildByName("pay"):getChildByName("info2"):setVisible(false) 
                    view:getChildByName("pay"):setTag(1)
                    view:getChildByName("pay"):getChildByName("info1"):getChildByName("sell"):setString(self._Cfg_growthFund[1]['gold'])
                else
                    
                    view:getChildByName("title"):getChildByName("time"):setString("")
                   
                    view:getChildByName("pay"):getChildByName("info1"):setVisible(false) 
                    view:getChildByName("pay"):getChildByName("info2"):setVisible(true) 
                    view:getChildByName("pay"):setTag(2)
                end
                break
            end
        end
        
    elseif self._jjType == 2 then
        view:getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("中级成长基金"))
        view:getChildByName("info"):getChildByName("icon"):loadTexture(dd.getPathFromUI("bank_2.png",1))
        view:getChildByName("info"):getChildByName("count"):setString(self._Cfg_growthFund[2]['sum'])
        view:getChildByName("info"):getChildByName("need"):setString(ff.langString("需要银行LV.{0}",{self._Cfg_growthFund[2]['banklv']}))
        if self._lv >= self._Cfg_growthFund[2]['banklv'] then
            view:getChildByName("info"):getChildByName("need"):setColor(cc.c3b(7,159,0))
        else
            view:getChildByName("info"):getChildByName("need"):setColor(cc.c3b(237,101,101))
        end
        view:getChildByName("infoex"):getChildByName("tiao1"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[2]['hqlv1']}))
        view:getChildByName("infoex"):getChildByName("tiao2"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[2]['hqlv2']}))
        view:getChildByName("infoex"):getChildByName("tiao3"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[2]['hqlv3']}))
        view:getChildByName("infoex"):getChildByName("tiao4"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[2]['hqlv4']}))
        
        local gift = Split(self._Cfg_growthFund[2]['reward1'],'%^')
        view:getChildByName("infoex"):getChildByName("cost1"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[2]['reward2'],'%^')
        view:getChildByName("infoex"):getChildByName("cost2"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[2]['reward3'],'%^')
        view:getChildByName("infoex"):getChildByName("cost3"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[2]['reward4'],'%^')
        view:getChildByName("infoex"):getChildByName("cost4"):setString(gift[3])
        for i=1,dd.myGrowthFund:rowCount() do
            if dd.myGrowthFund:getLong(i,"type") == 2 then
                if dd.myGrowthFund:getLong(i,"state") > 99 then
                    local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                    view:getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    view:getChildByName("pay"):getChildByName("info1"):setVisible(true) 
                    view:getChildByName("pay"):getChildByName("info2"):setVisible(false) 
                    view:getChildByName("pay"):setTag(1)
                    view:getChildByName("pay"):getChildByName("info1"):getChildByName("sell"):setString(self._Cfg_growthFund[2]['gold'])
                else
                    
                    view:getChildByName("title"):getChildByName("time"):setString("")
                
                    view:getChildByName("pay"):getChildByName("info1"):setVisible(false) 
                    view:getChildByName("pay"):getChildByName("info2"):setVisible(true) 
                    view:getChildByName("pay"):setTag(2)
                end
                break
            end
        end
    elseif self._jjType == 3 then
        view:getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("高级成长基金"))
        view:getChildByName("info"):getChildByName("icon"):loadTexture(dd.getPathFromUI("bank_3.png",1))
        view:getChildByName("info"):getChildByName("count"):setString(self._Cfg_growthFund[3]['sum'])
        view:getChildByName("info"):getChildByName("need"):setString(ff.langString("需要银行LV.{0}",{self._Cfg_growthFund[3]['banklv']}))
        if self._lv >= self._Cfg_growthFund[3]['banklv'] then
            view:getChildByName("info"):getChildByName("need"):setColor(cc.c3b(7,159,0))
        else
            view:getChildByName("info"):getChildByName("need"):setColor(cc.c3b(237,101,101))
        end
        view:getChildByName("infoex"):getChildByName("tiao1"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[3]['hqlv1']}))
        view:getChildByName("infoex"):getChildByName("tiao2"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[3]['hqlv2']}))
        view:getChildByName("infoex"):getChildByName("tiao3"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[3]['hqlv3']}))
        view:getChildByName("infoex"):getChildByName("tiao4"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[3]['hqlv4']}))
        
        local gift = Split(self._Cfg_growthFund[3]['reward1'],'%^')
        view:getChildByName("infoex"):getChildByName("cost1"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[3]['reward2'],'%^')
        view:getChildByName("infoex"):getChildByName("cost2"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[3]['reward3'],'%^')
        view:getChildByName("infoex"):getChildByName("cost3"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[3]['reward4'],'%^')
        view:getChildByName("infoex"):getChildByName("cost4"):setString(gift[3])
        for i=1,dd.myGrowthFund:rowCount() do
            if dd.myGrowthFund:getLong(i,"type") == 3 then
                if dd.myGrowthFund:getLong(i,"state") > 99 then
                    local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                    view:getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    view:getChildByName("pay"):getChildByName("info1"):setVisible(true) 
                    view:getChildByName("pay"):getChildByName("info2"):setVisible(false) 
                    view:getChildByName("pay"):setTag(1)
                    view:getChildByName("pay"):getChildByName("info1"):getChildByName("sell"):setString(self._Cfg_growthFund[3]['gold'])
                else
                    
                    view:getChildByName("title"):getChildByName("time"):setString("")

                    view:getChildByName("pay"):getChildByName("info1"):setVisible(false) 
                    view:getChildByName("pay"):getChildByName("info2"):setVisible(true) 
                    view:getChildByName("pay"):setTag(2)
                end
                break
            end
        end
    end
end

function bankpopLayer:onBuy(params)
    local code = params[1]
    if code == 0 then      
        self:updatePopInfo()
        --dd.currentLayer._widget:onShowTips("\t"..ff.langString("购买成功"),true)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function bankpopLayer:autoOpen(  )
   for i=1,dd.myGrowthFund:rowCount() do
           
        if dd.myGrowthFund:getLong(i,"type") == 1 and dd.myGrowthFund:getLong(i,"state") ~= -1 then
            
            if dd.myGrowthFund:getLong(i,"state") > 99 then
                self._jjType =1 
            end
        elseif  dd.myGrowthFund:getLong(i,"type") == 2 and dd.myGrowthFund:getLong(i,"state") ~= -1 then
            
            if dd.myGrowthFund:getLong(i,"state") > 99 then
                self._jjType =2 
            end
        elseif  dd.myGrowthFund:getLong(i,"type") == 3 and dd.myGrowthFund:getLong(i,"state") ~= -1 then
            
            if dd.myGrowthFund:getLong(i,"state") > 99 then
                self._jjType =3
            end
        end
    end
end

function bankpopLayer.onStart( sender )
    schedule(sender, sender.update,1)
end

function bankpopLayer.onBefore( sender )
    -- body
    ff.net:registerEvent(2,dd.Tjf_ActiveGrowthFund, function (message)sender:onBuy(message)end)
    sender:autoOpen()
    sender:updatePopInfo()
end

function bankpopLayer:onAutoSize(  )
	local hh = ff.height
	self:setContentSize(cc.size(720,hh))
    self:getChildByName("mask"):setContentSize(cc.size(720,hh))
    self:getChildByName("pop"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onReturn)
    self:getChildByName("pop"):getChildByName("view"):getChildByName("pay"):addTouchEventListener(self.buyJJ)
    local h = hh/2 - 360
    self:getChildByName("pop"):setPositionY(h )
    self:getChildByName("mask"):setPositionY(0 )
end


function bankpopLayer.onReturn( sender,eventType )
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("bankpop")
            if widget == nil then
                return
            end
        pop.onClosePopDialog("bankpop")
    end
end


function bankpopLayer.onEnd( sender )
	-- body
    dd.delBackEvent()
    sender:stopAllActions()
    if ff.platform ~= 1 then
        sender:getChildByName("pop"):getChildByName("view"):
            getChildByName("info"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
    ff.net:removeEvent(2,dd.Tjf_ActiveGrowthFund)
end


function bankpopLayer.update( sender )
    
        local item1 = sender:getChildByName("pop"):getChildByName("view"):getChildByName("title")
        if sender._jjType == 1 then
            
            for i=1,dd.myGrowthFund:rowCount() do
                if dd.myGrowthFund:getLong(i,"type") == 1 then
                    if dd.myGrowthFund:getLong(i,"state") > 99 then
                        local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                        item1:getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    else
                        item1:getChildByName("time"):setString("") 
                    end
                    break
                end
            end
            
        elseif sender._jjType == 2 then
           
            for i=1,dd.myGrowthFund:rowCount() do

                if dd.myGrowthFund:getLong(i,"type") == 2 then
                    if dd.myGrowthFund:getLong(i,"state") > 99 then
                       local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                        item1:getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    else
                        item1:getChildByName("time"):setString("") 
                    end
                    break
                end
            end
        elseif sender._jjType == 3 then
           
            for i=1,dd.myGrowthFund:rowCount() do
                if dd.myGrowthFund:getLong(i,"type") == 3 then
                    if dd.myGrowthFund:getLong(i,"state") > 99 then
                       local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                        item1:getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    else
                        item1:getChildByName("time"):setString("") 
                    end
                    break
                end
            end
        end
    
end