--晶体升级dd.cfgCrystal
local crystalUpLayer = class("crystalUp")
crystalUpLayer._name = "crystalUp"
crystalUpLayer._init = false
crystalUpLayer._selectTone = 1  --品质(自动选择的) 
crystalUpLayer._citems = {}     --晶体item表

crystalUpLayer._selectcrys = {0,0,0,0,0,0,0}    --最后一个吞噬  其他被吞噬  id 应为配置id
crystalUpLayer._crypos = 0                      --点击的index
crystalUpLayer._cryid = 0                       --选中的晶体id

crystalUpLayer._inProgress = false

crystalUpLayer._expUp    = false
crystalUpLayer._oldLevel = 0

function crystalUpLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, crystalUpLayer)
    return target
end

function crystalUpLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("masking"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("masking"):setPositionY(0)
        
        self:getChildByName("bg"):setContentSize(cc.size(720,hh))
        self:getChildByName("bg"):setPositionY(0)
        
        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("mainArea"):setContentSize(cc.size(720, hh - 105))
        self:getChildByName("mainArea"):setPositionY(0)
        self:getChildByName("mainArea"):getChildByName("sums"):setPositionY(hh - 105 - 55 )
        
        
        self:getChildByName("mainArea"):getChildByName("list"):setContentSize(cc.size(720, hh - 105 - 160 - 58))
        self:getChildByName("mainArea"):getChildByName("list"):requestRefreshView()        
        
    end
end

function crystalUpLayer:onInit()
    if self._init == false then        
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3)
        --自动选择
        local function onAuto(sender,eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then    
                doaction = true
            end
            if doaction == true then
                local cid = self:getCrystalCid(self._selectcrys[7])
                if cid == 0 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("请选择要升级晶体"))
                elseif dd.cfgCrystal[cid]["color"] < self._selectTone then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("不能吞噬更高品质的晶体"))
                else
                    self:clearPos(1)
                    self:autoSelect(self._selectTone)
                    self:updateInfo()
                    if self:getIndex() == 1 then
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有符合条件的晶体"))
                    end
                end
            end          
        end
        --升级(吞噬)
        local function onUp(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if self._selectcrys[7] == 0 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("请添加需要升级的晶体"))
                elseif self:isEmpty() == true then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("请添加需要被吞噬的晶体"))
                else
                    self._oldLevel = self:getCrystalLevel(self._selectcrys[7])
                    self:toUp()
                end
            end            
        end
        --品质选择
        local function onSelectTone(sender,eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then    
                doaction = true
            end
            if doaction == true then
                self:unSelect()
                if sender:getSelectedState() == true then
                    return
                end 
                if sender:getName() == "checkbox1" then
                    self._selectTone = 1
                elseif sender:getName() == "checkbox2" then
                    self._selectTone = 2
                elseif sender:getName() == "checkbox3" then
                    self._selectTone = 3
                elseif sender:getName() == "checkbox4" then
                    self._selectTone = 4
                end
                local mid = self:getCrystalCid(self._selectcrys[7])
                if mid ~= 0 then
                    if dd.cfgCrystal[mid]["color"] < self._selectTone then
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("不能吞噬更高品质的晶体"))
                    end
                else
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("请选择要升级晶体"))
                end
            end
        end
        --点击晶体槽
        local function onClickCrybox(sender,eventType)  
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then    
                doaction = true
            end
            if doaction == true then
                if sender:getName() == "goal" then
                    self._crypos = 7
                    self:updates()
                    if self._cryid ~= 0 then    --有晶体
                        self.openPop()
                    else
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有符合条件的晶体"))
                    end
                else
                    if self._selectcrys[7] ~= 0 then
                        if sender:getName() == "cry1" then
                            self._crypos = 1
                        elseif sender:getName() == "cry2" then
                            self._crypos = 2
                        elseif sender:getName() == "cry3" then
                            self._crypos = 3
                        elseif sender:getName() == "cry4" then
                            self._crypos = 4
                        elseif sender:getName() == "cry5" then
                            self._crypos = 5
                        elseif sender:getName() == "cry6" then
                            self._crypos = 6
                        end
                        self:updates()
                        if self._cryid ~= 0 then    --有晶体
                            self.openPop()
                        else
                            dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有符合条件的晶体"))
                        end
                    else
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("请选择要升级晶体"))
                    end
                end
            end
        end 
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
        self:getChildByName("mainArea"):getChildByName("bottom"):getChildByName("up"):addTouchEventListener(onUp)
        --加粗
        self:getChildByName("pop"):getChildByName("bline"):getChildByName("chu_name"):getVirtualRenderer():enableBold(true)
        --self:getChildByName("mainArea"):getChildByName("sums"):getChildByName("Label_108"):getVirtualRenderer():enableBold(true)
        --self:getChildByName("mainArea"):getChildByName("sums"):getChildByName("tip"):getVirtualRenderer():enableBold(true)
        self:getChildByName("mainArea"):getChildByName("sums"):getChildByName("value"):getVirtualRenderer():enableBold(true)
        self:getChildByName("mainArea"):getChildByName("list"):getChildByName("top"):getChildByName("name"):getChildByName("name"):getVirtualRenderer():enableBold(true)
        
        local top = self:getChildByName("mainArea"):getChildByName("list"):getChildByName("top")
        top:getChildByName("auto"):getChildByName("checkbox1"):addTouchEventListener(onSelectTone)
        top:getChildByName("auto"):getChildByName("checkbox2"):addTouchEventListener(onSelectTone)
        top:getChildByName("auto"):getChildByName("checkbox3"):addTouchEventListener(onSelectTone)
        top:getChildByName("auto"):getChildByName("checkbox4"):addTouchEventListener(onSelectTone)  
        top:getChildByName("auto"):getChildByName("autobtn"):addTouchEventListener(onAuto)   
        top:getChildByName("tree"):getChildByName("goal"):addTouchEventListener(onClickCrybox)
        for i=1,6 do
            top:getChildByName("tree"):getChildByName("cry"..i):addTouchEventListener(onClickCrybox)
        end       
        top:getChildByName("auto"):getChildByName("checkbox1"):setSelectedState(true)
        
        self._selectTone = 1        
        self:initPop()       
        self._init = true
    end
    self:checkSpine()
    --self:updates()
    --释放独享图片导致有显示延迟
    self:updateInfo()
    self.updateGold()
end

function crystalUpLayer:initPop()
    local function close(sender, eventType)
        self.closePop(sender, eventType)
    end
    local function clear(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            self._selectcrys[self._crypos] = 0
            self:updateInfo()
            self.closePop(sender, eventType)
        end
    end
    local function select(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            if self._cryid ~= 0 then
                self._selectcrys[self._crypos] = self._cryid
                if self._crypos == 7 then
                    self:clearPos(1)
                end  
                self:updateInfo()
                self.closePop(sender, eventType)
            else
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("未选中晶体"))
            end          
        end    
    end
    self:getChildByName("pop"):getChildByName("close"):addTouchEventListener(close)
    self:getChildByName("pop"):getChildByName("clear"):addTouchEventListener(clear)
    self:getChildByName("pop"):getChildByName("select"):addTouchEventListener(select)
end

function crystalUpLayer:updates()
    self:getChildByName("mainArea"):getChildByName("sums"):getChildByName("value"):setString(dd.myCrystals:rowCount())
    self:updateInfo()
    self:updatePop()
end
function crystalUpLayer.updateGold()
    local widget = pop.getDialog("crystalUp")
    widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
    widget:getChildByName("topArea"):requestDoLayout()

    local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
    w = 720 - (w + 94 + 75 + 104)
    widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
    widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
end
function crystalUpLayer:updateInfo()
    local view = self:getChildByName("mainArea"):getChildByName("list"):getChildByName("top")
    local mid = self:getCrystalCid(self._selectcrys[7])
    if mid == 0 then
        view:getChildByName("tree"):getChildByName("goal"):getChildByName("click"):setVisible(true)
        self:unCrystalIcon()
        view:getChildByName("progress"):getChildByName("progress"):setPercent(0)
        view:getChildByName("name"):getChildByName("name"):setString(ff.langString("请选择要升级晶体"))
        view:getChildByName("progress"):getChildByName("level"):setString("LV.0")
        view:getChildByName("progress"):getChildByName("exp"):setString("0/0")        
        self:showEffectTips(0)        
        for i=1,6 do
            view:getChildByName("tree"):getChildByName("cry"..i):loadTexture(dd.getPathFromUI("cr_box_1.png",1))
            view:getChildByName("tree"):getChildByName("cry"..i):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            view:getChildByName("tree"):getChildByName("cry"..i):getChildByName("exp"):setVisible(false)
        end
        view:getChildByName("tree"):getChildByName("goal"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    else
        local col = dd.cfgCrystal[mid]["color"]        
        local curexp = self:getCrystalExp(self._selectcrys[7])
        local lv = self:getCrystalLevel(self._selectcrys[7])
        local needexp = 99999
        local percent = 0
        local progress = view:getChildByName("progress"):getChildByName("progress")
        if dd.cfgCrystalLevelUp[col][lv + 1]["exp"] ~= nil then
            needexp = dd.cfgCrystalLevelUp[col][lv + 1]["exp"] - curexp
            percent = math.floor(100*curexp/dd.cfgCrystalLevelUp[col][lv + 1]["exp"])
            --进度条
            --progress:setPercent(math.floor(100*curexp/dd.cfgCrystalLevelUp[col][lv + 1]["exp"]))
            view:getChildByName("progress"):getChildByName("exp"):setString(curexp.."/"..dd.cfgCrystalLevelUp[col][lv + 1]["exp"])
        else
            percent = 100
            --progress:setPercent(100)
            view:getChildByName("progress"):getChildByName("exp"):setString(curexp.."/"..(9999999))
        end
        progress:stopAllActions()
        if self._expUp == true then
            dd.myProgressTo(progress,self:getCrystalLevel(self._selectcrys[7]) - self._oldLevel, percent, 2)
        else
            progress:setPercent(percent)
        end
        self._expUp = false
        
        view:getChildByName("name"):getChildByName("name"):setString(ff.langString(dd.cfgCrystal[mid]["name"]))
        view:getChildByName("progress"):getChildByName("level"):setString("LV."..lv)
        
        view:getChildByName("tree"):getChildByName("goal"):getChildByName("click"):setVisible(false)
        view:getChildByName("tree"):getChildByName("goal"):loadTexture(dd.getPathFromUI("cr_box_"..col..".png",1))
        view:getChildByName("tree"):getChildByName("goal"):getChildByName("icon"):loadTexture(dd.getHuizhangIcon(mid),0)
        
        self:showEffectTips(self._selectcrys[7])
        for i=1,6 do
            local cid = self:getCrystalCid(self._selectcrys[i])
            view:getChildByName("tree"):getChildByName("cry"..i):getChildByName("icon"):setPosition(cc.p(74,65))
            view:getChildByName("tree"):getChildByName("cry"..i):getChildByName("exp"):setPosition(cc.p(74,22))
            if cid ~= 0 then
                local color = dd.cfgCrystal[cid]["color"]
                local level = self:getCrystalLevel(self._selectcrys[i])
                local getexp = dd.cfgCrystal[cid]["exp"] + self:getCrystalExp(self._selectcrys[i]) + dd.cfgCrystalLevelUp[color][level]["getexp"]
                view:getChildByName("tree"):getChildByName("cry"..i):loadTexture(dd.getPathFromUI("cr_box_"..color..".png",1))
                view:getChildByName("tree"):getChildByName("cry"..i):getChildByName("exp"):setString("EXP "..getexp)
                view:getChildByName("tree"):getChildByName("cry"..i):getChildByName("exp"):setVisible(true)
                view:getChildByName("tree"):getChildByName("cry"..i):getChildByName("icon"):loadTexture(dd.getHuizhangIcon(cid),0)
                view:getChildByName("tree"):getChildByName("cry"..i):getChildByName("icon"):setVisible(true)
            else
                view:getChildByName("tree"):getChildByName("cry"..i):loadTexture(dd.getPathFromUI("cr_box_1.png",1))
                view:getChildByName("tree"):getChildByName("cry"..i):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                view:getChildByName("tree"):getChildByName("cry"..i):getChildByName("exp"):setVisible(false)
            end
        end
    end
end

function crystalUpLayer:updatePop()
    local pop = self:getChildByName("pop")
    pop:getChildByName("count"):setString(self:getOkCrystalNum())
    if self._crypos == 7 then
        self:setBtnLight(self:getChildByName("pop"):getChildByName("clear"), false)
    else
        self:setBtnLight(self:getChildByName("pop"):getChildByName("clear"), true)
    end
    self:updateList()
    self:updateByCryRow(self._cryid)
end

function crystalUpLayer:updateList()
    local view = self:getChildByName("pop"):getChildByName("clist1")
    local hh = view:getContentSize().height
    local num = self:getOkCrystalNum()   --获取符合条件的晶体
    local row = math.ceil(num/4)
    local count = 1
    local innerhh = 0
    self._cryid = 0
    view:jumpToTop()
    --隐藏items
    for i,v in ipairs(self._citems) do
        if tolua.isnull(v) then
            self._citems = nil
        else
            v:setVisible(false)
            v:setTag(0)
            v:getChildByName("cbox"):setSelectedState(false)
            v:getChildByName("cbox"):setTouchEnabled(true)
        end
    end
    --补足2行 用空格子补
    if row < 2 then
        row = 2
    end
    if row*134 > hh then
        view:setInnerContainerSize(cc.size(720,row*134))
        innerhh = row*134
    else
        view:setInnerContainerSize(cc.size(720,hh))
        innerhh = hh
    end

    for i=1, dd.myCrystals:rowCount() do
        local id = dd.myCrystals:getLong(i,"cid")
        local cid = dd.myCrystals:getLong(i,"id")
        local level = dd.myCrystals:getLong(i,"level")
        local heroid = dd.myCrystals:getLong(i,"heroid")
        local color = dd.cfgCrystal[cid]['color']
        if self:isCondition(self._crypos,i) == true then
            local item = self._citems[count]
            if item == nil then
                item = self:getChildByName("pop"):getChildByName("itemmode"):clone()
                self._citems[count] = item
                view:addChild(item)
            end
            item:setVisible(true)
            item:setPositionX(23 + ((count-1)%4)*175 )
            item:setPositionY(innerhh - 136 - math.floor((count-1)/4)*134 )
            item:getChildByName("box"):loadTexture(dd.getPathFromUI("cr_box_"..color..".png",1))
            item:getChildByName("cbox"):loadTextureBackGroundSelected(
                dd.getPathFromUI("cr_boxon_"..color..".png",1))
            item:getChildByName("cbox"):loadTextureFrontCross(
                dd.getPathFromUI("cr_boxon_"..color..".png",1))
            
            item:getChildByName("icon"):loadTexture(dd.getHuizhangIcon(cid),0)
            --item:getChildByName("level"):setString("LV."..level)
            if self:isOnHero(i) == true then
                item:getChildByName("tag"):setVisible(true)
                item:getChildByName("tag"):loadTexture(dd.getPathFromUI("e_word.png",1))
            else
                item:getChildByName("tag"):setVisible(false)
            end            
            if self._cryid == 0 then
                self._cryid = id
            end            
            item:setTag(id)
            item:getChildByName("cbox"):setTag(id)
            item:getChildByName("cbox"):addTouchEventListener(self.onSelectCry)
            count = count + 1
        end
    end
    --补足2行 用空格子补
    for i=count,8 do
        local item = self._citems[i]
        if item == nil then
            item = self:getChildByName("pop"):getChildByName("itemmode"):clone()
            self._citems[i] = item
            view:addChild(item)
        end
        item:setVisible(true)
        item:setPositionX(23 + ((i-1)%4)*175 )
        item:setPositionY(innerhh - 136 - math.floor((i-1)/4)*134 )
        item:getChildByName("box"):loadTexture(dd.getPathFromUI("cr_box_1.png",1))
        item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        item:getChildByName("tag"):setVisible(false)
        item:getChildByName("cbox"):setTouchEnabled(false)
    end 
    
    if self._cryid ~= 0 then
        local old = self:getChildByName("pop"):getChildByName("clist1"):getChildByTag(self._cryid)
        if old ~= nil then
            old:getChildByName("cbox"):setSelectedState(true)
        end
        self:getChildByName("pop"):getChildByName("nothing"):setVisible(false)
        self:setBtnLight(self:getChildByName("pop"):getChildByName("select"),true)
    else
        self:getChildByName("pop"):getChildByName("nothing"):setVisible(true)
        self:setBtnLight(self:getChildByName("pop"):getChildByName("select"),false)
    end
end

function crystalUpLayer:updateByCryRow(id)
    local row = 0
    self:getChildByName("pop"):getChildByName("clist2"):removeAllChildren(true)
    for i=1, dd.myCrystals:rowCount() do
        if dd.myCrystals:getLong(i,"cid") == id then
            row = i
            break
        end
    end
    if row ~= 0 then
        local tid = dd.myCrystals:getLong(row,"id")   --cfgid
        local curexp = dd.myCrystals:getLong(row,"curexp")
        local level = dd.myCrystals:getLong(row,"level")
        local col = dd.cfgCrystal[tid]["color"] 
        local name = ff.langString(dd.cfgCrystal[tid]['name']) 
        local nextexp = 9999999
        --name
        if dd.myCrystals:getLong(row,"heroid") > 0 then
            for i=1,dd.heros:rowCount() do
                if dd.myCrystals:getLong(row,"heroid") == dd.heros:getLong(i,"hid") then
                    if dd.heros:getString(row,"name") == "" then
                        name = name.."("..ff.langString(dd.cfgHero[dd.heros:getLong(i,"id")]['name'])..")"
                    else
                        name = name.."("..dd.heros:getString(row,"name")..")"
                    end
                    break
                end
            end
        end
        self:getChildByName("pop"):getChildByName("bline"):getChildByName("chu_name"):setString(name)
    
    
        if dd.cfgCrystalLevelUp[col][level + 1]["exp"] ~= nil then
            nextexp = dd.cfgCrystalLevelUp[col][level + 1]["exp"]
        end
        for k=1,2 do
            local param = dd.cfgCrystal[tid]['param'..k]  
            if param > 0 then
                local item = self:getChildByName("pop"):getChildByName("fitem"):clone()
                local value = math.floor(dd.cfgCrystal[tid]['value'..k] + dd.cfgCrystal[tid]['addvalue'..k]*(level-1)/10)
                item:getChildByName("tips"):setString(ff.langString(dd.cfgEffect[param]['name']))
                if tonumber(dd.cfgEffect[param]['tips2']) ~= 0 then
                    item:getChildByName("value"):setString("+"..value..ff.langString(dd.cfgEffect[param]['tips2']))
                else
                    item:getChildByName("value"):setString("+"..value)
                end
                item:setVisible(true)
                self:getChildByName("pop"):getChildByName("clist2"):addChild(item)
            end
        end
        --等级
        local item = self:getChildByName("pop"):getChildByName("fitem"):clone()
        item:getChildByName("tips"):setString("LV."..level..": "..curexp.."/"..nextexp)   
        item:getChildByName("value"):setString("")    
        item:setVisible(true)
        self:getChildByName("pop"):getChildByName("clist2"):addChild(item)
    
        self:getChildByName("pop"):getChildByName("clist2"):requestRefreshView()
        self:setBtnLight(self:getChildByName("pop"):getChildByName("select"),true)
    else
        self:getChildByName("pop"):getChildByName("bline"):getChildByName("chu_name"):setString("")
        self:setBtnLight(self:getChildByName("pop"):getChildByName("select"),false)
    end
end


function crystalUpLayer:showEffectTips(id)
    local view = self:getChildByName("mainArea"):getChildByName("list"):getChildByName("effect")
    view:removeAllChildren(true)
    view:setContentSize(cc.size(720,110))
        
    if id > 0 then
        local cid = self:getCrystalCid(id)
        local str1 = ""
        local str2 = ""       
        local lv = self:getCrystalLevel(id)
        local param1 = dd.cfgCrystal[cid]['param1']   --效果id
        local value = dd.cfgCrystal[cid]['value1']
        local value1 = math.floor(value + dd.cfgCrystal[cid]['addvalue1']*(lv-1)/10)
        local value2 = math.floor(value + dd.cfgCrystal[cid]['addvalue1']*(lv)/10)
        value1 = value1/dd.cfgEffect[param1]['value']
        value2 = value2/dd.cfgEffect[param1]['value']
        
        --本级效果
        local item = self:getChildByName("item"):clone()
        view:addChild(item)
        item:getChildByName("tips"):setString(ff.langString("当前效果")..":"..ff.langString(dd.cfgEffect[param1]['name']))
        item:getChildByName("value"):setString(value1)
        
        if tonumber(dd.cfgEffect[param1]['tips2']) ~= 0 then
            item:getChildByName("value"):setString("+"..value1..ff.langString(dd.cfgEffect[param1]['tips2']))
        else
            item:getChildByName("value"):setString("+"..value1)
        end
        item:setVisible(true)
        item:setPositionX(0)
        item:setPositionY(110 - 50)
        --下级效果
        local item2 = self:getChildByName("item"):clone()
        view:addChild(item2)
        item2:getChildByName("tips"):setString(ff.langString("下级效果")..":"..ff.langString(dd.cfgEffect[param1]['name']))
        
        if tonumber(dd.cfgEffect[param1]['tips2']) ~= 0 then
            item2:getChildByName("value"):setString("+"..value2..ff.langString(dd.cfgEffect[param1]['tips2']))
        else
            item2:getChildByName("value"):setString("+"..value2)
        end
        item2:setVisible(true)
        item2:setPositionX(0)
        item2:setPositionY(110 - 100)
    else
        --本级效果
        local item = self:getChildByName("item"):clone()
        view:addChild(item)
        item:getChildByName("tips"):setString("")
        item:getChildByName("value"):setString("")
        item:setVisible(true)
        item:setPositionX(0)
        item:setPositionY(110 - 50)
        --下级效果
        local item2 = self:getChildByName("item"):clone()
        view:addChild(item2)
        item2:getChildByName("tips"):setString("")
        item2:getChildByName("value"):setString("")
        item2:setVisible(true)
        item2:setPositionX(0)
        item2:setPositionY(110 - 100)
    end
    self:getChildByName("mainArea"):getChildByName("list"):requestRefreshView() 
end

function crystalUpLayer:autoSelect(color)
    if color > 0 then
        self:autoSelectByColor(color)
    end  
end

function crystalUpLayer:autoSelectByColor(color)
    --先搜索exp
    for i=1, dd.myCrystals:rowCount() do
        local id = dd.myCrystals:getLong(i,"cid")
        local cid = dd.myCrystals:getLong(i,"id")
        if dd.cfgCrystal[cid]["expcrystal"] == 1 then
            local index = self:getIndex()
            if index > 0 then
                self._selectcrys[index] = id
            else
                break
            end
        end
    end
    --从一开始
    local function select(tocolor,color)
        for i=1, dd.myCrystals:rowCount() do
            local id = dd.myCrystals:getLong(i,"cid")
            local cid = dd.myCrystals:getLong(i,"id")
            if dd.cfgCrystal[cid]["color"] == tocolor and self:getCrystalLevel(id)== 1 
                and self:getCrystalExp(id)== 0 and self:isOnbox(id) == false and dd.myCrystals:getLong(i,"heroid")==0 then
                local index = self:getIndex()
                if index > 0 then
                    self._selectcrys[index] = id
                else
                    break
                end
            end
        end
        tocolor = tocolor + 1 
        if tocolor <= color then
            select(tocolor,color)
        end 
    end
    select(1,color)
end

function crystalUpLayer:unCrystalIcon()
    local tree = self:getChildByName("mainArea"):getChildByName("list"):getChildByName("top"):getChildByName("tree")
    tree:getChildByName("cry1"):loadTexture(dd.getPathFromUI("cr_box_1.png",1))
    tree:getChildByName("cry2"):loadTexture(dd.getPathFromUI("cr_box_1.png",1))
    tree:getChildByName("cry3"):loadTexture(dd.getPathFromUI("cr_box_1.png",1))
    tree:getChildByName("cry4"):loadTexture(dd.getPathFromUI("cr_box_1.png",1))
    tree:getChildByName("cry5"):loadTexture(dd.getPathFromUI("cr_box_1.png",1))
    tree:getChildByName("cry6"):loadTexture(dd.getPathFromUI("cr_box_1.png",1))
    tree:getChildByName("goal"):loadTexture(dd.getPathFromUI("cr_box_1.png",1))
    
    tree:getChildByName("cry1"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    tree:getChildByName("cry2"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    tree:getChildByName("cry3"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    tree:getChildByName("cry4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    tree:getChildByName("cry5"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    tree:getChildByName("cry6"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    tree:getChildByName("goal"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
end

function crystalUpLayer:unSelect()
    local box = self:getChildByName("mainArea"):getChildByName("list"):getChildByName("top"):getChildByName("auto")
    box:getChildByName("checkbox1"):setSelectedState(false)
    box:getChildByName("checkbox2"):setSelectedState(false)
    box:getChildByName("checkbox3"):setSelectedState(false)
    box:getChildByName("checkbox4"):setSelectedState(false)
end
--按钮灰亮
function crystalUpLayer:setBtnLight(node, light)
    if light == true then
        node:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        node:setTouchEnabled(true)
        node:getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
    else 
        local effect = ff.Effect:effectGrey()    
        node:getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        node:setTouchEnabled(false)
        node:getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
    end
end
-- 0全部清除      1清除被吞噬槽位
function crystalUpLayer:clearPos(tag)
    if tag == 0 then
        for i=1,7 do
            self._selectcrys[i] = 0
        end
    elseif tag == 1 then
        for i=1,6 do
            self._selectcrys[i] = 0
        end
    end
end

function crystalUpLayer.onSelectCry(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            sender:setSelectedState(true)
            local widget = pop.getDialog("crystalUp")
            if widget._cryid ~= sender:getTag() then
                local old = widget:getChildByName("pop"):getChildByName("clist1"):getChildByTag(widget._cryid)
                if old ~= nil then
                    old:getChildByName("cbox"):setSelectedState(false)
                end
                widget._cryid = sender:getTag()
                widget:updateByCryRow(widget._cryid)
            end
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
        local widget = pop.getDialog("crystalUp")
        local old = widget:getChildByName("pop"):getChildByName("clist1"):getChildByTag(widget._cryid)
        if old ~= nil then
            old:getChildByName("cbox"):setSelectedState(false)
        end
        widget._cryid = sender:getTag()
        widget:updateByCryRow(widget._cryid)
    end
    if doaction == true then
    end 
end

function crystalUpLayer:getMyCrystalsInfo()
    local message = ff.net:createMessage()
    message:addCmd(0x044)
    message:addLong(dd.uid)
    ff.net:rpc(message, false)
end

function crystalUpLayer:toUp()
    local message = ff.net:createMessage()
    message:addCmd(0x15f)
    message:addLong(dd.uid)
    message:addLong(self._selectcrys[7])
    message:addLong(self._selectcrys[1])
    message:addLong(self._selectcrys[2])
    message:addLong(self._selectcrys[3])
    message:addLong(self._selectcrys[4])
    message:addLong(self._selectcrys[5])
    message:addLong(self._selectcrys[6])
    message:addLong(0)  --预留位置
    message:addLong(0)  --预留位置
    ff.net:rpc(message, false)
end

function crystalUpLayer:isEmpty()
    for i=1,6 do
        if self._selectcrys[i] ~= 0 then
            return false
        end
    end
    return true
end

function crystalUpLayer:isHaveHighColor()
    for i=1,6 do
        if self._selectcrys[i] ~= 0 then
            local tid = self:getCrystalCid(self._selectcrys[i])
            if dd.cfgCrystal[tid]["color"] > 3 then
                return true
            end            
        end
    end
    return false
end

function crystalUpLayer:onCrystalUpgrade(params)
    local code = params[1]
    if code == 0 then
        AudioEngine.playEffect(ff.sounds[212])
        self:playAnimation()
        --dd.currentLayer._widget:onShowTips("\t"..ff.langString("融合成功"),true)
    else
        dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(code))
    end
end
function crystalUpLayer:onGetMyCrystalInfo(params)
    local code = params[1]
    if code == 0 then
        self:updates()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
function crystalUpLayer.closePop(sender,touchEventType)
    local function unShow()
        local widget = pop.getDialog("crystalUp")
        widget:getChildByName("masking"):setVisible(false)
        widget:getChildByName("pop"):setVisible(false)
    end    

    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("crystalUp") 
        widget:getChildByName("masking"):setVisible(false)
        widget:getChildByName("pop"):setVisible(false)
                     
    end
end

function crystalUpLayer.openPop()
    local widget = pop.getDialog("crystalUp") 
    widget:getChildByName("masking"):setVisible(true)
    pop.showPopEffect(12,widget:getChildByName("pop"))
end

function crystalUpLayer:getBags()
    local buildlevel = dd.getBuildLevel(1)
    local bagscount = 25 + math.floor(buildlevel/5)*5
    return bagscount
end

function crystalUpLayer:getCrystalCount(color)
    local count = 0
    for i=1, dd.myCrystals:rowCount() do
        local cid = dd.myCrystals:getLong(i,"id")
        if dd.cfgCrystal[cid]["color"] == color then
            count = count + 1
        end
    end
    return count 
end

function crystalUpLayer:getOkCrystalNum()
    local count = 0
    for i=1, dd.myCrystals:rowCount() do
        if self:isCondition(self._crypos,i) == true then
            count = count + 1
        end
    end
    return count
end

--服务器配置id  获取晶体 cfg id
function crystalUpLayer:getCrystalCid(pid)
    local cid = 0
    if pid == 0 then
        cid = 0
    else
        for i=1, dd.myCrystals:rowCount() do
            local id = dd.myCrystals:getLong(i,"cid")
            if id == pid then
                cid = dd.myCrystals:getLong(i,"id")
                break
            end
        end
    end
    return cid
end
function crystalUpLayer:getCrystalLevel(id)
    local lv = 0
    for i=1, dd.myCrystals:rowCount() do
        if id == dd.myCrystals:getLong(i,"cid") then
            lv = dd.myCrystals:getLong(i,"level")
            break
        end
    end
    return lv
end
function crystalUpLayer:getCrystalExp(id)
    local exp = 0
    for i=1, dd.myCrystals:rowCount() do
        if id == dd.myCrystals:getLong(i,"cid") then
            exp = dd.myCrystals:getLong(i,"curexp")
            break
        end
    end
    return exp
end
--pos 点击槽位
function crystalUpLayer:isCondition(pos,row)  
    local cid = dd.myCrystals:getLong(row,"id")
    local heroid = dd.myCrystals:getLong(row,"heroid")
    local level = dd.myCrystals:getLong(row,"level")
    if pos == 7 then
        if dd.cfgCrystal[cid]["expcrystal"] == 1 then
            return false
        end         
    else
        local mid = self:getCrystalCid(self._selectcrys[7])
        if mid ~= 0 then
            if dd.cfgCrystal[cid]["expcrystal"] == 1 then
                return true
            end  
        
            if dd.cfgCrystal[cid]["color"] > dd.cfgCrystal[mid]["color"] then
                return false
            end
            --level
            if dd.cfgCrystal[cid]["color"] == dd.cfgCrystal[mid]["color"] and self:getCrystalLevel(self._selectcrys[7]) < level then
                return false
            end
            if heroid ~=0 then
                return false
            end
        end
    end
    if self:isOnbox(dd.myCrystals:getLong(row,"cid")) == true then
        return false
    end
    return true
end
--是否在槽位
function crystalUpLayer:isOnbox(id)
    for i=1,7 do
        if self._selectcrys[i] == id then
            return true
        end
    end
    return false
end
function crystalUpLayer:isOnHero(row)
    if row > 0 then
        if dd.myCrystals:getLong(row,"heroid") ~= 0 then
            return true
        else
            return false    
        end
    else
        return false
    end
end

function crystalUpLayer:getIndex()
    local index = 0
    for i=1,6 do
        if self._selectcrys[i] == 0 then
            index = i
            break
        end
    end
    return index
end

function crystalUpLayer:checkSpine()    
    local top = self:getChildByName("mainArea"):getChildByName("list"):getChildByName("top")
    if top:getChildByTag(101) == nil then
        local animation = sp.SkeletonAnimation:create("images/effect/huizhang/xunzhangshengji.json", "images/effect/huizhang/xunzhangshengji.atlas")
        animation:setAnimation(0,"XZSJ_animation",false)
        animation:setPosition(cc.p(364,291))
        top:addChild(animation,10,101)
        animation:setVisible(false)
    end
end
--播放合成动画
function crystalUpLayer:playAnimation()
    if self._inProgress == false then    
        self._inProgress = true
        local tree = self:getChildByName("mainArea"):getChildByName("list"):getChildByName("top"):getChildByName("tree")
        local anr  = tree:getChildByName("goal"):getChildByName("icon"):getAnchorPoint()
        local size = tree:getChildByName("goal"):getChildByName("icon"):getContentSize()
        local pos  = tree:getChildByName("goal"):getChildByName("icon"):convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标

        for i=1,6 do
            if self._selectcrys[i] ~= 0 then
                local node = tree:getChildByName("cry"..i):getChildByName("icon")
                local exp  = tree:getChildByName("cry"..i):getChildByName("exp")
                node:runAction(cc.Sequence:create(
                    cc.DelayTime:create(0.1)
                    ,cc.CallFunc:create(function() self:playLight(node, true) end)
                    ,cc.DelayTime:create(0.2)
                    ,cc.CallFunc:create(function() self:playMove(0.2, pos, node) self:playMove(0.2, pos, exp) end)
                ))            
            end
        end
        self:playToScal()
    end
end
function crystalUpLayer:actionEnd()
    self._inProgress = false
    if self:getChildByName("mainArea"):getChildByName("list"):getChildByName("top"):getChildByTag(101) ~= nil then
        self:getChildByName("mainArea"):getChildByName("list"):getChildByName("top"):getChildByTag(101):setVisible(false)
        self:clearPos(1) 
        self._expUp = true
        self:updates()
        AudioEngine.playEffect(ff.sounds[604])
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("融合成功"),true)
    end
end
function crystalUpLayer:playMove(time, pos, node)
    local np = node:convertToNodeSpace(pos)
    local oldpos = cc.p(node:getPositionX(),node:getPositionY())
    cclog("x == "..oldpos.x)
    cclog("y == "..oldpos.y)
    node:runAction(cc.Sequence:create( 
                    cc.EaseExponentialIn:create( cc.MoveTo:create(time,np) )
                    ,cc.CallFunc:create(function()
                        node:setPosition(oldpos) 
                        node:setVisible(false) 
                        node:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
                     end)
                    ))
end
function crystalUpLayer:playLight(node, type)
    if type == true then
        node:getVirtualRenderer():setGLProgramState(ff.Effect:effectHighLight():getGLProgramState())
    else
        node:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
    end
end
function crystalUpLayer:playToScal()
    local tree = self:getChildByName("mainArea"):getChildByName("list"):getChildByName("top"):getChildByName("tree")
    local node = tree:getChildByName("goal"):getChildByName("icon")
    local animation = self:getChildByName("mainArea"):getChildByName("list"):getChildByName("top"):getChildByTag(101)
    node:runAction( cc.Sequence:create(
        cc.DelayTime:create(0.35)
        ,cc.CallFunc:create(function()animation:setVisible(true) animation:setAnimation(0,"XZSJ_animation",false) end)
        ,cc.DelayTime:create(0.4)
        ,cc.CallFunc:create(function() self:playLight(node, true) end)
        ,cc.ScaleTo:create(0.1,2)
        ,cc.ScaleTo:create(0.1,1)
        ,cc.CallFunc:create(function() self:playLight(node, false) end)
        ,cc.DelayTime:create(0.4)
        ,cc.CallFunc:create(function() self:actionEnd() end)
    ))
end

function crystalUpLayer:clearActions()
    local tree = self:getChildByName("mainArea"):getChildByName("list"):getChildByName("top"):getChildByName("tree")
    tree:getChildByName("goal"):getChildByName("icon"):stopAllActions()
    for i=1,6 do
        tree:getChildByName("cry"..i):getChildByName("icon"):stopAllActions()
    end
end

--接口
function crystalUpLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("crystalUp")
        if widget ~= nil then
            if widget:getChildByName("pop"):isVisible() == true then
                widget.closePop(sender,ccui.TouchEventType.ended)
                return
            end
            pop.onClosePopDialog("crystalUp")
        end
    end
end

function crystalUpLayer.onStart(sender)
    ff.net:registerEvent(2,dd.Tjf_crystal_upgrade, function (message)sender:onCrystalUpgrade(message)end)
    ff.net:registerEvent(2,dd.Tjf_crystal_info, function (message)sender:onGetMyCrystalInfo(message)end)
    ff.net:bindProperty(2507,"gold",sender.updateGold)
    sender:updates()
end
function crystalUpLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    return true
end
function crystalUpLayer.onEnd(sender)
    dd.delBackEvent()
    ff.net:removeEvent(2,dd.Tjf_crystal_upgrade)
    ff.net:removeEvent(2,dd.Tjf_crystal_info)
    ff.net:unbindProperty("gold",2507)
    sender:clearPos(0)
    if ff.platform ~= 1 then
        for i,item in ipairs(sender._citems) do
            if item then
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("box"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("cbox"):loadTextureBackGroundSelected(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("cbox"):loadTextureFrontCross(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("tag"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end
        for i=1,6 do
            sender:getChildByName("mainArea"):getChildByName("list"):getChildByName("top"):getChildByName("tree"):getChildByName("cry"..i):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            sender:getChildByName("mainArea"):getChildByName("list"):getChildByName("top"):getChildByName("tree"):getChildByName("cry"..i):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        end
        sender:getChildByName("mainArea"):getChildByName("list"):getChildByName("top"):getChildByName("tree"):getChildByName("goal"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("mainArea"):getChildByName("list"):getChildByName("top"):getChildByName("tree"):getChildByName("goal"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
    local animation = sender:getChildByName("mainArea"):getChildByName("list"):getChildByName("top"):getChildByTag(101)
    sender._inProgress = false
    sender:clearActions()
    if animation ~= nil then
        animation:removeFromParent(true)
    end
end

function crystalUpLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("crystalUp")
    if widget ~= nil then
        if widget:getChildByName("pop"):isVisible() == true then
            widget.closePop(sender,ccui.TouchEventType.ended)
            return
        end
        pop.onClosePopDialog("crystalUp")
    end  
end
--徽章服务端id
function onShowCrystalUpLayer(widget,upid)
    local layer = crystalUpLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    if upid then    
        layer._selectcrys[7] = upid
    end
    layer:onAutoSize()
    layer:onInit()
    return layer
end