equipforgeLayer = class("equipforgeLayer")
equipforgeLayer._name = "equipforge"
equipforgeLayer._init = false
equipforgeLayer._page = 0
equipforgeLayer._type = 0
equipforgeLayer._makecgf = {}
equipforgeLayer._equiplist = nil

function equipforgeLayer.extend( target )
	-- body\
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,equipforgeLayer)
	return target
end



function equipforgeLayer.onReturn( sender,eventType )
	-- body
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("equipforge")
        
        if widget then
           	pop.onClosePopDialog("equipforge")
        end
    end
end

function equipforgeLayer:onInit( )
	if self._init == false then
		self:onAutoSize()
        self:InitData()

        self:unselectType()
        self._page = 1
        self._type = 1
        self:getChildByName("topNavi2"):getChildByName("navi01"):setSelectedState(true)
        self:getChildByName("topNavi2"):getChildByName("navi01"):getChildByName("chu_Label"):setColor(cc.c3b(239,223,223))
        self:selectType(self:getChildByName("topNavi2"):getChildByName("type1"))
		self._init = true
	else
        --加新手引导
        if GuideControl.curId >= 7000 and GuideControl.curId <= 7100 then
            self:unselectType()
            self._page = 1
            self._type = 1
            self:getChildByName("topNavi2"):getChildByName("navi01"):setSelectedState(true)
            self:getChildByName("topNavi2"):getChildByName("navi01"):getChildByName("chu_Label"):setColor(cc.c3b(239,223,223))
            self:selectType(self:getChildByName("topNavi2"):getChildByName("type1"))
        end
    end
    self.updateGold()
    --self:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))    
end

function equipforgeLayer:onAutoSize( )
	local hh = ff.height
	self:setContentSize(cc.size(720,hh))
	self:getChildByName("back"):setContentSize(cc.size(720,hh))
    self:getChildByName("back"):setPositionY(0)

	self:getChildByName("top"):setPositionY(hh - 105)
    self:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
    --self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
    --self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("锻造"))

    self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)

    self:getChildByName("topNavi2"):setPositionY(hh - 105 - 85)
    self:getChildByName("mainarea"):setContentSize(cc.size(720,hh - 105 - 85 - 80 - 2))
    self:getChildByName("mainarea"):setPositionY(0)

    self:getChildByName("topNavi2"):getChildByName("navi01"):setTag(1)
    self:getChildByName("topNavi2"):getChildByName("navi02 "):setTag(2)
    self:getChildByName("topNavi2"):getChildByName("navi01"):addTouchEventListener(self.selectpage)
    self:getChildByName("topNavi2"):getChildByName("navi02 "):addTouchEventListener(self.selectpage)
    self:getChildByName("topNavi2"):getChildByName("navi03"):setTag(3)
    self:getChildByName("topNavi2"):getChildByName("navi03"):addTouchEventListener(self.selectpage)

    self:getChildByName("topNavi2"):getChildByName("type1"):setTag(1)
    self:getChildByName("topNavi2"):getChildByName("type2"):setTag(2)
    self:getChildByName("topNavi2"):getChildByName("type3"):setTag(3)
    self:getChildByName("topNavi2"):getChildByName("type1"):addTouchEventListener(self.onSelectType)
    self:getChildByName("topNavi2"):getChildByName("type2"):addTouchEventListener(self.onSelectType)
    self:getChildByName("topNavi2"):getChildByName("type3"):addTouchEventListener(self.onSelectType)

end
function equipforgeLayer.onEnd( sender )
    dd.delBackEvent()
    ff.net:unbindProperty("gold",2303)
end
function equipforgeLayer.onStart( sender )
    ff.net:bindProperty(2303,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
    sender:showEquip()
    schedule(sender,sender.update,1)
end

function equipforgeLayer.updateGold(name,row,old,value)
    --cclog("sdfsdf")
    local sender = pop.getDialog("equipforge")
    if sender ~= nil then
        sender:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("top"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("top"):requestDoLayout()
    end
end

function equipforgeLayer.onSelectType(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("equipforge")
        if widget ~= nil then
            widget._type = sender:getTag()
            widget:selectType()
            widget:showEquip()
            --AudioEngine.playEffect(ff.sounds[107])
        end
    end
end
function equipforgeLayer:selectType(sender)
    self:getChildByName("topNavi2"):getChildByName("type1"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
    self:getChildByName("topNavi2"):getChildByName("type1"):setSelectedState(false)

    self:getChildByName("topNavi2"):getChildByName("type2"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
    self:getChildByName("topNavi2"):getChildByName("type2"):setSelectedState(false)

    self:getChildByName("topNavi2"):getChildByName("type3"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
    self:getChildByName("topNavi2"):getChildByName("type3"):setSelectedState(false)
    if self._type == 1 then
        self:getChildByName("topNavi2"):getChildByName("type1"):getChildByName("chu_label"):setColor(cc.c3b(233, 239, 244))
    elseif self._type == 2 then
        self:getChildByName("topNavi2"):getChildByName("type2"):getChildByName("chu_label"):setColor(cc.c3b(233, 239, 244))
    else
        self:getChildByName("topNavi2"):getChildByName("type3"):getChildByName("chu_label"):setColor(cc.c3b(233, 239, 244))
    end
    if sender ~= nil then
        sender:setSelectedState(true)
    end
end
function equipforgeLayer.selectpage( sender,eventType )
	-- body
	if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("equipforge")
        if widget ~= nil then
            widget:unselectType()
            sender:getChildByName("chu_Label"):setColor(cc.c3b(239,223,223))
            local page  = sender:getTag()
            if widget._page == page then
                return
            else
                widget._page = page
                widget:showEquip()
            end
        end
    end
end

function equipforgeLayer:InitData( )
    self:getChildByName("mainarea"):removeAllChildren(true)
    self:getChildByName("mainarea"):setVisible(true)

    self._equiplist = ff.NetTable:create()
    self._equiplist:addStreamCol("id",ff.NET_LONG)
    self._equiplist:addStreamCol("type",ff.NET_LONG)
    self._equiplist:addStreamCol("level",ff.NET_LONG)
    self._equiplist:addStreamCol("param1",ff.NET_LONG)
    self._equiplist:addStreamCol("param2",ff.NET_LONG)
    self._equiplist:addStreamCol("name",ff.NET_STRING,15)
    self._equiplist:addStreamCol("param3",ff.NET_LONG)
    self._equiplist:addStreamCol("param4",ff.NET_LONG)
    local propData1 = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_equipment_make`  ORDER BY `id` ASC")
    for i=1, propData1:rowCount() do
        local pId = tonumber(propData1:getString(i, "id"))
        self._makecgf[pId] = {}
        self._makecgf[pId]['material1']   = tonumber(propData1:getString(i, "material1"))
        self._makecgf[pId]['material2'] = tonumber(propData1:getString(i, "material2"))
        self._makecgf[pId]['material3'] = tonumber(propData1:getString(i, "material3"))
        self._makecgf[pId]['material4'] = tonumber(propData1:getString(i, "material4"))
        self._makecgf[pId]['silver'] = tonumber(propData1:getString(i, "silver"))
        self._makecgf[pId]['time'] = tonumber(propData1:getString(i, "time"))
    end
    propData1:clear()
end

function equipforgeLayer:unselectType(  )
	self:getChildByName("topNavi2"):getChildByName("navi01"):setSelectedState(false)
    self:getChildByName("topNavi2"):getChildByName("navi02 "):setSelectedState(false)
    self:getChildByName("topNavi2"):getChildByName("navi01"):getChildByName("chu_Label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi2"):getChildByName("navi02 "):getChildByName("chu_Label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi2"):getChildByName("navi03"):setSelectedState(false)
    self:getChildByName("topNavi2"):getChildByName("navi03"):getChildByName("chu_Label"):setColor(cc.c3b(135,89,89))
end



function equipforgeLayer.openMake( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then
        local tag = sender:getTag()
        local widget = pop.getDialog("equipforge")
        if widget ~= nil then
          local id = widget._equiplist:getLong(tag,"id")
          AudioEngine.playEffect(ff.sounds[109])
          pop.onShowPopDialog("equipmake",id)
        end
    end
end

function equipforgeLayer.update( sender )
    -- body
    
    for i=1, sender._equiplist:rowCount() do
        local item =  sender:getChildByName("mainarea"):getChildByTag(i)
        if item ~= nil then
            local can = true
            local needitem = {}
            for j=1,4 do
                if sender._makecgf[sender._equiplist:getLong(i,"type")]['material'..j] > 0 then
                    for m=1,j do
                        if needitem[m] ~= nil then
                            if needitem[m][1] == sender._makecgf[sender._equiplist:getLong(i,"type")]['material'..j] then
                                needitem[m][2] = needitem[m][2] + 1
                                
                                break
                            end
                        else
                            needitem[m] = {sender._makecgf[sender._equiplist:getLong(i,"type")]['material'..j],1}
                            break
                        end
                    end
                end
            end
            
            for k=1,#needitem do
                
                if dd.getToolsByType(needitem[k][1],needitem[k][2]) == false then
                        
                    can = false
                   break
                end
            end
           
            if can then
                item:getChildByName("chu_can"):setString(ff.langString("材料齐全"))
                item:getChildByName("chu_can"):setColor(cc.c3b(0,128,0))
            else
               item:getChildByName("chu_can"):setString(ff.langString("材料不足！"))
               item:getChildByName("chu_can"):setColor(cc.c3b(179,4,24))
            end
            item:getChildByName("chu_can"):getVirtualRenderer():enableBold(true)
            item:requestDoLayout()
        end
    end
end

function equipforgeLayer:showEquip()
    if self._equiplist ~= nil then
        self._equiplist:delRows()
    end
    cclog("type:"..self._type)
    local datas = nil
    if self._page == 1 then
        datas = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_equipment` WHERE `color` = '5' and `place`='"..self._type.."' AND `level` < '41' ORDER BY `level` ASC")
    elseif self._page == 2 then
        datas = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_equipment` WHERE `color` = '5' and `place`='"..self._type.."' AND `level` < '81' AND `level` > '40' ORDER BY `level` ASC")
    elseif self._page == 3 then
        datas = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_equipment` WHERE `color` = '5' and `place`='"..self._type.."' AND `level` > '80' ORDER BY `level` ASC")
    end

    if datas ~= nil then
        local  count = datas:rowCount()
        for i=1, datas:rowCount() do
            if tonumber(datas:getString(i, "type")) < 4000 then
                local index = self._equiplist:addRow()
                self._equiplist:setLong(index,"id",tonumber(datas:getString(i, "id")))

                self._equiplist:setLong(index,"level", tonumber(datas:getString(i, "level")))
                self._equiplist:setLong(index,"pic" ,tonumber(datas:getString(i, "pic")))
                self._equiplist:setLong(index,"type",tonumber(datas:getString(i, "type")))

                self._equiplist:setLong(index,"param1" ,tonumber(datas:getString(i, "param1")))
                self._equiplist:setLong(index,"param2" ,tonumber(datas:getString(i, "param2")))
                self._equiplist:setLong(index,"param3" ,tonumber(datas:getString(i, "param3")))
                self._equiplist:setLong(index,"param4" ,tonumber(datas:getString(i, "param4")))
            end
        end
        datas:clear()
    end
    for i=1,self._equiplist:rowCount() do
        local item =  self:getChildByName("mainarea"):getChildByTag(i)
        if item == nil then
            item = self:getChildByName("item"):clone()
            item:setVisible(true)
            item:setTag(i)
            self:getChildByName("mainarea"):pushBackCustomItem(item)
        end
        item:getChildByName("name"):getVirtualRenderer():enableBold(true)
        item:getChildByName("name"):setString(ff.langString(dd.cfgEquip[self._equiplist:getLong(i,"id")]['name']))
        item:getChildByName("level"):setString(ff.langString("LV.")..self._equiplist:getLong(i,"level"))

        local string = ""
        for j=1,4 do
            local name = "param"..tostring(j)
            if self._equiplist:getLong(i,name) > 0 then
                local id = math.floor(self._equiplist:getLong(i,"id")/10)..1
                local effectid = dd.cfgArms[tonumber(id)]["param"..j]
                local effect = dd.cfgArms[tonumber(id)]['value'..j]
                local effectex  = effect/dd.cfgEffect[dd.cfgArms[tonumber(id)]["param"..j]]['value']
                local value = tostring(effectex)
                local effectid2 = dd.cfgArms[tonumber(self._equiplist:getLong(i,"id"))]["param"..j]
                local effect2 = dd.cfgArms[self._equiplist:getLong(i,"id")]['value'..j]
                local effectex2  = effect2/dd.cfgEffect[dd.cfgArms[self._equiplist:getLong(i,"id")]["param"..j]]['value']
                local value2 = tostring(effectex2)
                --local equipshow = dd.cfgEffect[dd.cfgArms[tonumber(id)]["param"..j]]['equipshow']
                local stringEquipShow = ""
                --if equipshow == 1 then
                --    stringEquipShow = "("..ff.langString("英雄出征时生效")..")"
                --elseif equipshow == 2 then
                --    stringEquipShow = "("..ff.langString("防御部长时生效")..")"
                --elseif equipshow == 4 then
                --    stringEquipShow = "("..ff.langString("内政部长时生效")..")"
                ----elseif equipshow == 8 then
                --  --  stringEquipShow = "("..ff.langString("英雄出征时生效")..")"
                --end

                string = tostring(string) .. ff.langString(dd.cfgEffect[self._equiplist:getLong(i,name)]['tips1'],{"("..value.."-"..value2..")"})..stringEquipShow.."\n"
            end
        end
        local can = true
            local needitem = {}
            for j=1,4 do
                if self._makecgf[self._equiplist:getLong(i,"type")]['material'..j] > 0 then
                    for m=1,j do
                        if needitem[m] ~= nil then
                            if needitem[m][1] == self._makecgf[self._equiplist:getLong(i,"type")]['material'..j] then
                                needitem[m][2] = needitem[m][2] + 1
                                
                                break
                            end
                        else
                            needitem[m] = {self._makecgf[self._equiplist:getLong(i,"type")]['material'..j],1}
                            break
                        end
                    end
                end
            end
            if needitem ~= nil and  table.getn(needitem) > 0 then
                for k=1,#needitem do
                    
                    if dd.getToolsByType(needitem[k][1],needitem[k][2]) == false then
                            
                        can = false
                       break
                    end
                end
            else
                can = false
            end
    
            if can then
                item:getChildByName("chu_can"):setString(ff.langString("材料齐全"))
                item:getChildByName("chu_can"):setColor(cc.c3b(0,128,0))
            else
               item:getChildByName("chu_can"):setString(ff.langString("材料不足！"))
               item:getChildByName("chu_can"):setColor(cc.c3b(179,4,24))
            end
            item:getChildByName("chu_can"):getVirtualRenderer():enableBold(true)
            item:requestDoLayout()

        item:getChildByName("image"):getChildByName("ico"):loadTexture(dd.getArmIcon(self._equiplist:getLong(i,"id")),0)
        item:getChildByName("info"):setString(string)
        item:setVisible(true)
        item:setEnabled(true)
        item:addTouchEventListener(self.openMake)
        item:getChildByName("ok"):setTag(i)
        item:getChildByName("ok"):addTouchEventListener(self.openMake)
    end
    for i=self._equiplist:rowCount(),self:getChildByName("mainarea"):getChildrenCount() do
        if i > self._equiplist:rowCount() then
            self:getChildByName("mainarea"):removeChildByTag(i)
        end
    end
    self:getChildByName("mainarea"):refreshView(true)
    self:getChildByName("mainarea"):scrollToTop(0,false)
end
function onShowEquipForge(widget)
    local layer = equipforgeLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end