--民居
local homeLayer   = class("homeLayer")
homeLayer._name = "homeLayer"
homeLayer._init = false
homeLayer._pos  = 0
homeLayer._bid  = 0
homeLayer._lv  = 0
homeLayer._effect = false
homeLayer.lastUpdate = 0
homeLayer.tick = 0
function homeLayer:onInit()
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"pos") == self._pos then
            self._bid = dd.mybuilds:getLong(i,"bid")
            self._lv = dd.mybuilds:getLong(i,"level")
            break
        end
    end
    if self._lv == 0 then
        self._lv = 1 --刚建造的时候按照1级的数据处理
    end
    local area_1 = self:getChildByName("mainArea"):getChildByName("area_1")
    local area_2 = self:getChildByName("mainArea"):getChildByName("area_2")

    local buildNum = 0
    local train_all = 10
    local pro_all = 0
    local limit_base = 0 
    for var=1, dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(var,"bid") == self._bid then
            buildNum = buildNum + 1
            local lv = dd.mybuilds:getLong(var,"level")
            if lv <= 0 then
                lv = 1
            end
            train_all = train_all + dd.cfgBuildingUp[self._bid][lv]['value3']
            pro_all = pro_all + dd.cfgBuildingUp[self._bid][lv]['value1']
            limit_base = limit_base + dd.cfgBuildingUp[self._bid][lv]['value2']
        end
    end
    area_1:getChildByName("build_num_text"):setString(buildNum)

    local add = 0 
    local limit_add = 0
    local train_add = 0
    for var=1, dd.myeffect:rowCount() do
        if dd.myeffect:getLong(var,'id') == 105 or dd.myeffect:getLong(var,'id') == 515 then
            add = add + dd.myeffect:getLong(var,'param')
        elseif dd.myeffect:getLong(var,'id') == 125 then
            limit_add = dd.myeffect:getLong(var,'param')
        elseif dd.myeffect:getLong(var,'id') == 14 then
            train_add = dd.myeffect:getLong(var,'param')
        end
    end
    local one_train = dd.cfgBuildingUp[self._bid][self._lv]['value3']  + train_add
    local one_train_add = train_add
    local one_train_base = dd.cfgBuildingUp[self._bid][self._lv]['value3']

    area_1:getChildByName("train_num_text"):setString(dd.showKM(one_train_base,5))
    area_1:getChildByName("train_add_text"):setString("")
    area_1:getChildByName("train_all_text"):setString(dd.showKM(train_all,5))
    
    local one_pro_base = dd.cfgBuildingUp[self._bid][self._lv]['value1']
    local one_pro = math.modf(one_pro_base * (1 + add/1000.0))
    local one_pro_add = math.modf(one_pro_base * add/1000.0)    
    if one_pro_add > 0 then
        area_2:getChildByName("one_pro_text"):setString(dd.showKM(one_pro_base,5))
        area_2:getChildByName("add_text"):setString("+"..dd.showKM(one_pro_add,5))
    else
        area_2:getChildByName("one_pro_text"):setString(dd.showKM(one_pro_base,5))
        area_2:getChildByName("add_text"):setString("")
    end
    local limit_base = dd.cfgBuildingUp[self._bid][self._lv]['value2']
    local limit = math.modf(limit_base * (1 + limit_add/1000.0))
    local limit_add_num = math.modf(limit_base * (limit_add/1000.0))

    local pastTime = dd.getServerTime() - dd.myResInfo[self._pos]['lastUpdate']
    local now = dd.myResInfo[self._pos]['nowNum']
    if pastTime > 0 then
        local time_pro = math.floor(one_pro*pastTime/3600.0)
        now = now + time_pro
        if now > limit then      
            now = limit
        end 
    end
    if now >= limit then
        area_2:getChildByName("now_num_text"):setColor(cc.c3b(237,101,101))
    else
        area_2:getChildByName("now_num_text"):setColor(cc.c3b(118,137,137))
    end
    area_2:getChildByName("now_num_text"):setString(dd.showKM(now,5))
    if limit_add_num > 0 then
        area_2:getChildByName("limit_text"):setString("/"..dd.showKM(limit_base,5))
        area_2:getChildByName("limit_add_text"):setString("+"..dd.showKM(limit_add_num,5))
    else
        area_2:getChildByName("limit_text"):setString("/"..dd.showKM(limit_base,5))
        area_2:getChildByName("limit_add_text"):setString("")
    end

    self:getChildByName("mainArea"):getChildByName("btm"):getChildByName("getBtn"):addTouchEventListener(self.getRes)
    if now > 0 then
        self:getChildByName("mainArea"):getChildByName("btm"):getChildByName("getBtn"):setTouchEnabled(true)
        self:getChildByName("mainArea"):getChildByName("btm"):getChildByName("getBtn"):setBright(true)
        self:getChildByName("mainArea"):getChildByName("btm"):getChildByName("getBtn"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
    else
        self:getChildByName("mainArea"):getChildByName("btm"):getChildByName("getBtn"):setTouchEnabled(false)
        self:getChildByName("mainArea"):getChildByName("btm"):getChildByName("getBtn"):setBright(false)
        self:getChildByName("mainArea"):getChildByName("btm"):getChildByName("getBtn"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
    end
    self.lastUpdate = dd.myResInfo[self._pos]['lastUpdate']
    area_2:requestDoLayout()
    area_1:requestDoLayout()
    if self._init == false then
        self:getChildByName("mainArea"):getChildByName("panel_notice"):getChildByName("chu_notice_text"):setString(ff.langString(dd.cfgBuilding[self._bid]['tips2']))
        self:getChildByName("bar"):getChildByName("chu_help_27_tip"):setString(ff.langString("点击查看建筑效果"))
        self:getChildByName("mainArea"):getChildByName("btm"):getChildByName("getBtn"):getChildByName("chu_label"):setString(ff.langString("征收"))
        local function showHelp(sender,eventType)
            if eventType==ccui.TouchEventType.ended then   
                pop.onShowPopDialog("buildHelp",self._bid,self._lv)
            end
        end
        self:getChildByName("mainArea"):getChildByName("area_2"):getChildByName("img_bg"):getChildByName("woman"):loadTexture("images/icon/res/ic05_bk.png",0)
        self:getChildByName("bar"):getChildByName("help_27"):addTouchEventListener(showHelp)
        self._init = true
    end
end

function homeLayer.getRes(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("home")
        if widget ~= nil then
            local message = ff.net:createMessage()
            message:addCmd(0x0000016a)
            message:addLong(dd.uid)
            message:addLong(widget._pos)
            ff.net:rpc(message,false)            
        end
    end
end
function homeLayer:updateRes(dt)
    self.tick = self.tick + 1
    if self.tick >= 60 or dd.myResInfo[self._pos]['lastUpdate'] > self.lastUpdate then
        self.tick = 0
        self:onUpdate()
    end
end
function homeLayer:onUpdate()
    local area_1 = self:getChildByName("mainArea"):getChildByName("area_1")
    local area_2 = self:getChildByName("mainArea"):getChildByName("area_2")

    local buildNum = 0
    local train_all = 10
    local pro_all = 0
    local limit_base = 0 
    for var=1, dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(var,"bid") == self._bid then
            buildNum = buildNum + 1
            local lv = dd.mybuilds:getLong(var,"level")
            if lv <= 0 then
                lv = 1
            end
            train_all = train_all + dd.cfgBuildingUp[self._bid][lv]['value3']
            pro_all = pro_all + dd.cfgBuildingUp[self._bid][lv]['value1']
            limit_base = limit_base + dd.cfgBuildingUp[self._bid][lv]['value2']
        end
    end
    area_1:getChildByName("build_num_text"):setString(buildNum)
    local add = 0 
    local limit_add = 0
    local train_add = 0
    for var=1, dd.myeffect:rowCount() do
        if dd.myeffect:getLong(var,'id') == 105 or dd.myeffect:getLong(var,'id') == 515 then
            add = add + dd.myeffect:getLong(var,'param')
        elseif dd.myeffect:getLong(var,'id') == 125 then
            limit_add = dd.myeffect:getLong(var,'param')
        elseif dd.myeffect:getLong(var,'id') == 14 then
            train_add = dd.myeffect:getLong(var,'param')
        end
    end
    local one_train = dd.cfgBuildingUp[self._bid][self._lv]['value3'] + train_add
    local one_train_add = train_add
    local one_train_base = dd.cfgBuildingUp[self._bid][self._lv]['value3']

    area_1:getChildByName("train_num_text"):setString(dd.showKM(one_train_base,5))
    area_1:getChildByName("train_add_text"):setString("")
    area_1:getChildByName("train_all_text"):setString(dd.showKM(train_all,5))

    local one_pro_base = dd.cfgBuildingUp[self._bid][self._lv]['value1']
    local one_pro = math.modf(one_pro_base * (1 + add/1000.0))
    local one_pro_add = math.modf(one_pro_base * add/1000.0)    
    if one_pro_add > 0 then
        area_2:getChildByName("one_pro_text"):setString(dd.showKM(one_pro_base,5))
        area_2:getChildByName("add_text"):setString("+"..dd.showKM(one_pro_add,5))
    else
        area_2:getChildByName("one_pro_text"):setString(dd.showKM(one_pro_base,5))
        area_2:getChildByName("add_text"):setString("")
    end

    local limit_base = dd.cfgBuildingUp[self._bid][self._lv]['value2']
    local limit = math.modf(limit_base * (1 + limit_add/1000.0))
    local limit_add_num = math.modf(limit_base * (limit_add/1000.0))
    
    local pastTime = dd.getServerTime() - dd.myResInfo[self._pos]['lastUpdate']
    local now = dd.myResInfo[self._pos]['nowNum']
    if pastTime > 0 then
        local time_pro = math.floor(one_pro*pastTime/3600.0)
        now = now + time_pro
        if now > limit then      
            now = limit
        end 
    end
    if now >= limit then
        area_2:getChildByName("now_num_text"):setColor(cc.c3b(237,101,101))
    else
        area_2:getChildByName("now_num_text"):setColor(cc.c3b(118,137,137))
    end
    area_2:getChildByName("now_num_text"):setString(dd.showKM(now,5))
    if limit_add_num > 0 then
        area_2:getChildByName("limit_text"):setString("/"..dd.showKM(limit_base,5))
        area_2:getChildByName("limit_add_text"):setString("+"..dd.showKM(limit_add_num,5))

    else
        area_2:getChildByName("limit_text"):setString("/"..dd.showKM(limit_base,5))
        area_2:getChildByName("limit_add_text"):setString("")
    end

    self:getChildByName("mainArea"):getChildByName("btm"):getChildByName("getBtn"):addTouchEventListener(self.getRes)
    if now > 0 then
        self:getChildByName("mainArea"):getChildByName("btm"):getChildByName("getBtn"):setTouchEnabled(true)
        self:getChildByName("mainArea"):getChildByName("btm"):getChildByName("getBtn"):setBright(true)
        self:getChildByName("mainArea"):getChildByName("btm"):getChildByName("getBtn"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
    else
        self:getChildByName("mainArea"):getChildByName("btm"):getChildByName("getBtn"):setTouchEnabled(false)
        self:getChildByName("mainArea"):getChildByName("btm"):getChildByName("getBtn"):setBright(false)
        self:getChildByName("mainArea"):getChildByName("btm"):getChildByName("getBtn"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
    end
    area_2:requestDoLayout()
    area_1:requestDoLayout()
    self.lastUpdate = dd.myResInfo[self._pos]['lastUpdate']
end
function homeLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, homeLayer)
    return target
end
--界面显示后调用
function homeLayer.onStart(sender)
    sender:onInit()
    sender:scheduleUpdateWithPriorityLua(function (dt)sender:updateRes(dt) end, 0)
end
--界面关闭效果结束后调用
function homeLayer.onEnd(sender)
    ff.net:removeEvent(2,dd.Tjf_ResourceGain)
    local help = pop.getDialog("buildHelp")
    if help ~= nil and help:isVisible() then
        help:setVisible(false)    
    end
    sender:unscheduleUpdate()
end
function homeLayer:backResourceGain(ret) 
    if ret[1] == 0 then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功收取{0}{1}",{ret[4],ff.langString("银币")}),1)
        end   
        dd.mainUI:showGiftNotice(6,0,ret[4],cc.p(360,(ff.height)/2),1)  
    else
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.mainUI:onShowCodeTips(ret[1])
        end  
    end
end

--界面即将播放显示缓动时调用，返回false界面显示将终止
function homeLayer.onBefore(sender)
    ff.net:registerEvent(2,dd.Tjf_ResourceGain, function (message)sender:backResourceGain(message)end)
    if sender._init == false then
        local hh = ff.height
        sender:setContentSize(cc.size(720,hh - 190 - 214))
        sender:getChildByName("bar"):setPositionY(hh - 190 - 214 - 10 - 41)
        sender:getChildByName("mainArea"):setContentSize(cc.size(720,hh - 190 - 214-60))
        sender:getChildByName("mainArea"):setInnerContainerSize(cc.size(720,hh - 190 - 214-60))
        sender:getChildByName("mainArea"):setPositionY(0)
        local area_2_hh = sender:getChildByName("mainArea"):getChildByName("area_2"):getContentSize().height
        sender:getChildByName("mainArea"):getChildByName("area_1"):setPositionY((hh-190 - 214 - 60- area_2_hh))
        local yy = sender:getChildByName("mainArea"):getChildByName("area_1"):getPositionY()-area_2_hh
        sender:getChildByName("mainArea"):getChildByName("area_2"):setPositionY(yy-5)
        local panel_notice_hh = sender:getChildByName("mainArea"):getChildByName("panel_notice"):getContentSize().height
        sender:getChildByName("mainArea"):getChildByName("panel_notice"):setPositionY(sender:getChildByName("mainArea"):getChildByName("area_2"):getPositionY()-panel_notice_hh - 20)
    end
    return false
end

function onShowHome(widget,pos,lastpos)
    cclog("onShowHome:"..pos..","..lastpos)
    local layer = homeLayer.extend(widget)
    layer:setVisible(false)
    if lastpos == pos then
        layer._effect = false
    else
        layer._effect = true
    end 
    layer._pos = pos
    return layer
end