JailLayer = class("JailLayer")
JailLayer._name = "Jail"
JailLayer._init = false
JailLayer._type = 1
JailLayer._Cfg_Corpse = {}
JailLayer._info = nil
JailLayer._prison = nil


function JailLayer.extend( target )
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target,t)
    end
    setmetatable(t,JailLayer)
    return target
    -- body
end

function JailLayer:onAutoSize()
    local hh = ff.height - 214
    self:setContentSize(cc.size(720,hh))
    self:getChildByName("bg"):setContentSize(cc.size(720,hh))
    self:getChildByName("bg"):setPositionY(0)
    self:getChildByName("topArea"):setPositionY(hh - 105)
    self:getChildByName("topNavi"):setPositionY(hh - 105-85)
    self:getChildByName("info"):setPositionY(hh - 105-85-38)
    self:getChildByName("list"):setContentSize(cc.size(720,hh-105-85-42))
    self:getChildByName("list"):setPositionY(0)
    self:getChildByName("list2"):setContentSize(cc.size(720,hh-105-85-42))
    self:getChildByName("list2"):setPositionY(0)
    self:getChildByName("pop"):setContentSize(cc.size(720,hh-105))
    self:getChildByName("pop"):setPositionY(0)
    self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onReturn)
    self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
    self:getChildByName("topNavi"):getChildByName("navi1"):addTouchEventListener(self.onSelectType)
    self:getChildByName("topNavi"):getChildByName("navi2"):addTouchEventListener(self.onSelectType)
    self:getChildByName("topNavi"):getChildByName("navi1"):setTag(1)
    self:getChildByName("topNavi"):getChildByName("navi2"):setTag(2)
    self:getChildByName("info"):getChildByName("help"):addTouchEventListener(self.onPop)
    self:getChildByName("info"):getChildByName("tips"):setString(ff.langString("玩法说明"))
    self:getChildByName("pop"):getChildByName("pop"):getChildByName("close"):addTouchEventListener(self.onClosePop)
    self:getChildByName("item"):getChildByName("oper2"):addTouchEventListener(self.openSlot)
    self:getChildByName("item2"):getChildByName("open"):addTouchEventListener(self.onOpen)
    self:getChildByName("item2"):getChildByName("down"):addTouchEventListener(self.onDown)
    self:getChildByName("item3"):getChildByName("bianxing"):addTouchEventListener(self.onbianxing)
    self:getChildByName("item3"):getChildByName("dianji"):addTouchEventListener(self.ondianji)
    self:getChildByName("item3"):getChildByName("shifang"):addTouchEventListener(self.onshifang)
    self:getChildByName("item3"):getChildByName("chujue"):addTouchEventListener(self.onchujue)
    self:getChildByName("item"):getChildByName("oper1"):getChildByName("yanjiu"):addTouchEventListener(self.yanjiu)
    self:getChildByName("item"):getChildByName("oper1"):getChildByName("rengdiao"):addTouchEventListener(self.rengdiao)
end

function JailLayer.onOpen( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then    
        local widget = pop.getDialog("Jail")
        if widget == nil then
            return
        end
        local tag = sender:getTag()
        local Panel = widget:getChildByName("list2"):getChildByTag(tag)
        if Panel ~= nil then
            local item  = Panel:getChildByTag(1)
            if item ~= nil then
                item:getChildByName("open"):setVisible(false)
                item:getChildByName("down"):setVisible(true)
            end
            local item3 = Panel:getChildByTag(3)
            if item3 == nil then
                item3 = widget:getChildByName("item3"):clone()
                item3:setPosition(cc.p(0,0))
                Panel:addChild(item3,1,3)
                item:setPosition(cc.p(0,80))
                Panel:setContentSize(cc.size(700,250))
            end
            item3:setVisible(true)
            if widget._prison[tag] ~= nil then
                item3:getChildByName("bianxing"):setTag(tag)
                item3:getChildByName("dianji"):setTag(tag)
                item3:getChildByName("shifang"):setTag(tag)
                item3:getChildByName("chujue"):setTag(tag)
            end
            widget:getChildByName("list2"):refreshView()
        end
    end
end

function JailLayer.onPop( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then    
        local widget = pop.getDialog("Jail")
        if widget == nil then
            return
        end
        if widget._type == 1 then
            widget:getChildByName("pop"):getChildByName("pop"):getChildByName("block1"):getChildByName("content"):setString(ff.langString("在大地图中击败其他玩家，有一定的概率捕获对方的英雄成为俘虏，并关押一定的时间，在此期间，你可以对俘虏进行鞭挞，电击等刑罚，来获取资源或加速道具。")..ff.langString("需要注意的是，当监狱中有英雄俘虏时，你在大地图上的城市将被标记，而且，你无法使用保护道具，否则俘虏将被自动释放。"))
        else
            widget:getChildByName("pop"):getChildByName("pop"):getChildByName("block1"):getChildByName("content"):setString(ff.langString("在大地图中击败其他玩家，有一定的概率捕获对方的英雄成为俘虏，并关押一定的时间，在此期间，你可以对俘虏进行鞭挞，电击等刑罚，来获取资源或加速道具。")..ff.langString("需要注意的是，当监狱中有英雄俘虏时，你在大地图上的城市将被标记，而且，你无法使用保护道具，否则俘虏将被自动释放。"))
        end
        widget:getChildByName("pop"):setVisible(true)
    end
end

function JailLayer.onClosePop( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then    
        local widget = pop.getDialog("Jail")
        if widget == nil then
            return
        end
        widget:getChildByName("pop"):setVisible(false)
    end
end

function JailLayer.onDown( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("Jail")
        if widget == nil then
            return
        end
        local tag = sender:getTag()
        local Panel = widget:getChildByName("list2"):getChildByTag(tag)
        if Panel ~= nil then
            local item  = Panel:getChildByTag(1)
            if item ~= nil then
                item:getChildByName("open"):setVisible(true)
                item:getChildByName("down"):setVisible(false)
            end
            local item3 = Panel:getChildByTag(3)
            if item3 ~= nil then
                item3:removeFromParent(true)
                item:setPosition(cc.p(0,0))
                Panel:setContentSize(cc.size(700,170))
            end
            widget:getChildByName("list2"):refreshView()
        end    
    end
end

function JailLayer.onbianxing( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then  
        local widget = pop.getDialog("Jail")
        if widget == nil then
            return
        end
        local id = sender:getTag()
        if widget._prison[id] ~= nil then
            if widget._prison[id]["freezeCD"] > dd.getServerTime() then
                dd.mainUI:onShowTips(ff.langString("这名俘虏太虚弱了，无法承受刑罚"))
                return
            else
                local message = ff.net:createMessage()
                message:addCmd(0x0000010e)
                message:addLong(dd.uid)
                message:addLong(1)
                message:addLong(widget._prison[id]["playerUid"])
                message:addLong(widget._prison[id]["herohid"])
                --cclog("========"..widget._prison[id]["playerUid"].."=="..widget._prison[id]["herohid"])
                ff.net:rpc(message,false)
            end
        end
    end
end

function JailLayer.ondianji( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then  
        local widget = pop.getDialog("Jail")
        if widget == nil then
            return
        end
        local id     = sender:getTag()
        if widget._prison[id] ~= nil then
            if widget._prison[id]["freezeCD"] > dd.getServerTime() then
                dd.mainUI:onShowTips(ff.langString("这名俘虏太虚弱了，无法承受刑罚"))
                return
            else
                local message = ff.net:createMessage()
                message:addCmd(0x0000010e)
                message:addLong(dd.uid)
                message:addLong(2)
                message:addLong(widget._prison[id]["playerUid"])
                message:addLong(widget._prison[id]["herohid"])
                ff.net:rpc(message,false)  
            end
        end
    end
end

function JailLayer.onshifang( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then 
        local widget = pop.getDialog("Jail")
        if widget == nil then
            return
        end
        local id     = sender:getTag()
        if widget._prison[id] ~= nil then
            if widget._prison[id]["actionCD"] > dd.getServerTime() then
                dd.mainUI:onShowTips(ff.langString("俘虏的虚弱时间结束前，无法释放"))
                return
            else
                local message = ff.net:createMessage()
                message:addCmd(0x0000010e)
                message:addLong(dd.uid)
                message:addLong(8)
                message:addLong(widget._prison[id]["playerUid"])
                message:addLong(widget._prison[id]["herohid"])
                ff.net:rpc(message,false)  
            end 
        end
    end
end

function JailLayer.onchujue( sender,eventType )
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then  
        local widget = pop.getDialog("Jail")
        if widget == nil then
            return
        end
        local id     = sender:getTag()
        if widget._prison[id] ~= nil then
            if widget._prison[id]["executeTime"] > dd.getServerTime() then
                dd.mainUI:onShowTips(ff.langString("处决倒计时结束前，无法处决俘虏"))
                return
            else
                local message = ff.net:createMessage()
                message:addCmd(0x0000010e)
                message:addLong(dd.uid)
                message:addLong(9)
                message:addLong(widget._prison[id]["playerUid"])
                message:addLong(widget._prison[id]["herohid"])
                ff.net:rpc(message,false)  
            end
        end
    end
end

function JailLayer.onSelectType( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("Jail")
        if widget ~= nil then
            local tag = sender:getTag()
            if tag ~= widget._type then
                widget._type = sender:getTag()
                widget:selectType(true)
            else
                widget:selectType(false)
            end
        end
    end
end

function JailLayer:selectType( flesh,sender)
    self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)

    self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)

    if self._type == 1 then
        self:getZomibeList()
        self:getChildByName("list"):setVisible(true)
        self:getChildByName("list2"):setVisible(false)
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(239, 223, 223))
    elseif self._type == 2 then
        self:GetPrisonLists()
        self:getChildByName("list2"):setVisible(true)
        self:getChildByName("list"):setVisible(false)
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(239, 223, 223))
    end
    if sender ~= nil then
        sender:setSelectedState(true)
    end
    if flesh then
        --self:getChildByName("list"):removeAllChildren(true)
        self:showList()
    end
end


function onShowJail( widget )
    -- body
    local layer = JailLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)

    layer:onInit()
    return layer
end

function JailLayer:onInit( )
    -- body
    if self._init == false then
        self:onAutoSize()
        self._init = true
    end
    
    self:initDate()

    self.updateGold()
    self:Autocreate()
end

function JailLayer:initDate(  )
    self._info = nil
    self._prison = nil
    self._Cfg_Corpse = {}
    local propData1 = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_buffcorpse`")
    for i=1, propData1:rowCount() do
       local id = tonumber(propData1:getString(i, "id"))
       self._Cfg_Corpse[id]={}
       self._Cfg_Corpse[id]['pic'] =propData1:getString(i, "pic")
       self._Cfg_Corpse[id]['buffid'] = tonumber(propData1:getString(i, "buffid"))
       self._Cfg_Corpse[id]['buffnum'] = tonumber(propData1:getString(i, "buffnum"))
   
       if ff.lang == -1 then
            self._Cfg_Corpse[id]['name']   = propData1:getString(i, "name")
            
        else    
            self._Cfg_Corpse[id]['name']   = tonumber(propData1:getString(i, "name_lan"))
            
        end
    end
    propData1:clear()
end

function JailLayer:Autocreate(  )
    for i=1,dd.mygifts:getLong(1,"ZombieCount") do
        local item = self:getChildByName("item"):clone()
        item:setTag(i)
        item:getChildByName("oper2"):setTag(i)
        item:getChildByName("oper1"):getChildByName("yanjiu"):setTag(i)
        item:getChildByName("oper1"):getChildByName("rengdiao"):setTag(i)
        item:setVisible(true)
        self:getChildByName("list"):pushBackCustomItem(item)
    end
end

function JailLayer.onReturn( sender,eventType )
    -- body
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("Jail")
        if widget == nil then
            return
        end
        if widget:getChildByName("pop"):isVisible() == true then
            widget:getChildByName("pop"):setVisible(false)
            return
        end
        pop.onClosePopDialog("Jail")
    end
end

function JailLayer:showList(  )
    if self._type == 1 then
        local view = false
        for i=1,dd.mygifts:getLong(1,"ZombieCount") do
            local item = self:getChildByName("list"):getChildByTag(i)
            if item == nil then
                item = self:getChildByName("item"):clone()
                item:setTag(i)
                
                item:setVisible(true)
                self:getChildByName("list"):pushBackCustomItem(item)
                item:setVisible(true)
            end
            item:getChildByName("oper2"):setTag(i)
            item:getChildByName("oper1"):getChildByName("yanjiu"):setTag(i)
            item:getChildByName("oper1"):getChildByName("rengdiao"):setTag(i)
            if  self._info ~= nil  and self._info[i] ~= nil then
                if  self._info[i]["type"] == 0 then
                    item:getChildByName("oper1"):setVisible(false)
                    item:getChildByName("oper2"):setVisible(false)
                    item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                    item:getChildByName("ico"):getChildByName("back"):setVisible(true)
                    item:getChildByName("ico"):getChildByName("lock"):setVisible(false)
                    item:getChildByName("name"):setString("")
                    item:getChildByName("info"):setString("")
                    item:getChildByName("name2"):setString(ff.langString("空闲"))
                    if view == false then
                        view = true
                        item:getChildByName("oper1"):setVisible(false)
                        item:getChildByName("oper2"):setVisible(true)
                        --item:getChildByName("oper2"):setTag(num)
                        item:getChildByName("oper2"):getChildByName("Label_64"):setString("")
                        item:getChildByName("oper2"):getChildByName("item"):setVisible(true)
                        item:getChildByName("oper2"):getChildByName("item"):getChildByName("count"):setString("200")
                        item:getChildByName("oper2"):getChildByName("item"):getChildByName("oper"):setString(ff.langString("立即研究"))
                    end
                else
                    item:getChildByName("name2"):setString("")
                    if self._info[i]["state"] == 0 then
                        item:getChildByName("oper1"):setVisible(true)
                        item:getChildByName("oper2"):setVisible(false)
                        
                        item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getBossImg(),0)
                        item:getChildByName("ico"):getChildByName("back"):setVisible(true)
                        item:getChildByName("ico"):getChildByName("lock"):setVisible(false)

                        item:getChildByName("name"):setString(ff.langString(self._Cfg_Corpse[self._info[i]["type"]]["name"]))
                    else
                        item:getChildByName("oper1"):setVisible(false)
                        item:getChildByName("oper2"):setVisible(true)
                        item:getChildByName("ico"):getChildByName("back"):setVisible(false)
                        item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getSkillIcon(self._info[i]["type"]),0)
                        item:getChildByName("ico"):getChildByName("lock"):setVisible(false)
                        item:getChildByName("oper2"):getChildByName("Label_64"):setString(ff.langString("放弃"))
                        item:getChildByName("oper2"):getChildByName("item"):setVisible(false)
                        local value = tonumber(self._Cfg_Corpse[self._info[i]["type"]]["buffnum"])/dd.cfgEffect[tonumber(self._Cfg_Corpse[self._info[i]["type"]]["buffid"])]['value']
                        local str = dd.cfgEffect[tonumber(self._Cfg_Corpse[self._info[i]["type"]]["buffid"])]['tips1']
                        str = ff.langString(str,{value})
                        item:getChildByName("name"):setString(str)
                    end
                    local time = tonumber(self._info[i]["endTime"]) - dd.getServerTime()
                    item:getChildByName("info"):setString("Time:"..ff.getLeftTime(time,":"))
                end

            else
                item:getChildByName("oper1"):setVisible(false)
                item:getChildByName("oper2"):setVisible(false)
                item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("ico"):getChildByName("back"):setVisible(true)
                item:getChildByName("ico"):getChildByName("lock"):setVisible(false)
                item:getChildByName("name"):setString("")
                item:getChildByName("info"):setString("")
                item:getChildByName("name2"):setString(ff.langString("空闲"))
                if view == false then
                    view = true
                    item:getChildByName("oper1"):setVisible(false)
                    item:getChildByName("oper2"):setVisible(true)
                    item:getChildByName("oper2"):getChildByName("Label_64"):setString("")
                    item:getChildByName("oper2"):getChildByName("item"):setVisible(true)
                    item:getChildByName("oper2"):getChildByName("item"):getChildByName("count"):setString("200")
                    item:getChildByName("oper2"):getChildByName("item"):getChildByName("oper"):setString(ff.langString("立即研究"))
                end
            end
            item:requestDoLayout()
        end
        local needGold = {0,0,0,50,100,150,200,250,300,350,400,500,600,700,800}
        if dd.mygifts:getLong(1,"ZombieCount") < 15 then
            local num = dd.mygifts:getLong(1,"ZombieCount")+1
            local item = self:getChildByName("list"):getChildByTag(num)
            if item == nil then
                item = self:getChildByName("item"):clone()
                item:setTag(dd.mygifts:getLong(1,"ZombieCount")+1)
                item:setVisible(true)
                item:setTag(num)
                item:getChildByName("oper2"):setTag(num)
                item:getChildByName("oper1"):getChildByName("yanjiu"):setTag(num)
                item:getChildByName("oper1"):getChildByName("rengdiao"):setTag(num)
                item:getChildByName("name"):setString("")
                item:getChildByName("info"):setString("")
                item:getChildByName("name2"):setString(ff.langString("未解锁"))
                item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("ico"):getChildByName("back"):setVisible(false)
                item:getChildByName("ico"):getChildByName("lock"):setVisible(true)
                self:getChildByName("list"):insertCustomItem(item,dd.mygifts:getLong(1,"ZombieCount"))
                item:getChildByName("oper1"):setVisible(false)
                item:getChildByName("oper2"):setVisible(true)
                item:getChildByName("oper2"):getChildByName("Label_64"):setString("")
                item:getChildByName("oper2"):getChildByName("item"):setVisible(true)
                item:getChildByName("oper2"):getChildByName("item"):getChildByName("count"):setString(tostring(needGold[num]))
                item:getChildByName("oper2"):getChildByName("item"):getChildByName("oper"):setString(ff.langString("解锁"))
            end
        end

        if self._info ~= nil and table.getn(self._info) >0 then
            local index = 1
            for k,v in pairs(self._info) do
                if k > 100 then
                    --local num = dd.mygifts:getLong(1,"ZombieCount")+1 + index
                    index = index + 1
                    local item = self:getChildByName("list"):getChildByTag(k)
                    if item == nil then
                        if v["type"] ~= 0 then
                            item = self:getChildByName("item"):clone()
                            item:setTag(k)
                            
                            item:setVisible(true)
                            self:getChildByName("list"):pushBackCustomItem(item)
                            item:setVisible(true)
                            item:getChildByName("oper2"):setTag(k)
                            item:getChildByName("oper1"):getChildByName("yanjiu"):setTag(k)
                            item:getChildByName("oper1"):getChildByName("rengdiao"):setTag(k)
                            item:getChildByName("name2"):setString("")
                            if v["state"] == 0 then
                                item:getChildByName("oper1"):setVisible(true)
                                item:getChildByName("oper2"):setVisible(false)
                                
                                item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getBossImg(),0)
                                item:getChildByName("ico"):getChildByName("back"):setVisible(true)
                                item:getChildByName("ico"):getChildByName("lock"):setVisible(false)

                                item:getChildByName("name"):setString(ff.langString(self._Cfg_Corpse[v["type"]]["name"]))
                            else
                                item:getChildByName("oper1"):setVisible(false)
                                item:getChildByName("oper2"):setVisible(true)
                                item:getChildByName("ico"):getChildByName("back"):setVisible(false)
                                item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getSkillIcon(v["type"]),0)
                                item:getChildByName("ico"):getChildByName("lock"):setVisible(false)
                                item:getChildByName("oper2"):getChildByName("Label_64"):setString(ff.langString("放弃"))
                                item:getChildByName("oper2"):getChildByName("item"):setVisible(false)
                                local value = tonumber(self._Cfg_Corpse[v["type"]]["buffnum"])/dd.cfgEffect[tonumber(self._Cfg_Corpse[v["type"]]["buffid"])]['value']
                                local str = dd.cfgEffect[tonumber(self._Cfg_Corpse[v["type"]]["buffid"])]['tips1']
                                str = ff.langString(str,{value})
                                item:getChildByName("name"):setString(str)
                            end
                            local time = tonumber(v["endTime"]) - dd.getServerTime()
                            item:getChildByName("info"):setString("Time:"..ff.getLeftTime(time,":"))
                        end
                    else
                        if v["type"] == 0 then
                            item:removeFromParent()
                        else
                            item:getChildByName("oper2"):setTag(k)
                            item:getChildByName("oper1"):getChildByName("yanjiu"):setTag(k)
                            item:getChildByName("oper1"):getChildByName("rengdiao"):setTag(k)
                            item:getChildByName("name2"):setString("")
                            if v["state"] == 0 then
                                item:getChildByName("oper1"):setVisible(true)
                                item:getChildByName("oper2"):setVisible(false)
                                
                                item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getBossImg(),0)
                                item:getChildByName("ico"):getChildByName("back"):setVisible(true)
                                item:getChildByName("ico"):getChildByName("lock"):setVisible(false)

                                item:getChildByName("name"):setString(ff.langString(self._Cfg_Corpse[v["type"]]["name"]))
                            else
                                item:getChildByName("oper1"):setVisible(false)
                                item:getChildByName("oper2"):setVisible(true)
                                item:getChildByName("ico"):getChildByName("back"):setVisible(false)
                                item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getSkillIcon(v["type"]),0)
                                item:getChildByName("ico"):getChildByName("lock"):setVisible(false)
                                item:getChildByName("oper2"):getChildByName("Label_64"):setString(ff.langString("放弃"))
                                item:getChildByName("oper2"):getChildByName("item"):setVisible(false)
                                local value = tonumber(self._Cfg_Corpse[v["type"]]["buffnum"])/dd.cfgEffect[tonumber(self._Cfg_Corpse[v["type"]]["buffid"])]['value']
                                local str = dd.cfgEffect[tonumber(self._Cfg_Corpse[v["type"]]["buffid"])]['tips1']
                                str = ff.langString(str,{value})
                                item:getChildByName("name"):setString(str)
                            end
                            local time = tonumber(v["endTime"]) - dd.getServerTime()
                            item:getChildByName("info"):setString("Time:"..ff.getLeftTime(time,":"))
                        end
                    end
                    
                end
            end
        end
    else
        for i=1,dd.myinfo:getLong(1,"GeneralPrisonCnt") do
            local Panel = self:getChildByName("list2"):getChildByTag(i)
            if Panel == nil then
                Panel = self:getChildByName("Panel"):clone()
                Panel:setTag(i)
                self:getChildByName("list2"):pushBackCustomItem(Panel)
                Panel:setVisible(true)
            end
            
            if  self._prison ~= nil  and self._prison[i] ~= nil then
                cclog("=11111111111111111111==="..i)
                local item2  = Panel:getChildByTag(2)
                if item2 ~= nil then
                    Panel:removeAllChildren(true)
                end

                local item = Panel:getChildByTag(1)
                if item == nil then
                    item = self:getChildByName("item2"):clone()
                    item:setVisible(true)
                    Panel:addChild(item, 1,1)
                    item:setPosition(cc.p(0,0))
                    Panel:setContentSize(cc.size(700,170))
                end
                item:getChildByName("open"):setTag(i)
                item:getChildByName("down"):setTag(i)
                item:getChildByName("open"):setVisible(true)
                item:getChildByName("down"):setVisible(false)
                item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getHeroIcon(self._prison[i]["heroid"]),0)
                local name = ff.langString(dd.cfgHero[self._prison[i]["heroid"]]['name'])
                local name2 = ""
                if string.len(self._prison[i]["unionFlag"]) > 1 then
                    name2 = name2.."["..self._prison[i]["unionFlag"].."]"..self._prison[i]["playername"]
                else
                    name2 = name2..self._prison[i]["playername"]
                end
                item:getChildByName("text"):getChildByName("name"):setString(ff.langString("{0}的{1}",{name2,name}))
                if self._prison[i]["freezeCD"] > dd.getServerTime() then
                    item:getChildByName("text"):getChildByName("time"):setString("("..ff.getLeftTime(self._prison[i]["freezeCD"] - dd.getServerTime(),":")..")")
                    item:getChildByName("text"):getChildByName("time"):setColor(cc.c3b(255,0,36))
                else
                    item:getChildByName("text"):getChildByName("time"):setString("("..ff.getLeftTime(self._prison[i]["actionCD"] - dd.getServerTime(),":")..")")
                    item:getChildByName("text"):getChildByName("time"):setColor(cc.c3b(255,255,255))
                end
                local time = 0
                local per = 0
                local start = self._prison[i]["executestart"]
                local endtime   = self._prison[i]["executeTime"]
                if (endtime - start )>0 then
                    per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                end
                time = self._prison[i]["executeTime"] - dd.getServerTime()
                        
                item:getChildByName("forge"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
                item:getChildByName("forge"):getChildByName("buffer"):setString(ff.langString("处决倒计时")..":"..ff.getLeftTime(time,":"))
                
                time = 0
                per = 0
                start = self._prison[i]["executestart"]
                endtime   = self._prison[i]["releaseTime"]
                if (endtime - start )>0 then
                    per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                end
                time = self._prison[i]["releaseTime"] - dd.getServerTime()
                        
                item:getChildByName("forge2"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
                item:getChildByName("forge2"):getChildByName("buffer"):setString(ff.langString("逃跑倒计时")..":"..ff.getLeftTime(time,":"))
                item:requestDoLayout()  
            else
                cclog("=2222222222222222222222222222")
                local item2  = Panel:getChildByTag(1)
                if item2 ~= nil then
                    Panel:removeAllChildren(true)
                end

                local item = Panel:getChildByTag(2)
                if item == nil then
                    item = self:getChildByName("item"):clone()
                    item:setVisible(true)
                    Panel:addChild(item, 1,2)
                    item:setPosition(cc.p(0,0))    
                end
                Panel:setContentSize(cc.size(700,170))
                item:getChildByName("oper1"):setVisible(false)
                item:getChildByName("oper2"):setVisible(false)
                item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("ico"):getChildByName("back"):setVisible(true)
                item:getChildByName("ico"):getChildByName("lock"):setVisible(false)
                item:getChildByName("name"):setString("")
                item:getChildByName("info"):setString("")
                item:getChildByName("name2"):setString(ff.langString("空闲"))
                item:requestDoLayout()
            end
        end

        if dd.myinfo:getLong(1,"GeneralPrisonCnt") < 30 then
            local num = dd.myinfo:getLong(1,"GeneralPrisonCnt")+1
            local Panel = self:getChildByName("list2"):getChildByTag(num)
            if Panel == nil then

                Panel = self:getChildByName("Panel"):clone()
                Panel:setTag(num)
                
                self:getChildByName("list2"):pushBackCustomItem(Panel)
                Panel:setVisible(true)
            end
            local item2  = Panel:getChildByTag(1)
            if item2 ~= nil then
                Panel:removeAllChildren(true)
            end

            local item = Panel:getChildByTag(2)
            if item == nil then
                item = self:getChildByName("item"):clone()
                Panel:addChild(item, 1,2)
                item:setPosition(cc.p(0,0))
                Panel:setContentSize(cc.size(700,170))
                
                item:setVisible(true)
                item:getChildByName("oper2"):setTag(num+1000)
                item:getChildByName("name"):setString("")
                item:getChildByName("info"):setString("")
                item:getChildByName("name2"):setString(ff.langString("未解锁"))
                item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("ico"):getChildByName("back"):setVisible(false)
                item:getChildByName("ico"):getChildByName("lock"):setVisible(true)
                item:getChildByName("oper1"):setVisible(false)
                item:getChildByName("oper2"):setVisible(true)
                item:getChildByName("oper2"):getChildByName("Label_64"):setString("")
                item:getChildByName("oper2"):getChildByName("item"):setVisible(true)
                item:getChildByName("oper2"):getChildByName("item"):getChildByName("count"):setString((num - 2)*50)
                item:getChildByName("oper2"):getChildByName("item"):getChildByName("oper"):setString(ff.langString("解锁"))
            end
        end
        self:getChildByName("list2"):refreshView()
    end
end

function JailLayer:getZomibeList()
    local message = ff.net:createMessage()
    message:addCmd(0x00000058)
    message:addLong(dd.uid)
    ff.net:rpc(message,false)
end

function JailLayer:GetPrisonLists()
    local message = ff.net:createMessage()
    message:addCmd(0x00000036)
    message:addLong(dd.uid)
    message:addLong(0)
    ff.net:rpc(message,false)
end

function JailLayer.onEnd( sender )
    -- body
    sender:getChildByName("list"):removeAllChildren(true)
    sender:getChildByName("list2"):removeAllChildren(true)
    ff.net:removeEvent(2,dd.Tjf_GetBuffZombieLists)
    ff.net:removeEvent(2,dd.Tjf_BuffZombieOpenSlot)
    ff.net:removeEvent(2,dd.Tjf_BuffZombieAction)
    ff.net:removeEvent(2,dd.Tjg_GetPrisonLists)
    ff.net:removeEvent(2,dd.Tjg_PrisonOpenSlot)
    ff.net:removeEvent(2,dd.Tjg_PrisonAction)
    ff.net:removeEvent(2,dd.Tjf_notify_SNGetBonus)
    ff.net:unbindProperty("gold",2324)
    dd.delBackEvent(sender.onReturn)
    sender:stopAllActions()
end

function JailLayer:onGetBuffZombieLists(params)
    local code = params[1]
    if code == 0 then
        self._info = params[2]
        self:showList()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function JailLayer:onGetPrisonLists(params)
    local code = params[1]
    if code == 0 then
        self._prison = params[2]
        self:showList()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end


function JailLayer:onBuffZombieOpenSlot(params)
    local code = params[1]
    if code == 0 then
        self:getChildByName("list"):removeAllChildren(true)
        self:showList()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function JailLayer:onPrisonOpenSlot(params)
    local code = params[1]
    if code == 0 then

        self:showList()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
function JailLayer.update( sender )
    if sender._type == 1 then
        if sender._info ~= nil then
            for k,v in pairs(sender._info) do
                local item = sender:getChildByName("list"):getChildByTag(k)
                if item ~= nil then
                    if  v["type"] ~= 0 then
                        local time = tonumber(v["endTime"]) - dd.getServerTime()
                        item:getChildByName("info"):setString("Time:"..ff.getLeftTime(time,":"))
                    end
                    
                end
            end
        end
    else
     
        if sender._prison ~= nil then
            for k,v in pairs(sender._prison) do
                local item = sender:getChildByName("list2"):getChildByTag(k)
                if item ~= nil then
                    local item2 = item:getChildByTag(1)
                    if item2 ~= nil then
                        if v["freezeCD"] > dd.getServerTime() then
                            item2:getChildByName("text"):getChildByName("time"):setString("("..ff.getLeftTime(v["freezeCD"] - dd.getServerTime(),":")..")")
                            item2:getChildByName("text"):getChildByName("time"):setColor(cc.c3b(255,0,36))
                        else
                            item2:getChildByName("text"):getChildByName("time"):setString("("..ff.getLeftTime(v["actionCD"] - dd.getServerTime(),":")..")")
                            item2:getChildByName("text"):getChildByName("time"):setColor(cc.c3b(255,255,255))
                        end
                        local time = 0
                        local per = 0
                        local start = v["executestart"]
                        local endtime   = v["executeTime"]
                        if (endtime - start )>0 then
                            per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                        end
                        time = v["executeTime"] - dd.getServerTime()
                                
                        item2:getChildByName("forge"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
                        item2:getChildByName("forge"):getChildByName("buffer"):setString(ff.langString("处决倒计时")..":"..ff.getLeftTime(time,":"))
                        
                        time = 0
                        per = 0
                        start = v["executestart"]
                        endtime   = v["releaseTime"]
                        if (endtime - start )>0 then
                            per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                        end
                        time = v["releaseTime"] - dd.getServerTime()
                                
                        item2:getChildByName("forge2"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
                        item2:getChildByName("forge2"):getChildByName("buffer"):setString(ff.langString("逃跑倒计时")..":"..ff.getLeftTime(time,":"))
                    end
                end
            end
        end
   
    end
    
end

function JailLayer:onBuffZombieAction(params)
    local code = params[1]
    if code == 0 then
        if params[2] ~= nil then
            local slot = params[2]["slot"]
            if self._info[slot] ~= nil then
                self._info[slot]["state"] = params[2]["state"]
                self._info[slot]["endTime"] = params[2]["endTime"]
                self._info[slot]["type"] = params[2]["type"]
            else
                self._info[slot] ={}
                self._info[slot]["state"] = params[2]["state"]
                self._info[slot]["endTime"] = params[2]["endTime"]
                self._info[slot]["type"] = params[2]["type"]
            end
            self:showList()
        end
        
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function JailLayer:onPrisonAction(params)
    local code = params[1]
    if code == 0 then
        local info = params[2]
        if info.action == 8 or info.action == 9 then
            for k,v in pairs(self._prison) do
                cclog("===="..v["playerUid"].."=="..info.playerUid)
                cclog("===="..v["herohid"].."=="..info.hid)
                if v["playerUid"] == info.playerUid and v["herohid"] == info.hid then
                    cclog("=33333333333333=========="..info.hid)
                    self._prison[k]=nil
                    break
                end
            end
        else
            for k,v in pairs(self._prison) do
                if v["playerUid"] == info.playerUid and v["herohid"] == info.hid then
                    v["actionCD"] = info.actionCD
                    v["freezeCD"] = info.freezeCD
                    break
                end
            end
        end
        self:showList()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function JailLayer:popRewardDialog(infos)
    if table.getn(infos) > 0 then
        --商店里，是购买的才提示
        if infos[1]["from"] == 23 then
            cclog("prop Count : "..table.getn(infos))
            pop.onShowPopDialog("reward",infos)
        end
    else
        return 
    end
end

function JailLayer.onBefore( sender)
  -- bod
    ff.net:registerEvent(2,dd.Tjf_GetBuffZombieLists, function (message)sender:onGetBuffZombieLists(message)end)
    ff.net:registerEvent(2,dd.Tjf_BuffZombieOpenSlot, function (message)sender:onBuffZombieOpenSlot(message)end)
    ff.net:registerEvent(2,dd.Tjf_BuffZombieAction, function (message)sender:onBuffZombieAction(message)end)
    ff.net:registerEvent(2,dd.Tjg_GetPrisonLists, function (message)sender:onGetPrisonLists(message)end)
    ff.net:registerEvent(2,dd.Tjg_PrisonOpenSlot,function (message)sender:onPrisonOpenSlot(message)end)
    ff.net:registerEvent(2,dd.Tjg_PrisonAction,function (message)sender:onPrisonAction(message)end)
    ff.net:registerEvent(2,dd.Tjf_notify_SNGetBonus, function (message) sender:popRewardDialog(message) end)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
end

function JailLayer.openSlot( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then    
        local widget = pop.getDialog("Jail")
        local id     = sender:getTag()
        if id < 1000 then
            
            if id > dd.mygifts:getLong(1,"ZombieCount") then
                if  widget._info ~= nil  and widget._info[id] ~= nil then
                    cclog("!44444444444!!q"..id)
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000176)
                    message:addLong(dd.uid)
                    message:addLong(9)
                    message:addLong(id)
                
                    ff.net:rpc(message,false)
                else
                    cclog("!!!!!!!!!!!q"..id)
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000177)
                    message:addLong(dd.uid)
                    message:addLong(id)
            
                    ff.net:rpc(message,false)
                end
            else
                if  widget._info ~= nil  and widget._info[id] ~= nil then
                    if  widget._info[id]["type"] == 0 then
                        local message = ff.net:createMessage()
                        message:addCmd(0x00000176)
                        message:addLong(dd.uid)
                        message:addLong(8)
                        message:addLong(id)
                    
                        ff.net:rpc(message,false)
                    else
                        local message = ff.net:createMessage()
                        message:addCmd(0x00000176)
                        message:addLong(dd.uid)
                        message:addLong(9)
                        message:addLong(id)
                     
                        ff.net:rpc(message,false)
                    end
                else
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000176)
                    message:addLong(dd.uid)
                    message:addLong(8)
                    message:addLong(id)
               
                    ff.net:rpc(message,false)
                end
            end
        else
            id = id - 1000
            local message = ff.net:createMessage()
            message:addCmd(0x0000013b)
            message:addLong(dd.uid)
            message:addLong(id)
    
            ff.net:rpc(message,false)
        end
    end
end

function JailLayer.yanjiu( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then    
        local widget = pop.getDialog("Jail")
        local id     = sender:getTag()
        
        --if id <= dd.mygifts:getLong(1,"ZombieCount") then
            cclog("======"..id)
            if  widget._info ~= nil  and widget._info[id] ~= nil then
                cclog("====3=="..id.."="..widget._info[id]["type"])
                if  widget._info[id]["state"] == 0 then
                    cclog("===4==="..id)
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000176)
                    message:addLong(dd.uid)
                    message:addLong(1)
                    message:addLong(id)
                
                    ff.net:rpc(message,false)
                
                end
            
            end
        --end
    end
end

function JailLayer.rengdiao( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then    
        local widget = pop.getDialog("Jail")
        local id     = sender:getTag()
        
        --if id <= dd.mygifts:getLong(1,"ZombieCount") then
            
            if  widget._info ~= nil  and widget._info[id] ~= nil then
                if  widget._info[id]["state"] == 0 then
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000176)
                    message:addLong(dd.uid)
                    message:addLong(9)
                    message:addLong(id)
                
                    ff.net:rpc(message,false)
                
                end
            
            end
        --end
    end
end

function JailLayer.onStart( sender )
    ff.net:bindProperty(2324,"gold",sender.updateGold)
    --sender:getZomibeList()
    sender:GetPrisonLists()
    sender._type = 2
    sender:selectType(true,sender:getChildByName("topNavi"):getChildByName("navi2"))
    schedule(sender, sender.update,1)
end

function JailLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("Jail")
    if widget ~= nil then
        widget:getChildByName("topArea"):getChildByName("money"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("topArea"):requestDoLayout()
    end
end
