--司令部
local mainbaseLayer   = class("mainbaseLayer")
mainbaseLayer._name = "mainbaseLayer"
mainbaseLayer._init = false
mainbaseLayer._pos  = 0
mainbaseLayer._bid  = 1
mainbaseLayer._lv  = 0
mainbaseLayer._heroRow = 1

function mainbaseLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, mainbaseLayer)
    return target
end
function mainbaseLayer.onChangeName(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local parent = pop.getDialog("mainbase")    
        parent:getChildByName("masking"):setVisible(true)
        pop.onShowPopDialog("changeName",1)
    end 
end
function mainbaseLayer.onQueryPower(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        pop.onShowPopDialog("powerInfo")
    end
end

function mainbaseLayer:onInit()
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"pos") == self._pos then
            self._bid = dd.mybuilds:getLong(i,"bid")
            self._lv = dd.mybuilds:getLong(i,"level")
            break
        end
    end
	if self._init == false then
		local hh = dd.currentLayer._pop:getContentSize().height
        if dd.currentLayer._pop ~= nil then
            self:setContentSize(cc.size(720,hh - 190))
            self:getChildByName("masking"):setContentSize(cc.size(720,hh - 105))
            self:getChildByName("view"):setContentSize(cc.size(720,hh - 190 - 50 ))
            if hh - 190 - 60 > 785 then
                self:getChildByName("view"):getChildByName("view"):setPositionY(hh - 190 - 60 - 785)
            else
                self:getChildByName("view"):getChildByName("view"):setPositionY(5)
            end
            local innerhh = self:getChildByName("view"):getInnerContainerSize().height
			self:getChildByName("view"):setPositionY(0)
            			
			self:getChildByName("top"):setPositionY(hh - 190 - 43-7)

            self:getChildByName("top"):getChildByName("tip"):getChildByName("tips"):setString(ff.langString("点击查看建筑效果"))
			self:getChildByName("top"):getChildByName("help1"):addTouchEventListener(dd.Helper)

            local function showSelectHeros(sender,eventType)
                local doaction = false
                if eventType == ccui.TouchEventType.canceled then
                    local startp = sender:getTouchBeganPosition()
                    local endp   = sender:getTouchEndPosition()
                    if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                        doaction = true
                    end
                end

                if eventType==ccui.TouchEventType.ended then    
                    doaction = true
                end
                if doaction == true then
                    if sender:getName() ~= "inter" then
                        AudioEngine.playEffect(ff.sounds[101])
                    end
                    if dd.myinfo:getLong(1,"level") < 10 then
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("司令部等级达{0}级开放",{10}))
                    else
                        pop.onShowPopDialog("selectHero", 4)
                    end
                end
            end
            local function showOfficeHeros(sender,eventType)
                local doaction = false
                if eventType == ccui.TouchEventType.canceled then
                    local startp = sender:getTouchBeganPosition()
                    local endp   = sender:getTouchEndPosition()
                    if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                        doaction = true
                    end
                end

                if eventType==ccui.TouchEventType.ended then    
                    doaction = true
                end
                if doaction == true then
                    if sender:getName() ~= "defense" then
                        AudioEngine.playEffect(ff.sounds[101])
                    end
                    if dd.myinfo:getLong(1,"level") < 11 then
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("司令部等级达{0}级开放",{11}))
                    else
                        pop.onShowPopDialog("selectHero", 2)
                    end
                end
            end

            local function showHelp(sender,eventType)
                if eventType==ccui.TouchEventType.ended then  
                    pop.onShowPopDialog("mainBaseHelp")
                end
            end

            local function onCityName(sender,eventType)
                local doaction = false
                if eventType == ccui.TouchEventType.canceled then
                    local startp = sender:getTouchBeganPosition()
                    local endp   = sender:getTouchEndPosition()
                    if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                        doaction = true
                    end
                end

                if eventType==ccui.TouchEventType.ended then    
                    doaction = true
                end
                if doaction == true then
                    AudioEngine.playEffect(ff.sounds[101])
                    local parent = pop.getDialog("mainbase")    
                    parent:getChildByName("masking"):setVisible(true)
                    pop.onShowPopDialog("changeName",1)                    
                end
            end

            local function onPower(sender,eventType)
                local doaction = false
                if eventType == ccui.TouchEventType.canceled then
                    local startp = sender:getTouchBeganPosition()
                    local endp   = sender:getTouchEndPosition()
                    if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                        doaction = true
                    end
                end

                if eventType==ccui.TouchEventType.ended then    
                    doaction = true
                end
                if doaction == true then
                    AudioEngine.playEffect(ff.sounds[101])
                    pop.onShowPopDialog("powerInfo")                  
                end
            end

            self:getChildByName("top"):getChildByName("help1"):addTouchEventListener(showHelp)
            
            self:getChildByName("view"):getChildByName("view"):getChildByName("city_name"):addTouchEventListener(onCityName)
            self:getChildByName("view"):getChildByName("view"):getChildByName("power"):addTouchEventListener(onPower)
            
            self:getChildByName("view"):getChildByName("view"):getChildByName("city_name"):getChildByName("change"):addTouchEventListener(self.onChangeName)
            self:getChildByName("view"):getChildByName("view"):getChildByName("power"):getChildByName("peak"):addTouchEventListener(self.onQueryPower)
            self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("inter"):addTouchEventListener(showSelectHeros)
            self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("intericon"):addTouchEventListener(showSelectHeros)
            self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("clip"):getChildByName("icon1"):addTouchEventListener(showSelectHeros)

            self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("defense"):addTouchEventListener(showOfficeHeros)
            self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("defenseicon"):addTouchEventListener(showOfficeHeros)
            self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("clip"):getChildByName("icon2"):addTouchEventListener(showOfficeHeros)
            --加粗
            self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("defense"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
            self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("inter"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
			self._init = true
		end	
	end
end

function mainbaseLayer:updates()
    local lv = dd.myinfo:getLong(1,"level")
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"bid") == self._bid then
            self:getChildByName("view"):getChildByName("view"):getChildByName("city_name"):getChildByName("name"):setString(dd.mycity:getString(1,"name"))
            self:getChildByName("view"):getChildByName("view"):getChildByName("power"):getChildByName("value"):setString(ff.getFormatMoney(dd.myinfo:getLong(1,"power")))
            break
        end
    end
    --出兵数量 出兵队列
    local info = ff.dbmanager:sql_fetch_rows("select * from cfg_citylv where lv="..lv)
    local npcCount = 0
    local npcDeq = 0
    for i=1,dd.myeffect:rowCount() do
        if dd.myeffect:getLong(i,"id") == 1 then
            npcCount = dd.myeffect:getLong(i,"param")
        end
        if dd.myeffect:getLong(i,"id") == 2 then
            npcDeq = dd.myeffect:getLong(i,"param")
        end
    end
    self:getChildByName("view"):getChildByName("view"):getChildByName("work"):getChildByName("armys"):getChildByName("npc_num"):setString(ff.langString("出兵数量")..":"..ff.getFormatMoney(npcCount))
    self:getChildByName("view"):getChildByName("view"):getChildByName("work"):getChildByName("armys"):getChildByName("npc_deq"):setString(ff.langString("可出战部队")..":"..ff.getFormatMoney(npcDeq))
    --地块
    self:getChildByName("view"):getChildByName("view"):getChildByName("work"):getChildByName("farms"):getChildByName("hero"):setString(ff.langString("英雄等级上限")..":"..ff.getFormatMoney(info:getString(1,'herolv')))   
    self:getChildByName("view"):getChildByName("view"):getChildByName("work"):getChildByName("farms"):getChildByName("title"):setString(ff.langString("开放地块")..":"..ff.getFormatMoney(info:getString(1,'field')))
    
    --英雄
    local ishave2 = false
    local ishave4 = false
    local name2 = ""
    local name4 = ""
    for i=1,dd.heros:rowCount() do
        local off = dd.heros:getLong(i,"type")
        local id= dd.heros:getLong(i,"id")
        if off == 2 then     --防御
            ishave2 = true
            if dd.heros:getString(i,"name") == "" then
                name2 = ff.langString(dd.cfgHero[id]['name'])
            else
                name2 = dd.heros:getString(i,"name")
            end
            self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("clip"):getChildByName("icon2"):loadTexture(dd.getHeroBigIcon(id),0)
        elseif off == 4 then
            ishave4 = true
            if dd.heros:getString(i,"name") == "" then
                name4 = ff.langString(dd.cfgHero[id]['name'])
            else
                name4 = dd.heros:getString(i,"name")
            end
            self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("clip"):getChildByName("icon1"):loadTexture(dd.getHeroBigIcon(id),0)
        end
    
    end
    if ishave4 == true then
        self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("intericon"):setVisible(false)
        self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("clip"):getChildByName("icon1"):setVisible(true)
        self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("inter"):getChildByName("chu_label"):setString(ff.langString("内政部长"))
    else
        self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("intericon"):setVisible(true)
        self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("clip"):getChildByName("icon1"):setVisible(false)
        self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("inter"):getChildByName("chu_label"):setString(ff.langString("内政部长"))
    end
    if ishave2 == true then
        self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("defenseicon"):setVisible(false)
        self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("clip"):getChildByName("icon2"):setVisible(true)
        self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("defense"):getChildByName("chu_label"):setString(ff.langString("守备部长"))
    else
        self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("defenseicon"):setVisible(true)
        self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("clip"):getChildByName("icon2"):setVisible(false)
        self:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("defense"):getChildByName("chu_label"):setString(ff.langString("守备部长"))
    end
     
end

function mainbaseLayer:closeMasking()
    self:getChildByName("masking"):setVisible(false)
end

function mainbaseLayer.onChangeNameEvent(param)
    local code = param[1]
    if code == 0 then
        local widget = pop.getDialog("mainbase")
        widget:updates()
    end
end
function mainbaseLayer:onSetHeroPosition(param)
    local code = param[1]
    if code == 0 then        
        self:updates()
    end
end

function mainbaseLayer:onUpdateView()
    self.onEnd(self)
    self:onInit()
    self.onBefore(self)
    self.onStart(self)
end

function mainbaseLayer.onStart(sender)
    sender:updates()
end

function mainbaseLayer.onBefore(sender)
    ff.net:registerEvent(3,dd.Tjf_City_ChangeName,sender.onChangeNameEvent)
    ff.net:registerEvent(3,dd.Tjf_hero_office, function (message)sender:onSetHeroPosition(message)end)
	return false
end

function mainbaseLayer.onEnd(sender)
    sender:stopAllActions()
    ff.net:removeEvent(3,dd.Tjf_City_ChangeName)
    ff.net:removeEvent(3,dd.Tjf_hero_office)
    sender:closeMasking()
    if ff.platform ~= 1 then
        sender:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("clip"):getChildByName("icon1"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("view"):getChildByName("view"):getChildByName("heros"):getChildByName("clip"):getChildByName("icon2"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
    local help = pop.getDialog("mainBaseHelp")
    if help ~= nil and help:isVisible() then
        help:setVisible(false)    
    end
end

function mainbaseLayer.onReturn(sender)
    local widget = pop.getDialog("mainbase")
    if widget ~= nil then
        --如果弹出了修改城市名字面板，则先关闭它
        if pop.isShowing("changeName") == true then
            pop.onClosePopDialog("changeName")   
            return  true      
        end  
    end
    return false
end

function onShowBase(widget,pos)
	local layer = mainbaseLayer.extend(widget)
	layer:setVisible(false)
	layer._pos = pos
	layer:onInit()
	return layer
end