--科技中心
local tecLayer = class("tecLayer")
tecLayer._name = "tecLayer"
tecLayer._init = false
tecLayer._pos  = 0
tecLayer._bid  = 0
tecLayer._lv  = 0
tecLayer._selectid  = 0
tecLayer._selectlv  = 0
tecLayer._selecttype  = 1
tecLayer._type  = 0     --研究/升级
tecLayer._res = false
tecLayer._items = {}
tecLayer._taskid  = 0
tecLayer._hand = nil

function tecLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, tecLayer)
    return target
end

function tecLayer:onInit()
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"pos") == self._pos then
            self._bid = dd.mybuilds:getLong(i,"bid")
            self._lv = dd.mybuilds:getLong(i,"level")
            break
        end
    end

    if self._init == false then
        local hh = dd.currentLayer._pop:getContentSize().height        
        if dd.currentLayer._pop ~= nil then
            self:setContentSize(cc.size(720,hh - 105 - 85))
            self:getChildByName("masking"):setContentSize(cc.size(720,hh - 105 ))
            self:getChildByName("masking"):setPositionY(0)
            
            self:getChildByName("top"):setPositionY(hh - 190 - 52)
            self:getChildByName("nav"):setPositionY(hh - 190 - 52 - 80 -8)
            
            self:getChildByName("view"):setContentSize(cc.size(720,hh - 190 - 52 - 88))
            self:getChildByName("view"):getChildByName("view"):setContentSize(cc.size(720,hh - 190 - 52 - 88))
            --单选框
            local function onSelect(sender,eventType)
                if eventType == ccui.TouchEventType.ended then
                    if sender:getSelectedState() == true then
                        self:getChildByName("nav"):getChildByName("group1"):setSelectedState(false)
                        self:getChildByName("nav"):getChildByName("group2"):setSelectedState(false)
                        self:getChildByName("nav"):getChildByName("group3"):setSelectedState(false)     
                        return
                    end    

                    self:getChildByName("nav"):getChildByName("group1"):setSelectedState(false)
                    self:getChildByName("nav"):getChildByName("group2"):setSelectedState(false)
                    self:getChildByName("nav"):getChildByName("group3"):setSelectedState(false)     
                    if sender:getName() == "group1" then
                        self:stopAllActions()
                        self:getChildByName("nav"):getChildByName("group1"):getChildByName("chu_label"):setColor(cc.c3b(223,239,244))
                        self:getChildByName("nav"):getChildByName("group2"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
                        self:getChildByName("nav"):getChildByName("group3"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
                        self:onShowTec(1)
                    elseif sender:getName() == "group2" then
                        self:stopAllActions()
                        self:getChildByName("nav"):getChildByName("group2"):getChildByName("chu_label"):setColor(cc.c3b(223,239,244))
                        self:getChildByName("nav"):getChildByName("group1"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
                        self:getChildByName("nav"):getChildByName("group3"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
                        self:onShowTec(2)
                    elseif sender:getName() == "group3" then
                        self:stopAllActions()
                        self:getChildByName("nav"):getChildByName("group3"):getChildByName("chu_label"):setColor(cc.c3b(223,239,244))
                        self:getChildByName("nav"):getChildByName("group2"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
                        self:getChildByName("nav"):getChildByName("group1"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
                        self:onShowTec(3)
                    end
                end
            end
            self:getChildByName("nav"):getChildByName("group1"):setSelectedState(false)
            self:getChildByName("nav"):getChildByName("group2"):setSelectedState(false)
            self:getChildByName("nav"):getChildByName("group3"):setSelectedState(false)
            self:getChildByName("nav"):getChildByName("group1"):addTouchEventListener(onSelect) 
            self:getChildByName("nav"):getChildByName("group2"):addTouchEventListener(onSelect)
            self:getChildByName("nav"):getChildByName("group3"):addTouchEventListener(onSelect)           

            self:getChildByName("top"):getChildByName("label"):setString(ff.langString("点击查看建筑效果"))
            --加粗
            self:getChildByName("tecItem"):getChildByName("level"):getVirtualRenderer():enableBold(true)
            self:onInitPop()            
            self:getChildByName("nav"):getChildByName("group1"):setSelectedState(true)
            local function showHelp(sender,eventType)
                if eventType==ccui.TouchEventType.ended then   
                    pop.onShowPopDialog("buildHelp",self._bid,self._lv)
                end
            end
            self:getChildByName("top"):getChildByName("help"):addTouchEventListener(showHelp)
            
            local function onTouchBegan(touch, event)
                self:unshowHand()
                return false
            end
            local listener = cc.EventListenerTouchOneByOne:create()
            listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
            listener:setSwallowTouches(true)
            self:getChildByName("touch"):getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self:getChildByName("touch"))
            
            self._init = true
        end
    end
    self:getChildByName("masking"):setVisible(false)
end

--科技弹窗
function tecLayer:onInitPop()
    --close
    local function closePop(sender,touchEventType)
        if touchEventType == ccui.TouchEventType.ended then
            self.closePop(sender,touchEventType)
        end
    end 
    --研究
    local function studyTec(sender, touchEventType)
        if touchEventType == ccui.TouchEventType.ended then
            if dd.currentLayer._widget:haveSameQue(2) == false then
                local build = pop.getDialog("tec")
                if build ~= nil then
                    local function sendMessage(type)
                        local message = ff.net:createMessage()
                        message:addCmd(0x105)
                        message:addLong(dd.uid)
                        message:addLong(build._type + type)
                        message:addLong(build._selectid)
                        ff.net:rpc(message,false)
                        AudioEngine.playEffect(ff.sounds["r001"])
                    end
                    local function backMessage()
                        sendMessage(3)
                    end
                    if build._res == false then
                        sendMessage(1)
                    else
                        dd.currentLayer._widget:onShowBuyRes(2,build._selectid*100 + build._selectlv+1,build._selectlv+1,backMessage)                        
                    end    
                end    
            else            
                dd.currentLayer._widget:onShowSameQue(2)
            end    
        end    
    end    
    --金币
    local function onGold(sender, touchEventType)
        if touchEventType == ccui.TouchEventType.ended then
            local count = tonumber(sender:getChildByName("count"):getString())
            if count < dd.gold() then
                local message = ff.net:createMessage()
                message:addCmd(0x105)
                message:addLong(dd.uid)         
                message:addLong(self._type + 2)   
                message:addLong(self._selectid)
                ff.net:rpc(message, false)
            else
                local function sure()
                    pop.onShowPopDialog("charge")
                end
                dd.mainUI:onShowSure(ff.langString("金币不足"),ff.langString("充值可以让你立即拥有大量金币.\n是否现在就去?"),sure,true,2,2,ff.langString("充值"))
                --dd.currentLayer._widget:onShowTips("\t"..ff.langString("金币不足"))
            end
        end  
    end
    --前往
    local function goPrePop(sender, touchEventType)
        if touchEventType == ccui.TouchEventType.ended then
            if sender.type == 1 then     --建筑            
                if dd.currentLayer._pop ~= nil then
                    local pos = 0
                    for i=1,dd.mybuilds:rowCount() do
                        if dd.mybuilds:getLong(i,"bid") == sender.toid then                        
                            pos = dd.mybuilds:getLong(i,"pos")           
                        end
                    end
                    dd.currentLayer._pop._pos = pos
                    self:onShowOtherGrade(sender.toid) 
            end
            elseif sender.type == 2 then 
                self:onShowTecPop(sender.toid)
            end
        end
    end
    --free
    local function onFree(sender, touchEventType)
        if touchEventType == ccui.TouchEventType.ended then     
            local message = ff.net:createMessage()
            message:addCmd(0x104)
            message:addLong(dd.uid)
            message:addLong(0)
            message:addLong(0)
            message:addLong(2) --type
            ff.net:rpc(message,false)
            --AudioEngine.playEffect(ff.sounds["r002"])
        end 
    end
    --speedUp
    local function onSpeedUp(sender, touchEventType)
        if touchEventType == ccui.TouchEventType.ended then  
            local message = ff.net:createMessage()
            local function speedUp()
                message:addCmd(0x104)
                message:addLong(dd.uid)
                message:addLong(8) --speedUp
                message:addLong(0)
                message:addLong(2) 
                ff.net:rpc(message,false)
            end
            dd.currentLayer._widget:onShowBuyTime(2,speedUp)
            --guide auther:lhz
            GuideControl:GuideCheck() 
            --guide end
        end 
    end
    --stop
    local function onStop(sender, touchEventType)
        if touchEventType == ccui.TouchEventType.ended then     
            local message = ff.net:createMessage()
            message:addCmd(0x104)
            message:addLong(dd.uid)
            message:addLong(9)
            message:addLong(0)
            message:addLong(2) --type
            ff.net:rpc(message,false)
        end 
    end
    
    local function onHelp(sender, touchEventType)
        if touchEventType == ccui.TouchEventType.ended then     
            dd.mainUI.onUnionHelp(sender, touchEventType)
        end 
    end
    
    self:getChildByName("pop"):getChildByName("view"):getChildByName("close"):addTouchEventListener(closePop)
    self:getChildByName("pop"):getChildByName("view"):getChildByName("lentec"):getChildByName("sure"):addTouchEventListener(studyTec)
    self:getChildByName("pop"):getChildByName("view"):getChildByName("lentec"):getChildByName("gold"):addTouchEventListener(onGold)
    self:getChildByName("pop"):getChildByName("view"):getChildByName("lentec"):getChildByName("need"):getChildByName("go"):addTouchEventListener(goPrePop)

    --self:getChildByName("pop"):getChildByName("view"):getChildByName("que"):getChildByName("speedup"):setVisible(true) 
    self:getChildByName("pop"):getChildByName("view"):getChildByName("que"):getChildByName("help"):setTag(2)
    self:getChildByName("pop"):getChildByName("view"):getChildByName("que"):getChildByName("speedup"):setTag(2)
    self:getChildByName("pop"):getChildByName("view"):getChildByName("que"):getChildByName("free"):setTag(2)
    self:getChildByName("pop"):getChildByName("view"):getChildByName("que"):getChildByName("free"):addTouchEventListener(onFree)
    self:getChildByName("pop"):getChildByName("view"):getChildByName("que"):getChildByName("help"):addTouchEventListener(onHelp)
    self:getChildByName("pop"):getChildByName("view"):getChildByName("que"):getChildByName("speedup"):addTouchEventListener(onSpeedUp)
    self:getChildByName("pop"):getChildByName("view"):getChildByName("que"):getChildByName("pro"):getChildByName("stop"):addTouchEventListener(onStop)
    --加粗
    self:getChildByName("pop"):getChildByName("view"):getChildByName("eitem"):getChildByName("level"):getVirtualRenderer():enableBold(true)

end

function tecLayer.onTecStudying(param)
    local code = param[1]
    if code ~= 0 then
        dd.mainUI:onShowCodeTips(code)
        return
    end
    --guide auther:lhz
    GuideControl:GuideCheck()
    --eguide nd

    local action = param[2]
    local tid = param[3]
    local tec = pop.getDialog("tec")
    tec:updateTec(tec._selecttype)
    tec:updatePop(tec._selectid)
    if action%10 == 1 then
        AudioEngine.playEffect(ff.sounds[206])
    elseif action%10 == 2 then
        AudioEngine.playEffect(ff.sounds["r002"])
        AudioEngine.playEffect(ff.sounds[206])
        AudioEngine.playEffect(ff.sounds[212])
    else
    end
end

function tecLayer.onFreeStudy(params)    
    local tec = pop.getDialog("tec")
    tec:updateTec(tec._selecttype)
    tec:updatePop(tec._selectid)
    --guide auther:lhz
   GuideControl:GuideCheck()
    --guide end
end

function tecLayer:updateEffect(tid,lv)
    local maxLv = dd.cfgTec[tid]['lv_limit']
    local popView = self:getChildByName("pop"):getChildByName("view")
    local hh = popView:getChildByName("effectview"):getContentSize().height
    local effect = {dd.cfgTecLv[100*tid + 1]['eff_1'],dd.cfgTecLv[100*tid + 1]['eff_2'],dd.cfgTecLv[100*tid + 1]['eff_3']}
    local effnum = 0
    local count = 1
    local ihh = 0
    for i, eff in ipairs(effect) do
        if eff ~= 0 then
            effnum = effnum + 1
        end
    end
    if effnum == 0 then
        effnum = 1
    end
    popView:getChildByName("effectview"):getChildByName("tips"):getChildByName("name"):setString(ff.langString(dd.cfgTec[tid]['tec_name']))
    popView:getChildByName("effectview"):getChildByName("tips"):getChildByName("label"):setString(ff.langString(dd.cfgTec[tid]['tec_tip']))
    popView:getChildByName("effectview"):getChildByName("cur"):removeAllChildren(true)
    popView:getChildByName("effectview"):getChildByName("next"):removeAllChildren(true)
    popView:getChildByName("effectview"):getChildByName("cur"):setVisible(false)
    popView:getChildByName("effectview"):getChildByName("next"):setVisible(false)
    if maxLv == 1 then   --开启类
        
        popView:getChildByName("eitem"):getChildByName("tips"):setString(ff.langString("当前等级"))
        local str_cur_w  = popView:getChildByName("eitem"):getChildByName("tips"):getContentSize().width
        popView:getChildByName("eitem"):getChildByName("tips"):setString(ff.langString("下一级"))
        local str_next_w = popView:getChildByName("eitem"):getChildByName("tips"):getContentSize().width
        local pre_width = str_cur_w + 10
        if str_cur_w < str_next_w then
            pre_width = str_next_w + 10
        end

        local richText = ccui.RichText:create()
        richText:ignoreContentAdaptWithSize(false)
        richText:setContentSize(cc.size(470 - pre_width,600))    
        richText:setAutoHeight()
                 
        local temp_str2 = ff.langString(dd.cfgTec[tid]['tec_tip'])
        local chat2 = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, temp_str2, "Helvetica", 20)
        richText:insertElement(chat2, 0)
        richText:formatText()

        local size = richText:getContentSize()
        local space = size.height + 10
        if space < 30 then
            space = 30
        end
        richText:setPosition(cc.p(pre_width + 470/2 - pre_width/2,space/2 +4))
        popView:getChildByName("effectview"):getChildByName("cur"):setContentSize(cc.size(485, space))
        popView:getChildByName("effectview"):getChildByName("cur"):addChild(richText)
        popView:getChildByName("effectview"):getChildByName("cur"):setVisible(true)
        popView:getChildByName("effectview"):getChildByName("next"):setVisible(false)
        --固定文字
        local richText_h = ccui.RichText:create()
        richText_h:ignoreContentAdaptWithSize(false)
        richText_h:setContentSize(cc.size(pre_width,300))    
        richText_h:setAutoHeight()
        local temp_str = ""
        local temp_w   = 0
        if lv == 0 then
            temp_str  = ff.langString("下一级")
            temp_w    = str_next_w
        else
            temp_str = ff.langString("当前等级")
            temp_w    = str_cur_w
        end
        local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, temp_str, "Helvetica", 20)
        richText_h:insertElement(chat,0)
        richText_h:formatText()
        richText_h:setPosition(cc.p(pre_width - temp_w +pre_width/2,space - 10-5-1))
        popView:getChildByName("effectview"):getChildByName("cur"):addChild(richText_h)

        ihh = 110 + space + 20
        if ihh <= hh then
            ihh = hh
        end
        popView:getChildByName("effectview"):setInnerContainerSize(cc.size(485,ihh))
        popView:getChildByName("effectview"):getChildByName("tips"):setPositionY(ihh - 115)
        popView:getChildByName("effectview"):getChildByName("cur"):setPositionY(ihh - 115 - space - 3)
    else                --升级类型
        popView:getChildByName("eitem"):getChildByName("tips"):setString(ff.langString("当前等级"))
        local str_cur_w  = popView:getChildByName("eitem"):getChildByName("tips"):getContentSize().width
        popView:getChildByName("eitem"):getChildByName("tips"):setString(ff.langString("下一级"))
        local str_next_w = popView:getChildByName("eitem"):getChildByName("tips"):getContentSize().width
        local pre_width = str_cur_w + 10
        if str_cur_w < str_next_w then
            pre_width = str_next_w + 10
        end

        if lv == 0 then --lv
            --cur
            local richText = ccui.RichText:create()
            richText:ignoreContentAdaptWithSize(false)
            richText:setContentSize(cc.size(470 - pre_width,600))    
            richText:setAutoHeight()

            local cur_count = 0
            for i, effid in ipairs(effect) do
                if effid ~= 0 then                   
                    local temp_str2 = self.getEffectTips(effid,0).." "
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, temp_str2, "Helvetica", 20)
                    richText:insertElement(chat2, cur_count)
                    richText:formatText()
                    cur_count = cur_count + 1

                    local temp_str3 = self.getEffectValue(effid,0).."\n"
                    local chat3 = ccui.RichElementText:create(1, cc.c3b(7,159,0), 255, temp_str3, "Helvetica", 20)
                    richText:insertElement(chat3, cur_count)
                    richText:formatText()
                    cur_count = cur_count + 1
                end
            end

            local size = richText:getContentSize()
            local space = size.height + 10
            if space < 30 then
                space = 30
            end
            richText:setPosition(cc.p(pre_width + 470/2 - pre_width/2,space/2 +4))
           
            popView:getChildByName("effectview"):getChildByName("cur"):setContentSize(cc.size(485, space))
            popView:getChildByName("effectview"):getChildByName("cur"):addChild(richText)

            --固定文字
            local richText_h = ccui.RichText:create()
            richText_h:ignoreContentAdaptWithSize(false)
            richText_h:setContentSize(cc.size(pre_width,300))    
            richText_h:setAutoHeight()
            local str_h = ff.langString("当前等级")
            local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, str_h, "Helvetica", 20)
            richText_h:insertElement(chat,0)
            richText_h:formatText()
            richText_h:setPosition(cc.p(pre_width - str_cur_w + pre_width/2,space - 10-5-1))
            popView:getChildByName("effectview"):getChildByName("cur"):addChild(richText_h)
            --next
            local richText2 = ccui.RichText:create()
            richText2:ignoreContentAdaptWithSize(false)
            richText2:setContentSize(cc.size(470 - pre_width,600))    
            richText2:setAutoHeight()

            local next_count = 0
            for i, effid in ipairs(effect) do
                if effid ~= 0 then
                    local value = dd.cfgTecLv[tid*100 + 1]['value_'..i]
                    local temp_str2 = self.getEffectTips(effid,value).." "
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, temp_str2, "Helvetica", 20)
                    richText2:insertElement(chat2, next_count)
                    richText2:formatText()
                    next_count = next_count + 1

                    local temp_str3 = self.getEffectValue(effid,value).."\n"
                    local chat3 = ccui.RichElementText:create(1, cc.c3b(7,159,0), 255, temp_str3, "Helvetica", 20)
                    richText2:insertElement(chat3, next_count)
                    richText2:formatText()
                    next_count = next_count + 1
                end
            end

            local size = richText:getContentSize()
            local space = size.height + 10
            if space < 30 then
                space = 30
            end
            richText2:setPosition(cc.p(pre_width + 470/2 - pre_width/2,space/2 +4))
            popView:getChildByName("effectview"):getChildByName("next"):setContentSize(cc.size(485, space))
            popView:getChildByName("effectview"):getChildByName("next"):addChild(richText2)
            --固定文字
            local richText_h = ccui.RichText:create()
            richText_h:ignoreContentAdaptWithSize(false)
            richText_h:setContentSize(cc.size(pre_width,300))    
            richText_h:setAutoHeight()
            local temp_str = ff.langString("下一级")
            local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, temp_str, "Helvetica", 20)
            richText_h:insertElement(chat,0)
            richText_h:formatText()
            richText_h:setPosition(cc.p(pre_width - str_next_w +pre_width/2,space - 10-5-1))
            popView:getChildByName("effectview"):getChildByName("next"):addChild(richText_h)

            ihh = 110 + space*2 + 20
            if ihh <= hh then
                ihh = hh
            end
            popView:getChildByName("effectview"):setInnerContainerSize(cc.size(485,ihh))
            popView:getChildByName("effectview"):getChildByName("tips"):setPositionY(ihh - 115)

            popView:getChildByName("effectview"):getChildByName("cur"):setPositionY(ihh - 115 - space - 3)
            popView:getChildByName("effectview"):getChildByName("next"):setPositionY(ihh - 115 - space*2 - 6)
            popView:getChildByName("effectview"):getChildByName("cur"):setVisible(true)
            popView:getChildByName("effectview"):getChildByName("next"):setVisible(true)
        elseif lv == maxLv then  --最高级
            local richText = ccui.RichText:create()
            richText:ignoreContentAdaptWithSize(false)
            richText:setContentSize(cc.size(470 - pre_width,600))    
            richText:setAutoHeight()

            local cur_count = 0
            for i, effid in ipairs(effect) do
                if effid ~= 0 then
                    local value = dd.cfgTecLv[tid*100 + lv]['value_'..i]                    
                    local temp_str2 = self.getEffectTips(effid,value).." "
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, temp_str2, "Helvetica", 20)
                    richText:insertElement(chat2, cur_count)
                    richText:formatText()
                    cur_count = cur_count + 1

                    local temp_str3 = self.getEffectValue(effid,value).."\n"
                    local chat3 = ccui.RichElementText:create(1, cc.c3b(7,159,0), 255, temp_str3, "Helvetica", 20)
                    richText:insertElement(chat3, cur_count)
                    richText:formatText()
                    cur_count = cur_count + 1
                end
            end

            local size = richText:getContentSize()
            local space = size.height + 10
            if space < 30 then
                space = 30
            end
            richText:setPosition(cc.p(pre_width + 470/2 - pre_width/2,space/2 +4))
            popView:getChildByName("effectview"):getChildByName("cur"):setContentSize(cc.size(485, space))
            popView:getChildByName("effectview"):getChildByName("cur"):addChild(richText)
            popView:getChildByName("effectview"):getChildByName("cur"):setVisible(true)
            popView:getChildByName("effectview"):getChildByName("next"):setVisible(false)
            --固定文字
            local richText_h = ccui.RichText:create()
            richText_h:ignoreContentAdaptWithSize(false)
            richText_h:setContentSize(cc.size(pre_width,300))    
            richText_h:setAutoHeight()
            local temp_str = ff.langString("当前等级")
            local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, temp_str, "Helvetica", 20)
            richText_h:insertElement(chat,0)
            richText_h:formatText()
            richText_h:setPosition(cc.p(pre_width - str_cur_w +pre_width/2,space - 10-5-1))
            popView:getChildByName("effectview"):getChildByName("cur"):addChild(richText_h)

            ihh = 110 + space + 20
            if ihh <= hh then
                ihh = hh
            end
            popView:getChildByName("effectview"):setInnerContainerSize(cc.size(485,ihh))
            popView:getChildByName("effectview"):getChildByName("tips"):setPositionY(ihh - 115)
            popView:getChildByName("effectview"):getChildByName("cur"):setPositionY(ihh - 115 - space - 3)
        else
            local richText = ccui.RichText:create()
            richText:ignoreContentAdaptWithSize(false)
            richText:setContentSize(cc.size(470 - pre_width,600))    
            richText:setAutoHeight()

            local cur_count = 0
            for i, effid in ipairs(effect) do
                if effid ~= 0 then
                    local value = dd.cfgTecLv[tid*100 + lv]['value_'..i]               
                    local temp_str2 = self.getEffectTips(effid,value).." "
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, temp_str2, "Helvetica", 20)
                    richText:insertElement(chat2, cur_count)
                    richText:formatText()
                    cur_count = cur_count + 1

                    local temp_str3 = self.getEffectValue(effid,value).."\n"
                    local chat3 = ccui.RichElementText:create(1, cc.c3b(7,159,0), 255, temp_str3, "Helvetica", 20)
                    richText:insertElement(chat3, cur_count)
                    richText:formatText()
                    cur_count = cur_count + 1
                end
            end

            local size = richText:getContentSize()
            local space = size.height + 10
            if space < 30 then
                space = 30
            end
            richText:setPosition(cc.p(pre_width + 470/2 - pre_width/2,space/2 +4))
            popView:getChildByName("effectview"):getChildByName("cur"):setContentSize(cc.size(485, space))
            popView:getChildByName("effectview"):getChildByName("cur"):addChild(richText)
            --固定文字
            local richText_h = ccui.RichText:create()
            richText_h:ignoreContentAdaptWithSize(false)
            richText_h:setContentSize(cc.size(pre_width,300))    
            richText_h:setAutoHeight()
            local temp_str = ff.langString("当前等级")
            local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, temp_str, "Helvetica", 20)
            richText_h:insertElement(chat,0)
            richText_h:formatText()
            richText_h:setPosition(cc.p(pre_width - str_cur_w +pre_width/2,space - 10-5-1))
            popView:getChildByName("effectview"):getChildByName("cur"):addChild(richText_h)

            --next
            local richText2 = ccui.RichText:create()
            richText2:ignoreContentAdaptWithSize(false)
            richText2:setContentSize(cc.size(470 - pre_width,600))    
            richText2:setAutoHeight()

            local next_count = 0
            for i, effid in ipairs(effect) do
                if effid ~= 0 then
                    local value = dd.cfgTecLv[tid*100 + lv + 1]['value_'..i]
                    local temp_str2 = self.getEffectTips(effid,value).." "
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, temp_str2, "Helvetica", 20)
                    richText2:insertElement(chat2, next_count)
                    richText2:formatText()
                    next_count = next_count + 1

                    local temp_str3 = self.getEffectValue(effid,value).."\n"
                    local chat3 = ccui.RichElementText:create(1, cc.c3b(7,159,0), 255, temp_str3, "Helvetica", 20)
                    richText2:insertElement(chat3, next_count)
                    richText2:formatText()
                    next_count = next_count + 1
                end
            end

            local size = richText:getContentSize()
            local space = size.height + 10
            if space < 30 then
                space = 30
            end
            richText2:setPosition(cc.p(pre_width + 470/2 - pre_width/2,space/2 +4))
            popView:getChildByName("effectview"):getChildByName("next"):setContentSize(cc.size(485, space))
            popView:getChildByName("effectview"):getChildByName("next"):addChild(richText2)
            --固定文字
            local richText_h = ccui.RichText:create()
            richText_h:ignoreContentAdaptWithSize(false)
            richText_h:setContentSize(cc.size(pre_width,300))    
            richText_h:setAutoHeight()
            local temp_str = ff.langString("下一级")
            local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, temp_str, "Helvetica", 20)
            richText_h:insertElement(chat,0)
            richText_h:formatText()
            richText_h:setPosition(cc.p(pre_width - str_next_w +pre_width/2,space - 10-5-1))
            popView:getChildByName("effectview"):getChildByName("next"):addChild(richText_h)
            
            ihh = 110 + space*2 + 20
            if ihh <= hh then
                ihh = hh
            end
            popView:getChildByName("effectview"):setInnerContainerSize(cc.size(485,ihh))
            popView:getChildByName("effectview"):getChildByName("tips"):setPositionY(ihh - 115)

            popView:getChildByName("effectview"):getChildByName("cur"):setPositionY(ihh - 115 - space - 3)
            popView:getChildByName("effectview"):getChildByName("next"):setPositionY(ihh - 115 - space*2 - 6)
            popView:getChildByName("effectview"):getChildByName("cur"):setVisible(true)
            popView:getChildByName("effectview"):getChildByName("next"):setVisible(true)
        end
    end  
end

function tecLayer:onShowTecPop(tid)
    local popView = self:getChildByName("pop"):getChildByName("view")
    --self:getChildByName("pop"):setVisible(true)
    self.openPop()       
    self:updatePop(tid)
end

function tecLayer:onShowTec(type)
    --guide auther:lhz
   GuideControl:GuideCheck()
    --guide end
    self:getChildByName("view"):getChildByName("view"):jumpToTop()
    self:updateTec(type)
end
function tecLayer.onShowPop(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("tec")
        widget:onShowTecPop(sender.tid)
    end
end

function tecLayer:showCross(tid,posx,posy,xspace,yspace,lineindex)
    local pretid = {dd.cfgTecShow[tid]['preid1'],dd.cfgTecShow[tid]['preid2'],dd.cfgTecShow[tid]['preid3']}
    local iline = dd.cfgTecShow[tid]['index']  --行
    local irow = dd.cfgTecShow[tid]['pos']     --列
    lineindex = 1
    for i, id in pairs(pretid) do
        if id ~= 0 then
            local dline = iline - dd.cfgTecShow[id]['index']
            local drow = irow - dd.cfgTecShow[id]['pos']
            if drow == 0 then
                if dline > 0 then
                    local line = self:getChildByName("line"..lineindex):clone()
                    line:setVisible(true)
                    line:setAnchorPoint(cc.p(0.5,0))
                    line:setPosition(cc.p(posx + 102, posy + 120 ))
                    line:setContentSize(cc.size(9,yspace))
                    self:getChildByName("view"):getChildByName("view"):getChildByName("cross"):addChild(line)
                end
            elseif drow < 0 then --在右边
                if dline > 0 then
                    local line = self:getChildByName("line"..lineindex):clone()
                    line:setVisible(true)                    
                    line:setAnchorPoint(cc.p(0.5,0))
                    line:setPosition(cc.p(posx + 102-4.5, posy + yspace-50 + 22))
                    line:setRotation(90)
                    line:setContentSize(cc.size(9,xspace*(-drow)+9))
                    self:getChildByName("view"):getChildByName("view"):getChildByName("cross"):addChild(line)

                    --start
                    local line0 = self:getChildByName("line"..lineindex):clone()
                    line0:setVisible(true)
                    line0:setAnchorPoint(cc.p(0.5,0))
                    line0:setPosition(cc.p(posx + 102, posy + yspace-50 + 0))
                    line0:setContentSize(cc.size(9,23.8))
                    self:getChildByName("view"):getChildByName("view"):getChildByName("cross"):addChild(line0)

                    --end
                    local line1 = self:getChildByName("line"..lineindex):clone()
                    line1:setVisible(true)
                    line1:setAnchorPoint(cc.p(0.5,0))
                    line1:setPosition(cc.p(posx + 102 + xspace*(-drow), posy + yspace-50 + 18))
                    line1:setContentSize(cc.size(9,35 + xspace*(dline-1)))
                    self:getChildByName("view"):getChildByName("view"):getChildByName("cross"):addChild(line1)
                elseif dline == 0 then
                    local line = self:getChildByName("line"..lineindex):clone()
                    line:setVisible(true)                    
                    line:setAnchorPoint(cc.p(0.5,0))
                    line:setPosition(cc.p(posx + 102-4.5, posy + yspace/2-10))
                    line:setRotation(90)
                    line:setContentSize(cc.size(9,xspace*(-drow)+9))
                    self:getChildByName("view"):getChildByName("view"):getChildByName("cross"):addChild(line)
                end
            elseif drow > 0 then --在左边
                if dline > 0 then
                    --横线                    
                    local line = self:getChildByName("line"..lineindex):clone()
                    line:setVisible(true)                    
                    line:setAnchorPoint(cc.p(0.5,1))
                    line:setPosition(cc.p(posx + 102+4.5, posy + yspace-50 + 22))
                    line:setRotation(90)
                    line:setContentSize(cc.size(9,xspace*(drow)+9))
                    self:getChildByName("view"):getChildByName("view"):getChildByName("cross"):addChild(line)
                    
                    --start
                    local line0 = self:getChildByName("line"..lineindex):clone()
                    line0:setVisible(true)
                    line0:setAnchorPoint(cc.p(0.5,0))
                    line0:setPosition(cc.p(posx + 102, posy + yspace-50 + 0))
                    line0:setContentSize(cc.size(9,23.8))
                    self:getChildByName("view"):getChildByName("view"):getChildByName("cross"):addChild(line0)
                    --end
                    local line1 = self:getChildByName("line"..lineindex):clone()
                    line1:setVisible(true)
                    line1:setAnchorPoint(cc.p(0.5,0))
                    line1:setPosition(cc.p(posx + 102 - xspace*(drow), posy + yspace-50 + 18))
                    line1:setContentSize(cc.size(9,35 + xspace*(dline-1)))
                    self:getChildByName("view"):getChildByName("view"):getChildByName("cross"):addChild(line1)
                elseif dline == 0 then
                    local line = self:getChildByName("line"..lineindex):clone()
                    line:setVisible(true)                    
                    line:setAnchorPoint(cc.p(0.5,1))
                    line:setPosition(cc.p(posx + 102+4.5, posy+yspace/2-10))
                    line:setRotation(90)
                    line:setContentSize(cc.size(9,xspace*(drow)+9))
                    self:getChildByName("view"):getChildByName("view"):getChildByName("cross"):addChild(line)
                end
            end 
        end
    end
end

--前置检查
function tecLayer:PreCheck(tlvid)
    cclog("tlvid:"..tlvid)
    local prebid = dd.cfgTecLv[tlvid]['pre_build_id']
    local preblv = dd.cfgTecLv[tlvid]['pre_build_lv']

    local pretid1 = math.floor(dd.cfgTecLv[tlvid]['pre_tec_1']/100)
    local pretid2 = math.floor(dd.cfgTecLv[tlvid]['pre_tec_2']/100)
    local pretid3 = math.floor(dd.cfgTecLv[tlvid]['pre_tec_3']/100)
    local pretlv1 = dd.cfgTecLv[tlvid]['pre_tec_1'] - pretid1*100
    local pretlv2 = dd.cfgTecLv[tlvid]['pre_tec_2'] - pretid2*100
    local pretlv3 = dd.cfgTecLv[tlvid]['pre_tec_3'] - pretid3*100

    local prebuild = true
    local pretec1 = true
    local pretec2 = true
    local pretec3 = true
        
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"bid") == prebid then                
            local lv = dd.mybuilds:getLong(i,"level")
            if lv >= preblv then
                prebuild = false
            end
            break
        end
    end
    --前置建筑满足 检查前置科技1
    if prebuild == true then
    else
        if pretid1 == 0 then
            pretec1 = false
        end
        if pretid2 == 0 then
            pretec2 = false
        end
        if pretid3 == 0 then
            pretec3 = false
        end
        for i=1,dd.myTec:rowCount() do
            local lv = dd.myTec:getLong(i,"lv")
            if dd.myTec:getLong(i,"tec_id") == pretid1 then        
                if lv >= pretlv1 then
                    pretec1 = false
                end
            elseif  dd.myTec:getLong(i,"tec_id") == pretid2 then
                if lv >= pretlv2 then
                    pretec2 = false
                end
            elseif  dd.myTec:getLong(i,"tec_id") == pretid3 then   
                if lv >= pretlv3 then
                    pretec3 = false
                end
            end
        end
    end
    return{prebuild, pretec1, pretec2, pretec3}
end

function tecLayer.openPop()
    local widget = pop.getDialog("tec") 
    widget:getChildByName("masking"):setVisible(true)
    
    widget:getChildByName("pop"):setVisible(true)
    --第3个参数false必然，第4个参数表示参加newguide检查
    pop.showPopEffect(12,widget:getChildByName("pop"):getChildByName("view"),false,true)
end


function tecLayer.closePop(sender,touchEventType)
    local function unShow()
        local widget = pop.getDialog("tec")
        widget:getChildByName("masking"):setVisible(false)
        widget:getChildByName("pop"):setVisible(false)
        --guide auther:lhz
        GuideControl:GuideCheck()
        --guide end
    end    
    
    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("tec")
        widget:getChildByName("masking"):setVisible(false)
        widget:getChildByName("pop"):setVisible(false) 
        --guide auther:lhz
        GuideControl:GuideCheck()
        --guide end
                       
    end
end

function tecLayer.showActionDetaile()
    local sender = pop.getDialog("tec")
    if sender ~= nil then
        local type = 2
        for i=1,dd.mylists:rowCount() do
            if dd.mylists:getLong(i,"type") == type then
                local tid       = dd.mylists:getLong(i,"param1")
                local starttime = dd.mylists:getLong(i,"start")
                local endtime   = dd.mylists:getLong(i,"end")
                local curtime   = dd.getServerTime()
                local total     = endtime - starttime
                if total <= 0 then
                    dd.mylists:delRow(i)
                    return
                end    
                local now       = curtime - starttime
                local progress  = math.floor(now * 100 / total)
                if progress > 100 then
                    progress = 100
                end
                if progress < 0 then
                    progress = 0
                end
                local view = sender:getChildByName("pop"):getChildByName("view"):getChildByName("que")
                view:getChildByName("pro"):getChildByName("progress"):getChildByName("progress"):setPercent(progress) 

                               
                if (total - now) > dd.getRealFreeTick() then
                    if dd.myUnion:getLong(1,"unionid") > 0 and dd.myHelper[2] == -1 then    
                        view:getChildByName("help"):setVisible(true)
                        view:getChildByName("speedup"):setVisible(false)  
                        view:getChildByName("free"):setVisible(false)
                    else
                        view:getChildByName("help"):setVisible(false)
                        view:getChildByName("speedup"):setVisible(true)  
                        view:getChildByName("free"):setVisible(false)
                    end
                else
                    view:getChildByName("help"):setVisible(false)
                    view:getChildByName("speedup"):setVisible(false)  
                    view:getChildByName("free"):setVisible(true)
                end
                
                if now > total then
                    now = total
                end    
                view:getChildByName("time"):setString(ff.getLeftTime((total - now),":"))
                return
            end
        end
        sender:stopAllActions()
        sender:updateTec(sender._selecttype)
        if sender:getChildByName("pop"):isVisible() == true then
            sender:updatePop(sender._selectid)        
        end
    end 
end

function tecLayer.showAction()
    local sender = pop.getDialog("tec")
    if sender ~= nil then
        local type = 2
        for i=1,dd.mylists:rowCount() do
            if dd.mylists:getLong(i,"type") == type then
                local tid       = dd.mylists:getLong(i,"param1")
                local starttime = dd.mylists:getLong(i,"start")
                local endtime   = dd.mylists:getLong(i,"end")
                local curtime   = dd.getServerTime()
                local total     = endtime - starttime
                if total == 0 then
                    return
                end    
                local now       = curtime - starttime
                local progress  = math.floor(now * 100 / total)
                if progress > 100 then
                    progress = 100
                end
                if progress < 0 then
                    progress = 0
                end

                sender:getChildByName("view"):getChildByName("view"):getChildByTag(10000):getChildByName("progress"):setPercent(100 - progress)    

                local item = sender:getChildByName("view"):getChildByName("view"):getChildByTag(10000)
                if item ~= nil then
                    if (total - now) > dd.getRealFreeTick() then
                        item:getChildByName("progress"):setColor(cc.c3b(255,255,255))
                    else
                        item:getChildByName("progress"):setColor(cc.c3b(0,180,0))
                    end
                end

                if now > total then
                    now = total
                end    
                sender:getChildByName("view"):getChildByName("view"):getChildByTag(10000):getChildByName("time"):setString(ff.getLeftTime((total - now),":"))
                return
            end
        end
        sender:stopAllActions()   
        sender:updateTec(sender._selecttype)
        if sender:getChildByName("pop"):isVisible() == true then
            sender:updatePop(sender._selectid)        
        end
    end 
end

function tecLayer:onUpdateQueDetaile(tid)
    --判断显示研究中还是研究按钮
    self:getChildByName("pop"):getChildByName("view"):getChildByName("lentec"):setVisible(true)
    self:getChildByName("pop"):getChildByName("view"):getChildByName("que"):setVisible(false)

    for i=1,dd.mylists:rowCount() do
        if dd.mylists:getLong(i,"type") == 2 and dd.mylists:getLong(i,"param1") == tid then
            self:getChildByName("pop"):getChildByName("view"):getChildByName("lentec"):setVisible(false)
            self:getChildByName("pop"):getChildByName("view"):getChildByName("que"):setVisible(true)
            self.showActionDetaile()
            schedule(self, self.showActionDetaile,1)
            break
        end
    end
end
--打开界面使用
function tecLayer:updateType(type)
    if type == 1 then 
        self:getChildByName("nav"):getChildByName("group1"):setSelectedState(true)
        self:getChildByName("nav"):getChildByName("group2"):setSelectedState(false)
        self:getChildByName("nav"):getChildByName("group3"):setSelectedState(false)
        self:getChildByName("nav"):getChildByName("group1"):getChildByName("chu_label"):setColor(cc.c3b(223,239,244))
        self:getChildByName("nav"):getChildByName("group2"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
        self:getChildByName("nav"):getChildByName("group3"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
        self:updateTec(1)
    elseif type == 2 then
        self:getChildByName("nav"):getChildByName("group1"):setSelectedState(false)
        self:getChildByName("nav"):getChildByName("group2"):setSelectedState(true)
        self:getChildByName("nav"):getChildByName("group3"):setSelectedState(false)
        self:getChildByName("nav"):getChildByName("group2"):getChildByName("chu_label"):setColor(cc.c3b(223,239,244))
        self:getChildByName("nav"):getChildByName("group1"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
        self:getChildByName("nav"):getChildByName("group3"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
        self:updateTec(2)
    elseif type == 3 then
        self:getChildByName("nav"):getChildByName("group1"):setSelectedState(false)
        self:getChildByName("nav"):getChildByName("group2"):setSelectedState(false)
        self:getChildByName("nav"):getChildByName("group3"):setSelectedState(true)
        self:getChildByName("nav"):getChildByName("group3"):getChildByName("chu_label"):setColor(cc.c3b(223,239,244))
        self:getChildByName("nav"):getChildByName("group2"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
        self:getChildByName("nav"):getChildByName("group1"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
        self:updateTec(3)
    end
end

function tecLayer:updateTec(type)
    self:getChildByName("view"):getChildByName("view"):getChildByName("cross"):removeAllChildren(true)
    self._selecttype = type
    --计算深度
    local maxIndex = 0
    for tid,item in pairs(dd.cfgTecShow) do
        if item['type'] == type then
            if item['index'] > maxIndex then
                maxIndex = item['index']
            end
        end
    end    
    --隐藏items
    for i,v in ipairs(self._items) do
        if tolua.isnull(v) then
            self._items[i] = nil
        else
            v:setVisible(false)
            v:setTag(0)
        end
    end

    --计算滚动区域
    local x_space = 240
    local y_space = 285
    local posX = 16
    local posY = maxIndex*y_space - 50
    local count = 1
    local lineindex = 1
    self:getChildByName("view"):getChildByName("view"):setInnerContainerSize(cc.size(720, posY))
    self:getChildByName("view"):getChildByName("view"):getChildByName("cross"):setContentSize(cc.size(720,posY))
    --科技
    for tid,item in pairs(dd.cfgTecShow) do
        if item['type'] == type then 
            local tec = self._items[count]
            if tec == nil then
                tec = self:getChildByName("tecItem"):clone() 
                self._items[count] = tec
                self:getChildByName("view"):getChildByName("view"):addChild(tec,1)
            end   
            count = count + 1   
            tec:setPositionX(posX + (item['pos'] - 1)*x_space )
            tec:setPositionY(posY - 235 - (item['index']-1)*y_space)         

            local lv = 0         
            for i=1, dd.myTec:rowCount() do
                if dd.myTec:getLong(i,'tec_id') == tid then    
                    lv = dd.myTec:getLong(i,'lv')
                    break
                end
            end
            local maxLv = dd.cfgTec[tid]['lv_limit']
            --icon       
            tec:getChildByName("tec"):getChildByName("icon"):loadTexture(dd.getTecIcon(tid),0)
            tec:getChildByName("name"):getChildByName("label"):setString(ff.langString(dd.cfgTec[tid]['tec_name']))
            tec:getChildByName("level"):setString("LV."..lv.."/"..maxLv)
            tec:setVisible(true) 
            tec:setTag(tid)
            tec.tid = tid
            
            --检查锁
            if lv < dd.cfgTec[tid]['lv_limit'] then
                local btable = nil
                btable = self:PreCheck(tid*100 + lv + 1)
                local prebuild = btable[1]
                local pretec1 = btable[2]
                local pretec2 = btable[3]
                local pretec3 = btable[4]
    
                if lv > 0 then
                    tec:getChildByName("lock"):setVisible(false)
                    if (prebuild or pretec1 or pretec2 or pretec3) == false then
                        tec:getChildByName("lockpanel"):setVisible(false)
                    else
                        tec:getChildByName("lockpanel"):setVisible(true)
                        tec:getChildByName("lockpanel"):loadTexture(dd.getPathFromUI("pag_grey.png",1))
                    end
                    lineindex = 1
                else
                    if (prebuild or pretec1 or pretec2 or pretec3) == false then
                        tec:getChildByName("lock"):setVisible(false)
                        tec:getChildByName("lockpanel"):setVisible(false)
                        lineindex = 1
                    else
                        tec:getChildByName("lock"):setVisible(true)
                        tec:getChildByName("lock"):loadTexture(dd.getPathFromUI("lock02.png",1))
                        tec:getChildByName("lockpanel"):setVisible(true)
                        tec:getChildByName("lockpanel"):loadTexture(dd.getPathFromUI("pag_grey.png",1))
                        lineindex = 2
                    end
                end
            else
                lineindex = 1
                tec:getChildByName("lock"):setVisible(false)
                tec:getChildByName("lockpanel"):setVisible(false)
            end
            tec:addTouchEventListener(self.onShowPop)

            self:showCross(tid,tec:getPositionX(),tec:getPositionY(),x_space,y_space,lineindex)
            --是否正在研究
            tec:getChildByName("clock"):setVisible(false)
            tec:getChildByName("time"):setVisible(false)
            tec:getChildByName("progress"):setVisible(false)
        end
    end     
    --检查排程
    for i=1,dd.mylists:rowCount() do
        if dd.mylists:getLong(i,"type") == 2 then
            local tid = dd.mylists:getLong(i,"param1")
            local tec = self:getChildByName("view"):getChildByName("view"):getChildByTag(tid)
            if tec ~= nil then
                tec:getChildByName("clock"):setVisible(true)
                tec:getChildByName("time"):setVisible(true)
                tec:getChildByName("progress"):setVisible(true)
                tec:setTag(10000)
                self.showAction()
                schedule(self, self.showAction,1)
                break
            end            
        end
    end  
end


function tecLayer:updatePop(tid)
    if self:getChildByName("pop"):isVisible() == false then
        return
    end
    local popView = self:getChildByName("pop"):getChildByName("view")     
    --icon
    popView:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getTecIcon(tid),0)    
    
    popView:getChildByName("res"):getChildByName("res_1"):getChildByName("res_have"):setString(dd.showKM(dd.stone(),4))
    popView:getChildByName("res"):getChildByName("res_2"):getChildByName("res_have"):setString(dd.showKM(dd.wood(),4))
    popView:getChildByName("res"):getChildByName("res_3"):getChildByName("res_have"):setString(dd.showKM(dd.iron(),4))
    popView:getChildByName("res"):getChildByName("res_4"):getChildByName("res_have"):setString(dd.showKM(dd.food(),4))
    popView:getChildByName("res"):getChildByName("res_5"):getChildByName("res_have"):setString(dd.showKM(dd.silver(),4))
    
    --显示当前等级科技
    local lv = 0  
    local maxLv = dd.cfgTec[tid]['lv_limit']
    local tlvid = 0
    local tnextid = 0  
    local time = 0
    local gold = 0
    local prebid = 0
    local preblv = 0
    local pretid1 = 0
    local pretid2 = 0
    local pretid3 = 0
    local pretlv1 = 0
    local pretlv2 = 0
    local pretlv3 = 0

    for i=1, dd.myTec:rowCount() do
        if dd.myTec:getLong(i,'tec_id') == tid then       
            lv = dd.myTec:getLong(i,'lv')
            break
        end
    end
    tlvid = 100*tid + lv
    tnextid = tlvid + 1
    popView:getChildByName("icon"):getChildByName("level"):setString("LV."..lv.."/"..maxLv) 
    --研究按钮 金币研究按钮
    self._selectid = tid
    self._selectlv = lv
    self:updateEffect(tid,lv)
    --当前等级为0
    if lv <= 0 then   
        self._type = 10    
    else  
        self._type = 20  --是升级 
    end

    --当前等级最高 
    local condition = false
    local ismax = false
    if lv == maxLv then
        popView:getChildByName("lentec"):getChildByName("need"):getChildByName("label"):setString(ff.langString("已达最高等级"))
        condition = false
        ismax = true
        popView:getChildByName("res"):getChildByName("res_1"):getChildByName("res_need"):setString(0)
        popView:getChildByName("res"):getChildByName("res_2"):getChildByName("res_need"):setString(0)
        popView:getChildByName("res"):getChildByName("res_3"):getChildByName("res_need"):setString(0)
        popView:getChildByName("res"):getChildByName("res_4"):getChildByName("res_need"):setString(0)
        popView:getChildByName("res"):getChildByName("res_5"):getChildByName("res_need"):setString(0)
    else 
        time = dd.cfgTecLv[tnextid]['time_cost']
		for var=1, dd.myeffect:rowCount() do
            if dd.myeffect:getLong(var,'id') == 6 then
				local param = dd.myeffect:getLong(var,'param')/dd.cfgEffect[6]["value"]
				time = math.ceil(time/(1+param/100))
				break
			end
		end
        prebid = dd.cfgTecLv[tnextid]['pre_build_id']
        preblv = dd.cfgTecLv[tnextid]['pre_build_lv']

        pretid1 = math.floor(dd.cfgTecLv[tnextid]['pre_tec_1']/100)
        pretid2 = math.floor(dd.cfgTecLv[tnextid]['pre_tec_2']/100)
        pretid3 = math.floor(dd.cfgTecLv[tnextid]['pre_tec_3']/100)
        pretlv1 = dd.cfgTecLv[tnextid]['pre_tec_1'] - pretid1*100
        pretlv2 = dd.cfgTecLv[tnextid]['pre_tec_2'] - pretid2*100
        pretlv3 = dd.cfgTecLv[tnextid]['pre_tec_3'] - pretid3*100

        local btable = nil
        if lv>0 then
            btable = self:PreCheck(tlvid + 1)
        else
            btable = self:PreCheck(tlvid + 1)
        end
        local prebuild = btable[1]
        local pretec1 = btable[2]
        local pretec2 = btable[3]
        local pretec3 = btable[4]

        if prebuild == true then
            popView:getChildByName("lentec"):getChildByName("need"):getChildByName("go").type = 1
            popView:getChildByName("lentec"):getChildByName("need"):getChildByName("go").toid = prebid
            popView:getChildByName("lentec"):getChildByName("need"):getChildByName("label"):setString(ff.langString("需要 {0} {1} 级",{ff.langString(dd.cfgBuilding[prebid]['name']),preblv}))
        elseif pretec1 == true then
            popView:getChildByName("lentec"):getChildByName("need"):getChildByName("go").type = 2
            popView:getChildByName("lentec"):getChildByName("need"):getChildByName("go").toid = pretid1
            popView:getChildByName("lentec"):getChildByName("need"):getChildByName("label"):setString(ff.langString("需要 {0} {1} 级",{ff.langString(dd.cfgTec[pretid1]['tec_name']),pretlv1}))
        elseif pretec2 == true then
            popView:getChildByName("lentec"):getChildByName("need"):getChildByName("go").type = 2
            popView:getChildByName("lentec"):getChildByName("need"):getChildByName("go").toid = pretid2
            popView:getChildByName("lentec"):getChildByName("need"):getChildByName("label"):setString(ff.langString("需要 {0} {1} 级",{ff.langString(dd.cfgTec[pretid2]['tec_name']),pretlv2}))
        elseif pretec3 == true then 
            popView:getChildByName("lentec"):getChildByName("need"):getChildByName("go").type = 2
            popView:getChildByName("lentec"):getChildByName("need"):getChildByName("go").toid = pretid3
            popView:getChildByName("lentec"):getChildByName("need"):getChildByName("label"):setString(ff.langString("需要 {0} {1} 级",{ff.langString(dd.cfgTec[pretid3]['tec_name']),pretlv3}))
        else     
            condition = true

            popView:getChildByName("lentec"):getChildByName("need"):getChildByName("label"):setString(ff.langString("已满足前置条件"))
        end        

        --资源(下一级)
        popView:getChildByName("res"):getChildByName("res_1"):getChildByName("res_need"):setString(dd.showKM(dd.cfgTecLv[tnextid]['stone'],4))
        popView:getChildByName("res"):getChildByName("res_2"):getChildByName("res_need"):setString(dd.showKM(dd.cfgTecLv[tnextid]['wood'],4))
        popView:getChildByName("res"):getChildByName("res_3"):getChildByName("res_need"):setString(dd.showKM(dd.cfgTecLv[tnextid]['iron'],4))
        popView:getChildByName("res"):getChildByName("res_4"):getChildByName("res_need"):setString(dd.showKM(dd.cfgTecLv[tnextid]['food'],4))
        popView:getChildByName("res"):getChildByName("res_5"):getChildByName("res_need"):setString(dd.showKM(dd.cfgTecLv[tnextid]['silver'],4))

        if dd.myinfo:getLong(1,"level") <= 10 then
            popView:getChildByName("res"):getChildByName("res_1"):setVisible(false)           
            popView:getChildByName("res"):getChildByName("res_3"):setVisible(false) 
            popView:getChildByName("res"):getChildByName("res_5"):setPositionX(328)
        elseif dd.myinfo:getLong(1,"level") <= 14 then
            popView:getChildByName("res"):getChildByName("res_1"):setVisible(true)           
            popView:getChildByName("res"):getChildByName("res_3"):setVisible(false) 
            popView:getChildByName("res"):getChildByName("res_5"):setPositionX(481)
        else
            popView:getChildByName("res"):getChildByName("res_1"):setVisible(true)           
            popView:getChildByName("res"):getChildByName("res_3"):setVisible(true) 
            popView:getChildByName("res"):getChildByName("res_5"):setPositionX(624)
        end

        self._res = false
        if dd.stone() < dd.cfgTecLv[tnextid]['stone'] then
            popView:getChildByName("res"):getChildByName("res_1"):getChildByName("res_have"):setColor(cc.c3b(179,4,24))
            self._res = true
        else    
            popView:getChildByName("res"):getChildByName("res_1"):getChildByName("res_have"):setColor(cc.c3b(161,175,175))
        end

        if dd.wood() < dd.cfgTecLv[tnextid]['wood'] then
            popView:getChildByName("res"):getChildByName("res_2"):getChildByName("res_have"):setColor(cc.c3b(179,4,24))
            self._res = true
        else    
            popView:getChildByName("res"):getChildByName("res_2"):getChildByName("res_have"):setColor(cc.c3b(161,175,175))
        end

        if dd.iron() < dd.cfgTecLv[tnextid]['iron'] then
            popView:getChildByName("res"):getChildByName("res_3"):getChildByName("res_have"):setColor(cc.c3b(179,4,24))
            self._res = true
        else    
            popView:getChildByName("res"):getChildByName("res_3"):getChildByName("res_have"):setColor(cc.c3b(161,175,175))
        end

        if dd.food() < dd.cfgTecLv[tnextid]['food'] then
            popView:getChildByName("res"):getChildByName("res_4"):getChildByName("res_have"):setColor(cc.c3b(179,4,24))
            self._res = true
        else    
            popView:getChildByName("res"):getChildByName("res_4"):getChildByName("res_have"):setColor(cc.c3b(161,175,175))
        end

        if dd.silver() < dd.cfgTecLv[tnextid]['silver'] then
            popView:getChildByName("res"):getChildByName("res_5"):getChildByName("res_have"):setColor(cc.c3b(179,4,24))
            self._res = true
        else    
            popView:getChildByName("res"):getChildByName("res_5"):getChildByName("res_have"):setColor(cc.c3b(161,175,175))
        end
        --金币计算
        --local gold = 0
        local useid = tnextid
        if lv > 0 then
            --useid = tlvid
        end
        if dd.stone() < dd.cfgTecLv[useid]['stone'] then
            gold = gold + (dd.cfgTecLv[useid]['stone'] - dd.stone())/dd.stone_lv
        end    
        if dd.iron() < dd.cfgTecLv[useid]['iron'] then
            gold = gold + (dd.cfgTecLv[useid]['iron'] - dd.iron())/dd.iron_lv
        end    
        if dd.food() < dd.cfgTecLv[useid]['food'] then
            gold = gold + (dd.cfgTecLv[useid]['food'] - dd.food())/dd.food_lv
        end    
        if dd.wood() < dd.cfgTecLv[useid]['wood'] then
            gold = gold + (dd.cfgTecLv[useid]['wood'] - dd.wood())/dd.wood_lv
        end    
        if dd.silver() < dd.cfgTecLv[useid]['silver'] then
            gold = gold + (dd.cfgTecLv[useid]['silver'] - dd.silver())/dd.silver_lv
        end 
        cclog("资源.."..gold)
        cclog("时间.."..dd.getRealGoodp(time))
        --zyq 要剪掉free时间
        gold = gold + dd.getRealGoodp(time - dd.getRealFreeTick())
        
        --popView:getChildByName("lentec"):getChildByName("gold"):getChildByName("count"):setString(math.ceil(gold))
    end
    if condition == true then
        popView:getChildByName("lentec"):getChildByName("need"):getChildByName("label"):setColor(cc.c3b(161,175,175))
        --按钮恢复正常
        popView:getChildByName("lentec"):getChildByName("sure"):setVisible(true)
        popView:getChildByName("lentec"):getChildByName("sure"):setTouchEnabled(true)
        popView:getChildByName("lentec"):getChildByName("sure"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        popView:getChildByName("lentec"):getChildByName("sure"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
        popView:getChildByName("lentec"):getChildByName("sure"):getChildByName("time"):setColor(cc.c3b(255,255,255))

        popView:getChildByName("lentec"):getChildByName("gold"):setVisible(true)
        popView:getChildByName("lentec"):getChildByName("gold"):setTouchEnabled(true)
        popView:getChildByName("lentec"):getChildByName("gold"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        popView:getChildByName("lentec"):getChildByName("gold"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
        popView:getChildByName("lentec"):getChildByName("gold"):getChildByName("count"):setColor(cc.c3b(255,255,255))
        --前置按钮
        popView:getChildByName("lentec"):getChildByName("need"):getChildByName("go"):setVisible(false)
    else
        popView:getChildByName("lentec"):getChildByName("need"):getChildByName("label"):setColor(cc.c3b(255,0,0))
        --按钮变灰
        popView:getChildByName("lentec"):getChildByName("sure"):setVisible(true)
        popView:getChildByName("lentec"):getChildByName("sure"):setTouchEnabled(false)
        local effect = ff.Effect:effectGrey()    
        popView:getChildByName("lentec"):getChildByName("sure"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        popView:getChildByName("lentec"):getChildByName("sure"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        popView:getChildByName("lentec"):getChildByName("sure"):getChildByName("time"):setColor(cc.c3b(116,123,125))

        popView:getChildByName("lentec"):getChildByName("gold"):setVisible(true)
        popView:getChildByName("lentec"):getChildByName("gold"):setTouchEnabled(false)
        local effect = ff.Effect:effectGrey()    
        popView:getChildByName("lentec"):getChildByName("gold"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        popView:getChildByName("lentec"):getChildByName("gold"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        popView:getChildByName("lentec"):getChildByName("gold"):getChildByName("count"):setColor(cc.c3b(116,123,125))
        --前置按钮
        if ismax == false then
            popView:getChildByName("lentec"):getChildByName("need"):getChildByName("go"):setVisible(true)
        else
            popView:getChildByName("lentec"):getChildByName("need"):getChildByName("go"):setVisible(false)
        end
    end
    popView:getChildByName("lentec"):getChildByName("need"):requestDoLayout()    
    popView:getChildByName("lentec"):getChildByName("sure"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
    popView:getChildByName("lentec"):getChildByName("gold"):getChildByName("count"):setString(math.ceil(gold))
    self:onUpdateQueDetaile(tid)
end

function tecLayer:getTecInfo()
    local message = ff.net:createMessage()
    message:addCmd(0x007)
    message:addLong(dd.uid)         
    ff.net:rpc(message, false)
end
function tecLayer.onGetTecInfo(params)
    local code = params[1]
    if code == 0 then
        local widget = pop.getDialog("tec")
        widget:updateTec(widget._selecttype)
        widget:updatePop(widget._selectid)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function tecLayer:onPropUse(params)
    local code = params[1]
    if code == 0 then
        self:updateTec(self._selecttype)
        self:updatePop(self._selectid)
    end
end

function tecLayer:onShowOtherGrade(bid)
    self:stopAllActions()
    if pop.builds[self._bid] ~= nil then
        local name = pop.builds[self._bid][2]
        pop.onClosePopDialog(name)
    end
    if dd.currentLayer._pop ~= nil then 
        dd.currentLayer._pop._bid = bid 
        dd.currentLayer._pop:showUpgrade(bid)
        dd.currentLayer._pop._upgrade:stopAllActions()
        pop.showPopEffect(99,dd.currentLayer._pop._upgrade)    
        dd.currentLayer._pop:getChildByName("btns"):getChildByName("option"):setSelectedState(false)
        dd.currentLayer._pop:getChildByName("btns"):getChildByName("upgrade"):setSelectedState(true)
    end
end

function tecLayer.getEffectTips(effectid,value)
    if ff.langString(dd.cfgEffect[effectid]["tips2"]) == "%" then
        return  ff.langString(dd.cfgEffect[effectid]["name"])
    else
        local evalue = dd.cfgEffect[effectid]['value']    
        if evalue ~= 0 then
            value = value/evalue
        end
        return ff.langString(dd.cfgEffect[effectid]["tips1"],{value})
    end
end
function tecLayer.getEffectValue(effectid,value)
    if ff.langString(dd.cfgEffect[effectid]["tips2"]) ~= "%" then
        return ""
    else
        local str = ""
        local evalue = dd.cfgEffect[effectid]['value']    
        if evalue ~= 0 then
            value = value/evalue
        end
        str = "+"..value.."%"
        return str
    end
end

--任务需要显示pop
function tecLayer:showByTid(tid)
    local function show()
        self:onShowTecPop(tid)
    end
    if tid ~= nil then
        if dd.cfgTecShow[tid] ~= nil then
            local type = dd.cfgTecShow[tid]['type']
            self:updateType(type)  
            self:getChildByName("view"):getChildByName("view"):jumpToTop()
            self:showHand(tid)
            --self:onShowTecPop(tid) 
        elseif tid < 100 then
            self:updateType(tid)        
        end
    end
end

function tecLayer:showHand(tid)
    if dd.canShowHandArrow() == false then
        return
    end

    local item   = self:getChildByName("view"):getChildByName("view"):getChildByTag(tid)
    if item == nil then
        return
    end

    if self._hand == nil then
        self._hand = cc.Sprite:create("images/city/effect/hand.png") 
        self._hand:setRotation(120)                   
        self:addChild(self._hand,9,9)
    end
    self._hand:stopAllActions()
    
    local inery  = self:getChildByName("view"):getChildByName("view"):getInnerContainer():getPositionY()
    local fixy = inery + item:getPositionY()
    if fixy < 0 then
        self:getChildByName("view"):getChildByName("view"):getInnerContainer():setPositionY(inery - fixy)
    end   
    
    local pos  = self.getWorldPos(item)
    pos = self:convertToNodeSpace(pos)
    self._hand:setPosition(cc.p(pos.x + 140,pos.y + 80))
    
    local action = cc.MoveBy:create(0.5,cc.p(-20,40))
    local back = action:reverse()
    self._hand:runAction(cc.RepeatForever:create(cc.Sequence:create(action, back)))
    self._hand:setVisible(true)
end

function tecLayer:unshowHand()
    if self._hand ~= nil then
        self._hand:setVisible(false)
    end
end

function tecLayer.getWorldPos(node)
    local anr   = node:getAnchorPoint()
    local size  = node:getContentSize()
    local p = node:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
    return p
end
--给新手引导用的表示队列变化
function tecLayer.onQueue(params)
    if table.getn(params) > 1 then      
        local reson  = params[1]
        local type   = params[2]
        local param1 = params[3]
        local param2 = params[4]
        local param3 = params[5]
        local param4 = params[6]
        local bid    = params[7]

        if reson == 1 and type == 2 then
            if GuideControl._curGuideLayer ~= nil then
                GuideControl._curGuideLayer:checkDelay()
            end
            GuideControl:GuideCheck()  
        end
    end
end

function tecLayer.onStart(sender)
    --科技研究事件
    ff.net:registerEvent(2,dd.Tjf_rpc_TecStudy,sender.onTecStudying)
    ff.net:registerEvent(2501,dd.Tjf_Queue_QueueAction,sender.onFreeStudy)
    ff.net:registerEvent(2,dd.Tjf_rpc_GetTecInfo,sender.onGetTecInfo)
    ff.net:registerEvent(3,dd.Tjf_notify_SNQueueInfo,sender.onQueue)
    ff.net:registerEvent(9,dd.Tjf_prop_use, function (message)sender:onPropUse(message)end)
    if sender._taskid == 0 then
        sender:updateType(sender._selecttype)
    else
        sender:showByTid(sender._taskid)
    end 
end

function tecLayer.onEnd(sender)
    sender:stopAllActions()
    local popView = sender:getChildByName("pop"):getChildByName("view")
    sender:getChildByName("pop"):setVisible(false)
    sender:getChildByName("masking"):setVisible(false)    
    sender:getChildByName("view"):getChildByName("view"):getChildByName("cross"):removeAllChildren(true)
    if ff.platform ~= 1 then
        for i,item in ipairs(sender._items) do
            if item then
                item:getChildByName("tec"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("lock"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("lockpanel"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end
        
        if popView ~= nil then
            popView:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        end
    end
        
    ff.net:removeEvent(2,dd.Tjf_rpc_TecStudy)
    ff.net:removeEvent(2501,dd.Tjf_Queue_QueueAction)
    ff.net:removeEvent(2,dd.Tjf_rpc_GetTecInfo)
    ff.net:removeEvent(3,dd.Tjf_notify_SNQueueInfo)
    ff.net:removeEvent(9,dd.Tjf_prop_use)

    local help = pop.getDialog("buildHelp")
    if help ~= nil and help:isVisible() then
        help:setVisible(false)    
    end
end

--界面即将播放
function tecLayer.onBefore(sender)
    return false
end

function tecLayer.onReturn(sender)
    if sender:getChildByName("pop"):isVisible() == true then
        sender.closePop(sender,ccui.TouchEventType.ended)
        return true
    else
        return false
    end     
end


function onShowTec(widget,pos,lastpos,tid)
    local layer = tecLayer.extend(widget)
    layer:setVisible(false)
    layer._pos = pos
    --任务需要制定type
    if tid == nil then
        cclog("任务没有传来科技ID")
        layer._taskid = 0
    else
        cclog("任务传来的科技ID == "..tid)
        layer._taskid = tid
    end
    layer:onInit()
    return layer
end