--瞭望塔
local towerLayer = class("towerLayer")
towerLayer._name = "towerLayer"
towerLayer._init = false
towerLayer._pos  = 0
towerLayer._bid  = 0
towerLayer._lv   = 0

function towerLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, towerLayer)
    return target
end

function onShowTower(widget,pos )
	-- body
	local layer = towerLayer.extend(widget)
    layer:setVisible(false)
    layer._pos = pos
    layer:onInit()
    return layer
end

function towerLayer.itemEvent( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then
        local tag = sender:getTag()
        --if tag <= dd.myTower:rowCount() then 
           -- local  id = dd.myTower:getLong(tag,"army_id")
           -- local type = dd.myTower:getLong(tag,"type")
            
        local type = 0
            for i=1,dd.myTower:rowCount() do
                if dd.myTower:getLong(i,"army_id") == tag then
                    type = dd.myTower:getLong(i,"type")
                    break
                end
            end
            local widget = pop.getDialog("tower")
            --cclog("===="..type)
            if widget == nil or tonumber(type) == 3 then
                return
            end
            if tonumber(type) == 11 then
                local getMailListMsg = ff.net:createMessage()
                getMailListMsg:addCmd(0x0000001e)
                getMailListMsg:addLong(dd.uid)
                getMailListMsg:addLong(tag)
   -- cclog("=============id"..sender._troopID)
            
                ff.net:rpc(getMailListMsg,false)
                return
            end

            pop.onShowPopDialog("towerinfo",tag)
        --end

       
    end
end

function towerLayer:showinfo(  )
    -- body
    local per = 0
    if self._lv <= 11 then
        per = self._lv * 5
    elseif self._lv > 11 and self._lv <= dd.cfgBuilding[3]['maxlevel'] then
        per = 50 + (self._lv - 11) * 10
    end
    if per > 100 then
        per = 100
    end
    self:getChildByName("towerinfo"):getChildByTag(10000):setPercentage(per)
    self:getChildByName("towerinfo"):getChildByName("info"):getChildByName("percentage"):setString(per.."%")

    self:getChildByName("main"):removeAllChildren(true)

    for i=1,dd.myTower:rowCount() do
        local type = dd.myTower:getLong(i,"type")
        if type <1 or type >5 then
            break
        end
        local item = self:getChildByName("item"):clone()
        item:setTag(dd.myTower:getLong(i,"army_id"))

        item:setVisible(true)

        item:addTouchEventListener(self.itemEvent)
        cclog("99999999999999--"..dd.myTower:getLong(i,"playerID"))
        if dd.myTower:getLong(i,"playerID") > 0 then
            item:getChildByName("player"):getChildByName("player"):loadTexture(dd.getPlayerIcon(dd.myTower:getLong(i,"playerID")))
        elseif dd.myTower:getLong(i,"playerID") == 0 then
            item:getChildByName("player"):getChildByName("player"):loadTexture(dd.getPathFromUI("1unknow.png",1))
        elseif dd.myTower:getLong(i,"playerID") < 0 then
            item:getChildByName("player"):getChildByName("player"):loadTexture(dd.getBossImg(),0)
        end
        local from = dd.myTower:getLong(i,"from")
        local to = dd.myTower:getLong(i,"to")

        local canfrom = true
        if from == 0 and to == 0 then
            canfrom = false
        end
        local union = dd.myTower:getString(i,"allyFlag")
        local canunion = true
        if union == nil then
            canunion = false
        end
        local name = dd.myTower:getString(i,"loginName")
        local canname = true
        if name == nil then
            canname = false
        end

        --cclog("========"..name)
        local start = dd.myTower:getLong(i,"start")
        local endtime = dd.myTower:getLong(i,"arrival")
        local per = 0
        if (endtime - start )>0 then
            per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
        end
        local time = endtime - dd.getServerTime()

        local mapsite=dd.MapidToXY(from)
        --2攻击，3侦查，4增援，5联盟战争
        if type == 1 then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic01_tower.png",1))
            if canfrom then
                item:getChildByName("from"):setString(ff.langString("占领").."：X "..mapsite.x..",Y "..mapsite.y)
            else
                item:getChildByName("from"):setString(ff.langString("占领").."：X ??,Y ??")
            end
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("public/pg03.png",1))
        elseif type == 2 then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic01_tower.png",1))
            if canfrom then
                item:getChildByName("from"):setString(ff.langString("攻击来自：X ")..mapsite.x..",Y "..mapsite.y)
            else
                item:getChildByName("from"):setString(ff.langString("攻击来自：X ??,Y ??"))
            end
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("public/pg03.png",1))
        elseif type == 3 then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic03_tower.png",1))
            if canfrom then
                item:getChildByName("from"):setString(ff.langString("侦查来自：X ")..mapsite.x..",Y "..mapsite.y)
            else
                item:getChildByName("from"):setString(ff.langString("侦查来自：X ??,Y ??"))
            end
            item:getChildByName("Image_48_1"):setVisible(false)
            item:getChildByName("Image_48_0_1"):setVisible(false)
            item:getChildByName("Image_86"):setVisible(false)
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("pg01.png",1))
        elseif type == 4 then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic04_tower.png",1))
            if canfrom then
                item:getChildByName("from"):setString(ff.langString("增援来自：X ")..mapsite.x..",Y "..mapsite.y)
            else
                item:getChildByName("from"):setString(ff.langString("增援来自：X ??,Y ??"))
            end
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("pg09.png",1))
        elseif type == 5 then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic02_tower.png",1))
            if canfrom then
                item:getChildByName("from"):setString(ff.langString("联合攻击来自：X ")..mapsite.x..",Y "..mapsite.y)
            else
                item:getChildByName("from"):setString(ff.langString("联合攻击来自：X ??,Y ??"))
            end
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("public/pg03.png",1))
        elseif type == 11 then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic05_tower.png",1))
            if canfrom then
                item:getChildByName("from"):setString(ff.langString("运输来自").."：X "..mapsite.x..",Y "..mapsite.y)
            else
                item:getChildByName("from"):setString(ff.langString("运输来自").."：X ??,Y ??")
            end
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("pg09.png",1))
        elseif type == 0 then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("img00_tower.png",1))
            if canfrom then
                item:getChildByName("from"):setString("？？"..ff.langString("来自").."：X "..mapsite.x..",Y "..mapsite.y)
            else
                item:getChildByName("from"):setString("？？"..ff.langString("来自").."：X ??,Y ??")
            end
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("public/pg03.png",1))
        end
        
        item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):setPercent(per)

        if canunion then
        	if union ~= nil and string.len(union)>1 then
            	item:getChildByName("info"):getChildByName("men"):setString("["..union.."]")
        	else
        		item:getChildByName("info"):getChildByName("men"):setString("")
        	end
        else
            item:getChildByName("info"):getChildByName("men"):setString("[??]")
        end

        if canname then
            item:getChildByName("info"):getChildByName("name"):setString(name)
        else
            item:getChildByName("info"):getChildByName("name"):setString("??")
        end

        if (endtime - start )>0 and time > 0 then
            item:getChildByName("ProgressBar"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
        else
            item:getChildByName("ProgressBar"):getChildByName("time"):setString("")
        end
        

        self:getChildByName("main"):pushBackCustomItem(item)
    end
    self:getChildByName("main"):scrollToTop(0.5,true)
    self:getChildByName("main"):setItemsMargin(5)
end

function towerLayer.updateinfo( sender )
    -- body
    local have = false
    for i=1,dd.myTower:rowCount() do
        have = true
        --cclog("=============================================")
        sender:getChildByName("strinfo"):setVisible(false)
       local item = sender:getChildByName("main"):getChildByTag(dd.myTower:getLong(i,"army_id"))
       if item ~= nil then
            local start = dd.myTower:getLong(i,"start")
            local endtime = dd.myTower:getLong(i,"arrival")
            local per = 0
            if (endtime - start )>0 then
                per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
            end
            local time = endtime - dd.getServerTime()
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):setPercent(per)
            if time > 0 then
                item:getChildByName("ProgressBar"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
            else
                item:getChildByName("ProgressBar"):getChildByName("time"):setString("")
                --sender:getChildByName("main"):removeChildByTag(dd.myTower:getLong(i,"army_id"))
               --sender:getChildByName("main"):refreshView(true)
            end
        else
        	local type = dd.myTower:getLong(i,"type")
            --cclog("============================================="..type)
        if type <0 or type >5 and type ~= 11 then
            break
        end
        local item = sender:getChildByName("item"):clone()
        item:setTag(dd.myTower:getLong(i,"army_id"))

        item:setVisible(true)

        item:addTouchEventListener(sender.itemEvent)

        if dd.myTower:getLong(i,"playerID") ~= 0 then
            item:getChildByName("player"):getChildByName("player"):loadTexture(dd.getPlayerIcon(dd.myTower:getLong(i,"playerID")))
        else
            item:getChildByName("player"):getChildByName("player"):loadTexture(dd.getPathFromUI("1unknow.png",1))
        end
        local from = dd.myTower:getLong(i,"from")
        local to = dd.myTower:getLong(i,"to")
        
        local canfrom = true
        if from == 0 then
            canfrom = false
        end
        local union = dd.myTower:getString(i,"allyFlag")
        local canunion = true
        if union == nil then
            canunion = false
        end
        local name = dd.myTower:getString(i,"loginName")
        local canname = true
        if name == nil then
            canname = false
        end

        --cclog("========"..name)
        local start = dd.myTower:getLong(i,"start")
        local endtime = dd.myTower:getLong(i,"arrival")
        local per = 0
        if (endtime - start )>0 then
            per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
        end
        local time = endtime - dd.getServerTime()

        local mapsite=dd.MapidToXY(from)
        --2攻击，3侦查，4增援，5联盟战争
        if type == 1 then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic01_tower.png",1))
            if canfrom then
                item:getChildByName("from"):setString(ff.langString("占领").."：X "..mapsite.x..",Y "..mapsite.y)
            else
                item:getChildByName("from"):setString(ff.langString("占领：X ??,Y ??"))
            end
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("public/pg03.png",1))
        elseif type == 2 then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic01_tower.png",1))
            if canfrom then
                item:getChildByName("from"):setString(ff.langString("攻击来自：X ")..mapsite.x..",Y "..mapsite.y)
            else
                item:getChildByName("from"):setString(ff.langString("攻击来自：X ??,Y ??"))
            end
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("public/pg03.png",1))
        elseif type == 3 then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic03_tower.png",1))
            if canfrom then
                item:getChildByName("from"):setString(ff.langString("侦查来自：X ")..mapsite.x..",Y "..mapsite.y)
            else
                item:getChildByName("from"):setString(ff.langString("侦查来自：X ??,Y ??"))
            end
            item:getChildByName("Image_48_1"):setVisible(false)
            item:getChildByName("Image_48_0_1"):setVisible(false)
            item:getChildByName("Image_86"):setVisible(false)
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("pg01.png",1))
        elseif type == 4 then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic04_tower.png",1))
            if canfrom then
                item:getChildByName("from"):setString(ff.langString("增援来自：X ")..mapsite.x..",Y "..mapsite.y)
            else
                item:getChildByName("from"):setString(ff.langString("增援来自：X ??,Y ??"))
            end
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("pg09.png",1))
        elseif type == 5 then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic02_tower.png",1))
            if canfrom then
                item:getChildByName("from"):setString(ff.langString("联合攻击来自：X ")..mapsite.x..",Y "..mapsite.y)
            else
                item:getChildByName("from"):setString(ff.langString("联合攻击来自：X ??,Y ??"))
            end
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("public/pg03.png",1))
        elseif type == 11 then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic05_tower.png",1))
            if canfrom then
                item:getChildByName("from"):setString(ff.langString("运输来自").."：X "..mapsite.x..",Y "..mapsite.y)
            else
                item:getChildByName("from"):setString(ff.langString("运输来自").."：X ??,Y ??")
            end
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("public/pg03.png",1))
        elseif type == 0 then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic00_tower.png",1))
            if canfrom then
                item:getChildByName("from"):setString("？？"..ff.langString("来自").."：X "..mapsite.x..",Y "..mapsite.y)
            else
                item:getChildByName("from"):setString("？？"..ff.langString("来自").."：X ??,Y ??")
            end
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("public/pg03.png",1))
        end
        
        item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):setPercent(per)

        if canunion then
        	if union ~= nil and string.len(union)>1 then
            	item:getChildByName("info"):getChildByName("men"):setString("["..union.."]")
            else
        		item:getChildByName("info"):getChildByName("men"):setString("")
        	
        	end
        else
            item:getChildByName("info"):getChildByName("men"):setString("[??]")
        end

        if canname then
            item:getChildByName("info"):getChildByName("name"):setString(name)
        else
            item:getChildByName("info"):getChildByName("name"):setString("??")
        end

        if (endtime - start )>0 and time > 0 then
            item:getChildByName("ProgressBar"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
        else
            item:getChildByName("ProgressBar"):getChildByName("time"):setString("")
        end
        

        sender:getChildByName("main"):pushBackCustomItem(item)
       end
    end

    if have == false then
        sender:getChildByName("strinfo"):setVisible(true)
        sender:getChildByName("strinfo"):getChildByName("info"):setString(ff.langString("当前没有战斗信息"))
    else
        sender:getChildByName("strinfo"):setVisible(false)
    end
end

function towerLayer:onInit(  )
	-- body
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"pos") == self._pos then
            self._bid = dd.mybuilds:getLong(i,"bid")
            self._lv = dd.mybuilds:getLong(i,"level")
            break
        end
    end

    if self._init == false then
        local hh = dd.currentLayer._pop:getContentSize().height
        if dd.currentLayer._pop ~= nil then
            self:setContentSize(cc.size(720,hh - 184))
            self:getChildByName("info"):setPositionY(hh - 184 - 38 - 20)
            self:getChildByName("towerinfo"):setPositionY(hh - 184 - 38 - 90 - 20)
            self:getChildByName("main"):setPositionY(0)
            self:getChildByName("main"):setContentSize(cc.size(720,hh-184-200 - 20))
        end
        local x,y = self:getChildByName("towerinfo"):getChildByName("progress"):getPosition()
        --cclog("x:"..x.." y:"..y)
        local oil_bar = cc.ProgressTimer:create(dd.newSpriteFromUI("img02_tower.png"))
        oil_bar:setBarChangeRate(cc.p(1,0))--设置进程条的变化速率
        oil_bar:setType(cc.PROGRESS_TIMER_TYPE_RADIAL)--设置进程条的类型
        oil_bar:setPosition(cc.p(x,y))
        oil_bar:setPercentage(30)--设置初始值为0
        oil_bar:setVisible(true)
        self:getChildByName("towerinfo"):addChild(oil_bar,1,10000)
        
        local function showHelp(sender,eventType)
            if eventType==ccui.TouchEventType.ended then     
                pop.onShowPopDialog("buildHelp",self._bid,self._lv)
            end
        end
        self:getChildByName("info"):getChildByName("help"):addTouchEventListener(showHelp)
        self._init = true
    end
    --self:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))    
    self:showinfo()
    
end

function towerLayer.onBefore( sender )
	-- body
	ff.net:registerEvent(1,dd.Tjf_notify_SNWatchTower,function (message) sender:notify(message)  end)

	return false
end

function towerLayer:notify(message)
	if message ~= nil then
    	local tag = message[1]
    	--cclog("================"..tag)
    	self:getChildByName("main"):removeChildByTag(tag)
	end
end

function towerLayer:notifyYun(towerinfo)
    if towerinfo == nil then
            return
        end
        local type = towerinfo.type
        local from = towerinfo.from
        local to = towerinfo.to
        local start = towerinfo.start
        local arrival = towerinfo.arrival
        local allyFlag = towerinfo.allyFlag
        local loginName = towerinfo.loginName
        local playerId = towerinfo.playerid
        local heromaster = towerinfo.heromaster
        local heroname = towerinfo.heroname
        local heroid = towerinfo.heroid
        local heroLv = towerinfo.heroLv

        local alltroop = towerinfo.alltroop
        
        local bu_1 = 0
        local bu_2 = 0
        local bu_3 = 0
        local bu_4 = 0
        local bu_5 = 0
        
        if towerinfo.info ~= nil then

            if towerinfo.info:getLong(1,"bu_1") > 0 then
                bu_1 = towerinfo.info:getLong(1,"bu_1")
            end
            if towerinfo.info:getLong(1,"bu_2") > 0 then
                bu_2 = towerinfo.info:getLong(1,"bu_2")
            end
            if towerinfo.info:getLong(1,"bu_3") > 0 then
                bu_3 = towerinfo.info:getLong(1,"bu_3")
            end
            if towerinfo.info:getLong(1,"bu_4") > 0 then
                bu_4 = towerinfo.info:getLong(1,"bu_4")
            end
            if towerinfo.info:getLong(1,"bu_5") > 0 then
                bu_5 = towerinfo.info:getLong(1,"bu_5")
            end
        end

        if towerinfo.info ~= nil then
        towerinfo.info:clear()
        end
        local table = {}
        table.to = to
        table.from = from
        table.res1 = bu_1
        table.res2 = bu_2
        table.res3 = bu_4
        table.res4 = bu_3
        table.res5 = bu_5

       pop.onShowPopDialog("transportInfo",0,true,table)
end

function towerLayer.onStart( sender )
    -- body
    --ff.net:bindProperty(2317,"gold",sender.updateGold)
    schedule(sender,sender.updateinfo,1)
    ff.net:registerEvent(1,dd.Tjf_GetWatchTowerDetail,function (message) sender:notifyYun(message)  end)
end
function towerLayer.updateGold(name,row,old,value)
    --cclog("sdfsdf")
    local widget = pop.getDialog("towerLayer")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.gold())
        widget:getChildByName("top"):requestDoLayout()
    end
end

function towerLayer.onEnd( sender )
    -- body
    sender:stopAllActions()
    --dd.delBackEvent()
    ff.net:removeEvent(1,dd.Tjf_GetWatchTowerDetail)
    ff.net:removeEvent(1,dd.Tjf_notify_SNWatchTower)
    local help = pop.getDialog("buildHelp")
    if help ~= nil and help:isVisible() then
        help:setVisible(false)    
    end
     --ff.net:unbindProperty("gold",2317)
end

