
towerInfoLayer = class("towerInfoLayer")
towerInfoLayer._name = "towerinfo"
towerInfoLayer._init = false
towerInfoLayer._troopID = 0
towerInfoLayer._info = nil
towerInfoLayer._type = 0
towerInfoLayer._from = 0
towerInfoLayer._to = 0
towerInfoLayer._start = 0
towerInfoLayer._arrival = 0
towerInfoLayer._allyFlag = nil
towerInfoLayer._loginName = nil

towerInfoLayer._heromaster = 0
towerInfoLayer._heroname = nil
towerInfoLayer._heroid = 0
towerInfoLayer._heroLv = 0
towerInfoLayer._playerId = 0
towerInfoLayer._alltroop = 0

function towerInfoLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,towerInfoLayer)
	return target
end

function onShowTowerInfo( widget,troopid )
	-- body
	local layer = towerInfoLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
	layer:onInit(troopid)
	return layer
end

function towerInfoLayer:onInit( troopid )
	-- body
	self._troopID = troopid
	if self._init == false then
		self:AutoSize()
		self._init = true
		self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onReturn)
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
	end
	self:addUiEvent()
    self.updateGold()
    --self:getChildByName("topArea"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))    
	--self:showinfo()
	--schedule(self,self.update,1)
end

function towerInfoLayer.update( sender )
	-- body
	
	local start = sender._start 
    local endtime = sender._arrival
    local per = 0
    if (endtime - start )>0 then
        per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
    end
    --cclog("=============="..per)
    local time = endtime - dd.getServerTime()
    local item = sender:getChildByName("main"):getChildByTag(1)
    if item ~= nil then
        item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):setPercent(per)
    end
    --item:getChildByName("ProgressBar"):getChildByName("time"):setString(dd.getTimeStr(time))
end

function towerInfoLayer.onReturn( sender,eventType )
	-- body
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("towerinfo")
		if widget == nil then
			return
		end
        pop.onClosePopDialog("towerinfo")
    end
end

function towerInfoLayer:AutoSize(  )
	-- body
	local hh = ff.height
	self:setContentSize(cc.size(720,hh))
	self:getChildByName("back"):setContentSize(cc.size(720,hh))
	self:getChildByName("back"):setPositionY(0)
	self:getChildByName("topArea"):setPositionY(hh-105)
	--self:getChildByName("info"):setPositionY(hh- 50 -142- 10 - 5 - 50)
	self:getChildByName("main"):setContentSize(cc.size(720,hh- 110))
	--self:getChildByName("back"):setContentSize(cc.size(685,hh- 50 -142- 10 - 5 - 50-10))
	self:getChildByName("main"):setPositionY(0)
    self:getChildByName("main"):setPositionX(0)
	--self:getChildByName("back"):setPositionY(0)
end

function towerInfoLayer:showinfo(  )
	-- body
	self:getChildByName("main"):removeAllChildren(true)
	
	local type = self._type
    local from = self._from
        local to = self._to
        local canfrom = true
        if from == 0 then
            canfrom = false
        end
    local union = self._allyFlag 
    local canunion = true
    if union == nil then
        canunion = false
    end
    local name = self._loginName
    local canname = true
    if name == nil then
        canname = false
    end

    local item = self:getChildByName("item"):clone()
    --cclog("========"..name)
    item:setVisible(true)
    item:setTag(1)
    local start = self._start 
    local endtime = self._arrival
    local per = 0
    if (endtime - start )>0 then
        per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
    end
    local time = endtime - dd.getServerTime()

    local mapsite=dd.MapidToXY(from)
    --cclog("===ididdidididid=="..self._playerId)
    if self._playerId > 0 then
    	item:getChildByName("player"):getChildByName("player"):loadTexture(dd.getPlayerIcon(self._playerId))
    else
        item:getChildByName("player"):getChildByName("player"):loadTexture(dd.getPathFromUI("1unknow.png",1))
    end
    --2攻击，3侦查，4增援，5联盟战争
    if type == 1 then
        item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic01_tower.png",1))
        if canfrom then
           item:getChildByName("from"):setString(ff.langString("占领：X ")..mapsite.x..",Y "..mapsite.y)
        else
            item:getChildByName("from"):setString(ff.langString("占领：X ??,Y ??"))
        end
        item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("public/pg03.png",1))
    elseif type == 2 then
        item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic01_tower.png",1))
        if canfrom then
           item:getChildByName("from"):setString(ff.langString("攻击来自：X ")..mapsite.x..",Y "..mapsite.y)
        else
            item:getChildByName("from"):setString(ff.langString("攻击来自：X ??,Y ??"))
        end
        item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("public/pg03.png",1))
    elseif type == 3 then
        item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic03_tower.png",1))
        if canfrom then
            item:getChildByName("from"):setString(ff.langString("侦查来自：X ")..mapsite.x..",Y "..mapsite.y)
        else
            item:getChildByName("from"):setString(ff.langString("侦查来自：X ??,Y ??"))
        end
        item:getChildByName("Image_48_1"):setVisible(false)
        item:getChildByName("Image_48_0_1"):setVisible(false)
        item:getChildByName("Image_86"):setVisible(false)
        item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("pg01.png",1))
    elseif type == 4 then
        item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic04_tower.png",1))
        if canfrom then
            item:getChildByName("from"):setString(ff.langString("增援来自：X ")..mapsite.x..",Y "..mapsite.y)
        else
            item:getChildByName("from"):setString(ff.langString("增援来自：X ??,Y ??"))
        end
        item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("pg09.png",1))
    elseif type == 5 then
        item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic02_tower.png",1))
        if canfrom then
            item:getChildByName("from"):setString(ff.langString("联合攻击来自：X ")..mapsite.x..",Y "..mapsite.y)
        else
            item:getChildByName("from"):setString(ff.langString("联合攻击来自：X ??,Y ??"))
        end
            item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("public/pg03.png",1))
    elseif type == 0 then
        item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic00_tower.png",1))
        if canfrom then
            item:getChildByName("from"):setString("？？"..ff.langString("来自").."：X "..mapsite.x..",Y "..mapsite.y)
        else
            item:getChildByName("from"):setString("？？"..ff.langString("来自").."：X ??,Y ??")
        end
        item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):loadTexture(dd.getPathFromUI("public/pg03.png",1))
    end
    
    item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):setPercent(per)
    item:getChildByName("info"):requestDoLayout()
    if canunion then
        if union ~= nil and string.len(union)>1 then
            item:getChildByName("info"):getChildByName("men"):setString("["..union.."]")
        else 
            item:getChildByName("info"):getChildByName("men"):setString("")
        end
    else
        item:getChildByName("info"):getChildByName("men"):setString("[??]")
    end

    if canname then
        item:getChildByName("info"):getChildByName("name"):setString(name)
    else
        item:getChildByName("info"):getChildByName("name"):setString(ff.langString("??"))
    end
    self:getChildByName("main"):pushBackCustomItem(item)
    
    local count = 0
    local item1 = nil
    local panel = self:getChildByName("info"):clone()
    panel:setVisible(true)

    if type ~= 4 then
        if self._heroLv == 0 then
            panel:getChildByName("herolv"):setString(ff.langString("发起人英雄").."：LV.??")
        else
            panel:getChildByName("herolv"):setString(ff.langString("发起人英雄").."：LV."..self._heroLv)
        end
    else
        panel:getChildByName("herolv"):setString("")
    end

    if self._alltroop == 0 then
        panel:getChildByName("power"):setString(ff.langString("总兵力").."：？？")
    else
        panel:getChildByName("power"):setString(ff.langString("总兵力").."："..self._alltroop)
    end


    self:getChildByName("main"):pushBackCustomItem(panel)

    local hh = 0
    if self._info ~= nil then
    	for i=1,6 do
    	if self._info:getLong(1,"bu_"..tostring(i)) > 0 then
    		
    		if count == 0 then
    			item1 = self:getChildByName("item2"):clone()
                self:getChildByName("main"):pushBackCustomItem(item1)
                --panel:addChild(item1)
                --item1:setPositionY(hh)
    			--self:getChildByName("main"):pushBackCustomItem(item)
    			item1:setVisible(true)
                --hh = hh +300
    		end
    		count = count + 1
    		local player = item1:getChildByName("player"..count)
    		if count == 3 then
    			count = 0
    		end
    		player:setVisible(true)
            local star = ""
            for j=1,i do
                star = star.."0"
            end
            player:getChildByName("start"):getChildByName("start"):setString(star)

    		player:getChildByName("count"):getChildByName("count"):setString(self._info:getLong(1,"bu_"..tostring(i)))
    		player:getChildByName("person"):loadTexture(dd.getArmyIcon(tonumber(i)),0)
            --cclog("==1111="..i)
    	end
    end
    
    for i=1,6 do
    	if self._info:getLong(1,"qi_"..i) > 0 then
    		if count == 0 then
    			item1 = self:getChildByName("item2"):clone()
                self:getChildByName("main"):pushBackCustomItem(item1)
                --panel:addChild(item1)
                --item1:setPositionY(hh)
                --self:getChildByName("main"):pushBackCustomItem(item)
                item1:setVisible(true)
    		end
    		count = count + 1
    		local player = item1:getChildByName("player"..count)
    		if count == 3 then
    			count = 0
    		end
    		player:setVisible(true)
            local star = ""
            for j=1,i do
                star = star.."0"
            end
            player:getChildByName("start"):getChildByName("start"):setString(star)

    		player:getChildByName("count"):getChildByName("count"):setString(self._info:getLong(1,"qi_"..tostring(i)))
            local name = "1"..tostring(i)
    		player:getChildByName("person"):loadTexture(dd.getArmyIcon(tonumber(name)),0)
           -- cclog("==22222="..i)
    	end
    end

    for i=1,6 do
    	if self._info:getLong(1,"gong_"..i) > 0 then
    		if count == 0 then
    			item1 = self:getChildByName("item2"):clone()
                self:getChildByName("main"):pushBackCustomItem(item1)
                --panel:addChild(item1)
                --item1:setPositionY(hh)
                --self:getChildByName("main"):pushBackCustomItem(item)
                item1:setVisible(true)
    		end
    		count = count + 1
    		local player = item1:getChildByName("player"..count)
    		if count == 3 then
    			count = 0
    		end
    		player:setVisible(true)
            local star = ""
            for j=1,i do
                star = star.."0"
            end
            player:getChildByName("start"):getChildByName("start"):setString(star)
           
    		player:getChildByName("count"):getChildByName("count"):setString(self._info:getLong(1,"gong_"..tostring(i)))
            local name = "2"..tostring(i)
    		player:getChildByName("person"):loadTexture(dd.getArmyIcon(tonumber(name)),0)
            --cclog("==33333="..i)
    	end
    end

    for i=1,4 do
    	if self._info:getLong(1,"che_"..i) > 0 then
    		if count == 0 then
    			item1 = self:getChildByName("item2"):clone()
                self:getChildByName("main"):pushBackCustomItem(item1)
                --panel:addChild(item1)
                --item1:setPositionY(hh)
                --self:getChildByName("main"):pushBackCustomItem(item)
                item1:setVisible(true)
    		end
    		count = count + 1
    		local player = item1:getChildByName("player"..count)
    		if count == 3 then
    			count = 0
    		end
    		player:setVisible(true)
            local star = ""
            for j=1,i do
                star = star.."0"
            end
            player:getChildByName("start"):getChildByName("start"):setString(star)

    		player:getChildByName("count"):getChildByName("count"):setString(self._info:getLong(1,"che_"..tostring(i)))
            local name = "20"..tostring(i)
    		player:getChildByName("person"):loadTexture(dd.getArmyIcon(tonumber(name)),0)
    	end
    end
    --panel:getChildByName("info"):setPositionY(hh)
    --hh = hh+48
    --panel:setContentSize(cc.size(685,hh))
    
    
    end

    self:getChildByName("main"):setItemsMargin(8)
    --self:getChildByName("main"):refreshView(true)
end

function towerInfoLayer.onBefore( sender )
    -- body
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    ff.net:bindProperty(2317,"gold",sender.updateGold)
end

function towerInfoLayer.onStart( sender )
    -- body
    local getMailListMsg = ff.net:createMessage()
    getMailListMsg:addCmd(0x0000001e)
    getMailListMsg:addLong(dd.uid)
    getMailListMsg:addLong(sender._troopID)
    
   -- cclog("=============id"..sender._troopID)
            
    ff.net:rpc(getMailListMsg,false)
    schedule(sender,sender.update,1)
    
end
function towerInfoLayer.updateGold(name,row,old,value)
    --cclog("sdfsdf")
    local widget = pop.getDialog("towerinfo")
    if widget ~= nil then
        --cclog("sdfsdf111111111111111111111111111111111111111111111111111111111111111111111111111111111111")
        widget:getChildByName("topArea"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("topArea"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("topArea"):requestDoLayout()
    end
end

function towerInfoLayer.onEnd( sender )
	-- body
	sender:stopAllActions()
	dd.delBackEvent()
    if sender._info ~= nil then
        sender._info:clear()
        sender._info = nil
    end
	ff.net:removeEvent(1,dd.Tjf_GetWatchTowerDetail)
    ff.net:unbindProperty("gold",2317)
end

function towerInfoLayer:addUiEvent()
	-- body
	local function update( towerinfo )
		-- body
		if towerinfo == nil then
			return
		end

		--cclog("==========shoudao !!!!!!!!!!!!!!!")

		if self._info then
			self._info:clear()
			self._info = nil
		end

		self._type = towerinfo.type
		self._from = towerinfo.from
		self._to = towerinfo.to
		self._start = towerinfo.start
		self._arrival = towerinfo.arrival
		self._allyFlag = towerinfo.allyFlag
		self._loginName = towerinfo.loginName
        self._playerId = towerinfo.playerid
		self._heromaster = towerinfo.heromaster
		self._heroname = towerinfo.heroname
		self._heroid = towerinfo.heroid
		self._heroLv = towerinfo.heroLv

		self._alltroop = towerinfo.alltroop

		cclog("id=="..self._heroid.."all=="..self._alltroop)
		self._info = ff.NetTable:create()
		--cclog("====================")
		--self._info:addCol("playerid",ff.NET_LONG)
		--self._info:addCol("citypos",ff.NET_LONG)
		--self._info:addCol("allyofficial",ff.NET_LONG)
		--self._info:addCol("username",ff.NET_STRING,15)
		self._info:addCol("bu_1",ff.NET_LONG)
		self._info:addCol("bu_2",ff.NET_LONG)
		self._info:addCol("bu_3",ff.NET_LONG)
		self._info:addCol("bu_4",ff.NET_LONG)
		self._info:addCol("bu_5",ff.NET_LONG)
		self._info:addCol("bu_6",ff.NET_LONG)
		self._info:addCol("qi_1",ff.NET_LONG)
		self._info:addCol("qi_2",ff.NET_LONG)
		self._info:addCol("qi_3",ff.NET_LONG)
		self._info:addCol("qi_4",ff.NET_LONG)
		self._info:addCol("qi_5",ff.NET_LONG)
		self._info:addCol("qi_6",ff.NET_LONG)
		self._info:addCol("gong_1",ff.NET_LONG)
		self._info:addCol("gong_2",ff.NET_LONG)
		self._info:addCol("gong_3",ff.NET_LONG)
		self._info:addCol("gong_4",ff.NET_LONG)
		self._info:addCol("gong_5",ff.NET_LONG)
		self._info:addCol("gong_6",ff.NET_LONG)
		self._info:addCol("che_1",ff.NET_LONG)
		self._info:addCol("che_2",ff.NET_LONG)
		self._info:addCol("che_3",ff.NET_LONG)
		self._info:addCol("che_4",ff.NET_LONG)
		self._info:addCol("che_5",ff.NET_LONG)
		self._info:addCol("che_6",ff.NET_LONG)
		self._info:addCol("jiaobucount",ff.NET_LONG)
		--self._info:addCol("jiaobulv",ff.NET_LONG)
		self._info:addCol("jiaoqicount",ff.NET_LONG)
		--self._info:addCol("jiaoqilv",ff.NET_LONG)
		self._info:addCol("jiaogongcount",ff.NET_LONG)
		--self._info:addCol("jiaogonglv",ff.NET_LONG)

		local bu_1 = 0
		local bu_2 = 0
		local bu_3 = 0
		local bu_4 = 0
		local bu_5 = 0
		local bu_6 = 0
		local qi_1 = 0
		local qi_2 = 0
		local qi_3 = 0
		local qi_4 = 0
		local qi_5 = 0
		local qi_6 = 0
		local gong_1 = 0
		local gong_2 = 0
		local gong_3 = 0
		local gong_4 = 0
		local gong_5 = 0
		local gong_6 = 0
		local che_1 = 0
		local che_2 = 0
		local che_3 = 0
		local che_4 = 0
		local che_5 = 0
		local che_6 = 0
		local jiaobucount = 0
		local jiaoqicount = 0
		local jiaogongcount = 0

		if towerinfo.info ~= nil then

		for i=1,towerinfo.info:rowCount() do
			if towerinfo.info:getLong(i,"bu_1") > 0 then
				bu_1 = bu_1 + towerinfo.info:getLong(i,"bu_1")
			end
			if towerinfo.info:getLong(i,"bu_2") > 0 then
				bu_2 = bu_2 + towerinfo.info:getLong(i,"bu_2")
			end
			if towerinfo.info:getLong(i,"bu_3") > 0 then
				bu_3 = bu_3 + towerinfo.info:getLong(i,"bu_3")
			end
			if towerinfo.info:getLong(i,"bu_4") > 0 then
				bu_4 = bu_4 + towerinfo.info:getLong(i,"bu_4")
			end
			if towerinfo.info:getLong(i,"bu_5") > 0 then
				bu_5 = bu_5 + towerinfo.info:getLong(i,"bu_5")
			end
			if towerinfo.info:getLong(i,"bu_6") > 0 then
				bu_6 = bu_6 + towerinfo.info:getLong(i,"bu_6")
			end
			if towerinfo.info:getLong(i,"qi_1") > 0 then
				qi_1 = qi_1 + towerinfo.info:getLong(i,"qi_1")
			end
			if towerinfo.info:getLong(i,"qi_2") > 0 then
				qi_2 = qi_2 + towerinfo.info:getLong(i,"qi_2")
			end
			if towerinfo.info:getLong(i,"qi_3") > 0 then
				qi_3 = qi_3 + towerinfo.info:getLong(i,"qi_3")
			end
			if towerinfo.info:getLong(i,"qi_4") > 0 then
				qi_4 = qi_4 + towerinfo.info:getLong(i,"qi_4")
			end
			if towerinfo.info:getLong(i,"qi_5") > 0 then
				qi_5 = qi_5 + towerinfo.info:getLong(i,"qi_5")
			end
			if towerinfo.info:getLong(i,"qi_6") > 0 then
				qi_6 = qi_6 + towerinfo.info:getLong(i,"qi_6")
			end
			if towerinfo.info:getLong(i,"gong_1") > 0 then
				gong_1 = gong_1 + towerinfo.info:getLong(i,"gong_1")
			end
			if towerinfo.info:getLong(i,"gong_2") > 0 then
				gong_2 = gong_2 + towerinfo.info:getLong(i,"gong_2")
			end
			if towerinfo.info:getLong(i,"gong_3") > 0 then
				gong_3 = gong_3 + towerinfo.info:getLong(i,"gong_3")
			end
			if towerinfo.info:getLong(i,"gong_4") > 0 then
				gong_4 = gong_4 + towerinfo.info:getLong(i,"gong_4")
			end
			if towerinfo.info:getLong(i,"gong_5") > 0 then
				gong_5 = gong_5 + towerinfo.info:getLong(i,"gong_5")
			end
			if towerinfo.info:getLong(i,"gong_6") > 0 then
				gong_6 = gong_6 + towerinfo.info:getLong(i,"gong_6")
			end
			if towerinfo.info:getLong(i,"che_1") > 0 then
				che_1 = che_1 + towerinfo.info:getLong(i,"che_1")
			end
			if towerinfo.info:getLong(i,"che_2") > 0 then
				che_2 = che_2 + towerinfo.info:getLong(i,"che_2")
			end
			if towerinfo.info:getLong(i,"che_3") > 0 then
				che_3 = che_3 + towerinfo.info:getLong(i,"che_3")
			end
			if towerinfo.info:getLong(i,"che_4") > 0 then
				che_4 = che_4 + towerinfo.info:getLong(i,"che_4")
			end
			if towerinfo.info:getLong(i,"che_5") > 0 then
				che_5 = che_5 + towerinfo.info:getLong(i,"che_5")
			end
			if towerinfo.info:getLong(i,"che_6") > 0 then
				che_6 = che_6 + towerinfo.info:getLong(i,"che_6")
			end
			if towerinfo.info:getLong(i,"jiaobucount") > 0 then
				jiaobucount = jiaobucount + towerinfo.info:getLong(i,"jiaobucount")
			end
			if towerinfo.info:getLong(i,"jiaoqicount") > 0 then
				jiaoqicount = jiaoqicount + towerinfo.info:getLong(i,"jiaoqicount")
			end
			if towerinfo.info:getLong(i,"jiaogongcount") > 0 then
				jiaogongcount = jiaogongcount + towerinfo.info:getLong(i,"jiaogongcount")
			end
		end
	end

		self._info:addRow()
		self._info:setLong(1,"bu_1",bu_1)
		self._info:setLong(1,"bu_2",bu_2)
		self._info:setLong(1,"bu_3",bu_3)
		self._info:setLong(1,"bu_4",bu_4)
		self._info:setLong(1,"bu_5",bu_5)
		self._info:setLong(1,"bu_6",bu_6)
		self._info:setLong(1,"qi_1",qi_1)
		self._info:setLong(1,"qi_2",qi_2)
		self._info:setLong(1,"qi_3",qi_3)
		self._info:setLong(1,"qi_4",qi_4)
		self._info:setLong(1,"qi_5",qi_5)
		self._info:setLong(1,"qi_6",qi_6)
		self._info:setLong(1,"gong_1",gong_1)
		self._info:setLong(1,"gong_2",gong_2)
		self._info:setLong(1,"gong_3",gong_3)
		self._info:setLong(1,"gong_4",gong_4)
		self._info:setLong(1,"gong_5",gong_5)
		self._info:setLong(1,"gong_6",gong_6)
		self._info:setLong(1,"che_1",che_1)
		self._info:setLong(1,"che_2",che_2)
		self._info:setLong(1,"che_3",che_3)
		self._info:setLong(1,"che_4",che_4)
		self._info:setLong(1,"che_5",che_5)
		self._info:setLong(1,"che_6",che_6)
		self._info:setLong(1,"jiaobucount",jiaobucount)
		self._info:setLong(1,"jiaoqicount",jiaoqicount)
		self._info:setLong(1,"jiaogongcount",jiaogongcount)

		cclog("bu1=="..bu_1)
		cclog("bu2=="..bu_2)
		cclog("bu3=="..bu_3)
		cclog("bu4=="..bu_4)
		cclog("bu5=="..bu_5)
		cclog("bu6=="..bu_6)
		cclog("qi1=="..qi_1)
		cclog("qi2=="..qi_2)
		cclog("qi3=="..qi_3)
		cclog("qi4=="..qi_4)
		cclog("qi5=="..qi_5)
		cclog("qi6=="..qi_6)
		cclog("gong_1=="..gong_1)
		cclog("gong_2=="..gong_2)
		cclog("gong_3=="..gong_3)
		cclog("gong_4=="..gong_4)
		cclog("gong_5=="..gong_5)
		cclog("gong_6=="..gong_6)
		cclog("che_1=="..che_1)
		cclog("che_2=="..che_2)
		cclog("che_3=="..che_3)
		cclog("che_4=="..che_4)
		cclog("che_5=="..che_5)
		cclog("che_6=="..che_6)
		
        if towerinfo.info ~= nil then
		towerinfo.info:clear()
        end
		self:showinfo()
	end

	ff.net:registerEvent(1,dd.Tjf_GetWatchTowerDetail,update)
end