--司令部升级
local buildHelpLayer   = class("buildHelpLayer")
buildHelpLayer._name = "buildHelp"
buildHelpLayer._init = false
buildHelpLayer.bid = 0
buildHelpLayer.lv = 0

function buildHelpLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, buildHelpLayer)
    return target
end
function buildHelpLayer:onInit()
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,hh - 214))
        self:getChildByName("mask"):setContentSize(cc.size(720,hh - 214))
        self:getChildByName("back"):setContentSize(cc.size(720,hh - 214 - 105 - 85 - 60))
        self:getChildByName("top"):setPositionY(hh - 214 - 105 - 85 - 60)
        self:getChildByName("bottom"):setPositionY(0)
        self:getChildByName("close"):setPositionY(hh - 214 - 105 - 85 - 60 - 27)
        self:getChildByName("list_back"):setContentSize(cc.size(720,hh - 214 - 105 - 85 - 60 - 60 - 23))
        self:getChildByName("list"):setContentSize(cc.size(720,hh - 214 - 105 - 85 - 60 - 110 - 30))
        self:getChildByName("chu_name_text"):setPositionY(hh - 214 - 105 - 85 - 60 - 20)
        self:getChildByName("title"):setPositionY(hh - 214 - 105 - 85 - 60 - 85)
        self:getChildByName("close"):addTouchEventListener(self.onReturn)
        self._init = true
    end
    self:initTitle()
    self:getChildByName("list"):removeAllChildren()
end
function buildHelpLayer:setTitle(tag)
    self:getChildByName("title"):getChildByName("chu_effect_text_1"):setVisible(tag>=1)
    self:getChildByName("title"):getChildByName("chu_effect_text_2"):setVisible(tag>=2)
    self:getChildByName("title"):getChildByName("chu_effect_text_3"):setVisible(tag>=3)
    self:getChildByName("lvItem"):getChildByName("num1"):setVisible(tag>=1)
    self:getChildByName("lvItem"):getChildByName("num2"):setVisible(tag>=2)
    self:getChildByName("lvItem"):getChildByName("num3"):setVisible(tag>=3)
end
function buildHelpLayer:initTitle()
    if self.bid == 2 then
        self:setTitle(2)
        self:getChildByName("title"):getChildByName("chu_effect_text_1"):setString(ff.langString("保护量"))
        self:getChildByName("title"):getChildByName("chu_effect_text_2"):setString(ff.langString("减少粮耗"))
    elseif self.bid == 4 then
        self:setTitle(1)
        self:getChildByName("title"):getChildByName("chu_effect_text_1"):setString(ff.langString("锻造速度"))
    elseif self.bid == 5 then
        self:setTitle(1)
        self:getChildByName("title"):getChildByName("chu_effect_text_1"):setString(ff.langString("城防容量"))
    elseif self.bid == 12 then
        self:setTitle(1)
        self:getChildByName("title"):getChildByName("chu_effect_text_1"):setString(ff.langString("经验加成"))
    elseif self.bid == 32 then
        self:setTitle(1)
        self:getChildByName("title"):getChildByName("chu_effect_text_1"):setString(ff.langString("制造速度"))
    elseif self.bid == 11 then
        self:setTitle(1)
        self:getChildByName("title"):getChildByName("chu_effect_text_1"):setString(ff.langString("研发速度"))
    elseif self.bid == 3 then
        self:setTitle(1)
        self:getChildByName("title"):getChildByName("chu_effect_text_1"):setString(ff.langString("反侦察能力"))
    elseif self.bid == 23 then
        self:setTitle(2)
        self:getChildByName("title"):getChildByName("chu_effect_text_1"):setString(ff.langString("产量"))
        self:getChildByName("title"):getChildByName("chu_effect_text_2"):setString(ff.langString("生产上限"))
    elseif self.bid == 24 then
        self:setTitle(2)
        self:getChildByName("title"):getChildByName("chu_effect_text_1"):setString(ff.langString("产量"))
        self:getChildByName("title"):getChildByName("chu_effect_text_2"):setString(ff.langString("生产上限"))
    elseif self.bid == 25 then
        self:setTitle(2)
        self:getChildByName("title"):getChildByName("chu_effect_text_1"):setString(ff.langString("产量"))
        self:getChildByName("title"):getChildByName("chu_effect_text_2"):setString(ff.langString("生产上限"))
    elseif self.bid == 26 then
        self:setTitle(2)
        self:getChildByName("title"):getChildByName("chu_effect_text_1"):setString(ff.langString("产量"))
        self:getChildByName("title"):getChildByName("chu_effect_text_2"):setString(ff.langString("生产上限"))
    elseif self.bid == 27 then
        self:setTitle(3)
        self:getChildByName("title"):getChildByName("chu_effect_text_1"):setString(ff.langString("产量"))
        self:getChildByName("title"):getChildByName("chu_effect_text_2"):setString(ff.langString("生产上限"))
        self:getChildByName("title"):getChildByName("chu_effect_text_3"):setString(ff.langString("单次征兵上限"))

    end
end
function buildHelpLayer:initInfo()
    self:getChildByName("chu_name_text"):setString(ff.langString(dd.cfgBuilding[self.bid]['name']))
    self:getChildByName("list"):removeAllChildren()
    for key, value in pairs(dd.cfgBuildingUp[self.bid]) do
        if dd.cfgBuilding[self.bid]['maxlevel'] < key then
            break
        end
        local item = self:getChildByName("lvItem"):clone() 
        item:setVisible(true)
        if key == self.lv then
            item:loadTexture("images/icon/rank/help_back.png",0)
        end
        item:setTag(key)
        item:getChildByName("lv_text"):setString(key)
        local end1 = ""
        local chu1 = 1
        if value["param1"] > 0 and dd.cfgEffect[value["param1"]]['value'] == 10 then
            end1 = "%"  
            chu1 = dd.cfgEffect[value["param1"]]['value']
        end
        local end2 = ""
        local chu2 = 1
        if value["param2"] > 0 and dd.cfgEffect[value["param2"]]['value'] == 10 then
            end2 = "%"  
            chu2 = dd.cfgEffect[value["param2"]]['value']
        end
        local end3 = ""
        local chu3 = 1
        if value["param3"] > 0 and dd.cfgEffect[value["param3"]]['value'] == 10 then
            end3 = "%"                        
            chu3 = dd.cfgEffect[value["param3"]]['value'] 
        end
        item:getChildByName("num1"):setString(dd.showKM(value['value1']/chu1,5)..end1)
        item:getChildByName("num2"):setString(dd.showKM(value['value2']/chu2,5)..end2)
        item:getChildByName("num3"):setString(dd.showKM(value['value3']/chu3,5)..end3)
        self:getChildByName("list"):addChild(item)
    end
--    if self.bid == 2 then
--        local item = self:getChildByName("lvItem"):clone()
--        item:getChildByName("num1"):setContentSize(cc.size(500,47))
--        item:setVisible(true)
--        item:getChildByName("lv_text"):setString(ff.langString("Max"))
--        local v = dd.cfgEffect[dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['param1']]['value']
--        local addStr = ""
--        if v == 10 then
--            addStr = (dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['value1']/10)
--        else
--            addStr = dd.showKM(dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['value1'],5)
--        end
--        item:getChildByName("num1"):setString(ff.langString("银币保护量").."+"..addStr)
--        self:getChildByName("list"):addChild(item)
--    elseif self.bid == 3 then
--        local item = self:getChildByName("lvItem"):clone()
--        item:getChildByName("num1"):setContentSize(cc.size(500,47))
--        item:setVisible(true)
--        item:getChildByName("lv_text"):setString(ff.langString("Max"))
--        local v = dd.cfgEffect[dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['param2']]['value']
--        local addStr = ""
--        if v == 10 then
--            addStr = (dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['value2']/10)
--        else
--            addStr = dd.showKM(dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['value2'],5)
--        end
--        item:getChildByName("num1"):setString(ff.langString(dd.cfgEffect[dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['param2']]['tips1'],{addStr}))
--        self:getChildByName("list"):addChild(item)
--    elseif self.bid == 5 then
--        local item = self:getChildByName("lvItem"):clone()
--        item:getChildByName("num1"):setContentSize(cc.size(500,47))
--        item:setVisible(true)
--        item:getChildByName("lv_text"):setString(ff.langString("Max"))
--        local v = dd.cfgEffect[dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['param2']]['value']
--        local addStr = ""
--        cclog("v:"..v) 
--        if v == 10 then
--            addStr = (dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['value2']/10)
--        else
--            addStr = dd.showKM(dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['value2'],5)
--        end
--        item:getChildByName("num1"):setString(ff.langString(dd.cfgEffect[dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['param2']]['tips1'],{addStr}))
--        self:getChildByName("list"):addChild(item)
--    elseif self.bid == 12 then
--        local item = self:getChildByName("lvItem"):clone()
--        item:getChildByName("num1"):setContentSize(cc.size(500,47))
--        item:setVisible(true)
--        item:getChildByName("lv_text"):setString(ff.langString("Max"))
--        local v = dd.cfgEffect[dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['param2']]['value']
--        local addStr = ""
--        if v == 10 then
--            addStr = (dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['value2']/10)
--        else
--            addStr = dd.showKM(dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['value2'],5)
--        end
--        item:getChildByName("num1"):setString(ff.langString(dd.cfgEffect[dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['param2']]['tips1'],{addStr}))
--        self:getChildByName("list"):addChild(item)
--    end
    self:getChildByName("list"):refreshView(true)
    self:getChildByName("list"):jumpToTop()
end

--界面显示后调用
function buildHelpLayer.onStart(sender)
    sender:initInfo()
end

--界面关闭效果结束后调用
function buildHelpLayer.onEnd(sender)
    dd.delBackEvent(sender.onReturn)
    if ff.platform ~= 1 then
        if sender:getChildByName("list"):getChildByTag(sender.lv) ~= nil then
            sender:getChildByName("list"):getChildByTag(sender.lv):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        end
    end
end
--界面即将播放显示缓动时调用，返回false界面显示将终止
function buildHelpLayer.onBefore(sender)
    sender:getChildByName("mask"):setPositionY(ff.height - 214 - 105 - 85 - 60)
    return true
end

function buildHelpLayer:onClose()
    return false
end

function buildHelpLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("buildHelp")
        if widget~=nil and widget:onClose() == false then
            pop.onClosePopDialog("buildHelp")
        end    
    end
end
function onShowBuildHelp(widget,bid,level)
    local layer = buildHelpLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer.bid = bid
    layer.lv = level
    layer:onInit()
    return layer
end