--司令部升级
local embassyHelpLayer   = class("embassyHelpLayer")
embassyHelpLayer._name = "embassyHelp"
embassyHelpLayer._init = false
embassyHelpLayer.bid = 14
embassyHelpLayer.lv = 0
function embassyHelpLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, embassyHelpLayer)
    return target
end
function embassyHelpLayer:onInit()
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,hh - 214))
        self:getChildByName("back"):setContentSize(cc.size(720,hh - 214))
        self:getChildByName("mainArea"):setContentSize(cc.size(720,hh - 214 - 120))
        self:getChildByName("mainArea"):setInnerContainerSize(cc.size(720,hh - 214 - 120))
        self:getChildByName("mainArea"):getChildByName("mainArea"):setContentSize(cc.size(720,hh - 214 - 120))
        self:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("mainback"):setContentSize(cc.size(690,hh - 214 - 120 + 4))
        self:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("lvArea"):setContentSize(cc.size(690,hh - 214 - 120 - 635))
        self:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("lvArea"):setInnerContainerSize(cc.size(690,52*dd.cfgBuilding[self.bid]['maxlevel']))
        self:getChildByName("topArea"):getChildByName("return"):addTouchEventListener(self.onReturn)
        self:getChildByName("topArea"):getChildByName("add_btn"):addTouchEventListener(dd.onPay)
        self._init = true
    end
    self.updateGold()
    self:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("lvArea"):removeAllChildren()
end
function embassyHelpLayer.updateGold()
    local sender = pop.getDialog("embassy_help")
    if sender ~= nil then
        sender:getChildByName("topArea"):getChildByName("gold_text"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("topArea"):getChildByName("gold_text"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("topArea"):requestDoLayout()
    end
end
function embassyHelpLayer:initInfo()
    for i=1,dd.mybuilds:rowCount() do
        if 14 == dd.mybuilds:getLong(i,"bid") then
            self.lv = dd.mybuilds:getLong(i,"level")
            break
        end
    end
    self:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("lvArea"):removeAllChildren()
    for key, value in pairs(dd.cfgBuildingUp[14]) do
        if dd.cfgBuilding[self.bid]['maxlevel'] < key then
            break
        end
    	local item = self:getChildByName("lvItem"):clone()
    	item:setVisible(true)
    	item:setTag(key)
    	item:getChildByName("lv_text"):setString(key)
        item:getChildByName("num_text"):setString(dd.showKM(value['value1'],5))
        if key == self.lv then
            item:loadTexture("images/icon/rank/help_back.png",0)
        end
        local xx = 0
        local yy = 52*dd.cfgBuilding[self.bid]['maxlevel'] - (key-1)*52
        item:setPosition(cc.p(xx,yy))
        self:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("lvArea"):addChild(item)
    end
end

--界面显示后调用
function embassyHelpLayer.onStart(sender)
    ff.net:bindProperty(2400,"gold",function ()sender.updateGold() end)
    sender:initInfo()
end

--界面关闭效果结束后调用
function embassyHelpLayer.onEnd(sender)
    dd.delBackEvent(sender.onReturn)
    ff.net:unbindProperty("gold",2400) 
end
--界面即将播放显示缓动时调用，返回false界面显示将终止
function embassyHelpLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("icon"),sender:getChildByName("topArea"):getChildByName("add_btn"))
    return true
end

function embassyHelpLayer:onClose()
    return false
end

function embassyHelpLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("embassy_help")
        if widget~=nil and widget:onClose() == false then
            pop.onClosePopDialog("embassy_help")
        end    
    end
end
function onShowEmbassyHelp(widget)
    local layer = embassyHelpLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end