--card
local cardLayer = class("card")
cardLayer._name = "card"
cardLayer._init = false
cardLayer._operate = 1
cardLayer._sprite  = nil

function cardLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, cardLayer)
    return target
end

function cardLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height - 211
    end
end

function cardLayer:onInit()
    if self._init == false then        
        local function onClose(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                pop.onClosePopDialog("card")
            end
        end
        
        local function onBuy(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                local row  = cc.UserDefault:getInstance():getIntegerForKey("httpif")
                local type = hif._lists:getLong(row,"type") 
                self._operate = 1
                if type == 1 then
                    --模拟充值
                    local message = ff.net:createMessage()
                    message:addCmd(0x135)
                    message:addLong(dd.uid)
                    message:addLong(401)
                    ff.net:postMessage(message)
                else
                    platform_pay(dd.cfgCharge[401]['product'],dd.cfgCharge[401]['gold'])
                end
            end
        end
        local function onBuy1(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                local row  = cc.UserDefault:getInstance():getIntegerForKey("httpif")
                local type = hif._lists:getLong(row,"type") 
                self._operate = 1
                if type == 1 then
                    --模拟充值
                    local message = ff.net:createMessage()
                    message:addCmd(0x135)
                    message:addLong(dd.uid)
                    message:addLong(402)
                    ff.net:postMessage(message)
                else
                    platform_pay(dd.cfgCharge[402]['product'],dd.cfgCharge[402]['gold'])
                end
            end
        end
        
        local function onGet(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                self:takePrepaidCard()
            end
        end
        local function onGet1(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                self:takePrepaidCard1()
            end
        end
        
        local function onRenew(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                local row  = cc.UserDefault:getInstance():getIntegerForKey("httpif")
                local type = hif._lists:getLong(row,"type") 
                self._operate = 2
                if type == 1 then
                    --模拟充值
                    local message = ff.net:createMessage()
                    message:addCmd(0x135)
                    message:addLong(dd.uid)
                    message:addLong(401)
                    ff.net:postMessage(message)
                else
                    platform_pay(dd.cfgCharge[401]['product'],dd.cfgCharge[401]['gold'])
                end
            end
        end

        local function onRenew1(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                local row  = cc.UserDefault:getInstance():getIntegerForKey("httpif")
                local type = hif._lists:getLong(row,"type") 
                self._operate = 2
                if type == 1 then
                    --模拟充值
                    local message = ff.net:createMessage()
                    message:addCmd(0x135)
                    message:addLong(dd.uid)
                    message:addLong(402)
                    ff.net:postMessage(message)
                else
                    platform_pay(dd.cfgCharge[402]['product'],dd.cfgCharge[402]['gold'])
                end
            end
        end
        
        self:getChildByName("close"):addTouchEventListener(onClose)
        self:getChildByName("buy"):getChildByName("buybtn"):addTouchEventListener(onBuy)
        self:getChildByName("get"):getChildByName("getbtn"):addTouchEventListener(onGet)
        self:getChildByName("get"):getChildByName("renew"):addTouchEventListener(onRenew)
        self:getChildByName("haveget"):getChildByName("renew"):addTouchEventListener(onRenew)
        self:getChildByName("theme"):getChildByName("chu_tip"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3)  
        --加粗
        self:getChildByName("info"):getChildByName("info1"):getChildByName("worth"):getVirtualRenderer():enableBold(true) 
        self:getChildByName("info"):getChildByName("info1"):getChildByName("price"):getVirtualRenderer():enableBold(true)  
        self:getChildByName("info"):getChildByName("info1"):getChildByName("sale"):getChildByName("value"):getVirtualRenderer():enableBold(true)

        self:getChildByName("buy1"):getChildByName("buybtn"):addTouchEventListener(onBuy1)
        self:getChildByName("get1"):getChildByName("getbtn"):addTouchEventListener(onGet1)
        self:getChildByName("get1"):getChildByName("renew"):addTouchEventListener(onRenew1)
        self:getChildByName("haveget1"):getChildByName("renew"):addTouchEventListener(onRenew1)
        --self:getChildByName("theme1"):getChildByName("chu_tip"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3)  
        --加粗
        self:getChildByName("info1"):getChildByName("info1"):getChildByName("worth"):getVirtualRenderer():enableBold(true) 
        self:getChildByName("info1"):getChildByName("info1"):getChildByName("price"):getVirtualRenderer():enableBold(true)  
        self:getChildByName("info1"):getChildByName("info1"):getChildByName("sale"):getChildByName("value"):getVirtualRenderer():enableBold(true)
           
        self:initCardInfo()
        self._init = true
    end
    self:updateOperate()
    self:getChildByName("haveget"):getChildByName("time"):setString("00:00:00")
    self:getChildByName("info"):getChildByName("light"):runAction(cc.RepeatForever:create(cc.RotateBy:create(13,360)))
    self:getChildByName("haveget1"):getChildByName("time"):setString("00:00:00")
    self:getChildByName("info1"):getChildByName("light"):runAction(cc.RepeatForever:create(cc.RotateBy:create(13,360)))
end

function cardLayer:initCardInfo()
    local info = self:getChildByName("info")
    info:getChildByName("get_value"):setString(ff.getFormatMoney(dd.cfgCharge[401]["getgold"]))   --立即获得
    info:getChildByName("day_value"):setString(600)
    info:getChildByName("info1"):getChildByName("worth"):setString(ff.getFormatMoney(dd.cfgCharge[401]["getgold"] + 600*30))
    info:getChildByName("info1"):getChildByName("price"):setString(dd.cfgCharge[401]['fuhao']..dd.cfgCharge[401]["goldforshow"]/100) --充值多少
    info:getChildByName("info1"):getChildByName("sale"):getChildByName("value"):setString(dd.cfgCharge[401]["value"].."%")
    local info = self:getChildByName("info1")
    info:getChildByName("get_value"):setString(ff.getFormatMoney(dd.cfgCharge[402]["getgold"]))   --立即获得
    info:getChildByName("day_value"):setString(300)
    info:getChildByName("info1"):getChildByName("worth"):setString(ff.getFormatMoney(dd.cfgCharge[402]["getgold"] + 300*30))
    info:getChildByName("info1"):getChildByName("price"):setString(dd.cfgCharge[402]['fuhao']..dd.cfgCharge[402]["goldforshow"]/100) --充值多少
    info:getChildByName("info1"):getChildByName("sale"):getChildByName("value"):setString(dd.cfgCharge[402]["value"].."%")  
end

function cardLayer:showBuy()
    self:getChildByName("buy"):setVisible(true)
    self:getChildByName("get"):setVisible(false)
    self:getChildByName("haveget"):setVisible(false)

end

function cardLayer:showBuy1()
    self:getChildByName("buy1"):setVisible(true)
    self:getChildByName("get1"):setVisible(false)
    self:getChildByName("haveget1"):setVisible(false)

end
function cardLayer:showGet()
    self:getChildByName("buy"):setVisible(false)
    self:getChildByName("get"):setVisible(true)
    self:getChildByName("haveget"):setVisible(false)

    self:getChildByName("get"):getChildByName("value"):setString(ff.getFormatMoney(dd.myCard:getLong(1,"golds")))
    self:getChildByName("get"):getChildByName("days"):setString(ff.langString("剩余：{0}天",{ff.getFormatMoney(dd.myCard:getLong(1,"days"))}))
end
function cardLayer:showHaveGet()
    self:getChildByName("buy"):setVisible(false)
    self:getChildByName("get"):setVisible(false)
    self:getChildByName("haveget"):setVisible(true)

    self:getChildByName("haveget"):getChildByName("time"):setString(ff.getLeftTime(dd.myCard:getLong(1,"time")-dd.getServerTime(),":"))
    self:getChildByName("haveget"):getChildByName("days"):setString(ff.langString("剩余：{0}天",{ff.getFormatMoney(dd.myCard:getLong(1,"days"))}))
end

function cardLayer:showGet1()
    self:getChildByName("buy1"):setVisible(false)
    self:getChildByName("get1"):setVisible(true)
    self:getChildByName("haveget1"):setVisible(false)

    self:getChildByName("get1"):getChildByName("value"):setString(ff.getFormatMoney(dd.myCard:getLong(1,"golds1")))
    self:getChildByName("get1"):getChildByName("days"):setString(ff.langString("剩余：{0}天",{ff.getFormatMoney(dd.myCard:getLong(1,"days1"))}))
end
function cardLayer:showHaveGet1()
    self:getChildByName("buy1"):setVisible(false)
    self:getChildByName("get1"):setVisible(false)
    self:getChildByName("haveget1"):setVisible(true)

    self:getChildByName("haveget1"):getChildByName("time"):setString(ff.getLeftTime(dd.myCard:getLong(1,"time1")-dd.getServerTime(),":"))
    self:getChildByName("haveget1"):getChildByName("days"):setString(ff.langString("剩余：{0}天",{ff.getFormatMoney(dd.myCard:getLong(1,"days1"))}))
end

function cardLayer:updateOperate()
    if dd.myCard == nil then
        self:showBuy()
        self:showBuy1()
    else
        if dd.myCard:getLong(1,"days") == 0 then
            self:showBuy()
        else
            if dd.myCard:getLong(1,"golds") > 0 then
                self:showGet()
            else
                self:showHaveGet()
            end
        end
        --cclog("========="..dd.myCard:getLong(1,"days1").."=="..dd.myCard:getLong(1,"golds1"))
        if dd.myCard:getLong(1,"days1") == 0 then
            self:showBuy1()
        else
            if dd.myCard:getLong(1,"golds1") > 0 then
                self:showGet1()
            else
                self:showHaveGet1()
            end
        end
    end 
end

function cardLayer:takePrepaidCard()
    local message = ff.net:createMessage()
    message:addCmd(0x152)
    message:addLong(dd.uid)
    message:addLong(0)
    ff.net:rpc(message,false) 
end

function cardLayer:takePrepaidCard1()
    local message = ff.net:createMessage()
    message:addCmd(0x152)
    message:addLong(dd.uid)
    message:addLong(1)
    ff.net:rpc(message,false) 
end

function cardLayer:onTakePrepaidCard(params)
    local code = params[1]
    if code == 0 then
        self:updateOperate()
        dd.mainUI:showGiftNotice(7,0,params[2],cc.p(180,250),1)
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("领取成功"),true)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
function cardLayer:onTestCharge(params)
    --[[
    local code = params[1]
    if code == 0 then
        if self:getChildByName("buy"):isVisible() == true then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("购买成功"),true)
        else
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("续费成功"),true)
        end        
        self:updateOperate()
        
    else
        dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(code))
    end
    --]]
end

function cardLayer:onCardNotify(params)
    --[[
    if self:getChildByName("buy"):isVisible() == true then
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("购买成功"),true)
    else
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("续费成功"),true)
    end 
    --]]       
    self:updateOperate()
end
function cardLayer:onSNCharge(params)
    local id = params[1]
    if id == 401 or id == 402 then
        if self._operate == 1 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("购买成功"),true)
        else
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("续费成功"),true)
        end        
        self:updateOperate()
    end
end

function cardLayer.showAction()
    local sender = pop.getDialog("card")
    if sender:getChildByName("haveget"):isVisible() then
        local time = dd.myCard:getLong(1,"time")-dd.getServerTime()
        if time > 0 then
            sender:getChildByName("haveget"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
        else
            sender:updateOperate()
        end
    end
    --cclog("============"..dd.myCard:getLong(1,"time").."=="..dd.myCard:getLong(1,"time1"))
    if sender:getChildByName("haveget1"):isVisible() then
        local time1 = dd.myCard:getLong(1,"time1")-dd.getServerTime()
        if time1 > 0 then
            sender:getChildByName("haveget1"):getChildByName("time"):setString(ff.getLeftTime(time1,":"))
        else
            sender:updateOperate()
        end
    end
end

--接口
function cardLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
    end
end

function cardLayer:onClose()
   
end

function cardLayer.onStart(sender)
    ff.net:registerEvent(2,dd.Tjf_card_TakePrepaidCard, function (message)sender:onTakePrepaidCard(message)end)
    ff.net:registerEvent(504,dd.Tjf_charge_TestCharge, function (message)sender:onTestCharge(message)end)
    ff.net:registerEvent(401,dd.Tjf_notify_SNPrepaidCard, function (message)sender:onCardNotify(message)end)
    ff.net:registerEvent(401,dd.Tjf_notify_SNCharge, function (message)sender:onSNCharge(message)end)
    sender.showAction()
    schedule(sender, sender.showAction,1)
end

function cardLayer.onEnd(sender)
    dd.delBackEvent()
    sender:stopAllActions()
    sender:getChildByName("info"):getChildByName("light"):stopAllActions()
    ff.net:removeEvent(2,dd.Tjf_card_TakePrepaidCard)
    ff.net:removeEvent(504,dd.Tjf_charge_TestCharge)
    ff.net:removeEvent(401,dd.Tjf_notify_SNPrepaidCard)
    ff.net:removeEvent(401,dd.Tjf_notify_SNCharge)
end

function cardLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("card")
    if widget then
        pop.onClosePopDialog("card")
    end
end

function onShowCardLayer(widget)
    local layer = cardLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onAutoSize()
    layer:onInit()
    return layer
end