--更换头像
local changeHeadLayer = class("changeHead")
changeHeadLayer._name = "changeHead"
changeHeadLayer._init = false
changeHeadLayer._selectid = 0
changeHeadLayer._items = {}
changeHeadLayer._heads = {}--{1001,1002,1003,1004,1005,1006,1007,1008,1009,1010,1011,1012,1013,1014,1015}

function changeHeadLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, changeHeadLayer)
    return target
end

function changeHeadLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        
        self:getChildByName("bg"):setContentSize(cc.size(720,hh))
        self:getChildByName("bg"):setPositionY(0)
        
        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("mainArea"):setPositionY(164)
        self:getChildByName("mainArea"):setContentSize(cc.size(720, hh - 105 - 164))
        self:getChildByName("mainArea"):getChildByName("view"):setContentSize(cc.size(720, hh - 105 - 164-7))
    end
end

function changeHeadLayer:onInit()
    if self._init == false then   
        local function onChange(sender,eventType)
            if eventType==ccui.TouchEventType.ended then
                if dd.myinfo:getLong(1,"face") == self._selectid then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("正在使用该头像"))
                else
                    local message = ff.net:createMessage()
                    message:addCmd(0x10b)
                    message:addLong(dd.uid)   
                    message:addString("",15)
                    message:addLong(self._selectid)   
                    ff.net:rpc(message, false) 
                end
            end        
        end     
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
        self:getChildByName("topArea"):getChildByName("chu_title"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3)
        self:getChildByName("rebtn"):addTouchEventListener(onChange)
        self:setChangeBtnLight(false)
        self._init = true
    end
    --cclog("======sdf===="..dd.getToolsCount(1101).."=="..dd.getToolsCount(1102))
    self._heads = {1001,1002,1003,1004,1005,1006,1007,1008,1009,1010,1011,1012,1013,1014,1015}
    if dd.getToolsCount(1302) > 0 then
        table.insert(self._heads,1,2043)
    end
    if dd.getToolsCount(1300) > 0 then
        table.insert(self._heads,1,2042)
    end
    if dd.getToolsCount(1295) > 0 then
        table.insert(self._heads,1,2039)
    end
    if dd.getToolsCount(1296) > 0 then
        table.insert(self._heads,1,2040)
    end
    if dd.getToolsCount(1297) > 0 then
        table.insert(self._heads,1,2041)
    end
    if dd.getToolsCount(1287) > 0 then
        table.insert(self._heads,1,2036)
    end
    if dd.getToolsCount(1288) > 0 then
        table.insert(self._heads,1,2037)
    end
    if dd.getToolsCount(1289) > 0 then
        table.insert(self._heads,1,2038)
    end

    if dd.getToolsCount(1283) > 0 then
        table.insert(self._heads,1,2033)
    end
    if dd.getToolsCount(1284) > 0 then
        table.insert(self._heads,1,2034)
    end
    if dd.getToolsCount(1285) > 0 then
        table.insert(self._heads,1,2035)
    end
    if dd.getToolsCount(1274) > 0 then
        table.insert(self._heads,1,2031)
    end
    if dd.getToolsCount(1275) > 0 then
        table.insert(self._heads,1,2032)
    end
    if dd.getToolsCount(1137) > 0 then
        table.insert(self._heads,1,2028)
    end
    if dd.getToolsCount(1138) > 0 then
        table.insert(self._heads,1,2029)
    end
    if dd.getToolsCount(1139) > 0 then
        table.insert(self._heads,1,2030)
    end
    if dd.getToolsCount(1134) > 0 then
        table.insert(self._heads,1,2025)
    end
    if dd.getToolsCount(1135) > 0 then
        table.insert(self._heads,1,2026)
    end
    if dd.getToolsCount(1136) > 0 then
        table.insert(self._heads,1,2027)
    end
    if dd.getToolsCount(1131) > 0 then
        table.insert(self._heads,1,2022)
    end
    if dd.getToolsCount(1132) > 0 then
        table.insert(self._heads,1,2023)
    end
    if dd.getToolsCount(1133) > 0 then
        table.insert(self._heads,1,2024)
    end
    if dd.getToolsCount(1128) > 0 then
        table.insert(self._heads,1,2019)
    end
    if dd.getToolsCount(1129) > 0 then
        table.insert(self._heads,1,2020)
    end
    if dd.getToolsCount(1130) > 0 then
        table.insert(self._heads,1,2021)
    end
    if dd.getToolsCount(1121) > 0 then
        table.insert(self._heads,1,2016)
    end
    if dd.getToolsCount(1122) > 0 then
        table.insert(self._heads,1,2017)
    end
    if dd.getToolsCount(1123) > 0 then
        table.insert(self._heads,1,2018)
    end
    if dd.getToolsCount(1062) > 0 then
        table.insert(self._heads,1,2013)
    end
    if dd.getToolsCount(1063) > 0 then
        table.insert(self._heads,1,2014)
    end
    if dd.getToolsCount(1064) > 0 then
        table.insert(self._heads,1,2015)
    end
    if dd.getToolsCount(1076) > 0 then
        table.insert(self._heads,1,2010)
    end
    if dd.getToolsCount(1077) > 0 then
        table.insert(self._heads,1,2011)
    end
    if dd.getToolsCount(1078) > 0 then
        table.insert(self._heads,1,2012)
    end
    if dd.getToolsCount(1101) > 0 then
        table.insert(self._heads,1,2001)
    end
    if dd.getToolsCount(1102) > 0 then
        table.insert(self._heads,1,2002)
    end
    if dd.getToolsCount(1105) > 0 then
        table.insert(self._heads,1,2005)
    end
    if dd.getToolsCount(1106) > 0 then
        table.insert(self._heads,1,2006)
    end
    if dd.getToolsCount(1108) > 0 then
        table.insert(self._heads,1,2008)
    end
    if dd.getToolsCount(1109) > 0 then
        table.insert(self._heads,1,2009)
    end
    if dd.getToolsCount(1215) > 0 then
        table.insert(self._heads,1,2004)
    end
    if dd.getToolsCount(1214) > 0 then
        table.insert(self._heads,1,2003)
    end
    
end

function changeHeadLayer:updateHeadList()
    local view = self:getChildByName("mainArea"):getChildByName("view")
    local hh = view:getContentSize().height
    local num = table.getn(self._heads)
    local innerhh = 0
    local count = 0
    local row = math.ceil(num/3)
    --隐藏items
    for i,v in ipairs(self._items) do
        if tolua.isnull(v) then
            self._items[i] = nil
        else
            v:setVisible(false)
            v:setTag(i)
        end
    end
    if row*214 > hh then
        view:setInnerContainerSize(cc.size(720,row*214))
        innerhh = row*214
    else
        view:setInnerContainerSize(cc.size(720,hh))
        innerhh = hh
    end
    
    for i,id in pairs(self._heads) do
        local item = self._items[i]
        if item == nil then
            item = self:getChildByName("mainArea"):getChildByName("itemmode"):clone()
            self._items[i] = item
            view:addChild(item)
        end
        item:setVisible(true)        
        item:setPositionX(125 + ((i-1)%3)*235 )
        item:setPositionY(innerhh - 110 - math.floor((i-1)/3)*214 )
        item:getChildByName("icon"):loadTexture(dd.getPlayerIcon(id), 0)
        item.hid = id
        item.pid = 2   --前置条件
        item:setTag(id)
        item:addTouchEventListener(self.onSelect)
    end
end

function changeHeadLayer:isLock(hid)
    return false
end

function changeHeadLayer:setChangeBtnLight(select)
    if select == true then
        self:getChildByName("rebtn"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        self:getChildByName("rebtn"):setTouchEnabled(true)
    else 
        local effect = ff.Effect:effectGrey()    
        self:getChildByName("rebtn"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        self:getChildByName("rebtn"):setTouchEnabled(false)
    end
end

function changeHeadLayer.onSelect(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            sender:setSelectedState(true)
            local widge = pop.getDialog("changeHead")
            if widge._selectid ~= sender.hid then
                local item = widge:getChildByName("mainArea"):getChildByName("view"):getChildByTag(widge._selectid)  
                if item ~= nil then
                    item:setSelectedState(false)
                end 
                widge._selectid = sender.hid
    
                if widge:isLock(widge._selectid) == true then
                    widge:setChangeBtnLight(false)
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("未满足前置条件"))
                else
                    widge:setChangeBtnLight(true)
                end            
                doaction = true
            end
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
        local widge = pop.getDialog("changeHead")
        local item = widge:getChildByName("mainArea"):getChildByName("view"):getChildByTag(widge._selectid)  
        if item ~= nil then
            item:setSelectedState(false)
        end 
        widge._selectid = sender.hid

        if widge:isLock(widge._selectid) == true then
            widge:setChangeBtnLight(false)
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("未满足前置条件"))
        else
            widge:setChangeBtnLight(true)
        end
    end
    if doaction == true then
    end
end

function changeHeadLayer:onChangeHead(params)
    local code = params[1]
    if code == 0 then
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("更换成功"),true)
        local widget = pop.getDialog("changeHead")
        if widget ~= nil then
            pop.onClosePopDialog("changeHead")
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

--接口
function changeHeadLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("changeHead")
        if widget ~= nil then
            pop.onClosePopDialog("changeHead")
        end
    end
end

function changeHeadLayer:onClose()

end

function changeHeadLayer.onStart(sender)
    ff.net:registerEvent(4,dd.Tjf_User_ChangeName, function (message)sender:onChangeHead(message)end)
    sender:updateHeadList()
    local item = sender:getChildByName("mainArea"):getChildByName("view"):getChildByTag(dd.myinfo:getLong(1,"face"))
    if item ~= nil then
        sender.onSelect(item, ccui.TouchEventType.ended)
        item:setSelectedState(true)
    end
end

function changeHeadLayer.onEnd(sender)
    dd.delBackEvent()
    sender:stopAllActions()
    ff.net:removeEvent(4,dd.Tjf_User_ChangeName)
    if ff.platform ~= 1 then
        for i,item in ipairs(sender._items) do
            if item then
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:setSelectedState(false)
            end
        end
    end
end
--[[
function changeHeadLayer.onBefore(sender)
    return true
end
--]]
function changeHeadLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("changeHead")
    if widget ~= nil then
        pop.onClosePopDialog("changeHead")
    end
end

function onShowChangeHeadLayer(widget, parent)
    local layer = changeHeadLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onAutoSize()
    layer:onInit()
    return layer
end