local chatGroup   = class("chatGroup")
chatGroup._name   = "chatGroup"

chatGroup._init   = false
chatGroup._index  = 0
chatGroup._parant = nil
chatGroup._view   = nil
chatGroup._ineditor = false
chatGroup._data     = nil

chatGroup._gid      = 0
chatGroup._page     = 0
chatGroup._members  = nil

function chatGroup.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, chatGroup)
    return target
end

function chatGroup:onInit()
    if self._init == false then
        local hh = ff.height - 105 - 190

        self:setContentSize(cc.size(ff.width,hh))
        self:setPositionY(190)

        self:getChildByName("addfriend"):setPositionY(hh - 144)
        self:getChildByName("pannel"):setPositionY(0)

        --self:getChildByName("groups"):setContentSize(cc.size(720,hh - 110 - 144 - 8))
        --self:getChildByName("groups"):setPositionY(110 + 4)

        self:getChildByName("groups"):setContentSize(cc.size(720,hh - 144 - 8))
        self:getChildByName("groups"):setPositionY(4)


        local tableView = cc.TableView:create(self:getChildByName("groups"):getContentSize())
        tableView:setTag(1)
        tableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
        tableView:setDelegate()
        tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
        tableView:setPosition(cc.p(0, 0))
        self:getChildByName("groups"):addChild(tableView)
        tableView:setName("debug")

        --tableView:registerScriptHandler(self.scrollViewDidScroll,cc.SCROLLVIEW_SCRIPT_SCROLL)
        tableView:registerScriptHandler(self.tableCellTouched,cc.TABLECELL_TOUCHED)
        tableView:registerScriptHandler(self.cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
        tableView:registerScriptHandler(self.tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
        tableView:registerScriptHandler(self.numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
        self._view = tableView

        --self:getChildByName("pannel"):getChildByName("editor"):addTouchEventListener(self.editChats)
        --self:getChildByName("pannel"):getChildByName("infos"):getChildByName("return"):addTouchEventListener(self.returnGroups)        
        --self:getChildByName("pannel"):getChildByName("infos"):getChildByName("del"):addTouchEventListener(self.delGroupMessage)        


        self:getChildByName("addfriend"):addTouchEventListener(self._parant.onShowFriends)
        self:getChildByName("addfriend"):getChildByName("addbtn"):addTouchEventListener(self._parant.onShowFriends)
        self._init = true
    end
    ff.net:registerEvent(2,dd.Tjf_Chat_GetGroup,self.onUpdateGroup)
    ff.net:registerEvent(2,dd.Tjf_ChatGroupSetting,self.onUpdateGroup)        
    ff.net:registerEvent(2,dd.Tjf_GetGroupMembers,self.showGroupDetail)        


    --self._ineditor = false
    cclog("group reloadData")
    self._view:reloadData()
    platform_showWaiting(0)
end

--编辑聊天记录
--[[
function chatGroup.editChats(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._groupPannel ~= nil then
            sender:setVisible(false)
            widget._groupPannel._ineditor = true
            
            widget._groupPannel:getChildByName("pannel"):getChildByName("infos"):setVisible(true)
            for i=1,dd.myChatHistroy:rowCount() do
                dd.myChatHistroy:setLong(i,"select",0)
            end
            for j,cell in ipairs(widget._groupPannel:getChildByName("groups"):getChildByTag(1):getContainer():getChildren()) do
                local item = cell:getChildByTag(1)
                if item ~= nil and item:isVisible() == true then
                    item:getChildByName("face"):setPositionX(70)
                    item:getChildByName("faces"):setPositionX(5)
                    item:getChildByName("chu_creator"):setPositionX(145)
                    item:getChildByName("chu_last"):setPositionX(145)
                    item:getChildByName("info"):setPositionX(145)
                    item:getChildByName("selected"):setPositionX(-20)
                    item:getChildByName("selected"):setSelectedState(false)

                    item:getChildByName("selected"):setOpacity(0)
                    local action = cc.Spawn:create(
                                cc.EaseExponentialOut:create(cc.MoveBy:create(0.5,cc.p(50,0))),
                                cc.FadeIn:create(0.5)
                                )            
                    if item:getChildByName("chu_creator"):isVisible() == true then
                        item:getChildByName("editor"):setOpacity(0)
                        item:getChildByName("editor"):setVisible(true)
                        item:getChildByName("editor"):runAction(cc.FadeIn:create(0.5))
                    end

                    item:getChildByName("face"):runAction(cc.EaseExponentialOut:create(cc.MoveBy:create(0.5,cc.p(50,0))))
                    item:getChildByName("faces"):runAction(cc.EaseExponentialOut:create(cc.MoveBy:create(0.5,cc.p(50,0))))
                    item:getChildByName("chu_last"):runAction(cc.EaseExponentialOut:create(cc.MoveBy:create(0.5,cc.p(50,0))))
                    item:getChildByName("chu_creator"):runAction(cc.EaseExponentialOut:create(cc.MoveBy:create(0.5,cc.p(50,0))))
                    item:getChildByName("selected"):runAction(action)
                    item:getChildByName("info"):runAction(cc.EaseExponentialOut:create(cc.MoveBy:create(0.5,cc.p(50,0))))
                    item:getChildByName("selected"):setVisible(true)
                end
            end
        end
    end
end
function chatGroup.returnGroups(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._groupPannel ~= nil then
            widget._groupPannel._ineditor = false
            widget._groupPannel:getChildByName("pannel"):getChildByName("editor"):setVisible(true)            
            widget._groupPannel:getChildByName("pannel"):getChildByName("infos"):setVisible(false)

            local offset = widget._groupPannel:getChildByName("groups"):getChildByTag(1):getContentOffset()
            widget._groupPannel:getChildByName("groups"):getChildByTag(1):reloadData()
            widget._groupPannel:getChildByName("groups"):getChildByTag(1):setContentOffset(offset)
        end
    end    
end

function chatGroup.delGroupMessage(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        for i=1,dd.myChatHistroy:rowCount() do
            if dd.myChatHistroy:getLong(i,"select") == 1 then
                ff.dbmanager:sql_query("delete from client_chat_history where `type`='"..dd.myChatHistroy:getLong(i,"type").."' and `targetid`='"..dd.myChatHistroy:getLong(i,"id").."'")

            end
        end
    end
end
]]
--显示私聊
function chatGroup.onShowPrivate(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end    
    if eventType==ccui.TouchEventType.ended then    
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end    
    local uid = 0
    if sender:getName() == "face" then
        uid = sender:getTag()
    else
        uid = sender:getChildByName("face"):getTag()
    end

    local widget = pop.getDialog("chat")
    if doaction == true then
        if uid ~= dd.uid then
            for i=1,dd.myfriends:rowCount() do
                if dd.myfriends:getLong(i,"uid") == uid then
                    if widget ~= nil then
                        widget:onShowPrivate(uid,dd.myfriends:getString(i,"name"),2)
                    end
                    break
                end
            end
        end
    end
end



function chatGroup.onShowGroup(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end    
    if eventType==ccui.TouchEventType.ended then    
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end    
    if doaction == true then
        local widget = pop.getDialog("chat")
        local id = 0
        if sender:getName() == "faces" then
            id = sender:getTag()
        else
            id = sender:getChildByName("faces"):getTag()
        end
        if widget._fromShare == true then
          local message = ff.net:createMessage()
            message:addCmd(0xF0C)
            message:addLong(dd.uid)
            message:addLong(widget._fromShareType)
            message:addLong(3)
            message:addString("",63)
            message:addString(widget._fromShareString,127)
            message:addLong(id)
           
            message:addLong(0)
            message:addLong(0)
    
            ff.net:rpc(message,false)
            local function close(event)
               widget.onReturn()
            end
            performWithDelay(widget, close,0.5)
            
          return
        end
        
        for i=1,dd.myChatHistroy:rowCount() do
            if dd.myChatHistroy:getLong(i,"type") == 4 and dd.myChatHistroy:getLong(i,"id") == id then
                widget:onShowGroup(id,ff.langString("{0}的聊天组",{dd.myChatHistroy:getString(i,"name")}))
                break
            end
        end
    end
end
function chatGroup:onShowGroupDetail(id)
    cclog("onShowGroupDetail:"..id)
    self._gid = id
    self._page= 0
    if self._members ~= nil then
        self._members:clear()
    end
    self._members = nil
    self:getGroupDetail()
end
function chatGroup:getGroupDetail()
    local message = ff.net:createMessage()
    ff.net:addCmd(message,0x00000E07)
    message:addLong(dd.uid)
    message:addLong(self._gid)
    message:addLong(self._page + 1)--页数
    ff.net:rpc(message,false)
end
function chatGroup.showGroupDetail(message)
    local code = message:getLong()
    cclog("chatGroup.showGroupDetail  ret="..code)
    if code == 0 then 
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._groupPannel ~= nil then
            local type=message:getLong()
            local groupid=message:getLong()
            local members=message:getLong()--成员总数
            local page=message:getLong()--当前查询页
            local nums=message:getLong()
            if type == 0 and groupid == widget._groupPannel._gid then
                if widget._groupPannel._members == nil then
                    widget._groupPannel._members = ff.NetTable:create()
                    widget._groupPannel._members:addStreamCol("uid",ff.NET_LONG)
                    widget._groupPannel._members:addStreamCol("name",ff.NET_STRING,15)
                    widget._groupPannel._members:addStreamCol("face",ff.NET_LONG)                    
                    widget._groupPannel._members:addStreamCol("serverid",ff.NET_LONG)
                    widget._groupPannel._members:addStreamCol("level",ff.NET_LONG)
                    widget._groupPannel._members:addStreamCol("unionsname",ff.NET_STRING,3)
                    widget._groupPannel._members:addStreamCol("job",ff.NET_LONG)
                end
                message:getData(nums, widget._groupPannel._members)
                if members > (page - 1)*10 + nums then
                    widget._groupPannel._page = page
                    widget._groupPannel:getGroupDetail()
                else
                    widget._groupPannel._members:addStreamCol("select",ff.NET_LONG)
                    widget:showAddMember(widget._groupPannel._members,groupid)
                end
            end
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function chatGroup.onShowGroupOptins(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end    
    if eventType==ccui.TouchEventType.ended then    
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end    
    if doaction == true then
        local widget = pop.getDialog("chat")
        local id = sender:getTag()
        for i=1,dd.myChatHistroy:rowCount() do
            if dd.myChatHistroy:getLong(i,"id") == id then
                if dd.uid ~= dd.myChatHistroy:getLong(i,"master") then
                    local message = ff.net:createMessage()
                    ff.net:addCmd(message,0x00000F07)
                    message:addLong(dd.uid)
                    message:addLong(3)--成员退出
                    message:addLong(id)
                    message:addLong(1)
                    message:addLong(dd.uid)
                    ff.net:rpc(message,false)
                else
                    widget._groupPannel:onShowGroupDetail(id)
                end
                break
            end
        end
        cclog("id:"..id)
    end
end
function chatGroup.tableCellAtIndex(table,idx)
    cclog("tableCellAtIndex:"..idx)
    local widget = pop.getDialog("chat")
    if widget ~= nil and widget._groupPannel ~= nil then
        return widget._groupPannel:darwItem(table,idx)
    end
    return nil
end
function chatGroup:darwItem(viewtable,idx)
    if dd.myChatHistroy == nil then
        return nil
    end
    local users = dd.myChatHistroy
    if users:rowCount() < idx + 1 then
        return nil
    end
    if dd.myChatHistroy:getLong(idx+1,"type") ~= 3 then
        if dd.myChatHistroy:getLong(idx+1,"master") == 0 then
            return nil
        end
    end
    local row = idx + 1
    local cell = viewtable:dequeueCell()
    local item = nil
    if nil == cell then
        cell = cc.TableViewCell:new()
        item = self:getChildByName("item"):clone()
        item:setTag(1)
        item:setPosition(cc.p(10,0))
        item:setVisible(true)
        if dd.myChatHistroy:getLong(row,"type") == 3 then
            item:getChildByName("face"):addTouchEventListener(self.onShowPrivate)
            item:addTouchEventListener(self.onShowPrivate)
        else
            item:getChildByName("faces"):addTouchEventListener(self.onShowGroup)
            item:addTouchEventListener(self.onShowGroup)
            item:getChildByName("editor"):addTouchEventListener(self.onShowGroupOptins)
        end
        item:getChildByName("faces"):setPositionX(5)
        item:getChildByName("selected"):setVisible(false)
        item:getChildByName("info"):setPositionX(145)
        item:getChildByName("chu_creator"):setPositionX(145)
        item:getChildByName("chu_last"):setPositionX(145)
        item:getChildByName("editor"):setVisible(false)
        item:setTouchEnabled(true,false)
        --item:getChildByName("selected"):addTouchEventListener(onSelect)
        cell:addChild(item)
    else
        item=cell:getChildByTag(1)
        --add event
        if dd.myChatHistroy:getLong(row,"type") == 3 then
            item:getChildByName("face"):addTouchEventListener(self.onShowPrivate)
            item:addTouchEventListener(self.onShowPrivate)
        else
            item:addTouchEventListener(self.onShowGroup)
            item:getChildByName("faces"):addTouchEventListener(self.onShowGroup)
            item:getChildByName("editor"):addTouchEventListener(self.onShowGroupOptins)
        end
        --内容相同，直接显示
        if users:getLong(row,"type") == 3 then
            if item:getChildByName("face"):getTag() == users:getLong(row,"id") then
                item:getChildByName("editor"):setVisible(false)
                item:getChildByName("face"):setVisible(true)
                item:getChildByName("faces"):setVisible(false)
                item:getChildByName("chu_creator"):setVisible(false)
                item:getChildByName("chu_last"):setVisible(true)

                if dd.myChatHistroy:getLong(row,"unread") > 0 then
                    item:getChildByName("tag"):getChildByName("label"):setString(dd.myChatHistroy:getLong(row,"unread"))
                    item:getChildByName("tag"):setVisible(true)
                else
                    item:getChildByName("tag"):setVisible(false)
                end      
                item:setVisible(true)          
                return cell
            end
        end
    end
    
    if item ~= nil then      
        if dd.myChatHistroy:getLong(row,"type") == 3 then
            item:getChildByName("chu_creator"):setVisible(false)
            item:getChildByName("chu_last"):setVisible(true)
            item:getChildByName("faces"):setVisible(false)
            item:getChildByName("face"):setVisible(true)
            item:getChildByName("editor"):setVisible(false)
        else
            item:getChildByName("chu_creator"):setVisible(true)
            item:getChildByName("chu_last"):setVisible(true)
            item:getChildByName("face"):setVisible(false)
            item:getChildByName("faces"):setVisible(true)
            item:getChildByName("editor"):setVisible(true)    
        end    
        if dd.myChatHistroy:getLong(row,"unread") > 0 then
            item:getChildByName("tag"):getChildByName("label"):setString(dd.myChatHistroy:getLong(row,"unread"))
            item:getChildByName("tag"):setVisible(true)
        else
            item:getChildByName("tag"):setVisible(false)
        end
        item:getChildByName("face"):setTag(users:getLong(row,"id"))
        item:getChildByName("faces"):setTag(users:getLong(row,"id"))
        if users:getLong(row,"type") == 3 then
            for i=1,dd.myfriends:rowCount() do
                if dd.myfriends:getLong(i,"uid") == users:getLong(row,"id") then
                    item:getChildByName("face"):getChildByName("face"):loadTexture(dd.getPlayerIcon(dd.myfriends:getLong(i,"face")),0)
                    if dd.myfriends:getLong(row,"online") == 0 then
                        local effect = ff.Effect:effectGrey()    
                        item:getChildByName("face"):getChildByName("face"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
                    else    
                        item:getChildByName("face"):getChildByName("face"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
                    end    
                    if dd.myfriends:getLong(i,"unionid") > 0 then
                        if dd.myfriends:getLong(i,"job") >= 5 then
                            item:getChildByName("info"):getChildByName("ulevel"):setString(dd.myfriends:getLong(i,"job"))
                        end
                        item:getChildByName("info"):getChildByName("short"):setString("["..dd.myfriends:getString(i,"unionsname").."]")
                    end
                    item:getChildByName("info"):getChildByName("name"):setString(dd.myfriends:getString(i,"name").." LV."..dd.myfriends:getLong(i,"level"))
                    break
                end
            end            
        else
            local members = Split(dd.myChatHistroy:getString(row,"names"),",")
            for i=1,4 do
                if table.getn(members) >= i *2 then
                    item:getChildByName("faces"):getChildByName("face"..i):getChildByName("face"):loadTexture(dd.getPlayerIcon(tonumber(members[i*2])),0)
                else
                    item:getChildByName("faces"):getChildByName("face"..i):getChildByName("face"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                end
            end
            --缺联盟、等级、联盟职位
            item:getChildByName("info"):getChildByName("name"):setString(users:getString(row,"name"))
            cclog("master:"..users:getLong(row,"master")..",uid:"..dd.uid..",name:"..users:getString(row,"name"))
            if users:getLong(row,"master") == dd.uid then
                item:getChildByName("editor"):getChildByName("chu_label"):setString(ff.langString("管理"))                
            else                
                item:getChildByName("editor"):getChildByName("chu_label"):setString(ff.langString("退出"))                
            end
        end

        if users:getLong(row,"time") > 0 then
            item:getChildByName("chu_last"):setString(ff.langString("最后发言时间")..":"..ff.getTimeTips(tonumber(dd.getChatServerTime() - dd.myChatHistroy:getLong(row,"time"))))
        else
            item:getChildByName("chu_last"):setString(ff.langString("尚无任何发言"))
        end
        item:getChildByName("editor"):setTag(users:getLong(row,"id"))
        item:getChildByName("info"):requestDoLayout()
    end
    return cell
end

function chatGroup.tableCellTouched(table,cell)
    cclog("tableCellTouched")
    local widget = pop.getDialog("chat")
    if widget ~= nil and widget._groupPannel ~= nil then
    end
end
    
    
function chatGroup.cellSizeForTable(table)
    return 144,720
end
    
function chatGroup.numberOfCellsInTableView(table)
    if dd.myChatHistroy ~= nil then
        local nums = dd.myChatHistroy:rowCount()
        for i=1,dd.myChatHistroy:rowCount() do
            if dd.myChatHistroy:getLong(i,"type") ~= 3 then
                if dd.myChatHistroy:getLong(i,"master") == 0 then
                    nums = nums - 1
                end
            end
        end        
        return nums
    end
    return 0
end

function chatGroup:updateView()
    if dd.myChatHistroy == nil then
        return
    end
    if self:isVisible() == true then
        cclog("chatGroup:updateView")
        if dd.myChatHistroy:rowCount() * 144 > ff.height - 105 - 190 - 144 - 8 then
            local offset = self:getChildByName("groups"):getChildByTag(1):getContentOffset()
            self:getChildByName("groups"):getChildByTag(1):reloadData()
            self:getChildByName("groups"):getChildByTag(1):setContentOffset(offset)
        else
            self:getChildByName("groups"):getChildByTag(1):reloadData()
        end
    end
end

function chatGroup.onUpdateGroup(params)
    local code = params[1]
    if code == 0 then
        local widget = pop.getDialog("chat")
        if widget == nil or widget._groupPannel == nil then
            return
        end
        widget._groupPannel:updateView()
        widget:updateTag()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function chatGroup:onEnd()
    cclog("chatGroup:onEnd")
    self._gid = 0
    self._page= 0
    if self._members ~= nil then
        self._members:clear()
    end
    self._members = nil
    self:setVisible(false)
end
function chatGroup:onClose()
    ff.net:removeEvent(2,dd.Tjf_Chat_GetGroup)
    ff.net:removeEvent(2,dd.Tjf_ChatGroupSetting)
    ff.net:removeEvent(2,dd.Tjf_GetGroupMembers)
end
function chatLayer:onShowChatGroup()
    platform_showWaiting(1,0)
    if self._groupPannel == nil then
        local widget   = chatGroup.extend(self:getChildByName("chatgroup"))
        self._groupPannel = widget
        self._groupPannel._parant = self
    end
    self:setTitle(ff.langString("聊天记录"))

    self._groupPannel:setVisible(true)
    self._groupPannel:onInit()
end
