--club
local clubLayer = class("club")
clubLayer._name = "club"
clubLayer._init = false

function clubLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, clubLayer)
    return target
end

function clubLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("topbox"):setPositionY(hh - 105 - 60)
        self:getChildByName("bg"):setContentSize(cc.size(720, hh - 105))
        self:getChildByName("list"):setContentSize(cc.size(720,hh - 105 - 60))
        --self:getChildByName("list"):getChildByName("slot"):setPositionY(hh - 105 - 60 - 390)
        self:getChildByName("list"):getChildByName("lottery"):setPositionY(hh - 105 - 60 - 390*2 -10)
        self:getChildByName("list"):setInnerContainerSize(cc.size(720,ff.height - 105 - 60))
    end
end

function clubLayer:onInit()
    if self._init == false then        
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)

        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3) 

        local function goSlot(sender,eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then    
                doaction = true
            end
            if doaction == true then
                pop.onShowPopDialog("lottery")              
            end
        end
        local function goInvitation(sender,eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then    
                doaction = true
            end
            if doaction == true then
                pop.onShowPopDialog("Invitation")              
            end
        end
        local function goLottery(sender,eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then    
                doaction = true
            end
            if doaction == true then
                if dd.myinfo:getLong(1,"level") < 7 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("司令部等级达{0}级开放",{7}))
                    return
                else
                    if sender:getTag() == 99 then
                        pop.onShowPopDialog("lotterypaid",1)    

                    else
                        pop.onShowPopDialog("lotterypaid")    
                    end
                end          
            end
        end
        self:getChildByName("list"):getChildByName("Invitation"):getChildByName("icons"):getChildByName("playbtn"):addTouchEventListener(goInvitation)
        self:getChildByName("list"):getChildByName("slot"):getChildByName("icons"):getChildByName("playbtn"):addTouchEventListener(goSlot)
        self:getChildByName("list"):getChildByName("lottery"):getChildByName("icons"):getChildByName("playbtn"):addTouchEventListener(goLottery)

        self._init = true
    end
    --12级开启老虎机

    local haveAtive = false
    if dd.LotteryPaidTimeActive ~= 0  and dd.LotteryPaidTimeEndActive ~= 0 then
        if dd.LotteryPaidTimeActive < dd.getServerTime() and dd.LotteryPaidTimeEndActive > dd.getServerTime() then
            haveAtive = true 
        end
    end
    if haveAtive == true then
        local Active = self:getChildByName("list"):getChildByTag(99)
        if Active == nil then
            Active = self:getChildByName("list"):getChildByName("lottery"):clone()
            Active:setTag(99)
            Active:getChildByName("icons"):getChildByName("playbtn"):setTag(99)
            self:getChildByName("list"):addChild(Active)
        end
    else
        if self:getChildByName("list"):getChildByTag(99) ~= nil then
            
            self:getChildByName("list"):getChildByTag(99):removeFromParent(true)
            
        end
    end
    local x = 0
    if haveAtive == true then
        x = 1
    end
    self:getChildByName("list"):getChildByName("Invitation"):setVisible(true)
    self:getChildByName("list"):getChildByName("Invitation"):setPositionY(ff.height - 105 - 60 - 390*(2+x) -10)
    self:getChildByName("list"):getChildByName("lottery"):setPositionY(ff.height - 105 - 60 - 390*(1+x) - 10)
    if self:getChildByName("list"):getChildByTag(99) ~= nil then
        self:getChildByName("list"):getChildByTag(99):getChildByName("sp"):setVisible(true)
        self:getChildByName("list"):getChildByTag(99):getChildByName("sp"):getChildByName("nr"):setString(ff.langString("万圣节转盘"))
        self:getChildByName("list"):getChildByTag(99):getChildByName("tips"):getChildByName("tips"):setString("")
        self:getChildByName("list"):getChildByTag(99):setVisible(true)
        self:getChildByName("list"):getChildByTag(99):getChildByName("icons"):getChildByName("icon"):loadTexture("images/active/active_ico.png",0)
        self:getChildByName("list"):getChildByTag(99):setPositionY(ff.height - 105 - 60 - 390 - 10)
        
    end
    --[[
    if dd.myinfo:getLong(1,"level") < 12 then
        self:getChildByName("list"):getChildByName("slot"):setVisible(false)
        self:getChildByName("list"):getChildByName("slot"):setPositionY(ff.height - 105 - 60 - 390*2 -10)
        self:getChildByName("list"):getChildByName("lottery"):setPositionY(ff.height - 105 - 60 - 390 - 10)
    else
        self:getChildByName("list"):getChildByName("slot"):setVisible(true)
        self:getChildByName("list"):getChildByName("slot"):setPositionY(ff.height - 105 - 60 - 390)
        self:getChildByName("list"):getChildByName("lottery"):setPositionY(ff.height - 105 - 60 - 390*2 -30)
    end
    --]]
    self.updateGold()
    self:startMyAct()
end

function clubLayer.updateGold()
    local widget = pop.getDialog("club")
    if widget ~= nil then
        widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
        widget:getChildByName("topArea"):requestDoLayout()

        local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
    end
end

function clubLayer:startMyAct()
    self:starFlash()
    self:pearlsFlash()
end
--星星闪烁
function  clubLayer:starFlash()
    local slotStar    = self:getChildByName("list"):getChildByName("slot"):getChildByName("icons")
    local lotteryStar = self:getChildByName("list"):getChildByName("lottery"):getChildByName("icons")
    local InvitationStar = self:getChildByName("list"):getChildByName("Invitation"):getChildByName("icons")
    --有4个星星

    for i=1,4 do
        local star = slotStar:getChildByName("star"..i)
        star:setScale(0)
        --lottery
        local star2 = lotteryStar:getChildByName("star"..i)
        local star3 = InvitationStar:getChildByName("star"..i)
        star2:setScale(0)
        self.starAct(star)
        star3:setScale(0)
        self.starAct(star3)
        self.starAct(star2)
        if self:getChildByName("list"):getChildByTag(99) ~= nil then
            local star4 = self:getChildByName("list"):getChildByTag(99):getChildByName("icons"):getChildByName("star"..i)
            star4:setScale(0)
            self.starAct(star4)
        end
    end
end

function clubLayer.starAct(star)
    local param = math.floor((math.random() * 999999)% 10) + 1
    local dir = math.floor((math.random() * 999999)% 2) + 1
    -- create action
    local scal = cc.ScaleTo:create(1, 1.6)
    local delay = cc.DelayTime:create(0.5)
    local scal_rever = cc.ScaleTo:create(1, 0)
    local delayFalse = cc.DelayTime:create(0.1+0.2*param)

    local rotation = nil
    if dir == 2 then
        rotation = cc.RotateTo:create(2.6+0.2*param, 900)    
    else
        rotation = cc.RotateTo:create(2.6+0.2*param, -900)
    end
    
    local seq = cc.Sequence:create(delayFalse,scal, delay, scal_rever)
    local spaw = cc.Spawn:create(seq,rotation)

    star:runAction( cc.RepeatForever:create(spaw) )
end
--珠子闪烁
function clubLayer:pearlsFlash()
    local slotPearls    = self:getChildByName("list"):getChildByName("slot"):getChildByName("icons"):getChildByName("pearls")
    local lotteryPearls = self:getChildByName("list"):getChildByName("lottery"):getChildByName("icons"):getChildByName("pearls")
    self:pearlsAct(slotPearls,1)
    self:pearlsAct(lotteryPearls,2)
    local InvitationPearls = self:getChildByName("list"):getChildByName("Invitation"):getChildByName("icons"):getChildByName("pearls")
    self:pearlsAct(InvitationPearls,1)
    if self:getChildByName("list"):getChildByTag(99) ~= nil then
        local lotteryPearlsex = self:getChildByName("list"):getChildByTag(99):getChildByName("icons"):getChildByName("pearls")
        self:pearlsAct(lotteryPearlsex,1)
        
    end
end
function clubLayer:pearlsAct(pearls,flag)
    local picIds = {4,5,6,7,8,9,11,11,13,13,9}
    local function switchFunc(light)
        if light == true then
            for i=1,11 do
                if i%2 == 1 then
                    pearls:getChildByName("p1_"..i):loadTexture(dd.getPathFromUI("clight_"..picIds[i]..".png",1))
                else
                    pearls:getChildByName("p1_"..i):loadTexture(dd.getPathFromUI("cdark_"..picIds[i]..".png",1))
                end
            end
        else
            for i=1,11 do
                if i%2 == 1 then
                    pearls:getChildByName("p1_"..i):loadTexture(dd.getPathFromUI("cdark_"..picIds[i]..".png",1))
                else
                    pearls:getChildByName("p1_"..i):loadTexture(dd.getPathFromUI("clight_"..picIds[i]..".png",1))
                end
            end
        end
    end   
    local callfun = cc.CallFunc:create(function() switchFunc(true) end)
    local callfun_reaver = cc.CallFunc:create(function() switchFunc(false) end)
    local delay = cc.DelayTime:create(0.5)
    local delay2 = cc.DelayTime:create(0.5)
    local seq = cc.Sequence:create(callfun,delay,callfun_reaver,delay2)

    if flag == 1 then
        seq = cc.Sequence:create(callfun,delay,callfun_reaver,delay2)
    else
        seq = cc.Sequence:create(callfun_reaver,delay,callfun,delay2)
    end
    pearls:runAction(cc.RepeatForever:create(seq))
end

function clubLayer:stopMyAction()
    local slotStar    = self:getChildByName("list"):getChildByName("slot"):getChildByName("icons")
    local lotteryStar = self:getChildByName("list"):getChildByName("lottery"):getChildByName("icons")
    local InvitationStar = self:getChildByName("list"):getChildByName("Invitation"):getChildByName("icons")
    --有4个星星
    for i=1,4 do
        slotStar:getChildByName("star"..i):stopAllActions()
        lotteryStar:getChildByName("star"..i):stopAllActions()
        InvitationStar:getChildByName("star"..i):stopAllActions()
        if self:getChildByName("list"):getChildByTag(99) ~= nil then
            local lotteryPearlsex = self:getChildByName("list"):getChildByTag(99):getChildByName("icons"):getChildByName("star"..i):stopAllActions()
        end
    end
    slotStar:getChildByName("pearls"):stopAllActions()
    if self:getChildByName("list"):getChildByTag(99) ~= nil then
        self:getChildByName("list"):getChildByTag(99):getChildByName("icons"):getChildByName("pearls"):stopAllActions()
    end
    lotteryStar:getChildByName("pearls"):stopAllActions()
    InvitationStar:getChildByName("pearls"):stopAllActions()
end

--接口
function clubLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        sender:setTouchEnabled(false)
        pop.onClosePopDialog("club")
        sender:setTouchEnabled(true)
    end
end

function clubLayer.onStart(sender)
    ff.net:bindProperty(2516,"gold",sender.updateGold)
end

function clubLayer.onEnd(sender)
    dd.delBackEvent()
    ff.net:unbindProperty("gold",2516)
    sender:stopMyAction()
    if sender:getChildByName("list"):getChildByTag(99) ~= nil then
        sender:getChildByName("list"):getChildByTag(99):removeFromParent()
    end
end

function clubLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))    
end

function clubLayer.onReturn(sender,eventType)
    pop.onClosePopDialog("club")
end

function onShowClubLayer(widget)
    local layer = clubLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onAutoSize()
    layer:onInit()
    return layer
end