fightShowOthersLayer = class("fightShowOthersLayer")
fightShowOthersLayer._name = "fightShowOthers"
fightShowOthersLayer._init = false
fightShowOthersLayer._info = {}

function fightShowOthersLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,fightShowOthersLayer)
	return target
end

function onShowfightShowOthers( widget,info)
	-- body
	local layer = fightShowOthersLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
	layer:onInit(info)
	return layer
end

function fightShowOthersLayer.onReturn( sender,eventType )
	-- body
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("fightShowOthers")
		if widget == nil then
			return
		end
        pop.onClosePopDialog("fightShowOthers")
    end
end

function fightShowOthersLayer:AutoSize(  )
	-- body
	local hh = ff.height
	self:setContentSize(cc.size(720,hh))
	self:setPositionY(0)
	self:getChildByName("back"):setContentSize(cc.size(720,hh))
	self:getChildByName("top"):setPositionY(hh - 105)
    --self:getChildByName("top"):getChildByName("chu_title"):setString(ff.langString("战报"))
    --self:getChildByName("top"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)

    self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    self:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
    self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)

    self:getChildByName("back"):setPositionY(0)
    self:getChildByName("scrollview"):setContentSize(cc.size(720,hh-110))
    self:getChildByName("scrollview"):setPositionY(0)
end

function fightShowOthersLayer:onInit( info)
	-- body
	if self._init == false then
		self:AutoSize()
		self._init = true 
	end
    if self._info ~= nil and self._info.id == info.id then
    else
    	self._info = info
    	self:onShow()
    end
    self.updateGold()
end

function fightShowOthersLayer.onEnd( sender )
	-- body
    sender._info = nil
    sender:getChildByName("scrollview"):removeAllChildren(true)
	dd.delBackEvent()
    ff.net:unbindProperty("gold",2308)
end

function fightShowOthersLayer:onShow(  )
	-- body
    --self:getChildByName("scrollview"):removeAllChildren(true)
    local jingong = self:getChildByName("type"):clone()
    jingong:setVisible(true)
    jingong:getChildByName("type"):setString(ff.langString("进攻方"))
    self:getChildByName("scrollview"):pushBackCustomItem(jingong)

    for i=1,self._info.Ainfo:rowCount() do
        local panel = self:getChildByName("panel"):clone()
        panel:setVisible(true)
        panel:setContentSize(cc.size(690,136))
        panel:setTag(100+i)
        local player = self:getChildByName("player"):clone()
        player:setVisible(true)
        panel:addChild(player)
        player:setTag(1)
        player:setPosition(cc.p(0,0))
        player:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(self._info.Ainfo:getLong(i,"ico")),0)
        local name = ""
        if string.len(self._info.A_union_Name2) > 0 then
            name = name.."["..self._info.A_union_Name2.."]"
        end
        player:getChildByName("heroInfo"):setString(name..self._info.Ainfo:getString(i,"name"))
        player:getChildByName("name1"):setString(ff.langString("战力")..":"..self._info.Ainfo:getLong(i,"powerUp"))
        player:getChildByName("count1"):setString(" - "..self._info.Ainfo:getLong(i,"powerLose"))

        local power = 0
        local powerlose = 0
        for j=1,self._info.amyInfo:rowCount() do
            --cclog("===="..self._info.Ainfo:getLong(i,"id").."==="..self._info.amyInfo:getLong(j,"playerid"))
            if self._info.Ainfo:getLong(i,"id") == self._info.amyInfo:getLong(j,"playerid") then
                power = power + self._info.amyInfo:getLong(j,"power")
                powerlose = powerlose + self._info.amyInfo:getLong(j,"powerlose")
                --cclog("sdf="..power.."sdfsd=="..powerlose)
            end
        end

        player:getChildByName("name2"):setString(ff.langString("部队")..":"..power)
        player:getChildByName("count2"):setString(" - "..powerlose)
        player:getChildByName("open"):setTag(100+i)
        player:getChildByName("open"):addTouchEventListener(self.openItems)
        player:getChildByName("Image_180"):setTag(100+i)
        player:getChildByName("Image_180"):addTouchEventListener(self.openItems)
        player:getChildByName("down"):setTag(100+i)
        player:getChildByName("down"):addTouchEventListener(self.closeItems)
        player:getChildByName("down"):setTouchEnabled(false)

        self:getChildByName("scrollview"):pushBackCustomItem(panel)
    end
	
    local fangyu = self:getChildByName("type"):clone()
    fangyu:setVisible(true)
    fangyu:getChildByName("type"):setString(ff.langString("防御方"))
    self:getChildByName("scrollview"):pushBackCustomItem(fangyu)
    if self._info.Binfo ~= nil then
        for i=1,self._info.Binfo:rowCount() do
            local panel = self:getChildByName("panel"):clone()
            panel:setVisible(true)
            panel:setContentSize(cc.size(690,136))
            panel:setTag(200+i)
            local player = self:getChildByName("player"):clone()
            player:setVisible(true)
            player:setTag(1)
            panel:addChild(player)
            player:setPosition(cc.p(0,0))
            local name = ""
            --cclog("=444444444444444444=========="..self._info.Binfo:getLong(i,"type"))
            if self._info.Binfo:getLong(i,"type") ~= 3 then
                player:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(self._info.Binfo:getLong(i,"ico")),0)
                if string.len(self._info.B_union_Name2) > 0 then
                    name = name.."["..self._info.B_union_Name2.."]"
                end
                player:getChildByName("heroInfo"):setString(name..self._info.Binfo:getString(i,"name"))
            else
                player:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(1005),0)
                player:getChildByName("heroInfo"):setString(ff.langString("黑杰克"))
            end
            player:getChildByName("name1"):setString(ff.langString("战力")..":"..self._info.Binfo:getLong(i,"powerUp"))
            player:getChildByName("count1"):setString(" - "..self._info.Binfo:getLong(i,"powerLose"))

            local power = 0
            local powerlose = 0
            for j=1,self._info.amyInfo:rowCount() do
                --cclog("===="..self._info.Ainfo:getLong(i,"id").."==="..self._info.amyInfo:getLong(j,"playerid"))
                if self._info.Binfo:getLong(i,"id") == self._info.amyInfo:getLong(j,"playerid") then
                    power = power + self._info.amyInfo:getLong(j,"power")
                    powerlose = powerlose + self._info.amyInfo:getLong(j,"powerlose")
                    --cclog("sdf="..power.."sdfsd=="..powerlose)
                end
            end

            player:getChildByName("name2"):setString(ff.langString("部队")..":"..power)
            player:getChildByName("count2"):setString(" - "..powerlose)
            player:getChildByName("open"):setTag(200+i)
            player:getChildByName("open"):addTouchEventListener(self.openItemsEx)
            player:getChildByName("Image_180"):setTag(200+i)
            player:getChildByName("Image_180"):addTouchEventListener(self.openItemsEx)
            player:getChildByName("down"):setTag(200+i)
            player:getChildByName("down"):addTouchEventListener(self.closeItemsEx)
            player:getChildByName("down"):setTouchEnabled(false)

            self:getChildByName("scrollview"):pushBackCustomItem(panel)
        end
    end

	--self:getChildByName("scrollview"):scrollToTop(0.5,true)
    --self:getChildByName("scrollview"):setItemsMargin(5)
end

function fightShowOthersLayer.openItems( sender, evenType )
    -- body
    if evenType == ccui.TouchEventType.ended then
    --cclog("111111111")
        local widget = pop.getDialog("fightShowOthers")
        if widget == nil then
            return
        end
        --sender:setTouchEnabled(false)
        local index = sender:getTag()
        local num = index - 100
        if widget ~= nil and widget._info ~= nil and widget._info.Ainfo:rowCount() >= num then
            local panel = widget:getChildByName("scrollview"):getChildByTag(index)
            if panel ~= nil then
                local player = panel:getChildByTag(1)
                if player ~= nil then
                    player:getChildByName("open"):setVisible(false)
                    player:getChildByName("open"):setTouchEnabled(false)
                    player:getChildByName("down"):setVisible(true)
                    player:getChildByName("down"):setTouchEnabled(true)
                    player:getChildByName("Image_180"):addTouchEventListener(widget.closeItems)
                    local hh = 0 
                    local item2 = widget:getChildByName("res1"):clone()
                    item2:setVisible(true)
                    item2:setTag(2)
                    panel:addChild(item2)
                    item2:setPosition(cc.p(-5,0))
                    hh = hh + 150
                    local level = dd.myinfo:getLong(1,"level")
                    if level <= 10 then
                        item2:getChildByName("res1"):getChildByName("res1"):setPositionX(999)
                        item2:getChildByName("res1"):getChildByName("res3"):setPositionX(999)
                        item2:getChildByName("res1"):getChildByName("res5"):setPositionX(354)
                    elseif level > 10 and level <= 14 then
                        item2:getChildByName("res1"):getChildByName("res1"):setPositionX(354)
                        item2:getChildByName("res1"):getChildByName("res3"):setPositionX(999)
                        item2:getChildByName("res1"):getChildByName("res5"):setPositionX(495)
                    else
                        item2:getChildByName("res1"):getChildByName("res1"):setPositionX(354)
                        item2:getChildByName("res1"):getChildByName("res3"):setPositionX(495)
                        item2:getChildByName("res1"):getChildByName("res5"):setPositionX(636)
                    end
                    local itemcount1 = 1
                    if widget._info.resInfo ~= nil then
                        local item3 = nil
                        for i=1,widget._info.resInfo:rowCount() do

                            if widget._info.resInfo:getLong(i,"playerid") == widget._info.Ainfo:getLong(num,"id") then

                                local type =  widget._info.resInfo:getLong(i,"itemType") 
                                if tonumber(type) == 1 then
                                    if item3 == nil then
                                        item3 = widget:getChildByName("res2"):clone()
                                        item3:setVisible(true)
                                        item3:setTag(3)
                                        panel:addChild(item3)
                                        item3:setPosition(cc.p(-5,hh))
                                        hh = hh + 150
                                    end
                                    if itemcount1 <6 then
                                        item3:getChildByName("res1"):getChildByName("res"..itemcount1):loadTexture(dd.getToolsIcon(widget._info.resInfo:getLong(i,"itemId")),0)
                                        item3:getChildByName("res1"):getChildByName("res"..itemcount1):getChildByName("count"):setString("+"..dd.showKM(widget._info.resInfo:getLong(i,"itemCnt"),5))
                                        itemcount1 = itemcount1 + 1
                                    end
                                elseif tonumber(type) == 2 then
                                    item2:getChildByName("res1"):getChildByName("res1"):getChildByName("count"):setString("+"..dd.showKM(widget._info.resInfo:getLong(i,"itemCnt"),3) )
                                elseif tonumber(type) == 3 then
                                    item2:getChildByName("res1"):getChildByName("res2"):getChildByName("count"):setString("+"..dd.showKM(widget._info.resInfo:getLong(i,"itemCnt"),3) )
                                elseif tonumber(type) == 4 then
                                    item2:getChildByName("res1"):getChildByName("res3"):getChildByName("count"):setString("+"..dd.showKM(widget._info.resInfo:getLong(i,"itemCnt"),3) ) 
                                elseif tonumber(type) == 5 then
                                    item2:getChildByName("res1"):getChildByName("res4"):getChildByName("count"):setString("+"..dd.showKM(widget._info.resInfo:getLong(i,"itemCnt"),3) ) 
                                elseif tonumber(type) == 6 then
                                    item2:getChildByName("res1"):getChildByName("res5"):getChildByName("count"):setString("+"..dd.showKM(widget._info.resInfo:getLong(i,"itemCnt"),3) )
                                end
                            end
                        end   --print(i)
                        if item3 ~= nil then
                            for i=itemcount1,5 do
                                item3:getChildByName("res1"):getChildByName("res"..i):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                                item3:getChildByName("res1"):getChildByName("res"..i):getChildByName("count"):setString("")
                            end
                        end
                    end


                    for i=1,widget._info.amyInfo:rowCount() do
                        if widget._info.Ainfo:getLong(num,"id") == widget._info.amyInfo:getLong(i,"playerid") then
                            local itemamy = widget:getChildByName("item"):clone()
                            itemamy:setVisible(true)
                            itemamy:setTag(4+i)
                            panel:addChild(itemamy)
                            itemamy:setPosition(cc.p(-5,hh))
                            hh = hh + 54
                            itemamy:getChildByName("name"):setString(ff.langString(dd.cfgSoldier[widget._info.amyInfo:getLong(i,"id")]["soldierName"]))
                            itemamy:getChildByName("start"):setString(dd.cfgSoldier[widget._info.amyInfo:getLong(i,"id")]["step"])
                            itemamy:getChildByName("count1"):setString(widget._info.amyInfo:getLong(i,"power")-widget._info.amyInfo:getLong(i,"powerlose")-widget._info.amyInfo:getLong(i,"medcnt"))
                            itemamy:getChildByName("count2"):setString(widget._info.amyInfo:getLong(i,"medcnt"))
                            itemamy:getChildByName("count3"):setString(widget._info.amyInfo:getLong(i,"powerlose"))
                        end
                    end

                    local item3 = widget:getChildByName("amytitle"):clone()
                    item3:setVisible(true)
                    item3:setTag(4)
                    panel:addChild(item3)
                    item3:setPosition(cc.p(-5,hh))
                    hh = hh + 58

                    player:setPosition(cc.p(0,hh))
                    hh = hh + 136

                    panel:setContentSize(cc.size(690,hh))

                end
            end

        end
        
      
        widget:getChildByName("scrollview"):refreshView()
        --sender:setTouchEnabled(true)  
    end
end

function fightShowOthersLayer.openItemsEx( sender, evenType )
    -- body
    if evenType == ccui.TouchEventType.ended then
    --cclog("111111111")
        local widget = pop.getDialog("fightShowOthers")
        if widget == nil then
            return
        end
        --sender:setTouchEnabled(false)
        local index = sender:getTag()
        local num = index - 200
        if widget ~= nil and widget._info ~= nil and widget._info.Binfo:rowCount() >= num then
            local panel = widget:getChildByName("scrollview"):getChildByTag(index)
            if panel ~= nil then
                local player = panel:getChildByTag(1)
                if player ~= nil then
                    player:getChildByName("open"):setVisible(false)
                    player:getChildByName("open"):setTouchEnabled(false)
                    player:getChildByName("down"):setVisible(true)
                    player:getChildByName("down"):setTouchEnabled(true)
                    player:getChildByName("Image_180"):addTouchEventListener(widget.closeItemsEx)
                    local hh = 0 

                    for i=1,widget._info.amyInfo:rowCount() do
                        if widget._info.Binfo:getLong(num,"id") == widget._info.amyInfo:getLong(i,"playerid") then
                            local itemamy = widget:getChildByName("item"):clone()
                            itemamy:setVisible(true)
                            itemamy:setTag(3+i)
                            panel:addChild(itemamy)
                            itemamy:setPosition(cc.p(-5,hh))
                            hh = hh + 54
                            itemamy:getChildByName("name"):setString(ff.langString(dd.cfgSoldier[widget._info.amyInfo:getLong(i,"id")]["soldierName"]))
                            itemamy:getChildByName("start"):setString(dd.cfgSoldier[widget._info.amyInfo:getLong(i,"id")]["step"])
                            itemamy:getChildByName("count1"):setString(widget._info.amyInfo:getLong(i,"power")-widget._info.amyInfo:getLong(i,"powerlose")-widget._info.amyInfo:getLong(i,"medcnt"))
                            itemamy:getChildByName("count2"):setString(widget._info.amyInfo:getLong(i,"medcnt"))
                            itemamy:getChildByName("count3"):setString(widget._info.amyInfo:getLong(i,"powerlose"))
                        end
                    end

                    local item3 = widget:getChildByName("amytitle"):clone()
                    item3:setVisible(true)
                    item3:setTag(3)
                    panel:addChild(item3)
                    item3:setPosition(cc.p(-5,hh))
                    hh = hh + 58

                    player:setPosition(cc.p(0,hh))
                    hh = hh + 136

                    panel:setContentSize(cc.size(690,hh))

                end
            end

        end
        
      
        widget:getChildByName("scrollview"):refreshView()
        --sender:setTouchEnabled(true)  
    end
end

function fightShowOthersLayer.closeItems( sender, evenType )
    -- body
    if evenType == ccui.TouchEventType.ended then
    --cclog("111111111")
        local widget = pop.getDialog("fightShowOthers")
        if widget == nil then
            return
        end
        --sender:setTouchEnabled(false)
        local index = sender:getTag()
        local num = index - 100
        --if widget ~= nil and widget._info ~= nil and widget._info.Binfo:rowCount() >= num then
            local panel = widget:getChildByName("scrollview"):getChildByTag(index)
            if panel ~= nil then
                local player = panel:getChildByTag(1)
                if player ~= nil then
                    player:getChildByName("down"):setVisible(false)
                    player:getChildByName("open"):setVisible(true)
                    player:getChildByName("open"):setTouchEnabled(true)
                    player:getChildByName("down"):setTouchEnabled(false)
                    player:getChildByName("Image_180"):addTouchEventListener(widget.openItems)
                    local item2 = panel:getChildByTag(2)
                    if item2 ~= nil then
                        item2:removeFromParent(true)
                    end

                    for i=1,widget._info.amyInfo:rowCount() do
                        if widget._info.Ainfo:getLong(num,"id") == widget._info.amyInfo:getLong(i,"playerid") then
                            local itemamy = panel:getChildByTag(4+i)
                            if itemamy ~= nil then
                                itemamy:removeFromParent(true)
                            end
                        end
                    end

                    local item3 = panel:getChildByTag(3)
                    if item3 ~= nil then
                        item3:removeFromParent(true)
                    end
                    local item4 = panel:getChildByTag(4)
                    if item4 ~= nil then
                        item4:removeFromParent(true)
                    end

                    player:setPosition(cc.p(0,0))

                    panel:setContentSize(cc.size(690,136))

                end
            end

       -- end
        widget:getChildByName("scrollview"):refreshView()
        --sender:setTouchEnabled(true)  
    end
end

function fightShowOthersLayer.closeItemsEx( sender, evenType )
    -- body
    if evenType == ccui.TouchEventType.ended then
    --cclog("111111111")
        local widget = pop.getDialog("fightShowOthers")
        if widget == nil then
            return
        end
        --sender:setTouchEnabled(false)
        local index = sender:getTag()
        local num = index - 200
        --if widget ~= nil and widget._info ~= nil and widget._info.Binfo:rowCount() >= num then
            local panel = widget:getChildByName("scrollview"):getChildByTag(index)
            if panel ~= nil then
                local player = panel:getChildByTag(1)
                if player ~= nil then
                    player:getChildByName("down"):setVisible(false)
                    player:getChildByName("open"):setVisible(true)
                    player:getChildByName("open"):setTouchEnabled(true)
                    player:getChildByName("down"):setTouchEnabled(false)
                    player:getChildByName("Image_180"):addTouchEventListener(widget.openItemsEx)

                    for i=1,widget._info.amyInfo:rowCount() do
                        if widget._info.Binfo:getLong(num,"id") == widget._info.amyInfo:getLong(i,"playerid") then
                            local itemamy = panel:getChildByTag(3+i)
                            if itemamy ~= nil then
                                itemamy:removeFromParent(true)
                            end
                        end
                    end

                    local item3 = panel:getChildByTag(3)
                    if item3 ~= nil then
                        item3:removeFromParent(true)
                    end

                    player:setPosition(cc.p(0,0))

                    panel:setContentSize(cc.size(690,136))

                end
            end

       -- end
        widget:getChildByName("scrollview"):refreshView()
        --sender:setTouchEnabled(true)  
    end
end

function fightShowOthersLayer.onStart( sender )
    -- body
    ff.net:bindProperty(2308,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
end

function fightShowOthersLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("fightShowOthers")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end