fightCompareLayer = class("fightCompareLayer")
fightCompareLayer._name = "fightCompare"
fightCompareLayer._init = false
fightCompareLayer._info = {}

function fightCompareLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,fightCompareLayer)
	return target
end

function onShowFightCompare( widget,info )
	-- body
	local layer = fightCompareLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
	layer:onInit(info)
	return layer
end

function fightCompareLayer.onReturn( sender,eventType )
	-- body
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("fightCompare")
		if widget == nil then
			return
		end
        pop.onClosePopDialog("fightCompare")
    end
end

function fightCompareLayer:AutoSize(  )
	-- body
	local hh = ff.height
	self:setContentSize(cc.size(720,hh ))
	self:setPositionY(0)
	self:getChildByName("back"):setContentSize(cc.size(720,hh))
	self:getChildByName("top"):setPositionY(hh - 105)
    --self:getChildByName("top"):getChildByName("chu_title"):setString(ff.langString("对比"))
   -- self:getChildByName("top"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
    self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    self:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
    self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)

    self:getChildByName("back"):setPositionY(0)
    self:getChildByName("scrollview"):setContentSize(cc.size(720,hh-110))
    self:getChildByName("scrollview"):setPositionY(0)
end

function fightCompareLayer:onInit( info )
	-- body
	if self._init == false then
		self:AutoSize()
		self._init = true 
	end
	self.updateGold()
	self._info = info 
	self:onShow()
end

function fightCompareLayer.onEnd( sender )
	-- body
    sender:getChildByName("scrollview"):removeAllChildren(true)
    local widght  = pop.getDialog("fightRep")
    if widght ~= nil then
    	widght._compare = false
    end
	dd.delBackEvent()
	ff.net:unbindProperty("gold",2312)
end

function fightCompareLayer:onShow(  )
	-- body

	local mainArea = self:getChildByName("mainArea"):clone()
	mainArea:setVisible(true)
	local left = nil
	local right = nil
	local leftdes = nil
	local rightdes = nil
	local mapsite=dd.MapidToXY(self._info.A_pos)

	if self._info.ALeft == true then
		left = mainArea:getChildByName("left")
		right = mainArea:getChildByName("right")
		leftdes = mainArea:getChildByName("left"):getChildByName("des") 
		rightdes = mainArea:getChildByName("right"):getChildByName("des")
		left:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getPathFromUI("img01_attack.png",1))
		right:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getPathFromUI("img01_defend.png",1))
	else
		right = mainArea:getChildByName("left")
		left = mainArea:getChildByName("right")
		rightdes = mainArea:getChildByName("left"):getChildByName("des") 
		leftdes = mainArea:getChildByName("right"):getChildByName("des")
		
	end
	leftdes:getChildByName("amy"):getChildByName("info"):setString(ff.langString("军队").." : "..self._info.Achuzhan)
	rightdes:getChildByName("amy"):getChildByName("info"):setString(ff.langString("军队").." : "..self._info.Bchuzhan)
	left:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getPathFromUI("img01_attack.png",1))
	right:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getPathFromUI("img01_defend.png",1))
	
    left:getChildByName("player"):getChildByName("pos"):setString("("..mapsite.x..","..mapsite.y..")")
    if self._info.B_pos ~= nil then
	    local mapsiteB=dd.MapidToXY(self._info.B_pos)
	    right:getChildByName("player"):getChildByName("pos"):setString("("..mapsiteB.x..","..mapsiteB.y..")")
	end
	if self._info.A_union_Name ~= nil and string.len(self._info.A_union_Name ) >0 then
    	left:getChildByName("player"):getChildByName("union"):setString("["..self._info.A_union_Name.."]")
    else
    	left:getChildByName("player"):getChildByName("union"):setString("")
    end

    if self._info.B_union_Name ~= nil and string.len(self._info.B_union_Name ) >0 then
    	right:getChildByName("player"):getChildByName("union"):setString("["..self._info.B_union_Name.."]")
    else
    	right:getChildByName("player"):getChildByName("union"):setString("")
    end

    --if self._info.result == 1 then
    ---	left:getChildByName("player"):getChildByName("name"):setColor(cc.c3b(0,202,0))
    --else
    --	right:getChildByName("player"):getChildByName("name"):setColor(cc.c3b(0,202,0))
    --end

    if self._info.type ~= 15 then
	    right:getChildByName("player"):getChildByName("name"):setString(self._info.B_name)

	    right:getChildByName("player"):getChildByName("player"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(self._info.BIco),0)
		
	else
		right:getChildByName("player"):getChildByName("name"):setString(ff.langString("黑杰克"))

	    right:getChildByName("player"):getChildByName("player"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(1005),0)
		
	end

    left:getChildByName("player"):getChildByName("name"):setString(self._info.A_name)

    left:getChildByName("player"):getChildByName("player"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(self._info.AIco),0)

    --leftdes:getChildByName("amy"):getChildByName("info"):setString(ff.langString("军队").."："..self._info.A_amy)
    --rightdes:getChildByName("amy"):getChildByName("info"):setString(ff.langString("军队").."："..self._info.B_amy)

	if self._info.addBu ~= 0 then
		if self._info.addBu > 0 then
			for i=1,self._info.addBu do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("a1"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("a1"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("a1"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("a1"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.addBu) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("a1"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("a1"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("a1"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("a1"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("a1"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("a1"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("a1"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("a1"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end

	if self._info.addQi ~= 0 then
		if self._info.addQi > 0 then
			for i=1,self._info.addQi do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("a2"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("a2"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("a2"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("a2"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.addQi) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("a2"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("a2"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("a2"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("a2"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("a2"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("a2"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("a2"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("a2"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end

	if self._info.addGong ~= 0 then
		if self._info.addGong > 0 then
			for i=1,self._info.addGong do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("a3"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("a3"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("a3"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("a3"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.addGong) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("a3"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("a3"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("a3"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("a3"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("a3"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("a3"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("a3"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("a3"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end

	if self._info.addHPBu ~= 0 then
		if self._info.addHPBu > 0 then
			for i=1,self._info.addHPBu do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("a4"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("a4"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("a4"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("a4"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.addHPBu) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("a4"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("a4"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("a4"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("a4"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("a4"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("a4"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("a4"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("a4"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end

	if self._info.addHPQi ~= 0 then
		if self._info.addHPQi > 0 then
			for i=1,self._info.addHPQi do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("a5"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("a5"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("a5"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("a5"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.addHPQi) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("a5"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("a5"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("a5"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("a5"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("a5"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("a5"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("a5"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("a5"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end

	if self._info.addHPGong ~= 0 then
		if self._info.addHPGong > 0 then
			for i=1,self._info.addHPGong do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("a6"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("a6"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("a6"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("a6"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.addHPGong) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("a6"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("a6"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("a6"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("a6"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("a6"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("a6"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("a6"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("a6"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end

	if self._info.equipPower ~= 0 then
		if self._info.equipPower > 0 then
			for i=1,self._info.equipPower do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("hero1"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("hero1"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("hero1"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("hero1"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.equipPower) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("hero1"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("hero1"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("hero1"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("hero1"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("hero1"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("hero1"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("hero1"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("hero1"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end

	if self._info.gemLevel ~= 0 then
		if self._info.gemLevel > 0 then
			for i=1,self._info.gemLevel do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("hero2"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("hero2"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("hero2"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("hero2"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.gemLevel) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("hero2"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("hero2"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("hero2"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("hero2"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("hero2"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("hero2"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("hero2"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("hero2"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end

	leftdes:getChildByName("tec1"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[1701]['tec_name']))
	rightdes:getChildByName("tec1"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[1701]['tec_name']))
	leftdes:getChildByName("tec2"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[1702]['tec_name']))
	rightdes:getChildByName("tec2"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[1702]['tec_name']))
	leftdes:getChildByName("tec3"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[1703]['tec_name']))
	rightdes:getChildByName("tec3"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[1703]['tec_name']))
	leftdes:getChildByName("tec4"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[1901]['tec_name']))
	rightdes:getChildByName("tec4"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[1901]['tec_name']))
	leftdes:getChildByName("tec5"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[1902]['tec_name']))
	rightdes:getChildByName("tec5"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[1902]['tec_name']))
	leftdes:getChildByName("tec6"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[1903]['tec_name']))
	rightdes:getChildByName("tec6"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[1903]['tec_name']))
	leftdes:getChildByName("tec7"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[2101]['tec_name']))
	rightdes:getChildByName("tec7"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[2101]['tec_name']))
	leftdes:getChildByName("tec8"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[2103]['tec_name']))
	rightdes:getChildByName("tec8"):getChildByName("Label_70"):setString(ff.langString(dd.cfgTec[2103]['tec_name']))



	leftdes:getChildByName("info1_0"):getChildByName("Label_70"):setString(ff.langString("野战兵熟练度"))
	rightdes:getChildByName("info1_0"):getChildByName("Label_70"):setString(ff.langString("野战兵熟练度"))
	leftdes:getChildByName("info2_0"):getChildByName("Label_70"):setString(ff.langString("装甲车熟练度"))
	rightdes:getChildByName("info2_0"):getChildByName("Label_70"):setString(ff.langString("装甲车熟练度"))
	leftdes:getChildByName("info3_0"):getChildByName("Label_70"):setString(ff.langString("枪手熟练度"))
	rightdes:getChildByName("info3_0"):getChildByName("Label_70"):setString(ff.langString("枪手熟练度"))
	leftdes:getChildByName("info4_0"):getChildByName("Label_70"):setString(ff.langString("攻城车熟练度"))
	rightdes:getChildByName("info4_0"):getChildByName("Label_70"):setString(ff.langString("攻城车熟练度"))

	leftdes:getChildByName("info1_0"):getChildByName("have"):setString("LV."..self._info.A_yu1)
	rightdes:getChildByName("info1_0"):getChildByName("have"):setString("LV."..self._info.B_yu1)
	leftdes:getChildByName("info3_0"):getChildByName("have"):setString("LV."..self._info.A_yu2)
	rightdes:getChildByName("info3_0"):getChildByName("have"):setString("LV."..self._info.B_yu2)
	leftdes:getChildByName("info2_0"):getChildByName("have"):setString("LV."..self._info.A_yu3)
	rightdes:getChildByName("info2_0"):getChildByName("have"):setString("LV."..self._info.B_yu3)
	leftdes:getChildByName("info4_0"):getChildByName("have"):setString("LV."..self._info.A_yu4)
	rightdes:getChildByName("info4_0"):getChildByName("have"):setString("LV."..self._info.B_yu4)

	leftdes:getChildByName("Image_67_0_1_2_0"):getChildByName("Label_68"):setString(ff.langString("熟练度"))
	rightdes:getChildByName("Image_67_0_1_2_0"):getChildByName("Label_68"):setString(ff.langString("熟练度"))


	if self._info.tec1 ~= 0 then
		if self._info.tec1 > 0 then
			for i=1,self._info.tec1 do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec1"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec1"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("tec1"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec1"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.tec1) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec1"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec1"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("tec1"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec1"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("tec1"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("tec1"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("tec1"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("tec1"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end

	if self._info.tec2 ~= 0 then
		if self._info.tec2 > 0 then
			for i=1,self._info.tec2 do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec2"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec2"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("tec2"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec2"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.tec2) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec2"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec2"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("tec2"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec2"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("tec2"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("tec2"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("tec2"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("tec2"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end

	if self._info.tec3 ~= 0 then
		if self._info.tec3 > 0 then
			for i=1,self._info.tec3 do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec3"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec3"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("tec3"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec3"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.tec3) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec3"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec3"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("tec3"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec3"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("tec3"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("tec3"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("tec3"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("tec3"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end

	if self._info.tec4 ~= 0 then
		if self._info.tec4 > 0 then
			for i=1,self._info.tec4 do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec4"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec4"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("tec4"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec4"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.tec4) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec4"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec4"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("tec4"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec4"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("tec4"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("tec4"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("tec4"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("tec4"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end

	if self._info.tec5 ~= 0 then
		if self._info.tec5 > 0 then
			for i=1,self._info.tec5 do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec5"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec5"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("tec5"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec5"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.tec5) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec5"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec5"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("tec5"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec5"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("tec5"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("tec5"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("tec5"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("tec5"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end

	if self._info.tec6 ~= 0 then
		if self._info.tec6 > 0 then
			for i=1,self._info.tec6 do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec6"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec6"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("tec6"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec6"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.tec6) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec6"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec6"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("tec6"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec6"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("tec6"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("tec6"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("tec6"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("tec6"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end

	if self._info.tec7 ~= 0 then
		if self._info.tec7 > 0 then
			for i=1,self._info.tec7 do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec7"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec7"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("tec7"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec7"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.tec7) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec7"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec7"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("tec7"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec7"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("tec7"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("tec7"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("tec7"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("tec7"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end

	if self._info.tec8 ~= 0 then
		if self._info.tec8 > 0 then
			for i=1,self._info.tec8 do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec8"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec8"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
				rightdes:getChildByName("tec8"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec8"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
			end
		else
			for i=1,math.abs(self._info.tec8) do
				local name = "ico"..tostring(4-i)
				leftdes:getChildByName("tec8"):getChildByName(name):setVisible(true)
				leftdes:getChildByName("tec8"):getChildByName(name):loadTexture(dd.getPathFromUI("down01.png",1))
				rightdes:getChildByName("tec8"):getChildByName(name):setVisible(true)
				rightdes:getChildByName("tec8"):getChildByName(name):loadTexture(dd.getPathFromUI("up01.png",1))
			end
		end
	else
		leftdes:getChildByName("tec8"):getChildByName("ico3"):setVisible(true)
		leftdes:getChildByName("tec8"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
		rightdes:getChildByName("tec8"):getChildByName("ico3"):setVisible(true)
		rightdes:getChildByName("tec8"):getChildByName("ico3"):loadTexture(dd.getPathFromUI("equal01.png",1))
	end


		if self._info.A_isHao > 0 then
			leftdes:getChildByName("info1"):getChildByName("have"):setVisible(true)
			leftdes:getChildByName("info1"):getChildByName("have"):setString(ff.langString("是"))		
		else
			leftdes:getChildByName("info1"):getChildByName("have"):setVisible(true)
			leftdes:getChildByName("info1"):getChildByName("have"):setString(ff.langString("否"))
		end

	if self._info.A_isShen > 0 then
			leftdes:getChildByName("info2"):getChildByName("have"):setVisible(true)
			leftdes:getChildByName("info2"):getChildByName("have"):setString(ff.langString("是"))		
	else
			leftdes:getChildByName("info2"):getChildByName("have"):setVisible(true)
			leftdes:getChildByName("info2"):getChildByName("have"):setString(ff.langString("否"))
	end

	if self._info.A_liao > 0 then
			leftdes:getChildByName("info3"):getChildByName("have"):setVisible(true)
			leftdes:getChildByName("info3"):getChildByName("have"):setString(ff.langString("是"))		
	else
			leftdes:getChildByName("info3"):getChildByName("have"):setVisible(true)
			leftdes:getChildByName("info3"):getChildByName("have"):setString(ff.langString("否"))
	end

	if self._info.A_cheng > 0 then
			leftdes:getChildByName("info4"):getChildByName("have"):setVisible(true)
			leftdes:getChildByName("info4"):getChildByName("have"):setString(ff.langString("是"))		
	else
			leftdes:getChildByName("info4"):getChildByName("have"):setVisible(true)
			leftdes:getChildByName("info4"):getChildByName("have"):setString(ff.langString("否"))
	end

	if self._info.A_dashi > 0 then
			leftdes:getChildByName("info5"):getChildByName("have"):setVisible(true)
			leftdes:getChildByName("info5"):getChildByName("have"):setString(ff.langString("是"))		
	else
			leftdes:getChildByName("info5"):getChildByName("have"):setVisible(true)
			leftdes:getChildByName("info5"):getChildByName("have"):setString(ff.langString("否"))
	end

	if self._info.A_zhan > 0 then
			leftdes:getChildByName("info6"):getChildByName("have"):setVisible(true)
			leftdes:getChildByName("info6"):getChildByName("have"):setString(ff.langString("是"))		
	else
			leftdes:getChildByName("info6"):getChildByName("have"):setVisible(true)
			leftdes:getChildByName("info6"):getChildByName("have"):setString(ff.langString("否"))
	end

	if self._info.B_isHao > 0 then
			rightdes:getChildByName("info1"):getChildByName("have"):setVisible(true)
			rightdes:getChildByName("info1"):getChildByName("have"):setString(ff.langString("是"))		
		else
			rightdes:getChildByName("info1"):getChildByName("have"):setVisible(true)
			rightdes:getChildByName("info1"):getChildByName("have"):setString(ff.langString("否"))
		end

	if self._info.B_isShen > 0 then
			rightdes:getChildByName("info2"):getChildByName("have"):setVisible(true)
			rightdes:getChildByName("info2"):getChildByName("have"):setString(ff.langString("是"))		
	else
			rightdes:getChildByName("info2"):getChildByName("have"):setVisible(true)
			rightdes:getChildByName("info2"):getChildByName("have"):setString(ff.langString("否"))
	end

	if self._info.B_liao > 0 then
			rightdes:getChildByName("info3"):getChildByName("have"):setVisible(true)
			rightdes:getChildByName("info3"):getChildByName("have"):setString(ff.langString("是"))		
	else
			rightdes:getChildByName("info3"):getChildByName("have"):setVisible(true)
			rightdes:getChildByName("info3"):getChildByName("have"):setString(ff.langString("否"))
	end

	if self._info.B_cheng > 0 then
			rightdes:getChildByName("info4"):getChildByName("have"):setVisible(true)
			rightdes:getChildByName("info4"):getChildByName("have"):setString(ff.langString("是"))		
	else
			rightdes:getChildByName("info4"):getChildByName("have"):setVisible(true)
			rightdes:getChildByName("info4"):getChildByName("have"):setString(ff.langString("否"))
	end

	if self._info.B_dashi > 0 then
			rightdes:getChildByName("info5"):getChildByName("have"):setVisible(true)
			rightdes:getChildByName("info5"):getChildByName("have"):setString(ff.langString("是"))		
	else
			rightdes:getChildByName("info5"):getChildByName("have"):setVisible(true)
			rightdes:getChildByName("info5"):getChildByName("have"):setString(ff.langString("否"))
	end

	if self._info.B_zhan > 0 then
			rightdes:getChildByName("info6"):getChildByName("have"):setVisible(true)
			rightdes:getChildByName("info6"):getChildByName("have"):setString(ff.langString("是"))		
	else
			rightdes:getChildByName("info6"):getChildByName("have"):setVisible(true)
			rightdes:getChildByName("info6"):getChildByName("have"):setString(ff.langString("否"))
	end


	self:getChildByName("scrollview"):pushBackCustomItem(mainArea)
	self:getChildByName("scrollview"):scrollToTop(0.5,true)
    self:getChildByName("scrollview"):setItemsMargin(5)
end

function fightCompareLayer.onStart( sender )
    -- body
    ff.net:bindProperty(2312,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
end

function fightCompareLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("fightCompare")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end