--查看邮件面板
mailReceiveLayer = class("mailReceiveLayer")
mailReceiveLayer._name = "mailReceive"
mailReceiveLayer._init = false
mailReceiveLayer._mailInfo = nil
mailReceiveLayer._mailId = -1
mailReceiveLayer._mailIndex = -1
mailReceiveLayer._mailIndexMax = -1
mailReceiveLayer._rId = -1
mailReceiveLayer._send = false
mailReceiveLayer._isGet = false
mailReceiveLayer._senderName = nil
mailReceiveLayer._senderUnion = nil 
mailReceiveLayer._ReceiveName = nil
mailReceiveLayer._ReceiveUnion = nil
mailReceiveLayer._start = false


function mailReceiveLayer.extend( target )
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,mailReceiveLayer)
	return target
	-- body
end

function onShowMailReceive( widget,parent,id,index,indexmax )
	local layer = mailReceiveLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
	layer.parent = parent
	layer:onInit(id,index,indexmax)
	return layer
	-- body
end

function mailReceiveLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("mailReceive")
        if widget == nil then
            return
        end
        pop.onClosePopDialog("mailReceive")
    end
end

function mailReceiveLayer:initData(id,index,indexmax )
	self._mailId = tonumber(id)
	self._mailIndex = tonumber(index)
	self._mailIndexMax = tonumber(indexmax)
    self._rId = -1
    self._isGet = false
    self._senderName = nil
	self._senderUnion = nil 
	self._ReceiveName = nil
	self._ReceiveUnion = nil
    local mail = nil
    if index == indexmax then
        local effect = ff.Effect:effectGrey()    
        self:getChildByName("receive"):getChildByName("downmail"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        self:getChildByName("receive"):getChildByName("downmail"):setTouchEnabled(false)
        
    else
        self:getChildByName("receive"):getChildByName("downmail"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        self:getChildByName("receive"):getChildByName("downmail"):setTouchEnabled(true)
    
    end
    if index == 1 then
        local effect = ff.Effect:effectGrey()    
        self:getChildByName("receive"):getChildByName("upmail"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        self:getChildByName("receive"):getChildByName("upmail"):setTouchEnabled(false)
        
    else
        self:getChildByName("receive"):getChildByName("upmail"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        self:getChildByName("receive"):getChildByName("upmail"):setTouchEnabled(true)
   
    end


    --if self.parent._showData:getLong(self._mailIndex,"read_flag") == 0 then
    --    local message = ff.net:createMessage()
    --    message:addCmd(0xF09)
     --   message:addLong(dd.uid)
     --   message:addLong(2)

     --   message:addLong(1)
    --    message:addSuperLong(self.parent._showData:getSuperLong(self._mailIndex,"id"))
    --    message:addLong(self.parent._showData:getLong(self._mailIndex,"read_flag"))
                       
    --    ff.net:rpc(message,false)
    --end


    self:getChildByName("receive"):getChildByName("title"):setString(self.parent._showData:getString(self._mailIndex,'title').." ("..index.."/"..indexmax..")")

    local count = string.len(self.parent._showData:getString(self._mailIndex,"sender_union") )

    if count < 1 then
        self:getChildByName("receive"):getChildByName("info"):getChildByName("info"):getChildByName("union"):setString("")
    else
        self:getChildByName("receive"):getChildByName("info"):getChildByName("info"):getChildByName("union"):setString("["..self.parent._showData:getString(self._mailIndex,"sender_union").."]")
    end



    local dateStr = ff.getFormatTime(self.parent._showData:getLong(self._mailIndex,'time'))
    self:getChildByName("receive"):getChildByName('time'):setString(dateStr)

    local send_uid = self.parent._showData:getLong(self._mailIndex,"sender_uid")

    if send_uid == 0 then
        --self:getChildByName("receive"):getChildByName('uid'):setString("")
        self:getChildByName("receive"):getChildByName("info"):getChildByName("info"):getChildByName("name"):setString(ff.langString('运营团队'))
    else
       -- self:getChildByName("receive"):getChildByName('uid'):setString("UID:"..self._mailInfo:getLong(1,"sender_uid"))
        self:getChildByName("receive"):getChildByName("info"):getChildByName("info"):getChildByName("name"):setString(self.parent._showData:getString(self._mailIndex,"sender"))
    end

    if self.parent._type == 2 then
        self:getChildByName("receive"):getChildByName("info"):getChildByName("info"):getChildByName("from"):setString(ff.langString('From:'))
    elseif self.parent._type == 3 then
        self:getChildByName("receive"):getChildByName("info"):getChildByName("info"):getChildByName("from"):setString(ff.langString('To:'))
    end
    self:getChildByName("receive"):getChildByName("info"):getChildByName("info"):requestDoLayout()
    
    self:getChildByName("scrollview"):removeAllChildren()

    mail = ff.dbmanager:sql_fetch_rows("select * from client_recv_mail where `id`='"..id.."'")
    if mail ~= nil and mail:rowCount() > 0 then
    	
        if string.len(mail:getString(1,"detail")) >  0 then
        	
            self:updateCheckView(mail,true)
            return
        else
            mail:clear()
        end        
    end
    self._send = true
	if self._start == true then
		local getMailListMg = ff.net:createMessage()
    	getMailListMg:addCmd(0xE0B)
    	getMailListMg:addLong(dd.uid)
    	getMailListMg:addSuperLong(self._mailId)
    	ff.net:rpc(getMailListMg,false)
    	--sender._start = false
	end
	-- body
end

function mailReceiveLayer.onStart( sender )
	-- body
	if sender._send then
		local getMailListMg = ff.net:createMessage()
    	getMailListMg:addCmd(0xE0B)
    	getMailListMg:addLong(dd.uid)
    	getMailListMg:addSuperLong(sender._mailId)
    	ff.net:rpc(getMailListMg,false)
    	sender._start = true
	end
    ff.net:bindProperty(2310,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
end

function mailReceiveLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("mailReceive")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end

function mailReceiveLayer.collectmail( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then   
        local widget = pop.getDialog("mailReceive")
        if widget == nil then
            return
        end
        widget.parent:collectMail(widget._mailId)
    end
end

function mailReceiveLayer.deletemail( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then   
        local widget = pop.getDialog("mailReceive")
        if widget == nil then
            return
        end

        local message = ff.net:createMessage()
        message:addCmd(0xF09)
        message:addLong(dd.uid)

        if widget.parent._type == 2 then
            message:addLong(1)
        elseif widget.parent._type == 3 then
            message:addLong(3)
        end
        message:addLong(1)
        message:addSuperLong(widget._mailId)
        message:addLong(0)
        ff.net:rpc(message,false)
        pop.onClosePopDialog("mailReceive")
    end
end

function mailReceiveLayer.answermail( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then   
        local widget = pop.getDialog("mailReceive")
        if widget == nil then
            return
        end
        if not pop.isShowing("mailWrite") then
            
            local send_uid = widget.parent._showData:getLong(widget._mailIndex,'sender_uid')
            if send_uid == 0 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("系统邮件无法回复"))
                return
            end

            if widget.parent._type == 3 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("发出的邮件无法回复"))
                return
            end

            if widget._mailInfo == nil then 
                return
            end

            if tonumber(widget._mailInfo:getLong(1,"mail_type")) == 1 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("联盟邮件无法回复"))
                return
            end
            widget:stopAllActions()
            local name = widget.parent._showData:getString(widget._mailIndex,"sender")
            local title = widget._mailInfo:getString(1,'title')
            pop.onShowPopDialog("mailWrite",false,send_uid,name,title,widget._mailInfo:getString(1,'lang'),{},0,widget._mailInfo:getSuperLong(1,'id'))
            pop.onClosePopDialog("mailReceive")
            --cclog("========="..widget._mailInfo:getSuperLong(1,'id'))
            --pop.onShowPopDialog("mailWrite",send_uid,name,title,widget._mailInfo:getString(1,'lang'),{},widget._mailInfo:getSuperLong(1,'id'))
        end
    end
end

function mailReceiveLayer.onTrans(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("mailReceive")
        if widget == nil then
            return
        end
        local type = sender:getTag()
        local id   = sender:getParent():getTag()
        local item   =widget:getChildByName("scrollview"):getChildByTag(id) --self:getChildByName("chatpanel"):getChildByName("lists"):getChildByTag(id)

        if item ~= nil then
        --local data = ff.dbmanager:sql_fetch_rows("select `chat` from client_chat where `id`='"..id.."'")
            if widget._mailInfo ~= nil then
                if type == 1 then
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000D01)
                    message:addLong(dd.uid)
                    message:addString(item.string,511)
                   
                    message:addString(dd.languageCode[ff.set_trans_lan + 1],15)
                    message:addLong(id)
                    message:addLong(0)
                    message:addLong(0)
                    message:addLong(0)
                    ff.net:postMessage(message)     
                else
                    widget:onTranslate({0,"","",item.string,id},true)   
                end
            end
        end
        --if data ~= nil then
        --    data:clear()
        --end            
    end
end

function mailReceiveLayer:onTranslate(message,back)
    local code = message[1]
    if code == 0 then
        local target = message[4]
        local id     = message[5]
        
        local item   =self:getChildByName("scrollview"):getChildByTag(id) --self:getChildByName("chatpanel"):getChildByName("lists"):getChildByTag(id)
        
        if item ~= nil then

            item:getChildByName("Label"):setString(target)
            local len_one_line = 30
            if ff.lang == 0 then
                len_one_line = 60
            end
            local hh = math.ceil((string.len(target) - 1)/len_one_line) * 30
            local num = 0 
            local content = '' 
            content,num = string.gsub(target,"\n","\n")  
            hh = hh + num * 30 
            if hh < 30  then
                hh = 30
          
            end

            item:getChildByName("Label"):setContentSize(cc.size(655,hh)) 

            item:setContentSize(cc.size(720,hh+80)) 
            item:requestDoLayout()
            
            if back == true then
                item:getChildByName("trans"):getChildByName("dotrans"):setTag(1)
                item:getChildByName("trans"):getChildByName("label"):setString(ff.langString("未翻译"))
            else
                item:getChildByName("trans"):getChildByName("dotrans"):setTag(2)
                item:getChildByName("trans"):getChildByName("label"):setString(ff.langString("已翻译"))
            end
        end
    end
end


function mailReceiveLayer:updateCheckView(mailInfo,fromDB)
        cclog("updateCheckView")
        if mailInfo == nil then 
            return
        end
        if mailInfo ~= nil and mailInfo:rowCount() == 0 then
            mailInfo:clear()
            return
        end
        if  self._mailInfo  then
            self._mailInfo:clear()
            self._mailInfo = nil
        end  
            self._mailInfo=ff.NetTable:create()
            self._mailInfo:addStreamCol("id",ff.NET_SUPER_LONG)
            self._mailInfo:addStreamCol("time",ff.NET_LONG)
            self._mailInfo:addStreamCol("mail_type",ff.NET_LONG)

            self._mailInfo:addStreamCol("sender_uid",ff.NET_LONG)
            self._mailInfo:addStreamCol("sender",ff.NET_STRING,15)
            self._mailInfo:addStreamCol("sender_union",ff.NET_STRING,3)
            self._mailInfo:addStreamCol("title",ff.NET_STRING,63)
            self._mailInfo:addStreamCol("detail",ff.NET_STRING,4095)
            self._mailInfo:addStreamCol("read_flag",ff.NET_LONG)
            self._mailInfo:addStreamCol("lang",ff.NET_STRING,15)
            self._mailInfo:addStreamCol("issend",ff.NET_LONG)
            self._mailInfo:addStreamCol("receiveid",ff.NET_SUPER_LONG)
            self._mailInfo:addRow()

            self._mailInfo:setSuperLong(1,"id",mailInfo:getSuperLong(1,"id"))
            self._mailInfo:setLong(1,"time",mailInfo:getLong(1,"time"))
            self._mailInfo:setLong(1,"mail_type",mailInfo:getLong(1,"mail_type"))
            self._mailInfo:setLong(1,"sender_uid",mailInfo:getLong(1,"sender_uid"))
            self._mailInfo:setLong(1,"read_flag",mailInfo:getLong(1,"read_flag"))
            self._mailInfo:setString(1,"sender",mailInfo:getString(1,"sender"))
            self._mailInfo:setString(1,"sender_union",mailInfo:getString(1,"sender_union"))
            self._mailInfo:setString(1,"title",mailInfo:getString(1,"title"))
            self._mailInfo:setString(1,"detail",mailInfo:getString(1,"detail"))
            self._mailInfo:setString(1,"lang",mailInfo:getString(1,"lang"))
            self._mailInfo:setLong(1,"issend",mailInfo:getLong(1,"issend"))
            self._mailInfo:setSuperLong(1,"receiveid",mailInfo:getSuperLong(1,"receiveid"))
            mailInfo:clear()
        if self._rId == -1 then
            if self.parent._type == 2 then
            	self._senderName = self._mailInfo:getString(1,"sender")
            	self._senderUnion = self._mailInfo:getString(1,"sender_union")

            	self._ReceiveName = dd.myinfo:getString(1,"name")
            	if dd.myUnion ~= nil and string.len(dd.myUnion:getString(1,"unionflag"))>0 then
         			self._ReceiveUnion = dd.myUnion:getString(1,"unionflag")
         		end
            elseif self.parent._type == 3 then
            	self._senderName = dd.myinfo:getString(1,"name")
            	if dd.myUnion ~= nil and string.len(dd.myUnion:getString(1,"unionflag"))>0 then
         			self._senderUnion = dd.myUnion:getString(1,"unionflag")
         		end
         		self._ReceiveName = self._mailInfo:getString(1,"sender")
         		self._ReceiveUnion =self._mailInfo:getString(1,"sender_union")
            end
            self._rId = self._mailInfo:getSuperLong(1,"receiveid")
            local autoSize = false
            if string.len(self._mailInfo:getString(1,"detail")) > 0 then 
                local  item  = nil
                local send_uid = self._mailInfo:getLong(1,"sender_uid")
                if send_uid == 0 then
                    item = self:getChildByName("area1"):clone()
                else
                    item = self:getChildByName("area"):clone()
                    item:getChildByName("trans"):setVisible(true)
                    item:setTag(self._mailInfo:getSuperLong(1,"id"))
                    item:getChildByName("trans"):setTag(self._mailInfo:getSuperLong(1,"id"))
                    item:getChildByName("trans"):getChildByName("label"):setString(ff.langString("未翻译"))
                    item:getChildByName("trans"):getChildByName("dotrans"):setTag(1)
                    item:getChildByName("trans"):getChildByName("dotrans"):addTouchEventListener(self.onTrans)
                    autoSize = true
                end
   
                item:setVisible(true)
                item:getChildByName("answer"):getChildByName("answerEx"):setString("RE:")
                if self._mailInfo:getLong(1,"issend") == 1 then 

                	if self._senderUnion ~= nil then
                	local count = string.len(self._senderUnion )

                	if count < 1 then
                    	item:getChildByName("answer"):getChildByName("union"):setString("")
                	else
                    	item:getChildByName("answer"):getChildByName("union"):setString("["..self._senderUnion.."]")
                	end
                	end

                	if send_uid == 0 then
                    	item:getChildByName("answer"):getChildByName("name"):setString(ff.langString('运营团队'))
                	else
                    	item:getChildByName("answer"):getChildByName("name"):setString(self._senderName)
                	end

            	else
            		if self._ReceiveUnion ~= nil then
                	local count = string.len(self._ReceiveUnion )

                	if count < 1 then
                    	item:getChildByName("answer"):getChildByName("union"):setString("")
                	else
                    	item:getChildByName("answer"):getChildByName("union"):setString("["..self._ReceiveUnion.."]")
                	end
                	end

                    item:getChildByName("answer"):getChildByName("name"):setString(self._ReceiveName)
            	end

            	
            	local dateStr = ff.getFormatTime(self._mailInfo:getLong(1,"time"))
            	item:getChildByName("answer"):getChildByName("time"):setString(dateStr)
            	
            	item:getChildByName("answer"):requestDoLayout()
            	if self._rId == 0 then
                    if  send_uid ~= 0  then
            		  item:getChildByName("Label"):setPositionY(300)
                    end
            		item:getChildByName("answer"):setVisible(false)
            	end
                if autoSize == true then
                    local num = 0 
                    local content = '' 
                    content,num = string.gsub(self._mailInfo:getString(1,"detail"),"\n","\n")  
                    local len_one_line = 30
                    if ff.lang == 0 then
                        len_one_line = 60
                    end
                    local hh = math.ceil((string.len(self._mailInfo:getString(1,"detail")) - 1)/len_one_line) * 30
                    --local x = (string.len(self._mailInfo:getString(1,"detail")) - 1)/len_one_line
                    --cclog("==============================="..x.."==========="..num)
                    hh = hh + num * 30 
                    if hh < 30  then
                        hh = 30
                    --elseif hh>200 then
                    --    hh = 200 
                    end
                    item.string = content
                    item:getChildByName("Label"):setContentSize(cc.size(655,hh)) 

                    item:setContentSize(cc.size(720,hh+80)) 
                    item:requestDoLayout()
                end
                
                item:getChildByName("Label"):setString(self._mailInfo:getString(1,"detail"))
                
                self:getChildByName("scrollview"):pushBackCustomItem(item)
            end

            if self._rId > 0 then
                local mail = nil
                id = self._rId
                mail = ff.dbmanager:sql_fetch_rows("select * from client_recv_mail where `id`='"..id.."'")
                if mail ~= nil and mail:rowCount() > 0 then
                    if string.len(mail:getString(1,"detail")) >  0 then
                        self:updateCheckView(mail,true)
                    else
                    mail:clear()
                    end        
                else

                    local getMailListMg = ff.net:createMessage()
                    getMailListMg:addCmd(0xE0B)
                    getMailListMg:addLong(dd.uid)
                    getMailListMg:addSuperLong(self._rId)
                    ff.net:rpc(getMailListMg,false)
                end
            end
            local id = self._mailInfo:getSuperLong(1,"id")
            ff.dbmanager:sql_query("update client_recv_mail set `read_flag`='1' where `id`='"..id.."'")

        elseif self._mailInfo:getSuperLong(1,"id") == self._rId then
            if string.len(self._mailInfo:getString(1,"detail")) > 0 then
            	
            	self._rId = self._mailInfo:getSuperLong(1,"receiveid")

                local  item  = nil
                item = self:getChildByName("area"):clone()
                item:getChildByName("trans"):setVisible(true)
                item:getChildByName("trans"):setTag(self._mailInfo:getSuperLong(1,"id"))
                item:setTag(self._mailInfo:getSuperLong(1,"id"))
                item:getChildByName("trans"):getChildByName("label"):setString(ff.langString("未翻译"))
                item:getChildByName("trans"):getChildByName("dotrans"):setTag(1)
                item:getChildByName("trans"):getChildByName("dotrans"):addTouchEventListener(self.onTrans)
                item:setVisible(true)
                item:getChildByName("answer"):setVisible(true)
                item:getChildByName("answer"):getChildByName("answerEx"):setString("RE:")

                if self._mailInfo:getLong(1,"issend") == 1 then 

                	if self._senderUnion ~= nil then
                    	local count = string.len(self._senderUnion )

                    	if count < 1 then
                        	item:getChildByName("answer"):getChildByName("union"):setString("")
                    	else
                        	item:getChildByName("answer"):getChildByName("union"):setString("["..self._senderUnion.."]")
                    	end
                	end

                	local send_uid = self._mailInfo:getLong(1,"sender_uid")

                	if send_uid == 0 then
                    	item:getChildByName("answer"):getChildByName("name"):setString(ff.langString('运营团队'))
                	else
                    	item:getChildByName("answer"):getChildByName("name"):setString(self._senderName)
                	end

            	else
            		if self._ReceiveUnion ~= nil then

                	local count = string.len(self._ReceiveUnion )

                	if count < 1 then
                    	item:getChildByName("answer"):getChildByName("union"):setString("")
                	else
                    	item:getChildByName("answer"):getChildByName("union"):setString("["..self._ReceiveUnion.."]")
                	end
                	end

                	local send_uid = self._mailInfo:getLong(1,"sender_uid")
                    item:getChildByName("answer"):getChildByName("name"):setString(self._ReceiveName)

            	end

            	local dateStr = ff.getFormatTime(self._mailInfo:getLong(1,"time"))

            	item:getChildByName("answer"):getChildByName("time"):setString(dateStr)
                item:getChildByName("answer"):requestDoLayout()

                local num = 0 
                local content = '' 
                content,num = string.gsub(self._mailInfo:getString(1,"detail"),"\n","\n")  
                local len_one_line = 30
                if ff.lang == 0 then
                    len_one_line = 60
                end
                local hh = math.ceil((string.len(self._mailInfo:getString(1,"detail")) - 1)/len_one_line) * 30
                hh = hh + num * 30 
                if hh < 30  then
                    hh = 30
                --elseif hh>200 then
                --    hh = 200
                end
                item.string = content
                item:getChildByName("Label"):setContentSize(cc.size(655,hh)) 

                item:setContentSize(cc.size(720,hh+80)) 
                item:requestDoLayout()

                item:getChildByName("Label"):setString(self._mailInfo:getString(1,"detail"))


                self:getChildByName("scrollview"):pushBackCustomItem(item)
                --cclog("======================"..self._mailInfo:getLong(1,"read_flag"))
                if 1 ~= ff._and(self._mailInfo:getLong(1,"read_flag"),1) and self._mailInfo:getLong(1,"issend") ~= 2 then
                    if self._rId > 0 then
                        local mail = nil
                        id = self._rId
                        mail = ff.dbmanager:sql_fetch_rows("select * from client_recv_mail where `id`='"..id.."'")
                        if mail ~= nil and mail:rowCount() > 0 then
                            if string.len(mail:getString(1,"detail")) >  0 then
                                self:updateCheckView(mail,true)
                            else
                            mail:clear()
                            end        
                        else

                            local getMailListMg = ff.net:createMessage()
                            getMailListMg:addCmd(0xE0B)
                            getMailListMg:addLong(dd.uid)
                            getMailListMg:addSuperLong(self._rId)
                            ff.net:rpc(getMailListMg,false)
                        end
                    end
                end
                local id = self._mailInfo:getSuperLong(1,"id")
                ff.dbmanager:sql_query("update client_recv_mail set `read_flag`='1' where `id`='"..id.."'")
            end
        end

        self:getChildByName("scrollview"):scrollToBottom(0.5,true)
        self:getChildByName("scrollview"):setItemsMargin(5)
end

function mailReceiveLayer:addUiEvent( )
    local function updateCheckViewEx(mailInfo)
        cclog("updateCheckView")
        self._isGet = false
        if mailInfo == nil then 
            return
        end
        if mailInfo ~= nil and mailInfo:rowCount() == 0 then
            mailInfo:clear()
            return
        end
        self:updateCheckView(mailInfo,false)

    end
    ff.net:registerEvent(1,dd.Tjf_Mail_GetMailContent,updateCheckViewEx)
    ff.net:registerEvent(4,dd.Tjf_Lang_trans,function (message) self:onTranslate(message)  end)
    -- body
end

function mailReceiveLayer.onEnd( sender )
    dd.delBackEvent()
    ff.net:removeEvent(1,dd.Tjf_Mail_GetMailContent)
    ff.net:removeEvent(4,dd.Tjf_Lang_trans)
    ff.net:unbindProperty("gold",2310)
    -- body
end

function mailReceiveLayer.nextMail( sender,eventType )
    if eventType == ccui.TouchEventType.ended then   
        local widget = pop.getDialog("mailReceive")
        if widget == nil then
            return
        end
        if widget._mailIndex >= widget._mailIndexMax then 
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有邮件了"))
        else
            local id = widget.parent._showData:getSuperLong(widget._mailIndex+1,"id")
            local cont = widget.parent._showData:rowCount()
            widget:initData(id,widget._mailIndex+1,cont)
        end
    end
end

function mailReceiveLayer.upMail( sender,eventType )
    if eventType == ccui.TouchEventType.ended then   
        local widget = pop.getDialog("mailReceive")
        if widget == nil then
            return
        end
        if widget._mailIndex <= 1  then 
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有邮件了"))
        else
            local id = widget.parent._showData:getSuperLong(widget._mailIndex-1,"id")
            local cont = widget.parent._showData:rowCount()
            widget:initData(id,widget._mailIndex-1,cont)
        end
    end
    -- body
end

function mailReceiveLayer:onInit(id,index,indexmax)
	self:addUiEvent()
	self._start = false
	if self._init == false then
		local hh = ff.height
        self:getChildByName("back"):setContentSize(cc.size(ff.width,ff.height-214))
        self:getChildByName("back"):setPositionY(0)

		self:setContentSize(cc.size(720,hh - 214))
		self:getChildByName("top"):setPositionY(hh - 214 - 105)
		self:getChildByName("receive"):setPositionY(hh - 214 - 105 - 190)

		self:getChildByName("oper"):setPositionY(0)
		--self:getChildByName("collect"):setPositionY(30)
		--self:getChildByName("delete"):setPositionY(30)

		self:getChildByName("scrollview"):setVisible(true)
		
		self:getChildByName("scrollview"):setContentSize(cc.size(720,hh  - 214 - 105 - 190 - 167))
		self:getChildByName("scrollview"):setPositionY(167)
		self:getChildByName("scrollview"):addScrollViewEventListener(self.scrollViewEvent)
        self:getChildByName("Image_back"):setContentSize(cc.size(700,hh - 214 - 105 - 190 - 167))
        self:getChildByName("Image_back"):setPositionY(167)
        self:getChildByName("Image_back"):setPositionX(10)

		self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
        self:getChildByName("oper"):getChildByName("answer"):addTouchEventListener(self.answermail)
        self:getChildByName("oper"):getChildByName("collect"):addTouchEventListener(self.collectmail)
        self:getChildByName("oper"):getChildByName("delete"):addTouchEventListener(self.deletemail)
        self:getChildByName("receive"):getChildByName("downmail"):addTouchEventListener(self.nextMail)
        self:getChildByName("receive"):getChildByName("upmail"):addTouchEventListener(self.upMail)
        --self:getChildByName("top"):getChildByName("chu_title"):setString(ff.langString("邮件"))
        --self:getChildByName("top"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)

        --self:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))

		self._init = true
	end
    self.updateGold()
	self:initData(id,index,indexmax)

	-- body
end

function mailReceiveLayer.scrollViewEvent(sender, evenType)
    if evenType == ccui.ScrollviewEventType.bounceBottom then
        
        local widget = pop.getDialog("mailReceive")
       
                if widget ~= nil and widget._isGet == false and widget._rId ~= 0 then
                	if widget._rId > 0 then
                		local mail = nil
               	 		id = widget._rId
                		mail = ff.dbmanager:sql_fetch_rows("select * from client_recv_mail where `id`='"..id.."'")
                		if mail ~= nil and mail:rowCount() > 0 then
                    		if string.len(mail:getString(1,"detail")) > 0 then
                        		widget:updateCheckView(mail,true)
                    		else
                    		mail:clear()
                    		end        
                		else
                    		local getMailListMg = ff.net:createMessage()
                    		getMailListMg:addCmd(0xE0B)
                    		getMailListMg:addLong(dd.uid)
                   			getMailListMg:addSuperLong(widget._rId)
                    		ff.net:rpc(getMailListMg,false)
                    	end
                	end
            	end
                    
      
    end
end