scoutRepLayer = class("scoutRepLayer")
scoutRepLayer._name = "scoutRep"
scoutRepLayer._init = false
scoutRepLayer._info = {}
scoutRepLayer._id = 0
scoutRepLayer._needNet = false

function scoutRepLayer.extend( target )
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,scoutRepLayer)
	return target
	-- body
end

function onShowScoutRep( widget,id,info,time )
	-- body
	local layer = scoutRepLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
	layer:onInit(id,info,time)
	return layer
end

function scoutRepLayer.onReturn( sender,eventType )
	-- body
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("scoutRep")
		if widget == nil then
			return
		end
        pop.onClosePopDialog("scoutRep")
    end
end

function scoutRepLayer:onInit( id,info, time )
	-- body
	if self._init == false then
		self:AutoSize()
		self._init = true 
	end
	self:InitData(id,info,time)
	--self:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
	--self:showInfo()
    self.updateGold()
end

function scoutRepLayer:InitData(id,info ,time)
	-- body
    local table = Split(info,"%\\")
    self:getChildByName("strinfo"):setVisible(false)
    local title = self:getChildByName("title")
    title:getChildByName("red"):setVisible(true)
    title:getChildByName("lv"):setVisible(false)
    title:getChildByName("info"):getChildByName("time"):setString("")
    title:getChildByName("info"):getChildByName("pos"):setString("")
    self._id = id
    self._needNet = false
    local message = ff.net:createMessage()
    message:addCmd(0x00000136)
    message:addLong(dd.uid)
            
    message:addLong(2)
    message:addLong(1)
    message:addLong(1)
    message:addSuperLong(self._id)
 
    ff.net:rpc(message,false)       
    self:getChildByName("strinfo"):getChildByName("info"):setPositionY(29)
    if tonumber(table[2]) == 2 or tonumber(table[2]) == 0 then
    	self:getChildByName("strinfo"):setVisible(true)
    	--self:getChildByName("scrollview"):removeAllChildren(true)
        title:getChildByName("title"):setString(ff.langString("侦查失败"))
        local dateStr = ff.showData(time)
        title:getChildByName("info"):getChildByName("time"):setString(dateStr)
        
    	--local item = self:getChildByName("wininfo"):clone()
    	--item:getChildByName("center"):getChildByName("type"):setString(ff.langString("侦查"))
    	--item:setVisible(true)
    	if tonumber(table[1]) == 1 then
    		--item:getChildByName("heroA"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(tonumber(table[7])),0)
    		--item:getChildByName("heroB"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(tonumber(table[13])),0)
    		if tonumber(table[2]) == 2 then
    			--item:getChildByName("heroA"):getChildByName("iswin"):setVisible(true)
    			--item:getChildByName("heroA"):getChildByName("iswin"):getChildByName("win"):setColor(cc.c3b(251,19,8))
    			--item:getChildByName("heroA"):getChildByName("iswin"):getChildByName("win"):setString(ff.langString("LOSE"))
    			--item:getChildByName("typeA"):setVisible(false)--getChildByName("type"):setString(ff.langString("侦查方"))
    			--item:getChildByName("typeB"):setVisible(false)--getChildByName("type"):setString(ff.langString("被侦查方"))
    			--item:getChildByName("typeA2"):setString(ff.langString("间谍"))
    			--item:getChildByName("typeB2"):setString(ff.langString("被侦查"))
    			--item:getChildByName("heroB"):getChildByName("iswin"):setVisible(true)
    			--item:getChildByName("heroB"):getChildByName("iswin"):getChildByName("win"):setColor(cc.c3b(183,197,199))
    			--item:getChildByName("heroB"):getChildByName("iswin"):getChildByName("win"):setString(ff.langString("WIN"))
    			--local mapsite=dd.MapidToXY(tonumber(table[8]))
    			--item:getChildByName("posA"):setString("x:"..mapsite.x..",y:"..mapsite.y)
    			local mapsiteB=dd.MapidToXY(tonumber(table[14]))
    			title:getChildByName("info"):getChildByName("pos"):setString(ff.langString("侦查地点").." ("..mapsiteB.x..","..mapsiteB.y..")")
              --  if table[5] ~= nil and string.len(table[5])>0 then
    			-- item:getChildByName("infoA"):getChildByName("union"):setString("["..table[5].."]")
              --  end
    			--item:getChildByName("infoA"):getChildByName("name"):setString(table[6])
    			--item:getChildByName("infoA"):getChildByName("level"):setString("")
               -- if table[11] ~= nil and string.len(table[11])>0 then
               --     item:getChildByName("infoB"):getChildByName("union"):setString("["..table[11].."]")
                --end
                --item:getChildByName("infoB"):getChildByName("name"):setString(table[12])
               -- item:getChildByName("infoB"):getChildByName("level"):setString("")
               self:getChildByName("strinfo"):getChildByName("btmIcon"):setVisible(false)
    			self:getChildByName("strinfo"):getChildByName("info"):setString(ff.langString("你的侦察兵被俘虏了,提升“侦查”科技可提升成功概率"))
    		else
               -- item:getChildByName("typeA"):setVisible(false)--getChildByName("type"):setString(ff.langString("被侦查方"))
               -- item:getChildByName("typeB"):setVisible(false)
    			--item:getChildByName("heroA"):getChildByName("iswin"):setVisible(false)
    			--item:getChildByName("heroB"):getChildByName("iswin"):setVisible(false)
                self:getChildByName("strinfo"):getChildByName("btmIcon"):setVisible(false)
    			self:getChildByName("strinfo"):getChildByName("info"):setString(ff.langString("目标已经转移"))
                self:getChildByName("strinfo"):getChildByName("info"):setPositionY(17)
    		end
    	else
    		--item:getChildByName("heroB"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(tonumber(table[7])),0)
    		--item:getChildByName("heroA"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(tonumber(table[13])),0)
    		if tonumber(table[2]) == 2 then
    			--item:getChildByName("heroA"):getChildByName("iswin"):setVisible(true)
    			--item:getChildByName("heroB"):getChildByName("iswin"):getChildByName("win"):setColor(cc.c3b(251,19,8))
    			--item:getChildByName("heroB"):getChildByName("iswin"):getChildByName("win"):setString(ff.langString("LOSE"))
    			--item:getChildByName("typeA"):setVisible(false)--getChildByName("type"):setString(ff.langString("被侦查方"))
    			--item:getChildByName("typeB"):setVisible(false)--getChildByName("type"):setString(ff.langString("侦查方"))
    			--item:getChildByName("typeA2"):setString(ff.langString("被侦查"))
    			--item:getChildByName("typeB2"):setString(ff.langString("间谍"))
    			--item:getChildByName("heroB"):getChildByName("iswin"):setVisible(true)
    			--item:getChildByName("heroA"):getChildByName("iswin"):getChildByName("win"):setColor(cc.c3b(183,197,199))
    			--item:getChildByName("heroA"):getChildByName("iswin"):getChildByName("win"):setString(ff.langString("WIN"))
    			local mapsite=dd.MapidToXY(tonumber(table[14]))
                title:getChildByName("info"):getChildByName("pos"):setString(ff.langString("侦查地点").." ("..mapsite.x..","..mapsite.y..")")
    			--item:getChildByName("posA"):setString("x:"..mapsite.x..",y:"..mapsite.y)
    			--local mapsiteB=dd.MapidToXY(tonumber(table[8]))
    			--item:getChildByName("posB"):setString("x:"..mapsiteB.x..",y:"..mapsiteB.y)
                --if table[11] ~= nil and string.len(table[11])>0 then
    			--     item:getChildByName("infoA"):getChildByName("union"):setString("["..table[11].."]")
                -- end
    			--item:getChildByName("infoA"):getChildByName("name"):setString(table[12])
    			--item:getChildByName("infoA"):getChildByName("level"):setString("")
                --if table[5] ~= nil and string.len(table[5])>0 then
                --    item:getChildByName("infoB"):getChildByName("union"):setString("["..table[5].."]")
                --end
                --item:getChildByName("infoB"):getChildByName("name"):setString(table[6])
                --item:getChildByName("infoB"):getChildByName("level"):setString("")
                self:getChildByName("strinfo"):getChildByName("btmIcon"):setVisible(false)
    			self:getChildByName("strinfo"):getChildByName("info"):setString(table[6].." "..ff.langString("的间谍被抓走了"))
                self:getChildByName("strinfo"):getChildByName("info"):setPositionY(17)
    		else
                --item:getChildByName("typeA"):setVisible(false)--getChildByName("type"):setString(ff.langString("被侦查方"))
                --item:getChildByName("typeB"):setVisible(false)
    			--item:getChildByName("heroA"):getChildByName("iswin"):setVisible(false)
    			--item:getChildByName("heroB"):getChildByName("iswin"):setVisible(false)
                --self:getChildByName("string"):getChildByName("btmIcon"):setVisible(false)
                self:getChildByName("strinfo"):getChildByName("btmIcon"):setVisible(false)
    			self:getChildByName("strinfo"):getChildByName("info"):setString(ff.langString("目标已经转移"))
                self:getChildByName("strinfo"):getChildByName("info"):setPositionY(17)
    		end

    	end
    	--self:getChildByName("scrollview"):pushBackCustomItem(item)
    	--local image = self:getChildByName("Image"):clone()
    	--image:setVisible(true)
    	--self:getChildByName("scrollview"):pushBackCustomItem(image)
    	--self:getChildByName("scrollview"):scrollToBottom(0.5,true)
    	--self:getChildByName("scrollview"):setItemsMargin(5)
    elseif tonumber(table[1]) == 2 and tonumber(table[2]) == 1 then
        self:getChildByName("strinfo"):setVisible(true)
        --self:getChildByName("scrollview"):removeAllChildren(true)
        title:getChildByName("title"):setString(ff.langString("你的城市被侦查了"))
        local dateStr = ff.showData(time)
        title:getChildByName("info"):getChildByName("time"):setString(dateStr)
        --local item = self:getChildByName("wininfo"):clone()
        --item:getChildByName("center"):getChildByName("type"):setString(ff.langString("侦查"))
        --item:setVisible(true)
        --item:getChildByName("typeA"):setVisible(false)--getChildByName("type"):setString(ff.langString("被侦查方"))
        --item:getChildByName("typeB"):setVisible(false)
        --item:getChildByName("heroB"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(tonumber(table[7])),0)
        --item:getChildByName("heroA"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(tonumber(table[13])),0)
        --item:getChildByName("heroA"):getChildByName("iswin"):setVisible(false)
        --item:getChildByName("heroB"):getChildByName("iswin"):setVisible(false)
        self:getChildByName("strinfo"):getChildByName("btmIcon"):setVisible(true)
        self:getChildByName("strinfo"):getChildByName("btmIcon"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(tonumber(table[7])),0)
        self:getChildByName("strinfo"):getChildByName("info"):setString(ff.langString("你被{0}侦察了",{table[6]}))
        self:getChildByName("strinfo"):getChildByName("info"):setPositionY(17)
        --self:getChildByName("scrollview"):pushBackCustomItem(item)
        --local image = self:getChildByName("Image"):clone()
        --image:setVisible(true)
        --self:getChildByName("scrollview"):pushBackCustomItem(image)
        --self:getChildByName("scrollview"):scrollToBottom(0.5,true)
        --self:getChildByName("scrollview"):setItemsMargin(5)
    else
        self._needNet = true
    	title:getChildByName("red"):setVisible(false)
        title:getChildByName("lv"):setVisible(true)
    end
end

function scoutRepLayer.deletereport( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then   
        local widget = pop.getDialog("scoutRep")
        if widget == nil then
            return
        end

        local message = ff.net:createMessage()
        message:addCmd(0x00000136)
        message:addLong(dd.uid)
            
        message:addLong(1)
        message:addLong(1)
        message:addLong(1) 
        message:addSuperLong(widget._id)

        ff.net:rpc(message,false)
        pop.onClosePopDialog("scoutRep")
    end
end


function scoutRepLayer:AutoSize(  )
	-- body
	local hh = ff.height
	self:setContentSize(cc.size(720,hh))
	self:setPositionY(0)
	self:getChildByName("back"):setContentSize(cc.size(720,hh))
	self:getChildByName("top"):setPositionY(hh - 105)
    self:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
    --self:getChildByName("top"):getChildByName("chu_title"):setString(ff.langString("侦查"))
    --self:getChildByName("top"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
    self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    self:getChildByName("title"):getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/battle/type/scoutrep.png",0)
    self:getChildByName("title"):getChildByName("clear"):addTouchEventListener(self.deletereport)
    self:getChildByName("title"):setPositionY(hh - 105 - 320)
    self:getChildByName("strinfo"):setPositionY(hh - 105 - 320 - 150)
    self:getChildByName("back"):setPositionY(0)
    self:getChildByName("scrollview"):setContentSize(cc.size(720,hh-115 - 320))
    self:getChildByName("scrollview"):setPositionY(0)
end

function scoutRepLayer.onBefore(sender)
	-- body
    ff.net:registerEvent(2,dd.Tjf_Get_Scout_Report, function (message)sender:onGetScoutInfo(message)end)
end

function scoutRepLayer.onEnd( sender )
	-- body
	if sender._info.aryminfo ~= nil then
		sender._info.aryminfo:delRows()
	end
	if sender._info.cityinfo ~= nil then
		sender._info.cityinfo:delRows()
	end
	if sender._info.buildinfo ~= nil then
		sender._info.buildinfo:delRows()
	end
	if sender._info.tecinfo ~= nil then
		sender._info.tecinfo:delRows()
	end
	if sender._info.resinfo ~= nil then
		sender._info.resinfo:delRows()
	end
	if sender._info.iteminfo ~= nil then
		sender._info.iteminfo:delRows()
	end
	ff.net:removeEvent(2,dd.Tjf_Get_Scout_Report)
    dd.delBackEvent()
    sender:getChildByName("scrollview"):removeAllChildren(true)
    ff.net:unbindProperty("gold",2315)
end

function scoutRepLayer.onStart( sender )
    -- body
    if sender._needNet == true then
        local getRepMsg = ff.net:createMessage()
        getRepMsg:addCmd(0x00000029)
        getRepMsg:addLong(dd.uid)
        getRepMsg:addSuperLong(sender._id)
        
        ff.net:rpc(getRepMsg,false)
    end
    ff.net:bindProperty(2315,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
end

function scoutRepLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("scoutRep")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end

function scoutRepLayer:showInfo(  )
	-- body
    local title = self:getChildByName("title")
    title:getChildByName("title"):setString(ff.langString("侦查成功"))
    local dateStr = ff.showData(self._info.time)
    title:getChildByName("info"):getChildByName("time"):setString(dateStr)
    title:getChildByName("red"):setVisible(false)
    title:getChildByName("lv"):setVisible(true)

    local biaoti = self:getChildByName("biaoti"):clone()
    biaoti:setVisible(true)
    self:getChildByName("scrollview"):pushBackCustomItem(biaoti)

        local mapsiteB=dd.MapidToXY(self._info.B_pos)
        title:getChildByName("info"):getChildByName("pos"):setString(ff.langString("侦查地点").." ("..mapsiteB.x..","..mapsiteB.y..")")
 
    if self._info.hero_level == 0 then
    	local hero = self:getChildByName("hero"):clone()
        hero:setVisible(true)
        hero:getChildByName("hero"):setVisible(false)
        hero:getChildByName("nohero"):setVisible(true)
        self:getChildByName("scrollview"):pushBackCustomItem(hero)
    else
        local hero = self:getChildByName("hero"):clone()
        hero:setVisible(true)


    	hero:getChildByName("name"):setString(ff.langString(dd.cfgHero[self._info.hero_id]['name']))
        if self._info.hero_office ~= nil and self._info.hero_office > 0 then
    	   hero:getChildByName("title"):setString(ff.langString(dd.official[self._info.hero_office]))
 
        end
        hero:getChildByName("level"):setString("LV."..self._info.hero_level)
    	hero:getChildByName("hero"):getChildByName("ico"):loadTexture(dd.getHeroIcon(self._info.hero_id),0)
    	self:getChildByName("scrollview"):pushBackCustomItem(hero)
    end

    local index = 0
    local armyCnt = 0
    if self._info.aryminfo ~= nil then
    	armyCnt = self._info.aryminfo:rowCount()
    end
    local cityCnt = 0
    if self._info.cityinfo ~= nil then
    	cityCnt = self._info.cityinfo:rowCount()
    end

    local count = math.floor((armyCnt+cityCnt)/2) + ((((armyCnt+cityCnt)%2)>0) and 1 or 0)

    if count > 0 then
        local armyT = self:getChildByName("armys"):clone()
        armyT:setVisible(true)
        self:getChildByName("scrollview"):pushBackCustomItem(armyT)

        local armys = self:getChildByName("panle"):clone()
        armys:setVisible(true)
    	armys:setContentSize(cc.size(700,count*96))

    	local pos = 3
    	local arm = nil
    	for i=1,armyCnt do
      
    		if pos == 3 then
    			arm = self:getChildByName("armysinfo"):clone()
    			arm:setVisible(true)
    			armys:addChild(arm)
              
    			 arm:setPosition(cc.p(0,(count - (index+1))*96))
          
      
    			pos = 1
    			index = index + 1
    		end
    		local name = "army"..tostring(pos)
          
    		local tab=dd.cfgSoldier[self._info.aryminfo:getLong(i,"id")]
            arm:getChildByName(name):setVisible(true)
    		arm:getChildByName(name):getChildByName("ico"):loadTexture(dd.getArmyIcon(self._info.aryminfo:getLong(i,"id")),0)
    		local start = tab["step"]
    
            local star = ""
    		for j=1,start do
                star = star.."0"
            end
   
    		arm:getChildByName(name):getChildByName("start"):getChildByName("start"):setString(star)
    	
    		if self._info.aryminfo:getLong(i,"count")>0 then
    			arm:getChildByName(name):getChildByName("count"):setString(ff.langString(tab['soldierName']).." : "..dd.showKM(self._info.aryminfo:getLong(i,"count"),3))
    		else
    			arm:getChildByName(name):getChildByName("count"):setString(ff.langString(tab['soldierName']).." : ".."???")
    		end
    		pos = pos + 1
    	end
    	for i=1,cityCnt do
    		if pos == 3 then
    			arm = self:getChildByName("armysinfo"):clone()
    			arm:setVisible(true)
    			armys:addChild(arm)
    			arm:setPosition(cc.p(0,(count - (index+1))*96))
    			pos = 1
    			index = index + 1
    		end
    		local name = "army"..tostring(pos)
    		local tab=dd.cfgSoldier[self._info.cityinfo:getLong(i,"id")]
    		arm:getChildByName(name):getChildByName("ico"):loadTexture(dd.getArmyIcon(self._info.cityinfo:getLong(i,"id")),0)
    		local start = tab["step"]
    		local star = ""
            for j=1,start do
                star = star.."0"
            end

            arm:getChildByName(name):getChildByName("start"):getChildByName("start"):setString(star)
    		if self._info.aryminfo:getLong(i,"count")>0 then
    			arm:getChildByName(name):getChildByName("count"):setString(ff.langString(tab['soldierName']).." : "..dd.showKM(self._info.cityinfo:getLong(i,"count"),3))
    		else
    			arm:getChildByName(name):getChildByName("count"):setString(ff.langString(tab['soldierName']).." : ".."???")
    		end
    		pos = pos + 1
    		
    	end
    self:getChildByName("scrollview"):pushBackCustomItem(armys)
    end

    if self._info.resinfo ~= nil then
        local res1 = self:getChildByName("res1"):clone()
        res1:setVisible(true)

        local level = dd.myinfo:getLong(1,"level")
        if level <= 10 then
            res1:getChildByName("res1"):setPositionX(999)
            res1:getChildByName("res3"):setPositionX(999)
            res1:getChildByName("res5"):setPositionX(354)
        elseif level> 10 and level<= 14 then
            res1:getChildByName("res1"):setPositionX(354)
            res1:getChildByName("res3"):setPositionX(999)
            res1:getChildByName("res5"):setPositionX(495)
        else
            res1:getChildByName("res1"):setPositionX(354)
            res1:getChildByName("res3"):setPositionX(495)
            res1:getChildByName("res5"):setPositionX(636)
        end
       
        if self._info.resinfo ~= nil then
            for i=1,self._info.resinfo:rowCount() do
                local id = self._info.resinfo:getLong(i,"id")
                local name = "res"..tostring(id)
                
                res1:getChildByName(name):getChildByName("count"):setString(dd.showKM(self._info.resinfo:getLong(i,"count"),5))
            end
        end
        self:getChildByName("scrollview"):pushBackCustomItem(res1)
   	end
    if self._info.iteminfo ~= nil then
        local res2 = self:getChildByName("res2"):clone()
        res2:setVisible(true)
        local index = 1
        if self._info.iteminfo ~= nil then
            for i=1,self._info.iteminfo:rowCount() do
                local id = self._info.iteminfo:getLong(i,"id")
                local name = "res"..index
                index = index + 1
                res2:getChildByName("res1"):getChildByName(name):loadTexture(dd.getToolsIcon(id),0)
                
                res2:getChildByName("res1"):getChildByName(name):getChildByName("count"):setString(dd.showKM(self._info.iteminfo:getLong(i,"count"),5))
            end
        end
        for i=index,5 do
            res2:getChildByName("res1"):getChildByName("res"..i):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            res2:getChildByName("res1"):getChildByName("res"..i):getChildByName("count"):setString("")
        end
        self:getChildByName("scrollview"):pushBackCustomItem(res2)
    end

	local buildsCnt = 0
	if self._info.buildinfo ~= nil then
        buildsCnt = self._info.buildinfo:rowCount()
        if buildsCnt > 0 then
    		local builds = self:getChildByName("bulids"):clone()
            builds:setVisible(true)
            self:getChildByName("scrollview"):pushBackCustomItem(builds)
            local other = self:getChildByName("panle"):clone()
            other:setVisible(true)
            other:setContentSize(cc.size(700,buildsCnt*50))
            for i=1,buildsCnt do
                local item = self:getChildByName("item"):clone()
                item:setVisible(true)
                item:getChildByName("name"):setString(ff.langString(dd.cfgBuilding[self._info.buildinfo:getLong(i,"id")]['name']))
                item:getChildByName("level"):setString("LV."..self._info.buildinfo:getLong(i,"count"))
                other:addChild(item)
                item:setPositionY((i-1)*50)
                item:setPositionX(0)
                if (i % 2) == 0 then
                    item:getChildByName("Image_237"):loadTexture(dd.getPathFromUI("public/v2/title4.png",1))
                end
            end
            self:getChildByName("scrollview"):pushBackCustomItem(other)
        end
	end
	local texCnt = 0
	if self._info.tecinfo ~= nil then
		texCnt = self._info.tecinfo:rowCount()
        if texCnt > 0 then
            local tec = self:getChildByName("tec"):clone()
            tec:setVisible(true)
            self:getChildByName("scrollview"):pushBackCustomItem(tec)
            local other = self:getChildByName("panle"):clone()
            other:setVisible(true)
            other:setContentSize(cc.size(700,texCnt*50))
            for i=1,texCnt do
                local item = self:getChildByName("item"):clone()
                item:setVisible(true)
                item:getChildByName("name"):setString(ff.langString(dd.cfgTec[self._info.tecinfo:getLong(i,"id")]['tec_name']))
                item:getChildByName("level"):setString("LV."..self._info.tecinfo:getLong(i,"count"))
                other:addChild(item)
                item:setPositionY((i-1)*50)
                item:setPositionX(0)
                if (i % 2) == 0 then
                    item:getChildByName("Image_237"):loadTexture(dd.getPathFromUI("public/v2/title4.png",1))
                end
            end
             self:getChildByName("scrollview"):pushBackCustomItem(other)
         end
	end

    self:getChildByName("scrollview"):scrollToTop(0.1,true)
    --self:getChildByName("scrollview"):setItemsMargin(5)
end

function scoutRepLayer:onGetScoutInfo( params )
	-- body
    
	local code = params[1]
    if code == 0 then
        self._info = params[2]
        --self:getChildByName("scrollview"):removeAllChildren(true)
        self:showInfo()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end