PropShopLayer = class("PropShopLayer")
PropShopLayer._name = "propShop"
PropShopLayer._init = false
PropShopLayer._index= 1
PropShopLayer._itemIndex = 1

PropShopLayer.curNum   = 0
PropShopLayer.price    = 0
PropShopLayer.__update = {}
--缓冲
PropShopLayer._items = {}
PropShopLayer.propData = {}
PropShopLayer.userDatas = {}
PropShopLayer._animFrames = {}
PropShopLayer.propList = {{},{},{},{},{}}

PropShopLayer._view = nil
PropShopLayer._data = nil
PropShopLayer._isplaying = false
--
PropShopLayer.pos = 0

function PropShopLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, PropShopLayer)
    return target
end

function PropShopLayer:setCheckBox(sender)
    local bts = self:getChildByName("panel_props"):getChildByName("panel_top")
    bts:getChildByName("btn_navi1"):getChildByName("chu_label"):setColor(cc.c3b(99,124,130))
    bts:getChildByName("btn_navi1"):setSelectedState(false)
    bts:getChildByName("btn_navi2"):getChildByName("chu_label"):setColor(cc.c3b(99,124,130))
    bts:getChildByName("btn_navi2"):setSelectedState(false)
    bts:getChildByName("btn_navi3"):getChildByName("chu_label"):setColor(cc.c3b(99,124,130))
    bts:getChildByName("btn_navi3"):setSelectedState(false)
    bts:getChildByName("btn_navi4"):getChildByName("chu_label"):setColor(cc.c3b(99,124,130))
    bts:getChildByName("btn_navi4"):setSelectedState(false)
    bts:getChildByName("btn_navi5"):getChildByName("chu_label"):setColor(cc.c3b(99,124,130))
    bts:getChildByName("btn_navi5"):setSelectedState(false)
    local lab = sender:getChildByName("chu_label")
    lab:setColor(cc.c3b(233, 239, 244))
end

function PropShopLayer:initPropList()
    self.propList = {{},{},{},{},{}}
    for pId,tool in pairs(dd.cfgProp) do
        local pBag = dd.cfgProp[pId]['bag'] 
        if self._index == 1 then
            if dd.cfgProp[pId]['shop'] == 1 then
                if pBag == 1 then
                    self.propList[1][table.getn(self.propList[1]) + 1] = pId
                elseif pBag == 2 then
                    self.propList[2][table.getn(self.propList[2]) + 1] = pId
                elseif pBag == 3 then
                    self.propList[3][table.getn(self.propList[3]) + 1] = pId
                elseif pBag == 4 then
                    self.propList[4][table.getn(self.propList[4]) + 1] = pId
                elseif pBag == 5 then
                    self.propList[5][table.getn(self.propList[5]) + 1] = pId
                end
            end
        else
            if pBag == 1 and self.propData[pId]['num'] > 0 then
                self.propList[1][table.getn(self.propList[1]) + 1] = pId
            elseif pBag == 2 and self.propData[pId]['num'] > 0 then
                self.propList[2][table.getn(self.propList[2]) + 1] = pId
            elseif pBag == 3 and self.propData[pId]['num'] > 0 then
                self.propList[3][table.getn(self.propList[3]) + 1] = pId
            elseif pBag == 4 and self.propData[pId]['num'] > 0 then
                self.propList[4][table.getn(self.propList[4]) + 1] = pId
            elseif pBag == 5 and self.propData[pId]['num'] > 0 then
                self.propList[5][table.getn(self.propList[5]) + 1] = pId
            end
        end
    end
    function comps(index1, index2)
       return self.propData[index1].showorder <  self.propData[index2].showorder
    end
    for i=1,5 do
        table.sort(self.propList[i],comps)
        --cclog("==============["..i.."] count :"..table.getn(self.propList[i]))
    end

    self:updateCount()
    self._data:delRows()
    local data = self.propList[self._itemIndex]

    for i=1,table.getn(data) do
        --cclog("level: "..dd.myinfo:getLong(1,"level").."=====prop level: "..self.propData[data[i]]['showlevel'])
        if dd.myinfo:getLong(1,"level") < self.propData[data[i]]['showlevel'] then
        else
            local row = self._data:addRow()
            self._data:setLong(row,"cost",self.propData[data[i]]['cost'])
            self._data:setLong(row,"image",self.propData[data[i]]['image'])
            self._data:setString(row,"name",self.propData[data[i]]['name'])
            self._data:setString(row,"tips",self.propData[data[i]]['tips'])
            self._data:setLong(row,"type",self.propData[data[i]]['type'])
            self._data:setLong(row,"inbag",self.propData[data[i]]['inbag'])
            self._data:setLong(row,"showorder",self.propData[data[i]]['showorder'])
            self._data:setLong(row,"showlevel",self.propData[data[i]]['showlevel'])
            self._data:setLong(row,"num",self.propData[data[i]]['num'])
            self._data:setLong(row,"pid",self.propData[data[i]]['pid'])
        end
    end
    self._view:reloadData()    
end
function PropShopLayer:loadPropData()
    self.propData = {}
    local count = 0
    for pId,tool in pairs(dd.cfgProp) do
        self.propData[pId] = {}
        self.propData[pId]['cost']  = dd.cfgProp[pId]['value']                   --价格
        self.propData[pId]['image'] = dd.cfgProp[pId]['image']                   --显示图片
        self.propData[pId]['name']  = ff.langString(dd.cfgProp[pId]['name'],{dd.cfgProp[pId]['name1_lan']})     --道具名称
        self.propData[pId]['tips']  = ff.langString(dd.cfgProp[pId]['tips'],{dd.cfgProp[pId]['tips1_lan']})     --道具说明
        self.propData[pId]['type']  = dd.cfgProp[pId]['type']                    --道具类型
        self.propData[pId]['inbag'] = dd.cfgProp[pId]['inbag']                   --是否在背包里使用
        self.propData[pId]['showorder'] = dd.cfgProp[pId]['showorder']
        self.propData[pId]['showlevel'] = dd.cfgProp[pId]['showlevel']           --道具开放等级
        self.propData[pId]['num'] = 0
        self.propData[pId]['pid'] = pId
    end    
    if self._data == nil then
        self._data = ff.NetTable:create()
        self._data:addStreamCol("cost",ff.NET_LONG)
        self._data:addStreamCol("image",ff.NET_LONG)
        self._data:addStreamCol("name",ff.NET_STRING,64)
        self._data:addStreamCol("tips",ff.NET_STRING,256)
        self._data:addStreamCol("type",ff.NET_LONG)
        self._data:addStreamCol("inbag",ff.NET_LONG)
        self._data:addStreamCol("showorder",ff.NET_LONG)
        self._data:addStreamCol("showlevel",ff.NET_LONG)
        self._data:addStreamCol("num",ff.NET_LONG)
        self._data:addStreamCol("pid",ff.NET_LONG)
    end
end

function PropShopLayer:requestBuyMessage(pid, num)
    local message = ff.net:createMessage()
    message:addCmd(0x121)
    message:addLong(dd.uid)
    message:addLong(pid)
    message:addLong(num)
    ff.net:rpc(message,false)
    local popview = self:getChildByName("panel_props"):getChildByName("panel_buyItem")
    popview:setVisible(false)
    AudioEngine.playEffect(ff.sounds[212])
end

function PropShopLayer:requestUseMessage(pid, num)
    local message = ff.net:createMessage()
    message:addCmd(0x10a)
    message:addLong(dd.uid)
    message:addLong(pid)
    message:addLong(num)
    message:addLong(0)
    message:addLong(0)
    ff.net:rpc(message,false)
    local popview = self:getChildByName("panel_props"):getChildByName("panel_buyItem")
    popview:setVisible(false)
end

function PropShopLayer:responPropBuy(message)
    local result = message[1]
    if result == 0 then
        --dd.currentLayer._widget:onShowTips("\t"..ff.langString("道具购买成功 ！"),true)
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功购买{0}个{1}道具 ！",{self.curNum,self.propData[message[2]]["name"]}),true)
        self.pos.y = self.pos.y + 225
        local count = self.curNum * self.price
        dd.mainUI:showGiftNotice(7,0,count,self.pos,2)
        self:updateCount()
        self:reloadData()
    else
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("道具购买失败 ！"))
    end
end

function PropShopLayer:convertToWorldCoordinate(node)
    local anr   = node:getAnchorPoint()
    local size  = node:getContentSize()
    local p = node:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
    return p
end

function PropShopLayer:responPropUse(message)
    local result = message[1]
    if result == 0 then
        self:loadPropData()
        self:updateCount()
        self:initPropList()
        self:reloadData()
    else
        dd.mainUI:onShowCodeTips(result)
    end
end

function PropShopLayer:showBuyView(cType, propData)
    local popview = self:getChildByName("panel_props"):getChildByName("panel_buyItem")
    popview:setVisible(true)
    popview:setPositionY(-popview:getContentSize().height)
    popview:stopAllActions()
    local function checkGuide()
        if cType == 1 then
            GuideControl:GuideCheck()
        end

    end
    popview:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,0))),cc.CallFunc:create(checkGuide)))
    local imgBg = popview:getChildByName("img_icon_bg")
    local lab_itemNum = popview:getChildByName("lab_num")
    local img_icon = imgBg:getChildByName("img_icon")

    local lab_itemName = popview:getChildByName("infos"):getChildByName("lab_itemName")
    local lab_itemInfo = popview:getChildByName("infos"):getChildByName("lab_itemInfo")
    lab_itemName:setString(ff.langString(propData.name))
    lab_itemInfo:setString(ff.langString(propData.tips))
    lab_itemNum:setString(propData.num)--b
    img_icon:loadTexture(dd.getToolsIcon(propData.pid),0)

    local slider = popview:getChildByName("panel_slider"):getChildByName("slider")
    local lab_current = popview:getChildByName("panel_slider"):getChildByName("lab_current")
    slider:setPercent(0)

    local btn_sub = popview:getChildByName("btn_sub")
    local btn_add = popview:getChildByName("btn_add")
    local btn_commit = popview:getChildByName("btn_commit")
    local lab_comBuy = btn_commit:getChildByName("lab_buy")
    local lab_cost = btn_commit:getChildByName("lab_cost")
    local img_coin = btn_commit:getChildByName("Image_77")

    local panel_input = popview:getChildByName("panel_input")
    local tf_input = panel_input:getChildByName("lab_input")

    self.curNum = 1    --当前操作道具数量
    local userCoin = 0  --玩家当前货币值
    --local price = 0     --单价
    local maxNum = dd.getToolsCount(propData.pid)
    if cType == 1 then
        if maxNum > 99 then
            popview:getChildByName("lab_max"):setString("99")
        else
            popview:getChildByName("lab_max"):setString(maxNum)
        end
    else
        popview:getChildByName("lab_max"):setString("99")
    end


    local function setCommitButtonWithPrice()
        if self.curNum < 1 then
            self.curNum = 1
        end
        local curCost = math.floor(self.curNum) * self.price
        --cclog("==curCost: "..curCost.."====userCoin: "..userCoin)
        if curCost > userCoin then
            lab_cost:setColor(cc.c3b(255,0,0))
        else
            lab_cost:setColor(cc.c3b(255,255,255))
        end
        lab_cost:setString(math.floor(curCost))
        slider:setPercent((self.curNum / maxNum)*100)

        local bgWidth = btn_commit:getContentSize().width
        tf_input:setString(math.floor(self.curNum))
        --
        lab_current:setString(math.floor(self.curNum))

        -- cclog("lab_cost ===================="..lab_cost:getContentSize().width)
    end
    
    local function buttonClick(sender, touchType)
        if touchType == ccui.TouchEventType.ended then
            if sender == btn_sub then
                self.curNum = self.curNum - 1
                if self.curNum < 1 then
                    self.curNum = 1
                end
                setCommitButtonWithPrice()
            elseif sender == btn_add then
                self.curNum = self.curNum + 1
                if self.curNum > maxNum then
                    self.curNum = maxNum
                end
                setCommitButtonWithPrice()
            elseif sender == btn_commit then
                self.curNum = math.floor(self.curNum)
                setCommitButtonWithPrice()
                if cType == 1 then
                    self:requestUseMessage(propData.pid, self.curNum)
                else
                    self:requestBuyMessage(propData.pid, self.curNum)
                end
            end
        end
    end
    btn_add:addTouchEventListener(buttonClick)
    btn_sub:addTouchEventListener(buttonClick)
    btn_commit:addTouchEventListener(buttonClick)

    local function percentChangedEvent(sender,eventType)
        if eventType == ccui.SliderEventType.percentChanged then
            local percent = slider:getPercent()
            if maxNum > 99 then 
                maxNum = 99
            end
            self.curNum = (percent/100) * maxNum
            setCommitButtonWithPrice()
        end
    end  
    slider:addEventListener(percentChangedEvent)

    if cType == 1 then
        self.price = propData.cost
        userCoin = propData.num--dd.myUnion:getLong(1, "unionpoint")
        lab_comBuy:setString(ff.langString("使用"))
        popview:getChildByName("lab_viewInfo"):setString(ff.langString("道具使用"))
        maxNum = propData.num
        -- img_coin:loadTexture(dd.getPathFromUI("public/ic13.png", 1))
        lab_comBuy:setPositionY(50)
        lab_cost:setVisible(false)
        img_coin:setVisible(false)
    else
        self.price = propData.cost
        userCoin = dd.myinfo:getLong(1, "gold") --dd.myUnion:getLong(1, "nAllyFunds")
        lab_comBuy:setString(ff.langString("购买"))
        popview:getChildByName("lab_viewInfo"):setString(ff.langString("道具购买"))
        maxNum = 99
        -- img_coin:loadTexture(dd.getPathFromUI("public/ic14.png", 1))
        lab_comBuy:setPositionY(35)
        lab_cost:setVisible(true)
        img_coin:setVisible(true)
    end
    setCommitButtonWithPrice()

    --init editbox
    if panel_input:getChildByTag(10091) == nil then
        local editBox = dd.addEditBox(
             panel_input
            , panel_input:getContentSize()
            , "images/ui/alpha.png"
            , 10091
            , cc.p(0,0)
            , cc.p(popview:getChildByName("panel_input"):getChildByName("lab_input"):getPositionX()-32,0)
            , cc.c3b(255,255,255)
            , 20
            , 2
            , 4
            , 1
            , 5
            , true
            , true
            , true
        )
        local function editBoxTextEventHandle(strEventName,pSender)
            local edit = pSender
            local strFmt 
            if strEventName == "began" then
                tf_input:setVisible(false)
            elseif strEventName == "ended" or strEventName == "return" then
                local text = tonumber(edit:getText())
                if text == nil or text == "" then
                    tf_input:setVisible(true)
                    return
                end
                local input_count = text 
                if input_count > 99 then
                    input_count = 99
                end
                if input_count <= 0 then
                    input_count = 1
                end
                tf_input:setString(input_count)
                self.curNum = input_count
                setCommitButtonWithPrice()
                cclog("input_count:"..input_count..","..self.curNum)

                edit:setText("")
            --elseif strEventName == "changed" then
            --    tf_input:setVisible(true)
            end
        end
        editBox:registerScriptEditBoxHandler(editBoxTextEventHandle)
        slider:setCorrect(35,316)
    end
end

function PropShopLayer:darwItem(view,idx)    
    local data = self._data
    if data == nil then
        return nil
    end
    if data:rowCount() < idx + 1 then
        return nil
    end    
    local row = idx + 1
    local cell = view:dequeueCell()
    local item = nil
    if nil == cell then
        cell = cc.TableViewCell:new()
        item = self:getChildByName("panel_props"):getChildByName("panel_item"):clone()
        item:setTag(1)
        item:getChildByName("btn_use3"):getChildByName("chu_label"):setString(ff.langString("合成"))
        item:setPosition(cc.p(15,0))
        item:setTouchEnabled(true,false)
        cell:addChild(item)
    else
        item=cell:getChildByTag(1)
        item:setVisible(true)
        if item:getChildByName("img_icon_bg"):getTag() == data:getLong(row,"pid") then
            item:getChildByName("lab_num"):setString(data:getLong(row,"num"))  
            if self._index == 1 then
                item:getChildByName("btn_buy"):setVisible(true)
                item:getChildByName("btn_use"):setVisible(true)
                item:getChildByName("btn_use2"):setVisible(false)
                item:getChildByName("btn_use3"):setVisible(false)
            else
                item:getChildByName("btn_buy"):setVisible(false)
                item:getChildByName("btn_use"):setVisible(false)
                item:getChildByName("btn_use2"):setVisible(true)
                item:getChildByName("btn_use3"):setVisible(false)
            end
            if data:getLong(row,"num") < 1 or data:getLong(row,"inbag") == 0 then
                item:getChildByName("btn_use"):setVisible(false)
                item:getChildByName("btn_use2"):setVisible(false)
                item:getChildByName("btn_use3"):setVisible(false)
            else
                if self._index == 2 then
                    if data:getLong(row,"inbag") == 2 then
                        item:getChildByName("btn_use3"):setVisible(true)
                        item:getChildByName("btn_use2"):setVisible(false)
                    else
                        item:getChildByName("btn_use2"):setVisible(true)
                        item:getChildByName("btn_use3"):setVisible(false)
                    end
                else
                    if data:getLong(row,"inbag") ~= 2 then
                        item:getChildByName("btn_use"):setVisible(true)
                    else
                        item:getChildByName("btn_use"):setVisible(false)
                    end
                end
            end            
            return cell
        end
    end
    item:setVisible(true)

    item:getChildByName("img_icon_bg"):setTag(data:getLong(row,"pid"))
    item:getChildByName("btn_buy"):setTag(data:getLong(row,"pid"))
    item:getChildByName("btn_use"):setTag(data:getLong(row,"pid"))
    item:getChildByName("btn_use2"):setTag(data:getLong(row,"pid"))
    item:getChildByName("btn_use3"):setTag(data:getLong(row,"pid"))

    item:getChildByName("lab_name"):setString(data:getString(row,"name"))
    item:getChildByName("lab_info"):setString(data:getString(row,"tips"))
    item:getChildByName("img_icon_bg"):getChildByName("img_icon"):loadTexture(dd.getToolsIcon(data:getLong(row,"pid")),0)
    item:getChildByName("lab_num"):setString(data:getLong(row,"num"))    
    item:getChildByName("btn_buy"):getChildByName("lab_userpower"):setString(data:getLong(row,"cost"))       
    if self._index == 1 then
        item:getChildByName("btn_buy"):setVisible(true)
        item:getChildByName("btn_use"):setVisible(true)
        item:getChildByName("btn_use2"):setVisible(false)
        item:getChildByName("btn_use3"):setVisible(false)
    else
        item:getChildByName("btn_buy"):setVisible(false)
        item:getChildByName("btn_use"):setVisible(false)
        item:getChildByName("btn_use2"):setVisible(true)
        item:getChildByName("btn_use3"):setVisible(false)
    end
    if data:getLong(row,"num") < 1 or data:getLong(row,"inbag") == 0 then
        item:getChildByName("btn_use"):setVisible(false)
        item:getChildByName("btn_use2"):setVisible(false)
    else
        if self._index == 2 then
            if data:getLong(row,"inbag") == 2 then
                item:getChildByName("btn_use3"):setVisible(true)
                item:getChildByName("btn_use2"):setVisible(false)
            else
                item:getChildByName("btn_use3"):setVisible(false)
                item:getChildByName("btn_use2"):setVisible(true)
            end
        else
            if data:getLong(row,"inbag") ~= 2 then
                item:getChildByName("btn_use"):setVisible(true)
            else
                item:getChildByName("btn_use"):setVisible(false)
            end
        end
    end           
    return cell
end

function PropShopLayer:UseHammer( ToolId )
    if self._isplaying == true then
        return
    end
    if ToolId >= 1201 and ToolId <= 1203 then
        if dd.getToolsCount(1209) < 1 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有彩蛋"))
        else
            local function spineCallBack(event)
                local button = dd.mainUI:getChildByName("effect"):getChildByTag(100001)
                if button ~= nil and button.ToolId ~= nil and button.ToolId ~= 0 then
                    local message = ff.net:createMessage()
                    message:addCmd(0x0000014a)
                    message:addLong(dd.uid)
                    message:addLong(dd.cfgProp[button.ToolId]['drop'])
                    ff.net:rpc(message,false)
                    button.ToolId = 0
                end
                
            end
            local button = dd.mainUI:getChildByName("effect"):getChildByTag(100001)
            if button == nil then
                button = sp.SkeletonAnimation:create("images/active/zadan.json", "images/active/zadan.atlas")
                button:setAnchorPoint(cc.p(0.5,0.5))           
                dd.mainUI:getChildByName("effect"):addChild(button,2,100001)
                button:setPosition(cc.p(button:getContentSize().width - 110 ,button:getContentSize().height + 120 ))
                button:registerSpineEventHandler(spineCallBack,2)
            end
            if button ~= nil then
                button.ToolId = ToolId
                AudioEngine.playEffect(ff.sounds["zadan2"])
                if ToolId == 1201 then
                    button:setToSetupPose()
                    button:setAnimation(0,"jinchuizi_play",false)
                elseif ToolId == 1202 then
                    button:setToSetupPose()
                    button:setAnimation(0,"tiechuizi_play",false)
                else
                    button:setToSetupPose()
                    button:setAnimation(0,"muchuizi_play",false)
                end
                self._isplaying = true
            end
        end
    else
        if dd.getToolsCount(1294) < 1 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("缺少感恩的信"))
        else
            -- local function spineCallBack(event)
            --     local button = dd.mainUI:getChildByName("effect"):getChildByTag(100001)
            --     if button ~= nil and button.ToolId ~= nil and button.ToolId ~= 0 then
                    local message = ff.net:createMessage()
                    message:addCmd(0x0000014a)
                    message:addLong(dd.uid)
                    message:addLong(dd.cfgProp[ToolId]['drop'])
                    --message:addLong(dd.cfgProp[button.ToolId]['drop'])
                    ff.net:rpc(message,false)
                    --button.ToolId = 0
           --      end
                
           -- end
           --  local button = dd.mainUI:getChildByName("effect"):getChildByTag(100001)
           --  if button == nil then
           --      button = sp.SkeletonAnimation:create("images/active/youpiao.json", "images/active/youpiao.atlas")
           --      button:setAnchorPoint(cc.p(0.5,0.5))           
           --      dd.mainUI:getChildByName("effect"):addChild(button,2,100001)
           --      button:setPosition(cc.p(button:getContentSize().width + 50 ,button:getContentSize().height + 320 ))
           --      button:registerSpineEventHandler(spineCallBack,2)
           --  end
           --  if button ~= nil then
           --      button.ToolId = ToolId
           --      AudioEngine.playEffect(ff.sounds["zadan2"])
           --      if ToolId == 1217 then
           --          button:setToSetupPose()
           --          button:setAnimation(0,"jingmeiyoupiao",false)
           --      elseif ToolId == 1218 then
           --          button:setToSetupPose()
           --          button:setAnimation(0,"zhanxinyoupiao",false)
           --      else
           --          button:setToSetupPose()
           --          button:setAnimation(0,"pojiuyoupiao",false)
           --      end
           --      self._isplaying = true
           --  end
        end
    end
end

function PropShopLayer:initItems()

    local itemModel = self:getChildByName("panel_props"):getChildByName("panel_item")

    local btn_buy = itemModel:getChildByName("btn_buy")
    local btn_use = itemModel:getChildByName("btn_use")
    local btn_use2 = itemModel:getChildByName("btn_use2")
    local btn_use3 = itemModel:getChildByName("btn_use3")

    local function buttonClick(sender, touchType)
        local doaction = false
        if touchType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end

        if touchType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then
            local tool = self.propData[sender:getTag()]
            if sender:getName() == "btn_use" or sender:getName() == "btn_use2" then
                if tool.inbag == 3 then
                    --cclog("12341231243123132")
                    self:UseHammer(tool.pid)
                else
                    self:showBuyView(1, tool)
                end
                
            elseif sender:getName() == "btn_buy" then
                if tool.cost > dd.myinfo:getLong(1, "gold") then
                    local function sure()
                        pop.onShowPopDialog("charge")
                    end
                    dd.mainUI:onShowSure(ff.langString("金币不足"),ff.langString("充值可以让你立即拥有大量金币.\n是否现在就去?"),sure,true,2,2,ff.langString("充值"))
                    return
                end
                self.pos = self:convertToNodeSpace(self:convertToWorldCoordinate(sender))
                self:showBuyView(2, tool)
            elseif sender:getName() == "btn_use3" then

                local  tid = sender:getTag()
                print(tid,"=========================")
                if tid >= 1110 and tid <= 1120 then
                    pop.onShowPopDialog("hechengex")
                else
                    pop.onShowPopDialog("hechengJump",tid)
                end
                
                self.pos = self:convertToNodeSpace(self:convertToWorldCoordinate(sender))
                self.onReturn()
               -- dd.mainUI:showHeChengView(PropsynthersisID)
            elseif sender:getName() == "btn_close" then
                self:getChildByName("panel_props"):getChildByName("panel_buyItem"):stopAllActions()
                self:getChildByName("panel_props"):getChildByName("panel_buyItem"):setVisible(false)

            end
        end
    end

    btn_buy:addTouchEventListener(buttonClick)
    btn_use:addTouchEventListener(buttonClick)
    btn_use2:addTouchEventListener(buttonClick)   
    btn_use3:addTouchEventListener(buttonClick)        
    self:getChildByName("panel_props"):getChildByName("panel_buyItem"):getChildByName("btn_close"):addTouchEventListener(buttonClick)


end

function PropShopLayer:initTopBar()
    local panel_top = self:getChildByName("top")
    local panel_topButton = self:getChildByName("btns")

    local btn_back = panel_top:getChildByName("return")
    local btn_shop = self:getChildByName("btns"):getChildByName("shop")
    local btn_bag = self:getChildByName("btns"):getChildByName("bag")
    local function button(sender, touchType)
        if touchType == ccui.TouchEventType.ended then
            if sender == btn_back then
                pop.onClosePopDialog("propShop")
            elseif sender == btn_shop then
                btn_shop:getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
                btn_bag:getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                btn_shop:setSelectedState(false)
                btn_bag:setSelectedState(false)

                --self:setCheckBox()
                if self._index ~= 1 then
                    self._index = 1
                    self:initPropList()
                end
            elseif sender == btn_bag then
                btn_bag:getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
                btn_shop:getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                btn_shop:setSelectedState(false)
                btn_bag:setSelectedState(false)

                --self:setCheckBox()
                if self._index ~= 2 then
                    self._index = 2
                    self:initPropList()
                    --lhz
                    GuideControl:GuideCheck()
                end
            end
        end
    end
    btn_back:addTouchEventListener(button)
    btn_shop:addTouchEventListener(button)
    btn_bag:addTouchEventListener(button)
end

function PropShopLayer:initItemView()
    local panel_itemView = self:getChildByName("panel_props")
    local panel_top = panel_itemView:getChildByName("panel_top")
    panel_itemView:setVisible(true)

    local btn_item1 = panel_top:getChildByName("btn_navi1")
    local btn_item2 = panel_top:getChildByName("btn_navi2")
    local btn_item3 = panel_top:getChildByName("btn_navi3")
    local btn_item4 = panel_top:getChildByName("btn_navi4")
    local btn_item5 = panel_top:getChildByName("btn_navi5")

    self._itemIndex = 1
    local function buttonClick(sender, touchType)
        if touchType == ccui.TouchEventType.ended then
            self:setCheckBox(sender)
            if sender:getSelectedState() ~= true then
                self._itemIndex = sender:getTag()
                self:initPropList()
                --lhz
                GuideControl:GuideCheck()
            else
                self:reloadData()
            end
        end
    end
    btn_item1:addTouchEventListener(buttonClick)
    btn_item2:addTouchEventListener(buttonClick)
    btn_item3:addTouchEventListener(buttonClick)
    btn_item4:addTouchEventListener(buttonClick)
    btn_item5:addTouchEventListener(buttonClick)
end
function PropShopLayer:reloadData()
    if self._data ~= nil then
        if self._data:rowCount() <= 4 then
            self._view:reloadData()
        else
            local offset = self._view:getContentOffset()
            self._view:reloadData()
            self._view:setContentOffset(offset)
        end
    end
end
function PropShopLayer.updateGold(name,row,old,value)
    local sender = pop.getDialog("propShop")
    if sender ~= nil then
        sender:getChildByName("top"):getChildByName("count"):setString(dd.gold())
        local w = sender:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("top"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("top"):requestDoLayout()
    end
end


function PropShopLayer.onReturn(sender,eventType)
    local close = false
    local messageBox = dd.currentLayer._widget:getChildByName("besure")

    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        if messageBox:isVisible() == true then
            messageBox:setVisible(false)
        else
            pop.onClosePopDialog("propShop")
        end
    end
end
function PropShopLayer:updateCount()
    for tid,tool in pairs(self.propData) do
        self.propData[tid]['num'] = 0
    end
    for i=1,dd.mytools:rowCount() do
        if self.propData[dd.mytools:getLong(i,"tid")] ~= nil then
            self.propData[dd.mytools:getLong(i,"tid")]['num'] = dd.mytools:getLong(i,"count")
        end    
    end
    local index = 1
    for i=1,self._data:rowCount() do
        local num = self.propData[self._data:getLong(index,"pid")]['num']
        if self._index == 2 then
            if num <= 0 then
                self._data:delRow(index)
            else
                self._data:setLong(index,"num",num)
                index = index + 1
            end
        else
            self._data:setLong(index,"num",num)
            index = index + 1            
        end
    end
end

function PropShopLayer:popRewardDialog(infos)
    if table.getn(infos) > 0 then
        --商店里，是购买的才提示
        if infos[1]["from"] == 2 or infos[1]["from"] == 22 then
            cclog("prop Count : "..table.getn(infos))
            pop.onShowPopDialog("reward",infos)
        end
    else
        return 
    end
end

--刷新
function PropShopLayer.cellSizeForTable(table)
    return 225,690
end
    
function PropShopLayer.numberOfCellsInTableView(table)
    local widget = pop.getDialog("propShop")
    if widget == nil then
        return 0
    end
    if widget._data == nil then
        return 0
    end
    return widget._data:rowCount()
end
function PropShopLayer.tableCellAtIndex(table,idx)
    local widget = pop.getDialog("propShop")
    if widget ~= nil then
        return widget:darwItem(table,idx)
    end
    return nil
end

function PropShopLayer:show()
    if self._init == false then
        self._init = true
        self._index= 1
        self._itemIndex = 1
        --初始化数据
        self:loadPropData()
        self:initTopBar()
        self:initItemView()
        self:initItems()

        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
        self:getChildByName("btns"):getChildByName("shop"):setSelectedState(true)
        self:getChildByName("panel_props"):getChildByName("waiting"):setVisible(false)


        local panel_itemView = self:getChildByName("panel_props")
        local panel_top = panel_itemView:getChildByName("panel_top")
        panel_top:getChildByName("btn_navi1"):setSelectedState(true)

        local tableView = cc.TableView:create(cc.size(720,ff.height - 214 - 190 -85))
        tableView:setTag(1)
        tableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
        tableView:setDelegate()
        tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
        tableView:setPosition(cc.p(0, 0))
        self._view = tableView
        self:getChildByName("panel_props"):addChild(tableView)


        tableView:registerScriptHandler(self.cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
        tableView:registerScriptHandler(self.tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
        tableView:registerScriptHandler(self.numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)

        --tableView:setEnableToCenter(true)
        --tableView:setEnableToCenterAni(true)
    else
        self:updateCount()
    end        
end

function PropShopLayer:onItemExchange(params)
    local code = params[1]
    if code == 0 then      
        self:loadPropData()
        self:updateCount()
        self:initPropList()
        self:reloadData()
        self._isplaying = false
        local button = dd.mainUI:getChildByName("effect"):getChildByTag(100001)
        if button ~= nil then
            button:removeFromParent()
        end
    else
        --dd.mainUI:onShowCodeTips(code)
    end
end


function PropShopLayer.onStart(sender)
    ff.net:registerEvent(2,dd.Tjf_prop_buy, function (message)sender:responPropBuy(message) end)
    ff.net:registerEvent(2,dd.Tjf_prop_use, function (message)sender:responPropUse(message) end)
    ff.net:registerEvent(2,dd.Tjf_notify_SNGetBonus, function (message) sender:popRewardDialog(message) end)
    ff.net:registerEvent(2,dd.Tjf_ItemExchange,function (message)sender:onItemExchange(message)end)
    ff.net:bindProperty(2603,"gold",sender.updateGold)

    sender:show()
    sender:initPropList()
end
function PropShopLayer.onEnd(sender,btns)

    dd.delBackEvent(sender.onReturn)
    sender:stopAllActions()
    ff.net:removeEvent(2,dd.Tjf_prop_buy)
    ff.net:removeEvent(2,dd.Tjf_prop_use)
    ff.net:removeEvent(2,dd.Tjf_notify_SNGetBonus)
    ff.net:removeEvent(2,dd.Tjf_ItemExchange)
    ff.net:unbindProperty("gold",2603) 
    sender._isplaying = false
    local button = dd.mainUI:getChildByName("effect"):getChildByTag(100001)
    if button ~= nil then
        button:removeFromParent()
    end
    if ff.set_power <= 1 then
        local free = 0
        if table.getn(sender._items) >= 15 then
            for i=16,table.getn(sender._items) do
                local item = sender._items[16]
                item:release()
                table.remove(sender._items,16)
                free = free + 1
            end
        end
        cclog("free item:"..free)
    end
    if btns == nil then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:unSelectBtns()
        end    
    end

    if pop.getDialog("reward") then
        pop.onClosePopDialog("reward")
    end
    if pop.isShowing("barrack") then      
        local message = ff.net:createMessage()
        message:addCmd(0x0000005d)
        message:addLong(dd.uid)
        ff.net:rpc(message,false)
    end
end

function PropShopLayer.onBefore(sender)
    --sender:showItems(true)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("icon"),sender:getChildByName("top"):getChildByName("addgold")) 
    return true
end
function PropShopLayer:onInit()
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720, hh - 214))
        self:getChildByName("top"):setPositionY(hh - 214 - 105)
        self:getChildByName("btns"):setPositionY(hh - 214 - 190)
        self:getChildByName("panel_props"):setContentSize(cc.size(720,hh - 214 - 190))
        self:getChildByName("panel_props"):setPositionY(0)

        self:getChildByName("panel_props"):getChildByName("panel_top"):setPositionY(hh - 214 - 190 -85)

        self:getChildByName("panel_props"):getChildByName("waiting"):setPositionY(0)
        self:setPositionY(0)
    end
    self:getChildByName("panel_props"):getChildByName("panel_buyItem"):setVisible(false)
    self.updateGold()
    --cclog("====id : "..GuideControl.curId)
    if GuideControl.curId == 1010 then
        self._index = 1 
        self:getChildByName("btns"):getChildByName("shop"):setSelectedState(true)
        self:getChildByName("btns"):getChildByName("bag"):setSelectedState(false)
        self:getChildByName("btns"):getChildByName("shop"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("btns"):getChildByName("bag"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    end
    self._isplaying = false
    local button = dd.mainUI:getChildByName("effect"):getChildByTag(100001)
    if button ~= nil then
        button:removeFromParent()
    end
end

function onShowShop(widget,parent)
    local layer = PropShopLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer._parent = parent
    layer:onInit()
    return layer
end