--司令部升级
local personRankLayer   = class("personRankLayer")
personRankLayer._name = "personRank"
personRankLayer._init = false
personRankLayer.mainRankInfo = {}
personRankLayer.state = 1 -- 1=主面板 2=个人战力排行 3=个人击杀排行 4=联盟战力排行 5=联盟击杀排行
personRankLayer.type = 1
personRankLayer.infoList = {} 
personRankLayer.unionList = {} 
personRankLayer.animFrames = {}
personRankLayer.myRank = 0 --当前显示的排行中我的排名
personRankLayer.ifLastPage = 0--0=否1=是
personRankLayer.lastID = 0
personRankLayer.searchText = "" 
personRankLayer.searchMode = 0 --0=否1=是
function personRankLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, personRankLayer)
    return target
end
function personRankLayer:onInit()
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,hh - 214))
        self:getChildByName("mainInfo"):setContentSize(cc.size(720,hh - 214 - 105))
        self:getChildByName("mainInfo"):setInnerContainerSize(cc.size(720,hh - 214 - 105))
        
        self:getChildByName("rankInfo"):setContentSize(cc.size(720,hh - 214 - 105))
        self:getChildByName("rankInfo"):getChildByName("top"):setContentSize(cc.size(697,60))
        local infoH = hh - 214 - 105
        self:getChildByName("rankInfo"):getChildByName("topNavi"):setPositionY(infoH - 85)
        self:getChildByName("rankInfo"):getChildByName("rankArea"):addScrollViewEventListener(self.scrollViewEvent)
        self:getChildByName("rankInfo1"):setContentSize(cc.size(720,hh - 214 - 105))
        self:getChildByName("rankInfo1"):getChildByName("top"):setContentSize(cc.size(697,60))
        self:getChildByName("rankInfo1"):getChildByName("topNavi"):setPositionY(infoH - 85)
        self:getChildByName("rankInfo1"):getChildByName("top"):setPositionY(infoH - 85 -  31)
        self:getChildByName("rankInfo1"):getChildByName("info"):setPositionY(infoH - 85 - 92)  
        self:getChildByName("rankInfo1"):getChildByName("rankArea"):setContentSize(cc.size(720,hh - 214 - 105 - 200))
        self:getChildByName("rankInfo1"):getChildByName("rankArea"):addScrollViewEventListener(self.scrollViewEvent)
        
        self:initListener()
    end
    self.updateGold()
    self:addEvent()
end
function personRankLayer.updateGold(name,row,old,value)
    local sender = pop.getDialog("personRank")
    if sender ~= nil then
        sender:getChildByName("topArea"):getChildByName("gold_text"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("topArea"):getChildByName("gold_text"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("topArea"):requestDoLayout()
    end
end
function personRankLayer:addEditBox()
    local shInput = self:getChildByName("rankInfo"):getChildByName("search"):getChildByName("input_bg")
    if shInput:getChildByTag(160000) == nil then
        dd.addEditBox(shInput,cc.size(shInput:getContentSize().width - 40,shInput:getContentSize().height - 2),'images/ui/alpha.png',160000,cc.p(0.5,0.5),cc.p((shInput:getContentSize().width - 40)/2 + 5,shInput:getContentSize().height/2 + 5),cc.c3b(161,175,175),28,6,4,1,15,true,true,true)
        shInput:getChildByTag(160000):setText("")
    end

    local function editBoxTextEventHandle(strEventName,pSender)
        local edit = pSender
        local strFmt 
        if strEventName == "began" then

        elseif strEventName == "ended" or strEventName == "return" then
            local tag = pSender:getTag()
            local text = edit:getText()
            if  tag == 160000 and string.len(text) <= 0 then          
                edit:setText("")
                return
            end 
            self.searchText = text    
        elseif strEventName == "changed" then

        end
    end
    shInput:getChildByTag(160000):registerScriptEditBoxHandler(editBoxTextEventHandle)
end
function personRankLayer:getMainRankInfo()
    local message = ff.net:createMessage()
    message:addCmd(0x47)
    message:addLong(dd.uid)
    message:addLong(0)
    ff.net:rpc(message,false)
end
function personRankLayer:updateMainView()
    if self.mainRankInfo['fightRank'] > 0 then
        self:getChildByName("mainInfo"):getChildByName("prank"):getChildByName("pfrank_text"):setString(self.mainRankInfo['fightRank'])
    else
        self:getChildByName("mainInfo"):getChildByName("prank"):getChildByName("pfrank_text"):setString(ff.langString("没有排名"))
    end
    if self.mainRankInfo['killRank'] > 0 then
        self:getChildByName("mainInfo"):getChildByName("prank"):getChildByName("pkrank_text"):setString(self.mainRankInfo['killRank'])
    else
        self:getChildByName("mainInfo"):getChildByName("prank"):getChildByName("pkrank_text"):setString(ff.langString("没有排名"))
    end
    if self.mainRankInfo['unionFightRank'] > 0 then
        self:getChildByName("mainInfo"):getChildByName("urank"):getChildByName("ufrank_text"):setString(self.mainRankInfo['unionFightRank'])
    else
        self:getChildByName("mainInfo"):getChildByName("urank"):getChildByName("ufrank_text"):setString(ff.langString("没有排名"))
    end
    if self.mainRankInfo['unionKillRank'] > 0 then
        self:getChildByName("mainInfo"):getChildByName("urank"):getChildByName("ukrank_text"):setString(self.mainRankInfo['unionKillRank'])
    else
        self:getChildByName("mainInfo"):getChildByName("urank"):getChildByName("ukrank_text"):setString(ff.langString("没有排名"))
    end
end
function personRankLayer:goToMain()
    if self.type == 1 then
        self.state = 1
        self:disAll()
        self:getChildByName("mainInfo"):setVisible(true)
        self:getChildByName("mainInfo"):setEnabled(true)
        self:getChildByName("rankInfo"):getChildByName("search"):getChildByName("input_bg"):getChildByTag(160000):setEnabled(false)
        self:getChildByName("rankInfo"):getChildByName("search"):getChildByName("input_bg"):getChildByTag(160000):setText("")
        self.searchMode = 0
        self.searchText = ""
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("排名"))
        self:getMainRankInfo()
    else
        self.state = 35
        self:disAll()
        self:getChildByName("mainInfo"):setVisible(false)
        self:getChildByName("mainInfo"):setEnabled(false)
        self:getChildByName("rankInfo1"):setVisible(true)
        self:getChildByName("rankInfo1"):setEnabled(true)
        
        self:setRankType()
        self:freshView()
        self:getRankData()
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("个人排名"))
        self:getChildByName("rankInfo1"):getChildByName("rankArea"):getInnerContainer():stopAllActions()
        self:getChildByName("rankInfo1"):getChildByName("rankArea"):scrollToTop(0.01,false)
        self:getChildByName("rankInfo1"):getChildByName("topNavi"):getChildByName("fight"):setSelectedState(true)
            
        self.searchMode = 0
        self.searchText = ""
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("排名"))
    end
end 
function personRankLayer:checkUpdate()
    if self.ifLastPage == 0 then
        self:showWaiting(true)
        self:getRankData()
    end 
end
function personRankLayer.scrollViewEvent(sender, evenType)
    if evenType == ccui.ScrollviewEventType.bounceBottom then
        local rank = pop.getDialog("personRank")
        if rank:getChildByName("waiting"):isVisible() == false and rank:isVisible() == true  then
            rank:checkUpdate()
        end    
    elseif evenType ==  ccui.ScrollviewEventType.scrollToTop then
    end
end
function personRankLayer:getRankData()
    cclog("state:"..self.state.." lastID:"..self.lastID)
    local message = ff.net:createMessage()
    if self.type == 1 then
        if self.state == 2 then
            message:addCmd(0x1b)
            message:addLong(dd.uid)
            message:addLong(self.searchMode)
            message:addLong(0)
            message:addString(self.searchText,15)
            message:addLong(self.lastID)
            self.lastState = self.state -- 排行信息前的状态        
        elseif self.state == 3 then
            message:addCmd(0x1b)
            message:addLong(dd.uid)
            message:addLong(self.searchMode)
            message:addLong(1)
            message:addString(self.searchText,15)
            message:addLong(self.lastID)  
            self.lastState = self.state -- 排行信息前的状态
        elseif self.state == 4 then
            message:addCmd(0x30)
            message:addLong(dd.uid)
            message:addLong(0)
            message:addLong(0)
            message:addString("",15)
            message:addLong(self.lastID)
            message:addLong(9)
            message:addLong(0)
            self.lastState = self.state -- 排行信息前的状态
        elseif self.state == 5 then
            message:addCmd(0x30)
            message:addLong(dd.uid)
            message:addLong(0)
            message:addLong(1)
            message:addString("",15)
            message:addLong(self.lastID)
            message:addLong(9)
            message:addLong(0)
            self.lastState = self.state -- 排行信息前的状态
        end
    else
        if dd.KFRoomInfo == nil then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("活动尚未开始"))
            return
        else
            if dd.KFRoomInfo:rowCount() > 0 then
                local index = dd.KFRoomInfo:rowCount()
                message:addCmd(0x303)
                message:addLong(dd.uid)
                message:addLong(dd.KFRoomInfo:getLong(index,"roomid"))
                message:addLong(self.state)
                message:addLong(self.lastID)
                --cclog("==="..self.state)
                --cclog("==="..self.lastID)
            else
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("活动尚未开始"))
                return
            end
        end
        --self.lastState = self.state -- 排行信息前的状态
    end
    ff.net:postMessage(message)
end
function personRankLayer:initListener()
    self:getChildByName("topArea"):getChildByName("return"):addTouchEventListener(self.onReturn)
    local function showPersonRank(sender,eventType)
        if eventType==ccui.TouchEventType.ended then 
            self.state = 2
            self:disAll()
            self:getChildByName("rankInfo"):setVisible(true)
            self:getChildByName("rankInfo"):setEnabled(true)
            
            
            self:getChildByName("rankInfo"):getChildByName("search"):setVisible(true)
            self:getChildByName("rankInfo"):getChildByName("search"):setContentSize(cc.size(700,61))          
            self:getChildByName("rankInfo"):getChildByName("search"):getChildByName("input_bg"):getChildByTag(160000):setEnabled(true)
            self:getChildByName("rankInfo"):getChildByName("search"):getChildByName("input_bg"):getChildByTag(160000):setText("")
            local infoH = ff.height - 214 - 105
            self:getChildByName("rankInfo"):getChildByName("search"):setPositionY(infoH - 85 - 66)
            self:getChildByName("rankInfo"):getChildByName("top"):setPositionY(infoH - 85 - 66 - 31)
            self:getChildByName("rankInfo"):getChildByName("info"):setPositionY(infoH - 85 - 66 - 92)  
            self:getChildByName("rankInfo"):getChildByName("rankArea"):setContentSize(cc.size(720,ff.height - 214 - 105 - 270))
            
            self.searchMode = 0
            self.searchText = ""
            self:setRankType()
            self:freshView()
            self:getRankData()
            self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("个人排名"))
            self:getChildByName("rankInfo"):getChildByName("rankArea"):getInnerContainer():stopAllActions()
            self:getChildByName("rankInfo"):getChildByName("rankArea"):scrollToTop(0.01,false)
            self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("fight"):setSelectedState(true)
            if sender:getName() == "prank" then
                AudioEngine.playEffect(ff.sounds[109])
            end
        end  
    end
    local function showUnionRank(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            self.state = 4
            self:disAll()
            self:getChildByName("rankInfo"):setVisible(true)
            self:getChildByName("rankInfo"):setEnabled(true)
                       
            self:getChildByName("rankInfo"):getChildByName("search"):setContentSize(cc.size(700,0))
            self:getChildByName("rankInfo"):getChildByName("search"):setVisible(false)
            self:getChildByName("rankInfo"):getChildByName("search"):getChildByName("input_bg"):getChildByTag(160000):setEnabled(false)
            self:getChildByName("rankInfo"):getChildByName("search"):getChildByName("input_bg"):getChildByTag(160000):setText("")
            local infoH = ff.height - 214 - 105
            self:getChildByName("rankInfo"):getChildByName("top"):setPositionY(infoH - 85 - 33)
            self:getChildByName("rankInfo"):getChildByName("info"):setPositionY(infoH - 85 - 93) 
            self:getChildByName("rankInfo"):getChildByName("rankArea"):setContentSize(cc.size(720,ff.height - 214 - 105 - 205))
            
            self.searchMode = 0
            self.searchText = ""
            self:setRankType()
            self:freshView()
            self:getRankData()
            self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("联盟排名"))
            self:getChildByName("rankInfo"):getChildByName("rankArea"):getInnerContainer():stopAllActions()
            self:getChildByName("rankInfo"):getChildByName("rankArea"):scrollToTop(0.01,false)
            self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("fight"):setSelectedState(true)
            if sender:getName() == "urank" then
                AudioEngine.playEffect(ff.sounds[109])
            end
        end  
    end
    self:getChildByName("mainInfo"):getChildByName("prank"):addTouchEventListener(showPersonRank)
    self:getChildByName("mainInfo"):getChildByName("prank"):getChildByName("prank_btn"):addTouchEventListener(showPersonRank)
    self:getChildByName("mainInfo"):getChildByName("urank"):getChildByName("urank_btn"):addTouchEventListener(showUnionRank)
    self:getChildByName("mainInfo"):getChildByName("urank"):addTouchEventListener(showUnionRank)
    local function showKillRank(sender,eventType)
        if eventType==ccui.TouchEventType.ended then    
            if self.state == 5 or self.state == 3 then
                return
            end
            if self:getChildByName("waiting"):isVisible() then
                return
            end
            self.searchMode = 0
            self.searchText = ""
            self:getChildByName("rankInfo"):getChildByName("search"):getChildByName("input_bg"):getChildByTag(160000):setText("")

            if self.state == 4 then
                self.state = 5 
            elseif self.state == 2 then
                self.state = 3 
            end
            self.lastID = 0 --防止在获取数据的时候切换排行导致数据出错
            self:setRankType()
            self:freshView()
            self:getRankData()
            self:getChildByName("rankInfo"):getChildByName("rankArea"):getInnerContainer():stopAllActions()
            self:getChildByName("rankInfo"):getChildByName("rankArea"):scrollToTop(0.01,false)
        end  
    end
    local function showFightRank(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            if self.state == 2 or self.state == 4 then
                return
            end
            if self:getChildByName("waiting"):isVisible() then
                return
            end
            self.searchMode = 0
            self.searchText = ""
            self:getChildByName("rankInfo"):getChildByName("search"):getChildByName("input_bg"):getChildByTag(160000):setText("")

            if self.state == 5 then
                self.state = 4 
            elseif self.state == 3 then
                self.state = 2 
            end
            self.lastID = 0 --防止在获取数据的时候切换排行导致数据出错
            self:setRankType()
            self:freshView()
            self:getRankData()
            self:getChildByName("rankInfo"):getChildByName("rankArea"):getInnerContainer():stopAllActions()
            self:getChildByName("rankInfo"):getChildByName("rankArea"):scrollToTop(0.01,false)
        end  
    end
    local function showKillRank1(sender,eventType)
        if eventType==ccui.TouchEventType.ended then    
            if self.state == 126 then
                return
            end
            if self:getChildByName("waiting"):isVisible() then
                return
            end
            self.searchMode = 0
            self.searchText = ""
            
            
            self.state = 126
           
            self.lastID = 0 --防止在获取数据的时候切换排行导致数据出错
            self:setRankType()
            self:freshView()
            self:getRankData()
            self:getChildByName("rankInfo1"):getChildByName("rankArea"):getInnerContainer():stopAllActions()
            self:getChildByName("rankInfo1"):getChildByName("rankArea"):scrollToTop(0.01,false)
        end  
    end
    local function showFightRank1(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            if self.state == 35 then
                return
            end
            if self:getChildByName("waiting"):isVisible() then
                return
            end
            self.searchMode = 0
            self.searchText = ""
            
            
            self.state = 35
            
            self.lastID = 0 --防止在获取数据的时候切换排行导致数据出错
            self:setRankType()
            self:freshView()
            self:getRankData()
            self:getChildByName("rankInfo1"):getChildByName("rankArea"):getInnerContainer():stopAllActions()
            self:getChildByName("rankInfo1"):getChildByName("rankArea"):scrollToTop(0.01,false)
        end  
    end
    self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("kill"):addTouchEventListener(showKillRank)
    self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("fight"):addTouchEventListener(showFightRank)
    self:getChildByName("rankInfo1"):getChildByName("topNavi"):getChildByName("kill"):addTouchEventListener(showKillRank1)
    self:getChildByName("rankInfo1"):getChildByName("topNavi"):getChildByName("fight"):addTouchEventListener(showFightRank1)
    local function goToMyRank(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            if self.myRank <= 0 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("您还没有进入排行"))
            elseif self.myRank == 1 then
                self:getChildByName("rankInfo"):getChildByName("rankArea"):scrollToTop(0.01,false)
            elseif self.myRank <= table.getn(self.infoList) then
                local ps = self.myRank * 100.0/table.getn(self.infoList)
                self:getChildByName("rankInfo"):getChildByName("rankArea"):scrollToPercentVertical(ps,0.5,false)
                self:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(self.myRank):setColor(cc.c3b(11,255,11))
            elseif self.myRank > table.getn(self.infoList) then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("还未获取到您的排名数据"))
            end 
        end  
    end
    local function showMe(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then     
            if self.state == 2 or self.state == 3 then
                pop.onShowPopDialog("powerInfo")
            else
                --这里显示我的联盟信息
                if dd.myUnion:getLong(1,"unionid") <= 0 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("您尚未加入联盟"))
                    return
                end
                pop.onShowPopDialog("unionInfo",self,dd.myUnion:getString(1,"unionflag"))
            end
        end  
    end
    self:getChildByName("rankInfo"):getChildByName("top"):getChildByName("myRank"):addTouchEventListener(showMe)
    self:getChildByName("topArea"):getChildByName("add_btn"):addTouchEventListener(dd.onPay)
    local function showSearchResult(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            if  string.len(self.searchText) <= 0 then          
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("输入的名称不能为空"))
                return
            end   
            local message = ff.net:createMessage()
            message:addCmd(0x1b)
            message:addLong(dd.uid)
            message:addLong(1)
            if self.state == 2 then            
                message:addLong(0)
            elseif self.state == 3 then  
                message:addLong(1)
            end
            message:addString(self.searchText,15)
            message:addLong(0)
            ff.net:rpc(message,false)
            self.searchMode = 1
            self:freshView()
            self:getChildByName("rankInfo"):getChildByName("rankArea"):getInnerContainer():stopAllActions()
            self:getChildByName("rankInfo"):getChildByName("rankArea"):scrollToTop(0.01,false)
        end  
    end
    self:getChildByName("rankInfo"):getChildByName("search"):getChildByName("souBtn"):addTouchEventListener(showSearchResult)
end
function personRankLayer:freshView()   
    if self.type == 1 then
        for var=1,10 do
            self:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(var):setVisible(false)
            self:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(var):getChildByName("all_back"):loadTexture(dd.getPathFromUI("public/block04.png",1))
        end 
        if table.getn(self.infoList) > 0 then
            for var=1,table.getn(self.infoList) do
                if var > 10 then
                    self:getChildByName("rankInfo"):getChildByName("rankArea"):removeChildByTag(var)           
                end
            end
        elseif table.getn(self.unionList) > 0 then
            for var=1,table.getn(self.unionList) do
                if var > 10 then
                    self:getChildByName("rankInfo"):getChildByName("rankArea"):removeChildByTag(var)           
                end
            end
        end
        self.infoList = {} 
        self.unionList = {}
        self:getChildByName("rankInfo"):getChildByName("rankArea"):refreshView()
        self.ifLastPage = 0--0=否1=是
        self.lastID = 0
    else
        for var=1,10 do
            self:getChildByName("rankInfo1"):getChildByName("rankArea"):getChildByTag(var):setVisible(false)
            self:getChildByName("rankInfo1"):getChildByName("rankArea"):getChildByTag(var):getChildByName("all_back"):loadTexture(dd.getPathFromUI("public/block04.png",1))
        end 
        if table.getn(self.infoList) > 0 then
            for var=1,table.getn(self.infoList) do
                if var > 10 then
                    self:getChildByName("rankInfo1"):getChildByName("rankArea"):removeChildByTag(var)           
                end
            end
        elseif table.getn(self.unionList) > 0 then
            for var=1,table.getn(self.unionList) do
                if var > 10 then
                    self:getChildByName("rankInfo1"):getChildByName("rankArea"):removeChildByTag(var)           
                end
            end
        end
        self.infoList = {} 
        self.unionList = {}
        self:getChildByName("rankInfo1"):getChildByName("rankArea"):refreshView()
        self.ifLastPage = 0--0=否1=是
        self.lastID = 0
    end
end

function personRankLayer:disAll()
    self:getChildByName("mainInfo"):setVisible(false)
    self:getChildByName("mainInfo"):setEnabled(false)
    self:getChildByName("rankInfo"):setVisible(false)
    self:getChildByName("rankInfo"):setEnabled(false)
    self:getChildByName("rankInfo1"):setVisible(false)
    self:getChildByName("rankInfo1"):setEnabled(false)
end
function personRankLayer:setRankType()
    if self.type == 1 then
        self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("fight"):setTouchEnabled(true)
        self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("fight"):setSelectedState(false)
        self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("fight"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
        self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("kill"):setTouchEnabled(true)
        self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("kill"):setSelectedState(false)
        self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("kill"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
        local it = self:getChildByName("rankItem") 
        if self.state == 2 or self.state == 4 then
            self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("fight"):setTouchEnabled(false)
            self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("fight"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
            self:getChildByName("rankInfo"):getChildByName("info"):getChildByName("chu_fight_tip"):setString(ff.langString("战力"))
        elseif self.state == 3 or self.state == 5 then
            self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("kill"):setTouchEnabled(false)
            self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("kill"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
            self:getChildByName("rankInfo"):getChildByName("info"):getChildByName("chu_fight_tip"):setString(ff.langString("杀伤"))
        end
        if self.state == 2 or self.state == 3 then
            for var=1,10 do
                local item = self:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(var)
                if var <= 10 and item ~= nil then
                    item:getChildByName("user_name"):setVisible(false)
                    item:getChildByName("union_short"):setVisible(false)
                    item:getChildByName("union_panel"):setVisible(false)
                    item:getChildByName("fight_tip"):setVisible(true)
                    item:getChildByName("alliance_text"):setVisible(true)
                    item:getChildByName("short"):setVisible(true)
                    item:getChildByName("union_name"):setVisible(true) 
                    item:getChildByName("mark_back"):setVisible(true)                
                end
            end
            it:getChildByName("user_name"):setVisible(false)
            it:getChildByName("union_short"):setVisible(false)
            it:getChildByName("union_panel"):setVisible(false)
            it:getChildByName("fight_tip"):setVisible(true)
            it:getChildByName("alliance_text"):setVisible(true)
            it:getChildByName("short"):setVisible(true)
            it:getChildByName("union_name"):setVisible(true)
            it:getChildByName("mark_back"):setVisible(true)    
        elseif self.state == 4 or self.state == 5 then
            for var=1,10 do
                local item = self:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(var)
                if var <= 10 and item ~= nil then
                    item:getChildByName("user_name"):setVisible(false)
                    item:getChildByName("union_short"):setVisible(true)
                    item:getChildByName("union_panel"):setVisible(true)
                    item:getChildByName("fight_tip"):setVisible(false)
                    item:getChildByName("alliance_text"):setVisible(false)
                    item:getChildByName("short"):setVisible(false)
                    item:getChildByName("union_name"):setVisible(false)
                    item:getChildByName("mark_back"):setVisible(false)             
                end
            end
            it:getChildByName("user_name"):setVisible(false)
            it:getChildByName("union_short"):setVisible(true)
            it:getChildByName("union_panel"):setVisible(true)
            it:getChildByName("fight_tip"):setVisible(false)
            it:getChildByName("alliance_text"):setVisible(false)
            it:getChildByName("short"):setVisible(false)
            it:getChildByName("union_name"):setVisible(false) 
            it:getChildByName("mark_back"):setVisible(false)
        end
    else
        self:getChildByName("rankInfo1"):getChildByName("topNavi"):getChildByName("fight"):setTouchEnabled(true)
        self:getChildByName("rankInfo1"):getChildByName("topNavi"):getChildByName("fight"):setSelectedState(false)
        self:getChildByName("rankInfo1"):getChildByName("topNavi"):getChildByName("fight"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
        self:getChildByName("rankInfo1"):getChildByName("topNavi"):getChildByName("kill"):setTouchEnabled(true)
        self:getChildByName("rankInfo1"):getChildByName("topNavi"):getChildByName("kill"):setSelectedState(false)
        self:getChildByName("rankInfo1"):getChildByName("topNavi"):getChildByName("kill"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
        local it = self:getChildByName("rankItem") 
        self:getChildByName("rankInfo1"):getChildByName("info"):getChildByName("chu_fight_tip1"):setString(ff.langString("积分"))
        
        if self.state == 35 then
            self:getChildByName("rankInfo1"):getChildByName("topNavi"):getChildByName("fight"):setTouchEnabled(false)
            self:getChildByName("rankInfo1"):getChildByName("topNavi"):getChildByName("fight"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
            for var=1,10 do
                local item = self:getChildByName("rankInfo1"):getChildByName("rankArea"):getChildByTag(var)
                if var <= 10 and item ~= nil then
                    item:getChildByName("user_name"):setVisible(false)
                    item:getChildByName("union_short"):setVisible(false)
                    item:getChildByName("union_panel"):setVisible(false)
                    item:getChildByName("fight_tip"):setVisible(true)
                    item:getChildByName("alliance_text"):setVisible(true)
                    item:getChildByName("short"):setVisible(true)
                    item:getChildByName("union_name"):setVisible(true) 
                    item:getChildByName("mark_back"):setVisible(true)                
                end
            end
            it:getChildByName("user_name"):setVisible(false)
            it:getChildByName("union_short"):setVisible(false)
            it:getChildByName("union_panel"):setVisible(false)
            it:getChildByName("fight_tip"):setVisible(true)
            it:getChildByName("alliance_text"):setVisible(true)
            it:getChildByName("short"):setVisible(true)
            it:getChildByName("union_name"):setVisible(true)
            it:getChildByName("mark_back"):setVisible(true)    
        elseif self.state == 126 then
            self:getChildByName("rankInfo1"):getChildByName("topNavi"):getChildByName("kill"):setTouchEnabled(false)
            self:getChildByName("rankInfo1"):getChildByName("topNavi"):getChildByName("kill"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
            for var=1,10 do
                local item = self:getChildByName("rankInfo1"):getChildByName("rankArea"):getChildByTag(var)
                if var <= 10 and item ~= nil then
                    item:getChildByName("user_name"):setVisible(false)
                    item:getChildByName("union_short"):setVisible(true)
                    item:getChildByName("union_panel"):setVisible(true)
                    item:getChildByName("fight_tip"):setVisible(false)
                    item:getChildByName("alliance_text"):setVisible(false)
                    item:getChildByName("short"):setVisible(false)
                    item:getChildByName("union_name"):setVisible(false)
                    item:getChildByName("mark_back"):setVisible(false)             
                end
            end
            it:getChildByName("user_name"):setVisible(false)
            it:getChildByName("union_short"):setVisible(true)
            it:getChildByName("union_panel"):setVisible(true)
            it:getChildByName("fight_tip"):setVisible(false)
            it:getChildByName("alliance_text"):setVisible(false)
            it:getChildByName("short"):setVisible(false)
            it:getChildByName("union_name"):setVisible(false) 
            it:getChildByName("mark_back"):setVisible(false)
        end
        
        
    end
end
function personRankLayer:freshMyRank()
    if self.type == 1 then
        local rank = self:getChildByName("rankInfo"):getChildByName("top"):getChildByName("myRank")
        rank:setVisible(false)
        self:getChildByName("rankInfo"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setVisible(true)
        if self.myRank <= 0 then
            if self.state <= 3 then
                self:getChildByName("rankInfo"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setString(ff.langString("您尚未进入此排名"))
            else
                if dd.myUnion:getLong(1,'unionid') > 0 then                       
                    self:getChildByName("rankInfo"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setString(ff.langString("您的联盟尚未进入此排名"))        
                else
                    self:getChildByName("rankInfo"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setString(ff.langString("您尚未加入联盟"))        
                end
            end
        else
            if self.state <= 3 then
                self:getChildByName("rankInfo"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setString(ff.langString("你的排名")..":"..self.myRank)
            else
                self:getChildByName("rankInfo"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setString(ff.langString("你所在联盟的排名")..":"..self.myRank)        
            end
        end
    else
        local rank = self:getChildByName("rankInfo1"):getChildByName("top"):getChildByName("myRank")
        rank:setVisible(false)
        self:getChildByName("rankInfo1"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setVisible(true)
        if self.myRank <= 0 then
            if self.state ==35 then
                self:getChildByName("rankInfo1"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setString(ff.langString("您尚未进入此排名"))
            else
                if dd.myUnion:getLong(1,'unionid') > 0 then                       
                    self:getChildByName("rankInfo1"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setString(ff.langString("您的联盟尚未进入此排名"))        
                else
                    self:getChildByName("rankInfo1"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setString(ff.langString("您尚未加入联盟"))        
                end
            end
        else
            if self.state ==35  then
                self:getChildByName("rankInfo1"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setString(ff.langString("你的排名")..":"..self.myRank)
            else
                self:getChildByName("rankInfo1"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setString(ff.langString("你所在联盟的排名")..":"..self.myRank)        
            end
        end
    end
end

function personRankLayer:backGetRankUser(ret)
    if ret[1] == 0 then               
        self.ifLastPage = ret[2]['ifLast']
        self.myRank = ret[2]['myRank']
        self:freshMyRank()
        if ret[3] == nil or ret[3]:rowCount() <= 0 then
            self:showWaiting(false)
            if self.searchMode == 1 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("搜索不到玩家"))
            end
            return
        end
        for var=1,ret[3]:rowCount() do
            if ret[3]:getLong(var,'user_rank') > table.getn(self.infoList) then
                local key = table.getn(self.infoList) + 1
                self.infoList[key] = {}
                self.infoList[key]["user_rank"] = ret[3]:getLong(var,'user_rank')
                self.infoList[key]["user_id"] = ret[3]:getLong(var,'user_id')
                self.infoList[key]["user_pic"] = ret[3]:getLong(var,'user_pic')
                self.infoList[key]["user_name"] = ret[3]:getString(var,'user_name')
                self.infoList[key]["union_office"] = ret[3]:getLong(var,'union_office')
                self.infoList[key]["union_id"] = ret[3]:getLong(var,'union_id')
                self.infoList[key]["union_short"] = ret[3]:getString(var,'union_short')
                self.infoList[key]["union_name"] = ret[3]:getString(var,'union_name')
                self.infoList[key]["value"] = ret[3]:getSuperLong(var,'value')
            end
        end
        self:initInfoList()
    else
        dd.mainUI:onShowCodeTips(ret[1])
    end
end

function personRankLayer:GetKFActivityRank(ret)
    if ret[1] == 0 then               
        self.ifLastPage = ret[2]['ifLast']
        self.myRank = ret[2]['myRank']
        self:freshMyRank()
        if ret[3] == nil or ret[3]:rowCount() <= 0 then
            self:showWaiting(false)
            return
        end
        if ret[2]["type"] == 35 then
            for var=1,ret[3]:rowCount() do
                if ret[3]:getLong(var,'user_rank') > table.getn(self.infoList) then
                    local key = table.getn(self.infoList) + 1
                    self.infoList[key] = {}
                    self.infoList[key]["user_rank"] = ret[3]:getLong(var,'user_rank')
                    self.infoList[key]["user_id"] = ret[3]:getLong(var,'user_id')
                    self.infoList[key]["user_pic"] = ret[3]:getLong(var,'user_pic')
                    self.infoList[key]["user_name"] = ret[3]:getString(var,'user_name')
                    self.infoList[key]["union_office"] = 0
                    self.infoList[key]["union_id"] = 0
                    self.infoList[key]["union_short"] = ret[3]:getString(var,'union_short')
                    self.infoList[key]["union_name"] = ret[3]:getString(var,'union_name')
                    self.infoList[key]["value"] = ret[3]:getSuperLong(var,'value')
                end
            end
        else

            for var=1,ret[3]:rowCount() do
                if ret[3]:getLong(var,'user_rank') > table.getn(self.unionList) then
                    local row = table.getn(self.unionList) + 1
                    --cclog("=2222=="..row)
                    self.unionList[row] = {}
                    self.unionList[row]["rank"] = ret[3]:getLong(var,'user_rank')
                    self.unionList[row]["unionid"] = ret[3]:getLong(var,'user_id')
                    self.unionList[row]["short"] = ret[3]:getString(var,'union_short')
                    self.unionList[row]["name"] = ret[3]:getString(var,'union_name')
                    self.unionList[row]["totem"] = ret[3]:getLong(var,'user_pic')
                    self.unionList[row]["rels"] = 0
                    self.unionList[row]["power"] = ret[3]:getSuperLong(var,'value')            
                    self.unionList[row]["members"] = 0
                    self.unionList[row]["memberMax"] = 0
                    self.unionList[row]["applying"] = 0
                    self.unionList[row]["inviting"] = 0
                    --cclog("=2222=="..ret[3]:getLong(var,'user_rank'))
                    --cclog("=2222=="..ret[3]:getLong(var,'user_id'))
                    --cclog("=2222=="..ret[3]:getString(var,'union_short'))
                    --cclog("=2222=="..ret[3]:getString(var,'union_name'))
                    --cclog("=2222=="..ret[3]:getLong(var,'user_pic'))
                    --cclog("=2222=="..ret[3]:getSuperLong(var,'value'))
                end
            end
        end
        self:initInfoList()
    else
        dd.mainUI:onShowCodeTips(ret[1])
    end
end
function personRankLayer:showWaiting(play)
    self:getChildByName("waiting"):getChildByTag(1):stopAllActions()
    if play == true then
        local animation = cc.Animation:createWithSpriteFrames(self.animFrames, 0.1)
        self:getChildByName("waiting"):getChildByTag(1):runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
        self:getChildByName("waiting"):setVisible(true) 
    else        
        self:getChildByName("waiting"):setVisible(false)
    end
end
function personRankLayer:initInfoList()
    self:showWaiting(false)
    local nextpage = false
    local tick = 1

    local function showInfo(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then         
            local key = sender:getTag()
            local info = self.infoList[key]
            if self.state == 2 or self.state == 3 then
                if info['user_id'] == dd.uid then
                    pop.onShowPopDialog("powerInfo")
                else
                    pop.onShowPopDialog("power2",self,info['user_id'])
                end
            else
                --这里显示我的联盟信息
                pop.onShowPopDialog("unionInfo",self,info['union_short'])
            end
            AudioEngine.playEffect(ff.sounds[109])
        end  
    
    end

    if self.type == 1 then
        local beforey = self:getChildByName("rankInfo"):getChildByName("rankArea"):getInnerContainer():getPositionY()
        for i=1,table.getn(self.infoList) do
            local rank = self.infoList[i]["user_rank"]
            if rank ~= nil and rank > self.lastID then
                self.lastID = rank
                local item = self:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(i)
                if item == nil then
                    item = self:getChildByName("rankItem"):clone()
                    item:setVisible(true)
                    item:setTag(i)
                    self:getChildByName("rankInfo"):getChildByName("rankArea"):addChild(item)
                end   
                if rank > 999 then
                    item:getChildByName("rank_icon"):setVisible(false)
                    item:getChildByName("rank_panel"):getChildByName("rank_text"):setVisible(true)   
                    item:getChildByName("rank_panel"):getChildByName("rank_text"):setString(rank)  
                    item:getChildByName("back"):setVisible(false)       
                else
                    item:getChildByName("rank_icon"):setVisible(true)
                    item:getChildByName("rank_icon"):loadTexture(self:getRankIcon(rank),0)
                    if rank > 3 then
                        item:getChildByName("rank_panel"):getChildByName("rank_text"):setVisible(true)
                        if self.state == 2 or self.state == 3 then                     
                            item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionX(38)
                            if rank > 100 then
                                item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionY(50)
                            else
                                item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionY(43)
                            end
                        elseif self.state == 4 or self.state == 5 then
                            item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionY(43)
                            item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionX(38)
                        end
                        item:getChildByName("rank_panel"):getChildByName("rank_text"):setString(rank) 
                        item:getChildByName("back"):setVisible(false)     
                    else
                        item:getChildByName("rank_panel"):getChildByName("rank_text"):setVisible(false)                    
                        item:getChildByName("back"):setVisible(true)
                        item:getChildByName("back"):loadTexture("images/icon/rank/back_"..rank..".png",0)
                    end
                end
                item:getChildByName("mark_icon"):loadTexture(self:getMarkIcon(i),0)
                
                if (self.state == 2 or self.state == 3) then
                    if self.infoList[i]["union_id"] > 0 then
                        item:getChildByName("short"):setString("["..self.infoList[i]["union_short"].."]")
                        item:getChildByName("union_name"):setString(self.infoList[i]["user_name"])
                        item:getChildByName("alliance_text"):setString(self.infoList[i]["union_name"])
                    else
                        item:getChildByName("user_name"):setVisible(true)
                        item:getChildByName("fight_tip"):setVisible(false)
                        item:getChildByName("alliance_text"):setVisible(false)
                        item:getChildByName("short"):setVisible(false)
                        item:getChildByName("union_name"):setVisible(false)     
                        item:getChildByName("user_name"):setString(self.infoList[i]["user_name"])
                    end
                end  
                item:getChildByName("fight_text"):setString(ff.getFormatMoney(self.infoList[i]["value"]))
                item:addTouchEventListener(showInfo)
                if self.state == 2 or self.state == 3 then
                    if dd.uid == self.infoList[i]['user_id'] then
                        item:getChildByName("all_back"):loadTexture("images/icon/rank/block12_on.png",0)
                    end
                end
                item:setVisible(true)
                if table.getn(self.infoList) <= 10 then
                else    
                    nextpage = true
                end
            end   
        end    

        if nextpage == true then
            self:getChildByName("rankInfo"):getChildByName("rankArea"):getInnerContainer():setPositionY(beforey)     
            self:getChildByName("rankInfo"):getChildByName("rankArea"):refreshView()
            if table.getn(self.infoList) > 0 then
                self:getChildByName("rankInfo"):getChildByName("rankArea"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,20)))
            end
        end
    else
        local beforey = self:getChildByName("rankInfo1"):getChildByName("rankArea"):getInnerContainer():getPositionY()
        if self.state == 35 then
            for i=1,table.getn(self.infoList) do
                local rank = self.infoList[i]["user_rank"]
                if rank ~= nil and rank > self.lastID then
                    self.lastID = rank
                    local item = self:getChildByName("rankInfo1"):getChildByName("rankArea"):getChildByTag(i)
                    if item == nil then
                        item = self:getChildByName("rankItem"):clone()
                        item:setVisible(true)
                        item:setTag(i)
                        self:getChildByName("rankInfo1"):getChildByName("rankArea"):addChild(item)
                    end   
                    if rank > 999 then
                        item:getChildByName("rank_icon"):setVisible(false)
                        item:getChildByName("rank_panel"):getChildByName("rank_text"):setVisible(true)   
                        item:getChildByName("rank_panel"):getChildByName("rank_text"):setString(rank)  
                        item:getChildByName("back"):setVisible(false)       
                    else
                        item:getChildByName("rank_icon"):setVisible(true)
                        item:getChildByName("rank_icon"):loadTexture(self:getRankIcon(rank),0)
                        if rank > 3 then
                            item:getChildByName("rank_panel"):getChildByName("rank_text"):setVisible(true)
                            if self.state == 35 then                     
                                item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionX(38)
                                if rank > 100 then
                                    item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionY(50)
                                else
                                    item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionY(43)
                                end
                            elseif self.state == 126 then
                                item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionY(43)
                                item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionX(38)
                            end
                            item:getChildByName("rank_panel"):getChildByName("rank_text"):setString(rank) 
                            item:getChildByName("back"):setVisible(false)     
                        else
                            item:getChildByName("rank_panel"):getChildByName("rank_text"):setVisible(false)                    
                            item:getChildByName("back"):setVisible(true)
                            item:getChildByName("back"):loadTexture("images/icon/rank/back_"..rank..".png",0)
                        end
                    end
                    item:getChildByName("mark_icon"):loadTexture(self:getMarkIcon(i),0)
                    
                 
                    item:getChildByName("short"):setString("["..self.infoList[i]["union_short"].."]")
                    item:getChildByName("union_name"):setString(self.infoList[i]["user_name"])
                    item:getChildByName("alliance_text"):setString(self.infoList[i]["union_name"])
                        
                    item:getChildByName("fight_text"):setString(ff.getFormatMoney(self.infoList[i]["value"]))
                    --item:removeTouchEventListener(showInfo)
                    if self.state == 35 then
                        if dd.uid == self.infoList[i]['user_id'] then
                            item:getChildByName("all_back"):loadTexture("images/icon/rank/block12_on.png",0)
                        end
                    end
                    item:setVisible(true)
                    if table.getn(self.infoList) <= 10 then
                    else    
                        nextpage = true
                    end
                end   
            end    

            if nextpage == true then
                self:getChildByName("rankInfo1"):getChildByName("rankArea"):getInnerContainer():setPositionY(beforey)     
                self:getChildByName("rankInfo1"):getChildByName("rankArea"):refreshView()
                if table.getn(self.infoList) > 0 then
                    self:getChildByName("rankInfo1"):getChildByName("rankArea"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,20)))
                end
            end
        else
            for i=1,table.getn(self.unionList) do
            local rank = self.unionList[i]["rank"]
            if rank ~= nil and rank > self.lastID then 
                self.lastID = rank
                local item = self:getChildByName("rankInfo1"):getChildByName("rankArea"):getChildByTag(i)
                if item == nil then
                    item = self:getChildByName("rankItem"):clone()
                    item:setVisible(true)
                    item:setTag(i)
                    self:getChildByName("rankInfo1"):getChildByName("rankArea"):addChild(item)
                end   
                
                if rank > 999 then
                    item:getChildByName("rank_icon"):setVisible(false)
                    item:getChildByName("rank_panel"):getChildByName("rank_text"):setVisible(true)   
                    item:getChildByName("rank_panel"):getChildByName("rank_text"):setString(rank)
                    item:getChildByName("back"):setVisible(false)        
                else
                    item:getChildByName("rank_icon"):setVisible(true)
                    item:getChildByName("rank_icon"):loadTexture(self:getRankIcon(rank),0)
                    if rank > 3 then
                        item:getChildByName("rank_panel"):getChildByName("rank_text"):setVisible(true)

                        item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionX(33)
                        if rank > 100 then
                            item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionY(53)
                        else
                            item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionY(48)
                        end
                        
                        item:getChildByName("rank_panel"):getChildByName("rank_text"):setString(rank)
                        item:getChildByName("back"):setVisible(false)     
                    else
                        item:getChildByName("back"):setVisible(true)
                        item:getChildByName("back"):loadTexture("images/icon/rank/back_"..rank..".png",0)
                        item:getChildByName("rank_panel"):getChildByName("rank_text"):setVisible(false)
                    end
                end
                item:getChildByName("mark_icon"):loadTexture(self:getMarkIcon(i),0)
                item:getChildByName("union_short"):setString("["..self.unionList[i]["short"].."]")
                item:getChildByName("union_panel"):getChildByName("union_name"):setString(self.unionList[i]["name"])           
                item:getChildByName("fight_text"):setString(ff.getFormatMoney(self.unionList[i]["power"]))
                --if self.state == 4 or self.state == 5 then
                    if dd.myUnion:getLong(1,'unionid') == self.unionList[i]['unionid'] then
                        item:getChildByName("all_back"):loadTexture("images/icon/rank/block12_on.png",0)
                    end
                --end
                item:setVisible(true)
                if rank <= 10 then

                else    
                    nextpage = true
                end
                --item:removeTouchEventListener(showUnionInfo)
            end    
        end    
        if nextpage == true then
            self:getChildByName("rankInfo1"):getChildByName("rankArea"):getInnerContainer():setPositionY(beforey)
            self:getChildByName("rankInfo1"):getChildByName("rankArea"):refreshView()
            if table.getn(self.unionList) > 0 then
                self:getChildByName("rankInfo1"):getChildByName("rankArea"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,20)))
            end
        end  
        end
    end
end
function personRankLayer:getRankIcon(rank)
    if self.type == 1 then
        if self.state == 2 or self.state == 3 then
            if rank <= 3 then
                return "images/icon/rank/"..rank..".png"
            elseif rank <= 10 then
                return "images/icon/rank/tag01_rank.png"
            elseif rank <= 100 then
                return "images/icon/rank/tag02_rank.png"
            elseif rank <= 999 then
                return "images/icon/rank/tag03_rank.png"
            end
            
        elseif self.state == 4 or self.state == 5 then
            if rank <= 3 then
                return "images/icon/rank/no"..rank..".png"
            elseif rank <= 10 then
                return "images/icon/rank/tag01_union.png"
            elseif rank <= 100 then
                return "images/icon/rank/tag02_union.png"
            elseif rank <= 999 then
                return "images/icon/rank/tag03_union.png"
            end
        end
    else
        if self.state ==35 then
            if rank <= 3 then
                return "images/icon/rank/"..rank..".png"
            elseif rank <= 10 then
                return "images/icon/rank/tag01_rank.png"
            elseif rank <= 100 then
                return "images/icon/rank/tag02_rank.png"
            elseif rank <= 999 then
                return "images/icon/rank/tag03_rank.png"
            end
            
        elseif self.state == 126 then
            if rank <= 3 then
                return "images/icon/rank/no"..rank..".png"
            elseif rank <= 10 then
                return "images/icon/rank/tag01_union.png"
            elseif rank <= 100 then
                return "images/icon/rank/tag02_union.png"
            elseif rank <= 999 then
                return "images/icon/rank/tag03_union.png"
            end
        end
    end
end

function personRankLayer:getMarkIcon(i)
    if self.type == 1 then
        if self.state == 2 or self.state == 3 then
            if table.getn(self.infoList) >= i then
                return dd.getPlayerIcon(self.infoList[i]["user_pic"])
            else
                return dd.getPlayerIcon(nil)
            end
        elseif self.state == 4 or self.state == 5 then
            if table.getn(self.unionList) >= i then
                return dd.getUnionIcon(self.unionList[i]["totem"])
            else
                return dd.getUnionIcon(nil)
            end
        end
    else
        if self.state == 35 then
            if table.getn(self.infoList) >= i then
                return dd.getPlayerIcon(self.infoList[i]["user_pic"])
            else
                return dd.getPlayerIcon(nil)
            end
        elseif self.state == 126 then
            if table.getn(self.unionList) >= i then
                return dd.getUnionIcon(self.unionList[i]["totem"])
            else
                return dd.getUnionIcon(nil)
            end
        end
    end
end
function personRankLayer:backGetUserRankInfo(ret)
    if ret[1] == 0 then
        self.mainRankInfo = ret[2]
        self:updateMainView()
    else
        dd.showPopTip(ret[1])
    end
end
function personRankLayer:backGetRankAlly(params)
    cclog(".................")
    local code = params[1]
    if code == 0 then
        self.ifLastPage = params[3]
        self.myRank = params[6]
        cclog("state:"..self.state.."  rank:"..self.myRank)
        self:freshMyRank()
        local datas = params[5]
        if datas ~= nil then
            for i=1,datas:rowCount() do
                local row = table.getn(self.unionList) + 1
                self.unionList[row] = {}
                self.unionList[row]["rank"] = datas:getLong(i,"rank")
                self.unionList[row]["unionid"] = datas:getLong(i,"unionid")
                self.unionList[row]["short"] = datas:getString(i,"short")
                self.unionList[row]["name"] = datas:getString(i,"name")
                self.unionList[row]["totem"] = datas:getLong(i,"totem")
                self.unionList[row]["rels"] = datas:getLong(i,"rels")
                self.unionList[row]["power"] = datas:getSuperLong(i,"power")                
                self.unionList[row]["members"] = datas:getLong(i,"members")
                self.unionList[row]["memberMax"] = datas:getLong(i,"memberMax")
                self.unionList[row]["applying"] = datas:getLong(i,"applying")
                self.unionList[row]["inviting"] = datas:getLong(i,"inviting")
            end
        end
        if datas ~= nil then
            self:updatePage()
        else
            self:showWaiting(false)
        end    
    else
        dd.showPopTip(code)        
    end
end
function personRankLayer:updatePage()
    self:showWaiting(false)
    local nextpage = false
    local tick = 1
    
    local function showUnionInfo(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then        
            local key = sender:getTag()
            if self.unionList[key]["short"] ~= nil then
                pop.onShowPopDialog("unionInfo",self,self.unionList[key]["short"])
            end
            AudioEngine.playEffect(ff.sounds[109])
        end
    end
    local beforey = self:getChildByName("rankInfo"):getChildByName("rankArea"):getInnerContainer():getPositionY()

    for i=1,table.getn(self.unionList) do
        local rank = self.unionList[i]["rank"]
        if rank ~= nil and rank > self.lastID then 
            self.lastID = rank
            local item = self:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(i)
            if item == nil then
                item = self:getChildByName("rankItem"):clone()
                item:setVisible(true)
                item:setTag(i)
                self:getChildByName("rankInfo"):getChildByName("rankArea"):addChild(item)
            end   
            
            if rank > 999 then
                item:getChildByName("rank_icon"):setVisible(false)
                item:getChildByName("rank_panel"):getChildByName("rank_text"):setVisible(true)   
                item:getChildByName("rank_panel"):getChildByName("rank_text"):setString(rank)
                item:getChildByName("back"):setVisible(false)        
            else
                item:getChildByName("rank_icon"):setVisible(true)
                item:getChildByName("rank_icon"):loadTexture(self:getRankIcon(rank),0)
                if rank > 3 then
                    item:getChildByName("rank_panel"):getChildByName("rank_text"):setVisible(true)
                    if self.state == 2 or self.state == 3 then
                        item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionY(39)
                        item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionX(39)
                    elseif self.state == 4 or self.state == 5 then
                        item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionX(33)
                        if rank > 100 then
                            item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionY(53)
                        else
                            item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionY(48)
                        end
                    end
                    item:getChildByName("rank_panel"):getChildByName("rank_text"):setString(rank)
                    item:getChildByName("back"):setVisible(false)     
                else
                    item:getChildByName("back"):setVisible(true)
                    item:getChildByName("back"):loadTexture("images/icon/rank/back_"..rank..".png",0)
                    item:getChildByName("rank_panel"):getChildByName("rank_text"):setVisible(false)
                end
            end
            item:getChildByName("mark_icon"):loadTexture(self:getMarkIcon(i),0)
            item:getChildByName("union_short"):setString("["..self.unionList[i]["short"].."]")
            item:getChildByName("union_panel"):getChildByName("union_name"):setString(self.unionList[i]["name"])           
            item:getChildByName("fight_text"):setString(ff.getFormatMoney(self.unionList[i]["power"]))
            if self.state == 4 or self.state == 5 then
                if dd.myUnion:getLong(1,'unionid') == self.unionList[i]['unionid'] then
                    item:getChildByName("all_back"):loadTexture("images/icon/rank/block12_on.png",0)
                end
            end
            item:setVisible(true)
            if rank <= 10 then

            else    
                nextpage = true
            end
            item:addTouchEventListener(showUnionInfo)
        end    
    end    
    if nextpage == true then
        self:getChildByName("rankInfo"):getChildByName("rankArea"):getInnerContainer():setPositionY(beforey)
        self:getChildByName("rankInfo"):getChildByName("rankArea"):refreshView()
        if table.getn(self.unionList) > 0 then
            self:getChildByName("rankInfo"):getChildByName("rankArea"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,20)))
        end
    end  
end
function personRankLayer:addEvent()
    ff.net:registerEvent(1,dd.Tjg_GetKFActivityRank,function (message)self:GetKFActivityRank(message)end)
    ff.net:registerEvent(1,dd.Tjf_GetRankUser,function (message)self:backGetRankUser(message)end)
    ff.net:registerEvent(1,dd.Tjf_GetUserRankInfo,function (message)self:backGetUserRankInfo(message)end)
    ff.net:registerEvent(3,dd.Tjf_union_GetRankAlly,function (message)self:backGetRankAlly(message)end)
    ff.net:bindProperty(2404,"gold",function ()self.updateGold() end) 
end
--界面显示后调用
function personRankLayer.onStart(sender)
    if sender._init == false then    	
        --先添加10条
        sender:getChildByName("rankItem"):getChildByName("fight_tip"):setString(ff.langString("联盟")..":")
        for i=1,10 do
            local item = sender:getChildByName("rankItem"):clone()
            item:setTag(i)
            sender:getChildByName("rankInfo"):getChildByName("rankArea"):addChild(item)
        end
        sender:getChildByName("rankInfo"):getChildByName("rankArea"):refreshView()

        for i=1,10 do
            local item = sender:getChildByName("rankItem"):clone()
            item:setTag(i)
            sender:getChildByName("rankInfo1"):getChildByName("rankArea"):addChild(item)
        end
        sender:getChildByName("rankInfo1"):getChildByName("rankArea"):refreshView()
    
        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("images/mv/normaleffect.plist")
    
        local mv = cc.Sprite:createWithSpriteFrameName("of_native_loader_progress_01.png")
        local xx = sender:getChildByName("waiting"):getChildByName("label"):getPositionX()
        mv:setContentSize(cc.size(30,30))
        mv:setPosition(cc.p(xx - 30,15))
        mv:setScale(0.4)
    
        sender:getChildByName("waiting"):addChild(mv,1,1)
        for j = 1, 12 do
            local frame = nil
            if j < 10 then
                frame = cache:getSpriteFrame("of_native_loader_progress_0"..j..".png")
            else    
                frame = cache:getSpriteFrame("of_native_loader_progress_"..j..".png")
            end 
            sender.animFrames[j] = frame
        end
        sender._init = true
    end
    sender:addEditBox()
    sender:freshView()   
    sender:goToMain()
end

--界面关闭效果结束后调用
function personRankLayer.onEnd(sender,btns)
    cclog("onEnd:personRankLayer")
    sender:disAll()
    dd.delBackEvent(sender.onReturn)
    ff.net:removeEvent(1,dd.Tjf_GetRankUser)
    ff.net:removeEvent(1,dd.Tjg_GetKFActivityRank)
    ff.net:removeEvent(1,dd.Tjf_GetUserRankInfo)
    ff.net:removeEvent(3,dd.Tjf_union_GetRankAlly)
    ff.net:unbindProperty("gold",2404) 
    
    if ff.platform ~= 1 then
        if sender.type == 1 then
            if table.getn(sender.infoList) > 0 then
                for var=1,table.getn(sender.infoList) do
                    local item = sender:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(var)
                    if item ~= nil then
                        item:getChildByName("rank_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        item:getChildByName("mark_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        item:getChildByName("back"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        item:setVisible(false)
                        if var > 10 then
                            sender:getChildByName("rankInfo"):getChildByName("rankArea"):removeChild(item,true)
                        else
                            sender:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(var):getChildByName("all_back"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        end        
                    end
                end
            elseif table.getn(sender.unionList) > 0 then
                for var=1,table.getn(sender.unionList) do
                    local item = sender:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(var)
                    if item ~= nil then
                        item:getChildByName("rank_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        item:getChildByName("mark_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        item:getChildByName("back"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        item:setVisible(false)
                        if var > 10 then
                            sender:getChildByName("rankInfo"):getChildByName("rankArea"):removeChild(item,true)
                        else
                            sender:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(var):getChildByName("all_back"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        end        
                    end
                end
            end
        else
            if table.getn(sender.infoList) > 0 then
                for var=1,table.getn(sender.infoList) do
                    local item = sender:getChildByName("rankInfo1"):getChildByName("rankArea"):getChildByTag(var)
                    if item ~= nil then
                        item:getChildByName("rank_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        item:getChildByName("mark_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        item:getChildByName("back"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        item:setVisible(false)
                        if var > 10 then
                            sender:getChildByName("rankInfo1"):getChildByName("rankArea"):removeChild(item,true)
                        else
                            sender:getChildByName("rankInfo1"):getChildByName("rankArea"):getChildByTag(var):getChildByName("all_back"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        end        
                    end
                end
            elseif table.getn(sender.unionList) > 0 then
                for var=1,table.getn(sender.unionList) do
                    local item = sender:getChildByName("rankInfo1"):getChildByName("rankArea"):getChildByTag(var)
                    if item ~= nil then
                        item:getChildByName("rank_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        item:getChildByName("mark_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        item:getChildByName("back"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        item:setVisible(false)
                        if var > 10 then
                            sender:getChildByName("rankInfo1"):getChildByName("rankArea"):removeChild(item,true)
                        else
                            sender:getChildByName("rankInfo1"):getChildByName("rankArea"):getChildByTag(var):getChildByName("all_back"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        end        
                    end
                end
            end
        end
    end
    sender.state = 1 -- 1=主面板 2=个人战力排行 3=个人击杀排行 4=联盟战力排行 5=联盟击杀排行
    sender.ifLastPage = 0--0=否1=是
    sender.lastID = 0
    sender.infoList = {} 
    sender.unionList = {} 
    sender.animFrames = {}    
    sender:getChildByName("rankInfo"):getChildByName("rankArea"):scrollToTop(0.01,false)
    
    if btns == nil then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:unSelectBtns()
        end 
    end
end
--界面即将播放显示缓动时调用，返回false界面显示将终止
function personRankLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("icon"),sender:getChildByName("topArea"):getChildByName("add_btn"))
    if sender.type == 1 then
        sender:getMainRankInfo()
    end
    return true
end

function personRankLayer:onClose()
    if self.type == 1 then
        if self.state ~= 1 then
            if self.state == 5 or self.state == 4 then
                local widget = pop.getDialog("unionInfo")
                if widget and self:getChildByTag(10008) and pop.isShowing("unionInfo") then
                    pop.onClosePopDialog("unionInfo")
                    return true
                end
            end
            self:goToMain()
            --回到主界面
            return true
        else
            return false
        end
    else
        return false
    end
    return false
end
function personRankLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("personRank")
        if widget~=nil and widget:getChildByName("waiting"):isVisible() then
            return
        end
        if widget~=nil and widget:onClose() == false then
            pop.onClosePopDialog("personRank")
        end    
    end
end
function onShowPersonRank(widget,type)
    local layer = personRankLayer.extend(widget)
    if type == nil then
        type = 1 
    end
    layer.type = type
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end