ActivityneiLayer = class("ActivityneiLayer")
ActivityneiLayer._name = "Activitynei"
ActivityneiLayer._init = false
ActivityneiLayer._type = 1 

function ActivityneiLayer.extend( target )
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target,t)
    end
    setmetatable(t,ActivityneiLayer)
    return target
    -- body
end

function ActivityneiLayer:onAutoSize()
    local hh = ff.height
    self:setContentSize(cc.size(720,hh))
    self:getChildByName("back"):setContentSize(cc.size(720,hh))
    self:getChildByName("back"):setPositionY(0)
    self:getChildByName("top"):setPositionY(hh - 105)
    self:getChildByName("list"):setContentSize(cc.size(720,hh-105))
    self:getChildByName("list"):setPositionY(0)
    self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    self:getChildByName("item"):getChildByName("reward"):addTouchEventListener(self.onPop)
    self:getChildByName("item"):getChildByName("Image_73"):addTouchEventListener(self.onPop)
end

function onShowActivitynei( widget ,id,info)
    -- body
    local layer = ActivityneiLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer._id = id
    layer._info = info
    layer:onInit()
    return layer
end

function ActivityneiLayer:onInit( )
    -- body
    if self._init == false then
        self:onAutoSize()
        self._init = true
    end
    self:initDate()

    self.updateGold()
 
end

function ActivityneiLayer.update( sender )
    if sender._Cfg_Activity[sender._id] ~= nil then

        local title = sender:getChildByName("list"):getChildByTag(1)
        if title ~= nil then
            local time = tonumber(sender._info[sender._id]["endTime"]) - dd.getServerTime()
            title:getChildByName("info"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
        end
    end
    
end


function ActivityneiLayer:initDate(  )
    self._Cfg_Activity = {}
    local propData1 = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_level_activity`")
    for i=1, propData1:rowCount() do
       local id = tonumber(propData1:getString(i, "id"))
       self._Cfg_Activity[id]={}
       self._Cfg_Activity[id]['target1'] = tonumber(propData1:getString(i, "target1"))
       self._Cfg_Activity[id]['num1'] = tonumber(propData1:getString(i, "number1"))
       self._Cfg_Activity[id]['reward1'] = propData1:getString(i, "reward1")
       self._Cfg_Activity[id]['target2'] = tonumber(propData1:getString(i, "target2"))
       self._Cfg_Activity[id]['num2'] = tonumber(propData1:getString(i, "number2"))
       self._Cfg_Activity[id]['reward2'] = propData1:getString(i, "reward2")
       self._Cfg_Activity[id]['target3'] = tonumber(propData1:getString(i, "target3"))
       self._Cfg_Activity[id]['num3'] = tonumber(propData1:getString(i, "number3"))
       self._Cfg_Activity[id]['reward3'] = propData1:getString(i, "reward3")
       self._Cfg_Activity[id]['target4'] = tonumber(propData1:getString(i, "target4"))
       self._Cfg_Activity[id]['num4'] = tonumber(propData1:getString(i, "number4"))
       self._Cfg_Activity[id]['reward4'] = propData1:getString(i, "reward4")
       self._Cfg_Activity[id]['target5'] = tonumber(propData1:getString(i, "target5"))
       self._Cfg_Activity[id]['num5'] = tonumber(propData1:getString(i, "number5"))
       self._Cfg_Activity[id]['reward5'] = propData1:getString(i, "reward5")
       self._Cfg_Activity[id]['target6'] = tonumber(propData1:getString(i, "target6"))
       self._Cfg_Activity[id]['num6'] = tonumber(propData1:getString(i, "number6"))
       self._Cfg_Activity[id]['reward6'] = propData1:getString(i, "reward6")
       self._Cfg_Activity[id]['target7'] = tonumber(propData1:getString(i, "target7"))
       self._Cfg_Activity[id]['num7'] = tonumber(propData1:getString(i, "number7"))
       self._Cfg_Activity[id]['reward7'] = propData1:getString(i, "reward7")
       self._Cfg_Activity[id]['target8'] = tonumber(propData1:getString(i, "target8"))
       self._Cfg_Activity[id]['num8'] = tonumber(propData1:getString(i, "number8"))
       self._Cfg_Activity[id]['reward8'] = propData1:getString(i, "reward8")

       if ff.lang == -1 then
            self._Cfg_Activity[id]['name']   = propData1:getString(i, "name")
            self._Cfg_Activity[id]['disc1']   = propData1:getString(i, "description1")
            self._Cfg_Activity[id]['disc2']   = propData1:getString(i, "description2")
        else    
            self._Cfg_Activity[id]['name']   = tonumber(propData1:getString(i, "name_lan"))
            self._Cfg_Activity[id]['disc1']   = tonumber(propData1:getString(i, "description_lan1"))
            self._Cfg_Activity[id]['disc2']   = tonumber(propData1:getString(i, "description_lan2"))
         
        end
    end
    propData1:clear()
end



function ActivityneiLayer.onPop(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then    
        local widget = pop.getDialog("Activitynei")
        local id     = sender:getTag()

        local gifts = {}
        local giftInfo =Split(widget._Cfg_Activity[widget._id]['reward'..tostring(id)],'|')
                
        for k,v in pairs(giftInfo) do
            local gift =Split(v,'%^') 
            gifts[k] = {}
            gifts[k]["type"]  = tonumber(gift[1])
            gifts[k]["id"]    = tonumber(gift[2])
            gifts[k]["count"] = tonumber(gift[3])  
        end

        pop.onShowPopDialog("gifts",gifts,nil)    
    end
end

function ActivityneiLayer.onReturn( sender,eventType )
    -- body
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("Activitynei")
            if widget == nil then
                return
            end
        pop.onClosePopDialog("Activitynei")
    end
end

function ActivityneiLayer:showList(  )
    if self._Cfg_Activity[self._id] ~= nil then
        local title = self:getChildByName("title"):clone()
        title:setVisible(true)
        title:setTag(1)
        self:getChildByName("list"):pushBackCustomItem(title)
        title:getChildByName("title"):getChildByName("name"):setString(ff.langString(self._Cfg_Activity[self._id]['name']))
        if self._id == 1 then
            title:getChildByName("info"):getChildByName("my"):setString(ff.langString("我的进度："))
            if self._info[self._id]["point"] >= self._Cfg_Activity[self._id]['target4'] then
                title:getChildByName("info"):getChildByName("mypoint"):setString(ff.langString("已全部达成"))
            else
                title:getChildByName("info"):getChildByName("mypoint"):setString("LV."..self._info[self._id]["point"])
            end
        elseif self._id ==2 then
            title:getChildByName("info"):getChildByName("my"):setString(ff.langString("我的进度："))
            if self._info[self._id]["point"] >= self._Cfg_Activity[self._id]['target4'] then
                title:getChildByName("info"):getChildByName("mypoint"):setString(ff.langString("已全部达成"))
            else
                title:getChildByName("info"):getChildByName("mypoint"):setString(self._info[self._id]["point"])
            end
        end

        
        local time = tonumber(self._info[self._id]["endTime"]) - dd.getServerTime()
        title:getChildByName("info"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
        title:getChildByName("info"):getChildByName("info"):setString(ff.langString(self._Cfg_Activity[self._id]['disc1'])..ff.langString(self._Cfg_Activity[self._id]['disc2']))

        local jindu = self:getChildByName("jindu"):clone()
        jindu:setTag(2)
        jindu:setVisible(true)
        self:getChildByName("list"):pushBackCustomItem(jindu)
        if self._Cfg_Activity[self._id]['target5'] ~= 0 then

        else
            jindu:getChildByName("info5"):setVisible(false)
            jindu:getChildByName("info4"):setVisible(true)
            if self._id == 1 then
                for i=1,4 do
                    jindu:getChildByName("info4"):getChildByName("item"..tostring(i)):getChildByName("point"):setString(self._info[self._id]["player"..tostring(i)].."/"..self._info[self._id]["Max"..tostring(i)])
                    jindu:getChildByName("info4"):getChildByName("item"..tostring(i)):getChildByName("level"):setString("LV."..tostring(self._Cfg_Activity[self._id]['target'..tostring(i)]))
                end

            elseif self._id ==2 then
                for i=1,4 do
                    jindu:getChildByName("info4"):getChildByName("item"..tostring(i)):getChildByName("point"):setString(self._info[self._id]["player"..tostring(i)].."/"..self._info[self._id]["Max"..tostring(i)])
                    jindu:getChildByName("info4"):getChildByName("item"..tostring(i)):getChildByName("level"):setString(tostring(self._Cfg_Activity[self._id]['target'..tostring(i)]))
                end
            end
        end 
        local per = 0
        if self._info[self._id]["point"] < self._Cfg_Activity[self._id]['target1'] then
            per = self._info[self._id]["point"]  * 25 / self._Cfg_Activity[self._id]['target1'] 

        elseif self._info[self._id]["point"] >= self._Cfg_Activity[self._id]['target1'] and self._info[self._id]["point"] < self._Cfg_Activity[self._id]['target2'] then
            per =  (self._info[self._id]["point"] - self._Cfg_Activity[self._id]['target1'] ) * 25 /  (self._Cfg_Activity[self._id]['target2'] - self._Cfg_Activity[self._id]['target1'])  + 25
        elseif self._info[self._id]["point"] >= self._Cfg_Activity[self._id]['target2'] and self._info[self._id]["point"] < self._Cfg_Activity[self._id]['target3'] then
            per =  (self._info[self._id]["point"] - self._Cfg_Activity[self._id]['target2'] ) * 25 / (self._Cfg_Activity[self._id]['target3'] - self._Cfg_Activity[self._id]['target2'])  + 50
            
        elseif self._info[self._id]["point"] >= self._Cfg_Activity[self._id]['target3'] and self._info[self._id]["point"] < self._Cfg_Activity[self._id]['target4'] then
            per =  (self._info[self._id]["point"] - self._Cfg_Activity[self._id]['target3'] ) * 25 / (self._Cfg_Activity[self._id]['target4'] - self._Cfg_Activity[self._id]['target3'])  + 75

        elseif self._info[self._id]["point"] >= self._Cfg_Activity[self._id]['target4'] then
            per = 100
        end
        
        jindu:getChildByName("bar"):getChildByName("ProgressBar"):setPercent(per)
        jindu:getChildByName("info4"):requestDoLayout()


        local panel = self:getChildByName("rongqi"):clone()
        panel:setTag(3)
        panel:setVisible(true)
        
        local hh = 0
        if self._Cfg_Activity[self._id]['target5'] ~= 0 then

        else
            for i=1,4 do
                
                local j = 5 - i 
                local item = self:getChildByName("item"):clone()
                item:setVisible(true)
                panel:addChild(item)
                item:setTag(j)
                item:getChildByName("reward"):setTag(j)
                item:getChildByName("Image_73"):setTag(j)
                item:setPosition(cc.p(0,hh))
                hh = hh + 155
                panel:setContentSize(cc.size(720,hh))

                if i == 1 then
                    item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ico_ac1.png",1))
                    item:getChildByName("num"):setVisible(false)
                elseif i ==2 then
                    item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ico_ac2.png",1))
                    item:getChildByName("num"):setVisible(false)
                else
                    item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ico_ac3.png",1))
                    item:getChildByName("num"):setVisible(true)
                    item:getChildByName("num"):setString(tostring(i))
                end
                if self._id == 1 then
                    item:getChildByName("need"):setString("LV."..tostring(self._Cfg_Activity[self._id]['target'..tostring(j)]))
                elseif self._id == 2 then
                    item:getChildByName("need"):setString(tostring(self._Cfg_Activity[self._id]['target'..tostring(j)]))

                end
                local giftInfo =Split(self._Cfg_Activity[self._id]['reward'..tostring(j)],'|')
                
                for k,v in pairs(giftInfo) do
                    local gift =Split(v,'%^') 
                    local jiang = item:getChildByName("item"..tostring(k))
                    if jiang ~= nil then
                        
                        jiang:getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                        jiang:getChildByName("count"):setString(gift[3])
                    end
                end
            end
    

            local title = self:getChildByName("howto"):clone()
            title:setVisible(true)
            panel:addChild(title)
            title:setTag(99)
            title:setPosition(cc.p(0,hh+3))
            hh = hh + 48+3
            panel:setContentSize(cc.size(720,hh))

            self:getChildByName("list"):pushBackCustomItem(panel)
        end 
        self:getChildByName("list"):jumpToTop()
    end
    
end

function ActivityneiLayer.onEnd( sender )
    -- body
    sender:getChildByName("list"):removeAllChildren(true)
    dd.delBackEvent()
    ff.net:unbindProperty("gold",2321)
    sender:stopAllActions()
end

function ActivityneiLayer.onBefore( sender)
  -- body
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
    
    schedule(sender, sender.update,1)
    sender:showList()
end

function ActivityneiLayer.onStart( sender )
    ff.net:bindProperty(2321,"gold",sender.updateGold)
end

function ActivityneiLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("Activitynei")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end
