ActivityneiExxLayer = class("ActivityneiExxLayer")
ActivityneiExxLayer._name = "ActivityneiExx"
ActivityneiExxLayer._init = false


function ActivityneiExxLayer.extend( target )
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target,t)
    end
    setmetatable(t,ActivityneiExxLayer)
    return target
    -- body
end

function ActivityneiExxLayer:onAutoSize()
    local hh = ff.height
    self:setContentSize(cc.size(720,hh))
    self:getChildByName("top"):setPositionY(hh - 105)
    self:getChildByName("back"):setContentSize(cc.size(720,hh))
    self:getChildByName("back"):setPositionY(0)

    self:getChildByName("list"):setContentSize(cc.size(720,hh-105))
    self:getChildByName("list"):setPositionY(0)

    self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)

end

function onShowActivityneiExx( widget)
    -- body
    local layer = ActivityneiExxLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end

function ActivityneiExxLayer:onInit( )
    -- body
    if self._init == false then
        self:onAutoSize()
        self._init = true
    end
    
    self.updateGold()
end

function ActivityneiExxLayer.update( sender )
    
end

function ActivityneiExxLayer.onReturn( sender,eventType )
    -- body
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("ActivityneiExx")
            if widget == nil then
                return
            end
            
        pop.onClosePopDialog("ActivityneiExx")
    end
end

function ActivityneiExxLayer.onEnd( sender )
    -- body
    
    dd.delBackEvent()

    ff.net:unbindProperty("gold",2350)
    sender:stopAllActions()
end

function ActivityneiExxLayer.onBefore( sender)
  -- body
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
    schedule(sender, sender.update,1)
end

function ActivityneiExxLayer.update( sender )
    if dd.GoldActivity ~= nil and dd.GoldActivity:getLong(1,"startTime")  < dd.getServerTime() and dd.GoldActivity:getLong(1 ,"activityEnd") > dd.getServerTime( ) then
        
        local time = dd.GoldActivity:getLong(1,"activityEnd") - dd.getServerTime()
        if time > 0 then
            sender:getChildByName("list"):getChildByName("info"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
        end 
        sender:getChildByName("list"):getChildByName("info"):getChildByName("mypoint"):setString(":"..dd.GoldActivity:getLong(1,"xiaofeijinbi"))
        sender:getChildByName("list"):getChildByName("info"):getChildByName("my_0_0"):setString(ff.langString("活动奖励")..":"..math.floor(dd.GoldActivity:getLong(1,"xiaofeijinbi") * dd.GoldActivity:getLong(1,"qianfenbi") /1000))
        sender:getChildByName("list"):getChildByName("info"):requestDoLayout()
    end
end

function ActivityneiExxLayer.onStart( sender )
    ff.net:bindProperty(2350,"gold",sender.updateGold)
end

function ActivityneiExxLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("ActivityneiExx")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end
