hechengJumpLayer = class("hechengJumpLayer")
hechengJumpLayer._name = "hechengJump"
hechengJumpLayer._init = false
hechengJumpLayer._tid = 0

function hechengJumpLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,hechengJumpLayer)
	return target
end

function hechengJumpLayer:onInit(  )
	-- body
	if self._init == false then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		self:setPositionY(0)
		self:getChildByName("back"):setContentSize(cc.size(720,hh))
		self:getChildByName("back"):addTouchEventListener(self.onReturn)
		self:getChildByName("top"):setPositionY(hh - 105)
		self:getChildByName("scrollview"):setContentSize(cc.size(720,hh-105))
    	self:getChildByName("scrollview"):setPositionY(0)
    	self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    	self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    	self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("节日庆典"))
		self:getChildByName("item"):getChildByName("sure"):addTouchEventListener(self.onHeCheng)
        self:getChildByName("item"):getChildByName("fsdf"):addTouchEventListener(self.onHeCheng)
        self._init = true
	end
	self.updateGold()
end

function hechengJumpLayer.onStart( sender )
	ff.net:bindProperty(2326,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
    sender:showList()
end

function hechengJumpLayer.onHeCheng( sender,eventType )
	
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("hechengJump")
        if widget == nil then
            return
        end  
        local id = sender:getTag()
        
        if id >= 5521 and id <= 5524 then
            pop.onShowPopDialog("hechengex")
        else
            dd.mainUI:showHeChengView(id)
        end
        
    end   
    
end

function hechengJumpLayer.onBefore( sender )
    ff.net:registerEvent(3,dd.Tjf_ItemExchange,function (message)sender:onItemExchange(message)end)
end

function hechengJumpLayer:onItemExchange(params)
    local code = params[1]
    if code == 0 then      
        self:showList()
        AudioEngine.playEffect(ff.sounds[601])
        if dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("合成成功！"),true)
        end
    else
        --dd.mainUI:onShowCodeTips(code)
    end
end

function hechengJumpLayer.onReturn( sender,eventType )
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("hechengJump")
        if widget == nil then
            return
        end
        if dd.currentLayer._widget ~= nil then
            if dd.currentLayer._widget:getChildByName("hecheng"):isVisible() == true then
                dd.currentLayer._widget:getChildByName("hecheng"):setVisible(false)
                return
            end
        end
        pop.onClosePopDialog("hechengJump")
    end
end

function hechengJumpLayer.onEnd( sender )
    -- body
    ff.net:removeEvent(3,dd.Tjf_ItemExchange)
    dd.delBackEvent(sender.onReturn)
    sender:stopAllActions()
    sender:getChildByName("scrollview"):removeAllChildren(true)
    ff.net:unbindProperty("gold",2326)
end

function onShowhechengJump(widget,tid)
	-- body
    cclog("jinliale!!!!!!!!!!!!!!!!!!!!!!!!!"..tid)
	local layer = hechengJumpLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
    layer._tid = tid
    layer:onInit()
    return layer
end

function hechengJumpLayer:showList(  )

    for k,v in pairs(dd.cfgPropsynthersis) do
        local id = v['target_id']
        if v["Material1"] == self._tid or v["Material2"] == self._tid or v["Material3"] == self._tid or v["Material4"] == self._tid then
            local item = self:getChildByName("scrollview"):getChildByTag(k)
            if item == nil then
                item = self:getChildByName("item"):clone()
                self:getChildByName("scrollview"):pushBackCustomItem(item)
            end
            if item ~= nil then
                
                item:setVisible(true)
                item:setTag(k)
                item:getChildByName("fsdf"):setTag(k)
                item:getChildByName("sure"):setTag(k)
                item:getChildByName("sure"):getChildByName("chu_label"):setString(ff.langString("合成"))
                item:getChildByName("item"):getChildByName("ico"):getChildByName("icon"):loadTexture(dd.getToolsIcon(id),0)
                item:getChildByName("item"):getChildByName("count"):setString(dd.getToolsCount(id))
                item:getChildByName("name"):setString(ff.langString(dd.cfgProp[id]['name']))
                item:getChildByName("info"):setString(ff.langString(dd.cfgProp[id]['tips'],{dd.cfgProp[id]['tips1_lan']}))
                
            end
        end
    end

end

function hechengJumpLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("hechengJump")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end