--vip
local unionGiftLayer = class("unionGift")
unionGiftLayer._name = "unionGift"
unionGiftLayer._init = false
unionGiftLayer._countDown = 0
unionGiftLayer._cfggifts = {}
unionGiftLayer._items = {}

function unionGiftLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, unionGiftLayer)
    return target
end

function unionGiftLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        --self:setContentSize(cc.size(720,hh-221-105 + 8))
    end
end

function unionGiftLayer:onInit()
    if self._init == false then        
        self:getChildByName("view"):getChildByName("giftbbs"):getChildByName("bbs"):setString(
        ff.langString("每当你联盟中的盟友购买金币时所有成员都会获得一份奖励丰厚的礼物.接受礼物将增加礼物点数,提升礼物等级.礼物等级越高联盟礼物的收益越大。"))
        
        --close
        local function onClose(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                pop.onClosePopDialog("unionGift")
            end
        end
        
        --清除
        local function onClear(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                for i=1, dd.myUnionGifts:rowCount() do
                    local id = dd.myUnionGifts:getLong(i,"id")
                    if dd.myUnionGifts:getLong(i,"start") == 0 then --未开启
                        local time = dd.myUnionGifts:getLong(i,"endtime")-dd.getServerTime()
                        if time <= 0 then --过期
                            local message = ff.net:createMessage()
                            message:addCmd(0x141)
                            message:addLong(dd.uid)
                            message:addLong(2) 
                            message:addLong(id)
                            ff.net:rpc(message,false)
                        end
                    else--已开启
                        local message = ff.net:createMessage()
                        message:addCmd(0x141)
                        message:addLong(dd.uid)
                        message:addLong(2) 
                        message:addLong(id)
                        ff.net:rpc(message,false)
                    end
                end
            end
        end
        
        self:getChildByName("view"):getChildByName("close"):addTouchEventListener(onClose)
        self:getChildByName("view"):getChildByName("clean"):addTouchEventListener(onClear)
        --加粗
        self:getChildByName("view"):getChildByName("item"):getChildByName("chu_name"):getVirtualRenderer():enableBold(true)
        --self:onInitCfg()
        self._init = true
    end
    self:onUpdateInfo()
end

function unionGiftLayer:onInitCfg()
    --gift
    local gift = ff.dbmanager:sql_fetch_rows("select * from cfg_league_gift")
    for i=1, gift:rowCount() do
        local id = tonumber(gift:getString(i, "id"))
        self._cfggifts[id] = {}
        if ff.lang == -1 then
            self._cfggifts[id]['name'] = gift:getString(i, "name")
        else
            self._cfggifts[id]['name'] = tonumber(gift:getString(i, "name_lan"))
        end
        self._cfggifts[id]['pic'] = tonumber(gift:getString(i, "pic"))
        self._cfggifts[id]['giftexp'] = tonumber(gift:getString(i, "giftexp"))
        self._cfggifts[id]['drop'] = tonumber(gift:getString(i, "drop"))
    end
    gift:clear()
end

function unionGiftLayer:onUpdateInfo()
    local percent = math.floor(100*dd.myUnion:getLong(1,"boxexp")/dd.myUnion:getLong(1,"boxtotal"))
    if percent >100 then
        percent = 100
    end
    self:getChildByName("view"):getChildByName("level"):getChildByName("level"):setString("LV."..dd.myUnion:getLong(1,"boxlevel"))
    self:getChildByName("view"):getChildByName("level"):getChildByName("point"):setString(dd.myUnion:getLong(1,"boxexp").."/"..dd.myUnion:getLong(1,"boxtotal"))
    self:getChildByName("view"):getChildByName("level"):getChildByName("pro"):setPercent(percent)
end

function unionGiftLayer:onUpdateGiftList()
    local view = self:getChildByName("view"):getChildByName("view"):getChildByName("view")
    view:stopAllActions()
    
    --view:jumpToTop()
    
    local num = dd.myUnionGifts:rowCount()
    local count = 1
    local innerhh = 0
    self._countDown = 0
    local arr1 = { "道具",
         "石油",  --2
         "木材",  --3
         "钢铁",  --4
         "粮食",  --5
         "银币",  --6
         "金币",  --7
         "士兵",  --8
         "英雄经验",--9
         "联盟贡献",--10
         "VIP点数",--11
         "联盟礼物",--12
         "联盟商店",--13
         "联盟基金",
         "晶体"
    }
    if 126*num > 390 then
        view:setInnerContainerSize(cc.size(720,126*num))
        innerhh = 126*num + 4
    else
        view:setInnerContainerSize(cc.size(720,390))
        innerhh = 390
    end
    if num > 0 then
        self:getChildByName("view"):getChildByName("view"):getChildByName("nogift"):setVisible(false)
    else
        self:getChildByName("view"):getChildByName("view"):getChildByName("nogift"):setVisible(true)
    end   
    --for i=1, dd.myUnionGifts:rowCount() do
    local function add_sche()
        
        if count <= dd.myUnionGifts:rowCount() then
            
            local item = self._items[count]
            if item == nil then
                item = self:getChildByName("view"):getChildByName("item"):clone()
                self._items[count] = item
                view:addChild(item)
            end
            local type = dd.myUnionGifts:getLong(count,"type")
            local gid = dd.myUnionGifts:getLong(count,"tid")
            local tid = dd.myUnionGifts:getLong(count,"dropid")  --掉落id
            item:setVisible(true)
            item:setPositionX(15)
            item:setPositionY(innerhh - 126 - (count-1)*126)
            
            item:getChildByName("time"):getChildByName("tips"):setColor(cc.c3b(161,175,175))  
            item:getChildByName("icon"):getChildByName("icon"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            item:getChildByName("openbtn"):getChildByName("icon"):loadTexture(dd.getPathFromUI("gift_ic37.png",1))
            item:getChildByName("cleanbtn"):getChildByName("icon"):loadTexture(dd.getPathFromUI("gift_ic36.png",1))
            --cclog("礼物类型 == "..type.."  "..ff.langString(arr1[type]))
            if dd.myUnionGifts:getLong(count,"start") ~= 0 then
                cclog("礼物类型 == "..type.."  "..ff.langString(arr1[type]))
                item:getChildByName("openbtn"):setVisible(false)
                item:getChildByName("cleanbtn"):setVisible(true)
                item:setTag(count)
                item:getChildByName("time"):getChildByName("time"):setVisible(false)
                item:getChildByName("chu_name"):setString(ff.langString(arr1[type]))
                item:getChildByName("time"):getChildByName("tips"):setString(ff.langString("金币").." x "..dd.myUnionGifts:getLong(count,"gold"))
                if type == 1 then       --道具    
                    item:getChildByName("chu_name"):setString(ff.langString(dd.cfgProp[tid]['name'],{dd.cfgProp[tid]['name1_lan']}).." x "..dd.myUnionGifts:getLong(count,"count"))
                    item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getToolsIcon(tid),0)
                elseif type == 8 then   --士兵
                    item:getChildByName("chu_name"):setString(ff.langString(dd.cfgSoldier[tid]["soldierName"]).." x "..dd.myUnionGifts:getLong(count,"count"))
                    item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getArmyIcon(tid),0)
                elseif type == 12 then  --联盟礼物
                elseif type == 13 then  --联盟商店
                    item:getChildByName("chu_name"):setString(ff.langString(dd.cfgProp[tid]['name'],{dd.cfgProp[tid]['name1_lan']}).." x "..dd.myUnionGifts:getLong(count,"count"))
                    item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getToolsIcon(tid),0)
                elseif type == 14 then --联盟基金
                    item:getChildByName("chu_name"):setString(ff.langString(arr1[type]).." x "..dd.myUnionGifts:getLong(count,"count"))
                    item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/ic14.png",1))
                elseif type == 15 then --晶体
                    item:getChildByName("chu_name"):setString(ff.langString(dd.cfgProp[tid]['name'],{dd.cfgProp[tid]['name1_lan']}).." x "..dd.myUnionGifts:getLong(count,"count"))
                    item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getHuizhangIcon(tid),0)
                else 
                    item:getChildByName("chu_name"):setString(ff.langString(arr1[type]).." x "..dd.myUnionGifts:getLong(count,"count"))
                    if type == 2 then     --石
                        item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/charge/ic01_big.png",0)
                    elseif type == 3 then --木
                        item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/charge/ic02_big.png",0)
                    elseif type == 4 then  --铁
                        item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/charge/ic03_big.png",0)
                    elseif type == 5 then
                        item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/charge/ic04_big.png",0)
                    elseif type == 6 then  --银币
                        item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/charge/ic05_big.png",0)
                    elseif type == 7 then  --金币
                        item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/charge/gold.png",0)
                    elseif type == 9 then  --英雄经验(无效)
                        --item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/uniongift/1.png",0)
                    elseif type == 10 then --联盟贡献
                        item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/charge/unionpoint.png",0)
                    elseif type == 11 then --vip点数
                        item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/charge/vippoint.png",0)
                    end
                end
            else     --未开启
                --cclog("==ssss====="..gid.."=="..count)
                item:getChildByName("chu_name"):setString(ff.langString(dd.cfgUnionGift[gid]['name']))
                item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getUnionGiftIcon(gid),0)
                local time = dd.myUnionGifts:getLong(count,"endtime")-dd.getServerTime()
                if time > 0 then --未过期
                    item:getChildByName("openbtn"):setVisible(true)
                    item:getChildByName("cleanbtn"):setVisible(false)
                    item:getChildByName("time"):getChildByName("tips"):setString(ff.langString("结束剩余时间:"))
                    item:getChildByName("time"):getChildByName("time"):setVisible(true)
                    item:getChildByName("time"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                    item:getChildByName("time"):requestDoLayout()
                    self._countDown = self._countDown + 1
                    --cclog("=="..self._countDown)
                    item:setTag(1000+self._countDown)
                    item.idex = count
                else
                    item:getChildByName("openbtn"):setVisible(false)
                    item:getChildByName("cleanbtn"):setVisible(true)
                    item:getChildByName("time"):getChildByName("tips"):setString(ff.langString("已过期"))
                    item:getChildByName("time"):getChildByName("tips"):setColor(cc.c3b(179,4,24))
                    item:getChildByName("time"):getChildByName("time"):setVisible(false)
                    local effect = ff.Effect:effectGrey()    
                    item:getChildByName("icon"):getChildByName("icon"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState()) 
                end
            end
            item:getChildByName("openbtn"):addTouchEventListener(self.onOpenGift)
            item:getChildByName("cleanbtn"):addTouchEventListener(self.onCleanGift)        
            item:getChildByName("openbtn")._gid = dd.myUnionGifts:getLong(count,"id")
            item:getChildByName("cleanbtn")._gid = dd.myUnionGifts:getLong(count,"id")
            count = count + 1 
        else
            view:stopAllActions()
            for i=count,table.getn(self._items) do
                self._items[i]:setVisible(false)
                self._items[i]:setTag(i)
            end
            cclog("-----------------------------")
            --view:addChild(item)
            --count = count + 1
        end
        
    end

    schedule(view, add_sche,0.01)
end

function unionGiftLayer:onUpdateGiftList_First()
    local view = self:getChildByName("view"):getChildByName("view"):getChildByName("view")
    for i,v in ipairs(self._items) do
        if tolua.isnull(v) then
            self._items[i] = nil
        else
            v:setVisible(false)
            v:setTag(i)
        end
    end
    view:jumpToTop()

    local num = dd.myUnionGifts:rowCount()
    local count = 1
    local innerhh = 0
    self._countDown = 0
    local arr1 = { "道具",
        "石油",  --2
        "木材",  --3
        "钢铁",  --4
        "粮食",  --5
        "银币",  --6
        "金币",  --7
        "士兵",  --8
        "英雄经验",--9
        "联盟贡献",--10
        "VIP点数",--11
        "联盟礼物",--12
        "联盟商店",--13
        "联盟基金",
        "晶体"
    }
    if 126*num > 390 then
        view:setInnerContainerSize(cc.size(720,126*num))
        innerhh = 126*num + 4
    else
        view:setInnerContainerSize(cc.size(720,390))
        innerhh = 390
    end
    if num > 0 then
        self:getChildByName("view"):getChildByName("view"):getChildByName("nogift"):setVisible(false)
    else
        self:getChildByName("view"):getChildByName("view"):getChildByName("nogift"):setVisible(true)
    end   
    --count = row
    if dd.myUnionGifts:rowCount() > 10 then
        for i=1, 10 do
            self:addItem(arr1,innerhh, count)
            count = count + 1
        end
        local function add_sche()
            if count <= dd.myUnionGifts:rowCount() then
                self:addItem(arr1,innerhh, count)
                count = count + 1
            else
                view:stopAllActions()
                cclog("已停止添加脚本 ==========2222 ")
            end
        end
        cclog("开启添加脚本 =========1111 ")
        schedule(view, add_sche,0.01)
    else
        cclog("少于10个 =========aaaa ")
        for i=1, dd.myUnionGifts:rowCount() do
            self:addItem(arr1,innerhh, count, i)
            count = count + 1
        end
    end
end

function unionGiftLayer:addItem(arr1,innerhh, i)
    local item = self._items[i]
    if item == nil then
        item = self:getChildByName("view"):getChildByName("item"):clone()
        self._items[i] = item
        self:getChildByName("view"):getChildByName("view"):getChildByName("view"):addChild(item)
    end
    local type = dd.myUnionGifts:getLong(i,"type")
    local gid = dd.myUnionGifts:getLong(i,"tid")
    local tid = dd.myUnionGifts:getLong(i,"dropid")  --掉落id
    item:setVisible(true)
    item:setPositionX(15)
    item:setPositionY(innerhh - i*126)

    item:getChildByName("time"):getChildByName("tips"):setColor(cc.c3b(161,175,175))  
    item:getChildByName("icon"):getChildByName("icon"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
    item:getChildByName("openbtn"):getChildByName("icon"):loadTexture(dd.getPathFromUI("gift_ic37.png",1))
    item:getChildByName("cleanbtn"):getChildByName("icon"):loadTexture(dd.getPathFromUI("gift_ic36.png",1))
    --cclog("礼物类型 == "..type.."  "..ff.langString(arr1[type]))
    if dd.myUnionGifts:getLong(i,"start") ~= 0 then
        cclog("礼物类型 == "..type.."  "..ff.langString(arr1[type]))
        item:getChildByName("openbtn"):setVisible(false)
        item:getChildByName("cleanbtn"):setVisible(true)
        item:getChildByName("time"):getChildByName("time"):setVisible(false)
        item:getChildByName("chu_name"):setString(ff.langString(arr1[type]))
        item:getChildByName("time"):getChildByName("tips"):setString(ff.langString("金币").." x "..dd.myUnionGifts:getLong(i,"gold"))
        if type == 1 then       --道具    
            item:getChildByName("chu_name"):setString(ff.langString(dd.cfgProp[tid]['name'],{dd.cfgProp[tid]['name1_lan']}).." x "..dd.myUnionGifts:getLong(i,"count"))
            item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getToolsIcon(tid),0)
        elseif type == 8 then   --士兵
            item:getChildByName("chu_name"):setString(ff.langString(dd.cfgSoldier[tid]["soldierName"]).." x "..dd.myUnionGifts:getLong(i,"count"))
            item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getArmyIcon(tid),0)
        elseif type == 12 then  --联盟礼物
        elseif type == 13 then  --联盟商店
            item:getChildByName("chu_name"):setString(ff.langString(dd.cfgProp[tid]['name'],{dd.cfgProp[tid]['name1_lan']}).." x "..dd.myUnionGifts:getLong(i,"count"))
            item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getToolsIcon(tid),0)
        elseif type == 14 then --联盟基金
            item:getChildByName("chu_name"):setString(ff.langString(arr1[type]).." x "..dd.myUnionGifts:getLong(i,"count"))
            item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/ic14.png",1))
        elseif type == 15 then --晶体
            item:getChildByName("chu_name"):setString(ff.langString(dd.cfgProp[tid]['name'],{dd.cfgProp[tid]['name1_lan']}).." x "..dd.myUnionGifts:getLong(i,"count"))
            item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getHuizhangIcon(tid),0)
        else 
            item:getChildByName("chu_name"):setString(ff.langString(arr1[type]).." x "..dd.myUnionGifts:getLong(i,"count"))
            if type == 2 then     --石
                item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/res/ic01_bk.png",0)
            elseif type == 3 then --木
                item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/res/ic02_bk.png",0)
            elseif type == 4 then  --铁
                item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/res/ic03_bk.png",0)
            elseif type == 5 then
                item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/res/ic04_bk.png",0)
            elseif type == 6 then  --银币
                item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/res/ic05_bk.png",0)
            elseif type == 7 then  --金币
                item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/charge/gold.png",0)
            elseif type == 9 then  --英雄经验(无效)
            --item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/uniongift/1.png",0)
            elseif type == 10 then --联盟贡献
                item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/charge/unionpoint.png",0)
            elseif type == 11 then --vip点数
                item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/charge/vippoint.png",0)
            end
        end
    else     --未开启
        item:getChildByName("chu_name"):setString(ff.langString(dd.cfgUnionGift[gid]['name']))
        item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getUnionGiftIcon(gid),0)
        local time = dd.myUnionGifts:getLong(i,"endtime")-dd.getServerTime()
        if time > 0 then --未过期
            item:getChildByName("openbtn"):setVisible(true)
            item:getChildByName("cleanbtn"):setVisible(false)
            item:getChildByName("time"):getChildByName("tips"):setString(ff.langString("结束剩余时间:"))
            item:getChildByName("time"):getChildByName("time"):setVisible(true)
            item:getChildByName("time"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
            self._countDown = self._countDown + 1
            item:setTag(1000+self._countDown)
            item.idex = i
        else
            item:getChildByName("openbtn"):setVisible(false)
            item:getChildByName("cleanbtn"):setVisible(true)
            item:getChildByName("time"):getChildByName("tips"):setString(ff.langString("已过期"))
            item:getChildByName("time"):getChildByName("tips"):setColor(cc.c3b(179,4,24))
            item:getChildByName("time"):getChildByName("time"):setVisible(false)
            local effect = ff.Effect:effectGrey()    
            item:getChildByName("icon"):getChildByName("icon"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState()) 
        end
    end
    item:getChildByName("openbtn"):addTouchEventListener(self.onOpenGift)
    item:getChildByName("cleanbtn"):addTouchEventListener(self.onCleanGift)        
    item:getChildByName("openbtn")._gid = dd.myUnionGifts:getLong(i,"id")
    item:getChildByName("cleanbtn")._gid = dd.myUnionGifts:getLong(i,"id")
end

function unionGiftLayer:onUpdateView()
    self.onEnd(self)
    self:onInit()
    self.onBefore(self)
    self.onStart(self)
end

function unionGiftLayer.showAction()
    local sender = pop.getDialog("unionGift")
    local view = sender:getChildByName("view"):getChildByName("view"):getChildByName("view")
    for i=1, sender._countDown do
        local item = view:getChildByTag(1000 + i)
        if item ~= nil and item.idex ~= nil and item.idex > 0 and item.idex <= dd.myUnionGifts:rowCount() then
            --cclog("===="..item.idex)
            local time = dd.myUnionGifts:getLong(item.idex,"endtime")-dd.getServerTime()
            if time > 0 then
                item:getChildByName("time"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
            else
                sender:onUpdateGiftList()
            end
        end
    end
end

function unionGiftLayer.onOpenGift(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        sender:setTouchEnabled(false)
        local message = ff.net:createMessage()
        message:addCmd(0x141)
        message:addLong(dd.uid)
        message:addLong(1) 
        message:addLong(sender._gid)
        ff.net:rpc(message,false)
        local function sched()
            sender:setTouchEnabled(true)
        end 
        performWithDelay(sender,sched,0.5)
    end
end

function unionGiftLayer.onCleanGift(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local message = ff.net:createMessage()
        message:addCmd(0x141)
        message:addLong(dd.uid)
        message:addLong(2) 
        message:addLong(sender._gid)
        ff.net:rpc(message,false)
    end
end

function unionGiftLayer:onUnionGiftAction(params)
    local code = params[1]
    if code == 0 then
        self:getChildByName("view"):getChildByName("view"):getChildByName("view"):stopAllActions()
        --cclog("888888888888888888888888888888")
        self:onUpdateGiftList()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function unionGiftLayer:onTestCharge(params)
    local code = params[1]
    if code == 0 then
        self:onUpdateInfo()
        self:onUpdateGiftList()
    end
end

function unionGiftLayer.onStart(sender)
    ff.net:registerEvent(4,dd.Tjf_union_unionGiftAction, function (message)sender:onUnionGiftAction(message)end)
    ff.net:registerEvent(502,dd.Tjf_charge_TestCharge, function (message)sender:onTestCharge(message)end)
    schedule(sender, sender.showAction,1)
    sender:onUpdateGiftList_First()
end

function unionGiftLayer.onBefore(sender)
    sender:getChildByName("view"):getChildByName("view"):getChildByName("view"):jumpToTop()
    return true
end

function unionGiftLayer.onEnd(sender)
    dd.delBackEvent()
    sender:stopAllActions()
    sender:getChildByName("view"):getChildByName("view"):getChildByName("view"):stopAllActions()
    ff.net:removeEvent(4,dd.Tjf_union_unionGiftAction)
    ff.net:removeEvent(502,dd.Tjf_charge_TestCharge)
    if ff.platform ~= 1 then
        for i,item in ipairs(sender._items) do
            if item then
                item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("openbtn"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("cleanbtn"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end
    end
    local widge = pop.getDialog("union")
    if widge ~= nil then
        --widge:updateGiftList()
        widge:closeGiftClear()
    end
end

function unionGiftLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("unionGift")
    if widget then
        pop.onClosePopDialog("unionGift")
    end
end

function onShowUnionGiftLayer(widget, parent)
    local layer = unionGiftLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onAutoSize()
    layer:onInit()
    return layer
end