unionMemberLayer   = class("unionMemberLayer")
unionMemberLayer._name = "unionMember"
unionMemberLayer._init = false
unionMemberLayer._parent = nil

unionMemberLayer._state = {0,0,0,0,0,0}
unionMemberLayer._member= {0,0,0,0,0,1}
unionMemberLayer._members = {}
unionMemberLayer.selectUid = 0
unionMemberLayer.selectLevel = 0
unionMemberLayer.r5Max = 2
unionMemberLayer.r4Max = 4
unionMemberLayer.r3Page = 10
unionMemberLayer.r2Page = 10
unionMemberLayer.r1Page = 10

function unionMemberLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, unionMemberLayer)
    return target
end
function unionMemberLayer:onInit()
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))

        self:getChildByName("lists"):setContentSize(cc.size(720,hh - 105 - 178))
        self:getChildByName("lists"):setPositionY(176)
        self:getChildByName("mask"):setContentSize(cc.size(720,hh - 105))
        self:getChildByName("mask"):setPositionY(0)

        self:getChildByName("back"):setContentSize(cc.size(720,hh))
        self:getChildByName("back"):setPosition(cc.p(0,0))

        self:getChildByName("ulevel"):setPositionY(0)
        self:getChildByName("user"):setPositionY(0)
        
        self:getChildByName("lists"):getChildByName("rank6"):getChildByName("title"):getChildByName("show"):addTouchEventListener(self.selectGroup)
        self:getChildByName("lists"):getChildByName("rank5"):getChildByName("title"):getChildByName("show"):addTouchEventListener(self.selectGroup)
        self:getChildByName("lists"):getChildByName("rank4"):getChildByName("title"):getChildByName("show"):addTouchEventListener(self.selectGroup)
        self:getChildByName("lists"):getChildByName("rank3"):getChildByName("title"):getChildByName("show"):addTouchEventListener(self.selectGroup)
        self:getChildByName("lists"):getChildByName("rank2"):getChildByName("title"):getChildByName("show"):addTouchEventListener(self.selectGroup)
        self:getChildByName("lists"):getChildByName("rank1"):getChildByName("title"):getChildByName("show"):addTouchEventListener(self.selectGroup)

        self:getChildByName("lists"):getChildByName("rank6"):getChildByName("title"):addTouchEventListener(self.selectGroup2)
        self:getChildByName("lists"):getChildByName("rank5"):getChildByName("title"):addTouchEventListener(self.selectGroup2)
        self:getChildByName("lists"):getChildByName("rank4"):getChildByName("title"):addTouchEventListener(self.selectGroup2)
        self:getChildByName("lists"):getChildByName("rank3"):getChildByName("title"):addTouchEventListener(self.selectGroup2)
        self:getChildByName("lists"):getChildByName("rank2"):getChildByName("title"):addTouchEventListener(self.selectGroup2)
        self:getChildByName("lists"):getChildByName("rank1"):getChildByName("title"):addTouchEventListener(self.selectGroup2)


        self:getChildByName("lists"):getChildByName("rank6"):getChildByName("leader"):addTouchEventListener(self.onShowUser)
        self:getChildByName("lists"):getChildByName("rank5"):getChildByName("lists"):getChildByName("item1"):addTouchEventListener(self.onShowUser)
        self:getChildByName("lists"):getChildByName("rank5"):getChildByName("lists"):getChildByName("item2"):addTouchEventListener(self.onShowUser)

        self:getChildByName("lists"):getChildByName("rank6"):getChildByName("leader"):setTag(0)
        self:getChildByName("lists"):getChildByName("rank5"):getChildByName("lists"):getChildByName("item1"):setTag(0)
        self:getChildByName("lists"):getChildByName("rank5"):getChildByName("lists"):getChildByName("item2"):setTag(0)

        self:getChildByName("user"):getChildByName("close"):addTouchEventListener(self.closeUser)
        self:getChildByName("user"):getChildByName("view"):getChildByName("levelup"):addTouchEventListener(self.levelUp)
        self:getChildByName("user"):getChildByName("view"):getChildByName("leveldown"):addTouchEventListener(self.levelDown)
        self:getChildByName("user"):getChildByName("view"):getChildByName("kick"):addTouchEventListener(self.kickMember)
        self:getChildByName("user"):getChildByName("view"):getChildByName("addarmys"):addTouchEventListener(self.addArmys)
        self:getChildByName("user"):getChildByName("view"):getChildByName("detail"):addTouchEventListener(self.showInfo)
        self:getChildByName("user"):getChildByName("view"):getChildByName("trans_btn"):addTouchEventListener(self.transport)
        
        
        self:getChildByName("lists"):getChildByName("rank6"):getChildByName("help"):addTouchEventListener(self.onShowHelp)
        self:getChildByName("ulevel"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.closeRank)
        self:getChildByName("bottom"):getChildByName("power_btn"):addTouchEventListener(self.onShowHelp)
        self:getChildByName("bottom"):getChildByName("mail_btn"):addTouchEventListener(self.onMail)
        --top条
        self:getChildByName("top"):setPositionY(ff.height - 105)
        self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onClose)
        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    end
    self.r4Max = 4 + self:getRank4Plus()
    self:getChildByName("mask"):setVisible(false)
    self.updateGold()    
    self._members = {}     
    self._state = {0,0,0,0,0,0}
end
function unionMemberLayer.updateGold(name,row,old,value)
    local sender = pop.getDialog("unionMember")
    if sender ~= nil then
        sender:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("top"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("top"):requestDoLayout()
    end
end
function unionMemberLayer.showInfo(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionMember")
        if widget ~= nil then
            if widget.selectUid == 0 then
                return
            end
            if widget.selectUid == dd.uid then
                pop.onShowPopDialog("powerInfo")
            else
                pop.onShowPopDialog("power2",widget._parent,widget.selectUid)
            end
        end
    end  
end
function unionMemberLayer.transport(sender,eventType)
    if eventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("unionMember")
        local index = widget:getLevelAndIndex(widget.selectUid,widget.selectLevel)

        if index ~= 0 then
            local params = {}
            params.touid = widget.selectUid
            params.totem = dd.myUnion:getLong(1,"totem")
            params.level= widget._members[widget.selectLevel][index]["level"]
            params.name = widget._members[widget.selectLevel][index]["name"]
            params.cid = widget._members[widget.selectLevel][index]["cid"]
            pop.onShowPopDialog("transport",params)
        end
    end
end
--显示帮助
function unionMemberLayer.onShowHelp(sender,eventType)
    if eventType==ccui.TouchEventType.ended then    
        local widget = pop.getDialog("unionMember")
        if widget ~= nil then
            if widget:getChildByName("ulevel"):isVisible() == false then
                widget:getChildByName("ulevel"):setVisible(true)
                widget:getChildByName("mask"):setVisible(true)
                widget:getChildByName("ulevel"):setPosition(cc.p(0,0))
            end
        end
    end  
end

function unionMemberLayer.onMail(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        if dd.myUnion:getLong(1,'unionofficial') < 3 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您的联盟权限不足"))
                return
        end
        pop.onShowPopDialog("mailWrite",false,dd.myUnion:getLong(1,"unionid"),dd.myUnion:getString(1,"name"),'','ch',{},1,0)
    end  
end
function unionMemberLayer.closeRank(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("unionMember")
        if widget ~= nil then
            widget:onCloseRank()
        end
    end  
end
function unionMemberLayer:onCloseRank()
    self:getChildByName("mask"):setVisible(false)
    self:getChildByName("ulevel"):setVisible(false)
end

function unionMemberLayer.selectGroup(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then        
        local widget = pop.getDialog("unionMember")
        if widget ~= nil then
            widget:onShowRank(sender:getTag(),sender)
        end
    end   
end
function unionMemberLayer.selectGroup2(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then        
        local widget = pop.getDialog("unionMember")
        if widget ~= nil then
            widget:onShowRank(sender:getChildByName("show"):getTag(),sender:getChildByName("show"))
        end
    end   
end

--显示玩家信息
function unionMemberLayer.onShowUser(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then        
        local widget = pop.getDialog("unionMember")
        if widget ~= nil and sender.uid ~= nil then
            widget:showUser(sender.uid,sender.level)
        end
    end     
end
function unionMemberLayer.closeUser(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionMember")
        if widget ~= nil then
            widget:onCloseUser()
        end
    end  
end
function unionMemberLayer:onCloseUser()   
    self:getChildByName("user"):setVisible(false)
    self:getChildByName("mask"):setVisible(false)
end
function unionMemberLayer.kickMember(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        if dd.myUnion:getLong(1,"unionofficial") < 5 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您没有足够的联盟权限！"))
            return
        end
        local widget = pop.getDialog("unionMember")
        if widget ~= nil then
            local message = ff.net:createMessage()
            message:addCmd(0x0000011a)
            message:addLong(dd.uid)
            message:addLong(4)
            message:addLong(widget.selectUid)
            ff.net:rpc(message,false)
        end
    end  
end
function unionMemberLayer.levelUp(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        if dd.myUnion:getLong(1,"unionofficial") < 4 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您没有足够的联盟权限！"))
            return
        end

        local widget = pop.getDialog("unionMember")
        local index = widget:getLevelAndIndex(widget.selectUid,widget.selectLevel)

        local lv = widget._members[widget.selectLevel][index]["ulevel"]
        lv = tonumber(lv)
        if lv == 5 then
            if dd.myUnion:getLong(1,"unionofficial") < 6 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("您没有足够的联盟权限！"))
                return
            end
            local name = widget._members[widget.selectLevel][index]["name"]
            dd.currentLayer._widget:onShowSure(ff.langString("警告"),ff.langString("确定要将`{0}`提升为新的盟主吗？",{name}),function()
                local message = ff.net:createMessage()
                message:addCmd(0x12b)
                message:addLong(dd.uid)
                message:addString(name,15)
                ff.net:rpc(message,false)
            end,false,1)
            return
        end
        if widget ~= nil then
            local message = ff.net:createMessage()
            message:addCmd(0x11a)
            message:addLong(dd.uid)
            message:addLong(1)
            message:addLong(widget.selectUid)
            ff.net:rpc(message,false)
        end
    end  
end
function unionMemberLayer.levelDown(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        if dd.myUnion:getLong(1,"unionofficial") < 4 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您没有足够的联盟权限！"))
            return
        end
        local widget = pop.getDialog("unionMember")
        if widget ~= nil then
            local message = ff.net:createMessage()
            message:addCmd(0x0000011a)
            message:addLong(dd.uid)
            message:addLong(2)
            message:addLong(widget.selectUid)
            ff.net:rpc(message,false)
        end
    end  
end
function unionMemberLayer.addArmys(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionMember")
        if widget ~= nil then
            local index = widget:getLevelAndIndex(widget.selectUid,widget.selectLevel)
                               
            if index ~= 0 then
                local params = {}
                params.cid = tonumber(widget._members[widget.selectLevel][index]["cid"])
                params.uid = widget.selectUid
                params.unionid = dd.myUnion:getLong(1,"unionid")
                params.short =dd.myUnion:getString(1,"unionflag")
                params.ulevel=tonumber(dd.myUnion:getString(1,"level"))
                params.name = widget._members[widget.selectLevel][index]["name"]
                params.level= widget._members[widget.selectLevel][index]["level"]
                params.type = 4
                pop.onShowPopDialog("chuzhen",4,params)
            end
            widget:onCloseUser()
        end
    end  
end

function unionMemberLayer:showUser(uid,level)
    if uid <= 0 then
        return
    end
    local index = self:getLevelAndIndex(uid,level)
    local info = nil
    cclog("index == "..index)
    if index ~= 0 then
        info = self._members[level][index]
    end
    if info ~= nil then        
        local user = self:getChildByName("user"):getChildByName("view")
        user:getChildByName("name"):setString(info["name"])
        user:getChildByName("level"):setString(info["level"])
        user:getChildByName("power"):setString(ff.getFormatMoney(info["power"]))
        user:getChildByName("kills"):setString(ff.getFormatMoney(info["kills"]))
        user:getChildByName("tag"):setString( self.lastLogin(tonumber(info["lastupdate"])))

        user:getChildByName("face"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(info["face"]),0)

        local ulevel = dd.myUnion:getLong(1,"unionofficial")
        local target = tonumber(info["ulevel"])

        self:updateBtnLevel(ulevel,target,uid)
        
        if self:getChildByName("user"):isVisible() == false then
            self:getChildByName("user"):setVisible(true)
            self:getChildByName("mask"):setVisible(true)
            self:getChildByName("user"):setPosition(cc.p(0,0))
        end
        if ulevel >= 4 then
            self:getChildByName("user"):setContentSize(cc.size(720,540))
            self:getChildByName("user"):getChildByName("view"):setContentSize(cc.size(720,540))
            self:getChildByName("user"):getChildByName("close"):setPositionY(515)
        else
            self:getChildByName("user"):setContentSize(cc.size(720,440))
            self:getChildByName("user"):getChildByName("view"):setContentSize(cc.size(720,440))
            self:getChildByName("user"):getChildByName("close"):setPositionY(415)
        end
        self.selectUid = uid
        self.selectLevel = level
    end
end
function unionMemberLayer:updateBtnLevel(ulevel,target,uid)
    local user = self:getChildByName("user"):getChildByName("view")
    if target == 6 then
        user:getChildByName("levelup"):getChildByName("chu_jc_label"):setVisible(true)
        user:getChildByName("levelup"):getChildByName("chu_label"):setVisible(false)
        user:getChildByName("levelup"):getChildByName("chu_rank"):setVisible(false)
        user:getChildByName("levelup"):getChildByName("chu_jc_label"):setString(ff.langString("已是最高"))
    elseif target == 5 then
        user:getChildByName("levelup"):getChildByName("chu_jc_label"):setVisible(true)
        user:getChildByName("levelup"):getChildByName("chu_label"):setVisible(false)
        user:getChildByName("levelup"):getChildByName("chu_rank"):setVisible(false)
        user:getChildByName("levelup"):getChildByName("chu_jc_label"):setString(ff.langString("继承"))
    else
        user:getChildByName("levelup"):getChildByName("chu_jc_label"):setVisible(false)
        user:getChildByName("levelup"):getChildByName("chu_label"):setVisible(true)
        user:getChildByName("levelup"):getChildByName("chu_rank"):setVisible(true)
        user:getChildByName("levelup"):getChildByName("chu_label"):setString(ff.langString("提升到"))
        user:getChildByName("levelup"):getChildByName("chu_rank"):setString("Rank"..(target + 1))
    end

    if target == 1 then
        user:getChildByName("leveldown"):getChildByName("chu_jc_label"):setVisible(true)
        user:getChildByName("leveldown"):getChildByName("chu_label"):setVisible(false)
        user:getChildByName("leveldown"):getChildByName("chu_rank"):setVisible(false)
        user:getChildByName("leveldown"):getChildByName("chu_jc_label"):setString(ff.langString("已是最低"))

    else
        user:getChildByName("leveldown"):getChildByName("chu_jc_label"):setVisible(false)
        user:getChildByName("leveldown"):getChildByName("chu_label"):setVisible(true)
        user:getChildByName("leveldown"):getChildByName("chu_rank"):setVisible(true)
        user:getChildByName("leveldown"):getChildByName("chu_label"):setString(ff.langString("降职为"))
        if target == 5 then
            user:getChildByName("leveldown"):getChildByName("chu_rank"):setString("Rank3")
        else
            user:getChildByName("leveldown"):getChildByName("chu_rank"):setString("Rank"..(target - 1))
        end
    end

    if ulevel >= 4 then
        if  ulevel > target then
            user:getChildByName("levelup"):setBright(true)
            user:getChildByName("levelup"):getChildByName("chu_jc_label"):setColor(cc.c3b(255,255,255))
            user:getChildByName("levelup"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
            user:getChildByName("levelup"):getChildByName("chu_rank"):setColor(cc.c3b(255,255,255))
            user:getChildByName("levelup"):setTouchEnabled(true)
            user:getChildByName("leveldown"):setBright(true)
            user:getChildByName("leveldown"):getChildByName("chu_jc_label"):setColor(cc.c3b(255,255,255))
            user:getChildByName("leveldown"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
            user:getChildByName("leveldown"):getChildByName("chu_rank"):setColor(cc.c3b(255,255,255))
            user:getChildByName("leveldown"):setTouchEnabled(true)
            user:getChildByName("kick"):setBright(true)
            user:getChildByName("kick"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
            user:getChildByName("kick"):setTouchEnabled(true)
        else
            user:getChildByName("levelup"):setBright(false)      
            user:getChildByName("levelup"):getChildByName("chu_jc_label"):setColor(cc.c3b(116,123,125))
            user:getChildByName("levelup"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
            user:getChildByName("levelup"):getChildByName("chu_rank"):setColor(cc.c3b(116,123,125))      
            user:getChildByName("leveldown"):setBright(false)
            user:getChildByName("leveldown"):getChildByName("chu_jc_label"):setColor(cc.c3b(116,123,125))
            user:getChildByName("leveldown"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
            user:getChildByName("leveldown"):getChildByName("chu_rank"):setColor(cc.c3b(116,123,125))
            user:getChildByName("kick"):setBright(false)
            user:getChildByName("kick"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))

            user:getChildByName("leveldown"):setTouchEnabled(false)
            user:getChildByName("levelup"):setTouchEnabled(false)
            user:getChildByName("kick"):setTouchEnabled(false)
        end
        user:getChildByName("update_tips"):setVisible(true)
        user:getChildByName("tag"):setVisible(true)
   else    
        user:getChildByName("levelup"):setBright(false)
        user:getChildByName("leveldown"):setBright(false)
        user:getChildByName("kick"):setBright(false)
        user:getChildByName("levelup"):getChildByName("chu_jc_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("levelup"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("levelup"):getChildByName("chu_rank"):setColor(cc.c3b(116,123,125))
        user:getChildByName("leveldown"):getChildByName("chu_jc_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("leveldown"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("leveldown"):getChildByName("chu_rank"):setColor(cc.c3b(116,123,125))
        user:getChildByName("kick"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        
        user:getChildByName("leveldown"):setTouchEnabled(false)
        user:getChildByName("levelup"):setTouchEnabled(false)
        user:getChildByName("kick"):setTouchEnabled(false)
        user:getChildByName("update_tips"):setVisible(false)
        user:getChildByName("tag"):setVisible(false)
    end  

    if target == 1 then
        user:getChildByName("leveldown"):setBright(false)
        user:getChildByName("leveldown"):getChildByName("chu_jc_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("leveldown"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("leveldown"):getChildByName("chu_rank"):setColor(cc.c3b(116,123,125))
        user:getChildByName("leveldown"):setTouchEnabled(false)
    end   
    if uid == dd.uid then
        user:getChildByName("addarmys"):setBright(false)
        user:getChildByName("addarmys"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("trans_btn"):setBright(false)
        user:getChildByName("trans_btn"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("addarmys"):setTouchEnabled(false)
        user:getChildByName("trans_btn"):setTouchEnabled(false)
    else
        user:getChildByName("addarmys"):setBright(true)
        user:getChildByName("addarmys"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
        user:getChildByName("trans_btn"):setBright(true)
        user:getChildByName("trans_btn"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
        user:getChildByName("addarmys"):setTouchEnabled(true)
        user:getChildByName("trans_btn"):setTouchEnabled(true)
    end
    self.selectUid = uid
    self.selectLevel = target
end
--keep是否保持按钮打开状态
function unionMemberLayer:onShowRank(index,sender,keep)    
    local show = false
    if keep == nil then
        keep = false
    end
    if sender:isFlippedY() == true and keep == false then
        sender:setFlippedY(false)
    else
        sender:setFlippedY(true)
        show = true
    end        
    if index == 6 then
        if show == false then
            self:getChildByName("lists"):getChildByName("rank6"):getChildByName("leader"):setVisible(false)
            self:getChildByName("lists"):getChildByName("rank6"):setContentSize(cc.size(720,77))
            self:getChildByName("lists"):requestRefreshView()
        else
            self:onShowULevel(6)
        end    
    elseif index == 5 then
        if show == false then
            self:getChildByName("lists"):getChildByName("rank5"):getChildByName("lists"):setVisible(false)
            self:getChildByName("lists"):getChildByName("rank5"):setContentSize(cc.size(720,77))
            self:getChildByName("lists"):requestRefreshView()
        else
            self:onShowULevel(5)
        end    
    else    
        if show == false then
            self:getChildByName("lists"):getChildByName("rank"..index):getChildByName("lists"):setVisible(false)
            self:getChildByName("lists"):getChildByName("rank"..index):setContentSize(cc.size(720,77))
            self:getChildByName("lists"):requestRefreshView()
        else
            self:onShowULevel(index)
        end    
    end
end

function unionMemberLayer:onShowULevel(ulevel)
    if self._state[ulevel] == 0 then
        self:queryMember(ulevel)
    else
        self:showULevel(ulevel)
    end    
end

function unionMemberLayer.updateTag(secends)
    if secends - dd.getServerTime() < 3600 * 24 then
        return "ic03_member.png"
    elseif secends - dd.getServerTime() < 3600 * 24 * 3 then   
        return "ic02_member.png"
    elseif secends - dd.getServerTime() < 3600 * 24 * 7 then   
        return "ic01_member.png"
    else
        return "ic04_member.png"
    end    
end

function unionMemberLayer.lastLogin(secends)
    if secends == 0 then
        return ""
    elseif dd.getServerTime() - secends < 3600 * 24 then
        return ff.langString("{0}天之内",{1})
    elseif dd.getServerTime() - secends < 3600 * 24 * 3 then   
        return ff.langString("{0}天前",{1})
    elseif dd.getServerTime() - secends < 3600 * 24 * 7 then   
        return ff.langString("{0}天前",{3})
    else
        return ff.langString("{0}天前",{7})
    end  
end

function unionMemberLayer:showULevel(level)
    cclog("showULevel:"..level)
    local myLv = dd.myUnion:getLong(1,"unionofficial")
    local members = self._members[level]
    local nums    = 0
    if members ~= nil then
        nums = table.getn(members)
    end
    if nums == 0 then
        return
    end
    self._state[level] = 1

    if level == 6 then
        if nums == 1 then
            local leader = self:getChildByName("lists"):getChildByName("rank6"):getChildByName("leader")
            leader:getChildByName("info"):getChildByName("name"):setString(members[1]["name"])
            leader:getChildByName("info"):getChildByName("level"):setString("LV."..members[1]["level"])
            leader:getChildByName("info"):getChildByName("power"):setString(dd.showKM(tonumber(members[1]["power"]),5))
            leader:getChildByName("icon"):loadTexture(dd.getPlayerIcon(tonumber(members[1]["face"])),0)
            --上次登陆
            local last = tonumber(members[1]["lastupdate"])
            leader:getChildByName("info"):getChildByName("tag"):setVisible(myLv>=4)
            leader:getChildByName("info"):getChildByName("tag"):setString(self.lastLogin(last))
          
            self:getChildByName("lists"):getChildByName("rank6"):getChildByName("leader"):setVisible(true)
            self:getChildByName("lists"):getChildByName("rank6"):setContentSize(cc.size(720,277))
            self:getChildByName("lists"):getChildByName("rank6"):getChildByName("leader").uid = tonumber(members[1]["uid"])
            self:getChildByName("lists"):getChildByName("rank6"):getChildByName("leader").level = level
            self:getChildByName("lists"):getChildByName("rank6"):getChildByName("leader"):setTag(tonumber(members[1]["uid"]))
        end
    elseif level == 5 then
        local rank5 = self:getChildByName("lists"):getChildByName("rank5")
        rank5:getChildByName("title"):getChildByName("member"):setString(nums.."/"..self.r5Max)        
        if nums > 0 then
            for i=1,nums do
                if i > 2 then
                    break
                end    
                local item = rank5:getChildByName("lists"):getChildByName("item"..i)
                item:getChildByName("info"):getChildByName("name"):setString(members[i]["name"])
                item:getChildByName("info"):getChildByName("level"):setString("LV."..members[i]["level"])
                item:getChildByName("info"):getChildByName("power"):setString(dd.showKM(members[i]["power"],5))
                item:getChildByName("icon"):loadTexture(dd.getPlayerIcon(tonumber(members[i]["face"])),0)
                item:getChildByName("ulevel"):setString(5)
                item:getChildByName("ulevel"):setVisible(false)
                item.uid = tonumber(members[i]["uid"])
                item.level = level
                item:setTag(tonumber(members[i]["uid"]))
                --上次登陆
                local last = tonumber(members[i]["lastupdate"])
                item:getChildByName("info"):getChildByName("tag"):setVisible(myLv>=4)
                item:getChildByName("info"):getChildByName("tag"):setString(self.lastLogin(last))
            end
            if nums <= 1 then
                rank5:getChildByName("lists"):getChildByName("item2"):setVisible(false)
            else
                rank5:getChildByName("lists"):getChildByName("item2"):setVisible(true)
            end

            self:getChildByName("lists"):getChildByName("rank5"):getChildByName("lists"):setVisible(true)
            self:getChildByName("lists"):getChildByName("rank5"):setContentSize(cc.size(720,277))
        end
    else 
        local rank = self:getChildByName("lists"):getChildByName("rank"..level)
        local rlist = rank:getChildByName("lists")
        rank:getChildByName("lists"):stopAllActions()
        for tid,item in pairs(rlist:getChildren()) do
            if item ~= nil then
                item:setVisible(false)
            end
        end 

        if level == 4 then
            rank:getChildByName("title"):getChildByName("member"):setString(nums.."/"..self.r4Max)
        else
            rank:getChildByName("title"):getChildByName("member"):setString(nums)
        end
        if nums > 0 then
            local hh = 200 * math.ceil(nums/2)
            rank:getChildByName("lists"):setContentSize(cc.size(720,hh))
            rank:setContentSize(cc.size(720,hh + 77))  
            if nums <= 10 then
                for i=1,nums do
                    self:addItem(rank, members, i, hh,level)
                end
            else
                local count = 11
                for i=1,10 do
                    self:addItem(rank, members, i, hh,level)
                end
                local function add_sche()
                    if count <= nums then
                        self:addItem(rank, members, count, hh,level)
                        count = count + 1
                    else
                        rank:getChildByName("lists"):stopAllActions()
                    end
                end
                schedule(rank:getChildByName("lists"), add_sche,0.01)
            end 
            rank:getChildByName("lists"):setVisible(true)
        end
    end
    self:getChildByName("lists"):requestRefreshView()
end
function unionMemberLayer:addItem(rank, members, i, hh,level)
    local item = rank:getChildByName("lists"):getChildByTag(i)
    if item == nil then
        item = self:getChildByName("item"):clone()
        rank:getChildByName("lists"):addChild(item)
    end
    item:setTag(i)
    item:getChildByName("icon"):loadTexture(dd.getPlayerIcon(tonumber(members[i]["face"])),0)
    item:getChildByName("bg"):loadTexture(dd.getPathFromUI("bg5_member.png",1))
    item.uid = tonumber(members[i]["uid"])
    item.level = level
    item:addTouchEventListener(self.onShowUser)
    item:getChildByName("name"):setString(members[i]["name"])
    item:getChildByName("power"):setString(dd.showKM(tonumber(members[i]["power"]),5))
    item:getChildByName("level"):setString("LV."..members[i]["level"])

    local last = tonumber(members[i]["lastupdate"])
    item:getChildByName("tag"):setVisible(dd.myUnion:getLong(1,"unionofficial")>=4)
    item:getChildByName("tag"):setString(self.lastLogin(last))
    local shang = math.modf(i/2.0)         
    local yu = i%2
    if yu == 0 then
        shang = shang - 1
    end
    if yu == 1 then
        item:setPositionX(20)
    elseif yu == 2 then
        item:setPositionX(255)    
    elseif yu == 0 then    
        item:setPositionX(370)    
    end  
    item:setVisible(true)
    item:setPositionY(hh - 200 * (shang + 1))
end

function unionMemberLayer:getLevelAndIndex(uid,level)
    local index = 0
    if self._members[level] ~= nil then
        for i=1, table.getn(self._members[level]) do
            if self._members[level][i]["uid"] == uid then
                index = i
                break
            end
        end
    end
    return index
end
--成员等级变化 数据更新
function unionMemberLayer:updateUlevel(new, old, uid)
    local oldmembers = self._members[old]
    local oldinfos = nil
    local flag = 0
    --旧等级表
    self._members[old] = {}
    for i=1, table.getn(oldmembers) do
        if oldmembers[i]["uid"] == uid then
            flag = 1
            oldinfos = oldmembers[i]
        else
            self._members[old][i-flag] = oldmembers[i]
        end
    end
       --0是剔除
    if new ~= 0 then
        if oldinfos ~= nil then
            oldinfos["ulevel"] = new    
        end
        --新等级表
        if self._members[new] ~= nil then
            local num = table.getn(self._members[new])
            self._members[new][num+1] = oldinfos
        else
            self._members[new] = {}
            self._members[new][1] = oldinfos
        end
    end
end

function unionMemberLayer.onGetAllyMemberLists(params)
    local code = params[1]
    if code == 0 then
        local ulevel = params[2]

        local widget = pop.getDialog("unionMember")
        if widget ~= nil then
            widget._members[ulevel] = params[3]
            widget:showULevel(ulevel)
        end    
    else
        dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(code))
    end
end
function unionMemberLayer.onGetUnionMembersNum(params)
    cclog("unionMemberLayer.onGetUnionMembersNum")
    local code = params[1]
    if code == 0 then
        local flag = params[2]
        if flag == dd.myUnion:getString(1,"unionflag") then
            local rank4 = params[3]
            local rank3 = params[4]
            local rank2 = params[5]
            local rank1 = params[6]
            local rank5 = params[7]
            local widget = pop.getDialog("unionMember")
            if widget ~= nil then
                widget._member[1] = rank1
                widget._member[2] = rank2
                widget._member[3] = rank3
                widget._member[4] = rank4
                widget._member[5] = rank5
                
                widget:getChildByName("lists"):getChildByName("rank6"):getChildByName("title"):getChildByName("member"):setString("1/1")
                widget:getChildByName("lists"):getChildByName("rank5"):getChildByName("title"):getChildByName("member"):setString(rank5.."/"..widget.r5Max)
                widget:getChildByName("lists"):getChildByName("rank4"):getChildByName("title"):getChildByName("member"):setString(rank4.."/"..widget.r4Max)
                widget:getChildByName("lists"):getChildByName("rank3"):getChildByName("title"):getChildByName("member"):setString(rank3)
                widget:getChildByName("lists"):getChildByName("rank2"):getChildByName("title"):getChildByName("member"):setString(rank2)
                widget:getChildByName("lists"):getChildByName("rank1"):getChildByName("title"):getChildByName("member"):setString(rank1)

                widget:getChildByName("lists"):getChildByName("rank6"):getChildByName("title"):getChildByName("member"):setVisible(true)
                widget:getChildByName("lists"):getChildByName("rank5"):getChildByName("title"):getChildByName("member"):setVisible(true)
                widget:getChildByName("lists"):getChildByName("rank4"):getChildByName("title"):getChildByName("member"):setVisible(true)
                widget:getChildByName("lists"):getChildByName("rank3"):getChildByName("title"):getChildByName("member"):setVisible(true)
                widget:getChildByName("lists"):getChildByName("rank2"):getChildByName("title"):getChildByName("member"):setVisible(true)
                widget:getChildByName("lists"):getChildByName("rank1"):getChildByName("title"):getChildByName("member"):setVisible(true)
            end
        end
    else
        dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(code))
    end
end

function unionMemberLayer:queryMember(ulevel)
    local message = ff.net:createMessage()
    message:addCmd(0x00000012)
    message:addLong(dd.uid)
    message:addString(dd.myUnion:getString(1,"unionflag"),3)
    message:addLong(ulevel)
    ff.net:rpc(message,false)
end

function unionMemberLayer.onClose(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionMember")
        if widget ~= nil then
            widget.onReturn(widget)
        end
    end
end
function unionMemberLayer.updateLogin()
    local widget = pop.getDialog("unionMember")
    if widget ~= nil and widget:isVisible() then
        widget:freshMemberLogin()
    end
end
function unionMemberLayer.onStart(sender)
    ff.net:bindProperty(103,"gold",sender.updateGold)  
    ff.net:bindProperty(1001,"unionofficial",sender.updateLogin)  
    if sender._init == false then
        local datas = ff.dbmanager:sql_fetch_rows("select * from cfg_league_power order by `id`")
        for i=1,datas:rowCount() do
            local item = sender:getChildByName("ulevel"):getChildByName("view"):getChildByName("item"):clone()
            item:setVisible(true)

            if ff.lang == -1 then
                item:getChildByName("name"):setString(ff.langString(datas:getString(i,"description")))
            else
                item:getChildByName("name"):setString(ff.langString(tonumber(datas:getString(i,"description_lan"))))
            end  

            if tonumber(datas:getString(i,"rank6")) ~= 1 then
                item:getChildByName("tag6"):setVisible(false)
            end  
            
            if tonumber(datas:getString(i,"rank5")) ~= 1 then
                item:getChildByName("tag5"):setVisible(false)
            end    
            if tonumber(datas:getString(i,"rank4")) ~= 1 then
                item:getChildByName("tag4"):setVisible(false)
            end    
            if tonumber(datas:getString(i,"rank3")) ~= 1 then
                item:getChildByName("tag3"):setVisible(false)
            end    
            if tonumber(datas:getString(i,"rank2")) ~= 1 then
                item:getChildByName("tag2"):setVisible(false)
            end    
            if tonumber(datas:getString(i,"rank1")) ~= 1 then
                item:getChildByName("tag1"):setVisible(false)
            end    
            sender:getChildByName("ulevel"):getChildByName("view"):getChildByName("lists"):addChild(item)
        end
        if datas ~= nil then
            datas:clear()
            datas = nil
        end    
        sender._init = true
    end
end
function unionMemberLayer.onEnd(sender)
    dd.delBackEvent()
    ff.net:removeEvent(1,dd.Tjf_union_AllyMemberAction)
    ff.net:removeEvent(1,dd.Tjf_rpc_getUnionMembers)
    ff.net:removeEvent(1,dd.Tjf_rpc_getUnionMembersNum)
    ff.net:removeEvent(1,dd.Tjf_union_AllyLeaderChange)
    if ff.platform ~= 1 then
        sender:getChildByName("lists"):getChildByName("rank6"):getChildByName("leader"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("lists"):getChildByName("rank5"):getChildByName("lists"):getChildByName("item1"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("lists"):getChildByName("rank5"):getChildByName("lists"):getChildByName("item2"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
    sender.selectUid = 0
    for var=1, 5 do
        sender:getChildByName("lists"):getChildByName("rank"..var):getChildByName("lists"):stopAllActions()
        if sender:getChildByName("lists"):getChildByName("rank"..var):getChildByName("lists"):isVisible() == true then
            sender:getChildByName("lists"):getChildByName("rank"..var):getChildByName("title"):getChildByName("show"):setFlippedY(false) 
            sender:getChildByName("lists"):getChildByName("rank"..var):getChildByName("lists"):setVisible(false)
            sender:getChildByName("lists"):getChildByName("rank"..var):setContentSize(cc.size(720,77))
            sender:getChildByName("lists"):requestRefreshView()
        end
    end
    ff.net:unbindProperty("gold",103) 
    ff.net:unbindProperty("unionofficial",1001)  
    sender:onCloseUser()
end

function unionMemberLayer:backAllyMemberAction(ret)
    if ret[1] == 0 then
        local uid = ret[3]
        local lv = self.selectLevel
        if ret[2] == 1 then
            self:updateUlevel(lv + 1,lv,uid)
            if lv == 5 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("该成员已成功继任为会长！"),true)
            else
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("该成员的官职已被提升一级！"),true)
            end
            if self:getChildByName("lists"):getChildByName("rank"..(lv+1)):getChildByName("title"):getChildByName("show"):isFlippedY() == true then
                self:onShowULevel(lv+1)        
            end
            self:updateBtnLevel(dd.myUnion:getLong(1,'unionofficial'),lv+1,ret[3])
            self._member[lv] = self._member[lv] - 1
            self._member[lv+1] = self._member[lv+1] + 1
            if lv == 5 then
                self:getChildByName("lists"):getChildByName("rank5"):getChildByName("title"):getChildByName("member"):setString(self._member[5].."/"..self.r5Max)
            elseif lv == 4 then
                self:getChildByName("lists"):getChildByName("rank4"):getChildByName("title"):getChildByName("member"):setString(self._member[4].."/"..self.r4Max)
            else
                self:getChildByName("lists"):getChildByName("rank"..lv):getChildByName("title"):getChildByName("member"):setString(self._member[lv])
            end 
            if (lv+1) == 5 then
                self:getChildByName("lists"):getChildByName("rank5"):getChildByName("title"):getChildByName("member"):setString(self._member[5].."/"..self.r5Max)
            elseif (lv+1) == 4 then
                self:getChildByName("lists"):getChildByName("rank4"):getChildByName("title"):getChildByName("member"):setString(self._member[4].."/"..self.r4Max)
            else
                self:getChildByName("lists"):getChildByName("rank"..(lv+1)):getChildByName("title"):getChildByName("member"):setString(self._member[lv+1])
            end 
            self:freshMember(ret[2],lv)
        elseif ret[2] == 2 then
            local newLv = lv-1
            if lv == 5 then
                newLv = 3
            end
            self:updateUlevel(newLv,lv,uid)
            
            if self:getChildByName("lists"):getChildByName("rank"..newLv):getChildByName("title"):getChildByName("show"):isFlippedY() == true then
                self:onShowULevel(newLv)        
            end
            self:updateBtnLevel(dd.myUnion:getLong(1,'unionofficial'),newLv,ret[3])
            self._member[lv] = self._member[lv] - 1
            self._member[newLv] = self._member[newLv] + 1
            if newLv == 5 then
                self:getChildByName("lists"):getChildByName("rank5"):getChildByName("title"):getChildByName("member"):setString(self._member[5].."/"..self.r5Max)
            elseif newLv == 4 then
                self:getChildByName("lists"):getChildByName("rank4"):getChildByName("title"):getChildByName("member"):setString(self._member[4].."/"..self.r4Max)
            else
                self:getChildByName("lists"):getChildByName("rank"..newLv):getChildByName("title"):getChildByName("member"):setString(self._member[newLv])
            end 
            if lv == 5 then
                self:getChildByName("lists"):getChildByName("rank5"):getChildByName("title"):getChildByName("member"):setString(self._member[5].."/"..self.r5Max)
            elseif lv == 4 then
                self:getChildByName("lists"):getChildByName("rank4"):getChildByName("title"):getChildByName("member"):setString(self._member[4].."/"..self.r4Max)
            else
                self:getChildByName("lists"):getChildByName("rank"..lv):getChildByName("title"):getChildByName("member"):setString(self._member[lv])
            end 
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("该成员的官职已被降低一级！"))
            self:freshMember(ret[2],lv)
        elseif ret[2] == 4 then
            self._member[lv] = self._member[lv] - 1
            if lv == 5 then
                self:getChildByName("lists"):getChildByName("rank5"):getChildByName("title"):getChildByName("member"):setString(self._member[5].."/"..self.r5Max)
            elseif lv == 4 then
                self:getChildByName("lists"):getChildByName("rank4"):getChildByName("title"):getChildByName("member"):setString(self._member[4].."/"..self.r4Max)
            else
                self:getChildByName("lists"):getChildByName("rank"..lv):getChildByName("title"):getChildByName("member"):setString(self._member[lv])
            end 
            self:updateUlevel(0,lv,uid)
            self:onCloseUser() 
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("该成员已被踢出联盟！"))
            self:freshMember(ret[2],lv)
        end
    else
        dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(ret[1]))
        return
    end
end
function unionMemberLayer:getRank4Plus()
    local ret = 0
    for i=1,dd.myUnionTecs:rowCount() do
        if dd.myUnionTecs:getLong(i,"id") == 101 then
            local lv = dd.myUnionTecs:getLong(i,"level")
            if lv == 0 then
                ret = 0
            else
                local teclvid = 10100+lv
                local rows = ff.dbmanager:sql_fetch_rows("select * from cfg_league_tech_levelup where id="..teclvid)
                local param = tonumber(rows:getString(1, "effect3"))
                local value  = tonumber(rows:getString(1, "params3"))
                if dd.cfgEffect[param]['value'] > 0 then
                    value = value/dd.cfgEffect[param]['value']
                end
                ret = value
                rows:clear()
            end
            break
        end
    end
    return ret
end
function unionMemberLayer.updateLogin()
    local widget = pop.getDialog("unionMember")
    if widget ~= nil and widget:isVisible() then
        widget:freshMemberLogin()
    end
end
function unionMemberLayer:freshMemberLogin() 
    local office = dd.myUnion:getLong(1,"unionofficial")
    for var=1, 6 do
        if var == 6 then
            local leader = self:getChildByName("lists"):getChildByName("rank6"):getChildByName("leader") 
            leader:getChildByName("info"):getChildByName("tag"):setVisible(office>=4)
        elseif self:getChildByName("lists"):getChildByName("rank"..var):getChildByName("lists"):isVisible() == true then
            if var == 5 then
                local rank5 = self:getChildByName("lists"):getChildByName("rank5")
                for i=1,2 do   
                    local item = rank5:getChildByName("lists"):getChildByName("item"..i)
                    item:getChildByName("info"):getChildByName("tag"):setVisible(office>=4)
                end
            else
                local rank = self:getChildByName("lists"):getChildByName("rank"..var)
                local rlist = rank:getChildByName("lists")
                for tid,item in pairs(rlist:getChildren()) do
                    if item ~= nil then
                        item:getChildByName("tag"):setVisible(office>=4)
                    end
                end 
            end
        end
    end  
end
function unionMemberLayer:freshMember(type,lv) 
    if type == 1 then
        local sender = self:getChildByName("lists"):getChildByName("rank"..lv):getChildByName("title"):getChildByName("show")
        local sender1 = self:getChildByName("lists"):getChildByName("rank"..(lv+1)):getChildByName("title"):getChildByName("show")        
        if self._member[lv] <= 0 then
            self:onShowRank(lv,sender,false)
        else
            self:onShowRank(lv,sender,true)   
        end   
        self:onShowRank(lv+1,sender1,true)    
    elseif type == 2 then
        local newLv = lv-1
        if lv >= 5 then
            newLv = 3
        end
        local sender = self:getChildByName("lists"):getChildByName("rank"..lv):getChildByName("title"):getChildByName("show")
        local sender1 = self:getChildByName("lists"):getChildByName("rank"..newLv):getChildByName("title"):getChildByName("show")    

        if self._member[lv] <= 0 then
            self:onShowRank(lv,sender,false)
        else
            self:onShowRank(lv,sender,true)   
        end   
        self:onShowRank(newLv,sender1,true) 
    elseif type == 4 then
        local sender = self:getChildByName("lists"):getChildByName("rank"..lv):getChildByName("title"):getChildByName("show")   
        if self._member[lv] <= 0 then
            self:onShowRank(lv,sender,false)
        else
            self:onShowRank(lv,sender,true)   
        end  
    end
end

function unionMemberLayer.onAllyLeaderChange(code)
    if code == 0 then
        local widget = pop.getDialog("unionMember")
        if widget ~= nil then
            widget.onReturn(widget)
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("禅让成功"),true)
            dd.myUnion:setLong(1,"unionofficial",3)
        end
    end
end

function unionMemberLayer.onBefore(sender) 
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("icon"),sender:getChildByName("top"):getChildByName("addgold"))  

    ff.net:registerEvent(1,dd.Tjf_union_AllyMemberAction, function (message)sender:backAllyMemberAction(message)end)
    ff.net:registerEvent(1,dd.Tjf_rpc_getUnionMembers,sender.onGetAllyMemberLists)    
    ff.net:registerEvent(1,dd.Tjf_rpc_getUnionMembersNum,sender.onGetUnionMembersNum)    
    ff.net:registerEvent(1,dd.Tjf_union_AllyLeaderChange,sender.onAllyLeaderChange)

    if sender:getChildByName("lists"):getChildByName("rank6"):getChildByName("title"):getChildByName("show"):isFlippedY() == true then
        sender:queryMember(6)        
    end  
    if sender:getChildByName("lists"):getChildByName("rank5"):getChildByName("title"):getChildByName("show"):isFlippedY() == true then
        sender:queryMember(5)        
    end  
    if sender:getChildByName("lists"):getChildByName("rank4"):getChildByName("title"):getChildByName("show"):isFlippedY() == true then
        sender:queryMember(4)        
    end  
    if sender:getChildByName("lists"):getChildByName("rank3"):getChildByName("title"):getChildByName("show"):isFlippedY() == true then
        sender:queryMember(3)        
    end  
    if sender:getChildByName("lists"):getChildByName("rank2"):getChildByName("title"):getChildByName("show"):isFlippedY() == true then
        sender:queryMember(2)        
    end  
    if sender:getChildByName("lists"):getChildByName("rank1"):getChildByName("title"):getChildByName("show"):isFlippedY() == true then
        sender:queryMember(1)        
    end  

    local message = ff.net:createMessage()
    message:addCmd(0x00000013)
    message:addLong(dd.uid)
    message:addString(dd.myUnion:getString(1,"unionflag"),3)
    ff.net:rpc(message,false)

    --初始化所有脸谱
    return true
end
function unionMemberLayer.onReturn(sender)
    if sender == nil then
        sender = pop.getDialog("unionMember")
    end
    if sender:getChildByName("user"):isVisible() == true and sender:getChildByName("user"):getPositionY() == 0 then
        sender:onCloseUser()
        return true
    end
    if sender:getChildByName("ulevel"):isVisible() == true and sender:getChildByName("ulevel"):getPositionY() == 0 then
        sender:onCloseRank()
        return true
    end
    pop.onClosePopDialog("unionMember")
    
    local widget = pop.getDialog("unionOption")
    local union = pop.getDialog("union")
    if widget ~= nil and widget:isVisible() then
        if union ~= nil then
            union._managerIndex = 5
        end
    elseif union ~= nil and union:isVisible() then
        union._managerIndex = 1
    end
    return false
end

function onShowUnionMember(widget)
    local layer = unionMemberLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
	layer:onInit()
	return layer
end
