local unionOptionLayer   = class("unionOptionLayer")
unionOptionLayer._name = "unionOption"
unionOptionLayer._init = false
unionOptionLayer._index = 0

unionOptionLayer._lan   = 1
unionOptionLayer._rule  = 1
unionOptionLayer._zone  = 1
unionOptionLayer.ifAuto = 1 --0=否，1=是
unionOptionLayer.need_fight  = 1
unionOptionLayer.need_lv  = 1

unionOptionLayer._leaderedit = nil
unionOptionLayer.fightEdit = nil
unionOptionLayer.lvEdit = nil
unionOptionLayer.allApplyNum = 0
unionOptionLayer.applyList = {}
unionOptionLayer.applyKey = 0
unionOptionLayer.applyBaseSize = nil

unionOptionLayer.inputName = ""
unionOptionLayer.inputShort = ""
unionOptionLayer.changeCD = 0
unionOptionLayer.changeGold = 1000
unionOptionLayer.MaxMarkNum = 60
unionOptionLayer.mark_init = false
unionOptionLayer.selMark = 1
function unionOptionLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, unionOptionLayer)
    return target
end
function unionOptionLayer:onInit()
    if self._init == false then
    	local hh = ff.height
        self:setContentSize(cc.size(720,hh))
    	self:getChildByName("view"):setContentSize(cc.size(720,hh - 105))
        self:getChildByName("view"):getChildByName("mainArea"):setContentSize(cc.size(720,hh - 105))
    	self:getChildByName("view"):setPositionY(0)
        self:getChildByName("mask"):setContentSize(cc.size(720,hh - 105))
        self:getChildByName("mask"):setPositionY(0)

        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item1"):getChildByName("back_btn"):addTouchEventListener(self.showLeave)
        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item2"):getChildByName("back_btn"):addTouchEventListener(self.showHistory)
        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item3"):getChildByName("back_btn"):addTouchEventListener(self.showOption)
        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item4"):getChildByName("back_btn"):addTouchEventListener(self.showChangeName)
        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item5"):getChildByName("back_btn"):addTouchEventListener(self.showDismiss)
        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item6"):getChildByName("back_btn"):addTouchEventListener(self.showApplyInfo)
        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item7"):getChildByName("back_btn"):addTouchEventListener(self.changeUnionMark) 
    end
    self:getChildByName("view"):setVisible(true)
    self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item6"):setVisible(false)
    self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item3"):setVisible(false)
    self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item4"):setVisible(false)
    self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item5"):setVisible(false)
    self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item7"):setVisible(false)

    local ulevel = dd.myUnion:getLong(1,"unionofficial")
    if ulevel == 4 then
        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item3"):setVisible(true)
        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item6"):setVisible(true)
    elseif ulevel == 5 then
        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item3"):setVisible(true)
        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item6"):setVisible(true)
    elseif ulevel == 6 then
        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item3"):setVisible(true)
        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item6"):setVisible(true)
        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item4"):setVisible(true)
        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item5"):setVisible(true)
        self:getChildByName("view"):getChildByName("mainArea"):getChildByName("item7"):setVisible(true)
    end    	
    ff.net:registerEvent(1,dd.Tjf_union_EditAllyCondition,function (message)self:backEditAllyCondition(message)end)
    ff.net:registerEvent(1,dd.Tjf_union_ApplicationAction,function (message)self:backApplicationAction(message)end)
    ff.net:registerEvent(2,dd.Tjf_CheckName,function (message)self:backCheckName(message)end)
    ff.net:registerEvent(1,dd.Tjf_AllyNameAction,function (message)self:backAllyNameAction(message)end)
    ff.net:registerEvent(1,dd.Tjf_union_EditAllyTotem,function (message)self:backEditAllyTotem(message)end)
    
    self:getChildByName("mask"):setVisible(false)
    self.updateGold()         
end
function unionOptionLayer.updateGold(name,row,old,value)
    local sender = pop.getDialog("unionOption")
    if sender ~= nil then
        sender:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("top"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("top"):requestDoLayout()
    end
end

function unionOptionLayer.saveMark(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        if dd.myUnion:getLong(1,'unionofficial') < 6 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您的联盟权限不足"))
            return
        end
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then
            local message = ff.net:createMessage()
            message:addCmd(0x0000013a)
            message:addLong(dd.uid)
            message:addLong(widget.selMark)
            ff.net:rpc(message,false)
        end
    end 
end
function unionOptionLayer:selectOneMark()
    --设置选中
    cclog("~~~~~selMark:"..self.selMark)
    for var=1,self.MaxMarkNum do
        if var == self.selMark then
            self:getChildByName("changeMark"):getChildByName("logo_con"):getChildByTag(var):getChildByName("sel"):setVisible(false)
            self:getChildByName("changeMark"):getChildByName("logo_con"):getChildByTag(var):getChildByName("logo"):getVirtualRenderer():setGLProgramState(ff.Effect:effectHighLight():getGLProgramState())
        else
            self:getChildByName("changeMark"):getChildByName("logo_con"):getChildByTag(var):getChildByName("sel"):setVisible(true)
            self:getChildByName("changeMark"):getChildByName("logo_con"):getChildByTag(var):getChildByName("logo"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        end
    end
end
function unionOptionLayer:initMark()
    if self.mark_init == true then
        return
    end
    self.selMark = dd.myUnion:getLong(1,"totem")
    local logoCon = self:getChildByName("changeMark"):getChildByName("logo_con")
    logoCon:removeAllChildren()
    local function selectMark(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then   
            self.selMark = sender:getTag()
            self:selectOneMark()
            AudioEngine.playEffect(ff.sounds[109])
        end
    end
    local layerSize = logoCon:getContentSize()
    local size = self:getChildByName("changeMark"):getChildByName('logo_item'):getContentSize()
    local shang = math.modf(self.MaxMarkNum/3)
    local yu = self.MaxMarkNum%3
    if yu > 0 then
        shang = shang + 1
    end
    local panelHeight = layerSize.height
    if shang >= 3 then
        panelHeight = shang * (size.height + 40)
        logoCon:setInnerContainerSize(cc.size(layerSize.width,panelHeight))
    end
    for var=1, self.MaxMarkNum do
        local mark = self:getChildByName("changeMark"):getChildByName('logo_item'):clone()
        mark:getChildByName('logo'):loadTexture(dd.getUnionIcon(var),0)
        mark:setVisible(true)
        mark:setTag(var)
        local shang = math.modf((var-1)/3)
        local yu = (var-1)%3
        local x = 140 + 220 * yu
        local y = panelHeight - 200 * shang - 120

        mark:setPosition(cc.p(x,y))
        logoCon:addChild(mark)
        mark:addTouchEventListener(selectMark)
    end
    self:selectOneMark()
    self.mark_init = true
end
function unionOptionLayer:checkChangeNameData()
    local name = self.nameEdit:getText()
    local short = self.shortEdit:getText()
    local save = self:getChildByName("changeName"):getChildByName("saveBtn")
    cclog("changeCD:"..self.changeCD)
    if self.changeCD > 0 then
        save:setTouchEnabled(false)
        save:setBright(false)
        save:getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        save:getChildByName("gold_text"):setColor(cc.c3b(116,123,125))
        return
    else
        save:setTouchEnabled(true)
        save:setBright(true)
        save:getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
        save:getChildByName("gold_text"):setColor(cc.c3b(255,255,255))
    end
end
function unionOptionLayer.updateCD(sender)
    if sender ~= nil then
        if sender.changeCD <= 0 then
            sender:getChildByName("changeName"):getChildByName("mainArea"):getChildByName("cd_text"):setString("00:00:00")
        else
            sender.changeCD = sender.changeCD - 1
            sender:getChildByName("changeName"):getChildByName("mainArea"):getChildByName("cd_text"):setString(dd.getTimeStr2(sender.changeCD))
        end
    end
end
function unionOptionLayer:backApplicationAction(ret)
    if ret[1] == 0 then
        if ret[2] == 0 then
            self.allApplyNum = ret[3]
            if self.allApplyNum <= 0 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("当前没有申请信息"))
                return               
            end
            self.applyList = {}
            for var=1,ret[4]:rowCount() do
                local key = table.getn(self.applyList) + 1
                self.applyList[key] = {}
                self.applyList[key]["time"]= ret[4]:getLong(var,'time')
                self.applyList[key]["uid"]= ret[4]:getLong(var,'uid')
                self.applyList[key]["name"]= ret[4]:getString(var,'name')
                self.applyList[key]["face"]= ret[4]:getLong(var,'face')
                self.applyList[key]["vipLv"]= ret[4]:getLong(var,'vipLv')
                self.applyList[key]["fight"]= ret[4]:getLong(var,'fight')
                self.applyList[key]["kill"]= ret[4]:getLong(var,'kill')
                self.applyList[key]["lv"]= ret[4]:getLong(var,'lv')  
                self.applyList[key]["state"] = 2--1=邀请中2-申请中3-被拒绝             
            end
            self:initApplyList()
        elseif ret[2] == 1 then
            table.remove(self.applyList,self.applyKey)
            self:initApplyList()
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("已同意该玩家入盟"),true)
            return               
        elseif ret[2] == 2 then
            table.remove(self.applyList,self.applyKey)
            self:initApplyList()
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("已拒绝该玩家入盟"))
            return     
        end
    else
        dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(ret[1]))
    end
    
end
function unionOptionLayer:initApplyList()
    local layer = self:getChildByName("apply"):getChildByName("listCon")
    layer:removeAllChildren()
    
    local panelHeight = self.applyBaseSize.height
    local max = math.ceil(panelHeight/(self.applyItemSize.height + 9))

    if table.getn(self.applyList) >= max then
        panelHeight = (self.applyItemSize.height + 9) * table.getn(self.applyList)       
    end
    layer:setInnerContainerSize(cc.size(self.applyBaseSize.width,panelHeight))
    for var=1, table.getn(self.applyList) do
        local item = self:getChildByName("apply"):getChildByName("infoItem"):clone()
        item:getChildByName("mark"):loadTexture(dd.getPlayerIcon(self.applyList[var]["face"]),0)
        item:getChildByName("name_text"):setString(self.applyList[var]['name'].." LV."..self.applyList[var]['lv']) 
        item:getChildByName("rank_text"):setString(ff.getFormatMoney(self.applyList[var]['fight']))
        if self.applyList[var]['state'] == 1 then
            item:getChildByName("info_tip"):setString(ff.langString("邀请中").."...")
            item:getChildByName("agreeBtn"):setVisible(false)
            item:getChildByName("agreeBtn"):setEnabled(false)
            item:getChildByName("refuseBtn"):setVisible(true)
            item:getChildByName("refuseBtn"):setEnabled(true)
            item:getChildByName("refuseBtn"):setTag(10000)
        elseif self.applyList[var]['state'] == 2 then
            item:getChildByName("info_tip"):setString(ff.langString("申请中").."...")
            item:getChildByName("agreeBtn"):setVisible(true)
            item:getChildByName("agreeBtn"):setEnabled(true)
            item:getChildByName("refuseBtn"):setVisible(true)
            item:getChildByName("refuseBtn"):setEnabled(true)
            item:getChildByName("refuseBtn"):setTag(10001)
        end

        local x = 15
        local y = panelHeight - var * 115
        item:setPosition(cc.p(x,y))
        item:setVisible(true)
        item:setTag(var)
        layer:addChild(item)
    end
    if table.getn(self.applyList) == 0 then
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("当前没有申请和邀请信息"))
        return
    end

end


function unionOptionLayer:getChangeData()
    local message = ff.net:createMessage()
    message:addCmd(0x00000157)
    message:addLong(dd.uid)
    message:addLong(0)
    message:addString("",15)     
    message:addString("",3)
    ff.net:rpc(message,false)   

end
function unionOptionLayer:getZmData()
    local message = ff.net:createMessage()
    message:addCmd(0x00000156)
    message:addLong(dd.uid)
    message:addLong(0)     
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    ff.net:rpc(message,false)   

end

function unionOptionLayer.changeUnionMark(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then          
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then
            if dd.myUnion:getLong(1,"unionofficial") < 6 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("您的联盟权限不足"))
                return
            end
            local apply = widget:getChildByName("changeMark")
            apply:stopAllActions()                      
            pop.showPopEffect(99,apply)
            widget:selectOneMark()
        end
    end
end

function unionOptionLayer.showApplyInfo(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then          
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then
            if dd.myUnion:getLong(1,"unionofficial") < 4 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("您的联盟权限不足"))
                return
            end
            local apply = widget:getChildByName("apply")
            apply:stopAllActions()
            local message = ff.net:createMessage()
            message:addCmd(0x117)
            message:addLong(dd.uid)
            message:addLong(0)
            message:addLong(0)
            ff.net:rpc(message,false)                       
            pop.showPopEffect(99,apply)           
        end
    end
end
--保存入盟条件
function unionOptionLayer.saveZm(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        if dd.myUnion:getLong(1,'unionofficial') < 4 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您的联盟权限不足"))
            return
        end
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then
            widget:onSaveZm()
        end
    end 
end

function unionOptionLayer:onSaveZm()
    local message = ff.net:createMessage()
    message:addCmd(0x00000156)
    message:addLong(dd.uid)
    message:addLong(1)
    message:addLong(self.ifAuto)
    message:addLong(self.need_lv)
    message:addLong(self.need_fight)
    message:addLong(self._lan)
    message:addLong(self._rule)
    message:addLong(self._zone)
    ff.net:rpc(message,false)   
end
--解散
function unionOptionLayer.closeDismiss(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then
            widget:onCloseDismiss()
        end
    end     
end
function unionOptionLayer.showDismiss(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then          
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then
            widget:onCloseNewLeader()
            widget:getChildByName("dismiss"):setPositionY(0)
            widget:getChildByName("dismiss"):setVisible(true)
            widget:getChildByName("mask"):setVisible(true)        end
    end    
end
function unionOptionLayer:onCloseDismiss()
    local function endAction()
        self:getChildByName("mask"):setVisible(false)
        self:getChildByName("dismiss"):setVisible(false)
    end
    cclog("y:"..self:getChildByName("dismiss"):getPositionY())
    if self:getChildByName("dismiss"):isVisible() == true and self:getChildByName("dismiss"):getPositionY() == 0 then
        endAction()
        return true
    end    
    return false    
end
function unionOptionLayer:onCloseApply()
    local function endAction()
        local layer = self:getChildByName("apply"):getChildByName("listCon")
        layer:removeAllChildren()
        self:getChildByName("apply"):setVisible(false)
    end
    if self:getChildByName("apply"):isVisible() == true and self:getChildByName("apply"):getPositionY() == 0 then
        endAction()
        return true
    end    
    return false    
end
function unionOptionLayer:onCloseZM()
    local function endAction()
        self:getChildByName("zm"):setVisible(false)
        self.fightEdit:setEnabled(false)
        self.lvEdit:setEnabled(false)
    end
    if self:getChildByName("zm"):isVisible() == true and self:getChildByName("zm"):getPositionY() == 0 then
        endAction()
        return true
    end    
    return false    
end
function unionOptionLayer:onCloseChange()
    local function endAction()
        self:getChildByName("changeName"):setVisible(false)
        self.nameEdit:setText("")
        self.shortEdit:setText("")
        self.nameEdit:setEnabled(false)
        self.shortEdit:setEnabled(false)
    end
    if self:getChildByName("changeName"):isVisible() == true and self:getChildByName("changeName"):getPositionY() == 0 then
        endAction()
        return true
    end    
    return false    
end
function unionOptionLayer:onCloseChangeMark()
    if self:getChildByName("changeMark"):isVisible() == true and self:getChildByName("changeMark"):getPositionY() == 0 then
        self:getChildByName("changeMark"):setVisible(false)
        return true
    end    
    return false    
end
function unionOptionLayer.onSureDismiss(sender,eventType)
    if eventType==ccui.TouchEventType.ended then 
        
        dd.currentLayer._widget:onShowSure(ff.langString("警告"),ff.langString("我们需要您谨慎抉择，真的要解散`{0}`吗?",
            {dd.myUnion:getString(1,"unionname")}),
            function()
                local message = ff.net:createMessage()
                message:addCmd(0x00000114)
                message:addLong(dd.uid)
                ff.net:rpc(message,false)
            end,false,1)
    end 
end
function unionOptionLayer.onAllyDismiss(ret)
    if code == 0 then
        local widget = pop.getDialog("union")
        if widget ~= nil then
            widget._messageid = {0,0}
            widget:getChildByName("dismiss"):setVisible(false)
            widget:getChildByName("mask"):setVisible(false)
            pop.onClosePopDialog("union")
        end
    else
        dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(code))
    end    
    -- body
end

--继承
function unionOptionLayer:onCloseNewLeader()
    local function endAction()
        self:getChildByName("leader"):setVisible(false)
    end
    if self:getChildByName("leader"):isVisible() == true and self:getChildByName("leader"):getPositionY() == 0 then
        endAction()
        return true
    end    
    return false    
end
function unionOptionLayer.closeNewLeader(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then
            widget:onCloseNewLeader()
        end
    end 
end
function unionOptionLayer:closeIndex()
	if self._index == 0 then
		pop.onCloseEffect(99,self:getChildByName("view"))
	elseif self._index == 3 then
		pop.onCloseEffect(99,self:getChildByName("zm"))
		self.fightEdit:setEnabled(false)
        self.lvEdit:setEnabled(false)
    elseif self._index == 4 then
        pop.onCloseEffect(99,self:getChildByName("changeName"))
        self.nameEdit:setEnabled(false)
        self.shortEdit:setEnabled(false)
	end	
    return false
end

function unionOptionLayer:showIndex()
	if self._index == 0 then
        self:getChildByName("view"):setVisible(true)
        self:getChildByName("view"):setPosition(cc.p(0,0))
	elseif self._index == 3 then
        pop.showPopEffect(99,self:getChildByName("zm"))
        self.fightEdit:setEnabled(true) 
        self.lvEdit:setEnabled(true)
    elseif self._index == 4 then
        pop.showPopEffect(99,self:getChildByName("changeName"))
        self.nameEdit:setEnabled(true)
        self.shortEdit:setEnabled(true)		
	end	
end
function unionOptionLayer.onSureLeader(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then
            if string.len(widget._leaderedit:getText()) > 0 then
                if sender:getChildByName("label"):getString() == ff.langString("确定") then
                    local message = ff.net:createMessage()
                    message:addCmd(0x0000000f)
                    message:addLong(dd.uid)
                    message:addLong(0)
                    message:addString(widget._leaderedit:getText(),15)
                    platform_showWaiting(1,1)
                    local result = ff.net:call(message)
                    platform_showWaiting(0,0)
                    message:clear()
                    if result ~= nil then
                        local code = result:getLong()
                        if code == 0 then
                            local uid  = result:getLong()
                            local name = result:getString(15)
                            local face = result:getLong()
                            local city = result:getString(15)
                            local level= result:getLong()
                            local unionid = result:getLong()
                            if unionid == dd.myUnion:getLong(1,"unionid") then
                                widget:getChildByName("leader"):getChildByName("view"):getChildByName("tips"):getChildByName("label1"):setVisible(false)
                                widget:getChildByName("leader"):getChildByName("view"):getChildByName("tips"):getChildByName("label2"):setVisible(true)
                                widget:getChildByName("leader"):getChildByName("view"):getChildByName("sure"):getChildByName("label"):setString(ff.langString("继承"))
                                widget._leaderedit:setText("")
                            else
                                dd.currentLayer._widget:onShowTips("\t"..ff.langString("该玩家和你不属于同一个联盟。"))
                            end
                        else   
                            dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(code)) 
                        end
                        result:clear()
                    else
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有该玩家，是否输入了错误的名字？"))    
                    end
                else
                    local message = ff.net:createMessage()
                    message:addCmd(0x0000012b)
                    message:addLong(dd.uid)
                    message:addString(widget._leaderedit:getText(),15)
                    ff.net:rpc(message,false)                
                end
            end    
        end    
    end        
end
function unionOptionLayer.showNewLeader(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then
            widget:getChildByName("leader"):getChildByName("view"):setPositionY(-widget:getChildByName("view"):getContentSize().height)
            widget:getChildByName("leader"):setPositionY(0)
            widget:getChildByName("leader"):setVisible(true)
            widget:getChildByName("leader"):getChildByName("view"):getChildByName("sure"):getChildByName("label"):setString(ff.langString("确定"))
            widget:getChildByName("leader"):getChildByName("view"):getChildByName("tips"):getChildByName("label1"):setVisible(true)
            widget:getChildByName("leader"):getChildByName("view"):getChildByName("tips"):getChildByName("label2"):setVisible(false)
            widget:getChildByName("leader"):getChildByName("view"):runAction(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,140))))
        end
    end    
end

function unionOptionLayer.showChangeName(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then          
        if dd.myUnion:getLong(1,"unionofficial") < 6 then
            dd.currentLayer._widget:onShowTips(ff.langString("您的联盟权限不足"))
            return
        end
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then
            widget:closeIndex()
            widget._index = sender:getTag()
            widget:showIndex()
        end 
    end    
end
function unionOptionLayer.showLeave(sender,eventType)
    local function sure()
        local function sureLeave()
            dd.currentLayer._widget:onShowSure(ff.langString("警告"),ff.langString("我们需要您谨慎抉择，真的要离开`{0}`吗?",
            {dd.myUnion:getString(1,"unionname")}),
            function()
                local message = ff.net:createMessage()
                message:addCmd(0x00000119)
                message:addLong(dd.uid)
                ff.net:rpc(message,false)
            end,false,1)

        end
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then
            performWithDelay(widget,sureLeave, 0.8)
        end 
    end
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then         
        if dd.myUnion:getLong(1,"unionofficial") < 6 then
            dd.currentLayer._widget:onShowSure(ff.langString("警告"),ff.langString("您确认要\n离开联盟吗?"),sure,false,1)
        else
            local  widget = pop.getDialog("union")
            if widget ~= nil then
                performWithDelay(widget,function()
                    widget:selectMember()
                    pop.onShowPopDialog("unionMember")
                    widget._managerIndex = 2
                end, 0.1)
            end
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("盟主必须先定择继承人才能离开联盟"))
        end
    end    
end
function unionOptionLayer.showOption(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then          
        if dd.myUnion:getLong(1,"unionofficial") < 4 then
            dd.currentLayer._widget:onShowTips(ff.langString("您的联盟权限不足"))
            return
        end
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then
        	widget:closeIndex()
        	widget._index = sender:getTag()
        	widget:showIndex()
        end	
    end
end
function unionOptionLayer.showHistory(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then          
        local widget = pop.onShowPopDialog("unionHistory")
    end
end
function unionOptionLayer:backEditAllyCondition(ret)
    if ret[1] == 0 then
        if ret[2] == 1 then
            self:onCloseZM()       
            self._index = 0
            self:showIndex()
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("招募设置已保存"),true)
        elseif ret[2] == 0 then
            self._lan = ret[3]['lan']
            self._zone= ret[3]['time']
            self._rule= ret[3]['rule']
            self.ifAuto = ret[3]['ifAuto']
            self.need_fight  = ret[3]['fight']
            self.need_lv  = ret[3]['lv']
            cclog("ifAuto"..self.ifAuto.."lan:"..self._lan.."zone:"..self._zone.."rule:"..self._rule.."fight:"..self.need_fight.."lv:"..self.need_lv)
            self:getChildByName("zm"):getChildByName("detail"):getChildByName("lan"):getChildByName("lan_bg"):getChildByName("chu_lan_text"):setString(ff.langString(dd.languageArr[self._lan]))
            self:getChildByName("zm"):getChildByName("detail"):getChildByName("rule"):getChildByName("rule_bg"):getChildByName("rule_text"):setString(dd.ruleArr[self._rule])
            self:getChildByName("zm"):getChildByName("detail"):getChildByName("time"):getChildByName("time_bg"):getChildByName("chu_time_text"):setString(dd.timeArr[self._zone])
            self:getChildByName("zm"):getChildByName("detail"):getChildByName("join"):getChildByName("auto_btn"):setSelectedState(self.ifAuto == 1)
            local fightInput = self:getChildByName("zm"):getChildByName("detail"):getChildByName("join"):getChildByName("fight_bg")
            local lvInput = self:getChildByName("zm"):getChildByName("detail"):getChildByName("join"):getChildByName("lv_bg")

            if self.need_fight == nil then
                self.need_fight = 0
            end
            if self.need_lv == nil then
                self.need_lv = 0
            end

            if fightInput:getChildByTag(12012) ~= nil then
                fightInput:getChildByTag(12012):setText(tostring(self.need_fight))
            end
            if lvInput:getChildByTag(12013) ~= nil then
                lvInput:getChildByTag(12013):setText(tostring(self.need_lv))
            end
        end
    end
end

function unionOptionLayer:backCheckName(ret)
    if ret[1] == true then
        if ret[2] == 1 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("此联盟名可以使用"),true)
        elseif ret[2] == 2 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("此联盟简称可以使用"),true)
        elseif ret[2] == 3 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("此玩家名可以使用"),true)
        end
    else
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            if ret[3] == 3 then
                if ret[2] == 1 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("此联盟名称已被使用"))
                elseif ret[2] == 2 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("此联盟简称已被使用"))
                elseif ret[2] == 3 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("此玩家名称已被使用"))
                end
            else
                dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(ret[3]))
            end
        end 
    end
end
function unionOptionLayer:backAllyNameAction(ret)
    if ret[1] == 0 then
        if ret[2] == 1 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("联盟名称修改成功"),true)   
            dd.mainUI:showGiftNotice(7,0,ret[4],cc.p(360,ff.height/2),2) 
            local widget = pop.getDialog("union")
            if widget ~= nil then
                local info = widget:getChildByName("manager"):getChildByName("view"):getChildByName("info")
                info:getChildByName("short"):setString("["..dd.myUnion:getString(1,"unionflag").."]")
                info:getChildByName("name"):setString(dd.myUnion:getString(1,"unionname"))
                info:requestDoLayout()
            end 
        end
        self.changeCD = ret[3] - dd.getServerTime()
        self:checkChangeNameData()
        cclog("~~~~~~~~~~~~~~~nextTime:"..self.changeCD) 
    else
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            if ret[1] == 3 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("此联盟名称已被使用"))
            else
                dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(ret[1]))
            end
        end
    end    
end
function unionOptionLayer:backEditAllyTotem(ret)
    if ret[1] == 0 then
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("联盟徽章修改成功"),true)
        local widget = pop.getDialog("union")
        if widget ~= nil then
            local info = widget:getChildByName("manager"):getChildByName("view"):getChildByName("info")
            info:getChildByName("icon"):loadTexture(dd.getUnionIcon(dd.myUnion:getLong(1,"totem")),0)
        end 
    else
        dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(ret[1]))
    end    
end
function unionOptionLayer:initSubPanel()
    local hh = ff.height
    self:getChildByName("apply"):setContentSize(cc.size(720,hh - 100))
    self:getChildByName("apply"):getChildByName("back"):setContentSize(cc.size(720,hh - 100))
    self:getChildByName("apply"):getChildByName("listCon"):setContentSize(cc.size(720,hh - 100))
    self:getChildByName("apply"):setPositionY(0)
    self:getChildByName("zm"):setContentSize(cc.size(720,hh - 105))
    self:getChildByName("zm"):getChildByName("save"):setPositionY(hh - 760)
    self:getChildByName("zm"):getChildByName("save"):addTouchEventListener(self.saveZm)
    local shh = 600
    self:getChildByName("zm"):getChildByName("detail"):setContentSize(cc.size(720,shh))
    self:getChildByName("zm"):getChildByName("detail"):setPositionY(hh - 105 - shh)
    self:getChildByName("zm"):getChildByName("detail"):setVisible(true)
    self:getChildByName("zm"):setPositionY(0)
    local change = self:getChildByName("changeName")
    change:setContentSize(cc.size(720,hh - 105))
    change:getChildByName("mainArea"):setContentSize(cc.size(720,hh - 105 - 420))
    change:getChildByName("mainArea"):setInnerContainerSize(cc.size(720,hh - 105 - 420))
    change:setPositionY(0)
    change:getChildByName("saveBtn"):getChildByName("gold_text"):setString(self.changeGold)
    local cmark = self:getChildByName("changeMark")
    cmark:setContentSize(cc.size(720,hh - 105))
    cmark:getChildByName("back"):setContentSize(cc.size(720,hh - 105))
    cmark:getChildByName("logo_con"):setContentSize(cc.size(720,hh - 105 - 210))
    cmark:getChildByName("logo_con"):setInnerContainerSize(cc.size(720,hh - 105 - 210))
    cmark:setPositionY(0)
    cmark:getChildByName("saveBtn"):addTouchEventListener(self.saveMark)

    self:getChildByName("zm"):getChildByName("detail"):getChildByName("lan"):getChildByName("pre_btn"):addTouchEventListener(self.preLan)
    self:getChildByName("zm"):getChildByName("detail"):getChildByName("lan"):getChildByName("next_btn"):addTouchEventListener(self.nextLan)

    self:getChildByName("zm"):getChildByName("detail"):getChildByName("time"):getChildByName("pre_btn"):addTouchEventListener(self.preTimeZone)
    self:getChildByName("zm"):getChildByName("detail"):getChildByName("time"):getChildByName("next_btn"):addTouchEventListener(self.nextTimeZone)

    self:getChildByName("zm"):getChildByName("detail"):getChildByName("rule"):getChildByName("pre_btn"):addTouchEventListener(self.preRule)
    self:getChildByName("zm"):getChildByName("detail"):getChildByName("rule"):getChildByName("next_btn"):addTouchEventListener(self.nextRule)
    self:getChildByName("zm"):getChildByName("detail"):getChildByName("join"):getChildByName("auto_btn"):addTouchEventListener(self.autoJoin)
    self:getChildByName("zm"):getChildByName("detail"):getChildByName("join"):getChildByName("notice_tip"):addTouchEventListener(self.autoJoin)
    self:getChildByName("leader"):getChildByName("view"):getChildByName("sure"):addTouchEventListener(self.onSureLeader)
    self:getChildByName("leader"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.closeNewLeader)        
    self:getChildByName("leader"):setContentSize(cc.size(720,hh - 8))
    self:getChildByName("leader"):setPositionY(0)

    self:getChildByName("leader"):getChildByName("view"):getChildByName("tips"):getChildByName("label1"):setString(ff.langString("请选择一个优秀的盟友，作为新的会长。"))
    self:getChildByName("leader"):getChildByName("view"):getChildByName("tips"):getChildByName("label2"):setString(ff.langString("这是一个重要的决定，我们需要你对继承者的身份进行二次确认。"))

    self:getChildByName("dismiss"):getChildByName("view"):getChildByName("sure"):addTouchEventListener(self.onSureDismiss)
    self:getChildByName("dismiss"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.closeDismiss)        
    self:getChildByName("dismiss"):setContentSize(cc.size(720,hh - 8))
    self:getChildByName("dismiss"):setPositionY(0)
    local cname = self:getChildByName("changeName")
    cname:setContentSize(cc.size(720,hh - 105))
    cname:getChildByName("back"):setContentSize(cc.size(720,hh - 105))
    if (hh - 105 - 120 - 115 - 100) > 780 then
        cname:getChildByName("mainArea"):setContentSize(cc.size(720,780))
        cname:getChildByName("mainArea"):setInnerContainerSize(cc.size(720,780))
    else
        cname:getChildByName("mainArea"):setContentSize(cc.size(720,hh - 105 - 120 - 115 - 100))
        cname:getChildByName("mainArea"):setInnerContainerSize(cc.size(720,hh - 105 - 120 - 115 - 100))
    end
    --edit
    local size = self:getChildByName("leader"):getChildByName("view"):getChildByName("input"):getChildByName("input"):getChildByName("input"):getContentSize()
    local editBox = dd.addEditBox(
        self:getChildByName("leader"):getChildByName("view"):getChildByName("input"):getChildByName("input")
        , size
        , "images/chatInput.png"
        , 12011
        , cc.p(0,0)
        , cc.p(self:getChildByName("leader"):getChildByName("view"):getChildByName("input"):getChildByName("input"):getChildByName("input"):getPosition())
        , cc.c3b(255,255,255)
        , 20
        , 6
        , 4
        , 1
        , 32
        , true
        , true
        , true
    )
    self._leaderedit = editBox

    local fightInput = self:getChildByName("zm"):getChildByName("detail"):getChildByName("join"):getChildByName("fight_bg")
    local lvInput = self:getChildByName("zm"):getChildByName("detail"):getChildByName("join"):getChildByName("lv_bg")

    if self.need_fight == nil then
        self.need_fight = 0
    end
    if self.need_lv == nil then
        self.need_lv = 0
    end


    if fightInput:getChildByTag(12012) == nil then
        dd.addEditBox(fightInput,cc.size(fightInput:getContentSize().width - 20,fightInput:getContentSize().height - 10),'images/ui/alpha.png',12012,cc.p(0.5,0.5),cc.p(fightInput:getContentSize().width/2,fightInput:getContentSize().height/2),cc.c3b(161,175,175),20,2,4,1,12,true,true,true)
        fightInput:getChildByTag(12012):setText(tostring(self.need_fight))
        self.fightEdit = fightInput:getChildByTag(12012)
    end
    if lvInput:getChildByTag(12013) == nil then
        dd.addEditBox(lvInput,cc.size(lvInput:getContentSize().width - 20,lvInput:getContentSize().height - 10),'images/ui/alpha.png',12013,cc.p(0.5,0.5),cc.p(lvInput:getContentSize().width/2,lvInput:getContentSize().height/2 +1),cc.c3b(161,175,175),20,2,4,1,10,true,true,true)
        lvInput:getChildByTag(12013):setText(tostring(self.need_lv))
        self.lvEdit = lvInput:getChildByTag(12013)
    end
    local function editBoxTextEventHandle(strEventName,pSender)
        local edit = pSender
        local strFmt 
        if strEventName == "began" then

        elseif strEventName == "ended" or strEventName == "return" then
            local text = edit:getText()
            if tonumber(text) == nil then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("输入必须是数字"))
                edit:setText(tostring(self.need_fight))
                return
            elseif tonumber(text) < 0 then         
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("输入的数值必须大于0"))
                edit:setText(tostring(self.need_lv))
                return           
            end
            local tag = edit:getTag()
            if tag == 12013 and tonumber(text) > dd.cfgBuilding[1]['maxlevel'] then
                edit:setText(tostring(dd.cfgBuilding[1]['maxlevel']))               
            end
            if tag == 12012 then
                self.need_fight = math.modf(tonumber(fightInput:getChildByTag(12012):getText()))
            elseif tag == 12013 then
                self.need_lv = math.modf(tonumber(lvInput:getChildByTag(12013):getText()))
            end
        elseif strEventName == "changed" then

        end
    end
    fightInput:getChildByTag(12012):registerScriptEditBoxHandler(editBoxTextEventHandle)
    lvInput:getChildByTag(12013):registerScriptEditBoxHandler(editBoxTextEventHandle)

    local shortInput = self:getChildByName("changeName"):getChildByName("mainArea"):getChildByName("short"):getChildByName("short_bg")
    local nameInput = self:getChildByName("changeName"):getChildByName("mainArea"):getChildByName("name"):getChildByName("name_bg")

    if nameInput:getChildByTag(12014) == nil then
        dd.addEditBox(nameInput,cc.size(nameInput:getContentSize().width - 20,nameInput:getContentSize().height - 2),'images/ui/alpha.png',12014,cc.p(0.5,0.5),cc.p(nameInput:getContentSize().width/2,nameInput:getContentSize().height/2 + 5),cc.c3b(161,175,175),28,6,4,5,15,true,true,true)
        self.nameEdit = nameInput:getChildByTag(12014)
    end
    self.nameEdit:setText("")
    if shortInput:getChildByTag(12015) == nil then
        dd.addEditBox(shortInput,cc.size(shortInput:getContentSize().width - 20,shortInput:getContentSize().height - 2),'images/ui/alpha.png',12015,cc.p(0.5,0.5),cc.p(shortInput:getContentSize().width/2,shortInput:getContentSize().height/2 + 5),cc.c3b(161,175,175),28,6,4,1,3,true,true,true)
        self.shortEdit = shortInput:getChildByTag(12015)
    end
    self.shortEdit:setText("")
    local function editBoxTextEventHandle1(strEventName,pSender)
        local edit = pSender
        local strFmt 
        if strEventName == "began" then

        elseif strEventName == "ended" or strEventName == "return" then
            local tag = pSender:getTag()
            local text = edit:getText()
            if tag == 12014 and string.len(text) <= 0 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("联盟名称不能为空"))
                edit:setText("")
                return
            elseif  tag == 12015 and string.len(text) ~= 3 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("联盟简称必须是3个字符"))
                edit:setText("")
                return
            end
            self:checkChangeNameData()          
        elseif strEventName == "changed" then

        end
    end
    --top条
    self:getChildByName("top"):setPositionY(ff.height - 105)
    self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onClose)
    self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    local apply = self:getChildByName("apply")
    self.applyBaseSize = apply:getContentSize()
    self.applyItemSize = apply:getChildByName("infoItem"):getContentSize()

    local function agreeOption(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then     
            if dd.myUnion:getLong(1,"unionofficial") < 4 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("您的联盟权限不足"))
                return
            end
            local message = ff.net:createMessage()
            message:addCmd(0x117)
            message:addLong(dd.uid)
            message:addLong(1)
            local key = sender:getParent():getTag()
            message:addLong(self.applyList[key]["uid"])
            ff.net:rpc(message,false)
            self.applyKey = key--正在操作哪个申请
        end 
    end
    local function refuseOption(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then     
            if dd.myUnion:getLong(1,"unionofficial") < 4 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("您的联盟权限不足"))
                return
            end
            if sender:getTag() == 10000 then --取消邀请
            elseif sender:getTag() == 10001 then --拒绝申请
                local message = ff.net:createMessage()
                message:addCmd(0x117)
                message:addLong(dd.uid)
                message:addLong(2)
                local key = sender:getParent():getTag()
                message:addLong(self.applyList[key]["uid"])
                ff.net:rpc(message,false)
                self.applyKey = key--正在操作哪个申请
            end 
        end 
    end
    self:getChildByName("apply"):getChildByName("infoItem"):getChildByName("agreeBtn"):addTouchEventListener(agreeOption)
    self:getChildByName("apply"):getChildByName("infoItem"):getChildByName("refuseBtn"):addTouchEventListener(refuseOption)

    local function checkUnionName(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then       
            if cc.PLATFORM_OS_ANDROID ~= cc.Application:getInstance():getTargetPlatform() then  
                self.inputName = self:getChildByName("changeName"):getChildByName("mainArea"):getChildByName("name"):getChildByName("name_bg"):getChildByTag(12014):getText() 
            else
                local isv = platform_isInputVisable()
                if isv == 1 then
                    self.inputName = platform_updateInputText()
                    self:getChildByName("changeName"):getChildByName("mainArea"):getChildByName("name"):getChildByName("name_bg"):getChildByTag(12014):setText(self.inputName)
                    platform_clearInput()
                else
                    self.inputName = self:getChildByName("changeName"):getChildByName("mainArea"):getChildByName("name"):getChildByName("name_bg"):getChildByTag(12014):getText()  
                end
            end
            local message = ff.net:createMessage()
            message:addCmd(0x128)
            message:addLong(dd.uid)
            message:addLong(1)
            message:addString(self.inputName,15)
            ff.net:rpc(message,false)
            self.okGo = false
        end 

    end
    local function checkUnionShort(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then         
            if cc.PLATFORM_OS_ANDROID ~= cc.Application:getInstance():getTargetPlatform() then 
                self.inputShort = self:getChildByName("changeName"):getChildByName("mainArea"):getChildByName("short"):getChildByName("short_bg"):getChildByTag(12015):getText()
            else
                local isv = platform_isInputVisable()
                if isv == 1 then
                    self.inputShort = platform_updateInputText()
                    self:getChildByName("changeName"):getChildByName("mainArea"):getChildByName("short"):getChildByName("short_bg"):getChildByTag(12015):setText(self.inputShort)
                    platform_clearInput()
                else
                    self.inputShort = self:getChildByName("changeName"):getChildByName("mainArea"):getChildByName("short"):getChildByName("short_bg"):getChildByTag(12015):getText()
                end
            end
            if string.len(self.inputShort) ~= 3 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("联盟简称必须是3个字符"))
                return
            end
            local message = ff.net:createMessage()
            message:addCmd(0x128)
            message:addLong(dd.uid)
            message:addLong(2)
            message:addString(self.inputShort,15)
            ff.net:rpc(message,false)
            self.okGo = false
        end 

    end
    self:getChildByName("changeName"):getChildByName("mainArea"):getChildByName("name"):getChildByName("check_btn"):addTouchEventListener(checkUnionName)
    self:getChildByName("changeName"):getChildByName("mainArea"):getChildByName("short"):getChildByName("check_btn"):addTouchEventListener(checkUnionShort)

    local function changeUnionName(sender,eventType)
        if eventType==ccui.TouchEventType.ended then    
            if self.changeCD > 0 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("联盟改名正在冷却中"))
                return
            end
            self.inputName = self:getChildByName("changeName"):getChildByName("mainArea"):getChildByName("name"):getChildByName("name_bg"):getChildByTag(12014):getText() 
            self.inputShort = self:getChildByName("changeName"):getChildByName("mainArea"):getChildByName("short"):getChildByName("short_bg"):getChildByTag(12015):getText()

            if self.inputName == '' or self.inputShort == '' then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("必须填写联盟名和联盟简称"))
                return
            end
            if string.len(self.inputShort) ~= 3 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("联盟简称必须是3个字符"))
                return
            end
            if dd.gold() < self.changeGold then
                local function sure()
                    pop.onShowPopDialog("charge")
                end
                dd.mainUI:onShowSure(ff.langString("金币不足"),ff.langString("充值可以让你立即拥有大量金币.\n是否现在就去?"),sure,true,2,2,ff.langString("充值"))
                return
            end
            local message = ff.net:createMessage()
            message:addCmd(0x157)
            message:addLong(dd.uid)
            message:addLong(1)
            message:addString(self.inputName,15)
            message:addString(self.inputShort,3)                
            ff.net:rpc(message,false)
        end 
    end  
    self:getChildByName("changeName"):getChildByName("saveBtn"):addTouchEventListener(changeUnionName)  
end
function unionOptionLayer.onStart(sender)
    ff.net:bindProperty(103,"gold",sender.updateGold)    
    if sender._init == false then 
        sender:initSubPanel()
        sender:initMark()
        sender._init = true
    end
    sender.fightEdit:setText("0")
    sender.lvEdit:setText("1")
    sender.nameEdit:setText("")
    sender.shortEdit:setText("")
    sender.fightEdit:setEnabled(false)
    sender.lvEdit:setEnabled(false)
    sender.nameEdit:setEnabled(false)
    sender.shortEdit:setEnabled(false)
    local save = sender:getChildByName("changeName"):getChildByName("saveBtn")
    save:setTouchEnabled(false)
    save:setBright(false)
    save:getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
    save:getChildByName("gold_text"):setColor(cc.c3b(116,123,125))
    sender:onCloseNewLeader()

    sender._lan = dd.myUnion:getLong(1,"lan")
    sender._zone= dd.myUnion:getLong(1,"time")
    sender._rule= dd.myUnion:getLong(1,"rule")

    sender:getChildByName("zm"):getChildByName("detail"):getChildByName("lan"):getChildByName("lan_bg"):getChildByName("chu_lan_text"):setString(ff.langString(dd.languageArr[sender._lan]))
    sender:getChildByName("zm"):getChildByName("detail"):getChildByName("time"):getChildByName("time_bg"):getChildByName("chu_time_text"):setString(dd.timeArr[sender._zone])
    sender:getChildByName("zm"):getChildByName("detail"):getChildByName("rule"):getChildByName("rule_bg"):getChildByName("rule_text"):setString(dd.ruleArr[sender._rule])

    sender._index = 0
    schedule(sender, sender.updateCD,1)
end
function unionOptionLayer.onEnd(sender)
    ff.net:unbindProperty("gold",103) 
    dd.delBackEvent()
    ff.net:removeEvent(1,dd.Tjf_union_EditAllyCondition)
    ff.net:removeEvent(1,dd.Tjf_union_ApplicationAction)
    ff.net:removeEvent(2,dd.Tjf_CheckName)
    ff.net:removeEvent(1,dd.Tjf_AllyNameAction)
    ff.net:removeEvent(1,dd.Tjf_union_EditAllyTotem)
    local layer = sender:getChildByName("apply"):getChildByName("listCon")
    layer:removeAllChildren()
    sender.applyList = {}
    sender.applyKey = 0
    sender:stopAllActions()
end
function unionOptionLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("icon"),sender:getChildByName("top"):getChildByName("addgold")) 
    if dd.myUnion:getLong(1,"unionofficial") >= 4 then
        sender:getZmData()
    end
    if dd.myUnion:getLong(1,"unionofficial") > 5 then
        sender:getChangeData()
    end
	return true
end

--招募管理，上下按钮
function unionOptionLayer.preTimeZone(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then        
            if widget._zone > 1 then            
                widget._zone = widget._zone - 1
            else
                widget._zone = table.getn(dd.timeArr)
            end
            widget:getChildByName("zm"):getChildByName("detail"):getChildByName("time"):getChildByName("time_bg"):getChildByName("chu_time_text"):setString(dd.timeArr[widget._zone])
        end            
    end 
end
function unionOptionLayer.nextTimeZone(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then    
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then
            if widget._zone < table.getn(dd.timeArr) then            
                widget._zone = widget._zone + 1
            else
                widget._zone = 1
            end
            widget:getChildByName("zm"):getChildByName("detail"):getChildByName("time"):getChildByName("time_bg"):getChildByName("chu_time_text"):setString(dd.timeArr[widget._zone])
        end            
    end 
end
function unionOptionLayer.preLan(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then        
            if widget._lan > 1 then            
                widget._lan = widget._lan - 1
            else
                widget._lan = table.getn(dd.languageArr)
            end
            widget:getChildByName("zm"):getChildByName("detail"):getChildByName("lan"):getChildByName("lan_bg"):getChildByName("chu_lan_text"):setString(ff.langString(dd.languageArr[widget._lan]))
        end                
    end 
end
function unionOptionLayer.nextLan(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then        
            if widget._lan < table.getn(dd.languageArr) then            
                widget._lan = widget._lan + 1
            else
                widget._lan = 1
            end
            widget:getChildByName("zm"):getChildByName("detail"):getChildByName("lan"):getChildByName("lan_bg"):getChildByName("chu_lan_text"):setString(ff.langString(dd.languageArr[widget._lan]))
        end            
    end 
end
function unionOptionLayer.preRule(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then        
            if widget._rule > 1 then            
                widget._rule = widget._rule - 1
            else
                widget._rule = table.getn(dd.ruleArr)
            end
            widget:getChildByName("zm"):getChildByName("detail"):getChildByName("rule"):getChildByName("rule_bg"):getChildByName("rule_text"):setString(dd.ruleArr[widget._rule])
        end            
    end 
end
function unionOptionLayer.nextRule(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then        
            if widget._rule < table.getn(dd.ruleArr) then            
                widget._rule = widget._rule + 1
            else
                widget._rule = 1
            end
            widget:getChildByName("zm"):getChildByName("detail"):getChildByName("rule"):getChildByName("rule_bg"):getChildByName("rule_text"):setString(dd.ruleArr[widget._rule])
        end            
    end 
end
function unionOptionLayer.autoJoin(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then        
            if widget.ifAuto == 1 then
                widget.ifAuto = 0 
            else
                widget.ifAuto = 1
            end
        end         
        if sender:getName() == "notice_tip" then
            widget:getChildByName("zm"):getChildByName("detail"):getChildByName("join"):getChildByName("auto_btn"):setSelectedState(widget.ifAuto==1)
        end
    end 
end
function unionOptionLayer.onClose(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then
            widget.onReturn(widget)
        end
    end
end

function unionOptionLayer.onReturn(sender)
    local  sender = pop.getDialog("unionOption")
    if sender:getChildByName("dismiss"):isVisible() then
        sender:getChildByName("dismiss"):setVisible(false)
        sender:getChildByName("mask"):setVisible(false)
    end
    if sender:getChildByName("leader"):isVisible() then
        sender:getChildByName("leader"):setVisible(false)
        sender:getChildByName("mask"):setVisible(false)
    end
    if sender:onCloseApply() == true then
        return true
    end 
    if sender:onCloseZM() == true or sender:onCloseChange() == true or sender:onCloseChangeMark() == true then
        if sender._index ~= 0 then
            sender._index = 0
            sender:showIndex()
        end
        return true
    end
    pop.onClosePopDialog("unionOption")
    local union = pop.getDialog("union")
    if union ~= nil and union:isVisible() then
        union._managerIndex = 1
    end
    return false
end

function onShowUnionOption(widget)
    local layer = unionOptionLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
	layer:onInit()
	return layer
end
