StrongholdInfoLayer = class("StrongholdInfoLayer")
StrongholdInfoLayer._name = "StrongholdInfo"
StrongholdInfoLayer._init = false
StrongholdInfoLayer._id = 0
StrongholdInfoLayer._info = {}
StrongholdInfoLayer._list = {}
StrongholdInfoLayer._tecCfg = {}
StrongholdInfoLayer._type = 1


function StrongholdInfoLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,StrongholdInfoLayer)
	return target
end

function StrongholdInfoLayer:onInit(  )
	-- body
    local hh = ff.height
	if self._init == false then
		
		self:setContentSize(cc.size(720,hh))
		self:setPositionY(0)
		self:getChildByName("bg"):setContentSize(cc.size(720,hh))
		self:getChildByName("bg"):addTouchEventListener(self.onReturn)
		self:getChildByName("topArea"):setPositionY(hh - 105)
		self:getChildByName("list"):setContentSize(cc.size(720,hh- 105 - 85 - 38))
    	self:getChildByName("list"):setPositionY(0)
        self:getChildByName("list2"):setContentSize(cc.size(720,hh- 105 - 85 - 38 - 120))
        self:getChildByName("list2"):setPositionY(120)
        self:getChildByName("topNavi"):setPositionY(hh - 105 - 85)
        self:getChildByName("info"):setPositionY(hh - 105 - 85 - 38)
        self:getChildByName("oper"):getChildByName("join"):getChildByName("Label"):setString(ff.langString("参与驻守"))
        self:getChildByName("oper"):getChildByName("join"):addTouchEventListener(self.onJoin)
        self:getChildByName("topNavi"):getChildByName("navi1"):addTouchEventListener(self.onSelectType)
        self:getChildByName("topNavi"):getChildByName("navi2"):addTouchEventListener(self.onSelectType)
        self:getChildByName("topNavi"):getChildByName("navi1"):setTag(1)
        self:getChildByName("topNavi"):getChildByName("navi2"):setTag(2)
        self:getChildByName("pop"):setPositionY(0)
        self:getChildByName("pop"):getChildByName("close"):addTouchEventListener(self.closePop)
        self:getChildByName("info"):getChildByName("help"):addTouchEventListener(self.openPop)
        
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setString(ff.langString("信息"))
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setString(ff.langString("奖励查看"))
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
        self:getChildByName("topNavi"):requestDoLayout()
    	self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onReturn)
    	self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
    	--self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("据点"))
       -- self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
        --self:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        self._init = true
	end
    if dd.KSRoom == 0 then
        self:getChildByName("info"):setPositionY(hh - 105 - 85 - 38)
        self:getChildByName("pop"):getChildByName("block1"):getChildByName("content"):setString(ff.langString("驻守据点的集结部队将获得“坚固壁垒”的额外效果，驻守时间越久，额外效果越强。如果驻守部队被击败，将退出据点，同时重置“坚固壁垒”的效果。"))

        self:getChildByName("topNavi"):setVisible(true)
        self:getChildByName("list"):setContentSize(cc.size(720,hh- 105 - 85 - 38))
        self:getChildByName("info"):getChildByName("tips"):setString(ff.langString("坚守据点时间越久，坚固壁垒的效果越强。"))
    else
        self:getChildByName("pop"):getChildByName("block1"):getChildByName("content"):setString(ff.langString("跨服战场中有5处女神遗迹，分别包含不同的神力，占领遗迹可使所有联盟成员获得女神的祝福。"))
        
        self:getChildByName("info"):setPositionY(hh - 105 - 42)
        self:getChildByName("info"):getChildByName("tips"):setString(ff.langString("占领女神获取强大增益"))
        self:getChildByName("topNavi"):setVisible(false)
        self:getChildByName("list"):setContentSize(cc.size(720,hh- 105 - 38))
    end
    self:initDate()
	self.updateGold()
end

function StrongholdInfoLayer.onJoin(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        for i=1,dd.mybuilds:rowCount() do
            if dd.mybuilds:getLong(i,"bid") == 15 then
                pop.onClosePopDialog("StrongholdInfo")
                onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos")) 
                return
            end
        end
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("请先建造{0}",{ff.langString(dd.cfgBuilding[15]['name'])}),true)
    end
end

function StrongholdInfoLayer.openPop(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then  
        local widget = pop.getDialog("StrongholdInfo") 
        pop.showPopEffect(12,widget:getChildByName("pop"))
    end
end

function StrongholdInfoLayer.onStart( sender )
	ff.net:bindProperty(2328,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    
    schedule(sender, sender.update,1)
    
end

function StrongholdInfoLayer.closePop(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("StrongholdInfo") 
        widget:getChildByName("pop"):setVisible(false)
    end
end

function StrongholdInfoLayer.onSelectType( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("StrongholdInfo")
        if widget ~= nil and widget._info ~= nil  then
            local tag = sender:getTag()
            if tag ~= widget._type then
                widget._type = sender:getTag()
                widget:selectType()
            else
                widget:selectType()
            end
        end
    end
end

function StrongholdInfoLayer:selectType(sender)
    self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)

    self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)

    if self._type == 1 then
        self:getChildByName("list2"):setVisible(false)
        self:getChildByName("list"):setVisible(true)
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(239, 223, 223))
    elseif self._type == 2 then
        self:getChildByName("list2"):setVisible(true)
        self:getChildByName("list"):setVisible(false)
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(239, 223, 223))
    end
    if sender ~= nil then
        sender:setSelectedState(true)
    end
    
    self:showList()
   
end


function StrongholdInfoLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("StrongholdInfo")
		if widget == nil then
			return
		end
        if widget:getChildByName("pop"):isVisible() == true then
            widget.closePop(sender,ccui.TouchEventType.ended)
            return
        end
        pop.onClosePopDialog("StrongholdInfo")
    end
end


function StrongholdInfoLayer.onBtn( sender,eventType )
    
    if eventType == ccui.TouchEventType.ended then
        
    end
    
end

function StrongholdInfoLayer.onEnd( sender )
    -- body
    dd.delBackEvent()
    ff.net:removeEvent(2,dd.Tjf_GetStrongholdWarDetail)
    sender:stopAllActions()
    sender:getChildByName("list"):removeAllChildren(true)
    ff.net:unbindProperty("gold",2328)
end

function onShowStrongholdInfo(widget,id)
	-- body
	local layer = StrongholdInfoLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
    layer._id = id
    layer:onInit()
    return layer
end

function StrongholdInfoLayer:getTaskList()
    local message = ff.net:createMessage()
    message:addCmd(0x0000005f)
    message:addLong(dd.uid)
    message:addLong(self._id)
    ff.net:rpc(message,false)
end

function StrongholdInfoLayer.onBefore( sender)
  -- bod
    ff.net:registerEvent(2,dd.Tjf_GetStrongholdWarDetail, function (message)sender:GetStrongholdWarDetail(message)end)
    sender:getTaskList()
    sender._type = 1
    sender:selectType(sender:getChildByName("topNavi"):getChildByName("navi1"))
end

function StrongholdInfoLayer:GetStrongholdWarDetail(params)
    local code = params[1]
    if code == 0 then
        self._info = params[2]
        self._list = params[3]
        self:showList()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end


function StrongholdInfoLayer.update( sender )
    if dd.KSRoom == 0 then

    	local item2 = sender:getChildByName("list"):getChildByTag(2)
        if item2 ~= nil then

            if sender._info.unionid > 0 then
                local time = dd.getServerTime() - sender._info.startTime
                
                item2:getChildByName("time"):setString(ff.langString("已持续")..":"..ff.getLeftTime(time,":"))
            else
                item2:getChildByName("time"):setString(ff.langString("已持续")..":0")
            end
        end
    end

end

function StrongholdInfoLayer:initDate(  )
    local rows = ff.dbmanager:sql_fetch_rows("select * from cfg_kuafujudian")
    self._tecCfg = {}

    for i=1,rows:rowCount() do
        local id = tonumber(rows:getString(i,"id"))
        self._tecCfg[id] = {}
        self._tecCfg[id]["buff1"] = tonumber(rows:getString(i,"buff1"))
        self._tecCfg[id]["num1"] = tonumber(rows:getString(i,"buff1_num"))
        self._tecCfg[id]["buff2"] = tonumber(rows:getString(i,"buff2"))
        self._tecCfg[id]["num2"] = tonumber(rows:getString(i,"buff2_num"))
        self._tecCfg[id]["buff3"] = tonumber(rows:getString(i,"buff3"))
        self._tecCfg[id]["num3"] = tonumber(rows:getString(i,"buff3_num"))
        self._tecCfg[id]["buff4"] = tonumber(rows:getString(i,"buff4"))
        self._tecCfg[id]["num4"] = tonumber(rows:getString(i,"buff5_num"))
        self._tecCfg[id]["pic"] = rows:getString(i,"pic")
        if ff.lang == -1 then
            self._tecCfg[id]["name"] = rows:getString(i,"name")
        else    
            self._tecCfg[id]["name"] = tonumber(rows:getString(i,"name_lan"))
        end
    end
    rows:clear()
end

function StrongholdInfoLayer:showList(  )
    if next(self._info) == nil then
        return
    end
    if self._type == 1 then
    	local item1 = self:getChildByName("list"):getChildByTag(1)
        if item1 == nil then
            item1 = self:getChildByName("block1"):clone()
            item1:setVisible(true)
            item1:setTag(1)
            self:getChildByName("list"):pushBackCustomItem(item1)
        end
        if self._info.unionid > 0 then
            item1:getChildByName("union"):setString("["..self._info.short.."]")
            item1:getChildByName("name"):setString(self._info.name..ff.langString("占领中"))
            item1:getChildByName("zbd"):setString(ff.langString("总兵力")..":"..self._info.army.."/"..self._info.armyMax)
            item1:getChildByName("power"):setString("Power:"..self._info.pow)
        else
            item1:getChildByName("union"):setString("")
            item1:getChildByName("name"):setString(ff.langString("无人占领"))
            item1:getChildByName("zbd"):setString(ff.langString("总兵力")..":0")
            item1:getChildByName("power"):setString("Power:0")
        end

        

        
        if dd.KSRoom == 0 then
            local item2 = self:getChildByName("list"):getChildByTag(2)
            if item2 == nil then
                item2 = self:getChildByName("item"):clone()
                item2:setVisible(true)
                item2:setTag(2)
                self:getChildByName("list"):pushBackCustomItem(item2)
            end
            item1:getChildByName("Image_71"):loadTexture(dd.getPathFromUI("Stronghold_ico.png",1))
            item2:getChildByName("name"):setString(ff.langString("坚固壁垒"))

            if self._info.unionid > 0 then
                local time = dd.getServerTime() - self._info.startTime
                local addbuff = math.floor(time / 3600)
                item2:getChildByName("info"):setString(ff.langString("驻防部队生命").." +"..addbuff.."%")
                item2:getChildByName("time"):setString(ff.langString("已持续")..":"..ff.getLeftTime(time,":"))
            else
                item2:getChildByName("info"):setString(ff.langString("驻防部队生命").." +0%")
                item2:getChildByName("time"):setString(ff.langString("已持续")..":0")
            end
            local item3 = self:getChildByName("list"):getChildByTag(3)
            if item3 == nil then
                item3 = self:getChildByName("string"):clone()
                item3:setVisible(true)
                item3:setTag(3)
                item3:getChildByName("string"):setString(ff.langString("可驻守士兵数量与占领者玩家联合作战中心相关。坚守据点至争夺阶段结束后，玩家所在联盟获得据点的使用权。在此期间据点无法被攻击，所有联盟成员每日可前往据点界面领取奖励。"))
                self:getChildByName("list"):pushBackCustomItem(item3)
            end
        else
            local item2 = self:getChildByName("list"):getChildByTag(2)
            if item2 == nil then
                item2 = self:getChildByName("item2"):clone()
                item2:setVisible(true)
                item2:setTag(2)
                self:getChildByName("list"):pushBackCustomItem(item2)
            end
            item1:getChildByName("Image_71"):loadTexture(dd.getPathFromUI("Stronghold_ico_"..self._id..".png",1))
            if self._tecCfg[self._id] ~= nil then
                item2:getChildByName("name"):setString(ff.langString(self._tecCfg[self._id]["name"]))
                item2:getChildByName("ico"):getChildByName("ico"):loadTexture("images/active/"..self._tecCfg[self._id]["pic"]..".png",0)
                local string = ""
                local str = ""
                local value = 0

                for i=1,4 do
                    if self._tecCfg[self._id]["buff"..i] ~= 0 then
                        
                        value = self._tecCfg[self._id]["num"..i]/dd.cfgEffect[self._tecCfg[self._id]["buff"..i]]['value']
                        str = dd.cfgEffect[self._tecCfg[self._id]["buff"..i]]['tips1']
                        str = ff.langString(str,{value})
                        if i > 1 then
                            string = string.." , "
                            
                        end
                        string= string .. str
                    end
                end
                item2:getChildByName("info"):setString(string)
            end
            local item3 = self:getChildByName("list"):getChildByTag(3)
            if item3 == nil then
                item3 = self:getChildByName("string"):clone()
                item3:setVisible(true)
                item3:setTag(3)
                item3:getChildByName("string"):setString(ff.langString("跨服战场中有5处女神遗迹，分别包含不同的神力，占领遗迹可使所有联盟成员获得女神的祝福。"))
                self:getChildByName("list"):pushBackCustomItem(item3)
            end
        end
        local hh = ff.height
        if self._info.unionid > 0 and dd.myUnion:getLong(1,"unionid") > 0 and self._info.unionid == dd.myUnion:getLong(1,"unionid") then
            self:getChildByName("oper"):setVisible(true)
            self:getChildByName("list2"):setContentSize(cc.size(720,hh- 105 - 85 - 38 - 120))
            self:getChildByName("list2"):setPositionY(120)
        else
            self:getChildByName("oper"):setVisible(false)
            self:getChildByName("list2"):setContentSize(cc.size(720,hh- 105 - 85 - 38))
            self:getChildByName("list2"):setPositionY(0)
        end
    else
        local item1 = self:getChildByName("list2"):getChildByTag(1)
        if item1 == nil then
            item1 = self:getChildByName("block2"):clone()
            item1:setVisible(true)
            item1:setTag(1)
            item1:getChildByName("info"):setString(ff.langString("成功占领据点后，在占领期间，每日可用联盟贡献换取以下奖励！如果占领多个据点，奖励将会增加"))
            self:getChildByName("list2"):pushBackCustomItem(item1)
        end

        for k,v in pairs(dd.cfgStrongHold) do
            local item = self:getChildByName("list2"):getChildByTag(k+1)
            if item == nil then
                item = self:getChildByName("item2"):clone()
                item:setVisible(true)
                item:setTag(k+1)
                self:getChildByName("list2"):pushBackCustomItem(item)

            end

            item:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/Stronghold/"..v['pic']..".png",0)
            item:getChildByName("name"):setString(ff.langString(v['name']))
            item:getChildByName("info"):setString(ff.langString(v['disc']))

        end
        
    end
end

function StrongholdInfoLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("StrongholdInfo")
    if widget ~= nil then
        widget:getChildByName("topArea"):getChildByName("money"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("topArea"):requestDoLayout()
    end
end