local StrongholdInfoEx = class("StrongholdInfoLayerEx")
StrongholdInfoEx._name = "StrongholdInfoEx"
StrongholdInfoEx._init = false 
StrongholdInfoEx._type = 1
StrongholdInfoEx._typeEx = 1 
StrongholdInfoEx._info1 = {}
StrongholdInfoEx._info2 = {}
StrongholdInfoEx._list1 = {}
StrongholdInfoEx._list2 = {}
StrongholdInfoEx._id = 0


function StrongholdInfoEx.extend( target )
	local b = tolua.getpeer(target)
	if not b then
		b = {}
		tolua.setpeer(target,b)
	end
	setmetatable(b,StrongholdInfoEx)
	return target
end

function onShowStrongholdInfoEx( widget ,id)
	local layer = StrongholdInfoEx.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer._id = id
	layer:onInit()
	return layer
end

function StrongholdInfoEx:onInit(  )
	if self._init == false then
        self:onAutoSize()
        self._init = true
    end
    self:initDate()
    self.updateGold()
    self:getChildByName("info"):getChildByName("ico"):loadTexture("images/bank/bank_back2.jpg",0)
end

function StrongholdInfoEx:initDate(  )
	
end

function StrongholdInfoEx.onStart( sender )
    -- body
    
    ff.net:bindProperty(2329,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    
    schedule(sender, sender.update,1)
end

function StrongholdInfoEx:getLCStrongholdItemStore()
    local message = ff.net:createMessage()
    message:addCmd(0x0000017d)
    message:addLong(dd.uid)
    message:addLong(0)
    message:addLong(0)
    message:addLong(self._id)
    ff.net:rpc(message,false)

end

function StrongholdInfoEx:senderLCStrongholdItemStore(pos)
    local message = ff.net:createMessage()
    message:addCmd(0x0000017d)
    message:addLong(dd.uid)
    message:addLong(1)
    message:addLong(pos)
    message:addLong(self._id)
    ff.net:rpc(message,false)

end

function StrongholdInfoEx:getLCStrongholdMineStore()
    local message = ff.net:createMessage()
    message:addCmd(0x0000017e)
    message:addLong(dd.uid)
    message:addLong(0)
    message:addLong(0)
    message:addLong(self._id)
    ff.net:rpc(message,false)
end

function StrongholdInfoEx:senderLCStrongholdMineStore(pos)
    local message = ff.net:createMessage()

    message:addCmd(0x0000017e)
    message:addLong(dd.uid)
    message:addLong(1)
    message:addLong(pos)
    message:addLong(self._id)
    ff.net:rpc(message,false)
end



function StrongholdInfoEx:GetLCStrongholdItemStoreEx(params)
    local code = params[1]
    if code == 0 then
        
        self._info1 = params[2]
        self._list1 = params[3]
        self:showListInfo()
        if self._info1.operType == 1 then
            if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("购买成功"),true)
            end 
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function StrongholdInfoEx:GetLCStrongholdMineStoreEx(params)
    local code = params[1]
    if code == 0 then

        self._info2 = params[2]

        self._list2 = params[3]
        if self._info2.operType == 1 then
            if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("购买成功"),true)
            end 
            WorldControl:getInstance()._worldUILayer:setSceneCenterByGid(self._info2.zypos - 1,true) 
            WorldControl:getInstance():showGid(self._info2.zypos,false)
            pop.onClosePopDialog("StrongholdInfoEx")
            return
        end
        self:showListInfo()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function StrongholdInfoEx.onBefore( sender )
    sender._type = 1
    sender._typeEx = 1
    sender:selectTypeEx(sender:getChildByName("topNavi"):getChildByName("navi1"))
    sender:selectType(sender:getChildByName("type"):getChildByName("type1"))
    ff.net:registerEvent(2,dd.Tjf_GetLCStrongholdItemStore, function (message)sender:GetLCStrongholdItemStoreEx(message)end)
    ff.net:registerEvent(2,dd.Tjf_GetLCStrongholdMineStore, function (message)sender:GetLCStrongholdMineStoreEx(message)end)
    
    sender:getLCStrongholdMineStore()
    sender:getLCStrongholdItemStore()
end

function StrongholdInfoEx:onAutoSize(  )
	local hh = ff.height
	self:setContentSize(cc.size(720,hh))
    self:getChildByName("topArea"):setPositionY(hh - 105)
    self:getChildByName("topNavi"):setPositionY(hh - 105 - 85 )
	self:getChildByName("info"):setPositionY(hh - 105 - 85 - 220)
    self:getChildByName("type"):setPositionY(hh - 105 - 85 - 220 - 80)
	self:getChildByName("list"):setContentSize(cc.size(720 ,hh - 184 - 220 - 85 - 80))
    self:getChildByName("list"):setPositionY(80)
    self:getChildByName("list3"):setPositionY((hh - 184 - 220 - 85)/2)
	self:getChildByName("type"):getChildByName("type1"):setTag(1)
	self:getChildByName("type"):getChildByName("type2"):setTag(2)
	self:getChildByName("type"):getChildByName("type3"):setTag(3)
    self:getChildByName("type"):getChildByName("type1"):getChildByName("Label_100"):setString(ff.langString("据点特产"))
    self:getChildByName("type"):getChildByName("type2"):getChildByName("Label_100"):setString(ff.langString("据点资源地"))
    self:getChildByName("type"):getChildByName("type3"):getChildByName("Label_100"):setString(ff.langString("即将开放"))
	self:getChildByName("type"):getChildByName("type3"):addTouchEventListener(self.onSelectType)
    self:getChildByName("type"):getChildByName("type2"):addTouchEventListener(self.onSelectType)
    self:getChildByName("type"):getChildByName("type1"):addTouchEventListener(self.onSelectType)
    self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onReturn)
    self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
    self:getChildByName("topNavi"):getChildByName("navi1"):addTouchEventListener(self.onSelectTypeEx)
    self:getChildByName("topNavi"):getChildByName("navi2"):addTouchEventListener(self.onSelectTypeEx)
    self:getChildByName("topNavi"):getChildByName("navi1"):setTag(1)
    self:getChildByName("topNavi"):getChildByName("navi2"):setTag(2)
    self:getChildByName("time"):setPositionY(0)
    self:getChildByName("item"):getChildByName("buy"):addTouchEventListener(self.onBuy)
    self:getChildByName("item2"):getChildByName("buy"):addTouchEventListener(self.onBuy)
    --self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("据点"))
    --self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
    --self:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
    self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setString(ff.langString("首页"))
    self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
    self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setString(ff.langString("设备"))
    self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
    self:getChildByName("topNavi"):requestDoLayout()
end

function StrongholdInfoEx.onSelectType( sender,eventType )
	if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("StrongholdInfoEx")
        if widget ~= nil then
            local tag = sender:getTag()
            --widget._typeEx = sender:getTag()
            if tag ~= widget._typeEx then
                widget._typeEx = sender:getTag()
                widget:selectType()
            else
                widget:selectType()
            end
            --widget:selectType()

        end
    end
end

function StrongholdInfoEx.onBuy( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then    
        local widget = pop.getDialog("StrongholdInfoEx")
        local id     = sender:getTag()

        if widget._typeEx == 1 then
            if widget._list1[id] == nil or  (widget._list1[id]["cancount"] - widget._list1[id]["havecount"]) < 1  then
                if dd.currentLayer._widget ~= nil then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("可购买数量不足"))
                end
                return
            end
            widget:senderLCStrongholdItemStore(id)
        elseif widget._typeEx == 2 then
  
            widget:senderLCStrongholdMineStore(id)
        end
        
    end
end

function StrongholdInfoEx:selectTypeEx(sender)
    self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)

    self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)

    if self._type == 1 then

        self:getChildByName("list"):setVisible(true)
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(239, 223, 223))
    elseif self._type == 2 then

        self:getChildByName("list"):setVisible(false)
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(239, 223, 223))
    end
    if sender ~= nil then
        sender:setSelectedState(true)
    end
    
    self:showListInfo()
   
end


function StrongholdInfoEx.onSelectTypeEx( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("StrongholdInfoEx")
        if widget ~= nil then
            local tag = sender:getTag()
            if tag ~= widget._type then
                widget._type = sender:getTag()
                widget:selectTypeEx()
            else
                widget:selectTypeEx()
            end

        end
    end
end

function StrongholdInfoEx.onReturn(sender,eventType )
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("StrongholdInfoEx")
        if widget == nil then
            return
        end
        pop.onClosePopDialog("StrongholdInfoEx")
    end
end

function StrongholdInfoEx:selectType( sender)
	self:getChildByName("type"):getChildByName("type1"):getChildByName("Label_100"):setColor(cc.c3b(97,117,123))
    self:getChildByName("type"):getChildByName("type1"):setSelectedState(false)

    self:getChildByName("type"):getChildByName("type2"):getChildByName("Label_100"):setColor(cc.c3b(97,117,123))
    self:getChildByName("type"):getChildByName("type2"):setSelectedState(false)

    self:getChildByName("type"):getChildByName("type3"):getChildByName("Label_100"):setColor(cc.c3b(97,117,123))
    self:getChildByName("type"):getChildByName("type3"):setSelectedState(false)
    if self._typeEx == 1 then
        self:getChildByName("type"):getChildByName("type1"):getChildByName("Label_100"):setColor(cc.c3b(233, 239, 244))
    elseif self._typeEx == 2 then
        self:getChildByName("type"):getChildByName("type2"):getChildByName("Label_100"):setColor(cc.c3b(233, 239, 244))
    else
        self:getChildByName("type"):getChildByName("type3"):getChildByName("Label_100"):setColor(cc.c3b(233, 239, 244))
    end
    if sender ~= nil then
        sender:setSelectedState(true)
    end
    self:showListInfo( )
end

function StrongholdInfoEx.onEnd( sender )
	-- body
    dd.delBackEvent()
    sender:stopAllActions()
	sender:getChildByName("info"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    ff.net:unbindProperty("gold",2329)
    ff.net:removeEvent(2,dd.Tjf_GetLCStrongholdItemStore)
    ff.net:removeEvent(2,dd.Tjf_GetLCStrongholdMineStore)
end


function StrongholdInfoEx.update( sender )
    if sender._type == 1 then
        if sender._typeEx == 1 then
            if sender._list1 == nil or next(sender._list1) == nil then
                return
            end
            
            local time = sender._info1.cd - dd.getServerTime()
            
            sender:getChildByName("time"):getChildByName("time"):setString("CD: "..ff.getLeftTime(time,":"))
            
            for k,v in pairs(sender._list1) do
                local item = sender:getChildByName("list"):getChildByTag(k)
                if item ~= nil then
                    if (v["cancount"]-v["havecount"]) < 1  then
                        local effect = ff.Effect:effectGrey()    
                        item:getChildByName("buy"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
                        item:getChildByName("buy"):setTouchEnabled(false)
                        
                    else
                        item:getChildByName("buy"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
                        item:getChildByName("buy"):setTouchEnabled(true)
                    end
                end
                
            end
            
        elseif sender._typeEx == 2 then
            if sender._list2 == nil or next(sender._list2) == nil then
                return
            end
            local time = sender._info2.cd - dd.getServerTime()
 
            sender:getChildByName("time"):getChildByName("time"):setString("CD: "..ff.getLeftTime(time,":"))
            for k,v in pairs(sender._list2) do
                local item = sender:getChildByName("list"):getChildByTag(k)
                if item ~= nil then
                    if sender._info2.cd > dd.getServerTime() then
                        local effect = ff.Effect:effectGrey()    
                        item:getChildByName("buy"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
                        item:getChildByName("buy"):setTouchEnabled(false)
                    else
                        item:getChildByName("buy"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
                        item:getChildByName("buy"):setTouchEnabled(true)
                    end
                end
                
            end
        else
        end
    end
end

function StrongholdInfoEx:showListInfo( )
    self:getChildByName("list"):removeAllChildren(true)
	if self._type == 1 then
        self:getChildByName("list"):setVisible(true)
        self:getChildByName("list3"):setVisible(false)
        self:getChildByName("list4"):setVisible(false)
        self:getChildByName("info"):setVisible(true)
        self:getChildByName("type"):setVisible(true)
        self:getChildByName("time"):setVisible(true)
        if self._typeEx == 1 then
            if self._list1 == nil or next(self._list1) == nil then
                return
            end
            for k,v in pairs(self._list1) do
                local item = self:getChildByName("list"):getChildByTag(k)
                if item == nil then
                    item = self:getChildByName("item"):clone()
                    item:setVisible(true)
                    item:setTag(k)
                    item:getChildByName("buy"):setTag(k)
                    self:getChildByName("list"):pushBackCustomItem(item)
                    item:getChildByName("buy"):getChildByName("Label"):setString(ff.langString("购买"))
                end
                if( v["cancount"]-v["havecount"]) < 1 then
                    local effect = ff.Effect:effectGrey()    
                    item:getChildByName("buy"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
                    item:getChildByName("buy"):setTouchEnabled(false)
                    
                else
                    item:getChildByName("buy"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
                    item:getChildByName("buy"):setTouchEnabled(true)
                end
                item:getChildByName("ally"):setString(v["needAllyPoint"])
                item:getChildByName("count"):getChildByName("count"):setString(v["cancount"]-v["havecount"])
                local cfgid = k + 100
                for i,v in ipairs(dd.cfgStrongHold) do
                    if v['id'] == cfgid then
                        item:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/Stronghold/"..v['pic']..".png",0)
                        item:getChildByName("name"):setString(ff.langString(v['name']))
                        item:getChildByName("info"):setString(ff.langString(v['disc']))
                    end
                end
            end
            local time = self._info1.cd - dd.getServerTime()
            
            self:getChildByName("time"):getChildByName("time"):setString("CD: "..ff.getLeftTime(time,":"))
        elseif self._typeEx == 2 then
            if self._list2 == nil or next(self._list2) == nil then
                return
            end
            for k,v in pairs(self._list2) do
                local item = self:getChildByName("list"):getChildByTag(k)
                if item == nil then
                    item = self:getChildByName("item2"):clone()
                    item:setVisible(true)
                    item:setTag(k)
                    item:getChildByName("buy"):setTag(k)
                    self:getChildByName("list"):pushBackCustomItem(item)
                    item:getChildByName("buy"):getChildByName("Label"):setString(ff.langString("购买"))
                end
                item:getChildByName("ally"):setString(v["needAllyPoint"])
                local cfgid = k + 200
                for i,v in ipairs(dd.cfgStrongHold) do
                    if v['id'] == cfgid then
                        item:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/Stronghold/"..v['pic']..".png",0)
                        item:getChildByName("name"):setString(ff.langString(v['name']))
                        item:getChildByName("info"):setString(ff.langString(v['disc']))
                    end
                end

                if self._info2.cd > dd.getServerTime() then
                    local effect = ff.Effect:effectGrey()    
                    item:getChildByName("buy"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
                    item:getChildByName("buy"):setTouchEnabled(false)
                else
                    item:getChildByName("buy"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
                    item:getChildByName("buy"):setTouchEnabled(true)
                end
            end
            local time = self._info2.cd - dd.getServerTime()
            
            self:getChildByName("time"):getChildByName("time"):setString("CD: "..ff.getLeftTime(time,":"))
        else
            self:getChildByName("list"):setVisible(false)
            self:getChildByName("list3"):setVisible(true)
            self:getChildByName("time"):setVisible(false)
        end
    else
        self:getChildByName("list"):setVisible(false)
        self:getChildByName("list3"):setVisible(false)
        self:getChildByName("list4"):setVisible(true)
        self:getChildByName("info"):setVisible(false)
        self:getChildByName("type"):setVisible(false)
        self:getChildByName("time"):setVisible(false)
    end
end

function StrongholdInfoEx.updateGold(name,row,old,value)
    local widget = pop.getDialog("StrongholdInfoEx")
    if widget ~= nil then
        widget:getChildByName("topArea"):getChildByName("money"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("topArea"):requestDoLayout()
    end
end