changeSkinLayer = class("changeSkinLayer")
changeSkinLayer._name = "changeSkin"
changeSkinLayer._init = false
changeSkinLayer._startTime = 0
changeSkinLayer._endTime = 0
changeSkinLayer._id = 0

function changeSkinLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,changeSkinLayer)
	return target
end

function changeSkinLayer:onInit(  )
	-- body
	if self._init == false then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		self:setPositionY(0)
		self:getChildByName("back"):setContentSize(cc.size(720,hh))
		self:getChildByName("back"):addTouchEventListener(self.onReturn)
		self:getChildByName("top"):setPositionY(hh - 105)
		self:getChildByName("scrollview"):setContentSize(cc.size(720,hh-105))
    	self:getChildByName("scrollview"):setPositionY(0)
        self:getChildByName("item"):getChildByName("sure"):addTouchEventListener(self.onUse)
        self:getChildByName("item"):getChildByName("sure1"):addTouchEventListener(self.onMake)
    	self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    	self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    	self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("皮肤"))
		self._init = true
	end
    self._startTime = 0
    self._endTime = 0
    self._id = 0
	self.updateGold()
end

function changeSkinLayer.onUse( sender,eventType  )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("changeSkin")
        if widget == nil then
            return
        end  
        local id = sender:getTag()
        if id ~= widget._id and widget._id ~= 0 then
            local function sure()
                if id == 9 then
                    widget:sendMsg(9)
                else
                    widget:sendMsg(1,id)
                end
            end
            dd.mainUI:onShowSure(ff.langString("警告"),ff.langString("时间未到改变皮肤，将替代原有皮肤，使用相同皮肤，持续时间将累计。"),sure,true)
        else
            if id == 9 then
                widget:sendMsg(9)
            else
                widget:sendMsg(1,id)
            end
        end
        
    end   
end

function changeSkinLayer.onMake( sender,eventType  )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("changeSkin")
        if widget == nil then
            return
        end  
        local id = sender:getTag()
        local index = 0
        for i,v in pairs(dd.cfgPropsynthersis) do
            if v['target_id'] == id then
                index = i
                break
            end
        end
        dd.mainUI:showHeChengView(index)
    end   
end

function changeSkinLayer.onStart( sender )
	ff.net:bindProperty(2327,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))    
    schedule(sender, sender.update,1) 
end

function changeSkinLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("changeSkin")
		if widget == nil then
			return
		end
        pop.onClosePopDialog("changeSkin")
    end
end

function changeSkinLayer.onEnd( sender )
    -- body
    ff.net:removeEvent(3,dd.Tjf_SetAvatar)
    ff.net:removeEvent(3,dd.Tjf_ItemExchange)
    dd.delBackEvent()
    sender:stopAllActions()
    sender:getChildByName("scrollview"):removeAllChildren(true)
    ff.net:unbindProperty("gold",2327)
end

function changeSkinLayer:sendMsg( type ,id)
    local message = ff.net:createMessage()
    message:addCmd(0x0000017c)
    message:addLong(dd.uid)
    message:addLong(type)
    if type == 1 then
        message:addLong(id)
    else
        message:addLong(0)
    end
    ff.net:rpc(message,false)   
end

function changeSkinLayer.onBefore( sender )
    ff.net:registerEvent(3,dd.Tjf_ItemExchange,function (message)sender:onItemExchange(message)end)
    ff.net:registerEvent(3,dd.Tjf_SetAvatar,function (message)sender:onSetAvatar(message)end)
    sender:sendMsg(0)
    sender:showList()
end

function changeSkinLayer:onItemExchange(params)
    local code = params[1]
    if code == 0 then      
        self:showList()
        
    else
        --dd.mainUI:onShowCodeTips(code)
    end
end

function changeSkinLayer:onSetAvatar( params )
    local code = params[1]
    if code == 0 then    
        self._startTime = params[4]
        self._endTime = params[5]
        self._id = params[3]
        if params[3] ~= 0 then
            --self:stopAllActions()
            --schedule(self, self.update,1)
            self.update(self)
        end  
        self:showList()
    
    end
end

function onShowchangeSkin(widget)
	-- body
	local layer = changeSkinLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end

function changeSkinLayer.update( sender )
	local item = sender:getChildByName("scrollview"):getChildByTag(1)
	if item ~= nil then
        if sender._id ~= 0 then
            item:getChildByName("progress"):setVisible(true)
            local time = sender._endTime-dd.getServerTime()
            item:getChildByName("progress"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
            local per = 0
            if (sender._endTime - sender._startTime )>0 then
              per = (sender._endTime - sender._startTime - (sender._endTime - dd.getServerTime()))/(sender._endTime - sender._startTime)*100
            end

            item:getChildByName("progress"):getChildByName("progress"):getChildByName("progress"):setPercent(per)
        else
            item:getChildByName("progress"):setVisible(false)
            item:getChildByName("progress"):getChildByName("time"):setString("")
            item:getChildByName("progress"):getChildByName("progress"):getChildByName("progress"):setPercent(0)
        end
		--local time = sender._Time - dd.getServerTime()
        --item:getChildByName("time"):setString(ff.getLeftTime(time,":"))
	end
end

function changeSkinLayer:showList(  )
	local item1 = self:getChildByName("scrollview"):getChildByTag(1)
    if item1 == nil then
        item1 = self:getChildByName("block4"):clone()
        item1:setTag(1)
        item1:getChildByName("progress"):setVisible(false)
        item1:getChildByName("progress"):getChildByName("time"):setString("")
        item1:getChildByName("progress"):getChildByName("progress"):getChildByName("progress"):setPercent(0)
        self:getChildByName("scrollview"):pushBackCustomItem(item1)
        item1:getChildByName("heroname"):setString(ff.langString("时间未到改变皮肤，将替代原有皮肤，使用相同皮肤，持续时间将累计。"))
    end
    if item1 ~= nil then
        item1:setVisible(true)
    end

    for k,v in pairs(dd.cfgAppearance) do
        local item = self:getChildByName("scrollview"):getChildByTag(k)
        if item == nil then
            item = self:getChildByName("item"):clone()
            item:setTag(k)
            item:getChildByName("sure"):setTag(k)
            item:getChildByName("sure"):getChildByName("chu_label"):setString(ff.langString("使用"))
            item:getChildByName("sure1"):setTag(v["itemid"])
            item:getChildByName("name"):setString(ff.langString(v['name']))
            item:getChildByName("info"):setString(ff.langString(v['tips']))
            item:getChildByName("sure1"):getChildByName("chu_label"):setString(ff.langString("合成"))
            item:getChildByName("item"):getChildByName("ico"):getChildByName("icon"):loadTexture(dd.getToolsIcon(v['itemid']),0)
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        end
        if item ~= nil then
            item:setVisible(true)
            
            item:getChildByName("item"):getChildByName("count"):setString(dd.getToolsCount(v['itemid']))
            
        end
    end

    local item = self:getChildByName("scrollview"):getChildByTag(9)
    if item == nil then
        item = self:getChildByName("item"):clone()
        item:setTag(9)
        item:getChildByName("sure"):setTag(9)
        item:getChildByName("sure"):getChildByName("chu_label"):setString(ff.langString("使用"))
        item:getChildByName("sure1"):setVisible(false)

        item:getChildByName("item"):getChildByName("ico"):getChildByName("icon"):loadTexture(dd.getToolsIcon(1103),0)
        item:getChildByName("item"):getChildByName("count"):setString("")
        item:getChildByName("item"):getChildByName("back"):setVisible(false)
        item:getChildByName("name"):setString(ff.langString(dd.cfgProp[1103]['name']))
        item:getChildByName("info"):setString(ff.langString(dd.cfgProp[1103]['tips']))
        self:getChildByName("scrollview"):pushBackCustomItem(item)
    end
    if item ~= nil then
        item:setVisible(true)
        
    end

end

function changeSkinLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("changeSkin")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end