local wmpLayer = class("wmpLayer")
wmpLayer._name = "wmpLayer"
wmpLayer._init = false
wmpLayer._data = nil
wmpLayer._map = nil
wmpLayer._pos = nil
wmpLayer._scroll = nil
wmpLayer._mapBaseW = 2048--底图大小
wmpLayer._mapBaseH = 1280
wmpLayer._citycnt = 17
wmpLayer.cityGidArr = {{id=10,x=320,y=320},
                       {id=20,x=214,y=214},{id=22,x=68,y=252},{id=21,x=108,y=108},{id=23,x=252,y=68},
                       {id=50,x=426,y=214},{id=53,x=388,y=68},{id=51,x=532,y=108},{id=52,x=572,y=252},
                       {id=30,x=426,y=426},{id=32,x=572,y=388},{id=31,x=532,y=532},{id=33,x=388,y=572},
                       {id=40,x=214,y=426},{id=43,x=252,y=572},{id=41,x=108,y=532},{id=42,x=68,y=388}}
wmpLayer.tipSizeArr = {cc.size(250,31),cc.size(158,31)}  
wmpLayer.tipPosArr = {cc.p(30,0),cc.size(25,0)}      
wmpLayer.showing = false  
wmpLayer._info = {}                
function wmpLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, wmpLayer)
    return target
end

function wmpLayer:onInit()
    if self._init == false then
        self:setContentSize(cc.size(720,ff.height))
        self:getChildByName("mapArea"):setContentSize(cc.size(720,ff.height))
        self._scroll = self:getChildByName("mapArea")
        self:getChildByName("close"):setPosition(cc.p(680,ff.height - 43))
        self:getChildByName("chu_worldmap"):setPosition(cc.p(640,ff.height - 16))
        self._scroll:getChildByName("worldmap"):getChildByName("map"):addTouchEventListener(self.onGo)
		self:getChildByName("close"):addTouchEventListener(self.onReturn)
		self:getChildByName("unRes"):setSelectedState(false)	
        self:getChildByName("unUnion"):setSelectedState(true)  
		self:getChildByName("zb"):addTouchEventListener(self.goUser)
        self:getChildByName("unRes"):addTouchEventListener(self.onShowRes)
		self:getChildByName("unUnion"):addTouchEventListener(self.onShowUnion)
        self:getChildByName("table"):setPositionY(70)
        self:getChildByName("res"):setPositionY(3)
        self:getChildByName("res"):getChildByName("tip"):getChildByName("tip_text"):setString(ff.langString("1-3级资源地"))
        self:getChildByName("res"):getChildByName("tip_0"):getChildByName("tip_text"):setString(ff.langString("4-5级资源地"))

		self._init = true
	end
    if dd.KSRoom == 0 then
        self._citycnt = 17
        self.cityGidArr = {{id=10,x=320,y=320},
                       {id=20,x=214,y=214},{id=22,x=68,y=252},{id=21,x=108,y=108},{id=23,x=252,y=68},
                       {id=50,x=426,y=214},{id=53,x=388,y=68},{id=51,x=532,y=108},{id=52,x=572,y=252},
                       {id=30,x=426,y=426},{id=32,x=572,y=388},{id=31,x=532,y=532},{id=33,x=388,y=572},
                       {id=40,x=214,y=426},{id=43,x=252,y=572},{id=41,x=108,y=532},{id=42,x=68,y=388}}
    else
        self._citycnt = 5
        self.cityGidArr = {{id=21,x=100,y=100},{id=22,x=51,y=51},{id=23,x=51,y=151},{id=24,x=151,y=51},{id=25,x=151,y=151}}

    end
    self._info = {}
	self._scroll:getChildByName("worldmap"):getChildByName("map"):removeAllChildren(true)
    self:initMap()
	if self._data == nil then
        self._data = ff.NetTable:create()
		self._data:addStreamCol("uid",ff.NET_LONG)
		self._data:addStreamCol("gid",ff.NET_LONG)
        self._data:addStreamCol("master",ff.NET_LONG)
    end
    self._data:delRows()
    self:showUnionMember()
    self:showStronghold()
end
function wmpLayer:showTheTable(visible)
    --if self.showing then
    --    return
    --end 
    --local function endFun()
    self:getChildByName("table"):setVisible(visible)     
--        self:getChildByName("table"):setOpacity(255)   
    --    self.showing = false
    --end
    --self:getChildByName("table"):setOpacity(255) 
    --local action = cc.FadeOut:create(1)
    --local seq = cc.Sequence:create(cc.DelayTime:create(5),action,cc.CallFunc:create(endFun))
    --self:getChildByName("table"):runAction(seq)
    --self.showing = true 
end
function wmpLayer:initMap()
    self._map = self._scroll:getChildByName("worldmap"):getChildByName("map")
    self._map:setAnchorPoint(cc.p(0.5,0.5))
    self._scroll:setInnerContainerSize(cc.size(self._mapBaseW,self._mapBaseH))
    self._scroll:getChildByName("worldmap"):setContentSize(cc.size(self._mapBaseW + 16,self._mapBaseH + 16))
    self._scroll:getChildByName("worldmap"):getChildByName("map"):loadTexture("images/world/wmp_back.jpg",0)
    self._scroll:getChildByName("worldmap"):getChildByName("res"):loadTexture("images/world/wmp_back_2.png",0)
    self._scroll:getChildByName("worldmap"):setPosition(cc.p(1024,640))
    self._map:setPosition(cc.p(1032,648))

    local res = self._map:getChildByTag(999)
    if res == nil then
        local res = self._scroll:getChildByName("worldmap"):getChildByName("res"):clone()
        res:loadTexture("images/world/wmp_back_2.png",0)
        res:setAnchorPoint(cc.p(0.5,0.5))
        res:setPosition(cc.p(1032,648))
        res:setVisible(true)
        self._map:addChild(res,0,999)
    end
    
    self:initMapItem() 
    self:updateNowPos()
    self:initCityItem()
end

function wmpLayer:updateNowPos(gid)
    if dd.currentLayer._name == "WorldUILayer" then
        local cgid = WorldControl:getInstance()._worldUILayer:getSceneCenterGid()
        if gid ~= nil then
            cgid = gid
        end
        if self._pos == nil then
            self._pos = self:getChildByName("pos_icon"):clone()
            self._map:addChild(self._pos,3)
        end
        if cgid ~= dd.mycity:getLong(1,"cid") then
            local xy = self:getMapPositon(cgid)
            self._pos:setPosition(xy)
            self._pos:setVisible(true)
        else
            self._pos:setVisible(false)
        end
    end 
end
function wmpLayer:initCityItem()
    for var=1, self._citycnt do
        local item = self:getChildByName("cityItem"):clone()        
        item:setTag(var)
        item:addTouchEventListener(self.goCity)
        self._map:addChild(item,2)
        if var <= 1 and dd.KSRoom == 0 then
            item:loadTexture(dd.getPathFromUI("big_city.png",1))                               
        end
        
        local gid = self.cityGidArr[var]['x'] + (self.cityGidArr[var]['y']) * ff.world_maplayerSize.width
        local xy = self:getMapPositon(gid)
        item:setPosition(cc.p(xy))
        item:setVisible(true)
    end
end

function wmpLayer:initMapItem()
    for var=1, self._citycnt do
        local item = self:getChildByName("mapItem"):clone()
        --item:getChildByName("tip"):setContentSize(self.tipSizeArr[ff.lang+1])
--        item:getChildByName("tip"):getChildByName("tip_text"):setPosition(self.tipPosArr[ff.lang+1])
        --item:getChildByName("tip"):setVisible(false)
        self._map:addChild(item,1)
        item:setName("item"..var)
        if var <= 1 then           
            item:loadTexture(dd.getPathFromUI("public/alpha.png",1))    
            ---item:getChildByName("tip"):setVisible(true)
            --item:getChildByName("tip"):getChildByName("tip_text"):setString(ff.langString("5级资源地"))
        elseif var <= 5 then            
            if var == 3 then 
                --item:getChildByName("tip"):setVisible(true)
                --item:getChildByName("tip"):getChildByName("tip_text"):setString(ff.langString("3-4级资源地"))
            end           
        end
        if var > 1 and (var == 2 or var == 6 or var == 10 or var == 14) then
            item:loadTexture(dd.getPathFromUI("public/alpha.png",1))    
            if var == 2 then
                --item:getChildByName("tip"):setVisible(true)
                --item:getChildByName("tip"):getChildByName("tip_text"):setString(ff.langString("4-5级资源地"))
    	    end
    	elseif var > 1 then     	
            item:loadTexture(dd.getPathFromUI("mid_area.png",1))
    	end
    	local gid = self.cityGidArr[var]['x'] + (self.cityGidArr[var]['y']) * ff.world_maplayerSize.width
    	local xy = self:getMapPositon(gid)
        item:setPosition(xy)
--    	item:setVisible(true)
        if self:getChildByName("unRes"):getSelectedState() == false then
            item:setVisible(false)
            self:getChildByName("res"):setVisible(false)
            local res = self._map:getChildByTag(999)
            if res ~= nil then
                res:setVisible(false)
            end
        else
            item:setVisible(true)
            self:getChildByName("res"):setVisible(true)
            local res = self._map:getChildByTag(999)
            if res ~= nil then
                res:setVisible(true)
            end
        end
    end
end

function wmpLayer.onClose(sender,eventType)
	if eventType==ccui.TouchEventType.ended then   
		pop.onClosePopDialog("worldmap")
	end
end


function wmpLayer.onShowRes(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("worldmap")
		if sender:getSelectedState() == true then
            for var=1, widget._citycnt do
                if widget._map:getChildByName("item"..var) ~= nil  then
                    widget._map:getChildByName("item"..var):setVisible(false)
                end
            end
            widget:getChildByName("res"):setVisible(false)
            local res = widget._map:getChildByTag(999)
            if res ~= nil then
                res:setVisible(false)
            end
		else
            for var=1, widget._citycnt do
                if widget._map:getChildByName("item"..var) ~= nil then
                    widget._map:getChildByName("item"..var):setVisible(true)
                end
            end
            widget:getChildByName("res"):setVisible(true)
            local res = widget._map:getChildByTag(999)
            if res ~= nil then
                res:setVisible(true)
            end
		end
	end
end
function wmpLayer:showUnionMember()
	if dd.myUnion:getLong(1,"unionid") > 0 then
        local message = ff.net:createMessage()
        message:addCmd(0x0000004a)
        message:addLong(dd.uid)
        message:addLong(dd.myUnion:getLong(1,"unionid"))
        ff.net:rpc(message,false)
    --else
     --   self:showTheTable(false)
	end
end
function wmpLayer:showStronghold(  )
    local message = ff.net:createMessage()
    message:addCmd(0x0000005e)
    message:addLong(dd.uid)
    ff.net:rpc(message,false)
end
function wmpLayer.onShowUnion(sender,eventType)
	if eventType==ccui.TouchEventType.ended then   
		local widget = pop.getDialog("worldmap")
		if sender:getSelectedState() == false then 
			if widget._data:rowCount() <= 0 then
				widget:showUnionMember()
			--else
				
			end
            widget:showUnions(true)
		else
			widget:showUnions(false)
		end
	end
end
function wmpLayer:showUnions(tag)
    self:showTheTable(tag)
	for i=1,self._data:rowCount() do
		local uid = self._data:getLong(i,"uid")
		if uid ~= dd.uid then
			local gid = self._data:getLong(i,"gid")
			local master = self._data:getLong(i,"master")

			if tag == true then
				local xy = self:getMapPositon(gid)
		        local zb = self:getChildByName("zb"):clone()
		        zb:setVisible(true)
		        if master == 1 then 
		        	zb:loadTexture(dd.getPathFromUI("wmp_leader.png",1))
		        else
		        	zb:loadTexture(dd.getPathFromUI("wmp_union.png",1))
		        end
                cclog("uid:"..uid.."  gid:"..gid)
		        zb:setTag(gid)
		        zb:setVisible(gid>0)
		        zb:setPosition(cc.p(xy.x,xy.y-5))
		        self._map:addChild(zb,3)
                
		    else
		    	local item = self._map:getChildByTag(gid)
		    	if item ~= nil then
		    		item:removeFromParent(true)
		    	end
                --self:showTheTable(false)
		    end
	    end
	end
end


--根据cid计算小地图上坐标
function wmpLayer:getMapPositon(gid)
    local gid = gid - 1
    local x = gid%ff.world_maplayerSize.width
    local y = math.floor((gid-x)/ff.world_maplayerSize.width)

    cclog("x:"..x..","..y)
    if dd.worldLayer ~= nil then
        local mapPoint = dd.worldLayer._curMapLayer:getMapPointByMapGid(cc.p(x,y))
        x = mapPoint.x/dd.worldLayer._curMapLayer:getScale()
        y = mapPoint.y/dd.worldLayer._curMapLayer:getScale()
        x = math.floor(x * wmpLayer._mapBaseW/(ff.world_maplayerSize.width*252))
        y = math.floor(y * 1140/(ff.world_maplayerSize.height*140)) + 70
        return cc.p(x,y)
    end
    return cc.p(1024,640)
end
function wmpLayer.onGo(sender,eventType)
    local function close(sender)
        local widget = pop.getDialog("worldmap")
        if widget == nil then
            return
        end
        widget._map:setScale(1)
        pop.onClosePopDialog("worldmap")
    end
	local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
        	doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then
    	doaction = true
    end
	if doaction == true then
	    local widget = pop.getDialog("worldmap")
        if widget == nil then
            return
        end
		local endp   = sender:getTouchEndPosition()
		local location = sender:convertToNodeSpace(endp)
        local px,py = widget._scroll:getInnerContainer():getPosition()
       
        --70是图片修正
        local x = endp.x - px
        local y = endp.y - py - 70
        --计算地图坐标
        x = math.floor(x * (ff.world_maplayerSize.width*252)/widget._mapBaseW)
        y = math.floor(y * (ff.world_maplayerSize.height*140)/(widget._mapBaseH - 140))
        --计算gid
        local ret = cc.p(0,0)
        local vx  = math.floor(x - ff.world_maplayerSize.width * 252/2)
        local vy  = math.floor(ff.world_maplayerSize.height * 140 - y)
        --屏幕坐标转换成游戏坐标   
        ret.x = math.floor(0.5 * (vy / (140/2) + vx / (252/2)))
        ret.y = math.floor(0.5 * (vy / (140/2) - vx / (252/2)))

        if ret.x < 0 then
            dd.mainUI:onShowTips(ff.langString("请在区域内选择"))
            return
        end        
        if ret.x >= ff.world_maplayerSize.width then
            dd.mainUI:onShowTips(ff.langString("请在区域内选择"))
            return
        end
        if ret.y < 0 then
            dd.mainUI:onShowTips(ff.langString("请在区域内选择"))
            return
        end
        if ret.y >= ff.world_maplayerSize.height then
            dd.mainUI:onShowTips(ff.langString("请在区域内选择"))
            return
        end
        local gid = ret.x + ff.world_maplayerSize.height * ret.y + 1
        widget:updateNowPos(gid)
        if dd.worldLayer ~= nil then
            dd.worldLayer:setSceneCenterByGid(gid - 1,true)   
        end
        local action = cc.ScaleTo:create(1,4)
        local seq = cc.Sequence:create(action,cc.CallFunc:create(close))
        local endp   = widget._map:convertToNodeSpace(sender:getTouchEndPosition())
        local ax = endp.x/widget._mapBaseW
        local ay = endp.y/widget._mapBaseH
        widget._map:setAnchorPoint(cc.p(ax,ay))
        widget._map:setPosition(cc.p(endp.x,endp.y))
        widget._map:setEnabled(false)
        widget._map:runAction(seq)
    end
end

function wmpLayer.goCity(sender,eventType)
    local function close(sender)
        local widget = pop.getDialog("worldmap")
        if widget == nil then
            return
        end
        widget._map:setScaleX(1)
        widget._map:setScaleY(1)
        widget._map:setEnabled(true)
        pop.onClosePopDialog("worldmap")
    end
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then
        cclog("=======================touch city name:"..sender:getName())
        if sender:getName() == "cityItem" then
            local widget = pop.getDialog("worldmap")
            if widget == nil then
                return
            end
            local key = sender:getTag()
            local gid = widget.cityGidArr[key]['x']-1 + (widget.cityGidArr[key]['y']-1) * ff.world_maplayerSize.height
            widget:updateNowPos(gid)
            if dd.worldLayer ~= nil then
                dd.worldLayer:setSceneCenterByGid(gid,true)   
            end
            local action = cc.ScaleTo:create(0.8,4)
            local seq = cc.Sequence:create(action,cc.CallFunc:create(close))
            local endp   = widget._map:convertToNodeSpace(sender:getTouchEndPosition())
            local ax = endp.x/widget._mapBaseW
            local ay = endp.y/widget._mapBaseH
            widget._map:setAnchorPoint(cc.p(ax,ay))
            widget._map:setPosition(cc.p(endp.x,endp.y))
            widget._map:setEnabled(false)
            widget._map:runAction(seq)         
         end
    end
end
function wmpLayer.goUser(sender,eventType)
	local function close(sender)
        local widget = pop.getDialog("worldmap")
        if widget == nil then
            return
        end
        widget._map:setScaleX(1)
        widget._map:setScaleY(1)
        widget._map:setEnabled(true)
		pop.onClosePopDialog("worldmap")
	end

	local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
        	doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then
    	doaction = true
    end
	if doaction == true then
        local gid = sender:getTag()
        if dd.worldLayer ~= nil then
            dd.worldLayer:setSceneCenterByGid(gid - 1,true)   
        end
	    local action = cc.ScaleTo:create(0.8,4)
        local seq = cc.Sequence:create(action,cc.CallFunc:create(close))
        local widget = pop.getDialog("worldmap")
        if widget == nil then
            return
        end
        local endp   = widget._map:convertToNodeSpace(sender:getTouchEndPosition())
        local ax = endp.x/widget._mapBaseW
        local ay = endp.y/widget._mapBaseH
        widget._map:setAnchorPoint(cc.p(ax,ay))
        widget._map:setPosition(cc.p(endp.x,endp.y))
        widget._map:setEnabled(false)
        widget._map:runAction(seq)
	end
end

function wmpLayer.onGetStrongholdLists( message )
    local widget = pop.getDialog("worldmap")
    if widget == nil then
        return
    end
    local code = message:getLong()
    if code == 0 then
        widget._info = {}
        local count = message:getLong()
        for i=1,count do
            local id = message:getLong()
            local state = message:getLong()--0未开放1报名2争夺3保护
            local endTime = message:getLong()
            local unionid = message:getLong()
            local short = message:getString(3)
            local name = message:getString(15)
            local ico = message:getLong()
            
            message:getLong()
            message:getLong()
            message:getLong()
       
            widget._info[i] = {}
            widget._info[i]["id"] = id
            widget._info[i]["unionid"] = unionid
            
            widget._info[i]["state"] = state

            widget._info[i]["endTime"] = endTime
            widget._info[i]["short"] = short
            widget._info[i]["name"] = name
            widget._info[i]["ico"] = ico
        end 
        widget:showStrongholdLists()
    end
    message:clear()
    message = nil
end

function wmpLayer.update( sender )
    if table.getn(sender._info) >= 12 then
        for i,v in ipairs(self._info) do
            if v["state"] == 2 then
                for var=1, sender._citycnt do
                    
                    if self.cityGidArr[var]['id'] == v["id"] then
                        local item = self._map:getChildByTag(var)
      
                        if item ~=nil then
                            local time = v["endTime"] - dd.getServerTime()
                            item:getChildByName("info"):setString(ff.getLeftTime(time,":"))
                        end
                        break
                    end
                end
            end
        end
    end
end

function wmpLayer:showStrongholdLists(  )
    for i,v in ipairs(self._info) do
        if v["state"] == 2 or v["state"] == 3 then
            for var=1, self._citycnt do
                
                if self.cityGidArr[var]['id'] == v["id"] then
                    local item = self._map:getChildByTag(var)
  
                    if item ~=nil then
                        if v["unionid"] > 0 then
                            item:getChildByName("info"):setString("[".. v["short"].."]"..v["name"])
                        else
                            item:getChildByName("info"):setString("")
                        end
                        --item:loadTexture(dd.getPathFromUI("Stronghold.png",1))
                    end
                    break
                end
            end
        end
    end
end

function wmpLayer.onGetUnions(message)
	local widget = pop.getDialog("worldmap")
	if widget == nil then
		return
	end
	local code = message:getLong()
	if code == 0 then
		local unionid = message:getLong()
		local short = message:getString(3)
		message:getString(15)
		message:getLong()
		message:getLong()
		message:getLong()
		message:getLong()
		message:getSuperLong()

		message:getLong()
		message:getLong()
		local masterid = message:getLong()
		local name  = message:getString(15)
		local face  = message:getLong()
		local level = message:getLong()
		local gid   = message:getLong()
		local count = message:getLong()
        cclog("count:"..count)
		local row = widget._data:addRow()
		widget._data:setLong(row,"uid",masterid)
		widget._data:setLong(row,"gid",gid)
		widget._data:setLong(row,"master",1)
	
		for i=1,count do
			local row = widget._data:addRow()
			widget._data:setLong(row,"uid",message:getLong())
			message:getLong()
			message:getLong()
			widget._data:setLong(row,"gid",message:getLong())
			widget._data:setLong(row,"master",0)
		end	
		widget:showUnions(true)
	end
end

function wmpLayer.onStart(sender)
	local xy = sender:getMapPositon(dd.mycity:getLong(1,"cid"))
    local item = sp.SkeletonAnimation:create("images/world/wmpself.json", "images/world/wmpself.atlas")
    item:setAnimation(0,"SJDT_animation",true)
    item:setTag(dd.uid)
    item:setPosition(10,0)

    local zb = sender:getChildByName("zb"):clone()
    zb:setVisible(true)
    zb:addChild(item)
    zb:setTag(dd.mycity:getLong(1,"cid"))
    zb:setPosition(cc.p(xy.x + 13,xy.y + 18))
    sender._map:addChild(zb,3)

    local x = xy.x - ff.width/2
    if x < 0 then
        x = 0
    end
    if x + ff.width >= wmpLayer._mapBaseW then
        x = wmpLayer._mapBaseW - ff.width
    end
    local y = xy.y - ff.height/2
    if y < 0 then
        y = 0
    end
    if y + ff.height >= wmpLayer._mapBaseH then
        y = wmpLayer._mapBaseH - ff.height
    end
    sender._scroll:getInnerContainer():setPosition(cc.p(-x,-y))


    ff.net:registerEvent(1,dd.Tjf_map_getAllyMap,sender.onGetUnions)
    ff.net:registerEvent(1,dd.Tjf_map_GetStrongholdLists,sender.onGetStrongholdLists)
end

function wmpLayer.onEnd(sender)
    dd.delBackEvent()
	ff.net:removeEvent(1,dd.Tjf_map_getAllyMap)
    ff.net:removeEvent(1,dd.Tjf_map_GetStrongholdLists)
	if sender._map ~= nil then
        sender._map:stopAllActions()
        sender._map:removeAllChildren(true)
        if ff.platform ~= 1 then
            sender._map:loadTexture(dd.getPathFromUI("public/alpha.png",1))    
        end
    end
    sender._pos = nil
    sender:getChildByName("table"):stopAllActions() 
	sender:stopAllActions() 
	sender._mapBaseW = 2048
    sender._mapBaseH = 1280
    sender:getChildByName("unRes"):setSelectedState(false)    
    sender:getChildByName("unUnion"):setSelectedState(true) 
end
function wmpLayer.onBefore(sender)	
	sender:stopAllActions()
    sender._map:setEnabled(true)
	return true
end
function wmpLayer:onClose()
    return false
end

function wmpLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("worldmap")
        if widget~=nil and widget:onClose() == false then
            pop.onClosePopDialog("worldmap")
        end    
    end
end

function onShowWmp(widget)  
    local layer = wmpLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end