

function report_format( message )
    local code = message:getLong()
    if code == 0 then
        local table = {}

    table.id = message:getSuperLong()

    table.time = message:getLong()
    table.pos = message:getLong()
    table.type = message:getLong()
    table.result = message:getLong()

    table.A_union_ID = message:getLong()
    table.A_union_Name = message:getString(15)
    table.A_union_Name2 = message:getString(3)
    table.A_hero_Master_ID = message:getLong()
    table.A_hero_Name = message:getString(15)
    table.A_hero_office = message:getLong()
    table.A_hero_ID = message:getLong()
    table.A_hero_level = message:getLong()
    table.A_hero_power = message:getLong()
    table.A_hero_exp = message:getLong()
    
    table.B_union_ID = message:getLong()
    table.B_union_Name = message:getString(15)
    table.B_union_Name2 = message:getString(3)
    table.B_hero_Master_ID = message:getLong()
    table.B_hero_Name = message:getString(15)
    table.B_hero_office = message:getLong()
    table.B_hero_ID = message:getLong()
    table.B_hero_level = message:getLong()
    table.B_hero_power = message:getLong()
    table.B_hero_exp = message:getLong()

    local Acount = message:getLong()

    local info = nil
    if Acount>0 then
        info=ff.NetTable:create()
        info:addStreamCol("type",ff.NET_LONG)
        info:addStreamCol("id",ff.NET_LONG)
        info:addStreamCol("office",ff.NET_LONG)
        info:addStreamCol("name",ff.NET_STRING,15)
        info:addStreamCol("level",ff.NET_LONG)
        info:addStreamCol("ico",ff.NET_LONG)
        info:addStreamCol("pos",ff.NET_LONG)
        info:addStreamCol("powerUp",ff.NET_LONG)
        info:addStreamCol("powerLose",ff.NET_LONG)

        message:getData(Acount,info)
    end

    table.Ainfo = info

    local Bcount = message:getLong()
   
    local infoB = nil
    if Bcount>0 then
        infoB=ff.NetTable:create()
        infoB:addStreamCol("type",ff.NET_LONG)
        infoB:addStreamCol("id",ff.NET_LONG)
        infoB:addStreamCol("office",ff.NET_LONG)
        infoB:addStreamCol("name",ff.NET_STRING,15)
        infoB:addStreamCol("level",ff.NET_LONG)
        infoB:addStreamCol("ico",ff.NET_LONG)
        infoB:addStreamCol("pos",ff.NET_LONG)
        infoB:addStreamCol("powerUp",ff.NET_LONG)
        infoB:addStreamCol("powerLose",ff.NET_LONG)
    
        message:getData(Bcount,infoB)
    end

    table.Binfo = infoB

    local resCnt = message:getLong()
    local resInfo = nil
  
    if resCnt > 0 then
        resInfo=ff.NetTable:create()
        resInfo:addStreamCol("playerid",ff.NET_LONG)
        resInfo:addStreamCol("itemType",ff.NET_LONG)
        resInfo:addStreamCol("itemId",ff.NET_LONG)
        resInfo:addStreamCol("itemCnt",ff.NET_LONG)
        message:getData(resCnt,resInfo)
    end

    table.resInfo = resInfo

    local amyCnt = message:getLong()

    local amyInfo = nil
    if amyCnt > 0 then
        amyInfo=ff.NetTable:create()
        amyInfo:addStreamCol("playerid",ff.NET_LONG)
        amyInfo:addStreamCol("id",ff.NET_LONG)
        amyInfo:addStreamCol("power",ff.NET_LONG)
        amyInfo:addStreamCol("powerlose",ff.NET_LONG)
        amyInfo:addStreamCol("medcnt",ff.NET_LONG)

        message:getData(amyCnt,amyInfo)
    end

    table.amyInfo = amyInfo

    local NPCCnt = message:getLong()

    local NPCInfo = nil
    if NPCCnt > 0 then
        NPCInfo=ff.NetTable:create()
        NPCInfo:addStreamCol("id",ff.NET_LONG)
        NPCInfo:addStreamCol("power",ff.NET_LONG)
        NPCInfo:addStreamCol("powerUp",ff.NET_LONG)
        NPCInfo:addStreamCol("powerStill",ff.NET_LONG)

        message:getData(NPCCnt,NPCInfo)
    end
    local compare = {}
    compare.canCompare = message:getLong()
    if compare.canCompare ~= 0 then
        compare.A_hero_level = message:getLong()
        compare.A_ALLPower = message:getSuperLong()
        compare.A_AmyCnt = message:getLong()
        compare.A_isHao = message:getLong()
        compare.A_isShen = message:getLong()
        compare.A_liao = message:getLong()
        compare.A_cheng = message:getLong()
        compare.A_dashi = message:getLong()
        compare.A_zhan = message:getLong()
        compare.A_yu1 = message:getLong()
        compare.A_yu2 = message:getLong()
        compare.A_yu3 = message:getLong()
        compare.A_yu4 = message:getLong()

        compare.B_hero_level = message:getLong()
        compare.B_ALLPower = message:getSuperLong()
        compare.B_AmyCnt = message:getLong()
        compare.B_isHao = message:getLong()
        compare.B_isShen = message:getLong()
        compare.B_liao = message:getLong()
        compare.B_cheng = message:getLong()
        compare.B_dashi = message:getLong()
        compare.B_zhan = message:getLong()
        compare.B_yu1 = message:getLong()
        compare.B_yu2 = message:getLong()
        compare.B_yu3 = message:getLong()
        compare.B_yu4 = message:getLong()

        compare.addBu = message:getLong()
        compare.addQi = message:getLong()
        compare.addGong = message:getLong()
        compare.addHPBu = message:getLong()
        compare.addHPQi = message:getLong()
        compare.addHPGong = message:getLong()
        compare.equipPower = message:getLong()
        compare.gemLevel = message:getLong()
        compare.tec1 = message:getLong()
        compare.tec2 = message:getLong()
        compare.tec3 = message:getLong()
        compare.tec4 = message:getLong()
        compare.tec5 = message:getLong()
        compare.tec6 = message:getLong()
        compare.tec7 = message:getLong()
        compare.tec8 = message:getLong()
        compare.union1 = message:getLong()
        compare.union2 = message:getLong()
        compare.union3 = message:getLong()
        compare.union4 = message:getLong()
        compare.result = table.result

        --cclog("=="..compare.A_isHao.."="..compare.B_isHao.."="..compare.A_liao.."="..compare.B_liao)
    end

        table.NPCInfo = NPCInfo

        table.compare = compare

        message:clear()  
        
        return {code,table}
    else
        message:clear()
        return {code}
    end
end