local buildsListLayer   = class("buildsListLayer")
buildsListLayer._name   = "buildsListLayer"
buildsListLayer._parent = nil
buildsListLayer._init   = false
buildsListLayer._pos    = 0
buildsListLayer._bid    = 0
buildsListLayer._upgrade= nil
buildsListLayer._type   = 0
buildsListLayer._widget = nil
buildsListLayer._lastpos= 0
buildsListLayer._showup = false
buildsListLayer._params = nil
buildsListLayer._initType = false

buildsListLayer._newbie = 0


--用来保存任务过来的参数
dd._saveparam = {0,0,0}
--返回函数
function buildsListLayer.onClose(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    else    
        if eventType == ccui.TouchEventType.ended then
            close = true
        end
    end
    if close == true then    
        local widget = dd.currentLayer._pop
        if widget ~= nil then
            if widget._type == 1 then
                if dd.currentLayer._widget ~= nil then
                    dd.currentLayer._widget:closeBuilds()
                end
            else
                if widget._widget ~= nil then
                    if widget._widget.onReturn ~= nil then
                        if widget._widget.onReturn(widget._widget) == true then
                            return
                        end
                    end
                end    
                for i=1,dd.mybuilds:rowCount() do
                    if dd.mybuilds:getLong(i,"pos") == widget._pos then
                        widget._type = 1
                        pop.onCloseEffect(99,widget._upgrade)
                        widget._parent:closeBuilds()
                        return
                    end    
                end
                widget._type = 1
                widget._upgrade:stopAllActions()
                pop.onCloseEffect(99,widget._upgrade)
                widget:getChildByName("lists"):stopAllActions()
                pop.showPopEffect(99,widget:getChildByName("lists"))       
            end   
        end    
    end
end
function buildsListLayer:closeNow()
    self:stopAllActions()
    self:setVisible(false)
    if self._widget ~= nil then
        if pop.builds[self._bid] ~= nil then
            pop.closeNow(self._widget)
        end
        self._widget = nil
    end
    pop.closeNow(self)   
end

function buildsListLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, buildsListLayer)
    return target
end
function buildsListLayer:onShowBtns(flag)
    self:getChildByName("btns"):setVisible(flag)
end

function buildsListLayer:onInit()	
    function onSelect(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            if sender:getSelectedState() == true then
                self:getChildByName("btns"):getChildByName("option"):setSelectedState(false)
                self:getChildByName("btns"):getChildByName("upgrade"):setSelectedState(false)     
                return
            end    

            self:getChildByName("btns"):getChildByName("option"):setSelectedState(false)
            self:getChildByName("btns"):getChildByName("upgrade"):setSelectedState(false)     
            if sender:getName() == "option" then
                self:onShowOption()
                self:getChildByName("btns"):getChildByName("option"):getChildByName("label"):setColor(cc.c3b(239,223,223))
                self:getChildByName("btns"):getChildByName("upgrade"):getChildByName("label"):setColor(cc.c3b(135,89,89))
            else
                self:onShowGrade()
                self:getChildByName("btns"):getChildByName("upgrade"):getChildByName("label"):setColor(cc.c3b(239,223,223))
                self:getChildByName("btns"):getChildByName("option"):getChildByName("label"):setColor(cc.c3b(135,89,89))
            end
        end
    end

    if self._init == false then
        self:getChildByName("btns"):getChildByName("option"):addTouchEventListener(onSelect)
        self:getChildByName("btns"):getChildByName("upgrade"):addTouchEventListener(onSelect)

        --self:getChildByName("btns"):getChildByName("option"):getChildByName("label"):enableOutline(cc.c4b(0,0,0,255),3)
        --self:getChildByName("btns"):getChildByName("upgrade"):getChildByName("label"):enableOutline(cc.c4b(0,0,0,255),3)

        --self:getChildByName("btns"):getChildByName("option"):getChildByName("label"):getVirtualRenderer():enableBold(true)
        --self:getChildByName("btns"):getChildByName("upgrade"):getChildByName("label"):enableBold(true)

        self:getChildByName("back"):setPositionY(-(1180 - self:getContentSize().height)/2)
        self:getChildByName("topArea"):setPositionY(self:getContentSize().height - 105)
        self:getChildByName("lists"):setPositionY(0)
        self:getChildByName("upgrade"):setPositionY(0)
        self:getChildByName("topArea"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
        self:getChildByName("topArea"):getChildByName("icon"):addTouchEventListener(dd.onPay)
        self:getChildByName("topArea"):getChildByName("count"):addTouchEventListener(dd.onPay)

        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)

        self:getChildByName("lists"):addChild(self:getChildByName("jg"):clone())
    	self._init = true    
   	end
    dd.currentLayer._pop = self

    self:onShowBtns(false)
    self:getChildByName("btns"):getChildByName("option"):setSelectedState(false)
    self:getChildByName("btns"):getChildByName("upgrade"):setSelectedState(true)
    self:getChildByName("btns"):getChildByName("option"):getChildByName("label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("btns"):getChildByName("upgrade"):getChildByName("label"):setColor(cc.c3b(239,223,223))


    ff.net:bindProperty(2201,"gold",self.updateGold)    

    self._type = 1
    self._bid  = 0 
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"pos") == self._pos then
            self._type = 2
            self._bid  = dd.mybuilds:getLong(i,"bid")
            break
        end            
    end
    
    self:getChildByName("upgrade"):setVisible(false)
    if self._type == 1 then
        self:getChildByName("lists"):setVisible(true)
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("建造列表"))
    else    
        self:getChildByName("lists"):setVisible(false)
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString(dd.cfgBuilding[self._bid]['name']))
    end    

    self:getChildByName("lists"):setPositionY(0)
    self:getChildByName("topArea"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
    self:getChildByName("topArea"):getChildByName("return"):addTouchEventListener(self.onClose)
    self:stopAllActions()
    pop.showPopEffect(11,self)
    self.updateGold()
end
function buildsListLayer.updateGold(name,row,old,value)
    local widget = dd.currentLayer._pop
    if widget ~= nil then
        widget:getChildByName("topArea"):getChildByName("count"):setString(dd.gold())
        local w = widget:getChildByName("topArea"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("topArea"):requestDoLayout()
    end
end
function buildsListLayer:onShowOption()
    local function showBuild()
        if self._widget ~= nil then
            self._widget:stopAllActions()
            pop.showPopEffect(99,self._widget,true)        
        end
    end
    if pop.builds[self._bid] ~= nil then
        local name = pop.builds[self._bid][2]
        pop.onShowPopDialog(name,self._pos,self._lastpos)
        self._lastpos = self._pos
        self._widget = pop.getDialog(name)

        self._upgrade:stopAllActions()
        pop.onCloseEffect(99,self._upgrade)
        showBuild()
        --performWithDelay(self, showBuild, 0.3)
    end
end


function buildsListLayer:onShowGrade()
    self:stopAllActions()
    if pop.builds[self._bid] ~= nil then
        local name = pop.builds[self._bid][2]
        pop.onClosePopDialog(name)
    end
    self._upgrade = showUpgrade(self,self._bid,self._pos)
    self._upgrade:stopAllActions()
    pop.showPopEffect(99,self._upgrade)    
end


function buildsListLayer.onClick(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then
        local bid = tonumber(sender:getName())
        if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
            for i,v in ipairs(dd.currentLayer._pop:getChildByName("lists"):getChildren()) do
                v:stopAllActions()
                v:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
                if v:getChildByTag(99) ~= nil then
                    v:getChildByTag(99):setVisible(false)
                end
            end 
         
            dd.currentLayer._pop._bid = bid
            dd.currentLayer._pop:showUpgrade(bid)
        end
    end
end
function buildsListLayer:showUpgrade(bid)
    self._type = 2
    self:getChildByName("lists"):stopAllActions()
    pop.onCloseEffect(99,self:getChildByName("lists"))

    self._upgrade = showUpgrade(self,bid,self._pos)
    self._upgrade:stopAllActions()
    pop.showPopEffect(99,self._upgrade)
    return self._upgrade
end
function buildsListLayer.onBefore(sender)
    sender._lastpos = 0
    if sender._type ~= 1 then
        if sender._showup == true then
            local btns = sender:getChildByName("btns")
            btns:getChildByName("upgrade"):setSelectedState(true)
            btns:getChildByName("option"):setSelectedState(false)
            btns:getChildByName("upgrade"):getChildByName("label"):setColor(cc.c3b(239,223,223))
            btns:getChildByName("option"):getChildByName("label"):setColor(cc.c3b(135,89,89))
        else    
            if pop.builds[sender._bid] ~= nil then
                local btns = sender:getChildByName("btns")
                btns:getChildByName("option"):setSelectedState(true)
                btns:getChildByName("upgrade"):setSelectedState(false)
                btns:getChildByName("option"):getChildByName("label"):setColor(cc.c3b(239,223,223))
                btns:getChildByName("upgrade"):getChildByName("label"):setColor(cc.c3b(135,89,89))
                btns:setVisible(true)
                btns:setPositionY(sender:getContentSize().height - 190)
            end            
        end    
        local name = pop.builds[sender._bid][2]
        local widget = pop.getDialog(name)
        if widget ~= nil and widget._init == true then
            sender._lastpos = sender._pos
            sender:show()
        end
    else
        if sender._initType == true then
            sender:show()
        end
    end
    return true
end
function buildsListLayer.onStart(sender)
    if sender._lastpos == sender._pos and sender._lastpos ~= 0 then
        if dd.currentLayer ~= nil then
            dd.currentLayer._widget:getChildByName("builds"):getChildByName("mask"):setVisible(false)
        end    
        return
    end
    sender:show()
    if dd.currentLayer ~= nil then
        dd.currentLayer._widget:getChildByName("builds"):getChildByName("mask"):setVisible(false)
    end        
end
function buildsListLayer:show()
    local sender = self
    if sender._type == 1 then
        pos = sender._pos
        if dd.cfgPos[pos] == nil then
            cclog3("buildsListLayer:show,"..pos)
            return
        end
        local type = dd.cfgPos[pos]['type']
        local tick = 0
        local index = 1

        --通过新手引导点进来的
        local blist = {}
        if sender._newbie > 0 then
            blist[1] = sender._newbie
        end
        for i,j in ipairs(dd.cfgBuildingOrder) do
            local bid = dd.cfgBuildingOrder[i]
            if bid ~= sender._newbie then
                blist[table.getn(blist) + 1] = bid
            end
        end
        for i,j in ipairs(blist) do
            local bid = blist[i]
            local item = dd.cfgBuilding[blist[i]]
            if item['type'] == type and dd.myinfo:getLong(1,'level') >= dd.cfgBuildingUp[bid][1]['level1'] then
                local count= 0
                for i=1,dd.mybuilds:rowCount() do
                    if bid == dd.mybuilds:getLong(i,"bid") then
                        count = count + 1
                    end
                end
                if count < item['maxcount'] then           
                    if dd.cfgPos[pos]['bid'] == 0 or dd.cfgPos[pos]['bid'] == bid then
                        local mod = sender:getChildByName("lists"):getChildByTag(index)
                        if mod == nil then
                            mod = sender:getChildByName("item"):clone()
                            sender:getChildByName("lists"):addChild(mod)
                        end
                        local image = dd.cfgBuildingUp[bid][1]['image']
                        local function callback()
                            local str = bid.."_"..(image - 10)
                            local spine = sp.SkeletonAnimation:create("images/builds/"..bid.."/"..str..".json", "images/builds/"..bid.."/"..str..".atlas")
                            spine:setAnimation(0,str.."_animation",true)
                            spine:setTag(10)
                            mod:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                            mod:getChildByName("icon"):addChild(spine)
                            local xScale = 200/spine:getContentSize().width
                            spine:setScale(xScale)
                            spine:setPosition(cc.p(100,100))
                        end
                        if mod:getChildByName("icon"):getChildByTag(10) ~= nil then
                            mod:getChildByName("icon"):getChildByTag(10):removeFromParent(true)
                        end
                        if image > 10 then
                            callback()
                            --performWithDelay(mod, callback, 0)
                        else
                            local image = cc.Sprite:create(dd.getBuildImage(bid,1))
                            local xScale = 200/image:getContentSize().width
                            image:setTag(10)
                            image:setScale(xScale)
                            image:setPosition(cc.p(100,100))

                            --self:getChildByName("detail"):getChildByName("item"):addChild(image)
                            mod:getChildByName("icon"):addChild(image)
                        end
                        mod:getChildByName("base"):getChildByName("name"):setString(ff.langString(item['name']))
                        mod:getChildByName("base"):getChildByName("tips"):setString(ff.langString(item['tips']))
                        mod:getChildByName("base"):getChildByName("count"):setString(count.."/"..item['maxcount'])

                        if dd.cfgBuildingUp[bid] ~= nil and dd.cfgBuildingUp[bid][1] ~= nil then
                            if dd.cfgBuildingUp[bid][1]["bid1"] > 0 then
                                for i=1,dd.mybuilds:rowCount() do
                                    if dd.mybuilds:getLong(i,"bid") == dd.cfgBuildingUp[bid][1]["bid1"] then
                                        if dd.mybuilds:getLong(i,"level") >= dd.cfgBuildingUp[bid][1]["level1"] then
                                            if dd.cfgBuildingUp[bid][1]["bid2"] > 0 then
                                                for i=1,dd.mybuilds:rowCount() do
                                                    if dd.mybuilds:getLong(i,"bid") == dd.cfgBuildingUp[bid][1]["bid2"] then
                                                        if dd.mybuilds:getLong(i,"level") >= dd.cfgBuildingUp[bid][1]["level2"] then
                                                            mod:getChildByName("base"):getChildByName("reqs"):setVisible(false)
                                                        else    
                                                            mod:getChildByName("base"):getChildByName("reqs"):setColor(cc.c3b(183,197,199))
                                                            mod:getChildByName("base"):getChildByName("reqs"):setString(ff.langString(dd.cfgBuilding[dd.cfgBuildingUp[bid][1]["bid2"]]['name']).." Lv "..dd.cfgBuildingUp[bid][1]["level2"])
                                                        end
                                                    end    
                                                end
                                            else    
                                                mod:getChildByName("base"):getChildByName("reqs"):setVisible(false)
                                            end
                                        else    
                                            mod:getChildByName("base"):getChildByName("reqs"):setColor(cc.c3b(183,197,199))
                                            mod:getChildByName("base"):getChildByName("reqs"):setString(ff.langString(dd.cfgBuilding[dd.cfgBuildingUp[bid][1]["bid1"]]['name']).." Lv "..dd.cfgBuildingUp[bid][1]["level1"])
                                        end
                                        break
                                    end    
                                end
                            end
                        end    
                        mod:setVisible(true)
                        mod:setTag(index)
                        mod:setName(tostring(bid))
                        index = index + 1
                        mod:addTouchEventListener(sender.onClick)            
                        --添加手型辅助按钮  
                        local hand = mod:getChildByTag(99)
                        if hand ~= nil then
                            hand:stopAllActions()
                            hand:setVisible(false)
                        end
                        mod:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
                        mod:stopAllActions()
                        if bid == sender._newbie and bid > 0 and dd.canShowHandArrow() == true then
                            cclog("show hand...")
                            if hand == nil then
                                hand = cc.Sprite:create("images/city/effect/hand.png")                      
                                mod:addChild(hand,99,99)
                            end
                            hand:setPosition(400,180)
                            local action = cc.MoveBy:create(0.5,cc.p(-20,-40))
                            local back = action:reverse()
                            hand:runAction(cc.RepeatForever:create(cc.Sequence:create(action,back)))
                            hand:setVisible(true)
                            mod:getVirtualRenderer():setGLProgramState(ff.Effect:effectHighLight():getGLProgramState())
                        end          
                    end    
                end    
            end    
        end
        for i=index,sender:getChildByName("lists"):getChildrenCount() do
            local mod = sender:getChildByName("lists"):getChildByTag(i)
            if mod ~= nil then
                mod:removeFromParent(true)
            end
        end
        --sender:getChildByName("lists"):addChild(sender:getChildByName("jg"):clone())
        sender:getChildByName("lists"):refreshView()
        sender:getChildByName("lists"):jumpToTop()
        sender._initType = true
    else
        if sender._showup == true then
            sender._bid = sender._bid
            sender:showUpgrade(sender._bid)                    
        else
            if pop.builds[sender._bid] ~= nil then
                cclog("here show:"..sender._pos)
                local name = pop.builds[sender._bid][2]
                pop.onShowPopDialog(name,sender._pos,sender._lastpos,sender._params)
                sender._lastpos = sender._pos
                sender._widget = pop.getDialog(name)
                pop.showPopEffect(99,sender._widget,true)   
            end
        end        
    end
end
function buildsListLayer.onEnd(sender)
    cclog("close building:"..sender._bid)
    if sender._widget ~= nil then
        if pop.builds[sender._bid] ~= nil then
            local name = pop.builds[sender._bid][2]
            pop.onClosePopDialog(name)
        end
        sender._widget = nil
    end   

    for i,v in ipairs(sender:getChildByName("lists"):getChildren()) do
        v:stopAllActions()
    end 
    --sender:getChildByName("lists"):removeAllChildren()

    --删除当前回退
    dd.delBackEvent()
    sender._parent = nil
    sender._pos = 0
end
function onShowBuildsList(parent,pos,show,param)
    local widget   = buildsListLayer.extend(parent:getChildByName("builds"))
    widget._newbie = 0
    --俱乐部特殊建筑
    if pos == nil then
        return
    end
    if dd.cfgPos[pos] == nil then
        return
    end
    if dd.myinfo:getLong(1,"TaskNewbieId") ~= 0 and pos == 118 then
        pop.onShowPopDialog("TaskNewbie")
        return
    end
    --cclog("==================="..dd.cfgPos[pos]['bid'])
    if dd.cfgPos[pos]['bid'] == 36 then  
        AudioEngine.playEffect(ff.sounds[105])  
        if dd.myinfo:getLong(1,"level") >= dd.cfgPos[pos]['lv'] then      
            pop.onShowPopDialog("club")
        else
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("司令部等级达{0}级开放",{dd.cfgPos[pos]['lv']}))
        end
    elseif dd.cfgPos[pos]['bid'] == 34 then  
        AudioEngine.playEffect(ff.sounds[105])  
        if dd.myinfo:getLong(1,"level") >= dd.cfgPos[pos]['lv'] then      
            pop.onShowPopDialog("Activityshou")
        else
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("司令部等级达{0}级开放",{dd.cfgPos[pos]['lv']}))
        end
    elseif dd.cfgPos[pos]['bid'] == 13 then  
        AudioEngine.playEffect(ff.sounds[105])  
        if dd.myinfo:getLong(1,"level") >= dd.cfgPos[pos]['lv'] then      
            pop.onShowPopDialog("Jail")
        else
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("司令部等级达{0}级开放",{dd.cfgPos[pos]['lv']}))
        end
    elseif dd.cfgPos[pos]['bid'] == 16 then  
        AudioEngine.playEffect(ff.sounds[105]) 
        
        if dd.myinfo:getLong(1,"level") >= dd.cfgPos[pos]['lv'] then      
            pop.onShowPopDialog("ExchangeItem")
        else
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("司令部等级达{0}级开放",{dd.cfgPos[pos]['lv']}))
        end
    elseif dd.cfgPos[pos]['bid'] == 37 then  
        AudioEngine.playEffect(ff.sounds[105]) 
        if dd.myinfo:getLong(1,"level") >= dd.cfgPos[pos]['lv'] then      
            pop.onShowPopDialog("StrongholdInfoShow",3)
        else
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("司令部等级达{0}级开放",{dd.cfgPos[pos]['lv']}))
        end
    elseif dd.cfgPos[pos]['bid'] == 38 then  
        AudioEngine.playEffect(ff.sounds[105]) 
        if dd.myinfo:getLong(1,"level") >= dd.cfgPos[pos]['lv'] then      
            pop.onShowPopDialog("Alchemist")
        else
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("司令部等级达{0}级开放",{dd.cfgPos[pos]['lv']}))
        end
    elseif dd.cfgPos[pos]['bid'] == 39 then  
        AudioEngine.playEffect(ff.sounds[105]) 
        if dd.myinfo:getLong(1,"level") >= dd.cfgPos[pos]['lv'] then      
            pop.onShowPopDialog("TrainingRoom")
        else
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("司令部等级达{0}级开放",{dd.cfgPos[pos]['lv']}))
        end
    else
        showBuildsList(parent,pos,show,param)
    end
end
function onShowBuildsListNewbie(parent,pos,bid)
    local widget   = buildsListLayer.extend(parent:getChildByName("builds"))
    widget._newbie = bid
    showBuildsList(parent,pos)
end
function showBuildsList(parent,pos,show,param)
    if dd.myinfo:getLong(1,"level") >= dd.cfgPos[pos]['lv'] then
        if dd.cfgPos[pos]['lv'] > 0 then
            local have = false
            for i=1,dd.myLocks:rowCount() do
                if dd.myLocks:getLong(i,"pos") == pos then
                    have = true
                    break
                end
            end
            for i=1,dd.mybuilds:rowCount() do
                if dd.mybuilds:getLong(i,"pos") == pos then
                    have = true
                    break
                end
            end
            --解锁
            if have == false then
                local message = ff.net:createMessage()
                message:addCmd(0x0000016c)
                message:addLong(dd.uid)
                message:addLong(pos)
                ff.net:rpc(message,false)            
                return
            end
        end
        AudioEngine.playEffect(ff.sounds[105])
    	local widget   = buildsListLayer.extend(parent:getChildByName("builds"))
        if widget._parent == parent and widget._pos == pos and widget:isVisible() == true then
            return
        end
        widget:closeNow()
        --通过底图移动过来的请求
        if dd._saveparam ~= nil and pos == dd._saveparam[1] then
            if dd._saveparam[2] == 2 then
                show = true
            end
            param = dd._saveparam[3]
        end
        dd._saveparam = {0,0,0}

    	widget._parent = parent
    	widget._pos    = pos
        widget._params = param

        if show == nil then
            widget._showup = false
        else
            widget._showup = show
        end
        --如果是0-1中，显示升级界面
        for i=1,dd.mylists:rowCount() do
            if (dd.mylists:getLong(i,"type") == 1 or dd.mylists:getLong(i,"type") == 13) and dd.mylists:getLong(i,"param4") == 1 then
                if dd.mylists:getLong(i,"param1") == pos then
                    widget._showup = true
                    break
                end
            end
        end
        if dd.currentLayer ~= nil then
            dd.currentLayer._widget:getChildByName("builds"):getChildByName("mask"):setVisible(true)
        end
        dd.regeditBackEvent(widget.onClose)
    	widget:onInit()
        if dd.buildingListWidget  == nil then
            dd.buildingListWidget = widget
        end

        return widget
    else
        if dd.cfgPos[pos]['lv'] == 99 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("该功能尚未开放，敬请期待！"))
        else
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("司令部等级达{0}级开放",{dd.cfgPos[pos]['lv']}))
        end
    end    
end
