--获得物品 上浮动画
--colortype  1:绿色 增益     2:红色 减益
function CityUILayer:showGiftNotice(type,tid,count,position,colortype)
    if colortype == nil then
        colortype = 1
    end
    local item = dd.mainUI:getChildByName("giftnotice"):clone()
    local textures = dd.getGiftsIcon(type,tid)
    item:setVisible(true)
    item:setPosition(cc.p(position.x-60, position.y))
    dd.mainUI:getChildByName("effect"):addChild(item)
    item:getChildByName("icon"):loadTexture(textures[1],textures[2])  
    
    if colortype == 1 then
        item:getChildByName("count"):setString("+"..count)
        item:getChildByName("count"):setColor(cc.c3b(7,159,0))
    elseif colortype == 2 then
        item:getChildByName("count"):setString("-"..count)
        item:getChildByName("count"):setColor(cc.c3b(179,4,24))
    else
        item:getChildByName("count"):setString("+"..count)
        item:getChildByName("count"):setColor(cc.c3b(7,159,0))
    end  
    
    item:getChildByName("icon"):setContentSize(cc.size(60,60))
    item:getChildByName("count"):setPositionX(60+20)
    
    local action1 = cc.MoveBy:create(0.5,cc.p(0,100))
    local action2 = cc.MoveBy:create(0.5,cc.p(0,100))
    local action3 = cc.FadeOut:create(0.5)
    local spaw    = cc.Spawn:create(action2, action3)
    local sequence = cc.Sequence:create(action1, spaw, cc.RemoveSelf:create())
    item:runAction(sequence)    
end