
function CityUILayer:canTouchSelectBtns()
    local btns = self:getChildByName("bottom"):getChildByName("btns")
    btns:getChildByName("quests"):setTouchEnabled(true)
    btns:getChildByName("items"):setTouchEnabled(true)
    btns:getChildByName("alliance"):setTouchEnabled(true)
    btns:getChildByName("mail"):setTouchEnabled(true)
    --btns:getChildByName("lottery"):setTouchEnabled(true)
    --btns:getChildByName("cid"):setTouchEnabled(true)
    btns:getChildByName("setting"):setTouchEnabled(true)
    btns:getChildByName("rank"):setTouchEnabled(true)
end
function CityUILayer:unSelectBtns(sender)
    local btns = self:getChildByName("bottom"):getChildByName("btns")
    if btns:getChildByName("quests") ~= sender then
        btns:getChildByName("quests"):setTouchEnabled(true)
    end
    if btns:getChildByName("items") ~= sender then
        btns:getChildByName("items"):setTouchEnabled(true)
    end
    if btns:getChildByName("alliance") ~= sender then
        btns:getChildByName("alliance"):setTouchEnabled(true)
    end
    if btns:getChildByName("mail") ~= sender then
        btns:getChildByName("mail"):setTouchEnabled(true)
    end
    if btns:getChildByName("rank") ~= sender then
        btns:getChildByName("rank"):setTouchEnabled(true)
    end
    if btns:getChildByName("setting") ~= sender then
        btns:getChildByName("setting"):setTouchEnabled(true)
    end

    btns:getChildByName("quests"):setSelectedState(false)
    btns:getChildByName("items"):setSelectedState(false)
    btns:getChildByName("alliance"):setSelectedState(false)
    btns:getChildByName("mail"):setSelectedState(false)
    --btns:getChildByName("lottery"):setSelectedState(false)
    --btns:getChildByName("cid"):setSelectedState(false)
    btns:getChildByName("rank"):setSelectedState(false)
    btns:getChildByName("setting"):setSelectedState(false)

    btns:getChildByName("quests"):getChildByName("label"):setColor(cc.c3b(143,150,152))
    btns:getChildByName("items"):getChildByName("label"):setColor(cc.c3b(143,150,152))
    btns:getChildByName("alliance"):getChildByName("label"):setColor(cc.c3b(143,150,152))
    btns:getChildByName("mail"):getChildByName("label"):setColor(cc.c3b(143,150,152))
    --btns:getChildByName("lottery"):getChildByName("label"):setColor(cc.c3b(143,150,152))
    --btns:getChildByName("cid"):getChildByName("label"):setColor(cc.c3b(143,150,152))
    btns:getChildByName("rank"):getChildByName("label"):setColor(cc.c3b(143,150,152))
    btns:getChildByName("setting"):getChildByName("label"):setColor(cc.c3b(143,150,152))
    if sender ~= nil then
         sender:getChildByName("label"):setColor(cc.c3b(255,255,255))
    end
    local widget = pop.getDialog("mailReceive")
    if pop.isShowing("mailReceive") then
        if widget then
            widget.onReturn()
            return
        end
    end
end
function CityUILayer.onPve(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        dd.yunClose(3)
    end
end
function CityUILayer.onPvp(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        if dd.myPvp ~= nil then
            --dd.yunClose(4,dd.myPvp,true)
            --dd.myPvp = nil
            if pop.isShowing("mail") then
                local widget = pop.getDialog("mail")
                if widget ~= nil then
                    if widget._type ~= 1 then
                        widget.selectType(widget:getChildByName("topNavi"):getChildByName("btreport"),ccui.TouchEventType.ended)
                        widget:getChildByName("topNavi"):getChildByName("btreport"):setSelectedState(true)
                    end
                end
            else
                pop.onShowPopDialog("mail",1)
            end  
            dd.myPvp = nil
        else
            sender:setVisible(false)
        end
    end
end
function CityUILayer.onHeals( sender,eventType )
    -- body
    if eventType==ccui.TouchEventType.ended then
        local have = false
        for i=1,dd.mybuilds:rowCount() do
            if dd.mybuilds:getLong(i,"bid") == 22 then
                        
                onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"))
                have= true
                return
            end
        end
        if have == false then
             dd.currentLayer._widget:onShowTips("\t"..ff.langString("你没有医院，请建造一个医院来容纳伤员"))
        end
               
     
    end
    
end

function CityUILayer.onBonus( sender,eventType )
    -- body
    if eventType==ccui.TouchEventType.ended then

        sender:setTouchEnabled(false)
        local message = ff.net:createMessage()
        message:addCmd(0x0000017b)
        message:addLong(dd.uid)
        message:addLong(dd.BonusIndex)
        ff.net:rpc(message, false)
        local function sched()
            sender:setTouchEnabled(true)
        end 
        performWithDelay(sender,sched,0.5)
    end
end

function CityUILayer.onTower( sender,eventType )
    -- body
    if eventType==ccui.TouchEventType.ended then
        local have = false
        for i=1,dd.mybuilds:rowCount() do
            if dd.mybuilds:getLong(i,"bid") == 3 then
                        
                onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"))
                have= true
                return
            end
        end
        if have == false then
             --dd.currentLayer._widget:onShowTips("\t你没有医院，请建造一个医院来容纳伤员")
        end
    end
    
end

function CityUILayer.onFuben(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        if dd.myinfo:getLong(1,"pataBegin") < dd.getServerTime() and dd.getServerTime() < dd.myinfo:getLong(1,"pataEnd") then
        
            pop.onShowPopDialog("TowerXmas")
        else
            pop.onShowPopDialog("towerfight")
        end
        
    end
end

function CityUILayer.onLianxu(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        pop.onShowPopDialog("sdchong",1)
        
    end
end

function CityUILayer.onLeiji(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        pop.onShowPopDialog("sdchong",2)
        
    end
end

function CityUILayer.onLogin(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        pop.onShowPopDialog("onlineReward")
        --pop.onShowPopDialog("sdchong",2)
    end
end
function CityUILayer.onCards(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        pop.onShowPopDialog("SurpriseRecharge",2)
    end
end
function CityUILayer.onLianjinsuo(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        pop.onShowPopDialog("AlchemistSkill")
    end
end


function CityUILayer.onAttendance(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        --pop.onShowPopDialog("card")
        if sender._type == 1 then
            pop.onShowPopDialog("Attendance")
        else
            pop.onShowPopDialog("bankpop")
        end
    end
end

function CityUILayer.onSurpriseRecharge(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        --pop.onShowPopDialog("card")
        pop.onShowPopDialog("SurpriseRecharge")
    end
end

function CityUILayer.onOnce(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        --pop.onShowPopDialog("card")
        pop.onShowPopDialog("SurpriseRecharge",5)
    end
end 

function CityUILayer.onkfevent(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        --pop.onShowPopDialog("card")
        pop.onShowPopDialog("SurpriseRecharge",6)
    end
end

function CityUILayer.onCloseTool(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        pop.onCloseEffect(99,dd.mainUI:getChildByName("tool"))
    end
end

function CityUILayer.onToolSure(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        local message = ff.net:createMessage()
        message:addCmd(0x00000121)
        message:addLong(dd.uid)
        message:addLong(1061)
        message:addLong(1)
        ff.net:rpc(message, false)
        pop.onCloseEffect(99,dd.mainUI:getChildByName("tool"))
    end
end



function CityUILayer.onSurpriseRechargeEx(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        --pop.onShowPopDialog("card")
        pop.onShowPopDialog("SurpriseRecharge",1)
    end
end

function  CityUILayer.onRestrictedGift( sender,eventType )
    if eventType==ccui.TouchEventType.ended then
        --pop.onShowPopDialog("card")
        pop.onShowPopDialog("RestrictedGift")
    end
end
--聊天面板
function CityUILayer.onChat(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        if not pop.isShowing("chat") then
            pop.onShowPopDialog("chat",1)
        end    
    end
end--任务面板
function CityUILayer.onTask(sender,eventType)
    if eventType == ccui.TouchEventType.canceled then
        if pop.getDialog("task") ~= nil and pop.getDialog("task"):isVisible() == true then
            return
        end
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            dd.currentLayer._widget:unSelectBtns(sender)
            pop.onShowPopDialog("task")
        end
    end
    if eventType==ccui.TouchEventType.ended then
        dd.currentLayer._widget:unSelectBtns(sender)
        if pop.getDialog("task") ~= nil and pop.getDialog("task"):isVisible() == true then
            return
        end
        pop.onShowPopDialog("task",nil)
    end
end
--设置面板
function CityUILayer.onSet(sender, eventType)
    if eventType == ccui.TouchEventType.canceled then
        if pop.getDialog("gameSet") ~= nil and pop.getDialog("gameSet"):isVisible() == true then
            return
        end        
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            dd.currentLayer._widget:unSelectBtns(sender)
            pop.onShowPopDialog("gameSet")
        end
    end
    if eventType == ccui.TouchEventType.ended then
        dd.currentLayer._widget:unSelectBtns(sender)
        if pop.getDialog("gameSet") ~= nil and pop.getDialog("gameSet"):isVisible() == true then
            return
        end        
        pop.onShowPopDialog("gameSet")
    end
end
--公告面板
function CityUILayer.showNotice(sender, eventType)
    if eventType == ccui.TouchEventType.ended then
        pop.onShowPopDialog("gameIntroduce")
    end
end
--道具面板
function CityUILayer.onItems(sender, eventType)
    if eventType == ccui.TouchEventType.canceled then
        if pop.getDialog("propShop") ~= nil and pop.getDialog("propShop"):isVisible() == true then
            return
        end        
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            dd.currentLayer._widget:unSelectBtns(sender)
            pop.onShowPopDialog("propShop", 1)
        end
    end
    if eventType == ccui.TouchEventType.ended then
        dd.currentLayer._widget:unSelectBtns(sender)
        if pop.getDialog("propShop") ~= nil and pop.getDialog("propShop"):isVisible() == true then
            return
        end        
        pop.onShowPopDialog("propShop", 1)
    end
end
function CityUILayer.showUnion(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        dd.mainUI:closePublic(true)
        --if sender.type ~= nil and sender.type == 1 then
            for j=1,dd.mybuilds:rowCount() do
                if dd.mybuilds:getLong(j,"bid") == 15 then
                    onShowBuildsList(dd.mainUI,dd.mybuilds:getLong(j,"pos")) 
                    break
                end
            end
        
    end
end
--联盟面板
function CityUILayer.onAlliance(sender,eventType)
    local function closeCityUp()
        local widget = pop.getDialog("cityUp")
        if widget ~= nil and widget:isVisible() then
            pop.onClosePopDialog("cityUp")
        end
    end
    if eventType == ccui.TouchEventType.canceled then
        if dd.myUnion:getLong(1,"unionid") <= 0 then
            if pop.getDialog("noUnion") ~= nil and pop.getDialog("noUnion"):isVisible() == true then
                return
            end        
        else
            if pop.getDialog("union") ~= nil and pop.getDialog("union"):isVisible() == true then
                return
            end        
        end            
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            if dd.myUnion:getLong(1,"unionid") <= 0 then
                closeCityUp()
                dd.mainUI:closePublic(true)
                dd.currentLayer._widget:unSelectBtns(sender)
                pop.onShowPopDialog("noUnion",1)
            else
                closeCityUp()
                dd.mainUI:closePublic(true)
                dd.currentLayer._widget:unSelectBtns(sender)
                pop.onShowPopDialog("union",1)
            end
        end
    end

    if eventType==ccui.TouchEventType.ended then
        dd.currentLayer._widget:unSelectBtns(sender)
        if dd.myUnion:getLong(1,"unionid") <= 0 then
            if pop.getDialog("noUnion") ~= nil and pop.getDialog("noUnion"):isVisible() == true then
                return
            end        
        else
            if pop.getDialog("union") ~= nil and pop.getDialog("union"):isVisible() == true then
                return
            end        
        end    
        closeCityUp()        
        dd.mainUI:closePublic(true)
        if dd.myUnion:getLong(1,"unionid") <= 0 then
            pop.onShowPopDialog("noUnion",1)
        else
            pop.onShowPopDialog("union",1)
        end
    end
end
--邮件面板
function CityUILayer.onMail(sender,eventType)

    if eventType == ccui.TouchEventType.canceled then
        if pop.getDialog("mail") ~= nil and pop.getDialog("mail"):isVisible() == true then
            return
        end              
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            dd.currentLayer._widget:unSelectBtns(sender)
            pop.onShowPopDialog("mail",2)
        end
    end
    
    if eventType == ccui.TouchEventType.ended then
        dd.currentLayer._widget:unSelectBtns(sender)
        if pop.getDialog("mail") ~= nil and pop.getDialog("mail"):isVisible() == true then
            return
        end             
        --pop.onShowPopDialog("joinMsg")
        pop.onShowPopDialog("mail",2)
    end
end

function CityUILayer.showPeronRank(sender,eventType)
    if eventType == ccui.TouchEventType.canceled then
        if pop.getDialog("personRank") ~= nil and pop.getDialog("personRank"):isVisible() == true then
            return
        end       

        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            dd.currentLayer._widget:unSelectBtns(sender)
            pop.onShowPopDialog("personRank")
        end
    end
    if eventType == ccui.TouchEventType.ended then
        dd.currentLayer._widget:unSelectBtns(sender)
        if pop.getDialog("personRank") ~= nil and pop.getDialog("personRank"):isVisible() == true then
            return
        end       
        pop.onShowPopDialog("personRank")
    end
end

--显示确认提示框
--标题名
--内容
--回调
--是否显示icon
--标题的颜色类型，1是普通2是显示红色
--type = 1表示确定，取消
--type = 2表示确定，tips

function CityUILayer:onShowSure(title,str,callback,icon,color,type,tips)
    if icon == nil then
        icon = false
    end
    if color == nil then
        color = 1
    end
    if type == nil then
        type = 1
    end
    if type == 1 then
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("sure"):setPositionX(231)
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):getChildByName("chu_label"):setString(ff.langString("取消"))
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):loadTextureNormal(dd.getPathFromUI('public/v2/blue_on.png',1))
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):setVisible(true)
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):addTouchEventListener(self.onPopCancel)
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("sure"):addTouchEventListener(self.onPopSure)
    elseif type == 2 then
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("sure"):setPositionX(231)
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):getChildByName("chu_label"):setString(tips)
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):loadTextureNormal(dd.getPathFromUI('public/v2/green.png',1))
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):setVisible(true)
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):addTouchEventListener(self.onPopSure)
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("sure"):addTouchEventListener(self.onPopCancel)
    elseif type == 3 then
        --self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):getChildByName("chu_label"):setString(ff.langString("取消"))
        --self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):loadTextureNormal(dd.getPathFromUI('public/v2/blue_on.png',1))
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("sure"):setPositionX(360)
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):setVisible(false)
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):addTouchEventListener(self.onPopSure)
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("sure"):addTouchEventListener(self.onPopSure)
    end
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("info"):getChildByName("label"):setString(title)
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("info"):getChildByName("info"):setString(str)
    self:getChildByName("besure"):setVisible(true)
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("info"):getChildByName("icon"):setVisible(icon)
    if color == 1 then
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("info"):getChildByName("label"):setColor(cc.c3b(161,175,175))
    else
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("info"):getChildByName("label"):setColor(cc.c3b(255,0,0))
    end
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("info"):requestDoLayout()
    self:getChildByName("besure"):getChildByName("warning"):setPositionY(ff.height/2 +100)
    pop.showPopEffect(5,self:getChildByName("besure"):getChildByName("warning"))
    self._state['callback']=callback
end
function CityUILayer.onPopCancel(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        dd.currentLayer._widget:getChildByName("besure"):setVisible(false) 
    end
end
function CityUILayer.onPopSure(sender,eventType)
    local function endAction()
        if dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:getChildByName("besure"):setVisible(false)
        end    
    end
    if eventType==ccui.TouchEventType.ended then
        dd.currentLayer._widget:getChildByName("besure"):setVisible(false)
        if dd.currentLayer._widget._state['callback'] ~= nil then
            dd.currentLayer._widget._state['callback']()
            dd.currentLayer._widget._state['callback'] = nil
        end            
    end
end

function CityUILayer:UpdateHeChengView()
    if self._state['hecheng'] ~= 0 and self:getChildByName("hecheng"):isVisible() == true then
        local PropsynthersisID = 0
        for i,v in pairs(dd.cfgPropsynthersis) do
            if v['target_id'] == self._state['hecheng'] then
                PropsynthersisID = i
                break
            end
        end
        
        if dd.cfgPropsynthersis[PropsynthersisID] ~= nil then
            local panel = self:getChildByName("hecheng"):getChildByName("warning")
            
            panel:getChildByName("item1"):getChildByName("count"):setString(dd.getToolsCount(self._state['hecheng']))

            if dd.cfgPropsynthersis[PropsynthersisID]['Material1'] > 0 and dd.cfgPropsynthersis[PropsynthersisID]['Material1_num'] > 0 then
                panel:getChildByName("item_1"):getChildByName("count"):setString(dd.getToolsCount(dd.cfgPropsynthersis[PropsynthersisID]['Material1']).."/"..dd.cfgPropsynthersis[PropsynthersisID]['Material1_num'])
                panel:getChildByName("item_1"):requestDoLayout()
            end
            if dd.cfgPropsynthersis[PropsynthersisID]['Material2'] > 0 and dd.cfgPropsynthersis[PropsynthersisID]['Material2_num'] > 0 then
                panel:getChildByName("item_2"):getChildByName("count"):setString(dd.getToolsCount(dd.cfgPropsynthersis[PropsynthersisID]['Material2']).."/"..dd.cfgPropsynthersis[PropsynthersisID]['Material2_num'])
                panel:getChildByName("item_2"):requestDoLayout()
            end
            if dd.cfgPropsynthersis[PropsynthersisID]['Material3'] > 0 and dd.cfgPropsynthersis[PropsynthersisID]['Material3_num'] > 0 then
                panel:getChildByName("item_3"):getChildByName("count"):setString(dd.getToolsCount(dd.cfgPropsynthersis[PropsynthersisID]['Material3']).."/"..dd.cfgPropsynthersis[PropsynthersisID]['Material3_num'])
                panel:getChildByName("item_3"):requestDoLayout()
            end
            
        end
    end
end

function CityUILayer:showHeChengView(PropsynthersisID)
    local index = PropsynthersisID
    if dd.cfgPropsynthersis[index] ~= nil then
        PropsynthersisID = dd.cfgPropsynthersis[index]['target_id']
        self._state['hecheng']=index
        local panel = self:getChildByName("hecheng"):getChildByName("warning")
        panel:getChildByName("item1"):getChildByName("ico"):getChildByName("icon"):loadTexture(dd.getToolsIcon(PropsynthersisID),0)
        panel:getChildByName("item1"):getChildByName("count"):setString(dd.getToolsCount(PropsynthersisID))
        panel:getChildByName("name"):setString(ff.langString(dd.cfgProp[PropsynthersisID]['name'],{dd.cfgProp[PropsynthersisID]['name1_lan']}))
        panel:getChildByName("info"):setString(ff.langString(dd.cfgProp[PropsynthersisID]['tips'],{dd.cfgProp[PropsynthersisID]['tips1_lan']}))
        if dd.cfgPropsynthersis[index]['Material1'] > 0 and dd.cfgPropsynthersis[index]['Material1_num'] > 0 then
            panel:getChildByName("item_1"):getChildByName("ico"):getChildByName("icon"):loadTexture(dd.getToolsIcon(dd.cfgPropsynthersis[index]['Material1']),0)
            panel:getChildByName("item_1"):getChildByName("count"):setString(dd.cfgPropsynthersis[index]['Material1_num'].."/"..dd.getToolsCount(dd.cfgPropsynthersis[index]['Material1']))
            if dd.cfgPropsynthersis[index]['Material1_num'] > dd.getToolsCount(dd.cfgPropsynthersis[index]['Material1']) then
                dd.setContainGLState(panel:getChildByName("item_1"),1)
            else
                dd.setContainGLState(panel:getChildByName("item_1"),2)
            end
        else
            panel:getChildByName("item_1"):getChildByName("ico"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            panel:getChildByName("item_1"):getChildByName("count"):setString("")
            dd.setContainGLState(panel:getChildByName("item_1"),2)
        end
        if dd.cfgPropsynthersis[index]['Material2'] > 0 and dd.cfgPropsynthersis[index]['Material2_num'] > 0 then
            panel:getChildByName("item_2"):getChildByName("ico"):getChildByName("icon"):loadTexture(dd.getToolsIcon(dd.cfgPropsynthersis[index]['Material2']),0)
            panel:getChildByName("item_2"):getChildByName("count"):setString(dd.cfgPropsynthersis[index]['Material2_num'].."/"..dd.getToolsCount(dd.cfgPropsynthersis[index]['Material2']))
            panel:getChildByName("item_2"):requestDoLayout()
            if dd.cfgPropsynthersis[index]['Material2_num'] > dd.getToolsCount(dd.cfgPropsynthersis[index]['Material2']) then
                dd.setContainGLState(panel:getChildByName("item_2"),1)
            else
                dd.setContainGLState(panel:getChildByName("item_2"),2)
            end
        else
            panel:getChildByName("item_2"):getChildByName("ico"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            panel:getChildByName("item_2"):getChildByName("count"):setString("")
            dd.setContainGLState(panel:getChildByName("item_2"),2)
        end
        if dd.cfgPropsynthersis[index]['Material3'] > 0 and dd.cfgPropsynthersis[index]['Material3_num'] > 0 then
            panel:getChildByName("item_3"):getChildByName("ico"):getChildByName("icon"):loadTexture(dd.getToolsIcon(dd.cfgPropsynthersis[index]['Material3']),0)
            panel:getChildByName("item_3"):getChildByName("count"):setString(dd.cfgPropsynthersis[index]['Material3_num'].."/"..dd.getToolsCount(dd.cfgPropsynthersis[index]['Material3']))
            panel:getChildByName("item_3"):requestDoLayout()
            if dd.cfgPropsynthersis[index]['Material3_num'] > dd.getToolsCount(dd.cfgPropsynthersis[index]['Material3']) then
                dd.setContainGLState(panel:getChildByName("item_3"),1)
            else
                dd.setContainGLState(panel:getChildByName("item_3"),2)
            end
        else
            panel:getChildByName("item_3"):getChildByName("ico"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            panel:getChildByName("item_3"):getChildByName("count"):setString("")
            dd.setContainGLState(panel:getChildByName("item_3"),2)
        end
        self:getChildByName("hecheng"):setVisible(true)

        self:getChildByName("hecheng"):getChildByName("warning"):setPositionY(ff.height/2 +100)
        pop.showPopEffect(16,self:getChildByName("hecheng"):getChildByName("warning"))
    else
        self:onShowTips("\t"..ff.langString("配方已过期"))
    end
    

end

function CityUILayer:onShowSureEx(type,goldCount)
    self:getChildByName("besureEx"):getChildByName("root"):setVisible(false)
    self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("label"):setString(ff.langString("糖果派送"))
    self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("sure1"):getChildByName("chu_label"):setString(ff.langString("查看糖果"))
    self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("sure1"):setTag(1)
    AudioEngine.playEffect(ff.sounds[920])
    if type == 1 then
        self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("info"):setVisible(true)
        self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("info1"):setVisible(false)
        local info = self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("info")
        info:getChildByName("info_1"):setString(ff.langString("你小心翼翼得打开糖果，惊喜得发现金币{0}，祝你万圣节快乐。",{goldCount}))
        info:getChildByName("info_0"):setString(ff.langString("赠送")..":")
        info:getChildByName("info"):setString(goldCount)
    elseif type == 2 then
        self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("sure1"):getChildByName("chu_label"):setString(ff.langString("去看看"))
        self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("sure1"):setTag(2)
        self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("info"):setVisible(false)
        self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("info1"):setVisible(true)
        local info = self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("info1")
        info:getChildByName("info"):setString(ff.langString("很遗憾你来晚了，虽然没抢到糖果，但无意间触发了“万圣节惊喜充值”。惊喜充值限时1小时，是否前去看看？"))

    else
        self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("info"):setVisible(false)
        self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("info1"):setVisible(true)
        local info = self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("info1")
        info:getChildByName("info"):setString(ff.langString("很遗憾你来晚了，糖果已经派送完了，下次请手快哦！"))

    end

    self:getChildByName("besureEx"):setVisible(true)
    
    self:getChildByName("besureEx"):getChildByName("warning"):getChildByName("info"):requestDoLayout()
    self:getChildByName("besureEx"):getChildByName("warning"):setPositionY(ff.height/2 +100)
    pop.showPopEffect(5,self:getChildByName("besureEx"):getChildByName("warning"))

end

function CityUILayer:onShowSurePop(type)
    --self:getChildByName("besureEx"):getChildByName("root"):setVisible(false)
    if type ~= 2 then
        local message = ff.net:createMessage()
        message:addCmd(0x0000005b)
        message:addLong(dd.uid)
        message:addLong(dd.BonusLast)
        ff.net:rpc(message,false)      
        self:getChildByName("besureEx"):getChildByName("root"):getChildByName("list"):removeAllChildren(true)
        pop.showPopEffect(5,self:getChildByName("besureEx"):getChildByName("root"))

    else
        dd.currentLayer._widget:getChildByName("besureEx"):setVisible(false) 
        local function callback( )
            dd.currentLayer:runAction(cc.Sequence:create(cc.CallFunc:create(function() dd.MoveMapTo(cc.p(1970,1106),0.5,1) end)))
        end
        if dd.currentLayer._name ~= "CityLayer" then
            dd.yunClose(1)

            --performWithDelay(self, callback, 0.5)
        else
            performWithDelay(self, callback, 0.5)
        end
    end
    
    

end

function CityUILayer.onHeChengPopSure( sender,eventType )
    if eventType==ccui.TouchEventType.ended then
        if dd.currentLayer._widget._state['hecheng'] ~= nil then
            local index = dd.currentLayer._widget._state['hecheng']
            
            cclog("----"..dd.cfgPropsynthersis[index]['target_id'].."="..index)
            if dd.cfgPropsynthersis[index] == nil then
                return
            end
            if dd.cfgPropsynthersis[index]['target_id'] == 1101 and dd.getToolsCount(1101) > 0 then
                dd.mainUI:onShowTips(ff.langString("该道具只可合成一件")) 
                return
            end
            if dd.cfgPropsynthersis[index]['target_id'] == 1102 and dd.getToolsCount(1102) > 0 then
                dd.mainUI:onShowTips(ff.langString("该道具只可合成一件")) 
                return
            end
            if dd.cfgPropsynthersis[index]['Material1'] > 0 and dd.cfgPropsynthersis[index]['Material1_num'] > 0 then
                if dd.getToolsCount(dd.cfgPropsynthersis[index]['Material1']) < dd.cfgPropsynthersis[index]['Material1_num'] then
                    dd.mainUI:onShowTips(ff.langString("材料不足！")) 
                    return
                end
            end
            if dd.cfgPropsynthersis[index]['Material2'] > 0 and dd.cfgPropsynthersis[index]['Material2_num'] > 0 then
                if dd.getToolsCount(dd.cfgPropsynthersis[index]['Material2']) < dd.cfgPropsynthersis[index]['Material2_num'] then
                    dd.mainUI:onShowTips(ff.langString("材料不足！")) 
                    return
                end
            end
            if dd.cfgPropsynthersis[index]['Material3'] > 0 and dd.cfgPropsynthersis[index]['Material3_num'] > 0 then
                if dd.getToolsCount(dd.cfgPropsynthersis[index]['Material3']) < dd.cfgPropsynthersis[index]['Material3_num'] then
                    dd.mainUI:onShowTips(ff.langString("材料不足！")) 
                    return
                end
            end
            local message = ff.net:createMessage()
            message:addCmd(0x0000014a)
            message:addLong(dd.uid)
            message:addLong(index)
            ff.net:rpc(message,false)
            dd.currentLayer._widget:getChildByName("hecheng"):setVisible(false) 
        end    
               
    end
end

function CityUILayer.onPopExCancel(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        dd.currentLayer._widget:getChildByName("besureEx"):setVisible(false) 
    end
end 

function CityUILayer.onPopEx2Cancel(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        dd.currentLayer._widget:getChildByName("besureEx"):getChildByName("root"):setVisible(false) 
    end
end

function CityUILayer.onPopGoCancel(sender,eventType)
    if eventType==ccui.TouchEventType.ended then

        dd.currentLayer._widget:onShowSurePop(sender:getTag())

    end
end

function CityUILayer.onHeChengPopCancel(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        dd.currentLayer._widget:getChildByName("hecheng"):setVisible(false) 
    end
end

--显示提示框
function CityUILayer:onShowTips(str,error,tick)
    local view = self:getChildByName("warning_1")
    local time = 2
    if tick == nil then
        time = 2
    else
        time = tick
    end

    if error == nil then
        view:getChildByName("back1"):setVisible(true)
        view:getChildByName("back2"):setVisible(false)
        AudioEngine.playEffect(ff.sounds[211])
    else
        view:getChildByName("back1"):setVisible(false)
        view:getChildByName("back2"):setVisible(true)
    end

    if self._TipsAction == nil then
        self._TipsAction = sp.SkeletonAnimation:create("images/city/tips.json", "images/city/tips.atlas")
        self._TipsAction:setPositionY(60)
        self._TipsAction:setPositionX(360)
        --self._TipsAction:setAnchorPoint(cc.p(0.5, 0.5))
        self:getChildByName("warning_1"):addChild(self._TipsAction,999,999)
        self._TipsAction:setVisible(false)
    end
    if error == nil then
        self._TipsAction:setVisible(false)
    else
        self._TipsAction:setVisible(true)
        self._TipsAction:setAnimation(0,"lvkuang_animation",false)
        AudioEngine.playEffect(ff.sounds[111]) 
    end
    view:getChildByName("label"):setString(str)
    view:setPositionY(ff.height - 580)    

    cclog("onShowTips...")
    local action = view:getActionByTag(89)
    if action == nil then
        view:setVisible(true)
        action = view:runAction(cc.Sequence:create(cc.DelayTime:create(time),cc.CallFunc:create(self.closeWarning)))
    else        
        view:stopAllActions()
        view:setVisible(true)        
        action = view:runAction(cc.Sequence:create(cc.DelayTime:create(time),cc.CallFunc:create(self.closeWarning)))
    end
end
--显示提示框
function CityUILayer:onShowCodeTips(error)
    if error ~= nil and error == 10 then
        if error == 10 then
            local function sure()
                pop.onShowPopDialog("charge")
            end
            dd.mainUI:onShowSure(ff.langString("金币不足"),ff.langString("充值可以让你立即拥有大量金币.\n是否现在就去?"),sure,true,2,2,ff.langString("充值"))
        end        
    else
        self:onShowTips("\t"..dd.errorCode(error))
    end
end
--显示拆除提示框
function CityUILayer:onShowRemove(pos)
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"pos") == pos then
            local bid   = dd.mybuilds:getLong(i,"bid")
            local level = dd.mybuilds:getLong(i,"level")

            self:getChildByName("sameWarning"):setVisible(false)
            self:getChildByName("addspeed"):setVisible(false)
            self:getChildByName("remove"):setVisible(true)
            local view = self:getChildByName("remove"):getChildByName("view")
            view:getChildByName("title"):setString(ff.langString("拆除建筑{0}",{ff.langString(dd.cfgBuilding[bid]['name'])}).." LV."..level)


            view:getChildByName("tools"):getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/tools/"..dd.cfgProp[1009]['image']..".png",0)
            view:getChildByName("tools"):getChildByName("tips"):setString(ff.langString(dd.cfgProp[1009]['tips'],{dd.cfgProp[1009]['tips1_lan']}))
            view:getChildByName("tools"):getChildByName("count"):getChildByName("label"):setString("0")

            view:getChildByName("tools"):getChildByName("sure"):setTag(pos)
            view:getChildByName("tools"):getChildByName("sure"):getChildByName("label"):setVisible(false)
            view:getChildByName("tools"):getChildByName("sure"):getChildByName("label2"):setVisible(true)
            view:getChildByName("tools"):getChildByName("sure"):getChildByName("icon"):setVisible(true)
            view:getChildByName("tools"):getChildByName("sure"):getChildByName("count"):setVisible(true)
            view:getChildByName("tools"):getChildByName("sure"):getChildByName("count"):setString(dd.cfgProp[1009]['value'])
            view:getChildByName("tools"):getChildByName("sure"):loadTextureNormal(dd.getPathFromUI("public/v2/blue_on.png",1))

            for j=1,dd.mytools:rowCount() do
                if dd.mytools:getLong(j,"tid") == 1009 then
                    if dd.mytools:getLong(j,"count") > 0 then
                        view:getChildByName("tools"):getChildByName("sure"):loadTextureNormal(dd.getPathFromUI("public/v2/normal.png",1))
                        view:getChildByName("tools"):getChildByName("sure"):getChildByName("label"):setVisible(true)
                        view:getChildByName("tools"):getChildByName("sure"):getChildByName("label2"):setVisible(false)
                        view:getChildByName("tools"):getChildByName("sure"):getChildByName("icon"):setVisible(false)
                        view:getChildByName("tools"):getChildByName("sure"):getChildByName("count"):setVisible(false)
                    end    
                    view:getChildByName("tools"):getChildByName("count"):getChildByName("label"):setString("x"..dd.mytools:getLong(j,"count"))                    
                    break
                end
            end
            --拆除建筑时间计算
            local puls = 0
            for k=1,dd.myplus:rowCount() do
                if dd.myplus:getLong(k,"id") == 41 then
                    puls = dd.myplus:getLong(k,"param")
                    break
                end
            end

            local time = 0
            if level >= dd.cfgBuilding[bid]['maxlevel'] then
                time = math.ceil(dd.cfgBuildingUp[bid][level]['time'] * 0.6/((1000 + puls)/1000))
            else
                time = math.ceil(dd.cfgBuildingUp[bid][level]['time'] * 0.6/((1000 + puls)/1000))
            end    

            view:getChildByName("normal"):getChildByName("time"):getChildByName("label"):setString(ff.getLeftTime(time,":"))
            view:getChildByName("normal"):getChildByName("sure"):setTag(pos)
            view:getChildByName("close"):setTouchEnabled(true)

            view:setPositionY(-view:getContentSize().height)
            view:runAction(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,214))))
        end
    end
end

--显示资源补足
--队列类型
--id
--等级
function CityUILayer:onShowBuyRes(type,id,level,callback,py)
    local view = self:getChildByName("addspeed"):getChildByName("view")
    view:stopAllActions()
    
    if dd.myinfo:getLong(1,"level") <= 10 then
        view:getChildByName("res"):getChildByName("res1"):setVisible(false)
        view:getChildByName("res"):getChildByName("res2"):setVisible(false)
        view:getChildByName("res"):getChildByName("stone_need"):setVisible(false)
        view:getChildByName("res"):getChildByName("stone_have"):setVisible(false)
        view:getChildByName("res"):getChildByName("iron_need"):setVisible(false)
        view:getChildByName("res"):getChildByName("iron_have"):setVisible(false)
    elseif dd.myinfo:getLong(1,"level") <= 14 then
        view:getChildByName("res"):getChildByName("res2"):setVisible(true)
        view:getChildByName("res"):getChildByName("res1"):setVisible(false)
        view:getChildByName("res"):getChildByName("stone_need"):setVisible(true)
        view:getChildByName("res"):getChildByName("stone_have"):setVisible(true)
        view:getChildByName("res"):getChildByName("iron_need"):setVisible(false)
        view:getChildByName("res"):getChildByName("iron_have"):setVisible(false)

    else
        view:getChildByName("res"):getChildByName("res2"):setVisible(true)
        view:getChildByName("res"):getChildByName("res1"):setVisible(true)
        view:getChildByName("res"):getChildByName("stone_need"):setVisible(true)
        view:getChildByName("res"):getChildByName("stone_have"):setVisible(true)
        view:getChildByName("res"):getChildByName("iron_need"):setVisible(true)
        view:getChildByName("res"):getChildByName("iron_have"):setVisible(true)
    end

    local lists = view:getChildByName("tools"):getChildByName("lists")
    local gold  = 0

    view:getChildByName("gold"):setVisible(false)
    view:getChildByName("detail"):setVisible(false)
    view:getChildByName("res"):setVisible(true)
    view:getChildByName("detail"):getChildByName("tname"):getVirtualRenderer():enableBold(true)


    local function onClose(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            ff.net:removeEvent(3,dd.Tjf_prop_use)
            ff.net:unbindProperty("wood",301)
            ff.net:unbindProperty("stone",301)
            ff.net:unbindProperty("iron",301)
            ff.net:unbindProperty("food",301)
            ff.net:unbindProperty("silver",301)
            if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
                local view = dd.currentLayer._widget:getChildByName("addspeed")
                view:setVisible(false)
            end                
        end            
    end
    local function selectToolItem(tid)
        local showdetail = true
        local index = 1
        for i,v in ipairs(view:getChildByName("tools"):getChildByName("lists"):getChildren()) do
            v:getChildByName("select"):setSelectedState(false)
            if tid == v:getTag() then
                index = i
            end
        end
        cclog("index:"..index)
        if dd.cfgProp[tid] ~= nil then
            view:getChildByName("detail"):getChildByName("tname"):setString(ff.langString(dd.cfgProp[tid]['name'],{dd.cfgProp[tid]['name1_lan']}))
            view:getChildByName("detail"):getChildByName("info"):setString(ff.langString(dd.cfgProp[tid]['tips'],{dd.cfgProp[tid]['tips1_lan']}))
            view:getChildByName("detail"):getChildByName("sure"):setTag(tid)

            if dd.getToolsCount(tid) > 0 then
                view:getChildByName("detail"):getChildByName("sure"):setBright(true)
                view:getChildByName("detail"):getChildByName("sure"):setTouchEnabled(true)
                view:getChildByName("detail"):getChildByName("sure"):loadTextureNormal(dd.getPathFromUI("public/v2/btn03.png",1))
                view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label"):setVisible(true)
                view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label2"):setVisible(false)
                view:getChildByName("detail"):getChildByName("gold"):setVisible(false)
            else
                if dd.cfgProp[tid]['shop'] == 1 then
                    view:getChildByName("detail"):getChildByName("sure"):loadTextureNormal(dd.getPathFromUI("public/v2/btn02.png",1))
                    view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label2"):setVisible(true)
                    view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label"):setVisible(false)
                    view:getChildByName("detail"):getChildByName("gold"):setVisible(true)
                    view:getChildByName("detail"):getChildByName("gold"):getChildByName("count"):setString(dd.cfgProp[tid]['value'])
                    if dd.gold() >= tonumber(dd.cfgProp[tid]['value']) then
                        view:getChildByName("detail"):getChildByName("gold"):getChildByName("count"):setColor(cc.c3b(161,175,175))
                    else
                        view:getChildByName("detail"):getChildByName("gold"):getChildByName("count"):setColor(cc.c3b(179,4,24))
                    end
                    view:getChildByName("detail"):getChildByName("sure"):setBright(true)
                    view:getChildByName("detail"):getChildByName("sure"):setTouchEnabled(true)
                    view:getChildByName("detail"):getChildByName("gold"):requestDoLayout()
                else
                    view:getChildByName("detail"):getChildByName("sure"):loadTextureNormal(dd.getPathFromUI("public/v2/btn03.png",1))
                    view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label"):setVisible(true)
                    view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label2"):setVisible(false)
                    view:getChildByName("detail"):getChildByName("gold"):setVisible(false)
                    view:getChildByName("detail"):getChildByName("sure"):setBright(false)
                    view:getChildByName("detail"):getChildByName("sure"):setTouchEnabled(false)
                end
            end
        else    
            view:getChildByName("detail"):getChildByName("sure"):setTag(0)
            showdetail = false
        end    
        --检查新手引导
        local function checkGuide()
            GuideControl:GuideCheck()
        end
        local function unShow()
            view:getChildByName("detail"):setVisible(false)
        end
        local xx = view:getChildByName("tools"):getChildByName("lists"):getInnerContainer():getPositionX()
        xx = xx + (index - 1)*144 + 72
        view:getChildByName("detail"):getChildByName("arrow"):setPositionX(xx - 15)

        if view:getChildByName("detail"):isVisible() ~= showdetail then
            if showdetail == true then
                view:getChildByName("detail"):setVisible(true)
                view:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,214))),cc.CallFunc:create(checkGuide)))
            else
                if pop.isLevelShowing(4) == true then
                    py = 0
                else
                    py = 214
                end      
                py = py - 120
                view:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,py))),cc.CallFunc:create(unShow)))
            end
        end        
    end
    local function updateTools(params)
        local code = params[1]
        local tid  = params[2]
        local cur  = params[3]
        if code == 0 and  tid > 0 then
            local item = lists:getChildByTag(tid)
            if item ~= nil then
                item:getChildByName("count"):setString("x"..dd.getToolsCount(tid))
                selectToolItem(tid)
            end    
            GuideControl:GuideCheck()
        end
    end
    ff.net:registerEvent(3,dd.Tjf_prop_use,updateTools)

    local function selectTools(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                sender:setSelectedState(true)
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then
            selectToolItem(sender:getTag())
            if eventType == ccui.TouchEventType.canceled then 
                sender:setSelectedState(true)
            end
        end
    end

    local function onSure(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            local tid = sender:getTag()
            if tid == 0 then
                return
            end

            local count = dd.getToolsCount(tid)
            if count <= 0 then
                if dd.cfgProp[tid] ~= nil and dd.cfgProp[tid]['shop'] == 1 then
                    if dd.gold()< dd.cfgProp[tid]['value'] then
                        self:onShowTips("\t"..ff.langString("您没有足够的金币购买该道具！"))
                        return
                    end
                else
                    self:onShowTips("\t"..ff.langString("您没有这个道具！"))
                    return
                end
            end
            local message = ff.net:createMessage()
            message:addCmd(0x0000010a)
            message:addLong(dd.uid)
            message:addLong(tid)
            message:addLong(1)
            if count > 0 then
                message:addLong(0)
            else
                message:addLong(1)
                AudioEngine.playEffect(ff.sounds[212])
            end
            message:addLong(0)
            ff.net:rpc(message,false)
        end
    end
    local function onResSure(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            if dd.gold() < gold then
                dd.mainUI:onShowCodeTips(10)
            else
                if callback ~= nil then
                    AudioEngine.playEffect(ff.sounds[212])
                    callback()
                end    
                ff.net:removeEvent(3,dd.Tjf_prop_use)
                ff.net:unbindProperty("wood",301)
                ff.net:unbindProperty("stone",301)
                ff.net:unbindProperty("iron",301)
                ff.net:unbindProperty("food",301)
                ff.net:unbindProperty("silver",301)

                if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
                    local view = dd.currentLayer._widget:getChildByName("addspeed")
                    view:setVisible(false)
                end                 
            end    
        end        
    end

    view:getChildByName("close"):addTouchEventListener(onClose)
    view:getChildByName("detail"):getChildByName("sure"):addTouchEventListener(onSure)
    view:getChildByName("res"):getChildByName("sure"):addTouchEventListener(onResSure)

    local function addItem(tid,count)
        if count == nil or count < 0 then
            count = 0
        end
        local item  = view:getChildByName("tools"):getChildByName("item"):clone()
        item:getChildByName("count"):setString("")
        
        if tid > 0 then
            item:getChildByName("count"):setString("x"..count)
            item:getChildByName("select"):getChildByName("icon"):loadTexture(dd.getToolsIcon(tid),0)
            item:getChildByName("select"):setTouchEnabled(true)
            item:getChildByName("select"):setTag(tid)
            item:getChildByName("select"):addTouchEventListener(selectTools)
        else    
            item:getChildByName("select"):setTag(0)
            item:getChildByName("select"):setTouchEnabled(false)
        end
        item:setVisible(true)
        item:setTag(tid)
        lists:addChild(item)    
        lists:refreshView()
    end


    local iron_need  = 0
    local stone_need = 0
    local wood_need  = 0
    local food_need  = 0
    local silver_need= 0
    local tool_need  = 0

    local iron_have  = 0
    local stone_have = 0
    local wood_have  = 0
    local food_have  = 0
    local silver_have= 0
    local tool_have  = 0

    if type == 1 or type == 13 then
        view:getChildByName("tips"):setString(ff.langString("建造资源不足"))
        stone_need = dd.cfgBuildingUp[id][level]['stone']
        iron_need  = dd.cfgBuildingUp[id][level]['iron']
        wood_need  = dd.cfgBuildingUp[id][level]['wood']
        food_need  = dd.cfgBuildingUp[id][level]['food']
        silver_need  = dd.cfgBuildingUp[id][level]['silver']
        tool_need  = dd.cfgBuildingUp[id][level]['tcount']
        tool_have  = dd.getToolsCount(dd.cfgBuildingUp[id][level]['tid'])
    elseif type == 2 then
        view:getChildByName("tips"):setString(ff.langString("科技研究资源不足"))
        stone_need = dd.cfgTecLv[id]['stone']
        iron_need  = dd.cfgTecLv[id]['iron']
        wood_need  = dd.cfgTecLv[id]['wood']
        food_need  = dd.cfgTecLv[id]['food']
        silver_need  = dd.cfgTecLv[id]['silver']
        tool_need  = 0
    elseif type == 3 then
        view:getChildByName("tips"):setString(ff.langString("士兵训练资源不足"))
        stone_need = dd.cfgSoldier[id]['needStone'] * level
        iron_need  = dd.cfgSoldier[id]['needIron'] * level
        wood_need  = dd.cfgSoldier[id]['needWood'] * level
        food_need  = dd.cfgSoldier[id]['needFood'] * level
        silver_need  = dd.cfgSoldier[id]['needSilver'] * level
        tool_need  = 0
    elseif type == 4 then
        view:getChildByName("tips"):setString(ff.langString("城防建造资源不足"))
        stone_need = dd.cfgSoldier[id]['needStone'] * level
        iron_need  = dd.cfgSoldier[id]['needIron'] * level
        wood_need  = dd.cfgSoldier[id]['needWood'] * level
        food_need  = dd.cfgSoldier[id]['needFood'] * level
        silver_need  = dd.cfgSoldier[id]['needSilver'] * level
        tool_need  = 0
    elseif type == 9 then
        view:getChildByName("tips"):setString(ff.langString("伤病治疗资源不足"))
        local star = dd.cfgSoldier[id]['step']
        local plus_414 = 0
        local plus_416 = 0
        local res_fix = 1
        local silver_fix = 1
        for i=1,dd.myeffect:rowCount() do
            if dd.myeffect:getLong(i,"id") == 414 then
                plus_414 = dd.myeffect:getLong(i,"param")
            elseif dd.myeffect:getLong(i,"id") == 416 then
                plus_416 = dd.myeffect:getLong(i,"param")
            end 
        end         
        if star == 1 then
            res_fix = 0.2*(1-plus_414/1000)*(1-plus_416/1000)
            silver_fix = 0.1*(1-plus_414/1000)*(1-plus_416/1000)
        elseif star == 2 then   
            res_fix = 0.3*(1-plus_414/1000)*(1-plus_416/1000)
            silver_fix = 0.15*(1-plus_414/1000)*(1-plus_416/1000)
        else
            res_fix = 0.4*(1-plus_414/1000)*(1-plus_416/1000)
            silver_fix = 0.2*(1-plus_414/1000)*(1-plus_416/1000)
        end
        stone_need = math.ceil(dd.cfgSoldier[id]['needStone'] * level * res_fix)
        iron_need  = math.ceil(dd.cfgSoldier[id]['needIron'] * level * res_fix)
        wood_need  = math.ceil(dd.cfgSoldier[id]['needWood'] * level * res_fix)
        food_need  = math.ceil(dd.cfgSoldier[id]['needFood'] * level * res_fix)
        silver_need  = math.ceil(dd.cfgSoldier[id]['needSilver'] * level *silver_fix)
        tool_need  = 0
    elseif type == 10 then
        view:getChildByName("tips"):setString(ff.langString("角斗士训练资源不足"))
        stone_need = dd.cfgSoldier[id]['needStone'] * level
        iron_need  = dd.cfgSoldier[id]['needIron'] * level
        wood_need  = dd.cfgSoldier[id]['needWood'] * level
        food_need  = dd.cfgSoldier[id]['needFood'] * level
        silver_need  = dd.cfgSoldier[id]['needSilver'] * level
        tool_need  = 0
    elseif type == 11 then
        view:getChildByName("tips"):setString(ff.langString("攻城器械建造资源不足"))
        stone_need = dd.cfgSoldier[id]['needStone'] * level
        iron_need  = dd.cfgSoldier[id]['needIron'] * level
        wood_need  = dd.cfgSoldier[id]['needWood'] * level
        food_need  = dd.cfgSoldier[id]['needFood'] * level
        silver_need  = dd.cfgSoldier[id]['needSilver'] * level
        tool_need  = 0
    end
    view:getChildByName("res"):getChildByName("iron_need"):setString(dd.showKM(iron_need,5).."/")
    view:getChildByName("res"):getChildByName("stone_need"):setString(dd.showKM(stone_need,5).."/")
    view:getChildByName("res"):getChildByName("wood_need"):setString(dd.showKM(wood_need,5).."/")
    view:getChildByName("res"):getChildByName("food_need"):setString(dd.showKM(food_need,5).."/")
    view:getChildByName("res"):getChildByName("silver_need"):setString(dd.showKM(silver_need,5).."/")
    if tool_need > 0 then
        view:getChildByName("res"):getChildByName("res8"):setVisible(true)
        view:getChildByName("res"):getChildByName("tool_need"):setVisible(true)
        view:getChildByName("res"):getChildByName("tool_have"):setVisible(true)

        view:getChildByName("res"):getChildByName("res8"):setString(ff.langString(dd.cfgProp[dd.cfgBuildingUp[id][level]['tid']]['name'],{dd.cfgProp[dd.cfgBuildingUp[id][level]['tid']]['name1_lan']}))
        view:getChildByName("res"):getChildByName("tool_need"):setString(tool_need.."/")
        view:getChildByName("res"):getChildByName("tool_have"):setString(tool_have)
    else
        view:getChildByName("res"):getChildByName("res8"):setVisible(false)
        view:getChildByName("res"):getChildByName("tool_need"):setVisible(false)
        view:getChildByName("res"):getChildByName("tool_have"):setVisible(false)
    end


    local function updateGold()
        if dd.iron() >= iron_need then
            view:getChildByName("res"):getChildByName("iron_have"):setColor(cc.c3b(0,255,0))
        else
            view:getChildByName("res"):getChildByName("iron_have"):setColor(cc.c3b(255,0,0))
        end
        view:getChildByName("res"):getChildByName("iron_have"):setString(dd.showKM(dd.iron(),5))

        if dd.stone() >= stone_need then
            view:getChildByName("res"):getChildByName("stone_have"):setColor(cc.c3b(0,255,0))
        else
            view:getChildByName("res"):getChildByName("stone_have"):setColor(cc.c3b(255,0,0))
        end
        view:getChildByName("res"):getChildByName("stone_have"):setString(dd.showKM(dd.stone(),5))

        if dd.food() >= food_need then
            view:getChildByName("res"):getChildByName("food_have"):setColor(cc.c3b(0,255,0))
        else
            view:getChildByName("res"):getChildByName("food_have"):setColor(cc.c3b(255,0,0))
        end
        view:getChildByName("res"):getChildByName("food_have"):setString(dd.showKM(dd.food(),5))

        if dd.wood() >= wood_need then
            view:getChildByName("res"):getChildByName("wood_have"):setColor(cc.c3b(0,255,0))
        else
            view:getChildByName("res"):getChildByName("wood_have"):setColor(cc.c3b(255,0,0))
        end
        view:getChildByName("res"):getChildByName("wood_have"):setString(dd.showKM(dd.wood(),5))

        if dd.silver() >= silver_need then
            view:getChildByName("res"):getChildByName("silver_have"):setColor(cc.c3b(0,255,0))
        else
            view:getChildByName("res"):getChildByName("silver_have"):setColor(cc.c3b(255,0,0))
        end
        view:getChildByName("res"):getChildByName("silver_have"):setString(dd.showKM(dd.silver(),5))

        gold = 0
        if dd.stone() < stone_need then
            gold = gold + (stone_need - dd.stone())/dd.stone_lv
        end    
        if dd.iron() < iron_need then
            gold = gold + (iron_need - dd.iron())/dd.iron_lv
        end    
        if dd.food() < food_need then
            gold = gold + (food_need - dd.food())/dd.food_lv
        end    
        if dd.wood() < wood_need then
            gold = gold + (wood_need - dd.wood())/dd.wood_lv
        end    
        if dd.silver() < silver_need then
            gold = gold + (silver_need - dd.silver())/dd.silver_lv
        end    

        if tool_need > 0 then
            if tool_have >= tool_need then
                view:getChildByName("res"):getChildByName("tool_have"):setColor(cc.c3b(0,255,0))
            else
                view:getChildByName("res"):getChildByName("tool_have"):setColor(cc.c3b(255,0,0))
            end
            if tool_have < tool_need then
                gold = gold + (tool_need - tool_have) * dd.cfgProp[dd.cfgBuildingUp[id][level]['tid']]['value']
            end
        end

        gold = math.ceil(gold)

        view:getChildByName("res"):getChildByName("info"):getChildByName("count"):setString(ff.langString("可以使用").." "..ff.getFormatMoney(gold).." ")
        view:getChildByName("res"):getChildByName("info"):refreshView()
        if gold < dd.gold() then
            local effect = ff.Effect:effectGrey()    
            view:getChildByName("res"):getChildByName("sure"):setGLProgramState(effect:getGLProgramState())
        else    
            view:getChildByName("res"):getChildByName("sure"):setGLProgramState(ff.gameCore:getNormalGLState())
        end    
        if gold <= 0 then
            if type == 1 or type == 13 or type == 4 or type == 11 then
                view:getChildByName("res"):getChildByName("sure"):getChildByName("chu_label"):setString(ff.langString("建造"))
            elseif type == 2 then
                view:getChildByName("res"):getChildByName("sure"):getChildByName("chu_label"):setString(ff.langString("研究"))
            elseif type == 3 then
                view:getChildByName("res"):getChildByName("sure"):getChildByName("chu_label"):setString(ff.langString("训练"))
            elseif type == 8 then
                view:getChildByName("res"):getChildByName("sure"):getChildByName("chu_label"):setString(ff.langString("锻造"))
            end
        else
            view:getChildByName("res"):getChildByName("sure"):getChildByName("chu_label"):setString(ff.langString("补足"))
        end
    end
    updateGold()

    local function updateRes()
        view:getChildByName("res"):requestDoLayout()
        updateGold()
    end

    ff.net:bindProperty(301,"wood",updateRes)
    ff.net:bindProperty(301,"stone",updateRes)    
    ff.net:bindProperty(301,"iron",updateRes)    
    ff.net:bindProperty(301,"food",updateRes)    
    ff.net:bindProperty(301,"silver",updateRes)    
    --设置道具
    local lists = view:getChildByName("tools"):getChildByName("lists")
    lists:removeAllChildren(true)
    local params = {stone_need,wood_need,iron_need,food_need,silver_need}
    local need  = {params[1] - dd.stone(),params[2] - dd.wood(),params[3] - dd.iron(),params[4] - dd.food(),params[5] - dd.silver()}
    
    local rows = ff.NetTable:create()
    rows:addCol("tid",ff.NET_LONG)
    rows:addCol("count",ff.NET_LONG)

    local join = {}
    local have = true

    while have do
        have = false
        for tp=1,5 do
            local tid   = 0
            local count = 0        
            if need[tp] > 0 then
                for j=1,dd.mytools:rowCount() do
                    if join[dd.mytools:getLong(j,"tid")] == nil then
                        if dd.cfgProp[dd.mytools:getLong(j,"tid")] ~= nil and dd.cfgProp[dd.mytools:getLong(j,"tid")]['showtype'] == tp then
                            tid = dd.mytools:getLong(j,"tid")
                            break
                        end    
                    end
                end
                if tid > 0 then
                    local temp = rows:addRow()
                    rows:setLong(temp,"tid",tid)
                    rows:setLong(temp,"count",dd.getToolsCount(tid))
                    join[tid] = 1
                    have = true
                end 
            end    
        end        
    end

    --设置高度
    if py == nil then
        py = 214
    end    

    if pop.isLevelShowing(1) == true then
        self:getChildByName("addspeed"):setLocalZOrder(6)
    else
        if pop.isLevelShowing(4) == true then
            self:getChildByName("addspeed"):setLocalZOrder(16)
            py = 0
        else
            self:getChildByName("addspeed"):setLocalZOrder(6)
        end      
    end
    py = py - 120

    if rows:rowCount() == 0 then
        view:getChildByName("tools"):setVisible(false)
        view:getChildByName("detail"):setVisible(false)
        py = py - 190
    else
        view:getChildByName("tools"):setVisible(true)
    end       

    local frist = 0
    if GuideControl.curId == 1230 then
        frist = 2013
    end
    if frist > 0 then
        for i=1,rows:rowCount() do
            if tonumber(rows:getString(i,"id")) == frist then
                local count = dd.getToolsCount(tonumber(rows:getString(i,"id")))
                addItem(tonumber(rows:getString(i,"id")),dd.getToolsCount(tonumber(rows:getString(i,"id"))))
            end
        end
    end
    for i=1,rows:rowCount() do
        if tonumber(rows:getString(i,"id")) ~= frist then
            local count = dd.getToolsCount(tonumber(rows:getString(i,"id")))
            addItem(rows:getLong(i,"tid"),rows:getLong(i,"count"))
        end
    end
    if rows:rowCount() < 5 then
        for i=rows:rowCount()+1,math.ceil(rows:rowCount()/5)*5 do
            addItem(0,0)
        end
    end
    rows:clear()

    view:requestDoLayout()
    view:getChildByName("res"):requestDoLayout()
    view:getChildByName("close"):setTouchEnabled(true)
  
    local function onStar()
        if lists:getChildrenCount() > 0 then
            GuideControl:GuideCheck()
        end
    end
    if self:getChildByName("addspeed"):isVisible() == false then
        view:setPositionY(-view:getContentSize().height)
        self:getChildByName("addspeed"):setVisible(true)
        view:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,py))),cc.CallFunc:create(onStar)))
    end    
end
--显示加速面板
function CityUILayer:onShowBuyTime(type,callback,py)
    local view = self:getChildByName("addspeed"):getChildByName("view")
    local lists = view:getChildByName("tools"):getChildByName("lists")
    view:stopAllActions()
    local gold  = 0
    cclog("onShowBuyTime:"..type)

    view:getChildByName("gold"):setVisible(true)
    view:getChildByName("res"):setVisible(false)
    view:getChildByName("detail"):setVisible(false)
    view:getChildByName("detail"):getChildByName("tname"):getVirtualRenderer():enableBold(true)

    local function onClose(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            ff.net:removeEvent(4,dd.Tjf_Queue_QueueAction)
            if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
                local view = dd.currentLayer._widget:getChildByName("addspeed")
                view:getChildByName("view"):stopAllActions()
                view:setVisible(false)
            end    
        end            
    end
    local function selectToolItem(tid)
        local showdetail = true
        local index = 1
        for i,v in ipairs(view:getChildByName("tools"):getChildByName("lists"):getChildren()) do
            v:getChildByName("select"):setSelectedState(false)
            if tid == v:getTag() then
                index = i
            end
        end
        cclog("index:"..index)
        if dd.cfgProp[tid] ~= nil then
            view:getChildByName("detail"):getChildByName("tname"):setString(ff.langString(dd.cfgProp[tid]['name'],{dd.cfgProp[tid]['name1_lan']}))
            view:getChildByName("detail"):getChildByName("info"):setString(ff.langString(dd.cfgProp[tid]['tips'],{dd.cfgProp[tid]['tips1_lan']}))
            view:getChildByName("detail"):getChildByName("sure"):setTag(tid)

            if dd.getToolsCount(tid) > 0 then
                view:getChildByName("detail"):getChildByName("sure"):setBright(true)
                view:getChildByName("detail"):getChildByName("sure"):setTouchEnabled(true)
                view:getChildByName("detail"):getChildByName("sure"):loadTextureNormal(dd.getPathFromUI("public/v2/btn03.png",1))
                view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label"):setVisible(true)
                view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label2"):setVisible(false)
                view:getChildByName("detail"):getChildByName("gold"):setVisible(false)
            else
                if dd.cfgProp[tid]['shop'] == 1 then
                    view:getChildByName("detail"):getChildByName("sure"):loadTextureNormal(dd.getPathFromUI("public/v2/btn02.png",1))
                    view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label2"):setVisible(true)
                    view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label"):setVisible(false)
                    view:getChildByName("detail"):getChildByName("gold"):setVisible(true)
                    view:getChildByName("detail"):getChildByName("gold"):getChildByName("count"):setString(dd.cfgProp[tid]['value'])
                    if dd.gold() >= tonumber(dd.cfgProp[tid]['value']) then
                        view:getChildByName("detail"):getChildByName("gold"):getChildByName("count"):setColor(cc.c3b(161,175,175))
                    else
                        view:getChildByName("detail"):getChildByName("gold"):getChildByName("count"):setColor(cc.c3b(179,4,24))
                    end
                    view:getChildByName("detail"):getChildByName("sure"):setBright(true)
                    view:getChildByName("detail"):getChildByName("sure"):setTouchEnabled(true)
                    view:getChildByName("detail"):getChildByName("gold"):requestDoLayout()
                else
                    view:getChildByName("detail"):getChildByName("sure"):loadTextureNormal(dd.getPathFromUI("public/v2/btn03.png",1))
                    view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label"):setVisible(true)
                    view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label2"):setVisible(false)
                    view:getChildByName("detail"):getChildByName("gold"):setVisible(false)
                    view:getChildByName("detail"):getChildByName("sure"):setBright(false)
                    view:getChildByName("detail"):getChildByName("sure"):setTouchEnabled(false)
                end
            end
        else    
            view:getChildByName("detail"):getChildByName("sure"):setTag(0)
            showdetail = false
        end    
        --检查新手引导
        local function checkGuide()
            GuideControl:GuideCheck()
        end
        local function unShow()
            view:getChildByName("detail"):setVisible(false)
        end
        local xx = view:getChildByName("tools"):getChildByName("lists"):getInnerContainer():getPositionX()
        xx = xx + (index - 1)*144 + 72
        view:getChildByName("detail"):getChildByName("arrow"):setPositionX(xx - 15)

        if view:getChildByName("detail"):isVisible() ~= showdetail then
            if showdetail == true then
                view:getChildByName("detail"):setVisible(true)
                view:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,214))),cc.CallFunc:create(checkGuide)))
            else
                if pop.isLevelShowing(4) == true then
                    py = 0
                else
                    py = 214
                end      
                py = py - 120
                view:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,py))),cc.CallFunc:create(unShow)))
            end
        end        
    end



    local function selectTools(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                sender:setSelectedState(true)
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then
            selectToolItem(sender:getTag())
            if eventType == ccui.TouchEventType.canceled then 
                sender:setSelectedState(true)
            end
        end
    end

    local viptick = dd.getRealFreeTick()
    local function updateGold()
        local have = false
        for i=1,dd.mylists:rowCount() do
            if dd.mylists:getLong(i,"type") == type then
                view:getChildByName("tips"):setString(ff.langString("使用黄金加速"))    
                view:getChildByName("gold"):getChildByName("actions"):getChildByName("progress"):getChildByName("time"):setString(ff.getLeftTime(dd.mylists:getLong(i,"end") - dd.getServerTime(),":"))

                --local gold = 0
                if type == 1 or type == 13 or type == 2 then 
                    gold = dd.getRealGoodp(dd.mylists:getLong(i,"end") - dd.getServerTime() - dd.getRealFreeTick())
                else    
                    gold = dd.getRealGoodp(dd.mylists:getLong(i,"end") - dd.getServerTime())    
                end
                if gold < 0 then
                    gold = 0
                end
                if type == 1 or type == 2 or type == 13 then
                    if dd.mylists:getLong(i,"end") - dd.getServerTime() <= viptick then
                        view:getChildByName("gold"):getChildByName("actions"):getChildByName("free"):setVisible(true)
                        view:getChildByName("gold"):getChildByName("actions"):getChildByName("speedup"):setVisible(false)
                    else
                        view:getChildByName("gold"):getChildByName("actions"):getChildByName("free"):setVisible(false)
                        view:getChildByName("gold"):getChildByName("actions"):getChildByName("speedup"):setVisible(true)
                    end
                end

                view:getChildByName("gold"):getChildByName("info"):getChildByName("label"):setString(ff.langString("可以使用").." "..ff.getFormatMoney(gold).." ")    
                view:getChildByName("gold"):getChildByName("info"):refreshView()
                
                local starttime = dd.mylists:getLong(i,"start")
                local endtime   = dd.mylists:getLong(i,"end")
                local curtime   = dd.getServerTime()
                local total     = endtime - starttime
                local now       = curtime - starttime

                local progress  = math.floor(now * 100 / total)
                if progress > 100 then
                    progress = 100
                end
                if progress < 0 then
                    progress = 0
                end

                local xx,yy = view:getChildByName("gold"):getChildByName("actions"):getChildByName("progress"):getChildByName("now"):getPosition()
                view:getChildByName("gold"):getChildByName("actions"):getChildByName("progress"):getChildByName("now"):setPercent(progress)    
                
                if type == 3 or type == 4 or type == 11 then
                    if dd.mylists:getLong(i,"param3") == 1 then
                        have = false
                    else
                        have = true
                    end
                else
                    have = true
                end
                break
            end
        end
        if have == false then
            local function unShow()
                if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
                    local view = dd.currentLayer._widget:getChildByName("addspeed")
                    view:setVisible(false)
                    --guide auther:lhz
                    GuideControl:GuideCheck()
                    --guide end 
                end    
            end    
            if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
                local view = dd.currentLayer._widget:getChildByName("addspeed"):getChildByName("view")
                view:stopAllActions()
                unShow()
                --view:runAction(cc.Sequence:create(cc.MoveTo:create(0.5, cc.p(0,-view:getContentSize().height)),cc.CallFunc:create(unShow)))
            end  
            ff.net:removeEvent(4,dd.Tjf_Queue_QueueAction)
        end    
    end
    updateGold()    

    local function updateTools(params)
        local tid = view:getChildByName("detail"):getChildByName("sure"):getTag()
        if tid > 0 then
            local item = view:getChildByName("tools"):getChildByName("lists"):getChildByTag(tid)
            if item ~= nil then
                item:getChildByName("count"):setString("x"..dd.getToolsCount(tid))
                selectToolItem(tid)
            end
            updateGold()  
            GuideControl:GuideCheck()   
        end
    end
    ff.net:registerEvent(4,dd.Tjf_Queue_QueueAction,updateTools)

    local function onSure(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            local tid = sender:getTag()
            local count = dd.getToolsCount(tid)
            local usetype = 1
            cclog("count:"..count..","..tid)
            if count <= 0 then
                if dd.cfgProp[tid]['shop'] == 1 then
                    if dd.gold()< dd.cfgProp[tid]['value'] then
                        self:onShowTips("\t"..ff.langString("您没有足够的金币购买该道具！"))
                        return
                    else
                        usetype = 2
                    end
                else
                    self:onShowTips("\t"..ff.langString("您没有这个道具！"))
                    return
                end
            end
            local message = ff.net:createMessage()
            message:addCmd(0x00000104)
            message:addLong(dd.uid)
            message:addLong(usetype)
            message:addLong(tid)
            message:addLong(type)
            if usetype == 2 then
                AudioEngine.playEffect(ff.sounds[212])
            end
            ff.net:rpc(message,false)
        end
    end
    local function onResSure(sender,eventType)
        cclog("hhh onResSure:"..gold..","..dd.gold())
        if eventType==ccui.TouchEventType.ended then     
            if dd.gold() < gold then
                --self:onShowTips("\t"..ff.langString("您的黄金不足!"))
                dd.mainUI:onShowCodeTips(10)
            else
                if callback ~= nil then
                    AudioEngine.playEffect(ff.sounds[212])
                    callback()
                end    
                ff.net:removeEvent(4,dd.Tjf_Queue_QueueAction)
                local view = dd.currentLayer._widget:getChildByName("addspeed")
                view:getChildByName("view"):stopAllActions()
                view:setVisible(false)
                --guide auther:lhz
                GuideControl:GuideCheck()
                --guide end
            end    
        end        
    end
    local function onFree(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     

            local message = ff.net:createMessage()
            message:addCmd(0x104)
            message:addLong(dd.uid)
            message:addLong(0)
            message:addLong(0)
            message:addLong(type)
            ff.net:rpc(message,false)

            ff.net:removeEvent(4,dd.Tjf_Queue_QueueAction)
            if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
                local view = dd.currentLayer._widget:getChildByName("addspeed")
                view:getChildByName("view"):stopAllActions()
                view:setVisible(false)
            end                
        end        
    end    


    view:getChildByName("close"):addTouchEventListener(onClose)
    view:getChildByName("detail"):getChildByName("sure"):addTouchEventListener(onSure)
    view:getChildByName("gold"):getChildByName("actions"):getChildByName("speedup"):addTouchEventListener(onResSure)
    view:getChildByName("gold"):getChildByName("actions"):getChildByName("free"):addTouchEventListener(onFree)

    view:getChildByName("gold"):getChildByName("actions"):getChildByName("speedup"):setVisible(true)
    view:getChildByName("gold"):getChildByName("actions"):getChildByName("free"):setVisible(false)

    local function addItem(tid,count)
        if count == nil or count < 0 then
            count = 0
        end

        local item  = view:getChildByName("tools"):getChildByName("item"):clone()
        item:getChildByName("count"):setString("")
        
        if tid > 0 then
            item:getChildByName("count"):setString("x"..count)
            item:getChildByName("select"):getChildByName("icon"):loadTexture(dd.getToolsIcon(tid),0)
            item:getChildByName("select"):setTouchEnabled(true)
            item:getChildByName("select"):setTag(tid)
            item:getChildByName("select"):addTouchEventListener(selectTools)
        else    
            item:getChildByName("select"):setTag(0)
            item:getChildByName("select"):setTouchEnabled(false)
        end
        item:setVisible(true)
        item:setTag(tid)
        lists:addChild(item)    
        lists:refreshView()
    end

    for i=1,dd.mylists:rowCount() do
        if dd.mylists:getLong(i,"type") == type then
            local param1 = dd.mylists:getLong(i,"param1")
            if type == 1 or type == 13 then
                local bid = 0
                for j=1,dd.mybuilds:rowCount() do
                    if dd.mybuilds:getLong(j,"pos") == param1 then
                        bid = dd.mybuilds:getLong(j,"bid")
                        break
                    end
                end
                view:getChildByName("gold"):getChildByName("chu_info"):setString(ff.langString(dd.cfgBuilding[bid]['name']).." LV."..dd.mylists:getLong(i,"param3").." - LV."..dd.mylists:getLong(i,"param4"))
            elseif type == 2 then
                view:getChildByName("gold"):getChildByName("chu_info"):setString(ff.langString(dd.cfgTec[param1]['tec_name']).." LV."..dd.mylists:getLong(i,"param3").." - LV."..dd.mylists:getLong(i,"param4"))
            elseif type == 3 then
                view:getChildByName("gold"):getChildByName("chu_info"):setString(ff.langString(dd.cfgSoldier[param1]['soldierName']).." X"..dd.mylists:getLong(i,"param2"))
            elseif type == 4 then
                view:getChildByName("gold"):getChildByName("chu_info"):setString(ff.langString(dd.cfgSoldier[param1]['soldierName']).." X"..dd.mylists:getLong(i,"param2"))
            elseif type == 8 then
                 for j,v in pairs(dd.cfgEquip) do    

                    if tonumber(dd.cfgEquip[j]['type'])== param1 then
                        view:getChildByName("gold"):getChildByName("chu_info"):setString(ff.langString(dd.cfgEquip[j]['name']).."  "..ff.langString("制作中"))
                        break
                    end
                end
            elseif type == 9 then
                view:getChildByName("gold"):getChildByName("chu_info"):setString(ff.langString("治疗").." "..ff.langString(dd.cfgSoldier[param1]['soldierName']).." X"..dd.mylists:getLong(i,"param2"))
            elseif type == 11 then
                view:getChildByName("gold"):getChildByName("chu_info"):setString(ff.langString(dd.cfgSoldier[param1]['soldierName']).." X"..dd.mylists:getLong(i,"param2"))
            end
            break
        end
    end


    schedule(view, updateGold, 1)
    --设置道具
    lists:removeAllChildren(true)

    local other = 0
    local rows = nil
    if type == 1 or type == 13 then
        other = 32
    elseif type == 2 then
        other = 33
    elseif type == 3 or type == 4 or type == 11 then
        other = 34
    elseif type == 9 then
        other = 35       
    end
    if other <= 0 then
        rows = ff.dbmanager:sql_fetch_rows("select `name`,`tips`,`id`,`showtype`,`showcount` from cfg_props where `showtype`='7' order by `showorder` asc")
    else
        rows = ff.dbmanager:sql_fetch_rows("select `name`,`tips`,`id`,`showtype`,`showcount` from cfg_props where `showtype` in ('7','"..other.."') order by `showorder` asc")
    end
    local index = 1
    for i=1,rows:rowCount() do
        local tid = tonumber(rows:getString(index,"id"))
        local count = dd.getToolsCount(tid)
        if count <= 0 and dd.cfgProp[tid]['shop'] ~= 1 then
            rows:delRow(index)
        else
            index = index + 1
        end
    end    

    --设置高度
    local rowcount = 0
    if rows ~= nil then
        rowcount = rows:rowCount()
        local frist = 0
        if GuideControl.curId == 5020 then
            frist = 3112
        elseif GuideControl.curId == 1360 or GuideControl.curId == 1420 then
            frist = 3111    
        end
        if frist > 0 then
            for i=1,rows:rowCount() do
                if tonumber(rows:getString(i,"id")) == frist then
                    local count = dd.getToolsCount(tonumber(rows:getString(i,"id")))
                    addItem(tonumber(rows:getString(i,"id")),dd.getToolsCount(tonumber(rows:getString(i,"id"))))
                end
            end
        end
        for i=1,rows:rowCount() do
            if tonumber(rows:getString(i,"id")) ~= frist then
                local count = dd.getToolsCount(tonumber(rows:getString(i,"id")))
                addItem(tonumber(rows:getString(i,"id")),dd.getToolsCount(tonumber(rows:getString(i,"id"))))
            end
        end
        rows:clear()
        if rowcount < 5 then
            for i=(rowcount + 1),5 do
                addItem(0,0)
            end
        end
    end    

    --设置高度
    if py == nil then
        py = 214
    end    

    if pop.isLevelShowing(4) == true then
        self:getChildByName("addspeed"):setLocalZOrder(16)
        py = 0
    else
        self:getChildByName("addspeed"):setLocalZOrder(6)
    end      
    py = py - 120

    
    if rowcount == 0 then
        view:getChildByName("tools"):setVisible(false)
        py = py - 190
    else
        view:getChildByName("tools"):setVisible(true)
    end     
    view:requestDoLayout()
    view:getChildByName("close"):setTouchEnabled(true)


    --guide auther:lhz
    local function onStar()
        GuideControl:GuideCheck()
    end
    --guide end
    if self:getChildByName("addspeed"):isVisible() == false then
        view:setPositionY(-view:getContentSize().height)
        self:getChildByName("addspeed"):setVisible(true)
        view:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,py))),cc.CallFunc:create(onStar)))
    end    
end
function CityUILayer:closeMulTools()
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        local view = dd.currentLayer._widget:getChildByName("multools")
        view:setVisible(false)
    end  
    ff.net:removeEvent(4,dd.Tjf_prop_use)
    ff.net:unbindProperty("wood",302)
    ff.net:unbindProperty("stone",302)
    ff.net:unbindProperty("iron",302)
    ff.net:unbindProperty("food",302)
    ff.net:unbindProperty("silver",302)
    GuideControl:GuideCheck()   
end
--显示使用多种道具的面板
function CityUILayer:onShowMulTools(type,value,callback,closenow)
    cclog("the type:"..type)
    local rows = ff.dbmanager:sql_fetch_rows("select `id`,`showtype`,`showcount` from cfg_props where `showtype`='"..type.."' order by `showorder` ")
    local index = 1
    for i=1,rows:rowCount() do
        local tid = tonumber(rows:getString(index,"id"))
        local count = dd.getToolsCount(tid)
        if count <= 0 and dd.cfgProp[tid] ~= nil and dd.cfgProp[tid]['shop'] ~= 1 and tid ~= 1061 then
            rows:delRow(index)
        else
            index = index + 1
        end
    end
    if rows == nil or rows:rowCount() <= 0 then
        --显示跳转界面
        local function sure()
            pop.onShowPopDialog("task")
        end
        if type >= 1 and type <= 5 then
            local str = ""
            if type == 1 then
                str = ff.langString("石油")
            elseif type == 2 then
                str = ff.langString("木材")                
            elseif type == 3 then
                str = ff.langString("钢铁")                
            elseif type == 4 then
                str = ff.langString("粮食")                
            else
                str = ff.langString("银币")   
            end
            self:onShowSure(str.." "..ff.langString("不足"),ff.langString("您没有可以使用的资源道具.\n完成任务可以获得大量资源奖励，是否前往?"),sure,true,2,2,ff.langString("去看看"))
        end
        return
    end

    cclog("onShowMulTools.........:"..type)
    local view = self:getChildByName("multools"):getChildByName("view")
    local lists = view:getChildByName("tools"):getChildByName("lists")
    lists:removeAllChildren(true)
    view:getChildByName("detail"):setVisible(false)

    if closenow == nil then
        closenow = false
    end

    if type <= 5 then
        view:getChildByName("res"):loadTexture(dd.getPathFromUI("public/ic0"..type..".png",1))
        view:getChildByName("res"):setVisible(true)
        view:getChildByName("count"):setVisible(true)
    else
        view:getChildByName("res"):setVisible(false)
        view:getChildByName("count"):setVisible(false)
    end



    local function updateRes()
        if type == 1 then
            view:getChildByName("count"):setString(ff.getFormatMoney(dd.stone()))
        elseif type == 2 then
            view:getChildByName("count"):setString(ff.getFormatMoney(dd.wood()))
        elseif type == 3 then
            view:getChildByName("count"):setString(ff.getFormatMoney(dd.iron()))
        elseif type == 4 then
            view:getChildByName("count"):setString(ff.getFormatMoney(dd.food()))
        elseif type == 5 then
            view:getChildByName("count"):setString(ff.getFormatMoney(dd.silver()))
        end           
    end
    updateRes()
    ff.net:bindProperty(302,"wood",updateRes)
    ff.net:bindProperty(302,"stone",updateRes)    
    ff.net:bindProperty(302,"iron",updateRes)    
    ff.net:bindProperty(302,"food",updateRes)    
    ff.net:bindProperty(302,"silver",updateRes)    


    local function onClose(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            self:closeMulTools()
        end            
    end
    local function selectToolItem(tid)
        local showdetail = true
        local index = 1
        for i,v in ipairs(view:getChildByName("tools"):getChildByName("lists"):getChildren()) do
            v:getChildByName("select"):setSelectedState(false)
            if tid == v:getTag() then
                index = i
            end
        end
        cclog("index:"..index)
        if dd.cfgProp[tid] ~= nil then
            view:getChildByName("detail"):getChildByName("tname"):setString(ff.langString(dd.cfgProp[tid]['name'],{dd.cfgProp[tid]['name1_lan']}))
            view:getChildByName("detail"):getChildByName("info"):setString(ff.langString(dd.cfgProp[tid]['tips'],{dd.cfgProp[tid]['tips1_lan']}))
            view:getChildByName("detail"):getChildByName("sure"):setTag(tid)

            if dd.getToolsCount(tid) > 0 then
                view:getChildByName("detail"):getChildByName("sure"):setBright(true)
                view:getChildByName("detail"):getChildByName("sure"):setTouchEnabled(true)
                view:getChildByName("detail"):getChildByName("sure"):loadTextureNormal(dd.getPathFromUI("public/v2/btn03.png",1))
                view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label"):setVisible(true)
                view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label2"):setVisible(false)
                view:getChildByName("detail"):getChildByName("gold"):setVisible(false)
            else
                if dd.cfgProp[tid]['shop'] == 1 then
                    view:getChildByName("detail"):getChildByName("sure"):loadTextureNormal(dd.getPathFromUI("public/v2/btn02.png",1))
                    view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label2"):setVisible(true)
                    view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label"):setVisible(false)
                    view:getChildByName("detail"):getChildByName("gold"):setVisible(true)
                    view:getChildByName("detail"):getChildByName("gold"):getChildByName("count"):setString(dd.cfgProp[tid]['value'])
                    if dd.gold() >= tonumber(dd.cfgProp[tid]['value']) then
                        view:getChildByName("detail"):getChildByName("gold"):getChildByName("count"):setColor(cc.c3b(161,175,175))
                    else
                        view:getChildByName("detail"):getChildByName("gold"):getChildByName("count"):setColor(cc.c3b(179,4,24))
                    end
                    view:getChildByName("detail"):getChildByName("sure"):setBright(true)
                    view:getChildByName("detail"):getChildByName("sure"):setTouchEnabled(true)
                    view:getChildByName("detail"):getChildByName("gold"):requestDoLayout()
                else
                    view:getChildByName("detail"):getChildByName("sure"):loadTextureNormal(dd.getPathFromUI("public/v2/btn03.png",1))
                    view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label"):setVisible(true)
                    view:getChildByName("detail"):getChildByName("sure"):getChildByName("chu_label2"):setVisible(false)
                    view:getChildByName("detail"):getChildByName("gold"):setVisible(false)
                    view:getChildByName("detail"):getChildByName("sure"):setBright(false)
                    view:getChildByName("detail"):getChildByName("sure"):setTouchEnabled(false)
                end
            end
        else    
            view:getChildByName("detail"):getChildByName("sure"):setTag(0)
            showdetail = false
        end    
        --检查新手引导
        local function checkGuide()
            GuideControl:GuideCheck()
        end
        local function unShow()
            view:getChildByName("detail"):setVisible(false)
        end
        local xx = view:getChildByName("tools"):getChildByName("lists"):getInnerContainer():getPositionX()
        xx = xx + (index - 1)*144 + 72
        view:getChildByName("detail"):getChildByName("arrow"):setPositionX(xx - 15)

        if view:getChildByName("detail"):isVisible() ~= showdetail then
            if showdetail == true then
                view:getChildByName("detail"):setVisible(true)
                if pop.isLevelShowing(4) == true then
                    view:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,0))),cc.CallFunc:create(checkGuide)))
                else
                    view:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,214))),cc.CallFunc:create(checkGuide)))
                end
            else
                if pop.isLevelShowing(4) == true then
                    py = 0
                else
                    py = 214
                end      
                py = py - 120
                view:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,py))),cc.CallFunc:create(unShow)))
            end
        end        
    end
    local function selectTools(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                sender:setSelectedState(true)
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then
            selectToolItem(sender:getTag())
            if eventType == ccui.TouchEventType.canceled then 
                sender:setSelectedState(true)
            end
        end
    end

    local function updateTools(params)
        local code = params[1]
        if code == 0 then
            local tid  = params[2]
            local cur  = params[3]
            if tid > 0 then
                local item = lists:getChildByTag(tid)
                if item ~= nil then
                    item:getChildByName("count"):setString("x"..dd.getToolsCount(tid))
                    selectToolItem(tid)
                end    
            end

            GuideControl:GuideCheck()   
        else
            dd.mainUI:onShowCodeTips(code)
        end
    end

    ff.net:registerEvent(4,dd.Tjf_prop_use,updateTools)    

    local function onSure(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            local tid = sender:getTag()
            if tid == 0 then
                return
            end

            local count = dd.getToolsCount(tid)

            if count <= 0 then
                if dd.cfgProp[tid]['shop'] == 1 then
                    if dd.gold()< dd.cfgProp[tid]['value'] then
                        self:onShowTips("\t"..ff.langString("您没有足够的金币购买该道具！"))
                        return
                    end
                else
                    self:onShowTips("\t"..ff.langString("您没有这个道具！"))
                    return
                end
            end
            if callback ~= nil then
                AudioEngine.playEffect(ff.sounds[212])
                callback(tid)
                self:closeMulTools()
            else    

                if tonumber(dd.cfgProp[tid]['showtype']) == 16  and dd.myinfo:getLong(1,"GeneralPrisonerCnt") > 0 then
                    local function sure()
                        local message = ff.net:createMessage()
                        message:addCmd(0x0000010a)
                        message:addLong(dd.uid)
                        message:addLong(tid)
                        message:addLong(1)
                        if count > 0 then
                            message:addLong(0)
                        else
                            message:addLong(1)
                        end
                        message:addLong(0)
                        ff.net:rpc(message,false)
                    end
                    dd.mainUI:onShowSure(ff.langString("警告"),ff.langString("此时开启保护，将自动释放监狱中所有俘虏，是否仍要开启？"),sure,true,2,2,ff.langString("使用"))
                else
                    local message = ff.net:createMessage()
                    message:addCmd(0x0000010a)
                    message:addLong(dd.uid)
                    message:addLong(tid)
                    message:addLong(1)
                    if count > 0 then
                        message:addLong(0)
                    else
                        message:addLong(1)
                    end
                    message:addLong(0)
                    ff.net:rpc(message,false)
                    AudioEngine.playEffect(ff.sounds[212])
                end
            end
            if closenow == true then
                self:closeMulTools()
            end
        end
    end

    view:getChildByName("close"):addTouchEventListener(onClose)
    view:getChildByName("detail"):getChildByName("sure"):addTouchEventListener(onSure)

    local function addItem(tid,count)
        if count < 0 or count == nil then
            count = 0
        end
        local item  = view:getChildByName("tools"):getChildByName("item"):clone()
        item:getChildByName("count"):setString("")
        
        if tid > 0 then
            item:getChildByName("count"):setString("x"..count)
            item:getChildByName("select"):getChildByName("icon"):loadTexture(dd.getToolsIcon(tid),0)
            item:getChildByName("select"):setTouchEnabled(true)
            item:getChildByName("select"):setTag(tid)
            item:getChildByName("select"):addTouchEventListener(selectTools)
        else    
            item:getChildByName("select"):setTag(0)
            item:getChildByName("select"):setTouchEnabled(false)
        end
        item:setVisible(true)
        item:setTag(tid)
        lists:addChild(item)    
        lists:refreshView()
    end


    if rows ~= nil then
        rowcount = rows:rowCount()
        local frist = 0
        if GuideControl.curId == 6050 then
            frist = 11105
        end
        if frist > 0 then
            for i=1,rows:rowCount() do
                if tonumber(rows:getString(i,"id")) == frist then
                    local count = dd.getToolsCount(tonumber(rows:getString(i,"id")))
                    addItem(tonumber(rows:getString(i,"id")),dd.getToolsCount(tonumber(rows:getString(i,"id"))))
                end
            end
        end
        for i=1,rows:rowCount() do
            if tonumber(rows:getString(i,"id")) ~= frist then
                local count = dd.getToolsCount(tonumber(rows:getString(i,"id")))
                addItem(tonumber(rows:getString(i,"id")),dd.getToolsCount(tonumber(rows:getString(i,"id"))))
            end
        end
        rows:clear()
        if rowcount < 5 then
            for i=(rowcount + 1),5 do
                addItem(0,0)
            end
        end
    end        


    view:requestDoLayout()
    view:getChildByName("close"):setTouchEnabled(true)

    local py = 214
    if pop.isLevelShowing(4) == true then
        self:getChildByName("multools"):setLocalZOrder(14)
        py = 0
    else
        self:getChildByName("multools"):setLocalZOrder(4)
    end  

    --检查新手引导
    local function checkGuide()
        GuideControl:GuideCheck()
    end    
    py = py - 120
    if self:getChildByName("multools"):isVisible() == false then
        view:setPositionY(-view:getContentSize().height)
        self:getChildByName("multools"):setVisible(true)
        view:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,py))),cc.CallFunc:create(checkGuide)))
    end    
end

function CityUILayer:onShowTools()
    if dd.cfgProp[1061] == nil then
        return
    end

    self:getChildByName("tool"):getChildByName("view"):getChildByName("tools"):getChildByName("icon"):loadTexture(dd.getToolsIcon(1061),0)
    self:getChildByName("tool"):getChildByName("view"):getChildByName("count"):setString("X"..dd.getToolsCount(1061) )
    self:getChildByName("tool"):getChildByName("view"):getChildByName("name"):setString(ff.langString(dd.cfgProp[1061]["name"]))
    self:getChildByName("tool"):getChildByName("view"):getChildByName("tips"):setString(ff.langString(dd.cfgProp[1061]["tips"]))
    self:getChildByName("tool"):getChildByName("view"):getChildByName("gold"):setString("500")
    if self:getChildByName("tool"):isVisible() == false then
        self:getChildByName("tool"):setPositionY(-self:getChildByName("tool"):getContentSize().height)
        self:getChildByName("tool"):setVisible(true)
        self:getChildByName("tool"):runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,500)))))
    end    
end



function CityUILayer:onShowSureUseTools(tips,tid,count,callback)
    cclog("onShowSureUseTools.........")
    local view = self:getChildByName("usetools"):getChildByName("view")
    
    --显示
    view:getChildByName("tips"):setString(ff.langString(tips))
    view:getChildByName("tools"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getToolsIcon(tid),0)
    view:getChildByName("tools"):getChildByName("name"):setString(ff.langString(dd.cfgProp[tid]['name'],{dd.cfgProp[tid]['name1_lan']}))
    view:getChildByName("tools"):getChildByName("tips"):setString(ff.langString(dd.cfgProp[tid]['tips'],{dd.cfgProp[tid]['tips1_lan']}))

    
    local have = dd.getToolsCount(tid)
    local function onSure(sender,eventType)
        if eventType==ccui.TouchEventType.ended then   
            if callback ~= nil then
                callback()
            end    
            self.closeUseTools()
        end
    end

    if have < count then
        view:getChildByName("tools"):getChildByName("count"):getChildByName("label"):setColor(cc.c3b(255,0,0))
        view:getChildByName("tools"):getChildByName("sure2"):setVisible(false)
        view:getChildByName("tools"):getChildByName("sure2"):setTouchEnabled(false)
        view:getChildByName("tools"):getChildByName("sure"):setVisible(true)
        view:getChildByName("tools"):getChildByName("sure"):getChildByName("count"):setString(dd.cfgProp[tid]['value'] * (count - have))
        view:getChildByName("tools"):getChildByName("sure"):addTouchEventListener(onSure)
    else
        view:getChildByName("tools"):getChildByName("sure2"):setVisible(true)
        view:getChildByName("tools"):getChildByName("sure2"):setTouchEnabled(true)
        view:getChildByName("tools"):getChildByName("sure"):setVisible(false)
        view:getChildByName("tools"):getChildByName("sure2"):addTouchEventListener(onSure)
        view:getChildByName("tools"):getChildByName("count"):getChildByName("label"):setColor(cc.c3b(84,101,107))
    end
    view:getChildByName("tools"):getChildByName("count"):getChildByName("label"):setString("x"..have)

    local py = 214
    if pop.isLevelShowing(4) == true then
        self:getChildByName("usetools"):setLocalZOrder(14)
        py = 0
    else
        self:getChildByName("usetools"):setLocalZOrder(4)
    end  

    view:getChildByName("close"):setTouchEnabled(true)
    if self:getChildByName("usetools"):isVisible() == false then
        self:getChildByName("usetools"):setVisible(true)
        view:setPositionY(-255)
        view:runAction(cc.MoveTo:create(0.5, cc.p(0,py)))
    end    
end
--使用指定道具
--tips
--道具id
--使用数量
--返回函数 带道具数量参数
function CityUILayer:onShowUseTools(tips,tid,count,callback)
    cclog("onShowUseTools.........")
    local view = self:getChildByName("usetools"):getChildByName("view")
    
    --显示
    view:getChildByName("tips"):setString(ff.langString(tips))
    view:getChildByName("tools"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getToolsIcon(tid),0)
    view:getChildByName("tools"):getChildByName("name"):setString(ff.langString(dd.cfgProp[tid]['name'],{dd.cfgProp[tid]['name1_lan']}))
    view:getChildByName("tools"):getChildByName("tips"):setString(ff.langString(dd.cfgProp[tid]['tips'],{dd.cfgProp[tid]['tips1_lan']}))

    local function onUse(params)
        local code = params[1]
        if code == 0 then
            self.closeUseTools()
            ff.net:removeEvent(5,dd.Tjf_prop_use)
            if callback ~= nil then                
                callback()
            end    
        else
            dd.mainUI:onShowCodeTips(code)
        end    
    end
    ff.net:registerEvent(5,dd.Tjf_prop_use,onUse)
    
    local have = dd.getToolsCount(tid)
    local function onSure(sender,eventType)
        if eventType==ccui.TouchEventType.ended then  
            local message = ff.net:createMessage()
            message:addCmd(0x0000010a)
            message:addLong(dd.uid)
            message:addLong(tid)
            message:addLong(count)
            if dd.getToolsCount(tid) < count then
                message:addLong(1)
            else    
                message:addLong(0)
            end    
            message:addLong(0)
            ff.net:rpc(message,false)
            AudioEngine.playEffect(ff.sounds[212])
        end
    end

    if have < count then
        view:getChildByName("tools"):getChildByName("count"):getChildByName("label"):setColor(cc.c3b(255,0,0))
        view:getChildByName("tools"):getChildByName("sure2"):setVisible(false)
        view:getChildByName("tools"):getChildByName("sure2"):setTouchEnabled(false)
        view:getChildByName("tools"):getChildByName("sure"):setVisible(true)
        view:getChildByName("tools"):getChildByName("sure"):getChildByName("count"):setString(dd.cfgProp[tid]['value'] * (count - have))
        view:getChildByName("tools"):getChildByName("sure"):addTouchEventListener(onSure)
    else
        view:getChildByName("tools"):getChildByName("sure2"):setVisible(true)
        view:getChildByName("tools"):getChildByName("sure2"):setTouchEnabled(true)
        view:getChildByName("tools"):getChildByName("sure"):setVisible(false)
        view:getChildByName("tools"):getChildByName("sure2"):addTouchEventListener(onSure)
        view:getChildByName("tools"):getChildByName("count"):getChildByName("label"):setColor(cc.c3b(84,101,107))
    end
    view:getChildByName("tools"):getChildByName("count"):getChildByName("label"):setString("x"..have)

    view:getChildByName("close"):setTouchEnabled(true)

    local py = 214
    if pop.isLevelShowing(4) == true then
        self:getChildByName("usetools"):setLocalZOrder(14)
        py = 0
    else
        self:getChildByName("usetools"):setLocalZOrder(4)
    end  

    if self:getChildByName("usetools"):isVisible() == false then
        self:getChildByName("usetools"):setVisible(true)
        view:setPositionY(-255)
        local action = view:runAction(cc.MoveTo:create(0.5, cc.p(0,py)))
        action:setTag(89)
    end    
end
--显示相同队列
function CityUILayer:onShowSameQue(type)
    cclog("onShowSameQue:"..type)
    local view = self:getChildByName("sameWarning"):getChildByName("view")
    local animation = view:getChildByName("detail"):getChildByName("tools"):getChildByTag(9999)
    if animation ~= nil then
        animation:removeFromParent(true)
    end
    for i=1,dd.mylists:rowCount() do
        if type == dd.mylists:getLong(i,"type") then
            local param1 = dd.mylists:getLong(i,"param1")
            local param2 = dd.mylists:getLong(i,"param2")
            local param3 = dd.mylists:getLong(i,"param3")
            local param4 = dd.mylists:getLong(i,"param4")

            if type == 1 or type == 13 then                
                local time1 = 0
                local time2 = 0
                local pos1  = 0
                local pos2  = 0
                local row1  = 0
                local row2  = 0
                for j=1,dd.mylists:rowCount() do
                    if dd.mylists:getLong(j,"type") == 1 then
                        time1 = dd.mylists:getLong(j,"end")
                        pos1  = dd.mylists:getLong(j,"param1")
                        row1  = j
                    end
                    if dd.mylists:getLong(j,"type") == 13 then
                        time2 = dd.mylists:getLong(j,"end")
                        pos2  = dd.mylists:getLong(j,"param1")
                        row2  = j
                    end
                end
                
                local pos = 0
                if pos1 > 0 and pos2 == 0 then
                    pos = pos1
                    param3 = dd.mylists:getLong(row1,"param3")
                    param4 = dd.mylists:getLong(row1,"param4")      
                    type = 1              
                elseif pos1 == 0 and pos2 > 0 then
                    pos = pos2
                    param3 = dd.mylists:getLong(row2,"param3")
                    param4 = dd.mylists:getLong(row2,"param4")     
                    type = 13               
                elseif pos1 > 0 and pos2 > 0 then
                    if time1 <= time2 then
                        pos = pos1
                        param3 = dd.mylists:getLong(row1,"param3")
                        param4 = dd.mylists:getLong(row1,"param4")      
                        type = 1              
                    else
                        pos = pos2
                        param3 = dd.mylists:getLong(row2,"param3")
                        param4 = dd.mylists:getLong(row2,"param4")      
                        type = 13              
                    end
                end
                local bid = 0
                for j=1,dd.mybuilds:rowCount() do
                    if dd.mybuilds:getLong(j,"pos") == pos then
                        bid = dd.mybuilds:getLong(j,"bid")
                        break
                    end    
                end
                view:getChildByName("title"):setString(ff.langString("当前有建造项目"))
                
                local image = 0

                image = dd.cfgBuildingUp[bid][1]['image']
                if image > 10 then
                    local str = bid.."_"..(image - 10)
                    local animation = sp.SkeletonAnimation:create("images/builds/"..bid.."/"..str..".json", "images/builds/"..bid.."/"..str..".atlas")
                    animation:setAnimation(0,str.."_animation",true)
                    animation:setAnchorPoint(cc.p(0,0))
                    
                    view:getChildByName("detail"):getChildByName("tools"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                    local xScale = 140/animation:getContentSize().height
                    animation:setScale(xScale)
                    animation:setPosition(80,75)
                    view:getChildByName("detail"):getChildByName("tools"):addChild(animation,9999,9999)
                else
                    local image = cc.Sprite:create(dd.getBuildImage(bid,1))
                    local xScale = 140/image:getContentSize().width
                    image:setScale(xScale)
                    image:setPosition(cc.p(80,75))
                    view:getChildByName("detail"):getChildByName("tools"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                    view:getChildByName("detail"):getChildByName("tools"):addChild(image,9999,9999)
                    --view:getChildByName("detail"):getChildByName("tools"):loadTexture(dd.getBuildImage(bid,1),0)
                end

                --view:getChildByName("detail"):getChildByName("tools"):loadTexture(dd.getBuildImage(bid,1),0)
                if param3 > param4 then
                    view:getChildByName("detail"):getChildByName("label"):setColor(cc.c3b(255,0,0))
                else                    
                    view:getChildByName("detail"):getChildByName("label"):setColor(cc.c3b(183,197,199))
                end
                view:getChildByName("detail"):getChildByName("label"):setString(ff.langString(dd.cfgBuilding[bid]['name']).."  "..param3.."->"..param4)
            elseif type == 2 then
                local tid = param1
                view:getChildByName("title"):setString(ff.langString("当前正有科技在研究"))
                view:getChildByName("detail"):getChildByName("tools"):loadTexture(dd.getTecIcon(tid),0)
                view:getChildByName("detail"):getChildByName("label"):setColor(cc.c3b(183,197,199))
                view:getChildByName("detail"):getChildByName("label"):setString(ff.langString(dd.cfgTec[tid]['tec_name']).."  "..param3.."->"..param4)
            elseif type == 3 then
                local sid = param1
                view:getChildByName("title"):setString(ff.langString("当前正有部队在训练"))
                view:getChildByName("detail"):getChildByName("tools"):loadTexture(dd.getArmyIcon(sid),0)
                view:getChildByName("detail"):getChildByName("label"):setColor(cc.c3b(183,197,199))
                view:getChildByName("detail"):getChildByName("label"):setString(ff.langString(dd.cfgSoldier[sid]['soldierName']).."  x"..param2)
            elseif type == 4 then                
                local sid = param1
                view:getChildByName("title"):setString(ff.langString("当前正有城防在建造"))
                view:getChildByName("detail"):getChildByName("tools"):loadTexture(dd.getArmyIcon(sid),0)
                view:getChildByName("detail"):getChildByName("label"):setColor(cc.c3b(183,197,199))
                view:getChildByName("detail"):getChildByName("label"):setString(ff.langString(dd.cfgSoldier[sid]['soldierName']).."  x"..param2)
            elseif type == 8 then                
                local sid = param1
                view:getChildByName("title"):setString(ff.langString("当前正有装备在锻造"))
                --cclog("================="..sid)
                view:getChildByName("detail"):getChildByName("tools"):loadTexture(dd.getArmIconByType(sid),0)
                view:getChildByName("detail"):getChildByName("label"):setColor(cc.c3b(183,197,199))

                for j,v in pairs(dd.cfgEquip) do    

                    if tonumber(dd.cfgEquip[j]['type'])== sid then
                        view:getChildByName("detail"):getChildByName("label"):setString(ff.langString(dd.cfgEquip[j]['name']).."  "..ff.langString("制作中"))
                        break
                    end
                end
            elseif type == 9 then                
                local sid = param1
                view:getChildByName("title"):setString(ff.langString("当前正有伤兵在治疗"))
                view:getChildByName("detail"):getChildByName("tools"):loadTexture(dd.getArmyIcon(sid),0)
                view:getChildByName("detail"):getChildByName("label"):setColor(cc.c3b(183,197,199))
                view:getChildByName("detail"):getChildByName("label"):setString(ff.langString(dd.cfgSoldier[sid]['soldierName']).."  x"..param2)
            elseif type == 11 then                
                local sid = param1
                view:getChildByName("title"):setString(ff.langString("当前正有攻城武器在建造"))
                view:getChildByName("detail"):getChildByName("tools"):loadTexture(dd.getArmyIcon(sid),0)
                view:getChildByName("detail"):getChildByName("label"):setColor(cc.c3b(183,197,199))
                view:getChildByName("detail"):getChildByName("label"):setString(ff.langString(dd.cfgSoldier[sid]['soldierName']).."  x"..param2)
            end
            view:getChildByName("detail"):getChildByName("actions"):getChildByName("stop"):setTag(type)
            view:getChildByName("detail"):getChildByName("actions"):getChildByName("free"):setTag(type)
            view:getChildByName("detail"):getChildByName("actions"):getChildByName("speedup"):setTag(type)
            view:getChildByName("detail"):getChildByName("actions"):getChildByName("unionhelp"):setTag(type)
            view:getChildByName("detail"):getChildByName("actions"):getChildByName("finish"):setTag(type)
            view:getChildByName("close"):setTouchEnabled(true)

            self:getChildByName("sameWarning"):setVisible(true)
            self:getChildByName("addspeed"):setVisible(false)
            self:getChildByName("remove"):setVisible(false)

            local btns = self:getChildByName("sameWarning"):getChildByName("view"):getChildByName("detail")
            btns:getChildByName("actions"):getChildByName("free"):addTouchEventListener(self.onFree)
            btns:getChildByName("actions"):getChildByName("speedup"):addTouchEventListener(self.onGoldSpeed)
            btns:getChildByName("actions"):getChildByName("unionhelp"):addTouchEventListener(self.onUnionHelp)
            btns:getChildByName("actions"):getChildByName("stop"):addTouchEventListener(self.onStop)
            btns:getChildByName("actions"):getChildByName("finish"):addTouchEventListener(self.onFinish)

            local py = 214
            if pop.isLevelShowing(4) == true then
                self:getChildByName("sameWarning"):setLocalZOrder(14)
                py = 0
            else
                self:getChildByName("sameWarning"):setLocalZOrder(4)
            end  

            view:setPositionY(-view:getContentSize().height)
            view:runAction(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,py))))
            self:showSameQueAction()
            break
        end
    end
end
function CityUILayer:showSameQueAction()
    if self:getChildByName("sameWarning"):isVisible() == true then
        local type = self:getChildByName("sameWarning"):getChildByName("view"):getChildByName("detail"):getChildByName("actions"):getChildByName("speedup"):getTag()
        for i=1,dd.mylists:rowCount() do
            if dd.mylists:getLong(i,"type") == type then
                local starttime = dd.mylists:getLong(i,"start")
                local endtime   = dd.mylists:getLong(i,"end")
                local curtime   = dd.getServerTime()
                local total     = endtime - starttime
                local now       = curtime - starttime

                local detail = self:getChildByName("sameWarning"):getChildByName("view"):getChildByName("detail")
                detail:getChildByName("actions"):getChildByName("progress"):getChildByName("time"):setString(ff.getLeftTime((total - now),":"))

                local progress  = math.floor(now * 100 / total)
                if progress > 100 then
                    progress = 100
                end
                if progress < 0 then
                    progress = 0
                end
                detail:getChildByName("actions"):getChildByName("progress"):getChildByName("back"):getChildByName("progress"):setPercent(progress)    

                --按钮
                detail:getChildByName("actions"):getChildByName("speedup"):setVisible(false)
                detail:getChildByName("actions"):getChildByName("unionhelp"):setVisible(false)
                detail:getChildByName("actions"):getChildByName("free"):setVisible(false)
                detail:getChildByName("actions"):getChildByName("finish"):setVisible(false)

                local btns = self:getChildByName("sameWarning"):getChildByName("view"):getChildByName("detail")
                if type == 1 or type == 2 or type == 13 then
                    btns:getChildByName("actions"):getChildByName("stop"):addTouchEventListener(self.onStopBuilding)
                    if (total - now) > dd.getRealFreeTick() then
                        if dd.myUnion:getLong(1,"unionid") > 0 and dd.myHelper[type] == -1 then
                            detail:getChildByName("actions"):getChildByName("unionhelp"):setVisible(true)
                        else
                            detail:getChildByName("actions"):getChildByName("speedup"):setVisible(true)
                        end
                    else
                        detail:getChildByName("actions"):getChildByName("free"):setVisible(true)
                    end
                else
                    if type == 3 or type == 4 or type == 11 then
                        btns:getChildByName("actions"):getChildByName("stop"):addTouchEventListener(self.onArmysStop)
                        if dd.mylists:getLong(i,"param3") == 1 then
                            if type == 3 then
                                detail:getChildByName("actions"):getChildByName("finish"):getChildByName("label"):setString(ff.langString("入伍"))
                            else
                                detail:getChildByName("actions"):getChildByName("finish"):getChildByName("label"):setString(ff.langString("验收"))
                            end
                            detail:getChildByName("actions"):getChildByName("finish"):setVisible(true)
                        else
                            detail:getChildByName("actions"):getChildByName("finish"):getChildByName("label"):setString(ff.langString("已完成"))
                            detail:getChildByName("actions"):getChildByName("speedup"):setVisible(true)
                        end
                    else
                        detail:getChildByName("actions"):getChildByName("speedup"):setVisible(true)
                    end
                end    
                return
            end
        end
        --自动关闭界面
        self.closeSameWarning()
    end
end
function CityUILayer:haveSameQue(type)
    for i=1,dd.mylists:rowCount() do
        if dd.mylists:getLong(i,"type") == type then
            return true
        end    
    end
    return false
end
function CityUILayer:onShowQueQueTips(type,id,level)
    cclog("type:"..type.."id:"..id.."level"..level)
    if level <= 0 then
        return
    end
    --司令部升级有特殊界面
    if id == 1 then
        return
    end

    local view = self:getChildByName("warning_2")
    view:getChildByName("sureok"):setVisible(true)

    if type == 1 then
        local animation = view:getChildByName("sureok"):getChildByName("icon"):getChildByTag(9999)
        if animation ~= nil then
            animation:removeFromParent(true)
        end
        local image = 0
        if level == 0 then
            image = dd.cfgBuildingUp[id][1]['image']
        else
            image = dd.cfgBuildingUp[id][level]['image']
        end 
        
        if image > 10 then
            local str = id.."_"..(image - 10)
            local animation = sp.SkeletonAnimation:create("images/builds/"..id.."/"..str..".json", "images/builds/"..id.."/"..str..".atlas")
            animation:setAnimation(0,str.."_animation",true)
            local xScale = 90/animation:getContentSize().height
            animation:setScale(xScale)
            animation:setAnchorPoint(cc.p(0,0))
            animation:setPosition(50,50)
            view:getChildByName("sureok"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            view:getChildByName("sureok"):getChildByName("icon"):addChild(animation,9999,9999)
        else
            view:getChildByName("sureok"):getChildByName("icon"):loadTexture(dd.getBuildImage(id,1),0)
        end
        --view:getChildByName("sureok"):getChildByName("icon"):loadTexture(dd.getBuildImage(id,level),0)
        if level == 1 then
            view:getChildByName("sureok"):getChildByName("label"):setString(ff.langString(dd.cfgBuilding[id]['name']).." "..ff.langString("建造完成!"))
            view:getChildByName("sureok"):getChildByName("level"):setVisible(false)
            view:getChildByName("sureok"):getChildByName("level_image"):setVisible(false)
        else
            view:getChildByName("sureok"):getChildByName("label"):setString(ff.langString(dd.cfgBuilding[id]['name']).." "..ff.langString("升级完成!已经升级到"))
            view:getChildByName("sureok"):getChildByName("level"):setVisible(true)
            view:getChildByName("sureok"):getChildByName("level"):setString(level)
            view:getChildByName("sureok"):getChildByName("level_image"):setVisible(true)
        end    
    elseif type == 2 then
    end    
    if self._TipsAction2 == nil then
        self._TipsAction2 = sp.SkeletonAnimation:create("images/city/tips.json", "images/city/tips.atlas")
        self._TipsAction2:setPositionY(60)
        self._TipsAction2:setPositionX(360)
        self:getChildByName("warning_2"):addChild(self._TipsAction2,999,999)
        self._TipsAction2:setVisible(false)
    end
    self._TipsAction2:setVisible(true)
    self._TipsAction2:setAnimation(0,"lvkuang_animation",false)
    AudioEngine.playEffect(ff.sounds[111]) 
    view:setPositionY(ff.height - 580)    
    view:getChildByName("sureok"):requestDoLayout()

    local action = view:getActionByTag(89)
    if action == nil then
        view:setVisible(true)
        action = view:runAction(cc.Sequence:create(cc.DelayTime:create(2),cc.CallFunc:create(self.closeWarning2)))
    else        
        view:stopAllActions()
        view:setVisible(true)        
        action = view:runAction(cc.Sequence:create(cc.DelayTime:create(2),cc.CallFunc:create(self.closeWarning2)))
    end
end
function CityUILayer.onCloseWarning(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget.closeWarning(sender)
        end    
    end
end
function CityUILayer.onCloseRemove(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget.closeRemove()
        end    
    end
end
function CityUILayer.onCloseAddSpeed(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget.closeAddspeed()
        end    
    end
end

function CityUILayer.onCloseSameWarning(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget.closeSameWarning()
        end    
    end
end
function CityUILayer.onCloseUseTools(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget.closeUseTools()
        end    
    end
end

function CityUILayer.closeRemove()
    local view = dd.currentLayer._widget:getChildByName("remove")
    view:setVisible(false)    
   
end    
function CityUILayer.closeAddspeed()
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        local view = dd.currentLayer._widget:getChildByName("addspeed")
        view:setVisible(false)
    end    
    
end    
function CityUILayer.closeWarning2(sender)
    if sender == nil then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            sender = dd.currentLayer._widget:getChildByName("warning_2")
        end
    end
    if sender == nil then
        return
    end
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        sender:setVisible(false)
        local item = sender:getChildByTag(999)
        if item ~= nil then
            item:setVisible(false)
        end
    end  
    sender:stopAllActions()

    
end  
function CityUILayer.closeWarning(sender)
    if sender == nil then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            sender = dd.currentLayer._widget:getChildByName("warning_1")
        end
    end
    if sender == nil then
        return
    end
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        sender:setVisible(false)
        local item = sender:getChildByTag(999)
        if item ~= nil then
            item:setVisible(false)
        end
    end       
    sender:stopAllActions()
   
end    
function CityUILayer.closeSameWarning()
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        local view = dd.currentLayer._widget:getChildByName("sameWarning")
        view:setVisible(false)
    end    
    
end
function CityUILayer.closeUseTools()
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        local view = dd.currentLayer._widget:getChildByName("usetools")
        view:setVisible(false)
    end    
    
end
function CityUILayer.onSearch(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:showSearch()
        end
    end    
end

function CityUILayer.onJudian(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        if dd.currentLayer._name == "WorldUILayer" then

            if WorldControl:getInstance()._worldUILayer._info ~= nil and next(WorldControl:getInstance()._worldUILayer._info) ~= nil and table.getn(WorldControl:getInstance()._worldUILayer._info) >= 1 then

                if WorldControl:getInstance()._worldUILayer._index > table.getn(WorldControl:getInstance()._worldUILayer._info) then
                    WorldControl:getInstance()._worldUILayer._index = 1
                end
                --cclog("=2222=="..WorldControl:getInstance()._worldUILayer._index.."=="..table.getn(WorldControl:getInstance()._worldUILayer._info))
                local gid = 0
                for i=1,dd.StrongholdCnt do
                    if WorldControl:getInstance()._worldData.Stronghold[i]["id"] == WorldControl:getInstance()._worldUILayer._info[WorldControl:getInstance()._worldUILayer._index]["id"] then
                        gid = WorldControl:getInstance()._worldData.Stronghold[i]["gid1"]
                        break
                    end
                end
                if gid == 0 then
                    for i=1,4 do
                        if WorldControl:getInstance()._worldData.Stronghold2[i]["id"] == WorldControl:getInstance()._worldUILayer._info[WorldControl:getInstance()._worldUILayer._index]["id"] then
                            gid = WorldControl:getInstance()._worldData.Stronghold2[i]["gid1"]
                            break
                        end
                    end
                end
                WorldControl:getInstance()._worldUILayer._index = WorldControl:getInstance()._worldUILayer._index + 1
                --cclog("===="..WorldControl:getInstance()._worldUILayer._index.."=="..gid)
                if gid > 0 then
                    
                    WorldControl:getInstance()._worldUILayer:setSceneCenterByGid(gid - 1,true)
                    --WorldControl:getInstance()._worldUILayer._curMapLayer:showMapItem(gid, cc.p(0, 0))
                end
            end
            
        end
    end    
end

function CityUILayer:closePublic(force)
    if force == nil then
        force = false
    end

    local view = self:getChildByName("addspeed")
    if view:isVisible() == true then
        if view:getChildByName("view"):getActionByTag(89) == nil then
            self.closeAddspeed()
        end
        if force == false then
            return true
        else
            view:getChildByName("view"):stopAllActions()
            view:setVisible(false)
        end
    end
    view = self:getChildByName("sameWarning"):getChildByName("view")
    if self:getChildByName("sameWarning"):isVisible() == true then
        if view:getActionByTag(89) == nil then
            self.closeSameWarning()
        end
        if force == false then
            return true
        else
            view:stopAllActions()
            self:getChildByName("sameWarning"):setVisible(false)
        end
    end
    view = self:getChildByName("remove"):getChildByName("view")
    if self:getChildByName("remove"):isVisible() == true then
        if view:getActionByTag(89) == nil then
            self.closeRemove()
        end
        if force == false then
            return true
        else
            view:stopAllActions()
            self:getChildByName("remove"):setVisible(false)
        end
    end
    view = self:getChildByName("multools"):getChildByName("view")    
    if self:getChildByName("multools"):isVisible() == true then
        if view:getActionByTag(89) == nil then
            self:closeMulTools()
        end
        if force == false then
            return true
        else
            view:stopAllActions()
            self:getChildByName("multools"):setVisible(false)
        end
    end    
    view = self:getChildByName("usetools"):getChildByName("view")
    if self:getChildByName("usetools"):isVisible() == true then
        if view:getActionByTag(89) == nil then
            self.closeUseTools()
        end
        if force == false then
            return true
        else
            view:stopAllActions()
            self:getChildByName("usetools"):setVisible(false)
        end
    end    

    view = pop.getDialog("selectScroll")
    if view ~= nil and view:isVisible() == true then
        view:setVisible(false)
        if force == false then
            return true
        end
    end
    view = self:getChildByName("peek")
    if view:isVisible() == true then
        view:setVisible(false)
        return true
    end

    view = self:getChildByName("besureEx")
    if view:isVisible() == true then
        view:setVisible(false)
        return true
    end
    view = self:getChildByName("hecheng")
    if view:isVisible() == true then
        view:setVisible(false)
        return true
    end
    return false
end
function CityUILayer:showPeek(params,callback)
    self:getChildByName("peek"):setPositionY(0)

    local peek = self:getChildByName("peek"):getChildByName("peek")
    self:getChildByName("peek"):setVisible(true)
    peek:setVisible(true)
    --pop.showPopEffect(5,peek)

    peek:getChildByName("name"):setString(params['name'])
    if params['unionid'] > 0 and params['uname'] ~= nil and params['uname'] ~= "" then
        peek:getChildByName("union"):setString("["..params['short'].."]"..params['uname'])
    else
        peek:getChildByName("union"):setString(ff.langString("无"))
    end
    peek:getChildByName("power"):setString(ff.getFormatMoney(params['power']))
    peek:getChildByName("level"):setString("LV."..params['level'])
    peek:getChildByName("icon"):getChildByName("icon"):loadTexture(params['image'],1)
    
    if dd.silver() < 1000 then
        peek:getChildByName("label5"):setColor(cc.c3b(255,0,0))
        peek:getChildByName("sure"):setTouchEnabled(false)
        peek:getChildByName("sure"):setBright(false)
    else
        peek:getChildByName("label5"):setColor(cc.c3b(255,255,255))
        peek:getChildByName("sure"):setTouchEnabled(true)
        peek:getChildByName("sure"):setBright(true)
    end

    local function closePeek(sender,eventType)
        if eventType==ccui.TouchEventType.ended then
            self:getChildByName("peek"):setVisible(false)
        end
    end
    local function onSure(sender,eventType)
        if eventType==ccui.TouchEventType.ended then
            if callback ~= nil then
                callback()
            end
            self:getChildByName("peek"):setVisible(false)
        end
    end
    peek:getChildByName("close"):addTouchEventListener(closePeek)
    peek:getChildByName("sure"):addTouchEventListener(onSure)
    peek:requestDoLayout()
end



function CityUILayer:showSearch()
    local search = self:getChildByName("search"):getChildByName("search")
    self:getChildByName("search"):setVisible(true)
    search:setVisible(true)

    local input_x = search:getChildByName("input_x")
    local input_y = search:getChildByName("input_y")
    local function editBoxTextEventHandle(strEventName,pSender)
        if strEventName == "began" then
            pSender:setText("")
        elseif strEventName == "ended" or strEventName == "return" then
        elseif strEventName == "changed" then
        end
    end

    if input_x:getChildByTag(109) == nil then
        local editBox = dd.addEditBox(
             input_x
            , input_x:getChildByName("tag_x"):getContentSize()
            , "images/ui/alpha.png"
            , 109
            , cc.p(0,0)
            , cc.p(input_x:getChildByName("tag_x"):getPosition())
            , cc.c3b(255,255,255)
            , 20
            , 2
            , 4
            , 5
            , 4
            , true
            , true
            , true
        )
        input_x:setTag(0)
        editBox:registerScriptEditBoxHandler(editBoxTextEventHandle)
    end
    if input_y:getChildByTag(110) == nil then
        local editBox = dd.addEditBox(
             input_y
            , input_y:getChildByName("tag_y"):getContentSize()
            , "images/ui/alpha.png"
            , 110
            , cc.p(0,0)
            , cc.p(input_y:getChildByName("tag_y"):getPosition())
            , cc.c3b(255,255,255)
            , 20
            , 2
            , 4
            , 1
            , 4
            , true
            , true
            , true
        )
        input_y:setTag(0)
        editBox:registerScriptEditBoxHandler(editBoxTextEventHandle)
    end

    if input_x:getTag() == 0 and input_y:getTag() == 0 then
        local x = (dd.mycity:getLong(1,"cid")-1)%ff.world_maplayerSize.width 
        local y = math.floor((dd.mycity:getLong(1,"cid")-1 - x)/ff.world_maplayerSize.width)
        input_x:setTag(x + 1)
        input_y:setTag(y + 1)
    end
    input_x:getChildByTag(109):setText(input_x:getTag())
    input_y:getChildByTag(110):setText(input_y:getTag())
    pop.showPopEffect(5,search)
end
function CityUILayer.onCloseSearch(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:getChildByName("search"):setVisible(false)
        end
    end  
end
function CityUILayer.onWorldGo(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:getChildByName("search"):setVisible(false)
            dd.currentLayer._widget:worldGo()
        end
    end  
end
function CityUILayer:worldGo()
    cclog("worldGo")
    local x = nil
    local y = nil
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then    
        local xxx = platform_updateInputText(109)
        local tempx = tonumber(xxx)
        if tempx ~= nil and tempx > 0 then
            x = tempx
            cclog("x:"..x)
        end
        local yyy = platform_updateInputText(110)
        local tempy = tonumber(yyy)
        if tempy ~= nil and tempy > 0 then
            y = tempy
            cclog("y:"..y)
        end
    end
    if x == nil then
        x = tonumber(self:getChildByName("search"):getChildByName("search"):getChildByName("input_x"):getChildByTag(109):getText())
    end
    if y == nil then        
        y = tonumber(self:getChildByName("search"):getChildByName("search"):getChildByName("input_y"):getChildByTag(110):getText())
    end
    cclog(self:getChildByName("search"):getChildByName("search"):getChildByName("input_x"):getChildByTag(109):getText())
    cclog(self:getChildByName("search"):getChildByName("search"):getChildByName("input_y"):getChildByTag(110):getText())

    if x == nil then
        return
    else
        self:getChildByName("search"):getChildByName("search"):getChildByName("input_x"):setTag(x)
    end
    if y == nil then
        return
    else
        self:getChildByName("search"):getChildByName("search"):getChildByName("input_y"):setTag(y)
    end
    platform_clearInput()
    cclog("x:"..x..",y:"..y)

    if x<1 then
        x = 1
    end
    if x > ff.world_maplayerSize.width then
        x = ff.world_maplayerSize.width
    end
    if y<1 then
        y = 1
    end
    if y > ff.world_maplayerSize.height then
        y = ff.world_maplayerSize.height
    end
    x = x - 1
    y = y - 1
    local gid = x + y * ff.world_maplayerSize.width + 1
    if dd.worldLayer ~= nil then
        dd.worldLayer:setSceneCenterByGid(gid - 1,true)   
        WorldControl:getInstance():showGid(gid,false)
    end
end

function CityUILayer:showShare(params,isFight)
    local share = self:getChildByName("share")
    if isFight == true then
        share:setLocalZOrder(10)
    else
        share:setLocalZOrder(3)
    end

    

    self:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("label_union"):setColor(cc.c3b(156,166,166))
    self:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("label_friend"):setColor(cc.c3b(156,166,166))
    self:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("label_mail"):setColor(cc.c3b(156,166,166))      
    self:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("label_world"):setColor(cc.c3b(255,255,255))   
    self:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("world_mask"):setVisible(true)
    self:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("alliance_mask"):setVisible(false)
    self:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("friend_mask"):setVisible(false)
    self:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("mail_mask"):setVisible(false)

    self:getChildByName("share"):getChildByName("sure"):setTag(1)

    self:getChildByName("share"):setVisible(true)
    if isFight == false then
        self:getChildByName("share"):getChildByName("info"):getChildByName("icon"):setVisible(true)
        self:getChildByName("share"):getChildByName("info"):getChildByName("Image_654"):setVisible(true)
        self:getChildByName("share"):getChildByName("info"):getChildByName("level"):setVisible(true)
        if params['image'] == "" then
            self:getChildByName("share"):getChildByName("info"):getChildByName("icon"):getChildByName("icon"):loadTexture("world/701.png",1)
        else
            self:getChildByName("share"):getChildByName("info"):getChildByName("icon"):getChildByName("icon"):loadTexture(params['image'],1)
        end
        
        self:getChildByName("share"):getChildByName("info"):getChildByName("tips"):setString(ff.langString(params['sharename']).." ("..(WorldControl:getInstance():getCidStr(params['cid']))..")")
        self:getChildByName("share"):getChildByName("info"):getChildByName("level"):setString("LV."..params['sharelevel'])
        self:getChildByName("share"):getChildByName("info"):getChildByName("Image_656"):setPositionX(429)
    else
        self:getChildByName("share"):getChildByName("info"):getChildByName("icon"):setVisible(false)
        self:getChildByName("share"):getChildByName("info"):getChildByName("Image_654"):setVisible(false)
        self:getChildByName("share"):getChildByName("info"):getChildByName("level"):setVisible(false)
        self:getChildByName("share"):getChildByName("info"):getChildByName("tips"):setString(ff.langString("请选择你要分享的频道"))
        self:getChildByName("share"):getChildByName("info"):getChildByName("Image_656"):setPositionX(360)
    end
    pop.showPopEffect(16,share)


    function onSureShare(sender,eventType)
        if eventType==ccui.TouchEventType.ended then
            if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
                
                pop.onCloseEffect(16,dd.currentLayer._widget:getChildByName("share"))
                local type = 0
                local str  = ""
                if isFight == false then
                    if dd.KSRoom == 0 then
                        str  = params['cid']
                    else
                        str  = -params['cid']
                    end
                    --空地
                    if params['res_type'] == 0 then
                        type = 14
                    elseif params['res_type'] == 1 then
                        type = 13
                        str = str..","..params['res_id']..","..params['res_level']
                    elseif params['res_type'] == 2 then
                        type = 11
                        str = str..","..params['share_uname']..","..params['level']
                    elseif params['res_type'] == 3 then
                        type = 12
                        str = str..","..params['share_uname']..","..params['level']
                    else
                        return
                    end
                else
                    local widget = pop.getDialog('fightRep')
        
                    if widget ~= nil then
                        widget:getChildByName("show"):setVisible(false)
                    end
                    type = 20 
                    str = tostring(params.pos)
                    local isA = 1
                    if dd.uid ~= params.Ainfo:getLong(1,"id") then
                        isA = 2
                    end
                    if isA == 1 then
                        if params.Ainfo:rowCount()>0 then
                            str = str..",".."1,1,"..params.Binfo:getString(1,"name")..","..params.B_union_Name2..","..tostring(params.id)
                        else
                            str = str..",".."0,1,"..params.Binfo:getString(1,"name")..","..params.B_union_Name2..","..tostring(params.id)
                        end
                    else
                        if params.Binfo:rowCount()>0 then
                            str = str..",".."1,2,"..params.Ainfo:getString(1,"name")..","..params.A_union_Name2..","..tostring(params.id)
                        else
                            str = str..",".."0,2,"..params.Ainfo:getString(1,"name")..","..params.A_union_Name2..","..tostring(params.id)
                        end
                    end
                end
                --cclog("ooooooooooooooooo=="..str)
                --cclog("===================="..params['type'])
                

                local table = {}
                table.type = type
                table.number = str
                
                local tag = sender:getTag()
                --世界频道、联盟共享          
                if tag == 1  then
                    local message = ff.net:createMessage()
                    message:addCmd(0xF0C)
                    message:addLong(dd.uid)
                    message:addLong(type)
                    message:addLong(tag)
                    message:addString("",63)
                    message:addString(str,127)
                    message:addLong(0)
                    message:addLong(0)
                    ff.net:rpc(message,false)
                elseif tag ==2 then
                    if dd.myUnion:getLong(1,"unionid") <= 0 then
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("尚未加入联盟"))
                        return
                    else
                        local message = ff.net:createMessage()
                        message:addCmd(0xF0C)
                        message:addLong(dd.uid)
                        message:addLong(type)
                        message:addLong(tag)
                        message:addString("",63)
                        message:addString(str,127)
                        message:addLong(0)
                        message:addLong(0)
                        ff.net:rpc(message,false)
                    end
                elseif tag == 3 then
                    pop.onShowPopDialog("chat",2,table)
                else                    
                    pop.onShowPopDialog("Friend",nil,table)
                end
                
            end
        end
    end
    self:getChildByName("share"):getChildByName("sure"):addTouchEventListener(onSureShare)
end
function CityUILayer.onCloseShare(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            pop.onCloseEffect(99,dd.currentLayer._widget:getChildByName("share"))
            local widget = pop.getDialog('fightRep')
        
            if widget ~= nil then
                widget:getChildByName("show"):setVisible(false)
            end
        end
    end
end


function CityUILayer.selectChannel(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        if dd.currentLayer._widget ~= nil then
            local tag = sender:getTag()
            dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("label_world"):setColor(cc.c3b(156,166,166))
            dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("label_union"):setColor(cc.c3b(156,166,166))
            dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("label_friend"):setColor(cc.c3b(156,166,166))
            dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("label_mail"):setColor(cc.c3b(156,166,166))
        dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("world_mask"):setVisible(false)
        dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("alliance_mask"):setVisible(false)
        dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("friend_mask"):setVisible(false)
        dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("mail_mask"):setVisible(false)


            if tag == 1 then
                dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("label_world"):setColor(cc.c3b(255,255,255))
                dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("world_mask"):setVisible(true)
            elseif tag == 2 then
                dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("label_union"):setColor(cc.c3b(255,255,255))
                dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("alliance_mask"):setVisible(true)
            elseif tag == 3 then
                dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("label_friend"):setColor(cc.c3b(255,255,255))
                dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("friend_mask"):setVisible(true)
            else                
                dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("label_mail"):setColor(cc.c3b(255,255,255))
                dd.currentLayer._widget:getChildByName("share"):getChildByName("channel"):getChildByName("channel"):getChildByName("mail_mask"):setVisible(true)
            end
            dd.currentLayer._widget:getChildByName("share"):getChildByName("sure"):setTag(tag)
        end
    end
end

function CityUILayer:showDangrous(type)
    if type == nil then
        type = 2
    end
    if self._hxd ~= nil then
        self._hxd:removeFromParent(true)
        self._hxd = nil
    end
    if type == 1 then
        if ff.set_warn_help == 0 then
            return
        end
    end
    if type == 2 then
        if ff.set_warn_battle == 0 then
            return
        end
    end
    self._hxd = sp.SkeletonAnimation:create("images/city/hxd.json", "images/city/hxd.atlas")
    local hh = self._hxd:getContentSize().height
    local wh = self:getChildByName("mapArea"):getContentSize().height
    self._hxd:setScale(1,wh/hh)
    self._hxd:setPosition(cc.p(ff.width/2,(wh/2)))
    self:getChildByName("mapArea"):addChild(self._hxd,0,9)
    self._hxd:setAnimation(0,"HXD"..type.."_animation",true)
    
end
function CityUILayer:clearDangrous()
    if self._hxd ~= nil then
        self._hxd:removeFromParent(true)
        self._hxd = nil
    end 
end
