--http 接口
hif = hif or {}

hif._lists = nil
--当前有效入口
hif._row   = 1
hif.post = ""
hif.signature = ""
hif.signedData= ""

function hif.init()
	if hif._lists ~= nil then
		hif._lists:clear()
	end
    hif._lists = ff.NetTable:create()
    hif._lists:addCol("url",ff.NET_STRING,256)
    hif._lists:addCol("type",ff.NET_LONG)
    hif._lists:addCol("tips",ff.NET_STRING,64)
    hif._lists:addCol("ip",ff.NET_STRING,64)
    hif._lists:addCol("port",ff.NET_LONG)
    hif._lists:addCol("server",ff.NET_STRING,128)
    hif._lists:addCol("dbname",ff.NET_STRING,128)
    hif._lists:addCol("pid",ff.NET_LONG)
    hif._lists:addCol("id",ff.NET_LONG)

    --接口检查，
    hif._lists:addRow()
    --hif._lists:setString(1,"url","http://192.168.10.142/zwar/verify.php")
    --hif._lists:setString(1,"server","http://192.168.10.142/zwar/version/version.php")

    hif._lists:setString(1,"url","http://60.191.72.141/zwar/verify.php")
    hif._lists:setString(1,"server","http://60.191.72.141/zwar/version/version.php")
    hif._lists:setLong(1,"type",1)
    hif._lists:setString(1,"tips","alpha测试服务器（内网）")
    hif._lists:setString(1,"ip","192.168.10.4")
    --hif._lists:setString(1,"ip","60.191.28.90")
    hif._lists:setLong(1,"port",8112)
    hif._lists:setString(1,"dbname","z")
    hif._lists:setLong(1,"pid",101)
    hif._lists:setLong(1,"id",1)

    hif._lists:addRow()
    hif._lists:setString(2,"url","http://60.191.72.141/zwar/verify.php")
    hif._lists:setString(2,"server","http://60.191.72.141/zwar/version/version.php")
    hif._lists:setLong(2,"type",1)    
    hif._lists:setString(2,"tips","alpha测试服务器（内网2）")
    hif._lists:setString(2,"ip","192.168.10.4")
    hif._lists:setLong(2,"port",8723)    
    hif._lists:setString(2,"dbname","z")
    hif._lists:setLong(2,"pid",101)
    hif._lists:setLong(2,"id",2)  

    hif._lists:addRow()
    hif._lists:setString(3,"url","http://60.191.72.141/zwar/verify.php")
    hif._lists:setString(3,"server","http://60.191.72.141/zwar/version/version.php")
    hif._lists:setLong(3,"type",1)    
    hif._lists:setString(3,"tips","alpha测试服务器（外网）")
    hif._lists:setString(3,"ip","60.191.28.90")
    hif._lists:setLong(3,"port",8112)    
    hif._lists:setString(3,"dbname","z")
    hif._lists:setLong(3,"pid",101)
    hif._lists:setLong(3,"id",3)    

    hif._lists:addRow()
    hif._lists:setString(4,"url","http://54.149.156.125/verify.php")
    hif._lists:setString(4,"server","http://54.149.156.125/version/version.php")
    hif._lists:setLong(4,"type",3)    
    hif._lists:setString(4,"tips","rc.亚马逊测试服")
    hif._lists:setString(4,"dbname","z")
    hif._lists:setLong(4,"pid",102)
    hif._lists:setLong(4,"id",4)

    hif._lists:addRow()
    hif._lists:setString(5,"url","http://52.24.211.35/zwar/verify.php")
    hif._lists:setString(5,"server","http://52.24.211.35/zwar/version/version.php")
    hif._lists:setLong(5,"type",2)    
    hif._lists:setString(5,"tips","rc.正式服一号入口")
    hif._lists:setString(5,"dbname","z")
    hif._lists:setLong(5,"pid",108)
    hif._lists:setLong(5,"id",5)

    hif._lists:addRow()
    hif._lists:setString(6,"url","http://tjfzwarupdate1.feelingtouch.net/zwar/verify.php")
    hif._lists:setString(6,"server","http://tjfzwarupdate1.feelingtouch.net/zwar/version/version.php")
    hif._lists:setLong(6,"type",2)    
    hif._lists:setString(6,"tips","rc.正式服二号入口")
    hif._lists:setString(6,"dbname","z")
    hif._lists:setLong(6,"pid",108)
    hif._lists:setLong(6,"id",6)


    --bluestack
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local blue = cc.UserDefault:getInstance():getIntegerForKey("blue",0)
        if blue == 1 then
            hif._lists:setString(4,"url","http://54.149.156.125/zwar2/verify.php")
            hif._lists:setString(4,"server","http://54.149.156.125/zwar2/version/version.php")

            hif._lists:setString(5,"url","http://52.88.246.136/zwar2/verify.php")
            hif._lists:setString(5,"server","http://52.88.246.136/zwar2/version/version.php")

            hif._lists:setString(6,"url","http://tjfzwarupdate1.feelingtouch.net/zwar2/verify.php")
            hif._lists:setString(6,"server","http://tjfzwarupdate1.feelingtouch.net/zwar2/version/version.php")
        end
    end    


    if cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then
        hif._lists:setString(1,"url","http://60.191.72.141/zwarios/verify.php")
        hif._lists:setString(1,"server","http://60.191.72.141/zwarios/version/version.php")
        hif._lists:setString(2,"url","http://60.191.72.141/zwarios/verify.php")
        hif._lists:setString(2,"server","http://60.191.72.141/zwarios/version/version.php")
        hif._lists:setString(3,"url","http://60.191.72.141/zwarios/verify.php")
        hif._lists:setString(3,"server","http://60.191.72.141/zwarios/version/version.php")

        hif._lists:setString(4,"url","http://zwartest.dipan.com/verify.php")
        hif._lists:setString(4,"server","http://zwartest.dipan.com/version/version.php")

        hif._lists:setString(5,"url","http://tjfzwariosupdate1.feelingtouch.net/zwarios/verify.php")
        hif._lists:setString(5,"server","http://tjfzwariosupdate1.feelingtouch.net/zwarios/version/version.php")

        hif._lists:setString(6,"url","http://tjfzwariosupdate1.feelingtouch.net/zwarios/verify.php")
        hif._lists:setString(6,"server","http://tjfzwariosupdate1.feelingtouch.net/zwarios/version/version.php")
    end    
    hif._row = 1
end
--优先使用操作系统本省的方法，然后再用curl

function hif.fixReturn(str)
    local index = string.find(str, ",ret:")
    if index == nil then
        return str
    end
    return string.sub(str,index)
end

function hif.doPost(tag,url,cmd)
    print("tag:"..tag..","..url)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        for i=1,hif._lists:rowCount() do
            local post = hif._lists:getString(i,tag)
            local result = platform_doPost(post,url)
            if result ~= "init net error" then
                if tag == "url" then
                    return hif.fixReturn(result)..",row:"..i
                else
                    return result
                end
            end
        end
    end
    print("tag:"..tag)
    if tag == "url" then
        if cmd ~= nil then
            ff.gameCore:getPost(hif._lists,hif._row,url,cmd)
        else
            return hif.fixReturn(ff.gameCore:getPost(hif._lists,hif._row,url))
        end            
    else
        if cmd ~= nil then
            ff.gameCore:getPost(hif._lists:getString(1,"server").."?"..url,cmd)
        else
            return ff.gameCore:getPost(hif._lists:getString(1,"server").."?"..url)
        end           
    end
    return ""
end

function hif.checkLogin(cmd)
    cclog("hif.checkLogin")
    local google     = cc.UserDefault:getInstance():getStringForKey("google","")
    local facebook   = cc.UserDefault:getInstance():getStringForKey("facebook","")
    local gamecenter = cc.UserDefault:getInstance():getStringForKey("gamecenter","")
    cclog("hif.checkLogin:"..google..","..facebook..","..gamecenter)
    --兼容之前版本用
    local login_type = cc.UserDefault:getInstance():getIntegerForKey("login_type")
    if login_type == 4 then
        google = cc.UserDefault:getInstance():getStringForKey("login_id")
    elseif login_type == 5 then
        facebook = cc.UserDefault:getInstance():getStringForKey("login_id")
    elseif login_type == 6 then
        gamecenter = cc.UserDefault:getInstance():getStringForKey("login_id")
    end
    ff.partner = hif._lists:getLong(1,"pid")

	--机器码绑定
	local result = ""
    local sn = ""
    if cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then    
    	local test = cc.UserDefault:getInstance():getIntegerForKey("testacount")
	    if test == 0 then
	    	test = math.floor(math.random() * 1000000)
            cc.UserDefault:getInstance():setIntegerForKey("testacount",test)
	    end   
        sn = ff.mkey..test
    else
        sn = ff.mkey
    end
    local post = "code=loginEx&partner_id="..ff.partner.."&sn="..sn.."&google="..google.."&facebook="..facebook.."&gamecenter="..gamecenter

    if ff.show_loadplayer == true then
        --如果可以，绑定g+
        local alias = cc.UserDefault:getInstance():getStringForKey("login_alias","")
        post = post.."&bg=1&alias="..alias
    else    
        post = post.."&bg=0"
    end

    result = hif.doPost("url",post,cmd)
    if result ~= "" then
        return hif.dealCheckLogin(result)
    end
end
--返回
function hif.dealCheckLogin(result)
	if result == "init net error" then	
		return false
	end
	local tresult = Split(result,",")
    local retcode = {}
    for i=1,table.getn(tresult) do
        local temp = Split(tresult[i],":")
        if table.getn(temp) == 2 then
            if temp[2] == "null" then
                retcode[temp[1]] = ""
            else
                retcode[temp[1]] = temp[2]
            end
        end
    end
    for k,v in pairs(retcode) do
    	print(k,v)
    end
    cclog("hif.checkLogin:"..ff.gameCore:getTick())

    if retcode['ret'] == nil then
        platform_showDialog(ff.langString("网络连接错误"),ff.langString("服务忙，请稍后再试。"),2)
        cclog("网络忙")
        return false
    end

    if retcode['state'] ~= nil and tonumber(retcode['state']) == 99 then
        platform_showDialog(ff.langString("登录错误"),ff.langString("当前服务器维护中，请稍后再试"),2)
        return false
    end    
    
    local ret = tonumber(retcode['ret'])
    if ret ~= 0 then
        if ret == -99999 then
            platform_showDialog(ff.langString("账户异常"),ff.langString("您的账户被禁止登录,请联系GM."),2)
        else
            platform_showDialog(ff.langString("网络连接错误"),ff.langString("服务忙，请稍后再试。"),2)
        end
        return false
    end
    --保存最近一次认证的认证服务器地址
	local row = tonumber(retcode["row"])
    if row < 1 then
        row = 1
    end
    if row > hif._lists:rowCount() then
        row = hif._lists:rowCount()
    end
    hif._row = row
    print("here.......row:"..row..","..hif._lists:getLong(row,"type"))
    cc.UserDefault:getInstance():setIntegerForKey("httpif",hif._row)
    cc.UserDefault:getInstance():getIntegerForKey("login_type",88)

	ff.acount     = tonumber(retcode["id"])
    ff.account_id = tonumber(retcode["account_id"])
	ff.serverid = tonumber(retcode["serverid"])
    ff.partner  = tonumber(retcode["partner_id"])

	ff.addr = retcode["ip"]
	ff.port = retcode["port"]
	ff.gameKey  = retcode["gameKey"]
    ff.email    = retcode["bindemail"]
    ff.set_bind_mail = ff.email
    if string.len(ff.set_bind_mail) > 0 then
        cc.UserDefault:getInstance():setIntegerForKey("isbeing_bind_email",1)
        cc.UserDefault:getInstance():setStringForKey("bind_email_acount",ff.email)
    end
    cc.UserDefault:getInstance():setStringForKey("login_alias",retcode["bindAlias"])
    cc.UserDefault:getInstance():setStringForKey("fb_alias",retcode["fbAlias"])
    cc.UserDefault:getInstance():setStringForKey("gc_alias",retcode["gcAlias"])

    cc.UserDefault:getInstance():setStringForKey("google",retcode["bindName"])
    cc.UserDefault:getInstance():setStringForKey("facebook",retcode["facebook"])
    cc.UserDefault:getInstance():setStringForKey("gamecenter",retcode["gamecenter"])

    --开发用
    if ff.show_servers == true or  cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then
        ff.debug = true
    end
    if hif._lists:getLong(hif._row,"type") == 1 then
        cc.Director:getInstance():setDisplayStats(true)
    end
    if ff.debug == true and hif._lists:getLong(hif._row,"port") > 0 then
  	    ff.addr = hif._lists:getString(hif._row,"ip")
     	ff.port = hif._lists:getLong(hif._row,"port")
    end
	print("ff.addr:"..ff.addr..","..ff.port..","..ff.gameCore:getTick()..","..ff.partner)
	return true
end

function hif.clearAccount()
    local sn = ff.mkey
    if cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then 
        sn = sn..cc.UserDefault:getInstance():getIntegerForKey("testacount")
    end
	local post = "code=clear&partner_id="..ff.partner.."&sn="..sn.."&account_id="..ff.account_id.."&server_id="..ff.serverid
    result = hif.doPost("url",post)

	if result == "init net error" then	
		return false
	end

	local tresult = Split(result,",")
    local retcode = {}
    for i=1,table.getn(tresult) do
        local temp = Split(tresult[i],":")
        if table.getn(temp) == 2 then
            if temp[2] == "null" then
                retcode[temp[1]] = ""
            else
                retcode[temp[1]] = temp[2]
            end
        end
    end
    if tonumber(retcode['ret']) == 0 then
        return true
    end
    return false
end

function hif.bindEmail(email)
    cclog("hif.bindEmail:"..email)
    local sn = ""
    if cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then   
        sn = ff.mkey..cc.UserDefault:getInstance():getIntegerForKey("testacount")
    else
        sn = ff.mkey
    end
    local post = "code=mail&partner_id="..ff.partner.."&sn="..sn.."&email="..email.."&account_id="..ff.account_id
    result = hif.doPost("url",post)

    if result == "init net error" then  
        return -11
    end
    local tresult = Split(result,",")
    local retcode = {}
    for i=1,table.getn(tresult) do
        local temp = Split(tresult[i],":")
        if table.getn(temp) == 2 then
            if temp[2] == "null" then
                retcode[temp[1]] = ""
            else
                retcode[temp[1]] = temp[2]
            end
        end
    end
    if retcode['ret'] == nil then
        return -11
    end
    if tonumber(retcode['ret']) == 0 then
        cc.UserDefault:getInstance():setIntegerForKey("isbeing_bind_email",1)
        cc.UserDefault:getInstance():setStringForKey("bind_email_acount",email)
        ff.set_bind_mail = email
        ff.email = email
        return 0
    end
    return tonumber(retcode['ret'])
end
function hif.unbindGoolePlus(type)
    local sn = ff.mkey
    if cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then   
        sn = ff.mkey..cc.UserDefault:getInstance():getIntegerForKey("testacount")
    end
    local post = "code=unbindEx&partner_id="..ff.partner.."&sn="..sn.."&account_id="..ff.account_id.."&type="..type
    if type == 4 then
        post = post.."&id="..cc.UserDefault:getInstance():getStringForKey("google","")
    elseif type == 5 then
        post = post.."&id="..cc.UserDefault:getInstance():getStringForKey("facebook","")
    else
        post = post.."&id="..cc.UserDefault:getInstance():getStringForKey("gamecenter","")
    end
    local result = hif.doPost("url",post)
    cclog("result:"..result)
    if result == "init net error" then  
        return -101
    end
    local tresult = Split(result,",")
    local retcode = {}
    for i=1,table.getn(tresult) do
        local temp = Split(tresult[i],":")
        if table.getn(temp) == 2 then
            if temp[2] == "null" then
                retcode[temp[1]] = ""
            else
                retcode[temp[1]] = temp[2]
            end
        end
    end
    local ret = tonumber(retcode['ret'])
    if ret == 0 then
        if type == 4 then
            cc.UserDefault:getInstance():setStringForKey("login_alias","")
            cc.UserDefault:getInstance():setStringForKey("google","")
        elseif type == 5 then    
            cc.UserDefault:getInstance():setStringForKey("fb_alias","")
            cc.UserDefault:getInstance():setStringForKey("facebook","")
        else
            cc.UserDefault:getInstance():setStringForKey("gc_alias","")
            cc.UserDefault:getInstance():setStringForKey("gamecenter","")
        end
    end
    return ret
end
function hif.bindGooglePlus(type,account,alias)
	--cclog("hif.bindGooglePlus:"..type..","..account..","..alias)
    local sn = ff.mkey
    if cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then 
        sn = sn..cc.UserDefault:getInstance():getIntegerForKey("testacount")
    end

    local post = "code=bindEx&type="..type.."&account_id="..ff.account_id.."&partner_id="..ff.partner.."&sn="..sn.."&id="..account.."&alias="..alias
    local result = hif.doPost("url",post)
    cclog("result:"..result)
    if result == "init net error" then  
        return -3
    end
    local tresult = Split(result,",")
    local retcode = {}
    for i=1,table.getn(tresult) do
        local temp = Split(tresult[i],":")
        if table.getn(temp) == 2 then
            if temp[2] == "null" then
                retcode[temp[1]] = ""
            else
                retcode[temp[1]] = temp[2]
            end
        end
    end
    if retcode['ret'] == nil then
        return -2
    end
    cclog("ret:"..retcode['ret'])
    if tonumber(retcode['ret']) == 0 then
        if type == 4 then
            cc.UserDefault:getInstance():setStringForKey("login_alias",alias)
            cc.UserDefault:getInstance():setStringForKey("google",account)
        elseif type == 5 then    
            cc.UserDefault:getInstance():setStringForKey("fb_alias",alias)
            cc.UserDefault:getInstance():setStringForKey("facebook",account)
        else    
            cc.UserDefault:getInstance():setStringForKey("gc_alias",alias)
            cc.UserDefault:getInstance():setStringForKey("gamecenter",account)
        end
        return 0
    end
    return tonumber(retcode['ret'])
end
function hif.checkGooglePlus(type,account,alias)
    print("hif.checkGooglePlus:"..account..","..alias)
    local login_name = account
    local login_alias = alias

    local sn = ff.mkey
    if cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then 
        sn = sn..cc.UserDefault:getInstance():getIntegerForKey("testacount")
    end

    local post = "code=check&partner_id="..ff.partner.."&sn="..sn.."&bind_name="..login_name.."&alias_name="..login_alias
    if type == 5 then
        post = "code=fbcheck&partner_id="..ff.partner.."&sn="..sn.."&bind_name="..login_name.."&alias_name="..login_alias
    elseif type == 6 then    
        post = "code=gccheck&partner_id="..ff.partner.."&sn="..sn.."&bind_name="..login_name.."&alias_name="..login_alias
    end
    result = hif.doPost("url",post)
    print("result:"..result)

    if result == "init net error" then  
        return -3
    end
    local tresult = Split(result,",")
    local retcode = {}
    for i=1,table.getn(tresult) do
        local temp = Split(tresult[i],":")
        if table.getn(temp) == 2 then
            if temp[2] == "null" then
                retcode[temp[1]] = ""
            else
                retcode[temp[1]] = temp[2]
            end
        end
    end
    if retcode['ret'] == nil then
        return -2
    end
    print("ret:"..retcode['ret']..","..type..","..account..","..alias)
    if tonumber(retcode['ret']) == 0 then
        if type == 4 then
            cc.UserDefault:getInstance():setStringForKey("google",account)
            cc.UserDefault:getInstance():setStringForKey("login_alias",alias)

            cc.UserDefault:getInstance():setStringForKey("facebook","")
            cc.UserDefault:getInstance():setStringForKey("fb_alias","")
            cc.UserDefault:getInstance():setStringForKey("gamecenter","")
            cc.UserDefault:getInstance():setStringForKey("gc_alias","")

        elseif type == 5 then
            cc.UserDefault:getInstance():setStringForKey("facebook",account)
            cc.UserDefault:getInstance():setStringForKey("fb_alias",alias)

            cc.UserDefault:getInstance():setStringForKey("gamecenter","")
            cc.UserDefault:getInstance():setStringForKey("gc_alias","")
            cc.UserDefault:getInstance():setStringForKey("google","")
            cc.UserDefault:getInstance():setStringForKey("login_alias","")

        elseif type == 6 then
            cc.UserDefault:getInstance():setStringForKey("gamecenter",account)
            cc.UserDefault:getInstance():setStringForKey("gc_alias",alias)

            cc.UserDefault:getInstance():setStringForKey("google","")
            cc.UserDefault:getInstance():setStringForKey("login_alias","")
            cc.UserDefault:getInstance():setStringForKey("facebook","")
            cc.UserDefault:getInstance():setStringForKey("fb_alias","")
        end
        return 0
    end
    return tonumber(retcode['ret'])
end
function hif.getServerList()
    local result = ""
    local test = cc.UserDefault:getInstance():getIntegerForKey("testacount")
    local post = "code=list&partner_id="..ff.partner.."&sn="
    if cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then 
        local test = cc.UserDefault:getInstance():getIntegerForKey("testacount")
        if test == 0 then
            test = math.floor(math.random() * 1000000)
            cc.UserDefault:getInstance():setIntegerForKey("testacount",test)
        end   
        post = post..(ff.mkey..test)
    else
        post = post..ff.mkey
    end
    result = hif.doPost("url",post)

    if result == "init net error" then  
        return {false}
    end
    
    cclog("server result:"..result)
    local tresult = Split(result,",")
    local retcode = {}
    local items = {}
    for i=1,table.getn(tresult) do
        cclog(tresult[i])
        local temp = Split(tresult[i],":")
        cclog("len:"..table.getn(temp))
        if table.getn(temp) == 2 then
            if temp[2] == "null" then
                retcode[temp[1]] = ""
            else
                retcode[temp[1]] = temp[2]
            end
        else
            if table.getn(temp) > 2 then
                local server = {}
                local servers = Split(tresult[i],"|")
                for j=1,table.getn(servers) do
                    local temp = Split(servers[j],":")
                    if temp[2] == "null" then
                        server[temp[1]] = ""
                    else
                        server[temp[1]] = temp[2]
                    end
                end
                items[table.getn(items) + 1] = server
            end
        end
    end
    if tonumber(retcode['ret']) == 0 then
        return {true,retcode,items}
    else
        return {false}
    end
end
function hif.changeServer(id)
    local result = ""
    local test = cc.UserDefault:getInstance():getIntegerForKey("testacount")
    local post = "code=server&target="..id.."&account_id="..ff.account_id.."&sn="
    if cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then 
        local test = cc.UserDefault:getInstance():getIntegerForKey("testacount")
        if test == 0 then
            test = math.floor(math.random() * 1000000)
            cc.UserDefault:getInstance():setIntegerForKey("testacount",test)
        end   
        post = post..(ff.mkey..test)
    else
        post = post..ff.mkey
    end
    result = hif.doPost("url",post)

    if result == "init net error" then  
        return false
    end    

    local tresult = Split(result,",")
    local retcode = {}
    local items = {}
    for i=1,table.getn(tresult) do
        cclog(tresult[i])
        local temp = Split(tresult[i],":")
        if table.getn(temp) == 2 then
            if temp[2] == "null" then
                retcode[temp[1]] = ""
            else
                retcode[temp[1]] = temp[2]
            end
        end
    end
    if retcode['ret'] == nil then
        return false
    end
    if tonumber(retcode['ret']) == 0 then
        return true
    else
        return false
    end
end
function hif.onPay(params)    
    cclog("hif.onPay")
    local index = string.find(params,",fatality,",0)
    cclog("index:"..index)
    cclog("index:"..string.len(params))    
    local args = {}
    args[1] = string.sub(params, 1, index-1)
    args[2] = string.sub(params, index+10, string.len(params))
    cclog("hrere............1")
    local sn = ff.mkey
    if cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then 
        local test = cc.UserDefault:getInstance():getIntegerForKey("testacount")
        if test == 0 then
            test = math.floor(math.random() * 1000000)
            cc.UserDefault:getInstance():setIntegerForKey("testacount",test)
        end   
        sn = sn..test
    end
    --hif.post = "op_code=3&partner_id="..ff.partner.."&sn="..sn.."&id="..ff.account_id.."&user_id="..dd.uid.."&server_id="..ff.serverid.."&bill_provider=1".."&signature="..args[1].."&signedData="..args[2]
    hif.post = "code=gpay&partner_id="..ff.partner.."&sn="..sn.."&account_id="..ff.account_id.."&user_id="..dd.uid.."&server_id="..ff.serverid.."&bill_provider=1".."&signature="..args[1].."&signedData="..args[2]
    hif.signature = args[1]
    hif.signedData= args[2]

    local function backPay()
        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(dd._payid)
        local result = hif.doPost("url",hif.post)
        cclog("result:"..result)

        if result == "init net error" then  
            return platform_showDialog(ff.langString("网络连接错误"),ff.langString("网络连接中断！").."0x902",2,0)
        end
        local tresult = Split(result,",")
        local retcode = {}
        for i=1,table.getn(tresult) do
            local temp = Split(tresult[i],":")
            if table.getn(temp) == 2 then
                if temp[2] == "null" then
                    retcode[temp[1]] = ""
                else
                    retcode[temp[1]] = temp[2]
                end
            end
        end
        if retcode['ret'] ~= nil then
            cclog("pay ret:"..retcode['ret'])
            --消费
            local result = tonumber(retcode['ret'])
            --成功的，或者已经提交过的，执行消费
            if result == 0 or result == -2 then
                platform_consumItems(hif.signature)
            end
        else
            cclog("server error")
        end
    end
    dd._payid = cc.Director:getInstance():getScheduler():scheduleScriptFunc(backPay, 0.1, false)
end
function hif.onIOSPay(pid,signature)
    local sn = ff.mkey
    local post = "code=ipay&partner_id="..ff.partner.."&sn="..sn.."&account_id="..ff.account_id.."&user_id="..dd.uid.."&server_id="..ff.serverid.."&signature="..signature.."&pid="..pid
    
    local result = hif.doPost("url",post)
    cclog("result:"..result)

    if result == "init net error" then  
        return platform_showDialog(ff.langString("网络连接错误"),ff.langString("网络连接中断！").."0x902",2,0)
    end
    local tresult = Split(result,",")
    local retcode = {}
    for i=1,table.getn(tresult) do
        local temp = Split(tresult[i],":")
        if table.getn(temp) == 2 then
            if temp[2] == "null" then
                retcode[temp[1]] = ""
            else
                retcode[temp[1]] = temp[2]
            end
        end
    end
    if retcode['ret'] ~= nil then
        cclog("pay ret:"..retcode['ret'])
        --消费
        local result = tonumber(retcode['ret'])
        --成功的，或者已经提交过的，执行消费
        if result == 0 or result == -2 then
            ff.iosCore:finishPay(pid)
        end
    else
        cclog("server error")
    end
end
function hif.onPush(token)
    cclog("token:"..token)
    if string.len(token) > 16 then
        local message = ff.net:createMessage()
        message:addCmd(0x00000002)
        message:addLong(dd.uid)
        message:addLong(0)
        message:addLong(0)
        message:addLong(0)
        message:addLong(0)
        message:addString(tostring(token),255)
        ff.net:postMessage(message)        
    end
end