cmd=cmd or {}

dd.Tjf_CHAT_LOGIN  = 0x00001F01
dd.Tjf_CHAT_GETMESSAGE   = 0x00001E05
dd.Tjf_CHAT_SENDOK       = 0x00001F04




function chat_addEventListener()
    ff.net:addEventListener(dd.Tjf_CHAT_LOGIN,onChatLogin)
    ff.net:addEventListener(dd.Tjf_CHAT_GETMESSAGE,onChatMessage)
    ff.net:addEventListener(dd.Tjf_CHAT_SENDOK,onSendOk)
end

function chat_login()
    local message = ff.net:createMessage()
    ff.net:addCmd(message,0x00000F01)

    message:addLong(dd.uid)
    message:addString(dd.myinfo:getString(1,"name"),15)
    message:addLong(dd.myinfo:getLong(1,"face"))
    message:addLong(dd.myinfo:getLong(1,"level"))--等级
    message:addLong(dd.myinfo:getLong(1,"power"))--战力
    message:addString("个性签名:"..dd.myinfo:getString(1,"name"),31)
    message:addLong(dd.myUnion:getLong(1,"unionid"))
    message:addString(dd.myUnion:getString(1,"unionname"),15)
    message:addString(dd.myUnion:getString(1,"unionflag"),3)
    message:addLong(dd.myUnion:getLong(1,"unionofficial"))
    message:addLong(dd.myUnion:getLong(1,"totem"))
    message:addString(ff.gameKey,32)
    message:addLong(dd.overTime)
    message:addLong(ff.serverid)
    message:addLong(ff.lang)--机器的语言
    
    
    
    cclog("正在登陆聊天服务器......")
    ff.net:postMessage(message)
end
function onChatLogin(message)
    local code = message:getLong()
    if code == 0 then
        cclog("聊天服务器登陆成功......")
        dd.serverTime['chatzone'] = message:getLong()
        dd.serverTime['chattime'] = message:getLong() - os.time()

        --加载好友和黑名单 群组列表
        cmd.initSnsData()
        
        --清理缓冲
        cclog("clear client_chat")
        ff.dbmanager:sql_query("delete from client_chat")
        --注册消息
        ff.net:addEventListener(dd.Tjf_CHAT_GETMESSAGE,onChatMessage)
        --查询世界聊天记录
        local sm = onPeakChatMessage(1)
        ff.net:postMessage(sm)
        --查询邮件数量
        mail_peekNewMailCount()
        --查询未读信息
    else
        if dd.myfriends == nil then
            dd.myfriends = createFriendTable()
        end          
        if dd.myBlackList == nil then
            dd.myBlackList=createBlackTable()
        end 
        if dd.myFriendsInvite == nil then
            dd.myFriendsInvite = ff.NetTable:create()
            dd.myFriendsInvite:addStreamCol("uid",ff.NET_LONG)
            dd.myFriendsInvite:addStreamCol("name",ff.NET_STRING,15)
            dd.myFriendsInvite:addStreamCol("face",ff.NET_LONG)
            dd.myFriendsInvite:addStreamCol("unionid",ff.NET_LONG)
            dd.myFriendsInvite:addStreamCol("unionname",ff.NET_STRING,15)
            dd.myFriendsInvite:addStreamCol("short",ff.NET_STRING,3)
            dd.myFriendsInvite:addStreamCol("ulevel",ff.NET_LONG)--身份
            dd.myFriendsInvite:addStreamCol("serverid",ff.NET_LONG)
            dd.myFriendsInvite:addStreamCol("level",ff.NET_LONG)    
        end                 
        cclog3("chatServer login error:"..code)    
    end
    message.clear()
    return code
end

--查询消息
function onPeakChatMessage(type,id)
    local message = ff.net:createMessage()
    ff.net:addCmd(message,0x00000E05)
    message:addLong(dd.uid)
    message:addLong(type)
    if id == nil then
        id = 0
        message:addLong(0)
    else
        cclog("onPeakChatMessage:"..type..",id"..id)
        message:addLong(id)
    end     
    local theID = 0
    local data = ff.dbmanager:sql_fetch_rows("select `id` from client_chat where `type`='"..type.."' and `targetid`='"..id.."' order by `id` asc limit 1")
    if data ~= nil and data:rowCount() == 1 then
        theID = tonumber(data:getString(1,"id"))
    end
    if data ~= nil then    
        data:clear()
    end    
    cclog("theID:"..theID)
    message:addSuperLong(theID)
    --cclog("发送查询消息:"..theID.." id"..id)
    return message    
end

--聊天消息
function onChatMessage(message)
    local code   = message:getLong()
    local action = message:getLong()
    cclog("onChatMessage:"..code)
    if code == 0 then
        local type = message:getLong()
        local targetid = message:getLong()
        local row = message:getLong()
        
        cclog("targetid:"..targetid..",row:"..row.." type=="..type)
        if row > 0 then
            local nt = ff.NetTable:create()
            nt:addStreamCol("id",ff.NET_SUPER_LONG)
            nt:addStreamCol("time",ff.NET_LONG)
            nt:addStreamCol("uid",ff.NET_LONG)
            nt:addStreamCol("name",ff.NET_STRING,15)
            nt:addStreamCol("face",ff.NET_LONG)
            nt:addStreamCol("unionid",ff.NET_LONG)
            nt:addStreamCol("uflag",ff.NET_STRING,3)
            nt:addStreamCol("ulevel",ff.NET_LONG)
            nt:addStreamCol("uicon",ff.NET_LONG)
            nt:addStreamCol("chat",ff.NET_STRING,127)
            nt:addStreamCol("lang",ff.NET_STRING,15)
            nt:addStreamCol("level",ff.NET_LONG)
            nt:addStreamCol("group",ff.NET_LONG)
            message:getData(row,nt)
            
            nt:addStreamCol("type",ff.NET_LONG)
            nt:addStreamCol("targetid",ff.NET_LONG)
            for i=1,row do        
                if type == 1 then
                    local id = nt:getSuperLong(i,"id") 
                    nt:setSuperLong(i,"id",id+dd.AdvertiseCnt)    
                end
                nt:setLong(i,"type",type)
                nt:setLong(i,"targetid",targetid)
            end
            --print("chat============",nt:getString(1,"chat"))
            
            ff.dbmanager:sql_nettable(nt,"client_chat")
            --主动查询的消息记录不记录到history表
            if action==1 then
                --更新时间
                --if type >= 3 and dd.myChatHistroy ~= nil then
                if type >= 3 and dd.myChatHistroy ~= nil then
                    local addrow = 0
                    for i=1,dd.myChatHistroy:rowCount() do
                        if dd.myChatHistroy:getLong(i,"type") == type and dd.myChatHistroy:getLong(i,"id") == targetid then
                            addrow = i
                            break
                        end
                    end
                    if addrow == 0 then
                        if type == 3 and dd.myChatHistroy ~= nil then      
                            cclog("创建私聊频道")          
                            addrow = dd.myChatHistroy:addRow()
                            dd.myChatHistroy:setLong(addrow,"id",targetid)
                            dd.myChatHistroy:setLong(addrow,"type",type)
                            dd.myChatHistroy:setLong(addrow,"time",nt:getLong(row,"time"))
                            dd.myChatHistroy:setLong(addrow,"unread",row)
                        end
                    else
                        cclog("here........:"..row)
                        dd.myChatHistroy:setLong(addrow,"time",nt:getLong(row,"time"))
                        dd.myChatHistroy:setLong(addrow,"unread",dd.myChatHistroy:getLong(addrow,"unread")+row)
                    end
                    dd.saveUserValue(2,(type.."_"..targetid),dd.myChatHistroy:getLong(addrow,"unread"))
                end
                ff.dbmanager:sql_nettable(nt,"client_chat_history",true)    
            end
            nt:clear()
        end
        message:clear()
        return {code,type,row,action,targetid}
    else    
        message:clear()
        return {code}
    end
end

function onSendOk(message)
    local code = message:getLong()
    message:clear()
end
