
--设置装备
dd.Tjf_hero_GeneralSetEquip = 0x00001138
dd.Tjf_hero_skillAction = 0x00001109

--pve战斗
dd.Tjf_hero_CityZombieFight = 0x00001163

dd.Tjf_hero_GeneralPVEAttrSet = 0x00001170
dd.Tjf_hero_GeneralAddHP = 0x00001171

function hero_addEventListener()
    ff.net:addEventListener(dd.Tjf_hero_skillAction, onHeroSkillAction)
    ff.net:addEventListener(dd.Tjf_hero_GeneralSetEquip, onGeneralSetEquip)

    ff.net:addEventListener(dd.Tjf_hero_CityZombieFight, onCityZombieFight)
    ff.net:addEventListener(dd.Tjf_hero_GeneralPVEAttrSet,onHeroGeneralPveAttrSet)
    ff.net:addEventListener(dd.Tjf_hero_GeneralAddHP,onHeroGeneralAddHP)
end

function onHeroSkillAction(message)
    local code = message:getLong()
    if code == 0 then
        local type = message:getLong()
        local hid =  message:getLong()
        
        local tid = message:getLong()
        local count = message:getLong()
        if tid > 0 then
            dd.setToolCount(tid,count)
        end  
        
        local skillid = message:getLong()
        local skilllv = message:getLong()
        
        dd.gold(message:getLong())
        
        if type == 9 then   --重置
            for i=1,dd.heros:rowCount() do
                if dd.heros:getLong(i,"hid") == hid then
                    local skills = dd.heros:getNetTable(i,"skills")
                    skills:delRows()
                end
            end
        else
            local have = false
            for i=1,dd.heros:rowCount() do
                if dd.heros:getLong(i,"hid") == hid then
                    local skills = dd.heros:getNetTable(i,"skills")
                    for j=1,skills:rowCount() do
                        if skills:getLong(j,"sid") == skillid then
                            skills:setLong(j,"level",skilllv)
                            have = true
                            break
                        end
                    end
                    if have == false then
                        local row = skills:addRow()
                        skills:setLong(row,"sid",skillid)
                        skills:setLong(row,"level",skilllv)
                    end
                end
            end
        end
        
        message:clear()  
        return {code}
    else
        message:clear()
        return {code}
    end
end

function onGeneralSetEquip(message)
    local code = message:getLong()
    if code == 0 then
        local hid = message:getLong()
        local pos = message:getLong()
        local cur = message:getLong()
        local target = message:getLong()
        local hero_power = message:getLong()
        local user_power = message:getLong()
        cclog("hid:"..hid..",pos:"..pos..",cur:"..cur..",target:"..target)
        dd.myinfo:setLong(1,"power",user_power)
        local id = 0
        for i=1,dd.heros:rowCount() do
            if dd.heros:getLong(i,"hid") == hid then
                cclog("here........")
                id = dd.heros:getLong(i,"arms"..pos)
                dd.heros:setLong(i,"arms"..pos,cur)
                dd.heros:setLong(i,"power",hero_power)
                break
            end
        end
        if cur == 0 then
            cclog("id:"..id)
            for i=1,dd.myArms:rowCount() do
                if dd.myArms:getLong(i,"tid") == id then
                    dd.myArms:setLong(i,"heroid",0)
                    break
                end
            end
        else
            for i=1,dd.myArms:rowCount() do
                if dd.myArms:getLong(i,"tid") == cur then
                    dd.myArms:setLong(i,"heroid",hid)
                end
                if target > 0 and dd.myArms:getLong(i,"tid") == target then
                    dd.myArms:setLong(i,"heroid",0)
                end
            end
        end
        message:clear()
        return {code,cur}
    else
        message:clear()
        return {code}
    end

end
function onCityZombieFight(message)
    
    return message
end

function onHeroGeneralAddHP(message)
    
    local code = message:getLong()
    if code == 0 then
        local hid =  message:getLong()
        
        dd.gold(message:getLong())
        local tid = message:getLong()
        local count = message:getLong()
        if tid > 0 then
            dd.setToolCount(tid,count)
        end  


        for i=1,dd.heros:rowCount() do
            if dd.heros:getLong(i,"hid") == hid then
                dd.heros:setLong(i,"PVEHpMax",message:getLong())
                dd.heros:setLong(i,"PVEHpNow",message:getLong())
                dd.heros:setLong(i,"PVEHpTime",message:getLong())
                break
            end
        end
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("道具使用成功 ！"),true)
        message:clear()  
        return {code}
    else
        message:clear()
        return {code}
    end
end

function onHeroGeneralPveAttrSet( message )
    -- body
    local code = message:getLong()
    if code == 0 then
        local hid =  message:getLong()
        
        local type = message:getLong()
        local point = message:getLong()

        dd.gold(message:getLong())
        local tid = message:getLong()
        local count = message:getLong()
        if tid > 0 then
            dd.setToolCount(tid,count)
        end  


        for i=1,dd.heros:rowCount() do
            if dd.heros:getLong(i,"hid") == hid then
                dd.heros:setLong(i,"PVETotle",message:getLong())
                dd.heros:setLong(i,"PVEAct",message:getLong())
                dd.heros:setLong(i,"PVEDfc",message:getLong())
                dd.heros:setLong(i,"PVEHp",message:getLong())
                dd.heros:setLong(i,"PVEHpMax",message:getLong())
                dd.heros:setLong(i,"PVEHpNow",message:getLong())
                dd.heros:setLong(i,"PVEHpTime",message:getLong())
                break
            end
        end
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功"),true)
        message:clear()  
        return {code}
    else
        message:clear()
        return {code}
    end
end