function login_login_ex(sender,param)
    if param ~= nil and table.getn(param) == 2 then
        dd.setProgress(param[1],param[2])
    end    
    local message = ff.net:createMessage()
    message:addCmd(0x00000051)
    message:addLong(dd.uid)

    ff.net:postMessage(message)
    local function checkMessage_51()
        local result = ff.net:getMessage(0x00001051)
        if result ~= nil then
            dd.loadingLayer:stopAllActions()
            login_login_ex_result(result)
        end
    end
    schedule(dd.loadingLayer,checkMessage_51,0.1)
end
function login_login_ex_result(result)
    if result ~= nil then
        local ret = result:getLong()
        if ret == 0 then
            login_mydataEx(result)
            login_cityEx(result)
            login_queueInfoEx(result)
            tec_InfoEx(result)
            tower_InfoEx(result)
            solider_InfoEx(result)
            Troops_InfoEx(result)
            wall_InfoEx(result)

            login_toolsEx(result)
            login_plusEx(result)
            login_effectEx(result)
            login_unionHelperEx(result)
            login_UnionGiftsEx(result)
            login_UnionBattleEx(result)
            login_MallListEx(result)
            login_armsEx(result)
            login_taskEx(result)
            login_goldTaskEx(result)
            login_CrystalsEx(result)
            login_UnionTecEx(result)
            login_LockPosEx(result)
            login_GrowthFund(result)
            login_Activity(result)


            login_sounds(dd.loadingLayer,{60,ff.langString("音效初始化")})
            login_ok(dd.loadingLayer,{80,ff.langString("数据初始化")})

            --检查登录是否正确
            if dd.mylists == nil or dd.mybuilds == nil or dd.myinfo == nil then
                login_error(-3,"Login Error")
                return
            end

            if dd.myResOut ~= nil then
                dd.myResOut:clear()
            end
            --资源产量
            dd.myResOut = ff.NetTable:create()
            dd.myResOut:addStreamCol("lastupdate",ff.NET_LONG)
            dd.myResOut:addStreamCol("stone",ff.NET_LONG)
            dd.myResOut:addStreamCol("wood",ff.NET_LONG)
            dd.myResOut:addStreamCol("iron",ff.NET_LONG)
            dd.myResOut:addStreamCol("food",ff.NET_LONG)
            dd.myResOut:addStreamCol("silver",ff.NET_LONG)
            dd.myResOut:addStreamCol("stone_max",ff.NET_LONG)
            dd.myResOut:addStreamCol("wood_max",ff.NET_LONG)
            dd.myResOut:addStreamCol("iron_max",ff.NET_LONG)
            dd.myResOut:addStreamCol("food_max",ff.NET_LONG)
            dd.myResOut:addStreamCol("silver_max",ff.NET_LONG)
            dd.myResOut:addStreamCol("keepfood",ff.NET_LONG)
            dd.myResOut:addRow()
            --活跃度
            dd.myOnline = ff.NetTable:create(true)
            dd.myOnline:addStreamCol("lastupdate",ff.NET_LONG)
            dd.myOnline:addStreamCol("count",ff.NET_LONG)
            dd.myOnline:addStreamCol("online1",ff.NET_LONG)
            dd.myOnline:addStreamCol("online2",ff.NET_LONG)
            dd.myOnline:addStreamCol("online3",ff.NET_LONG)
            dd.myOnline:addStreamCol("online4",ff.NET_LONG)
            dd.myOnline:addStreamCol("online5",ff.NET_LONG)
            dd.myOnline:addRow()
            --交易宝石
            if dd.myGem ~= nil then
                dd.myGem:clear()
            end
            dd.myGem = ff.NetTable:create(true)
            dd.myGem:addStreamCol("pos",ff.NET_LONG)
            dd.myGem:addStreamCol("id",ff.NET_LONG)
            dd.myGem:addStreamCol("count",ff.NET_LONG)
            dd.myGem:addStreamCol("state",ff.NET_LONG)

            dd.myDayTask = ff.NetTable:create(true)
            dd.myDayTask:addStreamCol("canReceive",ff.NET_LONG)
            dd.myDayTask:addStreamCol("time",ff.NET_LONG)
            dd.myDayTask:addStreamCol("getStep",ff.NET_LONG)
            dd.myDayTask:addRow()   

            if dd.myAlchemist ~= nil then
                dd.myAlchemist:clear()
                dd.myAlchemist = nil 
            end  

            if dd.myTowerInfo ~= nil then
                dd.myTowerInfo:clear()
                dd.myTowerInfo = nil 
            end  
            
            if dd.myEvtMall ~= nil then
                dd.myEvtMall:clear()
                dd.myEvtMall = nil 
            end  

                  
            
        else
            login_error(ret,"0x00000051")               
        end
        result:clear()
    else
        cclog3("login_login_ex_result error")
    end    
end

function login_mydataEx(result)
    --我的信息
    if dd.myinfo ~= nil then
        dd.myinfo:clear()
    end    
    dd.myinfo = ff.NetTable:create(true)
    dd.myinfo:addStreamCol("uid",ff.NET_LONG)
    dd.myinfo:addStreamCol("name",ff.NET_STRING,15)
    dd.myinfo:addStreamCol("face",ff.NET_LONG)
    dd.myinfo:addStreamCol("born",ff.NET_LONG)
    dd.myinfo:addStreamCol("state",ff.NET_LONG)
    dd.myinfo:addStreamCol("gold",ff.NET_LONG)
    dd.myinfo:addStreamCol("vippoint",ff.NET_LONG)
    dd.myinfo:addStreamCol("power",ff.NET_LONG)
    dd.myinfo:addStreamCol("kills",ff.NET_LONG)
    result:getData(1, dd.myinfo)
    cclog("dd.name="..dd.myinfo:getString(1,"name"))

    dd.myinfo:addStreamCol("vip",ff.NET_LONG)
    dd.myinfo:addStreamCol("nAllyTitle",ff.NET_LONG)
    dd.myinfo:addStreamCol("market",ff.NET_LONG)
    dd.myinfo:addStreamCol("tzl",ff.NET_LONG)

    dd.myinfo:addStreamCol("urumail",ff.NET_LONG)
    dd.myinfo:addStreamCol("ursmail",ff.NET_LONG)
    dd.myinfo:addStreamCol("ursys",ff.NET_LONG)
    dd.myinfo:addStreamCol("urreport",ff.NET_LONG)
    dd.myinfo:addStreamCol("urpve",ff.NET_LONG)
    dd.myinfo:addStreamCol("urcj",ff.NET_LONG)
    dd.myinfo:addStreamCol("uryg",ff.NET_LONG)
    dd.myinfo:addStreamCol("urboss",ff.NET_LONG)
    dd.myinfo:addStreamCol("urgc",ff.NET_LONG)
    dd.myinfo:addStreamCol("urZB",ff.NET_LONG)
    dd.myinfo:addStreamCol("urRboss",ff.NET_LONG)

    dd.myinfo:addStreamCol("chat_unread",ff.NET_LONG)
    dd.myinfo:addStreamCol("chat_friends",ff.NET_LONG)
    dd.myinfo:addStreamCol("chat_union",ff.NET_LONG)

    dd.myinfo:addStreamCol("lucky",ff.NET_LONG)
    dd.myinfo:addStreamCol("applys",ff.NET_LONG)
    dd.myinfo:addStreamCol("newbie",ff.NET_LONG)

    --玩家议会等级
    dd.myinfo:addStreamCol("level",ff.NET_LONG)
    --可以攻击的NPCLEVEL
    dd.myinfo:addStreamCol("npclevel",ff.NET_LONG)
    dd.myinfo:addStreamCol("TaskNewbieId",ff.NET_LONG)
    dd.myinfo:addStreamCol("TaskNewbieTime",ff.NET_LONG)
    dd.myinfo:addStreamCol("TaskNewbieStep",ff.NET_LONG)
    dd.myinfo:addStreamCol("uruionmail",ff.NET_LONG)
    
    dd.ActiveInfo = ff.NetTable:create(true)
      dd.ActiveInfo:addStreamCol("type",ff.NET_LONG)
      dd.ActiveInfo:addStreamCol("id",ff.NET_LONG)
      dd.ActiveInfo:addStreamCol("startTime",ff.NET_LONG)
      dd.ActiveInfo:addStreamCol("endTime",ff.NET_LONG)
      dd.ActiveInfo:addStreamCol("realId",ff.NET_LONG)
      dd.ActiveInfo:addStreamCol("iskua",ff.NET_LONG)
      dd.ActiveInfo:addStreamCol("baoliu2",ff.NET_LONG)
      dd.ActiveInfo:addStreamCol("baoliu3",ff.NET_LONG)
      dd.ActiveInfo:addStreamCol("baoliu4",ff.NET_LONG)
    


    --联盟
    if dd.myUnion ~= nil then
        dd.myUnion:clear()
    end        
    dd.myUnion = ff.NetTable:create(true)
    --联盟ID
    dd.myUnion:addStreamCol("unionid",ff.NET_LONG)
    --联盟名
    dd.myUnion:addStreamCol("unionname",ff.NET_STRING,15)        
    --联盟官职
    dd.myUnion:addStreamCol("unionofficial",ff.NET_LONG)
    --联盟贡献
    dd.myUnion:addStreamCol("unionpoint",ff.NET_LONG)
    --联盟简称
    dd.myUnion:addStreamCol("unionflag",ff.NET_STRING,3)
    --联盟图腾
    dd.myUnion:addStreamCol("totem",ff.NET_LONG)
    result:getData(1, dd.myUnion)

    dd.myinfo:setLong(1,"vip",result:getLong())

    --礼包数量
    dd.myUnion:addStreamCol("boxcount",ff.NET_LONG)
    dd.myUnion:addStreamCol("boxlevel",ff.NET_LONG)
    dd.myUnion:addStreamCol("boxexp",ff.NET_LONG)
    dd.myUnion:addStreamCol("boxtotal",ff.NET_LONG)
    --盟主
    dd.myUnion:addStreamCol("master",ff.NET_STRING,32)
    --成员数
    dd.myUnion:addStreamCol("member",ff.NET_LONG)
    dd.myUnion:addStreamCol("memberMax",ff.NET_LONG)
    --排名
    dd.myUnion:addStreamCol("rank",ff.NET_LONG)
    --战力
    dd.myUnion:addStreamCol("power",ff.NET_SUPER_LONG)
    --基金
    dd.myUnion:addStreamCol("nAllyFunds",ff.NET_LONG)
    --公告
    dd.myUnion:addStreamCol("nAllyBBS",ff.NET_STRING,256)  

    --角标数据
    --战争
    dd.myUnion:addStreamCol("battles",ff.NET_LONG)
    --据点
    dd.myUnion:addStreamCol("points",ff.NET_LONG)
    --帮助
    dd.myUnion:addStreamCol("helpers",ff.NET_LONG)
    --报告
    dd.myUnion:addStreamCol("report",ff.NET_LONG)
    --留言
    dd.myUnion:addStreamCol("unread",ff.NET_LONG)
    --征服者
    dd.myUnion:addStreamCol("nIsKingAlly",ff.NET_LONG)
    --语言
    dd.myUnion:addStreamCol("lan",ff.NET_LONG)
    --偏向
    dd.myUnion:addStreamCol("rule",ff.NET_LONG)
    --时区
    dd.myUnion:addStreamCol("time",ff.NET_LONG)
    --活跃度
    dd.myUnion:addStreamCol("act",ff.NET_LONG)
    --联盟科技
    dd.myUnion:addStreamCol("level",ff.NET_LONG)
    dd.myUnion:addStreamCol("tec1",ff.NET_LONG)
    dd.myUnion:addStreamCol("tec2",ff.NET_LONG)
    dd.myUnion:addStreamCol("tec3",ff.NET_LONG)
    --待审核记录
    dd.myUnion:addStreamCol("apply",ff.NET_LONG)

    if dd.myUnionTecs ~= nil then
        dd.myUnionTecs:clear()
    end
    dd.myUnionTecs = ff.NetTable:create(true)
    dd.myUnionTecs:addStreamCol("id",ff.NET_LONG)
    dd.myUnionTecs:addStreamCol("level",ff.NET_LONG)
    dd.myUnionTecs:addStreamCol("exp",ff.NET_LONG)  
    dd.myUnionTecs:addStreamCol("startime",ff.NET_LONG)
    dd.myUnionTecs:addStreamCol("endtime",ff.NET_LONG)    

    --礼包
    if dd.mygifts ~= nil then
        dd.mygifts:clear()
    end 
    dd.mygifts = ff.NetTable:create(true)

    --nOnlinePackTime
    dd.mygifts:addStreamCol("onlinepack",ff.NET_LONG)
    dd.mygifts:addStreamCol("onlinepackid",ff.NET_LONG)
    --银行！！！！
    dd.mygifts:addStreamCol("bankGetLevel",ff.NET_LONG)
    --接收到的联盟邀请数
    dd.mygifts:addStreamCol("inviteNum",ff.NET_LONG)
    --连续登录天数
    dd.mygifts:addStreamCol("checkDay",ff.NET_LONG)
    --奖励是否领取
    dd.mygifts:addStreamCol("checkDayInfo",ff.NET_LONG)
    --是否已经充值    nHasTopuped int 4   
    dd.mygifts:addStreamCol("nHasTopuped",ff.NET_LONG)
    --email绑定奖励是否发放 nIsEmailBinded  int 4   
    dd.mygifts:addStreamCol("nIsEmailBinded",ff.NET_LONG)
    --facebook绑定奖励是否发放  nIsFacebookBinded   int 4   
    dd.mygifts:addStreamCol("nIsFacebookBinded",ff.NET_LONG)
    --今日已攻击次数   nTdyAttack  int 4   战役推图
    dd.mygifts:addStreamCol("SurpriseRechargeId",ff.NET_LONG)
    --可攻击次数上限   nMaxAttack  int 4   战役推图
    dd.mygifts:addStreamCol("SurpriseRechargeTime",ff.NET_LONG)
    --Facebook Like奖励是否发放   nIsFBLiked  int 4   
    dd.mygifts:addStreamCol("ZombieCount",ff.NET_LONG)
    result:getData(1, dd.mygifts)


    dd.mygifts:addStreamCol("LevelRechargeId",ff.NET_LONG)
    dd.mygifts:addStreamCol("LevelRechargeTime",ff.NET_LONG)
    dd.mygifts:addStreamCol("SurpriseRechargeIdEx",ff.NET_LONG)
    dd.mygifts:addStreamCol("SurpriseRechargeTimeEx",ff.NET_LONG)
    dd.mygifts:addStreamCol("ActiveCharge",ff.NET_LONG)
    dd.mygifts:addStreamCol("ActiveChargeTime",ff.NET_LONG)
    dd.mygifts:addStreamCol("ResCharge",ff.NET_LONG)
    dd.mygifts:addStreamCol("ResChargeTime",ff.NET_LONG)
    dd.mygifts:addStreamCol("BonusCharge",ff.NET_LONG)
    dd.mygifts:addStreamCol("BonusChargeTime",ff.NET_LONG)
    dd.mygifts:addStreamCol("OnceCharge",ff.NET_LONG)
    dd.mygifts:addStreamCol("OnceChargeTime",ff.NET_LONG)
    dd.myinfo:setLong(1,"nAllyTitle",result:getLong())

    if dd.mygifts ~= nil and dd.mygifts:rowCount() == 1 then
        if dd.mygifts:getLong(1,"nIsEmailBinded") == 0 and string.len(ff.email) > 0 then
            local message = ff.net:createMessage()
            message:addCmd(0x0000013c)
            message:addLong(dd.uid)
            message:addLong(1)
            ff.net:postMessage(message)   
        end
        local facebook   = cc.UserDefault:getInstance():getStringForKey("facebook","")
        if dd.mygifts:getLong(1,"nIsFacebookBinded") == 0 and string.len(facebook) == 32 then
            local message = ff.net:createMessage()
            message:addCmd(0x0000013c)
            message:addLong(dd.uid)
            message:addLong(2)
            ff.net:postMessage(message)   
        end
        
    end


    dd.myinfo:setLong(1,"lucky",result:getLong())
    dd.myinfo:setLong(1,"applys",result:getLong())
    dd.myinfo:setLong(1,"newbie",result:getLong())

    dd.myUnion:setLong(1,"rank",result:getLong())
    dd.myUnion:setSuperLong(1,"power",result:getSuperLong())
    dd.myinfo:setLong(1,"npclevel",result:getLong())
    --cclog("=============2============"..dd.myinfo:getLong(1,"NowActive"))

    --最大体力，当前体力，体力更新时间
    dd.myinfo:addStreamCol("MaxActive",ff.NET_LONG)
    dd.myinfo:addStreamCol("NowActive",ff.NET_LONG)
    dd.myinfo:addStreamCol("ActiveTime",ff.NET_LONG)

    dd.myinfo:setLong(1,"MaxActive",result:getLong())
    dd.myinfo:setLong(1,"NowActive",result:getLong())
    dd.myinfo:setLong(1,"ActiveTime",result:getLong())

    dd.myinfo:addStreamCol("ActiveType",ff.NET_LONG)

    dd.myinfo:addStreamCol("ActiveID",ff.NET_LONG)
    dd.myinfo:addStreamCol("ActiveBegin",ff.NET_LONG)
    dd.myinfo:addStreamCol("ActiveEnd",ff.NET_LONG)

    dd.myinfo:addStreamCol("LastCityFirmnessTime",ff.NET_LONG)
    dd.myinfo:addStreamCol("CityFirmnessByTime",ff.NET_LONG)
    dd.myinfo:addStreamCol("MaxCityFirmness",ff.NET_LONG)
    dd.myinfo:addStreamCol("GeneralPrisonCnt",ff.NET_LONG)
    dd.myinfo:addStreamCol("GeneralPrisonerCnt",ff.NET_LONG)

    dd.myinfo:addStreamCol("pataBegin",ff.NET_LONG)
    dd.myinfo:addStreamCol("pataEnd",ff.NET_LONG)

    dd.myinfo:addStreamCol("treeBegin",ff.NET_LONG)
    dd.myinfo:addStreamCol("treeEnd",ff.NET_LONG)

    dd.myinfo:addStreamCol("towerBegin",ff.NET_LONG)
    dd.myinfo:addStreamCol("towerEnd",ff.NET_LONG)

end
function login_cityEx(result)
    if dd.mycity ~= nil then
        dd.mycity:clear()
    end 
    dd.mycity = ff.NetTable:create(true)
    dd.mycity:addStreamCol("name",ff.NET_STRING,15)
    dd.mycity:addStreamCol("cid",ff.NET_LONG)
    dd.mycity:addStreamCol("avatar",ff.NET_LONG)
    dd.mycity:addStreamCol("stone",ff.NET_LONG)
    dd.mycity:addStreamCol("wood",ff.NET_LONG)
    dd.mycity:addStreamCol("iron",ff.NET_LONG)
    dd.mycity:addStreamCol("food",ff.NET_LONG)
    dd.mycity:addStreamCol("silver",ff.NET_LONG)
    result:getData(1, dd.mycity)
    dd.mycity:addStreamCol("buff",ff.NET_LONG)
    dd.mycity:addStreamCol("lastupdate",ff.NET_LONG)
    dd.mycity:addStreamCol("localupdate",ff.NET_LONG)
    dd.mycity:setLong(1,"localupdate",dd.getServerTime())
    
    local row = result:getLong()
    if dd.mybuilds ~= nil then
        dd.mybuilds:clear()
    end 
    dd.mybuilds = ff.NetTable:create(true)
    dd.mybuilds:addStreamCol("pos",ff.NET_LONG)
    dd.mybuilds:addStreamCol("bid",ff.NET_LONG)
    dd.mybuilds:addStreamCol("level",ff.NET_LONG)
    dd.mybuilds:addStreamCol("state",ff.NET_LONG)        
    if row > 0 then
        result:getData(row, dd.mybuilds)
        for i=1,dd.mybuilds:rowCount() do
            if dd.mybuilds:getLong(i,"bid") == 1 then
                dd.myinfo:setLong(1,"level",dd.mybuilds:getLong(i,"level"))
            end                        
        end
    end
end
function login_queueInfoEx(result)
    cclog("here..................")
    if dd.mylists ~= nil then
        dd.mylists:clear()
    end    
    dd.mylists = ff.NetTable:create(true,1001)
    dd.mylists:addStreamCol("type",ff.NET_LONG)
    dd.mylists:addStreamCol("start",ff.NET_LONG)
    dd.mylists:addStreamCol("end",ff.NET_LONG)
    dd.mylists:addStreamCol("param1",ff.NET_LONG)
    dd.mylists:addStreamCol("param2",ff.NET_LONG)
    dd.mylists:addStreamCol("param3",ff.NET_LONG)
    dd.mylists:addStreamCol("param4",ff.NET_LONG)
    local row = result:getLong()
    if row > 0 then
        result:getData(row,dd.mylists)
    end
    --额外参数，客户端用，目前用来表示是否已经触发过free动画
    dd.mylists:addStreamCol("param5",ff.NET_LONG)
end
function tec_InfoEx(result)
    if dd.myTec ~= nil then
        dd.myTec:clear()
    end    
    dd.myTec = ff.NetTable:create(true)
    dd.myTec:addStreamCol("tec_id",ff.NET_LONG)
    dd.myTec:addStreamCol("lv",ff.NET_LONG)

    local row = result:getLong()
    if row > 0 then
        result:getData(row, dd.myTec)
    end   
end
--瞭望塔
function tower_InfoEx(result)
    if dd.myTower ~= nil then
        dd.myTower:clear()
    end    
    dd.myTower = ff.NetTable:create(true)
    --dd.myTower:addStreamCol("uid_id",ff.NET_LONG)
    dd.myTower:addStreamCol("army_id",ff.NET_LONG)
    dd.myTower:addStreamCol("type",ff.NET_LONG)
    dd.myTower:addStreamCol("from",ff.NET_LONG)
    dd.myTower:addStreamCol("to",ff.NET_LONG)
    dd.myTower:addStreamCol("start",ff.NET_LONG)
    dd.myTower:addStreamCol("arrival",ff.NET_LONG)
    dd.myTower:addStreamCol("allyFlag",ff.NET_STRING,3)
    dd.myTower:addStreamCol("playerID",ff.NET_LONG)
    dd.myTower:addStreamCol("loginName",ff.NET_STRING,15)
    local row = result:getLong()
    if row > 0 then
        result:getData(row, dd.myTower)
    end   
end

--部队
function solider_InfoEx(result)
    if dd.soliders ~= nil then
        dd.soliders:clear()
    end    
    dd.soliders = ff.NetTable:create()    
    dd.soliders:addStreamCol("soldierid",ff.NET_LONG)--兵种
    dd.soliders:addStreamCol("count",ff.NET_LONG)--数量
    dd.soliders:addStreamCol("hurtcount",ff.NET_LONG)--伤病数量
    local row = result:getLong()
    if row > 0 then
        result:getData(row, dd.soliders)
    end
end
--军队
function Troops_InfoEx(result)
    if dd.myTroops ~= nil then
        dd.myTroops:clear()
    end    
    dd.myTroops = ff.NetTable:create()    
    dd.myTroops:addStreamCol("id",ff.NET_LONG)
    dd.myTroops:addStreamCol("type",ff.NET_LONG)
    dd.myTroops:addStreamCol("state",ff.NET_LONG)

    dd.myTroops:addStreamCol("from",ff.NET_LONG)
    dd.myTroops:addStreamCol("to",ff.NET_LONG)
    dd.myTroops:addStreamCol("start",ff.NET_LONG)
    dd.myTroops:addStreamCol("arrival",ff.NET_LONG)
    dd.myTroops:addStreamCol("hid",ff.NET_LONG)

    dd.myTroops:addStreamCol("b1",ff.NET_LONG)
    dd.myTroops:addStreamCol("b2",ff.NET_LONG)
    dd.myTroops:addStreamCol("b3",ff.NET_LONG)
    dd.myTroops:addStreamCol("b4",ff.NET_LONG)
    dd.myTroops:addStreamCol("b5",ff.NET_LONG)
    dd.myTroops:addStreamCol("b6",ff.NET_LONG)            

    dd.myTroops:addStreamCol("q1",ff.NET_LONG)
    dd.myTroops:addStreamCol("q2",ff.NET_LONG)
    dd.myTroops:addStreamCol("q3",ff.NET_LONG)
    dd.myTroops:addStreamCol("q4",ff.NET_LONG)
    dd.myTroops:addStreamCol("q5",ff.NET_LONG)
    dd.myTroops:addStreamCol("q6",ff.NET_LONG)            

    dd.myTroops:addStreamCol("g1",ff.NET_LONG)
    dd.myTroops:addStreamCol("g2",ff.NET_LONG)
    dd.myTroops:addStreamCol("g3",ff.NET_LONG)
    dd.myTroops:addStreamCol("g4",ff.NET_LONG)
    dd.myTroops:addStreamCol("g5",ff.NET_LONG)
    dd.myTroops:addStreamCol("g6",ff.NET_LONG)            

    dd.myTroops:addStreamCol("w1",ff.NET_LONG)
    dd.myTroops:addStreamCol("w2",ff.NET_LONG)
    dd.myTroops:addStreamCol("w3",ff.NET_LONG)
    dd.myTroops:addStreamCol("w4",ff.NET_LONG)
    dd.myTroops:addStreamCol("w5",ff.NET_LONG)
    dd.myTroops:addStreamCol("w6",ff.NET_LONG)            

    dd.myTroops:addStreamCol("s1",ff.NET_LONG)
    dd.myTroops:addStreamCol("s2",ff.NET_LONG)
    dd.myTroops:addStreamCol("s3",ff.NET_LONG)            

    dd.myTroops:addStreamCol("param1",ff.NET_LONG)            
    dd.myTroops:addStreamCol("param2",ff.NET_LONG)            
    dd.myTroops:addStreamCol("param3",ff.NET_LONG)            
    dd.myTroops:addStreamCol("param4",ff.NET_LONG)            

    local row = result:getLong()
    if row > 0 then
        result:getData(row, dd.myTroops)
    end
end
--城防
function wall_InfoEx(result)
    if dd.myWall ~= nil then
        dd.myWall:clear()
    end    
    dd.myWall = ff.NetTable:create()
    dd.myWall:addStreamCol("wallid",ff.NET_LONG)
    dd.myWall:addStreamCol("count",ff.NET_LONG)
    local row = result:getLong()
    if row > 0 then
        result:getData(row, dd.myWall)
    end   
end
--道具
function login_toolsEx(result)
    if dd.mytools ~= nil then
        dd.mytools:clear()
    end    
    dd.mytools = ff.NetTable:create(true)
    dd.mytools:addStreamCol("tid",ff.NET_LONG)
    dd.mytools:addStreamCol("count",ff.NET_LONG)
    local rows = result:getLong()
    if rows > 0 then
        result:getData(rows,dd.mytools)
    end
end
--加成
function login_plusEx(result)
    if dd.myplus ~= nil then
        dd.myplus:clear()
    end    
    dd.myplus = ff.NetTable:create(true)
    dd.myplus:addStreamCol("id",ff.NET_LONG)
    dd.myplus:addStreamCol("param",ff.NET_LONG)
    dd.myplus:addStreamCol("start",ff.NET_LONG)
    dd.myplus:addStreamCol("end",ff.NET_LONG)
    
    local rows = result:getLong()
    if rows > 0 then
        result:getData(rows,dd.myplus)
    end
end
--效果login_effect
function login_effectEx(result)
    if dd.myeffect ~= nil then
        dd.myeffect:clear()
    end    
    dd.myeffect = ff.NetTable:create(true)
    dd.myeffect:addStreamCol("id",ff.NET_LONG)
    dd.myeffect:addStreamCol("param",ff.NET_LONG)
    
    local rows = result:getLong()
    if rows > 0 then
        result:getData(rows,dd.myeffect)
    end
end
--联盟帮助
function login_unionHelperEx(result)
    dd.myHelp = {}
    --第一个帮助队列
    local bid1 = result:getLong()
    local buildLv = result:getLong()
    local curHelp = result:getLong()
    local maxHelp = result:getLong()
    local endTime = result:getLong()
    if bid1 > 0 then
        dd.myHelp['buildHelp'] = {}
        dd.myHelp['buildHelp']['bid'] = bid1
        dd.myHelp['buildHelp']['buildLv'] = buildLv
        dd.myHelp['buildHelp']['curHelp'] = curHelp
        dd.myHelp['buildHelp']['maxHelp'] = maxHelp
        dd.myHelp['buildHelp']['end'] = endTime
        dd.myHelper[1] = curHelp
    end
    --第二个帮助队列
    local bid2 = result:getLong()
    local buildLv = result:getLong()
    local curHelp = result:getLong()
    local maxHelp = result:getLong()
    local endTime = result:getLong()
    if bid2 > 0 then
        dd.myHelp['buildHelp1'] = {}
        dd.myHelp['buildHelp1']['bid'] = bid2
        dd.myHelp['buildHelp1']['buildLv'] = buildLv
        dd.myHelp['buildHelp1']['curHelp'] = curHelp
        dd.myHelp['buildHelp1']['maxHelp'] = maxHelp
        dd.myHelp['buildHelp1']['end'] = endTime
        dd.myHelper[13] = curHelp
    end
    --科技队列
    local tec_id = result:getLong()
    local tecLv = result:getLong()
    local curTecHelp = result:getLong()
    local maxTecHelp = result:getLong()
    local endTecTime = result:getLong()
    if tec_id > 0 then
        dd.myHelp['tecHelp'] = {}
        dd.myHelp['tecHelp']['tid'] = tec_id
        dd.myHelp['tecHelp']['tecLv'] = tecLv
        dd.myHelp['tecHelp']['curHelp'] = curTecHelp
        dd.myHelp['tecHelp']['maxHelp'] = maxTecHelp
        dd.myHelp['tecHelp']['end'] = endTecTime
        dd.myHelper[2] = curTecHelp
    end
    local num = result:getLong()
    local info=ff.NetTable:create()
    info:addStreamCol("uid",ff.NET_LONG)
    info:addStreamCol("name",ff.NET_STRING,15)
    info:addStreamCol("official",ff.NET_LONG)
    info:addStreamCol("hType",ff.NET_LONG)
    info:addStreamCol("hid",ff.NET_LONG)
    info:addStreamCol("lv",ff.NET_LONG)
    info:addStreamCol("curHelp",ff.NET_LONG)
    info:addStreamCol("maxHelp",ff.NET_LONG)
    info:addStreamCol("end",ff.NET_LONG)
    info:addStreamCol("face",ff.NET_LONG)
    cclog("unionHelp num:"..num)
    result:getData(num,info)
    
    dd.unionHelpList = {}
    for var=1, info:rowCount() do
        local key = table.getn(dd.unionHelpList) + 1
        dd.unionHelpList[key] = {}
        dd.unionHelpList[key]["uid"] = info:getLong(var,'uid')
        dd.unionHelpList[key]["name"] = info:getString(var,'name')
        dd.unionHelpList[key]["official"] = info:getLong(var,'official')
        dd.unionHelpList[key]["hType"] = info:getLong(var,'hType')
        dd.unionHelpList[key]["hid"] = info:getLong(var,'hid')
        dd.unionHelpList[key]["lv"] = info:getLong(var,'lv')
        dd.unionHelpList[key]["curHelp"] = info:getLong(var,'curHelp')
        dd.unionHelpList[key]["maxHelp"] = info:getLong(var,'maxHelp')
        dd.unionHelpList[key]["endTime"] = info:getLong(var,'end')
        dd.unionHelpList[key]["face"] = info:getLong(var,'face')
    end
    info:clear()
end
--礼包
function login_UnionGiftsEx(result)
    dd.myUnion:setLong(1,"boxlevel",result:getLong())
    dd.myUnion:setLong(1,"boxexp",result:getLong())
    dd.myUnion:setLong(1,"boxtotal",result:getLong())

    if dd.myUnionGifts ~= nil then
        dd.myUnionGifts:clear()
    end
    dd.myUnionGifts = ff.NetTable:create() 
    dd.myUnionGifts:addStreamCol("id",ff.NET_LONG)
    dd.myUnionGifts:addStreamCol("tid",ff.NET_LONG)
    dd.myUnionGifts:addStreamCol("endtime",ff.NET_LONG)
    dd.myUnionGifts:addStreamCol("start",ff.NET_LONG)
    dd.myUnionGifts:addStreamCol("type",ff.NET_LONG)
    dd.myUnionGifts:addStreamCol("dropid",ff.NET_LONG)
    dd.myUnionGifts:addStreamCol("count",ff.NET_LONG)
    dd.myUnionGifts:addStreamCol("gold",ff.NET_LONG)

    local rows = result:getLong()
    if rows > 0 then
        result:getData(rows,dd.myUnionGifts)
    end
end
--联合作战
function login_UnionBattleEx(result)
    if dd.myUnionBattle ~= nil then
        dd.myUnionBattle:clear()
        dd.myUnionBattle = nil
    end    
    dd.myUnionBattle = ff.NetTable:create()
    dd.myUnionBattle:addStreamCol("type",ff.NET_LONG)
    dd.myUnionBattle:addStreamCol("status",ff.NET_LONG)--0=正在集结 1=集结后出征
    dd.myUnionBattle:addStreamCol("statusStart",ff.NET_LONG)--状态开始时间
    dd.myUnionBattle:addStreamCol("statusEnd",ff.NET_LONG)--状态结束时间

    dd.myUnionBattle:addStreamCol("attackUid",ff.NET_LONG)
    dd.myUnionBattle:addStreamCol("attackServerid",ff.NET_LONG)--发起者服务器
    dd.myUnionBattle:addStreamCol("site",ff.NET_LONG)--发起者坐标

    dd.myUnionBattle:addStreamCol("unionid",ff.NET_LONG)
    dd.myUnionBattle:addStreamCol("attackUnionFlag",ff.NET_STRING,3)
    dd.myUnionBattle:addStreamCol("attackUname",ff.NET_STRING,15)--发起者主公名称
    dd.myUnionBattle:addStreamCol("unionOffical",ff.NET_LONG)
    dd.myUnionBattle:addStreamCol("targetType",ff.NET_LONG)--目标类型
    dd.myUnionBattle:addStreamCol("attackedUid",ff.NET_LONG)--被攻击者编号

    dd.myUnionBattle:addStreamCol("attackedServerid",ff.NET_LONG)--被攻击者服务器
    dd.myUnionBattle:addStreamCol("attackedSite",ff.NET_LONG)--被攻击者坐标
    dd.myUnionBattle:addStreamCol("attackedUnionid",ff.NET_LONG)
    dd.myUnionBattle:addStreamCol("attackedUnionFlag",ff.NET_STRING,3)
    dd.myUnionBattle:addStreamCol("attackedUname",ff.NET_STRING,15)
    dd.myUnionBattle:addStreamCol("attackedUnionOffical",ff.NET_LONG)

    dd.myUnionBattle:addStreamCol("currentSoldiers",ff.NET_LONG)--当前兵力  类型=1时：攻方总兵力 类型=2时：防方总兵力
    dd.myUnionBattle:addStreamCol("maxSoldiers",ff.NET_LONG)--兵力上限
    local nums=result:getLong()
    if nums > 0 then
        result:getData(nums,dd.myUnionBattle)
        cclog("myUnionBattle:"..nums..",uid:"..dd.myUnionBattle:getLong(1,"attackUid"))
    end
end

--价格
function login_MallListEx(result)
    local rows = result:getLong()
    for i=1,rows do
        local tid = result:getLong()
        local value = result:getLong()
        if dd.cfgProp[tid] == nil then
            dd.cfgProp[tid] = {}
        end
        dd.cfgProp[tid]['shop']  = 1
        dd.cfgProp[tid]['value'] = value    
    end
end
--装备
function login_armsEx(result)
    local rows = result:getLong()
    if dd.myArms ~= nil then
        dd.myArms:clear()
    end    
    dd.myArms = ff.NetTable:create()
    dd.myArms:addStreamCol("tid",ff.NET_LONG)
    dd.myArms:addStreamCol("aid",ff.NET_LONG)
    dd.myArms:addStreamCol("heroid",ff.NET_LONG)
    dd.myArms:addStreamCol("gem1",ff.NET_LONG)
    dd.myArms:addStreamCol("gem2",ff.NET_LONG)
    dd.myArms:addStreamCol("gem3",ff.NET_LONG)
    dd.myArms:addStreamCol("gem4",ff.NET_LONG)
    if rows > 0 then
        result:getData(rows, dd.myArms)
        dd.myArms:addStreamCol("power",ff.NET_LONG)
        for i=1,dd.myArms:rowCount() do
            local power = dd.cfgArms[dd.myArms:getLong(i,"aid")]['power']
            if dd.myArms:getLong(i,"gem1") > 0 then
                power = power + dd.cfgGems[dd.myArms:getLong(i,"gem1")]['power']
            end
            if dd.myArms:getLong(i,"gem2") > 0 then
                power = power + dd.cfgGems[dd.myArms:getLong(i,"gem2")]['power']
            end
            if dd.myArms:getLong(i,"gem3") > 0 then
                power = power + dd.cfgGems[dd.myArms:getLong(i,"gem3")]['power']
            end
            if dd.myArms:getLong(i,"gem4") > 0 then
                power = power + dd.cfgGems[dd.myArms:getLong(i,"gem4")]['power']
            end
            dd.myArms:setLong(i,"power",power)
        end
    else
        dd.myArms:addStreamCol("power",ff.NET_LONG)
    end  
end
function login_taskEx(result)
    if dd.myTasks ~= nil then
        dd.myTasks:clear()
    end
    dd.myTasks = ff.NetTable:create(true) 
    dd.myTasks:addStreamCol("builds",ff.NET_LONG)
    dd.myTasks:addStreamCol("buildsState",ff.NET_LONG)
    dd.myTasks:addStreamCol("tec",ff.NET_LONG)
    dd.myTasks:addStreamCol("tecState",ff.NET_LONG)
    dd.myTasks:addStreamCol("heros",ff.NET_LONG)
    dd.myTasks:addStreamCol("herosState",ff.NET_LONG)
    dd.myTasks:addStreamCol("others",ff.NET_LONG)
    dd.myTasks:addStreamCol("othersState",ff.NET_LONG)

    dd.myTasks:addStreamCol("buildsPro",ff.NET_LONG)
    dd.myTasks:addStreamCol("tecPro",ff.NET_LONG)
    dd.myTasks:addStreamCol("herosPro",ff.NET_LONG)
    dd.myTasks:addStreamCol("othersPro",ff.NET_LONG)

    dd.myTasks:addStreamCol("recommendTask",ff.NET_LONG)
    local index = dd.myTasks:addRow()
    dd.myTasks:setLong(index,"builds",result:getLong())
    dd.myTasks:setLong(index,"buildsState",result:getLong())
    dd.myTasks:setLong(index,"tec",result:getLong())
    dd.myTasks:setLong(index,"tecState",result:getLong())
    dd.myTasks:setLong(index,"heros",result:getLong())
    dd.myTasks:setLong(index,"herosState",result:getLong())
    dd.myTasks:setLong(index,"others",result:getLong())
    dd.myTasks:setLong(index,"othersState",result:getLong())

    dd.myTasks:setLong(index,"buildsPro",result:getLong())
    dd.myTasks:setLong(index,"tecPro",result:getLong())
    dd.myTasks:setLong(index,"herosPro",result:getLong())
    dd.myTasks:setLong(index,"othersPro",result:getLong())
    dd.myTasks:setLong(index,"recommendTask",result:getLong())
end
--金币任务
function login_goldTaskEx(result)
    local rows = result:getLong()
    if dd.myGoldTasks ~= nil then
        dd.myGoldTasks:clear()
    end
    dd.myGoldTasks = ff.NetTable:create(true) 
    dd.myGoldTasks:addStreamCol("id",ff.NET_LONG)
    dd.myGoldTasks:addStreamCol("state",ff.NET_LONG)
    dd.myGoldTasks:addStreamCol("starttime",ff.NET_LONG)
    dd.myGoldTasks:addStreamCol("endtime",ff.NET_LONG)
    dd.myGoldTasks:addStreamCol("progress1",ff.NET_LONG)
    dd.myGoldTasks:addStreamCol("progress2",ff.NET_LONG)
    dd.myGoldTasks:addStreamCol("progress3",ff.NET_LONG)
    dd.myGoldTasks:addStreamCol("param1",ff.NET_LONG)
    dd.myGoldTasks:addStreamCol("param2",ff.NET_LONG)
    dd.myGoldTasks:addStreamCol("param3",ff.NET_LONG)
    dd.myGoldTasks:addStreamCol("param4",ff.NET_LONG)
    dd.myGoldTasks:addStreamCol("param5",ff.NET_LONG)
    
    if rows > 0 then
        result:getData(rows,dd.myGoldTasks)
    end
end
--晶体
function login_CrystalsEx(result)
    local rows = result:getLong()
    if dd.myCrystals ~= nil then
        dd.myCrystals:clear()
    end    
    dd.myCrystals = ff.NetTable:create(true)
    dd.myCrystals:addStreamCol("cid",ff.NET_LONG)
    dd.myCrystals:addStreamCol("id",ff.NET_LONG)
    dd.myCrystals:addStreamCol("level",ff.NET_LONG)
    dd.myCrystals:addStreamCol("curexp",ff.NET_LONG)
    dd.myCrystals:addStreamCol("heroid",ff.NET_LONG)
    dd.myCrystals:addStreamCol("pos",ff.NET_LONG)
    
    if rows > 0 then
        result:getData(rows, dd.myCrystals)
    end  
end

--联盟科技
function login_UnionTecEx(result)
    local rows = result:getLong()
    if dd.myUnionTecs ~= nil then
        dd.myUnionTecs:clear()
    end
    dd.myUnionTecs = ff.NetTable:create(true)
    dd.myUnionTecs:addStreamCol("id",ff.NET_LONG)
    dd.myUnionTecs:addStreamCol("level",ff.NET_LONG)
    dd.myUnionTecs:addStreamCol("exp",ff.NET_LONG)  
    dd.myUnionTecs:addStreamCol("startime",ff.NET_LONG)
    dd.myUnionTecs:addStreamCol("endtime",ff.NET_LONG)  
    
    if rows > 0 then
        result:getData(rows, dd.myUnionTecs)
    end  
end

--解锁地块
function login_LockPosEx(result)
    local rows = result:getLong()
    if dd.myLocks ~= nil then
        dd.myLocks:clear()
    end
    dd.myLocks = ff.NetTable:create() 
    dd.myLocks:addStreamCol("pos",ff.NET_LONG)
    
    if rows > 0 then
        result:getData(rows,dd.myLocks)
    end
end

function login_GrowthFund(result)
    local rows = result:getLong()
    if dd.myGrowthFund ~= nil then
        dd.myGrowthFund:clear()
    end
    dd.myGrowthFund = ff.NetTable:create() 
    dd.myGrowthFund:addStreamCol("type",ff.NET_LONG)
    dd.myGrowthFund:addStreamCol("state",ff.NET_LONG)
    
    if rows > 0 then
        result:getData(rows,dd.myGrowthFund)
    end
end

function login_Activity(result)

    dd.myinfo:setLong(1,"ActiveType",result:getLong())
    dd.myinfo:setLong(1,"ActiveID",result:getLong())
    dd.myinfo:setLong(1,"ActiveBegin",result:getLong())
    dd.myinfo:setLong(1,"ActiveEnd",result:getLong())

    dd.myinfo:setLong(1,"LastCityFirmnessTime",result:getLong())
    dd.myinfo:setLong(1,"CityFirmnessByTime",result:getLong())
    dd.myinfo:setLong(1,"MaxCityFirmness",result:getLong())
    dd.myinfo:setLong(1,"GeneralPrisonCnt",result:getLong())
    dd.myinfo:setLong(1,"GeneralPrisonerCnt",result:getLong())
end

function login_end(result)
    result:clear()
end
