--tjf 邮件
dd.Tjf_Mail_GetNewMailAmount = 7689 --玩家未读邮件数量查询 
dd.Tjf_Mail_GetMailList = 0x1E0A --玩家邮件列表查询
dd.Tjf_Mail_GetMailContent = 7691 --玩家邮件内容查询
dd.Tjf_Mail_GetSavedMailList = 7692 --玩家已收藏邮件列表查询=======
dd.Tjf_Mail_SendMail = 0x1F08 --发送邮件=======
dd.Tjf_Mail_MailAction = 7945--邮件操作
dd.Tjf_Mail_SaveMail = 7946--邮件收藏操作

function mail_addEventListener()
   
    --8.1.9.    玩家未读邮件数量查询
    ff.net:addEventListener(dd.Tjf_Mail_GetNewMailAmount,mail_getNewMailAmount)
    --8.1.10.   玩家邮件列表查询
    ff.net:addEventListener(dd.Tjf_Mail_GetMailList,mail_getMailList)
    --8.1.11.   玩家邮件内容查询
    ff.net:addEventListener(dd.Tjf_Mail_GetMailContent,mail_getMailContent)
    --8.1.12.   玩家已收藏邮件列表查询
    ff.net:addEventListener(dd.Tjf_Mail_GetSavedMailList,mail_getSavedMailList)
    --8.2.8.    发送邮件
    ff.net:addEventListener(dd.Tjf_Mail_SendMail,mail_sendMail)
    --8.2.9.  邮件操作
    ff.net:addEventListener(dd.Tjf_Mail_MailAction,mail_mailAction)
    --8.2.10.  邮件收藏操作
    ff.net:addEventListener(dd.Tjf_Mail_SaveMail,mail_saveMail)

end

function mail_peekNewMailCount()
    local message = ff.net:createMessage()
    ff.net:addCmd(message,0x00000E09)
    message:addLong(dd.uid)
    ff.net:postMessage(message)
end


function mail_getNewMailAmount(result)
    if result ~= nil then
        local ret = result:getLong()
        local type = result:getLong()
        dd.myinfo:setLong(1,"urumail",result:getLong())
        dd.myinfo:setLong(1,"ursmail",result:getLong())
        dd.myinfo:setLong(1,"uruionmail",result:getLong())
        cclog("======================11111111111111111111111============================".. dd.myinfo:getLong(1,"uruionmail"))
        
        result:clear()
    end 
end
function mail_getMailList(result)
    --cclog("recv====================")
    local ret = result:getLong()
    local mailNum = 0
    local allMailNum = 0
    local searchtype = 1
    local mtype = 0
    local table = {}
    if ret == 0 then
        mtype = result:getLong()
        allMailNum = result:getLong()
        searchtype = result:getLong()
        mailNum = result:getLong()
        table.allMailNum = allMailNum
        table.mailNum = mailNum
        table.mtype   = mtype
        table.searchtype = searchtype

        cclog('总邮件数:'..allMailNum)
        cclog('本次返回邮件数:'..mailNum)

        --fatality 必须判断是否>0防止内存泄漏
        if mailNum > 0 then
            local info=ff.NetTable:create()
            info:addStreamCol("id",ff.NET_SUPER_LONG)
            info:addStreamCol("time",ff.NET_LONG)
            info:addStreamCol("mail_type",ff.NET_LONG)
            info:addStreamCol("sender_uid",ff.NET_LONG)
            info:addStreamCol("sender",ff.NET_STRING,15)
            info:addStreamCol("sender_union",ff.NET_STRING,3)
            info:addStreamCol("title",ff.NET_STRING,63)
            info:addStreamCol("content",ff.NET_STRING,31)
            info:addStreamCol("read_flag",ff.NET_LONG)
            
            result:getData(mailNum, info)
            info:addStreamCol("selected",ff.NET_LONG)
            info:addStreamCol("to_uid",ff.NET_LONG)

            for var=1, info:rowCount() do
                --cclog("==============="..info:getLong(var,"read_flag"))
                info:setLong(var,'selected',0)
                info:setLong(var,'to_uid',0)
                
                if info:getLong(var,"sender_uid") == 0 then

                    local str = info:getString(var,"content")
              
                    local str11 = SplitEx(str,",",1)
                    if tonumber(str11[1]) ~= 0 then
                        local tt = ff.langString(notify[tonumber(str11[1])])..str11[2]
                        info:setString(var,"content",tt)
                    else
                        info:setString(var,"content",str11[2])
                    end
           
                    str = info:getString(var,"title")
                    str11 = SplitEx(str,",",1)
                    if tonumber(str11[1]) ~= 0 then
                        local tt = ""
                        if str11[2] ~= nil then
                            tt = ff.langString(notify[tonumber(str11[1])])..str11[2]
                        else
                            tt = ff.langString(notify[tonumber(str11[1])])
                        end
                        info:setString(var,"title",tt)
                    else
                        if str11[2] ~= nil then
                            info:setString(var,"title",str11[2])
                        else
                            info:setString(var,"title",ff.langString(notify[tonumber(str11[1])]))
                        end
                        
                    end
                end
            end
            table.info = info
        end    
        ff.dbmanager:sql_nettable(info,"client_recv_user_mail")
        result:clear()
        return table
    else
        result:clear()
        return nil
    end
end
function mail_getMailContent(result)
    local ret = result:getLong()
    if ret == 0 then
        cclog('获得邮件内容')
        local info=ff.NetTable:create()
        info:addStreamCol("id",ff.NET_SUPER_LONG)
        info:addStreamCol("time",ff.NET_LONG)
        info:addStreamCol("mail_type",ff.NET_LONG)
        info:addStreamCol("sender_uid",ff.NET_LONG)
        info:addStreamCol("sender",ff.NET_STRING,15)
        info:addStreamCol("sender_union",ff.NET_STRING,3)
        info:addStreamCol("title",ff.NET_STRING,63)
        info:addStreamCol("detail",ff.NET_STRING,4095)
        info:addStreamCol("read_flag",ff.NET_LONG)
        info:addStreamCol("lang",ff.NET_STRING,15)
        info:addStreamCol("issend",ff.NET_LONG)
        info:addStreamCol("receiveid",ff.NET_SUPER_LONG)

        result:getData(1, info)
        --cclog("===="..info:getSuperLong(1,"id").."=============="..info:getLong(1,"read_flag"))
        
        if ff._and(info:getLong(1,"read_flag"),1) ~= 1 and dd.myinfo:getLong(1,"urumail") > 0  then
            if info:getLong(1,"mail_type") == 1 then
                dd.myinfo:setLong(1,"uruionmail",(dd.myinfo:getLong(1,"uruionmail")  -1 ))

            end
                dd.myinfo:setLong(1,"urumail",(dd.myinfo:getLong(1,"urumail")  -1 ))
                --info:setLong(1,"read_flag",1)
            --end
        end
        --cclog("sender===="..info:getSuperLong(1,"id"))
        --cclog("receiveid===213123123=====".. info:getString(1,"detail"))
        if info:getLong(1,"sender_uid") == 0 then

            local str = info:getString(1,"detail")
            --cclog("123==="..str)
            local str11 = SplitEx(str,",",1)
            if tonumber(str11[1]) ~= 0 then
                local tt = ""
                if tonumber(str11[1]) == 80 then
                    local item = Split(str11[2],"%^")
                    tt = ff.langString(notify[tonumber(str11[1])],{ff.langString("金币")}).." X"..item[3]
                else
                    --cclog("==12=="..str11[1].."ssdfdsf=="..str11[2])
            
                    if tonumber(str11[2]) == 0 then
                        tt = ff.langString(notify[tonumber(str11[1])])
                        --cclog("123=========sdf==="..tt)
                    else
                        tt = ff.langString(notify[tonumber(str11[1])])..str11[2]
                        --cclog("fwdasd=========sdf==="..tt)
                    end
                end
                
                info:setString(1,"detail",tt)
            else
                info:setString(1,"detail",str11[2])
            end
           
            str = info:getString(1,"title")
            str11 = SplitEx(str,",",1)
            if tonumber(str11[1]) ~= 0 then
                local tt = ""
                if str11[2] ~= nil then
                     tt = ff.langString(notify[tonumber(str11[1])])..str11[2]
                else
                    tt = ff.langString(notify[tonumber(str11[1])])
                end
                info:setString(1,"title",tt)
            else
                if str11[2] ~= nil then
                    info:setString(1,"title",str11[2])
                else
                    info:setString(1,"title",ff.langString(notify[tonumber(str11[1])]))
                end
                
            end
        end
        if info ~= nil and info:rowCount() == 1 then
            local id = info:getSuperLong(1,"id")
            ff.dbmanager:sql_query("update client_recv_mail set `detail`='"..info:getString(1,"detail").."',`receiveid`='"..info:getSuperLong(1,"receiveid").."',`lang`='"..info:getString(1,"lang").."' where `id`='"..id.."'")
        end    
        result:clear()
        return info
    else
        result:clear()
        return nil
    end
end
function mail_getSavedMailList(result)
    local ret = result:getLong()
    if ret == 0 then
        local mtype = result:getLong()
        local allMailNum = result:getLong()
        local mailNum = result:getLong()
        cclog("mtype:"..mtype)

        cclog('总收藏数:'..allMailNum)
        cclog('本次返回收藏数:'..mailNum)
        local table = {}
        table.allMailNum = allMailNum
        table.mailNum = mailNum
        table.mtype   = mtype

        if mailNum > 0 then
            local info=ff.NetTable:create()
            info:addStreamCol("id",ff.NET_SUPER_LONG)
            info:addStreamCol("time",ff.NET_LONG)
            info:addStreamCol("mail_type",ff.NET_LONG)
            info:addStreamCol("sender_uid",ff.NET_LONG)
            info:addStreamCol("sender",ff.NET_STRING,15)
            info:addStreamCol("sender_union",ff.NET_STRING,3)
            info:addStreamCol("title",ff.NET_STRING,63)
            info:addStreamCol("content",ff.NET_STRING,31)
            info:addStreamCol("group",ff.NET_LONG)
            result:getData(mailNum, info)
            info:addStreamCol("selected",ff.NET_LONG)
            for var=1, info:rowCount() do
                info:setLong(var,'selected',0)
                cclog("====="..info:getSuperLong(var,"id"))
            end
            table.info = info
        end    
        result:clear()
        return table
    else
        result:clear()
        return nil    
    end
end

function mail_sendMail(result)
    local ret = result:getLong()
    if ret == 0 then
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("发送邮件成功"),true)
        local widget = pop.getDialog("mailWrite")
        if widget ~= nil then
            widget.onReturn(widget:getChildByName("top"):getChildByName("return"),ccui.TouchEventType.ended)
        end
    else
        dd.mainUI:onShowCodeTips(ret)
    end
    result:clear()
    return ret
end

function mail_mailAction(result)
    local ret = result:getLong()
    if ret == 0 then
        local table = {}
        local opType = result:getLong()
        local mailNum = result:getLong()
        if opType == 1  or opType == 3 then
            cclog("标记已删除")
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("删除成功"),true)
        elseif opType == 2 then
            cclog("标记已读")
        end
        local info=ff.NetTable:create()
        info:addStreamCol("id",ff.NET_SUPER_LONG)
        if mailNum > 0 then
            result:getData(mailNum,info)
        end    
        cclog("row:"..info:rowCount())
        for i=1,info:rowCount() do
            print(info:getSuperLong(i,"id"))
        end
        table.opType = opType
        table.mailNum = mailNum
        table.info = info
        result:clear()
        return table
    else
        result:clear()
        return nil
    end
end

function mail_saveMail(result)
    local ret = result:getLong()
    if ret == 0 then
        local table = {}
        table.op = result:getLong()
        table.type = result:getLong()
        table.id   = result:getSuperLong()
        result:clear()
        if table.op == 1 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("收藏成功"),true)
        elseif table.op == 2 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("取消收藏成功"),true)
        end
        return table
    else
        result:clear()
        return nil
    end
end