dd.Tjf_prop_buy  = 0x00001121
dd.Tjf_prop_use = 0x0000110a
dd.Tjf_prop_info = 0x0000100a       --查询道具信息
dd.Tjf_crystal_info = 0x00001044    --查询晶体信息
dd.Tjf_crystal_upgrade = 0x0000115f --晶体吞噬
dd.Tjf_crystal_set = 0x00001160     --设置英雄晶体
dd.Tjf_gem_compose = 0x0000111e
dd.Tjg_equip_forge = 0x00001111
dd.Tjg_equip_set_gem = 0x00001112
dd.Tjg_lottery_paid = 0x00001179
dd.Tjg_LotteryHolidayAction = 0x0000117a
--老虎机
dd.Tjf_lottery = 0x0000115e
function prop_addEventListener()
    ff.net:addEventListener(dd.Tjf_prop_buy, onBuyPropAction)
    ff.net:addEventListener(dd.Tjf_prop_use, onUsePropAction)
    ff.net:addEventListener(dd.Tjf_prop_info, onGetMyPropsInfo)
    ff.net:addEventListener(dd.Tjf_crystal_info, onGetMyCrystalInfo)
    ff.net:addEventListener(dd.Tjf_crystal_upgrade, onCrystalUpgrade)
    ff.net:addEventListener(dd.Tjf_crystal_set, onCrystalSet)
    ff.net:addEventListener(dd.Tjf_gem_compose,onGemCompose)
    ff.net:addEventListener(dd.Tjg_equip_forge,onEquipGorge)
    ff.net:addEventListener(dd.Tjg_equip_set_gem,onEquipSetGem)
    ff.net:addEventListener(dd.Tjg_lottery_paid,onLotteryPaid)
    ff.net:addEventListener(dd.Tjg_LotteryHolidayAction,onLotteryHolidayAction)
    ff.net:addEventListener(dd.Tjf_lottery, onLottery)
end


function onBuyPropAction(message)
	local result = message:getLong()
	cclog("on buy prop action=========="..result)
	if result == 0 then
		local pid = message:getLong()
		local buyNum = message:getLong()
		local curNum = message:getLong()
		local curMoney = message:getLong()

		dd.setToolCount(pid, curNum)
		dd.myinfo:setLong(1, "gold", curMoney)
        if pid == 1061 and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功购买{0}个{1}道具 ！",{buyNum,ff.langString(dd.cfgProp[pid]["name"])}),true)
        end
		message:clear()
		return {result, pid, curNum}
	end
	message:clear()
	return {result}
end


function onUsePropAction(message)
	local result = message:getLong()
	cclog("on use prop acition=========="..result)
	if result == 0 then
		local pid = message:getLong()
		local num = message:getLong()
		local param = message:getLong()
		local gold = message:getLong()

        if pid > 0 then
    		dd.setToolCount(pid, num)
        end
		dd.myinfo:setLong(1, "gold", gold)

		message:clear()
        --dd.currentLayer._widget:onShowTips("\t"..ff.langString("道具使用成功 ！"),true)
		return {result, pid, num}
    else
        dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(result))
	end
	message:clear()
	return {result}
end

function onGetMyPropsInfo(message)
    local code = message:getLong()
    if code == 0 then
        local num = message:getLong()
        
        local info=ff.NetTable:create()
        info:addStreamCol("tid",ff.NET_LONG)
        info:addStreamCol("count",ff.NET_LONG)
        message:getData(num, info)        
        
        message:clear()  
        return {code, info}
    else
        message:clear()
        return {code}
    end
end

function onGemCompose( message )
    -- body
    local code = message:getLong()
    if code == 0 then
        local composeId = message:getLong()
        local getitemid = message:getLong()
        local getitemadd = message:getLong()
        local getitemcnt = message:getLong()
        dd.setToolCount(getitemid,getitemcnt)
        local silver = message:getLong()
        dd.silver(silver)
        local n = message:getLong()
        for i=1,n do
            local itemid = message:getLong()
            local itemcnt = message:getLong()
            dd.setToolCount(itemid,itemcnt)
        end
        message:clear()  
        return {code}
    else
        message:clear()
        return {code}
    end
end

function onEquipGorge( message )
    -- body
    local code = message:getLong()
   
    if code == 0 then
        local type = message:getLong()
        local start   = message:getLong()
        local endtime = message:getLong()
        local param1 = message:getLong()
        local param2 = message:getLong()
        local param3 = message:getLong()
        local param4 = message:getLong()
        local item1id = message:getLong()
        local item1cout = message:getLong()
        dd.setToolCount(item1id,item1cout)
        local item2id = message:getLong()
        local item2cout = message:getLong()
        dd.setToolCount(item2id,item2cout)
        local item3id = message:getLong()
        local item3cout = message:getLong()
        dd.setToolCount(item3id,item3cout)
        local item4id = message:getLong()
        local item4cout = message:getLong()
        dd.setToolCount(item4id,item4cout)
        local equiptid = message:getLong()
        local silver = message:getLong()
       -- cclog("===================="..silver)
        dd.silver(silver)
        if tonumber(equiptid) > 0 then
            for i=1,dd.myArms:rowCount() do
                if dd.myArms:getLong(i,"tid") == tonumber(equiptid) then
                dd.myArms:delRow(i)
                end
            end
        end
        if start > 0 then
            local row = dd.mylists:addRow()
            dd.mylists:setLong(row,"type",type)
            dd.mylists:setLong(row,"start",start)
            dd.mylists:setLong(row,"end",endtime)
            dd.mylists:setLong(row,"param1",param1)
            dd.mylists:setLong(row,"param2",param2)
            dd.mylists:setLong(row,"param3",param3)
            dd.mylists:setLong(row,"param4",param4)
        end
        message:clear()  
        return {code}
    else
        message:clear()
        return {code}
    end
end

function onEquipSetGem( message )
    local code = message:getLong()
    if code == 0 then
        local type = message:getLong()
        local eid = message:getLong()
        local holeindex = message:getLong()
        local gemid = message:getLong()
        local heropower = message:getLong()
        local lordpower = message:getLong()
        local silver = message:getLong()
        local itemid = message:getLong()
        local itemCnt = message:getLong()
        dd.setToolCount(itemid,itemCnt)
        dd.silver(silver)
        dd.myinfo:setLong(1,"power",lordpower)
        for i=1,dd.myArms:rowCount() do
            if dd.myArms:getLong(i,"tid") == eid then
                dd.myArms:setLong(i,"gem"..holeindex,gemid)
                local power = dd.cfgArms[dd.myArms:getLong(i,"aid")]['power']
                if dd.myArms:getLong(i,"gem1") > 0 then
                    power = power + dd.cfgGems[dd.myArms:getLong(i,"gem1")]['power']
                end
                if dd.myArms:getLong(i,"gem2") > 0 then
                    power = power + dd.cfgGems[dd.myArms:getLong(i,"gem2")]['power']
                end
                if dd.myArms:getLong(i,"gem3") > 0 then
                    power = power + dd.cfgGems[dd.myArms:getLong(i,"gem3")]['power']
                end
                if dd.myArms:getLong(i,"gem4") > 0 then
                    power = power + dd.cfgGems[dd.myArms:getLong(i,"gem4")]['power']
                end
                dd.myArms:setLong(i,"power",power)
                if dd.myArms:getLong(i,"heroid") ~= 0 then
                    for j=1,dd.heros:rowCount() do
                        if dd.myArms:getLong(i,"heroid") == dd.heros:getLong(j,"hid") then
                            dd.heros:setLong(j,"power",heropower)
                        end
                    end
                end
                break
            end
        end
        return {code,type,eid}
    else
        message:clear()
        return {code}
    end
end

function onLotteryPaid(message )
    -- body
   ---cclog("getonLotteryPaidonLotteryPaidonLotteryPaidonLotteryPaidonLotteryPaid")
    local code = message:getLong()
    if code == 0 then
        local type = message:getLong()
        local pos = message:getLong()
        local coinCnt = message:getLong()
        local gold = message:getLong()
        local itemId = message:getLong()
        local itemGetCnt = message:getLong()
        local itemCnt = message:getLong()
        cclog("=====================")
        cclog(itemId.."=="..itemCnt)
        dd.setToolCount(2041, coinCnt)
        dd.myinfo:setLong(1, "gold", gold)
        if itemId > 0 then
            dd.setToolCount(itemId, itemCnt)
        end
        --cclog("========"..itemId.."="..itemCnt)
        message:clear()  
        return {code,itemId,itemGetCnt,type}
    else
        message:clear()
        return {code}
    end
end

function onLotteryHolidayAction(message )
    -- body
   ---cclog("getonLotteryPaidonLotteryPaidonLotteryPaidonLotteryPaidonLotteryPaid")
    local code = message:getLong()
    if code == 0 then
        local type = message:getLong()
        local pos = message:getLong()
        
        local itemId1 = message:getLong()
        
        local itemCnt1 = message:getLong()
        local gold = message:getLong()
        dd.setToolCount(itemId1, itemCnt1)
        dd.myinfo:setLong(1, "gold", gold)
        local itemId = message:getLong()
        local itemGetCnt = message:getLong()
        local itemCnt = message:getLong()
        if itemId > 0 then
            dd.setToolCount(itemId, itemCnt)
        end
        --cclog("========"..itemId.."="..itemCnt)
        message:clear()  
        return {code,itemId,itemGetCnt,type}
    else
        message:clear()
        return {code}
    end
end


function onGetMyCrystalInfo(message)
    local code = message:getLong()
    if code == 0 then
        local num = message:getLong()

        local info=ff.NetTable:create()
        info:addStreamCol("cid",ff.NET_LONG)
        info:addStreamCol("id",ff.NET_LONG)
        info:addStreamCol("level",ff.NET_LONG)
        info:addStreamCol("curexp",ff.NET_LONG)
        info:addStreamCol("heroid",ff.NET_LONG)
        info:addStreamCol("pos",ff.NET_LONG)
        message:getData(num, info)        
        
        dd.myCrystals = ff.NetTable:create(true)
        dd.myCrystals = info
        
        message:clear()  
        return {code, info}
    else
        message:clear()
        return {code}
    end
end

function onCrystalUpgrade(message)
    local code = message:getLong()
    if code == 0 then
        local cid = message:getLong()
        local type = message:getLong()
        local level = message:getLong()
        local curexp = message:getLong()
        local heroid = message:getLong()
        local pos = message:getLong()
        
        local heropower = message:getLong()
        local upower = message:getLong()
        local cry1 = message:getLong()
        local cry2 = message:getLong()
        local cry3 = message:getLong()
        local cry4 = message:getLong()
        local cry5 = message:getLong()
        local cry6 = message:getLong()
        local cry7 = message:getLong()
        local cry8 = message:getLong()
        
        --维护晶体信息        
        local k = 1
        for i=1,dd.myCrystals:rowCount() do
            if dd.myCrystals:getLong(k,"cid") ~= 0 then
                if dd.myCrystals:getLong(k,"cid") == cid then
                    dd.myCrystals:setLong(k,"heroid",heroid)
                    dd.myCrystals:setLong(k,"curexp",curexp)
                    dd.myCrystals:setLong(k,"pos",pos)
                    dd.myCrystals:setLong(k,"level",level)
                elseif dd.myCrystals:getLong(k,"cid") == cry1 then
                    dd.myCrystals:delRow(k)
                    k = k-1
                elseif dd.myCrystals:getLong(k,"cid") == cry2 then
                    dd.myCrystals:delRow(k)
                    k = k-1
                elseif dd.myCrystals:getLong(k,"cid") == cry3 then
                    dd.myCrystals:delRow(k)
                    k = k-1
                elseif dd.myCrystals:getLong(k,"cid") == cry4 then
                    dd.myCrystals:delRow(k)
                    k = k-1
                elseif dd.myCrystals:getLong(k,"cid") == cry5 then
                    dd.myCrystals:delRow(k)
                    k = k-1
                elseif dd.myCrystals:getLong(k,"cid") == cry6 then
                    dd.myCrystals:delRow(k)
                    k = k-1
                elseif dd.myCrystals:getLong(k,"cid") == cry7 then
                    dd.myCrystals:delRow(k)
                    k = k-1
                elseif dd.myCrystals:getLong(k,"cid") == cry8 then
                    dd.myCrystals:delRow(k)
                    k = k-1
                end
            end
            k = k+1
        end 
        
        message:clear()  
        return {code}
    else
        message:clear()
        return {code}
    end
end

function onCrystalSet(message)
    local code = message:getLong()
    if code == 0 then
        local hid = message:getLong()
        local pos = message:getLong()
        local curcid = message:getLong()
        local dropcid = message:getLong()  --脱下id
        
        local heropower  = message:getLong()
        local user_power = message:getLong()
        dd.myinfo:setLong(1,"power",user_power)
        --维护英雄信息
        for i=1,dd.heros:rowCount() do
            if dd.heros:getLong(i,"hid") == hid then
                dd.heros:setLong(i,"tools"..pos,curcid)
                dd.heros:setLong(i,"power",heropower)
                break
            end
        end   
        --维护晶体信息
        for i=1,dd.myCrystals:rowCount() do
            if dd.myCrystals:getLong(i,"cid") == curcid then
                dd.myCrystals:setLong(i,"heroid",hid)
                dd.myCrystals:setLong(i,"pos",pos)
            end
            if dd.myCrystals:getLong(i,"cid") == dropcid then
                dd.myCrystals:setLong(i,"heroid",0)
                dd.myCrystals:setLong(i,"pos",0)
            end
        end  
        
        message:clear()  
        return {code,curcid}
    else
        message:clear()
        return {code}
    end
end
function onLottery(message)
    local code = message:getLong()
    if code == 0 then
        local handletype = message:getLong()
        local inputGold = message:getLong()
        local usGold = message:getLong()
        local residueGold = message:getLong()
        local resultdiscrp = message:getLong()
        local luky = message:getLong()

        local nCount = message:getLong()
  
        local info = ff.NetTable:create()
            info:addStreamCol("times",ff.NET_LONG)
            info:addStreamCol("id",ff.NET_LONG)  
            info:addStreamCol("getnum",ff.NET_LONG)
        message:getData(nCount,info)
         
        message.clear()

        dd.setToolCount(1024, residueGold)

        return {code, residueGold, resultdiscrp, info, nCount, luky}
    else
        return {code}
    end
end