cmd=cmd or {}

dd.Tjf_getUnionWarInfo = 0x00001023--查询联盟战争详情

dd.Tjf_unlockUnionWarSite = 0x0000112d--开启联盟战争军队位置
dd.Tjf_unionWarNotify = 0x1000000e--联盟战争通知
dd.Tjf_unionWarAddItemNotify = 0x1000000b--联盟战争槽位信息通知
dd.Tjf_unionWarAllyWarCancel = 0x00001166--取消联合攻击
dd.Tjf_unionWarAllyWarReturn = 0x00001167


function unionWar_addEventListener()
    ff.net:addEventListener(dd.Tjf_getUnionWarInfo,getUnionWarInfoBack)
    ff.net:addEventListener(dd.Tjf_unlockUnionWarSite,unlockUnionWarSiteBack)
    ff.net:addEventListener(dd.Tjf_unionWarNotify,unionWarNotify)
    ff.net:addEventListener(dd.Tjf_unionWarAddItemNotify,unionWarAddItemNotify)

    ff.net:addEventListener(dd.Tjf_unionWarAllyWarCancel,onAllyWarCancel)
    --遣返
    ff.net:addEventListener(dd.Tjf_unionWarAllyWarReturn,onUnionWarAllyWarReturn)
    
    
end

--查询联盟战争详情返回
function getUnionWarInfoBack(message)
 	local code = message:getLong()
 	cclog("getUnionWarInfoBack.....   code="..code)
    if code ==0 then
		local warType=message:getLong()
		local attackSite=message:getLong()
		local status=message:getLong()
		local statusStart=message:getLong()
		local statusEnd=message:getLong()
		local currentSoldiers=message:getLong()
		local maxSoldiers=message:getLong()
		local slotOpened=message:getLong()
		local buildMapID=message:getLong()
		local fighting=message:getLong()

        local nums=message:getLong()
        cclog("getUnionWarInfoBack.....   nums="..nums..",power:"..fighting)

		local info=ff.NetTable:create()
		info:addStreamCol("uid",ff.NET_LONG)
		info:addStreamCol("name",ff.NET_STRING,15)
		info:addStreamCol("face",ff.NET_LONG)
		info:addStreamCol("startTime",ff.NET_LONG)
		info:addStreamCol("arrival",ff.NET_LONG)
		info:addStreamCol("heroName",ff.NET_STRING,15)
		info:addStreamCol("heroGID",ff.NET_LONG)
		info:addStreamCol("heroLevel",ff.NET_LONG)
		--info:addStreamCol("statusStart",ff.NET_LONG)
		--info:addStreamCol("statusEnd",ff.NET_LONG)
		
		info:addStreamCol("b1",ff.NET_LONG)
		info:addStreamCol("b2",ff.NET_LONG)
		info:addStreamCol("b3",ff.NET_LONG)
		info:addStreamCol("b4",ff.NET_LONG)
		info:addStreamCol("b5",ff.NET_LONG)
		info:addStreamCol("b6",ff.NET_LONG)
		
		info:addStreamCol("q1",ff.NET_LONG)
		info:addStreamCol("q2",ff.NET_LONG)
		info:addStreamCol("q3",ff.NET_LONG)
		info:addStreamCol("q4",ff.NET_LONG)
		info:addStreamCol("q5",ff.NET_LONG)
		info:addStreamCol("q6",ff.NET_LONG)
		
		info:addStreamCol("g1",ff.NET_LONG)
		info:addStreamCol("g2",ff.NET_LONG)
		info:addStreamCol("g3",ff.NET_LONG)
		info:addStreamCol("g4",ff.NET_LONG)
		info:addStreamCol("g5",ff.NET_LONG)
		info:addStreamCol("g6",ff.NET_LONG)
		
		info:addStreamCol("w1",ff.NET_LONG)
		info:addStreamCol("w2",ff.NET_LONG)
		info:addStreamCol("w3",ff.NET_LONG)
		info:addStreamCol("w4",ff.NET_LONG)
		info:addStreamCol("w5",ff.NET_LONG)
		info:addStreamCol("w6",ff.NET_LONG)
		
		info:addStreamCol("gInfantryNums",ff.NET_LONG)
		info:addStreamCol("gInfantryLevel",ff.NET_LONG)
		info:addStreamCol("gCavalryNums",ff.NET_LONG)
		info:addStreamCol("gCavalryLevel",ff.NET_LONG)
		info:addStreamCol("gArcherNums",ff.NET_LONG)
		info:addStreamCol("gArcherLevel",ff.NET_LONG)
		
		info:addStreamCol("unionJob",ff.NET_LONG)--联盟官职
		
		message:getData(nums, info)
		message:clear()

				
		
		return {code=0,buildMapID=buildMapID,slotOpened=slotOpened,currentSoldiers=currentSoldiers,maxSoldiers=maxSoldiers,fighting=fighting,type=warType,status=status,site=attackSite,statusStart=statusStart,statusEnd=statusEnd,data=info}
    else
     	cclog(dd.errorCode(code))
     	return {code=code}
  	end
  	message:clear()
end


--开启格子
--uid 发起者编号
--type 1=道具开启 2=Get&Use 没道具直接花钱完成
function cmd.unlockUnionWarSite(uid,type)
	local message = ff.net:createMessage()
    ff.net:addCmd(message,0x0000012d)
    message:addLong(dd.uid)
    
    message:addLong(type)
    message:addLong(uid)
    ff.net:rpc(message,false)
end

function unlockUnionWarSiteBack(message)
	local code = message:getLong()
 	cclog("unlockUnionWarSiteBack.....   code="..code)
 	local tab={}
 	tab.code=code
    if code ==0 then
		tab.nAction=message:getLong()
		tab.nLeaderID=message:getLong()
		tab.nSlot=message:getLong()
		tab.nItemID=message:getLong()
		tab.nItemCnt=message:getLong()
		dd.setToolCount(tab.nItemID,tab.nItemCnt)
		--
		tab.nGold=message:getLong()
		dd.myinfo:setLong(1,"gold",tab.nGold)
	end
	message:clear()
	return tab
end

--联盟战争通知
function unionWarNotify(message)
	local uid    = message:getLong()
	local reason = message:getLong()
	local id     = 0

	local type = message:getLong()
	local state = message:getLong()
	local start   = message:getLong()
	local endtime = message:getLong()
	local attackUid= message:getLong()
	if reason == 1 or reason == 2 then
		for i=1,dd.myUnionBattle:rowCount() do
			if dd.myUnionBattle:getLong(i,"attackUid") == attackUid then
				id = attackUid
				dd.myUnionBattle:delRow(i)
				break
			end
		end
	else
		local row = 0
		for i=1,dd.myUnionBattle:rowCount() do
			if dd.myUnionBattle:getLong(i,"attackUid") == attackUid then
				row = i
				break
			end
		end
		if row == 0 then
			row = dd.myUnionBattle:addRow()
		end
		dd.myUnionBattle:setLong(row,"type",type)
		dd.myUnionBattle:setLong(row,"status",state)
		dd.myUnionBattle:setLong(row,"statusStart",start)
		dd.myUnionBattle:setLong(row,"statusEnd",endtime)
		dd.myUnionBattle:setLong(row,"attackUid",attackUid)

		dd.myUnionBattle:setLong(row,"attackServerid",message:getLong())
		dd.myUnionBattle:setLong(row,"site",message:getLong())

		dd.myUnionBattle:setLong(row,"unionid",message:getLong())
		dd.myUnionBattle:setString(row,"attackUnionFlag",message:getString(3))
		dd.myUnionBattle:setString(row,"attackUname",message:getString(15))
		dd.myUnionBattle:setLong(row,"unionOffical",message:getLong())
		dd.myUnionBattle:setLong(row,"targetType",message:getLong())
		dd.myUnionBattle:setLong(row,"attackedUid",message:getLong())

		dd.myUnionBattle:setLong(row,"attackedServerid",message:getLong())
		dd.myUnionBattle:setLong(row,"attackedSite",message:getLong())
		dd.myUnionBattle:setLong(row,"attackedUnionid",message:getLong())
		dd.myUnionBattle:setString(row,"attackedUnionFlag",message:getString(3))
		dd.myUnionBattle:setString(row,"attackedUname",message:getString(15))
		dd.myUnionBattle:setLong(row,"attackedUnionOffical",message:getLong())

		dd.myUnionBattle:setLong(row,"currentSoldiers",message:getLong())
		dd.myUnionBattle:setLong(row,"maxSoldiers",message:getLong())
	end
	message:clear()
	return {reason,id}
end

--联盟战争槽位信息通知
function unionWarAddItemNotify(message)

	local tab={}

	tab.uid=message:getLong()
	tab.attackUid=message:getLong()
	tab.nSlot=message:getLong()
	
	tab.newuid=message:getLong()
	tab.name=message:getString(15)
	tab.face=message:getLong()
	tab.nStart=message:getLong()
	tab.nArrival=message:getLong()
	tab.heroName=message:getString(15)
	tab.nHeroGID=message:getLong()
	tab.nHeroGrade=message:getLong()

	--总兵力
	tab.allSoilders=0
	
	tab.b1=message:getLong()
	tab.b2=message:getLong()
	tab.b3=message:getLong()
	tab.b4=message:getLong()
	tab.b5=message:getLong()
	tab.b6=message:getLong()
	

	tab.q1=message:getLong()
	tab.q2=message:getLong()
	tab.q3=message:getLong()
	tab.q4=message:getLong()
	tab.q5=message:getLong()
	tab.q6=message:getLong()
	

	tab.g1=message:getLong()
	tab.g2=message:getLong()
	tab.g3=message:getLong()
	tab.g4=message:getLong()
	tab.g5=message:getLong()
	tab.g6=message:getLong()
	
	tab.w1=message:getLong()
	tab.w2=message:getLong()
	tab.w3=message:getLong()
	tab.w4=message:getLong()
	tab.w5=message:getLong()
	tab.w6=message:getLong()
	
	tab.gInfantryNums=message:getLong()
	tab.gInfantryLevel=message:getLong()
	tab.gCavalryNums=message:getLong()
	tab.gCavalryLevel=message:getLong()
	tab.gArcherNums=message:getLong()
	tab.gArcherLevel=message:getLong()

	
	tab.unionJob=message:getLong()
	
	message:clear()
	return tab
end

function onAllyWarCancel(message)
	local code = message:getLong()
	message:clear()
	return code
end

function onUnionWarAllyWarReturn(message)
	local code = message:getLong()
	if code == 0 then
		local uid = message:getLong()
		message:clear()
		return {code,uid}
	end
	message:clear()
	return {code}
end