dd.Tjf_map_query_message = 0x1142
dd.Tjf_map_MapGetResourceDetail = 0x0000100c
dd.Tjf_map_MapGetCityDetail = 0x0000100b
dd.Tjf_map_MapGetCampDetail = 0x0000100d


dd.Tjf_map_notification = 0x10000002

dd.Tjf_map_army_notification = 0x10000003
dd.Tjf_map_res_notification = 0x10000006
dd.Tjf_map_camp_notification = 0x10000007
dd.Tjf_map_city_notification = 0x10000008
dd.Tjf_map_fort_notification = 0x10000019
dd.Tjf_map_npc_notification = 0x10000020
dd.Tjf_map_stronghold_notification = 0x10000023

dd.Tjf_map_battle_notification = 0x10000015

--迁城
dd.Tjf_map_CityMove = 0x00001137
--收藏
dd.Tjf_map_BookMarkAction = 0x00001124
--获取收藏列表
dd.Tjf_map_GetBookMarkLists = 0x00001019

--行军加速
dd.Tjf_map_MarchSpeedup = 0x0000112f

--联盟事件
dd.Tjf_map_UnionName  = 0x10000035
dd.Tjf_map_UnionShip  = 0x10000033

--获取联盟成员坐标
dd.Tjf_map_getAllyMap  = 0x0000104a

--获取联盟增援上限
dd.Tjf_chuzheng_limit  = 0x0000104e

dd.Tjf_map_peek = 0x0000104f
dd.Tjf_map_GetStrongholdLists = 0x0000105e
dd.Tjf_map_GetMyStrongholdLists = 0x00001060
dd.Tjf_map_SNMapStrongholdTower = 0x10000025
dd.Tjf_map_SNMapBubble = 0x10000043
function world_addEventListener()

	ff.net:addEventListener(dd.Tjf_map_query_message, mapQueryAction)		    --地图订阅
	ff.net:addEventListener(dd.Tjf_map_notification, mapNotificationAction)		--地图通知消息

	ff.net:addEventListener(dd.Tjf_map_res_notification, mapResNotificationAction)		        --地图资源通知消息
	ff.net:addEventListener(dd.Tjf_map_camp_notification, mapCampNotificationAction)		    --地图帐篷通知消息
	ff.net:addEventListener(dd.Tjf_map_city_notification, mapCityNotificationAction)		    --地图城市通知消息
	ff.net:addEventListener(dd.Tjf_map_army_notification, mapArmyNotificationAction)		    --地图军队通知消息
	ff.net:addEventListener(dd.Tjf_map_fort_notification, mapFortNotificationAction)		    --地图要塞通知消息
	ff.net:addEventListener(dd.Tjf_map_npc_notification, mapNpcNotificationAction)		        --地图NPC通知消息
	ff.net:addEventListener(dd.Tjf_map_stronghold_notification, mapStrongholdNotificationAction)		    --地图据点通知消息

	--查询资源点详细情况
	ff.net:addEventListener(dd.Tjf_map_MapGetResourceDetail,onMapGetResourceDetail)
	ff.net:addEventListener(dd.Tjf_map_MapGetCityDetail,onMapGetCityDetail)
	ff.net:addEventListener(dd.Tjf_map_MapGetCampDetail,onMapGetCityDetail)
	--飞城
	ff.net:addEventListener(dd.Tjf_map_CityMove,onCityMove)
    --收藏
    ff.net:addEventListener(dd.Tjf_map_BookMarkAction,onBookMarkAction)
    ff.net:addEventListener(dd.Tjf_map_GetBookMarkLists,onGetBookMarkLists,endGetBookMarkLists)
	-- ff.net:addEventListener(dd.Queue_Message_Action, canelComposeAction)

	ff.net:addEventListener(dd.Tjf_map_MarchSpeedup,onMarchSpeedup)

	ff.net:addEventListener(dd.Tjf_map_UnionName,onMapUnionName)
	ff.net:addEventListener(dd.Tjf_map_UnionShip,onMapUnionShip)

	ff.net:addEventListener(dd.Tjf_map_battle_notification,onSNMapFight)
	ff.net:addEventListener(dd.Tjf_map_getAllyMap,onGetAllyMap,onGetAllyMapRelease)

	ff.net:addEventListener(dd.Tjf_chuzheng_limit,onGetMemberReinforceInfo)
	--查看地块
	ff.net:addEventListener(dd.Tjf_map_peek,onMapGetTileDetail)
	ff.net:addEventListener(dd.Tjf_map_GetStrongholdLists,onMapGetStrongholdLists)
	ff.net:addEventListener(dd.Tjf_map_GetMyStrongholdLists,onGetMyStrongholdLists)
	ff.net:addEventListener(dd.Tjf_map_SNMapStrongholdTower,onSNMapStrongholdTower)
end
function onGetBookMarkLists(message)
    cclog("获取收藏列表")
    local code = message:getLong()
    if code == 0 then
        local num = message:getLong()
        local resTable = ff.NetTable:create()
        resTable:addStreamCol("type", ff.NET_LONG)      
        resTable:addStreamCol("cid", ff.NET_LONG)   
        resTable:addStreamCol("time", ff.NET_LONG)  
        resTable:addStreamCol("name", ff.NET_STRING,32)      
        cclog("收藏数量===================="..num)
        if num > 0 then
            message:getData(num,resTable)
        end
        message:clear()
        return {code,resTable}
    else
        cclog("onGetBookMarkLists:"..dd.errorCode(code))
        message:clear()
        return {code}
    end
end
function endGetBookMarkLists(ret)
    if ret[1] == 0 and ret[2] ~= nil then
        ret[2]:clear()
        ret[2] = nil
    end
end
function onBookMarkAction(message)
    cclog("地图收藏操作")
    local code = message:getLong()
    if code == 0 then
        local bookInfo = {}
        bookInfo['opType'] = message:getLong()  
        bookInfo['type'] = message:getLong() 
        bookInfo['pos'] = message:getLong()
        bookInfo['time'] = message:getLong()
        bookInfo['name'] = message:getString(15)
        message:clear()
        return {code,bookInfo}
    else
        cclog("onBookMarkAction:"..dd.errorCode(code))
        message:clear()
        return {code}
    end
end
function mapStrongholdNotificationAction(message)
	cclog("地图据点信息通知")
	return message
end

function mapNpcNotificationAction(message)
	cclog("地图NPC通知")
	local userId = message:getLong()
	local reason = message:getLong()   --通知原因
	local gid = message:getLong()
	local npcId = message:getLong()
	local hp = message:getLong()       --血量万分比
	local serverId = message:getLong()
	local areaId   = message:getLong()

	local ret = {reason,gid,npcId,areaId,hp}
	message:clear()
	return ret
end

function mapFortNotificationAction(message)
	cclog("联盟要塞通知")
	local userId = message:getLong()
	local reason = message:getLong()   --通知原因
	local gid = message:getLong()
	local avatar = message:getLong()   --要塞状态*10000+要塞等级*100+战火状态*10+敌友标志

	local unionId = message:getLong()
	local unionFlag = message:getString(3)
	local serverId = message:getLong()
	local areaId = message:getLong()

	message:clear()
end

function mapArmyNotificationAction(message)
	return message
end

function mapCampNotificationAction(message)
	return message	
end

function mapCityNotificationAction(message)
	return message	
end

function mapResNotificationAction(message)
	return message	
end

--地图通知
function mapNotificationAction(message)
	local dataTable = {}
	dataTable.userId   = message:getLong()		--玩家编号
	dataTable.serverId = message:getLong()		--服务器编号
	dataTable.areaId   = message:getLong()		--分块编号

	--cclog("玩家编号==========="..dataTable.userId)
	--cclog("服务器编号========="..dataTable.serverId)
	--cclog("地图通知分块编号==========="..dataTable.areaId)

	--资源数量
	local resNum = message:getLong()
	local resTable = ff.NetTable:create()
	resTable:addStreamCol("gid", ff.NET_LONG)		--地图坐标
	resTable:addStreamCol("avatar", ff.NET_LONG)	--显示信息
	resTable:addStreamCol("uid", ff.NET_LONG)		--占领的玩家编号，0=未占领
	cclog("资源数量===================="..resNum)
	if resNum > 0 then
		message:getData(resNum,resTable)
	end
	dataTable.resTable = resTable

	--城池数量
	local cityNum = message:getLong()
	local cityTable = ff.NetTable:create()
	cityTable:addStreamCol("gid", ff.NET_LONG)
	cityTable:addStreamCol("avatar", ff.NET_LONG)
	cityTable:addStreamCol("baseInfo", ff.NET_LONG)	--城池外观
	cityTable:addStreamCol("uid", ff.NET_LONG)		--所属主公编号
	cclog("城池数量===================="..cityNum)
	if cityNum > 0 then
		message:getData(cityNum, cityTable)
	end
	dataTable.cityTable = cityTable
	

	--帐篷数量
	local campNum = message:getLong()
	local campTable = ff.NetTable:create()
	campTable:addStreamCol("gid", ff.NET_LONG)
	campTable:addStreamCol("avatar", ff.NET_LONG)
	campTable:addStreamCol("uid", ff.NET_LONG)
	cclog("帐篷数量===================="..campNum)
	if campNum > 0 then
		message:getData(campNum, campTable)
	end
	dataTable.campTable = campTable

	--军队数量
	local marchNum   = message:getLong()
	local marchTable = ff.NetTable:create()
	marchTable:addStreamCol("id", ff.NET_LONG)
	marchTable:addStreamCol("avatar", ff.NET_LONG)
	marchTable:addStreamCol("from", ff.NET_LONG)	--出发地
	marchTable:addStreamCol("to", ff.NET_LONG)		--目的地
	marchTable:addStreamCol("start", ff.NET_LONG)--出发时间
	marchTable:addStreamCol("end", ff.NET_LONG)	--到达时间
	marchTable:addStreamCol("type", ff.NET_LONG)		--出征类型
	marchTable:addStreamCol("state", ff.NET_LONG)	--出征状态
	marchTable:addStreamCol("uid", ff.NET_LONG)		--所属主公编号
	-- cclog("军队数量===================="..marchNum)
	if marchNum > 0 then
		message:getData(marchNum, marchTable)
	end
	dataTable.marchTable = marchTable

	local unionNum = message:getLong()
	local unionTable = ff.NetTable:create()
	unionTable:addStreamCol("unionid", ff.NET_LONG)
	unionTable:addStreamCol("short", ff.NET_STRING, 3)
	-- cclog("联盟数量==================="..unionNum)
	if unionNum > 0 then
		message:getData(unionNum, unionTable)
	end
	dataTable.unionTable = unionTable

	--玩家数量
	local userNum = message:getLong()
	local userTable = ff.NetTable:create()
	userTable:addStreamCol("uid", ff.NET_LONG)
	userTable:addStreamCol("unionid", ff.NET_LONG)
	userTable:addStreamCol("power", ff.NET_LONG)	      --主公战力
	userTable:addStreamCol("name", ff.NET_STRING, 15)   --主公名称
	-- userTable:addStreamCol("level", ff.NET_LONG)		  --等级
	-- cclog("玩家数量===================="..userNum)
	if userNum > 0 then
		message:getData(userNum, userTable)
	end
	userTable:addStreamCol("short",ff.NET_STRING,3)

	for i=1,userTable:rowCount() do
		if userTable:getLong(i,"unionid") > 0 then
			for j=1,unionTable:rowCount() do
				if userTable:getLong(i,"unionid") == unionTable:getLong(j,"unionid") then
					userTable:setString(i,"short",unionTable:getString(j,"short"))
					break
				end
			end
		end
	end
	dataTable.userTable = userTable

	cclog("NPC====================")
	local other = ff.NetTable:create()
	other:addCol("cid",ff.NET_LONG)
	other:addCol("type",ff.NET_LONG)
	other:addCol("avatar",ff.NET_LONG)
	other:addCol("unionid",ff.NET_LONG)
	other:addCol("id",ff.NET_LONG)
	other:addCol("blood",ff.NET_LONG)
	other:addCol("short",ff.NET_STRING, 3)
	other:addCol("name",ff.NET_STRING, 15)
	other:addCol("image",ff.NET_LONG)
	other:addCol("level",ff.NET_LONG)

	--联盟要塞
	local unionP_count = message:getLong()
	if unionP_count > 0 then
		cclog("unionP_count:"..unionP_count)
		local unionPTable  = ff.NetTable:create()
		unionPTable:addStreamCol("cid", ff.NET_LONG)
		unionPTable:addStreamCol("avatar", ff.NET_LONG)
		unionPTable:addStreamCol("unionid", ff.NET_LONG)	      --主公战力
		unionPTable:addStreamCol("short", ff.NET_STRING, 3)   --主公名称
		message:getData(unionP_count, unionPTable)
		for i=1,unionPTable:rowCount() do
			local row = other:addRow()
			other:setLong(row,"cid",unionPTable:getLong(i,"cid"))
			other:setLong(row,"type",11)
			other:setLong(row,"avatar",unionPTable:getLong(i,"avatar"))
			other:setLong(row,"unionid",unionPTable:getLong(i,"unionid"))
			other:setString(row,"short",unionPTable:getString(i,"short"))
		end
		unionPTable:clear()
	end

	--npc
	local npc_count = message:getLong()
	if npc_count > 0 then
		cclog("npc_count:"..npc_count)

		local npcTable  = ff.NetTable:create()
		npcTable:addStreamCol("cid", ff.NET_LONG)
		npcTable:addStreamCol("npcid", ff.NET_LONG)
		npcTable:addStreamCol("blood", ff.NET_LONG)	      --主公战力		
		message:getData(npc_count, npcTable)
		for i=1,npcTable:rowCount() do
			cclog("npcTable:"..npcTable:getLong(i,"npcid"))
			local row = other:addRow()
			other:setLong(row,"cid",npcTable:getLong(i,"cid"))
			other:setLong(row,"type",21)
			other:setLong(row,"id",npcTable:getLong(i,"npcid"))
			other:setLong(row,"blood",npcTable:getLong(i,"blood"))
			cclog("id:"..other:getLong(row,"id"))
			other:setLong(row,"image",dd.cfgNpc[other:getLong(row,"id")]['mapimage'])
			--other:setLong(row,"image",9021901)
			if npcTable:getLong(i,"npcid") == 999 then
				WorldControl:getInstance()._worldUILayer._curMapLayer:addEffect(npcTable:getLong(i,"cid"),10000101)
			end
			--other:setLong(row,"image",9000211)
			other:setLong(row,"level",dd.cfgNpc[other:getLong(row,"id")]['level'])
			other:setString(row,"name",ff.langString(dd.cfgNpc[other:getLong(row,"id")]['name']))
		end
		npcTable:clear()		
	end
	--玩家据点
	local point_count = message:getLong()
	if point_count > 0 then
		local pointTable  = ff.NetTable:create()
		pointTable:addStreamCol("cid", ff.NET_LONG)
		pointTable:addStreamCol("avatar", ff.NET_LONG)
		pointTable:addStreamCol("uid", ff.NET_LONG)	      --主公战力
		pointTable:addStreamCol("name", ff.NET_STRING, 15)   --主公名称
		pointTable:addStreamCol("unionid", ff.NET_LONG)	      --主公战力
		pointTable:addStreamCol("short", ff.NET_STRING, 31)   --主公名称
		message:getData(point_count, pointTable)
		for i=1,pointTable:rowCount() do
			local row = other:addRow()
			other:setLong(row,"cid",pointTable:getLong(i,"cid"))
			other:setLong(row,"type",3)
			other:setLong(row,"id",pointTable:getLong(i,"uid"))
			other:setLong(row,"avatar",pointTable:getLong(i,"avatar"))
			other:setLong(row,"unionid",pointTable:getLong(i,"unionid"))
			other:setString(row,"short",pointTable:getString(i,"short"))
			other:setString(row,"name",pointTable:getString(i,"name"))
		end		
		pointTable:clear()	
	end

	local point2_count = message:getLong()
	local point2Table  = ff.NetTable:create()
	point2Table:addStreamCol("cid", ff.NET_LONG)
	point2Table:addStreamCol("state", ff.NET_LONG)
	point2Table:addStreamCol("time", ff.NET_LONG)	
	point2Table:addStreamCol("level", ff.NET_LONG)	
	point2Table:addStreamCol("point", ff.NET_LONG)	
	point2Table:addStreamCol("unionid", ff.NET_LONG)	
	point2Table:addStreamCol("npc", ff.NET_LONG)	
	point2Table:addStreamCol("nowbing", ff.NET_LONG)	
	point2Table:addStreamCol("maxbing", ff.NET_LONG)	
	point2Table:addStreamCol("baoliu4", ff.NET_LONG)
	if point2_count > 0 then	
		message:getData(point2_count, point2Table)		
	end
	dataTable.tower = point2Table  
	dataTable.other = other
	message:clear()
	return dataTable
end

--地图订阅消息
function mapQueryAction(message)
	local ret = message:getLong()
	--cclog("mapQueryAction ==========ret =============="..ret)
	if ret == 0 then
		--从大到小， 大区---服务器---分块编号
		local keepTime = message:getLong()		    --订阅过期时间（过期重新请求）
		local invalidNum = message:getLong()	    --已失效订阅
		local invalidTable = {}
		for i=1,invalidNum do
			invalidTable[i] = message:getLong()
		end
		message:clear()
		return {ret, keepTime, invalidTable}
	end
	message:clear()
	return {ret}
end

--查询资源点详细信息
function onMapGetResourceDetail(message)
	local code = message:getLong()
	if code == 0 then
		local serverid = message:getLong()
		return {code,message}
	else
		message:clear()
		return {code}
	end	
end
function onMapGetCityDetail(message)
	local code = message:getLong()
	if code == 0 then
		local serverid = message:getLong()
		return {code,message}
	else
		message:clear()
		return {code}
	end	
end
--飞城
function onCityMove( message )
	local code = message:getLong()
	if code == 0 then
		dd.mycity:setLong(1,"cid",message:getLong())
		dd.gold(message:getLong())
		local tid = message:getLong()
		local count = message:getLong()
		dd.setToolCount(tid,count)
		message:clear()
		return {code,tid}
	end
	message:clear()
	return {code}
end
function onMarchSpeedup(message)
	local code = message:getLong()
	if code == 0 then
		local action = message:getLong()
		local tid = message:getLong()
		local count = message:getLong()
		if tid > 0 then
			dd.setToolCount(tid,count)
		end
		dd.gold(message:getLong())
		local id = message:getLong()
		for i=1,dd.myTroops:rowCount() do
			if id == dd.myTroops:getLong(i,"id") then
				dd.myTroops:setLong(i,"type",message:getLong())
				dd.myTroops:setLong(i,"state",message:getLong())
				dd.myTroops:setLong(i,"from",message:getLong())
				dd.myTroops:setLong(i,"to",message:getLong())
		        dd.myTroops:setLong(i,"start",message:getLong())
		        dd.myTroops:setLong(i,"arrival",message:getLong())
		        dd.myTroops:setLong(i,"hid",message:getLong())
		        break
			end
		end
	end
	message:clear()
	return code
end

function onMapUnionName(message)
	local uid     = message:getLong()
	local unionid = message:getLong()
	local uname   = message:getString(15)
	local short   = message:getString(3)

	cclog("uid:"..uid..",unionid:"..unionid..",uname:"..uname..",short:"..short)
	message:clear()
	return {unionid,uname,short}
end
function onMapUnionShip(message)
	local uid     = message:getLong()
	local u1   = message:getLong()
	local u2   = message:getLong()
	local ship1   = message:getLong()
	local ship2   = message:getLong()
	message:clear()
	return {u1,u2,ship2}
end
function onSNMapFight(message)
	local uid = message:getLong()
	local gid = message:getLong()
	message:clear()
	return gid
end
function onGetAllyMap(message)
	return message
end
function onMapGetStrongholdLists(message)
	return message
end
function onGetMyStrongholdLists(message)
	return message
end
function onSNMapStrongholdTower( message )
	return message
end
function onGetAllyMapRelease(message)
	if message ~= nil then
		message:clear()
	end
end
function onGetMemberReinforceInfo(message)
	local code = message:getLong()
	if code == 0 then
		return {code,message:getLong(),message:getLong(),message:getLong()}
	end
	return {code}
end

function onMapGetTileDetail(message)
	local code = message:getLong()
	if code == 0 then
        data = {}
        data.cid = message:getLong()
        local type = message:getLong()
        if type == 2 then
	        data.type= 1
        elseif type == 1 then
        	data.type = 2
        elseif type == 5 then
        	data.type = 21	
        else
        	data.type = type
        end
        data.unionid = message:getLong()
        message:getString(15)
        data.short = message:getString(3)     
        data.uid 	= message:getLong()
        data.name   = message:getString(15)
        message:getLong()
        message:getLong()
        message:getLong()
        data.power = message:getLong()
        message:getLong()
        data.level  = message:getLong()
        data.avatar = message:getLong()
        cclog("type:"..type..","..data.type..","..data.level..","..data.avatar)
        if data.type == 1 then
        	data.level = dd.cfgWorldRes[math.floor(data.avatar/10000)]['level']
        end
        message:clear()
        return {code,data}
	end
	message:clear()
	return {code}
end