-- ios的loading界面

local ProgressLayer    = class("ProgressLayer_ios")
ProgressLayer._name = "ProgressLayer_ios"
ProgressLayer._bar     = nil
ProgressLayer._tips    = nil
ProgressLayer._count   = 0
ProgressLayer._callback= nil
ProgressLayer._value   = 0
ProgressLayer._nowvalue= 0
ProgressLayer._str     = ""
ProgressLayer._lasttick= 0
ProgressLayer._back = 0
ProgressLayer._action = nil
ProgressLayer._params = {}

local row

function ProgressLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, ProgressLayer)
    return target
end

function ProgressLayer:onClickFeed()

    --测试充值
    --platform_initPay(nil,getBuyItems())
    --platform_pay("ft_zw_product1201",499)
    --测试gamecenter
    --require "define"
    --dd.initGame()
    --platform_googleplay(5)
    --ff.gameCore:getPost(hif._lists,1,"code=login&partner_id=101&sn=c2e9ef3808b1a2126d8b1b4dd7cf2c78","test")
    --ff.gameCore:getPost("test","http://60.191.72.141/zwar/verify.php?code=fbcheck&partner_id=101&sn=375f7e95bd432cce4b493ddd2c8c9ffb&bind_name=9429576C023E2B2774EB88D115243072&alias_name=69315940@qq.com&sc=6")
    --platform_showDialog("Network connection error","Network connection was lost!0x901",11,0)
    --platform_openUrl("http://www.163.com")

    --ff.iosCore:showView()
    print("here.......1")
    platform_feedback()
end


function ProgressLayer:onClickOk()
    self:getChildByName("pnl_list_bg"):setVisible(false)

    local id = hif._lists:getLong(row,"id")
    local index = 1    
    for i=1,hif._lists:rowCount() do
        if hif._lists:getLong(index,"id") ~= id then
            hif._lists:delRow(index)
        else
            index = index + 1
        end
    end
    ff.loadingLayer:setTips(ff.langString("开始连接服务器..."))


    --ios or windwos版本用异步
    if cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_IPAD then   
        self:login()
    else
        hif._row = 1             
        local result = hif.checkLogin()
        if result == false then          
            ff.loadingLayer:setTips(ff.langString("服务忙，请稍后再试。"))
            return
        end
        performWithDelay(self, self.checkUpdate, 0.05)
    end
end

function ProgressLayer:login()
    ff.loadingLayer._params['checkLogin'] = ""
    hif.checkLogin("checkLogin")

    local action = nil
    local function backCheck()
        if ff.loadingLayer._params['checkLogin'] ~= "" then
            local result  = hif.fixReturn(ff.loadingLayer._params['checkLogin'])
            print("result:"..result..","..ff.loadingLayer._params['checkLogin'])
            if hif.dealCheckLogin(result) == false then
                ff.loadingLayer:stopAction(action)
                ff.loadingLayer:setTips(ff.langString("服务忙，请稍后再试。"))
                return
            end
            if ff.addr == "" then
                ff.loadingLayer._params['checkLogin'] = ""
                hif.checkLogin("checkLogin")
                return
            end
            ff.loadingLayer:stopAction(action)
            performWithDelay(ff.loadingLayer, ff.loadingLayer.checkUpdate, 1)
        end
    end
    action = schedule(ff.loadingLayer, backCheck, 1)
end

function ProgressLayer:initUI()
    self:getChildByName("btn_feed"):setVisible(false)
    self:getChildByName("btn_feed"):
        addTouchEventListener( function (sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                cclog("feedback...")
                self:onClickFeed()
            end
        end )
    self:getChildByName("pnl_list_bg"):getChildByName("btn_ok"):
        addTouchEventListener( function (sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:onClickOk()
            end
        end )


    self._params = {}

    self:getChildByName("img_pb_bg"):getChildByName("tag"):setVisible(false)
    local mv = self:getChildByName("img_pb_bg"):getChildByName("tag"):getChildByTag(1)
    if mv ~= nil then
        mv:removeFromParent(true)
    end
    print("2")
    --spine

    local sprite = sp.SkeletonAnimation:create("preloader/spineboy/loadingtu1280x720.json", "preloader/spineboy/loadingtu1280x720.atlas")
    sprite:setPositionX(360)
    sprite:setPositionY(1440/2)
    sprite:setAnimation(0, "SLGloading_animation", true)
    self:getChildByName("img_bg"):addChild(sprite,1,1)

    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()

    local event = cc.EventListenerCustom:create("checkLogin",self.dealHttpIF)
    eventDispatcher:addEventListenerWithFixedPriority(event, 1)            

    local event = cc.EventListenerCustom:create("checkVersion",self.dealHttpIF)
    eventDispatcher:addEventListenerWithFixedPriority(event, 1)            

    local event = cc.EventListenerCustom:create("langOK",self.dealHttpIF)
    eventDispatcher:addEventListenerWithFixedPriority(event, 1)            

    

    local event = cc.EventListenerCustom:create("restart",self.dealRestart)
    eventDispatcher:addEventListenerWithFixedPriority(event, 1)            
end


function ProgressLayer.dealHttpIF(event)
    local result  = event:getUserData()
    if ff.loadingLayer ~= nil then
        print("dealHttpIF:"..event:getEventName()..","..result)
        ff.loadingLayer._params[event:getEventName()] = result
    end
end
function ProgressLayer.dealRestart(event)
    local name = event:getEventName()
    if name == "restart" and ff.loadingLayer ~= nil then
        platform_restart()
    end
end

function ProgressLayer:setProgress(value)
    if value < 1 then
        value = 1
    end
    if value > 100 then
        value = 100
    end
    self._value = value
    if value <= 1 then
        self._nowvalue = 0
    end
end
function ProgressLayer:setTips(tips)
    if tips then
        platform_setLoadingBarTip(tips)
        self:getChildByName("img_pb_bg"):getChildByName("tips"):setVisible(true)
        self:getChildByName("img_pb_bg"):getChildByName("tips"):setString(tips)
    end
end

function ProgressLayer:setLabelColor(color)
    self:getChildByName("img_pb_bg"):getChildByName("tips"):setColor(cc.c3b(255,0,0))
end

function ProgressLayer:beginJsons(callback,tips)
    self._tips = tips
    local count = ff.gameCore:addAsyncJsonStart()
    if count > 0 then
        if callback ~= nil then
            self:setTips(tips.."......0%")       
        end    
        self._count    = count
        self._total    = count
        self._callback = callback
    else
        if callback ~= nil then
            callback()
        end    
    end    
end
function ProgressLayer:showTop()
    local lay = cc.LayerColor:create(cc.c4b(255,0,0,150))    
    cc.Director:getInstance():setNotificationNode(lay)
    local notif = cc.Director:getInstance():getNotificationNode()
    notif:setTag(999)
end

function ProgressLayer:finish()
    cclog("finish")
    self._count = self._count - 1
    if self._tips ~= nil then
        local per = math.ceil((self._total - self._count) * 100/self._total)
        self:setTips(self._tips.."......"..per.."%")
        self:setProgress(per)
    end
    cclog("count:"..self._count)
    if self._count == 0 then
        if self._callback ~= nil then
            self._callback()
        end    
    end
end

function ProgressLayer:onShowAsync(callback,tips)
    self._callback = callback
    self:setProgress(100)
    performWithDelay(self, self._callback, 0.05)
end
function ProgressLayer:onLogin()
    dd.loadingLayer:setProgress(100)
    if ff.restart == false then
        dd.initCfg()
        return
    end
    performWithDelay(dd.loadingLayer, login_begin, 2)
end   

function ProgressLayer.onSuccess()
    cclog("onSuccess")
    if cc.PLATFORM_OS_WINDOWS ~= cc.Application:getInstance():getTargetPlatform() then
        if ff.dbmanager:create("data"..ff.db_version..".db") == 0 then
            ff.loadingLayer:setProgress(0)
            downDB(ff.loadingLayer.onSuccess,ff.loadingLayer.onError)
            return
        end
    else
        if ff.dbmanager:create("data.db") == 0 then
            downDB(ff.loadingLayer.onSuccess,ff.loadingLayer.onError)
            return
        end
    end
    if ff.needUpdate == true then
        updateVersionSQL()
    end

    require "define"
    dd.currentLayer = ff.loadingLayer 
    dd.loadingLayer = ff.loadingLayer     

    ff.loadingLayer:getChildByName("btn_feed"):setVisible(true)


    ff.loadingLayer:runAction(cc.Sequence:create(    
       
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "net/gamenet"  
            require "sound"
            require "newbie"
            end),

        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "message/city_message"  
            require "message/login_message"
            require "message/login_messageEx"
            require "message/personal_message"
            require "message/build_message"
            require "message/global_message"
            require "message/chat_message"
            end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "message/mail_message"             
            require "message/worldMap_message" 
            require "message/prop_message"
            require "message/union_war_message"
            require "message/hero_message"
            require "message/report_message"
            require "message/sns_message"
            end),

        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "guide/guideControl"  
            require "ui/warning"
            require "ui/wating"
            require "battle/battle"
            require "pve/pve"
            end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "city/buildsList" 
            require "city/upgrade"
            require "city/city"
            end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "city/cityUI" 
            require "city/resources"
            require "city/buffs" 
            end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/mail/mailDialog" 
            require "view/mail/mailWrite"
            require "view/mail/mailReceive" 
            require "view/mail/scoutRep" 
            end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/mail/fightRep" 
            require "view/mail/repView"
            require "view/mail/fightcompare" 
            require "view/mail/fightShowOthers" 
            end),

        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/mail/notice"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/mail/mailFriend"  end),



        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/barrack/barrack"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/barrack/barrackHelp"  end),

        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/home/home"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/baoKu/baoKu"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/mainbase/mainbase"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/res/res"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/embassy/embassy"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/tec/tec"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/tower/tower"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/tower/towerInfo"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/warcollege/warcollege"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/warcollege/heroskill"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/warcollege/heroskillEx"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/equip/equipbuild"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/equip/equipforge/equipmake"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/equip/equipforge/equipforge"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/equip/equipsetgem/equipsetgem"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/equip/itemcompose/equipcompose"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/barrack/gcs"  end),
        --]]
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/equip/crystalUp"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/equip/warehouse"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/lottery/lotterypaid"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/union/noUnion/noUnion"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/task/task"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/task/taskInfo"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/chat/chat"  end),

        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/union/union"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/union/unionInnerRank"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/union/rank/rank"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/union/shop/unionShop"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/union/unionInfoLayer/unionInfoLayer"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/union/unionOption/unionOption"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/union/unionMember/unionMember"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/union/unionTec/unionTec"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/union/unionHelp/unionHelp"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/union/unionGift/unionGift"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/union/unionHistory/unionHistory"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/union/unionDiplomacy/unionDiplomacy"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/union/unionMessage/unionMessage"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/union/ChristmasTree"  end),

        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/power/power"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/changeName/changeName"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/role/uinfo"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/props/propShop"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/warhouse/warhouse"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/warhouse/warinfo"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/chuzhen/chuzhen"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/army/armyInfo"  end),

        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/charge/charge"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/card/monthCard"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/vip/vip"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/rank/personRank"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/cityUp"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/gameStar"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/set/gameSet"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/changeHead/changeHead"  end),


        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/lottery/lottery"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build_help/embassyHelp"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build_help/warHouseHelp"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build_help/mainBaseHelp"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build_help/hospitalHelp"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build_help/buildHelp"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "pve/pveUI"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "world/collect/collect"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "world/collect/colPop"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "world/newWorldMap"  end),

        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/transport/transport"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/transport/transportInfo"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "battle/result"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/task/goldActivity"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/mainbase/selectHero"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/gameIntroduce/gameIntroduce"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/card/reward"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/set/scrollSelect"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/onlineReward/onlineReward"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/warcollege/heroInfo"  end),

        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/warcollege/arms"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/charge/gifts"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/club/club"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/gatherd/gatherd"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "city/joinMSG"  end),

        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "world/mapNpc"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/bank/bank"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/bank/bankpop"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "city/Attendance"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/taskNewbie/TaskNewbie"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/charge/SurpriseRecharge"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/task/Activityshou"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/task/Activitynei"  end),

        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/task/ActivityneiEx" 
        require "view/task/ActivityneiExx"  
         end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/task/ActiveUse"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/task/ActiveInfo"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/task/hechengJump"  end),

        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "world/changeSkin"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/Invitation/Invitation"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/jail/jail"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "world/StrongholdInfo"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/task/StrongholdInfoShow"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "world/StrongholdInfoEx"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/ExchangeItem/ExchangeItem"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/task/TowerXmas"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/charge/sdchong"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "world/StrongTower"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "world/StrongholdInfoEEX"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/task/hechengex"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/Alchemist/Alchemist"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/Alchemist/AlchemistSkill"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/task/towerfight"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "view/build/TrainingRoom/TrainingRoom"  end),
        cc.DelayTime:create(0.02),cc.CallFunc:create(function (message) require "ui/popDialog"  end),
        
        --必须最后调用

        cc.DelayTime:create(1),cc.CallFunc:create(function (message) ff.loadingLayer.nextSuccess() end)
        ))
end
function ProgressLayer.nextSuccess()
    dd.requires()
    dd.initGame()
    local action = nil
    local function backCheck()
        print("check here.....")
        if ff.loadingLayer._params['langOK'] ~= "" then
            ff.loadingLayer:stopAction(action)
            local ln = "l"..ff.lang
            local data = ff.dbmanager:sql_fetch_rows("select `"..ln.."` from cfg_lang where `id`='"..lan["初始化UI..."].."'")
            if data ~= nil and data:rowCount() == 1 then
                ff.loadingLayer:setTips(data:getString(1,ln))
            else
                ff.loadingLayer:setTips("Game Loading...")
            end
            if data ~= nil then
                data:clear()
            end
            dd.loadingLayer:setProgress(20)
            dd.loadingLayer:onLogin()
        end
    end
    action = schedule(ff.loadingLayer, backCheck, 1)
end

function ProgressLayer.onError(errorCode)
    if ff.loadingLayer ~= nil then
        ff.loadingLayer.onSuccess()
    end
end   
-- 初始化各种
function ProgressLayer.checkUpdate()
    if ff.loadingLayer ~= nil then
        platform_showLoadingBar(1)
        ff.loadingLayer:setProgress(5)
        ff.loadingLayer:setTips(ff.langString("Check Update..."))
    end    
    --版本更新
    if cc.PLATFORM_OS_WINDOWS ~= cc.Application:getInstance():getTargetPlatform() then    
        checkVersionIOS()
    else
        ff.loadingLayer.onSuccess()
    end
end

function ProgressLayer:onStart()
    self:getChildByName("version"):setString("version:"..ff.apk_version_name.."."..cc.UserDefault:getInstance():getIntegerForKey("version"))
    hif.init()
    cclog("row:"..hif._lists:rowCount())
    if cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then
        ff.show_servers = true
    end
    if ff.show_servers == true or cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then
        self:getChildByName("pnl_list_bg"):setVisible(true)
        self:showServers()       
        platform_showLoadingBar(5)
    else
        self:getChildByName("pnl_list_bg"):setVisible(false)
        local index = 1
        for i=1,hif._lists:rowCount() do
            if hif._lists:getLong(index,"type") ~= 2 then
                hif._lists:delRow(index)
            else
                index = index + 1
            end
        end
        self:login()
    end
end

function ProgressLayer.onEnterOrExit(tag)
    cclog("ProgressLayer.onEnterOrExit.........................IOS:"..tag)
    if tag == "enter" then
        --ff.loadingLayer:showTop()
    elseif tag == "enterTransitionFinish" then
        ff.loadingLayer:onStart()
    elseif tag == "exitTransitionStart" then
        ff.loadingLayer:setProgress(90)
    elseif tag == "exit" then    
        ff.loadingLayer:setProgress(100)        
        ff.loadingLayer:unscheduleUpdate()        
    elseif tag == "cleanup" then 
        --cc.Director:getInstance():getTextureCache():removeUnusedTextures()     
    end
end

function ProgressLayer.servers_callback(tag)
    ff.loadingLayer._back = tonumber(tag)
    cclog("type  ============"..ff.loadingLayer._back)
end

function ProgressLayer:showServers()
    local list = self:getChildByName("pnl_list_bg"):getChildByName("lv_server")
    local item = self:getChildByName("pnl_list_bg"):getChildByName("item")
    list:removeAllItems()
    row = hif._row
    for i=1,hif._lists:rowCount() do
        local id = hif._lists:getLong(i,"id")
        local tip = hif._lists:getString(i,"tips")
        local widget = item:clone()
        widget:setVisible(true)
        widget:getChildByName("label"):setString(tip)
        if row == i then
            widget:getChildByName("label"):setColor(cc.c3b(0, 255, 0))
        else
            widget:getChildByName("label"):setColor(cc.c3b(255, 255, 255))
        end
        widget:setTag(id)
        widget:addTouchEventListener( function (sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                for j,v in ipairs(list:getChildren()) do
                    v:getChildByName("label"):setColor(cc.c3b(255, 255, 255))
                end            
                sender:getChildByName("label"):setColor(cc.c3b(0, 255, 0))
                row = id
            end
        end )
        list:pushBackCustomItem(widget)
    end
end

function ProgressLayer:update(dt)
    if self._nowvalue < self._value then
        self._nowvalue = self._nowvalue + 0.5
        --platform_setLoadingBarPercent(self._nowvalue * 10)
    end
    local value = self._nowvalue
    self:getChildByName("img_pb_bg"):getChildByName("pb_loading"):setPercent(self._nowvalue)

    self:getChildByName("img_pb_bg"):getChildByName("tag"):setVisible(true)
    local x = math.floor(value * 596/100)
    self:getChildByName("img_pb_bg"):getChildByName("tag"):getChildByName("top"):setPositionX(x - 70)


    local mv = self:getChildByName("img_pb_bg"):getChildByName("tag"):getChildByTag(1)
    if mv == nil then
        mv = cc.Sprite:create("images/loading/bar_loading_0.png")
        self:getChildByName("img_pb_bg"):getChildByName("tag"):addChild(mv,3,3)
        mv:setTag(1)

        local animation = cc.Animation:create()
        for j = 0, 14 do
            animation:addSpriteFrameWithFileName("images/loading/bar_loading_"..j..".png")
        end
        animation:setDelayPerUnit(0.1)
        mv:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
        mv:setPosition(cc.p(0,15))
    end
    mv:setPositionX(x)
end
function ProgressLayer:setVersion(version)
    --if version ~= nil then
    --    self:getChildByName("version"):setVisible(true)
    --    self:getChildByName("version"):setString(version)
    --end
end
function ProgressLayer:showVersionDetail()
    local infos = getVersionDetail()
    if table.getn(infos) > 0 then
        for i=1,table.getn(infos) do
            local content = i.."."..infos[i][1]
            local color = infos[i][2]
            platform_showWeihuText(content,color)
        end
    end
end

return ProgressLayer