local pveUILayer   = class("pveUILayer")
pveUILayer._name = "pve"
pveUILayer._init = false
pveUILayer._id   = 0
pveUILayer._level    = 0
pveUILayer._zombieid = 0
pveUILayer._enemy= nil
pveUILayer._hid  = 0
pveUILayer._battle = nil
pveUILayer._info = {}
pveUILayer._turn = 0
pveUILayer._drop = nil
pveUILayer.attackEF = {}
pveUILayer.dankongInfo = {}
pveUILayer.battleBG = nil
pveUILayer.loseIsShow = false

function pveUILayer:getStar(value,type)
	if type == 1 or type == 2 then
		if value <= 500 then
			return 1
		elseif value <= 1000 then
			return 2
		elseif value<= 1500 then
			return 3
		elseif value<= 2000 then
			return 4
		elseif value<= 3000 then
			return 5
		elseif value<= 4000 then
			return 6
		elseif value<= 5000 then
			return 7
		elseif value<= 7000 then
			return 8
		elseif value<= 10000 then
			return 9
		else
			return 10
		end
	elseif type == 3 then
		if value <= 750 then
			return 1
		elseif value <= 1500 then
			return 2
		elseif value<= 2200 then
			return 3
		elseif value<= 3000 then
			return 4
		elseif value<= 4500 then
			return 5
		elseif value<= 6000 then
			return 6
		elseif value<= 8000 then
			return 7
		elseif value<= 10000 then
			return 8
		elseif value<= 15000 then
			return 9
		else
			return 10
		end
	else
		if value <= 250 then
			return 1
		elseif value <= 500 then
			return 2
		elseif value<= 800 then
			return 3
		elseif value<= 1200 then
			return 4
		elseif value<= 1800 then
			return 5
		elseif value<= 2400 then
			return 6
		elseif value<= 3000 then
			return 7
		elseif value<= 4000 then
			return 8
		elseif value<= 6000 then
			return 9
		else
			return 10
		end
	end
end


function pveUILayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, pveUILayer)
    return target
end

function pveUILayer:onInit(id)
	if self._init == false then
        
		self:setContentSize(cc.size(720,ff.height))       

		self:getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onClose)
		self:getChildByName("view"):getChildByName("battle"):addTouchEventListener(self.onBattle)
        self:getChildByName("view"):getChildByName("giveup"):addTouchEventListener(self.onGiveUp)

        self:getChildByName("battle"):getChildByName("detail"):getChildByName("btns"):
            getChildByName("attack"):setTitleText(ff.langString("攻击"))
        self:getChildByName("battle"):getChildByName("detail"):getChildByName("btns"):
            getChildByName("leave"):setTitleText(ff.langString("立即结束"))

        self.labelY = self:getChildByName("view"):getChildByName("giveup"):getChildByName("label"):getPositionY()
        local size = self:getChildByName("battle"):getChildByName("progress"):getContentSize()
        self:getChildByName("battle"):getChildByName("progress"):setPositionY(ff.height-size.height)

        local battle = self:getChildByName("view"):getChildByName("battle")
        self:getChildByName("view"):getChildByName("giveup"):setVisible(true)
        local x = battle:getPositionX()
        battle:setPositionX(x-160)

		self:getChildByName("battle"):getChildByName("detail"):getChildByName("btns"):getChildByName("leave"):addTouchEventListener(self.nowEnd)
		
		self:getChildByName("battle"):getChildByName("detail"):getChildByName("lists"):setMaxLine(500)

		self:getChildByName("win"):getChildByName("info"):getChildByName("close"):addTouchEventListener(self.endBattle)
		self:getChildByName("lose"):getChildByName("close"):addTouchEventListener(self.endBattle)
       
        
        
        self.dankongInfo["attack"] = {cc.p(400, 950), cc.p(400, 750), cc.p(630, 730), 0.6,0.8, 0.65}
        self.dankongInfo["zj"] = 
        {
            cc.p(450, 970), cc.p(280, 700), cc.p(580, 790), cc.p(400, 815), cc.p(660, 905), cc.p(630, 700), 
            0.4, 0.8, 0.5, 0.45, 0.55, 0.42
        }

        self.battleBG = cc.Sprite:create("images/pve/pveBG.jpg")

        local hh = ff.height
        local h = (896/1280*hh)*1.1
        local s = h/896

        self.battleBG:setScaleY(s>1.1 and s or 1.1)
        self.battleBG:setScaleX(1.1)
        self.battleBG:setPosition(360, 850)
        self:addChild(self.battleBG, -1)

        local xx, yy = self:getChildByName("view"):getChildByName("herolists"):getPosition()
        self:getChildByName("view"):getChildByName("herolists"):setPosition(xx, yy-10)

        local function onTouchBegan(touch, event)
            if event == ccui.TouchEventType.began then
                local info = self:getChildByName("view"):getChildByName("droplists"):getChildByName("info") or self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):getChildByName("info")
                if info then
                    info:runAction(cc.Sequence:create(cc.ScaleTo:create(0.10, 0.01), cc.CallFunc:create(function () info:removeFromParent() end)))
                end
            end
        end
        self:getChildByName("win"):setTouchEnabled(true)
        self:addTouchEventListener(onTouchBegan)
        self:getChildByName("view"):addTouchEventListener(onTouchBegan)
        self:getChildByName("win"):addTouchEventListener(onTouchBegan)
        self:getChildByName("win"):getChildByName("info"):addTouchEventListener(onTouchBegan)
        
        self:getChildByName("battle"):getChildByName("effects"):getChildByName("touch"):getChildByName("touch"):setTouchEnabled(false)
        math.randomseed(ff.gameCore:getTick())
		self._init = true
	end

    self.battleBG:setVisible(false)

    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("images/pve/PveAnimation/PveAnimation0.png", "images/pve/PveAnimation/PveAnimation0.plist" , "images/pve/PveAnimation/PveAnimation.ExportJson")
    self.attackEF["attack"] = {}
    self.attackEF["baoji"] = {}
    self.attackEF["zj"] = {}

    self:getChildByName("battle"):getChildByName("effects"):getChildByName("touch"):addTouchEventListener(self.onAttack)
    self:getChildByName("battle"):getChildByName("detail"):getChildByName("btns"):getChildByName("attack"):addTouchEventListener(self.onAttack)
  
	self:getChildByName("view"):setVisible(true)
	self:getChildByName("battle"):setVisible(false)
    self:getChildByName("lose"):setVisible(false)
    self.loseIsShow  = false
    self:getChildByName("win"):setVisible(false)
    self:getChildByName("win"):getChildByName("result"):loadTexture("images/battle/result/img03_fight.png")
    
    self._info= {}
	self._id = id
    cclog("self._id:"..id)

    for i=1,dd.myZombie:rowCount() do
		if dd.myZombie:getLong(i,"id") == self._id then
            local infozm = self:getChildByName("battle"):getChildByName("effects"):getChildByName("infozm")
            infozm:getChildByName("txt_1"):getChildByName("Label_2"):setString(""..math.floor(dd.myZombie:getLong(i, "att") + 0.5))
            infozm:getChildByName("txt_2"):getChildByName("Label_2"):setString(""..math.floor(dd.myZombie:getLong(i, "def") + 0.5))
            if dd.myZombie:getLong(i, "mz") > 0 then
                infozm:getChildByName("txt_3"):getChildByName("Label_2"):setString(math.floor(dd.myZombie:getLong(i, "mz") + 0.5))
                infozm:getChildByName("txt_3"):getChildByName("Label_2_0"):setString(ff.langString("劈砍")..":")
            elseif dd.myZombie:getLong(i, "sb") > 0 then
                infozm:getChildByName("txt_3"):getChildByName("Label_2"):setString(math.floor(dd.myZombie:getLong(i, "sb") + 0.5))
                infozm:getChildByName("txt_3"):getChildByName("Label_2_0"):setString(ff.langString("火攻")..":")
            elseif dd.myZombie:getLong(i, "bj") > 0 then
                infozm:getChildByName("txt_3"):getChildByName("Label_2"):setString(math.floor(dd.myZombie:getLong(i, "bj") + 0.5))
                infozm:getChildByName("txt_3"):getChildByName("Label_2_0"):setString(ff.langString("狙击")..":")
            elseif dd.myZombie:getLong(i, "kb") > 0 then
                infozm:getChildByName("txt_3"):getChildByName("Label_2"):setString(math.floor(dd.myZombie:getLong(i, "kb") + 0.5))
                infozm:getChildByName("txt_3"):getChildByName("Label_2_0"):setString(ff.langString("枪械")..":")
            elseif dd.myZombie:getLong(i, "hg") > 0 then
                infozm:getChildByName("txt_3"):getChildByName("Label_2"):setString(math.floor(dd.myZombie:getLong(i, "hg") + 0.5))
                infozm:getChildByName("txt_3"):getChildByName("Label_2_0"):setString(ff.langString("搏击")..":")
            else
                infozm:getChildByName("txt_3"):getChildByName("Label_2"):setVisible(false)
                infozm:getChildByName("txt_3"):getChildByName("Label_2_0"):setVisible(false)
            end
            infozm:getChildByName("txt_3"):requestDoLayout()
            infozm:getChildByName("txt_1"):getChildByName("Label_2_0"):setString(ff.langString("攻击")..":")
            infozm:getChildByName("txt_2"):getChildByName("Label_2_0"):setString(ff.langString("防御")..":")
        end
    end
    self.unablePve = false	
	self:onShow()

    self:getChildByName("view"):getChildByName("herolists"):doLayout()
    self:sureHero(self._hid,true, false)
end

function pveUILayer.onBattle(sender,eventType)
	if eventType==ccui.TouchEventType.ended then     
		local widget = pop.getDialog("pve")
		widget:goBattle()
	end	
end

function pveUILayer.onGiveUp(sender,eventType)
	if eventType==ccui.TouchEventType.ended then     
        
        local function callback()
            local message = ff.net:createMessage()
            message:addCmd(0x00000162)
            message:addLong(dd.uid)
            message:addLong(sender:getParent():getParent()._id)
            ff.net:rpc(message,false)

            
        end
        dd.mainUI:onShowSure(ff.langString("放弃确认"), ff.langString("放弃后会重新生成一个僵尸，\n是否确认要放弃战斗"), callback, false, 2)
	end	
end

function pveUILayer:goBattle()
	if self._hid <= 0 then
		dd.currentLayer._widget:onShowTips("\t"..ff.langString("请选择出战英雄"))
		return
	end
	for i=1,dd.heros:rowCount() do
		if dd.heros:getLong(i,"hid") == self._hid then
			if dd.heros:getLong(i,"state") ~= 0 then
				dd.currentLayer._widget:onShowTips("\t"..ff.langString("请选择空闲英雄"))
				return
			end
			break
		end
	end
    local message = ff.net:createMessage()
    message:addCmd(0x00000163)
    message:addLong(dd.uid)
    message:addLong(self._id)
    message:addLong(self._hid)
    message:addLong(0)
    ff.net:rpc(message,false)
end
function pveUILayer:sureHero(hid,show,noani)
	for i,v in ipairs(self:getChildByName("view"):getChildByName("herolists"):getChildren()) do
		v:getChildByName("item"):setSelectedState(false)
		if show == true and v:getChildByName("item"):getTag() == hid then
			v:getChildByName("item"):setSelectedState(true)
            v:setLocalZOrder(1000)
            v:getChildByName("icon"):setColor(cc.c3b(255,255,255))
            v:getChildByName("name"):setColor(cc.c3b(255,255,255))
            v:getChildByName("level"):getChildByName("label"):setColor(cc.c3b(255,255,255))
            v:getChildByName("level"):setSelectedState(true)
            if not noani then
                v:runAction(cc.ScaleTo:create(0.25, 1))
            else
                v:setScale(1)
            end
            self._hid = hid
        else
            v:setLocalZOrder(0)
            v:getChildByName("icon"):setColor(cc.c3b(128,128,128))
            v:getChildByName("name"):setColor(cc.c3b(197,197,197))
            v:getChildByName("level"):getChildByName("label"):setColor(cc.c3b(197,197,197))
            v:getChildByName("level"):setSelectedState(false)
            if not noani then
                v:runAction(cc.ScaleTo:create(0.25, 0.8))
            else
                v:setScale(0.8)
            end
           
		end
	end
end

function pveUILayer.updateHP( sender )

    for i,v in ipairs(sender:getChildByName("view"):getChildByName("herolists"):getChildren()) do
        for j=1,dd.heros:rowCount() do
           if dd.heros:getLong(j,"hid") == v:getChildByName("item"):getTag() then
                if (dd.getServerTime() -  dd.heros:getLong(j,"PVEHpTime")) %300 == 0 then
                    local point = (dd.getServerTime() -  dd.heros:getLong(j,"PVEHpTime")) /300
                    local hp =math.ceil(point * dd.heros:getLong(j,"PVEHpMax") / 100 + dd.heros:getLong(j,"PVEHpNow"))
                    if hp > dd.heros:getLong(j,"PVEHpMax") then
                        hp = dd.heros:getLong(j,"PVEHpMax") 
                    end
                    v:getChildByName("hp"):getChildByName("hp"):setPercent(math.ceil(100 * hp/dd.heros:getLong(j,"PVEHpMax")))
                end
            end
        end
        
    end
end

function pveUILayer.nowEnd(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("pve")
        widget:showBattleEnd()
    end
end

function pveUILayer.selectHero(sender,eventType)
	if eventType==ccui.TouchEventType.ended then     
		local widget = pop.getDialog("pve")
		widget:sureHero(sender:getTag(), true)
	end	
end
function pveUILayer:updateHramInfo()
    local heroInfo =  self:getChildByName("battle"):getChildByName("effects"):getChildByName("infoself")
    local zombieInfo =  self:getChildByName("battle"):getChildByName("effects"):getChildByName("infozm")
    local widget = pop.getDialog("pve")
end

function pveUILayer:checkTime()
    local battle = self:getChildByName("view"):getChildByName("battle")
    local giveup = self:getChildByName("view"):getChildByName("giveup")
    if dd.getServerTime() - self._time > 0 and dd.getServerTime() - self._time < 86400 then
        local time1 = giveup:getChildByName("time")
        if time1:isVisible() then
        else
            time1:setVisible(true)
        end
        local y = self.labelY
        giveup:getChildByName("label"):setPositionY(y-12)
        giveup:setBright(false)
        giveup:setTouchEnabled(false)
        time1:setString(ff.getDateByTimes(86400-(dd.getServerTime() - self._time)))
        time1:setColor(cc.c3b(255,0,0))
        giveup:getChildByName("label"):setColor(cc.c3b(116,123,125))
    else
        local time = giveup:getChildByName("time")
        if time:isVisible() then
            time:setVisible(false)
        end
        local label = giveup:getChildByName("label")
        local y = self.labelY
        giveup:getChildByName("label"):setPositionY(y)
        giveup:setBright(true)
        giveup:setTouchEnabled(true)
        giveup:getChildByName("label"):setColor(cc.c3b(255,255,255))
    end

    if dd.cityZombieCD-dd.getServerTime() >= 7200 then   
        battle:setBright(false)
        battle:setTouchEnabled(false)
        local label = battle:getChildByName("label")
        local time = battle:getChildByName("time")
        if time:isVisible() then
        else
            time:setVisible(true)
        end
        local y = self.labelY
        label:setPositionY(y-12)
        time:setString(ff.getDateByTimes(dd.cityZombieCD-dd.getServerTime()))
        time:setColor(cc.c3b(255,0,0))
        giveup:getChildByName("label"):setColor(cc.c3b(116,123,125))
    else
        local time = battle:getChildByName("time")
        if time:isVisible() then
            time:setVisible(false)
        end
        local label = battle:getChildByName("label")
        local y = self.labelY
        label:setPositionY(y)
        battle:setBright(true)
        battle:setTouchEnabled(true)
        giveup:getChildByName("label"):setColor(cc.c3b(255,255,255))
    end
end

function pveUILayer.getColor(color)
    local colorcode = cc.c3b(196,213,214)
    if color == 1 then
        colorcode = cc.c3b(196,213,214)
    elseif color == 2 then
        colorcode = cc.c3b(75,137,81)
    elseif color == 3 then
        colorcode = cc.c3b(63,116,160)
    elseif color == 4 then
        colorcode = cc.c3b(164,80,151)
    elseif color == 5 then
        colorcode = cc.c3b(255,250,106)
    else
        colorcode = cc.c3b(196,213,214)
    end
    return colorcode
end

function pveUILayer:skipDialog(index, base, id)
    local currentType = base
    local dialog = nil 
    if index > 3 then
        dialog = self:getChildByName("info3")
        self:getChildByName("info2"):setVisible(false)
    else
        dialog = self:getChildByName("info2")
        self:getChildByName("info3"):setVisible(false)
    end

    local drops = base._drop
    if drops[1] == 1 then
        dialog:getChildByName("kuang"):getChildByName("descrip"):setColor(self.getColor(dd.cfgProp[drops[2]]["color"]))
        dialog:getChildByName("kuang"):getChildByName("descrip"):setString(ff.langString(dd.cfgProp[drops[2]]["name"],{dd.cfgProp[drops[2]]["name1_lan"]}).."\n"..ff.langString(dd.cfgProp[drops[2]]["tips"],{dd.cfgProp[drops[2]]["tips1_lan"]}))
    elseif drops[1] == 2 then
        dialog:getChildByName("kuang"):getChildByName("descrip"):setColor(self.getColor(1))
        dialog:getChildByName("kuang"):getChildByName("descrip"):setString(ff.langString("石油").."\n"..ff.langString("总量") .. "+" .. drops[3])
    elseif drops[1] == 3 then
        dialog:getChildByName("kuang"):getChildByName("descrip"):setColor(self.getColor(1))
        dialog:getChildByName("kuang"):getChildByName("descrip"):setString(ff.langString("木材").."\n"..ff.langString("总量") .. "+" .. drops[3])
    elseif drops[1] == 4 then
        dialog:getChildByName("kuang"):getChildByName("descrip"):setColor(self.getColor(1))
        dialog:getChildByName("kuang"):getChildByName("descrip"):setString(ff.langString("钢铁").."\n"..ff.langString("总量") .. "+" .. drops[3])
    elseif drops[1] == 5 then
        dialog:getChildByName("kuang"):getChildByName("descrip"):setColor(self.getColor(1))
        dialog:getChildByName("kuang"):getChildByName("descrip"):setString(ff.langString("粮食").."\n"..ff.langString("总量") .. "+" .. drops[3])
    elseif drops[1] == 6 then

        dialog:getChildByName("kuang"):getChildByName("descrip"):setColor(self.getColor(1))
        dialog:getChildByName("kuang"):getChildByName("descrip"):setString(ff.langString("银币").."\n"..ff.langString("总量") .. "+" .. drops[3])
    elseif drops[1] == 7 then

        dialog:getChildByName("kuang"):getChildByName("descrip"):setColor(self.getColor(1))
        dialog:getChildByName("kuang"):getChildByName("descrip"):setString(ff.langString("金币").."\n"..ff.langString("总量") .. "+" .. drops[3])
    elseif drops[1] == 8 then

        dialog:getChildByName("kuang"):getChildByName("descrip"):setColor(self.getColor(1))
        dialog:getChildByName("kuang"):getChildByName("descrip"):setString(ff.langString("士兵").."\n"..ff.langString("总量") .. "+" .. drops[3])
    elseif drops[1] == 15 then
        local param1 = dd.cfgCrystal[drops[2]]["param1"]
        local eff = dd.cfgEffect[param1]["tips1"]

        dialog:getChildByName("kuang"):getChildByName("descrip"):setColor(self.getColor(dd.cfgCrystal[drops[2]]["color"]))
        dialog:getChildByName("kuang"):getChildByName("descrip"):setString(ff.langString(dd.cfgCrystal[drops[2]]["name"]).." LV.1".."\n"..ff.langString(eff, {dd.cfgCrystal[drops[2]]["value1"]}))
    end
    

    local anr   = currentType:getAnchorPoint()
    local size  = currentType:getContentSize()
    local p = currentType:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height))
    local pos = self:convertToNodeSpace(p)

    pos.x = pos.x + 200
    
    pos.y = pos.y + 130
    dialog:stopAllActions()
    dialog:setPosition(pos)
    dialog:setVisible(true)

    function dispear( sender )
              
        sender:setVisible(false)
    end

    performWithDelay(dialog,dispear,2)
    
end

function pveUILayer:onShow()
    local sender = self
    for i=1,dd.myZombie:rowCount() do
		if dd.myZombie:getLong(i,"id") == sender._id then 
            sender._hid = 0
			if sender._enemy[dd.myZombie:getLong(i,"info")] == nil then
                break
			end
            local ztype = dd.myZombie:getLong(i,"info")
                
            cclog("ztype: " .. ztype)
            for i=1,dd.heros:rowCount() do
			    if dd.heros:getLong(i,"state") == 0 then
                    if dd.heros:getLong(i,"id") == ztype then
				        sender._hid = dd.heros:getLong(i,"hid")
				        break
                    end
			    end
		    end
            local maxlv = 0
            if sender._hid == 0 then
                for i=1,dd.heros:rowCount() do
			        if dd.heros:getLong(i,"state") == 0 then
                        if dd.heros:getLong(i,"level") > maxlv then
				            sender._hid = dd.heros:getLong(i,"hid")
                        end
			        end
		        end
            end
        end
    end

	for i=1,dd.myZombie:rowCount() do
		if dd.myZombie:getLong(i,"id") == self._id then 
			if self._enemy[dd.myZombie:getLong(i,"info")] == nil then
				break
			end
			local image = self._enemy[dd.myZombie:getLong(i,"info")]["image"]
			self._zombieid = dd.myZombie:getLong(i,"info")
			self._level    = dd.myZombie:getLong(i,"level")
			self:getChildByName("view"):getChildByName("icon"):loadTexture(dd.getZombieImg(self._zombieid),0)
            self:getChildByName("view"):getChildByName("icon")
            local attack = dd.myZombie:getLong(i,"star")
            
            self._time = dd.myZombie:getLong(i, "time")

            local function checkTime()
                self:checkTime()
            end
            self:getChildByName("view"):stopAllActions()
            schedule(self:getChildByName("view"), checkTime, 1)
            checkTime()
			local stars = dd.myZombie:getLong(i,"star")

            if  stars == 5  then
                local str = ""
                for j=1, stars do
				    str = str.."0"
			    end
                self:getChildByName("view"):getChildByName("info"):getChildByName("AtlasLabel_146"):setString(str)
                self:getChildByName("view"):getChildByName("info"):getChildByName("AtlasLabel_146"):setVisible(true)
                self:getChildByName("view"):getChildByName("boss"):setVisible(true)
            else
                self:getChildByName("view"):getChildByName("info"):getChildByName("AtlasLabel_146"):setVisible(false)
                self:getChildByName("view"):getChildByName("boss"):setVisible(false)
            end
             

			self:getChildByName("view"):getChildByName("info"):getChildByName("name"):setString(ff.langString(self._enemy[dd.myZombie:getLong(i,"info")]['name']).." LV."..dd.myZombie:getLong(i,"level"))
			self:getChildByName("view"):getChildByName("info"):getChildByName("tips"):setString(ff.langString(self._enemy[dd.myZombie:getLong(i,"info")]['tips']))
			local s = "" .. self:getChildByName("view"):getChildByName("info"):getChildByName("tips"):getString()
            function utfstrlen(str)
                local len = #str;
                local left = len;
                local cnt = 0;
                local arr={0,0xc0,0xe0,0xf0,0xf8,0xfc};
                while left ~= 0 do
                    local tmp=string.byte(str,-left);
                    local i=#arr;
                    while arr[i] do
                        if tmp>=arr[i] then left=left-i;break;end
                            i=i-1;
                    end
                    cnt=cnt+1;
                end
                return cnt;
            end
            local strnum = utfstrlen(s)
            local size = self:getChildByName("view"):getChildByName("info"):getChildByName("tips"):getContentSize()
            local n = math.ceil(strnum / math.floor((size.width/20)))
            
            local function click(sender, eventType)
                local doaction = false
                if eventType == ccui.TouchEventType.canceled then
                    local startp = sender:getTouchBeganPosition()
                    local endp   = sender:getTouchEndPosition()
                    if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                        doaction = true
                    end
                end
    
                if eventType==ccui.TouchEventType.ended then    
                    doaction = true
                end
                if doaction == true then
                    
                    local tag = sender:getTag()
                    self:skipDialog(tag, sender)
                end
            end

            self:getChildByName("view"):getChildByName("info"):requestDoLayout()
            local expnum = 0
			local drops = dd.giftPack(dd.myZombie:getString(i,"show"))
            
            local k = 0
            local x = 0
			for j=1,table.getn(drops) do
                local item = nil
                if drops[j][1] ~= 9 then
				    item = self:getChildByName("item1"):clone()
				    item:setVisible(true)
				    self:getChildByName("view"):getChildByName("droplists"):addChild(item)
                    item:setPosition(x*144, 0)
                    x = x+1
                    k = k+1
                end

				if drops[j][1] == 1 then
					item:getChildByName("item"):getChildByName("icon"):loadTexture(dd.getToolsIcon(drops[j][2]),0)
					item:getChildByName("count"):setString(drops[j][3])
					item:setTag(k)
					item._drop = drops[j]
                    item:addTouchEventListener(click)
                elseif drops[j][1] >=2 and drops[j][1] <= 7 then
                    local pic = nil;
                    if drops[j][1] == 2 then 
                        pic = "images/icon/res/ic04_bk.png"
                    elseif drops[j][1] == 3 then
                        pic = "images/icon/res/ic02_bk.png"
                    elseif drops[j][1] == 4 then
                        pic = "images/icon/res/ic03_bk.png"
                    elseif drops[j][1] == 5 then
                        pic = "images/icon/res/ic01_bk.png"
                    elseif drops[j][1] == 6 then
                        pic = "images/icon/res/ic05_bk.png"
                    elseif drops[j][1] == 7 then
                        pic = "images/icon/charge/gold.png"
                    end
					item:getChildByName("item"):getChildByName("icon"):loadTexture(pic, 0)
					item:getChildByName("count"):setString(drops[j][3])
					item:setTag(k)
                    item._drop = drops[j]
                    item:addTouchEventListener(click)
				elseif drops[j][1] == 9 then
					expnum = expnum + drops[j][3]
				elseif drops[j][1] == 15 then
					item:getChildByName("item"):getChildByName("icon"):loadTexture("images/icon/huizhang/"..dd.cfgCrystal[drops[j][2]]['pic']..".png",0)
					
					item:getChildByName("count"):setString(drops[j][3])
					item:setTag(k)
                    item._drop = drops[j]
                    item:addTouchEventListener(click)
				end
                self:getChildByName("view"):getChildByName("icon"):loadTexture(dd.getZombieImg(self._zombieid),0)
			end
            self:getChildByName("view"):getChildByName("info"):getChildByName("exp"):getChildByName("Label_167"):setString(expnum)
            local plus_7 = 0
            for i=1,dd.myeffect:rowCount() do
		        if dd.myeffect:getLong(i,"id") == 7 then
			        plus_7 = dd.myeffect:getLong(i,"param")
		        end		
	        end
			self:getChildByName("view"):getChildByName("info"):getChildByName("exp"):getChildByName("Label_137"):setString(" +"..math.floor(expnum * (plus_7/1000)))
            self:getChildByName("view"):getChildByName("info"):getChildByName("exp"):requestDoLayout()

            local count = table.getn(self:getChildByName("view"):getChildByName("herolists"):getItems())
            if count > 0 then
                self:getChildByName("view"):getChildByName("herolists"):removeAllChildren(true)   
            end
	        local heros = dd.heros:rowCount()
	        if heros < 5 then
		        heros = 5 
	        end	        
            for j=1,heros do
		        local item = self:getChildByName("item2"):clone()
		        item:setVisible(true)
                
		        if j <= dd.heros:rowCount() then
			        item:getChildByName("icon"):loadTexture("images/icon/hero/"..(10+dd.cfgHero[dd.heros:getLong(j,"id")]['pic'])..".png",0)
			        if dd.heros:getLong(j,"state") == 0 then
				        item:getChildByName("item"):addTouchEventListener(self.selectHero)						
			        else
				        item:setTouchEnabled(false)
				        item:getChildByName("item"):setTouchEnabled(false)
			        end
			        item:getChildByName("item"):setTag(dd.heros:getLong(j,"hid"))
			        item:getChildByName("level"):setVisible(true)
                    item:getChildByName("hp"):setVisible(true)
                    item:getChildByName("name"):setString(ff.langString(dd.cfgHero[dd.heros:getLong(j,"id")]['name']))
			        item:getChildByName("level"):getChildByName("label"):setString(dd.heros:getLong(j,"level"))
                    local point = (dd.getServerTime() -  dd.heros:getLong(j,"PVEHpTime")) /300
                    local hp =math.ceil(point * dd.heros:getLong(j,"PVEHpMax") / 100 + dd.heros:getLong(j,"PVEHpNow"))
                    if hp > dd.heros:getLong(j,"PVEHpMax") then
                        hp = dd.heros:getLong(j,"PVEHpMax") 
                    end
                    item:getChildByName("hp"):getChildByName("hp"):setPercent(math.ceil(100 * hp/dd.heros:getLong(j,"PVEHpMax")))
		        else
			        item:getChildByName("item"):setTouchEnabled(false)
			        item:getChildByName("level"):setVisible(false)
                    item:getChildByName("hp"):setVisible(false)
			        item:setTag(0)
		        end			
		        item:setScale(0.8)
                item:setLocalZOrder(0)
                item:requestDoLayout()	
                self:getChildByName("view"):getChildByName("herolists"):pushBackCustomItem(item)	        
            end

            break
		end

	end
end
function pveUILayer.onClose(sender,eventType)
	if eventType==ccui.TouchEventType.ended then
		pop.onClosePopDialog("pve")
        
        GuideControl:GuideCheck()
     
	end
end
function pveUILayer.onGetCityZombie(message)
	local code = message:getLong()
    local widget = pop.getDialog("pve")
	if code == 0 then
		
		widget._info.id = message:getLong()
		widget._info.hp = message:getLong()
		widget._info.win = message:getLong()
		widget._info.hid = message:getLong()
		widget._info.addexp = message:getLong()
		widget._info.level = message:getLong()
		widget._info.exp = message:getLong()
        dd.cityZombieCD = message:getLong()
		widget._info.turns = message:getLong()
		if widget._battle == nil then
			widget._battle = ff.NetTable:create()
		    widget._battle:addStreamCol("turn",ff.NET_LONG)
    		widget._battle:addStreamCol("r_blood",ff.NET_LONG)
    		widget._battle:addStreamCol("b_blood",ff.NET_LONG)
    		widget._battle:addStreamCol("r_mz",ff.NET_LONG)
    		widget._battle:addStreamCol("r_sx",ff.NET_LONG)
    		widget._battle:addStreamCol("r_normal",ff.NET_LONG)
    		widget._battle:addStreamCol("r_sxnum",ff.NET_LONG)
    		widget._battle:addStreamCol("r_power",ff.NET_LONG)
    		widget._battle:addStreamCol("b_mz",ff.NET_LONG)
    		widget._battle:addStreamCol("b_sx",ff.NET_LONG)
    		widget._battle:addStreamCol("b_normal",ff.NET_LONG)
    		widget._battle:addStreamCol("b_sxnum",ff.NET_LONG)
    		widget._battle:addStreamCol("b_power",ff.NET_LONG)
    		widget._battle:addStreamCol("r_e_blood",ff.NET_LONG)
    		widget._battle:addStreamCol("b_e_blood",ff.NET_LONG)
    	else
    		widget._battle:delRows()
    	end
        message:getData(widget._info.turns, widget._battle)

        widget._info.nCount = message:getLong()        	
        if widget._drop == nil and widget._info.nCount > 0 then 
            widget._drop = ff.NetTable:create()
            widget._drop:addStreamCol("type_",ff.NET_LONG)
    		widget._drop:addStreamCol("id_",ff.NET_LONG)
    		widget._drop:addStreamCol("num_",ff.NET_LONG)          
        else

        end

        message:getData(widget._info.nCount, widget._drop)

        for i=1,dd.heros:rowCount() do
            if dd.heros:getLong(i,"hid") == widget._info.hid then
                dd.heros:setLong(i,"PVEHpMax",message:getLong() )
                dd.heros:setLong(i,"PVEHpNow",message:getLong() )
                dd.heros:setLong(i,"PVEHpTime",message:getLong() )
                break
            end
        end
        

    	widget:onShowBattle()
	else
        if code == 133 then
            function dispear( sender )
               
                sender:setVisible(false)
            end
            for i,v in ipairs(widget:getChildByName("view"):getChildByName("herolists"):getChildren()) do
                
                if  v:getChildByName("item"):getTag() == widget._hid then
                    local anr   = v:getChildByName("item"):getAnchorPoint()
                    local size  = v:getChildByName("item"):getContentSize()
                    local p = v:getChildByName("item"):convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height))
                    local pos = widget:convertToNodeSpace(p)

                    pos.x = pos.x + 73
                    
                    pos.y = pos.y + 98
                    widget:getChildByName("info"):stopAllActions()
                    widget:getChildByName("info"):setPosition(pos)
                    widget:getChildByName("info"):setVisible(true)
                    local hpMax = false
                    for j=1,dd.heros:rowCount() do
                        if dd.heros:getLong(j,"hid") == widget._hid then
                            local point = (dd.getServerTime() -  dd.heros:getLong(j,"PVEHpTime")) /300
                            local hp =math.ceil(point * dd.heros:getLong(j,"PVEHpMax") / 100 + dd.heros:getLong(j,"PVEHpNow"))
                            if hp >= dd.heros:getLong(j,"PVEHpMax") then
                                hp = dd.heros:getLong(j,"PVEHpMax") 
                                hpMax = true
                            end
                            break
                        end
                    end
                    if hpMax == false then
                        widget:getChildByName("info"):getChildByName("kuang"):getChildByName("descrip"):setString(ff.langString("我的体力不足"))
                    else
                        widget:getChildByName("info"):getChildByName("kuang"):getChildByName("descrip"):setString(ff.langString("它太强了，我没有胜算"))
                    end
                    
                    performWithDelay(widget:getChildByName("info"),dispear,2)
                    break
                end
            end
        else
            dd.mainUI:onShowCodeTips(code)
        end
	end
	message:clear()
end

function pveUILayer.endBattle(sender,eventType)
	if eventType==ccui.TouchEventType.ended then
		local widget = pop.getDialog("pve")
		widget:onEndBattle()
	end
end
function pveUILayer:onEndBattle()
    self:getChildByName("battle"):stopAllActions()
    self:stopAllActions()
    self:getChildByName("win"):getChildByName("result"):getChildByTag(50):stopAllActions()
    self:getChildByName("win"):getChildByName("result"):removeAllChildren()
	self:getChildByName("battle"):setVisible(false)
	--pop.onClosePopDialog("pve")
    self.onReturn()
end

function pveUILayer.onReturn(sender)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        pop.onClosePopDialog("pve")
    end
end

function pveUILayer.onAttack(sender,eventType)
	if eventType==ccui.TouchEventType.ended then
		local widget = pop.getDialog("pve")
        if widget.loseIsShow == true then
            return
        end
		widget._turn = widget._turn + 1
		widget:updateInfo()
        widget:addAttackEF()
        widget:updateHramInfo()
		local function startAction()
			widget:getChildByName("battle"):getChildByName("effects"):getChildByName("touch"):setTouchEnabled(true)	
			widget:getChildByName("battle"):getChildByName("detail"):getChildByName("btns"):getChildByName("attack"):setEnabled(true)  

            GuideControl:GuideCheck()
          
		end
		widget:getChildByName("battle"):getChildByName("detail"):getChildByName("btns"):getChildByName("attack"):setEnabled(false)
		widget:getChildByName("battle"):getChildByName("effects"):getChildByName("touch"):setTouchEnabled(false)
        widget:getChildByName("battle"):getChildByName("effects"):getChildByName("touch"):stopAllActions()
        widget:getChildByName("battle"):getChildByName("effects"):getChildByName("touch"):setOpacity(0)
        
        if widget._turn < widget._info.turns then
            cclog("widget._turn  " .. widget._turn)
            if widget._battle:getLong(widget._turn + 1, "turn") == 0 then
                widget:runAction(cc.Sequence:create(cc.DelayTime:create(1.5), cc.CallFunc:create(function () widget:showBattleEnd() end)))
            end
            local battle = widget:getChildByName("battle")
            local progress = battle:getChildByName("progress")
            local bluehp = widget._battle:getLong(1,"b_blood")
            if bluehp <= 0 then
    	        bluehp = 0
            end
	        local redhp = widget._battle:getLong(1,"r_blood")
            if redhp <= 0 then
    	        redhp = 0
            end	

            for i = 1, dd.heros:rowCount() do
                
                if dd.heros:getLong(i,"hid") == widget._info.hid then
                    redhp = dd.heros:getLong(i,"PVEHpMax")
                    break
                end
            end

            local blueend = false
            local redend = false
            widget._info.blue_step = (widget._battle:getLong(widget._turn,"b_blood") - widget._battle:getLong(widget._turn,"b_e_blood"))/20

		    widget._info.red_step = (widget._battle:getLong(widget._turn,"r_blood") - widget._battle:getLong(widget._turn,"r_e_blood"))/20

            cclog("widget._info.red_step: " ..widget._info.red_step)
            cclog("widget._info.blue_step: " ..widget._info.blue_step)
            local function updateBlueHp()
                if widget._info.blue_hp == nil then
                    progress:getChildByName("progress"):getChildByName("blue"):stopAllActions()
                    return
                end
                if widget._info.blue_hp == nil or bluehp == nil then
                    return
                end
			    if widget._info.blue_hp <= widget._battle:getLong(widget._turn,"b_e_blood") then
				    widget._info.blue_hp = widget._battle:getLong(widget._turn,"b_e_blood")
				    progress:getChildByName("progress"):getChildByName("blue"):stopAllActions()
			        blueend = true
                    if blueend and redend then
                        widget:getChildByName("battle"):getChildByName("effects"):getChildByName("touch"):runAction(cc.Sequence:create(cc.FadeIn:create(0.05),cc.CallFunc:create(startAction)))            
                    end
                end
                if tonumber(widget._info.blue_hp) < 0 then
                    progress:getChildByName("progress"):getChildByName("blue"):getChildByName("hp"):setString("0/"..bluehp)
                else
                    progress:getChildByName("progress"):getChildByName("blue"):getChildByName("hp"):setString(math.floor(widget._info.blue_hp).."/"..bluehp)
                end
			    widget._info.blue_hp = math.floor(widget._info.blue_hp - widget._info.blue_step)
			    progress:getChildByName("progress"):getChildByName("blue"):getChildByName("progress"):setPercent((widget._info.blue_hp * 100)/bluehp)
		    end
		    local function updateRedHp()
                
                if widget._info.red_hp == nil then
                    progress:getChildByName("progress"):getChildByName("red"):stopAllActions()
                    return
                end


                
			    if widget._info.red_hp <= widget._battle:getLong(widget._turn,"r_e_blood") then
				    widget._info.red_hp = widget._battle:getLong(widget._turn,"r_e_blood")
				    progress:getChildByName("progress"):getChildByName("red"):stopAllActions()
                    redend = true
                    if blueend and redend then
                        widget:getChildByName("battle"):getChildByName("effects"):getChildByName("touch"):runAction(cc.Sequence:create(cc.FadeIn:create(0.05),cc.CallFunc:create(startAction)))
			        end
                end
                if tonumber(widget._info.red_hp) < 0 then
                    progress:getChildByName("progress"):getChildByName("red"):getChildByName("hp"):setString("0/"..redhp)
                else            
                    progress:getChildByName("progress"):getChildByName("red"):getChildByName("hp"):setString(math.floor(widget._info.red_hp).."/"..redhp)
                end
			    widget._info.red_hp = math.floor(widget._info.red_hp - widget._info.red_step)
			    progress:getChildByName("progress"):getChildByName("red"):getChildByName("progress"):setPercent((widget._info.red_hp * 100)/redhp)
		    end

            local seq = cc.Sequence:create(cc.DelayTime:create(0.8), cc.CallFunc:create(function() schedule(progress:getChildByName("progress"):getChildByName("blue"), updateBlueHp, 0);schedule(progress:getChildByName("progress"):getChildByName("red"), updateRedHp, 0)end))
            widget:runAction(seq)
		    
		else
			widget:runAction(cc.Sequence:create(cc.DelayTime:create(1.5), cc.CallFunc:create(function () widget:showBattleEnd() end)))
		end        
	end
end

function pveUILayer:ShowWin()
    self:getChildByName("win"):setVisible(true)
    self:getChildByName("battle"):setVisible(false)
    local LvUpExp = 0;
    local id = nil
    local lv = nil
    local name = nil
    for i = 1, dd.heros:rowCount() do
        if dd.heros:getLong(i,"hid") == self._info.hid then
            id = dd.heros:getLong(i,"id")
            lv = dd.heros:getLong(i,"level")
            name = dd.heros:getString(i,"name")
            local star = dd.cfgHero[id]["star"]
            LvUpExp = dd.cfgHeroUp[star][lv+1]["levelupexp"]
            break;
        end
    end
    
    self:getChildByName("win"):getChildByName("info"):getChildByName("heroInfo"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getHeroIcon(id), 0)
    self:getChildByName("win"):getChildByName("info"):getChildByName("heroInfo"):getChildByName("info"):getChildByName("name"):setString(name.."  LV."..lv)

    local exp = self._info.exp - self._info.addexp
    local add = self._info.addexp
    local pro = self:getChildByName("win"):getChildByName("info"):getChildByName("exp"):getChildByName("progress1")
    local num = self:getChildByName("win"):getChildByName("info"):getChildByName("exp"):getChildByName("num")

    local function updateExp()
        local a = add>=3 and 3 or add
        if exp + a < LvUpExp then
            exp = exp + a
        else
            exp = exp + a - LvUpExp
           
        end
        pro:setPercent(exp / LvUpExp * 100)
        if exp < 0 then
            num:setString("0/"..LvUpExp)
        else
            num:setString(exp.."/"..LvUpExp)
        end
        add = add - a
        if add <= 0 then
            self:getChildByName("win"):getChildByName("info"):getChildByName("exp"):stopAllActions()
        end
    end
    schedule(self:getChildByName("win"):getChildByName("info"):getChildByName("exp"), updateExp, 0.01)

     local function click(sender, eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end
    
        if eventType==ccui.TouchEventType.ended then    
            doaction = true
        end
        if doaction == true then
            
            local tag = sender:getTag()
            self:skipDialog(tag, sender)
        end
    end
    

    updateExp();
    local x = 0
    for i = 1, self._info.nCount do 
        local items = self:getChildByName("item1"):clone()
        items:setVisible(true)
        local type_ = self._drop:getLong(i,"type_")
        local did = self._drop:getLong(i,"id_")  
        local num__ = self._drop:getLong(i,"num_")
        items:setPosition(x*144, 0)
        if type_ == 1 then
            local pidicon = nil
            pidicon = dd.cfgProp[did] 
            items:getChildByName("item"):getChildByName("icon"):loadTexture("images/icon/tools/"..pidicon["image"]..".png", 0)
            items:getChildByName("count"):setString(num__)
            self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):addChild(items)
            items:addTouchEventListener(click)
            items:setTag(x+1)
            items._drop = {type_, did, num__}
            x = x+1
        elseif type_ >=2 and type_ <= 7 then
            local pic = nil;
            if type_ == 2 then 
                pic = "images/icon/res/ic04_bk.png"
            elseif type_ == 3 then
                pic = "images/icon/res/ic02_bk.png"
            elseif type_ == 4 then
                pic = "images/icon/res/ic03_bk.png"
            elseif type_ == 5 then
                pic = "images/icon/res/ic01_bk.png"
            elseif type_ == 6 then
                pic = "images/icon/res/ic05_bk.png"
            elseif type_ == 7 then
                pic = "images/icon/charge/gold.png"
            end
            items:getChildByName("item"):getChildByName("icon"):loadTexture(pic, 0)
            items:getChildByName("count"):setString(num__)
            items:addTouchEventListener(click)
            items:setTag(x+1)
            items._drop = {type_, did, num__}
            x = x+1
            self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):addChild(items)
        elseif type_ == 9 then

        elseif type_ == 15 then
            local pidicon = nil
            pidicon = dd.getHuizhangIcon(did)
            items:getChildByName("item"):getChildByName("icon"):loadTexture(pidicon, 0)
            x = x+1
            items:getChildByName("count"):setString(num__)
            items:addTouchEventListener(click)
            items:setTag(x+1)
            items._drop = {type_, did, num__}
            self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):addChild(items)
        end
        local sprite = sp.SkeletonAnimation:create("images/pve/PveAnimation/zhuchengshengji.json", "images/pve/PveAnimation/zhuchengshengji.atlas")
        sprite:setPosition(cc.p(items:getContentSize().width / 2-10, items:getContentSize().height / 2-15))
        sprite:setAnimation(0, "Guangquan_animation", true)
        items:getChildByName("item"):addChild(sprite)
    end
    function update()
       local sprite = sp.SkeletonAnimation:create("images/pve/PVEshengli.json", "images/pve/PVEshengli.atlas")
       sprite:setPosition(cc.p(360, -70))
       sprite:setAnimation(0, "PVEshengli_animation", true)
       self:getChildByName("win"):getChildByName("result"):addChild(sprite, 50,50)
    end
    update()
    
    AudioEngine.playEffect(ff.sounds[305]) 

    GuideControl:GuideCheck()

end
function pveUILayer:showBattleEnd()
    self:getChildByName("battle"):stopAllActions()
    self:getChildByName("battle"):getChildByName("progress"):getChildByName("progress"):getChildByName("red"):stopAllActions()
    self:getChildByName("battle"):getChildByName("progress"):getChildByName("progress"):getChildByName("blue"):stopAllActions()
	self:getChildByName("battle"):getChildByName("effects"):getChildByName("touch"):setVisible(false)
	self:getChildByName("battle"):getChildByName("effects"):getChildByName("touch"):setTouchEnabled(false)
    if self._info.win == 1 then
		self:ShowWin()
	elseif self._info.win == 2 then
		self:getChildByName("lose"):setVisible(true)
		self:getChildByName("battle"):setVisible(false)
        self:getChildByName("lose"):setTouchEnabled(true)
        self.loseIsShow  = true
        AudioEngine.playEffect(ff.sounds[306]) 
	end		
end
function pveUILayer:addAttackEF()
    local function LShake_(taget)
        local action = cc.Sequence:create(
            cc.MoveBy:create(0.04, cc.p(10, 10)),
            cc.MoveBy:create(0.04, cc.p(-10, 10)),
            cc.MoveBy:create(0.04, cc.p(-10, -10)),
            cc.MoveBy:create(0.04, cc.p(10, -10))
        )
        taget:runAction(action)
    end
    
    if self._battle:getLong(self._turn,"r_sx") > 0 then
        local shoot = 0 
        local miss = 0  
        local double = 0 
        local ddouble = 0 
        local fire = 0 
        for i=1,dd.heros:rowCount() do
		    if dd.heros:getLong(i,"hid") == self._info.hid then
			    shoot = dd.cfgHero[dd.heros:getLong(i,"id")]['shoot']
                miss = dd.cfgHero[dd.heros:getLong(i,"id")]['miss']
                double = dd.cfgHero[dd.heros:getLong(i,"id")]['double']
                ddouble = dd.cfgHero[dd.heros:getLong(i,"id")]['ddouble']
                fire = dd.cfgHero[dd.heros:getLong(i,"id")]['fire']
			    break
		    end
	    end
        if ddouble > 0 then
            
          local sprite = sp.SkeletonAnimation:create("images/pve/skeleton.json", "images/pve/skeleton.atlas")
          sprite:setPosition(cc.p(360, 600))
          sprite:setAnimation(0, "Headshot_animation", false)
          self:addChild(sprite, 5)
          performWithDelay(sprite, function()  sprite:removeFromParent() end, 2)

            local pram = 0
            self.attackEF["attack"][1] = {}
            self.attackEF["attack"][2] = {}
            local zombiePosX, zombiePosY = self:getChildByName("battle"):getChildByName("effects"):getChildByName("zombie"):getPosition()
            function addEF()
                pram = pram + 1  
                if pram > 6 then
                    return 
                end             
                local randomPosX, randomPosY = zombiePosX + math.random(0, 300) - 350 , zombiePosY + math.random(300, 800)                
                self.attackEF["attack"][1][pram] = ccs.Armature:create("PveAnimation")
                self.attackEF["attack"][1][pram]:getAnimation():play("attack")
                self.attackEF["attack"][1][pram]:setPosition(cc.p(randomPosX, randomPosY))
                self.attackEF["attack"][1][pram]:setAnchorPoint(cc.p(0.7, 0.5))
                self.attackEF["attack"][1][pram]:setScale(math.random(300, 500) / 100)
                self:addChild(self.attackEF["attack"][1][pram], 9)
                    
                self.attackEF["attack"][2][pram] = cc.Sprite:create("images/pve/dankong.png")
                self.attackEF["attack"][2][pram]:setPosition(cc.p(randomPosX, randomPosY))
                self.attackEF["attack"][2][pram]:setScale(math.random(40, 100) / 100)
                self:addChild(self.attackEF["attack"][2][pram], 10)

                LShake_(self.battleBG)
		        dd.shake(self:getChildByName("battle"):getChildByName("effects"):getChildByName("zombie"))
                self.attackEF["attack"][2][pram]:runAction(cc.Sequence:create(cc.FadeOut:create(1), cc.CallFunc:create(
                    function ()
                        for i = 1, 6 do
                            if self.attackEF["attack"][1][i] ~= nil then
                                self.attackEF["attack"][1][i]:removeFromParent()
                                self.attackEF["attack"][1][i] = nil
                            end
                            if self.attackEF["attack"][2][i] ~= nil then
                                self.attackEF["attack"][2][i]:removeFromParent()
                                self.attackEF["attack"][2][i] = nil
                            end    
                        end
                    end)))     
                AudioEngine.playEffect(ff.sounds[302])              
            end
            self:runAction(cc.Repeat:create(cc.Sequence:create(cc.CallFunc:create(addEF), cc.DelayTime:create(0.15)), 6))
        end  
        if shoot > 0 then    
            
            local daoRotate = {0, 284, 73}
            local xueRotate = {335, 48, 355}
            local DaoScale = {1, 1.6, 2.0}
            local xueScale = {1.2, 1.5, 1.8}
            local pos = {cc.p(530, 800), cc.p(500, 810), cc.p(550, 830)}
            local _ = 0
            function pgonce()
                _ = _ + 1
                local dh = cc.Sprite:create("images/pve/Mark.png");
                dh:setPosition(pos[_])
                dh:setRotation(daoRotate[_])
                dh:setScale(DaoScale[_])
                self:addChild(dh, 9)

                local lx = ccs.Armature:create("PveAnimation")
                lx:getAnimation():play("baoji")
                lx:setPosition(dh:getPosition())
                lx:setAnchorPoint(cc.p(0.5, 6/7))
                lx:setRotation(xueRotate[_])
                lx:setScale(xueScale[_])
                self:addChild(lx, 8)

                dh:runAction(cc.Sequence:create(cc.FadeOut:create(0.5), cc.CallFunc:create(function () dh:removeFromParent() end)))
                lx:runAction(cc.Sequence:create(cc.FadeOut:create(0.5), cc.CallFunc:create(function () lx:removeFromParent() end)))
                if _ >= 3 then
                    self:getChildByName("battle"):stopAllActions()
                end
                LShake_(self.battleBG)
		        dd.shake(self:getChildByName("battle"):getChildByName("effects"):getChildByName("zombie"))
                AudioEngine.playEffect(ff.sounds[301])
            end
            self:getChildByName("battle"):runAction(cc.RepeatForever:create( cc.Sequence:create(
                cc.DelayTime:create(0.3),
                cc.CallFunc:create(function () pgonce() end)
            )))
        end
        if miss > 0 then
           
            local sprite = sp.SkeletonAnimation:create("images/pve/skeleton.json", "images/pve/skeleton.atlas")
            sprite:setPosition(cc.p(360, 600))
            sprite:setAnimation(0, "Fire_animation", false)
            self:addChild(sprite, 5)
            performWithDelay(sprite, function()  sprite:removeFromParent() end, 2)

            local posX = self:getChildByName("battle"):getChildByName("effects"):getChildByName("zombie"):getPositionX()
            local posY = self:getChildByName("battle"):getChildByName("effects"):getChildByName("zombie"):getPositionY()
            self.attackEF["fire"] = ccs.Armature:create("PveAnimation")
            self.attackEF["fire"]:getAnimation():play("fire")
            self.attackEF["fire"]:setPosition(posX - 150, posY - 220)
            self.attackEF["fire"]:setAnchorPoint(cc.p(0.5, 0))
            self.attackEF["fire"]:setScale(0.5) 
            self:getChildByName("battle"):getChildByName("effects"):addChild(self.attackEF["fire"], 5)
            self:runAction(cc.Sequence:create(
                cc.DelayTime:create(1),
                cc.CallFunc:create(function () self.attackEF["fire"]:removeFromParent() end)
            ))
            self.attackEF["fire"]:runAction(cc.ScaleTo:create(0.2, 2))
            AudioEngine.playEffect(ff.sounds[304]) 
        end
        if fire > 0 then
            
            local sprite = sp.SkeletonAnimation:create("images/pve/skeleton.json", "images/pve/skeleton.atlas")
            sprite:setPosition(cc.p(360, 600))
            sprite:setAnimation(0, "Crit_animation", false)
            self:addChild(sprite, 5)
            performWithDelay(sprite, function()  sprite:removeFromParent() end, 2)

            self.attackEF["baoji"] = ccs.Armature:create("PveAnimation")
            self.attackEF["baoji"]:getAnimation():play("baoji")
            self.attackEF["baoji"]:setPosition(530, 900)
            self.attackEF["baoji"]:setAnchorPoint(cc.p(0.5, 5/6))
            self.attackEF["baoji"]:setScale(2)
            self:addChild(self.attackEF["baoji"], 10)

            local dk = cc.Sprite:create("images/pve/dankong.png");
            dk:setPosition(600, 900)
            dk:setScale(1.5)
            self:addChild(dk, 9)
            local xj = cc.Sprite:create("images/pve/xueji.png");
            xj:setPosition(450, 820)
            xj:setScale(5)
            self:addChild(xj, 10)

            LShake_(self.battleBG)
		    dd.shake(self:getChildByName("battle"):getChildByName("effects"):getChildByName("zombie"))
            self:runAction(cc.Sequence:create(
                cc.DelayTime:create(1),
                cc.CallFunc:create(function () self.attackEF["baoji"]:removeFromParent()  dk:removeFromParent() xj:removeFromParent() end)
            ))
            AudioEngine.playEffect(ff.sounds[303]) 
        end
        if double > 0 then
            
            local function addBaoji()
                self.attackEF["juji"] = ccs.Armature:create("PveAnimation")
                self.attackEF["juji"]:getAnimation():play("baoji")
                self.attackEF["juji"]:setPosition(600, 930)
                self.attackEF["juji"]:setAnchorPoint(cc.p(0.5, 5/6))
                self.attackEF["juji"]:setScale(2)
                self:addChild(self.attackEF["juji"], 10)

                local dk = cc.Sprite:create("images/pve/dankong.png");
                dk:setPosition(600, 930)
                dk:setScale(1.5)
                self:addChild(dk, 9)
                local xj = cc.Sprite:create("images/pve/xueji.png");
                xj:setPosition(450, 820)
                xj:setScale(5)
                self:addChild(xj, 10)

                LShake_(self.battleBG)
		        dd.shake(self:getChildByName("battle"):getChildByName("effects"):getChildByName("zombie"))
                self:runAction(cc.Sequence:create(
                    cc.DelayTime:create(1),
                    cc.CallFunc:create(function () self.attackEF["juji"]:removeFromParent()  dk:removeFromParent() xj:removeFromParent() end)
                ))
            end
            local sprite = sp.SkeletonAnimation:create("images/pve/Final_1_0.json", "images/pve/Final_1_0.atlas")
            sprite:setPosition(600, 930)
            sprite:setAnimation(0, "juji_animation", false)
            self:addChild(sprite, 5)
            performWithDelay(sprite, function()  addBaoji() sprite:removeFromParent() end, 0.5)

        
            AudioEngine.playEffect(ff.sounds[303]) 
        end
    else
        if self._battle:getLong(self._turn,"r_normal") > 0 then    
           
            local daoRotate = {0, 284, 73}
            local xueRotate = {335, 48, 355}
            local DaoScale = {0.5, 0.8, 0.5}
            local xueScale = {1.2, 1.5, 1.2}
            local pos = {cc.p(500, 950), cc.p(500, 800), cc.p(630, 800)}
            local _ = 0
            function pgonce()
                _ = _ + 1
                local dh = cc.Sprite:create("images/pve/dankong.png");
                dh:setPosition(pos[_])
               
                dh:setScale(DaoScale[_])
                self:addChild(dh, 9)

                local lx = ccs.Armature:create("PveAnimation")
                lx:getAnimation():play("attack")
                lx:setPosition(dh:getPosition())
               
                lx:setRotation(xueRotate[_])
                lx:setScale(xueScale[_])
                self:addChild(lx, 8)

                dh:runAction(cc.Sequence:create(cc.FadeOut:create(0.5), cc.CallFunc:create(function () dh:removeFromParent() end)))
                lx:runAction(cc.Sequence:create(cc.FadeOut:create(0.5), cc.CallFunc:create(function () lx:removeFromParent() end)))
                if _ >= 3 then
                    self:getChildByName("battle"):stopAllActions()
                end
                LShake_(self.battleBG)
		        dd.shake(self:getChildByName("battle"):getChildByName("effects"):getChildByName("zombie"))
                AudioEngine.playEffect(ff.sounds[303])
            end
            self:getChildByName("battle"):runAction(cc.RepeatForever:create( cc.Sequence:create(
                cc.DelayTime:create(0.3),
                cc.CallFunc:create(function () pgonce() end)
            )))
        end
    end
end
function pveUILayer:updateInfo()
	local battle = self:getChildByName("battle")
	local progress = battle:getChildByName("progress")

	local bluehp = self._battle:getLong(1,"b_blood")
    if bluehp <= 0 then
    	bluehp = 0
    end
	local redhp = self._battle:getLong(1,"r_blood")
    if redhp <= 0 then
    	redhp = 0
    end	
    local maxhp = redhp
    for i = 1, dd.heros:rowCount() do
        if dd.heros:getLong(i,"hid") == self._info.hid then
            maxhp = dd.heros:getLong(i,"PVEHpMax")
            break
        end
    end
	if self._turn == 0 then
		progress:getChildByName("progress"):getChildByName("blue"):getChildByName("hp"):setString(bluehp.."/"..bluehp)
		progress:getChildByName("progress"):getChildByName("red"):getChildByName("hp"):setString(redhp.."/"..maxhp)
        progress:getChildByName("progress"):getChildByName("blue"):getChildByName("progress"):setPercent(100)
        progress:getChildByName("progress"):getChildByName("red"):getChildByName("progress"):setPercent((redhp * 100)/maxhp)
        local size = progress:getChildByName("progress"):getChildByName("red"):getChildByName("progress"):getContentSize()
        progress:getChildByName("progress"):getChildByName("red"):getChildByName("progress"):setPosition(size.width/2, size.height/2)
		progress:getChildByName("progress"):getChildByName("red"):getChildByName("progress"):setScaleY(1.5)
        progress:getChildByName("progress"):getChildByName("red"):getChildByName("hp"):setPosition(size.width/2, size.height/2)
        progress:getChildByName("progress"):getChildByName("blue"):getChildByName("progress"):setPosition(size.width/2, size.height/2)
		progress:getChildByName("progress"):getChildByName("blue"):getChildByName("progress"):setScaleY(1.5)
        progress:getChildByName("progress"):getChildByName("blue"):getChildByName("hp"):setPosition(size.width/2, size.height/2)
        local id = 0
		for i=1,dd.heros:rowCount() do
			if dd.heros:getLong(i,"hid") == self._info.hid then
				progress:getChildByName("info"):getChildByName("red"):setString(ff.langString(dd.cfgHero[dd.heros:getLong(i,"id")]['name']))
				progress:getChildByName("info"):getChildByName("red_level"):getChildByName("level"):setString("LV."..dd.heros:getLong(i,"level"))
				id = dd.heros:getLong(i,"id")
				break
			end
		end
		progress:getChildByName("info"):getChildByName("blue"):setString(ff.langString(self._enemy[self._zombieid]['name']))
		progress:getChildByName("info"):getChildByName("blue_level"):getChildByName("level"):setString("LV."..self._level)

		battle:getChildByName("effects"):getChildByName("Panel_141"):getChildByName("hero"):loadTexture(dd.getHeroImg(id),0)
		battle:getChildByName("effects"):getChildByName("zombie"):loadTexture(dd.getZombieImg(self._zombieid),0)

		self._info.blue_hp = bluehp
		self._info.red_hp = redhp

		self:addTips(1,ff.langString("准备战斗！点击Tap攻击僵尸"),0)
	else
		self._info.blue_step = (self._battle:getLong(self._turn,"b_blood") - self._battle:getLong(self._turn,"b_e_blood"))/20
		if self._info.blue_step < 1 then
			self._info.blue_step = 1
		end
		self._info.red_step = (self._battle:getLong(self._turn,"r_blood") - self._battle:getLong(self._turn,"r_e_blood"))/20
		if self._info.red_step < 1 then
			self._info.red_step = 1
		end

	
		self:addTips(1,ff.langString("第{0}回合", {self._turn}))

		local mystr = ""
		if self._battle:getLong(self._turn,"r_mz") == 0 then
			mystr = ff.langString("攻击失误。")
			self:addTips(2,mystr,0)
		else
			local zombie = self:getChildByName("battle"):getChildByName("effects"):getChildByName("zombie")
			local rotation = math.random() * 360
            
			if self._battle:getLong(self._turn,"r_sx") == 1 then
				mystr = ff.langString("僵尸受到了属性攻击")
				self:addTips(2,mystr,-(self._battle:getLong(self._turn,"r_normal") + self._battle:getLong(self._turn,"r_sxnum") + self._battle:getLong(self._turn,"r_power")))
			else
				mystr = ff.langString("僵尸受到了攻击")
				self:addTips(2,mystr,-(self._battle:getLong(self._turn,"r_normal") + self._battle:getLong(self._turn,"r_sxnum") + self._battle:getLong(self._turn,"r_power")))
			end
		end

		if self._battle:getLong(self._turn,"b_mz") == 0 then
			mystr = ff.langString("你避开了僵尸的攻击。")
			self:addTips(2,mystr,0)
		else
			local hero = self:getChildByName("battle"):getChildByName("effects"):getChildByName("Panel_141"):getChildByName("hero")
			local rotation = math.random() * 360
			if self._battle:getLong(self._turn,"b_sx") == 1 then
				mystr = ff.langString("你受到了属性攻击")
				self:addTips(2,mystr,-(self._battle:getLong(self._turn,"b_normal") + self._battle:getLong(self._turn,"b_sxnum") + self._battle:getLong(self._turn,"b_power")))
            else
				mystr = ff.langString("你受到了攻击")
				self:addTips(2,mystr,-(self._battle:getLong(self._turn,"b_normal") + self._battle:getLong(self._turn,"b_sxnum") + self._battle:getLong(self._turn,"b_power")))
                              
			end
		end
	end
end
function pveUILayer:addTips(type,tips,value)
	local lists = self:getChildByName("battle"):getChildByName("detail"):getChildByName("lists")
	local item = self:getChildByName("item"):clone()
	item:setVisible(true)
	if type == 1 then
		item:getChildByName("tips"):setColor(cc.c3b(161,175,175))
		item:getChildByName("tips"):setFontSize(22)
		item:getChildByName("tips"):setString(ff.langString(tips))
	else
		item:getChildByName("tips"):setColor(cc.c3b(153,167,167))
		item:getChildByName("tips"):setFontSize(20)
		item:getChildByName("tips"):setString(ff.langString(tips))
	end
	if value ~= 0 then
		item:getChildByName("value"):setVisible(true)
		item:getChildByName("value"):setString(value)
	else
		item:getChildByName("value"):setVisible(false)
	end
	lists:addChild(item)

    lists:refreshView(true)
	lists:scrollToBottom(0.5,true)
end

function pveUILayer:getCrystalsValue(tools,param)
    local value = 0
    for i,item in ipairs(tools) do
        if item ~= 0 then
            value = value + self:getACrystalValue(item,param)
        end
    end
    return value
end

function pveUILayer:getACrystalValue(tid,param)
   
    for i=1,dd.myCrystals:rowCount() do
        if dd.myCrystals:getLong(i,"cid") == tid then
            local cryid = dd.myCrystals:getLong(i,"id")
            if dd.cfgCrystal[cryid]["param1"] == param then
                local lv = dd.myCrystals:getLong(i,"level")
                local value = dd.cfgCrystal[cryid]["value1"]+dd.cfgCrystal[cryid]["addvalue1"]*(lv-1)/10
                return value
            else
                return 0
            end
        end
    end
    return 0 
end

function pveUILayer:getArmsValue(arms,param)
    local value = 0
    for i,item in ipairs(arms) do
        for k=1,dd.myArms:rowCount() do
            if item == dd.myArms:getLong(k,"tid") then
                local cfgid = dd.myArms:getLong(k,"aid")
                if dd.cfgArms[cfgid] ~= nil then
                    for i=1, 4 do
                        if dd.cfgArms[cfgid]["param"..i] == param then
                            value = value + dd.cfgArms[cfgid]["value"..i]
                        end
                    end
                end
            end
        end
    end
    return value
end

function pveUILayer:getGemsValue(arms,param)
    local value = 0
    for i,item in ipairs(arms) do
        for k=1,dd.myArms:rowCount() do
            if dd.myArms:getLong(k,"tid")== item then
                value = value + self:getAGemValue(dd.myArms:getLong(k,"gem1"),param)
                value = value + self:getAGemValue(dd.myArms:getLong(k,"gem2"),param)
                value = value + self:getAGemValue(dd.myArms:getLong(k,"gem3"),param)
                value = value + self:getAGemValue(dd.myArms:getLong(k,"gem4"),param)
            end
        end
    end
    return value
end
function pveUILayer:getAGemValue(gid,param)
    if dd.cfgGems[gid] ~= nil then
        if dd.cfgGems[gid]['param1'] == param then
            return dd.cfgGems[gid]['value1']
        end
        if dd.cfgGems[gid]['param2'] == param then
            return dd.cfgGems[gid]['value2']
        end
        return 0
    else
        return 0
    end
end

function pveUILayer:onShowBattle()
	if dd.currentLayer._name == "pve" then
	
		self:getChildByName("view"):setVisible(false)

        for i = 1, dd.heros:rowCount() do
            if dd.heros:getLong(i,"hid") == self._info.hid then
                local index = i
                local id= dd.heros:getLong(index,"id")
                local lv = dd.heros:getLong(index,"level")  
                local type = dd.cfgHero[id]["crystal1"]
                local flag = math.log(type)/math.log(2) + 1

                local toolarr = {
                    dd.heros:getLong(index,"tools1"),
                    dd.heros:getLong(index,"tools2"),
                    dd.heros:getLong(index,"tools3"),
                    dd.heros:getLong(index,"tools4"),
                    dd.heros:getLong(index,"tools5"),
                    dd.heros:getLong(index,"tools6"),
                    dd.heros:getLong(index,"tools7"),
                    dd.heros:getLong(index,"tools8")
                }
                local armarr = {
                    dd.heros:getLong(index,"arms1"),
                    dd.heros:getLong(index,"arms2"),
                    dd.heros:getLong(index,"arms3"),
                    dd.heros:getLong(index,"arms4"),
                    dd.heros:getLong(index,"arms5"),
                    dd.heros:getLong(index,"arms6")
                }

                local namearr = {"攻击","防御","血量","劈砍","搏击","枪械","狙击","火焰"}
                local herovalue = {
                    dd.cfgHero[id]["atk"] + dd.cfgHero[id]["atkadd"]*(lv-1)/10,
                    dd.cfgHero[id]["def"] + dd.cfgHero[id]["defadd"]*(lv-1)/10,
                    dd.cfgHero[id]["hp"] + dd.cfgHero[id]["hpadd"]*(lv-1)/10,
                    dd.cfgHero[id]["shoot"] + dd.cfgHero[id]["shootadd"]*(lv-1)/10,
                    dd.cfgHero[id]["fire"] + dd.cfgHero[id]["fireadd"]*(lv-1)/10,
                    dd.cfgHero[id]["ddouble"] + dd.cfgHero[id]["ddoubleadd"]*(lv-1)/10,
                    dd.cfgHero[id]["double"] + dd.cfgHero[id]["doubleadd"]*(lv-1)/10,
                    dd.cfgHero[id]["miss"] + dd.cfgHero[id]["missadd"]*(lv-1)/10,
                    dd.cfgHero[id]["dfire"] + dd.cfgHero[id]["dfireadd"]*(lv-1)/10,
                    dd.cfgHero[id]["extraatk"] + dd.cfgHero[id]["extraatkadd"]*(lv-1)/10
                }
                local cryvalue = {
                    self:getCrystalsValue(toolarr,901),
                    self:getCrystalsValue(toolarr,902),
                    self:getCrystalsValue(toolarr,903),
                    self:getCrystalsValue(toolarr,904),
                    self:getCrystalsValue(toolarr,905),
                    self:getCrystalsValue(toolarr,906),
                    self:getCrystalsValue(toolarr,907),
                    self:getCrystalsValue(toolarr,908),
                    self:getCrystalsValue(toolarr,909),
                    self:getCrystalsValue(toolarr,910),
                }
                local armsvalue = {
                    self:getArmsValue(armarr,901),
                    self:getArmsValue(armarr,902),
                    self:getArmsValue(armarr,903),
                    self:getArmsValue(armarr,904),
                    self:getArmsValue(armarr,905),
                    self:getArmsValue(armarr,906),
                    self:getArmsValue(armarr,907),
                    self:getArmsValue(armarr,908),
                    self:getArmsValue(armarr,909),
                    self:getArmsValue(armarr,910)
                }
                local gemvalue = {
                    self:getGemsValue(armarr,901),
                    self:getGemsValue(armarr,902),
                    self:getGemsValue(armarr,903),
                    self:getGemsValue(armarr,904),
                    self:getGemsValue(armarr,905),
                    self:getGemsValue(armarr,906),
                    self:getGemsValue(armarr,907),
                    self:getGemsValue(armarr,908),
                    self:getGemsValue(armarr,909),
                    self:getGemsValue(armarr,910),
                }



                local infoself = self:getChildByName("battle"):getChildByName("effects"):getChildByName("infoself")
                
                local lv = dd.heros:getLong(i,"level")
                infoself:getChildByName("txt_1"):getChildByName("Label_2"):setString(math.floor(herovalue[1] + cryvalue[1] + armsvalue[1] + gemvalue[1]) + dd.heros:getLong(index,"PVEAct"))
                infoself:getChildByName("txt_2"):getChildByName("Label_2"):setString(math.floor(herovalue[2] + cryvalue[2] + armsvalue[2] + gemvalue[2]) + dd.heros:getLong(index,"PVEDfc"))
                if dd.cfgHero[id]["shoot"] > 0 then
                    infoself:getChildByName("txt_3"):getChildByName("Label_2"):setString(math.floor(herovalue[4] + cryvalue[4] + armsvalue[4] + gemvalue[4]))
                    infoself:getChildByName("txt_3"):getChildByName("Label_2_0"):setString(ff.langString(namearr[4])..":")
                    cclog(ff.langString("劈砍")..":")
                elseif dd.cfgHero[id]["miss"] > 0 then
                    infoself:getChildByName("txt_3"):getChildByName("Label_2"):setString(math.floor(herovalue[8] + cryvalue[8] + armsvalue[8] + gemvalue[8]))
                    infoself:getChildByName("txt_3"):getChildByName("Label_2_0"):setString(ff.langString(namearr[8])..":")
                    cclog("火攻:" .. ff.langString("火攻")..":")
                elseif dd.cfgHero[id]["double"] > 0 then
                    infoself:getChildByName("txt_3"):getChildByName("Label_2"):setString(math.floor(herovalue[7] + cryvalue[7] + armsvalue[7] + gemvalue[7]))
                    infoself:getChildByName("txt_3"):getChildByName("Label_2_0"):setString(ff.langString(namearr[7])..":")
                    cclog("狙击:" .. ff.langString("狙击")..":")
                elseif dd.cfgHero[id]["ddouble"] > 0 then
                    infoself:getChildByName("txt_3"):getChildByName("Label_2"):setString(math.floor(herovalue[6] + cryvalue[6] + armsvalue[6] + gemvalue[6]))
                    infoself:getChildByName("txt_3"):getChildByName("Label_2_0"):setString(ff.langString(namearr[6])..":")
                    cclog("枪械:" .. ff.langString("枪械")..":")
                elseif dd.cfgHero[id]["fire"] > 0 then
                    infoself:getChildByName("txt_3"):getChildByName("Label_2"):setString(math.floor(herovalue[5] + cryvalue[5] + armsvalue[5] + gemvalue[5]))
                    infoself:getChildByName("txt_3"):getChildByName("Label_2_0"):setString(ff.langString(namearr[5])..":")
                    cclog("搏击:" .. ff.langString("搏击")..":")
                else
                    infoself:getChildByName("txt_3"):getChildByName("Label_2"):setVisible(false)
                    infoself:getChildByName("txt_3"):getChildByName("Label_2_0"):setVisible(false)
                end
                infoself:getChildByName("txt_3"):requestDoLayout()
                infoself:getChildByName("txt_1"):getChildByName("Label_2_0"):setString(ff.langString("攻击")..":")
                infoself:getChildByName("txt_2"):getChildByName("Label_2_0"):setString(ff.langString("防御")..":")
                break;
            end
        end

		self._turn = 0
		self:updateInfo()

        self:getChildByName("battle"):getChildByName("detail"):getChildByName("lists"):removeAllChildren()
		function startAction()
			local label = self:getChildByName("battle"):getChildByName("effects"):getChildByName("touch"):getChildByName("touch"):getChildByName("label")
			label:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.ScaleTo:create(0.1, 1.05),cc.ScaleTo:create(0.1, 0.95))))
		end

		local hero = self:getChildByName("battle"):getChildByName("effects"):getChildByName("Panel_141"):getChildByName("hero")
        local heroInfo = self:getChildByName("battle"):getChildByName("effects"):getChildByName("infoself")
		hero:setPositionX(-330)	
        heroInfo:setPositionX(-140)	

        hero:setOpacity(100)
        heroInfo:setOpacity(100)
        local action = cc.Spawn:create(
                    cc.EaseBackOut:create(cc.MoveBy:create(0.5, cc.p(300,0))),
                    cc.FadeIn:create(0.5)
                    )
        hero:runAction(action)
        heroInfo:runAction(action:clone())

		local zombie = self:getChildByName("battle"):getChildByName("effects"):getChildByName("zombie")
        local zombieInfo = self:getChildByName("battle"):getChildByName("effects"):getChildByName("infozm")
		zombie:setPositionX(1020)	
        zombieInfo:setPositionX(860)	

        local action = cc.Spawn:create(
                    cc.EaseBackOut:create(cc.MoveBy:create(0.5, cc.p(-300,0))),
                    cc.FadeIn:create(0.5)
                    )
        zombie:runAction(action)
        zombieInfo:runAction(action:clone())

        self:getChildByName("battle"):getChildByName("effects"):getChildByName("touch"):setVisible(true)
        self:getChildByName("battle"):getChildByName("effects"):getChildByName("touch"):setTouchEnabled(true)
        self:getChildByName("battle"):getChildByName("effects"):getChildByName("touch"):setOpacity(0)
		self:getChildByName("battle"):getChildByName("effects"):getChildByName("touch"):runAction(cc.FadeIn:create(1))

		self:getChildByName("battle"):getChildByName("effects"):getChildByName("Panel_141"):getChildByName("hero")

		self:getChildByName("battle"):getChildByName("effects"):setVisible(true)
		self:getChildByName("battle"):getChildByName("detail"):setPositionY(-self:getChildByName("battle"):getChildByName("detail"):getContentSize().height)		
		self:getChildByName("battle"):setVisible(true)
		
		startAction()

        self.battleBG:setVisible(true)
		pop.showPopEffect(12,self:getChildByName("battle"):getChildByName("detail"))
        if GuideControl.curId >= 2020 and GuideControl.curId <= 2110 then
            GuideControl:GuideCheck()
        end
	end
end

function pveUILayer:onFreshCityZombie(message)
    local code = message:getLong()
    if code == 0 then
        cclog("================"..dd.currentLayer._name )
        if dd.currentLayer._name == "pve" then
            dd.currentLayer:updateZombie(self._id)
            pop.onClosePopDialog("pve")
        end
    end
    message:clear()
end

function pveUILayer.onStart(sender)
    sender:sureHero(sender._hid,true, false)
	ff.net:registerEvent(1,dd.Tjf_hero_CityZombieFight,sender.onGetCityZombie)
    ff.net:registerEvent(1,dd.Tjf_Pve_FreshCityZombie,function (message)sender:onFreshCityZombie(message)end)
    schedule(sender,sender.updateHP,1)
end
function pveUILayer.onEnd(sender)
    sender:stopAllActions()
	sender:getChildByName("view"):getChildByName("droplists"):removeAllChildren(true)
	sender:getChildByName("view"):getChildByName("herolists"):removeAllChildren(true)	
    sender:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):removeAllChildren(true)
    sender:getChildByName("battle"):getChildByName("detail"):getChildByName("btns"):getChildByName("attack"):setEnabled(true)
    sender:getChildByName("lose"):getChildByName("Image_269"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    sender:getChildByName("win"):getChildByName("result"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    sender:getChildByName("view"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    sender._battle = nil
    sender._drop = nil
    sender._info = nil
    ff.net:removeEvent(1, dd.Tjf_hero_CityZombieFight)
    ff.net:removeEvent(1, dd.Tjf_Pve_FreshCityZombie)
    sender.battleBG:setVisible(false)
    sender:getChildByName("view"):stopAllActions()
    sender:getChildByName("win"):getChildByName("info"):getChildByName("exp"):stopAllActions()
end

function onShowPve(widget,id,enemy)
    local layer = pveUILayer.extend(widget)
    layer._enemy= enemy
	layer:onInit(id)
    cclog("select id : " .. id )
	return layer
end