-- 顶部通用模版2
-- Author: zjd
-- Date: 2016-01-08 16:36:45
--

local _gamebing

GameBing = class("gamebing", function()
	if not _gamebing then
		if ff.platform ~= 1 then
		    _gamebing = dd.loadUi("images/ui/gamebing.ExportJson")
		end
		_gamebing:retain()
	end 
	return _gamebing:clone() 
end)


function GameBing.checkGooglePlayBack(sender)
    if _gamebing._ret > 0 then
        cclog("google:".._gamebing._google)
        local google     = cc.UserDefault:getInstance():getStringForKey("google","")
        cclog("google:".._gamebing._google..","..google)
        if string.len(google) < 32 then
            hif.bindGooglePlus(4,_gamebing._google,_gamebing.alias)
        end
        platform_showWaiting(0,0)
        _gamebing:stopAllActions()
        cclog("google end")
        _gamebing._google = ""
        _gamebing.alias   = ""
        _gamebing._ret    = 0        

        if platform_isConnectGPG() == true then
            sender:getChildByName("info"):getChildByName("signin"):getChildByName("Image_28_0"):setVisible(true)
            sender:getChildByName("info"):getChildByName("signin"):getChildByName("Image_28"):setVisible(false)
        end
    end
end

function GameBing.googlePlayLogin(code)
    cclog("retcode:"..code)
    local tb = Split(code,",fatality,")
    if table.getn(tb) == 3 then
        local type = tonumber(tb[1])
        local login_alias = tb[2]
        local login_name  = tb[3]
        if type == 4 then
            _gamebing._google = login_name
            _gamebing.alias = login_alias
        end
    end
    _gamebing._ret = 1
    cclog("here....")
end



function GameBing:ctor()
    self:setName("gamebing")

    _gamebing.alias   = ""
    _gamebing._google = ""
    _gamebing._ret    = 0

    local function onShow(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            if sender:getSelectedState() == false then
                if platform_isConnectGPG() == true then
                    self:getChildByName("info"):getChildByName("signin"):getChildByName("Image_28_0"):setVisible(true)
                    self:getChildByName("info"):getChildByName("signin"):getChildByName("Image_28"):setVisible(false)
                    platform_submitScore(dd.myinfo:getLong(1,"power"))
                else    
                    self:getChildByName("info"):getChildByName("signin"):getChildByName("Image_28_0"):setVisible(false)
                    self:getChildByName("info"):getChildByName("signin"):getChildByName("Image_28"):setVisible(true)
                end
                self:getChildByName("info"):setVisible(true)
            else
                self:getChildByName("info"):setVisible(false)
            end
        end
    end

    self:getChildByName("show"):addTouchEventListener(onShow)

    local function onSign()
        platform_showWaiting(1,0)
        platform_googleplay(4,self.googlePlayLogin)
        schedule(self,self.checkGooglePlayBack,1)

        self:getChildByName("show"):setSelectedState(false)
        self:getChildByName("info"):setVisible(false)
    end
    ---事件
    local function onSign_in(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            cclog("==onSign_in==")
            if platform_isConnectGPG() == true then
                return
            else
                onSign()
            end
        end
    end

    local function onAH(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            cclog("==onAH==")
            if platform_isConnectGPG() == true then
                platform_showAH()
                self:getChildByName("show"):setSelectedState(false)
                self:getChildByName("info"):setVisible(false)
                return
            else
                onSign()
            end
        end
    end

    local function onRank(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            cclog("==onRank==")
            if platform_isConnectGPG() == true then
                platform_showRank()
                self:getChildByName("show"):setSelectedState(false)
                self:getChildByName("info"):setVisible(false)
                return
            else
                onSign()
            end
        end
    end

    self:getChildByName("info"):getChildByName("signin"):addTouchEventListener(onSign_in)
    self:getChildByName("info"):getChildByName("ah"):addTouchEventListener(onAH)
    self:getChildByName("info"):getChildByName("rank"):addTouchEventListener(onRank)

end

return GameBing