--版本更新文件

function getVersion()
    return "version:r.827.1101"
end
function getVersion2()
    return "1131"
end
function getVersionDetail(ver)
	if ver == nil then
		ver = cc.UserDefault:getInstance():getIntegerForKey("version") - 1
	end
	ver = 1010
	local nt = versionInfos()
	local rets = {}
	for i=1,table.getn(nt) do
		if nt[i][1] > ver then
			rets[table.getn(rets) + 1] = {nt[i][2],nt[i][3]}
		end
	end
	return rets
end
--执行一次sql语句，以后不整包更新数据库了
function updateVersionSQL(version)
	cclog("更新新版本的数据库调整")
	
	ff.dbmanager:sql_query("replace into `cfg_ui_lang` (`key`, `text`, `fontsize`, `json`, `tips`, `use`, `bold`, `warnning`) VALUES ('chu_label', '分解', '22', 'images/ui/warehouse.ExportJson', '仓库', '502050', '1', '0')")

	updateLang(version)
end
function updateLang(version)
	cclog("更新新版本的语言表lang")
	print("updateLang3:"..ff.old_version)
	if ff.platform == 1 then
		local wp = cc.FileUtils:getInstance():getWritablePath()
		local version = ff.old_version
		cc.FileUtils:getInstance():addSearchPath(wp.."version/"..version.."/resource/ios/",true)
		cc.FileUtils:getInstance():addSearchPath(wp.."version/"..version.."/resource/ios/images/",true)
		cc.FileUtils:getInstance():addSearchPath(wp.."version/"..version.."/resource/ios/images/ui/",true)
	end
end


function versionInfos()
	return 
	{
		--版本号，说明，字体颜色

	}
end
--购买项目，逗号分割
function getBuyItems()
	return "ft_zw_product101,999;ft_zw_product102,2999;ft_zw_product103,5999;ft_zw_product104,9999;ft_zw_product901,499;ft_zw_product902,999;ft_zw_product903,1999;ft_zw_product904,2999;ft_zw_product905,5999;ft_zw_product906,9999;ft_zw_product1106,199;ft_zw_product1107,1999;ft_zw_product1201,499;ft_zw_product401,3999;ft_zw_product501,7999;ft_zw_product11001,999;ft_zw_product11002,2999;ft_zw_product11003,5999;ft_zw_product11004,9999;ft_zw_product11301,999;ft_zw_product11302,2999;ft_zw_product11303,5999;ft_zw_product11304,9999;ft_zw_product11501,999;ft_zw_product11502,2999;ft_zw_product11503,5999;ft_zw_product11504,9999;ft_zw_product10901,999;ft_zw_product10902,2999;ft_zw_product10903,5999;ft_zw_product10904,9999;ft_zw_product11101,999;ft_zw_product11102,2999;ft_zw_product11103,5999;ft_zw_product11104,9999;ft_zw_product60021,999;ft_zw_product60022,2999;ft_zw_product60023,5999;ft_zw_product60024,9999;ft_zw_product60031,999;ft_zw_product60032,2999;ft_zw_product60033,5999;ft_zw_product60034,9999;ft_zw_product60041,999;ft_zw_product60042,2999;ft_zw_product60043,5999;ft_zw_product60044,9999;ft_zw_product60051,999;ft_zw_product60052,2999;ft_zw_product60053,5999;ft_zw_product60054,9999;ft_zw_product60071,999;ft_zw_product60072,2999;ft_zw_product60073,5999;ft_zw_product60074,9999;ft_zw_product61021,999;ft_zw_product61022,2999;ft_zw_product61023,5999;ft_zw_product61024,9999;ft_zw_product50011,999;ft_zw_product50031,999;ft_zw_product50051,999;ft_zw_product50071,999;ft_zw_product601,999;ft_zw_product602,2999;ft_zw_product603,5999;ft_zw_product604,9999;ft_zw_product50081,999;ft_zw_product60091,999;ft_zw_product60092,2999;ft_zw_product60093,5999;ft_zw_product60094,9999;ft_zw_product61041,999;ft_zw_product61042,2999;ft_zw_product61043,5999;ft_zw_product61044,9999;ft_zw_product201,1499;ft_zw_product202,4999;ft_zw_product20701,999;ft_zw_product20801,999;ft_zw_product1301,399;ft_zw_product1302,899;ft_zw_product1303,1399;ft_zw_product1304,1899;ft_zw_product70049,4999;ft_zw_product50121,999;ft_zw_product50131,999;ft_zw_product60141,999;ft_zw_product60142,2999;ft_zw_product60143,5999;ft_zw_product60144,9999;ft_zw_product61051,999;ft_zw_product61052,2999;ft_zw_product61053,5999;ft_zw_product61054,9999;ft_zw_product60121,999;ft_zw_product60122,2999;ft_zw_product60123,5999;ft_zw_product60124,9999;ft_zw_product60131,999;ft_zw_product60132,2999;ft_zw_product60133,5999;ft_zw_product60134,9999;ft_zw_product402,1999;ft_zw_product70009,999;ft_zw_product70019,1999;ft_zw_product70029,2999;ft_zw_product70039,3999;ft_zw_product70059,5999;ft_zw_product70069,6999;ft_zw_product70079,7999;ft_zw_product70089,8999;ft_zw_product70099,9999;ft_zw_product90009,999;ft_zw_product90029,2999;ft_zw_product90059,5999"
	--return "ft_zw_product101,999;ft_zw_product102,2999;ft_zw_product103,5999;ft_zw_product104,9999;ft_zw_product901,499;ft_zw_product902,999;ft_zw_product903,1999;ft_zw_product904,2999;ft_zw_product905,5999;ft_zw_product906,9999;ft_zw_product401,3999"
end

