--armyInfo
local armyInfoLayer = class("armyInfo")
armyInfoLayer._name = "armyInfo"
armyInfoLayer._init = false
armyInfoLayer.key = 0
armyInfoLayer.hKey = 0
armyInfoLayer.id = 0
armyInfoLayer.troop = {}
armyInfoLayer._data  = nil
armyInfoLayer._type  = 1
armyInfoLayer._view = nil
armyInfoLayer._lianjin = 0

armyInfoLayer._hid   = 0
armyInfoLayer._level = 0


function armyInfoLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, armyInfoLayer)
    return target
end
--获取军队总士兵数
function armyInfoLayer:getArmysCount()
    local count = 0
    local data = nil
    if self._type == 1 then
        data = dd.myTroops
    else
        data = self._data
    end
    local index = self.key
    count = count + data:getLong(index,"b1")
    count = count + data:getLong(index,"b2")
    count = count + data:getLong(index,"b3")
    count = count + data:getLong(index,"b4")
    count = count + data:getLong(index,"b5")
    count = count + data:getLong(index,"b6")

    count = count + data:getLong(index,"q1")
    count = count + data:getLong(index,"q2")
    count = count + data:getLong(index,"q3")
    count = count + data:getLong(index,"q4")
    count = count + data:getLong(index,"q5")
    count = count + data:getLong(index,"q6")

    count = count + data:getLong(index,"g1")
    count = count + data:getLong(index,"g2")
    count = count + data:getLong(index,"g3")
    count = count + data:getLong(index,"g4")
    count = count + data:getLong(index,"g5")
    count = count + data:getLong(index,"g6")

    count = count + data:getLong(index,"w1")
    count = count + data:getLong(index,"w2")
    count = count + data:getLong(index,"w3")
    count = count + data:getLong(index,"w4")
    return count
end
--设置长宽，加士兵
function armyInfoLayer:onAutoSize()
    local num = 0
    local row = self.key
    local data = nil
    if self._type == 1 then
        data = dd.myTroops
    else
        data = self._data
    end
    local lists = self._view:getChildByName("list")
    for i=1,6 do
        local col = 7 - i
        if data:getLong(row,"b"..col) > 0 then
            num = num + 1
        end
        if data:getLong(row,"q"..col) > 0 then
            num = num + 1
        end
        if data:getLong(row,"g"..col) > 0 then
            num = num + 1
        end
        if col<=4 and data:getLong(row,"w"..col) > 0 then
            num = num + 1
        end        
    end
    if self._hid > 0 then
        num = num + 1
    end 

    --设置控件
    local line = math.ceil(num/3)
    cclog("num:"..num.." line:"..line)
    local hh = 0
    if line >= 2 then
        hh   = 270 * 2 + 3 * 13
    else
        hh   = 270 + 2 * 13
    end

    local total = hh + 175
    cclog("total:"..total)   
    self._view:setContentSize(cc.size(720,total))     
    self._view:getChildByName("back"):setContentSize(cc.size(720,total))
    self._view:getChildByName("num_text"):setString(ff.getFormatMoney(self:getArmysCount()))

    local offY = 172
    if line >= 2 then
        lists:setContentSize(cc.size(720,270 * 2 + 3 * 13 - 3))
        self._view:getChildByName("mainBg"):setContentSize(cc.size(720,270 * 2 + 3 * 13))
        offY = 178
    else
        lists:setContentSize(cc.size(720,270 + 2 * 13 - 3))
        self._view:getChildByName("mainBg"):setContentSize(cc.size(720,270 + 2 * 13))
    end
    lists:setInnerContainerSize(cc.size(720,270 * line + (line + 1) * 13))
--    self:getChildByName("list"):jumpToTop()
    --重新排列
    num = 0
    local yline = 1
    if self._hid > 0 then
        cclog("hero name:"..self._hid)
        local name = ""
        if self._type == 1 then
            if dd.heros:getString(self.hKey,"name") == "" then
                name = ff.langString(dd.cfgHero[dd.heros:getLong(self.hKey,"id")]['name'])
            else
                name = ff.langString(dd.heros:getString(self.hKey,"name"))
            end
        else
            if data:getString(self.key,"heroName") == "" then
                name = ff.langString(dd.cfgHero[self._hid]['name'])
            else
                name = ff.langString(data:getString(self.key,"heroName"))
            end
        end
        
        local item = self._view:getChildByName("armyItem"):clone()
        item:setVisible(true)
        item:setTag(self._hid)
        item:getChildByName("nums"):setString("LV."..self._level)
        item:getChildByName("icon"):loadTexture(dd.getHeroIcon(self._hid),0)
        item:getChildByName("star"):setVisible(false)
        item:getChildByName("name_text"):setString(name)
 
        lists:addChild(item)
        --暂时都放第一排
        local xx = 110 + 15 
        local yy = (line - yline) * 280 + offY
        item:setPosition(cc.p(xx,yy))
        num = num + 1
        yline = math.ceil(num/3)
    end
    if self._lianjin == 1 then
        local name = ""

        name = ff.langString("炼金术士")

        local item = self._view:getChildByName("armyItem"):clone()
        item:setVisible(true)
        item:setTag(self._hid)
        item:getChildByName("nums"):setString("LV."..dd.myAlchemist:getLong(1,"level"))
        item:getChildByName("icon"):loadTexture("images/effect/Alchemist/ico.png",0)
        item:getChildByName("star"):setVisible(false)
        item:getChildByName("name_text"):setString(name)
 
        lists:addChild(item)
        --暂时都放第一排
        local xx = num%3 * 220 + 15 * (num%3 + 1) + 110
        local yy = (line - yline) * 280 + offY
        item:setPosition(cc.p(xx,yy))
        num = num + 1
        yline = math.ceil(num/3)
        if num%3 == 0 then
            yline = yline + 1
        end
    end
    local function addItem(star,sid,count)
        cclog("addItem sid:"..sid)
        local item = self._view:getChildByName("armyItem"):clone()
        item:setVisible(true)
        item:setTag(sid)
        item:getChildByName("star"):setVisible(true)
        item:getChildByName("nums"):setString(ff.getFormatMoney(count))
        item:getChildByName("icon"):loadTexture(dd.getArmyIcon(sid),0)
        local str = ""
        for i=1,star do
            str = str.."0"
        end
        item:getChildByName("star"):setString(str)
        lists:addChild(item)
        local xx = num%3 * 220 + 15 * (num%3 + 1) + 110
        local yy = (line - yline) * 280 + offY
        item:setPosition(cc.p(xx,yy))
        num = num + 1
        yline = math.ceil(num/3)
        if num%3 == 0 then
            yline = yline + 1
        end
    end

    for i=1,6 do
        local col = 7 - i
        if data:getLong(row,"b"..col) > 0 then
            addItem(dd.cfgSoldier[dd.cfgSoldierIndex2["b"..col]]["step"],dd.cfgSoldierIndex2["b"..col],data:getLong(row,"b"..col))
        end
        if data:getLong(row,"q"..col) > 0 then
            addItem(dd.cfgSoldier[dd.cfgSoldierIndex2["q"..col]]["step"],dd.cfgSoldierIndex2["q"..col],data:getLong(row,"q"..col))
        end
        if data:getLong(row,"g"..col) > 0 then
            addItem(dd.cfgSoldier[dd.cfgSoldierIndex2["g"..col]]["step"],dd.cfgSoldierIndex2["g"..col],data:getLong(row,"g"..col))
        end
        if col<=4 and data:getLong(row,"w"..col) > 0 then
            addItem(dd.cfgSoldier[dd.cfgSoldierIndex2["w"..col]]["step"],dd.cfgSoldierIndex2["w"..col],data:getLong(row,"w"..col))
        end        
    end
end

function armyInfoLayer:onInit()
    if self._init == false then    
        local function closePop(sender,eventType)
            if eventType==ccui.TouchEventType.ended then    
                self:onClose()
            end
        end
        self:setContentSize(cc.size(720,ff.height)) 
        self:getChildByName("mask"):setContentSize(cc.size(720,ff.height)) 
        self._view:getChildByName("close"):addTouchEventListener(closePop)
        self._view:getChildByName("return"):addTouchEventListener(self.returnArmy)
        self._view:getChildByName("list"):jumpToTop()
        self._init = true
    end
end
function armyInfoLayer.returnArmy(sender,eventType)
    if eventType==ccui.TouchEventType.ended then    
        local widget = pop.getDialog("armyInfo")
        if widget ~= nil then
            if widget._type == 1 then
                if widget.key <= 0 then
                    return
                end
                local function backSure()
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000110)
                    message:addLong(dd.uid)
                    message:addLong(dd.myTroops:getLong(widget.key,"id"))
                    ff.net:rpc(message,false)
                    AudioEngine.playEffect(ff.sounds[412])
                    widget:onClose()
                end
                if dd.myTroops:getLong(widget.key,"state") == 2 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("部队正在返回中"))
                    return
                end
                --if dd.myTroops:getLong(widget.key,"state") == 1 or dd.myTroops:getLong(widget.key,"state") == 7 then
                if dd.myTroops:getLong(widget.key,"state") == 1 then
                    dd.currentLayer._widget:onShowSureUseTools(ff.langString("部队召回"),1018,1,backSure)
                    return
                end
                backSure()
            else
                if widget._callback ~= nil then
                    widget._callback(sender:getTag())
                end                
            end
        end
    end
end

function armyInfoLayer:onRecall(code)
    if code ~= 0 then
        dd.mainUI:onShowCodeTips(code)
    else
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("召回成功"),true)
        self:onClose()
    end
end

function armyInfoLayer:initInfo()
    self._view:getChildByName("info"):setVisible(false)
    if self._type == 1 then
        if self.key <= 0 then
            return
        end
        if dd.myTroops:getLong(self.key,"state") == 2 then
            self._view:getChildByName("return"):setBright(false) 
            self._view:getChildByName("return"):setTouchEnabled(false)        
            self._view:getChildByName("return"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        else
            self._view:getChildByName("return"):setBright(true) 
            self._view:getChildByName("return"):setTouchEnabled(true)        
            self._view:getChildByName("return"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
        end
        self._view:getChildByName("chu_title"):setString(ff.langString("{0}的军队",{dd.myinfo:getString(1,'name')}))
    else
        self._view:getChildByName("chu_title"):setString(ff.langString("{0}的军队",{self._data:getString(self.key,'name')}))        
    end
end
function armyInfoLayer:onClose()
    local widget = pop.getDialog("armyInfo")
    local sec_state = pop.isShowing("armyInfo")
    if widget and sec_state then
        pop.onClosePopDialog("armyInfo")
        return true
    end
    return false
end


function armyInfoLayer:setReturn(label,callback,show)
    if show == true then
        if self._data:getLong(self.key,"uid") == dd.uid then
            show = false
        end
    end
    self._view:getChildByName("return"):setVisible(show)
    self._view:getChildByName("return"):getChildByName("chu_label"):setString(label)
    self._view._callback = callback
    return self._view:getChildByName("return")
end
function armyInfoLayer.onStart(sender)
    sender:initInfo()
end

function armyInfoLayer.onEnd(sender)
    dd.delBackEvent(sender.onReturn)
    sender.key = 0
    sender.hKey = 0
    sender.id = 0
    sender.troop = {}
    sender:getChildByName("view"):getChildByName("list"):removeAllChildren()
end
function armyInfoLayer.onBefore(sender)
    sender:onInit()
    sender:onAutoSize()
    return true
end


function armyInfoLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("armyInfo")
        if widget~=nil and widget:onClose() == false then
            pop.onClosePopDialog("armyInfo")
        end    
    end
end
function armyInfoLayer:getKey()
    self._hid   = 0
    self._level = 0
    if self._type == 1 then
        for var=1, dd.myTroops:rowCount() do
        	if dd.myTroops:getLong(var,'id') == self.id then
                self.key = var
                self._lianjin = dd.myTroops:getLong(var,'s1')
                break
        	end
        end
        --获取英雄信息
        if dd.myTroops:getLong(self.key,'hid') > 0 then
            for var=1, dd.heros:rowCount() do
                if dd.heros:getLong(var,'hid') == dd.myTroops:getLong(self.key,'hid') then
                    self._hid   = dd.heros:getLong(var,"id")
                    self._level = dd.heros:getLong(var,"level")
                    self.hKey   = var
                    break
                end
            end
        end
    elseif self._type == 2 then
        self.key = self.id
        self.hKey  = 0
        self._hid  = self._data:getLong(self.key,"heroGID")
        self._level= self._data:getLong(self.key,"heroLevel")
    end
end
function onShowArmyInfo(widget,id,nt,type)
    local layer = armyInfoLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer.id    = id
    layer._data = nt
    layer._view = layer:getChildByName("view")
    if type == nil then
        layer._type = 1
    else
        layer._type = type
    end
    layer:getKey()
    return layer
end