--宝库
local baoKuLayer   = class("baoKuLayer")
baoKuLayer._name = "baoKuLayer"
baoKuLayer._init = false
baoKuLayer._pos  = 0
baoKuLayer._bid  = 0
baoKuLayer._lv  = 0
baoKuLayer._effect = false

function baoKuLayer:onInit()
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"pos") == self._pos then
            self._bid = dd.mybuilds:getLong(i,"bid")
            self._lv = dd.mybuilds:getLong(i,"level")
            break
        end
    end
    if self._lv == 0 then
        self._lv = 1 --刚建造的时候按照1级的数据处理
    end
    local oil = self:getChildByName("mainArea"):getChildByName("oil")
    local wood = self:getChildByName("mainArea"):getChildByName("wood")
    local food = self:getChildByName("mainArea"):getChildByName("food")
    local iron = self:getChildByName("mainArea"):getChildByName("iron")
    local silver = self:getChildByName("mainArea"):getChildByName("silver")
    if self._init == false then
        local x,y = self:getChildByName("mainArea"):getChildByName("oil"):getChildByName("pg"):getChildByName("bar_icon"):getPosition()
        local size = self:getChildByName("mainArea"):getChildByName("oil"):getChildByName("pg"):getChildByName("bar_icon"):getContentSize()
        cclog("x:"..x.." y:"..y.." width:"..size.width.." height:"..size.height)
        local oil_bar = cc.ProgressTimer:create(dd.newSpriteFromUI("new_pg06.png"))
        oil_bar:setBarChangeRate(cc.p(1,0))--设置进程条的变化速率
        oil_bar:setType(cc.PROGRESS_TIMER_TYPE_BAR)--设置进程条的类型
        oil_bar:setMidpoint(cc.p(0,0))--设置进度的运动方向
        oil_bar:setContentSize(cc.size(size.width, size.height))
        oil_bar:setPosition(cc.p(x,y))
        oil_bar:setPercentage(0)--设置初始值为0
        oil_bar:setVisible(true)
        self:getChildByName("mainArea"):getChildByName("oil"):getChildByName("pg"):addChild(oil_bar,0,10000)

        local x,y = self:getChildByName("mainArea"):getChildByName("wood"):getChildByName("pg"):getChildByName("bar_icon"):getPosition()
        cclog("x:"..x.." y:"..y)
        local wood_bar = cc.ProgressTimer:create(dd.newSpriteFromUI("new_pg06.png"))
        wood_bar:setBarChangeRate(cc.p(1,0))--设置进程条的变化速率
        wood_bar:setType(cc.PROGRESS_TIMER_TYPE_BAR)--设置进程条的类型
        wood_bar:setMidpoint(cc.p(0,0))--设置进度的运动方向
        wood_bar:setContentSize(cc.size(size.width, size.height))
        wood_bar:setPosition(cc.p(x,y))
        wood_bar:setPercentage(0)--设置初始值为0
        wood_bar:setVisible(true)
        self:getChildByName("mainArea"):getChildByName("wood"):getChildByName("pg"):addChild(wood_bar,0,10000)

        local x,y = self:getChildByName("mainArea"):getChildByName("food"):getChildByName("pg"):getChildByName("bar_icon"):getPosition()
        cclog("x:"..x.." y:"..y)
        local food_bar = cc.ProgressTimer:create(dd.newSpriteFromUI("new_pg06.png"))
        food_bar:setBarChangeRate(cc.p(1,0))--设置进程条的变化速率
        food_bar:setType(cc.PROGRESS_TIMER_TYPE_BAR)--设置进程条的类型
        food_bar:setMidpoint(cc.p(0,0))--设置进度的运动方向
        food_bar:setContentSize(cc.size(size.width, size.height))
        food_bar:setPosition(cc.p(x,y))
        food_bar:setPercentage(0)--设置初始值为0
        food_bar:setVisible(true)
        self:getChildByName("mainArea"):getChildByName("food"):getChildByName("pg"):addChild(food_bar,0,10000)


        local x,y = self:getChildByName("mainArea"):getChildByName("iron"):getChildByName("pg"):getChildByName("bar_icon"):getPosition()
        cclog("x:"..x.." y:"..y)
        local iron_bar = cc.ProgressTimer:create(dd.newSpriteFromUI("new_pg06.png"))
        iron_bar:setContentSize(cc.size(size.width, size.height))
        iron_bar:setBarChangeRate(cc.p(1,0))--设置进程条的变化速率
        iron_bar:setType(cc.PROGRESS_TIMER_TYPE_BAR)--设置进程条的类型
        iron_bar:setMidpoint(cc.p(0,0))--设置进度的运动方向
        iron_bar:setPosition(cc.p(x,y))
        iron_bar:setPercentage(0)--设置初始值为0
        iron_bar:setVisible(true)
        self:getChildByName("mainArea"):getChildByName("iron"):getChildByName("pg"):addChild(iron_bar,0,10000)
        
        --self:getChildByName("bar"):getChildByName("help_text"):setString(ff.langString(dd.cfgBuilding[self._bid]['tips']))
        self:getChildByName("bar"):getChildByName("chu_help_text"):setVisible(true)
        self:getChildByName("bar"):getChildByName("chu_help_text"):setString(ff.langString("点击查看建筑效果"))
    
        local x,y = self:getChildByName("mainArea"):getChildByName("iron"):getChildByName("pg"):getChildByName("bar_icon"):getPosition()
        cclog("x:"..x.." y:"..y)
        local silver_bar = cc.ProgressTimer:create(dd.newSpriteFromUI("new_pg06.png"))
        silver_bar:setContentSize(cc.size(size.width, size.height))
        silver_bar:setBarChangeRate(cc.p(1,0))--设置进程条的变化速率
        silver_bar:setType(cc.PROGRESS_TIMER_TYPE_BAR)--设置进程条的类型
        silver_bar:setMidpoint(cc.p(0,0))--设置进度的运动方向
        silver_bar:setPosition(cc.p(x,y))
        silver_bar:setPercentage(0)--设置初始值为0
        silver_bar:setVisible(true)
        self:getChildByName("mainArea"):getChildByName("silver"):getChildByName("pg"):addChild(silver_bar,0,10000)
        
        oil:getChildByName("res_bg"):getChildByName("res_icon"):loadTexture("images/icon/res/ic01_bk.png",0)
        wood:getChildByName("res_bg"):getChildByName("res_icon"):loadTexture("images/icon/res/ic02_bk.png",0)
        food:getChildByName("res_bg"):getChildByName("res_icon"):loadTexture("images/icon/res/ic04_bk.png",0)
        iron:getChildByName("res_bg"):getChildByName("res_icon"):loadTexture("images/icon/res/ic03_bk.png",0)
        silver:getChildByName("res_bg"):getChildByName("res_icon"):loadTexture("images/icon/res/ic05_bk.png",0)
        self._init = true
    end
    if self._lv == dd.cfgBuilding[self._bid]['maxlevel'] then
        silver:setVisible(true)
    else
        silver:setVisible(false)
    end
    if dd.myinfo:getLong(1,"level") <= 10 then
        oil:setVisible(false)
        iron:setVisible(false)
    elseif dd.myinfo:getLong(1,"level") <= 14 then
        oil:setVisible(true)
        iron:setVisible(false)
    else
        oil:setVisible(true)
        iron:setVisible(true)
    end
    
    local protect_base = dd.cfgBuildingUp[self._bid][self._lv]['value1']
    local plus_131 = 0
    local plus_132 = 0
    local plus_133 = 0
    local plus_134 = 0
    local plus_135 = 0
    local plus_804 = 0
    for var=1, dd.myeffect:rowCount() do
        if dd.myeffect:getLong(var,'id') == 131 then
            plus_131 = dd.myeffect:getLong(var,'param')
        elseif dd.myeffect:getLong(var,'id') == 132 then
            plus_132 = dd.myeffect:getLong(var,'param')
        elseif dd.myeffect:getLong(var,'id') == 133 then
            plus_133 = dd.myeffect:getLong(var,'param')
        elseif dd.myeffect:getLong(var,'id') == 134 then
            plus_134 = dd.myeffect:getLong(var,'param')
        elseif dd.myeffect:getLong(var,'id') == 135 then
            plus_135 = dd.myeffect:getLong(var,'param')
        elseif dd.myeffect:getLong(var,'id') == 804 then
            plus_804 = dd.myeffect:getLong(var,'param')
        end
    end
    local protect_oil = math.modf(protect_base * (1000 + plus_131 + plus_804)/1000)
    local protect_wood = math.modf(protect_base * (1000 + plus_132 + plus_804)/1000)
    local protect_food = math.modf(protect_base * (1000 + plus_133 + plus_804)/1000)
    local protect_iron = math.modf(protect_base * (1000 + plus_134 + plus_804)/1000)
    local protect_silver = math.modf(protect_base * (1000 + plus_135 + plus_804)/1000)
    oil:getChildByName("num_text"):setString(dd.showKM(dd.stone(),5).."/"..dd.showKM(protect_oil,5))
    wood:getChildByName("num_text"):setString(dd.showKM(dd.wood(),5).."/"..dd.showKM(protect_wood,5))
    food:getChildByName("num_text"):setString(dd.showKM(dd.food(),5).."/"..dd.showKM(protect_food,5))
    iron:getChildByName("num_text"):setString(dd.showKM(dd.iron(),5).."/"..dd.showKM(protect_iron,5))
    silver:getChildByName("num_text"):setString(dd.showKM(dd.silver(),5).."/"..dd.showKM(protect_silver,5))
    local oilRate = math.modf((dd.stone()/protect_oil) * 100)
    if oilRate > 100 then oilRate = 100 end
    cclog("oilRate:"..oilRate)
    local woodRate = math.modf((dd.wood()/protect_wood) * 100)
    if woodRate > 100 then woodRate = 100 end
    local foodRate = math.modf((dd.food()/protect_food) * 100)
    if foodRate > 100 then foodRate = 100 end
    local ironRate = math.modf((dd.iron()/protect_iron) * 100)
    if ironRate > 100 then ironRate = 100 end
    local silverRate = math.modf((dd.iron()/protect_silver) * 100)
    if silverRate > 100 then silverRate = 100 end
    if self._effect == true then
        local action_oil = cc.ProgressFromTo:create(0.5 + 1*oilRate/100, 0,oilRate);
        oil:getChildByName("pg"):getChildByTag(10000):runAction(action_oil)
    
        local action_wood = cc.ProgressFromTo:create(0.5 + 1*woodRate/100, 0,woodRate);
        wood:getChildByName("pg"):getChildByTag(10000):runAction(action_wood)
    
        local action_food = cc.ProgressFromTo:create(0.5 + 1*foodRate/100, 0,foodRate);
        food:getChildByName("pg"):getChildByTag(10000):runAction(action_food)
    
        local action_iron = cc.ProgressFromTo:create(0.5 + 1*ironRate/100, 0,ironRate);
        iron:getChildByName("pg"):getChildByTag(10000):runAction(action_iron)
        
        local action_silver = cc.ProgressFromTo:create(0.5 + 1*silverRate/100, 0,silverRate);
        silver:getChildByName("pg"):getChildByTag(10000):runAction(action_silver)
    else
        oil:getChildByName("pg"):getChildByTag(10000):setPercentage(oilRate)
        wood:getChildByName("pg"):getChildByTag(10000):setPercentage(woodRate)
        food:getChildByName("pg"):getChildByTag(10000):setPercentage(foodRate)
        iron:getChildByName("pg"):getChildByTag(10000):setPercentage(ironRate)
        silver:getChildByName("pg"):getChildByTag(10000):setPercentage(silverRate)
    end

    if oilRate < 100 then
        oil:getChildByName("pg"):getChildByName("bar_panel"):getChildByName("arrow"):getChildByName("rate_text"):setString(oilRate.."%")
    else
        oil:getChildByName("pg"):getChildByName("bar_panel"):getChildByName("arrow"):getChildByName("rate_text"):setString("MAX")
    end
    if woodRate < 100 then
        wood:getChildByName("pg"):getChildByName("bar_panel"):getChildByName("arrow"):getChildByName("rate_text"):setString(woodRate.."%")
    else
        wood:getChildByName("pg"):getChildByName("bar_panel"):getChildByName("arrow"):getChildByName("rate_text"):setString("MAX")
    end
    if foodRate < 100 then
        food:getChildByName("pg"):getChildByName("bar_panel"):getChildByName("arrow"):getChildByName("rate_text"):setString(foodRate.."%")
    else
        food:getChildByName("pg"):getChildByName("bar_panel"):getChildByName("arrow"):getChildByName("rate_text"):setString("MAX")
    end
    if ironRate < 100 then
        iron:getChildByName("pg"):getChildByName("bar_panel"):getChildByName("arrow"):getChildByName("rate_text"):setString(ironRate.."%")
    else
        iron:getChildByName("pg"):getChildByName("bar_panel"):getChildByName("arrow"):getChildByName("rate_text"):setString("MAX")
    end
    
    if silverRate < 100 then
        silver:getChildByName("pg"):getChildByName("bar_panel"):getChildByName("arrow"):getChildByName("rate_text"):setString(silverRate.."%")
    else
        silver:getChildByName("pg"):getChildByName("bar_panel"):getChildByName("arrow"):getChildByName("rate_text"):setString("MAX")
    end
    local bar_width = oil:getChildByName("pg"):getChildByName("bar_icon"):getContentSize().width
    
    
    local oilx = math.max(bar_width * oilRate/100,13)
    local woodx = math.max(bar_width * woodRate/100,13)
    local foodx = math.max(bar_width * foodRate/100,13)
    local ironx = math.max(bar_width * ironRate/100,13)
    local silverx = math.max(bar_width * silverRate/100,13)
    
    local oil_arr = oil:getChildByName("pg"):getChildByName("bar_panel"):getChildByName("arrow")
    local wood_arr = wood:getChildByName("pg"):getChildByName("bar_panel"):getChildByName("arrow")
    local food_arr = food:getChildByName("pg"):getChildByName("bar_panel"):getChildByName("arrow")
    local iron_arr = iron:getChildByName("pg"):getChildByName("bar_panel"):getChildByName("arrow")
    local silver_arr = silver:getChildByName("pg"):getChildByName("bar_panel"):getChildByName("arrow")
    
--    oil_arr:setVisible(oilRate>0)
--    wood_arr:setVisible(woodRate>0)
--    food_arr:setVisible(foodRate>0)
--    iron_arr:setVisible(ironRate>0)
--    silver_arr:setVisible(silverRate>0)
    
    if self._effect == true then
        oil_arr:setPositionX(0)
        wood_arr:setPositionX(0)
        food_arr:setPositionX(0)
        iron_arr:setPositionX(0)
        silver_arr:setPositionX(0)
        local posY = oil_arr:getPositionY()
        oil_arr:runAction(cc.Sequence:create(cc.MoveTo:create(0.5 + 1*oilRate/100, cc.p(oilx,posY))))
        wood_arr:runAction(cc.Sequence:create(cc.MoveTo:create(0.5 + 1*woodRate/100, cc.p(woodx,posY))))
        food_arr:runAction(cc.Sequence:create(cc.MoveTo:create(0.5 + 1*foodRate/100, cc.p(foodx,posY))))
        iron_arr:runAction(cc.Sequence:create(cc.MoveTo:create(0.5 + 1*ironRate/100, cc.p(ironx,posY))))
        silver_arr:runAction(cc.Sequence:create(cc.MoveTo:create(0.5 + 1*silverRate/100, cc.p(silverx,posY))))
    else
        oil_arr:setPositionX(oilx)
        wood_arr:setPositionX(woodx)
        food_arr:setPositionX(foodx)
        iron_arr:setPositionX(ironx)
        silver_arr:setPositionX(silverx)
    end
    local function goTrans(sender,eventType)
        if eventType==ccui.TouchEventType.ended then   
            if dd.myUnion:getLong(1,"unionid") <= 0 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("暂无联盟"))
            else
                pop.onShowPopDialog("unionMember")
            end
        end
    end
    self:getChildByName("trans_btn"):addTouchEventListener(goTrans)
    local function showHelp(sender,eventType)
        if eventType==ccui.TouchEventType.ended then    
            pop.onShowPopDialog("buildHelp",self._bid,self._lv)
        end
    end
    self:getChildByName("bar"):getChildByName("help_2"):addTouchEventListener(showHelp)
end

function baoKuLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, baoKuLayer)
    return target
end
--界面显示后调用
function baoKuLayer.onStart(sender)
    sender:onInit()
end
--界面关闭效果结束后调用
function baoKuLayer.onEnd(sender)
    local help = pop.getDialog("buildHelp")
    if help ~= nil and help:isVisible() then 
        help:setVisible(false)    
    end
end
--界面即将播放显示缓动时调用，返回false界面显示将终止
function baoKuLayer.onBefore(sender)
    if sender._init == false then       
        local hh = ff.height
        cclog("pop height:"..hh)
        sender:setContentSize(cc.size(720,hh - 190 - 214))
        sender:getChildByName("mainArea"):setContentSize(cc.size(720,hh - 190 - 214 - 60))    
        sender:getChildByName("mainArea"):setInnerContainerSize(cc.size(720,143 * 5))    
    end
    sender:getChildByName("mainArea"):getChildByName("oil"):setVisible(false) 
    sender:getChildByName("mainArea"):getChildByName("iron"):setVisible(false) 
    return false
end

function onShowBaoKu(widget,pos,lastpos)
    local layer = baoKuLayer.extend(widget)
    layer:setVisible(false)
--    if lastpos == pos then
--        layer._effect = false
--    else
--        layer._effect = true
--    end 
    layer._effect = false
    layer._pos = pos
    return layer
end