--兵营，城墙，医院
local barrackLayer   = class("barrackLayer")
barrackLayer._name = "barrackLayer"
barrackLayer._init = false
barrackLayer._pos  = 0
barrackLayer._bid  = 0
barrackLayer._lv  = 0
barrackLayer._sid  = 0
barrackLayer._min  = 0
barrackLayer._max  = 0
barrackLayer._edit = nil
barrackLayer._speed= 0
barrackLayer._step = 10
barrackLayer._type = 1
barrackLayer._res  = false
barrackLayer._info = {}
barrackLayer._show = 1 
barrackLayer._selectType = 1
barrackLayer._selectType2 = 1
--
--barrackLayer.__tid = nil
function barrackLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, barrackLayer)
    return target
end

function barrackLayer:onMakeArmys(sid)
	local view = self:getChildByName("pop"):getChildByName("view")

	view:getChildByName("icon1"):setVisible(false)
	view:getChildByName("icon2"):setVisible(false)
	view:getChildByName("icon3"):setVisible(false)
	view:getChildByName("icon4"):setVisible(false)
	view:getChildByName("icon5"):setVisible(false)
	view:getChildByName("label_1"):setVisible(false)
	view:getChildByName("label_2"):setVisible(false)
	view:getChildByName("label_3"):setVisible(false)
	view:getChildByName("label_4"):setVisible(false)
	view:getChildByName("label_5"):setVisible(false)

	if self._show == 2 then
		view:getChildByName("detail"):setVisible(false)
		view:getChildByName("unlockInfo"):setVisible(true)
		local army = dd.cfgSoldier[sid]
        local tid = dd.cfgTecLv[army['conditions']]['tec_id']
        local str = ff.langString("需要科技").." "..ff.langString(dd.cfgTec[tid]['tec_name'])
		view:getChildByName("unlockInfo"):getChildByName("tip"):setFontSize(24)
		view:getChildByName("unlockInfo"):getChildByName("tip"):setString(str)
		view:getChildByName("unlockInfo"):requestDoLayout()
		--cclog("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$")
	elseif self._show == 3 then
		view:getChildByName("detail"):setVisible(false)
		view:getChildByName("unlockInfo"):setVisible(true)
		view:getChildByName("unlockInfo"):getChildByName("tip"):setString(ff.langString("只能从活动中获得"))
		view:getChildByName("unlockInfo"):getChildByName("tip"):setFontSize(30)
	else
		view:getChildByName("icon2"):setVisible(true)
		view:getChildByName("icon4"):setVisible(true)
		view:getChildByName("icon5"):setVisible(true)
		view:getChildByName("label_2"):setVisible(true)
		view:getChildByName("label_4"):setVisible(true)
		view:getChildByName("label_5"):setVisible(true)

		if dd.myinfo:getLong(1,"level") <= 10 then
			view:getChildByName("icon5"):setPositionX(360)
			view:getChildByName("label_5"):setPositionX(360)
		elseif dd.myinfo:getLong(1,"level") <= 14 then
			view:getChildByName("icon1"):setVisible(true)
			view:getChildByName("label_1"):setVisible(true)
			view:getChildByName("icon5"):setPositionX(504)
			view:getChildByName("label_5"):setPositionX(504)
		else
			view:getChildByName("icon1"):setVisible(true)
			view:getChildByName("label_1"):setVisible(true)
			view:getChildByName("icon3"):setVisible(true)
			view:getChildByName("label_3"):setVisible(true)
			view:getChildByName("icon5"):setPositionX(648)
			view:getChildByName("label_5"):setPositionX(648)
		end


		view:getChildByName("detail"):setVisible(true)
		view:getChildByName("unlockInfo"):setVisible(false)
	end

	view:getChildByName("icon"):loadTexture(dd.getArmyIcon(sid))
	view:getChildByName("base"):getChildByName("name"):setString(ff.langString(dd.cfgSoldier[sid]['soldierName']))

	local count = 0
	if self._bid == 21 then
		for i=1,dd.soliders:rowCount() do
			if dd.soliders:getLong(i,"soldierid") == sid then
				count = dd.soliders:getLong(i,"count")
				break
			end	
		end
		for j=1,dd.myTroops:rowCount() do
			count = count + dd.myTroops:getLong(j,dd.cfgSoldierIndex[sid])
		end
	elseif self._bid == 22 then
		for i=1,dd.soliders:rowCount() do
			if dd.soliders:getLong(i,"soldierid") == sid then
				count = dd.soliders:getLong(i,"hurtcount")
				break
			end	
		end
	else
		for i=1,dd.myWall:rowCount() do
			if dd.myWall:getLong(i,"wallid") == sid then
				count = dd.myWall:getLong(i,"count")
				break
			end	
		end
	end	

	if self._type == 1 then
		if self._bid == 5 then
			view:getChildByName("detail"):getChildByName("dismis"):getChildByName("label"):setString(ff.langString("拆除"))
		else	
			view:getChildByName("detail"):getChildByName("dismis"):getChildByName("label"):setString(ff.langString("解散"))
		end				
	else	
		if self._bid == 5 then
			view:getChildByName("detail"):getChildByName("dismis"):getChildByName("label"):setString(ff.langString("建造"))
		elseif self._bid == 21 then
			view:getChildByName("detail"):getChildByName("dismis"):getChildByName("label"):setString(ff.langString("训练"))
		else	
			view:getChildByName("detail"):getChildByName("dismis"):getChildByName("label"):setString(ff.langString("治疗"))
		end
	end

		
	if count > 0 then
		view:getChildByName("detail"):getChildByName("dismis"):setBright(true)
		view:getChildByName("detail"):getChildByName("dismis"):setTouchEnabled(true)
	else	
		view:getChildByName("detail"):getChildByName("dismis"):setBright(false)
		view:getChildByName("detail"):getChildByName("dismis"):setTouchEnabled(false)
	end

	--基础信息
	view:getChildByName("tips"):setString(ff.langString(dd.cfgSoldier[sid]['tips']))
	local star = ""
	for i=1,6 do
		if i <= dd.cfgSoldier[sid]['atkstar'] then
			star = star.."0"
		else
			star = star.."1"
		end
	end
	view:getChildByName("info"):getChildByName("attack_label"):setString(star)
	star = ""
	for i=1,6 do
		if i <= dd.cfgSoldier[sid]['hpstar'] then
			star = star.."0"
		else
			star = star.."1"
		end
	end
	view:getChildByName("info"):getChildByName("hp_label"):setString(star)
	star = ""
	for i=1,6 do
		if i <= dd.cfgSoldier[sid]['spdstar'] then
			star = star.."0"
		else
			star = star.."1"
		end
	end
	view:getChildByName("info"):getChildByName("speed_label"):setString(star)

	local attackadd = 0
	local hpadd = 0
	local speedadd = 0
	if sid < 100 then
		local type = dd.cfgSoldier[sid]['type']%10
		if type == 1 then
			local plus_301 = 0
			local plus_521 = 0
			local plus_407 = 0
			local plus_321 = 0
			local plus_523 = 0
			local plus_409 = 0
			local plus_401 = 0
			--local plus_exp = 0
			--local plus_hp = 0
			for i=1,dd.myeffect:rowCount() do
				if dd.myeffect:getLong(i,"id") == 301 then
					plus_301 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 521 then
					plus_521 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 407 then
					plus_407 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 321 then
					plus_321 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 523 then
					plus_523 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 409 then
					plus_409 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 401 then
					plus_401 = dd.myeffect:getLong(i,"param")					
				end
			end
			--if self._info[1] ~= nil then
			----	plus_exp = self._info[1]["attack"]
			--	plus_hp = self._info[1]["hp"]
			--end
			attackadd = math.floor((plus_301/1000+plus_521/1000+plus_407/1000) * 100)
			hpadd     = math.floor((plus_321/1000+plus_523/1000+plus_409/1000) * 100)
			speedadd  = math.floor(plus_401/1000 * 100)
		elseif type ==2 then
			local plus_302 = 0
			local plus_521 = 0
			local plus_407 = 0
			local plus_322 = 0
			local plus_523 = 0
			local plus_409 = 0
			local plus_401 = 0
			local plus_402 = 0
			---local plus_exp = 0
			--local plus_hp = 0
			for i=1,dd.myeffect:rowCount() do
				if dd.myeffect:getLong(i,"id") == 302 then
					plus_302 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 521 then
					plus_521 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 407 then
					plus_407 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 322 then
					plus_322 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 523 then
					plus_523 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 401 then
					plus_401 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 402 then
					plus_402 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 409 then
					plus_409 = dd.myeffect:getLong(i,"param")
				end
			end
			--if self._info[3] ~= nil then
			--	plus_exp = self._info[3]["attack"]
			--	plus_hp = self._info[3]["hp"]
			--end
			attackadd = math.floor((plus_302/1000+plus_521/1000+plus_407/1000) * 100)
			hpadd     = math.floor((plus_322/1000+plus_523/1000+plus_409/1000) * 100)
			speedadd  = math.floor((plus_401/1000+plus_402/1000) * 100)
			cclog("attackadd: "..attackadd.."hpadd: "..hpadd.."speedadd: "..speedadd)
		else
			local plus_303 = 0
			local plus_521 = 0
			local plus_407 = 0
			local plus_323 = 0
			local plus_523 = 0
			local plus_409 = 0
			local plus_401 = 0
			local plus_402 = 0
			--local plus_exp = 0
			--local plus_hp = 0
			for i=1,dd.myeffect:rowCount() do
				if dd.myeffect:getLong(i,"id") == 303 then
					plus_303 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 521 then
					plus_521 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 407 then
					plus_407 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 323 then
					plus_323 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 523 then
					plus_523 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 409 then
					plus_409 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 401 then
					plus_401 = dd.myeffect:getLong(i,"param")
				end
			end
			--if self._info[2] ~= nil then
			--	plus_exp = self._info[2]["attack"]
			--	plus_hp = self._info[2]["hp"]
			--end
			attackadd = math.floor((plus_303/1000+plus_521/1000+plus_407/1000) * 100)
			hpadd     = math.floor((plus_323/1000+plus_523/1000+plus_409/1000) * 100)
			speedadd  = math.floor(plus_401/1000 * 100)

		end
	elseif sid == 100 then
		local plus_523 = 0
		local plus_409 = 0
		local plus_224 = 0
		local plus_200 = 0
		for i=1,dd.myeffect:rowCount() do
			if dd.myeffect:getLong(i,"id") == 523 then
				plus_523 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 409 then
				plus_409 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 224 then
				plus_224 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 200 then
				plus_200 = dd.myeffect:getLong(i,"param")
			end
		end
		hpadd     = math.floor((plus_409/1000+plus_224/1000+plus_200/1000+plus_523/1000) * 100)
	elseif dd.cfgSoldier[sid]['type'] == 11 then
		local plus_201 = 0
		local plus_521 = 0
		local plus_407 = 0
		local plus_225 = 0
		local plus_221 = 0
		local plus_409 = 0
		local plus_224 = 0
		local plus_523 = 0
		for i=1,dd.myeffect:rowCount() do
			if dd.myeffect:getLong(i,"id") == 201 then
				plus_201 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 521 then
				plus_521 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 407 then
				plus_407 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 225 then
				plus_225 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 221 then
				plus_221 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 409 then
				plus_409 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 224 then
				plus_224 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 523 then
				plus_523 = dd.myeffect:getLong(i,"param")
			end
		end
		attackadd = math.floor((plus_201/1000+plus_521/1000+plus_407/1000+plus_225/1000) * 100)
		hpadd     = math.floor((plus_221/1000+plus_409/1000+plus_224/1000+plus_523/1000) * 100)
	elseif dd.cfgSoldier[sid]['type'] == 12 then
		local plus_202 = 0
		local plus_521 = 0
		local plus_407 = 0
		local plus_225 = 0
		local plus_222 = 0
		local plus_409 = 0
		local plus_224 = 0
		local plus_523 = 0
		for i=1,dd.myeffect:rowCount() do
			if dd.myeffect:getLong(i,"id") == 202 then
				plus_202 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 521 then
				plus_521 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 407 then
				plus_407 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 225 then
				plus_225 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 222 then
				plus_222 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 409 then
				plus_409 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 224 then
				plus_224 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 523 then
				plus_523 = dd.myeffect:getLong(i,"param")
			end
		end
		attackadd = math.floor((plus_202/1000+plus_521/1000+plus_407/1000+plus_225/1000) * 100)
		hpadd     = math.floor((plus_222/1000+plus_409/1000+plus_224/1000+plus_523/1000) * 100)
	elseif dd.cfgSoldier[sid]['type'] == 13 then
		local plus_203 = 0
		local plus_521 = 0
		local plus_407 = 0
		local plus_225 = 0
		local plus_223= 0
		local plus_409 = 0
		local plus_224 = 0
		local plus_523 = 0
		for i=1,dd.myeffect:rowCount() do
			if dd.myeffect:getLong(i,"id") == 203 then
				plus_203 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 521 then
				plus_521 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 407 then
				plus_407 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 225 then
				plus_225 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 223 then
				plus_223 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 409 then
				plus_409 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 224 then
				plus_224 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 523 then
				plus_523 = dd.myeffect:getLong(i,"param")
			end
		end
		attackadd = math.floor((plus_203/1000+plus_521/1000+plus_407/1000+plus_225/1000) * 100)
		hpadd     = math.floor((plus_223/1000+plus_409/1000+plus_224/1000+plus_523/1000) * 100)
	else
		local plus_304 = 0
		local plus_521 = 0
		local plus_407 = 0
		local plus_324 = 0
		local plus_409 = 0
		local plus_523 = 0
		--local plus_exp = 0
		--local plus_hp = 0
		for i=1,dd.myeffect:rowCount() do
			if dd.myeffect:getLong(i,"id") == 304 then
				plus_304 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 521 then
				plus_521 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 407 then
				plus_407 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 324 then
				plus_324 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 409 then
				plus_409 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 523 then
				plus_523 = dd.myeffect:getLong(i,"param")
			end
		end
		--if self._info[4] ~= nil then
		--	plus_exp = self._info[4]["attack"]
		--	plus_hp = self._info[4]["hp"]
		--end
		attackadd = math.floor((plus_304/1000+plus_521/1000+plus_407/1000) * 100)
		hpadd     = math.floor((plus_324/1000+plus_409/1000+ plus_523/1000) * 100)
		speedadd  = math.floor((plus_401/1000) * 100)
	end
	cclog("attackadd: "..attackadd.."hpadd: "..hpadd.."speedadd: "..speedadd)
	view:getChildByName("info"):getChildByName("attack_effect"):setString("+"..attackadd.."%")
	view:getChildByName("info"):getChildByName("hp_effect"):setString("+"..hpadd.."%")
	view:getChildByName("info"):getChildByName("speed_effect"):setString("+"..speedadd.."%")


	--view:getChildByName("base"):getChildByName("count"):setString(count)
	view:getChildByName("base"):getChildByName("count"):setString(ff.langString("负载")..": "..dd.cfgSoldier[sid]['count'])
	view:getChildByName("base"):getChildByName("foodkeep"):setString(ff.langString("消耗总计")..": "..(dd.cfgSoldier[sid]['keepFood']/100).."/h")
	self._sid = sid
	self:setMaxMin()

	if (string.len(self._edit:getText()) == 0) or (self._max < tonumber(self._edit:getText())) or (tonumber(self._edit:getText()) <= 0)  then
		self:setNum(1)
		view:getChildByName("detail"):getChildByName("progress"):getChildByName("green"):setPercent(0)
	end
	--view:getChildByName("detail"):setVisible(true)
	view:getChildByName("speed"):setVisible(false)		


	local thetype = 3
	if self._bid == 22 then
		thetype = 9
	elseif self._bid == 5 then
		thetype = 4
	end		

	for i=1,dd.mylists:rowCount() do
		if dd.mylists:getLong(i,"type") == thetype and dd.mylists:getLong(i,"param1") == self._sid then
			view:getChildByName("detail"):setVisible(false)
			view:getChildByName("speed"):setVisible(true)		
			if dd.mylists:getLong(i,"param3") == 1 then
				if self._bid == 5 then
					view:getChildByName("speed"):getChildByName("tips"):setString(ff.langString("建造{0}个 {1} 已完成",{dd.mylists:getLong(i,"param2"),ff.langString(dd.cfgSoldier[dd.mylists:getLong(i,"param1")]['soldierName'])}))
					view:getChildByName("speed"):getChildByName("progress"):getChildByName("speedup"):getChildByName("chu_label"):setString(ff.langString("验收"))
				else
					view:getChildByName("speed"):getChildByName("tips"):setString(ff.langString("训练{0}名 {1} 已完成",{dd.mylists:getLong(i,"param2"),ff.langString(dd.cfgSoldier[dd.mylists:getLong(i,"param1")]['soldierName'])}))
					view:getChildByName("speed"):getChildByName("progress"):getChildByName("speedup"):getChildByName("chu_label"):setString(ff.langString("入伍"))
				end
			else
				view:getChildByName("speed"):getChildByName("progress"):getChildByName("speedup"):getChildByName("chu_label"):setString(ff.langString("Speed Up"))
				if self._bid == 5 then
					view:getChildByName("speed"):getChildByName("tips"):setString(ff.langString("正在建造{0}个 {1}",{dd.mylists:getLong(i,"param2"),ff.langString(dd.cfgSoldier[dd.mylists:getLong(i,"param1")]['soldierName'])}))
				else
					view:getChildByName("speed"):getChildByName("tips"):setString(ff.langString("正在训练{0}名 {1}",{dd.mylists:getLong(i,"param2"),ff.langString(dd.cfgSoldier[dd.mylists:getLong(i,"param1")]['soldierName'])}))
				end
			end
			break
		end
	end

	if self._type == 1 then
		--self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("dismis"):getChildByName("label"):setString(ff.langString("解散"))
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):setVisible(true)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):setVisible(true)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("dismissure"):setVisible(false)
	else		
		--self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("dismis"):getChildByName("label"):setString(ff.langString("训练"))
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):setVisible(false)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):setVisible(false)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("dismissure"):setVisible(true)
	end

    view:getChildByName("close"):setTouchEnabled(true)
    
    if view:getPositionY() ~= 0 or self:getChildByName("pop"):isVisible() == false  then
        view:setPosition(cc.p(0,-view:getContentSize().height))
        self:getChildByName("pop"):setVisible(true)
        --view:setOpacity(100)

		--guide. add by lhz       
        function callfun() 
	        if GuideControl.curId == 620 then
	            self:setNum(999)
			    pop.getDialog("barrack"):getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("progress"):getChildByName("green"):setPercent(100)
                GuideControl:GuideCheck()
			end
	    end
        performWithDelay(view, callfun, 0.3)
        --guide end
        view:runAction(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,0))))
    else
    	view:stopAllActions()
    end		
end
function barrackLayer:setNum(count)
	if count > self._max then
		count = self._max
	end
	if count < self._min then
		count = self._min
	end

	if tonumber(self._edit:getText() == count) then
		return
	end

	local res_fix = 1
	local silver_fix = 1
	if self._type == 1 then
		self._res = false
		local icon = nil
		local label= nil

		--1星兵种医疗消耗资源改为造兵消耗资源的20%*（1-plus_414/1000），银两消耗改为造兵消耗的10%*（1-plus_414/1000）

		if self._bid == 22 then
			local star = dd.cfgSoldier[self._sid]['step']
			local plus_414 = 0
			local plus_416 = 0
			for i=1,dd.myeffect:rowCount() do
				if dd.myeffect:getLong(i,"id") == 414 then
					plus_414 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 416 then
					plus_416 = dd.myeffect:getLong(i,"param")
				end	
			end			
			if star == 1 then
				res_fix = 0.2*(1-plus_414/1000)*(1-plus_416/1000)
				silver_fix = 0.1*(1-plus_414/1000)*(1-plus_416/1000)
			elseif star == 2 then	
				res_fix = 0.3*(1-plus_414/1000)*(1-plus_416/1000)
				silver_fix = 0.15*(1-plus_414/1000)*(1-plus_416/1000)
			else
				res_fix = 0.4*(1-plus_414/1000)*(1-plus_416/1000)
				silver_fix = 0.2*(1-plus_414/1000)*(1-plus_416/1000)
			end
		end
		--石
		if dd.cfgSoldier[self._sid]['needStone'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon1")
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_1")
			
			if dd.stone() < math.ceil(dd.cfgSoldier[self._sid]['needStone'] * count * res_fix) then
				label:setColor(cc.c3b(255,0,0))
				self._res = true
			else	
				label:setColor(cc.c3b(139,155,160))
			end	
			label:setString(dd.showKM(math.ceil(dd.cfgSoldier[self._sid]['needStone'] * count* res_fix),4).."/"..dd.showKM(dd.stone(),4))
			--label:setString(dd.0showKM(dd.stone(),4).."/"..dd.showKM(dd.cfgSoldier[self._sid]['needStone'] * count* res_fix,4))
		else
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_1")
			label:setColor(cc.c3b(139,155,160))
			label:setString("0/"..dd.showKM(dd.stone(),4))
			--label:setString(dd.showKM(dd.stone(),4).."/0")
		end	
		--木
		if dd.cfgSoldier[self._sid]['needWood'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon2")
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_2")
			if dd.wood() < math.ceil(dd.cfgSoldier[self._sid]['needWood'] * count* res_fix) then
				label:setColor(cc.c3b(255,0,0))
				self._res = true
			else	
				label:setColor(cc.c3b(139,155,160))
			end
			label:setString(dd.showKM(math.ceil(dd.cfgSoldier[self._sid]['needWood'] * count* res_fix),4).."/"..dd.showKM(dd.wood(),4))
			--label:setString(dd.showKM(dd.wood(),4).."/"..dd.showKM(dd.cfgSoldier[self._sid]['needWood'] * count* res_fix,4))
		else
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_2")
			label:setColor(cc.c3b(139,155,160))
			label:setString("0/"..dd.showKM(dd.wood(),4))
			--label:setString(dd.showKM(dd.wood(),4).."/0")
		end	
		--钢
		if dd.cfgSoldier[self._sid]['needIron'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon3")
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_3")
			if dd.iron() < math.ceil(dd.cfgSoldier[self._sid]['needIron'] * count* res_fix) then
				label:setColor(cc.c3b(255,0,0))
				self._res = true
			else	
				label:setColor(cc.c3b(139,155,160))
			end
			label:setString(dd.showKM(math.ceil(dd.cfgSoldier[self._sid]['needIron'] * count* res_fix),4).."/"..dd.showKM(dd.iron(),4))
			--label:setString(dd.showKM(dd.iron(),4).."/"..dd.showKM(dd.cfgSoldier[self._sid]['needIron'] * count* res_fix,4))
		else
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_3")
			label:setColor(cc.c3b(139,155,160))
			label:setString("0/"..dd.showKM(dd.iron(),4))
			--label:setString(dd.showKM(dd.iron(),4).."/0")
		end	
		--食
		if dd.cfgSoldier[self._sid]['needFood'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon4")
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_4")
			if dd.food() < math.ceil(dd.cfgSoldier[self._sid]['needFood'] * count* res_fix) then
				label:setColor(cc.c3b(255,0,0))
				self._res = true
			else	
				label:setColor(cc.c3b(139,155,160))
			end
			label:setString(dd.showKM(math.ceil(dd.cfgSoldier[self._sid]['needFood'] * count* res_fix),4).."/"..dd.showKM(dd.food(),4))
			--label:setString(dd.showKM(dd.food(),4).."/"..dd.showKM(dd.cfgSoldier[self._sid]['needFood'] * count* res_fix,4))
		else
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_4")
			label:setColor(cc.c3b(139,155,160))
			label:setString("0/"..dd.showKM(dd.food(),4))
			--label:setString(dd.showKM(dd.food(),4).."/0")
		end			
		--银子
		if dd.cfgSoldier[self._sid]['needSilver'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon5")
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_5")

			if dd.silver() < math.ceil(dd.cfgSoldier[self._sid]['needSilver'] * count*silver_fix) then
				label:setColor(cc.c3b(255,0,0))
				self._res = true
			else	
				label:setColor(cc.c3b(139,155,160))
			end
			label:setString(dd.showKM(math.ceil(dd.cfgSoldier[self._sid]['needSilver'] * count*silver_fix),4).."/"..dd.showKM(dd.silver(),4))
			--label:setString(dd.showKM(dd.silver(),4).."/"..dd.showKM(dd.cfgSoldier[self._sid]['needSilver'] * count*silver_fix,4))
		else
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_5")
			label:setColor(cc.c3b(139,155,160))
			label:setString("0/"..dd.showKM(dd.silver(),4))
			--label:setString(dd.showKM(dd.silver(),4).."/0")
		end			

		if self._res == true then
			self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("progress"):getChildByName("green"):loadProgressBarTexture(dd.getPathFromUI("public/v2/progress_precent2.png",1))
		else		
			self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("progress"):getChildByName("green"):loadProgressBarTexture(dd.getPathFromUI("public/v2/progress_precent.png",1))
		end		
	end	
	self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("min"):setString(self._min)
	self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("max"):setString(self._max)

	self._edit:setText(count)

	local res_gold = 0
	if dd.stone() < dd.cfgSoldier[self._sid]['needStone'] * count * res_fix then
		res_gold = (dd.cfgSoldier[self._sid]['needStone'] * count* res_fix - dd.stone())/dd.stone_lv
	end
	if dd.wood() < dd.cfgSoldier[self._sid]['needWood'] * count* res_fix then
		res_gold = res_gold + (dd.cfgSoldier[self._sid]['needWood'] * count* res_fix - dd.wood())/dd.wood_lv
	end
	if dd.iron() < dd.cfgSoldier[self._sid]['needIron'] * count* res_fix then
		res_gold = res_gold + (dd.cfgSoldier[self._sid]['needIron'] * count* res_fix - dd.iron())/dd.iron_lv
	end
	if dd.food() < dd.cfgSoldier[self._sid]['needFood'] * count* res_fix then
		res_gold = res_gold + (dd.cfgSoldier[self._sid]['needFood'] * count* res_fix - dd.food())/dd.food_lv
	end
	if dd.silver() < dd.cfgSoldier[self._sid]['needSilver'] * count *silver_fix then
		res_gold = res_gold + (dd.cfgSoldier[self._sid]['needSilver'] * count*silver_fix - dd.silver())/dd.silver_lv
	end	
	--取整
	res_gold = math.ceil(res_gold)

	--计算黄金
	if self._type == 1 then
		if self._bid == 21 or self._bid == 22 then
			--建造兵的时间=单个兵的基础造兵时间 /（（5.0+plus_403）/10.0*（1+plus_410））
			local p1 = 0
			local p2 = 0
			local p3 = 0
			for i=1,dd.myeffect:rowCount() do
				if dd.myeffect:getLong(i,"id") == 403 then
					p1 = dd.myeffect:getLong(i,"param")
				end
				if dd.myeffect:getLong(i,"id") == 410 then
					p2 = dd.myeffect:getLong(i,"param")
				end
				if dd.myeffect:getLong(i,"id") == 415 then
					p3 = dd.myeffect:getLong(i,"param")
				end				
			end
			local time = 0
			if self._bid == 21 then
				time = count * dd.cfgSoldier[self._sid]['needTime']
				local plus = ((5.0 + p1/1000)/10*(1+p2/1000))
				time = time/plus
			else		
				time = count * dd.cfgSoldier[self._sid]['treatTime']/(1+p3/1000)
			end	
			time = math.ceil(time)
			local golds = dd.getRealGoodp(time,res_gold)

			self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
			self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):getChildByName("count"):setString(golds)
			if self._bid == 21 then
				self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):getChildByName("label"):setString(ff.langString("训练"))
				self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):getChildByName("label"):setString(ff.langString("立即完成"))
			else			
				self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):getChildByName("label"):setString(ff.langString("治疗"))
				self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):getChildByName("label"):setString(ff.langString("立即完成"))
			end
			self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):getChildByName("label"):getVirtualRenderer():enableBold(true)
			
			self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):getChildByName("label"):getVirtualRenderer():enableBold(true)
			
		else
			local p1 = 0
			for i=1,dd.myeffect:rowCount() do
				if dd.myeffect:getLong(i,"id") == 232 then
					p1 = dd.myeffect:getLong(i,"param")
					break
				end
			end
			local time = math.ceil(count * dd.cfgSoldier[self._sid]['needTime'] / (1+p1/1000))
			local golds = dd.getRealGoodp(time,res_gold)

			self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
			self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):getChildByName("count"):setString(golds)
			self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):getChildByName("label"):setString(ff.langString("建造"))
			self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):getChildByName("label"):setString(ff.langString("立即完成"))
			self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):getChildByName("label"):getVirtualRenderer():enableBold(true)
			
			self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):getChildByName("label"):getVirtualRenderer():enableBold(true)
	
		end	
	else
		local index = 1
		local icon = nil
		local label= nil

		--钢
		if dd.cfgSoldier[self._sid]['needIron'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon"..index)
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_"..index)
			label:setString("0/"..dd.iron())
			index = index + 1
		end	
		--石
		if dd.cfgSoldier[self._sid]['needStone'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon"..index)
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_"..index)
			label:setString("0/"..dd.stone())
			index = index + 1
		end	
		--食
		if dd.cfgSoldier[self._sid]['needFood'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon"..index)
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_"..index)
			label:setString("0/"..dd.food())
			index = index + 1
		end			
		--木
		if dd.cfgSoldier[self._sid]['needWood'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon"..index)
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_"..index)
			label:setString("0/"..dd.wood())
			index = index + 1
		end	
		--银子
		if dd.cfgSoldier[self._sid]['needWood'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon"..index)
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_"..index)
			label:setString("0/"..dd.silver())
			index = index + 1
		end			
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("progress"):getChildByName("green"):loadProgressBarTexture(dd.getPathFromUI("public/v2/progress_precent.png",1))
	end	

	local progress = math.ceil(count * 100 / self._max)
	self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("progress"):getChildByName("green"):setPercent(progress)
end
function barrackLayer.onSure(sender,eventType)
	if eventType==ccui.TouchEventType.ended then    
		local build = pop.getDialog("barrack")
		local havesame = false

		if build._bid == 5 then
			havesame = dd.currentLayer._widget:haveSameQue(4)
		elseif build._bid == 21 then
			havesame = dd.currentLayer._widget:haveSameQue(3)
		else
			havesame = dd.currentLayer._widget:haveSameQue(9)
		end
		if havesame == false then
			if tonumber(build._edit:getText()) <= 0 then
				dd.currentLayer._widget:onShowTips("\t"..ff.langString("数量不能为0"))
			else
				if build ~= nil then
					local function sendMessage(type)
				        local message = ff.net:createMessage()
				        if build._sid >= 100 then
				        	message:addCmd(0x107)
				        	AudioEngine.playEffect(ff.sounds["b001"])
				        else	
				        	if build._bid == 21 then
					        	message:addCmd(0x106)
					        	AudioEngine.playEffect(ff.sounds["t001"])
					        else	
					        	message:addCmd(0x108)
					        end	
				        end	
				        message:addLong(dd.uid)
				        message:addLong(type)
				        message:addLong(build._sid)
				        message:addLong(tonumber(build._edit:getText()))
				        ff.net:rpc(message,false)
					end
					local function backMessage()
						sendMessage(13)
					end
					if build._res == false then
						sendMessage(11)
				    else
				    	if build._bid == 5 then
					    	dd.currentLayer._widget:onShowBuyRes(4,build._sid,tonumber(build._edit:getText()),backMessage)
					    elseif build._bid == 21 then
					    	dd.currentLayer._widget:onShowBuyRes(3,build._sid,tonumber(build._edit:getText()),backMessage)
					    else
					    	dd.currentLayer._widget:onShowBuyRes(9,build._sid,tonumber(build._edit:getText()),backMessage)
					    end	
				    end    
			    end    
			end    
		else		
			if build._bid == 5 then	
				dd.currentLayer._widget:onShowSameQue(4)
			elseif build._bid == 21 then
				dd.currentLayer._widget:onShowSameQue(3)
			else
				dd.currentLayer._widget:onShowSameQue(9)
			end
		end    
	end
end
function barrackLayer.onGoTec(sender,eventType)
	if eventType==ccui.TouchEventType.ended then    
		local build = pop.getDialog("barrack")
		if build._sid > 0 then
			local army = dd.cfgSoldier[build._sid]
        	local tid = dd.cfgTecLv[army['conditions']]['tec_id']
			for i=1,dd.mybuilds:rowCount() do
	            if dd.mybuilds:getLong(i,"bid") == 11 then
	            	onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"),nil,tid)
	            	build.closePop(build:getChildByName("pop"):getChildByName("view"):getChildByName("close"),ccui.TouchEventType.ended)
	                break
	            end
	        end
	    end
	end
end
function barrackLayer.onGoldSure(sender,eventType)
	if eventType==ccui.TouchEventType.ended then    
		local build = pop.getDialog("barrack")
		if build ~= nil then
			if tonumber(build._edit:getText()) <= 0 then
				dd.currentLayer._widget:onShowTips("\t"..ff.langString("数量不能为0"))
			else
		        local message = ff.net:createMessage()
		        if build._sid >= 100 then
		        	message:addCmd(0x107)
		        	AudioEngine.playEffect(ff.sounds["b002"])
		        else	
		        	if build._bid == 21 then
			        	message:addCmd(0x106)
			        else	
			        	message:addCmd(0x108)
			        end	
			        --AudioEngine.playEffect(ff.sounds["t002"])
		        end		
		        message:addLong(dd.uid)
		        message:addLong(12)
		        message:addLong(build._sid)
		        message:addLong(tonumber(build._edit:getText()))
		        ff.net:rpc(message,false)
		    end   
	    end    
	end
end
function barrackLayer.onSureDismis(sender,eventType)
	if eventType==ccui.TouchEventType.ended then    
		local build = pop.getDialog("barrack")
		if build ~= nil then
			if tonumber(build._edit:getText()) <= 0 then
				dd.currentLayer._widget:onShowTips("\t"..ff.langString("数量不能为0"))
			else
		        local message = ff.net:createMessage()
		        if build._sid >= 100 then
		        	message:addCmd(0x107)
		        else	
		        	if build._bid == 21 then
			        	message:addCmd(0x106)
			        else	
			        	message:addCmd(0x108)
			        end	
		        end		        
		        message:addLong(dd.uid)
		        message:addLong(91)
		        message:addLong(build._sid)
		        message:addLong(tonumber(build._edit:getText()))
		        ff.net:rpc(message,false)
		    end    
	    end    
	end
end
function barrackLayer.onDismis(sender,eventType)
	if eventType==ccui.TouchEventType.ended then    
		local widget = pop.getDialog("barrack")
		if widget ~= nil then
			if widget._type == 1 then
				widget._type = 2
				widget:setMaxMin()
			else	
				widget._type = 1
				widget:setMaxMin()
			end
			widget:onMakeArmys(widget._sid)
		end
	end
end
function barrackLayer.onSub(sender,eventType)
	local build = pop.getDialog("barrack")
	local function subCount(flag)
		if build._speed == build._step or flag == true then
			if build ~= nil and build._edit ~= nil then		
				local count = tonumber(build._edit:getText())
				if count == nil or count == "" then
					count = build._min
				end				
				if count < build._min then
					count = build._min
					sender:stopAllActions()
				else
					count = count - 1				
				end	

				build:setNum(count)	
				build._speed = 0
				build._step  = build._step - 1
				if build._step < 1 then
					build._step = 1
				end	
			end
		end
		build._speed = build._speed + 1	
	end
	if eventType==ccui.TouchEventType.began then   
		build._speed = 0
		schedule(sender,subCount,0.01)	
	elseif eventType==ccui.TouchEventType.ended then   
		subCount(true)
		build._speed = 0
		build._step  = 10
		sender:stopAllActions()	
	elseif eventType == ccui.TouchEventType.canceled then
		build._speed = 0
		build._step  = 10
		sender:stopAllActions()	
	end
end
function barrackLayer.onAdd(sender,eventType)
	local build = pop.getDialog("barrack")
	local function addCount(flag)
		if build._speed == build._step or flag == true then
			if build ~= nil and build._edit ~= nil then		
				local count = tonumber(build._edit:getText())
				if count > build._max then
					count = build._max
					sender:stopAllActions()
				else
					count = count + 1				
				end	
				if count == nil or count == "" then
					count = build._max
				end
				build:setNum(count)	
				build._speed = 0
				build._step  = build._step - 1
				if build._step < 1 then
					build._step = 1
				end	
			end
		end
		build._speed = build._speed + 1	
	end
	if eventType==ccui.TouchEventType.began then   
		build._speed = 0
		schedule(sender,addCount,0.01)	
	elseif eventType==ccui.TouchEventType.ended then   
		addCount(true)
		build._speed = 0
		build._step  = 10
		sender:stopAllActions()	
	elseif eventType == ccui.TouchEventType.canceled then
		build._speed = 0
		build._step  = 10
		sender:stopAllActions()	
	end
end

function barrackLayer.onSpeedup(sender,eventType)
	local function speedUp(type)
		if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
	        local message = ff.net:createMessage()
	        message:addCmd(0x00000104)
	        message:addLong(dd.uid)
	        message:addLong(8)
	        message:addLong(0)
	        message:addLong(type)
	        ff.net:rpc(message,false)
	        --AudioEngine.playEffect(ff.sounds["b002"])
		end	
	end
	local function speedUp3()
		speedUp(3)
	end	
	local function speedUp4()
		speedUp(4)
	end	
	local function speedUp9()
		speedUp(9)
	end	

	if eventType==ccui.TouchEventType.ended then   
		if dd.currentLayer ~= nil then
			local build = pop.getDialog("barrack")
			local que = 0
			if build._bid == 5 then
				que = 4
			elseif build._bid == 21 then
				que = 3
			end

			for i=1,dd.mylists:rowCount() do
				if dd.mylists:getLong(i,"type") == que and dd.mylists:getLong(i,"param3") == 1 then
				    local message = ff.net:createMessage()
				    message:addCmd(0x00000104)
				    message:addLong(dd.uid)
				    message:addLong(7)
				    message:addLong(build._pos)
				    message:addLong(que)
				    ff.net:postMessage(message)   
				    if que == 4 then
					    AudioEngine.playEffect(ff.sounds[231])   
					else
					    AudioEngine.playEffect(ff.sounds[230])   
					end			
					if GuideControl._isOver == false and GuideControl.curId <= 660 then
						cclog("关闭界面:"..GuideControl.curId)
						GuideControl.curId = 680
						dd.mainUI:closeBuilds()		
					end
					return
				end
			end

			if build._bid == 5 then
				dd.currentLayer._widget:onShowBuyTime(4,speedUp4)
			elseif build._bid == 21 then
				dd.currentLayer._widget:onShowBuyTime(3,speedUp3)
			else	
				dd.currentLayer._widget:onShowBuyTime(9,speedUp9)
			end	
		end	
	end	
end
function barrackLayer.onStop(sender,eventType)
	if eventType==ccui.TouchEventType.ended then   
		if eventType==ccui.TouchEventType.ended then   

			local function callback(  )
				-- body
				local build = pop.getDialog("barrack")
				local que = 0
				if build._bid == 5 then
					que = 4
				elseif build._bid == 21 then
					que = 3
				end
				if build ~= nil then
					for i=1,dd.mylists:rowCount() do
						if dd.mylists:getLong(i,"type") == que and dd.mylists:getLong(i,"param3") == 1 then
							return
						end
					end
					if que > 0 then
				        local message = ff.net:createMessage()
				        message:addCmd(0x104)
				        message:addLong(dd.uid)
				        message:addLong(9)
				        message:addLong(0)
				        message:addLong(que)
				        ff.net:rpc(message,false)
				    end
			    end
			end

		    dd.currentLayer._widget:onShowSure(ff.langString("训练取消确认"),ff.langString("您确认要取消本次操作吗？\n取消训练不会返还任何资源"),callback,true,2)
		end	
	end
end

function barrackLayer:selectArmy(sid)
	local item = nil
	if sid == 100 then
		item = self:getChildByTag(sid)
	else	
		item = self:getChildByName("mainArea"):getChildByTag(sid)
	end	
	if item ~= nil then		
		if dd.cfgSoldier[sid]['canBuild'] == 0 and self._bid ~= 22 then
			self._show = 3
			self._sid = sid
		else
			self._sid = sid
			self._type= 1
			if item:getChildByName("lock"):isVisible() == true then
				self._show = 2
			else	
				self._show = 1
			end
		end
		self:setNum(1)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("progress"):getChildByName("green"):setPercent(0)
		self:onMakeArmys(self._sid)
	end
end
function barrackLayer.closePop(sender,eventType)
    local function unShow()
    	local widget = pop.getDialog("barrack")
    	widget:getChildByName("pop"):setVisible(false)
		for i,item in ipairs(widget:getChildByName("mainArea"):getChildren()) do
			item:getChildByName("item"):setSelectedState(false)
		end	
		local item = widget:getChildByTag(100)
		if item ~= nil then
			item:getChildByName("item"):setSelectedState(false)
		end
        GuideControl:GuideCheck()
    end    

	if eventType==ccui.TouchEventType.ended then   
		local widget = pop.getDialog("barrack") 
		if widget ~= nil then
			widget._type = 1
			widget:setMaxMin()
	        unShow()
		end	        				
	end
end 

function barrackLayer:onInit()
	local function selectArmy(sender,eventType)
		local doaction = false
	    if eventType == ccui.TouchEventType.canceled then
	        local startp = sender:getTouchBeganPosition()
	        local endp   = sender:getTouchEndPosition()
	        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
				sender:setSelectedState(true)
	        	doaction = true
	        end
	    end

		if eventType==ccui.TouchEventType.ended then    
			doaction = true
		end
		if doaction == true then
			local sid = sender:getTag()
			for i,item in ipairs(self:getChildByName("mainArea"):getChildren()) do
				item:getChildByName("item"):setSelectedState(false)
			end	
			local item = self:getChildByTag(100)
			if item ~= nil then
				item:getChildByName("item"):setSelectedState(false)
			end
			self:selectArmy(sid)
		end
	end
	function sliderEvent( ref, eventType )
	    if eventType == ccui.SliderEventType.percentChanged then
	        local percent = ref:getPercent()
	        local curNum = math.ceil(percent / 100 * self._max)
	        self:setNum(curNum)
	    end
	end

	self._info = {}
	if self._init == false then
		self._init = true
		self:getChildByName("type"):getChildByName("type1"):getChildByName("Label_100"):setString(ff.langString("训练"))
		self:getChildByName("type"):getChildByName("type2"):getChildByName("Label_100"):setString(ff.langString("熟练度"))
		self:getChildByName("type"):getChildByName("type1"):setTag(1)
		self:getChildByName("type"):getChildByName("type2"):setTag(2)

	    self:getChildByName("type"):getChildByName("type2"):addTouchEventListener(self.onSelectType)
	    self:getChildByName("type"):getChildByName("type1"):addTouchEventListener(self.onSelectType)
	    self:getChildByName("type1"):getChildByName("type1"):getChildByName("Label_100"):setString(ff.langString("制造"))
		self:getChildByName("type1"):getChildByName("type2"):getChildByName("Label_100"):setString(ff.langString("城防值"))
		self:getChildByName("type1"):getChildByName("type1"):setTag(1)
		self:getChildByName("type1"):getChildByName("type2"):setTag(2)

		self:getChildByName("oper"):getChildByName("join"):getChildByName("Label"):setString(ff.langString("立即修复"))

	    self:getChildByName("type1"):getChildByName("type2"):addTouchEventListener(self.onSelectType2)
	    self:getChildByName("type1"):getChildByName("type1"):addTouchEventListener(self.onSelectType2)
	    self:getChildByName("oper"):getChildByName("join"):addTouchEventListener(self.onFix)
	    self:getChildByName("item1"):getChildByName("up"):addTouchEventListener(self.onUp)
	    self:getChildByName("oper"):setPositionY(0)
		local rows = ff.dbmanager:sql_fetch_rows("select `step`,`type`,`soldierid`,`canbuild` from cfg_soldier where `soldierid`<100 ORDER BY `type` ASC,`step` ASC")
		local maxstep = 6
		--if self._bid == 21 then
			--maxstep = 5
		--end		
		for i=1,rows:rowCount() do
			local item = self:getChildByName("item"):clone()
			item:setTag(tonumber(rows:getString(i,"soldierid")))
			item:getChildByName("person"):loadTexture(dd.getPathFromUI("public/alpha.png",1))

			local step = tonumber(rows:getString(i,"step"))
			local star = ""
			for j=1,step do
				star = star.."0"
			end
			item:getChildByName("star"):setString(star)

			local type = tonumber(rows:getString(i,"type"))
			local xx = 0
			local yy = 0
			if type == 1 then
				xx = 15
			elseif type == 2 then
				xx = 255
			else
				xx = 496
			end
			yy = (maxstep * 270) - step * 270
			self:getChildByName("mainArea"):addChild(item)
			item:setTouchEnabled(true)
			item:setVisible(true)
			item:setPosition(cc.p(xx,yy))
			item:getChildByName("item"):setTag(tonumber(rows:getString(i,"soldierid")))
			item:getChildByName("item"):addTouchEventListener(selectArmy)
		end	
		rows:clear()

		rows= ff.dbmanager:sql_fetch_rows("select `step`,`type`,`soldierid`,`canbuild` from cfg_soldier where `type`>=10 and `type`<20 ORDER BY `type` ASC,`step` ASC")
		for i=1,rows:rowCount() do
			local type = tonumber(rows:getString(i,"type"))
			local item = self:getChildByName("item"):clone()
			item:setTag(tonumber(rows:getString(i,"soldierid")))
			item:getChildByName("person"):loadTexture(dd.getPathFromUI("public/alpha.png",1))

			local step = tonumber(rows:getString(i,"step"))
			local star = ""
			for j=1,step do
				star = star.."0"
			end
			item:getChildByName("star"):setString(star)
			
			if type ~= 10 then
				type = type%10
				local xx = 0
				local yy = 0
				if type == 1 then
					xx = 15
				elseif type == 2 then
					xx = 255
				else
					xx = 496
				end
				yy = 0
				self:getChildByName("mainArea"):addChild(item)
				item:setPosition(cc.p(xx,yy))
			else
				self:addChild(item,0)	
			end	
			item:setTouchEnabled(false)
			item:setVisible(false)
			item:getChildByName("item"):setTag(tonumber(rows:getString(i,"soldierid")))			
			item:getChildByName("item"):addTouchEventListener(selectArmy)
		end	
		rows:clear()

		--输入
        local size = self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("input"):getChildByName("count"):getContentSize()
        local editBox = dd.addEditBox(
             self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("input")
            , size
            , "images/ui/alpha.png"
            , 10
            , cc.p(0,0.5)
            , cc.p(self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("input"):getChildByName("count"):getPosition())
            , cc.c3b(255,255,255)
            , 20
            , 2
            , 4
            , 1
            , 5
            , true
            , true
            , true
        )
        local function editBoxTextEventHandle(strEventName,pSender)
            local edit = pSender
            local strFmt 
            if strEventName == "began" then
            elseif strEventName == "ended" or strEventName == "return" then
                local text=edit:getText()
                local count = 0
                if text == nil or text == "" then
                	count = 0
                else
                	count = tonumber(text)
                end
                if count == nil or count == "" then
                	count = 0
                end
                self:setNum(count)
            elseif strEventName == "changed" then
            end
        end
        self._edit = editBox
        editBox:registerScriptEditBoxHandler(editBoxTextEventHandle)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.closePop)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("progress"):getChildByName("green"):addEventListener(sliderEvent)

		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):addTouchEventListener(self.onSure)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("unlockInfo"):getChildByName("gotec"):addTouchEventListener(self.onGoTec)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):addTouchEventListener(self.onGoldSure)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("dismis"):addTouchEventListener(self.onDismis)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("dismissure"):addTouchEventListener(self.onSureDismis)
		self:getChildByName("tips1"):setString(ff.langString("每个死亡的士兵会为你的对应兵种提升熟练度，星级越高，提升的熟练度越多"))

		self:getChildByName("pop"):getChildByName("view"):getChildByName("speed"):getChildByName("progress"):getChildByName("stop"):addTouchEventListener(self.onStop)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("speed"):getChildByName("progress"):getChildByName("speedup"):addTouchEventListener(self.onSpeedup)

		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sub"):addTouchEventListener(self.onSub)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("add"):addTouchEventListener(self.onAdd)

		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("progress"):getChildByName("green"):setCorrect(35,320)

	end

	local hh = dd.currentLayer._pop:getContentSize().height
	self:getChildByName("types"):setVisible(true)
	self:getChildByName("mainArea"):setVisible(true)
	self:getChildByName("list"):setVisible(false)
	if self._bid == 5 then
		local item = self:getChildByTag(100)
		if item ~= nil then
			item:setPositionY(hh - 190 - 60 - 270- 80)
		end
		self:getChildByName("type"):setVisible(false)
		self:getChildByName("type1"):setVisible(true)
		self:getChildByName("type1"):setPositionY(hh - 190 - 60 - 80)
		self:getChildByName("types"):setPositionY(hh - 190 - 60 - 90 - 270 - 80)
		self:getChildByName("mainArea"):setContentSize(cc.size(720,270))
		self:getChildByName("mainArea"):setInnerContainerSize(cc.size(720,270))
		self:getChildByName("mainArea"):setPositionY(hh - 190 - 60 - 90 - 270 - 10 - 270 - 80)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("dismis"):getChildByName("label"):setString(ff.langString("拆除"))
		self:getChildByName("types"):setVisible(true)
		self:getChildByName("list"):setVisible(false)
		self:getChildByName("list"):setPositionY(120)
		self:getChildByName("list"):setContentSize(cc.size(720,hh - 190 - 60 - 80-120))	
		self._selectType2 = 1	
		self:selectType2(self:getChildByName("type1"):getChildByName("type1"))
	elseif self._bid == 21 then
		self:getChildByName("oper"):setVisible(false)
		self:getChildByName("type"):setVisible(true)
		self:getChildByName("type1"):setVisible(false)
		self:getChildByName("type"):setPositionY(hh - 190 - 60 - 74)
		self:getChildByName("mainArea"):setContentSize(cc.size(720,hh - 190 - 60 - 90 - 5 - 80))
		self:getChildByName("mainArea"):setInnerContainerSize(cc.size(720,270 * 6))
		self:getChildByName("types"):setPositionY(hh - 190 - 60 - 82 - 80)
		self:getChildByName("mainArea"):setPositionY(5)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("dismis"):getChildByName("label"):setString(ff.langString("解散"))
		self:getChildByName("types"):setVisible(true)
		self:getChildByName("list"):setVisible(false)
		self:getChildByName("list"):setPositionY(0)
		self:getChildByName("list"):setContentSize(cc.size(720,hh - 190 - 60 - 80))
		self._selectType = 1
		--self:getChildByName("tips1"):setPositionY(0)
    	self:selectType(self:getChildByName("type"):getChildByName("type1"))
	else
		self:getChildByName("oper"):setVisible(false)
		self:getChildByName("type1"):setVisible(false)
		self:getChildByName("type"):setVisible(false)
		self:getChildByName("mainArea"):setContentSize(cc.size(720,hh - 190 - 60 - 5))
		self:getChildByName("mainArea"):setInnerContainerSize(cc.size(720,1620))
		self:getChildByName("mainArea"):setPositionY(5)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("dismis"):getChildByName("label"):setString(ff.langString("解散"))
		self:getChildByName("types"):setVisible(false)		
	end

	self:setMaxMin()

	for sid,army in pairs(dd.cfgSoldier) do
		local item = nil
		if army['type'] == 10 then
			item = self:getChildByTag(sid)
		else	
			item = self:getChildByName("mainArea"):getChildByTag(tonumber(sid))
		end	
		if item ~= nil then
			local see = false
			if self._bid == 5 then
				if sid >= 100 then
					see = true
				end
			else
				local maxstep = 6
				--if self._bid == 21 then
				--	maxstep = 5 
				--end
				if sid < 100 then
					if self._bid == 21 then
						local step = army['step']
						local type = army['type']
						type = type%10
						local xx = 0
						local yy = 0
						if type == 1 then
							xx = 15
						elseif type == 2 then
							xx = 255
						else
							xx = 496
						end
						yy = (maxstep * 270) - step * 270
						item:setPosition(cc.p(xx,yy))
					end
					see = true
				end
			end

			if see == false then
				item:setVisible(false)
				item:setTouchEnabled(false)
			else	
				item:getChildByName("clock"):setVisible(false)
				item:getChildByName("time"):setVisible(false)
				item:getChildByName("progress"):setVisible(false)
				item:getChildByName("count"):setString(0)
				item:getChildByName("lock"):setVisible(true)
				item:getChildByName("person"):loadTexture(dd.getArmyIcon(sid),0)
				item:setVisible(true)
				item:setTouchEnabled(true)
				if self._bid == 21 or self._bid == 5 then
					if army['conditions'] > 0 then
						for i=1,dd.myTec:rowCount() do
	                        if (dd.myTec:getLong(i,"tec_id")*100 + dd.myTec:getLong(i,"lv")) == army['conditions'] then
								item:getChildByName("lock"):setVisible(false)
							end
						end
					else
						item:getChildByName("lock"):setVisible(false)
					end
				elseif self._bid == 22 then
					item:getChildByName("lock"):setVisible(false)
					item:setVisible(false)
				end
			end	
		end
	end
	if self._bid == 21 then
		for sid,army in pairs(dd.cfgSoldier) do
			local item = self:getChildByName("mainArea"):getChildByTag(sid)
			if item ~= nil then
				local count = 0
				for i=1,dd.soliders:rowCount() do
					if dd.soliders:getLong(i,"soldierid") == sid then
						count = dd.soliders:getLong(i,"count")
						break
					end
				end
				for j=1,dd.myTroops:rowCount() do
					count = count + dd.myTroops:getLong(j,dd.cfgSoldierIndex[sid])
				end						
				cclog("sid:"..sid..",count:"..count)
				item:getChildByName("count"):setString(count)
			end
		end
	elseif self._bid == 22 then
		for i=1,dd.soliders:rowCount() do
			local item = self:getChildByName("mainArea"):getChildByTag(dd.soliders:getLong(i,"soldierid"))
			if item ~= nil then
				item:getChildByName("count"):setString(dd.soliders:getLong(i,"hurtcount"))
			end	
		end
	else	
		for i=1,dd.myWall:rowCount() do
			local item = nil
			if dd.myWall:getLong(i,"wallid") == 100 then
				item = self:getChildByTag(100)
			else
				item = self:getChildByName("mainArea"):getChildByTag(dd.myWall:getLong(i,"wallid"))
			end	
			if item ~= nil then
				item:getChildByName("count"):setString(dd.myWall:getLong(i,"count"))
			end	
		end
	end	

	--重新编排位置
	self:onFrsh()
	self:getChildByName("mainArea"):scrollToTop(0.2,true)
	
    local function showHelp(sender,eventType)
        if eventType==ccui.TouchEventType.ended then  
            if self._bid == 22 then
            	cclog("hospitalHelp")
                pop.onShowPopDialog("hospitalHelp")
            elseif self._bid == 21 then
            	cclog("barrackHelp")
            	pop.onShowPopDialog("barrackHelp")    
            elseif self._bid == 5 then
                cclog("barrackHelp")
                pop.onShowPopDialog("buildHelp",self._bid,self._lv)      
            end
        end
    end
    self:getChildByName("info"):getChildByName("help"):addTouchEventListener(showHelp)
end

function barrackLayer.onSelectType( sender,eventType )
	if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("barrack")
        if widget ~= nil then
            widget._selectType = sender:getTag()
            widget:selectType()
        end
    end
end

function barrackLayer.onSelectType2( sender,eventType )
	if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("barrack")
        if widget ~= nil then
            widget._selectType2 = sender:getTag()
            widget:selectType2()
        end
    end
end

function barrackLayer.onFix( sender,eventType  )
	if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("barrack")
        if widget ~= nil then
            local point = math.floor((dd.getServerTime() - dd.myinfo:getLong(1,"LastCityFirmnessTime"))/60) + dd.myinfo:getLong(1,"CityFirmnessByTime")
			if point > dd.myinfo:getLong(1,"MaxCityFirmness") then
				point = dd.myinfo:getLong(1,"MaxCityFirmness")
			end
			local left = math.ceil((dd.myinfo:getLong(1,"MaxCityFirmness") - point) / 10)
			if left > 0 then
				local message = ff.net:createMessage()
			    message:addCmd(0x0000011d)
			    message:addLong(dd.uid)
			    message:addLong(1)
			    ff.net:rpc(message,false)
			end
        end
    end
end

function barrackLayer.onUp( sender,eventType   )
	if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("barrack")
        if widget ~= nil then
            local tag = sender:getTag()
            local message = ff.net:createMessage()
		    message:addCmd(0x00000150)
		    message:addLong(dd.uid)
		    message:addLong(tag)
		    ff.net:rpc(message,false)
        end
    end
end

function barrackLayer:selectType( sender)
	self:getChildByName("type"):getChildByName("type1"):getChildByName("Label_100"):setColor(cc.c3b(97,117,123))
    self:getChildByName("type"):getChildByName("type1"):setSelectedState(false)

    self:getChildByName("type"):getChildByName("type2"):getChildByName("Label_100"):setColor(cc.c3b(97,117,123))
    self:getChildByName("type"):getChildByName("type2"):setSelectedState(false)

    
    if self._selectType == 1 then
        self:getChildByName("type"):getChildByName("type1"):getChildByName("Label_100"):setColor(cc.c3b(233, 239, 244))
    elseif self._selectType == 2 then
        self:getChildByName("type"):getChildByName("type2"):getChildByName("Label_100"):setColor(cc.c3b(233, 239, 244))
    end
    if sender ~= nil then
        sender:setSelectedState(true)
    end
    if self._selectType == 1 then
    	self:getChildByName("types"):setVisible(true)
		self:getChildByName("mainArea"):setVisible(true)
		self:getChildByName("list"):setVisible(false)
		--self:getChildByName("tips1"):setVisible(false)
    else
    	self:getChildByName("types"):setVisible(false)
		self:getChildByName("mainArea"):setVisible(false)
		self:getChildByName("list"):setVisible(true)
		--self:getChildByName("tips1"):setVisible(true)
		local message = ff.net:createMessage()
	    message:addCmd(0x0000005d)
	    message:addLong(dd.uid)
	    ff.net:rpc(message,false)
    end
end

function barrackLayer:selectType2( sender)
	self:getChildByName("type1"):getChildByName("type1"):getChildByName("Label_100"):setColor(cc.c3b(97,117,123))
    self:getChildByName("type1"):getChildByName("type1"):setSelectedState(false)

    self:getChildByName("type1"):getChildByName("type2"):getChildByName("Label_100"):setColor(cc.c3b(97,117,123))
    self:getChildByName("type1"):getChildByName("type2"):getChildByName("Label_100_0"):setColor(cc.c3b(97,117,123))
    self:getChildByName("type1"):getChildByName("type2"):setSelectedState(false)

    
    if self._selectType2 == 1 then
        self:getChildByName("type1"):getChildByName("type1"):getChildByName("Label_100"):setColor(cc.c3b(233, 239, 244))
    elseif self._selectType2 == 2 then
        self:getChildByName("type1"):getChildByName("type2"):getChildByName("Label_100"):setColor(cc.c3b(233, 239, 244))
        self:getChildByName("type1"):getChildByName("type2"):getChildByName("Label_100_0"):setColor(cc.c3b(233, 239, 244))
    end
    if sender ~= nil then
        sender:setSelectedState(true)
    end
    if self._selectType2 == 1 then
    	self:getChildByName("types"):setVisible(true)
		self:getChildByName("mainArea"):setVisible(true)
		self:getChildByName("list"):setVisible(false)
		local item = self:getChildByTag(100)
		if item ~= nil then
			item:setVisible(true)
		end
		self:getChildByName("oper"):setVisible(false)
		--self:getChildByName("tips1"):setVisible(false)
    else
    	self:getChildByName("types"):setVisible(false)
		self:getChildByName("mainArea"):setVisible(false)
		self:getChildByName("list"):setVisible(true)
		local item = self:getChildByTag(100)
		if item ~= nil then
			item:setVisible(false)
		end
		self:getChildByName("oper"):setVisible(true)
		--self:getChildByName("tips1"):setVisible(true)
		local message = ff.net:createMessage()
	    message:addCmd(0x0000011d)
	    message:addLong(dd.uid)
	    message:addLong(0)
	    ff.net:rpc(message,false)
    end
end

function barrackLayer:onGetSoldierTech(  params)
	local code = params[1]
    if code == 0 then      
        if params[2] ~= nil then
        	self._info = params[2]
        	self:showList(params[2])
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function barrackLayer:onGetSoldierTechPromote(  params)
	local code = params[1]
    if code == 0 then      
        if params[2] ~= nil then
        	for i=1,4 do
        		if i == params[2]["type"] then
        			self._info[i]["level"] = params[2]["level"]
        			self._info[i]["point"] = params[2]["point"]
        			self._info[i]["attack"] = params[2]["attack"]
        			self._info[i]["hp"] = params[2]["hp"]
        			self._info[i]["needpoint"] = params[2]["needpoint"]
        			self._info[i]["nextattack"] = params[2]["nextattack"]
        			self._info[i]["nexthp"] = params[2]["nexthp"]
        			print(i,self._info[i]["level"],self._info[i]["level"],"-------------------")
           			self:showList(self._info)
        			break
        		end
        	end
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end



function barrackLayer:onCityFirmnessAction(  params)
	local code = params[1]
    if code == 0 then      
        self:showList()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function barrackLayer:updateCityFirmnessAction(  )
	local widget = pop.getDialog("barrack")
    if widget == nil then
        return
    end
	if widget._bid ~= 5 then
		return
	end

	local point = math.floor((dd.getServerTime() - dd.myinfo:getLong(1,"LastCityFirmnessTime"))/60) + dd.myinfo:getLong(1,"CityFirmnessByTime")
	if point > dd.myinfo:getLong(1,"MaxCityFirmness") then
		point = dd.myinfo:getLong(1,"MaxCityFirmness")
	end
	local per = (point/dd.myinfo:getLong(1,"MaxCityFirmness"))*100
	local  time  = dd.myinfo:getLong(1,"LastCityFirmnessTime") + (dd.myinfo:getLong(1,"MaxCityFirmness") - dd.myinfo:getLong(1,"CityFirmnessByTime")) * 60 - dd.getServerTime()
	local item = widget:getChildByName("list"):getChildByTag(1)
	if item ~= nil then
		
		item:getChildByName("tips"):setString(ff.langString("修复倒计时")..":"..ff.getLeftTime(time,":"))
		item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):setPercent(per)
		item:getChildByName("ProgressBar"):getChildByName("time"):setString(ff.langString("城防值")..":"..point.."/"..dd.myinfo:getLong(1,"MaxCityFirmness"))

	end
	local left = math.ceil((dd.myinfo:getLong(1,"MaxCityFirmness") - point) / 10)
	widget:getChildByName("oper"):getChildByName("join"):getChildByName("count"):setString(left)
	widget:getChildByName("type1"):getChildByName("type2"):getChildByName("Label_100_0"):setString("("..point.."/"..dd.myinfo:getLong(1,"MaxCityFirmness")..")")
end

function barrackLayer:showList( info )
	if self._bid == 5 then
		local item = self:getChildByName("list"):getChildByTag(1)
		if item == nil then
			item = self:getChildByName("chengfang"):clone()
			item:setVisible(true)
			
			local point = math.floor((dd.getServerTime() - dd.myinfo:getLong(1,"LastCityFirmnessTime"))/60) + dd.myinfo:getLong(1,"CityFirmnessByTime")
			if point > dd.myinfo:getLong(1,"MaxCityFirmness") then
				point = dd.myinfo:getLong(1,"MaxCityFirmness")
			end
			local per = (point/dd.myinfo:getLong(1,"MaxCityFirmness"))*100
			local  time  = (dd.myinfo:getLong(1,"MaxCityFirmness") - point) * 60
			item:getChildByName("tips"):setString(ff.langString("修复倒计时")..":"..ff.getLeftTime(time,":"))
			item:getChildByName("ProgressBar"):getChildByName("ProgressBar"):setPercent(per)
			item:getChildByName("ProgressBar"):getChildByName("time"):setString(ff.langString("城防值")..":"..point.."/"..dd.myinfo:getLong(1,"MaxCityFirmness"))
			item:setTag(1)
			self:getChildByName("list"):pushBackCustomItem(item)
		end
		local item2 = self:getChildByName("list"):getChildByTag(2)
		if item2 == nil then
			item2 = self:getChildByName("tips2"):clone()
			item2:setString(ff.langString("城防值随城墙等级提升而提高，守城战失败将损失城防值,城防值归0后，你的城市将“沦陷”，并被迁移到另一个随机位置。"))
			item2:setVisible(true)
			item2:setTag(2)
			self:getChildByName("list"):pushBackCustomItem(item2)

		end
	elseif self._bid == 21 then
		local item = self:getChildByName("list"):getChildByTag(5)
		if item == nil then
			item = self:getChildByName("tips1"):clone()
			item:setVisible(true)
			item:setTag(5)
			self:getChildByName("list"):pushBackCustomItem(item)

		end
		for i=1,4 do
			if info[i] ~= nil then
				local item = self:getChildByName("list"):getChildByTag(i)
				if item == nil then
					item = self:getChildByName("item1"):clone()
					self:getChildByName("list"):pushBackCustomItem(item)
				end
				item:setVisible(true)
				item:setTag(i)
				item:getChildByName("up"):setTag(i-1)
				local level = 0 
				local rank = 0
				if info[i]["level"] > 130 and info[i]["level"] <= 180  then
					level = info[i]["level"] - 50
					rank = 1
				elseif info[i]["level"] > 180 and info[i]["level"] <= 230  then
					level = info[i]["level"] - 100
					rank = 2
				elseif info[i]["level"] > 230 then
					level = info[i]["level"] - 150
					rank = 3
				else
					level = info[i]["level"]
				end
				if i == 1 then
					item:getChildByName("name"):setString(ff.langString("野战兵熟练度").." LV."..level)
					item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/skill/1082.png",0)
				elseif i == 3 then
					item:getChildByName("name"):setString(ff.langString("装甲车熟练度").." LV."..level)
					item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/skill/4033.png",0)
				elseif i == 2 then
					item:getChildByName("name"):setString(ff.langString("枪手熟练度").." LV."..level)
					item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/skill/2082.png",0)
				elseif i == 4 then
					item:getChildByName("name"):setString(ff.langString("攻城车熟练度").." LV."..level)
					item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/skill/1032.png",0)
				end
				item:getChildByName("up"):getChildByName("Label_128"):setString(ff.langString("升级"))
				item:getChildByName("rank"):setString(ff.langString("当前阶级").." LV."..rank)
				if (info[i]["level"] == 130 or info[i]["level"] == 180 or info[i]["level"] == 230) and info[i]["point"] >= info[i]["needpoint"] then
					item:getChildByName("up"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
					item:getChildByName("up"):setTouchEnabled(true)
				else
					local effect = ff.Effect:effectGrey()    
                    item:getChildByName("up"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
					item:getChildByName("up"):setTouchEnabled(false)
				end
				item:getChildByName("exp"):setString("Exp: "..info[i]["point"].."/"..info[i]["needpoint"])
				item:getChildByName("powertip"):setString(ff.langString("额外攻击+{0}%，额外生命+{0}%",{info[i]["attack"]/10,info[i]["hp"]/10}))
			end
		end
	end
	
end

function barrackLayer:onFrsh()
	self:getChildByName("tips"):setVisible(false)	
	local maxstep = 0
	local index = 1
	if self._bid == 22 then
		for i=1,dd.soliders:rowCount() do
			if dd.soliders:getLong(i,"hurtcount") > 0 then
				maxstep = maxstep + 1 
			end
		end
		maxstep = math.ceil(maxstep/3)
		cclog("maxstep:"..maxstep)

		local hh = dd.currentLayer._pop:getContentSize().height
		local hh = hh - 190 - 60 - 5
		if maxstep * 270 > hh then
			hh = maxstep * 270
		end

		local have = false
		for i=1,dd.soliders:rowCount() do
			local sid = dd.soliders:getLong(i,"soldierid")
			local hurtcount = dd.soliders:getLong(i,"hurtcount")
			local item = self:getChildByName("mainArea"):getChildByTag(sid)
			if item ~= nil then
				if hurtcount > 0 then
					local step = math.ceil(index/3)
					local type = index%3 
					if type == 0 then
						type = 3
					end
					local xx = 0
					local yy = 0
					if type == 1 then
						xx = 15
					elseif type == 2 then
						xx = 255
					else
						xx = 496
					end
					yy = hh - step * 270
					item:setPosition(cc.p(xx,yy))
					item:setVisible(true)
					have = true
					index = index + 1
				else
					item:setVisible(false)
				end
			end
		end
		if have == true then
			self:getChildByName("tips"):setVisible(false)	
		else
			self:getChildByName("tips"):setVisible(true)	
		end
		self:getChildByName("mainArea"):setInnerContainerSize(cc.size(720,hh))
	elseif self._bid == 21 then
		for sid,army in pairs(dd.cfgSoldier) do
			if dd.cfgSoldier[sid]['step'] > 6 then
				local item = self:getChildByName("mainArea"):getChildByTag(sid)
				if item ~= nil then
					item:setVisible(false)
				end
			end
		end
		self:getChildByName("mainArea"):setInnerContainerSize(cc.size(720,270 * 6))
	else
		self:getChildByName("tips"):setVisible(false)	
	end
end

function barrackLayer:updateView()
	cclog("updateView")
	--刷新兵数量

	local lists = self:getChildByName("mainArea")
	for sid,army in pairs(dd.cfgSoldier) do
		local item = lists:getChildByTag(sid)
		if item ~= nil then
			item:getChildByName("progress"):setVisible(false)
			item:getChildByName("clock"):setVisible(false)
			item:getChildByName("time"):setVisible(false)	
			item:getChildByName("count"):setString("0")
		end			
	end
	local item = self:getChildByTag(100)
	if item ~= nil then
		item:getChildByName("progress"):setVisible(false)
		item:getChildByName("clock"):setVisible(false)
		item:getChildByName("time"):setVisible(false)	
		item:getChildByName("count"):setString("0")
	end

	local have = false
	if self._bid == 5 then
		for i=1,dd.myWall:rowCount() do
			local id = dd.myWall:getLong(i,"wallid")
			local item = nil
			if id == 100 then
				item = self:getChildByTag(id)
			else	
				item = lists:getChildByTag(id)
			end	
			if item ~= nil then
				cclog("dd.myWall:"..id..","..dd.myWall:getLong(i,"count"))
				item:getChildByName("count"):setString(dd.myWall:getLong(i,"count"))
			end			
			if id == self._sid then
				if dd.myWall:getLong(i,"count") > 0 then
					have = true
				end
			end
		end	
	else
		for sid,army in pairs(dd.cfgSoldier) do
			local id = sid
			local item = lists:getChildByTag(id)
			if item ~= nil then
				if self._bid == 21 then
					local count = 0
					for i=1,dd.soliders:rowCount() do
						if dd.soliders:getLong(i,"soldierid") == sid then
							count = dd.soliders:getLong(i,"count")
							break
						end
					end
					for j=1,dd.myTroops:rowCount() do
						count = count + dd.myTroops:getLong(j,dd.cfgSoldierIndex[sid])
					end
					item:getChildByName("count"):setString(count)
				else	
					local count = 0
					for i=1,dd.soliders:rowCount() do
						if dd.soliders:getLong(i,"soldierid") == sid then
							count = dd.soliders:getLong(i,"hurtcount")
							break
						end
					end
					item:getChildByName("count"):setString(count)
				end	
			end	
			if id == self._sid then
				if self._bid == 21 then
					local count = 0
					for i=1,dd.soliders:rowCount() do
						if dd.soliders:getLong(i,"soldierid") == id then
							count = dd.soliders:getLong(i,"count")
							break
						end
					end					
					for j=1,dd.myTroops:rowCount() do
						count = count + dd.myTroops:getLong(j,dd.cfgSoldierIndex[id])
					end
					if count > 0 then
						have = true
					end
				elseif self._bid == 22 then
					for i=1,dd.soliders:rowCount() do
						if dd.soliders:getLong(i,"soldierid") == id then
							if dd.soliders:getLong(i,"hurtcount") > 0 then
								have = true
							end
							break
						end
					end						
				end				
			end
		end
	end

	if have == false then
		self._type = 1
	end	
	--设置最大最小
	self:setMaxMin()
	self:showQueDetail()
	cclog("self._sid:"..self._sid)
	if self._sid > 0 then		
		self:onMakeArmys(self._sid)
	end	
	if self._bid == 22 then
		for i=1,dd.soliders:rowCount() do
			if dd.soliders:getLong(i,"soldierid") == self._sid then
				if dd.soliders:getLong(i,"hurtcount")  == 0 then
			    	self:getChildByName("pop"):setVisible(false)
				end	
				break
			end
		end
	end
end

function barrackLayer:setMaxMin()
	local count = 0
	local str = ""
	if self._type == 1 then
		if self._bid == 21 then
			--str = "单次征兵上限"
			count = 10
			for i=1,dd.myeffect:rowCount() do
				if dd.myeffect:getLong(i,"id") == 14 then
					count = count + dd.myeffect:getLong(i,"param")
					break
				end
			end
			local armys = 0
			for i=1,dd.soliders:rowCount() do
				armys = armys + dd.soliders:getLong(i,"count")
			end
			for j=1,dd.myTroops:rowCount() do
				armys = armys + dd.myTroops:getLong(j,"b1")
				armys = armys + dd.myTroops:getLong(j,"b2")
				armys = armys + dd.myTroops:getLong(j,"b3")
				armys = armys + dd.myTroops:getLong(j,"b4")
				armys = armys + dd.myTroops:getLong(j,"b5")
				armys = armys + dd.myTroops:getLong(j,"b6")

				armys = armys + dd.myTroops:getLong(j,"q1")
				armys = armys + dd.myTroops:getLong(j,"q2")
				armys = armys + dd.myTroops:getLong(j,"q3")
				armys = armys + dd.myTroops:getLong(j,"q4")
				armys = armys + dd.myTroops:getLong(j,"q5")
				armys = armys + dd.myTroops:getLong(j,"q6")

				armys = armys + dd.myTroops:getLong(j,"g1")
				armys = armys + dd.myTroops:getLong(j,"g2")
				armys = armys + dd.myTroops:getLong(j,"g3")
				armys = armys + dd.myTroops:getLong(j,"g4")
				armys = armys + dd.myTroops:getLong(j,"g5")
				armys = armys + dd.myTroops:getLong(j,"g6")

			end								

			self:getChildByName("info"):getChildByName("tips"):setString(ff.langString("单次征兵上限")..":"..count)
		--医院	
		elseif self._bid == 22 then	
			for i=1,dd.myeffect:rowCount() do
				if dd.myeffect:getLong(i,"id") == 16 then
					count = dd.myeffect:getLong(i,"param")
					break
				end
			end
			local p1 = 0
			for i=1,dd.myeffect:rowCount() do
				if dd.myeffect:getLong(i,"id") == 405 then
					p1 = dd.myeffect:getLong(i,"param")
				end
			end
			count = math.floor(count * (1 + p1/1000))
			self:getChildByName("info"):getChildByName("tips"):setString(ff.langString("单次治疗上限").."："..count)
		elseif self._bid == 5 then	
			count = 10
			local addlv = 0
			local plus_45 = 0
			for i=1,dd.myeffect:rowCount() do
				if dd.myeffect:getLong(i,"id") == 15 then
					count = dd.myeffect:getLong(i,"param")
				end
				if dd.myeffect:getLong(i,"id") == 231 then
					addlv = dd.myeffect:getLong(i,"param")
				end
				if dd.myeffect:getLong(i,"id") == 45 then
					plus_45 = dd.myeffect:getLong(i,"param")
				end
			end
			count = math.floor(count * (1 + addlv/1000))

			local armys = 0
			for i=1,dd.myWall:rowCount() do
				armys = armys + dd.myWall:getLong(i,"count")
			end
			self:getChildByName("info"):getChildByName("tips"):setString(ff.langString("已有：{0} 建造上限：{1}",{armys,count}))
			--增加单次可造城防数量上限功能，增加到建筑表的城墙上的功能。plus_45 目前只有这一个地方配置了该效果，没有在其他地方配置
			if plus_45 > count - armys then
				count = count - armys
			else
				count = plus_45
			end
		end	

		self._max = count
		cclog("max:"..self._max)
		if self._bid == 22 then
			self._max = 0
			for i=1,dd.soliders:rowCount() do
				if dd.soliders:getLong(i,"soldierid") == self._sid then
					if dd.soliders:getLong(i,"hurtcount") < count then
						self._max = dd.soliders:getLong(i,"hurtcount")
					else
						self._max = count	
					end	
					break
				end
			end
		end
		if self._max == 0 then
			self._min = 0
		else
			self._min = 1
		end	
	else
		if self._bid == 21 then
			for i=1,dd.soliders:rowCount() do
				if dd.soliders:getLong(i,"soldierid") == self._sid then
					self._max = dd.soliders:getLong(i,"count")
					break
				end	
			end
		elseif self._bid == 22 then
			for i=1,dd.soliders:rowCount() do
				if dd.soliders:getLong(i,"soldierid") == self._sid then
					self._max = dd.soliders:getLong(i,"hurtcount")
					break
				end	
			end
		else			
			for i=1,dd.myWall:rowCount() do
				if dd.myWall:getLong(i,"wallid") == self._sid then
					self._max = dd.myWall:getLong(i,"count")
					break
				end	
			end
		end

		if self._max == 0 then
			self._min = 0
		else	
			self._min = 1
		end	
	end	
	cclog("setNum:"..self._max..","..self._min)
end
function barrackLayer:showQueDetail()
	local type = 3--兵营
	if self._bid == 5 then
		type = 4
		self.updateCityFirmnessAction()
		schedule(self,self.updateCityFirmnessAction,1)
	elseif self._bid == 22 then
		type = 9
	end		
	for i=1,dd.mylists:rowCount() do
		if dd.mylists:getLong(i,"type") == type then
			local sid = dd.mylists:getLong(i,"param1")
			local item = nil
			if sid == 100 then
				item = self:getChildByTag(sid)
			else	
				item = self:getChildByName("mainArea"):getChildByTag(sid)
			end	
			if item ~= nil then
				item:getChildByName("progress"):setVisible(true)
				item:getChildByName("clock"):setVisible(true)
				item:getChildByName("time"):setVisible(true)
			end
			self.showAction()
			schedule(self,self.showAction,1)
			return
		end
	end
end
function barrackLayer.showAction()
	local sender = pop.getDialog("barrack")
	if sender ~= nil then
		local type = 3
		if sender._bid == 22 then
			type = 9
		elseif sender._bid == 5 then
			type = 4
		end		

		for i=1,dd.mylists:rowCount() do
			if dd.mylists:getLong(i,"type") == type then
				local sid       = dd.mylists:getLong(i,"param1")
			    local starttime = dd.mylists:getLong(i,"start")
	    		local endtime   = dd.mylists:getLong(i,"end")
			    local curtime   = dd.getServerTime()
	    		local total     = endtime - starttime
			    if total == 0 then
			        return
			    end    
			    local now       = curtime - starttime
	    		local progress  = math.floor(now * 100 / total)
	    		if progress > 100 then
	        		progress = 100
	    		end
	    		if progress < 0 then
	        		progress = 0
	    		end

	    		local view = sender:getChildByName("pop"):getChildByName("view"):getChildByName("speed")
			    view:getChildByName("progress"):getChildByName("progress"):setPercent(progress)    
			    if now > total then
			        now = total
			    end    
			    view:getChildByName("time"):setString(ff.getLeftTime((total - now),":"))

			    local item = nil
			    if sid == 100 then
			    	item = sender:getChildByTag(100)
			    else	
				    item = sender:getChildByName("mainArea"):getChildByTag(sid)
				end    
			    if item ~= nil then
			    	item:getChildByName("progress"):setPercent(100 - progress)    
			    	item:getChildByName("time"):setString(ff.getLeftTime((total - now),":"))
			    end
			    if dd.mylists:getLong(i,"param3") == 1 then
				    if item ~= nil then
				    	item:getChildByName("progress"):setPercent(100)    
				    	item:getChildByName("time"):setString("00:00:00")
				    end			
				    view:getChildByName("progress"):getChildByName("progress"):setPercent(100)    
				    view:getChildByName("time"):setString("00:00:00")

					if sender._bid == 5 then
						view:getChildByName("tips"):setString(ff.langString("建造{0}个 {1} 已完成",{dd.mylists:getLong(i,"param2"),ff.langString(dd.cfgSoldier[dd.mylists:getLong(i,"param1")]['soldierName'])}))
						view:getChildByName("progress"):getChildByName("speedup"):getChildByName("chu_label"):setString(ff.langString("验收"))
					else
						view:getChildByName("tips"):setString(ff.langString("训练{0}名 {1} 已完成",{dd.mylists:getLong(i,"param2"),ff.langString(dd.cfgSoldier[dd.mylists:getLong(i,"param1")]['soldierName'])}))
						view:getChildByName("progress"):getChildByName("speedup"):getChildByName("chu_label"):setString(ff.langString("入伍"))
					end
					sender:stopAllActions()			
				    if (GuideControl.curId == 635 or GuideControl.curId == 638 or GuideControl.curId == 632) and GuideControl._curGuideLayer ~= nil then
				    	cclog("here............:"..GuideControl.curId)
				        GuideControl._curGuideLayer:checkDelay()
				        GuideControl:GuideCheck()
				    end			
				end
			    return
			end
		end
		sender:updateView()
		sender:stopAllActions()			
	end	
end

function barrackLayer.onQueuqArmyAction(params)
	cclog("onQueuqArmyAction")
	pop.getDialog("barrack"):onFrsh()
	pop.getDialog("barrack"):updateView()
	GuideControl:GuideCheck()
end
function barrackLayer.onArmyAction(params)
	local code = params[1]
	if code == 0 then
		pop.getDialog("barrack"):onFrsh()
		pop.getDialog("barrack"):updateView()
		local widget = pop.getDialog("barrack")
		if widget ~= nil then
			if widget._bid == 5 then
				AudioEngine.playEffect(ff.sounds[230])
			else
				AudioEngine.playEffect(ff.sounds[231])
				if params[2] ~= nil and params[2] == 12 then
					local sid = params[3]
					if dd.cityLayer ~= nil then
	                    dd.cityLayer:playArmysEffect(widget._pos,3,dd.cfgSoldier[sid]['type'])
					end
				end
			end
		end
        GuideControl:GuideCheck()  
	else
		dd.mainUI:onShowCodeTips(code)
	end
end

function barrackLayer.updateRes(params)
	if params[1] == 0 then
		pop.getDialog("barrack"):updateView()
	end
end

function barrackLayer.onStart(sender)
	
	

	sender:onInit()
	sender:showQueDetail()
end

function barrackLayer.onEnd(sender)
	sender:stopAllActions()
	if ff.platform ~= 1 then
		for sid,army in pairs(dd.cfgSoldier) do
			local item = nil
			if army['type'] == 10 then
				item = sender:getChildByTag(sid)
			else	
				item = sender:getChildByName("mainArea"):getChildByTag(tonumber(sid))
			end	
			if item ~= nil then
				item:getChildByName("person"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
			end
		end
	end
	sender:getChildByName("list"):removeAllChildren(true)
	sender:getChildByName("type"):setVisible(false)
	sender:getChildByName("list"):setVisible(false)
	sender._selectType = 1
	if sender:getChildByName("pop"):isVisible() == true then
		sender:getChildByName("pop"):setVisible(false)
	end	
	ff.net:removeEvent(2,dd.Tjf_Queue_ArmysAction)
	ff.net:removeEvent(2,dd.Tjf_Queue_WallAction)
	ff.net:removeEvent(2,dd.Tjf_Queue_HealsAction)
	ff.net:removeEvent(2,dd.Tjf_Queue_QueueAction)
	ff.net:removeEvent(2,dd.Tjf_GetSoldierTech)  
	ff.net:removeEvent(2,dd.Tjf_SoldierTechPromote)     
	ff.net:removeEvent(2,dd.Tjf_CityFirmnessAction)
	ff.net:removeEvent(113,dd.Tjf_prop_use)
	
	local help = nil
    if sender._bid == 22 then
         help = pop.getDialog("hospitalHelp")
    elseif sender._bid == 21 then
         help = pop.getDialog("barrackHelp") 
         ff.net:removeEvent(2,dd.Tjf_GetSoldierTech)     
    elseif sender._bid == 5 then
        help = pop.getDialog("buildHelp")   
    end
    if help ~= nil and help:isVisible() then
        help:setVisible(false)    
    end
end
function barrackLayer.onBefore(sender)
	local hh = dd.currentLayer._pop:getContentSize().height
	if sender._init == false then
		sender:setContentSize(cc.size(720,hh - 190))
		sender:getChildByName("info"):setPositionY(hh - 190 - 10 - 41)		
	end		
	cclog("sender._bid:"..sender._bid)
	sender:getChildByName("pop"):setVisible(false)
	
	ff.net:registerEvent(2,dd.Tjf_Queue_ArmysAction,sender.onArmyAction)
	ff.net:registerEvent(2,dd.Tjf_Queue_WallAction,sender.onArmyAction)
	ff.net:registerEvent(2,dd.Tjf_Queue_HealsAction,sender.onArmyAction)
	ff.net:registerEvent(2,dd.Tjf_Queue_QueueAction,sender.onQueuqArmyAction)
    ff.net:registerEvent(2,dd.Tjf_GetSoldierTech, function (message)sender:onGetSoldierTech(message)end)	
    ff.net:registerEvent(2,dd.Tjf_SoldierTechPromote, function (message)sender:onGetSoldierTechPromote(message)end)		
    ff.net:registerEvent(2,dd.Tjf_CityFirmnessAction, function (message)sender:onCityFirmnessAction(message)end)		

	ff.net:registerEvent(113,dd.Tjf_prop_use,sender.updateRes)
	--local message = ff.net:createMessage()
    --message:addCmd(0x0000005d)
    --message:addLong(dd.uid)
    --ff.net:rpc(message,false)
	return false
end

--建造特有虚函数
--返回true表示回到上级菜单，返回false表示暂时不回到上级菜单
function barrackLayer.onReturn(sender)
	if sender:getChildByName("pop"):isVisible() == true then
		sender.closePop(sender,ccui.TouchEventType.ended)
		return true
	else
		return false
	end		
end

function onShowBarrack(widget,pos,tid)
	local layer = barrackLayer.extend(widget)
	layer:setVisible(false)
	layer._type= 1
	layer._pos = pos
	for i=1,dd.mybuilds:rowCount() do
		if dd.mybuilds:getLong(i,"pos") == pos then
			layer._bid = dd.mybuilds:getLong(i,"bid")
            layer._lv = dd.mybuilds:getLong(i,"level")
			break
		end
	end
	return layer
end