--兵营，城墙，医院
local gcsLayer   = class("gcsLayer")
gcsLayer._name = "gcs"
gcsLayer._init = false
gcsLayer._pos  = 0
gcsLayer._bid  = 0
gcsLayer._lv  = 0
gcsLayer._sid  = 0
gcsLayer._min  = 0
gcsLayer._max  = 0
gcsLayer._edit = nil
gcsLayer._speed= 0
gcsLayer._step = 10
gcsLayer._type = 1
gcsLayer._res  = false
gcsLayer._info = {}
gcsLayer._tips = false

function gcsLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, gcsLayer)
    return target
end

function gcsLayer:onMakeArmys(sid)
	local view = self:getChildByName("pop"):getChildByName("view")
	view:getChildByName("icon"):loadTexture(dd.getArmyIcon(sid))
	view:getChildByName("base"):getChildByName("name"):setString(ff.langString(dd.cfgSoldier[sid]['soldierName']))


	view:getChildByName("icon1"):setVisible(false)
	view:getChildByName("icon2"):setVisible(false)
	view:getChildByName("icon3"):setVisible(false)
	view:getChildByName("icon4"):setVisible(false)
	view:getChildByName("icon5"):setVisible(false)
	view:getChildByName("label_1"):setVisible(false)
	view:getChildByName("label_2"):setVisible(false)
	view:getChildByName("label_3"):setVisible(false)
	view:getChildByName("label_4"):setVisible(false)
	view:getChildByName("label_5"):setVisible(false)

	if self._tips == false then
		view:getChildByName("icon2"):setVisible(true)
		view:getChildByName("icon4"):setVisible(true)
		view:getChildByName("icon5"):setVisible(true)
		view:getChildByName("label_2"):setVisible(true)
		view:getChildByName("label_4"):setVisible(true)
		view:getChildByName("label_5"):setVisible(true)

		if dd.myinfo:getLong(1,"level") <= 10 then
			view:getChildByName("icon5"):setPositionX(360)
			view:getChildByName("label_5"):setPositionX(360)
		elseif dd.myinfo:getLong(1,"level") <= 14 then
			view:getChildByName("icon1"):setVisible(true)
			view:getChildByName("label_1"):setVisible(true)
			view:getChildByName("icon5"):setPositionX(504)
			view:getChildByName("label_5"):setPositionX(504)
		else
			view:getChildByName("icon1"):setVisible(true)
			view:getChildByName("label_1"):setVisible(true)
			view:getChildByName("icon3"):setVisible(true)
			view:getChildByName("label_3"):setVisible(true)
			view:getChildByName("icon5"):setPositionX(648)
			view:getChildByName("label_5"):setPositionX(648)
		end


		view:getChildByName("detail"):setVisible(true)
		view:getChildByName("unlockInfo"):setVisible(false)
	else
		view:getChildByName("detail"):setVisible(false)
		view:getChildByName("unlockInfo"):setVisible(true)
		view:getChildByName("unlockInfo"):getChildByName("tip"):setString(ff.langString(self._tips))
		view:getChildByName("unlockInfo"):requestDoLayout()
	end

	local count = 0
	for i=1,dd.soliders:rowCount() do
		if dd.soliders:getLong(i,"soldierid") == sid then
			count = dd.soliders:getLong(i,"count")
			break
		end	
	end
	for j=1,dd.myTroops:rowCount() do
		count = count + dd.myTroops:getLong(j,dd.cfgSoldierIndex[sid])
	end


	if count > 0 then
		view:getChildByName("detail"):getChildByName("dismis"):setBright(true)
		view:getChildByName("detail"):getChildByName("dismis"):setTouchEnabled(true)
	else	
		view:getChildByName("detail"):getChildByName("dismis"):setBright(false)
		view:getChildByName("detail"):getChildByName("dismis"):setTouchEnabled(false)
	end


	--view:getChildByName("base"):getChildByName("count"):setString(count)
	view:getChildByName("base"):getChildByName("count"):setString(ff.langString("负载")..": "..dd.cfgSoldier[sid]['count'])
	view:getChildByName("base"):getChildByName("foodkeep"):setString(ff.langString("消耗总计")..": "..(dd.cfgSoldier[sid]['keepFood']/100).."/h")
	self._sid = sid
	self:setMaxMin()
	if (string.len(self._edit:getText()) == 0) or (self._max < tonumber(self._edit:getText())) or (tonumber(self._edit:getText()) <= 0)  then
		self:setNum(1)
		view:getChildByName("detail"):getChildByName("progress"):getChildByName("green"):setPercent(0)
	end
	--view:getChildByName("detail"):setVisible(true)
	view:getChildByName("speed"):setVisible(false)		


	local thetype = 11

	for i=1,dd.mylists:rowCount() do
		if dd.mylists:getLong(i,"type") == thetype and dd.mylists:getLong(i,"param1") == self._sid then
			view:getChildByName("detail"):setVisible(false)
			view:getChildByName("speed"):setVisible(true)		
			if dd.mylists:getLong(i,"param3") == 1 then
				view:getChildByName("speed"):getChildByName("tips"):setString(ff.langString("建造{0}台 {1} 已完成",{dd.mylists:getLong(i,"param2"),ff.langString(dd.cfgSoldier[dd.mylists:getLong(i,"param1")]['soldierName'])}))
				view:getChildByName("speed"):getChildByName("progress"):getChildByName("speedup"):getChildByName("chu_label"):setString(ff.langString("验收"))
			else
				view:getChildByName("speed"):getChildByName("tips"):setString(ff.langString("正在建造{0}台 {1}",{dd.mylists:getLong(i,"param2"),ff.langString(dd.cfgSoldier[dd.mylists:getLong(i,"param1")]['soldierName'])}))
				view:getChildByName("speed"):getChildByName("progress"):getChildByName("speedup"):getChildByName("chu_label"):setString(ff.langString("加速"))
			end
			break
		end
	end

	if self._type == 1 then
		--self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("dismis"):getChildByName("label"):setString(ff.langString("解散"))
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):setVisible(true)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):setVisible(true)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("dismissure"):setVisible(false)
		view:getChildByName("detail"):getChildByName("dismis"):getChildByName("label"):setString(ff.langString("拆除"))
	else		
		--self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("dismis"):getChildByName("label"):setString(ff.langString("训练"))
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):setVisible(false)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):setVisible(false)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("dismissure"):setVisible(true)
		view:getChildByName("detail"):getChildByName("dismis"):getChildByName("label"):setString(ff.langString("建造"))		
	end

	--基础信息
	view:getChildByName("tips"):setString(ff.langString(dd.cfgSoldier[sid]['tips']))
	local star = ""
	for i=1,6 do
		if i <= dd.cfgSoldier[sid]['atkstar'] then
			star = star.."0"
		else
			star = star.."1"
		end
	end
	view:getChildByName("info"):getChildByName("attack_label"):setString(star)
	star = ""
	for i=1,6 do
		if i <= dd.cfgSoldier[sid]['hpstar'] then
			star = star.."0"
		else
			star = star.."1"
		end
	end
	view:getChildByName("info"):getChildByName("hp_label"):setString(star)
	star = ""
	for i=1,6 do
		if i <= dd.cfgSoldier[sid]['spdstar'] then
			star = star.."0"
		else
			star = star.."1"
		end
	end
	view:getChildByName("info"):getChildByName("speed_label"):setString(star)

	local attackadd = 0
	local hpadd = 0
	local speedadd = 0

	if sid < 100 then
		local type = dd.cfgSoldier[sid]['type']%10
		if type == 1 then
			local plus_301 = 0
			local plus_521 = 0
			local plus_407 = 0
			local plus_321 = 0
			local plus_523 = 0
			local plus_409 = 0
			local plus_401 = 0
			for i=1,dd.myeffect:rowCount() do
				if dd.myeffect:getLong(i,"id") == 301 then
					plus_301 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 521 then
					plus_521 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 407 then
					plus_407 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 321 then
					plus_321 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 523 then
					plus_523 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 409 then
					plus_409 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 401 then
					plus_401 = dd.myeffect:getLong(i,"param")					
				end
			end
			attackadd = math.floor((plus_301/1000+plus_521/1000+plus_407/1000) * 100)
			hpadd     = math.floor((plus_321/1000+plus_523/1000+plus_409/1000) * 100)
			speedadd  = math.floor(plus_401/1000 * 100)
		elseif type ==2 then
			local plus_302 = 0
			local plus_521 = 0
			local plus_407 = 0
			local plus_322 = 0
			local plus_523 = 0
			local plus_409 = 0
			local plus_401 = 0
			local plus_402 = 0
			for i=1,dd.myeffect:rowCount() do
				if dd.myeffect:getLong(i,"id") == 302 then
					plus_302 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 521 then
					plus_521 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 407 then
					plus_407 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 322 then
					plus_322 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 523 then
					plus_523 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 409 then
					plus_409 = dd.myeffect:getLong(i,"param")
				end
			end
			attackadd = math.floor((plus_302/1000+plus_521/1000+plus_407/1000) * 100)
			hpadd     = math.floor((plus_322/1000+plus_523/1000+plus_409/1000) * 100)
			speedadd  = math.floor((plus_401/1000+plus_402/1000) * 100)
		else
			local plus_303 = 0
			local plus_521 = 0
			local plus_407 = 0
			local plus_323 = 0
			local plus_523 = 0
			local plus_409 = 0
			local plus_401 = 0
			local plus_402 = 0
			for i=1,dd.myeffect:rowCount() do
				if dd.myeffect:getLong(i,"id") == 303 then
					plus_302 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 521 then
					plus_521 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 407 then
					plus_407 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 323 then
					plus_322 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 523 then
					plus_523 = dd.myeffect:getLong(i,"param")
				elseif dd.myeffect:getLong(i,"id") == 409 then
					plus_409 = dd.myeffect:getLong(i,"param")
				end
			end
			attackadd = math.floor((plus_303/1000+plus_521/1000+plus_407/1000) * 100)
			hpadd     = math.floor((plus_323/1000+plus_523/1000+plus_409/1000) * 100)
			speedadd  = math.floor(plus_401/1000 * 100)
		end
	elseif sid == 100 then
		local plus_523 = 0
		local plus_409 = 0
		local plus_224 = 0
		local plus_200 = 0
		for i=1,dd.myeffect:rowCount() do
			if dd.myeffect:getLong(i,"id") == 523 then
				plus_523 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 409 then
				plus_409 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 224 then
				plus_224 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 200 then
				plus_200 = dd.myeffect:getLong(i,"param")
			end
		end
		hpadd     = math.floor((plus_409/1000+plus_224/1000+plus_200/1000+plus_523/1000) * 100)
	elseif dd.cfgSoldier[sid]['type'] == 11 then
		local plus_201 = 0
		local plus_521 = 0
		local plus_407 = 0
		local plus_225 = 0
		local plus_221 = 0
		local plus_409 = 0
		local plus_224 = 0
		local plus_523 = 0
		for i=1,dd.myeffect:rowCount() do
			if dd.myeffect:getLong(i,"id") == 201 then
				plus_201 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 521 then
				plus_521 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 407 then
				plus_407 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 225 then
				plus_225 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 221 then
				plus_221 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 409 then
				plus_409 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 224 then
				plus_224 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 523 then
				plus_523 = dd.myeffect:getLong(i,"param")
			end
		end
		attackadd = math.floor((plus_201/1000+plus_521/1000+plus_407/1000+plus_225/1000) * 100)
		hpadd     = math.floor((plus_221/1000+plus_409/1000+plus_224/1000+plus_523/1000) * 100)
	elseif dd.cfgSoldier[sid]['type'] == 12 then
		local plus_202 = 0
		local plus_521 = 0
		local plus_407 = 0
		local plus_225 = 0
		local plus_222 = 0
		local plus_409 = 0
		local plus_224 = 0
		local plus_523 = 0
		for i=1,dd.myeffect:rowCount() do
			if dd.myeffect:getLong(i,"id") == 202 then
				plus_202 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 521 then
				plus_521 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 407 then
				plus_407 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 225 then
				plus_225 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 222 then
				plus_222 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 409 then
				plus_409 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 224 then
				plus_224 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 523 then
				plus_523 = dd.myeffect:getLong(i,"param")
			end
		end
		attackadd = math.floor((plus_202/1000+plus_521/1000+plus_407/1000+plus_225/1000) * 100)
		hpadd     = math.floor((plus_222/1000+plus_409/1000+plus_224/1000+plus_523/1000) * 100)
	elseif dd.cfgSoldier[sid]['type'] == 13 then
		local plus_203 = 0
		local plus_521 = 0
		local plus_407 = 0
		local plus_225 = 0
		local plus_223= 0
		local plus_409 = 0
		local plus_224 = 0
		local plus_523 = 0
		for i=1,dd.myeffect:rowCount() do
			if dd.myeffect:getLong(i,"id") == 203 then
				plus_203 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 521 then
				plus_521 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 407 then
				plus_407 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 225 then
				plus_225 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 223 then
				plus_223 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 409 then
				plus_409 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 224 then
				plus_224 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 523 then
				plus_523 = dd.myeffect:getLong(i,"param")
			end
		end
		attackadd = math.floor((plus_203/1000+plus_521/1000+plus_407/1000+plus_225/1000) * 100)
		hpadd     = math.floor((plus_223/1000+plus_409/1000+plus_224/1000+plus_523/1000) * 100)
	else
		local plus_304 = 0
		local plus_521 = 0
		local plus_407 = 0
		local plus_324 = 0
		local plus_409 = 0
		local plus_523 = 0
		local plus_401 = 0
		--local plus_exp = 0
		--local plus_hp = 0
		for i=1,dd.myeffect:rowCount() do
			if dd.myeffect:getLong(i,"id") == 304 then
				plus_304 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 521 then
				plus_521 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 407 then
				plus_407 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 324 then
				plus_324 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 409 then
				plus_409 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 523 then
				plus_523 = dd.myeffect:getLong(i,"param")
			elseif dd.myeffect:getLong(i,"id") == 401 then
				plus_401 = dd.myeffect:getLong(i,"param")
			end
		end
		--if self._info[4] ~= nil then
		---	plus_exp = self._info[4]["attack"]
		--	plus_hp = self._info[4]["hp"]
		--end
		attackadd = math.floor((plus_304/1000+plus_521/1000+plus_407/1000) * 100)
		hpadd     = math.floor((plus_324/1000+plus_409/1000+ plus_523/1000) * 100)
		speedadd  = math.floor((plus_401/1000) * 100)
	end

	view:getChildByName("info"):getChildByName("attack_effect"):setString("+"..attackadd.."%")
	view:getChildByName("info"):getChildByName("hp_effect"):setString("+"..hpadd.."%")
	view:getChildByName("info"):getChildByName("speed_effect"):setString("+"..speedadd.."%")



	--view:getChildByName("detail"):getChildByName("progress"):getChildByName("green"):setPercent(0)
    view:getChildByName("close"):setTouchEnabled(true)

    
    if view:getPositionY() ~= 0 or self:getChildByName("pop"):isVisible() == false  then
        view:setPosition(cc.p(0,-view:getContentSize().height))
        self:getChildByName("pop"):setVisible(true)
        view:runAction(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,0))))
    else
    	view:stopAllActions()
    end		
end
function gcsLayer:setNum(count)
	if count > self._max then
		count = self._max
	end
	if count < self._min then
		count = self._min
	end

	if tonumber(self._edit:getText() == count) then
		return
	end

	if self._type == 1 then
		self._res = false
		local icon = nil
		local label= nil
		--石
		if dd.cfgSoldier[self._sid]['needStone'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon1")
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_1")
			
			if dd.stone() < dd.cfgSoldier[self._sid]['needStone'] * count then
				label:setColor(cc.c3b(255,0,0))
				self._res = true
			else	
				label:setColor(cc.c3b(139,155,160))
			end
			label:setString(dd.showKM(dd.cfgSoldier[self._sid]['needStone'] * count,4).."/"..dd.showKM(dd.stone(),4))
			--label:setString(dd.showKM(dd.stone(),4).."/"..dd.showKM(dd.cfgSoldier[self._sid]['needStone'] * count,4))
		else
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_1")
			label:setColor(cc.c3b(139,155,160))
			label:setString("0/"..dd.showKM(dd.stone(),4))						
			--label:setString(dd.showKM(dd.stone(),4).."/0")						
		end	
		--木
		if dd.cfgSoldier[self._sid]['needWood'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon2")
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_2")
			if dd.wood() < dd.cfgSoldier[self._sid]['needWood'] * count then
				label:setColor(cc.c3b(255,0,0))
				self._res = true
			else	
				label:setColor(cc.c3b(139,155,160))
			end
			label:setString(dd.showKM(dd.cfgSoldier[self._sid]['needWood'] * count,4).."/"..dd.showKM(dd.wood(),4))
			--label:setString(dd.showKM(dd.wood(),4).."/"..dd.showKM(dd.cfgSoldier[self._sid]['needWood'] * count,4))
		else
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_2")
			label:setColor(cc.c3b(139,155,160))
			label:setString("0/"..dd.showKM(dd.wood(),4))						
			--label:setString(dd.showKM(dd.wood(),4).."/0")						
		end	
		--钢
		if dd.cfgSoldier[self._sid]['needIron'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon3")
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_3")
			if dd.iron() < dd.cfgSoldier[self._sid]['needIron'] * count then
				label:setColor(cc.c3b(255,0,0))
				self._res = true
			else	
				label:setColor(cc.c3b(139,155,160))
			end
			label:setString(dd.showKM(dd.cfgSoldier[self._sid]['needIron'] * count,4).."/"..dd.showKM(dd.iron(),4))
			--label:setString(dd.showKM(dd.iron(),4).."/"..dd.showKM(dd.cfgSoldier[self._sid]['needIron'] * count,4))
		else			
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_3")
			label:setColor(cc.c3b(139,155,160))
			label:setString("0/"..dd.showKM(dd.iron(),4))						
			--label:setString(dd.showKM(dd.iron(),4).."/0")						
		end	
		--食
		if dd.cfgSoldier[self._sid]['needFood'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon4")
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_4")
			if dd.food() < dd.cfgSoldier[self._sid]['needFood'] * count then
				label:setColor(cc.c3b(255,0,0))
				self._res = true
			else	
				label:setColor(cc.c3b(139,155,160))
			end
			label:setString(dd.showKM(dd.cfgSoldier[self._sid]['needFood'] * count,4).."/"..dd.showKM(dd.food(),4))
			--label:setString(dd.showKM(dd.food(),4).."/"..dd.showKM(dd.cfgSoldier[self._sid]['needFood'] * count,4))
		else
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_4")
			label:setColor(cc.c3b(139,155,160))
			label:setString("0/"..dd.showKM(dd.food(),4))						
			--label:setString(dd.showKM(dd.food(),4).."/0")						
		end			
		--银子
		if dd.cfgSoldier[self._sid]['needWood'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon5")
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_5")

			if dd.silver() < dd.cfgSoldier[self._sid]['needSilver'] * count then
				label:setColor(cc.c3b(255,0,0))
				self._res = true
			else	
				label:setColor(cc.c3b(139,155,160))
			end
			label:setString(dd.showKM(dd.cfgSoldier[self._sid]['needSilver'] * count,4).."/"..dd.showKM(dd.silver(),4))
		else
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_5")
			label:setColor(cc.c3b(139,155,160))
			label:setString("0/"..dd.showKM(dd.silver(),4))						
			--label:setString(dd.showKM(dd.silver(),4).."/0")						
		end			

		if self._res == true then
			self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("progress"):getChildByName("green"):loadProgressBarTexture(dd.getPathFromUI("public/v2/progress_precent2.png",1))
		else		
			self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("progress"):getChildByName("green"):loadProgressBarTexture(dd.getPathFromUI("public/v2/progress_precent.png",1))
		end		
	end	
	self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("min"):setString(self._min)
	self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("max"):setString(self._max)

	self._edit:setText(count)

	local res_gold = 0
	if dd.stone() < dd.cfgSoldier[self._sid]['needStone'] * count then
		res_gold = (dd.cfgSoldier[self._sid]['needStone'] * count - dd.stone())/dd.stone_lv
	end
	if dd.wood() < dd.cfgSoldier[self._sid]['needWood'] * count then
		res_gold = res_gold + (dd.cfgSoldier[self._sid]['needWood'] * count - dd.wood())/dd.wood_lv
	end
	if dd.iron() < dd.cfgSoldier[self._sid]['needIron'] * count then
		res_gold = res_gold + (dd.cfgSoldier[self._sid]['needIron'] * count - dd.iron())/dd.iron_lv
	end
	if dd.food() < dd.cfgSoldier[self._sid]['needFood'] * count then
		res_gold = res_gold + (dd.cfgSoldier[self._sid]['needFood'] * count - dd.food())/dd.food_lv
	end
	if dd.silver() < dd.cfgSoldier[self._sid]['needSilver'] * count then
		res_gold = res_gold + (dd.cfgSoldier[self._sid]['needSilver'] * count - dd.silver())/dd.silver_lv
	end		
	--取整
	res_gold = math.ceil(res_gold)

	--计算黄金
	if self._type == 1 then
		local p1 = 0
		for i=1,dd.myeffect:rowCount() do
			if dd.myeffect:getLong(i,"id") == 732 then
				p1 = dd.myeffect:getLong(i,"param")
			end
		end
		local time = 0
		time = count * dd.cfgSoldier[self._sid]['needTime']
		local plus = (0.5*(1+p1/1000))
		time = time/plus
		time = math.ceil(time)

		local golds = dd.getRealGoodp(time,res_gold)
		--至少1金？
		if golds <= 0 then
			golds = 1
		end	

		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):getChildByName("count"):setString(golds)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):getChildByName("label"):setString(ff.langString("建造"))
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):getChildByName("label"):setString(ff.langString("立即完成"))
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):getChildByName("label"):getVirtualRenderer():enableBold(true)
	
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):getChildByName("label"):getVirtualRenderer():enableBold(true)
	
	else
		local index = 1
		local icon = nil
		local label= nil

		--钢
		if dd.cfgSoldier[self._sid]['needIron'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon"..index)
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_"..index)
			label:setString("0/"..dd.iron())
			index = index + 1
		end	
		--石
		if dd.cfgSoldier[self._sid]['needStone'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon"..index)
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_"..index)
			label:setString("0/"..dd.stone())
			index = index + 1
		end	
		--食
		if dd.cfgSoldier[self._sid]['needFood'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon"..index)
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_"..index)
			label:setString("0/"..dd.food())
			index = index + 1
		end			
		--木
		if dd.cfgSoldier[self._sid]['needWood'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon"..index)
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_"..index)
			label:setString("0/"..dd.wood())
			index = index + 1
		end	
		--银子
		if dd.cfgSoldier[self._sid]['needWood'] > 0 then
			icon  = self:getChildByName("pop"):getChildByName("view"):getChildByName("icon"..index)
			label = self:getChildByName("pop"):getChildByName("view"):getChildByName("label_"..index)
			label:setString("0/"..dd.silver())
			index = index + 1
		end			
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("progress"):getChildByName("green"):loadProgressBarTexture(dd.getPathFromUI("public/v2/progress_precent.png",1))
	end	

	local progress = math.ceil(count * 100 / self._max)
	self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("progress"):getChildByName("green"):setPercent(progress)
end
function gcsLayer.onSure(sender,eventType)
	if eventType==ccui.TouchEventType.ended then    
		if dd.currentLayer._widget:haveSameQue(11) == false then
			local build = pop.getDialog("gcs")
			if tonumber(build._edit:getText()) <= 0 then
				dd.currentLayer._widget:onShowTips("\t"..ff.langString("数量不能为0"))
			else
				if build ~= nil then
					local function sendMessage(type)
				        local message = ff.net:createMessage()
			        	message:addCmd(0x106)
				        message:addLong(dd.uid)
				        message:addLong(type)
				        message:addLong(build._sid)
				        message:addLong(tonumber(build._edit:getText()))
				        cclog("sid:"..build._sid)
				        ff.net:rpc(message,false)
				        AudioEngine.playEffect(ff.sounds["t001"])
					end
					local function backMessage()
						sendMessage(13)
					end
					if build._res == false then
						sendMessage(11)
				    else
				    	dd.currentLayer._widget:onShowBuyRes(11,build._sid,tonumber(build._edit:getText()),backMessage)
				    end    
			    end    
			end    
		else			
			dd.currentLayer._widget:onShowSameQue(11)
		end    
	end
end
function gcsLayer.onGoldSure(sender,eventType)
	if eventType==ccui.TouchEventType.ended then    
		local build = pop.getDialog("gcs")
		if build ~= nil then
			if tonumber(build._edit:getText()) <= 0 then
				dd.currentLayer._widget:onShowTips("\t"..ff.langString("数量不能为0"))
			else
		        local message = ff.net:createMessage()
	        	message:addCmd(0x106)
		        message:addLong(dd.uid)
		        message:addLong(12)
		        message:addLong(build._sid)
		        message:addLong(tonumber(build._edit:getText()))
		        ff.net:rpc(message,false)
		    end   
	    end    
	end
end
function gcsLayer.onSureDismis(sender,eventType)
	if eventType==ccui.TouchEventType.ended then    
		local build = pop.getDialog("gcs")
		if build ~= nil then
			if tonumber(build._edit:getText()) <= 0 then
				dd.currentLayer._widget:onShowTips("\t"..ff.langString("数量不能为0"))
			else
		        local message = ff.net:createMessage()
	        	message:addCmd(0x106)
		        message:addLong(dd.uid)
		        message:addLong(91)
		        message:addLong(build._sid)
		        message:addLong(tonumber(build._edit:getText()))
		        ff.net:rpc(message,false)
		    end    
	    end    
	end
end
function gcsLayer.onDismis(sender,eventType)
	if eventType==ccui.TouchEventType.ended then    
		local widget = pop.getDialog("gcs")
		if widget ~= nil then
			if widget._type == 1 then
				widget._type = 2
				widget:setMaxMin()
			else	
				widget._type = 1
				widget:setMaxMin()
			end
			widget:onMakeArmys(widget._sid)
		end
	end
end
function gcsLayer.onSub(sender,eventType)
	local build = pop.getDialog("gcs")
	local function subCount(flag)
		if build._speed == build._step or flag == true then
			if build ~= nil and build._edit ~= nil then		
				local count = tonumber(build._edit:getText())
				if count < build._min then
					count = build._min
					sender:stopAllActions()
				else
					count = count - 1				
				end	
				if count == nil or count == "" then
					count = build._min
				end
				build:setNum(count)	
				build._speed = 0
				build._step  = build._step - 1
				if build._step < 1 then
					build._step = 1
				end	
			end
		end
		build._speed = build._speed + 1	
	end
	if eventType==ccui.TouchEventType.began then   
		build._speed = 0
		schedule(sender,subCount,0.01)	
	elseif eventType==ccui.TouchEventType.ended then   
		subCount(true)
		build._speed = 0
		build._step  = 10
		sender:stopAllActions()	
	elseif eventType == ccui.TouchEventType.canceled then
		build._speed = 0
		build._step  = 10
		sender:stopAllActions()	
	end
end
function gcsLayer.onAdd(sender,eventType)
	local build = pop.getDialog("gcs")
	local function addCount(flag)
		if build._speed == build._step or flag == true then
			if build ~= nil and build._edit ~= nil then		
				local count = tonumber(build._edit:getText())
				if count > build._max then
					count = build._max
					sender:stopAllActions()
				else
					count = count + 1				
				end	
				if count == nil or count == "" then
					count = build._max
				end				
				build:setNum(count)	
				build._speed = 0
				build._step  = build._step - 1
				if build._step < 1 then
					build._step = 1
				end	
			end
		end
		build._speed = build._speed + 1	
	end
	if eventType==ccui.TouchEventType.began then   
		build._speed = 0
		schedule(sender,addCount,0.01)	
	elseif eventType==ccui.TouchEventType.ended then   
		addCount(true)
		build._speed = 0
		build._step  = 10
		sender:stopAllActions()	
	elseif eventType == ccui.TouchEventType.canceled then
		build._speed = 0
		build._step  = 10
		sender:stopAllActions()	
	end
end

function gcsLayer.onSpeedup(sender,eventType)
	local function speedUp()
		if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
	        local message = ff.net:createMessage()
	        message:addCmd(0x00000104)
	        message:addLong(dd.uid)
	        message:addLong(8)
	        message:addLong(0)
	        message:addLong(11)
	        ff.net:rpc(message,false)
	        AudioEngine.playEffect(ff.sounds[231])
		end	
	end

	if eventType==ccui.TouchEventType.ended then  
		if dd.currentLayer ~= nil then
			local build = pop.getDialog("gcs")
			for i=1,dd.mylists:rowCount() do
				if dd.mylists:getLong(i,"type") == 11 and dd.mylists:getLong(i,"param3") == 1 then
				    local message = ff.net:createMessage()
				    message:addCmd(0x00000104)
				    message:addLong(dd.uid)
				    message:addLong(7)
				    message:addLong(build._pos)
				    message:addLong(11)
				    ff.net:postMessage(message)   
				    AudioEngine.playEffect(ff.sounds[231])   
					return
				end
			end
			dd.currentLayer._widget:onShowBuyTime(11,speedUp)
		end	
	end	
end
function gcsLayer.onStop(sender,eventType)
	if eventType==ccui.TouchEventType.ended then   
		for i=1,dd.mylists:rowCount() do
			if dd.mylists:getLong(i,"type") == 11 and dd.mylists:getLong(i,"param3") == 1 then
				return
			end
		end
		local function callback(  )
	        local message = ff.net:createMessage()
	        message:addCmd(0x104)
	        message:addLong(dd.uid)
	        message:addLong(9)
	        message:addLong(0)
	        message:addLong(11)
	        ff.net:rpc(message,false)
	    end
		dd.currentLayer._widget:onShowSure(ff.langString("训练取消确认"),ff.langString("您确认要取消本次操作吗？\n取消训练不会返还任何资源"),callback,true,2)

	end
end

function gcsLayer:selectArmy(sid)
	local item = nil
	if sid == 100 then
		item = self:getChildByTag(sid)
	else	
		item = self:getChildByName("mainArea"):getChildByTag(sid)
	end	
	if item ~= nil then		
		if dd.cfgSoldier[sid]['canBuild'] == 0 then
			dd.currentLayer._widget:onShowTips("\t"..ff.langString("据说不能造，这里直接打开老虎机"))
		else
			self._sid = sid
			self._type= 1
			if item:getChildByName("lock"):isVisible() == true then
				local army = dd.cfgSoldier[sid]
		        local tid = dd.cfgTecLv[army['conditions']]['tec_id']
		        self._tips = ff.langString("需要科技").." "..ff.langString(dd.cfgTec[tid]['tec_name'])
			else	
				self._tips = false
			end
			self:setNum(1)
			self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("progress"):getChildByName("green"):setPercent(0)
			self:onMakeArmys(self._sid)
		end	
	end
end
function gcsLayer.closePop(sender,eventType)
    local function unShow()
    	local widget = pop.getDialog("gcs")
    	widget:getChildByName("pop"):setVisible(false)
		for i,item in ipairs(widget:getChildByName("mainArea"):getChildren()) do
			item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/v2/select_normal.png",1))
		end	    	
    end    

	if eventType==ccui.TouchEventType.ended then   
		local widget = pop.getDialog("gcs") 
		if widget ~= nil then
			widget._type = 1
			widget:setMaxMin()
			unShow()

		end	        				
	end
end 

function gcsLayer:onInit()
	local function selectArmy(sender,eventType)
		local doaction = false
	    if eventType == ccui.TouchEventType.canceled then
	        local startp = sender:getTouchBeganPosition()
	        local endp   = sender:getTouchEndPosition()
	        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
				--sender:setSelectedState(true)
	        	doaction = true
	        end
	    end

		if eventType==ccui.TouchEventType.ended then    
			doaction = true
		end
		if doaction == true then
			local sid = sender:getTag()
			for i,item in ipairs(self:getChildByName("mainArea"):getChildren()) do
				item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/v2/select_normal.png",1))
			end	
			sender:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/v2/select_on.png",1))
			self:selectArmy(sid)
		end
	end
	function sliderEvent( ref, eventType )
	    if eventType == ccui.SliderEventType.percentChanged then
	        local percent = ref:getPercent()
	        local curNum = math.ceil(percent / 100 * self._max)
	        self:setNum(curNum)
	    end
	end


	if self._init == false then
		local rows = ff.dbmanager:sql_fetch_rows("select `step`,`type`,`soldierid`,`canbuild` from cfg_soldier where `type`=21 ORDER BY `step` ASC")
		local maxstep = rows:rowCount()

		for i=1,rows:rowCount() do
			local item = self:getChildByName("item"):clone()
			item:setTag(tonumber(rows:getString(i,"soldierid")))
			item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))

			local step = tonumber(rows:getString(i,"step"))
			local star = ""
			for j=1,step do
				star = star.."0"
			end
			item:getChildByName("star"):getChildByName("label"):setString(star)
			self:getChildByName("mainArea"):addChild(item)
			item:setTouchEnabled(true)
			item:setVisible(true)
			item:addTouchEventListener(selectArmy)
		end	
		rows:clear()


		--输入
        local size = self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("input"):getChildByName("count"):getContentSize()
        local editBox = dd.addEditBox(
             self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("input")
            , size
            , "images/ui/alpha.png"
            , 11
            , cc.p(0,0.5)
            , cc.p(self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("input"):getChildByName("count"):getPosition())
            , cc.c3b(255,255,255)
            , 20
            , 2
            , 4
            , 1
            , 5
            , true
            , true
            , true
        )
        local function editBoxTextEventHandle(strEventName,pSender)
            local edit = pSender
            local strFmt 
            if strEventName == "began" then
            elseif strEventName == "ended" or strEventName == "return" then
                local text=edit:getText()
                if text == nil or text == "" then
                	self:setNum(0)
                else
                	self:setNum(tonumber(text))
                end
            elseif strEventName == "changed" then
            end
        end
        self._edit = editBox
        editBox:registerScriptEditBoxHandler(editBoxTextEventHandle)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.closePop)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("progress"):getChildByName("green"):addEventListener(sliderEvent)

		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sure"):addTouchEventListener(self.onSure)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("unlockInfo"):getChildByName("gotec"):addTouchEventListener(self.onGoTec)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("goldsure"):addTouchEventListener(self.onGoldSure)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("dismis"):addTouchEventListener(self.onDismis)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("dismissure"):addTouchEventListener(self.onSureDismis)
		

		self:getChildByName("pop"):getChildByName("view"):getChildByName("speed"):getChildByName("progress"):getChildByName("stop"):addTouchEventListener(self.onStop)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("speed"):getChildByName("progress"):getChildByName("speedup"):addTouchEventListener(self.onSpeedup)

		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("sub"):addTouchEventListener(self.onSub)
		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("add"):addTouchEventListener(self.onAdd)

		self:getChildByName("pop"):getChildByName("view"):getChildByName("detail"):getChildByName("progress"):getChildByName("green"):setCorrect(35,320)
	end

	self:setMaxMin()

	for sid,army in pairs(dd.cfgSoldier) do
		local item = self:getChildByName("mainArea"):getChildByTag(tonumber(sid))
		if item ~= nil then
			item:getChildByName("clock"):setVisible(false)
			item:getChildByName("time"):setVisible(false)
			item:getChildByName("progress"):setVisible(false)
			item:getChildByName("count"):getChildByName("label"):setString(0)
			item:getChildByName("lock"):setVisible(true)
			item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/gcs/"..sid..".png",0)
			item:setVisible(true)
			item:setTouchEnabled(true)

			if army['conditions'] > 0 then
				for i=1,dd.myTec:rowCount() do
					if (dd.myTec:getLong(i,"tec_id")*100 + dd.myTec:getLong(i,"lv")) == army['conditions'] then
						item:getChildByName("lock"):setVisible(false)
					end
				end
			else
				item:getChildByName("lock"):setVisible(false)
			end
		end
	end
	for sid,army in pairs(dd.cfgSoldier) do
		local item = self:getChildByName("mainArea"):getChildByTag(sid)
		if item ~= nil then
			local count = 0
			for i=1,dd.soliders:rowCount() do
				if dd.soliders:getLong(i,"soldierid") == sid then
					count = dd.soliders:getLong(i,"count")
					break
				end
			end
			for j=1,dd.myTroops:rowCount() do
				count = count + dd.myTroops:getLong(j,dd.cfgSoldierIndex[sid])
			end
			item:getChildByName("count"):getChildByName("label"):setString(count)
		end
	end

	self:getChildByName("mainArea"):scrollToTop(0.2,true)
    local function showHelp(sender,eventType)
        if eventType==ccui.TouchEventType.ended then    
            pop.onShowPopDialog("buildHelp",self._bid,self._lv)
        end
    end
    self:getChildByName("info"):getChildByName("help"):addTouchEventListener(showHelp)
end
function gcsLayer.onGoTec(sender,eventType)
	if eventType==ccui.TouchEventType.ended then    
		local build = pop.getDialog("gcs")
		if build._sid > 0 then
			local army = dd.cfgSoldier[build._sid]
        	local tid = dd.cfgTecLv[army['conditions']]['tec_id']
			for i=1,dd.mybuilds:rowCount() do
	            if dd.mybuilds:getLong(i,"bid") == 11 then
	            	onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"),nil,tid)
	            	build.closePop(build:getChildByName("pop"):getChildByName("view"):getChildByName("close"),ccui.TouchEventType.ended)
	                break
	            end
	        end
	    end
	end
end
function gcsLayer:updateView()
	local lists = self:getChildByName("mainArea")
	for sid,army in pairs(dd.cfgSoldier) do
		local item = lists:getChildByTag(sid)
		if item ~= nil then
			item:getChildByName("progress"):setVisible(false)
			item:getChildByName("clock"):setVisible(false)
			item:getChildByName("time"):setVisible(false)	
			item:getChildByName("count"):getChildByName("label"):setString("0")
		end			
	end

	local have = false
	for sid,army in pairs(dd.cfgSoldier) do
		local item = lists:getChildByTag(sid)
		local count = 0
		if item ~= nil then
			for i=1,dd.soliders:rowCount() do
				if sid == dd.soliders:getLong(i,"soldierid") then
					count = dd.soliders:getLong(i,"count")
				
					break
				end
			end
			for j=1,dd.myTroops:rowCount() do
				
				count = count + dd.myTroops:getLong(j,dd.cfgSoldierIndex[sid])
			end
			item:getChildByName("count"):getChildByName("label"):setString(count)
		end
		if id == self._sid then
			if count > 0 then
				have = true
			end
		end
	end

	if have == false then
		self._type = 1
	end	
	--设置最大最小
	self:setMaxMin()
	self:showQueDetail()
	cclog("self._sid:"..self._sid)
	if self._sid > 0 then		
		self:onMakeArmys(self._sid)
	end	
end

function gcsLayer:setMaxMin()
	local count = 0
	local plus_46 = 0
	if self._type == 1 then
		count = 10

		for i=1,dd.myeffect:rowCount() do
			if dd.myeffect:getLong(i,"id") == 14 then
				count = count + dd.myeffect:getLong(i,"param")
			end
			if dd.myeffect:getLong(i,"id") == 46 then
				plus_46 =dd.myeffect:getLong(i,"param")
			end
		end

		local armys = 0

		for m=201,204 do
			for i=1,dd.soliders:rowCount() do
				if dd.soliders:getLong(i,"soldierid") == m then
					armys = armys + dd.soliders:getLong(i,"count")

					break
				end
			end

			for j=1,dd.myTroops:rowCount() do

				armys = armys + dd.myTroops:getLong(j,dd.cfgSoldierIndex[m])
			end
		end

		self._max = plus_46 - armys
		if self._max > count then
			self._max = count
		end
		if self._max == 0 then
			self._min = 0
		else
			self._min = 1
		end	
		self:getChildByName("info"):getChildByName("tips"):setString(ff.langString("已有：{0} 建造上限：{1}",{armys,plus_46}))

		--self:getChildByName("info"):getChildByName("tips"):setString(ff.langString("单次建造：{0} 总建造上限：{1}",{count,plus_46}))
	else
		for i=1,dd.soliders:rowCount() do
			if dd.soliders:getLong(i,"soldierid") == self._sid then
				self._max = dd.soliders:getLong(i,"count")
				break
			end	
		end
		if self._max == 0 then
			self._min = 0
		else	
			self._min = 1
		end	
	end	
	cclog("setNum:"..self._max..","..self._min)
end
function gcsLayer:showQueDetail()
	local type = 11
	for i=1,dd.mylists:rowCount() do
		if dd.mylists:getLong(i,"type") == type then
			local sid = dd.mylists:getLong(i,"param1")
			local item = self:getChildByName("mainArea"):getChildByTag(sid)
			if item ~= nil then
				item:getChildByName("progress"):setVisible(true)
				item:getChildByName("clock"):setVisible(true)
				item:getChildByName("time"):setVisible(true)
			end
			self.showAction()
			schedule(self,self.showAction,1)
			return
		end
	end
end
function gcsLayer.showAction()
	local sender = pop.getDialog("gcs")
	if sender ~= nil then
		local type = 11
		for i=1,dd.mylists:rowCount() do
			cclog(dd.mylists:getLong(i,"type"))
			if dd.mylists:getLong(i,"type") == type then
				local sid       = dd.mylists:getLong(i,"param1")
			    local starttime = dd.mylists:getLong(i,"start")
	    		local endtime   = dd.mylists:getLong(i,"end")
			    local curtime   = dd.getServerTime()
	    		local total     = endtime - starttime
			    if total == 0 then
			        return
			    end    
			    local now       = curtime - starttime
	    		local progress  = math.floor(now * 100 / total)
	    		if progress > 100 then
	        		progress = 100
	    		end
	    		if progress < 0 then
	        		progress = 0
	    		end

	    		local view = sender:getChildByName("pop"):getChildByName("view"):getChildByName("speed")
	    		view:getChildByName("progress"):getChildByName("progress"):setPercent(progress)    
			    if now > total then
			        now = total
			    end    
			    view:getChildByName("time"):setString(ff.getLeftTime((total - now),":"))

			    local item = nil
			    if sid == 100 then
			    	item = sender:getChildByTag(100)
			    else	
				    item = sender:getChildByName("mainArea"):getChildByTag(sid)
				end    
			    if item ~= nil then
			    	item:getChildByName("progress"):setPercent(100 - progress)    
			    	item:getChildByName("time"):setString(ff.getLeftTime((total - now),":"))
			    end

			    if dd.mylists:getLong(i,"param3") == 1 then
				    if item ~= nil then
				    	item:getChildByName("progress"):setPercent(100)    
				    	item:getChildByName("time"):setString("00:00:00")
				    end			
				    view:getChildByName("progress"):getChildByName("progress"):setPercent(100)    
				    view:getChildByName("time"):setString("00:00:00")

					view:getChildByName("tips"):setString(ff.langString("建造{0}个 {1} 已完成",{dd.mylists:getLong(i,"param2"),ff.langString(dd.cfgSoldier[dd.mylists:getLong(i,"param1")]['soldierName'])}))
					view:getChildByName("progress"):getChildByName("speedup"):getChildByName("chu_label"):setString(ff.langString("验收"))
					sender:stopAllActions()			
				end			    
			    return
			end
		end
		sender:updateView()
		sender:stopAllActions()			
	end	
end

function gcsLayer.onQueuqArmyAction(params)
	pop.getDialog("gcs"):updateView()
end
function gcsLayer.onArmyAction(params)
	local code = params[1]
	if code == 0 then
		local widget = pop.getDialog("gcs")
		if widget ~= nil then
			widget:updateView()
			AudioEngine.playEffect(ff.sounds[231])
			if params[2] ~= nil and params[2] == 12 then
				if dd.cityLayer ~= nil then
					local sid = params[3]
		            dd.cityLayer:playArmysEffect(widget._pos,1,dd.cfgSoldier[sid]['type'])
				end		
			end
		end
	else
		dd.mainUI:onShowCodeTips(code)
	end
end
function gcsLayer.updateRes(params)
	if params[1] == 0 then
		pop.getDialog("gcs"):updateView()
	end
end
function gcsLayer.onStart(sender)
	

end

function gcsLayer:onGetSoldierTech(  params)
	local code = params[1]
    if code == 0 then      
        if params[2] ~= nil then
        	self._info = params[2]
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function gcsLayer.onEnd(sender)
	if ff.platform ~= 1 then
		for sid,army in pairs(dd.cfgSoldier) do
			local item = sender:getChildByName("mainArea"):getChildByTag(tonumber(sid))
			if item ~= nil then
				item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/v2/select_normal.png",1))
				item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
			end
		end
	end

	if sender:getChildByName("pop"):isVisible() == true then
		sender:getChildByName("pop"):setVisible(false)
		
	end	
	ff.net:removeEvent(3,dd.Tjf_Queue_ArmysAction)
	ff.net:removeEvent(3,dd.Tjf_Queue_QueueAction)
	ff.net:removeEvent(114,dd.Tjf_prop_use)
	ff.net:removeEvent(2,dd.Tjf_GetSoldierTech)     


    local help = pop.getDialog("buildHelp")
    if help ~= nil and help:isVisible() then
        help:setVisible(false)    
    end
end
function gcsLayer.onBefore(sender)
	local hh = dd.currentLayer._pop:getContentSize().height
	if sender._init == false then
		sender:setContentSize(cc.size(720,hh - 184))
		sender:getChildByName("info"):setPositionY(hh - 184 - 5 - 38)
		sender:getChildByName("mainArea"):setContentSize(cc.size(720,hh - 184 - 50 - 4))
		sender:getChildByName("mainArea"):setPositionY(4)
		sender._init = true
	end	

	cclog("sender._bid:"..sender._bid)

	sender:getChildByName("pop"):setVisible(false)
	sender:showQueDetail()
	ff.net:registerEvent(3,dd.Tjf_Queue_ArmysAction,sender.onArmyAction)
	ff.net:registerEvent(3,dd.Tjf_Queue_QueueAction,sender.onQueuqArmyAction)
	ff.net:registerEvent(114,dd.Tjf_prop_use,sender.updateRes)
	ff.net:registerEvent(2,dd.Tjf_GetSoldierTech, function (message)sender:onGetSoldierTech(message)end)
	local message = ff.net:createMessage()
    message:addCmd(0x0000005d)
    message:addLong(dd.uid)
    ff.net:rpc(message,false)
	return false
end

--建造特有虚函数
--返回true表示回到上级菜单，返回false表示暂时不回到上级菜单
function gcsLayer.onReturn(sender)
	if sender:getChildByName("pop"):isVisible() == true then
		sender.closePop(sender,ccui.TouchEventType.ended)
		return true
	else
		return false
	end		
end

function onShowGCS(widget,pos,tid)
	local layer = gcsLayer.extend(widget)
	layer:setVisible(false)
	layer._type= 1
	layer._pos = pos
	for i=1,dd.mybuilds:rowCount() do
		if dd.mybuilds:getLong(i,"pos") == pos then
			layer._bid = dd.mybuilds:getLong(i,"bid")
            layer._lv = dd.mybuilds:getLong(i,"level")
			break
		end
	end	

	layer:onInit()
	return layer
end