--司令部升级
local cityUpLayer   = class("cityUpLayer")
cityUpLayer._name = "cityUp"
cityUpLayer._init = false
cityUpLayer.flash = nil
function cityUpLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, cityUpLayer)
    return target
end
function cityUpLayer:onInit()
    if self._init == false then
        local function onClose(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:onClose()
                pop.onClosePopDialog("cityUp")
            end
        end
        local function onSure(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if GuideControl.curId == 800 then
                    if dd.cityLayer ~= nil and dd.cityLayer._pop ~= nil and dd.cityLayer._pop._upgrade ~= nil then
                        if dd.cityLayer._pop._upgrade:isVisible() == true then
                            GuideControl.curId = 795
                            dd.mainUI:queShow(dd.mainUI:getQueIndex(),false)
                        end
                    end
                elseif GuideControl.curId == 5060 then    
                    if dd.cityLayer ~= nil and dd.cityLayer._pop ~= nil and dd.cityLayer._pop._upgrade ~= nil then
                        if dd.cityLayer._pop._upgrade:isVisible() == true then
                            if dd.buildingListWidget and dd.buildingListWidget:isVisible() then
                                GuideControl.curId = 5050
                            else
                                GuideControl.curId = 5045
                            end                              
                            --GuideControl.curId = 5050
                            dd.mainUI:queShow(dd.mainUI:getQueIndex(),false)
                        end
                    end
                end
                self:onClose()
                pop.onClosePopDialog("cityUp")
            end
        end
        local function onShare(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
            end
        end
        self:getChildByName("mask"):addTouchEventListener(onClose)
        self:getChildByName("view"):getChildByName("close"):addTouchEventListener(onClose)
        self:getChildByName("view"):getChildByName("sure_btn"):addTouchEventListener(onSure)
--        self:getChildByName("view"):getChildByName("share_btn"):addTouchEventListener(onShare)
        local function onTouchBegan(touch, event)
            self:unShowTips()
            return false
        end
        local listener = cc.EventListenerTouchOneByOne:create()
        listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
        listener:setSwallowTouches(true)
        self:getChildByName("touch"):getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self:getChildByName("touch"))

        self._init = true
    end
    local lv = dd.myinfo:getLong(1,"level")
    self:getChildByName("view"):getChildByName("topArea"):getChildByName("title_bg"):getChildByName("chu_lv_text"):setString("LV."..(lv-1).." — ".."LV."..lv)
    local info = ff.dbmanager:sql_fetch_rows("select * from cfg_citylv where lv="..lv)
    local info_lv = ff.dbmanager:sql_fetch_rows("select * from cfg_citylv where lv="..(lv-1))
    self:getChildByName("view"):getChildByName("middle"):getChildByName("tip_bg"):getChildByName("chu_left_text"):setString(ff.langString("你获得了升级奖励，价值{0}",{info:getString(1,'gift')}))
    local width = self:getChildByName("view"):getChildByName("middle"):getChildByName("tip_bg"):getChildByName("chu_left_text"):getContentSize().width
    self:getChildByName("view"):getChildByName("middle"):getChildByName("tip_bg"):getChildByName("icon"):setPositionX(width + 25)
    
    self:getChildByName("view"):getChildByName("topArea"):getChildByName("info"):getChildByName("seq_text"):setString(dd.cfgBuildingUp[1][lv-1]['value2'])
    self:getChildByName("view"):getChildByName("topArea"):getChildByName("info"):getChildByName("num_text"):setString(dd.showKM(dd.cfgBuildingUp[1][lv-1]['value1'],5))
    self:getChildByName("view"):getChildByName("topArea"):getChildByName("info"):getChildByName("area_text"):setString(info_lv:getString(1,'field'))
    self:getChildByName("view"):getChildByName("topArea"):getChildByName("info"):getChildByName("limit_text"):setString(info_lv:getString(1,'herolv'))

    self:getChildByName("view"):getChildByName("topArea"):getChildByName("info"):getChildByName("seq_text_0"):setString(dd.cfgBuildingUp[1][lv]['value2'])
    self:getChildByName("view"):getChildByName("topArea"):getChildByName("info"):getChildByName("num_text_0"):setString(dd.showKM(dd.cfgBuildingUp[1][lv]['value1'],5))
    self:getChildByName("view"):getChildByName("topArea"):getChildByName("info"):getChildByName("area_text_0"):setString(info:getString(1,'field'))
    self:getChildByName("view"):getChildByName("topArea"):getChildByName("info"):getChildByName("limit_text_0"):setString(info:getString(1,'herolv'))

    if tonumber(info:getString(1,'pic')) > 0 then   
        self:getChildByName("view"):getChildByName("topArea"):getChildByName("up_icon"):loadTexture("images/icon/cityUp/"..info:getString(1,'pic')..".png",0)
        self:getChildByName("view"):getChildByName("topArea"):getChildByName("up_text"):setString(ff.langString(tonumber(info:getString(1,'tips_lan'))))       
    else
        self:getChildByName("view"):getChildByName("topArea"):getChildByName("up_icon"):loadTexture(dd.getPathFromUI("img01_lvup.png",1))
        self:getChildByName("view"):getChildByName("topArea"):getChildByName("up_text"):setString(ff.langString("每次提升司令部等级都将获得礼品").."!")      
    end
    self:getChildByName("view"):getChildByName("topArea"):getChildByName("info"):requestDoLayout()
    if info ~= nil then
        info:clear()
        info = nil
    end
    if info_lv ~= nil then
        info_lv:clear()
        info_lv = nil
    end
end

function cityUpLayer:initGift(lv)
    local layer = self:getChildByName("view"):getChildByName("gift_con")
    layer:removeAllChildren()
    cclog("rews:"..dd.cfgBuildingUp[1][lv]['rews'])
    local giftInfo = Split(dd.cfgBuildingUp[1][lv]['rews'],'|')
    local layerSize = layer:getContentSize()
    layer:setInnerContainerSize(cc.size(layerSize.width,layerSize.height))
    local size = self:getChildByName("view"):getChildByName("giftItem"):getContentSize()
    local shang = math.modf(table.getn(giftInfo)/5)
    local yu = table.getn(giftInfo)%5
    if yu > 0 then
        shang = shang + 1
    end
    local panelWidth = layerSize.width
    if shang >= 2 then
        panelWidth = panelWidth + (table.getn(giftInfo) - 5) * 144
        layer:setInnerContainerSize(cc.size(panelWidth,layerSize.height))
    end
    for key, var in pairs(giftInfo) do
        local item = self:getChildByName("view"):getChildByName("giftItem"):clone()
        local sprite = sp.SkeletonAnimation:create("images/pve/PveAnimation/zhuchengshengji.json", "images/pve/PveAnimation/zhuchengshengji.atlas")
        sprite:setPosition(cc.p(70, 70))
        sprite:setAnimation(0, "Guangquan_animation", true)
        item:getChildByName("tool_bg"):addChild(sprite)
        local gift = Split(var,'%^')
        if gift[1] == '1' then
            item:getChildByName("tool_bg"):getChildByName("icon"):loadTexture(dd.getToolsIcon(tonumber(gift[2])),0)
            item:getChildByName("tool_bg"):getChildByName("icon"):setContentSize(cc.size(121,121))
        elseif gift[1] == '2' then--油
            item:getChildByName("tool_bg"):getChildByName("icon"):loadTexture('images/icon/res/ic01_bk.png',0)
        elseif gift[1] == '3' then--木
            item:getChildByName("tool_bg"):getChildByName("icon"):loadTexture('images/icon/res/ic02_bk.png',0)
        elseif gift[1] == '4' then--铁
            item:getChildByName("tool_bg"):getChildByName("icon"):loadTexture('images/icon/res/ic03_bk.png',0)
        elseif gift[1] == '5' then--粮
            item:getChildByName("tool_bg"):getChildByName("icon"):loadTexture('images/icon/res/ic04_bk.png',0)
        elseif gift[1] == '6' then--银
            item:getChildByName("tool_bg"):getChildByName("icon"):loadTexture('images/icon/res/ic05_bk.png',0)
        elseif gift[1] == '7' then--金币
            item:getChildByName("tool_bg"):getChildByName("icon"):loadTexture('images/icon/charge/gold.png',0)
            item:getChildByName("tool_bg"):getChildByName("icon"):setContentSize(cc.size(121,121))
        end
        item:getChildByName("num_bg"):getChildByName("num_text"):setString(dd.showKM(tonumber(gift[3]),6))
        item:setVisible(true)
        item.type = tonumber(gift[1])
        item.id = tonumber(gift[2])
        item.num = tonumber(gift[3])
        item:setTag(key)
        item:addTouchEventListener(self.onBlock)
        layer:addChild(item)
    end
end
function cityUpLayer.onBlock(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("cityUp")
        local main = widget      
        local anr   = sender:getAnchorPoint()--cc.p(0,0)
        local size  = sender:getContentSize()--size(140,170)
        local p = sender:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
        local np = main:convertToNodeSpace(p)

        if np.x <150 then
            widget:showTips(0.1,np.x,np.y,sender)
        elseif np.x > 550 then
            widget:showTips(0.9,np.x,np.y,sender)
        else
            widget:showTips(0.5,np.x,np.y,sender)
        end
    end
end

function cityUpLayer:showTips(anp,posx,posy,sender)
    local tips = self:getChildByName("tips")
    local id = sender.id
    tips:setAnchorPoint(cc.p(anp,0))
    tips:getChildByName("tip"):getVirtualRenderer():setDimensions(350,0)
    tips:getChildByName("tip"):setAnchorPoint(cc.p(anp,0))
    tips:getChildByName("tip"):setPosition(cc.p(anp*350+8,10))
    if sender.type == 1 then
        tips:getChildByName("flag"):setPosition(cc.p(anp*360,-10))
    else
        tips:getChildByName("flag"):setPosition(cc.p(anp*180,-10))
    end
    posx = posx + 70
    posy = posy + 120
    tips:setVisible(true)  
    tips:setPositionX(posx)
    tips:setPositionY(posy)
    local str = ""    
    local scolor = 1
    local resStr = {"","石油","木材","钢铁","粮食","银币"}
    tips:getChildByName("tip"):setString("")

    if sender.type == 1 then
        str = str..ff.langString(dd.cfgProp[id]['name'],{dd.cfgProp[id]['name1_lan']}).."\n"
        str = str..ff.langString(dd.cfgProp[id]['tips'],{dd.cfgProp[id]['tips1_lan']})
        scolor = dd.cfgProp[id]['color']
    else
        str = ff.langString(resStr[sender.type]).."+"..dd.showKM(sender.num,6)
    end 

    tips:removeChildByTag(101)    
    local richText = ccui.RichText:create()
    richText:ignoreContentAdaptWithSize(false)
    richText:setContentSize(cc.size(340,600))    
    richText:setAutoHeight()
    local chat = ccui.RichElementText:create(1, self.getColor(scolor), 255, str, "Helvetica", 20)
    richText:insertElement(chat,0)
    richText:formatText()
    local size = richText:getContentSize()
    richText:setPosition(cc.p(175,size.height/2 + 10))
    if sender.type == 1 then
        tips:setContentSize(cc.size(360,size.height + 20))
    else
        tips:setContentSize(cc.size(180,size.height + 20))
    end
    tips:addChild(richText,0,101)
end

function cityUpLayer.getColor(color)
    local colorcode = cc.c3b(196,213,214)
    if color == 1 then
        colorcode = cc.c3b(196,213,214)
    elseif color == 2 then
        colorcode = cc.c3b(75,137,81)
    elseif color == 3 then
        colorcode = cc.c3b(63,116,160)
    elseif color == 4 then
        colorcode = cc.c3b(164,80,151)
    elseif color == 5 then
        colorcode = cc.c3b(255,250,106)
    else
        colorcode = cc.c3b(196,213,214)
    end
    return colorcode
end
function cityUpLayer:unShowTips()
    self:getChildByName("tips"):setVisible(false)
end
--界面显示后调用
function cityUpLayer.onStart(sender)
    local sprite = sp.SkeletonAnimation:create("images/pve/PVEshengli.json", "images/pve/PVEshengli.atlas")
    sprite:setPosition(cc.p(250, 278))
    sprite:setAnimation(0, "PVEshengli_animation", true)
    sender:getChildByName("view"):addChild(sprite, 1)
    sender.flash = sprite
    sender:initGift(dd.myinfo:getLong(1,"level"))
    local function fun()
        sender:playDropAct()
    end
end
--界面关闭效果结束后调用
function cityUpLayer.onEnd(sender) 
    dd.delBackEvent()
    sender:getChildByName("view"):getChildByName("gift_con"):removeAllChildren()
    if sender.flash ~= nil then
        sender:getChildByName("view"):removeChild(sender.flash)
        sender.flash = nil
    end
    if dd.getTableLen(dd.openGameStar) > 0 and dd.myinfo:getLong(1,"level") >= dd.openGameStar['lv'] and dd.openGameStar['isget']==false then
         if ff.platform ~= 1 then
            pop.onShowPopDialog("gameStar")
        end
    end
    dd.joinUnionShowEx = false
end
--界面即将播放显示缓动时调用，返回false界面显示将终止
function cityUpLayer.onBefore(sender)
    if sender._init == false then
        local hh = ff.height
        sender:setContentSize(cc.size(720,hh))
        sender:getChildByName("touch"):setContentSize(cc.size(720,hh))
        sender:getChildByName("mask"):setContentSize(cc.size(720,hh))
    end
    sender:onInit()
    dd.joinUnionShowEx = true
    return true
end
function cityUpLayer:onClose()
    self:playDropAct()
    return false
end
function cityUpLayer:playDropAct()
    --屏蔽就注释以下代码
    local endPos = cc.p(200,100)
    local giftInfo = Split(dd.cfgBuildingUp[1][dd.myinfo:getLong(1,"level")]['rews'],'|')
    local count = table.getn(giftInfo)
    local num   = count
    if count > 10 then
        num = 10
        count = 10
    end
    for i=1,num do
        local item = self:getChildByName("view"):getChildByName("gift_con"):getChildByTag(i)
        if item ~= nil then
            local icon = item:getChildByName("tool_bg"):getChildByName("icon"):clone()
            local pos  = item:getChildByName("tool_bg"):getChildByName("icon"):convertToWorldSpace(cc.p(0.5 * 101,0.5 * 82))
            dd.mainUI:getChildByName("effect"):addChild(icon)
            icon:setPosition(cc.p(pos.x,pos.y))
            local moveup  = cc.EaseExponentialOut:create( cc.MoveTo:create(0.1, cc.p(pos.x,pos.y + 30)) )
            --local movedown = cc.MoveTo:create(0.8,endPos)
            local movedown = cc.EaseExponentialIn:create(cc.MoveTo:create(0.8,endPos))
            local seq  = cc.Sequence:create(cc.DelayTime:create(0.5),cc.FadeOut:create(0.3))
            local spaw = cc.Spawn:create(movedown,seq)
            local sequence = cc.Sequence:create(moveup,spaw,cc.RemoveSelf:create())
            icon:runAction(sequence)
        end 
        count = count - 1
    end
end
function cityUpLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("cityUp")
        if widget~=nil and widget:onClose() == false then
            pop.onClosePopDialog("cityUp")
        end    
    end
end
function onShowCityUp(widget)
    local layer = cityUpLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    return layer
end