--宝库
local embassyLayer   = class("embassyLayer")
embassyLayer._name = "embassyLayer"
embassyLayer._init = false
embassyLayer._pos  = 0
embassyLayer._bid  = 0
embassyLayer._lv  = 0
embassyLayer.enforceInfo = {}
embassyLayer._effect = false
embassyLayer.ifAllBack = false --是否是全部遣返
embassyLayer.enforceMax = 0
function embassyLayer:onInit()
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"pos") == self._pos then
            self._bid = dd.mybuilds:getLong(i,"bid")
            self._lv = dd.mybuilds:getLong(i,"level")
            break
        end
    end
    if self._lv == 0 then
        self._lv = 1 --刚建造的时候按照1级的数据处理
    end
    
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,hh - 190 - 214))
        self:getChildByName("bar"):setPosition(cc.p(2,hh - 190 - 214 - 51))
        self:getChildByName("mainArea"):setContentSize(cc.size(720,hh - 190 - 214 - 90 - 60))
        self:getChildByName("mainArea"):setPositionY(93)
        self:getChildByName("chu_notice_text"):setPosition(cc.p(360,(hh - 190 - 214)/2))
        self:getChildByName("armyItem"):requestDoLayout()
        self.pop = self:getChildByName('pop')
        self.baseSize = self:getChildByName("mainArea"):getContentSize()
        self.baseItemSize = self:getChildByName("armyItem"):getContentSize()
        local x,y = self:getChildByName("mainArea"):getPosition()
        self.basePos = cc.p(x,y)        
        self.popBaseSize = self.pop:getChildByName("popArea"):getChildByName("popArea"):getContentSize()
        self.popBaseItemSize = self.pop:getChildByName("popItem"):getContentSize()
        local x,y = self.pop:getChildByName("popArea"):getChildByName("popArea"):getPosition()
        self.popBasePos = cc.p(x,y)
        local function checkArmyInfo(sender,eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end
            if eventType == ccui.TouchEventType.ended then
                doaction = true
            end
            if doaction == true then                     
                if self.pop:getPositionY() ~= 0 or self.pop:isVisible() == false  then
                    self.pop:setVisible(true)
                    self.pop:getChildByName("send_back_btn"):setTag(sender:getTag()-1)
                    self:onShowPop(sender:getTag()-1)
                else
                    self.pop:stopAllActions()
                end 
            end
        end
        local function disbandArmy(sender,eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end
            if eventType == ccui.TouchEventType.ended then
                doaction = true
            end
            if doaction == true then                
                local id = sender:getTag()
                local message = ff.net:createMessage()
                message:addCmd(0x00000127)
                message:addLong(dd.uid)
                message:addLong(id)
                ff.net:rpc(message,false)
            end
        end
        local armyItem = self:getChildByName("armyItem")
        armyItem:getChildByName("check_btn"):addTouchEventListener(checkArmyInfo)
        local function sendAllBack(sender,eventType)
            if eventType==ccui.TouchEventType.ended then   
                self.ifAllBack = true
                for key, var in pairs(self.enforceInfo) do
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000127)
                    message:addLong(dd.uid)
                    message:addLong(var['troopID'])
                    ff.net:postMessage(message)
                end
            end
        end
        self:getChildByName("send_back_btn"):addTouchEventListener(sendAllBack)
        
        self.pop:getChildByName("close"):addTouchEventListener(self.closePop)
        self.pop:addTouchEventListener(self.closePop)
        local function sendBackArmy(sender,eventType)
            if eventType==ccui.TouchEventType.ended then   
                local id = sender:getTag()
                local message = ff.net:createMessage()
                message:addCmd(0x00000127)
                message:addLong(dd.uid)
                message:addLong(id)
                ff.net:rpc(message,false)
            end
        end
        self.pop:getChildByName("send_back_btn"):addTouchEventListener(sendBackArmy)
        
        local function showHelp(sender,eventType)
            if eventType==ccui.TouchEventType.ended then  
                pop.onShowPopDialog("embassy_help")
            end
        end
        self:getChildByName("bar"):getChildByName("help_14"):addTouchEventListener(showHelp)
        self._init = true
    end
    ff.net:registerEvent(1,dd.Tjf_GetMyReinforceInfo,function (message)self:backReinforceInfo(message)end)
    ff.net:registerEvent(1,dd.Tjf_ReinforceSendBack,function (message)self:backReinforceSend(message)end)
    self:getChildByName("mainArea"):scrollToTop(0.01,false)
end
function embassyLayer.closePop(sender,eventType)
    local function unShow()
        local widget = pop.getDialog("embassy")
        widget:getChildByName("pop"):setVisible(false)
        widget.pop:getChildByName("popArea"):getChildByName("popArea"):removeAllChildren()
    end    

    if eventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("embassy") 
        if widget ~= nil then
            unShow()
        end                         
    end
end
function embassyLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, embassyLayer)
    return target
end

function embassyLayer.softFun(d1, d2)
    local ret = dd.biger(d1["star"], d2["star"])
    if ret == 0 then
        ret = dd.biger(d1["type"], d2["type"])
        if ret == 0 then            
           ret = false
        end
    end
    return not ret
end
function embassyLayer:autoSizePop(shang)
    if shang > 2 then
        shang = 2
    end
    self.pop:getChildByName("pop_bg"):setContentSize(cc.size(720,770 - (2 - shang) * 287))
    self.pop:getChildByName("pop_bg"):setPositionY(0)
    self.pop:getChildByName("popArea"):setContentSize(cc.size(720,shang * 287 + 2))
    self.pop:getChildByName("popArea"):getChildByName("back"):setContentSize(cc.size(720,shang * 287 + 2))
    self.pop:getChildByName("popArea"):getChildByName("back"):setPositionY(shang * 287/2 + 1)
    self.pop:getChildByName("popArea"):getChildByName("popArea"):setContentSize(cc.size(720,shang * 287 ))
    self.pop:getChildByName("popArea"):getChildByName("popArea"):setInnerContainerSize(cc.size(720,shang * 287))
    self.pop:getChildByName("popArea"):getChildByName("popArea"):setPositionY(1)
    self.pop:getChildByName("top"):setPositionY(770 - (2 - shang) * 287 - 8)
    self.pop:getChildByName("close"):setPositionY(770 - (2 - shang) * 287 - 8 - 13)
    self.pop:getChildByName("chu_name_text"):setPositionY(770 - (2 - shang) * 287 - 14)
end
function embassyLayer:onShowPop(id)
    for key, var in pairs(self.enforceInfo) do
    	if var['troopID'] == id then
            local area = self.pop:getChildByName("popArea"):getChildByName("popArea")
            local size = self.pop:getChildByName("popItem"):getContentSize()
            local posX = area:getPositionX()
            local posY = area:getPositionY()
            local conSize = area:getContentSize()
            
            local len = 0 
            local troop = {}
            for k, v in pairs(var) do
                local parts = Split(k,'_')
                if table.getn(parts) == 2 then
                    if tonumber(parts[2]) ~= nil and v > 0 then
                        len = len + 1
                        troop[len] = {}
                        troop[len]['star'] = tonumber(parts[2])
                        if parts[1] == "bu" then
                            troop[len]['type'] = 1
                            troop[len]['tip'] = "b"
                        elseif parts[1] == "qi" then
                            troop[len]['type'] = 2
                            troop[len]['tip'] = "q"
                        elseif parts[1] == "gong" then
                            troop[len]['type'] = 3
                            troop[len]['tip'] = "g"
                        elseif parts[1] == "tou" then
                            troop[len]['type'] = 21
                            troop[len]['tip'] = "w"
                        end
                        troop[len]['num'] = v
                    end
                end
            end 
            table.sort(troop, self.softFun)
            local shang = math.modf(len/3)
            local yu = len%3
            if yu > 0 then
                shang = shang + 1
            end
            self:autoSizePop(shang)

            local panelHeight = shang * (self.popBaseItemSize.height + 63)
            area:setInnerContainerSize(cc.size(self.popBaseSize.width,panelHeight))
            local yOff = 165
            if shang >= 2 then
                yOff = 155
            end

            area:removeAllChildren()
            local index = 1
            for skey, value in pairs(troop) do
                local armItem = self.pop:getChildByName("popItem"):clone()
                local sid = tonumber(ff.dbmanager:sql_fetch_one_cell("select soldierid from cfg_soldier where tip2='"..value['tip']..value['star'].."'"))
                
                if value['type'] <= 3 then
                    armItem:getChildByName("item_icon"):loadTexture(dd.getArmyIcon(sid),0)
                elseif value['type'] == 21 then
                    sid = 201
                    armItem:getChildByName("item_icon"):loadTexture("images/icon/gcs/"..sid..".png",0)
                end
                armItem:getChildByName("item_icon"):loadTexture(dd.getArmyIcon(sid),0)
                armItem:getChildByName("item_icon"):getVirtualRenderer()
                armItem:getChildByName("num_bg"):getChildByName("num_text"):setString(ff.getFormatMoney(value['num']))
                
                local step = value['star']
                local item = armItem:getChildByName("star_bg")
                for j=1,step do
                    local star = nil
                    if j == 1 then
                        star = item:getChildByName("star_icon")
                    else
                        star = item:getChildByName("star_icon"):clone()
                        item:addChild(star)
                    end
                    local xx = (230-(step * 31))/2 + (j - 1)*31 + 6
                    star:setPosition(cc.p(xx,20))    
                end

                armItem:setVisible(true)
                local shang = math.modf((index-1)/3)
                local yu = (index-1)%3
                local x = 125 + 235 * yu
                local y = panelHeight - 280 * (shang+1) + yOff

                armItem:setPosition(cc.p(x,y))
                self.pop:getChildByName("popArea"):getChildByName("popArea"):addChild(armItem)
                index = index + 1
            end
            self.pop:getChildByName("chu_name_text"):setString(ff.langString("{0}的军队",{var['user_name']}))
            break
        end
   end
end

function embassyLayer:getReinforceInfo()
    local message = ff.net:createMessage()
    message:addCmd(0x0000001c)
    message:addLong(dd.uid)
    ff.net:rpc(message,false)
end
function embassyLayer:backReinforceInfo(message)
    local ret = message[1]
    if ret == 0 then
        for var=1, message[2]:rowCount() do
            local key = table.getn(self.enforceInfo) + 1
            self.enforceInfo[key] = {}
            self.enforceInfo[key]['troopID'] = message[2]:getLong(var,'troopID')
            self.enforceInfo[key]['user_id'] = message[2]:getLong(var,'user_id')
            self.enforceInfo[key]['user_name'] = message[2]:getString(var,'user_name')
            self.enforceInfo[key]['user_pic'] = message[2]:getLong(var,'user_pic')
            self.enforceInfo[key]['hero_name'] = message[2]:getString(var,'hero_name')
            self.enforceInfo[key]['hero_gid'] = message[2]:getLong(var,'hero_gid')
            self.enforceInfo[key]['hero_lv'] = message[2]:getLong(var,'hero_lv')

            self.enforceInfo[key]['bu_1'] = message[2]:getLong(var,'bu_1')
            self.enforceInfo[key]['bu_2'] = message[2]:getLong(var,'bu_2')
            self.enforceInfo[key]['bu_3'] = message[2]:getLong(var,'bu_3')
            self.enforceInfo[key]['bu_4'] = message[2]:getLong(var,'bu_4')
            self.enforceInfo[key]['bu_5'] = message[2]:getLong(var,'bu_5')
            self.enforceInfo[key]['bu_6'] = message[2]:getLong(var,'bu_6')

            self.enforceInfo[key]['qi_1'] = message[2]:getLong(var,'qi_1')
            self.enforceInfo[key]['qi_2'] = message[2]:getLong(var,'qi_2')
            self.enforceInfo[key]['qi_3'] = message[2]:getLong(var,'qi_3')
            self.enforceInfo[key]['qi_4'] = message[2]:getLong(var,'qi_4')
            self.enforceInfo[key]['qi_5'] = message[2]:getLong(var,'qi_5')
            self.enforceInfo[key]['qi_6'] = message[2]:getLong(var,'qi_6')
            
            self.enforceInfo[key]['gong_1'] = message[2]:getLong(var,'gong_1')
            self.enforceInfo[key]['gong_2'] = message[2]:getLong(var,'gong_2')
            self.enforceInfo[key]['gong_3'] = message[2]:getLong(var,'gong_3')
            self.enforceInfo[key]['gong_4'] = message[2]:getLong(var,'gong_4')
            self.enforceInfo[key]['gong_5'] = message[2]:getLong(var,'gong_5')
            self.enforceInfo[key]['gong_6'] = message[2]:getLong(var,'gong_6')
            
            self.enforceInfo[key]['tou_1'] = message[2]:getLong(var,'tou_1')
            self.enforceInfo[key]['tou_2'] = message[2]:getLong(var,'tou_2')
            self.enforceInfo[key]['tou_3'] = message[2]:getLong(var,'tou_3')
            self.enforceInfo[key]['tou_4'] = message[2]:getLong(var,'tou_4')
            self.enforceInfo[key]['tou_5'] = message[2]:getLong(var,'tou_5')
            self.enforceInfo[key]['tou_6'] = message[2]:getLong(var,'tou_6')
            
            self.enforceInfo[key]["jue_1_num"] = message[2]:getLong(var,'shushiid')
            self.enforceInfo[key]["jue_1_lv"] = message[2]:getLong(var,'shushilevel')
            self.enforceInfo[key]["jue_2_num"] = message[2]:getLong(var,'baoliu1')
            self.enforceInfo[key]["jue_2_lv"] = message[2]:getLong(var,'baoliu2')
            self.enforceInfo[key]["jue_3_num"] = message[2]:getLong(var,'baoliu3')
            self.enforceInfo[key]["jue_3_lv"] = message[2]:getLong(var,'baoliu4')
            self.enforceInfo[key]["start"] = message[2]:getLong(var,'start')
            self.enforceInfo[key]["end"] = message[2]:getLong(var,'end')
            self.enforceInfo[key]['union_off'] = message[2]:getLong(var,'union_off')  
        end
        self:updateView()
    else
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("操作失败"))
    end

end

function embassyLayer:checkNoView()
    if table.getn(self.enforceInfo) == 0 then
        self:getChildByName("chu_notice_text"):setVisible(true)
        self:getChildByName("chu_notice_text"):setString(ff.langString("当前没有驻守部队"))
        self:getChildByName("send_back_btn"):setVisible(false)
    else
        self:getChildByName("chu_notice_text"):setVisible(false)
        self:getChildByName("chu_notice_text"):setString("")
        self:getChildByName("send_back_btn"):setVisible(true)
    end
end
function embassyLayer:updateView()
    self:checkNoView()
    local armPanel = self:getChildByName("mainArea")
    local allEnfoNum = 0
    armPanel:removeAllItems()
    for key, value in pairs(self.enforceInfo) do
        local armItem = self:getChildByName("armyItem"):clone()
        armItem:setTag(value['troopID'])
        armItem:getChildByName("check_btn"):setTag(value['troopID'] + 1)
        armItem:getChildByName("soldier_bg"):getChildByName("soldier_icon"):loadTexture(dd.getPlayerIcon(value['user_pic']),0)
        armItem:getChildByName("chu_name_text"):setString(value["user_name"])
        local allNum = 0
        for k, var in pairs(value) do
        	local parts = Split(k,'_')
        	if table.getn(parts) == 2 then
        	   if tonumber(parts[2]) ~= nil then
                    allNum = allNum + tonumber(var)
        	   end
        	end
        end
        allEnfoNum = allEnfoNum + allNum
        armItem:getChildByName("num_text"):setString(ff.getFormatMoney(allNum))
        armPanel:addChild(armItem)
        armItem:setVisible(true)
    end
    armPanel:refreshView() 
    self:getChildByName("bar"):getChildByName("chu_help_text"):setString(ff.langString("当前驻守").." : "..ff.getFormatMoney(allEnfoNum).."/"..ff.getFormatMoney(dd.cfgBuildingUp[self._bid][self._lv]['value1']))
end
function embassyLayer:makeSomeData()
    cclog("make data")
    for var=1, 10 do
        local key = table.getn(self.enforceInfo) + 1
        self.enforceInfo[key] = {}
        self.enforceInfo[key]['troopID'] = var
        self.enforceInfo[key]['user_id'] = var + 1000
        self.enforceInfo[key]['user_name'] = 'user_'..var
        self.enforceInfo[key]['user_pic'] = var
        self.enforceInfo[key]['hero_name'] = 'hero_'..var
        self.enforceInfo[key]['hero_gid'] = var
        self.enforceInfo[key]['hero_lv'] = var
        
        self.enforceInfo[key]['bu_1'] = 1
        self.enforceInfo[key]['bu_2'] = 22
        self.enforceInfo[key]['bu_3'] = 333
        self.enforceInfo[key]['bu_4'] = 4444
        self.enforceInfo[key]['bu_5'] = 55
        self.enforceInfo[key]['bu_6'] = 66

        self.enforceInfo[key]['qi_1'] = 11
        self.enforceInfo[key]['qi_2'] = 11
        self.enforceInfo[key]['qi_3'] = 11
        self.enforceInfo[key]['qi_4'] = 11
        self.enforceInfo[key]['qi_5'] = 11
        self.enforceInfo[key]['qi_6'] = 11

        self.enforceInfo[key]['gong_1'] = 11
        self.enforceInfo[key]['gong_2'] = 11
        self.enforceInfo[key]['gong_3'] = 11
        self.enforceInfo[key]['gong_4'] = 11
        self.enforceInfo[key]['gong_5'] = 11
        self.enforceInfo[key]['gong_6'] = 11

        self.enforceInfo[key]['tou_1'] = 11
        self.enforceInfo[key]['tou_2'] = 11
        self.enforceInfo[key]['tou_3'] = 11
        self.enforceInfo[key]['tou_4'] = 11
        self.enforceInfo[key]['tou_5'] = 11
        self.enforceInfo[key]['tou_6'] = 11
--        

        self.enforceInfo[key]["jue_1_num"] = 1
        self.enforceInfo[key]["jue_1_lv"] = 2
        self.enforceInfo[key]["jue_2_num"] = 3
        self.enforceInfo[key]["jue_2_lv"] = 4
        self.enforceInfo[key]["jue_3_num"] = 5
        self.enforceInfo[key]["jue_3_lv"] = 2
        self.enforceInfo[key]["start"] = 1
        self.enforceInfo[key]["end"] = 2
        self.enforceInfo[key]['union_off'] = 1     
    end

end
function embassyLayer:backReinforceSend(result)
    if result[1] == 0 then
        for k, var in pairs(self.enforceInfo) do
            if var['troopID'] == result[2] then

                table.remove(self.enforceInfo,k)
                self:updateView()
                if self.pop:isVisible() == true then
                    self.closePop(nil,ccui.TouchEventType.ended)
                end
                if self.ifAllBack == false or (self.ifAllBack == true and table.getn(self.enforceInfo) <= 0) then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("遣回成功"),true)    
                end
                break
            end
        end
    else
        dd.mainUI:onShowCodeTips(result[1])
    end
end

--界面显示后调用
function embassyLayer.onStart(sender)
end
--界面关闭效果结束后调用
function embassyLayer.onEnd(sender)
    ff.net:removeEvent(1,dd.Tjf_GetMyReinforceInfo)
    ff.net:removeEvent(1,dd.Tjf_ReinforceSendBack)
    sender.enforceInfo = {}
    sender.ifAllBack = false
    local help = pop.getDialog("embassy_help")
    if help ~= nil and help:isVisible() then
        help:setVisible(false)    
    end
end
--界面即将播放显示缓动时调用，返回false界面显示将终止
function embassyLayer.onBefore(sender)
    sender:getReinforceInfo() 
    return false
end

function onShowEmbassy(widget,pos,lastpos)
    local layer = embassyLayer.extend(widget)
    layer:setVisible(false)
    if lastpos == pos then
        layer._effect = false
    else
        layer._effect = true
    end 
    layer._pos = pos
    layer:onInit()
    return layer
end