--warehouse
local warehouseLayer = class("warehouse")
warehouseLayer._name = "warehouse"
warehouseLayer._init = false
warehouseLayer._selectType = 1
warehouseLayer._mitems = {}
warehouseLayer._citems = {}  --晶体item表
warehouseLayer._gitems = {}  --宝石item表
warehouseLayer._eitems = {}  --装备item表

warehouseLayer._minit = false
warehouseLayer._cinit = false
warehouseLayer._ginit = false
warehouseLayer._einit = false

warehouseLayer._minnerhh = 0
warehouseLayer._cinnerhh = 0
warehouseLayer._ginnerhh = 0
warehouseLayer._einnerhh = 0

warehouseLayer._rows =  6

function warehouseLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, warehouseLayer)
    return target
end

function warehouseLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("bg"):setContentSize(cc.size(720,hh))
        self:getChildByName("bg"):setPositionY(0)
        
        self:getChildByName("touch"):setContentSize(cc.size(720, hh ))
        self:getChildByName("mainArea"):setContentSize(cc.size(720, hh - 105 - 85))
        self:getChildByName("mainArea"):getChildByName("view"):setContentSize(cc.size(720, hh - 105 - 85 - 3))
        self:getChildByName("mainArea"):getChildByName("view2"):setContentSize(cc.size(720, hh - 105 - 85 - 3))
        self:getChildByName("mainArea"):getChildByName("view3"):setContentSize(cc.size(720, hh - 105 - 85 - 3))
        self:getChildByName("mainArea"):getChildByName("view4"):setContentSize(cc.size(720, hh - 105 - 85 - 3))
        
        self:getChildByName("mainArea"):setPositionY(0)
        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("topNavi"):setPositionY(hh - 105 - 85)
        self:getChildByName("topNavi2"):setPositionY(hh - 105 - 85)
        self:getChildByName("topNavi3"):setPositionY(hh - 105 - 85)
    end
end

function warehouseLayer:onInit()
    if self._init == false then        
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
        
        local function onMix(sender,eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then 
                doaction = true
            end
            if doaction == true then
                pop.onShowPopDialog("equipcompose")
            end          
        end
        local function onChai( sender,eventType )
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then 
                doaction = true
            end
            if doaction == true then
                local id = sender:getTag()
                local function sureCancel()
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000144)
                    message:addLong(dd.uid)
                    message:addLong(id)
                    message:addLong(1)
                    ff.net:rpc(message, false)          
                end
                dd.currentLayer._widget:onShowSure(ff.langString("警告"),ff.langString("确定要分解该合金吗？"),sureCancel)
                
            end
        end

        local function onChai1( sender,eventType )
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then 
                doaction = true
            end
            if doaction == true then
                local id = sender:getTag()
                local function sureCancel1()
                    if id < 0 then
                        if dd.currentLayer._widget ~= nil then
                            dd.currentLayer._widget:onShowTips("\t"..ff.langString("装备分解失败，请卸下装备并摘除装备上的宝石"))
                        end
                    else
                        local message = ff.net:createMessage()
                        message:addCmd(0x0000014f)
                        message:addLong(dd.uid)
                        message:addLong(id)
                        ff.net:rpc(message, false)       
                    end
                       
                end
                dd.currentLayer._widget:onShowSure(ff.langString("警告"),ff.langString("确定要分解该装备吗？"),sureCancel1)
                
            end
        end

        local function onUp(sender,eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then 
                doaction = true
            end
            if doaction == true then
                pop.onShowPopDialog("crystalUp",sender:getTag())
            end            
        end
        local function onPut(sender,eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then 
                doaction = true
            end
            if doaction == true then
                pop.onClosePopDialog("warehouse")
                for i=1,dd.mybuilds:rowCount() do
                    if dd.mybuilds:getLong(i,"bid") == 12 then
                        onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"),false)   
                        break
                    end
                end
            end
        end
        --单选框
        local function onSelect(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if sender:getSelectedState() == true then
                    sender:getParent():getChildByName("navi1"):setSelectedState(false)
                    sender:getParent():getChildByName("navi2"):setSelectedState(false)
                    sender:getParent():getChildByName("navi3"):setSelectedState(false)   
                    sender:getParent():getChildByName("navi4"):setSelectedState(false)  
                    return
                end    

                sender:getParent():getChildByName("navi1"):setSelectedState(false)
                sender:getParent():getChildByName("navi2"):setSelectedState(false)
                sender:getParent():getChildByName("navi3"):setSelectedState(false)   
                sender:getParent():getChildByName("navi4"):setSelectedState(false)  
                if sender:getName() == "navi1" then
                    self._selectType = 1
                    sender:getParent():getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
                    sender:getParent():getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                    sender:getParent():getChildByName("navi3"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                    sender:getParent():getChildByName("navi4"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                    self:updateList()
                elseif sender:getName() == "navi2" then
                    self._selectType = 2
                    sender:getParent():getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
                    sender:getParent():getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                    sender:getParent():getChildByName("navi3"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                    sender:getParent():getChildByName("navi4"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                    self:updateList()
                elseif sender:getName() == "navi3" then
                    self._selectType = 3
                    sender:getParent():getChildByName("navi3"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
                    sender:getParent():getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                    sender:getParent():getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                    sender:getParent():getChildByName("navi4"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                    self:updateList()
                elseif sender:getName() == "navi4" then
                    self._selectType = 4
                    sender:getParent():getChildByName("navi4"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
                    sender:getParent():getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                    sender:getParent():getChildByName("navi3"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                    sender:getParent():getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                    self:updateList()
                end
            end
        end
        
        local function onTouchBegan(touch, event)
            
            return false
        end
        local listener = cc.EventListenerTouchOneByOne:create()
        listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
        listener:setSwallowTouches(true)
        self:getChildByName("touch"):getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self:getChildByName("touch"))
        
        self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)
        self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)
        self:getChildByName("topNavi"):getChildByName("navi3"):setSelectedState(false)
        self:getChildByName("topNavi"):getChildByName("navi4"):setSelectedState(true)
        self:getChildByName("topNavi"):getChildByName("navi4"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("topNavi"):getChildByName("navi1"):addTouchEventListener(onSelect) 
        self:getChildByName("topNavi"):getChildByName("navi2"):addTouchEventListener(onSelect)
        self:getChildByName("topNavi"):getChildByName("navi3"):addTouchEventListener(onSelect)   
        self:getChildByName("topNavi"):getChildByName("navi4"):addTouchEventListener(onSelect) 

        self:getChildByName("topNavi2"):getChildByName("navi1"):setSelectedState(false)
        self:getChildByName("topNavi2"):getChildByName("navi2"):setSelectedState(false)
        self:getChildByName("topNavi2"):getChildByName("navi3"):setSelectedState(false)
        self:getChildByName("topNavi2"):getChildByName("navi4"):setSelectedState(true)
        self:getChildByName("topNavi2"):getChildByName("navi4"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("topNavi2"):getChildByName("navi1"):addTouchEventListener(onSelect) 
        self:getChildByName("topNavi2"):getChildByName("navi2"):addTouchEventListener(onSelect)
        self:getChildByName("topNavi2"):getChildByName("navi3"):addTouchEventListener(onSelect)   
        self:getChildByName("topNavi2"):getChildByName("navi4"):addTouchEventListener(onSelect)

        self:getChildByName("topNavi3"):getChildByName("navi1"):setSelectedState(false)
        self:getChildByName("topNavi3"):getChildByName("navi2"):setSelectedState(false)
        self:getChildByName("topNavi3"):getChildByName("navi3"):setSelectedState(false)
        self:getChildByName("topNavi3"):getChildByName("navi4"):setSelectedState(true)
        self:getChildByName("topNavi3"):getChildByName("navi4"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("topNavi3"):getChildByName("navi1"):addTouchEventListener(onSelect) 
        self:getChildByName("topNavi3"):getChildByName("navi2"):addTouchEventListener(onSelect)
        self:getChildByName("topNavi3"):getChildByName("navi3"):addTouchEventListener(onSelect)   
        self:getChildByName("topNavi3"):getChildByName("navi4"):addTouchEventListener(onSelect)

        self:getChildByName("mainArea"):getChildByName("view"):getChildByName("tips"):getChildByName("equipbtn"):addTouchEventListener(onMix)
        self:getChildByName("mainArea"):getChildByName("view2"):getChildByName("tips"):getChildByName("equipbtn"):addTouchEventListener(onMix)
        self:getChildByName("mainArea"):getChildByName("view2"):getChildByName("tips"):getChildByName("equipbtn"):addTouchEventListener(onMix)
        self:getChildByName("mainArea"):getChildByName("view2"):getChildByName("tips"):getChildByName("equip1btn"):addTouchEventListener(onChai)
        self:getChildByName("mainArea"):getChildByName("view3"):getChildByName("tips"):getChildByName("equipbtn"):addTouchEventListener(onUp)
        self:getChildByName("mainArea"):getChildByName("view4"):getChildByName("tips"):getChildByName("equipbtn"):addTouchEventListener(onPut)
        self:getChildByName("mainArea"):getChildByName("view4"):getChildByName("tips"):getChildByName("equip1btn"):addTouchEventListener(onChai1)

        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3)
        self._selectType = 4
    
        self:initCfg()
        self._init = true
    end
    self.updateGold()
end

function warehouseLayer:initCfg()
    --gem    
    --cry
end

function warehouseLayer.updateGold()
    local widget = pop.getDialog("warehouse")
    widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
    widget:getChildByName("topArea"):requestDoLayout()

    local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
    w = 720 - (w + 94 + 75 + 104)
    widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
    widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
end

function warehouseLayer:updateList()
    self:getChildByName("mainArea"):getChildByName("view"):stopAllActions()
    self:getChildByName("mainArea"):getChildByName("view2"):stopAllActions()
    self:getChildByName("mainArea"):getChildByName("view3"):stopAllActions()
    self:getChildByName("mainArea"):getChildByName("view4"):stopAllActions()
    if self._selectType == 1 then
        self:getChildByName("mainArea"):getChildByName("view"):setVisible(true)
        self:getChildByName("mainArea"):getChildByName("view2"):setVisible(false)
        self:getChildByName("mainArea"):getChildByName("view3"):setVisible(false)
        self:getChildByName("mainArea"):getChildByName("view4"):setVisible(false)
        self:updateMaterialList()
    elseif self._selectType == 2 then
        self:getChildByName("mainArea"):getChildByName("view"):setVisible(false)
        self:getChildByName("mainArea"):getChildByName("view2"):setVisible(true)
        self:getChildByName("mainArea"):getChildByName("view3"):setVisible(false)
        self:getChildByName("mainArea"):getChildByName("view4"):setVisible(false)
        self:updateGemList()
    elseif self._selectType == 3 then
        self:getChildByName("mainArea"):getChildByName("view"):setVisible(false)
        self:getChildByName("mainArea"):getChildByName("view2"):setVisible(false)
        self:getChildByName("mainArea"):getChildByName("view3"):setVisible(true)
        self:getChildByName("mainArea"):getChildByName("view4"):setVisible(false)
        self:updateCryList()
    elseif self._selectType == 4 then
        self:getChildByName("mainArea"):getChildByName("view"):setVisible(false)
        self:getChildByName("mainArea"):getChildByName("view2"):setVisible(false)
        self:getChildByName("mainArea"):getChildByName("view3"):setVisible(false)
        self:getChildByName("mainArea"):getChildByName("view4"):setVisible(true)
        self:updateEquipList()
    else
        self:getChildByName("mainArea"):getChildByName("view"):setVisible(true)
        self:getChildByName("mainArea"):getChildByName("view2"):setVisible(false)
        self:getChildByName("mainArea"):getChildByName("view3"):setVisible(false)
        self:updateMaterialList()
    end
end
--装备
function warehouseLayer:updateEquipList()
    local view = self:getChildByName("mainArea"):getChildByName("view4")
    view:getChildByName("tips"):setVisible(false)
    local hh = view:getContentSize().height
    local num = dd.myArms:rowCount()
    local innerhh = 0
    local count = 1 
    local row = math.ceil(num/4)
    if row < self._rows then
        row = self._rows
    end
    view:jumpToTop()
    --隐藏items
    for i,v in ipairs(self._eitems) do
        if tolua.isnull(v) then
            self._eitems[i] = nil
        else
            v:setVisible(false)
            v:setTag(i)
            v:getChildByName("check"):setSelectedState(false)
        end
    end
    
    if row*168 > hh then
        view:setInnerContainerSize(cc.size(720,row*168))
        innerhh = row*168
    else
        view:setInnerContainerSize(cc.size(720,hh))
        innerhh = hh
    end
    self._einnerhh = innerhh
    if dd.myArms:rowCount() <= self._rows*4 then
        for i=1, dd.myArms:rowCount() do
            self:addEquipItem(innerhh,count,i)
            count = count + 1
        end 
        for i=count,row*4 do
            self:addEquipItem(innerhh,count,0)
            count = count + 1
        end
    else
        for i=1, self._rows*4 do
            self:addEquipItem(innerhh,count,i)
            count = count + 1
        end
        local function add_sche()
            if count <= dd.myArms:rowCount() then
                self:addEquipItem(innerhh,count,count)
                count = count + 1
            else
                for i=count,row*4 do
                    self:addEquipItem(innerhh,count,0)
                    count = count + 1
                end
                self:getChildByName("mainArea"):getChildByName("view4"):stopAllActions()
                cclog("已停止添加脚本 ==========装备 ")
            end
        end
        cclog("开启添加脚本 =========装备 ")
        schedule(self:getChildByName("mainArea"):getChildByName("view4"), add_sche,0.01)
    end     
end

function warehouseLayer:addEquipItem(innerhh,count,i)
    local item = self._eitems[count]
    if item == nil then
        item = self:getChildByName("mainArea"):getChildByName("equipitem"):clone()
        self._eitems[count] = item
        self:getChildByName("mainArea"):getChildByName("view4"):addChild(item)
    end
    item:setVisible(true)        
    item:setPositionX(25 + ((count-1)%4)*176 )
    item:setPositionY(innerhh - 165 - math.floor((count-1)/4)*168 )

    if i == 0 then
        item:getChildByName("back"):loadTexture(dd.getPathFromUI("m_box_1.png",1))
        item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        item:getChildByName("name"):getChildByName("name"):setString("")
        item:getChildByName("check"):setTouchEnabled(false)
    else
        local cfgid = dd.myArms:getLong(i,"aid")
        local color = dd.cfgArms[cfgid]['color']
        if color > 5 then
            color = 5 --白绿蓝紫(橙红 缺)
        end        
        item:getChildByName("back"):loadTexture(dd.getPathFromUI("m_box_"..color..".png",1))
        item:getChildByName("icon"):loadTexture(dd.getArmIcon(cfgid),0)
        item:getChildByName("name"):getChildByName("name"):setString(ff.langString(dd.cfgArms[cfgid]['name']))

        item:getChildByName("check"):loadTextureBackGroundSelected(
            dd.getPathFromUI("m_onbox_"..color..".png",1))
        item:getChildByName("check"):loadTextureFrontCross(
            dd.getPathFromUI("m_onbox_"..color..".png",1))

        item:getChildByName("check"):addTouchEventListener(self.onClickEquip)
        item:getChildByName("check"):setTouchEnabled(true)
        item.id = cfgid
        item:getChildByName("check").row = i
        item:getChildByName("check").count = count
    end
end

function warehouseLayer:updateEquipPos(tcount,addhh)
    local innerhh = self._einnerhh + addhh
    local count   = 1
    local addline = math.floor((tcount-1)/4)

    self:getChildByName("mainArea"):getChildByName("view4"):setInnerContainerSize(cc.size(720,innerhh))

    if addhh == 0 then
        self:getChildByName("mainArea"):getChildByName("view4"):getChildByName("tips"):setVisible(false)
    else
        --设置tips位置
        local tips = self:getChildByName("mainArea"):getChildByName("view4"):getChildByName("tips")
        tips:setPositionY(innerhh + 8 - addhh - 165 - addline*168)
        if tips:isVisible() == true then
            local fixy = self:getChildByName("mainArea"):getChildByName("view4"):getInnerContainer():getPositionY() + tips:getPositionY()
            if fixy < 0 then
                self:getChildByName("mainArea"):getChildByName("view4"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,-fixy)))
            end
        end
    end
    
    for i,item in ipairs(self._eitems) do
        if item and item:isVisible() == true then
            if math.floor((count-1)/4) > addline then
                item:setPositionX(25 + ((count-1)%4)*176 )
                item:setPositionY(innerhh - addhh - 165 - math.floor((count-1)/4)*168 )
            else                
                item:setPositionX(25 + ((count-1)%4)*176 )
                item:setPositionY(innerhh - 165 - math.floor((count-1)/4)*168 )
            end
            count = count + 1
        end
    end
end

function warehouseLayer:showEquipTips(row,count)
    local tid   = dd.myArms:getLong(row,"aid")   --cfgid
    local col   = dd.cfgArms[tid]["color"] 
    local name  = ff.langString(dd.cfgArms[tid]['name']) 
    self._sell_silver = 0
    local list  = self:getChildByName("mainArea"):getChildByName("view4")
    list:getChildByName("tips"):getChildByName("tips"):removeAllChildren(true)
    list:getChildByName("tips"):setVisible(true)
    --左边
    local richText1 = ccui.RichText:create()
    richText1:ignoreContentAdaptWithSize(false)
    richText1:setContentSize(cc.size(350,600)) 
    richText1:setAutoHeight()

    --name
    local haveHeros = false
    if dd.myArms:getLong(row,"heroid") > 0 then
        for i=1,dd.heros:rowCount() do
            if dd.myArms:getLong(row,"heroid") == dd.heros:getLong(i,"hid") then
                haveHeros = true
                if dd.heros:getString(row,"name") == "" then
                    name = name.."("..ff.langString(dd.cfgHero[dd.heros:getLong(i,"id")]['name'])..")"
                else
                    name = name.."("..dd.heros:getString(row,"name")..")"
                end
                break
            end
        end
    end

    list:getChildByName("tips"):getChildByName("name"):setString(name)
    --装备效果
    local count1 = 0

    local chatlv = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n".."LV."..dd.cfgArms[tid]['level'], "Helvetica", 20)
    richText1:insertElement(chatlv,count1)
    count1 = count1 + 1

    for i=1,3 do
        local param = dd.cfgArms[tid]["param"..i]
        if param > 0 then
            local value = dd.cfgArms[tid]['value'..i]
            if dd.cfgEffect[param]['value'] > 0 then
                value = value/dd.cfgEffect[param]['value']
            end
            local chat1 = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n"..ff.langString(dd.cfgEffect[param]['name']), "Helvetica", 20)
            richText1:insertElement(chat1,count1)
            count1 = count1 + 1
            if tonumber(dd.cfgEffect[param]['tips2']) ~= 0 then
                local valuestr = "+"..value..ff.langString(dd.cfgEffect[param]['tips2'])
                local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                richText1:insertElement(chat2,count1)
            else
                local valuestr = "+"..value
                local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                richText1:insertElement(chat2,count1)
            end
            count1 = count1 + 1
        end
    end
    richText1:formatText()

    --右边
    local richText2 = ccui.RichText:create()
    richText2:ignoreContentAdaptWithSize(false)
    richText2:setContentSize(cc.size(350,600)) 
    richText2:setAutoHeight()

    --宝石效果   富文本要从0开始
    local count2 = 0
    for i=1,3 do
        local gid = dd.myArms:getLong(row,"gem"..i)    --好像cfgid 也是这个
        if gid > 0 then
            if dd.cfgGems[gid]['param1'] > 0 then
                local value = dd.cfgGems[gid]['value1']
                local param = dd.cfgGems[gid]['param1']
                if dd.cfgEffect[param]['value'] > 0 then
                    value = value/dd.cfgEffect[param]['value']
                end
                local chat1 = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n"..ff.langString(dd.cfgEffect[param]['name']), "Helvetica", 20)
                richText2:insertElement(chat1,count2)
                count2 = count2 + 1

                if tonumber(dd.cfgEffect[param]['tips2']) ~= 0 then
                    local valuestr = "+"..value..ff.langString(dd.cfgEffect[param]['tips2'])
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                    richText2:insertElement(chat2,count2)
                else
                    local valuestr = "+"..value
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                    richText2:insertElement(chat2,count2)
                end
                count2 = count2 + 1
            end
            if dd.cfgGems[gid]['param2'] > 0 then
                local value = dd.cfgGems[gid]['value2']
                local param = dd.cfgGems[gid]['param2']
                if dd.cfgEffect[param]['value'] > 0 then
                    value = value/dd.cfgEffect[param]['value']
                end
                local chat1 = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n"..ff.langString(dd.cfgEffect[param]['name']), "Helvetica", 20)
                richText2:insertElement(chat1,count2)
                count2 = count2 + 1
                if tonumber(dd.cfgEffect[param]['tips2']) ~= 0 then
                    local valuestr = "+"..value..ff.langString(dd.cfgEffect[param]['tips2'])
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                    richText2:insertElement(chat2,count2)
                else
                    local valuestr = "+"..value
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                    richText2:insertElement(chat2,count2)
                end
                count2 = count2 + 1
            end                     
        end
    end
    richText2:formatText()
    if dd.cfgArms[tid]["sell_if"] == 1 then
        self._sell_silver = dd.cfgArms[tid]["sell_silver"] 
        if count2 == 0 and haveHeros == false then
            self:getChildByName("mainArea"):getChildByName("view4"):getChildByName("tips"):getChildByName("equip1btn"):setTag(dd.myArms:getLong(row,"tid"))
        else
            self:getChildByName("mainArea"):getChildByName("view4"):getChildByName("tips"):getChildByName("equip1btn"):setTag(-1)
        end
        self:getChildByName("mainArea"):getChildByName("view4"):getChildByName("tips"):getChildByName("equip1btn"):setVisible(true)
        
    else
        self:getChildByName("mainArea"):getChildByName("view4"):getChildByName("tips"):getChildByName("equip1btn"):setVisible(false)
    end
    --计算高度
    local height = 0
    local size1 = richText1:getContentSize()
    local size2 = richText2:getContentSize()
    if size1.height > size2.height then
        height = size1.height
    else
        height = size2.height
    end
    richText1:setPosition(cc.p(184,height - size1.height/2 + 80 -30))
    richText2:setPosition(cc.p(540,height - size2.height/2 + 80 -30))

    list:getChildByName("tips"):setContentSize(cc.size(652, height + 85))
    list:getChildByName("tips"):getChildByName("tips"):setContentSize(cc.size(652, height + 85))
    list:getChildByName("tips"):getChildByName("tips"):addChild(richText1)
    list:getChildByName("tips"):getChildByName("tips"):addChild(richText2)

    list:getChildByName("tips"):getChildByName("name"):setPositionY(height + 85 - 18)
    list:getChildByName("tips"):getChildByName("flag"):setPositionX(65 + ((count-1)%4)*176 )
    list:getChildByName("tips"):getChildByName("flag"):setPositionY(height + 85 - 4)

    return height + 85 + 20
end

function warehouseLayer.onClickEquip(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then   
            local widget = pop.getDialog("warehouse")
            if sender:getSelectedState() == true then
                for i,item in ipairs(widget._eitems) do
                    if item then
                        item:getChildByName("check"):setSelectedState(false)
                    end
                end
                widget:updateEquipPos(1,0)
            else
                for i,item in ipairs(widget._eitems) do
                    if item then
                        item:getChildByName("check"):setSelectedState(false)
                    end
                end
                sender:setSelectedState(true)
                local addhh = widget:showEquipTips(sender.row,sender.count)
                widget:updateEquipPos(sender.count,addhh)
            end 
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("warehouse")
        if sender:getSelectedState() == true then
            for i,item in ipairs(widget._eitems) do
                if item then
                    item:getChildByName("check"):setSelectedState(false)
                end
            end
            --此处设置true 结束会设置相反状态 上面的不会
            sender:setSelectedState(true)
            widget:updateEquipPos(1,0)
        else
            for i,item in ipairs(widget._eitems) do
                if item then
                    item:getChildByName("check"):setSelectedState(false)
                end
            end
            local addhh = widget:showEquipTips(sender.row,sender.count)
            widget:updateEquipPos(sender.count,addhh)
        end 
        doaction = true
    end
    if doaction == true then 
    end
end

--材料
function warehouseLayer:updateMaterialList()
    local view = self:getChildByName("mainArea"):getChildByName("view")
    view:getChildByName("tips"):setVisible(false)
    local hh = view:getContentSize().height
    local num = 0
    local innerhh = 0
    local count = 1
    local isHave5 = false     --是否有5个的 控制按钮灰亮
    for i=1, dd.mytools:rowCount() do
        local tid = dd.mytools:getLong(i,"tid")
        if dd.cfgProp[tid]['type'] > 100 then
            num = num + 1
            if dd.mytools:getLong(i,"count") >= 5 then
                isHave5 = true
            end
        end
    end
    local row = math.ceil(num/4)
    if row < self._rows then
        row = self._rows
    end
    view:jumpToTop()
    --隐藏items
    for i,v in ipairs(self._mitems) do
        if tolua.isnull(v) then
            self._mitems[i] = nil
        else
            v:setVisible(false)
            v:setTag(i)
            v:getChildByName("check"):setSelectedState(false)
        end
    end

    if row*168 > hh then
        view:setInnerContainerSize(cc.size(720,row*168))
        innerhh = row*168
    else
        view:setInnerContainerSize(cc.size(720,hh))
        innerhh = hh
    end
    self._minnerhh = innerhh
    if num <= self._rows*4 then
        for i=1, dd.mytools:rowCount() do
            local tid = dd.mytools:getLong(i,"tid") 
            if dd.cfgProp[tid]['type'] > 100 then
                self:addMaterialItem(innerhh,tid,count)
                count = count + 1
            end
        end
        for i=count,row*4 do
            self:addMaterialItem(innerhh,0,count)
            count = count + 1
        end
    else
        local flag = 0
        for i=1, dd.mytools:rowCount() do
        --for i=1, self._rows*4 do
            local tid = dd.mytools:getLong(i,"tid") 
            if dd.cfgProp[tid]['type'] > 100 then
                self:addMaterialItem(innerhh,tid,count)
                count = count + 1
                if count > self._rows*4 then
                    flag = i
                    break
                end
            end
            flag = i
        end
        local function add_sche()
            if count <= num then
                for i=flag + 1, dd.mytools:rowCount() do
                    local tid = dd.mytools:getLong(i,"tid") 
                    if dd.cfgProp[tid]['type'] > 100 then
                        self:addMaterialItem(innerhh,tid,count)
                        count = count + 1
                    end
                    flag = i
                end
            else
                for i=count,row*4 do
                    self:addMaterialItem(innerhh,0,count)
                    count = count + 1
                end
                self:getChildByName("mainArea"):getChildByName("view"):stopAllActions()
                cclog("已停止添加脚本 ==========材料 ")
            end
        end
        cclog("开启添加脚本 =========材料 ")
        schedule(self:getChildByName("mainArea"):getChildByName("view"), add_sche,0.01)
    end
end

function warehouseLayer:addMaterialItem(innerhh,tid,count)
    local item = self._mitems[count]
    if item == nil then
        item = self:getChildByName("mainArea"):getChildByName("itemmode"):clone()
        self._mitems[count] = item
        self:getChildByName("mainArea"):getChildByName("view"):addChild(item)
    end
    item:setVisible(true)        
    item:setPositionX(25 + ((count-1)%4)*176 )
    item:setPositionY(innerhh - 165 - math.floor((count-1)/4)*168 )
    
    if tid == 0 then
        item:getChildByName("back"):loadTexture(dd.getPathFromUI("m_box_1.png",1))
        item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        item:getChildByName("num"):getChildByName("num"):setString("")
        item:getChildByName("check"):setTouchEnabled(false)
    else
        local color = dd.cfgProp[tid]['color']
        if color > 5 then
            color = 5 --白绿蓝紫(橙红 缺)
        end
        item:getChildByName("back"):loadTexture(dd.getPathFromUI("m_box_"..color..".png",1))
        item:getChildByName("icon"):loadTexture(dd.getToolsIcon(tid), 0)
        item:getChildByName("num"):getChildByName("num"):setString(ff.getFormatMoney(dd.getToolsCount(tid)))

        item:getChildByName("check"):loadTextureBackGroundSelected(
            dd.getPathFromUI("m_onbox_"..color..".png",1))
        item:getChildByName("check"):loadTextureFrontCross(
            dd.getPathFromUI("m_onbox_"..color..".png",1))

        item:getChildByName("check"):addTouchEventListener(self.onClickMaterial)
        item:getChildByName("check"):setTouchEnabled(true)
        item:getChildByName("check").id = tid
        item:getChildByName("check").count = count
    end
end

function warehouseLayer:updateMaterialPos(tcount,addhh)
    local innerhh = self._minnerhh + addhh
    local count   = 1
    local addline = math.floor((tcount-1)/4)

    self:getChildByName("mainArea"):getChildByName("view"):setInnerContainerSize(cc.size(720,innerhh))

    if addhh == 0 then
        self:getChildByName("mainArea"):getChildByName("view"):getChildByName("tips"):setVisible(false)
    else
        --设置tips位置
        local tips = self:getChildByName("mainArea"):getChildByName("view"):getChildByName("tips")
        tips:setPositionY(innerhh + 8 - addhh - 165 - addline*168)
        if tips:isVisible() == true then
            local fixy = self:getChildByName("mainArea"):getChildByName("view"):getInnerContainer():getPositionY() + tips:getPositionY()
            if fixy < 0 then
                self:getChildByName("mainArea"):getChildByName("view"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,-fixy)))
            end
        end
    end
    
    for i,item in ipairs(self._mitems) do
        if item and item:isVisible() == true then
            if math.floor((count-1)/4) > addline then
                item:setPositionX(25 + ((count-1)%4)*176 )
                item:setPositionY(innerhh - addhh - 165 - math.floor((count-1)/4)*168 )
            else                
                item:setPositionX(25 + ((count-1)%4)*176 )
                item:setPositionY(innerhh - 165 - math.floor((count-1)/4)*168 )
            end
            count = count + 1
        end
    end
end

function warehouseLayer:showMaterialTips(tid,count)
    local name  = ff.langString(dd.cfgProp[tid]['name'],{dd.cfgProp[tid]['name1_lan']}) 

    local list  = self:getChildByName("mainArea"):getChildByName("view")
    list:getChildByName("tips"):getChildByName("tips"):removeAllChildren(true)
    list:getChildByName("tips"):setVisible(true)
    --左边
    local richText1 = ccui.RichText:create()
    richText1:ignoreContentAdaptWithSize(false)
    richText1:setContentSize(cc.size(350,600)) 
    richText1:setAutoHeight() 

    list:getChildByName("tips"):getChildByName("name"):setString(name)
    --装备效果
    local count1 = 0

    local chatlv = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n"..ff.langString(dd.cfgProp[tid]['tips'],{dd.cfgProp[tid]['tips1_lan']}), "Helvetica", 20)
    richText1:insertElement(chatlv,count1)
    count1 = count1 + 1

   
    richText1:formatText()
    --计算高度
    local height = 0
    local size1 = richText1:getContentSize()
    height = size1.height

    richText1:setPosition(cc.p(184,height - size1.height/2 + 80 -30))

    list:getChildByName("tips"):setContentSize(cc.size(652, height + 85))
    list:getChildByName("tips"):getChildByName("tips"):setContentSize(cc.size(652, height + 85))
    list:getChildByName("tips"):getChildByName("tips"):addChild(richText1)

    list:getChildByName("tips"):getChildByName("name"):setPositionY(height + 85 - 18)
    list:getChildByName("tips"):getChildByName("flag"):setPositionX(65 + ((count-1)%4)*176 )
    list:getChildByName("tips"):getChildByName("flag"):setPositionY(height + 85 - 4)

    return height + 85 + 20
end

function warehouseLayer.onClickMaterial(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then   
            local widget = pop.getDialog("warehouse")
            if sender:getSelectedState() == true then
                for i,item in ipairs(widget._mitems) do
                    if item then
                        item:getChildByName("check"):setSelectedState(false)
                    end
                end
                widget:updateMaterialPos(1,0)
            else
                for i,item in ipairs(widget._mitems) do
                    if item then
                        item:getChildByName("check"):setSelectedState(false)
                    end
                end
                sender:setSelectedState(true)
                local addhh = widget:showMaterialTips(sender.id,sender.count)
                widget:updateMaterialPos(sender.count,addhh)
            end 
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("warehouse")
        if sender:getSelectedState() == true then
            for i,item in ipairs(widget._mitems) do
                if item then
                    item:getChildByName("check"):setSelectedState(false)
                end
            end
            --此处设置true 结束会设置相反状态 上面的不会
            sender:setSelectedState(true)
            widget:updateMaterialPos(1,0)
        else
            for i,item in ipairs(widget._mitems) do
                if item then
                    item:getChildByName("check"):setSelectedState(false)
                end
            end
            local addhh = widget:showMaterialTips(sender.id,sender.count)
            widget:updateMaterialPos(sender.count,addhh)
        end 
        doaction = true
    end
    if doaction == true then 
    end
end
--宝石
function warehouseLayer:updateGemList()
    local view = self:getChildByName("mainArea"):getChildByName("view2")
    view:getChildByName("tips"):setVisible(false)
    local hh = view:getContentSize().height
    local num = 0
    local innerhh = 0
    local count = 1
    local isHave5 = false     --是否有5个的 控制按钮灰亮
    for i=1, dd.mytools:rowCount() do
        local tid = dd.mytools:getLong(i,"tid") 
        if dd.cfgProp[tid]['type'] == 8 then
            num = num + 1
            if dd.mytools:getLong(i,"count") >= 5 then
                isHave5 = true
            end
        end
    end

    local row = math.ceil(num/4)
    if row < self._rows then
        row = self._rows
    end
    view:jumpToTop()
    --隐藏items
    for i,v in ipairs(self._gitems) do
        if tolua.isnull(v) then
            self._gitems[i] = nil
        else
            v:setVisible(false)
            v:setTag(i)
            v:getChildByName("check"):setSelectedState(false)
        end
    end

    if row*168 > hh then
        view:setInnerContainerSize(cc.size(720,row*168))
        innerhh = row*168
    else
        view:setInnerContainerSize(cc.size(720,hh))
        innerhh = hh
    end

    self._ginnerhh = innerhh

    if num <= self._rows*4 then
        for i=1, dd.mytools:rowCount() do
            local tid = dd.mytools:getLong(i,"tid")
            if dd.cfgProp[tid]['type'] == 8 then            
                self:addGemItem(innerhh,tid,count)
                count = count + 1
            end
        end
        for i=count,row*4 do
            self:addGemItem(innerhh,0,count)
            count = count + 1
        end
    else
        local flag = 0
        for i=1, dd.mytools:rowCount() do
            local tid = dd.mytools:getLong(i,"tid") 
            if dd.cfgProp[tid]['type'] == 8 then
                self:addGemItem(innerhh,tid,count)
                count = count + 1
                if count > self._rows*4 then
                    flag = i
                    break
                end
            end
            flag = i
        end
        local function add_sche()
            if count <= num then
                for i=flag + 1, dd.mytools:rowCount() do
                    local tid = dd.mytools:getLong(i,"tid") 
                    if dd.cfgProp[tid]['type'] == 8 then
                        self:addGemItem(innerhh,tid,count)
                        count = count + 1
                    end
                    flag = i
                end
            else
                for i=count,row*4 do
                    self:addGemItem(innerhh,0,count)
                    count = count + 1
                end
                self:getChildByName("mainArea"):getChildByName("view2"):stopAllActions()
                cclog("已停止添加脚本 ==========宝石 ")
            end
        end
        cclog("开启添加脚本 =========宝石 ")
        schedule(self:getChildByName("mainArea"):getChildByName("view2"), add_sche,0.01)
    end
end

function warehouseLayer:addGemItem(innerhh,tid,count)
    local item = self._gitems[count]
    if item == nil then
        item = self:getChildByName("mainArea"):getChildByName("gemitem"):clone()
        self._gitems[count] = item
        self:getChildByName("mainArea"):getChildByName("view2"):addChild(item)
    end
    item:setVisible(true)        
    item:setPositionX(25 + ((count-1)%4)*176 )
    item:setPositionY(innerhh - 157 - math.floor((count-1)/4)*168 )
    if tid == 0 then
        item:getChildByName("back"):loadTexture(dd.getPathFromUI("g_box_1.png",1))
        item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        item:getChildByName("num"):getChildByName("num"):setString("")
        item:getChildByName("check"):setTouchEnabled(false)
    else
        item:getChildByName("back"):loadTexture(dd.getPathFromUI("g_box_1.png",1))
        item:getChildByName("icon"):loadTexture(dd.getToolsIcon(tid), 0)
        item:getChildByName("num"):getChildByName("num"):setString("LV."..dd.cfgGems[tid]["level"].." "..dd.getToolsCount(tid))
        
        item:getChildByName("check"):loadTextureBackGroundSelected(
            dd.getPathFromUI("g_onbox_1.png",1))
        item:getChildByName("check"):loadTextureFrontCross(
            dd.getPathFromUI("g_onbox_1.png",1))

        item:getChildByName("check"):addTouchEventListener(self.onClickGem)
        item:getChildByName("check"):setTouchEnabled(true)
        item:getChildByName("check").id = tid
        item:getChildByName("check").count = count
    end
end

function warehouseLayer:updateGemPos(tcount,addhh)
    local innerhh = self._ginnerhh + addhh
    local count   = 1
    local addline = math.floor((tcount-1)/4)
    
    self:getChildByName("mainArea"):getChildByName("view2"):setInnerContainerSize(cc.size(720,innerhh))
    
    if addhh == 0 then
        self:getChildByName("mainArea"):getChildByName("view2"):getChildByName("tips"):setVisible(false)        
    else
        --设置tips位置
        local tips = self:getChildByName("mainArea"):getChildByName("view2"):getChildByName("tips")
        tips:setPositionY(innerhh + 0 - addhh - 157 - addline*168)
        if tips:isVisible() == true then
            local fixy = self:getChildByName("mainArea"):getChildByName("view2"):getInnerContainer():getPositionY() + tips:getPositionY()
            if fixy < 0 then
                self:getChildByName("mainArea"):getChildByName("view2"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,-fixy)))
            end
        end
    end
    
    for i,item in ipairs(self._gitems) do
        if item and item:isVisible() == true then
            if math.floor((count-1)/4) > addline then
                item:setPositionX(25 + ((count-1)%4)*176 )
                item:setPositionY(innerhh - addhh - 157 - math.floor((count-1)/4)*168 )
            else                
                item:setPositionX(25 + ((count-1)%4)*176 )
                item:setPositionY(innerhh - 157 - math.floor((count-1)/4)*168 )
            end
            count = count + 1
        end
    end
end

function warehouseLayer:showGemTips(tid,count)
    local name  = ff.langString(dd.cfgProp[tid]['name'],{dd.cfgProp[tid]['name1_lan']}) 

    local list  = self:getChildByName("mainArea"):getChildByName("view2")
    list:getChildByName("tips"):getChildByName("tips"):removeAllChildren(true)
    list:getChildByName("tips"):setVisible(true)
    list:getChildByName("tips"):getChildByName("equip1btn"):setTag(tid)
    --左边
    local richText1 = ccui.RichText:create()
    richText1:ignoreContentAdaptWithSize(false)
    richText1:setContentSize(cc.size(350,600)) 
    richText1:setAutoHeight() 

    list:getChildByName("tips"):getChildByName("name"):setString(name)
    --装备效果
    local count1 = 0

    local chatlv = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n"..ff.langString(dd.cfgProp[tid]['tips'],{dd.cfgProp[tid]['tips1_lan']}), "Helvetica", 20)
    richText1:insertElement(chatlv,count1)
    count1 = count1 + 1

   
    richText1:formatText()
    --计算高度
    local height = 0
    local size1 = richText1:getContentSize()
    height = size1.height

    richText1:setPosition(cc.p(184,height - size1.height/2 + 80 -30))

    list:getChildByName("tips"):setContentSize(cc.size(652, height + 95))
    list:getChildByName("tips"):getChildByName("tips"):setContentSize(cc.size(652, height + 95))
    list:getChildByName("tips"):getChildByName("tips"):addChild(richText1)

    list:getChildByName("tips"):getChildByName("name"):setPositionY(height + 95 - 18)
    list:getChildByName("tips"):getChildByName("flag"):setPositionX(55 + ((count-1)%4)*176 )
    list:getChildByName("tips"):getChildByName("flag"):setPositionY(height + 95 - 4)

    return height + 95 + 20
end

function warehouseLayer.onClickGem(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then   
            local widget = pop.getDialog("warehouse")
            if sender:getSelectedState() == true then
                for i,item in ipairs(widget._gitems) do
                    if item then
                        item:getChildByName("check"):setSelectedState(false)
                    end
                end
                widget:updateGemPos(1,0)
            else
                for i,item in ipairs(widget._gitems) do
                    if item then
                        item:getChildByName("check"):setSelectedState(false)
                    end
                end
                sender:setSelectedState(true)
                local addhh = widget:showGemTips(sender.id,sender.count)
                widget:updateGemPos(sender.count,addhh)
            end 
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("warehouse")
        if sender:getSelectedState() == true then
            for i,item in ipairs(widget._gitems) do
                if item then
                    item:getChildByName("check"):setSelectedState(false)
                end
            end
            --此处设置true 结束会设置相反状态 上面的不会
            sender:setSelectedState(true)
            widget:updateGemPos(1,0)
        else
            for i,item in ipairs(widget._gitems) do
                if item then
                    item:getChildByName("check"):setSelectedState(false)
                end
            end
            local addhh = widget:showGemTips(sender.id,sender.count)
            widget:updateGemPos(sender.count,addhh)
        end 
        doaction = true
    end
    if doaction == true then 
    end
end

--晶体
function warehouseLayer:updateCryList()
    local view = self:getChildByName("mainArea"):getChildByName("view3")
    view:getChildByName("tips"):setVisible(false)
    local hh = view:getContentSize().height
    local num = dd.myCrystals:rowCount()
    local innerhh = 0
    local count = 1
    local row = math.ceil(num/4)
    if row < self._rows then
        row = self._rows
    end
    view:jumpToTop()
    --隐藏items
    for i,v in ipairs(self._citems) do
        if tolua.isnull(v) then
            self._citems[i] = nil
        else
            v:setVisible(false)
            v:setTag(i)
            v:getChildByName("check"):setSelectedState(false)
        end
    end

    if row*177 > hh then
        view:setInnerContainerSize(cc.size(720,row*177))
        innerhh = row*177 + 10
    else
        view:setInnerContainerSize(cc.size(720,hh))
        innerhh = hh
    end
    
    self._cinnerhh = innerhh

    if dd.myCrystals:rowCount() <= self._rows*4 then
        for i=1, dd.myCrystals:rowCount() do
            self:addCryItem(innerhh,i,i)
            count = count + 1
        end 
        for i=dd.myCrystals:rowCount()+1,row*4 do
            self:addCryItem(innerhh,0,i)
        end
    else
        for i=1, self._rows*4 do
            self:addCryItem(innerhh,i,i)
            count = count + 1
        end
        local function add_sche()
            if count <= dd.myCrystals:rowCount() then
                self:addCryItem(innerhh,count,count)
                count = count + 1
            else
                for i=count,row*4 do
                    self:addCryItem(innerhh,0,i)
                end
                self:getChildByName("mainArea"):getChildByName("view3"):stopAllActions()
                cclog("已停止添加脚本 ==========徽章 ")
            end
        end
        cclog("开启添加脚本 =========徽章 ")
        schedule(self:getChildByName("mainArea"):getChildByName("view3"), add_sche,0.01)
    end      
end

function warehouseLayer:addCryItem(innerhh,i,count)
    local item = self._citems[count]
    if item == nil then
        item = self:getChildByName("mainArea"):getChildByName("cryitem"):clone()
        self._citems[count] = item
        self:getChildByName("mainArea"):getChildByName("view3"):addChild(item)
    end
    item:setVisible(true)        
    item:setPositionX(25 + ((count-1)%4)*176 )
    item:setPositionY(innerhh - 170 - math.floor((count-1)/4)*177 )
    
    if i == 0 then
        item:getChildByName("back"):loadTexture(dd.getPathFromUI("c_box_1.png",1))
        item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        item:getChildByName("level"):getChildByName("level"):setString("")
        item:getChildByName("check"):setTouchEnabled(false)
    else
        local cid = dd.myCrystals:getLong(i,"id")
        local level = dd.myCrystals:getLong(i,"level")
        
        local color =  dd.cfgCrystal[cid]['color']
        if color > 5 then
            color = 5 --白绿蓝紫(橙红 缺)
        end

        item:getChildByName("back"):loadTexture(dd.getPathFromUI("c_box_"..color..".png",1))
        item:getChildByName("icon"):loadTexture(dd.getHuizhangIcon(cid),0)
        item:getChildByName("level"):getChildByName("level"):setString("LV."..level)

        item:getChildByName("check"):loadTextureBackGroundSelected(
            dd.getPathFromUI("c_onbox_"..color..".png",1))
        item:getChildByName("check"):loadTextureFrontCross(
            dd.getPathFromUI("c_onbox_"..color..".png",1))

        item:getChildByName("check"):setTouchEnabled(true)
        item:getChildByName("check"):addTouchEventListener(self.onClickCry)
        item:getChildByName("check").count = count
        item:getChildByName("check").row = i
    end
end

function warehouseLayer:updateCryPos(tcount,addhh)
    local innerhh = self._cinnerhh + addhh
    local count   = 1
    local addline = math.floor((tcount-1)/4)

    self:getChildByName("mainArea"):getChildByName("view3"):setInnerContainerSize(cc.size(720,innerhh))

    if addhh == 0 then
        self:getChildByName("mainArea"):getChildByName("view3"):getChildByName("tips"):setVisible(false)
    else
        --设置tips位置
        local tips = self:getChildByName("mainArea"):getChildByName("view3"):getChildByName("tips")
        tips:setPositionY(innerhh + 0 - addhh - 170 - addline*177)
        if tips:isVisible() == true then
            local fixy = self:getChildByName("mainArea"):getChildByName("view3"):getInnerContainer():getPositionY() + tips:getPositionY()
            if fixy < 0 then
                self:getChildByName("mainArea"):getChildByName("view3"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,-fixy)))
            end
        end
    end
    
    for i,item in ipairs(self._citems) do
        if item and item:isVisible() == true then
            if math.floor((count-1)/4) > addline then
                item:setPositionX(25 + ((count-1)%4)*176 )
                item:setPositionY(innerhh - addhh - 170 - math.floor((count-1)/4)*177 )
            else                
                item:setPositionX(25 + ((count-1)%4)*176 )
                item:setPositionY(innerhh - 170 - math.floor((count-1)/4)*177 )
            end
            count = count + 1
        end
    end
end

function warehouseLayer:showCryTips(row,count)
    local list  = self:getChildByName("mainArea"):getChildByName("view3")
    list:getChildByName("tips"):getChildByName("tips"):removeAllChildren(true)
    list:getChildByName("tips"):setVisible(true)

    list:getChildByName("tips"):getChildByName("equipbtn"):setTag(dd.myCrystals:getLong(row,'cid'))
    --左边
    local richText1 = ccui.RichText:create()
    richText1:ignoreContentAdaptWithSize(false)
    richText1:setContentSize(cc.size(350,600)) 
    richText1:setAutoHeight() 

    local tid = dd.myCrystals:getLong(row,'id')
    local name = ff.langString(dd.cfgCrystal[tid]['name'])
    list:getChildByName("tips"):getChildByName("name"):setString(name)
    --exp晶体不能升级
    if dd.cfgCrystal[tid]["expcrystal"] == 1 then
        self:setBtnLight(list:getChildByName("tips"):getChildByName("equipbtn"), false)
    else
        self:setBtnLight(list:getChildByName("tips"):getChildByName("equipbtn"), true)
    end

    --装备效果
    local count1 = 0
    local lv = dd.myCrystals:getLong(row,'level')   
    local upexp = 99999   --dd.cfgCrystal[id]['exp']
    if dd.cfgCrystalLevelUp[dd.cfgCrystal[tid]["color"]][lv + 1]["exp"] ~= nil then
        upexp = dd.cfgCrystalLevelUp[dd.cfgCrystal[tid]["color"]][lv + 1]["exp"]   
    end      

    local chat1 = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n".."LV."..lv..": "..dd.myCrystals:getLong(row,'curexp').."/"..upexp, "Helvetica", 20)
    richText1:insertElement(chat1,count1)
    count1 = count1 + 1     
    
    for k=1,2 do
        local param = dd.cfgCrystal[tid]['param'..k]  
        if param > 0 then
            local tempstr = dd.cfgEffect[param]['tips1']
            local value = math.floor(dd.cfgCrystal[tid]['value'..k] + dd.cfgCrystal[tid]['addvalue'..k]*(lv-1)/10)
            local chat2 = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n"..ff.langString(tempstr, {value}), "Helvetica", 20)
            richText1:insertElement(chat2,count1)
            count1 = count1 + 1  
        end
    end
   
    richText1:formatText()
    --计算高度
    local height = 0
    local size1 = richText1:getContentSize()
    height = size1.height

    richText1:setPosition(cc.p(184,height - size1.height/2 + 80 -30))

    list:getChildByName("tips"):setContentSize(cc.size(652, height + 85))
    list:getChildByName("tips"):getChildByName("tips"):setContentSize(cc.size(652, height + 85))
    list:getChildByName("tips"):getChildByName("tips"):addChild(richText1)

    list:getChildByName("tips"):getChildByName("name"):setPositionY(height + 85 - 18)
    list:getChildByName("tips"):getChildByName("flag"):setPositionX(60 + ((count-1)%4)*176 )
    list:getChildByName("tips"):getChildByName("flag"):setPositionY(height + 85 - 4)

    return height + 85 + 20
end

function warehouseLayer.onClickCry(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then   
            local widget = pop.getDialog("warehouse")
            if sender:getSelectedState() == true then
                for i,item in ipairs(widget._citems) do
                    if item then
                        item:getChildByName("check"):setSelectedState(false)
                    end
                end
                widget:updateCryPos(1,0)
            else
                for i,item in ipairs(widget._citems) do
                    if item then
                        item:getChildByName("check"):setSelectedState(false)
                    end
                end
                sender:setSelectedState(true)
                local addhh = widget:showCryTips(sender.row,sender.count)
                widget:updateCryPos(sender.count,addhh)
            end 
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("warehouse")
        if sender:getSelectedState() == true then
            for i,item in ipairs(widget._citems) do
                if item then
                    item:getChildByName("check"):setSelectedState(false)
                end
            end
            --此处设置true 结束会设置相反状态 上面的不会
            sender:setSelectedState(true)
            widget:updateCryPos(1,0)
        else
            for i,item in ipairs(widget._citems) do
                if item then
                    item:getChildByName("check"):setSelectedState(false)
                end
            end
            local addhh = widget:showCryTips(sender.row,sender.count)
            widget:updateCryPos(sender.count,addhh)
        end 
        doaction = true
    end
    if doaction == true then 
    end
end

function warehouseLayer:setBtnLight(node, light)
    if light == true then
        node:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        node:setTouchEnabled(true)
        node:getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
    else 
        local effect = ff.Effect:effectGrey()    
        node:getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        node:setTouchEnabled(false)
        node:getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
    end
end

function warehouseLayer:getMyPropsInfo()
    local message = ff.net:createMessage()
    message:addCmd(0x00a)
    message:addLong(dd.uid)
    ff.net:rpc(message, false)
end
function warehouseLayer:getMyCrystalsInfo()
    local message = ff.net:createMessage()
    message:addCmd(0x044)
    message:addLong(dd.uid)
    ff.net:rpc(message, false)
end

function warehouseLayer:onGetMyPropsInfo(params)
    local code = params[1]
    if code == 0 then
        if dd.mytools ~= nil then
            dd.mytools:clear()
        end    
        dd.mytools =  params[2]
        
        self:updateList(self._selectType)
    end
end

function warehouseLayer:onGemDecompose( params )
    local code = params[1]
    if code == 0 then
        if dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("分解成功，获得{0}合金粉末",{params[2]}),true)
        end
        self:updateList(self._selectType)
    end
end

function warehouseLayer:onEquipSell( params )
    local code = params[1]
    if code == 0 then
        if dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("分解成功，获得{0}银币",{self._sell_silver}),true)
        end
        self:updateList(self._selectType)
    end
end

function warehouseLayer:onGetMyCrystalInfo(params)
    local code = params[1]
    if code == 0 then
        local info = params[2]
        for i=1,info:rowCount() do
            cclog("sssscfgid"..info:getLong(i,"id"))
            cclog("ssss服务端id"..info:getLong(i,"cid"))
            cclog("ssss服务端level"..info:getLong(i,"level"))
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
function warehouseLayer:onCrystalUpgrade(params)
    local code = params[1]
    if code == 0 then
        self:updateList(self._selectType)
    end
end

function warehouseLayer:onGemsCompose(params)
    local code = params[1]
    if code == 0 then
        self:updateList(self._selectType)
    end
end

function warehouseLayer.getColor(color)
    local colorcode = cc.c3b(196,213,214)
    if color == 1 then
        colorcode = cc.c3b(196,213,214)
    elseif color == 2 then
        colorcode = cc.c3b(75,137,81)
    elseif color == 3 then
        colorcode = cc.c3b(63,116,160)
    elseif color == 4 then
        colorcode = cc.c3b(164,80,151)
    elseif color == 5 then
        colorcode = cc.c3b(255,250,106)
    else
        colorcode = cc.c3b(196,213,214)
    end
    return colorcode
end

function warehouseLayer.setTipsColor(node, color)
    local colorcode = cc.c3b(196,213,214)
    if color == 1 then
        colorcode = cc.c3b(196,213,214)
    elseif color == 2 then
        colorcode = cc.c3b(75,137,81)
    elseif color == 3 then
        colorcode = cc.c3b(63,116,160)
    elseif color == 4 then
        colorcode = cc.c3b(164,80,151)
    elseif color == 5 then
        colorcode = cc.c3b(255,250,106)
    else
        colorcode = cc.c3b(196,213,214)
    end
    node:setColor(colorcode)
end
--接口
function warehouseLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("warehouse")
        if widget ~= nil then
            pop.onClosePopDialog("warehouse")
        end
    end
end

function warehouseLayer:onClose()

end

function warehouseLayer.onStart(sender)
    ff.net:registerEvent(3,dd.Tjf_GemDecompose,function (message)sender:onGemDecompose(message)end)
    ff.net:registerEvent(3,dd.Tjf_EquipSell,function (message)sender:onEquipSell(message)end)
    ff.net:registerEvent(3,dd.Tjf_prop_info, function (message)sender:onGetMyPropsInfo(message)end)
    ff.net:registerEvent(3,dd.Tjf_crystal_info, function (message)sender:onGetMyCrystalInfo(message)end)
    ff.net:registerEvent(3,dd.Tjf_crystal_upgrade, function (message)sender:onCrystalUpgrade(message)end)
    ff.net:registerEvent(3,dd.Tjf_gem_compose,function (message)sender:onGemsCompose(message)end)
    ff.net:bindProperty(2505,"gold",sender.updateGold)
    sender:updateList(sender._selectType)
end

function warehouseLayer.onEnd(sender)
    dd.delBackEvent()
    ff.net:removeEvent(3,dd.Tjf_EquipSell)
    ff.net:removeEvent(3,dd.Tjf_GemDecompose)
    ff.net:removeEvent(3,dd.Tjf_prop_info)
    ff.net:removeEvent(3,dd.Tjf_crystal_info)
    ff.net:removeEvent(3,dd.Tjf_crystal_upgrade)
    ff.net:removeEvent(3,dd.Tjf_gem_compose)
    ff.net:unbindProperty("gold",2505)
    if ff.platform ~= 1 then
        for i,item in ipairs(sender._mitems) do
            if item then
                item:getChildByName("back"):loadTexture(dd.getPathFromUI("public/v2/ui_boxs_1.png",1))
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("check"):loadTextureBackGroundSelected(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("check"):loadTextureFrontCross(dd.getPathFromUI("public/alpha.png",1))
            end
        end
        for i,item in ipairs(sender._gitems) do
            if item then
                item:getChildByName("back"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("check"):loadTextureBackGroundSelected(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("check"):loadTextureFrontCross(dd.getPathFromUI("public/alpha.png",1))
            end
        end
        for i,item in ipairs(sender._citems) do
            if item then
                item:getChildByName("back"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("check"):loadTextureBackGroundSelected(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("check"):loadTextureFrontCross(dd.getPathFromUI("public/alpha.png",1))
            end
        end
        for i,item in ipairs(sender._eitems) do
            if item then
                item:getChildByName("back"):loadTexture(dd.getPathFromUI("public/v2/ui_boxs_1.png",1))
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("check"):loadTextureBackGroundSelected(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("check"):loadTextureFrontCross(dd.getPathFromUI("public/alpha.png",1))
            end
        end
    end
    --sender:updateEquipPos(1,0)
    --sender:updateMaterialPos(1,0)
    --sender:updateGemPos(1,0)
    --sender:updateCryPos(1,0)
    sender:getChildByName("mainArea"):getChildByName("view"):stopAllActions()
    sender:getChildByName("mainArea"):getChildByName("view2"):stopAllActions()
    sender:getChildByName("mainArea"):getChildByName("view3"):stopAllActions()
    sender:getChildByName("mainArea"):getChildByName("view4"):stopAllActions()
end
function warehouseLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    
        sender:getChildByName("topNavi"):setVisible(false)
        sender:getChildByName("topNavi2"):setVisible(false)
        sender:getChildByName("topNavi3"):setVisible(true)
        sender:getChildByName("topNavi"):setTouchEnabled(false)
        sender:getChildByName("topNavi2"):setTouchEnabled(false)
        sender:getChildByName("topNavi3"):setTouchEnabled(true)
    --end
    return true
end
function warehouseLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("warehouse")
    if widget then
        pop.onClosePopDialog("warehouse")
    end
end

function onShowWarehouseLayer(widget, parent)
    local layer = warehouseLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onAutoSize()
    layer:onInit()
    return layer
end