--司令部升级
local gameStarLayer   = class("gameStarLayer")
gameStarLayer._name = "gameStar"
gameStarLayer._init = false
gameStarLayer._state = {0,0,0,0,0}
gameStarLayer.haveGoldReward = false
function gameStarLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, gameStarLayer)
    return target
end
function gameStarLayer:onInit()
    if self._init == false then
        local function onClose(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
            
                        pop.onClosePopDialog("gameStar")
                   
            end
        end
        local function getGold(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local num = 0
                for key, var in ipairs(self._state) do
                	num = num + var
                end
                dd.openGameStar['star'] = num
                if num >= 5 then
                    local message = ff.net:createMessage()
                    message:addCmd(0x13d)
                    message:addLong(dd.uid)
                    message:addLong(1)
                    message:addLong(5)
                    ff.net:postMessage(message)
         
                        platform_gameStar(dd.openGameStar['star'])
                        pop.onClosePopDialog("gameStar")
                    --end
                --else
                    
                 --   pop.onClosePopDialog("gameStar")
                end
            end
        end
        local function onTouch(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local tag = sender:getTag()
                for key=1, 5 do
                    if key <= tag then
                        self._state[key] = 1
                    else
                        self._state[key] = 0
                    end                	
                end                
                self:initGift()
            end
        end
        local function onSure(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
               local num = 0
                for key, var in ipairs(self._state) do
                    num = num + var
                end
                dd.openGameStar['star'] = num
                platform_gameStar(dd.openGameStar['star'])
                pop.onClosePopDialog("gameStar")             
            end
        end
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("cancel_btn"):addTouchEventListener(onClose)
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("save_btn"):addTouchEventListener(onSure)
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("star_1"):addTouchEventListener(onTouch)
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("star_2"):addTouchEventListener(onTouch)
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("star_3"):addTouchEventListener(onTouch)
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("star_4"):addTouchEventListener(onTouch)
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("star_5"):addTouchEventListener(onTouch)        
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("get_btn"):addTouchEventListener(getGold)
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("get_btn"):getChildByName("chu_Label_49"):setString(ff.langString("前往"))
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("cancel_btn"):getChildByName("chu_Label_49"):setString(ff.langString("取消"))
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("save_btn"):getChildByName("chu_Label_49"):setString(ff.langString("反馈"))
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("chu_label"):setString(ff.langString("请给Z war评分"))
        self._init = true
    end
    self:initGift()
end

function gameStarLayer:initGift()
    local num = 0
    for key, var in ipairs(self._state) do
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("star_"..key):loadTexture(dd.getPathFromUI("star_"..var..".png",1))
        num = num + var
    end

    if num >= 5 then
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("get_btn"):setVisible(true)
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("cancel_btn"):setVisible(false)
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("save_btn"):setVisible(false)
    elseif num > 0 then
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("get_btn"):setVisible(false)
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("cancel_btn"):setVisible(true)
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("save_btn"):setVisible(true)
    else
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("get_btn"):setVisible(false)
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("cancel_btn"):setVisible(false)
        self:getChildByName("view"):getChildByName("state_1"):getChildByName("save_btn"):setVisible(false)
    end

end

--界面显示后调用
function gameStarLayer.onStart(sender)
    sender:getChildByName("view"):getChildByName("state_1"):setVisible(true)
    sender:getChildByName("view"):getChildByName("state_1"):setEnabled(true) 
    sender:getChildByName("view"):getChildByName("state_2"):setVisible(false)
    sender:getChildByName("view"):getChildByName("state_2"):setEnabled(false)
    local level = dd.myinfo:getLong(1,"level")
    if level == 6 then
        sender:getChildByName("view"):getChildByName("state_1"):getChildByName("gold"):setVisible(false)
    else
        sender:getChildByName("view"):getChildByName("state_1"):getChildByName("gold"):setVisible(true)
    end
    sender:getChildByName("view"):getChildByName("state_1"):getChildByName("get_btn"):setVisible(false)
    sender:getChildByName("view"):getChildByName("state_1"):getChildByName("cancel_btn"):setVisible(false)
    sender:getChildByName("view"):getChildByName("state_1"):getChildByName("save_btn"):setVisible(false)


end
--界面关闭效果结束后调用
function gameStarLayer.onEnd(sender)
    dd.delBackEvent()
    sender._state = {0,0,0,0,0}
end

--界面即将播放显示缓动时调用，返回false界面显示将终止
function gameStarLayer.onBefore(sender)
    if sender._init == false then
        local hh = ff.height
        sender:setContentSize(cc.size(720,hh))
        sender:getChildByName("mask"):setContentSize(cc.size(720,hh))
        sender:getChildByName("view"):setPositionY(0)
    end
    sender:onInit()
    return true
end
function gameStarLayer:onClose()
    return false
end

function gameStarLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("gameStar")
        if widget~=nil and widget:onClose() == false then
            pop.onClosePopDialog("gameStar")
        end    
    end
end
function onShowGameStar(widget)
    local layer = gameStarLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    return layer
end