--民居
local rareEarthLayer   = class("rareEarthLayer")
rareEarthLayer._name = "rareEarthLayer"
rareEarthLayer._init = false
rareEarthLayer._pos  = 0
rareEarthLayer._bid  = 0
rareEarthLayer._lv  = 0
rareEarthLayer._effect = false

function rareEarthLayer:onInit()
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"pos") == self._pos then
            self._bid = dd.mybuilds:getLong(i,"bid")
            self._lv = dd.mybuilds:getLong(i,"level")
            break
        end
    end
    if self._lv == 0 then
        self._lv = 1 --刚建造的时候按照1级的数据处理
    end
    local area_2 = self:getChildByName("mainArea"):getChildByName("area_2")

    local buildNum = 0
    local pro_all = 0
    local limit_base = 0 
    for var=1, dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(var,"bid") == self._bid then
            buildNum = buildNum + 1
            local lv = dd.mybuilds:getLong(var,"level")
            if lv <= 0 then
                lv = 1
            end
            pro_all = pro_all + dd.cfgBuildingUp[self._bid][dd.mybuilds:getLong(var,"level")]['value1']
            limit_base = limit_base + dd.cfgBuildingUp[self._bid][dd.mybuilds:getLong(var,"level")]['value2']
        end
    end

    area_2:getChildByName("build_num_text"):setString(buildNum)
    area_2:getChildByName("pro_text"):setString(dd.showKM(dd.cfgBuildingUp[self._bid][self._lv]['value1'],5).."/h")
    area_2:getChildByName("pro_all_text"):setString(dd.showKM(pro_all,6).."/h")
    area_2:getChildByName("now_text"):setString(dd.showKM(dd.gold(),6))

    local add = 0 
    local limit = limit_base
    if add > 0 then
        area_2:getChildByName("add_text"):setString("+"..(add/10).."%")
        area_2:getChildByName("add_text"):setVisible(true)
    else
        area_2:getChildByName("add_text"):setVisible(false)
    end
    area_2:getChildByName("limit_text"):setString(limit)
    if dd.gold() > limit then
        area_2:getChildByName("limit_text"):setColor(cc.c3b(120,27,35))
    else
        area_2:getChildByName("limit_text"):setColor(cc.c3b(255,255,255))
    end
    if self._init == false then
        self:getChildByName("mainArea"):getChildByName("panel_notice"):getChildByName("notice_text"):setString(ff.langString(dd.cfgBuilding[self._bid]['tips2']))
    end
end

function rareEarthLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, rareEarthLayer)
    return target
end
--界面显示后调用
function rareEarthLayer.onStart(sender)
end
--界面关闭效果结束后调用
function rareEarthLayer.onEnd(sender)
end
--界面即将播放显示缓动时调用，返回false界面显示将终止
function rareEarthLayer.onBefore(sender)
    if sender._init == false then
        local hh = ff.height
        if dd.currentPopLayer ~= nil then
            hh = dd.currentPopLayer:getContentSize().height
        end
        sender:setContentSize(cc.size(720,hh - 184))
        sender:getChildByName("mainArea"):setContentSize(cc.size(720,hh - 184))
        sender:getChildByName("mainArea"):setPositionY(50)

        sender._init = true
    end  
    return false
end

function onShowRareEarth(widget,pos,lastpos)
    local layer = rareEarthLayer.extend(widget)
    layer:setVisible(false)
    if lastpos == pos then
        layer._effect = false
    else
        layer._effect = true
    end 
    layer._pos = pos
    layer:onInit()
    return layer
end