
TaskNewbieLayer = class("TaskNewbieLayer")
TaskNewbieLayer._name = "TaskNewbie"
TaskNewbieLayer._init = false
TaskNewbieLayer._Cfg_Task = {}

function TaskNewbieLayer.extend( target )
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target,t)
    end
    setmetatable(t,TaskNewbieLayer)
    return target
    -- body
end

function TaskNewbieLayer:onAutoSize()
    local hh = ff.height
    self:setContentSize(cc.size(720,hh))
    self:getChildByName("mask"):setContentSize(cc.size(720,hh))
    --local h = hh/2 - 350
    self:getChildByName("view"):setPositionY(214)

    self:getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onReturn)
    self:getChildByName("view"):getChildByName("pay"):addTouchEventListener(self.onPay)

end

function TaskNewbieLayer.onPay( sender,eventType  )
    -- body
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("TaskNewbie")
        if widget == nil then
            return
        end

        if widget._Cfg_Task[dd.myinfo:getLong(1,"TaskNewbieId")]["triggertype"] < 7 then
            if dd.myinfo:getLong(1,"TaskNewbieTime") < dd.getServerTime() then
                if dd.currentLayer._widget ~= nil then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("超时"))  
                end
                pop.onClosePopDialog("TaskNewbie")
                return
            end
            if widget._Cfg_Task[dd.myinfo:getLong(1,"TaskNewbieId")]["triggertype"] == 2 then
                if dd.wood() >= widget._Cfg_Task[dd.myinfo:getLong(1,"TaskNewbieId")]["target"] then
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000173)
                    message:addLong(dd.uid)

                    ff.net:rpc(message,false) 
                    pop.onClosePopDialog("TaskNewbie")
                else
                   pop.onClosePopDialog("TaskNewbie")
                end
            elseif widget._Cfg_Task[dd.myinfo:getLong(1,"TaskNewbieId")]["triggertype"] == 4  then
                if dd.food() >= widget._Cfg_Task[dd.myinfo:getLong(1,"TaskNewbieId")]["target"] then
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000173)
                    message:addLong(dd.uid)

                    ff.net:rpc(message,false) 
                    pop.onClosePopDialog("TaskNewbie")
                else
                    pop.onClosePopDialog("TaskNewbie")
                end
            elseif widget._Cfg_Task[dd.myinfo:getLong(1,"TaskNewbieId")]["triggertype"] == 5 then
                if dd.silver() >= widget._Cfg_Task[dd.myinfo:getLong(1,"TaskNewbieId")]["target"] then
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000173)
                    message:addLong(dd.uid)

                    ff.net:rpc(message,false) 
                    pop.onClosePopDialog("TaskNewbie")
                else
                    pop.onClosePopDialog("TaskNewbie")
                end
            end
        else
            if dd.myinfo:getLong(1,"TaskNewbieStep") >= widget._Cfg_Task[dd.myinfo:getLong(1,"TaskNewbieId")]["target"] then
            
                local message = ff.net:createMessage()
                message:addCmd(0x00000173)
                message:addLong(dd.uid)

                ff.net:rpc(message,false) 
                pop.onClosePopDialog("TaskNewbie")
            else
                pop.onClosePopDialog("TaskNewbie")
            end
        end
    end
end

function onShowTaskNewbie( widget )
    -- body
    local layer = TaskNewbieLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)

    layer:onInit()
    return layer
end

function TaskNewbieLayer:onInit( )
    -- body
    if self._init == false then
        self:onAutoSize()
        self._init = true
  end
  self:initDate()
 
end

function TaskNewbieLayer:initDate(  )
    local propData1 = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_ruins`")
    for i=1, propData1:rowCount() do
        local id = tonumber(propData1:getString(i, "id"))
        self._Cfg_Task[id] = {}
        self._Cfg_Task[id]["target"] = tonumber(propData1:getString(i, "target"))
        self._Cfg_Task[id]['reward']   = propData1:getString(i, "reward")
        self._Cfg_Task[id]['triggertype']   = tonumber(propData1:getString(i, "triggertype"))
        self._Cfg_Task[id]['parameter']   = tonumber(propData1:getString(i, "parameter"))
        if ff.lang == -1 then
            self._Cfg_Task[id]['name']   = propData1:getString(i, "name")
            self._Cfg_Task[id]['disc']   = propData1:getString(i, "disc")
            self._Cfg_Task[id]['targetdisc']   = propData1:getString(i, "targetdisc")
        else    
            self._Cfg_Task[id]['name']   = tonumber(propData1:getString(i, "name_lan"))
            self._Cfg_Task[id]['disc']   = tonumber(propData1:getString(i, "disc_lan"))
            self._Cfg_Task[id]['targetdisc']   = tonumber(propData1:getString(i, "targetdisc_lan"))
        end
        
    end
    propData1:clear()
end

function TaskNewbieLayer.onReturn( sender,eventType )
    -- body
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("TaskNewbie")
            if widget == nil then
                return
            end
        pop.onClosePopDialog("TaskNewbie")
    end
end

function TaskNewbieLayer:showList(  )
    if dd.myinfo:getLong(1,"TaskNewbieId") ~= 0 then
        local id = dd.myinfo:getLong(1,"TaskNewbieId")
        if self._Cfg_Task[id] == nil then
            return
        end
        local item = self:getChildByName("view")
        
        item:getChildByName("title"):getChildByName("chu_title"):setString(ff.langString(self._Cfg_Task[id]["name"]))
        local time = dd.myinfo:getLong(1,"TaskNewbieTime") - dd.getServerTime()
        item:getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,"   "))

        item:getChildByName("info"):getChildByName("info1"):setString(ff.langString(self._Cfg_Task[id]["disc"]))

        local giftInfo = Split(self._Cfg_Task[id]["reward"],'|')
       
        for k,v in pairs(giftInfo) do
            local gift = Split(v,'%^')
      
            if item:getChildByName("reward"):getChildByName("ico"..tostring(k)) ~= nil  then
                item:getChildByName("reward"):getChildByName("ico"..tostring(k)):setVisible(true)
                item:getChildByName("reward"):getChildByName("count"..tostring(k)):setVisible(true)
                item:getChildByName("reward"):getChildByName("ico"..tostring(k)):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                item:getChildByName("reward"):getChildByName("count"..tostring(k)):setString(ff.getFormatMoney(gift[3]))
            end
            
        end

        if self._Cfg_Task[id]["triggertype"] < 7 then
            item:getChildByName("info"):getChildByName("info2"):setString(ff.langString(self._Cfg_Task[id]["targetdisc"]))
            item:getChildByName("info"):getChildByName("ico"):loadTexture(dd.getGiftsIcon((self._Cfg_Task[id]["triggertype"]+1), 0)[1],dd.getGiftsIcon(self._Cfg_Task[id]["triggertype"], 0)[2])
            if self._Cfg_Task[id]["triggertype"] == 2 then
                item:getChildByName("info"):getChildByName("count"):setString(ff.getFormatMoney(dd.wood()).."/"..ff.getFormatMoney(self._Cfg_Task[id]["target"]))
            elseif self._Cfg_Task[id]["triggertype"] == 4  then
                item:getChildByName("info"):getChildByName("count"):setString(ff.getFormatMoney(dd.food()).."/"..ff.getFormatMoney(self._Cfg_Task[id]["target"]))
            elseif self._Cfg_Task[id]["triggertype"] == 5 then
                item:getChildByName("info"):getChildByName("count"):setString(ff.getFormatMoney(dd.silver()).."/"..ff.getFormatMoney(self._Cfg_Task[id]["target"]))
            end

        elseif self._Cfg_Task[id]["triggertype"] >= 7 and self._Cfg_Task[id]["triggertype"] < 15 then
            item:getChildByName("info"):getChildByName("info2"):setString(ff.langString(self._Cfg_Task[id]["targetdisc"],{ff.getFormatMoney(dd.myinfo:getLong(1,"TaskNewbieStep"))}).."/"..ff.getFormatMoney(self._Cfg_Task[id]["target"]))
        else
            item:getChildByName("info"):getChildByName("info2"):setString(ff.langString(self._Cfg_Task[id]["targetdisc"],{self._Cfg_Task[id]["parameter"]}))
        end
        item:getChildByName("info"):requestDoLayout()
        item:getChildByName("reward"):requestDoLayout()
    end
end

function TaskNewbieLayer.update( sender )
    -- body
    if dd.myinfo:getLong(1,"TaskNewbieId") ~= 0 then
        local id = dd.myinfo:getLong(1,"TaskNewbieId")
        if sender._Cfg_Task[id] == nil then
            return
        end
        local item = sender:getChildByName("view")
        
        local time = dd.myinfo:getLong(1,"TaskNewbieTime") - dd.getServerTime()
        item:getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,"   "))
        if sender._Cfg_Task[id]["triggertype"] < 7 then
            if sender._Cfg_Task[id]["triggertype"] == 2 then
                if dd.wood() >= sender._Cfg_Task[dd.myinfo:getLong(1,"TaskNewbieId")]["target"] then
                    sender:getChildByName("view"):getChildByName("pay"):getChildByName("info1"):setVisible(false)
                    sender:getChildByName("view"):getChildByName("pay"):getChildByName("info2"):setVisible(true)
                else
                    sender:getChildByName("view"):getChildByName("pay"):getChildByName("info2"):setVisible(false)
                    sender:getChildByName("view"):getChildByName("pay"):getChildByName("info1"):setVisible(true)
                end
            elseif sender._Cfg_Task[id]["triggertype"] == 4  then
                if dd.food() >= sender._Cfg_Task[dd.myinfo:getLong(1,"TaskNewbieId")]["target"] then
                    sender:getChildByName("view"):getChildByName("pay"):getChildByName("info1"):setVisible(false)
                    sender:getChildByName("view"):getChildByName("pay"):getChildByName("info2"):setVisible(true)
                else
                    sender:getChildByName("view"):getChildByName("pay"):getChildByName("info2"):setVisible(false)
                    sender:getChildByName("view"):getChildByName("pay"):getChildByName("info1"):setVisible(true)
                end
            elseif sender._Cfg_Task[id]["triggertype"] == 5 then
                if dd.silver() >= sender._Cfg_Task[dd.myinfo:getLong(1,"TaskNewbieId")]["target"] then
                    sender:getChildByName("view"):getChildByName("pay"):getChildByName("info1"):setVisible(false)
                    sender:getChildByName("view"):getChildByName("pay"):getChildByName("info2"):setVisible(true)
                else
                    sender:getChildByName("view"):getChildByName("pay"):getChildByName("info2"):setVisible(false)
                    sender:getChildByName("view"):getChildByName("pay"):getChildByName("info1"):setVisible(true)
                end
            end
        else
            if dd.myinfo:getLong(1,"TaskNewbieStep") >= sender._Cfg_Task[dd.myinfo:getLong(1,"TaskNewbieId")]["target"] then
                sender:getChildByName("view"):getChildByName("pay"):getChildByName("info1"):setVisible(false)
                sender:getChildByName("view"):getChildByName("pay"):getChildByName("info2"):setVisible(true)
            else
                sender:getChildByName("view"):getChildByName("pay"):getChildByName("info2"):setVisible(false)
                sender:getChildByName("view"):getChildByName("pay"):getChildByName("info1"):setVisible(true)
            end
        end
    end
end

function TaskNewbieLayer.onEnd( sender )
    -- body
    if ff.platform ~= 1 then
        local item = sender:getChildByName("view")
        item:getChildByName("info"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        item:getChildByName("info"):getChildByName("count"):setString("")
        for i=1,3 do
            if item:getChildByName("reward"):getChildByName("ico"..tostring(i)) ~= nil  then
                item:getChildByName("reward"):getChildByName("ico"..tostring(i)):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("reward"):getChildByName("count"..tostring(i)):setString("")
            end
        end
    end
   
    sender:stopAllActions()
    
end

function TaskNewbieLayer.onBefore( sender)
  -- body
    
    schedule(sender, sender.update,1)
    sender:showList()
end

function TaskNewbieLayer.onStart( sender )
  -- body
    sender.update(sender)
end

