--heroskill
local heroskillLayer = class("heroskill")
heroskillLayer._name = "heroskill"
heroskillLayer._init = false
heroskillLayer._selectindex = 1

heroskillLayer._points = 0  --技能点数
heroskillLayer._toskilllv = 0

heroskillLayer._curpoints = 0  --技能点数
heroskillLayer._curskilllv = 0
heroskillLayer._curskillid = 0

heroskillLayer._cfgskillshow = {}
heroskillLayer._cfgheroskillup = {}

heroskillLayer._items = {}

function heroskillLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, heroskillLayer)
    return target
end

function heroskillLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("masking"):setContentSize(cc.size(720,hh -105))
        self:getChildByName("masking"):setPositionY(0)
        self:getChildByName("bg"):setContentSize(cc.size(720,hh))
        self:getChildByName("bg"):setPositionY(0)
        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("top"):setPositionY(hh - 105 - 32)
        self:getChildByName("refshbtn"):setPositionY(hh - 105 - 42 - 60)
        self:getChildByName("mainArea"):setContentSize(cc.size(720, hh - 105))
        self:getChildByName("mainArea"):getChildByName("view"):setContentSize(cc.size(720, hh - 105 - 60 -140 ))
    end
end

function heroskillLayer:onInit()
    if self._init == false then     
        local function backSure()
            self:heroSkillAction(9,dd.heros:getLong(self._selectindex,"hid"),0,0)
        end    
        local function onReset(sender, eventType)
            if eventType==ccui.TouchEventType.ended then     
                dd.currentLayer._widget:onShowSureUseTools("英雄技能重置",1015,1,backSure)
            end
        end
        local function onRefsh(sender, eventType)
            if eventType==ccui.TouchEventType.ended then     
                local num = dd.heros:rowCount()
                self._selectindex = self._selectindex + 1
                if self._selectindex > num then
                    self._selectindex = 1
                end
                self:updateView(self._selectindex)
            end
        end
        self:getChildByName("btm"):getChildByName("reset"):addTouchEventListener(onReset)
        self:getChildByName("refshbtn"):addTouchEventListener(onRefsh)
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3)
        self:initPop()
        self:initCfg()
        self._init = true
    end
    self.updateGold()
end

function heroskillLayer:initPop()
    local function close(sender, eventType)
        self.closePop(sender, eventType)
    end
    local function onMinus(sender, eventType)
        if eventType==ccui.TouchEventType.ended then    
            self._toskilllv = self._toskilllv - 1
            self._points = self._points + 1
            self:pointAction(self._curskillid,self._toskilllv,self._points)            
        end
    end
    local function onAdd(sender, eventType)
        if eventType==ccui.TouchEventType.ended then     
            self._toskilllv = self._toskilllv + 1
            self._points = self._points - 1
            self:pointAction(self._curskillid,self._toskilllv,self._points)
        end
    end
    local function onSave(sender, eventType)
        if eventType==ccui.TouchEventType.ended then  
            self:heroSkillAction(1,dd.heros:getLong(self._selectindex,"hid"),self._curskillid,self._curpoints - self._points)
        end
    end
    self:getChildByName("pop"):getChildByName("close"):addTouchEventListener(close)
    self:getChildByName("pop"):getChildByName("skillpoint"):getChildByName("minu"):addTouchEventListener(onMinus)
    self:getChildByName("pop"):getChildByName("skillpoint"):getChildByName("add"):addTouchEventListener(onAdd)
    self:getChildByName("pop"):getChildByName("save"):addTouchEventListener(onSave)
end

function heroskillLayer:initCfg()
    --skill    
    --show
    local time = ff.gameCore:getTick()
    local skillshow = ff.dbmanager:sql_fetch_rows("select * from cfg_skill_show")
    for i=1, skillshow:rowCount() do
        local id = tonumber(skillshow:getString(i, "id"))
        self._cfgskillshow[id] = {}
        self._cfgskillshow[id]["skilltreeid"] = tonumber(skillshow:getString(i, "skilltreeid"))
        self._cfgskillshow[id]["index"] = tonumber(skillshow:getString(i, "index"))
        self._cfgskillshow[id]["pos"] = tonumber(skillshow:getString(i, "pos"))
        self._cfgskillshow[id]["preid1"] = tonumber(skillshow:getString(i, "preid1"))
        self._cfgskillshow[id]["preid2"] = tonumber(skillshow:getString(i, "preid2"))
        self._cfgskillshow[id]["preid3"] = tonumber(skillshow:getString(i, "preid3"))
        self._cfgskillshow[id]["preid4"] = tonumber(skillshow:getString(i, "preid4"))
        self._cfgskillshow[id]["line"] = tonumber(skillshow:getString(i, "line"))
    end
    skillshow:clear()
    
    --skilllevelup
--    local skill = ff.dbmanager:sql_fetch_rows("select * from cfg_hero_skill_levelup")
--    for i=1, skill:rowCount() do
--        local info = {}
--        info['id'] = tonumber(skill:getString(i, "id"))
--        info['skillid'] = tonumber(skill:getString(i, "skillid"))
--        info['skilllevel'] = tonumber(skill:getString(i, "skilllevel"))
--        info['preid1'] = tonumber(skill:getString(i, "preid1"))
--        info['preid2'] = tonumber(skill:getString(i, "preid2"))
--        info['preid3'] = tonumber(skill:getString(i, "preid3"))
--
--        info['param1'] = tonumber(skill:getString(i, "param1"))
--        info['value1'] = tonumber(skill:getString(i, "value1"))
--        info['param2'] = tonumber(skill:getString(i, "param2"))
--        info['value2'] = tonumber(skill:getString(i, "value2"))
--        info['param3'] = tonumber(skill:getString(i, "param3"))
--        info['value3'] = tonumber(skill:getString(i, "value3"))
--        self._cfgheroskillup[info['skillid']] = self._cfgheroskillup[info['skillid']] or {}
--        self._cfgheroskillup[info['skillid']][info['skilllevel']] = info
--    end
--    skill:clear()

    time = ff.gameCore:getTick() - time
    cclog("英雄技能表时间  === "..time)
end

function heroskillLayer:updateView(index)
    self:updateSkillList(index)
    self:updateBasicInfo(index)
    if self:getChildByName("pop"):isVisible() == true then 
        self:updatePop(index,self._curskillid)
    end
end

function heroskillLayer:updateSkillList(index)
    local lv = dd.heros:getLong(index,"level")
    local id = dd.heros:getLong(index,"id")
    local hid = dd.heros:getLong(index,"id")
    local num = 0
    local treeid = dd.cfgHero[id]["skill"]
    local view = self:getChildByName("mainArea"):getChildByName("view")
    local hh = view:getContentSize().height
    local innerhh = 0
    local count = 1
    self:deleteTree()
    for key, skill in pairs(self._cfgskillshow) do
        if skill then
            if skill["skilltreeid"] == treeid then
                local row = skill["index"]
                if num<row then
                    num = row
                end
            end
        end
    end
    --隐藏items
    for i,v in ipairs(self._items) do
        if tolua.isnull(v) then
            self._items[i] = nil
        else
            v:setVisible(false)
            v:setTag(i)
        end
    end
    if num*198 > hh then
        view:setInnerContainerSize(cc.size(720,num*198 - 40))
        innerhh = num*198-40
        view:getChildByName("cross"):setContentSize(cc.size(720,innerhh))
    else
        view:setInnerContainerSize(cc.size(720,hh))
        innerhh = hh
        view:getChildByName("cross"):setContentSize(cc.size(720,innerhh))
    end
    view:getChildByName("cross"):setPositionX(0)
    view:getChildByName("cross"):setPositionY(0)
    for key, skill in pairs(self._cfgskillshow) do
        if skill then
            if skill["skilltreeid"] == treeid then
                local row = skill["index"]
                local line = skill["pos"]
                self:addItem(count,key,row,line,innerhh)    
                count = count + 1    
            end
        end
    end
end

function heroskillLayer:addItem(count,skillid,row,line,ihh)
    local view = self:getChildByName("mainArea"):getChildByName("view")
    local item = self._items[count]
    local offset = -60
    if item == nil then
        item = self:getChildByName("mainArea"):getChildByName("itemmode"):clone()
        self._items[count] = item
        view:addChild(item)
    end
    local maxlv = dd.cfgHeroSkill[skillid]["levelup"]
    local lv = 0

    local skills = dd.heros:getNetTable(self._selectindex,"skills")
    for i=1,skills:rowCount() do
        if skills:getLong(i,"sid") ==  skillid then
            lv = skills:getLong(i,"level")
            break
        end
    end
    item:setVisible(true)
    item:setPositionX(114 + offset+ (line-1)*82)
    item:setPositionY(ihh - 154 - (row-1)*198)
    if self:isPreok(skillid, lv) == 0 then
        item:getChildByName("lock"):setVisible(true)
        item:getChildByName("lock"):loadTexture(dd.getPathFromUI("lock02_.png",1))
        item:getChildByName("lockpanel"):setVisible(true)
        item:getChildByName("lockpanel"):loadTexture(dd.getPathFromUI("skill_grey.png",1))
    elseif self:isPreok(skillid, lv) == 1 then
        item:getChildByName("lock"):setVisible(false)
        item:getChildByName("lockpanel"):setVisible(true)
        item:getChildByName("lockpanel"):loadTexture(dd.getPathFromUI("skill_grey.png",1))
    else
        item:getChildByName("lock"):setVisible(false)
        item:getChildByName("lockpanel"):setVisible(false)
    end
    item:getChildByName("icon"):loadTexture(dd.getSkillIcon(skillid),0)
    self:showTree(skillid, item:getPositionX(), item:getPositionY(), self:isPreok(skillid, lv))
    item:getChildByName("point"):getChildByName("value"):setString(lv.."/"..maxlv)
    item:addTouchEventListener(self.onSelect)
    item.sid = skillid
end

function heroskillLayer.onSelect(sender, eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        cclog("技能id"..sender.sid) 
        local widget = pop.getDialog("heroskill")
        widget:updatePop(widget._selectindex,sender.sid)
        widget.openPop()
    end
end
--
function heroskillLayer:showTree(skillid, posx, posy, ispre)
    local preid = {
        self._cfgskillshow[skillid]["preid1"],
                    self._cfgskillshow[skillid]["preid2"],
                    self._cfgskillshow[skillid]["preid3"],
                    self._cfgskillshow[skillid]["preid4"]
                  }
    local iline = self._cfgskillshow[skillid]['index']  --行
    local irow = self._cfgskillshow[skillid]['pos']     --列
    local xspace = 120
    local yspace = 140
    local lineindex = 0
    if ispre == 0 then
        lineindex = 2
    elseif ispre == 1 then
        lineindex = 1
    else
        lineindex = 1
    end
    posx = posx + 63
    posy = posy + 75
    for i, id in pairs(preid) do
        if id ~= 0 then
            local dline = iline - self._cfgskillshow[id]['index']
            local drow = irow - self._cfgskillshow[id]['pos']
            if drow == 0 then
                if dline > 0 then
                    local line = self:getChildByName("mainArea"):getChildByName("line"..lineindex):clone()
                    line:setVisible(true)
                    line:setAnchorPoint(cc.p(0.5,0))
                    line:setPosition(cc.p(posx, posy + 62))
                    line:setContentSize(cc.size(9,yspace))
                    self:getChildByName("mainArea"):getChildByName("view"):getChildByName("cross"):addChild(line)
                end
            elseif drow < 0 then --在右边
                if dline > 0 then
                    local line = self:getChildByName("mainArea"):getChildByName("line"..lineindex):clone()
                    line:setVisible(true)                    
                    line:setAnchorPoint(cc.p(0.5,0))
                    line:setPosition(cc.p(posx - 4.5, posy + 62 + 22))
                    line:setRotation(90)
                    line:setContentSize(cc.size(9,xspace*(-drow)+9))
                    self:getChildByName("mainArea"):getChildByName("view"):getChildByName("cross"):addChild(line)
                    
                    --start
                    local line0 = self:getChildByName("mainArea"):getChildByName("line"..lineindex):clone()
                    line0:setVisible(true)
                    line0:setAnchorPoint(cc.p(0.5,0))
                    line0:setPosition(cc.p(posx, posy + 62 + 0))
                    line0:setContentSize(cc.size(9,23.8))
                    self:getChildByName("mainArea"):getChildByName("view"):getChildByName("cross"):addChild(line0)
                    
                    --end
                    local line1 = self:getChildByName("mainArea"):getChildByName("line"..lineindex):clone()
                    line1:setVisible(true)
                    line1:setAnchorPoint(cc.p(0.5,0))
                    line1:setPosition(cc.p(posx +82*(-drow), posy + 62 + 22))
                    line1:setContentSize(cc.size(9,35 + xspace*(dline-1)))
                    self:getChildByName("mainArea"):getChildByName("view"):getChildByName("cross"):addChild(line1)
                elseif dline == 0 then
                    local line = self:getChildByName("mainArea"):getChildByName("line"..lineindex):clone()
                    line:setVisible(true)                    
                    line:setAnchorPoint(cc.p(0.5,0))
                    line:setPosition(cc.p(posx, posy))
                    line:setRotation(90)
                    line:setContentSize(cc.size(9,xspace*(dline-1)))
                    self:getChildByName("mainArea"):getChildByName("view"):getChildByName("cross"):addChild(line)
                end
            elseif drow > 0 then --在左边
                if dline > 0 then
                    local line = self:getChildByName("mainArea"):getChildByName("line"..lineindex):clone()
                    line:setVisible(true)                    
                    line:setAnchorPoint(cc.p(0.5,1))
                    line:setPosition(cc.p(posx + 4.5, posy + 62 + 22))
                    line:setRotation(90)
                    line:setContentSize(cc.size(9,xspace*(drow)+9))
                    self:getChildByName("mainArea"):getChildByName("view"):getChildByName("cross"):addChild(line)
    
                    --start
                    local line0 = self:getChildByName("mainArea"):getChildByName("line"..lineindex):clone()
                    line0:setVisible(true)
                    line0:setAnchorPoint(cc.p(0.5,0))
                    line0:setPosition(cc.p(posx, posy + 62 + 0))
                    line0:setContentSize(cc.size(9,23.8))
                    self:getChildByName("mainArea"):getChildByName("view"):getChildByName("cross"):addChild(line0)
    
                    --end
                    local line1 = self:getChildByName("mainArea"):getChildByName("line"..lineindex):clone()
                    line1:setVisible(true)
                    line1:setAnchorPoint(cc.p(0.5,0))
                    line1:setPosition(cc.p(posx +82*(-drow), posy + 62 + 22))
                    line1:setContentSize(cc.size(9,35 + xspace*(dline-1)))
                    self:getChildByName("mainArea"):getChildByName("view"):getChildByName("cross"):addChild(line1)
                elseif dline == 0 then
                    local line = self:getChildByName("mainArea"):getChildByName("line"..lineindex):clone()
                    line:setVisible(true)                    
                    line:setAnchorPoint(cc.p(0.5,1))
                    line:setPosition(cc.p(posx, posy))
                    line:setRotation(90)
                    line:setContentSize(cc.size(9,xspace*(dline-1)))
                    self:getChildByName("mainArea"):getChildByName("view"):getChildByName("cross"):addChild(line)
                end
            end
        end
    end
end

function heroskillLayer:deleteTree()
     local view = self:getChildByName("mainArea"):getChildByName("view")
     view:getChildByName("cross"):removeAllChildren()
end

function heroskillLayer:updateBasicInfo(index)
    local name = dd.heros:getString(index,"name")
    local lv = dd.heros:getLong(index,"level")
    local office = dd.heros:getLong(index,"type")
    local id = dd.heros:getLong(index,"id")
    local star = dd.cfgHero[id]["star"]
    local totalpoint = dd.cfgHeroUp[star][lv]["skillcount"] + self:getHeroPlus()
    local skills = dd.heros:getNetTable(index,"skills")
    local usedpoint = 0 
    for j=1,skills:rowCount() do
        local sid = skills:getLong(j,"sid")
        local lv = skills:getLong(j,"level")
        if sid > 0 then
            usedpoint = usedpoint + lv
        end
    end
    if name == "" then
        self:getChildByName("top"):getChildByName("name_lv"):setString(ff.langString(dd.cfgHero[id]['name']).."  LV."..lv)
    else
        self:getChildByName("top"):getChildByName("name_lv"):setString(name.."  LV."..lv)
    end
    self:getChildByName("top"):getChildByName("skillpoint"):setString(ff.langString("剩余可分配技能点 ：")..(totalpoint - usedpoint))
end
function heroskillLayer:updatePop(index,skillid)
    local lv = dd.heros:getLong(index,"level")  --英雄等级
    local id = dd.heros:getLong(index,"id")
    local star = dd.cfgHero[id]["star"]
    local totalpoint = dd.cfgHeroUp[star][lv]["skillcount"] + self:getHeroPlus()
    local maxlv = dd.cfgHeroSkill[skillid]["levelup"]
    local skillname = dd.cfgHeroSkill[skillid]["skillname"]
    local skills = dd.heros:getNetTable(index,"skills")
    local skilllv = 0
    local usedpoint = 0 
    for j=1,skills:rowCount() do
        local sid = skills:getLong(j,"sid")
        local lv = skills:getLong(j,"level")
        if sid > 0 then
            usedpoint = usedpoint + lv
        end
        if sid == skillid then
            skilllv = lv
        end
    end
    local pop = self:getChildByName("pop")
    self._points = totalpoint - usedpoint  --当前可用技能点数
    self._curskilllv = skilllv             --当前技能等级
    self._toskilllv = skilllv
    self._curskillid = skillid
    self._curpoints = self._points
    pop:getChildByName("chu_point"):setString(ff.langString("剩余可分配技能点 ：")..(totalpoint - usedpoint))
    pop:getChildByName("skillpoint"):getChildByName("count"):setString(self._points)
    pop:getChildByName("info"):getChildByName("name"):getChildByName("name"):setString(ff.langString(skillname))
    pop:getChildByName("info"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getSkillIcon(skillid),0)
    self:pointAction(skillid, skilllv,self._points)
end

function heroskillLayer:pointAction(skillid, skilllv,points)
    local pop = self:getChildByName("pop")
    local maxlv = dd.cfgHeroSkill[skillid]["levelup"]
    local isAdd = true
    local isMinus = true
    local ispre = false
    if skilllv <= self._curskilllv then  --技能不能减
        isMinus = false
    end
    pop:getChildByName("info"):getChildByName("tips"):getChildByName("chu_pre"):setString("")
    pop:getChildByName("chu_point"):setString(ff.langString("剩余可分配技能点 ：")..(self._points))
    if skilllv < maxlv then
        self:getCfgByid(skillid, skilllv+1)
        local preid = { self._cfgheroskillup[skillid][skilllv+1]["preid1"],
                        self._cfgheroskillup[skillid][skilllv+1]["preid2"],
                        self._cfgheroskillup[skillid][skilllv+1]["preid3"]
                      }
        pop:getChildByName("skillpoint"):getChildByName("count"):setString(self._points)
        pop:getChildByName("skillpoint"):getChildByName("count"):setString(skilllv.."/"..maxlv)
        
        if points <= 0 then
            isAdd = false
        end
        --前置条件
        for i,pid in ipairs(preid) do
            if pid ~= 0 then
            --强行计算下
                local pskillid = math.floor(pid/100)
                local pskilllv = pid%100
                local pskillname = ff.langString(dd.cfgHeroSkill[pskillid]["skillname"])
                local truelv = self:getHeroSkillLv(self._selectindex,pskillid)
                if truelv < pskilllv then
                    isAdd = false
                    ispre = true
                    pop:getChildByName("info"):getChildByName("tips"):getChildByName("chu_pre"):setString(ff.langString("需要 {0} {1} 级",{pskillname,pskilllv}))
                    break
                end
            end
        end
    else
        pop:getChildByName("skillpoint"):getChildByName("count"):setString(skilllv.."/"..maxlv)
        isAdd = false
        --isMinus = false
    end
    self:setAddBtnLight(isAdd)
    self:setMinusBtnLight(isMinus)
    if self._curpoints ~= self._points then
        self:setSaveBtnLight(true)
    else
        self:setSaveBtnLight(false)
    end
    self:updateEffect(skillid,skilllv,ispre)
end

function heroskillLayer:updateEffect(skillid,skilllv,ispre)
    local pop = self:getChildByName("pop")
    --效果描述
    local effect = {}    
    pop:getChildByName("info"):getChildByName("tips"):getChildByName("effect1"):getVirtualRenderer():setDimensions(300,0)  
    pop:getChildByName("info"):getChildByName("tips"):getChildByName("effect2"):getVirtualRenderer():setDimensions(300,0) 
    pop:getChildByName("info"):getChildByName("tips"):getChildByName("effect3"):getVirtualRenderer():setDimensions(300,0) 
    pop:getChildByName("info"):getChildByName("tips"):getChildByName("effect4"):getVirtualRenderer():setDimensions(300,0)   
    
    local count = 1
    if ispre == true then
        --count = 2
    end
    if skilllv == 0 then
        self:getCfgByid(skillid, 1)
        effect = {
            self._cfgheroskillup[skillid][1]["param1"],
            self._cfgheroskillup[skillid][1]["param2"],
                    self._cfgheroskillup[skillid][1]["param3"]
                 }
        for i, effid in ipairs(effect) do
            if effid ~= 0 then
                  pop:getChildByName("info"):getChildByName("tips"):getChildByName("effect"..count):setString(self.getEffectTips(effid))
                  pop:getChildByName("info"):getChildByName("tips"):getChildByName("value"..count):setString(self.getEffectValue(effid,0))
                  count = count + 1
            end
        end
    else
        self:getCfgByid(skillid, skilllv)
        effect = {
                    self._cfgheroskillup[skillid][skilllv]["param1"],
                    self._cfgheroskillup[skillid][skilllv]["param2"],
                    self._cfgheroskillup[skillid][skilllv]["param3"]
                 }
        local values = 
                {
                    self._cfgheroskillup[skillid][skilllv]["value1"],
                    self._cfgheroskillup[skillid][skilllv]["value2"],
                    self._cfgheroskillup[skillid][skilllv]["value3"]
                }
        for i, effid in ipairs(effect) do
            if effid ~= 0 then
                  pop:getChildByName("info"):getChildByName("tips"):getChildByName("effect"..count):setString(self.getEffectTips(effid))
                  pop:getChildByName("info"):getChildByName("tips"):getChildByName("value"..count):setString(self.getEffectValue(effid,values[i]))
                  count = count + 1
            end
        end
    end
    for i=count,4 do
        pop:getChildByName("info"):getChildByName("tips"):getChildByName("effect"..i):setString("")
        pop:getChildByName("info"):getChildByName("tips"):getChildByName("value"..i):setString("")
    end
    pop:getChildByName("info"):getChildByName("tips"):requestDoLayout()
end

function heroskillLayer.updateGold()
    local widget = pop.getDialog("heroskill")
    widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
    widget:getChildByName("topArea"):requestDoLayout()

    local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
    w = 720 - (w + 94 + 75 + 104)
    widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
    widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
end

function heroskillLayer:updateSkillStree(index)
end

function heroskillLayer:heroSkillAction(type,hid,sid,count)
    local message = ff.net:createMessage()
    message:addCmd(0x109)
    message:addLong(dd.uid)
    message:addLong(type)
    message:addLong(hid)
    message:addLong(sid)
    message:addLong(count)
    ff.net:rpc(message, false)
end

function heroskillLayer:onHeroSkillAction(params)
    local code = params[1]
    if code == 0 then
        self:updateView(self._selectindex)
        self.closePop(nil,ccui.TouchEventType.ended)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function heroskillLayer.closePop(sender,touchEventType)
    local function unShow()
        local widget = pop.getDialog("heroskill")
        widget:getChildByName("masking"):setVisible(false)
        widget:getChildByName("pop"):setVisible(false)
    end    

    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("heroskill") 
        widget:getChildByName("masking"):setVisible(false)
        widget:getChildByName("pop"):setVisible(false)
        --[[
        widget:getChildByName("pop"):setPosition(cc.p(0,0))
        if widget ~= nil then
            widget:getChildByName("pop"):runAction(cc.Sequence:create(cc.MoveTo:create(0.5, cc.p(0,-615)),cc.CallFunc:create(unShow)))
        end 
        --]]                        
    end
--    local widget = pop.getDialog("heroskill")
--    pop.onCloseEffect(8,widget._upgrade)
end

function heroskillLayer.openPop()
    local widget = pop.getDialog("heroskill") 
    widget:getChildByName("masking"):setVisible(true)
    pop.showPopEffect(12,widget:getChildByName("pop"))
end

function heroskillLayer:setAddBtnLight(islight)
    if islight == true then
        self:getChildByName("pop"):getChildByName("skillpoint"):getChildByName("add"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        self:getChildByName("pop"):getChildByName("skillpoint"):getChildByName("add"):setTouchEnabled(true)
    else
        local effect = ff.Effect:effectGrey()    
        self:getChildByName("pop"):getChildByName("skillpoint"):getChildByName("add"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        self:getChildByName("pop"):getChildByName("skillpoint"):getChildByName("add"):setTouchEnabled(false)
    end
end
function heroskillLayer:setMinusBtnLight(islight)
    if islight == true then
        self:getChildByName("pop"):getChildByName("skillpoint"):getChildByName("minu"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        self:getChildByName("pop"):getChildByName("skillpoint"):getChildByName("minu"):setTouchEnabled(true)
    else
        local effect = ff.Effect:effectGrey()    
        self:getChildByName("pop"):getChildByName("skillpoint"):getChildByName("minu"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        self:getChildByName("pop"):getChildByName("skillpoint"):getChildByName("minu"):setTouchEnabled(false)
    end
end
function heroskillLayer:setSaveBtnLight(islight)
    if islight == true then
        self:getChildByName("pop"):getChildByName("save"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        self:getChildByName("pop"):getChildByName("save"):setTouchEnabled(true)
        self:getChildByName("pop"):getChildByName("save"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
    else
        local effect = ff.Effect:effectGrey()    
        self:getChildByName("pop"):getChildByName("save"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        self:getChildByName("pop"):getChildByName("save"):setTouchEnabled(false)
        self:getChildByName("pop"):getChildByName("save"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
    end
end

--接口
function heroskillLayer:getHeroPlus()
    for var=1, dd.myeffect:rowCount() do
        if dd.myeffect:getLong(var,'id') == 752 then
            return dd.myeffect:getLong(var,'param')
        end
    end
    return 0
end

function heroskillLayer:getHeroSkillLv(index,skillid)
    local skills = dd.heros:getNetTable(index,"skills")
    local skilllv = 0
    for j=1,skills:rowCount() do
        local sid = skills:getLong(j,"sid")
        local lv = skills:getLong(j,"level")
        if sid == skillid then
            skilllv = lv
        end
    end
    return skilllv
end
function heroskillLayer.getEffectTips(effectid)
    local str = ff.langString(dd.cfgEffect[effectid]['name'])
    return str
end
function heroskillLayer.getEffectValue(effectid,value)
    --type  是不是有value的
    local str = tostring(value)
    local ispercent = dd.cfgEffect[effectid]['tips2']
    local evalue = dd.cfgEffect[effectid]['value']    
    if evalue ~= 0 then
        value = value/evalue
    end
    if tonumber(ispercent) ~= 0 then
        str = "+"..value.."%"
        return str
    else
        return ""
    end   
end
function heroskillLayer:isPreok(skillid, skilllv)
    local maxlv = dd.cfgHeroSkill[skillid]["levelup"]
    if skilllv >= maxlv then
        --最高级
        return 3             
    else
        self:getCfgByid(skillid, skilllv+1)
        local preid = { self._cfgheroskillup[skillid][skilllv+1]["preid1"],
                    self._cfgheroskillup[skillid][skilllv+1]["preid2"],
                    self._cfgheroskillup[skillid][skilllv+1]["preid3"]
                  }
        --前置条件
        for i,pid in ipairs(preid) do
            if pid ~= 0 then
                --强行计算下
                local pskillid = math.floor(pid/100)
                local pskilllv = pid%100
                local pskillname = ff.langString(dd.cfgHeroSkill[pskillid]["skillname"])
                local truelv = self:getHeroSkillLv(self._selectindex,pskillid)
                if truelv < pskilllv then
                    --未解锁
                    if skilllv == 0 then
                        return 0
                    else
                        return 1
                    end
                end
            end
        end
        --可升级
        return 2
    end 
end

--sid  = 技能id + level
function heroskillLayer:getCfgByid(sid,lv)
    if self._cfgheroskillup[sid] == nil or self._cfgheroskillup[sid][lv] == nil then
        local rows = ff.dbmanager:sql_fetch_rows("select * from cfg_hero_skill_levelup where id="..sid*100 + lv)
        local info = {}
        info['id'] = tonumber(rows:getString(1, "id"))
        info['skillid'] = tonumber(rows:getString(1, "skillid"))
        info['skilllevel'] = tonumber(rows:getString(1, "skilllevel"))
        info['preid1'] = tonumber(rows:getString(1, "preid1"))
        info['preid2'] = tonumber(rows:getString(1, "preid2"))
        info['preid3'] = tonumber(rows:getString(1, "preid3"))
        info['param1'] = tonumber(rows:getString(1, "param1"))
        info['value1'] = tonumber(rows:getString(1, "value1"))
        info['param2'] = tonumber(rows:getString(1, "param2"))
        info['value2'] = tonumber(rows:getString(1, "value2"))
        info['param3'] = tonumber(rows:getString(1, "param3"))
        info['value3'] = tonumber(rows:getString(1, "value3"))
        self._cfgheroskillup[info['skillid']] = self._cfgheroskillup[info['skillid']] or {}
        self._cfgheroskillup[info['skillid']][info['skilllevel']] = info
        rows:clear()
    end
end

function heroskillLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("heroskill")
        if widget ~= nil then
            if widget:getChildByName("pop"):isVisible() == true then
                widget.closePop(sender,ccui.TouchEventType.ended)
                return
            end
            pop.onClosePopDialog("heroskill")
        end
    end
end

function heroskillLayer:onClose()

end

function heroskillLayer.onStart(sender)
    ff.net:registerEvent(2,dd.Tjf_hero_skillAction, function (message)sender:onHeroSkillAction(message)end)
    ff.net:bindProperty(2506,"gold",sender.updateGold)
    sender:updateView(sender._selectindex)
end

function heroskillLayer.onEnd(sender)
    dd.delBackEvent()
    ff.net:removeEvent(2,dd.Tjf_hero_skillAction)
    ff.net:unbindProperty("gold",2506)
    sender:getChildByName("masking"):setVisible(false)
    if ff.platform ~= 1 then
        sender:getChildByName("pop"):getChildByName("info"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:deleteTree()
        for i,item in ipairs(sender._items) do
            if item then
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("lock"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("lockpanel"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end
    end
end
function heroskillLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    return true
end
function heroskillLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("heroskill")
    if widget then
        if widget:getChildByName("pop"):isVisible() == true then
            widget.closePop(sender,ccui.TouchEventType.ended)
        else
            pop.onClosePopDialog("heroskill")
        end  
    end
end

function onShowHeroskillLayer(widget,row)
    local layer = heroskillLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    if row > 0 then
        layer._selectindex = row
    end
    layer:onAutoSize()
    layer:onInit()
    return layer
end