--heroskill
local heroskillLayerEx = class("heroskillEx")
heroskillLayerEx._name = "heroskillEx"
heroskillLayerEx._init = false
heroskillLayerEx._selectindex = 1
heroskillLayerEx._selectPoint = 1

heroskillLayerEx._points = 0  --技能点数


function heroskillLayerEx.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, heroskillLayerEx)
    return target
end

function heroskillLayerEx:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("masking"):setContentSize(cc.size(720,hh -105))
        self:getChildByName("masking"):setPositionY(0)
        self:getChildByName("bg"):setContentSize(cc.size(720,hh))
        self:getChildByName("bg"):setPositionY(0)
        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("ScrollView"):setContentSize(cc.size(720,hh - 105 - 135))
        self:getChildByName("ScrollView"):setPositionY(135)
        self:getChildByName("info"):setPositionY(hh - 105 - 45)
    end
end

function heroskillLayerEx:heroSkillAction(type,hid,count)
    local message = ff.net:createMessage()
    message:addCmd(0x170)
    message:addLong(dd.uid)
    message:addLong(hid)
    message:addLong(type)
    message:addLong(count)
    --cclog("============="..count)
    ff.net:rpc(message, false)
    self._points = 0 
end


function heroskillLayerEx.onMinu( sender, eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then

        local widget = pop.getDialog("heroskillEx")

        
        if widget._points > 0 then
            widget._points = widget._points - 1

        end
        
         widget:updatePopinfo()
    end
end

function heroskillLayerEx.onadd( sender, eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("heroskillEx")
        local  totle = dd.heros:getLong(widget._selectindex,"PVETotle") - dd.heros:getLong(widget._selectindex,"PVEAct") - dd.heros:getLong(widget._selectindex,"PVEDfc") -dd.heros:getLong(widget._selectindex,"PVEHp")
        
        if (totle - widget._points) > 0 then
            widget._points = widget._points + 1
        end
        
        widget:updatePopinfo()
    end
end

function heroskillLayerEx:setinfo(  )
    -- body
    local view = self:getChildByName("ScrollView")
    view:getChildByName("itemmode1"):getChildByName("velu"):setString(" +"..dd.heros:getLong(self._selectindex,"PVEAct"))
    view:getChildByName("itemmode1"):getChildByName("point"):getChildByName("value"):setString("LV."..dd.heros:getLong(self._selectindex,"PVEAct"))

    view:getChildByName("itemmode2"):getChildByName("velu"):setString(" +"..dd.heros:getLong(self._selectindex,"PVEDfc"))
    view:getChildByName("itemmode2"):getChildByName("point"):getChildByName("value"):setString("LV."..dd.heros:getLong(self._selectindex,"PVEDfc"))

    view:getChildByName("itemmode3"):getChildByName("velu"):setString(" +"..dd.heros:getLong(self._selectindex,"PVEHp")*10)
    view:getChildByName("itemmode3"):getChildByName("point"):getChildByName("value"):setString("LV."..dd.heros:getLong(self._selectindex,"PVEHp"))

    local info = self:getChildByName("info")
    local name  = ""
    if dd.heros:getString(self._selectindex,"name") == "" then
        if dd.cfgHero[self._selectindex] ~= nil then
            name = ff.langString(dd.cfgHero[self._selectindex]['name'])
        end
    else
        name = dd.heros:getString(self._selectindex,"name")
    end
    local level = dd.heros:getLong(self._selectindex,"level")
    info:getChildByName("level"):setString("LV."..level)
    info:getChildByName("name"):setString(name)
    info:getChildByName("power"):setString(dd.heros:getLong(self._selectindex,"power"))
    local  totle = dd.heros:getLong(self._selectindex,"PVETotle") - dd.heros:getLong(self._selectindex,"PVEAct") - dd.heros:getLong(self._selectindex,"PVEDfc") -dd.heros:getLong(self._selectindex,"PVEHp")
    info:getChildByName("point"):setString(totle)
    info:requestDoLayout()
end

function heroskillLayerEx:updatePopinfo(  )
    -- body
    local skillpoint = self:getChildByName("pop"):getChildByName("skillpoint")
    local  point1 = dd.heros:getLong(self._selectindex,"PVEAct") + self._points
    local  point2 = dd.heros:getLong(self._selectindex,"PVEDfc") + self._points
    local  point3 = dd.heros:getLong(self._selectindex,"PVEHp") + self._points
    local  totle = dd.heros:getLong(self._selectindex,"PVETotle") - self._points - dd.heros:getLong(self._selectindex,"PVEAct") - dd.heros:getLong(self._selectindex,"PVEDfc") -dd.heros:getLong(self._selectindex,"PVEHp")
    if self._selectPoint == 1 then

        skillpoint:getChildByName("count"):setString(point1.."/"..totle)
    elseif self._selectPoint == 2 then
        skillpoint:getChildByName("count"):setString(point2.."/"..totle)
    elseif self._selectPoint == 3 then
        skillpoint:getChildByName("count"):setString(point3.."/"..totle)
    end
    self:getChildByName("pop"):getChildByName("info"):getChildByName("tips"):requestDoLayout()
end

function heroskillLayerEx:onInit()
    if self._init == false then     
        local function backSure()
            self:heroSkillAction(0,dd.heros:getLong(self._selectindex,"hid"),0)
        end    
        local function onReset(sender, eventType)
            if eventType==ccui.TouchEventType.ended then     
                dd.currentLayer._widget:onShowSureUseTools("英雄属性重置",1027,1,backSure)
            end
        end

        self:getChildByName("ScrollView"):getChildByName("itemmode1"):addTouchEventListener(self.onSelect)
        self:getChildByName("ScrollView"):getChildByName("itemmode2"):addTouchEventListener(self.onSelect)
        self:getChildByName("ScrollView"):getChildByName("itemmode3"):addTouchEventListener(self.onSelect)
        self:getChildByName("pop"):getChildByName("skillpoint"):getChildByName("minu"):addTouchEventListener(self.onMinu)
        self:getChildByName("pop"):getChildByName("skillpoint"):getChildByName("add"):addTouchEventListener(self.onadd)
        self:getChildByName("btm"):getChildByName("reset"):addTouchEventListener(onReset)
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
        self:getChildByName("pop"):getChildByName("close"):addTouchEventListener(self.closePop)
        self:getChildByName("pop"):getChildByName("save"):addTouchEventListener(self.onSave)
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3)
        self._init = true
    end

    self:getChildByName("ScrollView"):getChildByName("itemmode1"):getChildByName("name"):setString(ff.langString("英勇打击"))
    self:getChildByName("ScrollView"):getChildByName("itemmode2"):getChildByName("name"):setString(ff.langString("稳健格挡"))
    self:getChildByName("ScrollView"):getChildByName("itemmode3"):getChildByName("name"):setString(ff.langString("强健体魄"))
    self.updateGold()
end

function heroskillLayerEx.onSave(sender, eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("heroskillEx")
        if widget._points ~= 0 then
            widget:heroSkillAction(widget._selectPoint,dd.heros:getLong(widget._selectindex,"hid"),widget._points)
        end
    end
end


function heroskillLayerEx.onSelect(sender, eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("heroskillEx")
        widget:updatePop(sender:getTag())
        widget.openPop()
    end
end

function heroskillLayerEx:updatePop( index )
    -- body
    self._selectPoint = index
    if index == 1 then
        self:getChildByName("pop"):getChildByName("info"):getChildByName("tips"):getChildByName("name"):setString(ff.langString("英勇打击"))
        self:getChildByName("pop"):getChildByName("info"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("1012.jpg",1))
        self:getChildByName("pop"):getChildByName("info"):getChildByName("name"):getChildByName("name"):setString("LV."..dd.heros:getLong(self._selectindex,"PVEAct"))
        self:getChildByName("pop"):getChildByName("info"):getChildByName("tips"):getChildByName("effect2"):setString(ff.langString("对抗僵尸时攻击"))
        self:getChildByName("pop"):getChildByName("info"):getChildByName("tips"):getChildByName("value2"):setString(" +"..dd.heros:getLong(self._selectindex,"PVEAct"))
    elseif index == 2 then
        self:getChildByName("pop"):getChildByName("info"):getChildByName("tips"):getChildByName("name"):setString(ff.langString("稳健格挡"))
        self:getChildByName("pop"):getChildByName("info"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("1021.jpg",1))
        self:getChildByName("pop"):getChildByName("info"):getChildByName("name"):getChildByName("name"):setString("LV."..dd.heros:getLong(self._selectindex,"PVEDfc"))
        self:getChildByName("pop"):getChildByName("info"):getChildByName("tips"):getChildByName("effect2"):setString(ff.langString("对抗僵尸时防御"))
        self:getChildByName("pop"):getChildByName("info"):getChildByName("tips"):getChildByName("value2"):setString(" +"..dd.heros:getLong(self._selectindex,"PVEDfc"))
    elseif index == 3 then
        self:getChildByName("pop"):getChildByName("info"):getChildByName("tips"):getChildByName("name"):setString(ff.langString("强健体魄"))
        self:getChildByName("pop"):getChildByName("info"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("1062.jpg",1))
        self:getChildByName("pop"):getChildByName("info"):getChildByName("name"):getChildByName("name"):setString("LV."..dd.heros:getLong(self._selectindex,"PVEHp"))
        self:getChildByName("pop"):getChildByName("info"):getChildByName("tips"):getChildByName("effect2"):setString(ff.langString("对抗僵尸时生命"))
        self:getChildByName("pop"):getChildByName("info"):getChildByName("tips"):getChildByName("value2"):setString(" +"..dd.heros:getLong(self._selectindex,"PVEHp")*10)
    end
    self:updatePopinfo()
end

function heroskillLayerEx.getHeroBigIcon(id)
    if dd.cfgHero[id] ~= nil then
        return "images/icon/hero/big/"..dd.cfgHero[id]['pic']..".png"
    end  
    return "images/icon/hero/big/1.png"
end

function heroskillLayerEx:onShowHeroInfo(  )
    -- body
    self:getChildByName("ScrollView"):getChildByName("heroico"):loadTexture(self.getHeroBigIcon(self._selectindex),0)

end

function heroskillLayerEx.updateGold()
    local widget = pop.getDialog("heroskillEx")
    widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
    widget:getChildByName("topArea"):requestDoLayout()

    local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
    w = 720 - (w + 94 + 75 + 104)
    widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
    widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
end



function heroskillLayerEx.closePop(sender,touchEventType)
    local function unShow()
        local widget = pop.getDialog("heroskillEx")
        widget:getChildByName("masking"):setVisible(false)
        widget:getChildByName("pop"):setVisible(false)
    end    

    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("heroskillEx") 
        widget:getChildByName("masking"):setVisible(false)
        widget:getChildByName("pop"):setVisible(false)
        --[[
        widget:getChildByName("pop"):setPosition(cc.p(0,0))
        if widget ~= nil then
            widget:getChildByName("pop"):runAction(cc.Sequence:create(cc.MoveTo:create(0.5, cc.p(0,-615)),cc.CallFunc:create(unShow)))
        end 
        --]]            
        widget._points = 0            
    end
--    local widget = pop.getDialog("heroskill")
--    pop.onCloseEffect(8,widget._upgrade)
end

function heroskillLayerEx.openPop()
    local widget = pop.getDialog("heroskillEx") 
    widget:getChildByName("masking"):setVisible(true)
    pop.showPopEffect(12,widget:getChildByName("pop"))
end


function heroskillLayerEx.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("heroskillEx")
        if widget ~= nil then
            if widget:getChildByName("pop"):isVisible() == true then
                widget.closePop(sender,ccui.TouchEventType.ended)
                return
            end
            pop.onClosePopDialog("heroskillEx")
        end
    end
end

function heroskillLayerEx:onClose()

end

function heroskillLayerEx:onHeroSkillAction(params)
    local code = params[1]
    if code == 0 then
        self:setinfo()
        self.closePop(nil,ccui.TouchEventType.ended)
        local widget = pop.getDialog("warcollege")
        if widget ~= nil then
            if pop.isShowing("warcollege") then
                if widget._selectIndex == self._selectindex then
                    widget:setHeroHp()
                end
            end    
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end



function heroskillLayerEx.onStart(sender)
    ff.net:registerEvent(2,dd.Tjf_hero_GeneralPVEAttrSet, function (message)sender:onHeroSkillAction(message)end)
    
    ff.net:bindProperty(2318,"gold",sender.updateGold)
    sender:setinfo()
end

function heroskillLayerEx.onEnd(sender)
    dd.delBackEvent()
    ff.net:removeEvent(2,dd.Tjf_hero_GeneralPVEAttrSet)
    ff.net:unbindProperty("gold",2318)
    sender:getChildByName("masking"):setVisible(false)
    if ff.platform ~= 1 then
        sender:getChildByName("ScrollView"):getChildByName("heroico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
end
function heroskillLayerEx.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    sender:onShowHeroInfo()
end
function heroskillLayerEx.onReturn(sender,eventType)
    local widget = pop.getDialog("heroskillEx")
    if widget then
        if widget:getChildByName("pop"):isVisible() == true then
            widget.closePop(sender,ccui.TouchEventType.ended)
        else
            pop.onClosePopDialog("heroskillEx")
        end  
    end
end

function onShowHeroskillLayerEx(widget,row)
    local layer = heroskillLayerEx.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    if row > 0 then
        layer._selectindex = row
    end
    layer:onAutoSize()
    layer:onInit()
    return layer
end