--军事学院
local warcollegeLayer = class("warcollegeLayer")
warcollegeLayer._name = "warcollege"
warcollegeLayer._init = false
warcollegeLayer._pos  = 0
warcollegeLayer._bid  = 0
warcollegeLayer._lv  = 0
warcollegeLayer._citems = {}
warcollegeLayer._aitems = {}

warcollegeLayer._selectIndex = 1
warcollegeLayer._oldCryRow = 0
warcollegeLayer._oldArmRow = 0

warcollegeLayer._crysIndex = 1
warcollegeLayer._armsIndex = 1       --3个装备孔

warcollegeLayer._cfgheroskillup = {}

warcollegeLayer._toolId = 1

warcollegeLayer._sprite    = nil
warcollegeLayer._oldLevel = 0
warcollegeLayer._inProgress = false

function warcollegeLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, warcollegeLayer)
    return target
end

function warcollegeLayer:onInit()
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"pos") == self._pos then
            self._bid = dd.mybuilds:getLong(i,"bid")
            self._lv = dd.mybuilds:getLong(i,"level")
            break
        end
    end
    local hh = dd.currentLayer._pop:getContentSize().height
    self:getChildByName("backex"):loadTexture("images/ui/warcollege_back.jpg",0)
    self:getChildByName("backex"):setContentSize(cc.size(720,hh - 105 - 75))
    self:getChildByName("backex"):setPositionY(0)

    if self._init == false then
        
        if dd.currentLayer._pop ~= nil then
            self:setContentSize(cc.size(720,hh - 105 - 85))
            self:getChildByName("view"):setContentSize(cc.size(720,hh - 105 - 85))
            self:getChildByName("masking"):setContentSize(cc.size(720,hh - 105))
            self:getChildByName("masking"):setPositionY(0)
            

            --查看技能
            local function onSkill(sender, eventType)
                local doaction = false
                if eventType == ccui.TouchEventType.canceled then
                    local startp = sender:getTouchBeganPosition()
                    local endp   = sender:getTouchEndPosition()
                    if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                        doaction = true
                    end
                end

                if eventType==ccui.TouchEventType.ended then    
                    doaction = true
                end
                if doaction == true then
                    if dd.heros:rowCount() > 0 then
                        pop.onShowPopDialog("heroskill", self._selectIndex)
                    end
                end
            end
            --点击装备
            local function onArm(sender, eventType)
                local doaction = false
                if eventType == ccui.TouchEventType.canceled then
                    local startp = sender:getTouchBeganPosition()
                    local endp   = sender:getTouchEndPosition()
                    if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                        doaction = true
                    end
                end

                if eventType==ccui.TouchEventType.ended then    
                    doaction = true
                end
                if doaction == true then
                    if dd.getBuildLevel(1) < 9 then   --司令部等级
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("司令部等级达{0}级开放",{9}))
                    elseif self:haveArmCanbe(sender:getTag(),self._selectIndex) == false then
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有可用装备"))
                    else
                        self:showPopByType(2, sender:getTag())
                    end
                end
            end
            --点击晶体
            local function onCry(sender, eventType)
                local doaction = false
                if eventType == ccui.TouchEventType.canceled then
                    local startp = sender:getTouchBeganPosition()
                    local endp   = sender:getTouchEndPosition()
                    if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                        doaction = true
                    end
                end

                if eventType==ccui.TouchEventType.ended then    
                    doaction = true
                end
                if doaction == true then
                    if sender:getChildByName("lock"):isVisible() == true then
                        if dd.getBuildLevel(1) >= 10 then   --司令部等级
                            dd.currentLayer._widget:onShowTips("\t"..ff.langString("英雄{0}级解锁",{(sender:getTag()-1)*10}))
                        else
                            dd.currentLayer._widget:onShowTips("\t"..ff.langString("司令部等级达{0}级开放",{10}))
                        end
                    elseif self:haveCryCanbe(sender:getTag(),self._selectIndex) == false then
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有可用勋章"))
                    else
                        self:showPopByType(1, sender:getTag())
                    end                    
                end
            end
            --点击经验
            local function onExp(sender, eventType)
                local doaction = false
                if eventType == ccui.TouchEventType.canceled then
                    local startp = sender:getTouchBeganPosition()
                    local endp   = sender:getTouchEndPosition()
                    if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                        doaction = true
                    end
                end

                if eventType==ccui.TouchEventType.ended then    
                    doaction = true
                end
                if doaction == true then
                    self:showPop2()
                end
            end

            local function onHp(sender, eventType)
                local doaction = false
                if eventType == ccui.TouchEventType.canceled then
                    local startp = sender:getTouchBeganPosition()
                    local endp   = sender:getTouchEndPosition()
                    if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                        doaction = true
                    end
                end

                if eventType==ccui.TouchEventType.ended then    
                    doaction = true
                end
                if doaction == true then
                    self:showPop3()
                end
            end

            local function onskillEx(sender, eventType)
                local doaction = false
                if eventType == ccui.TouchEventType.canceled then
                    local startp = sender:getTouchBeganPosition()
                    local endp   = sender:getTouchEndPosition()
                    if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                        doaction = true
                    end
                end

                if eventType==ccui.TouchEventType.ended then    
                    doaction = true
                end
                if doaction == true then
                    pop.onShowPopDialog("heroskillEx",self._selectIndex)
                end
            end
            --点击pvp信息
            local function onInfo(sender, eventType)
                local doaction = false
                if eventType == ccui.TouchEventType.canceled then
                    local startp = sender:getTouchBeganPosition()
                    local endp   = sender:getTouchEndPosition()
                    if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                        doaction = true
                    end
                end

                if eventType==ccui.TouchEventType.ended then    
                    doaction = true
                end
                if doaction == true then
                    --self:showPopByType(3, self._selectIndex)
                    pop.onShowPopDialog("heroInfo",dd.heros:getLong(self._selectIndex,"hid"))
                    --pop.onShowPopDialog("arms",{715})
                end
            end
            local function onfuhuo(sender, eventType)
                local doaction = false
                if eventType == ccui.TouchEventType.canceled then
                    local startp = sender:getTouchBeganPosition()
                    local endp   = sender:getTouchEndPosition()
                    if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                        doaction = true
                    end
                end

                if eventType==ccui.TouchEventType.ended then    
                    doaction = true
                end
                if doaction == true then
                    --self:showPopByType(3, self._selectIndex)
                    --pop.onShowPopDialog("heroInfo",dd.heros:getLong(self._selectIndex,"hid"))
                    --pop.onShowPopDialog("arms",{715})
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000140)
                    message:addLong(dd.uid)
                    message:addLong(dd.heros:getLong(self._selectIndex,"hid"))
                    
                    ff.net:rpc(message,false)
                end
            end
            --点击英雄
            local function onHero(sender, eventType)
                local doaction = false
                if eventType == ccui.TouchEventType.canceled then
                    local startp = sender:getTouchBeganPosition()
                    local endp   = sender:getTouchEndPosition()
                    if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                        if sender:getSelectedState() == true then  
                            self:unSelect() 
                            sender:setSelectedState(true)
                            return
                        end 
                        self:unSelect()
                        self:updates(sender:getTag())
                        sender:setSelectedState(true)
                    end
                end

                if eventType==ccui.TouchEventType.ended then  
                    if sender:getSelectedState() == true then  
                        self:unSelect() 
                        return
                    end   
                    self:unSelect()
                    self:updates(sender:getTag())
                end
            end
            self:getChildByName("view"):getChildByName("skillbtnwex"):addTouchEventListener(onskillEx)
            --self:getChildByName("view"):getChildByName("crys"):getChildByName("skillbtn"):addTouchEventListener(onSkill)
            self:getChildByName("view"):getChildByName("arms"):getChildByName("arm1"):addTouchEventListener(onArm)
            self:getChildByName("view"):getChildByName("arms"):getChildByName("arm2"):addTouchEventListener(onArm)
            self:getChildByName("view"):getChildByName("arms"):getChildByName("arm3"):addTouchEventListener(onArm)
            self:getChildByName("view"):getChildByName("arms"):getChildByName("arm1"):setTag(1)
            self:getChildByName("view"):getChildByName("arms"):getChildByName("arm2"):setTag(2)
            self:getChildByName("view"):getChildByName("arms"):getChildByName("arm3"):setTag(3)
            --self:getChildByName("view"):getChildByName("crys"):getChildByName("cry1"):addTouchEventListener(onCry)
            --self:getChildByName("view"):getChildByName("crys"):getChildByName("cry2"):addTouchEventListener(onCry)
            --self:getChildByName("view"):getChildByName("crys"):getChildByName("cry3"):addTouchEventListener(onCry)
            --self:getChildByName("view"):getChildByName("crys"):getChildByName("cry4"):addTouchEventListener(onCry)
            --self:getChildByName("view"):getChildByName("crys"):getChildByName("cry1"):setTag(1)
            --self:getChildByName("view"):getChildByName("crys"):getChildByName("cry2"):setTag(2)
            --self:getChildByName("view"):getChildByName("crys"):getChildByName("cry3"):setTag(3)
            --self:getChildByName("view"):getChildByName("crys"):getChildByName("cry4"):setTag(4)
            self:getChildByName("view"):getChildByName("infos"):getChildByName("addbtn"):addTouchEventListener(onExp)
            self:getChildByName("view"):getChildByName("infos"):getChildByName("addbtnhp"):addTouchEventListener(onHp)
            self:getChildByName("view"):getChildByName("infobtn"):setVisible(false) 
            self:getChildByName("view"):getChildByName("info"):addTouchEventListener(onInfo)
            local heros = self:getChildByName("view"):getChildByName("heros")
            heros:getChildByName("heros1"):getChildByName("check"):addTouchEventListener(onHero)
            heros:getChildByName("heros2"):getChildByName("check"):addTouchEventListener(onHero)
            heros:getChildByName("heros3"):getChildByName("check"):addTouchEventListener(onHero)
            heros:getChildByName("heros4"):getChildByName("check"):addTouchEventListener(onHero)
            heros:getChildByName("heros5"):getChildByName("check"):addTouchEventListener(onHero)
            heros:getChildByName("heros1"):getChildByName("check"):setTag(1)
            heros:getChildByName("heros2"):getChildByName("check"):setTag(2)
            heros:getChildByName("heros3"):getChildByName("check"):setTag(3)
            heros:getChildByName("heros4"):getChildByName("check"):setTag(4)
            heros:getChildByName("heros5"):getChildByName("check"):setTag(5)
            self:getChildByName("view"):getChildByName("mubei"):getChildByName("fuhuo"):addTouchEventListener(onfuhuo)
            self:getChildByName("view"):getChildByName("heros"):getChildByName("heros1"):getChildByName("check"):setSelectedState(true)
            local function showHelp(sender,eventType)
                if eventType==ccui.TouchEventType.ended then     
                    pop.onShowPopDialog("buildHelp",self._bid,self._lv)
                end
            end
            --self:getChildByName("top"):getChildByName("help"):addTouchEventListener(showHelp)
            --加粗
            --self:getChildByName("view"):getChildByName("crys"):getChildByName("chu_skillpoint"):getVirtualRenderer():enableBold(true)
            self:getChildByName("show"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
            --self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByName("tips"):getChildByName("equipbtn"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
            self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("equipbtn"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
            self:getChildByName("heroexp"):getChildByName("heros"):getChildByName("name"):getChildByName("name"):getVirtualRenderer():enableBold(true)
            self:getChildByName("heroexp"):getChildByName("tips"):getChildByName("tips"):getVirtualRenderer():enableBold(true)
                    
            self._sprite = dd.newSpriteFromUI("public/alpha.png")   
            self._sprite:setTexture(dd.getHeroBigIcon(2))
            self._sprite:setScale(1)
            self._sprite:setPosition(cc.p(360,400))
            self._sprite:setVisible(false)  
            self:addChild(self._sprite,10)    
    
            self:initPop()
            
            self._init = true
        end
    end   
    self:initExpPop()
    self:initHPPop()
    self._oldLevel = 0
    self:checkSpine()
end

function warcollegeLayer:initPop()
    --选中晶体
    local function onCryCheck(sender, eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                sender:setSelectedState(true)
                if self._oldCryRow ~= sender:getTag() then
                    self:updatePopCrys(self._selectIndex, self._crysIndex,sender:getTag(),sender.acount)
                    local item = self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByTag(self._oldCryRow)
                    if item ~= nil then
                        item:getChildByName("check"):setSelectedState(true)
                    end
                else
                    self:updatePopCrys(self._selectIndex, self._crysIndex,0,0)
                    sender:setSelectedState(true)
                end
                doaction = true
            end
        end

        if eventType==ccui.TouchEventType.ended then    
            if self._oldCryRow ~= sender:getTag() then
                self:updatePopCrys(self._selectIndex, self._crysIndex,sender:getTag(),sender.acount)
            else
                self:updatePopCrys(self._selectIndex, self._crysIndex,0,0)
                sender:setSelectedState(true)
            end
            doaction = true
        end
        if doaction == true then
        end
    end
    --装备晶体
    local function onSetCrystral(sender, eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end

        if eventType==ccui.TouchEventType.ended then 
            doaction = true
        end
        if doaction == true then
            if dd.heros:getLong(self._selectIndex,"tools"..self._crysIndex) == dd.myCrystals:getLong(self._oldCryRow,"cid") then
                local message = ff.net:createMessage()
                message:addCmd(0x160)
                message:addLong(dd.uid)
                message:addLong(dd.heros:getLong(self._selectIndex,"hid"))
                message:addLong(self._crysIndex)
                message:addLong(0)
                ff.net:rpc(message,false)
            else
                local message = ff.net:createMessage()
                message:addCmd(0x160)
                message:addLong(dd.uid)
                message:addLong(dd.heros:getLong(self._selectIndex,"hid"))
                message:addLong(self._crysIndex)
                message:addLong(dd.myCrystals:getLong(self._oldCryRow,"cid"))
                ff.net:rpc(message,false)
            end  
        end  
    end
    --晶体升级
    local function onUpCrystral(sender, eventType)
        if eventType==ccui.TouchEventType.ended then    
            self.closePop(self,ccui.TouchEventType.ended)
            pop.onShowPopDialog("crystalUp",dd.myCrystals:getLong(self._oldCryRow,"cid"))            
        end
    end
    
    --选中装备
    local function onArmCheck(sender, eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                sender:setSelectedState(true)
                if self._oldArmRow ~= sender:getTag() then
                    local item = self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByTag(self._oldArmRow)
                    self:updatePopArms(self._selectIndex, self._armsIndex,sender:getTag(),sender.acount)
                    if item ~= nil then
                        item:getChildByName("check"):setSelectedState(true)
                    end
                else
                    self:updatePopArms(self._selectIndex, self._armsIndex,0,0)
                    sender:setSelectedState(true)
                end
                doaction = true
            end
        end

        if eventType==ccui.TouchEventType.ended then 
            if self._oldArmRow ~= sender:getTag() then
                self:updatePopArms(self._selectIndex, self._armsIndex,sender:getTag(),sender.acount)
            else
                self:updatePopArms(self._selectIndex, self._armsIndex,0,0)
                sender:setSelectedState(true)
            end
            doaction = true
        end
        if doaction == true then
        end
    end
    --穿戴装备
    local function onSetArm(sender, eventType)
        if eventType==ccui.TouchEventType.ended then    
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then 
                doaction = true
            end
            if doaction == true then
                if dd.heros:getLong(self._selectIndex,"arms"..self._armsIndex) == dd.myArms:getLong(self._oldArmRow,"tid") then
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000138)
                    message:addLong(dd.uid)
                    message:addLong(dd.heros:getLong(self._selectIndex,"hid"))
                    message:addLong(self._armsIndex)
                    message:addLong(0)
                    ff.net:rpc(message,false)
                else
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000138)
                    message:addLong(dd.uid)
                    message:addLong(dd.heros:getLong(self._selectIndex,"hid"))
                    message:addLong(self._armsIndex)
                    message:addLong(dd.myArms:getLong(self._oldArmRow,"tid"))
                    ff.net:rpc(message,false) 
                end
            end
        end
    end
    --装备镶嵌
    local function onArmFill(sender, eventType)
        if eventType==ccui.TouchEventType.ended then    
            self.closePop(self,ccui.TouchEventType.ended)
            pop.onShowPopDialog("equipgem", self._oldArmRow)            
        end
    end
    --self:getChildByName("show"):getChildByName("crys"):getChildByName("citem"):getChildByName("check"):addTouchEventListener(onCryCheck) 
    --self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByName("tips"):getChildByName("equipbtn"):addTouchEventListener(onSetCrystral)
    
    self:getChildByName("show"):getChildByName("arms"):getChildByName("aitem"):getChildByName("check"):addTouchEventListener(onArmCheck) 
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("equipbtn"):addTouchEventListener(onSetArm) 
    
    self:getChildByName("show"):getChildByName("close"):addTouchEventListener(self.closePop)    
end

function warcollegeLayer:initExpPop()
    local function useTool(sender, eventType)
        if eventType==ccui.TouchEventType.ended then  
        cclog("=====================")
            local tid = sender:getTag()
            local count = dd.getToolsCount(tid)
            if count > 0 then
                self:showBuyView(tid)
                self.closePop2(self,ccui.TouchEventType.ended)
            else
                if tid > 0 then
                    self._oldLevel = dd.heros:getLong(self._selectIndex,"level")
                    
                    local message = ff.net:createMessage()
                    message:addCmd(0x0000010a)
                    message:addLong(dd.uid)
                    message:addLong(tid)
                    message:addLong(1)
                    if count <= 0 then
                        message:addLong(1)
                    else
                        message:addLong(0)
                    end
                    message:addLong(dd.heros:getLong(self._selectIndex,"hid"))
                    ff.net:rpc(message,false)
                end 
            end         
        end
    end
    --选中道具
    local function selectTool(sender, eventType)
        if eventType==ccui.TouchEventType.ended then  
            if sender:getSelectedState() == true then
                sender:setSelectedState(false)
                return
            end 
            for i,item in ipairs(self:getChildByName("heroexp"):getChildByName("tools"):getChildren()) do
                if item ~= nil then
                    item:getChildByName("check"):setSelectedState(false)
                end
            end
            self:updatePop2(self._selectIndex,sender:getTag())
        end
    end
    
    local tools = ff.dbmanager:sql_fetch_rows("select * from cfg_props where `showtype`='19'")
    local count = 1
    for i=1,tools:rowCount() do
        if dd.getToolsCount(tonumber(tools:getString(i,"id"))) > 0 or dd.cfgProp[tonumber(tools:getString(i,"id"))]['value'] > 0 then
            local item = self:getChildByName("heroexp"):getChildByName("toolitem"):clone()
            item:setTag(tonumber(tools:getString(i,"id")))
            item:getChildByName("check"):setTag(tonumber(tools:getString(i,"id")))
            
            item:getChildByName("icon"):loadTexture(dd.getToolsIcon(tonumber(tools:getString(i,"id"))),0)
            item:getChildByName("num"):getChildByName("value"):setString(dd.getToolsCount(tonumber(tools:getString(i,"id"))))
            item:getChildByName("check"):addTouchEventListener(selectTool)
            if count == 1 then
                self._toolId = tonumber(tools:getString(i,"id"))
                item:getChildByName("check"):setSelectedState(true)
            end
            item:setPositionX(20 + (count-1)*160)
            item:setPositionY(0)
            item:setVisible(true)
            self:getChildByName("heroexp"):getChildByName("tools"):addChild(item)
            count = count + 1
        end
    end
    tools:clear()
    
    self:getChildByName("heroexp"):getChildByName("usebtn"):addTouchEventListener(useTool)
    self:getChildByName("heroexp"):getChildByName("close"):addTouchEventListener(self.closePop2)
    self:getChildByName("panel_buyItem"):getChildByName("btn_close"):addTouchEventListener(self.closePop4)
end

function warcollegeLayer:initHPPop()
    local function useTool(sender, eventType)
        if eventType==ccui.TouchEventType.ended then  

            local message = ff.net:createMessage()
            message:addCmd(0x00000171)
            message:addLong(dd.uid)
            message:addLong(dd.heros:getLong(self._selectIndex,"hid"))
            message:addLong(1026)
            message:addLong(1)
            
            ff.net:rpc(message,false)
           
        end
    end

    local item = self:getChildByName("heroehp"):getChildByName("toolitem"):clone()
    item:setTag(1026)
    --item:getChildByName("check"):setTag(tonumber(tools:getString(i,"id")))
    
    item:getChildByName("icon"):loadTexture(dd.getToolsIcon(1026),0)
    item:getChildByName("num"):getChildByName("value"):setString(dd.getToolsCount(1026))
    --item:getChildByName("check"):addTouchEventListener(selectTool)
    item:setPositionX(20 )
    item:setPositionY(0)
    item:setVisible(true)
    self:getChildByName("heroehp"):getChildByName("tools"):addChild(item)


    self:getChildByName("heroehp"):getChildByName("usebtn"):addTouchEventListener(useTool)
    self:getChildByName("heroehp"):getChildByName("close"):addTouchEventListener(self.closePop3)
end


function warcollegeLayer:initCfg()
    --skilllevelup
    local skill = ff.dbmanager:sql_fetch_rows("select * from cfg_hero_skill_levelup")
    for i=1, skill:rowCount() do
        local info = {}
        info['id'] = tonumber(skill:getString(i, "id"))
        info['skillid'] = tonumber(skill:getString(i, "skillid"))
        info['skilllevel'] = tonumber(skill:getString(i, "skilllevel"))
        info['preid1'] = tonumber(skill:getString(i, "preid1"))
        info['preid2'] = tonumber(skill:getString(i, "preid2"))
        info['preid3'] = tonumber(skill:getString(i, "preid3"))

        info['param1'] = tonumber(skill:getString(i, "param1"))
        info['value1'] = tonumber(skill:getString(i, "value1"))
        info['param2'] = tonumber(skill:getString(i, "param2"))
        info['value2'] = tonumber(skill:getString(i, "value2"))
        info['param3'] = tonumber(skill:getString(i, "param3"))
        info['value3'] = tonumber(skill:getString(i, "value3"))
        self._cfgheroskillup[info['skillid']] = self._cfgheroskillup[info['skillid']] or {}
        self._cfgheroskillup[info['skillid']][info['skilllevel']] = info
    end
    skill:clear()
end

function warcollegeLayer.updateHp( sender )
    -- body
    if sender._selectIndex <= dd.heros:rowCount() and sender._selectIndex > 0 then
        if (dd.getServerTime() -  dd.heros:getLong(sender._selectIndex,"PVEHpTime")) % 300 == 0 then
            local  hpMax = dd.heros:getLong(sender._selectIndex,"PVEHpMax")

            local point = (dd.getServerTime() -  dd.heros:getLong(sender._selectIndex,"PVEHpTime")) /300
            
            local hp =math.ceil(point * dd.heros:getLong(sender._selectIndex,"PVEHpMax") / 100) + dd.heros:getLong(sender._selectIndex,"PVEHpNow")
            if hp > dd.heros:getLong(sender._selectIndex,"PVEHpMax") then
                hp = dd.heros:getLong(sender._selectIndex,"PVEHpMax") 
            end
            local infos = sender:getChildByName("view"):getChildByName("infos")
            infos:getChildByName("progresshp"):getChildByName("progress"):setPercent(math.ceil(100 * hp/hpMax))
            infos:getChildByName("progresshp"):getChildByName("exp"):setString(ff.getFormatMoney(hp).."/"..ff.getFormatMoney(hpMax))
            
        end
        local point  = dd.heros:getLong(sender._selectIndex,"PVETotle") - dd.heros:getLong(sender._selectIndex,"PVEAct") -dd.heros:getLong(sender._selectIndex,"PVEDfc")-dd.heros:getLong(sender._selectIndex,"PVEHp")
        sender:getChildByName("view"):getChildByName("skillbtnwex"):getChildByName("Label_189"):setString(point)
    end
end

function warcollegeLayer:updates(row)
    --heros
    local heros = self:getChildByName("view"):getChildByName("heros")
    self._selectIndex = row
    for i=1,dd.heros:rowCount() do
        local heroid= dd.heros:getLong(i,"hid")
        local id   = dd.heros:getLong(i,"id")
        local lv   = dd.heros:getLong(i,"level")
        local star = dd.cfgHero[id]["star"]
        local type = dd.cfgHero[id]["type"]
        local state = dd.heros:getLong(i,"status")
        if state == 9 then
            heros:getChildByName("heros"..i):getChildByName("check"):getChildByName("icon"):loadTexture(dd.getHeroLockIcon(i),0)
            heros:getChildByName("heros"..i):getChildByName("check"):getChildByName("lable_si"..i):setVisible(true)
            heros:getChildByName("heros"..i):getChildByName("check"):getChildByName("lable_si"..i):setString(ff.langString("已死"))
            heros:getChildByName("heros"..i):getChildByName("check"):getChildByName("lao"):setVisible(false)
        elseif state == 2 then
            heros:getChildByName("heros"..i):getChildByName("check"):getChildByName("lao"):setVisible(true)
            heros:getChildByName("heros"..i):getChildByName("check"):getChildByName("lable_si"..i):setVisible(false)
            heros:getChildByName("heros"..i):getChildByName("check"):getChildByName("icon"):loadTexture(dd.getHeroIcon(id),0)
        else
            heros:getChildByName("heros"..i):getChildByName("check"):getChildByName("lao"):setVisible(false)
            heros:getChildByName("heros"..i):getChildByName("check"):getChildByName("lable_si"..i):setVisible(false)
            heros:getChildByName("heros"..i):getChildByName("check"):getChildByName("icon"):loadTexture(dd.getHeroIcon(id),0)
        end
        
        heros:getChildByName("heros"..i):getChildByName("level"):getChildByName("level"):setString("LV."..lv)
        heros:getChildByName("heros"..i):getChildByName("lock"):setVisible(false)
    end
    for i=dd.heros:rowCount()+1,5 do
        heros:getChildByName("heros"..i):getChildByName("check"):getChildByName("icon"):loadTexture(dd.getHeroLockIcon(i),0)
        heros:getChildByName("heros"..i):getChildByName("level"):getChildByName("level"):setString("")
        heros:getChildByName("heros"..i):getChildByName("lock"):setVisible(true)
        heros:getChildByName("heros"..i):getChildByName("check"):getChildByName("lao"):setVisible(false)
        heros:getChildByName("heros"..i):getChildByName("check"):getChildByName("lable_si"..i):setVisible(false)
    end
    --datas
    if row <= dd.heros:rowCount() and row > 0 then
        self:updateUnLock(row)
    else
        self:updateLock(row)
    end
    self:getChildByName("view"):getChildByName("info"):requestDoLayout()
end
--未解锁
function warcollegeLayer:updateLock(row)
    local infos = self:getChildByName("view"):getChildByName("infos")
    local arms  = self:getChildByName("view"):getChildByName("arms")
    --local crys  = self:getChildByName("view"):getChildByName("crys")
    
    self:getChildByName("view"):getChildByName("info"):setVisible(false)
    infos:getChildByName("progress"):setVisible(false)
    infos:getChildByName("progresshp"):setVisible(false)
    infos:getChildByName("addbtn"):setVisible(false)    
    infos:getChildByName("addbtnhp"):setVisible(false)    
    self:getChildByName("view"):getChildByName("infobtn"):setVisible(false)
    infos:getChildByName("tips"):setString("")
    infos:getChildByName("chu_unlock"):setString(ff.langString("军事学院{0}级解锁",{dd.cfgHero[row]["lvlimit"]}))
    for i=1,3 do
        arms:getChildByName("arm"..i):getChildByName("icon"):loadTexture(dd.getPathFromUI("arm_boxs_1.png",1))
        arms:getChildByName("arm"..i):getChildByName("icon"):getChildByName("icon"):loadTexture(self.getArmGreyIcon(i),0)
        arms:getChildByName("arm"..i):getChildByName("add"):setVisible(false)
    end

    --self:getChildByName("view"):getChildByName("crys"):getChildByName("chu_skillpoint"):setVisible(false)
    --self:getChildByName("view"):getChildByName("crys"):getChildByName("skillbtn"):setVisible(false)
    self:getChildByName("view"):getChildByName("mubei"):setVisible(false)
    self:getChildByName("view"):getChildByName("heroicon"):getChildByName("lao"):setVisible(false)
    self:getChildByName("view"):getChildByName("heroicon"):getChildByName("langan"):setVisible(false)
    
    self:getChildByName("view"):getChildByName("heroicon"):setScale(1)
    self:getChildByName("view"):getChildByName("heroicon"):setVisible(true)
    self:getChildByName("view"):getChildByName("heroicon"):getChildByName("icon"):loadTexture(self.getHeroBigLockIcon(row),0)
    self:getChildByName("view"):getChildByName("arms"):getChildByName("arm1"):setTouchEnabled(false)
    self:getChildByName("view"):getChildByName("arms"):getChildByName("arm2"):setTouchEnabled(false)
    self:getChildByName("view"):getChildByName("arms"):getChildByName("arm3"):setTouchEnabled(false)
    self:getChildByName("view"):getChildByName("skillbtnwex"):setVisible(false)
end
--解锁的
function warcollegeLayer:updateUnLock(row)
    self:getChildByName("view"):getChildByName("info"):setVisible(true)
    self:getChildByName("view"):getChildByName("infos"):getChildByName("progress"):setVisible(true)
    self:getChildByName("view"):getChildByName("infos"):getChildByName("progresshp"):setVisible(true)
    self:getChildByName("view"):getChildByName("infos"):getChildByName("addbtn"):setVisible(true) 
    self:getChildByName("view"):getChildByName("infos"):getChildByName("addbtnhp"):setVisible(true)   
    --self:getChildByName("view"):getChildByName("infobtn"):setVisible(true) 
    --self:getChildByName("view"):getChildByName("crys"):getChildByName("chu_skillpoint"):setVisible(true)
    --self:getChildByName("view"):getChildByName("crys"):getChildByName("skillbtn"):setVisible(true)
    
    self:getChildByName("view"):getChildByName("infos"):getChildByName("chu_unlock"):setString("")
    --基本数据-exp
    self:updateBase(row)        
    --arms
    for i=1,3 do
        local aid = dd.heros:getLong(row,"arms"..i)
        self:updateArms(i, aid, row)
    end  
    --crys
    --[[
    for i=1,4 do
        local cid = dd.heros:getLong(row,"tools"..i)
        self:updateCrys(i, cid)
        if dd.getBuildLevel(1) >= 12 then   --司令部等级
            self:getChildByName("view"):getChildByName("crys"):getChildByName("cry"..i):setVisible(true)
        else
            self:getChildByName("view"):getChildByName("crys"):getChildByName("cry"..i):setVisible(false)
        end
    end      
    --skills
    self:updateSkills(row)
    --]]
    --self:getChildByName("view"):getChildByName("crys"):setVisible(false)
    
    self:getChildByName("view"):getChildByName("arms"):getChildByName("arm1"):setTouchEnabled(true)
    self:getChildByName("view"):getChildByName("arms"):getChildByName("arm2"):setTouchEnabled(true)
    self:getChildByName("view"):getChildByName("arms"):getChildByName("arm3"):setTouchEnabled(true)
    self:getChildByName("view"):getChildByName("skillbtnwex"):setVisible(true)
end
--主页-基本数据 - exp
function warcollegeLayer:updateBase(row)
    local infos = self:getChildByName("view"):getChildByName("infos")
    local level = dd.heros:getLong(row,"level")
    local exp   = dd.heros:getLong(row,"heroexp")
    local id    = dd.heros:getLong(row,"id")
    local power = dd.heros:getLong(row,"power")
    local state = dd.heros:getLong(row,"status")
    local name  = ""
    local total = 0
    if dd.cfgHeroUp[dd.cfgHero[id]['star']][level + 1] ~= nil then
        total = dd.cfgHeroUp[dd.cfgHero[id]['star']][level + 1]['levelupexp']
    else
        total = 999999999
    end
    if dd.heros:getString(row,"name") == "" then
        name = ff.langString(dd.cfgHero[id]['name'])
    else
        name = dd.heros:getString(row,"name")
    end
    self:getChildByName("view"):getChildByName("info"):getChildByName("chu_name"):setString(name)
    self:getChildByName("view"):getChildByName("info"):getChildByName("chu_level"):setString("LV."..level)
    self:getChildByName("view"):getChildByName("info"):getChildByName("power"):setString(ff.getFormatMoney(power))
    infos:getChildByName("tips"):setString(ff.langString(dd.cfgHero[id]['memo']))
    infos:getChildByName("progress"):getChildByName("progress"):setPercent(math.ceil(100 * exp/total))
    infos:getChildByName("progress"):getChildByName("exp"):setString(ff.getFormatMoney(exp).."/"..ff.getFormatMoney(total))
    infos:getChildByName("progress"):getChildByName("icon"):loadTexture("images/icon/hero/type/"..dd.cfgHero[id]['type']..".png", 0)

    if state == 9 then
        self:getChildByName("view"):getChildByName("heroicon"):setVisible(false)
        self:getChildByName("view"):getChildByName("mubei"):setVisible(true)
        self:getChildByName("view"):getChildByName("mubei"):getChildByName("fuhuo"):getChildByName("count"):setString(dd.showKM(level*15000,3))
    elseif state == 2 then
        self:getChildByName("view"):getChildByName("mubei"):setVisible(false)
        self:getChildByName("view"):getChildByName("heroicon"):setScale(0.8)
        self:getChildByName("view"):getChildByName("heroicon"):setVisible(true)
        self:getChildByName("view"):getChildByName("heroicon"):getChildByName("lao"):setVisible(true)
        self:getChildByName("view"):getChildByName("heroicon"):getChildByName("langan"):setVisible(true)
        self:getChildByName("view"):getChildByName("heroicon"):getChildByName("icon"):loadTexture(dd.getHeroBigIcon(id),0)
    else
        self:getChildByName("view"):getChildByName("heroicon"):getChildByName("lao"):setVisible(false)
        self:getChildByName("view"):getChildByName("heroicon"):getChildByName("langan"):setVisible(false)
        self:getChildByName("view"):getChildByName("mubei"):setVisible(false)
        self:getChildByName("view"):getChildByName("heroicon"):setScale(1)
        self:getChildByName("view"):getChildByName("heroicon"):setVisible(true)
        self:getChildByName("view"):getChildByName("heroicon"):getChildByName("icon"):loadTexture(dd.getHeroBigIcon(id),0)
    end
    local  hpMax = dd.heros:getLong(row,"PVEHpMax")
    local point = (dd.getServerTime() -  dd.heros:getLong(row,"PVEHpTime")) /300
    local hp =math.ceil(point * dd.heros:getLong(row,"PVEHpMax") / 100 + dd.heros:getLong(row,"PVEHpNow"))
    if hp > dd.heros:getLong(row,"PVEHpMax") then
        hp = dd.heros:getLong(row,"PVEHpMax") 
    end

    infos:getChildByName("progresshp"):getChildByName("progress"):setPercent(math.ceil(100 * hp/hpMax))
    infos:getChildByName("progresshp"):getChildByName("exp"):setString(ff.getFormatMoney(hp).."/"..ff.getFormatMoney(hpMax))
    infos:getChildByName("progresshp"):getChildByName("icon"):loadTexture("images/icon/hero/type/"..dd.cfgHero[id]['type']..".png", 0)
    local point  = dd.heros:getLong(row,"PVETotle") - dd.heros:getLong(row,"PVEAct") -dd.heros:getLong(row,"PVEDfc")-dd.heros:getLong(row,"PVEHp")
    self:getChildByName("view"):getChildByName("skillbtnwex"):getChildByName("Label_189"):setString(point)
end
--主页-装备数据
function warcollegeLayer:updateArms(index, aid, hrow)
    local arm = self:getChildByName("view"):getChildByName("arms"):getChildByName("arm"..index)
    if aid > 0 then
        for i=1,dd.myArms:rowCount() do
            if dd.myArms:getLong(i,"tid") == aid then
                local id = dd.myArms:getLong(i,"aid")
                local color = dd.cfgArms[id]['color']
                local name = dd.cfgArms[id]['name']
                arm:getChildByName("icon"):loadTexture(dd.getPathFromUI("arm_boxs_"..color..".png",1))
                arm:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getArmIcon(id),0)
                arm:getChildByName("add"):setVisible(false)
                break
            end
        end
    else
        arm:getChildByName("icon"):loadTexture(dd.getPathFromUI("arm_boxs_1.png",1))
        arm:getChildByName("icon"):getChildByName("icon"):loadTexture(self.getArmGreyIcon(index),0)
        arm:getChildByName("add"):setVisible(self:isAddOK(hrow, index))
    end    
end
--主页-晶体数据
function warcollegeLayer:updateCrys(index, cid)
    local cry = self:getChildByName("view"):getChildByName("crys"):getChildByName("cry"..index)
    local herolv = 0
    local islock = false
    local cfgid = dd.heros:getLong(self._selectIndex,"id")
    herolv = dd.heros:getLong(self._selectIndex,"level")
    if dd.getBuildLevel(1) >= 10 then        
        if herolv >= (index-1)*10 then
            islock = false
        else
            islock = true
        end
    else
        islock = true
    end
    if cid > 0 then
        for i=1,dd.myCrystals:rowCount() do
            if dd.myCrystals:getLong(i,"cid") == cid then
                local tid   = dd.myCrystals:getLong(i,"id")   --cfgid
                local color = dd.cfgCrystal[tid]['color']
                local level = dd.myCrystals:getLong(i,"level")
                cry:getChildByName("bg"):loadTexture(dd.getPathFromUI("cry_boxs_"..color..".png",1))
                cry:getChildByName("icon"):loadTexture(dd.getHuizhangIcon(tid),0)
                cry:getChildByName("level"):setString("LV."..level)
                break
            end
        end
    else
        cry:getChildByName("bg"):loadTexture(dd.getPathFromUI("cry_boxs_1.png",1))        
        cry:getChildByName("level"):setString("")
        if islock == true then
            cry:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        else
            cry:getChildByName("icon"):loadTexture(dd.getHuizhangGreyIcon(dd.cfgHero[cfgid]["crystal"..index]),0)
        end
    end
    cry:getChildByName("lock"):setVisible(islock)
end
--主页-技能数据
function warcollegeLayer:updateSkills(row)
    if row > 0 then
        local id = dd.heros:getLong(row,"id")
        local lv = dd.heros:getLong(row,"level")
        local star = dd.cfgHero[id]["star"]
        local totalpoint = dd.cfgHeroUp[star][lv]["skillcount"] + self:getHeroPlus()
        local skills = dd.heros:getNetTable(row,"skills")
        local usedpoint = 0 
        for j=1,skills:rowCount() do
            local sid = skills:getLong(j,"sid")
            local lv = skills:getLong(j,"level")
            if sid > 0 then
                usedpoint = usedpoint + lv
            end
        end
       -- self:getChildByName("view"):getChildByName("crys"):getChildByName("chu_skillpoint"):setString(ff.langString("剩余可分配技能点 ：")..(totalpoint - usedpoint))
    end
end

function warcollegeLayer:updatePop(type,params)
    if type == 1 then       --晶体
        self:getChildByName("show"):getChildByName("chu_title"):setString(ff.langString("徽章"))
        --self:getChildByName("show"):getChildByName("crys"):setVisible(true)
        self:getChildByName("show"):getChildByName("arms"):setVisible(false)
        --self:updatePopCrys(self._selectIndex, params,0,0)
    elseif type == 2 then   --装备
        self:getChildByName("show"):getChildByName("chu_title"):setString(ff.langString("装备"))
        --self:getChildByName("show"):getChildByName("crys"):setVisible(false)
        self:getChildByName("show"):getChildByName("arms"):setVisible(true)
        self:updatePopArms(self._selectIndex, params,0,0)
    elseif type == 3 then   --属性页
        local name = ""
        local row  = self._selectIndex
        local lv   = dd.heros:getLong(row,"level")
        if dd.heros:getString(row,"name") == "" then
            name = ff.langString(dd.cfgHero[dd.heros:getLong(row,"id")]['name'])
        else
            name = dd.heros:getString(row,"name")
        end        
        self:getChildByName("show"):getChildByName("chu_title"):setString(name.." LV."..lv)
        --self:getChildByName("show"):getChildByName("crys"):setVisible(false)
        self:getChildByName("show"):getChildByName("arms"):setVisible(false)
    end
end

function warcollegeLayer:updatePop2(hrow,tid)
    local progress = self:getChildByName("heroexp"):getChildByName("heros"):getChildByName("progress"):getChildByName("progress")
    progress:stopAllActions()
    --if self:getChildByName("heroexp"):isVisible() == false then
    --    return
    --end
    self._toolId = tid
    local count = dd.getToolsCount(tid)
    for i,item in ipairs(self:getChildByName("heroexp"):getChildByName("tools"):getChildren()) do
        if item ~= nil then
            local tid2 = item:getTag()
            item:getChildByName("num"):getChildByName("value"):setString(dd.getToolsCount(tid2))
            item:getChildByName("icon"):loadTexture(dd.getToolsIcon(tid2),0)
        end
    end
    
    if count > 0 then
        self:getChildByName("heroexp"):getChildByName("usebtn"):getChildByName("use"):setVisible(true)
        self:getChildByName("heroexp"):getChildByName("usebtn"):getChildByName("gold"):setVisible(false)
        self:setBtnLight(self:getChildByName("heroexp"):getChildByName("usebtn"),true)
        self:getChildByName("heroexp"):getChildByName("usebtn"):getChildByName("use"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))

    else
        if dd.cfgProp[tid]['value'] > 0 then
            self:getChildByName("heroexp"):getChildByName("usebtn"):getChildByName("use"):setVisible(false)
            self:getChildByName("heroexp"):getChildByName("usebtn"):getChildByName("gold"):setVisible(true)
            self:setBtnLight(self:getChildByName("heroexp"):getChildByName("usebtn"),true)
            self:getChildByName("heroexp"):getChildByName("usebtn"):getChildByName("gold"):getChildByName("value"):setString(dd.cfgProp[tid]['value'])
        else
            self:getChildByName("heroexp"):getChildByName("usebtn"):getChildByName("use"):setVisible(true)
            self:getChildByName("heroexp"):getChildByName("usebtn"):getChildByName("gold"):setVisible(false)
            self:setBtnLight(self:getChildByName("heroexp"):getChildByName("usebtn"),false)
            self:getChildByName("heroexp"):getChildByName("usebtn"):getChildByName("use"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        end
    end
    self:getChildByName("heroexp"):getChildByName("tips"):getChildByName("tips"):setString(ff.langString(dd.cfgProp[tid]['tips'],{dd.cfgProp[tid]['tips1_lan']}))
    self:getChildByName("heroexp"):getChildByName("usebtn"):setTag(tid)
    --heros
    local level = dd.heros:getLong(hrow,"level")
    local exp   = dd.heros:getLong(hrow,"heroexp")
    local id    = dd.heros:getLong(hrow,"id")
    local power = dd.heros:getLong(hrow,"power")
    local name  = ""
    local total = 0
    if dd.cfgHero[id] ~= nil and  dd.cfgHeroUp[dd.cfgHero[id]['star']][level + 1] ~= nil then
        total = dd.cfgHeroUp[dd.cfgHero[id]['star']][level + 1]['levelupexp']
    else
        total = 999999999
    end
    if dd.heros:getString(hrow,"name") == "" then
        if  dd.cfgHero[id] ~= nil then
            name = ff.langString(dd.cfgHero[id]['name'])
        end
    else
        name = dd.heros:getString(hrow,"name")
    end
    self:getChildByName("heroexp"):getChildByName("heros"):getChildByName("hero"):getChildByName("icon"):loadTexture(dd.getHeroIcon(id),0)
    self:getChildByName("heroexp"):getChildByName("heros"):getChildByName("name"):getChildByName("name"):setString(name.." LV."..level)
   
   -- local progress = self:getChildByName("heroexp"):getChildByName("heros"):getChildByName("progress"):getChildByName("progress")
    progress:stopAllActions()
    progress:setPercent(math.ceil(100 * exp/total))
    self:getChildByName("heroexp"):getChildByName("heros"):getChildByName("progress"):getChildByName("exp"):setString(ff.getFormatMoney(exp).."/"..ff.getFormatMoney(total))
end

function warcollegeLayer:updatePop3()
    local count = dd.getToolsCount(1026)
    local item = self:getChildByName("heroehp"):getChildByName("tools"):getChildByTag(1026)
    if item ~= nil then
        item:getChildByName("num"):getChildByName("value"):setString(count)
    end

    if count > 0 then
        self:getChildByName("heroehp"):getChildByName("usebtn"):getChildByName("use"):setVisible(true)
        self:getChildByName("heroehp"):getChildByName("usebtn"):getChildByName("gold"):setVisible(false)
    else
        self:getChildByName("heroehp"):getChildByName("usebtn"):getChildByName("use"):setVisible(false)
        self:getChildByName("heroehp"):getChildByName("usebtn"):getChildByName("gold"):setVisible(true)
        self:getChildByName("heroehp"):getChildByName("usebtn"):getChildByName("gold"):getChildByName("value"):setString(dd.cfgProp[1026]['value'])
    end
    self:getChildByName("heroehp"):getChildByName("tips"):getChildByName("tips"):setString(ff.langString(dd.cfgProp[1026]['tips'],{dd.cfgProp[1026]['tips1_lan']}))
    self:getChildByName("heroehp"):getChildByName("usebtn"):setTag(1026)
    --heros
    local level = dd.heros:getLong(self._selectIndex,"level")
    local id    = dd.heros:getLong(self._selectIndex,"id")
    local name  = ""

    if dd.heros:getString(self._selectIndex,"name") == "" then
        name = ff.langString(dd.cfgHero[id]['name'])
    else
        name = dd.heros:getString(self._selectIndex,"name")
    end
    self:getChildByName("heroehp"):getChildByName("heros"):getChildByName("hero"):getChildByName("icon"):loadTexture(dd.getHeroIcon(id),0)
    self:getChildByName("heroehp"):getChildByName("heros"):getChildByName("name"):getChildByName("name"):setString(name.." LV."..level)

    local  hpMax = dd.heros:getLong(self._selectIndex,"PVEHpMax")
    local point = (dd.getServerTime() -  dd.heros:getLong(self._selectIndex,"PVEHpTime")) /300
    local hp =math.ceil(point * dd.heros:getLong(self._selectIndex,"PVEHpMax") / 100 + dd.heros:getLong(self._selectIndex,"PVEHpNow"))
    if hp > dd.heros:getLong(self._selectIndex,"PVEHpMax") then
        hp = dd.heros:getLong(self._selectIndex,"PVEHpMax") 
    end
    local progress = self:getChildByName("heroehp"):getChildByName("heros"):getChildByName("progress"):getChildByName("progress")
    progress:stopAllActions()
    progress:setPercent(math.ceil(100 * hp/hpMax))
    self:getChildByName("heroehp"):getChildByName("heros"):getChildByName("progress"):getChildByName("exp"):setString(ff.getFormatMoney(hp).."/"..ff.getFormatMoney(hpMax))

end

function warcollegeLayer:requestUseMessage(pid, num)
    self._oldLevel = dd.heros:getLong(self._selectIndex,"level")
    local message = ff.net:createMessage()
    message:addCmd(0x0000010a)
    message:addLong(dd.uid)
    message:addLong(pid)
    message:addLong(num)
    message:addLong(0)

    message:addLong(dd.heros:getLong(self._selectIndex,"hid"))
    ff.net:rpc(message,false)
    local popview = self:getChildByName("panel_buyItem")
    popview:setVisible(false)
end

function warcollegeLayer:showBuyView(tid)
    cclog("=1111111111111")
    local propData = {}
    propData.name = dd.cfgProp[tid]["name"]
    propData.tips = dd.cfgProp[tid]["tips"]
    propData.num = dd.getToolsCount(tid)
    propData.pid = tid

    local popview = self:getChildByName("panel_buyItem")
    popview:setVisible(true)
    popview:setPositionY(-popview:getContentSize().height)
    popview:stopAllActions()
    popview:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,0)))))    

    local imgBg = popview:getChildByName("img_icon_bg")
    local lab_itemNum = popview:getChildByName("lab_num")
    local img_icon = imgBg:getChildByName("img_icon")

    local lab_itemName = popview:getChildByName("infos"):getChildByName("lab_itemName")
    local lab_itemInfo = popview:getChildByName("infos"):getChildByName("lab_itemInfo")
    lab_itemName:setString(ff.langString(propData.name))
    lab_itemInfo:setString(ff.langString(propData.tips,{dd.cfgProp[tid]['tips1_lan']}))
    lab_itemNum:setString(propData.num)--b
    img_icon:loadTexture(dd.getToolsIcon(propData.pid),0)

    local slider = popview:getChildByName("panel_slider"):getChildByName("slider")
    local lab_current = popview:getChildByName("panel_slider"):getChildByName("lab_current")
    slider:setPercent(0)

    local btn_sub = popview:getChildByName("btn_sub")
    local btn_add = popview:getChildByName("btn_add")
    local btn_commit = popview:getChildByName("btn_commit")
    local lab_comBuy = btn_commit:getChildByName("lab_buy")
    --local lab_cost = btn_commit:getChildByName("lab_cost")
    --local img_coin = btn_commit:getChildByName("Image_77")

    local panel_input = popview:getChildByName("panel_input")
    local tf_input = panel_input:getChildByName("lab_input")

    self.curNum = 1    --当前操作道具数量
    local userCoin = 0  --玩家当前货币值
    --local price = 0     --单价
    local maxNum = dd.getToolsCount(propData.pid)

    if maxNum > 99 then
        popview:getChildByName("lab_max"):setString("99")
    else
        popview:getChildByName("lab_max"):setString(maxNum)
    end



    local function setCommitButtonWithPrice()
        if self.curNum < 1 then
            self.curNum = 1
        end
        
        slider:setPercent((self.curNum / maxNum)*100)

        local bgWidth = btn_commit:getContentSize().width
        tf_input:setString(math.floor(self.curNum))

        lab_current:setString(math.floor(self.curNum))

    end
    
    local function buttonClick(sender, touchType)
        if touchType == ccui.TouchEventType.ended then
            if sender == btn_sub then
                self.curNum = self.curNum - 1
                if self.curNum < 1 then
                    self.curNum = 1
                end
                setCommitButtonWithPrice()
            elseif sender == btn_add then
                self.curNum = self.curNum + 1
                if self.curNum > maxNum then
                    self.curNum = maxNum
                end
                setCommitButtonWithPrice()
            elseif sender == btn_commit then
                self.curNum = math.floor(self.curNum)
                setCommitButtonWithPrice()

                self:requestUseMessage(propData.pid, self.curNum)
                
            end
        end
    end
    btn_add:addTouchEventListener(buttonClick)
    btn_sub:addTouchEventListener(buttonClick)
    btn_commit:addTouchEventListener(buttonClick)

    local function percentChangedEvent(sender,eventType)
        if eventType == ccui.SliderEventType.percentChanged then
            local percent = slider:getPercent()
            if maxNum > 99 then 
                maxNum = 99
            end
            self.curNum = (percent/100) * maxNum
            setCommitButtonWithPrice()
        end
    end  
    slider:addEventListener(percentChangedEvent)


    self.price = propData.cost
    userCoin = propData.num--dd.myUnion:getLong(1, "unionpoint")
    lab_comBuy:setString(ff.langString("使用"))
    popview:getChildByName("lab_viewInfo"):setString(ff.langString("道具使用"))
    maxNum = propData.num
    -- img_coin:loadTexture(dd.getPathFromUI("public/ic13.png", 1))
    lab_comBuy:setPositionY(50)
    --lab_cost:setVisible(false)
    --img_coin:setVisible(false)
   
    setCommitButtonWithPrice()

    --init editbox
    if panel_input:getChildByTag(10091) == nil then
        local editBox = dd.addEditBox(
             panel_input
            , panel_input:getContentSize()
            , "images/ui/alpha.png"
            , 10091
            , cc.p(0,0)
            , cc.p(popview:getChildByName("panel_input"):getChildByName("lab_input"):getPositionX()-32,0)
            , cc.c3b(255,255,255)
            , 20
            , 2
            , 4
            , 1
            , 5
            , true
            , true
            , true
        )
        local function editBoxTextEventHandle(strEventName,pSender)
            local edit = pSender
            local strFmt 
            if strEventName == "began" then
                tf_input:setVisible(false)
            elseif strEventName == "ended" or strEventName == "return" then
                local text = tonumber(edit:getText())
                if text == nil or text == "" then
                    tf_input:setVisible(true)
                    return
                end
                local input_count = text 
                if input_count > 99 then
                    input_count = 99
                end
                if input_count <= 0 then
                    input_count = 1
                end
                tf_input:setString(input_count)
                self.curNum = input_count
                setCommitButtonWithPrice()
                cclog("input_count:"..input_count..","..self.curNum)

                edit:setText("")
            --elseif strEventName == "changed" then
            --    tf_input:setVisible(true)
            end
        end
        editBox:registerScriptEditBoxHandler(editBoxTextEventHandle)
        slider:setCorrect(35,316)
    end
end

function warcollegeLayer:showProgressStep(hrow,oldlevel)
    local level = dd.heros:getLong(hrow,"level")
    local exp   = dd.heros:getLong(hrow,"heroexp")
    local id    = dd.heros:getLong(hrow,"id")
    local total = 0  
    local name  = ""      
    if dd.cfgHeroUp[dd.cfgHero[id]['star']][level + 1] ~= nil then
        total = dd.cfgHeroUp[dd.cfgHero[id]['star']][level + 1]['levelupexp']
    else
        total = 999999999
    end
    
    if dd.heros:getString(hrow,"name") == "" then
        name = ff.langString(dd.cfgHero[id]['name'])
    else
        name = dd.heros:getString(hrow,"name")
    end
    local progress = self:getChildByName("heroexp"):getChildByName("heros"):getChildByName("progress"):getChildByName("progress")
    progress:stopAllActions()
   
    --进度动作
    local from      = progress:getPercent()
    local to        = math.ceil(100 * exp/total)
    local count     = level - oldlevel
    local tempcount = 0
    local tolexp    = 0
    local curexp    = 0
    local over      = false
    if count > 2 then
        count = 2
    end
    local function step()
        from = from + 1
        if tempcount < count then
            if from >= 100 then
                from = 0   
                tempcount = tempcount + 1 
                oldlevel  = oldlevel  + 1
            end
        else
            oldlevel = level
            if from >= to then
                from = to  
                over = true
            end 
        end
        if dd.cfgHeroUp[dd.cfgHero[id]['star']][oldlevel + 1] ~= nil then
            tolexp = dd.cfgHeroUp[dd.cfgHero[id]['star']][oldlevel + 1]['levelupexp']
        else
            tolexp = 999999999
        end
        curexp     = math.floor(tolexp * from/100)
        self:getChildByName("heroexp"):getChildByName("heros"):getChildByName("progress"):getChildByName("progress"):setPercent(from)
        self:getChildByName("heroexp"):getChildByName("heros"):getChildByName("progress"):getChildByName("exp"):setString(ff.getFormatMoney(curexp).."/"..ff.getFormatMoney(tolexp))
        self:getChildByName("heroexp"):getChildByName("heros"):getChildByName("name"):getChildByName("name"):setString(name.." LV."..oldlevel)   
        
        if over == true then
            self:updatePop2(self._selectIndex,self._toolId)
            progress:stopAllActions()
        end
    end        
    schedule(progress, step, 0.01)
    
end

function warcollegeLayer:showPopByType(type, params)
    self:getChildByName("masking"):setVisible(true)
    self:updatePop(type,params)
    pop.showPopEffect(12,self:getChildByName("show"))
end

function warcollegeLayer.closePop(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  
        local function unShow()
            local widget = pop.getDialog("warcollege")
            widget:getChildByName("show"):setVisible(false)
            widget:getChildByName("masking"):setVisible(false)
        end    
    
        if eventType==ccui.TouchEventType.ended then   
            local widget = pop.getDialog("warcollege")
            widget:getChildByName("show"):setVisible(false)
            widget:getChildByName("masking"):setVisible(false)
            --[[
            local view = widget:getChildByName("show")
            view:runAction(cc.Sequence:create(cc.MoveTo:create(0.5, cc.p(0,-700)),cc.CallFunc:create(unShow)))
            --]]
        end
    end
end

function warcollegeLayer:showPop2()
    self:getChildByName("masking"):setVisible(true)
    self:updatePop2(self._selectIndex,self._toolId)
    self:getChildByName("heroexp"):setPosition(cc.p(0,0))
    pop.showPopEffect(12,self:getChildByName("heroexp")) 
end

function warcollegeLayer:showPop3()
    self:getChildByName("masking"):setVisible(true)
    self:updatePop3()
    self:getChildByName("heroehp"):setPosition(cc.p(0,0))
    pop.showPopEffect(12,self:getChildByName("heroehp")) 
end

function warcollegeLayer.closePop2(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  
        local function unShow()
            local widget = pop.getDialog("warcollege")
            widget:getChildByName("heroexp"):setVisible(false)
            widget:getChildByName("masking"):setVisible(false)
        end    
    
        if eventType==ccui.TouchEventType.ended then   
            local widget = pop.getDialog("warcollege")
            local progress = widget:getChildByName("heroexp"):getChildByName("heros"):getChildByName("progress"):getChildByName("progress")
            progress:stopAllActions()
            widget:getChildByName("heroexp"):setVisible(false)
            widget:getChildByName("masking"):setVisible(false)
            --[[
            local view = widget:getChildByName("heroexp")
            view:runAction(cc.Sequence:create(cc.MoveTo:create(0.5, cc.p(0,-600)),cc.CallFunc:create(unShow)))
            --]]
        end
    end
end

function warcollegeLayer.closePop4(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  

    
        if eventType==ccui.TouchEventType.ended then   
            local widget = pop.getDialog("warcollege")
            local progress = widget:getChildByName("panel_buyItem")
            progress:stopAllActions()
            widget:getChildByName("heroexp"):setVisible(false)
            widget:getChildByName("masking"):setVisible(false)
            progress:setVisible(false)
        end
    end
end

function warcollegeLayer.closePop3(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  
        local function unShow()
            local widget = pop.getDialog("warcollege")
            widget:getChildByName("heroehp"):setVisible(false)
            widget:getChildByName("masking"):setVisible(false)
        end    
    
        if eventType==ccui.TouchEventType.ended then   
            local widget = pop.getDialog("warcollege")
            widget:getChildByName("heroehp"):setVisible(false)
            widget:getChildByName("masking"):setVisible(false)
            --[[
            local view = widget:getChildByName("heroexp")
            view:runAction(cc.Sequence:create(cc.MoveTo:create(0.5, cc.p(0,-600)),cc.CallFunc:create(unShow)))
            --]]
        end
    end
end

--pop-晶体数据   英雄row 晶体type1234
function warcollegeLayer:updatePopCrys(hrow,ctype,cryrow,ccount)
    local hid = dd.heros:getLong(hrow,"hid")
    local id  = dd.heros:getLong(hrow,"id")
    local tool = dd.heros:getLong(hrow,"tools"..ctype)
    local type = dd.cfgHero[id]["crystal"..ctype]
    local count = 1
    local nums = 0
    local hh = self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getContentSize().height
    local ihh = 0
    local addhh = 0
    local addline = 1000
    self._oldCryRow = cryrow   
    self._crysIndex = ctype
    --隐藏
    self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByName("tips"):setVisible(false)
    for i,v in ipairs(self._citems) do
        if tolua.isnull(v) then
            self._citems[i] = nil
        else
            v:setVisible(false)
            v:setTag(i)
            v:getChildByName("check"):setSelectedState(false)
            v:getChildByName("check"):setTouchEnabled(true)
        end
    end
    --计算满足条件的数量
    for i=1,dd.myCrystals:rowCount() do
        local tid = dd.myCrystals:getLong(i,"id")   --cfgid
        local cpos = dd.cfgCrystal[tid]["type"]


        if ff._and(cpos, type) > 0 and dd.myCrystals:getLong(i,"heroid") == 0 then
            nums = nums + 1
        elseif dd.myCrystals:getLong(i,"heroid") == hid and dd.myCrystals:getLong(i,"cid") == tool then
            nums = nums + 1
        end
    end   
    --补足2行
    if nums < 12 then    
        nums = 12
    end
    if cryrow > 0 then
        --显示tips 最后设置位置
        addhh   = self:showCryTips(cryrow,ccount)    
        addline = math.floor((ccount-1)/4)
    end
    ihh = 147* math.ceil(nums/4) + addhh
    if ihh < hh then
        ihh = hh
    end
    self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):setInnerContainerSize(cc.size(720,ihh))
    
    --第一件显示装备的
    if tool > 0 then
        for i=1,dd.myCrystals:rowCount() do
            local tid = dd.myCrystals:getLong(i,"id")   --cfgid
            if dd.myCrystals:getLong(i,"cid") == tool then
                local item = self._citems[count]
                if item == nil then
                    item = self:getChildByName("show"):getChildByName("crys"):getChildByName("citem"):clone()
                    self._citems[count] = item
                    self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):addChild(item)
                end
                item:setVisible(true)
                item:getChildByName("level"):setString("LV."..dd.myCrystals:getLong(i,"level"))
                item:getChildByName("icon"):loadTexture(dd.getHuizhangIcon(tid),0)
                item:getChildByName("bg"):loadTexture(dd.getPathFromUI("cry_boxs_"..dd.cfgCrystal[tid]['color']..".png",1))
                item:getChildByName("check"):loadTextureBackGroundSelected(
                    dd.getPathFromUI("cry_onboxs_"..dd.cfgCrystal[tid]['color']..".png",1))
                item:getChildByName("check"):loadTextureFrontCross(
                    dd.getPathFromUI("cry_onboxs_"..dd.cfgCrystal[tid]['color']..".png",1))
                item:getChildByName("word_e"):setVisible(true)
                item:getChildByName("word_e"):loadTexture(dd.getPathFromUI("arm_e.png",1))
                item:setPositionX(30 + ((count-1)%4)*170 )
                item:setPositionY(ihh - 147 - math.floor((count-1)/4)*147 )
                item:setTag(i)
                item:getChildByName("check"):setTag(i)
                item:getChildByName("check").acount = count
                
                count = count + 1
                break
            end
        end
    end
    
    for i=1,dd.myCrystals:rowCount() do
        local tid = dd.myCrystals:getLong(i,"id")   --cfgid
        local cpos = dd.cfgCrystal[tid]["type"]
        if ff._and(cpos, type) > 0 and dd.myCrystals:getLong(i,"cid") ~= tool and dd.myCrystals:getLong(i,"heroid") == 0 then
            local item = self._citems[count]
            if item == nil then
                item = self:getChildByName("show"):getChildByName("crys"):getChildByName("citem"):clone()
                self._citems[count] = item
                self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):addChild(item)
            end
            item:setVisible(true)
            item:getChildByName("level"):setString("LV."..dd.myCrystals:getLong(i,"level"))
            item:getChildByName("icon"):loadTexture(dd.getHuizhangIcon(tid),0)
            item:getChildByName("bg"):loadTexture(dd.getPathFromUI("cry_boxs_"..dd.cfgCrystal[tid]['color']..".png",1))
            item:getChildByName("check"):loadTextureBackGroundSelected(
                dd.getPathFromUI("cry_onboxs_"..dd.cfgCrystal[tid]['color']..".png",1))
            item:getChildByName("check"):loadTextureFrontCross(
                dd.getPathFromUI("cry_onboxs_"..dd.cfgCrystal[tid]['color']..".png",1))
            item:getChildByName("word_e"):setVisible(false)            
            --计算tips空间
            if math.floor((count-1)/4) > addline then
                item:setPositionX(30 + ((count-1)%4)*170 )
                item:setPositionY(ihh - addhh - 147 - math.floor((count-1)/4)*147 )
            else
                item:setPositionX(30 + ((count-1)%4)*170 )
                item:setPositionY(ihh - 147 - math.floor((count-1)/4)*147 )
            end
            
            item:setTag(i)
            item:getChildByName("check"):setTag(i)
            item:getChildByName("check").acount = count
            
            count = count + 1
        end
    end
    --不够4排补足
    for i=count, nums do
        local item = self._citems[i]
        if item == nil then
            item = self:getChildByName("show"):getChildByName("crys"):getChildByName("citem"):clone()
            self._citems[i] = item
            self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):addChild(item)
        end
        if math.floor((count-1)/4) > addline then
            item:setPositionX(30 + ((count-1)%4)*170 )
            item:setPositionY(ihh - addhh - 147 - math.floor((count-1)/4)*147 )
        else
            item:setPositionX(30 + ((count-1)%4)*170 )
            item:setPositionY(ihh - 147 - math.floor((count-1)/4)*147 )
        end
        item:getChildByName("check"):setTouchEnabled(false)
        item:getChildByName("word_e"):setVisible(false)
        item:getChildByName("level"):setString("")
        item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        item:getChildByName("bg"):loadTexture(dd.getPathFromUI("cry_boxs_1.png",1))
        item:setVisible(true)
        count = count + 1
    end
    --选择默认显示的
    if cryrow > 0 then
        --设置tips位置
        local tips = self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByName("tips")
        tips:setPositionY(ihh - addhh - 147 - addline*147)
        if tips:isVisible() == true then
            local fixy = self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getInnerContainer():getPositionY() + tips:getPositionY()
            if fixy < 0 then
                self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,-fixy)))
            end
        end
    end   
end

function warcollegeLayer:showCryTips(row,ccount)
    local tid = dd.myCrystals:getLong(row,"id")   --cfgid
    local curexp = dd.myCrystals:getLong(row,"curexp")
    local level = dd.myCrystals:getLong(row,"level")
    local col = dd.cfgCrystal[tid]["color"] 
    local name = ff.langString(dd.cfgCrystal[tid]['name']) 
    local nextexp = 9999999
    local count = 0   
    self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByName("tips"):setVisible(true)   
    self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByName("tips"):getChildByName("tips"):removeAllChildren(true)
    --装备 or 卸下
    self._oldCryRow = row
    local richText = ccui.RichText:create()
    richText:ignoreContentAdaptWithSize(false)
    richText:setContentSize(cc.size(650,600)) 
    richText:setAutoHeight()
    --name
    if dd.myCrystals:getLong(row,"heroid") > 0 then
        for i=1,dd.heros:rowCount() do
            if dd.myCrystals:getLong(row,"heroid") == dd.heros:getLong(i,"hid") then
                if dd.heros:getString(row,"name") == "" then
                    name = name.."("..ff.langString(dd.cfgHero[dd.heros:getLong(i,"id")]['name'])..")"
                else
                    name = name.."("..dd.heros:getString(row,"name")..")"
                end
                break
            end
        end
        self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByName("tips"):getChildByName("equipbtn"):getChildByName("chu_label"):setString(ff.langString("卸下"))
    else
        self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByName("tips"):getChildByName("equipbtn"):getChildByName("chu_label"):setString(ff.langString("装备"))
    end
    self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByName("tips"):getChildByName("name"):setString(name)
    
    
    if dd.cfgCrystalLevelUp[col][level + 1]["exp"] ~= nil then
        nextexp = dd.cfgCrystalLevelUp[col][level + 1]["exp"]
    end
    local chat1 = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n".."LV."..level..":"..curexp.."/"..nextexp, "Helvetica", 20)
    richText:insertElement(chat1,count)
    count = count + 1
    
    for k=1,2 do
        local param = dd.cfgCrystal[tid]['param'..k]  
        if param > 0 then
            local value = math.floor(dd.cfgCrystal[tid]['value'..k] + dd.cfgCrystal[tid]['addvalue'..k]*(level-1)/10)
            
            local chat2 = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n"..ff.langString(dd.cfgEffect[param]['name']), "Helvetica", 20)
            richText:insertElement(chat2,count)
            count = count + 1
            
            if tonumber(dd.cfgEffect[param]['tips2']) ~= 0 then
                local valuestr = "+"..value..ff.langString(dd.cfgEffect[param]['tips2'])
                local chat3 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                richText:insertElement(chat3,count)
            else
                local valuestr = "+"..value
                local chat3 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                richText:insertElement(chat3,count)
            end
            count = count + 1
        end
    end
    richText:formatText()
    local size = richText:getContentSize()
    local height = size.height
    richText:setPosition(cc.p(333,height - height/2 + 80 -30))
    self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByName("tips"):setContentSize(cc.size(650, height + 85))
    self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByName("tips"):getChildByName("tips"):setContentSize(cc.size(650, height + 85))
    self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByName("tips"):getChildByName("tips"):addChild(richText)

    self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByName("tips"):getChildByName("name"):setPositionY(height + 85 - 18)
    self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByName("tips"):getChildByName("flag"):setPositionX(73 + ((ccount-1)%4)*170)
    self:getChildByName("show"):getChildByName("crys"):getChildByName("cryslist"):getChildByName("tips"):getChildByName("flag"):setPositionY(height + 85 - 4)

    return height + 85 + 20
end

--pop --装备数据   装备type 123
function warcollegeLayer:updatePopArms(hrow, atype, armrow, acount)
    local hid = dd.heros:getLong(hrow,"hid")
    local id  = dd.heros:getLong(hrow,"id")
    local aid = dd.heros:getLong(hrow,"arms"..atype)
    local count = 1
    local nums = 0
    local hh = self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getContentSize().height
    local ihh = 0
    local addhh = 0
    local addline = 1000
    self._oldArmRow = armrow
    self._armsIndex = atype
    --隐藏
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):setVisible(false)
    for i,v in ipairs(self._aitems) do
        if tolua.isnull(v) then
            self._aitems[i] = nil
        else
            v:setVisible(false)
            v:setTag(i)
            v:getChildByName("check"):setSelectedState(false)
            v:getChildByName("check"):setTouchEnabled(true)
        end
    end
    --计算满足条件的数量
    for i=1,dd.myArms:rowCount() do
        local tid = dd.myArms:getLong(i,"aid")
        local place = dd.cfgArms[tid]['place']
        if place == atype and dd.myArms:getLong(i,"heroid") == 0 then
            nums = nums + 1
        elseif dd.myArms:getLong(i,"heroid") == hid and dd.myArms:getLong(i,"tid") == aid then
            nums = nums + 1
        end
    end  
    --补足4行
    if nums < 15 then    
        nums = 15
    end
    if armrow > 0 then
        --显示tips 最后设置位置
        addhh   = self:showArmTips(armrow,acount)    
        addline = math.floor((acount-1)/5)
    end
    ihh = 147* math.ceil(nums/5) + addhh
    if ihh < hh then
        ihh = hh
    end
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):setInnerContainerSize(cc.size(720,ihh))

    --第一件显示装备的
    if aid > 0 then
        for i=1,dd.myArms:rowCount() do
            local tid = dd.myArms:getLong(i,"aid")   --cfgid
            if dd.myArms:getLong(i,"tid") == aid then
                local item = self._aitems[count]
                if item == nil then
                    item = self:getChildByName("show"):getChildByName("arms"):getChildByName("aitem"):clone()
                    self._aitems[count] = item
                    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):addChild(item)
                end
                item:setVisible(true)
                item:getChildByName("icon"):loadTexture(dd.getArmIcon(tid),0)
                item:getChildByName("bg"):loadTexture(dd.getPathFromUI("arm_boxs_"..dd.cfgArms[tid]['color']..".png",1))
                item:getChildByName("check"):loadTextureBackGroundSelected(
                    dd.getPathFromUI("arm_onboxs_"..dd.cfgArms[tid]['color']..".png",1))
                item:getChildByName("check"):loadTextureFrontCross(
                    dd.getPathFromUI("arm_onboxs_"..dd.cfgArms[tid]['color']..".png",1))
                item:getChildByName("word_e"):setVisible(true)
                item:getChildByName("word_e"):loadTexture(dd.getPathFromUI("arm_e.png",1))
                item:getChildByName("warn_i"):setVisible(false)
                item:setPositionX(13 + ((count-1)%5)*140 )
                item:setPositionY(ihh - 147 - math.floor((count-1)/5)*147 )
                item:setTag(i)
                item:getChildByName("check"):setTag(i)
                item:getChildByName("check").acount = count
                
                for i=1,dd.cfgArms[tid]['hole'] do
                    item:getChildByName("gem"..i):setVisible(true)                
                end            
                for i=dd.cfgArms[tid]['hole']+1,4 do
                    item:getChildByName("gem"..i):setVisible(false) 
                end

                for k=1,3 do
                    local gid = dd.myArms:getLong(i,"gem"..k)    --好像cfgid 也是这个
                    if gid > 0 then
                        local color = dd.cfgGems[gid]['color']
                        item:getChildByName("gem"..k):getChildByName("icon"):loadTexture(dd.getToolsIcon(gid), 0)
                    else
                        item:getChildByName("gem"..k):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                    end                    
                end
                count = count + 1
            end
        end
    end
    for i=1, dd.myArms:rowCount() do
        local tid = dd.myArms:getLong(i,"aid")
        local place = dd.cfgArms[tid]['place']
        if place == atype and dd.myArms:getLong(i,"heroid") == 0 then
            local item = self._aitems[count]
            if item == nil then
                item = self:getChildByName("show"):getChildByName("arms"):getChildByName("aitem"):clone()
                self._aitems[count] = item
                self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):addChild(item)
            end
            item:setVisible(true)
            item:getChildByName("icon"):loadTexture(dd.getArmIcon(tid),0)
            item:getChildByName("bg"):loadTexture(dd.getPathFromUI("arm_boxs_"..dd.cfgArms[tid]['color']..".png",1))
            item:getChildByName("check"):loadTextureBackGroundSelected(
                dd.getPathFromUI("arm_onboxs_"..dd.cfgArms[tid]['color']..".png",1))
            item:getChildByName("check"):loadTextureFrontCross(
                dd.getPathFromUI("arm_onboxs_"..dd.cfgArms[tid]['color']..".png",1))
            item:getChildByName("word_e"):setVisible(false)
            
            if dd.heros:getLong(self._selectIndex,"level") < dd.cfgArms[tid]['level'] then
                item:getChildByName("warn_i"):setVisible(true)
            else
                item:getChildByName("warn_i"):setVisible(false)
            end

            --计算tips空间
            if math.floor((count-1)/5) > addline then
                item:setPositionX(13 + ((count-1)%5)*140 )
                item:setPositionY(ihh - addhh - 147 - math.floor((count-1)/5)*147 )
            else
                item:setPositionX(13 + ((count-1)%5)*140 )
                item:setPositionY(ihh - 147 - math.floor((count-1)/5)*147 )
            end

            item:setTag(i)
            item:getChildByName("check"):setTag(i)
            item:getChildByName("check").acount = count

            for i=1,dd.cfgArms[tid]['hole'] do
                item:getChildByName("gem"..i):setVisible(true)    
                item:getChildByName("gem"..i):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))            
            end            
            for i=dd.cfgArms[tid]['hole']+1,4 do
                item:getChildByName("gem"..i):setVisible(false) 
            end

            for k=1,3 do
                local gid = dd.myArms:getLong(i,"gem"..k)    --好像cfgid 也是这个
                if gid > 0 then
                    local color = dd.cfgGems[gid]['color']
                    item:getChildByName("gem"..k):getChildByName("icon"):loadTexture(dd.getToolsIcon(gid), 0)
                else
                    item:getChildByName("gem"..k):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                end                    
            end
            count = count + 1
        end
    end
    --不够4排补足
    for i=count, nums do
        local item = self._aitems[i]
        if item == nil then
            item = self:getChildByName("show"):getChildByName("arms"):getChildByName("aitem"):clone()
            self._aitems[i] = item
            self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):addChild(item)
        end
        if math.floor((count-1)/5) > addline then
            item:setPositionX(13 + ((count-1)%5)*140 )
            item:setPositionY(ihh - addhh - 147 - math.floor((count-1)/5)*147 )
        else
            item:setPositionX(13 + ((count-1)%5)*140 )
            item:setPositionY(ihh - 147 - math.floor((count-1)/5)*147 )
        end
        item:getChildByName("check"):setTouchEnabled(false)
        item:getChildByName("word_e"):setVisible(false)
        item:getChildByName("warn_i"):setVisible(false)
        item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        item:getChildByName("bg"):loadTexture(dd.getPathFromUI("arm_boxs_1.png",1))
        item:getChildByName("gem1"):setVisible(false) 
        item:getChildByName("gem2"):setVisible(false) 
        item:getChildByName("gem3"):setVisible(false) 
        item:getChildByName("gem4"):setVisible(false) 
        item:setVisible(true)
        count = count + 1
    end
    if armrow > 0 then
        --设置tips位置
        local tips = self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips")
        tips:setPositionY(ihh - addhh - 147 - addline*147)
        if tips:isVisible() == true then
            local fixy = self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getInnerContainer():getPositionY() + tips:getPositionY()
            if fixy < 0 then
                self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,-fixy)))
            end
        end
    end
end
function warcollegeLayer:showArmTips(row,count)
    local tid = dd.myArms:getLong(row,"aid")   --cfgid
    local col = dd.cfgArms[tid]["color"] 
    local name = ff.langString(dd.cfgArms[tid]['name']) 
    
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("tips"):removeAllChildren(true)
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):setVisible(true)
    --左边
    local richText1 = ccui.RichText:create()
    richText1:ignoreContentAdaptWithSize(false)
    richText1:setContentSize(cc.size(310,600)) 
    richText1:setAutoHeight()
    
    --name
    if dd.myArms:getLong(row,"heroid") > 0 then
        for i=1,dd.heros:rowCount() do
            if dd.myArms:getLong(row,"heroid") == dd.heros:getLong(i,"hid") then
                if dd.heros:getString(row,"name") == "" then
                    name = name.."("..ff.langString(dd.cfgHero[dd.heros:getLong(i,"id")]['name'])..")"
                else
                    name = name.."("..dd.heros:getString(row,"name")..")"
                end
                break
            end
        end
        self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("equipbtn"):getChildByName("chu_label"):setString(ff.langString("卸下"))
    else
        self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("equipbtn"):getChildByName("chu_label"):setString(ff.langString("装备"))
    end
        
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("name"):setString(name)
    --装备效果
    local count1 = 0
    local lvstr  = "LV."..dd.cfgArms[tid]['level']
    if dd.heros:getLong(self._selectIndex,"level") < dd.cfgArms[tid]['level'] then
        lvstr = lvstr.."("..ff.langString("英雄等级不足以装备")..")"
    end
    
    local chatlv = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n"..lvstr, "Helvetica", 20)
    richText1:insertElement(chatlv,count1)
    count1 = count1 + 1

    for i=1,3 do
        local param = dd.cfgArms[tid]["param"..i]
        if param > 0 then
            local value = dd.cfgArms[tid]['value'..i]
            if dd.cfgEffect[param]['value'] > 0 then
                value = value/dd.cfgEffect[param]['value']
            end
            local chat1 = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n"..ff.langString(dd.cfgEffect[param]['name']), "Helvetica", 20)
            richText1:insertElement(chat1,count1)
            count1 = count1 + 1
            if tonumber(dd.cfgEffect[param]['tips2']) ~= 0 then
                local valuestr = "+"..value..ff.langString(dd.cfgEffect[param]['tips2'])
                local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                richText1:insertElement(chat2,count1)
            else
                local valuestr = "+"..value
                local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                richText1:insertElement(chat2,count1)
            end
            count1 = count1 + 1
        end
    end
    richText1:formatText()
    
    --右边
    local richText2 = ccui.RichText:create()
    richText2:ignoreContentAdaptWithSize(false)
    richText2:setContentSize(cc.size(310,600)) 
    richText2:setAutoHeight()
    
    --宝石效果   富文本要从0开始
    local count2 = 0
    for i=1,3 do
        local gid = dd.myArms:getLong(row,"gem"..i)    --好像cfgid 也是这个
        if gid > 0 then
            if dd.cfgGems[gid]['param1'] > 0 then
                local value = dd.cfgGems[gid]['value1']
                local param = dd.cfgGems[gid]['param1']
                if dd.cfgEffect[param]['value'] > 0 then
                    value = value/dd.cfgEffect[param]['value']
                end
                local chat1 = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n"..ff.langString(dd.cfgEffect[param]['name']), "Helvetica", 20)
                richText2:insertElement(chat1,count2)
                count2 = count2 + 1
                
                if tonumber(dd.cfgEffect[param]['tips2']) ~= 0 then
                    local valuestr = "+"..value..ff.langString(dd.cfgEffect[param]['tips2'])
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                    richText2:insertElement(chat2,count2)
                else
                    local valuestr = "+"..value
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                    richText2:insertElement(chat2,count2)
                end
                count2 = count2 + 1
            end
            if dd.cfgGems[gid]['param2'] > 0 then
                local value = dd.cfgGems[gid]['value2']
                local param = dd.cfgGems[gid]['param2']
                if dd.cfgEffect[param]['value'] > 0 then
                    value = value/dd.cfgEffect[param]['value']
                end
                local chat1 = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n"..ff.langString(dd.cfgEffect[param]['name']), "Helvetica", 20)
                richText2:insertElement(chat1,count2)
                count2 = count2 + 1
                if tonumber(dd.cfgEffect[param]['tips2']) ~= 0 then
                    local valuestr = "+"..value..ff.langString(dd.cfgEffect[param]['tips2'])
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                    richText2:insertElement(chat2,count2)
                else
                    local valuestr = "+"..value
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                    richText2:insertElement(chat2,count2)
                end
                count2 = count2 + 1
            end                     
        end
    end
    richText2:formatText()
    --计算高度
    local height = 0
    local size1 = richText1:getContentSize()
    local size2 = richText2:getContentSize()
    if size1.height > size2.height then
        height = size1.height
    else
        height = size2.height
    end
    richText1:setPosition(cc.p(163,height - size1.height/2 + 80 -30))
    richText2:setPosition(cc.p(520,height - size2.height/2 + 80 -30))
    
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):setContentSize(cc.size(696, height + 85))
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("tips"):setContentSize(cc.size(696, height + 85))
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("tips"):addChild(richText1)
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("tips"):addChild(richText2)
    
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("name"):setPositionY(height + 85 - 18)
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("flag"):setPositionX(71 + ((count-1)%5)*140)
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("flag"):setPositionY(height + 85 - 4)
    
    return height + 85 + 20
end

--弹窗 -pve pvp数据
function warcollegeLayer:unSelect()
    for i=1, 5 do
        self:getChildByName("view"):getChildByName("heros"):getChildByName("heros"..i):getChildByName("check"):setSelectedState(false)
    end
end

function warcollegeLayer:setBtnLight(node, light)
    if light == true then
        node:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        node:setTouchEnabled(true)
        if node:getChildByName("chu_label") ~= nil then
            node:getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
        end
    else 
        local effect = ff.Effect:effectGrey()    
        node:getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        node:setTouchEnabled(false)
        if node:getChildByName("chu_label") ~= nil then

            node:getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        end
    end
end

function warcollegeLayer:getHeroPlus()
    for var=1, dd.myeffect:rowCount() do
        if dd.myeffect:getLong(var,'id') == 752 then
            return dd.myeffect:getLong(var,'param')
        end
    end
    return 0
end

function warcollegeLayer:onCrystalSet(params)
    local code = params[1]
    if code == 0 then
        local curcid = params[2]
        self.closePop(self,ccui.TouchEventType.ended)
        self:updates(self._selectIndex)
        if curcid == 0 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("卸下成功"),true)
        else
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("穿戴成功"),true)
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function warcollegeLayer:onCrystalUpgrade(params)
    local code = params[1]
    if code == 0 then
        self:updates(self._selectIndex)
    end
end

function warcollegeLayer:onArmSet(params)
    local code = params[1]
    if code == 0 then
        self.closePop(self,ccui.TouchEventType.ended)
        self:updates(self._selectIndex)
        if params[2] == 0 then    --卸下装备
            AudioEngine.playEffect(ff.sounds[209])
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("卸下成功"),true)
        else
            AudioEngine.playEffect(ff.sounds[208])
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("穿戴成功"),true)
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function warcollegeLayer:onPropUse(params)
    local code = params[1]
    if code == 0 then
        local pid = params[2]
        if pid == self._toolId then
            if self._oldLevel < dd.heros:getLong(self._selectIndex,"level") then
                AudioEngine.playEffect(ff.sounds[210])
                self:playAnimation(self._selectIndex)
            else
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("道具使用成功 ！"),true)
            end
            self:updates(self._selectIndex)
            
            --self:updatePop2(self._selectIndex,self._toolId)
            self:showProgressStep(self._selectIndex,self._oldLevel)

            AudioEngine.playEffect(ff.sounds[212])
            self._oldLevel = 10000
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function warcollegeLayer:onHeroSkillAction(params)
    local code = params[1]
    if code == 0 then
        self:updates(self._selectIndex)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
--英雄 cfgid == row  
function warcollegeLayer.getHeroBigLockIcon(id)
    if dd.cfgHero[id] ~= nil then
        return "images/icon/hero/big/lock_"..dd.cfgHero[id]['pic']..".png"
    end  
    return "images/icon/hero/big/lock_1.png"
end
--装备的剪影
function warcollegeLayer.getArmGreyIcon(type)
    if type ~= nil then
        return "images/icon/arms/grey/"..type..".png"
    else
        return "images/icon/arms/grey/1.png"
    end
end
function warcollegeLayer:isAddOK(row,type)
    local isok = false
    for i=1, dd.myArms:rowCount() do
        local tid = dd.myArms:getLong(i,"aid")
        local place = dd.cfgArms[tid]['place']
        if place == type and dd.myArms:getLong(i,"heroid") == 0 then
            if dd.heros:getLong(row,"level") >= dd.cfgArms[tid]['level'] then
                isok = true
                break
            end
        end
    end
    return isok
end
function warcollegeLayer:haveArmCanbe(atype, hrow)
    local hid = dd.heros:getLong(hrow,"hid")
    local aid = dd.heros:getLong(hrow,"arms"..atype)
    local ishave = false
    for i=1,dd.myArms:rowCount() do
        local tid = dd.myArms:getLong(i,"aid")
        local place = dd.cfgArms[tid]['place']
        if place == atype and dd.myArms:getLong(i,"heroid") == 0 then
            ishave = true
            break
        elseif dd.myArms:getLong(i,"heroid") == hid and dd.myArms:getLong(i,"tid") == aid then
            ishave = true
            break
        end
    end
    return ishave
end

function warcollegeLayer:haveCryCanbe(type, hrow)
    --计算满足条件的数量
    local hid = dd.heros:getLong(hrow,"hid")
    local tool = dd.heros:getLong(hrow,"tools"..type)
    local ishave = false
    for i=1,dd.myCrystals:rowCount() do
        local tid = dd.myCrystals:getLong(i,"id")   --cfgid
        local cpos = dd.cfgCrystal[tid]["type"]
        if ff._and(cpos, type) > 0 and dd.myCrystals:getLong(i,"heroid") == 0 then
            ishave = true
            break
        elseif dd.myCrystals:getLong(i,"heroid") == hid and dd.myCrystals:getLong(i,"cid") == tool then
            ishave = true
            break
        end
    end
    return ishave
end

function warcollegeLayer:checkSpine()
    --英雄升级动画
    if self._sprite:getChildByTag(101) == nil then   
        local animation = sp.SkeletonAnimation:create("images/effect/hero/yingxiongshengji.json", "images/effect/hero/yingxiongshengji.atlas")
        animation:setAnimation(0,"YXshengji_animation",false)
        animation:setPosition(cc.p(270,285))
        self._sprite:addChild(animation,0,101)
    end  
end
function warcollegeLayer:playAnimation(row)
    local function unShow()
        self._inProgress = false
        self._sprite:setVisible(false)
    end
    local function call(type)
        if type == true then
            self._sprite:setGLProgramState(ff.Effect:effectHighLight():getGLProgramState())
        else
            self._sprite:setGLProgramState(ff.gameCore:getNormalGLState())
        end
    end
    if self._inProgress ==  false then
        self._inProgress = true
        self._sprite:setGLProgramState(ff.gameCore:getNormalGLState())
        self._sprite:setTexture(dd.getHeroBigIcon(dd.heros:getLong(row,"id")))
        self._sprite:setVisible(true)
        self._sprite:setOpacity(250)
        self._sprite:runAction( cc.Sequence:create( cc.DelayTime:create(1),cc.CallFunc:create(function() call(true) end),cc.DelayTime:create(0.2),cc.CallFunc:create(function() call(false) end),cc.FadeOut:create(0.8) ) )
        self._sprite:getChildByTag(101):setAnimation(0,"YXshengji_animation",false)
        self._sprite:getChildByTag(101):registerSpineEventHandler(unShow,SP_ANIMATION_COMPLETE)
        --self._animation:unregisterSpineEventHandler(SP_ANIMATION_COMPLETE)
    end
end

--sid  = 技能id + level
function warcollegeLayer:getEffectParamBy(sid,lv)
    if self._cfgheroskillup[sid] == nil or self._cfgheroskillup[sid][lv] == nil then
        local rows = ff.dbmanager:sql_fetch_rows("select * from cfg_hero_skill_levelup where id="..sid*100 + lv)
        local info = {}
        info['id'] = tonumber(rows:getString(1, "id"))
        info['skillid'] = tonumber(rows:getString(1, "skillid"))
        info['skilllevel'] = tonumber(rows:getString(1, "skilllevel"))
    
        info['param1'] = tonumber(rows:getString(1, "param1"))
        info['value1'] = tonumber(rows:getString(1, "value1"))
        info['param2'] = tonumber(rows:getString(1, "param2"))
        info['value2'] = tonumber(rows:getString(1, "value2"))
        info['param3'] = tonumber(rows:getString(1, "param3"))
        info['value3'] = tonumber(rows:getString(1, "value3"))
        self._cfgheroskillup[info['skillid']] = self._cfgheroskillup[info['skillid']] or {}
        self._cfgheroskillup[info['skillid']][info['skilllevel']] = info
        rows:clear()
    end
end

function warcollegeLayer.onStart(sender)
    ff.net:registerEvent(2,dd.Tjf_crystal_set, function (message)sender:onCrystalSet(message)end)
    ff.net:registerEvent(5,dd.Tjf_crystal_upgrade, function (message)sender:onCrystalUpgrade(message)end)
    ff.net:registerEvent(5,dd.Tjf_hero_GeneralSetEquip, function (message)sender:onArmSet(message)end)
    ff.net:registerEvent(7,dd.Tjf_prop_use, function (message)sender:onPropUse(message)end)
    ff.net:registerEvent(3,dd.Tjf_hero_skillAction, function (message)sender:onHeroSkillAction(message)end)
    ff.net:registerEvent(2,dd.Tjf_hero_GeneralAddHP, function (message)sender:onHeroSkillPoint(message)end)
    ff.net:registerEvent(2,dd.Tjg_GeneralReborn, function (message)sender:onGeneralReborn(message)end)
    sender:updates(sender._selectIndex)
    schedule(sender,sender.updateHp,1)
end

function warcollegeLayer:setHeroHp( )
    -- body
    local  hpMax = dd.heros:getLong(self._selectIndex,"PVEHpMax")

    local point = (dd.getServerTime() -  dd.heros:getLong(self._selectIndex,"PVEHpTime")) /300
    
    local hp =math.ceil(point * dd.heros:getLong(self._selectIndex,"PVEHpMax") / 100) + dd.heros:getLong(self._selectIndex,"PVEHpNow")
    if hp > dd.heros:getLong(self._selectIndex,"PVEHpMax") then
        hp = dd.heros:getLong(self._selectIndex,"PVEHpMax") 
    end
    local infos = self:getChildByName("view"):getChildByName("infos")
    infos:getChildByName("progresshp"):getChildByName("progress"):setPercent(math.ceil(100 * hp/hpMax))
    infos:getChildByName("progresshp"):getChildByName("exp"):setString(ff.getFormatMoney(hp).."/"..ff.getFormatMoney(hpMax))
end

function warcollegeLayer:onHeroSkillPoint(params)
    local code = params[1]
    if code == 0 then
        self:updatePop3()
        self:setHeroHp()
        --self.closePop3(nil,ccui.TouchEventType.ended)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function warcollegeLayer:onGeneralReborn(params)
    local code = params[1]
    if code == 0 then
        self:updates(self._selectIndex)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end


function warcollegeLayer.onEnd(sender)
    sender:stopAllActions()
    ff.net:removeEvent(2,dd.Tjf_crystal_set)
    ff.net:removeEvent(5,dd.Tjf_crystal_upgrade)
    ff.net:removeEvent(5,dd.Tjf_hero_GeneralSetEquip)
    ff.net:removeEvent(7,dd.Tjf_prop_use)
    ff.net:removeEvent(3,dd.Tjf_hero_skillAction)
    ff.net:removeEvent(2,dd.Tjf_hero_GeneralAddHP)

    if ff.platform ~= 1 then
        for i=1,5 do
            sender:getChildByName("view"):getChildByName("heros"):getChildByName("heros"..i):getChildByName("check"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        end
        sender:getChildByName("backex"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("view"):getChildByName("heroicon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("view"):getChildByName("infos"):getChildByName("progress"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        for i=1,3 do
            sender:getChildByName("view"):getChildByName("arms"):getChildByName("arm"..i):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        end

        --晶体
        for i,item in ipairs(sender._citems) do
            if item then            
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("bg"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("check"):loadTextureBackGroundSelected(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("check"):loadTextureFrontCross(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("word_e"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end
        --装备
        for i,item in ipairs(sender._aitems) do
            if item then
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("bg"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("check"):loadTextureBackGroundSelected(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("check"):loadTextureFrontCross(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("word_e"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                for k=1,4 do    
                    item:getChildByName("gem"..k):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))            
                end 
            end
        end
        --英雄升级经验
        sender:getChildByName("heroexp"):getChildByName("heros"):getChildByName("hero"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
    sender:getChildByName("heroehp"):getChildByName("tools"):removeAllChildren(true)
    sender:getChildByName("heroexp"):getChildByName("tools"):removeAllChildren(true)
--    local help = pop.getDialog("buildHelp")
--    if help ~= nil and help:isVisible() then
--        help:setVisible(false)    
--    end
    --sender._toolId = 1
    sender._inProgress = false
    if sender._sprite ~= nil then
        sender._sprite:setVisible(false)
        if sender._sprite:getChildByTag(101) ~= nil then
            sender._sprite:getChildByTag(101):removeFromParent(true)
        end 
    end
end

function warcollegeLayer.onBefore(sender)

   -- return false
end

function warcollegeLayer.onReturn(sender)
    if sender:getChildByName("show"):isVisible() == true then
        sender.closePop(sender,ccui.TouchEventType.ended)
        return true
    elseif sender:getChildByName("heroexp"):isVisible() == true then
        sender.closePop2(sender,ccui.TouchEventType.ended)
        return true

    elseif sender:getChildByName("heroehp"):isVisible() == true then
        sender.closePop3(sender,ccui.TouchEventType.ended)
        return true
    elseif sender:getChildByName("panel_buyItem"):isVisible() == true then
        sender.closePop4(sender,ccui.TouchEventType.ended)
        return true
    else
        return false 
    end
end


function onShowWarCollege(widget,pos)
    local layer = warcollegeLayer.extend(widget)
    layer:setVisible(false)
    layer._pos = pos
    layer:onInit()
    return layer
end