--司令部升级
local mainBaseHelpLayer   = class("mainBaseHelpLayer")
mainBaseHelpLayer._name = "mainBaseHelp"
mainBaseHelpLayer._init = false
mainBaseHelpLayer.bid = 1
mainBaseHelpLayer.lv = 0
function mainBaseHelpLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, mainBaseHelpLayer)
    return target
end
function mainBaseHelpLayer:onInit()
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,hh - 214))
        self:getChildByName("back"):setContentSize(cc.size(720,hh - 214))
        self:getChildByName("mainArea"):setContentSize(cc.size(720,hh - 214 - 120))
        self:getChildByName("mainArea"):setInnerContainerSize(cc.size(720,hh - 214 - 120))
        self:getChildByName("mainArea"):getChildByName("mainArea"):setContentSize(cc.size(720,hh - 214 - 120))
        self:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("mainback"):setContentSize(cc.size(690,hh - 214 - 120 + 4))
        self:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("lvArea"):setContentSize(cc.size(690,hh - 214 - 120 - 635))
        self:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("lvArea"):setInnerContainerSize(cc.size(690,52*(dd.cfgBuilding[self.bid]['maxlevel'] + 1)))
        self:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("preBtn"):addTouchEventListener(self.showPrePage)
        self:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("nextBtn"):addTouchEventListener(self.showNextPage)
        self:getChildByName("topArea"):getChildByName("return"):addTouchEventListener(self.onReturn)
        self:getChildByName("topArea"):getChildByName("add_btn"):addTouchEventListener(dd.onPay)
        self._init = true
    end
    self.updateGold()
    self:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("lvArea"):removeAllChildren()
end

function mainBaseHelpLayer.updateGold(name,row,old,value)
    local sender = pop.getDialog("mainBaseHelp")
    if sender ~= nil then
        sender:getChildByName("topArea"):getChildByName("gold_text"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("topArea"):getChildByName("gold_text"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("topArea"):requestDoLayout()
    end
end

function mainBaseHelpLayer.turningPage(sender,eventType)
    -- body
    if eventType == ccui.PageViewEventType.turning then
        local pageView = sender
        local pageIndex = tonumber(pageView:getCurPageIndex() + 1)
        local widget = pop.getDialog(mainBaseHelpLayer._name)
        if widget == nil then
            return
        end  
        if pageIndex == 2 then 
            widget:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("chu_title"):setString(ff.langString("守备部长"))
        elseif pageIndex == 3 then 
            widget:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("chu_title"):setString(ff.langString("内政部长"))
        else
            widget:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("chu_title"):setString(ff.langString("司令部"))
        end
        widget:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("preBtn"):setVisible(pageIndex>1)
        widget:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("nextBtn"):setVisible(pageIndex<3)
    end
end
function mainBaseHelpLayer.showPrePage(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("mainBaseHelp")
        if widget == nil then
            return
        end  
        local pageIndex = widget:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("infoPage"):getCurPageIndex()

        if pageIndex > 0 then
            widget:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("infoPage"):scrollToPage(pageIndex - 1)
        end
    end   
end

function mainBaseHelpLayer.showNextPage(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("mainBaseHelp")
        if widget == nil then
            return
        end  
        local pageIndex = widget:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("infoPage"):getCurPageIndex()

        if pageIndex <= 1 then
            widget:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("infoPage"):scrollToPage(pageIndex + 1)
        end
    end           
end
function mainBaseHelpLayer:initInfo()
    for i=1,dd.mybuilds:rowCount() do
        if 1 == dd.mybuilds:getLong(i,"bid") then
            self.lv = dd.mybuilds:getLong(i,"level")
            break
        end
    end
    self:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("lvArea"):removeAllChildren()
    for key, value in pairs(dd.cfgBuildingUp[1]) do
        if dd.cfgBuilding[self.bid]['maxlevel'] < key then
            break
        end
        local item = self:getChildByName("lvItem"):clone()
        item:setVisible(true)
        item:getChildByName("lv_text"):setString(key)
        item:getChildByName("num_text"):setString(value['value2'])
        
        item:getChildByName("bing_text"):setString(dd.showKM(value['value1'],5))

        if key == self.lv then
            item:loadTexture("images/icon/rank/help_back.png",0)
        end
        local xx = 0
        local yy = 52*(dd.cfgBuilding[self.bid]['maxlevel'] + 1) - (key-1)*52
        item:setPosition(cc.p(xx,yy))
        self:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("lvArea"):addChild(item)
    end
--    local item = self:getChildByName("lvItem"):clone()
--    item:setVisible(true)
--    item:getChildByName("lv_text"):setString(ff.langString("Max"))
--    item:getChildByName("bing_text"):setVisible(false)
--    local v = dd.cfgEffect[dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['param3']]['value']
--    local addStr = ""
--    if v == 10 then
--        addStr = (dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['value3']/10)
--    else
--        addStr = tostring(dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['value3'])
--    end
--    item:getChildByName("num_text"):setString(ff.langString(dd.cfgEffect[dd.cfgBuildingUp[self.bid][dd.cfgBuilding[self.bid]['maxlevel']]['param3']]['tips1'],{addStr}))
--    local xx = 0
--    local yy = 52*(dd.cfgBuilding[self.bid]['maxlevel'] + 1) - (dd.cfgBuilding[self.bid]['maxlevel'] + 1-1)*52
--    item:setPosition(cc.p(xx,yy))
--    self:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("lvArea"):addChild(item)
end

--界面显示后调用
function mainBaseHelpLayer.onStart(sender)
    ff.net:bindProperty(2402,"gold",function ()sender.updateGold() end) 
    local pageView = sender:getChildByName("mainArea"):getChildByName("mainArea"):getChildByName("infoPage")
    pageView:addEventListener(sender.turningPage)
    pageView:scrollToPage(0)
    sender:initInfo()
end

--界面关闭效果结束后调用
function mainBaseHelpLayer.onEnd(sender)
    dd.delBackEvent(sender.onReturn)
    ff.net:unbindProperty("gold",2402) 
end
--界面即将播放显示缓动时调用，返回false界面显示将终止
function mainBaseHelpLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("icon"),sender:getChildByName("topArea"):getChildByName("add_btn"))
    return true
end

function mainBaseHelpLayer:onClose()
    return false
end

function mainBaseHelpLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("mainBaseHelp")
        if widget~=nil and widget:onClose() == false then
            pop.onClosePopDialog("mainBaseHelp")
        end    
    end
end
function onShowMainBaseHelp(widget)
    local layer = mainBaseHelpLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end