--城市修改名字
local changeNameLayer = class("changeName")
changeNameLayer._name = "changeName"
changeNameLayer._init = false
changeNameLayer._edit = nil
changeNameLayer._type = nil      --1:城市改名 2.主公改名
changeNameLayer._oldname = ""

function changeNameLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, changeNameLayer)
    return target
end

function changeNameLayer:onInit()
    if self._init == false then
        --close
        local function onClose(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                pop.onClosePopDialog("changeName")
            end
        end
        
        --修改名字
        local function onChange(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                if self._edit:getText() ~= "" and self._edit:getText() ~= tostring(self._oldname) then
                    local price = self:getChildByName("view"):getChildByName("tools"):getChildByName("change"):getChildByName("count"):getString() 
                    if tonumber(price) > dd.gold() and self:getChildByName("view"):getChildByName("tools"):getChildByName("change"):isVisible()==true then
                        local function sure()
                            pop.onShowPopDialog("charge")
                        end
                        dd.mainUI:onShowSure(ff.langString("金币不足"),ff.langString("充值可以让你立即拥有大量金币.\n是否现在就去?"),sure,true,2,2,ff.langString("充值"))
                    else
                        local cmdvalue = 0
                        if self._type == 1 then      --城市改名
                            cmdvalue = 0x10c
                        elseif self._type == 2 then  --主公改名
                            cmdvalue = 0x10b
                        end
                        local message = ff.net:createMessage()
                        message:addCmd(cmdvalue)
                        message:addLong(dd.uid)   
                        message:addString(self._edit:getText(),15)
                        message:addLong(0)   
                        ff.net:rpc(message, false) 
                    end
                else
                    if self._type == 1 then      --城市改名
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("请输入新的城市名称"))
                    elseif self._type == 2 then  --主公改名
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("请输入新的主公名称"))
                    end
                end
            end
        end
        
        self:getChildByName("view"):getChildByName("close"):addTouchEventListener(onClose)
        self:getChildByName("view"):getChildByName("tools"):getChildByName("change"):addTouchEventListener(onChange)
        self:getChildByName("view"):getChildByName("tools"):getChildByName("usebtn"):addTouchEventListener(onChange)
        --加粗
        self:getChildByName("view"):getChildByName("tools"):getChildByName("change"):getChildByName("Label_76"):getVirtualRenderer():enableBold(true)
        --输入框
        local editbg = self:getChildByName("view"):getChildByName("edits"):getChildByName("editbox"):getChildByName("editbox")
        local size = editbg:getContentSize()
        local editBox = dd.addEditBox(
            self:getChildByName("view"):getChildByName("edits"):getChildByName("editbox")
            , size
            , "images/ui/alpha.png"
            , 13011
            , cc.p(editbg:getAnchorPoint())
            , cc.p(editbg:getPosition())
            , cc.c3b(255,255,255)
            , 20
            , 6
            , 4
            , 1
            , 15
            , true
            , true 
            , true
        )
        self._edit = editBox        
        --默认清除当前文字
        local function editBoxTextEventHandle(strEventName,pSender)
            if strEventName == "began" then
                pSender:setText("")
            elseif strEventName == "ended" or strEventName == "return" then
            elseif strEventName == "changed" then
            end
        end        
        editBox:registerScriptEditBoxHandler(editBoxTextEventHandle)

        self._init = true
    end   
    if self._type == 1 then      --城市改名
        self:getChildByName("view"):getChildByName("chu_title"):setString(ff.langString("更改城市名称"))
        self:getChildByName("view"):getChildByName("edits"):getChildByName("intips"):setString(ff.langString("请输入新的城市名称"))
        self:onInitTool(1006)
        self._edit:setText(dd.mycity:getString(1,"name"))
        self._oldname = dd.mycity:getString(1,"name")
    elseif self._type == 2 then  --主公改名
        self:getChildByName("view"):getChildByName("chu_title"):setString(ff.langString("更改主公名称"))
        self:getChildByName("view"):getChildByName("edits"):getChildByName("intips"):setString(ff.langString("请输入新的主公名称"))
        self:onInitTool(1005)
        self._edit:setText(dd.myinfo:getString(1,"name"))
        self._oldname = dd.myinfo:getString(1,"name")
    end 
end

function changeNameLayer:onInitTool(tid)
    local num = dd.getToolsCount(tid)
    if num < 1 then
        self:getChildByName("view"):getChildByName("tools"):getChildByName("tool"):getChildByName("num"):getChildByName("num"):setColor(cc.c3b(255,0,0))
        self:getChildByName("view"):getChildByName("tools"):getChildByName("change"):setVisible(true)
        self:getChildByName("view"):getChildByName("tools"):getChildByName("usebtn"):setVisible(false)
    else
        self:getChildByName("view"):getChildByName("tools"):getChildByName("tool"):getChildByName("num"):getChildByName("num"):setColor(cc.c3b(187,169,169))
        self:getChildByName("view"):getChildByName("tools"):getChildByName("change"):setVisible(false)
        self:getChildByName("view"):getChildByName("tools"):getChildByName("usebtn"):setVisible(true)
    end
    self:getChildByName("view"):getChildByName("tools"):getChildByName("tool"):getChildByName("num"):getChildByName("num"):setString("x"..num)
    self:getChildByName("view"):getChildByName("tools"):getChildByName("tool"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getToolsIcon(tid),0)
    self:getChildByName("view"):getChildByName("tools"):getChildByName("use_label"):setString(ff.langString("消耗 {0} {1} 个",{ff.langString(dd.cfgProp[tid]['name'],{dd.cfgProp[tid]['name1_lan']}),1}))
    self:getChildByName("view"):getChildByName("tools"):getChildByName("change"):getChildByName("count"):setString(dd.cfgProp[tid]['value'])
end

function changeNameLayer.onChangeNameEvent(param)
    local code = param[1]
    if code == 0 then
        pop.onClosePopDialog("changeName")
        AudioEngine.playEffect(ff.sounds[212])
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("更改成功"),true)
    else
        dd.mainUI:onShowCodeTips(code)
    end 
end

function changeNameLayer:onUpdataView()
    self:onInit()
end

function changeNameLayer.onStart(sender)
    --修改城池名字事件
    ff.net:registerEvent(2,dd.Tjf_City_ChangeName,sender.onChangeNameEvent)
    ff.net:registerEvent(2,dd.Tjf_User_ChangeName,sender.onChangeNameEvent)
end

function changeNameLayer.onEnd(sender)
    ff.net:removeEvent(2,dd.Tjf_City_ChangeName)
    ff.net:removeEvent(2,dd.Tjf_User_ChangeName)
    dd.delBackEvent()
    if ff.platform ~= 1 then
        sender:getChildByName("view"):getChildByName("tools"):getChildByName("tool"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
    if sender._type == 1 then       --司令部
        local widget = pop.getDialog("mainbase")
        if widget ~= nil then
            widget:closeMasking()
        end 
    elseif sender._type == 2 then   --powerInfo
        local widget = pop.getDialog("powerInfo")
        if widget ~= nil then
            widget:closeMasking()
        end
    end
end
--[[
function changeNameLayer.onBefore(sender)
    return false
end
--]]
function changeNameLayer.onReturn(sender,eventType)
    pop.onClosePopDialog("changeName")
end

function onShowChangeNameLayer(widget,type)
    local layer = changeNameLayer.extend(widget)
    layer._type = type
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end