--charge
local chargeLayer = class("charge")
chargeLayer._name = "charge"
chargeLayer._init = false
chargeLayer._clists = {}
chargeLayer._items = {}
chargeLayer._titems = {{},{},{},{}}

chargeLayer._cfgXinshou = {}
chargeLayer._cfgJieri = {}
chargeLayer._cfgHuodong = {}

chargeLayer._animroll = {}
chargeLayer._animstar = {}
chargeLayer._lastId = 0
chargeLayer._inProgress = false        

chargeLayer._justopen = false

function chargeLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, chargeLayer)
    return target
end

function chargeLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("touch"):setContentSize(cc.size(720,hh))
        self:getChildByName("touch"):setPositionY(0)
        self:getChildByName("bg"):setContentSize(cc.size(720,hh))
        self:getChildByName("bg"):setPositionY(0)
        
        self:getChildByName("masking"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("masking"):setPositionY(0)
        self:getChildByName("mainArea"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("topArea"):setPositionY(hh - 105)
        
        self:getChildByName("mainArea"):setPositionY(0)
        self:getChildByName("mainArea"):getChildByName("view"):setContentSize(cc.size(720, hh - 105))
    end
end

function chargeLayer:onInit()
    if self._init == false then        
        --topArea
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3)
        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("images/effect/charge/goldroll.plist")
        cache:addSpriteFrames("images/effect/charge/goldstar.plist")
        for i = 1, 9 do                                           --少了个0
            self._animroll[i] = cache:getSpriteFrame("charge_jinbi_"..i..".png")  
        end
        for i = 1, 20 do                                          
            self._animstar[i] = cache:getSpriteFrame("xing_"..i..".png")  
        end
        local spr = dd.newSpriteFromUI("public/alpha.png")
        spr:setPosition(cc.p(37,37))
        spr:setVisible(false)
        self:getChildByName("topArea"):getChildByName("gold"):addChild(spr,0,101)

        --self:initCfg()
        --加粗
        self:getChildByName("tips"):getChildByName("name"):getVirtualRenderer():enableBold(true)
        --item里面了

        local function onTouchBegan(touch, event)
            self:unShowTips()
            return false
        end
        local listener = cc.EventListenerTouchOneByOne:create()
        listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
        listener:setSwallowTouches(true)
        self:getChildByName("touch"):getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self:getChildByName("touch"))

    end
    self.updateGold()
end

function chargeLayer:initCfg()
    
        --self._cfgHuodong[info['id']] = self._cfgHuodong[info['id']] or {}
        --self._cfgHuodong[info['id']][info['type']] = info
   -- end
   -- huodong:clear()

end

function chargeLayer.updateGold()
    local widget = pop.getDialog("charge")
    widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
    widget:getChildByName("topArea"):requestDoLayout()

    local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
    w = 720 - (w + 94 + 75 + 104)
    widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
    widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
end

function chargeLayer:updateList(first)
    local view = self:getChildByName("mainArea"):getChildByName("view")
    local hh = view:getContentSize().height
    local innerhh = 0
    local counts = {1,1,1,1}
    local temphh = 0
    --隐藏items
    self:getChildByName("mainArea"):getChildByName("view"):stopAllActions()
    self:resetItems()
    if first == true then
        view:jumpToTop()
    end
    --计算长度
    for i=1, table.getn(self._clists) do
        local id = self._clists[i]["id"]
        local type = self._clists[i]["type"]
        local rews  = Split(dd.cfgCharge[id]['otherthing'],"|")
        local cnum = table.getn(rews)
        if type == 1 then
            rews  = Split(dd.cfgCharge[id]['otherthing'],"|")
            cnum = table.getn(rews)
            if dd.cfgCharge[id]['moregold'] > 0 then
                cnum = cnum + 1
            end
            if dd.cfgCharge[id]['leaguebox'] > 0 then
                cnum = cnum + 1
            end
            --固定只显示5个
            cnum = 5
            innerhh = innerhh + 110 + 218+160*math.ceil(cnum/5) + 95+30
        elseif type == 2 then
            rews = Split(self._cfgJieri[id]['otherthing'],"|")
            cnum = table.getn(rews)
            if self._cfgJieri[id]['moregold'] > 0 then
                cnum = cnum + 1
            end
            if self._cfgJieri[id]['leaguebox'] > 0 then
                cnum = cnum + 1
            end
            --固定只显示5个
            cnum = 5
            innerhh = innerhh + 110 + 218+160*math.ceil(cnum/5) + 95+30
        elseif type == 3 then
            rews = Split(self._cfgXinshou[id]['otherthing'],"|")
            cnum = table.getn(rews)
            if self._cfgXinshou[id]['moregold'] > 0 then
                cnum = cnum + 1
            end
            if self._cfgXinshou[id]['leaguebox'] > 0 then
                cnum = cnum + 1
            end
            --固定只显示5个
            cnum = 5
            innerhh = innerhh + 110 + 218+160*math.ceil(cnum/5) + 95+30
        elseif type == 4 then
            local typeparam = self._clists[i]["typeparam"]
            rews = Split(self._cfgHuodong[id][typeparam]['otherthing'],"|")
            cnum = table.getn(rews)
            if dd.cfgCharge[id]['moregold'] > 0 then
                cnum = cnum + 1
            end
            if dd.cfgCharge[id]['leaguebox'] > 0 then
                cnum = cnum + 1
            end
            --固定只显示5个
            cnum = 5
            innerhh = innerhh + 110 + 218+160*math.ceil(cnum/5) + 95+30
        else
            cclog("未知的充值类型!!!!!")
        end     
        cclog("type == "..type.."  id == "..id)
    end    
    if innerhh < hh then
        innerhh = hh
    end
    view:setInnerContainerSize(cc.size(720,innerhh+5))
    temphh = innerhh + 5

    local count = 1
    if first == true then
        if table.getn(self._clists) > 3 then
            for i=1, 3 do
                local ret = self:addItem(temphh, counts, count)
                temphh = ret[1]
                counts = ret[2]
                count = count + 1
            end
            local function add_sche()
                if count <= table.getn(self._clists) then
                    local ret = self:addItem(temphh, counts, count)
                    temphh = ret[1]
                    counts = ret[2]
                    count = count + 1
                else
                    self:getChildByName("mainArea"):stopAllActions()
                    cclog("已停止添加脚本 ==========2222 ")
                end
            end
            cclog("开启添加脚本 =========1111 ")
            schedule(self:getChildByName("mainArea"), add_sche,0.01)
        else
            cclog("少于3个 =========aaaa ")
            for i=1, table.getn(self._clists) do
                local ret = self:addItem(temphh, counts, count)
                temphh = ret[1]
                counts = ret[2]
                count = count + 1
            end
        end
    else
        for i=1, table.getn(self._clists) do
            local ret = self:addItem(temphh, counts, count)
            temphh = ret[1]
            counts = ret[2]
            count = count + 1
        end
    end
end

function chargeLayer:addItem(temphh, counts, i)
    local id = self._clists[i]["id"]
    local type = self._clists[i]["type"]
    local typeparam = self._clists[i]["typeparam"]
    local time = self._clists[i]["endtime"]-dd.getServerTime()
    local rews  = {}
    local moregold = 0
    local leaguebox = 0
    if type == 1 then
        rews = Split(dd.cfgCharge[id]['otherthing'],"|")
        moregold = dd.cfgCharge[id]['moregold']
        leaguebox = dd.cfgCharge[id]['leaguebox']
    elseif type == 2 then
        rews = Split(self._cfgJieri[id]['otherthing'],"|")
        moregold = self._cfgJieri[id]['moregold']
        leaguebox = self._cfgJieri[id]['leaguebox']
    elseif type == 3 then
        rews = Split(self._cfgXinshou[id]['otherthing'],"|")
        moregold = self._cfgXinshou[id]['moregold']
        leaguebox = self._cfgXinshou[id]['leaguebox']
    elseif type == 4 then
        rews = Split(self._cfgHuodong[id][typeparam]['otherthing'],"|")
        moregold = dd.cfgCharge[id]['moregold']
        leaguebox = dd.cfgCharge[id]['leaguebox']
    end
    local num = table.getn(rews)  -- 第一个显示金币
    if moregold > 0 then
        num = num + 1
    end
    if leaguebox > 0 then
        num = num + 1
    end
    --固定只显示5个
    num = 5
    local itheight = 328+160*math.ceil(num/5)+10 + 30
    local ihh = 160*math.ceil(num/5)+10  + 30 --item上的view
    if type > 0 then                      --1=正常充值  2=节日充值  3=新手充值 4=活动充值            
        local item = self._titems[type][counts[type]]

        if item == nil then
            if item == nil then
                if ff.platform ~= 1 then
                    item = CityUILayer.extend(ccs.GUIReader:getInstance():widgetFromJsonFile("images/ui/chargeItem.ExportJson"))
                else
                    item = CityUILayer.extend(dd.loadUi("images/ui/chargeItem.json"))
                end
                --加粗
                item:getChildByName("view"):getChildByName("top"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
                item:getChildByName("view"):getChildByName("top"):getChildByName("block"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
                item:getChildByName("view"):getChildByName("top"):getChildByName("time"):getVirtualRenderer():enableBold(true)
                item:getChildByName("view"):getChildByName("bottom"):getChildByName("oldprice"):getChildByName("old"):getVirtualRenderer():enableBold(true)
                item:getChildByName("view"):getChildByName("bottom"):getChildByName("oldprice"):getChildByName("new"):getVirtualRenderer():enableBold(true)
                item:getChildByName("view"):getChildByName("bottom"):getChildByName("charge"):getChildByName("cost"):getVirtualRenderer():enableBold(true)
                item:getChildByName("view"):getChildByName("bottom"):getChildByName("charge"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
                item:getChildByName("view"):getChildByName("top"):getChildByName("block"):getChildByName("chu_label"):setString(ff.langString("充值后你将获得以下物品").."!")
                item:getChildByName("view"):getChildByName("bottom"):getChildByName("charge"):getChildByName("chu_label"):setString(ff.langString("购买"))
            --else
                --item = self._titems[type][1]:clone()
            end
            self._titems[type][counts[type]] = item
            self:getChildByName("mainArea"):getChildByName("view"):addChild(item)
        end
        counts[type] = counts[type] + 1
        temphh = temphh - itheight - 85
        item:setContentSize(cc.size(720, itheight))
        item:getChildByName("view"):setContentSize(cc.size(720, itheight))
        item:getChildByName("view"):getChildByName("bg"):setContentSize(cc.size(700, itheight-2))
        item:setPositionX(0)
        item:setPositionY(temphh)    

        item:getChildByName("view"):setPositionY(0)
        item:getChildByName("view"):getChildByName("top"):setPositionY(itheight - 230)
        item:getChildByName("view"):getChildByName("view"):setPositionY(105)
        item:getChildByName("view"):getChildByName("bottom"):setPositionY(19)  
        cclog("type == "..type)
        local inf = self:getChargeSpine(type, id)
        --check spine
        if item:getChildByName("view"):getChildByName("top"):getChildByName("icon"):getChildByTag(inf[1]) == nil then
            item:getChildByName("view"):getChildByName("top"):getChildByName("icon"):removeAllChildren(true)
            local animation = sp.SkeletonAnimation:create("images/effect/charge/"..inf[2]..".json", "images/effect/charge/"..inf[2]..".atlas")
            animation:setAnimation(0,inf[3],true)
            animation:setPosition(cc.p(item:getChildByName("view"):getChildByName("top"):getChildByName("icon"):getContentSize().width/2,item:getChildByName("view"):getChildByName("top"):getChildByName("icon"):getContentSize().height/2+40))
            item:getChildByName("view"):getChildByName("top"):getChildByName("icon"):addChild(animation,0,inf[1])
        end
        local iname = ""
        local getgold = 0
        local oldprice = 0
        local curprice = 0
        local isale    = 0
        local fuhao = "$"
        if type == 1 then
            iname    = ff.langString(dd.cfgCharge[id]["name"])
            getgold  = dd.cfgCharge[id]["getgold"]
            oldprice = dd.cfgCharge[id]["yuanjia"]
            curprice = dd.cfgCharge[id]["goldforshow"]
            isale    = dd.cfgCharge[id]["value"]
            fuhao    = dd.cfgCharge[id]["fuhao"]
        elseif type == 2 then
            iname    = ff.langString(self._cfgJieri[id]["name"])
            getgold  = self._cfgJieri[id]["getgold"]
            oldprice = self._cfgJieri[id]["yuanjia"]
            curprice = self._cfgJieri[id]["goldforshow"]
            isale    = self._cfgJieri[id]["value"]
            fuhao    = dd.cfgCharge[id]["fuhao"]
        elseif type == 3 then
            iname    = ff.langString(self._cfgXinshou[id]["name"])
            getgold  = self._cfgXinshou[id]["getgold"]
            oldprice = self._cfgXinshou[id]["yuanjia"]
            curprice = self._cfgXinshou[id]["goldforshow"]
            isale    = self._cfgXinshou[id]["value"]
            fuhao    = dd.cfgCharge[id]["fuhao"]
        elseif type == 4 then
            iname    = ff.langString(self._cfgHuodong[id][typeparam]["name"])
            getgold  = dd.cfgCharge[id]["getgold"]
            oldprice = dd.cfgCharge[id]["yuanjia"]
            curprice = dd.cfgCharge[id]["goldforshow"]
            isale    = dd.cfgCharge[id]["value"]
            fuhao    = dd.cfgCharge[id]["fuhao"]
        else
            cclog("错误的充值类型")
            iname    = ff.langString(dd.cfgCharge[id]["name"])
            getgold  = dd.cfgCharge[id]["getgold"]
            oldprice = dd.cfgCharge[id]["yuanjia"]
            curprice = dd.cfgCharge[id]["goldforshow"]
            isale    = dd.cfgCharge[id]["value"]
            fuhao    = dd.cfgCharge[id]["fuhao"]
        end
        oldprice = tonumber(string.format("%.2f", oldprice/100)) 
        curprice = tonumber(string.format("%.2f", curprice/100) )
        item:getChildByName("view"):getChildByName("top"):getChildByName("chu_title"):setString(iname)
        item:getChildByName("view"):getChildByName("top"):getChildByName("goldnum"):setString(getgold)  --ff.getFormatMoney()
        if oldprice > 0 then
            item:getChildByName("view"):getChildByName("bottom"):getChildByName("oldprice"):setVisible(true)
            item:getChildByName("view"):getChildByName("bottom"):getChildByName("charge"):getChildByName("chu_label"):setVisible(false)
            item:getChildByName("view"):getChildByName("bottom"):getChildByName("charge"):getChildByName("cost"):setVisible(false)
            item:getChildByName("view"):getChildByName("bottom"):getChildByName("oldprice"):getChildByName("old"):setString(fuhao..oldprice)
            item:getChildByName("view"):getChildByName("bottom"):getChildByName("oldprice"):getChildByName("new"):setString(fuhao..curprice)
        else
            item:getChildByName("view"):getChildByName("bottom"):getChildByName("oldprice"):setVisible(false)
            item:getChildByName("view"):getChildByName("bottom"):getChildByName("charge"):getChildByName("chu_label"):setVisible(false)
            item:getChildByName("view"):getChildByName("bottom"):getChildByName("charge"):getChildByName("cost"):setVisible(true)
            item:getChildByName("view"):getChildByName("bottom"):getChildByName("charge"):getChildByName("cost"):setString(fuhao..curprice/100)
        end

        if isale>0 then
            item:getChildByName("view"):getChildByName("top"):getChildByName("sale"):setVisible(true)
            item:getChildByName("view"):getChildByName("top"):getChildByName("sale"):getChildByName("value"):setString(isale.."%")
        else
            item:getChildByName("view"):getChildByName("top"):getChildByName("sale"):setVisible(false)
        end
        if time > 0 then
            item:getChildByName("view"):getChildByName("bottom"):getChildByName("time"):setVisible(true)
            item:getChildByName("view"):getChildByName("bottom"):getChildByName("tips"):setVisible(true)
            item:getChildByName("view"):getChildByName("bottom"):getChildByName("tips"):setString(ff.langString("限时")..":")
            item:getChildByName("view"):getChildByName("bottom"):getChildByName("time"):setString(ff.getLeftTime(time,":"))

            item:getChildByName("view"):getChildByName("top"):getChildByName("time"):setVisible(false)
            item:getChildByName("view"):getChildByName("top"):getChildByName("time"):setString(ff.langString("限时")..":"..ff.getLeftTime(time,":"))
            item:setTag(i)
            schedule(self:getChildByName("mainArea"):getChildByName("view"), self.showAction,1)
            item:getChildByName("view"):getChildByName("bottom"):requestDoLayout()
        else
            item:getChildByName("view"):getChildByName("bottom"):getChildByName("time"):setVisible(false)
            item:getChildByName("view"):getChildByName("bottom"):getChildByName("tips"):setVisible(false)
            item:getChildByName("view"):getChildByName("top"):getChildByName("time"):setVisible(false)
            item:setTag(0)
        end
        item:setName(id)
        item:setVisible(true)
        item:getChildByName("view"):getChildByName("top"):getChildByName("block"):getChildByName("infobtn"):setTag(id)
        item:getChildByName("view"):getChildByName("top"):getChildByName("block"):getChildByName("infobtn"):addTouchEventListener(self.showGifts)
        item:getChildByName("view"):getChildByName("bottom"):getChildByName("charge"):addTouchEventListener(self.onCharge)
        item:getChildByName("view"):getChildByName("bottom"):getChildByName("charge")._id = id
        item:getChildByName("view"):getChildByName("bottom"):getChildByName("charge")._type = type

        item:getChildByName("view"):getChildByName("view"):setContentSize(cc.size(667, ihh))

        local index = 1   
        --先显示第一个
        if moregold > 0 then
            local mitem = item:getChildByName("view"):getChildByName("view"):getChildByName(index)
            if mitem == nil then
                mitem = item:getChildByName("view"):getChildByName("itemmode"):clone()
                mitem:setName(index)
                item:getChildByName("view"):getChildByName("view"):addChild(mitem)                                       
            end   
            mitem:setVisible(true)
            mitem:setPositionX(6 + (index-1)%5*138)
            mitem:setPositionY(ihh-170 - math.floor((index-1)/5)*160) 
            mitem:getChildByName("count"):getChildByName("value"):setString(moregold)
            mitem:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/charge/gold.png",0)
            mitem:setTouchEnabled(true)
            
            mitem:addTouchEventListener(self.showGifts)
            mitem:setTag(id)
            mitem.type = 7
            mitem.id = 0
            mitem.count = moregold

            index = index + 1
        end
        --显示第二个
        if leaguebox > 0 then
            local mitem = item:getChildByName("view"):getChildByName("view"):getChildByName(index)
            if mitem == nil then
                mitem = item:getChildByName("view"):getChildByName("itemmode"):clone()
                mitem:setName(index)
                item:getChildByName("view"):getChildByName("view"):addChild(mitem)                                       
            end   
            mitem:setVisible(true)
            mitem:setPositionX(6 + (index-1)%5*138)
            mitem:setPositionY(ihh-170 - math.floor((index-1)/5)*160) 
            mitem:getChildByName("count"):getChildByName("value"):setString(1)
            mitem:getChildByName("icon"):getChildByName("icon"):loadTexture( dd.getUnionGiftIcon(leaguebox),0)
            mitem:setTouchEnabled(true)

            mitem:addTouchEventListener(self.showGifts)
            mitem:setTag(id)
            mitem.type = 12
            mitem.id = leaguebox
            mitem.count = 1

            index = index + 1
        end
        --显示获得物品列表
        if tonumber(rews[1]) ~= 0 then
            for i=1,table.getn(rews) do
                if index <= 5 then
                    local rew = Split(rews[i],"%^")
                    local ctype = tonumber(rew[1])
                    local tid = tonumber(rew[2])
                    local num = tonumber(rew[3])   
                    local citem = item:getChildByName("view"):getChildByName("view"):getChildByName(index)
                    if citem == nil then
                        citem = item:getChildByName("view"):getChildByName("itemmode"):clone()
                        citem:setName(index)
                        item:getChildByName("view"):getChildByName("view"):addChild(citem)                                       
                    end    
                    citem:setVisible(true)                                
                    citem:setPositionX(6 + (index-1)%5*138)
                    citem:setPositionY(ihh-170 - math.floor((index-1)/5)*160)
                    citem:getChildByName("count"):getChildByName("value"):setString(num)
                    citem:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getGiftsIcon(ctype, tid)[1],dd.getGiftsIcon(ctype, tid)[2])
                    citem:setTouchEnabled(true)

                    citem:addTouchEventListener(self.showGifts)
                    citem:setTag(id)
                    citem.type = ctype
                    citem.id = tid
                    citem.count = num

                    index = index + 1
                else
                    break
                end
            end          
        end    
        for k = index, math.ceil( (index-1)/5 )*5 do
            local citem = item:getChildByName("view"):getChildByName("view"):getChildByName(k)
            if citem == nil then
                citem = item:getChildByName("view"):getChildByName("itemmode"):clone()
                citem:setName(k)
                item:getChildByName("view"):getChildByName("view"):addChild(citem)                                       
            end    
            citem:setVisible(true)                                
            citem:setPositionX(6 + (k-1)%5*138)
            citem:setPositionY(ihh-170 - math.floor((k-1)/5)*160)  
            citem:getChildByName("count"):getChildByName("value"):setString("")
            citem:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            citem:setTouchEnabled(false)
            index = index + 1
        end
        --隐藏多余的citem
        if index < item:getChildByName("view"):getChildByName("view"):getChildrenCount() then
            for k = index,item:getChildByName("view"):getChildByName("view"):getChildrenCount() do
                local child = item:getChildByName("view"):getChildByName("view"):getChildByName(k)
                if child then
                    child:setVisible(false)
                end
            end
        end        
    end
    --要同步counts
    return {temphh,counts}
end

function chargeLayer:resetItems()
    for i,items in ipairs(self._titems) do
        for k, item in ipairs(items) do
            if tolua.isnull(item) then
                items[k] = nil
            else
                item:setVisible(false)
                item:setTag(0)
                item:setName(0)
            end
        end
    end
end
function chargeLayer.showAction()
    local sender = pop.getDialog("charge")
    local view = sender:getChildByName("mainArea"):getChildByName("view")
    for i=1, table.getn(sender._clists) do
        local time = sender._clists[i]["endtime"]-dd.getServerTime()
        local node = sender:getChildByName("mainArea"):getChildByName("view"):getChildByTag(i)
        if node ~= nil then
            if time > 0 then
                --node:getChildByName("view"):getChildByName("top"):getChildByName("time"):setString(ff.langString("限时")..":"..ff.getLeftTime(time,":"))
                node:getChildByName("view"):getChildByName("bottom"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
            else
                sender:getChargeLists()
            end
        end   
    end
end

function chargeLayer.onShowTips(sender, eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then        
        local widget = pop.getDialog("charge")
        local pos2word = widget:getWorldPos(sender)
        local pos = widget:convertToNodeSpace(pos2word) 
        pos = cc.p(pos.x + 70, pos.y + 150)
        widget:showTips(sender.type, sender.id, sender.count, pos)
    end
end

function chargeLayer:showTips(type, id, count, pos)
    local ret  = dd.getGiftsTips(type, id, count)
    local name = ret[1]
    local str  = ret[2]
    
    local tips = self:getChildByName("tips")
    local wid  = 360
    tips:setVisible(true)
    tips:getChildByName("tips"):removeAllChildren(true)

    local richText = ccui.RichText:create()
    richText:ignoreContentAdaptWithSize(false)
    richText:setContentSize(cc.size(wid-30,600))    
    richText:setAutoHeight()

    local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, str, "Helvetica", 20)
    richText:insertElement(chat,0)
    richText:formatText()

    local size = richText:getContentSize()
    richText:setPosition(cc.p(172,size.height/2 + 15))
    tips:setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):addChild(richText)

    tips:getChildByName("name"):setString(name) 
    tips:getChildByName("name"):setPositionY(size.height + 40)

    tips:setPosition(pos)
    if pos.x < 100 then
        tips:setAnchorPoint(cc.p(0.2,0))
        tips:getChildByName("flag"):setPositionX(wid*0.2)
    elseif pos.x > 550 then
        tips:setAnchorPoint(cc.p(0.8,0))
        tips:getChildByName("flag"):setPositionX(wid*0.8)
    else
        tips:setAnchorPoint(cc.p(0.5,0))
        tips:getChildByName("flag"):setPositionX(wid*0.5)
    end        
end

function  chargeLayer:unShowTips()
    self:getChildByName("tips"):setVisible(false)
end

function chargeLayer.showGifts( sender, eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then    
        local widget = pop.getDialog("charge")
        local id     = sender:getTag()
        local type   = 0
        local typeparam = 0
        for i=1, table.getn(widget._clists) do
            if widget._clists[i]["id"] == id then
                type = widget._clists[i]["type"]
                typeparam = widget._clists[i]["typeparam"]
                break
            end
        end
        local gifts = {}
        local rews = {}
        local moregold = 0
        local leaguebox = 0
        if type == 1 then
            rews = Split(dd.cfgCharge[id]['otherthing'],"|")
            moregold = dd.cfgCharge[id]['moregold']
            leaguebox = dd.cfgCharge[id]['leaguebox']
        elseif type == 2 then
            rews = Split(widget._cfgJieri[id]['otherthing'],"|")
            moregold = widget._cfgJieri[id]['moregold']
            leaguebox = widget._cfgJieri[id]['leaguebox']
        elseif type == 3 then
            rews = Split(widget._cfgXinshou[id]['otherthing'],"|")
            moregold = widget._cfgXinshou[id]['moregold']
            leaguebox = widget._cfgXinshou[id]['leaguebox']
        elseif type == 4 then
            rews = Split(widget._cfgHuodong[id][typeparam]['otherthing'],"|")
            moregold = dd.cfgCharge[id]['moregold']
            leaguebox = dd.cfgCharge[id]['leaguebox']
        end

        local index = 1
        if moregold > 0 then
            gifts[index] = {}
            gifts[index]["type"] = 7
            gifts[index]["id"] = 0
            gifts[index]["count"] = moregold
            index = index + 1
        end
        if leaguebox > 0 then
            gifts[index] = {}
            gifts[index]["type"] = 12
            gifts[index]["id"] = leaguebox
            gifts[index]["count"] = 1
            index = index + 1
        end

        if tonumber(rews[1]) ~= 0 then
            for i=1,table.getn(rews) do
                local rew = Split(rews[i],"%^")
                gifts[index] = {}
                gifts[index]["type"]  = tonumber(rew[1])
                gifts[index]["id"]    = tonumber(rew[2])
                gifts[index]["count"] = tonumber(rew[3])  
                index = index + 1
            end
        end

        pop.onShowPopDialog("gifts",gifts,nil)    
    end
end

function chargeLayer.onCharge(sender, eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local row  = cc.UserDefault:getInstance():getIntegerForKey("httpif")
        local type = hif._lists:getLong(row,"type") 
        if type == 1 then
            local widget = pop.getDialog("charge")
            widget._lastId = sender._id
            --模拟充值
            local message = ff.net:createMessage()
            message:addCmd(0x135)
            message:addLong(dd.uid)
            message:addLong(sender._id)
            ff.net:rpc(message,false)
        else
            cclog("type  == "..sender._type)
            cclog("id  == "..sender._id)
            local function delay_fun()
                local widget = pop.getDialog("charge")
                if sender._type == 1 then
                    cclog("product  == "..dd.cfgCharge[sender._id]['product'])
                    platform_pay(dd.cfgCharge[sender._id]['product'],dd.cfgCharge[sender._id]['gold'])
                elseif sender._type == 2 then       
                    cclog("product  == "..widget._cfgJieri[sender._id]['product'])     
                    platform_pay(widget._cfgJieri[sender._id]['product'],widget._cfgJieri[sender._id]['gold'])
                elseif sender._type == 3 then
                    cclog("product  == "..widget._cfgXinshou[sender._id]['product']) 
                    platform_pay(widget._cfgXinshou[sender._id]['product'],widget._cfgXinshou[sender._id]['gold'])
                else
                    cclog("product  == "..dd.cfgCharge[sender._id]['product'])
                    platform_pay(dd.cfgCharge[sender._id]['product'],dd.cfgCharge[sender._id]['gold'])
                end
            end
            performWithDelay(sender,delay_fun,0.1)
            --dd.currentLayer._widget:onShowTips("\t"..ff.langString("该功能尚未开放，敬请期待！"))
        end
    end
    GuideControl:GuideCheck()
end

function chargeLayer:getChargeLists()
    local message = ff.net:createMessage()
    message:addCmd(0x043)
    message:addLong(dd.uid)
    ff.net:rpc(message,false)
end

function chargeLayer:onTestCharge(params)
    local code = params[1]
    if code == 0 then
        local widget = pop.getDialog("charge")
        local node = widget:getChildByName("mainArea"):getChildByName("view"):getChildByName(widget._lastId)
        local endnode =  widget:getChildByName("topArea"):getChildByName("gold")
        if node ~= nil then 
            node:runAction(cc.Sequence:create(
                cc.CallFunc:create(function() widget:addAnimation(node:getChildByName("view"):getChildByName("top"):getChildByName("icon"),endnode,150,100) end)
                ,cc.DelayTime:create(0.1)
                ,cc.CallFunc:create(function() widget:addAnimation(node:getChildByName("view"):getChildByName("top"):getChildByName("icon"),endnode,110,130) end)
                ,cc.DelayTime:create(0.1)
                ,cc.CallFunc:create(function() widget:addAnimation(node:getChildByName("view"):getChildByName("top"):getChildByName("icon"),endnode,200,150) end)
                ,cc.DelayTime:create(0.1)
                ,cc.CallFunc:create(function() widget:addAnimation(node:getChildByName("view"):getChildByName("top"):getChildByName("icon"),endnode,130,200) end)
                ,cc.DelayTime:create(0.1)
                ,cc.CallFunc:create(function() widget:addAnimation(node:getChildByName("view"):getChildByName("top"):getChildByName("icon"),endnode,150,100) end)
                ,cc.DelayTime:create(0.1)
                ,cc.CallFunc:create(function() widget:addAnimation(node:getChildByName("view"):getChildByName("top"):getChildByName("icon"),endnode,110,130) end)
            ))
            
            
        else
            cclog("根据id  获取item 错误")
        end
        
        widget:getChargeLists()
        --dd.currentLayer._widget:onShowTips("\t"..ff.langString("充值成功"),true)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
function chargeLayer:onGetChargeLists(params)
    local code = params[1]
    if code == 0 then
        self._clists = {} 
        self._clists = params[2]
        if self._justopen == true then
            self:updateList(true)
            self._justopen = false
        else
            --还好 只有这刷新
            self:getChildByName("mainArea"):stopAllActions()
            self:updateList(false)
        end       
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function chargeLayer:onSNCharge(params)
    local id = params[1]
    if id ~= 401 and id ~= 402 then
        local gifts = params[2]
        cclog("充值成功===============")
        if gifts ~= nil then
            pop.onShowPopDialog("reward",gifts,ff.langString("充值成功"))
        end
        self:getChargeLists()
        if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
            local upgrade = dd.currentLayer._pop._upgrade
            if upgrade ~= nil and upgrade:isVisible() == true and upgrade._bid == 35 then
                upgrade:updateRes(101)
            end
        end
    end
end

function chargeLayer:getChargeIcon(type, id)
    if type == 1 then
        return "images/icon/charge/"..dd.cfgCharge[id]["pic"]..".png"
    elseif type == 2 then
        return "images/icon/charge/"..self._cfgJieri[id]["pic"]..".png"
    elseif type == 3 then
        return "images/icon/charge/"..self._cfgXinshou[id]["pic"]..".png"
    elseif type == 4 then
        --return "images/icon/charge/"..self._cfgHuodong[id]["pic"]..".png"
        return "images/icon/charge/101.png"
    else
        return "images/icon/charge/101.png"
    end    
end
function chargeLayer:getChargeSpine(type, id)
    local pic = 0
    local str = ""
    local anima = ""
    if type == 1 then
        pic = dd.cfgCharge[id]["pic"]
    elseif type == 2 then
        pic = self._cfgJieri[id]["pic"]
    elseif type == 3 then
        pic = self._cfgXinshou[id]["pic"]
    elseif type == 4 then
        pic = 101
    else
        pic = 101
    end    
    if pic == 101 then
        str = "zhoumotehui"
        anima = "ZMTH_animation"
    elseif pic == 201 then
        str = "zhoumotehui"
        anima = "ZMTH_animation"
    elseif pic == 301 then
        str = "jieritehui"
        anima = "JRTH_animation"
    elseif pic == 901 then
        str = "putong_3"
        anima = "PTCZ3_animation"
    elseif pic == 902 then
        str = "putong_2"
        anima = "PTCZ2_animation"
    elseif pic == 903 then
        str = "putong_1"
        anima = "PTCZ1_animation"
    else
        str = "putong_1"
        anima = "PTCZ1_animation"
    end
    return {pic,str,anima}
end

function chargeLayer:addAnimation(nodestart, nodeend, dx, dy)
    local startp = self:convertToNodeSpace(self:getWorldPos(nodestart))
    startp = cc.p(startp.x + dx, startp.y + dy)
    local endp   = self:convertToNodeSpace(self:getWorldPos(nodeend))
    local dis = cc.pGetDistance(endp,startp) 
    local time = dis/1000
    --翻转
    local spr = cc.Sprite:createWithSpriteFrameName("charge_jinbi_0.png")
    self:addChild(spr,10,123)
    spr:setPosition(startp)
    spr:setRotation(-60)
    if startp.y +30> ff.height - 105 then
        spr:setVisible(false)
    end
    local animation = cc.Animation:createWithSpriteFrames(self._animroll, 0.05)
    spr:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
    --fun
    local function endFun()
        spr:removeFromParent(true)
    end
    --move
    spr:runAction(cc.Sequence:create(
                     cc.MoveTo:create(time, cc.p(endp.x -70, endp.y - 70))
                    ,cc.CallFunc:create(function() 
                            spr:setVisible(false)
                            self:playToScal()
                            performWithDelay(self,endFun, 0.1)
                            end)
                     ))
                     
end

function chargeLayer:getWorldPos(node)
    local anr   = node:getAnchorPoint()
    local size  = node:getContentSize()
    local p = node:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
    return p
end
function chargeLayer:playLight(node, type)
    if type == true then
        node:getVirtualRenderer():setGLProgramState(ff.Effect:effectHighLight():getGLProgramState())
    else
        node:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
    end
end
function chargeLayer:playToScal()
    local node = self:getChildByName("topArea"):getChildByName("gold")
    local spr = self:getChildByName("topArea"):getChildByName("gold"):getChildByTag(101)
    local animation = cc.Animation:createWithSpriteFrames(self._animstar, 0.1)
    if spr ~= nil and spr:isVisible() == false then
        spr:setVisible(true)
        spr:runAction(cc.Sequence:create(cc.Animate:create(animation),cc.CallFunc:create(function() spr:setVisible(false) end)))
    end
    node:runAction( cc.Sequence:create(
        cc.ScaleTo:create(0.02,1.1)
        ,cc.CallFunc:create(function() self:playLight(node, true) end)
        ,cc.ScaleTo:create(0.02,1)
        ,cc.CallFunc:create(function() self:playLight(node, false) end)
    ))
    AudioEngine.playEffect(ff.sounds[213])
end

--接口
function chargeLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("charge")
        if widget ~= nil then
            pop.onClosePopDialog("charge")
        end
    end
end

function chargeLayer:onClose()

end

function chargeLayer.onStart(sender)
    if sender._init == false then
        sender:initCfg()
        sender._init = true
    end
    sender._justopen = true
    sender:getChargeLists()    
end

function chargeLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),nil)
    ff.net:registerEvent(2,dd.Tjf_charge_TestCharge, function (message)sender:onTestCharge(message)end)
    ff.net:registerEvent(2,dd.Tjf_charge_GetTopupLists, function (message)sender:onGetChargeLists(message)end)
    ff.net:registerEvent(2,dd.Tjf_notify_SNCharge, function (message)sender:onSNCharge(message)end)
    ff.net:bindProperty(2504,"gold",sender.updateGold)
    sender:getChildByName("mainArea"):getChildByName("view"):jumpToTop()
    return true
end

function chargeLayer.onEnd(sender)
    dd.delBackEvent()
    ff.net:unbindProperty("gold",2504)
    --sender:stopAllActions()
    --要用view 否则会阻止面板的actions  view:时间脚本  main:添加item脚本
    sender:getChildByName("mainArea"):stopAllActions()
    sender:getChildByName("mainArea"):getChildByName("view"):stopAllActions()
    ff.net:removeEvent(2,dd.Tjf_charge_TestCharge)
    ff.net:removeEvent(2,dd.Tjf_charge_GetTopupLists)
    ff.net:removeEvent(2,dd.Tjf_notify_SNCharge)
    if ff.platform ~= 1 then
        for i,items in ipairs(sender._titems) do
            for k, item in ipairs(items) do
                item:getChildByName("view"):getChildByName("top"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("view"):getChildByName("top"):getChildByName("icon"):removeAllChildren(true)
                for t=1,item:getChildByName("view"):getChildByName("view"):getChildrenCount() do
                    local citem = item:getChildByName("view"):getChildByName("view"):getChildByName(t)
                    if citem ~= nil then
                        citem:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                    end
                end
            end
        end
    end
end
function chargeLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("charge")
    if widget ~= nil then
        pop.onClosePopDialog("charge")
    end
end

function onShowChargeLayer(widget)
    local layer = chargeLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onAutoSize()
    layer:onInit()
    return layer
end