sdchongLayer = class("sdchongLayer")
sdchongLayer._name = "sdchong"
sdchongLayer._init = false
sdchongLayer._type = 1


function sdchongLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,sdchongLayer)
	return target
end

function sdchongLayer:onInit(  )
	-- body
	if self._init == false then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		self:setPositionY(0)
		self:getChildByName("back"):setContentSize(cc.size(720,hh))
		self:getChildByName("back"):addTouchEventListener(self.onReturn)
		self:getChildByName("top"):setPositionY(hh - 105)
        self:getChildByName("title"):setPositionY(hh - 105 - 240)
        
		self:getChildByName("scrollview"):setContentSize(cc.size(720,hh- 105 - 240 ))
    	self:getChildByName("scrollview"):setPositionY(0)
 
    	self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    	self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    	self:getChildByName("title"):getChildByName("ico"):loadTexture("images/icon/task/gold/1900002.jpg",0)
		for i=1,4 do
            self:getChildByName("block1"):getChildByName("block5"):getChildByName("item"..i):addTouchEventListener(self.onShowTips)
            
        end
        for i=1,5 do
            self:getChildByName("block2"):getChildByName("item"..i):addTouchEventListener(self.onShowTips)
            
        end
        self._init = true
	end
    if self._type == 1 then
        self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("连续充值活动"))
    else
        self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("累计充值活动"))
    end
    self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
	self.updateGold()
end


function sdchongLayer.onShowTips(sender, eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then        
        local widget = pop.getDialog("sdchong")
        local pos2word = widget:getWorldPos(sender)
        local pos = widget:convertToNodeSpace(pos2word) 
        pos = cc.p(pos.x, pos.y+30)
        if tonumber(sender.type) > 0 then
            widget:showTips(tonumber(sender.type), tonumber(sender.id), tonumber(sender.count), pos)
        end
    end
end

function sdchongLayer:getWorldPos(node)
    local anr   = node:getAnchorPoint()
    local size  = node:getContentSize()
    local p = node:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
    return p
end


function sdchongLayer:showTips(type, id, count, pos)
    local ret  = dd.getGiftsTips(type, id, count)
    local name = ret[1]
    local str  = ret[2]
    
    local tips = self:getChildByName("tips")
    local wid  = 360
    tips:stopAllActions()
    tips:setVisible(true)
    tips:getChildByName("tips"):removeAllChildren(true)

    local richText = ccui.RichText:create()
    richText:ignoreContentAdaptWithSize(false)
    richText:setContentSize(cc.size(wid-30,600))    
    richText:setAutoHeight()

    local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, str, "Helvetica", 20)
    richText:insertElement(chat,0)
    richText:formatText()

    local size = richText:getContentSize()
    richText:setPosition(cc.p(172,size.height/2 + 15))
    tips:setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):addChild(richText)

    tips:getChildByName("name"):setString(name) 
    tips:getChildByName("name"):setPositionY(size.height + 40)

    tips:setPosition(pos)
    if pos.x < 300 then
        tips:setAnchorPoint(cc.p(0.2,0))
        tips:getChildByName("flag"):setPositionX(wid*0.2)
    elseif pos.x > 550 then
        tips:setAnchorPoint(cc.p(0.8,0))
        tips:getChildByName("flag"):setPositionX(wid*0.8)
    else
        tips:setAnchorPoint(cc.p(0.5,0))
        tips:getChildByName("flag"):setPositionX(wid*0.5)
    end       
    local function sched()
        tips:setVisible(false)
    end 

    performWithDelay(tips,sched,1.5) 
end


function sdchongLayer.onStart( sender )
	ff.net:bindProperty(2333,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
    
    schedule(sender, sender.update,1)
    sender:showList()
end

function sdchongLayer.update( sender )
    if sender._type == 1 then
        if next(dd.lianxuChong) == nil then
            return
        end
        local time = dd.lianxuChong.endTime - dd.getServerTime()
        sender:getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
    elseif sender._type ==2 then
        if next(dd.leijiChong) == nil then
            return
        end
        local time = dd.leijiChong.endTime - dd.getServerTime()
        sender:getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
    end
end

function sdchongLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("sdchong")
		if widget == nil then
			return
		end
        pop.onClosePopDialog("sdchong")
    end
end


function sdchongLayer.onEnd( sender )
    -- body
    dd.delBackEvent()
    sender:stopAllActions()
    sender:getChildByName("scrollview"):removeAllChildren(true)
    ff.net:unbindProperty("gold",2333)
end

function onShowsdchong(widget,type)
	-- body
	local layer = sdchongLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
	layer._type = type
    layer:onInit()
    return layer
end

function sdchongLayer.onBefore( sender)
  
end


function sdchongLayer:showList(  )

	if self._type == 1 then

        if next(dd.lianxuChong)  == nil then
            return
        end

        local time = dd.lianxuChong.endTime - dd.getServerTime()
        self:getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
        local item = self:getChildByName("scrollview"):getChildByTag(1)
        if item == nil then
            item = self:getChildByName("block4"):clone()
            item:setVisible(true)
            item:setTag(1)
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        end
        item:getChildByName("heroname_0"):setString(ff.langString("已经连续充值：{0}天"),{dd.lianxuChong.haveday})
        item:getChildByName("heroname"):setString(ff.langString("活动期间，连续充值可获得额外奖励，连续天数越多，奖励越丰厚。").."\n"..ff.langString("注意：中断充值后奖励将从第一日重新计算"))
    
        for i,v in ipairs(dd.lianxuChong.reward) do
            local day = self:getChildByName("scrollview"):getChildByTag(i+1)
            if day == nil then
                day = self:getChildByName("block1"):clone()
                day:setVisible(true)
                day:setTag(i+1)
                self:getChildByName("scrollview"):pushBackCustomItem(day)
            end
            if i > dd.lianxuChong.haveday then
                day:getChildByName("block5"):getChildByName("collected"):setVisible(false)
                for j=1,4 do
                    dd.setContainGLState(day:getChildByName("block5"):getChildByName("item"..tostring(j)),2)
                    dd.setContainGLState(day:getChildByName("block5"):getChildByName("count"..tostring(j)),2)
                end
            else
                day:getChildByName("block5"):getChildByName("collected"):setVisible(true)
                for j=1,4 do
                    dd.setContainGLState(day:getChildByName("block5"):getChildByName("item"..tostring(j)),1)
                    dd.setContainGLState(day:getChildByName("block5"):getChildByName("count"..tostring(j)),1)
                end
            end
            day:getChildByName("heroname_0"):setString(ff.langString("连续充值{0}天",{i}))
            day:getChildByName("block5"):getChildByName("day1"):getChildByName("num"):loadTexture("images/city/num/"..i..".png")
            local giftInfo = Split(v['reward'],'|')
            local index1 = 1
            for k,w in pairs(giftInfo) do
                local gift = Split(w,'%^')
                if day:getChildByName("block5"):getChildByName("item"..index1) ~= nil  then
                    day:getChildByName("block5"):getChildByName("item"..index1):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                    day:getChildByName("block5"):getChildByName("item"..index1).type = gift[1]
                    day:getChildByName("block5"):getChildByName("item"..index1).id = gift[2]
                    day:getChildByName("block5"):getChildByName("item"..index1).count = gift[3]
                    day:getChildByName("block5"):getChildByName("count"..index1):getChildByName("count"):setString(gift[3])
                    index1 = index1 +1
                end
            end
            if index1 <= 4 then
                for i=index1,4 do
                    day:getChildByName("block5"):getChildByName("item"..i).type = 0
                    day:getChildByName("block5"):getChildByName("item"..i).id = 0
                    day:getChildByName("block5"):getChildByName("item"..i).count = 0
                    day:getChildByName("block5"):getChildByName("item"..i):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                    day:getChildByName("block5"):getChildByName("count"..i):getChildByName("count"):setString("")
                end
            end
        end

    elseif self._type ==2 then
        if next(dd.leijiChong)  == nil then
            return
        end
        local item = self:getChildByName("scrollview"):getChildByTag(1)
        if item == nil then
            item = self:getChildByName("xiangzi"):clone()
            item:setVisible(true)
            item:setTag(1)
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        end


        local time = dd.leijiChong.endTime - dd.getServerTime()
        self:getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
        local item1 = self:getChildByName("scrollview"):getChildByTag(99)
        if item1 == nil then
            item1 = self:getChildByName("block4"):clone()
            item1:setVisible(true)
            item1:setTag(99)
            self:getChildByName("scrollview"):pushBackCustomItem(item1)
        end
        item1:getChildByName("heroname_0"):setString(ff.langString("已充值：{0}"),{dd.lianxuChong.havemoney})
        

        local per = 0
        local jinbi = 1
        if dd.leijiChong.reward[table.getn(dd.leijiChong.reward)]["money"] <= dd.leijiChong.havemoney then
            per = 100
        else
            for k,v in pairs(dd.leijiChong.reward) do
                if dd.leijiChong.havemoney <= v["money"] then
                    if tonumber(k) > 1 then
                        per = 100/10*(dd.leijiChong.havemoney - dd.leijiChong.reward[tonumber(k)-1]["money"])/ (v["money"] - dd.leijiChong.reward[tonumber(k)-1]["money"]) + 100/10*(tonumber(k)-1)
                    else
                        per = 100/10*dd.leijiChong.havemoney/ v["money"]
                    end
                    jinbi = k
                    break
                end
            end
        end
        item1:getChildByName("heroname"):setString(ff.langString("活动期间累计充值达到指定金额就可获得额外奖励，奖励通过邮件发放，请注意查收。"))

        if per > 100 then
            per = 100
        end
        local ScrollView = item:getChildByName("ScrollView")
        ScrollView:scrollToPercentHorizontal(per,0.1,false)
        ScrollView:getChildByName("forge"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
        for i,v in ipairs(dd.leijiChong.reward) do
            if ScrollView:getChildByName("item"..i) ~= nil then
                ScrollView:getChildByName("item"..i):getChildByName("point"):setString(v["money"])
                if dd.leijiChong.havemoney >= v["money"] then
                    ScrollView:getChildByName("item"..i):getChildByName("box"):loadTexture(dd.getPathFromUI("sdchongzhi_open.png",1))
                else
                    ScrollView:getChildByName("item"..i):getChildByName("box"):loadTexture(dd.getPathFromUI("sdchongzhi_close.png",1))
                end
            end


            local leiji = self:getChildByName("scrollview"):getChildByTag(i+1)
            if leiji == nil then
                leiji = self:getChildByName("block2"):clone()
                leiji:setVisible(true)
                leiji:setTag(i+1)
                self:getChildByName("scrollview"):pushBackCustomItem(leiji)
            end
            leiji:getChildByName("chu_Label_156"):setString(ff.langString("累计充值{0}美分",{v["money"]}))
            local giftInfo = Split(v["reward"],'|')
            local index1 = 1
            for k,w in pairs(giftInfo) do
                local gift = Split(w,'%^')
                if leiji:getChildByName("item"..index1) ~= nil  then
                    leiji:getChildByName("item"..index1):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                    leiji:getChildByName("item"..index1).type = gift[1]
                    leiji:getChildByName("item"..index1).id = gift[2]
                    leiji:getChildByName("item"..index1).count = gift[3]
                    leiji:getChildByName("count"..index1):getChildByName("count"):setString(gift[3])
                    index1 = index1 +1
                end
            end
            if index1 <= 5 then
                for i=index1,5 do
                    leiji:getChildByName("item"..i):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                    leiji:getChildByName("item"..i).type = 0
                    leiji:getChildByName("item"..i).id = 0
                    leiji:getChildByName("item"..i).count = 0
                    leiji:getChildByName("count"..i):getChildByName("count"):setString("")
                end
            end
        end
    end
    self:getChildByName("scrollview"):jumpToTop()
end

function sdchongLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("sdchong")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end