--处理联盟和世界聊天面板
function chatLayer:onShowUnion(init)
    self:setTitle("联盟")
    self:setReturnFun()

    self:getChildByName("chatpanel"):getChildByName("lists"):removeAllChildren(true)
    self:getChildByName("chatpanel"):setVisible(true)
    self:getChildByName("chatpanel"):getChildByName("chatInput"):setVisible(true)
    
    --聊天类型 1=世界2联盟3私聊4群组
    self._chattype = 2
    self._targetid = dd.myUnion:getLong(1,"unionid")
    self._lastID[2] = 0
    self._getMore = false

    dd.myinfo:setLong(1,"chat_union",0)
    self:updateTag()
    
    if self._firstUnion == false then
        local message =  onPeakChatMessage(2,dd.myUnion:getLong(1,"unionid"))
        ff.net:rpc(message,false)
        self._firstUnion = true
    else
        local nt = ff.dbmanager:sql_fetch_rows("select * from client_chat where `type`='2' and `id`>'"..self._lastID[2].."' order by `id` desc limit 10")
        self:showMessages(nt,false)
    end
end

function chatLayer:onShowWorld(init)
	self:setTitle("世界")
    self:setReturnFun()

    self:getChildByName("chatpanel"):getChildByName("lists"):removeAllChildren(true)
    self:getChildByName("chatpanel"):setVisible(true)
    self:getChildByName("chatpanel"):getChildByName("chatInput"):setVisible(true)
    self:getChildByName("chatpanel"):getChildByName("privateInput"):setVisible(false)
    
    self._chattype = 1
    self._targetid = 0
    self._getMore = false

    self._lastID[1] = 0
    
    local nt = ff.dbmanager:sql_fetch_rows("select * from client_chat where `type`='1' and `id`>'"..self._lastID[1].."' order by `id` desc limit 10")
    self:showMessages(nt,false)
end

--显示私聊
--notinitdata 不加载加载聊天记录
--openFrom 1 从好友面板打开  2 从消息面板打开
function chatLayer:onShowPrivate(uid,name,openFrom)
    cclog("显示私聊.."..uid.."   "..name)
    self:setTitle(name)

    self:getChildByName("chatpanel"):getChildByName("lists"):removeAllChildren(true)
    self:getChildByName("chatpanel"):setVisible(true)
    self:getChildByName("friendpanel"):setVisible(false)
    self:getChildByName("addmember"):setVisible(false)
    self:getChildByName("chatpanel"):getChildByName("privateInput"):setVisible(true)
    self:getChildByName("chatpanel"):getChildByName("chatInput"):setVisible(false)

    if self._friendPannel ~= nil then
        self._friendPannel:onEnd()
    end
    if self._groupPannel ~= nil then
        self._groupPannel:onEnd()
    end
    if self._addMemberPannel ~= nil then
        self._addMemberPannel:onEnd()
    end


    self._chattype = 3
    self._targetid = uid
    self._targetname=name

    --上次最大id,是否第一次查询
    self._privateID[uid]={0,0}

    if dd.myChatHistroy ~= nil then
        for i=1,dd.myChatHistroy:rowCount() do
            if dd.myChatHistroy:getLong(i,"type") == 3 and dd.myChatHistroy:getLong(i,"id") == uid then
                dd.myChatHistroy:setLong(i,"unread",0)
                dd.saveUserValue(2,"3_"..uid,0)
                break
            end
        end
    end

    
    local function fun(sender,eventType)
        if eventType == ccui.TouchEventType.ended then     
            if self._addMemberPannel ~= nil and self._addMemberPannel:isVisible() == true then
                self:getChildByName("top"):getChildByName("title"):getChildByName("title"):setString(self._addMemberPannel._saveTitle)
                self._addMemberPannel:onEnd()
                return
            end
        
            if openFrom == 2 then
                if self:getChildByName("chatpanel"):isVisible() == true then
                    self:getChildByName("chatpanel"):setVisible(false)
                    self._chattype = 0
                    self:onShowChatGroup()
                else
                    self.onReturn()
                end
            else
                if self:getChildByName("chatpanel"):isVisible() == true then
                    self:getChildByName("chatpanel"):setVisible(false)
                    self._chattype = 0
                    self:onShowFriend()
                else
                    self.onReturn()
                end                
            end
        end
    end
    
    --设置返回按钮为 显示好友
    self:setReturnFun(fun)
    self._getMore = false
    local message =  onPeakChatMessage(3,uid)
    ff.net:rpc(message,false)
    self:updateTag()
end

--显示群聊
function chatLayer:onShowGroup(groupid,name)
    cclog("显示群聊.."..groupid.."  "..name)
    self:setTitle(name)
    self:getChildByName("chatpanel"):getChildByName("lists"):removeAllChildren(true)

    self:getChildByName("chatpanel"):setVisible(true)
    self:getChildByName("friendpanel"):setVisible(false)
    self:getChildByName("chatpanel"):getChildByName("privateInput"):setVisible(true)
    self:getChildByName("addmember"):setVisible(false)

    if self._friendPannel ~= nil then
        self._friendPannel:onEnd()
    end
    if self._groupPannel ~= nil then
        self._groupPannel:onEnd()
    end
    if self._addMemberPannel ~= nil then
        self._addMemberPannel:onEnd()
    end
    
    self._chattype = 4
    self._targetid = groupid
    self._targetname=name
    self._getMore = false

    if dd.myChatHistroy ~= nil then
        for i=1,dd.myChatHistroy:rowCount() do
            if dd.myChatHistroy:getLong(i,"type") == 4 and dd.myChatHistroy:getLong(i,"id") == groupid then
                dd.myChatHistroy:setLong(i,"unread",0)
                dd.saveUserValue(2,"4_"..groupid,0)
                break
            end
        end
    end

    
    self._groupID[groupid]={0,0}
    
    local function fun(sender,eventType)
        if eventType == ccui.TouchEventType.ended then    
            if self._addMemberPannel ~= nil and self._addMemberPannel:isVisible() == true then
                self:getChildByName("top"):getChildByName("title"):getChildByName("title"):setString(self._addMemberPannel._saveTitle)
                self._addMemberPannel:onEnd()
                return
            end
            if self:getChildByName("chatpanel"):isVisible() == true then
                self:getChildByName("chatpanel"):setVisible(false)
                self._chattype = 0
                self:onShowChatGroup()
            else
                self.onReturn()
            end
        end
    end
    
    --设置返回按钮为 显示聊天消息
    self:setReturnFun(fun)
    
    local message = onPeakChatMessage(4,groupid)
    ff.net:postMessage(message)

    self:updateTag()
end

--显示好友选择界面
function chatLayer.onShowFriends(sender,eventType)
    if eventType==ccui.TouchEventType.ended then 
        local chat = pop.getDialog("chat")
        if chat ~= nil then
            chat:showAddMember()
        end
    end
end

function chatLayer.onSendMessage(sender,eventType)
	if eventType==ccui.TouchEventType.ended then   
		local widget = pop.getDialog("chat")
		widget:sendMessage()
	end
end

--发送聊天消息
function chatLayer:sendMessage()
    local info = ""
    if cc.PLATFORM_OS_ANDROID ~= cc.Application:getInstance():getTargetPlatform() then    
        if self._chattype <= 2 then
            info = self._chatbox:getText()
        else
            info = self._privatebox:getText()
        end
    else
        local isv = platform_isInputVisable()
        if isv == 1 then
            info = platform_updateInputText(0,1)
        else
            if self._chattype <= 2 then
                info = self._chatbox:getText()
            else
                info = self._privatebox:getText()
            end
        end
    end
    self._chatbox:setText("")
    self._privatebox:setText("")
    --cclog("info:"..info)
    if string.len(info) > 0 and string.len(info) ~= select(2, string.gsub(info," "," ")) then
        if self._chattype == 2 and dd.myUnion:getLong(1,"unionid") <= 0 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您当前尚未加入联盟"))
            return
        end
        if self._chattype > 2 and self._targetid <= 0 then
            return
        end
        --发送
        local message = ff.net:createMessage()
        message:addCmd(0xF04)
        message:addLong(dd.uid)
        message:addLong(self._chattype)
        message:addLong(self._targetid)
        message:addString(info,127)
        message:addString(ff.set_trans_lan,15)--语言类型
        ff.net:postMessage(message)
    end
end

--打开个人详细信息界面
function chatLayer.openUinfo(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end

    if doaction == true then
        local uid = sender:getTag()
        if uid == dd.uid then
            return
        end
        pop.onShowPopDialog("power2",pop.getDialog("chat"),uid)
    end
end

function chatLayer.goMap( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then
        local mapsite=sender.mapsite
        if(nil==mapsite) then
            return
        end
        local function close( event )
            local widget = pop.getDialog("chat")
            widget.onReturn()
            if dd.mainUI ~= nil then
                dd.mainUI:closeBuildsNow()
            end
            pop.CloseAll()
        end 
        
        
        local function toMap(event)
            if dd.currentLayer._name ~= "WorldUILayer" then
                dd.yunClose(2,nil,nil,mapsite)
            else
                if dd.worldLayer ~= nil then
                    performWithDelay(sender, close,0.1)
                    dd.worldLayer:setSceneCenterByGid(mapsite-1,true)   
                end
            end
        end
        local function toFight(event)
            --cclog("ii===")
            --performWithDelay(sender, close,0.5)
            pop.onShowPopDialog("fightRep",mapsite,0,true,nil)
        end
        local function toJoin(event)
           
            local function sureCancel()
                cmd.joinToGroup(mapsite)        
            end
        --提示
            if dd.myUnion == nil or dd.myUnion:getLong(1,"unionid") <= 0 then
                dd.currentLayer._widget:onShowSure(ff.langString("加入联盟"),ff.langString("是否申请加入该联盟。\n点击后申请，取消返回"),sureCancel,true,1)
            end
            
        end 
           
        if sender.type == 1 then
            if dd.KSRoom  ~= 0 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("该地点不在跨服战场中"))
                return
            end
            performWithDelay(sender, toMap,0.5)
        elseif sender.type == 3 then
            performWithDelay(sender, toFight,0.5)
        elseif sender.type == 11 then
            if dd.KSRoom  == 0 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("该地点不在本服地图内"))
                return
            end
            performWithDelay(sender, toMap,0.5)
        else
            performWithDelay(sender, toJoin,0.5)
        end
    end
end
--显示信息
function chatLayer:showMessages(nt,mov)
    if nt == nil then
        return
    end
    if nt:rowCount() < 1 then
        nt:clear()
        return
    end

    for j=1,nt:rowCount() do
        local i = nt:rowCount() - (j - 1)
        local type = tonumber(nt:getString(i,"type"))
        local uid  = tonumber(nt:getString(i,"uid"))
        local target = tonumber(nt:getString(i,"targetid"))
        local id   = tonumber(nt:getString(i,"id"))
        if j == nt:rowCount() then
            if type <= 2 then
                self._lastID[type] = id
            elseif type == 3 then
                self._privateID[target][1] = id
            else
                self._groupID[target][1] = id
            end    
        end
        local item = nil
        local ww   = 470
        if uid == dd.uid then
            if tonumber(nt:getString(i,"group")) == 0 or tonumber(nt:getString(i,"group")) == 21 then
                item = self:getChildByName("item2"):clone()
            else
                item = self:getChildByName("item4"):clone()
                ww = 400
            end
        elseif tonumber(nt:getString(i,"group")) == 0 then
            item = self:getChildByName("item1"):clone()   
            item:getChildByName("trans"):setVisible(true)
            item:getChildByName("trans"):setTag(tonumber(nt:getString(i,"id")))
            item:getChildByName("trans"):getChildByName("label"):setString(ff.langString("未翻译"))
            item:getChildByName("trans"):getChildByName("dotrans"):setTag(1)
            item:getChildByName("trans"):getChildByName("dotrans"):addTouchEventListener(self.onTrans)


            --if tonumber(nt:getString(i,"lang")) ~= ff.set_trans_lan then
            --end
        else
            item = self:getChildByName("item3"):clone()   
            ww = 400
        end   

        local info = item:getChildByName("info")
        if tonumber(nt:getString(i,"unionid")) > 0 then
            info:getChildByName("union"):setString("["..nt:getString(i,"uflag").."]")
            if tonumber(nt:getString(i,"ulevel")) >= 5 then
                info:getChildByName("icon"):setString(nt:getString(i,"ulevel"))
            else
                info:getChildByName("icon"):setString("")
            end
        else
            info:getChildByName("union"):setString("")
            info:getChildByName("icon"):setString("")
        end        
        info:getChildByName("name"):setString(nt:getString(i,"name").." LV."..nt:getString(i,"level"))         
        info:requestDoLayout()

        local face=item:getChildByName("face"):getChildByName("face")
        face:loadTexture(dd.getPlayerIcon(tonumber(nt:getString(i,"face"))),0)
        face:setTouchEnabled(true)
        face:setTag(uid)
        face:addTouchEventListener(self.openUinfo)
        --uinfo
        item:getChildByName("time"):setString(ff.getTimeTips(tonumber(dd.getChatServerTime() - tonumber(nt:getString(i,"time")))))
        local richText=ccui.RichText:create()
        richText:ignoreContentAdaptWithSize(false)
        richText:setContentSize(cc.size(ww,600))    
        richText:setAutoHeight()

        local chat  = nil--ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, nt:getString(i,"chat"), "Helvetica", 20)
        local chat1 = nil
        local chat2 = nil

        if tonumber(nt:getString(i,"group")) == 11 then
            local chatCo = Split(nt:getString(i,"chat"),'%,')
           --cclog('==============================='..tonumber(chatCo[1]))
            local pos = tonumber(chatCo[1])
            local mapsite=dd.MapidToXY(pos,2)
            local go = item:getChildByName("go")
            go.mapsite = pos
            go.type = 1
            if pos < 0 then
                mapsite=dd.MapidToXY(-pos,1)
                go.mapsite = -pos
                go.type = 11
            end
            local chatStr = ff.langString("分享")..":"..chatCo[2]..ff.langString("的城市")
            local chatStr1 = "(X:"..mapsite.x..",Y:"..mapsite.y..")"
            local chatStr2 = "LV."..chatCo[3]
            chat = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr, "Helvetica", 20)
            chat1 = ccui.RichElementText:create(1, cc.c3b(255, 0, 0), 255, chatStr1, "Helvetica", 20)
            chat2 = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr2, "Helvetica", 20)
            go:addTouchEventListener(self.goMap)
        elseif tonumber(nt:getString(i,"group")) == 12 then
            local chatCo = Split(nt:getString(i,"chat"),'%,')
            --cclog('==============================='..tonumber(chatCo[1]))
            local pos = tonumber(chatCo[1])
            local mapsite=dd.MapidToXY(pos,2)
            local go = item:getChildByName("go")
            go.type = 1
            go.mapsite = pos
            if pos < 0 then
                mapsite=dd.MapidToXY(-pos,1)
                go.mapsite = -pos
                go.type = 11
            end
            local chatStr = ff.langString("分享")..":"..chatCo[2]..ff.langString("的营帐")
            local chatStr1 = "(X:"..mapsite.x..",Y:"..mapsite.y..")"
            local chatStr2 = "LV."..chatCo[3]
            chat = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr, "Helvetica", 20)
            chat1 = ccui.RichElementText:create(1, cc.c3b(255, 0, 0), 255, chatStr1, "Helvetica", 20)
            chat2 = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr2, "Helvetica", 20)
            
            go:addTouchEventListener(self.goMap)
        elseif tonumber(nt:getString(i,"group")) == 13 then
            local chatCo = Split(nt:getString(i,"chat"),'%,')
            --cclog('==============================='..tonumber(chatCo[1]))
            --cclog("nimeia=="..item[1].."=="..item[2].."=="..item[3])
            local pos = tonumber(chatCo[1])
            local mapsite=dd.MapidToXY(pos,2)
            local go = item:getChildByName("go")
            go.type = 1
            go.mapsite = pos
            if pos < 0 then
                mapsite=dd.MapidToXY(-pos,1)
                go.mapsite = -pos
                go.type = 11
            end
            local chatStr = ff.langString("分享")..":"..ff.langString(dd.cfgWorldRes[tonumber(chatCo[2])]['name'])
            local chatStr1 = "(X:"..mapsite.x..",Y:"..mapsite.y..")"
            local chatStr2 = "LV."..chatCo[3]
            chat = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr, "Helvetica", 20)
            chat1 = ccui.RichElementText:create(1, cc.c3b(255, 0, 0), 255, chatStr1, "Helvetica", 20)
            chat2 = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr2, "Helvetica", 20)
            
            go:addTouchEventListener(self.goMap)
            --chat = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, nt:getString(i,"chat"), "Helvetica", 20)
        elseif tonumber(nt:getString(i,"group")) == 14 then
            local chatCo = Split(nt:getString(i,"chat"),'%,')
            --cclog('==============================='..tonumber(chatCo[1]))
            local pos = tonumber(chatCo[1])
            local mapsite=dd.MapidToXY(pos,2)
            local go = item:getChildByName("go")
            go.type = 1
            go.mapsite = pos
            if pos < 0 then
                mapsite=dd.MapidToXY(-pos,1)
                go.mapsite = -pos
                go.type = 11
            end
            local chatStr = ff.langString("分享")..":"..ff.langString("空地")
            local chatStr1 = "(X:"..mapsite.x..",Y:"..mapsite.y..")"
            chat = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr, "Helvetica", 20)
            chat1 = ccui.RichElementText:create(1, cc.c3b(255, 0, 0), 255, chatStr1, "Helvetica", 20)
            
            go:addTouchEventListener(self.goMap)
        elseif tonumber(nt:getString(i,"group")) == 20 then
            local chatCo = Split(nt:getString(i,"chat"),'%,')
            --cclog('==============================='..tonumber(chatCo[1]))
            local mapsite=dd.MapidToXY(tonumber(chatCo[1]))
            local chatStr = ff.langString("分享")..":"
            if tonumber(chatCo[3]) == 1 then
                chatStr = chatStr..ff.langString("攻击")..chatCo[4]..ff.langString("的战报")
            else
                chatStr = chatStr..ff.langString("防御")..chatCo[4]..ff.langString("的战报")
            end
            local chatStr1 = "(X:"..mapsite.x..",Y:"..mapsite.y..")"
            chat = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr, "Helvetica", 20)
            chat1 = ccui.RichElementText:create(1, cc.c3b(255, 0, 0), 255, chatStr1, "Helvetica", 20)
            local go = item:getChildByName("go")
            go.mapsite = tonumber(chatCo[6])
            go.type = 3
            go:addTouchEventListener(self.goMap)
        elseif tonumber(nt:getString(i,"group")) == 21 then
            chat = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, nt:getString(i,"chat"), "Helvetica", 20)
            local go = item:getChildByName("go")
            if go ~= nil then
                go.mapsite = tonumber(nt:getString(i,"unionid"))
                go.type = 2
                go:addTouchEventListener(self.goMap)
            end
        else
            chat = ccui.RichElementText:create(1, cc.c3b(246, 232, 143), 255, nt:getString(i,"chat"), "Helvetica", 20)
        end
        richText:insertElement(chat,0)
        if chat1 ~= nil then
            richText:insertElement(chat1,1)
        end
        if chat2 ~= nil then
            richText:insertElement(chat2,2)
        end
        richText:formatText()
        local size = richText:getContentSize()
        local hh = size.height + 70
        --if uid == dd.uid then
        --    hh = hh - 35
        --end
        if hh < 100 then
            hh = 100
        end
        --richText:setPosition(cc.p(25,(hh - size.height)/2))
        richText:setPosition(cc.p(260 - (470 - ww)/2,hh/2 - 5))
        item:getChildByName("detail"):setContentSize(cc.size(520,hh))
        item:getChildByName("detail"):addChild(richText)
        item:getChildByName("detail"):setTag(id)

        item:setContentSize(cc.size(720,hh)) 
        item:setVisible(true)
        item:setTag(id)

        if hh > 100 then
            --item:getChildByName("face"):setPositionY(item:getChildByName("face"):getPositionY() + (hh - 127))
            item:requestDoLayout()
        end
        --新加 做复制内容用
        item:getChildByName("detail"):setPostParent(false)
        item:getChildByName("detail"):setTouchEnabled(true,false)
        item:getChildByName("detail"):addTouchEventListener(self.copyContent)

        cclog("pushBackCustomItem")
        self:getChildByName("chatpanel"):getChildByName("lists"):pushBackCustomItem(item)
        self:getChildByName("chatpanel"):getChildByName("lists"):refreshView(true)
    end
    --self:getChildByName("chatpanel"):getChildByName("lists"):refreshView(true)
    
    nt:clear()
    if mov == nil or mov == true then
        self:getChildByName("chatpanel"):getChildByName("lists"):scrollToBottom(0.5,true)
    else
        if self:getChildByName("chatpanel"):getChildByName("lists"):getChildrenCount() < 10 then
            self:getChildByName("chatpanel"):getChildByName("lists"):scrollToBottom(0.5,true)
        else
            self:getChildByName("chatpanel"):getChildByName("lists"):scrollToBottom(0,false)
        end            
    end
    self._getMore = true
end

function chatLayer.onTrans(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("chat")
        if widget == nil then
            return
        end
        local type = sender:getTag()
        local id   = sender:getParent():getTag()
        local data = ff.dbmanager:sql_fetch_rows("select `chat` from client_chat where `id`='"..id.."'")
        if data ~= nil and data:rowCount() == 1 then
            if type == 1 then
                local message = ff.net:createMessage()
                message:addCmd(0x00000D01)
                message:addLong(dd.uid)
                message:addString(data:getString(1,"chat"),511)
                message:addString(dd.languageCode[ff.set_trans_lan + 1],15)
                message:addLong(id)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                ff.net:postMessage(message)     
            else
                widget:onTranslate({0,"","",data:getString(1,"chat"),id},true)   
            end
        end
        if data ~= nil then
            data:clear()
        end            
    end
end
function chatLayer:onTranslate(message,back)
    local code = message[1]
    if code == 0 then
        local target = message[4]
        local id     = message[5]
        --cclog(message[1]..","..message[2]..","..message[3]..","..message[4]..","..message[5])

        local item   = self:getChildByName("chatpanel"):getChildByName("lists"):getChildByTag(id)
        if item ~= nil then
            local ww   = 470
            local richText=ccui.RichText:create()
            richText:ignoreContentAdaptWithSize(false)
            richText:setContentSize(cc.size(ww,600))    
            richText:setAutoHeight()
            local chat = ccui.RichElementText:create(1, cc.c3b(246, 232, 143), 255, target, "Helvetica", 20)
            item:getChildByName("detail"):removeAllChildren()
            richText:insertElement(chat,0)
            richText:formatText()
            local size = richText:getContentSize()
            local hh = size.height + 70
            if hh < 100 then
                hh = 100
            end
            
            richText:setPosition(cc.p(260 - (470 - ww)/2,hh/2 - 5))
            item:getChildByName("detail"):setContentSize(cc.size(520,hh))
            item:getChildByName("detail"):addChild(richText)
            item:requestDoLayout()
            self:getChildByName("chatpanel"):getChildByName("lists"):refreshView(true)

            if back == true then
                item:getChildByName("trans"):getChildByName("dotrans"):setTag(1)
                item:getChildByName("trans"):getChildByName("label"):setString(ff.langString("未翻译"))
            else
                item:getChildByName("trans"):getChildByName("dotrans"):setTag(2)
                item:getChildByName("trans"):getChildByName("label"):setString(ff.langString("已翻译"))
            end
        end
    end
end


function chatLayer:insertMessages(nt,asc)
    if nt == nil then
        return
    end
    if nt:rowCount() < 1 then
        nt:clear()
        return
    end
    if asc == nil then
        asc = false
    end

    local beforey = self:getChildByName("chatpanel"):getChildByName("lists"):getInnerContainer():getPositionY()
    cclog("beforey:"..beforey)

    for j=1,nt:rowCount() do
        local tempv = nt:rowCount()
        if asc == true then
            tempv = 1
        end
        if j == tempv then
            if self._chattype == 3 and self._privateID[self._targetid][1] <= 0 then
                self._privateID[self._targetid][1] = tonumber(nt:getString(j,"id"))
            elseif self._chattype == 4 and self._groupID[self._targetid][1] <= 0 then                
                self._groupID[self._targetid][1] = tonumber(nt:getString(j,"id"))
            end
        end
        local i = 0
        if asc == false then
            i = nt:rowCount() - (j - 1)
        else
            i = j
        end
        local type = tonumber(nt:getString(i,"type"))
        local uid  = tonumber(nt:getString(i,"uid"))
        local id   = tonumber(nt:getString(i,"id"))
        if self:getChildByName("chatpanel"):getChildByName("lists"):getChildByTag(id) == nil then
            local item = nil
            local ww   = 470
            if uid == dd.uid then
                if tonumber(nt:getString(i,"group")) == 0 or tonumber(nt:getString(i,"group")) == 21 then
                    item = self:getChildByName("item2"):clone()
                else
                    item = self:getChildByName("item4"):clone()
                    ww = 400
                   -- cclog("222")
                end
            elseif tonumber(nt:getString(i,"group")) == 0 then
                item = self:getChildByName("item1"):clone()   
                item:getChildByName("trans"):setVisible(true)
                item:getChildByName("trans"):setTag(tonumber(nt:getString(i,"id")))
                item:getChildByName("trans"):getChildByName("dotrans"):setTag(1)
                item:getChildByName("trans"):getChildByName("label"):setString(ff.langString("未翻译"))
                item:getChildByName("trans"):getChildByName("dotrans"):addTouchEventListener(self.onTrans)
                --if tonumber(nt:getString(i,"lang")) ~= ff.set_trans_lan then
                --end                
            else
                item = self:getChildByName("item3"):clone()  
                ww = 400 
            end

            local info = item:getChildByName("info")
            if tonumber(nt:getString(i,"unionid")) > 0 then
                info:getChildByName("union"):setString("["..nt:getString(i,"uflag").."]")
                if tonumber(nt:getString(i,"ulevel")) >= 5 then
                    info:getChildByName("icon"):setString(nt:getString(i,"ulevel"))
                else
                    info:getChildByName("icon"):setString("")
                end
            else
                info:getChildByName("union"):setString("")
                info:getChildByName("icon"):setString("")
            end        
            info:getChildByName("name"):setString(nt:getString(i,"name").." LV."..nt:getString(i,"level"))     
            info:requestDoLayout()

            item:getChildByName("face"):getChildByName("face"):loadTexture(dd.getPlayerIcon(tonumber(nt:getString(i,"face"))),0)
            local face=item:getChildByName("face"):getChildByName("face")
            face:setTag(uid)
            face:setTouchEnabled(true)
            face:addTouchEventListener(self.openUinfo)


            item:getChildByName("time"):setString(ff.getTimeTips(tonumber(dd.getChatServerTime() - tonumber(nt:getString(i,"time")))))
            
            local richText=ccui.RichText:create()
            richText:ignoreContentAdaptWithSize(false)
            richText:setContentSize(cc.size(ww ,600))    
            --richText:setMaxLine(6)
            richText:setAutoHeight()

            local chat = nil--ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, nt:getString(i,"chat"), "Helvetica", 20)
            local chat1 = nil
            local chat2 = nil
            --cclog("==sdfsdfsdfsdf==="..tonumber(nt:getString(i,"group")))
            if tonumber(nt:getString(i,"group")) == 11 then
                local chatCo = Split(nt:getString(i,"chat"),'%,')
                local mapsite=dd.MapidToXY(tonumber(chatCo[1]))
                local chatStr = ff.langString("分享")..":"..chatCo[2]..ff.langString("的城市")
                local chatStr1 = "(X:"..mapsite.x..",Y:"..mapsite.y..")"
                local chatStr2 = "LV."..chatCo[3]
                chat = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr, "Helvetica", 20)
                chat1 = ccui.RichElementText:create(1, cc.c3b(255, 0, 0), 255, chatStr1, "Helvetica", 20)
                chat2 = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr2, "Helvetica", 20)
                local go = item:getChildByName("go")
                go.mapsite = tonumber(chatCo[1])
                go.type = 1
                go:addTouchEventListener(self.goMap)
            elseif tonumber(nt:getString(i,"group")) == 12 then
                local chatCo = Split(nt:getString(i,"chat"),'%,')
                local mapsite=dd.MapidToXY(tonumber(chatCo[1]))
                local chatStr = ff.langString("分享")..":"..chatCo[2]..ff.langString("的营帐")
                local chatStr1 = "(X:"..mapsite.x..",Y:"..mapsite.y..")"
                local chatStr2 = "LV."..chatCo[3]
                chat = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr, "Helvetica", 20)
                chat1 = ccui.RichElementText:create(1, cc.c3b(255, 0, 0), 255, chatStr1, "Helvetica", 20)
                chat2 = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr2, "Helvetica", 20)
                local go = item:getChildByName("go")
                go.mapsite = tonumber(chatCo[1])
                go.type = 1
                go:addTouchEventListener(self.goMap)
            elseif tonumber(nt:getString(i,"group")) == 13 then
                local chatCo = Split(nt:getString(i,"chat"),'%,')
                --cclog("nimeia=="..item[1].."=="..item[2].."=="..item[3])
                local mapsite=dd.MapidToXY(tonumber(chatCo[1]))
                local chatStr = ff.langString("分享")..":"..ff.langString(dd.cfgWorldRes[tonumber(chatCo[2])]['name'])
                local chatStr1 = "(X:"..mapsite.x..",Y:"..mapsite.y..")"
                local chatStr2 = "LV."..chatCo[3]
                chat = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr, "Helvetica", 20)
                chat1 = ccui.RichElementText:create(1, cc.c3b(255, 0, 0), 255, chatStr1, "Helvetica", 20)
                chat2 = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr2, "Helvetica", 20)
                local go = item:getChildByName("go")
                go.mapsite = tonumber(chatCo[1])
                go.type = 1
                go:addTouchEventListener(self.goMap)
                --chat = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, nt:getString(i,"chat"), "Helvetica", 20)
            elseif tonumber(nt:getString(i,"group")) == 14 then
                local chatCo = Split(nt:getString(i,"chat"),'%,')
                local mapsite=dd.MapidToXY(tonumber(chatCo[1]))
                local chatStr = ff.langString("分享")..":"..ff.langString("空地")
                local chatStr1 = "(X:"..mapsite.x..",Y:"..mapsite.y..")"
                chat = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr, "Helvetica", 20)
                chat1 = ccui.RichElementText:create(1, cc.c3b(255, 0, 0), 255, chatStr1, "Helvetica", 20)
                local go = item:getChildByName("go")
                go.mapsite = tonumber(chatCo[1])
                go.type = 1
                go:addTouchEventListener(self.goMap)
            elseif tonumber(nt:getString(i,"group")) == 20 then
                local chatCo = Split(nt:getString(i,"chat"),'%,')
                local mapsite=dd.MapidToXY(tonumber(chatCo[1]))
                local chatStr = ff.langString("分享")..":"
                if tonumber(chatCo[3]) == 1 then
                    chatStr = chatStr..ff.langString("攻击")..chatCo[4]..ff.langString("的战报")
                else
                    chatStr = chatStr..ff.langString("防御")..chatCo[4]..ff.langString("的战报")
                end
                local chatStr1 = "(X:"..mapsite.x..",Y:"..mapsite.y..")"
                chat = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, chatStr, "Helvetica", 20)
                chat1 = ccui.RichElementText:create(1, cc.c3b(255, 0, 0), 255, chatStr1, "Helvetica", 20)
                local go = item:getChildByName("go")
                go.mapsite = tonumber(chatCo[6])
                go.type = 3
                go:addTouchEventListener(self.goMap)
            elseif tonumber(nt:getString(i,"group")) == 21 then
                chat = ccui.RichElementText:create(1, cc.c3b(0, 255, 0), 255, nt:getString(i,"chat"), "Helvetica", 20)
                local go = item:getChildByName("go")
                if go ~= nil then
                    go.mapsite = tonumber(nt:getString(i,"unionid"))
                    go.type = 2
                    go:addTouchEventListener(self.goMap)
                end
            else
                chat = ccui.RichElementText:create(1, cc.c3b(246, 232, 143), 255, nt:getString(i,"chat"), "Helvetica", 20)
            end
        richText:insertElement(chat,0)
        if chat1 ~= nil then
            richText:insertElement(chat1,1)
        end
        if chat2 ~= nil then
            richText:insertElement(chat2,2)
        end
            richText:formatText()
            local size = richText:getContentSize()
            local hh = size.height + 70
            --if uid == dd.uid then
            --    hh = hh - 35
            --end
            if hh < 100 then
                hh = 100
            end
            --richText:setPosition(cc.p(25,(hh - size.height)/2))
            richText:setPosition(cc.p(260 - (470 - ww)/2,hh/2 - 5))
            item:getChildByName("detail"):setContentSize(cc.size(520,hh))
            item:getChildByName("detail"):addChild(richText)

            item:setContentSize(cc.size(720,hh)) 
            if hh > 100 then
                --item:getChildByName("face"):setPositionY(item:getChildByName("face"):getPositionY() + (hh - 127))
                item:requestDoLayout()
            end

            item:setVisible(true)
            item:setTag(id)

            --新加 做复制内容用
            item:getChildByName("detail"):setTouchEnabled(true,false)
            item:getChildByName("detail"):addTouchEventListener(self.copyContent)

            self:getChildByName("chatpanel"):getChildByName("lists"):insertCustomItem(item,0)
        end    
        self:getChildByName("chatpanel"):getChildByName("lists"):refreshView(true)
    end
    self:getChildByName("chatpanel"):getChildByName("lists"):getInnerContainer():setPositionY(beforey)
    self._getMore = true
    if nt:rowCount() > 0 then
        self:getChildByName("chatpanel"):getChildByName("lists"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,-20)))
    end
    nt:clear()
end
--接收聊天消息
function chatLayer.onChatMessage(params)
    local chat = pop.getDialog("chat")
    chat:showWaiting(false)
    
    local code = params[1]
    if code == 0 then
        local type = params[2]
        local row  = params[3]
        local action   = params[4]
        local targetid = params[5]
        cclog("type:"..type..",targetid:"..targetid)        
        if action == 1 then
            --角标
            if type >= 3 then
                if type == chat._chattype and chat._targetid == targetid then
                    for i=1,dd.myChatHistroy:rowCount() do
                        if dd.myChatHistroy:getLong(i,"type") == type and dd.myChatHistroy:getLong(i,"id") == targetid then
                            dd.myChatHistroy:setLong(i,"unread",0)
                            dd.saveUserValue(2,type.."_"..targetid,0)
                            break
                        end
                    end
                else
                    chat:updateTag()
                    if chat._type == 2 then
                        chat._groupPannel:updateView()
                    end
                end
            elseif type == 2 then
                if type ~= chat._chattype then
                    chat:updateTag()
                else
                    dd.myinfo:setLong(1,"chat_union",0)            
                end    
            end
            local nt = nil
            if (type == 1 or type == 2) and type == chat._chattype then
                nt = ff.dbmanager:sql_fetch_rows("select * from client_chat where `type`='"..type.."' and `id`>'"..chat._lastID[type].."' order by `id` asc limit 10")
            elseif type == 3 and chat._targetid == targetid then      
                nt = ff.dbmanager:sql_fetch_rows("select * from client_chat where `type`='"..type.."' and `targetid`='"..targetid.."' and `id`>'"..chat._privateID[targetid][1].."' order by `id` asc limit 10")
            elseif type == 4 and chat._targetid == targetid then                
                nt = ff.dbmanager:sql_fetch_rows("select * from client_chat where `type`='"..type.."' and `targetid`='"..targetid.."' and `id`>'"..chat._groupID[targetid][1].."' order by `id` asc limit 10")
            end
            chat:showMessages(nt)       
        elseif action == 0 then
            if row < 10 then
                if type == 1 or type == 2 then
                    chat._lastID[type + 2] = 1
                elseif type == 3 then
                    chat._privateID[targetid][2] = 1
                elseif type == 4 then
                    chat._groupID[targetid][2] = 1
                end
            end                     
            local nt = nil
            if type == chat._chattype and targetid == chat._targetid then
                nt = ff.dbmanager:sql_fetch_rows("select * from client_chat where `type`='"..type.."' and `targetid`='"..targetid.."' order by `id` ASC limit "..row) 
            end
            if type == 2 then
                if chat._lastID[2] == 0 then
                    if nt ~= nil then
                        nt:clear()
                    end
                    nt = ff.dbmanager:sql_fetch_rows("select * from client_chat where `type`='"..type.."' and `targetid`='"..targetid.."' order by `id` desc limit 10")     
                    chat:showMessages(nt)
                    return
                end
            elseif type == 3 then
                if chat._privateID[targetid][1] == 0 then
                    if nt ~= nil then
                        nt:clear()
                    end
                    nt = ff.dbmanager:sql_fetch_rows("select * from client_chat where `type`='"..type.."' and `targetid`='"..targetid.."' order by `id` desc limit 10")     
                    chat:showMessages(nt)
                    return
                end
            elseif type == 4 then
                if chat._groupID[targetid][1] == 0 then
                    if nt ~= nil then
                        nt:clear()
                    end
                    nt = ff.dbmanager:sql_fetch_rows("select * from client_chat where `type`='"..type.."' and `targetid`='"..targetid.."' order by `id` desc limit 10")     
                    chat:showMessages(nt)
                    return
                end                
            end
            chat:insertMessages(nt) 
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
--查看更多消息
function chatLayer:getMoreMessage()
    local minid = 0
    local lists = self:getChildByName("chatpanel"):getChildByName("lists")
    if self._getMore == false then
        return
    end
    for i,v in ipairs(lists:getChildren()) do
        local tag = v:getTag()
        if minid == 0 then
            minid = tag
        end
        if tag < minid then
            minid = tag
        end    
    end    
    cclog("minid:"..minid)

    local cache = false
    --是否已经取完
    if self._chattype <= 2 then
        if self._lastID[self._chattype + 2] > 0 then
            cache = true
        end
    elseif self._chattype == 3 then
        if self._privateID[self._targetid][2] > 0 then
            cache = true
        end
    else
        if self._groupID[self._targetid][2] > 0 then
            cache = true
        end
    end
    local rows = nil
    if self._chattype == 3 or self._chattype == 4 then
        rows = ff.dbmanager:sql_fetch_rows("select * from client_chat where `type`='"..self._chattype.."' and `targetid`='"..self._targetid.."' and `id`<'"..minid.."' order by `id` desc limit 10")
    else
        rows = ff.dbmanager:sql_fetch_rows("select * from client_chat where `type`='"..self._chattype.."' and `id`<'"..minid.."' order by `id` desc limit 10")
    end        
    if cache == true then
        self:insertMessages(rows,true)
        return
    else
        if rows ~= nil and rows:rowCount() >= 10 then
            self:insertMessages(rows,true)
            return
        end    
    end
    if rows ~= nil then
        rows:clear()
    end    
    self:showWaiting(true)
    local message = onPeakChatMessage(self._chattype,self._targetid)
    ff.net:postMessage(message)
end
--复制聊天内容
function chatLayer.copyContent(sender,eventtype)
    local widget=pop.getDialog("chat")
    --复制按钮事件

    local function show()
        widget.copyitem:setVisible(true)
        local pos = sender:getTouchBeganPosition()
        pos.x = pos.x - widget.copyitem:getContentSize().width/2
        if pos.x < 0 then
            pos.x = 0
        end
        if pos.x + widget.copyitem:getContentSize().width > 720 then
            pos.x = 720 - widget.copyitem:getContentSize().width
        end
        widget.copyitem:setPosition(pos)
        widget.copyitem:getChildByName("copybtn"):setTag(sender:getTag())
        widget.copyitem:getChildByName("reportbtn"):setTag(sender:getTag())
    end
    local drag = false
    local sp=sender:getTouchBeganPosition()
    if eventtype == ccui.TouchEventType.began then
        widget.copyitem:stopAllActions()
        widget.copyitem:setVisible(false)
        widget.copyitem:runAction(cc.Sequence:create(cc.DelayTime:create(1.2),cc.CallFunc:create(show)))
        drag = false
    elseif eventtype == ccui.TouchEventType.moved then
        if drag == false then
            local now = sender:getTouchMovePosition()
            if math.abs(sp.y - now.y) <= 10 and math.abs(sp.x - now.x) <= 10 then
            else
                drag = true
                widget.copyitem:stopAllActions()
                widget.copyitem:setVisible(false)
            end
        end
    elseif eventtype == ccui.TouchEventType.ended then
        if drag == false then
            widget.copyitem:stopAllActions()
        end
    else
        widget.copyitem:stopAllActions()
        widget.copyitem:setVisible(false)
    end
end
