--[[
	出征
]]
local chuZhen = class("chuzhen")
chuZhen._name = "chuzhen"
chuZhen._init = false
chuZhen._type = 0
chuZhen._soliders = {}
chuZhen._params = nil
chuZhen._max = 0
chuZhen._hid = 0
chuZhen._UsePower = false
chuZhen._callback = nil
chuZhen._lianjin = false

function chuZhen.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, chuZhen)
    return target
end

function chuZhen:doAutoSize()
	local w=ff.width
	local h=ff.height
	local mainArea = self:getChildByName("mainArea")

	self:setContentSize(cc.size(720,h))
	self:getChildByName("bg"):setContentSize(cc.size(720,h))
	self:getChildByName("bg"):setPositionY(0)
	self:getChildByName("topArea"):setPositionY(h - 105)
	self:getChildByName("image"):setPositionY(h - 108 - 133)
	self:getChildByName("herocontain"):setPositionY(h - 291 - 127)
	self:getChildByName("mainArea"):setContentSize(cc.size(720,h - 425 - 125))
	self:getChildByName("mainArea"):setPositionY(125)
	self:getChildByName("contain"):setPositionY(0)
	mainArea:getChildByName("back"):setContentSize(cc.size(690,h - 425 - 125))
	mainArea:getChildByName("back"):setPosition(cc.p(15,0))
	mainArea:getChildByName("listcontain"):setContentSize(cc.size(690,h - 425 - 125 - 60))
	mainArea:getChildByName("listcontain"):setPositionY(50)
	mainArea:getChildByName("bar01"):setPositionY(10)
	mainArea:getChildByName("nomsg"):setPositionY((h - 425 - 125)/2)


	self:getChildByName("herolist"):setContentSize(cc.size(720,h - 105 -8))
	self:getChildByName("herolist"):setPositionY(4)
	self:getChildByName("herolist"):getChildByName("back"):setContentSize(cc.size(720,ff.height - 105))
	self:getChildByName("herolist"):getChildByName("back"):setPositionY((ff.height - 105)/2)
	self:getChildByName("herolist"):getChildByName("list"):setContentSize(cc.size(720,ff.height - 105 - 8))
	self:getChildByName("herolist"):getChildByName("list"):setPositionY(0)	

end

function chuZhen:init(params)
	self._params = params
	--cclog("----------------33333333333333-------------"..self._params['level'])
	if self._init == false then
		self:doAutoSize()

		
	    local topArea=self:getChildByName("topArea")
	    topArea:getChildByName("title"):getChildByName("title"):getVirtualRenderer():enableBold(true)
	    topArea:getChildByName("title"):getChildByName("title"):setString(ff.langString("出征"))
	    topArea:getChildByName("addbtn"):addTouchEventListener(dd.onPay)

	    local backbtn= topArea:getChildByName("return")
	    backbtn:addTouchEventListener(self.onReturn)

	    local infobtn=self:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("infobtn")
	    infobtn:addTouchEventListener(self.openBuffer)
   


	    --self:getChildByName("contain"):getChildByName("btn1"):addTouchEventListener(self.onBest)
	    self:getChildByName("contain"):getChildByName("btn2"):addTouchEventListener(self.onPowerful)
	    self:getChildByName("contain"):getChildByName("btn3"):addTouchEventListener(self.onGo)

	    local addbtn= self:getChildByName("herocontain"):getChildByName("addbtn")
	    addbtn:addTouchEventListener(self.changeHero)	 
	    self:getChildByName("herocontain"):getChildByName("face"):addTouchEventListener(self.changeHero)	    

	    self:getChildByName("time"):getChildByName("item5"):getChildByName("time"):addTouchEventListener(self.onSelect)
	    self:getChildByName("time"):getChildByName("item10"):getChildByName("time"):addTouchEventListener(self.onSelect)
	    self:getChildByName("time"):getChildByName("item60"):getChildByName("time"):addTouchEventListener(self.onSelect)
	    self:getChildByName("time"):getChildByName("close"):addTouchEventListener(self.onCancel)
	    self:getChildByName("time"):getChildByName("sure"):addTouchEventListener(self.onSure)
		self._init = true
	end
	self:getChildByName("time"):setVisible(false)
	self:getChildByName("herolist"):setVisible(false)

	ff.net:registerEvent(102,dd.Tjf_Troops_Expedition,self.onExpedition)
	ff.net:registerEvent(102,dd.Tjf_Troops_AllyWarCreate,self.onExpedition)	
	ff.net:registerEvent(102,dd.Tjf_Troops_AllyWarJoin,self.onExpedition)	
	ff.net:registerEvent(102,dd.Tjf_prop_use, function (params)self:onPropUse(params)end)
	ff.net:registerEvent(102,dd.Tjf_chuzheng_limit,self.onChuZhenLimit)	
	ff.net:registerEvent(102,dd.Tjg_GetLCStrongholdG2Detail,self.onchulimit)

	self.updateGold()
    ff.net:bindProperty(2001,"gold",self.updateGold)

    
    self._hid = 0
    self:doSelectHero()
    self._soliders = {}

    --占领
    --self:getChildByName("info"):getChildByName("res"):setVisible(false)
    if self._type == 21 or self._type == 22 or self._type == 23 then
    	self:getChildByName("image"):getChildByName("image"):loadTexture("images/icon/battle/type/active_2.jpg",0)
    else
	    if params.uid == 0 then
			self:getChildByName("image"):getChildByName("image"):loadTexture("images/icon/battle/type/1.jpg",0)
		else
			if self._type == 4 or self._type == 24 then
				self:getChildByName("image"):getChildByName("image"):loadTexture("images/icon/battle/type/img02_cz.jpg",0)
			else
				self:getChildByName("image"):getChildByName("image"):loadTexture("images/icon/battle/type/win.png",0)
			end
		end
	end
    if self._type == 1 then
    	if params.uid == 0 then
    		--空地和金矿
	    	if params.res == 0 then
		    	self:getChildByName("contain"):getChildByName("btn2"):setTag(2)
		    else	
		    	self:getChildByName("contain"):getChildByName("btn2"):setTag(1)
		    end	
		else	    	
			self:getChildByName("contain"):getChildByName("btn2"):setTag(2)
		end		
    elseif self._type == 2 then
    	--攻击城市
		self:getChildByName("contain"):getChildByName("btn2"):setTag(2)
	elseif self._type == 88 then
    	--攻击城市
		self:getChildByName("contain"):getChildByName("btn2"):setTag(2)
    elseif self._type == 3 then
    	self:getChildByName("contain"):getChildByName("btn2"):setTag(2)
	elseif self._type == 4 or self._type == 24 then
    	self:getChildByName("contain"):getChildByName("btn2"):setTag(2)
	elseif self._type == 5 or self._type == 15 or self._type == 22 or self._type == 23 or self._type == 12 then			
    	self:getChildByName("contain"):getChildByName("btn2"):setTag(2)
    elseif self._type == 21 then
    	self:getChildByName("contain"):getChildByName("btn2"):setTag(2)
	end		

	if self._type <= 3 or self._type == 5 or self._type == 21 or self._type == 22 or self._type == 23 or self._type == 88 then
		self:getChildByName("herocontain"):getChildByName("face"):setVisible(true)
		self:getChildByName("herocontain"):getChildByName("addbtn"):setVisible(true)
		self:getChildByName("herocontain"):getChildByName("face"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
		self:getChildByName("herocontain"):getChildByName("name"):setVisible(false)
		self:getChildByName("herocontain"):getChildByName("info"):setVisible(false)
		self:getChildByName("herocontain"):getChildByName("msg"):setVisible(true)

	else		
		self:getChildByName("herocontain"):getChildByName("face"):setVisible(false)
		self:getChildByName("herocontain"):getChildByName("addbtn"):setVisible(false)

		self:getChildByName("herocontain"):getChildByName("face"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
		self:getChildByName("herocontain"):getChildByName("name"):setVisible(false)
		self:getChildByName("herocontain"):getChildByName("msg"):setVisible(false)
		self:getChildByName("herocontain"):getChildByName("info"):setVisible(true)
		if self._type == 4 or self._type == 24 then
			self:getChildByName("herocontain"):getChildByName("info"):setString(ff.langString("增援"))
		elseif self._type == 88 then
			self:getChildByName("herocontain"):getChildByName("info"):setString(ff.langString("副本"))

		else
			self:getChildByName("herocontain"):getChildByName("info"):setString(ff.langString("联盟战争"))
		end
	end
	self._lianjin = false

    self:initArmys()	
    for i=1,dd.soliders:rowCount() do
    	if (self._type ~= 4 and self._type ~= 24) or dd.cfgSoldier[dd.soliders:getLong(i,"soldierid")]['type'] ~= 21 then
	    	self:setNum(dd.soliders:getLong(i,"soldierid"),0,false)
	    end
    end
    self._UsePower = false
end

--更换英雄 显示英雄列表
function chuZhen.changeHero(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  
        local widget=pop.getDialog("chuzhen")
        widget:showHeroList()
    end
end

function chuZhen:doSelectHero()
	if self._hid == 0 then
        self:getChildByName("herocontain"):getChildByName("addbtn"):setVisible(true)
        self:getChildByName("herocontain"):getChildByName("msg"):setVisible(false)

        self:getChildByName("herocontain"):getChildByName("face"):setVisible(true)
        self:getChildByName("herocontain"):getChildByName("face"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        self:getChildByName("herocontain"):getChildByName("name"):setVisible(false)
        self:getChildByName("herocontain"):getChildByName("name"):setString(ff.langString("请选择带队英雄"))
        if self._UsePower == true then
	        self:BlinkHero(true)
	    end
	else
		--cclog("00000000000000000000000")
		self:BlinkHero(false)
		for i=1,dd.heros:rowCount() do
			if dd.heros:getLong(i,"hid") == self._hid then
				local id = dd.heros:getLong(i,"id")
		        self:getChildByName("herocontain"):getChildByName("addbtn"):setVisible(false)
		        self:getChildByName("herocontain"):getChildByName("msg"):setVisible(false)

		        self:getChildByName("herocontain"):getChildByName("face"):setVisible(true)
		        self:getChildByName("herocontain"):getChildByName("name"):setVisible(true)

		        self:getChildByName("herocontain"):getChildByName("name"):setString(ff.langString(dd.cfgHero[id]['name']).." LV."..dd.heros:getLong(i,"level"))
		        self:getChildByName("herocontain"):getChildByName("face"):getChildByName("icon"):loadTexture(dd.getHeroIcon(id),0)
		        break
			end
		end
	end
	--更行出兵信息
	local plus_1 = 0
	local plus_551 = 0

	local plus_392 = 0
	local plus_401 = 0
	local plus_402 = 0
	local plus_406 = 0
	local plus_393 = 0
	local plus_412 = 0
	local plus_413 = 0

	for i=1,dd.myeffect:rowCount() do
		if dd.myeffect:getLong(i,"id") == 1 then
			plus_1 = dd.myeffect:getLong(i,"param")
		end	
		if dd.myeffect:getLong(i,"id") == 551 then
			plus_551 = dd.myeffect:getLong(i,"param")
		end
		if dd.myeffect:getLong(i,"id") == 392 then
			plus_392 = dd.myeffect:getLong(i,"param")
		end
		if dd.myeffect:getLong(i,"id") == 401 then
			plus_401 = dd.myeffect:getLong(i,"param")
		end
		if dd.myeffect:getLong(i,"id") == 402 then
			plus_402 = dd.myeffect:getLong(i,"param")
		end
		if dd.myeffect:getLong(i,"id") == 406 then
			plus_406 = dd.myeffect:getLong(i,"param")
		end
		if dd.myeffect:getLong(i,"id") == 393 then
			plus_393 = dd.myeffect:getLong(i,"param")
		end				
		if dd.myeffect:getLong(i,"id") == 412 then
			plus_412 = dd.myeffect:getLong(i,"param")
		end				
		if dd.myeffect:getLong(i,"id") == 413 then
			plus_413 = dd.myeffect:getLong(i,"param")
		end				
	end

	if self._hid > 0 then
		plus_1 = plus_1 + dd.getHeroPlus(1,self._hid)
		plus_551 = plus_551 + dd.getHeroPlus(551,self._hid)
		plus_392 = plus_392 + dd.getHeroPlus(392,self._hid)
		plus_401 = plus_401 + dd.getHeroPlus(401,self._hid)
		plus_402 = plus_402 + dd.getHeroPlus(402,self._hid)
		plus_406 = plus_406 + dd.getHeroPlus(406,self._hid)
		plus_393 = plus_393 + dd.getHeroPlus(393,self._hid)
		plus_412 = plus_412 + dd.getHeroPlus(412,self._hid)
		plus_413 = plus_413 + dd.getHeroPlus(413,self._hid)
	end

	if dd.myAlchemist ~= nil and self._lianjin == true then
		if dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")] ~= nil then
			for i=1,3 do
				if dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."id"] == 551 then
					plus_551 = plus_551 + dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."num"]
				end
				if dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."id"] == 392 then
					plus_392 = plus_392 + dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."num"]
				end
			end
		end
	end
	--单次可出兵数量上限=plus_1*(1+plus_551/1000)
	self._max = math.floor(plus_1 * (1 + plus_551/1000))
	if (self._type == 5 or self._type == 15 or self._type == 12 or self._type == 4 or self._type == 24 or self._type == 22 or self._type == 23 ) and self._params['maxarmys'] ~= nil then
		cclog("maxarmys:"..self._params['maxarmys'])
		if self._max > self._params['maxarmys'] then
			self._max = self._params['maxarmys']
		end
	end

	--当前兵力，和当前负载
	local total = 0
	local bags = 0
	local speed = 0
	for id,temp in pairs(self._soliders) do
		total = total + temp
		bags = bags + dd.cfgSoldier[id]['count'] * temp
	end	

	if total > self._max then
		self:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info1"):setColor(cc.c3b(255,0,0))	
	else
		self:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info1"):setColor(cc.c3b(161,175,175))	
	end
	self:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info1"):setString(ff.langString("部队")..":"..dd.showKM((total),5).."/"..dd.showKM(self._max,5))
	
	--负载
	--向下取整 携带量  兵种表基础携带量*(1+plus_406/1000+plus_393/1000)
	bags = math.floor(bags * (1 + plus_406/1000 + plus_393/1000))

	if self._params ~= nil and self._params.res ~= nil and self._params.res >= 1 and self._params.res <= 6 then
		cclog("bags:"..bags..","..self._params.res)
		cclog("bags:"..bags..","..self._params.level)
		bags = math.floor(bags/dd.cfgWorldRes[self._params.res * 100 + self._params.level]['carry'])		
	end		
	self:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info2"):setString(ff.langString("负载")..":"..dd.showKM(bags,5))

	--计算时间
	for id,temp in pairs(self._soliders) do
		if tonumber(temp) > 0 then
			local tspeed = dd.cfgSoldier[id]['speed']

			if self._type == 4 or self._type == 24 then
				if dd.cfgSoldier[id]['type'] == 1 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000+ plus_412/1000)
				elseif dd.cfgSoldier[id]['type'] == 3 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_402/1000 + plus_392/1000+ plus_412/1000)
				elseif dd.cfgSoldier[id]['type'] == 2 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000+ plus_412/1000)
				else
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000)
				end
				if speed == 0 then
					speed = tspeed
				else
					if tspeed < speed then
						speed = tspeed
					end
				end
			elseif self._type == 21 then	
				if dd.cfgSoldier[id]['type'] == 1 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000+ plus_413/1000)
				elseif dd.cfgSoldier[id]['type'] == 3 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_402/1000 + plus_392/1000+ plus_413/1000)
				elseif dd.cfgSoldier[id]['type'] == 2 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000+ plus_413/1000)
				else
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000)
				end
				if speed == 0 then
					speed = tspeed
				else
					if tspeed < speed then
						speed = tspeed
					end
				end
			else
				if dd.cfgSoldier[id]['type'] == 1 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000)
				elseif dd.cfgSoldier[id]['type'] == 3 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_402/1000 + plus_392/1000)
				elseif dd.cfgSoldier[id]['type'] == 2 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000)
				else
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000)
				end
				if speed == 0 then
					speed = tspeed
				else
					if tspeed < speed then
						speed = tspeed
					end
				end
			end
		end	
	end	
	--出兵所需时间=一格所用时间为1000/（兵种基础速度*（1+plus_392/1000+plus_401/1000+plus_402/1000））秒   402只对骑兵起作用  取所需时间最长作为时间
    --  进攻后，兵全部死亡，回家时速度固定为40
    --  侦查时，速度固定为2000
    --  运输资源时，速度固定为80

	if speed > 0 and self._type ~= 88 then
	    local x1 = (self._params.cid-1)%ff.world_maplayerSize.width
	    local y1 = (self._params.cid-1 - x1)/ff.world_maplayerSize.width

	    local x2 = (dd.mycity:getLong(1,"cid")-1)%ff.world_maplayerSize.width
	    local y2 = (dd.mycity:getLong(1,"cid")-1-x2)/ff.world_maplayerSize.width

	    local dis = math.sqrt((x2 - x1)*(x2 - x1) + (y2 - y1)*(y2 - y1))
	    local tick = math.ceil(dis * 1000/speed)
	    self:getChildByName("contain"):getChildByName("btn3"):getChildByName("time"):setString(ff.getLeftTime(tick,":"))
	else
		self:getChildByName("contain"):getChildByName("btn3"):getChildByName("time"):setString("00:00:00")
	end

	self:getChildByName("herocontain"):requestDoLayout()
end
function chuZhen.selectHero(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  
        local widget=pop.getDialog("chuzhen")
        local hid = sender:getTag()
        widget._hid = hid
        widget:doSelectHero()
        local heros = widget:getChildByName("herolist")
        heros:setVisible(false)
    end
end
function chuZhen.cancelHero(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  
        local widget=pop.getDialog("chuzhen")
        local hid = sender:getTag()
        widget._hid = 0
        widget:doSelectHero()
        local heros = widget:getChildByName("herolist")
        heros:setVisible(false)
		--heros:stopAllActions()
		--pop.onCloseEffect(12,heros)
    end
end

function chuZhen:showHeroList()
	local heros = self:getChildByName("herolist")
	for hid,hero in pairs(heros:getChildByName("list"):getChildren()) do
		local have = false
		for i=1,dd.heros:rowCount() do
			if dd.heros:getLong(i,"hid") == hid then
				have = true
				break
			end
		end
		if have == false then
			hero:removeFromParent(true)
		end	
	end
	for i=1,dd.heros:rowCount() do
		local hid = dd.heros:getLong(i,"hid")
		local hero = heros:getChildByName("list"):getChildByTag(hid)
		if hero == nil then
			hero =heros:getChildByName("item"):clone()
			hero:setTag(hid)
			hero:getChildByName("btn"):setTag(hid)
			hero:getChildByName("btn2"):setTag(hid)
			hero:getChildByName("btn"):addTouchEventListener(self.selectHero)
			hero:getChildByName("btn2"):addTouchEventListener(self.cancelHero)
			hero:setVisible(true)
			heros:getChildByName("list"):addChild(hero)
		end
	end

	for i=1,dd.heros:rowCount() do
		local hero = heros:getChildByName("list"):getChildByTag(dd.heros:getLong(i,"hid"))
		if hero ~= nil then
			hero:getChildByName("heroname"):setString(ff.langString(dd.cfgHero[dd.heros:getLong(i,"id")]['name']).." LV."..dd.heros:getLong(i,"level"))
			hero:getChildByName("power"):setString(ff.langString("战力").."："..dd.heros:getLong(i,"power"))
			hero:getChildByName("face"):getChildByName("icon"):loadTexture(dd.getHeroIcon(dd.heros:getLong(i,"id")),0)
			hero:getChildByName("face"):getChildByName("type"):getChildByName("icon"):loadTexture("images/icon/hero/type/"..dd.cfgHero[dd.heros:getLong(i,"id")]['type']..".png",0)
			cclog("============================="..dd.heros:getLong(i,"status"))
			if dd.heros:getLong(i,"status") == 0 then
				if dd.heros:getLong(i,"type") == 0 then
					hero:getChildByName("state"):setVisible(false)
					hero:getChildByName("state2"):setVisible(true)
					hero:getChildByName("icon"):setVisible(false)
					hero:getChildByName("state"):setString(ff.langString("状态").."："..ff.langString("空闲"))
					hero:getChildByName("state2"):setString(ff.langString("状态").."："..ff.langString("空闲"))
					if self._hid == dd.heros:getLong(i,"hid") then
						hero:getChildByName("btn"):setVisible(false)
						hero:getChildByName("btn2"):setVisible(true)
					else
						hero:getChildByName("btn"):setVisible(true)
						hero:getChildByName("btn2"):setVisible(false)
					end	
					hero:getChildByName("face"):getChildByName("icon"):setColor(cc.c3b(255,255,255))
				else	
					hero:getChildByName("state"):setVisible(true)
					hero:getChildByName("icon"):setVisible(true)
					hero:getChildByName("state2"):setVisible(false)
					if dd.heros:getLong(i,"type") == 2 then
						hero:getChildByName("state"):setString(ff.langString("已任命为: 防御"))
					else
						hero:getChildByName("state"):setString(ff.langString("已任命为: 内政官"))
					end
					hero:getChildByName("face"):getChildByName("icon"):setColor(cc.c3b(128,128,128))
					hero:getChildByName("btn"):setVisible(false)
					hero:getChildByName("btn2"):setVisible(false)
				end
			elseif dd.heros:getLong(i,"status") == 1 then	
				hero:getChildByName("state"):setVisible(true)
				hero:getChildByName("icon"):setVisible(true)
				hero:getChildByName("state2"):setVisible(false)
				hero:getChildByName("face"):getChildByName("icon"):setColor(cc.c3b(128,128,128))
				hero:getChildByName("state"):setString(ff.langString("状态").."："..ff.langString("随军"))
				hero:getChildByName("btn"):setVisible(false)
				hero:getChildByName("btn2"):setVisible(false)
			elseif dd.heros:getLong(i,"status") == 2 then	
				hero:getChildByName("state"):setVisible(true)
				hero:getChildByName("icon"):setVisible(true)
				hero:getChildByName("state2"):setVisible(false)
				hero:getChildByName("face"):getChildByName("icon"):setColor(cc.c3b(128,128,128))
				hero:getChildByName("state"):setString(ff.langString("状态").."："..ff.langString("囚禁"))
				hero:getChildByName("btn"):setVisible(false)
				hero:getChildByName("btn2"):setVisible(false)
			elseif dd.heros:getLong(i,"status") == 9 then	
				hero:getChildByName("state"):setVisible(true)
				hero:getChildByName("icon"):setVisible(true)
				hero:getChildByName("state2"):setVisible(false)
				hero:getChildByName("face"):getChildByName("icon"):setColor(cc.c3b(128,128,128))
				hero:getChildByName("state"):setString(ff.langString("状态").."："..ff.langString("已死"))
				hero:getChildByName("btn"):setVisible(false)
				hero:getChildByName("btn2"):setVisible(false)
			else
				if dd.heros:getLong(i,"type") == 0 then
					hero:getChildByName("state"):setVisible(false)
					hero:getChildByName("icon"):setVisible(false)
					hero:getChildByName("state2"):setVisible(true)
					hero:getChildByName("face"):getChildByName("icon"):setColor(cc.c3b(255,255,255))
					if self._hid == dd.heros:getLong(i,"hid") then
						hero:getChildByName("btn"):setVisible(false)
						hero:getChildByName("btn2"):setVisible(true)
					else
						hero:getChildByName("btn"):setVisible(true)
						hero:getChildByName("btn2"):setVisible(false)
					end	
				else	
					hero:getChildByName("state"):setVisible(true)
					hero:getChildByName("icon"):setVisible(true)
					hero:getChildByName("state2"):setVisible(false)
					hero:getChildByName("face"):getChildByName("icon"):setColor(cc.c3b(128,128,128))
					if dd.heros:getLong(i,"type") == 2 then
						hero:getChildByName("state"):setString(ff.langString("已任命为: 防御"))
					else
						hero:getChildByName("state"):setString(ff.langString("已任命为: 内政官"))
					end
					hero:getChildByName("btn"):setVisible(false)
					hero:getChildByName("btn2"):setVisible(false)
				end
			end
			hero:requestDoLayout()
		end
	end
	heros:setVisible(true)
end

--控制数量
function chuZhen:setNum(sid,count,input)
	if tonumber(count) == nil then
		count = 0
	end
	cclog("sid:"..sid..",count:"..count)
	local org = count
	local bags = 0
	local nowcount = 0
	local total = 0
	local speed = 0
	for i=1,dd.soliders:rowCount() do
		if dd.soliders:getLong(i,"soldierid") == sid then
			total = dd.soliders:getLong(i,"count")
			break
		end
	end
	if tonumber(count) > total then
		count = total
	end

	
	--更行出兵信息
	local plus_1 = 0
	local plus_551 = 0

	local plus_392 = 0
	local plus_401 = 0
	local plus_402 = 0
	local plus_406 = 0
	local plus_393 = 0
	local plus_412 = 0
	local plus_413 = 0

	for i=1,dd.myeffect:rowCount() do
		if dd.myeffect:getLong(i,"id") == 1 then
			plus_1 = dd.myeffect:getLong(i,"param")
		end	
		if dd.myeffect:getLong(i,"id") == 551 then
			plus_551 = dd.myeffect:getLong(i,"param")
		end
		if dd.myeffect:getLong(i,"id") == 392 then
			plus_392 = dd.myeffect:getLong(i,"param")
		end
		if dd.myeffect:getLong(i,"id") == 401 then
			plus_401 = dd.myeffect:getLong(i,"param")
		end
		if dd.myeffect:getLong(i,"id") == 402 then
			plus_402 = dd.myeffect:getLong(i,"param")
		end
		if dd.myeffect:getLong(i,"id") == 406 then
			plus_406 = dd.myeffect:getLong(i,"param")
		end
		if dd.myeffect:getLong(i,"id") == 393 then
			plus_393 = dd.myeffect:getLong(i,"param")
		end				
		if dd.myeffect:getLong(i,"id") == 412 then
			plus_412 = dd.myeffect:getLong(i,"param")
		end				
		if dd.myeffect:getLong(i,"id") == 413 then
			plus_413 = dd.myeffect:getLong(i,"param")
		end				
	end

	if dd.myAlchemist ~= nil and self._lianjin == true then
		if dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")] ~= nil then
			for i=1,3 do
				if dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."id"] == 551 then
					plus_551 = plus_551 + dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."num"]
				end
				if dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."id"] == 392 then
					plus_392 = plus_392 + dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."num"]
				end
			end
		end
	end


	cclog(plus_1..","..plus_551..","..plus_392..","..plus_401..","..plus_402..","..plus_406..","..plus_393)
	if self._hid > 0 then
		plus_1 = plus_1 + dd.getHeroPlus(1,self._hid)
		plus_551 = plus_551 + dd.getHeroPlus(551,self._hid)
		plus_392 = plus_392 + dd.getHeroPlus(392,self._hid)
		plus_401 = plus_401 + dd.getHeroPlus(401,self._hid)
		plus_402 = plus_402 + dd.getHeroPlus(402,self._hid)
		plus_406 = plus_406 + dd.getHeroPlus(406,self._hid)
		plus_393 = plus_393 + dd.getHeroPlus(393,self._hid)
		plus_412 = plus_412 + dd.getHeroPlus(412,self._hid)
		plus_413 = plus_413 + dd.getHeroPlus(413,self._hid)
	end
	cclog(plus_1..","..plus_551..","..plus_392..","..plus_401..","..plus_402..","..plus_406..","..plus_393)

	--单次可出兵数量上限=plus_1*(1+plus_551/1000)
	self._max = math.floor(plus_1 * (1 + plus_551/1000))
	if (self._type == 5 or self._type == 15 or self._type == 12 or self._type == 4 or self._type == 24 or self._type == 22 or self._type == 23 ) and self._params['maxarmys'] ~= nil then
		cclog("maxarmys:"..self._params['maxarmys'])
		if self._max > self._params['maxarmys'] then
			self._max = self._params['maxarmys']
		end
	end
	--负载
	for id,temp in pairs(self._soliders) do
		if tonumber(id) ~= tonumber(sid) then
			nowcount = nowcount + temp
			bags = bags + dd.cfgSoldier[id]['count'] * temp
		end	
	end

	if self._max < nowcount + count then
		count = self._max - nowcount
		if count < 0 then
			count = 0
		end
	end	
	if nowcount + count > self._max then
		self:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info1"):setColor(cc.c3b(255,0,0))	
	else
		self:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info1"):setColor(cc.c3b(161,175,175))	
	end
	cclog("nowcount:"..nowcount..","..count..",max:"..self._max)
	self:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info1"):setString(ff.langString("部队")..":"..dd.showKM((nowcount + count),5).."/"..dd.showKM(self._max,5))
	self._soliders[sid] = count

	bags = bags + dd.cfgSoldier[sid]['count'] * count
	--向下取整 携带量  兵种表基础携带量*(1+plus_406/1000+plus_393/1000)
	bags = math.floor(bags * (1 + plus_406/1000 + plus_393/1000))
	if self._params ~= nil and self._params.res ~= nil and self._params.res >= 1 and self._params.res <= 6 then
		bags = math.floor(bags/dd.cfgWorldRes[self._params.res * 100 + self._params.level]['carry'])
	end
	self:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info2"):setString(ff.langString("负载")..":"..dd.showKM(bags,5))
	

	local item = self:getChildByName("mainArea"):getChildByName("listcontain"):getChildByTag(sid)
	if item ~= nil then
		local editbox = item:getChildByName("textpanel"):getChildByName(sid)
		editbox:setText(count)
		if total > 0 then
			local progress = math.floor(count*100/total)
			if input == true then
				item:getChildByName("panel"):getChildByName("slider"):setPercent(progress)
			else
				if org ~= count then
					item:getChildByName("panel"):getChildByName("slider"):setPercent(progress)
				end
			end	
		end
		item:getChildByName("name"):setString(ff.langString(dd.cfgSoldier[sid]['soldierName']).."  "..count.."/"..total)
	end
	--计算时间
	for id,temp in pairs(self._soliders) do
		if tonumber(temp) > 0 then
			local tspeed = dd.cfgSoldier[id]['speed']

			if self._type == 4 or self._type == 24 then
				if dd.cfgSoldier[id]['type'] == 1 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000+ plus_412/1000)
				elseif dd.cfgSoldier[id]['type'] == 3 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_402/1000 + plus_392/1000+ plus_412/1000)
				elseif dd.cfgSoldier[id]['type'] == 2 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000+ plus_412/1000)
				else
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000)
				end
				if speed == 0 then
					speed = tspeed
				else
					if tspeed < speed then
						speed = tspeed
					end
				end
			elseif self._type == 21 then	
				if dd.cfgSoldier[id]['type'] == 1 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000+ plus_413/1000)
				elseif dd.cfgSoldier[id]['type'] == 3 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_402/1000 + plus_392/1000+ plus_413/1000)
				elseif dd.cfgSoldier[id]['type'] == 2 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000+ plus_413/1000)
				else
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000)
				end
				if speed == 0 then
					speed = tspeed
				else
					if tspeed < speed then
						speed = tspeed
					end
				end
			else
				if dd.cfgSoldier[id]['type'] == 1 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000)
				elseif dd.cfgSoldier[id]['type'] == 3 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_402/1000 + plus_392/1000)
				elseif dd.cfgSoldier[id]['type'] == 2 then
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000)
				else
					tspeed = tspeed * (1 + plus_401/1000 + plus_392/1000)
				end
				if speed == 0 then
					speed = tspeed
				else
					if tspeed < speed then
						speed = tspeed
					end
				end
			end
		end	
	end	
	--出兵所需时间=一格所用时间为1000/（兵种基础速度*（1+plus_392/1000+plus_401/1000+plus_402/1000））秒   402只对骑兵起作用  取所需时间最长作为时间
    --  进攻后，兵全部死亡，回家时速度固定为40
    --  侦查时，速度固定为2000
    --  运输资源时，速度固定为80

	if speed > 0 and self._type ~= 88 then
	    local x1 = (self._params.cid-1)%ff.world_maplayerSize.width
	    local y1 = (self._params.cid-1 - x1)/ff.world_maplayerSize.width

	    local x2 = (dd.mycity:getLong(1,"cid")-1)%ff.world_maplayerSize.width
	    local y2 = (dd.mycity:getLong(1,"cid")-1-x2)/ff.world_maplayerSize.width

	    local dis = math.sqrt((x2 - x1)*(x2 - x1) + (y2 - y1)*(y2 - y1))
	    local tick = math.ceil(dis * 1000/speed)
	    cclog("speed:"..speed..","..dis)

	    self:getChildByName("contain"):getChildByName("btn3"):getChildByName("time"):setString(ff.getLeftTime(tick,":"))
	else
		self:getChildByName("contain"):getChildByName("btn3"):getChildByName("time"):setString("00:00:00")
	end
	self:getChildByName("mainArea"):getChildByName("bar01"):requestDoLayout()
	self:getChildByName("contain"):requestDoLayout()
end
function chuZhen:initArmys()
    local function sliderEvent( ref, type )
        if type == ccui.SliderEventType.percentChanged then
            local percent = ref:getPercent()
            local sid = ref:getTag()
            for i=1,dd.soliders:rowCount() do
            	if dd.soliders:getLong(i,"soldierid") == sid then
		            local maxNum  = dd.soliders:getLong(i,"count")
        		    local curNum  = math.floor(percent * maxNum/100)
        		    local item    = self:getChildByName("mainArea"):getChildByName("listcontain"):getChildByTag(sid)
        		    local editbox = item:getChildByName("textpanel"):getChildByName(sid)
        		    editbox:setText(curNum)
        		    self:setNum(sid,curNum,false)
					break        		    
            	end
            end
        end
    end
    local function onCheck( sender,eventType )
    	local touch = false
    	if eventType == ccui.TouchEventType.canceled then
	        local startp = sender:getTouchBeganPosition()
	        local endp   = sender:getTouchEndPosition()
	        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                touch = true          
	        end
	    end

	    if eventType==ccui.TouchEventType.ended then  
           touch = true 
	    end
	    if touch == true then
	    	self._lianjin = true
	    	if sender:getSelectedState() == true then
	    		self._lianjin = false
	    		self:doSelectHero()
	    	else
	    		self:doSelectHero()
	    	end
	    end
    end 
    --输入框事件
    local function editBoxTextEventHandle(strEventName,pSender)
    	local edit = pSender
    	if strEventName == "began" then
    		pSender:setText("")
	    elseif strEventName == "ended" then
	    elseif strEventName == "return" then
			local count = pSender:getText()
			local sid   = pSender:getName()
			if count == nil or count == "" then
				count = 0
			end
			if tonumber(count) == nil then
				count = 0
			end
			self:setNum(tonumber(sid),count,true)
        end
    end

    local realcount = 0
	for i=1,dd.soliders:rowCount() do
		if dd.soliders:getLong(i,"count") > 0 then
			if (self._type ~= 4 and self._type ~= 24 ) or dd.cfgSoldier[dd.soliders:getLong(i,"soldierid")]['type'] ~= 21 then
				realcount = 1
				break
			end
		end	
	end


	if realcount == 0 then
		self:getChildByName("mainArea"):getChildByName("nomsg"):setVisible(true)
		self:getChildByName("mainArea"):getChildByName("listcontain"):setVisible(false)
		self:getChildByName("mainArea"):getChildByName("bar01"):setVisible(false)
		self:getChildByName("contain"):setVisible(false)
	else

		self:getChildByName("mainArea"):getChildByName("nomsg"):setVisible(false)
		self:getChildByName("mainArea"):getChildByName("listcontain"):setVisible(true)
		self:getChildByName("mainArea"):getChildByName("bar01"):setVisible(true)
		self:getChildByName("contain"):setVisible(true)
		local lists = self:getChildByName("mainArea"):getChildByName("listcontain")
		local rcount = lists:getChildrenCount()
		
		local scount = 0
		for i=1,dd.soliders:rowCount() do
			if dd.soliders:getLong(i,"count") > 0 then
				if (self._type ~= 4 and self._type ~= 24) or dd.cfgSoldier[dd.soliders:getLong(i,"soldierid")]['type'] ~= 21 then
					scount = scount + 1
				end
			end	
		end

		for sid,item in ipairs(lists:getChildren()) do
			lists:removeChild(item,true)
		end
		local index = 0
		if self._type <= 3 or self._type == 5 or self._type == 21 or self._type == 22 or self._type == 23 or self._type == 88 then
			if dd.myAlchemist ~= nil then
				index = index +1
				local lianjin = lists:getChildByTag(9999)
				if lianjin == nil then
					 lianjin = self:getChildByName("mainArea"):getChildByName("lianjin"):clone()
					lianjin:getChildByName("face"):getChildByName("icon"):loadTexture("images/effect/Alchemist/ico.png",0)
					lianjin:setVisible(true)
					lianjin:setTag(9999)
					lists:addChild(lianjin)
					lianjin:getChildByName("Check"):addTouchEventListener(onCheck)
				end
				lianjin:getChildByName("name"):setString(ff.langString("炼金术士").."  LV."..dd.myAlchemist:getLong(1,"level"))
				local haogandu = dd.myAlchemist:getLong(1,"love") - math.floor((dd.getServerTime() - dd.myAlchemist:getLong(1,"loveTime"))/1000)
                if haogandu < 0 then
                    haogandu = 0
                end
				local string = ff.langString("好感度")..":  "..haogandu.."/1000"
				lianjin:getChildByName("face"):getChildByName("back"):setVisible(false)
				lianjin:getChildByName("Check"):setTouchEnabled(true)
				lianjin:getChildByName("Check"):setSelectedState(false)
				
				if haogandu < 100 then
					lianjin:getChildByName("face"):getChildByName("back"):setVisible(true)
					string = ff.langString("好感度")..":  "..haogandu.."/1000".."("..ff.langString("炼金术士好感度过低")..")"
					lianjin:getChildByName("Check"):setTouchEnabled(false)
				end
				if dd.myAlchemist:getLong(1,"state") == 1 then
					lianjin:getChildByName("face"):getChildByName("back"):setVisible(true)
					lianjin:getChildByName("Check"):setTouchEnabled(false)
					string = ff.langString("好感度")..":  "..haogandu.."/1000".."("..ff.langString("炼金术士正在出征")..")"
				end
				lianjin:getChildByName("level"):setString(string)
			else
				local lianjin = lists:getChildByTag(9999)
				if lianjin ~= nil then
					lists:removeChild(lianjin,true)
				end
			end
		else
			local lianjin = lists:getChildByTag(9999)
			if lianjin ~= nil then
				lists:removeChild(lianjin,true)
			end
		end

		if rcount < scount then
			for i=1,(scount - rcount) do
				local item = self:getChildByName("mainArea"):getChildByName("listitem"):clone()
				item:getChildByName("panel"):getChildByName("slider"):setCorrect(30,352)
				item:setVisible(true)
				lists:addChild(item)

		        local slider=item:getChildByName("panel"):getChildByName("slider")
		        slider:addEventListener(sliderEvent)

		        local size=item:getChildByName("textpanel"):getContentSize()
		        local pos=cc.p(0,0)
		        --输入框 textpanel
		        local editBox = dd.addEditBox(
		             item:getChildByName("textpanel")
		            , size
		            , "images/ui/alpha.png"
		            , 200000
		            , cc.p(0,0)
		            , pos
		            , cc.c3b(161,175,175)
		            , 20
		            , 2
		            , 4
		            , 1
		            , 5
		            , true
		            , true
		            , true
		        )
		        editBox:setName("editbox")
		        editBox:registerScriptEditBoxHandler(editBoxTextEventHandle)
			end
			lists:refreshView()
		end
		
		for i=1,dd.soliders:rowCount() do
			if dd.soliders:getLong(i,"count") > 0 then
				if (self._type ~= 4 and self._type ~= 24) or dd.cfgSoldier[dd.soliders:getLong(i,"soldierid")]['type'] ~= 21 then
					local item = lists:getItem(index)
					if item and item:getTag() ~= 9999 then
						index = index + 1

						local sid = dd.soliders:getLong(i,"soldierid")
						item:setTag(sid)
						local slider=item:getChildByName("panel"):getChildByName("slider")
						slider:setTag(sid)
						slider:setPercent(0)

						local editBox = item:getChildByName("textpanel"):getChildByTag(200000)
						editBox:setText("0")
						editBox:setName(sid)
						item:getChildByName("face"):getChildByName("icon"):loadTexture(dd.getArmyIcon(sid),0)
						item:getChildByName("name"):setString(ff.langString(dd.cfgSoldier[sid]['soldierName']).."  0/"..dd.soliders:getLong(i,"count"))
						local str = ""
						for j=1,dd.cfgSoldier[sid]['step'] do
							str = str.."0"
						end
						item:getChildByName("star"):setString(str)
						item:getChildByName("count"):setString(dd.showKM(dd.soliders:getLong(i,"count"),5))
					end
				end
			end
		end
	end	
end

function chuZhen.updateGold()
	local widget = pop.getDialog("chuzhen")
    if widget ~= nil then
		widget:getChildByName("topArea"):getChildByName("nums"):setString(dd.gold())
		widget:getChildByName("topArea"):requestDoLayout()
        local w = widget:getChildByName("topArea"):getChildByName("nums"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("topArea"):requestDoLayout()
    end
end

function chuZhen.openBuffer(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  
        local widget=pop.getDialog("chuzhen")
        dd.currentLayer._widget:onShowMulTools(8,0,nil,true)
    end
end
--按钮
function chuZhen.onBest(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  
    	local tag = sender:getTag()
        local widget=pop.getDialog("chuzhen")
        widget:autoHero()
        widget:autoSoliders(tag)
    end
end
function chuZhen:autoSoliders(tag)
	cclog("tag:"..tag)
	local armys = nil
	if tag == 1 then
		armys = ff.dbmanager:sql_fetch_rows("select `soldierid`,`collectorder` from cfg_soldier order by `count` desc")
	elseif tag == 2 then		
		armys = ff.dbmanager:sql_fetch_rows("select `soldierid`,`greedyorder` from cfg_soldier order by `greedyorder` desc")
	elseif tag == 3 then		
		armys = ff.dbmanager:sql_fetch_rows("select `soldierid`,`fightorder` from cfg_soldier order by `fightorder` desc")
	end
	self._soliders = {}
	if armys ~= nil then		
		for i=1,dd.soliders:rowCount() do
			if dd.soliders:getLong(i,"count") > 0 then
				self:setNum(dd.soliders:getLong(i,"soldierid"),0,true)
			end
		end

		local count = self._max
		local cary  = 1
		if tag == 1 then
			cary = self._params.cur 
			--cclog("res:"..self._params.res..","..self._params.level..","..dd.cfgWorldRes[self._params.res * 100 + self._params.level]['carry'])
			if self._params ~= nil and self._params.res ~= nil and self._params.res >= 1 and self._params.res <= 6 or self._params.res == 13 then
				cary = cary * dd.cfgWorldRes[self._params.res * 100 + self._params.level]['carry']
			end
			cclog("cary:"..cary..","..self._params.cur)
		end
		for i=1,armys:rowCount() do
			local id = tonumber(armys:getString(i,"soldierid"))
			if (self._type ~= 4 and  self._type ~= 24) or dd.cfgSoldier[id]['type'] ~= 21 then
				for j=1,dd.soliders:rowCount() do
					if id == dd.soliders:getLong(j,"soldierid") then
						if dd.soliders:getLong(j,"count") > 0 then
							if tag == 1 then
								local carycount = 0
								carycount = math.ceil(cary/dd.cfgSoldier[id]['count'])
								cclog("carycount:"..carycount..","..count)
								if dd.soliders:getLong(j,"count") >= carycount then
									if count < carycount then
										self:setNum(id,count,true)
									else
										self:setNum(id,carycount,true)
									end
									cary = 0
									break
								else
									if count < dd.soliders:getLong(j,"count") then
										self:setNum(id,count,true)
										count = 0
									else
										self:setNum(id,dd.soliders:getLong(j,"count"),true)
										count = count - dd.soliders:getLong(j,"count")
										cary = cary - dd.soliders:getLong(j,"count")*dd.cfgSoldier[id]['count']
									end
								end
							else
								if count < dd.soliders:getLong(j,"count") then
									self:setNum(id,count,true)
									count = 0
								else
									self:setNum(id,dd.soliders:getLong(j,"count"),true)
									count = count - dd.soliders:getLong(j,"count")
								end
							end
						end
					end
				end
			end
			if count <= 0 then
				break
			end
			if tag == 1 and cary <= 0 then
				break
			end
		end
		armys:clear()
	end
end
function chuZhen:autoHero()
	if self:getChildByName("herocontain"):getChildByName("face"):isVisible() == true then
		local max = 0
		for i=1,dd.heros:rowCount() do
			if dd.heros:getLong(i,"status") == 0 and dd.heros:getLong(i,"type") == 0 then
				if max == 0 then
					max = i
				else
					if dd.heros:getLong(i,"power") > dd.heros:getLong(max,"power") then
						max = i
					end
				end
			end
		end
		if max > 0 then
	        self._hid = dd.heros:getLong(max,"hid")
    	    self:doSelectHero()
    	end
	end
end
function chuZhen.onPowerful(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  
        local widget=pop.getDialog("chuzhen")
        local tag = sender:getTag()
        --widget:autoHero()
        widget._UsePower = true
        if widget._hid == 0 then
	        widget:BlinkHero(true)
	    end
        if tag == 1 then
        	widget:autoSoliders(1)        
        else
        	widget:autoSoliders(3)        
        end
        --guide auther:lhz
        GuideControl:GuideCheck()
        --guide end
    end
end
function chuZhen:BlinkHero( blink )
	-- body
	if true == blink then
		self:getChildByName("herocontain"):getChildByName("face"):stopAllActions()
        self:getChildByName("herocontain"):getChildByName("face"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        self:getChildByName("herocontain"):getChildByName("addbtn"):stopAllActions()
        self:getChildByName("herocontain"):getChildByName("addbtn"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
		local effect = ff.Effect:effectHighLight()    
        self:getChildByName("herocontain"):getChildByName("face"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        self:getChildByName("herocontain"):getChildByName("addbtn"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
		local function blink(type)
	        if type == true then
	            self:getChildByName("herocontain"):getChildByName("face"):getVirtualRenderer():setGLProgramState(ff.Effect:effectHighLight():getGLProgramState())
	        else
	            self:getChildByName("herocontain"):getChildByName("face"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
	        end
    	end
    	local function blink2(type)
	        if type == true then
	            self:getChildByName("herocontain"):getChildByName("addbtn"):getVirtualRenderer():setGLProgramState(ff.Effect:effectHighLight():getGLProgramState())
	        else
	            self:getChildByName("herocontain"):getChildByName("addbtn"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
	        end
    	end
    	self:getChildByName("herocontain"):getChildByName("face"):runAction(cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(0.5),cc.CallFunc:create(function() blink(false) end),cc.DelayTime:create(0.5),cc.CallFunc:create(function() blink(true) end))))
    	self:getChildByName("herocontain"):getChildByName("addbtn"):runAction(cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(0.5),cc.CallFunc:create(function() blink2(false) end),cc.DelayTime:create(0.5),cc.CallFunc:create(function() blink2(true) end))))
	else
        self:getChildByName("herocontain"):getChildByName("face"):stopAllActions()
        self:getChildByName("herocontain"):getChildByName("face"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        self:getChildByName("herocontain"):getChildByName("addbtn"):stopAllActions()
        self:getChildByName("herocontain"):getChildByName("addbtn"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
	end
end
function chuZhen.onGo(sender,eventType)
    if eventType==ccui.TouchEventType.ended then 
        local widget=pop.getDialog("chuzhen")
        if widget ~= nil then
	        widget:gogogo()
	    end
    end
end
function chuZhen:gogogo()
	local function goBattle()
		if self._type == 5 or self._type == 22 or self._type == 23 then
			local view = self:getChildByName("time")
		    if view:isVisible() == false then
		        view:setPositionY(-view:getContentSize().height)
		        view:setOpacity(100)
		        view:setVisible(true)
		        local action = cc.Spawn:create(
		                    cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,0))),
		                    cc.FadeIn:create(0.5)
		                    )
		        self:selectTime(1)
		        view:runAction(action)
		    end   
		elseif self._type == 88 then 
			if self._callback ~= nil then
				self._callback(self._hid,self._soliders,self._lianjin)
				self._callback = nil
				pop.onClosePopDialog("chuzhen")
			end
	    elseif self._type == 15 then
		    local message = ff.net:createMessage()
		    message:addCmd(0x0000012e)
		    message:addLong(dd.uid)
		    message:addLong(self._params.uid)
		    message:addLong(0)

		    local armys = ff.dbmanager:sql_fetch_rows("select `soldierid` from cfg_soldier where `type` in ('1','2','3','21') and `step`<='6' order by `type` asc,`step` asc")
		    if armys ~= nil then
		    	for i=1,armys:rowCount() do
		    		local sid = tonumber(armys:getString(i,"soldierid"))
		    		if self._soliders[sid] == nil then
		    			message:addLong(0)
		    		else
		    			message:addLong(self._soliders[sid])
					end	
		    	end
		    	--工程车预留2级
		    	message:addLong(0)
		    	message:addLong(0)
		    	--message:addLong(0)
		    	
		    	for i=1,16 do
		    		message:addLong(0)
		    	end
			    ff.net:rpc(message,false)
			    armys:clear()
		    else
		    	message:clear()
		    end
		else
			
		    local message = ff.net:createMessage()
		    message:addCmd(0x0000010f)
		    message:addLong(dd.uid)
		    message:addLong(self._params.cid)
		    if self._type == 21 then
			    message:addLong(2)
			elseif self._type == 22 or self._type == 23 then
				message:addLong(5)
			elseif self._type == 24  then
				message:addLong(4)
			else  
				message:addLong(self._type)
			end
		    message:addLong(0)
		    message:addLong(self._hid)

		    local armys = ff.dbmanager:sql_fetch_rows("select `soldierid` from cfg_soldier where `type` in ('1','2','3','21') and `step`<='6' order by `type` asc,`step` asc")
		    if armys ~= nil then
		    	for i=1,armys:rowCount() do
		    		local sid = tonumber(armys:getString(i,"soldierid"))
		    		if self._soliders[sid] == nil then
		    			message:addLong(0)
		    		else
		    			message:addLong(self._soliders[sid])
					end	
		    	end
		    	--工程车预留3级
		    	message:addLong(0)
		    	message:addLong(0)
		    	--message:addLong(0)
		    	if self._lianjin == true then
		    		message:addLong(1)
		    	else
		    		message:addLong(0)
		    	end
		    	for i=1,15 do
		    		
		    		message:addLong(0)
		    	end
			    ff.net:rpc(message,false)
			    armys:clear()
			    if self._type == 21  or self._type == 22 then
			    	local need = 12

		            if dd.cfgNpc[self._params.npcid] ~= nil then
		                need = dd.cfgNpc[self._params.npcid]['propquantity']
		            end
			    	--cclog("-----------------------------"..self._params.npcid)
			    	
			    	dd.currentLayer._widget:onShowTips("\t"..ff.langString("行动力减{0}",{need}),true)
			    end
		    else
		    	message:clear()
		    end
		end
	end
	local function onSure()
		if self._type == 5 and self._hid <= 0 then
			dd.currentLayer._widget:onShowTips("\t"..ff.langString("联合攻击必须携带英雄"))
			return
		end
		if (self._type == 22 or self._type == 23) and self._hid <= 0 then
			dd.currentLayer._widget:onShowTips("\t"..ff.langString("联合攻击必须携带英雄"))
			return
		end
		if self._type == 5 and self._params.unionid ~= 0 and self._params.level < 9 then
			dd.currentLayer._widget:onShowTips("\t"..ff.langString("联合攻击对方等级必须高于9级"))
			return
		end
		cclog("==="..self._params.unionid.."=="..self._params.level.."=="..self._type)
		if self._type == 5 and self._params.unionid == 0 and self._params.level < 12 then
			dd.currentLayer._widget:onShowTips("\t"..ff.langString("联合攻击对方无联盟是等级必须高于12级"))
			return
		end
		if self._type == 15 or self._type == 4  or self._type == 24 or self._type == 12 then
			if self._hid > 0 then
				dd.currentLayer._widget:onShowTips("\t"..ff.langString("不能携带英雄"))
				return
			end
		end
		
        local message = ff.net:createMessage()
        message:addCmd(0x00000126)
        message:addLong(dd.uid)
        if dd.myinfo:getLong(1,"state") == 1 then
	        message:addLong(101)
	    else    
	    	message:addLong(102)
	    end	
        ff.net:rpc(message,false)
        goBattle()
	end
	if self._type == 11 then
	else
		local count = 0
		for k,v in pairs(self._soliders) do
			count = count + v
		end
		if count <= 0 then
			dd.currentLayer._widget:onShowTips("\t"..ff.langString("请选派士兵"))
			return
		end
		local maxTroops = 0
		for i=1,dd.myTroops:rowCount() do
			if dd.myTroops:getLong(i,"type") ~= 13 then
				maxTroops = maxTroops + 1 
			end
		end
		for i=1,dd.myeffect:rowCount() do
			if dd.myeffect:getLong(i,"id") == 2 then
				if maxTroops >= dd.myeffect:getLong(i,"param") then
					dd.currentLayer._widget:onShowTips("\t"..ff.langString("出战队列已满，您无法排遣更多部队。"))
					return
				end
			end
		end
		--对方保护状况
        if self._params.protect == 1 and self._type ~= 4 and self._type ~= 24 then
			if self._type == 2 or self._type == 5 then
				dd.currentLayer._widget:onShowTips("\t"..ff.langString("对方处于保护中，无法被攻击。"))
			else	
				dd.currentLayer._widget:onShowTips("\t"..ff.langString("对方处于保护中，无法被侦查。"))
			end	
			return
		end
		--自己保护状况
		cclog("========================"..self._type)
		if self._params.uid > 0 and self._type ~= 11 and self._type ~= 21 and self._type ~= 22  and self._type ~= 23  then
			--首先判读是否是保护
			if dd.myinfo:getLong(1,"state") == 1 then
				dd.currentLayer._widget:onShowSure(ff.langString("解除保护"),ff.langString("您目前处于保护状态,无法出兵.\n是否解除保护?"),onSure,true,2)
				return
			else				
				for i=1,dd.myplus:rowCount() do
					if dd.myplus:getLong(i,"id") == 531 then
						dd.currentLayer._widget:onShowSure(ff.langString("解除保护"),ff.langString("您目前处于保护状态,无法出兵.\n是否解除保护?"),onSure,true,2)
						return
					end
				end
			end	
		end	
		if self._type == 5 and self._hid <= 0 then
			dd.currentLayer._widget:onShowTips("\t"..ff.langString("联合攻击必须携带英雄"))
			return
		end
		if (self._type == 22 or  self._type == 23) and self._hid <= 0 then
			dd.currentLayer._widget:onShowTips("\t"..ff.langString("联合攻击必须携带英雄"))
			return
		end
		if self._type == 5 and self._params.unionid ~= 0 and self._params.level < 9 then
			dd.currentLayer._widget:onShowTips("\t"..ff.langString("联合攻击对方等级必须高于9级"))
			return
		end
		cclog("==="..self._params.unionid.."=="..self._params.level.."=="..self._type)
		if self._type == 5 and self._params.unionid == 0 and self._params.level < 12 then
			dd.currentLayer._widget:onShowTips("\t"..ff.langString("联合攻击对方无联盟是等级必须高于12级"))
			return
		end
		if self._type == 15 or self._type == 4 or self._type == 24 or  self._type == 12  then
			if self._hid > 0 then
				dd.currentLayer._widget:onShowTips("\t"..ff.langString("不能携带英雄"))
				return
			end
		end
		--cclog("-----------------------------"..self._params['npctype'])
		if self._params['npctype'] ~= 99 then
			if self._type == 2 and self._params.level < 6 then
				dd.currentLayer._widget:onShowSure(ff.langString("警告"),ff.langString("攻击6级以下玩家不会获得资源，是否仍要攻击？"),goBattle,true,2)
				return
			end
		end
	end
	goBattle()
end
function chuZhen.onSelect(sender,eventType)
	if eventType==ccui.TouchEventType.ended then  
		local widget = pop.getDialog("chuzhen")
		widget:selectTime(0)
	end
end
function chuZhen.onCancel(sender,eventType)
	if eventType==ccui.TouchEventType.ended then  
		local widget = pop.getDialog("chuzhen")
        local function unShow()
            if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
                local view = widget:getChildByName("time")
                view:setVisible(false)
            end    
        end    
        local view = widget:getChildByName("time")
        view:runAction(cc.Sequence:create(cc.MoveTo:create(0.5, cc.p(0,-view:getContentSize().height)),cc.CallFunc:create(unShow)))
	end
end
function chuZhen.onSure(sender,eventType)
	if eventType==ccui.TouchEventType.ended then  
		local widget = pop.getDialog("chuzhen")
	    local message = ff.net:createMessage()
	    message:addCmd(0x0000012c)
	    message:addLong(dd.uid)
	    message:addLong(widget._params.cid)
	    if widget:getChildByName("time"):getChildByName("item5"):getChildByName("time"):getSelectedState() == true then
	    	message:addLong(300)
		elseif widget:getChildByName("time"):getChildByName("item10"):getChildByName("time"):getSelectedState() == true then	    	
			message:addLong(600)
		else			
			message:addLong(3600)
		end
	    message:addLong(widget._hid)

	    local armys = ff.dbmanager:sql_fetch_rows("select `soldierid` from cfg_soldier where `type` in ('1','2','3','21') and `step`<='6' order by `type` asc,`step` asc")
	    if armys ~= nil then
	    	for i=1,armys:rowCount() do
	    		local sid = tonumber(armys:getString(i,"soldierid"))
	    		if widget._soliders[sid] == nil then
	    			message:addLong(0)
	    		else
	    			message:addLong(widget._soliders[sid])
				end	
	    	end
	    	--工程车预留3级
	    	message:addLong(0)
	    	message:addLong(0)
	    	--message:addLong(0)
	    	if widget._lianjin == true then
	    		message:addLong(1)
	    	else
	    		message:addLong(0)
	    	end
	    	for i=1,15 do
	    		message:addLong(0)
	    	end
		    ff.net:rpc(message,false)
		    armys:clear()
		    if widget._type == 21  or widget._type == 22 then
		    	local need = 12

	            if dd.cfgNpc[widget._params.npcid] ~= nil then
	                need = dd.cfgNpc[widget._params.npcid]['propquantity']
	            end
		    	--cclog("-----------------------------"..self._params.npcid)
		    	
		    	dd.currentLayer._widget:onShowTips("\t"..ff.langString("行动力减{0}",{need}),true)
		    end
	    else
	    	message:clear()
	    end
	end
end
function chuZhen:selectTime(tag)
	local time = self:getChildByName("time")
	time:getChildByName("item5"):getChildByName("time"):setSelectedState(false)
	time:getChildByName("item10"):getChildByName("time"):setSelectedState(false)
	time:getChildByName("item60"):getChildByName("time"):setSelectedState(false)
	if tag == 1 then
		time:getChildByName("item5"):getChildByName("time"):setSelectedState(true)
	elseif tag == 2 then
		time:getChildByName("item10"):getChildByName("time"):setSelectedState(true)
	elseif tag == 3 then	
		time:getChildByName("item60"):getChildByName("time"):setSelectedState(true)
	end
end 
function chuZhen.onExpedition(params)
	--print("onExpedition...........")
	local code = params[1]
	if code == 0 then
		local type = params[2]
		--print("type====",type)
		if type == 5 then
			--呼叫出征管理界面
			local widget=pop.getDialog("chuzhen")
			if widget._type~=15 and widget._type~=4 and widget._type ~= 24  and widget._type~=12 then--15是从战争会所中打开出征
				pop.onShowPopDialog("warhouseinfo",dd.uid,1,widget._params.name,widget._params.short)
			end
		end
		pop.onClosePopDialog("chuzhen")
		if dd.cityLayer ~= nil then
			dd.cityLayer:updateCityArmys()
		end
    	AudioEngine.playEffect(ff.sounds[411])
        local auto =  math.floor(math.random() * 1000000)%2
        if auto == 0 then
            AudioEngine.playEffect(ff.sounds["p004"])
        else
            AudioEngine.playEffect(ff.sounds["p005"])
        end		
	else
		dd.mainUI:onShowCodeTips(code)
	end
end
function chuZhen.onchulimit(params)
	local widget = pop.getDialog('chuzhen')	
	if widget ~= nil then
		if params[1] == 0 then
			cclog(params[2].maxBing.."=="..params[2].nowBing)
			widget._params['maxarmys'] = (params[2].maxBing - params[2].nowBing)
			local plus_1 = 0
			local plus_551 = 0

			local plus_392 = 0
			local plus_401 = 0
			local plus_402 = 0
			local plus_406 = 0
			local plus_393 = 0

			for i=1,dd.myeffect:rowCount() do
				if dd.myeffect:getLong(i,"id") == 1 then
					plus_1 = dd.myeffect:getLong(i,"param")
				end	
				if dd.myeffect:getLong(i,"id") == 551 then
					plus_551 = dd.myeffect:getLong(i,"param")
				end
				if dd.myeffect:getLong(i,"id") == 392 then
					plus_392 = dd.myeffect:getLong(i,"param")
				end
				if dd.myeffect:getLong(i,"id") == 401 then
					plus_401 = dd.myeffect:getLong(i,"param")
				end
				if dd.myeffect:getLong(i,"id") == 402 then
					plus_402 = dd.myeffect:getLong(i,"param")
				end
				if dd.myeffect:getLong(i,"id") == 406 then
					plus_406 = dd.myeffect:getLong(i,"param")
				end
				if dd.myeffect:getLong(i,"id") == 393 then
					plus_393 = dd.myeffect:getLong(i,"param")
				end				
			end
			if dd.myAlchemist ~= nil and widget._lianjin == true then
				if dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")] ~= nil then
					for i=1,3 do
						if dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."id"] == 551 then
							plus_551 = plus_551 + dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."num"]
						end
						if dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."id"] == 392 then
							plus_392 = plus_392 + dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."num"]
						end
					end
				end
			end
			--单次可出兵数量上限=plus_1*(1+plus_551/1000)
			widget._max = math.floor(plus_1 * (1 + plus_551/1000))
			if (widget._type == 5 or widget._type == 15 or widget._type == 12 or widget._type == 4 or widget._type == 24 or widget._type == 22 or widget._type == 23) and widget._params['maxarmys'] ~= nil then
				if widget._max > widget._params['maxarmys'] then
					widget._max = widget._params['maxarmys']
				end
			end

			--当前兵力，和当前负载
			local total = 0
			local speed = 0
			for id,temp in pairs(widget._soliders) do
				total = total + temp
			end	

			if total > widget._max then
				widget:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info1"):setColor(cc.c3b(255,0,0))	
			else
				widget:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info1"):setColor(cc.c3b(161,175,175))	
			end
			widget:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info1"):setString(ff.langString("部队")..":"..dd.showKM((total),5).."/"..dd.showKM(widget._max,5))
			widget:getChildByName("herocontain"):requestDoLayout()
		else
			widget:getChildByName("contain"):getChildByName("btn3"):setBright(false)
			widget:getChildByName("contain"):getChildByName("btn3"):setTouchEnabled(false)
		end
	end
end
function chuZhen.onChuZhenLimit(params)
	local widget = pop.getDialog('chuzhen')	
	if widget ~= nil then
		if params[1] == 0 then
			if widget._params.uid == params[2] then				
				widget._params['maxarmys'] = params[3]
				local plus_1 = 0
				local plus_551 = 0

				local plus_392 = 0
				local plus_401 = 0
				local plus_402 = 0
				local plus_406 = 0
				local plus_393 = 0

				for i=1,dd.myeffect:rowCount() do
					if dd.myeffect:getLong(i,"id") == 1 then
						plus_1 = dd.myeffect:getLong(i,"param")
					end	
					if dd.myeffect:getLong(i,"id") == 551 then
						plus_551 = dd.myeffect:getLong(i,"param")
					end
					if dd.myeffect:getLong(i,"id") == 392 then
						plus_392 = dd.myeffect:getLong(i,"param")
					end
					if dd.myeffect:getLong(i,"id") == 401 then
						plus_401 = dd.myeffect:getLong(i,"param")
					end
					if dd.myeffect:getLong(i,"id") == 402 then
						plus_402 = dd.myeffect:getLong(i,"param")
					end
					if dd.myeffect:getLong(i,"id") == 406 then
						plus_406 = dd.myeffect:getLong(i,"param")
					end
					if dd.myeffect:getLong(i,"id") == 393 then
						plus_393 = dd.myeffect:getLong(i,"param")
					end				
				end
				if dd.myAlchemist ~= nil and widget._lianjin == true then
					if dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")] ~= nil then
						for i=1,3 do
							if dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."id"] == 551 then
								plus_551 = plus_551 + dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."num"]
							end
							if dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."id"] == 392 then
								plus_392 = plus_392 + dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."num"]
							end
						end
					end
				end
				--单次可出兵数量上限=plus_1*(1+plus_551/1000)
				widget._max = math.floor(plus_1 * (1 + plus_551/1000))
				if (widget._type == 5 or widget._type == 15 or widget._type == 12 or widget._type == 4 or widget._type == 24 or widget._type == 22 or widget._type == 23) and widget._params['maxarmys'] ~= nil then
					if widget._max > widget._params['maxarmys'] then
						widget._max = widget._params['maxarmys']
					end
				end
				--当前兵力，和当前负载
				local total = 0
				local speed = 0
				for id,temp in pairs(widget._soliders) do
					total = total + temp
				end	

				if total > widget._max then
					widget:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info1"):setColor(cc.c3b(255,0,0))	
				else
					widget:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info1"):setColor(cc.c3b(161,175,175))	
				end
				widget:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info1"):setString(ff.langString("部队")..":"..dd.showKM((total),5).."/"..dd.showKM(widget._max,5))
				widget:getChildByName("herocontain"):requestDoLayout()

				if params[3] == 0 then
					widget:getChildByName("contain"):getChildByName("btn3"):setBright(false)
					widget:getChildByName("contain"):getChildByName("btn3"):setTouchEnabled(false)
					dd.currentLayer._widget:onShowTips("\t"..ff.langString("对方尚未建造")..ff.langString(dd.cfgBuilding[14]['name']))
				end
			end
		else
			widget:getChildByName("contain"):getChildByName("btn3"):setBright(false)
			widget:getChildByName("contain"):getChildByName("btn3"):setTouchEnabled(false)
			dd.mainUI:onShowCodeTips(params[1])
		end
	end
end
--关闭
function chuZhen.onReturn(sender,eventType)
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
    
    	local widget = pop.getDialog("chuzhen")
    	if widget ~= nil then
	    	widget:onClose()
	    end
    end
end

function chuZhen:onClose()
	local view = dd.currentLayer._widget:getChildByName("multools")
	if view:isVisible() == true then
		dd.currentLayer._widget:closeMulTools()
		return true
	else	
		if self:getChildByName("herolist"):isVisible() == true then
			self:getChildByName("herolist"):setVisible(false)
			return true
		end
        pop.onClosePopDialog("chuzhen")
    end
    return false
end

function chuZhen.onBefore(sender)
	sender:getChildByName("contain"):getChildByName("btn3"):setBright(true)
	sender:getChildByName("contain"):getChildByName("btn3"):setTouchEnabled(true)
	if sender._type == 4 then
        local message = ff.net:createMessage()
        message:addCmd(0x0000004e)
        message:addLong(dd.uid)
        message:addLong(sender._params.uid)
        ff.net:rpc(message,false)	
	end
	if sender._type == 24 then
        local message = ff.net:createMessage()
        message:addCmd(0x00000061)
        message:addLong(dd.uid)
        message:addLong(sender._params.uid)
        ff.net:rpc(message,false)	
	end
end
--guide auther:lhz
function chuZhen.onStart(sender)
	dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("icon"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    GuideControl:GuideCheck()
end
--guide end
function chuZhen:onPropUse(params)
	local code = params[1]
	if code == 0 then
		local tid = params[2]
		if dd.cfgProp[tid] ~= nil and dd.cfgProp[tid]['showtype'] == 8 then
			dd.mainUI:onShowTips("\t"..ff.langString("部队上限提高了"),false)
			--单次可出兵数量上限=plus_1*(1+plus_551/1000)
			local plus_1 = 0
			local plus_551 = 0

			local plus_392 = 0
			local plus_401 = 0
			local plus_402 = 0
			local plus_406 = 0
			local plus_393 = 0

			for i=1,dd.myeffect:rowCount() do
				if dd.myeffect:getLong(i,"id") == 1 then
					plus_1 = dd.myeffect:getLong(i,"param")
				end	
				if dd.myeffect:getLong(i,"id") == 551 then
					plus_551 = dd.myeffect:getLong(i,"param")
				end
				if dd.myeffect:getLong(i,"id") == 392 then
					plus_392 = dd.myeffect:getLong(i,"param")
				end
				if dd.myeffect:getLong(i,"id") == 401 then
					plus_401 = dd.myeffect:getLong(i,"param")
				end
				if dd.myeffect:getLong(i,"id") == 402 then
					plus_402 = dd.myeffect:getLong(i,"param")
				end
				if dd.myeffect:getLong(i,"id") == 406 then
					plus_406 = dd.myeffect:getLong(i,"param")
				end
				if dd.myeffect:getLong(i,"id") == 393 then
					plus_393 = dd.myeffect:getLong(i,"param")
				end				
			end

			if self._hid > 0 then
				plus_1 = plus_1 + dd.getHeroPlus(1,self._hid)
				plus_551 = plus_551 + dd.getHeroPlus(551,self._hid)
				plus_392 = plus_392 + dd.getHeroPlus(392,self._hid)
				plus_401 = plus_401 + dd.getHeroPlus(401,self._hid)
				plus_402 = plus_402 + dd.getHeroPlus(402,self._hid)
				plus_406 = plus_406 + dd.getHeroPlus(406,self._hid)
				plus_393 = plus_393 + dd.getHeroPlus(393,self._hid)
			end
			if dd.myAlchemist ~= nil and self._lianjin == true then
				if dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")] ~= nil then
					for i=1,3 do
						if dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."id"] == 551 then
							plus_551 = plus_551 + dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."num"]
						end
						if dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."id"] == 392 then
							plus_392 = plus_392 + dd.Cfg_Alchemist_Lv[dd.myAlchemist:getLong(1,"level")]["buff"..i.."num"]
						end
					end
				end
			end
			--单次可出兵数量上限=plus_1*(1+plus_551/1000)
			self._max = math.floor(plus_1 * (1 + plus_551/1000))
			if (self._type == 5 or self._type == 15 or self._type == 12 or self._type == 4 or self._type == 24 or self._type == 22 or self._type == 23) and self._params['maxarmys'] ~= nil then
				cclog("maxarmys:"..self._params['maxarmys'])
				if self._max > self._params['maxarmys'] then
					self._max = self._params['maxarmys']
				end
			end
			--当前兵力，和当前负载
			local total = 0
			local bags = 0
			local speed = 0
			for id,temp in pairs(self._soliders) do
				total = total + temp
				bags = bags + dd.cfgSoldier[id]['count'] * temp
			end	

			if total > self._max then
				self:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info1"):setColor(cc.c3b(255,0,0))	
			else
				self:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info1"):setColor(cc.c3b(161,175,175))	
			end
			self:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info1"):setString(ff.langString("部队")..":"..dd.showKM((total),5).."/"..dd.showKM(self._max,5))
			
			--负载
			--向下取整 携带量  兵种表基础携带量*(1+plus_406/1000+plus_393/1000)
			bags = math.floor(bags * (1 + plus_406/1000 + plus_393/1000))
			if self._params ~= nil and self._params.res ~= nil and self._params.res >= 1 and self._params.res <= 6 then
				bags = math.floor(bags/dd.cfgWorldRes[self._params.res * 100 + self._params.level]['carry'])
			end
			self:getChildByName("mainArea"):getChildByName("bar01"):getChildByName("info2"):setString(ff.langString("负载")..":"..dd.showKM(bags,5))
		end
	end
end

function chuZhen.onEnd(sender)
	ff.net:removeEvent(102,dd.Tjf_Troops_Expedition)
	ff.net:removeEvent(102,dd.Tjf_Troops_AllyWarCreate)
	ff.net:removeEvent(102,dd.Tjf_Troops_AllyWarJoin)
	ff.net:removeEvent(102,dd.Tjf_prop_use)
	ff.net:removeEvent(102,dd.Tjf_chuzheng_limit)
	ff.net:removeEvent(102,dd.Tjg_GetLCStrongholdG2Detail)
	dd.delBackEvent()
	sender._callback = nil
	ff.net:unbindProperty("gold",2001)
	if ff.platform ~= 1 then
		for sid,item in ipairs(sender:getChildByName("mainArea"):getChildByName("listcontain"):getChildren()) do
			item:getChildByName("face"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
			sender:getChildByName("mainArea"):getChildByName("listcontain"):removeChild(item,true)
		end	
		sender:getChildByName("image"):getChildByName("image"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
	end
	sender._UsePower = false
	sender:BlinkHero(false)

end

--type 1  采集  4 增援
function onShowWarChuZhen(widget,type,params,CallFunc)
	if params == nil then
		params = {}
		params.cid = 1
		params.uid = 10001
		params.unionid = 1
		params.short ="fbi"
		params.ulevel="6"
		params.name = "fatality"
		params.level= 10
		params.count=9999
		params.res  = 1
		params.friend=4
		params.protect=0
	end

	local layer = chuZhen.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
	layer._type = tonumber(type)
	if CallFunc ~= nil then
		layer._callback = CallFunc
	end
    layer:init(params)
	return layer
end