--gatherd 集结地
local gatherdLayer = class("gatherd")
gatherdLayer._name = "gatherd"
gatherdLayer._init = false
gatherdLayer._armys = {}
gatherdLayer._walls = {}
gatherdLayer._hurts = {}
gatherdLayer._type  = 1
gatherdLayer._sliderMax = 0
gatherdLayer._soliderid  = 0   --id
gatherdLayer._solidernum = 0   --要解散的数量
gatherdLayer._datas = {}
gatherdLayer._hurtdatas = {}
gatherdLayer._plus      = 0

function gatherdLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, gatherdLayer)
    return target
end

function gatherdLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("bg"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("bg"):setPositionY(0)
        self:getChildByName("masking"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("masking"):setPositionY(0)
        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("list"):setContentSize(cc.size(720,hh-105-5))
        
        self:getChildByName("besure"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("besure"):setPositionY(0)
    end
end

function gatherdLayer:onInit()
    if self._init == false then        
        self:getChildByName("list"):getChildByName("trooptitle"):getChildByName("helpbtn"):setVisible(false)
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)

        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3) 

        --pop
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("close"):addTouchEventListener(self.closePop)
        self:getChildByName("item"):addTouchEventListener(self.openPop)
        self:getChildByName("item2"):addTouchEventListener(self.openPop)
        self:initPop()
        self._init = true
    end
    self.updateGold()
    self:updatesPos()
    self:updateTop()
    self._plus = 0
    for var=1, dd.myeffect:rowCount() do
        if dd.myeffect:getLong(var,'id') == 541 then
            self._plus = dd.myeffect:getLong(var,'param')
            self._plus = self._plus/1000
            break
        end
    end
    cclog("self._plus == "..self._plus)
end

function gatherdLayer.updateGold()
    local widget = pop.getDialog("gatherd")
    widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
    widget:getChildByName("topArea"):requestDoLayout()

    local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
    w = 720 - (w + 94 + 75 + 104)
    widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
    widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
end

function gatherdLayer:updates()
    local params = self:updatesPos()
    local troophh = params[1]
    local wallshh = params[2]
    local hurtshh = params[3]
    self:updateTop()
    self:updateArmysList(troophh)
    self:updateWallsList(wallshh)
    self:updateHurtsList(hurtshh)
end

function gatherdLayer:updatesPos()
    local hh = self:getChildByName("list"):getContentSize().height
    local ihh = 0
    --部队list
    local nums = 0
    local troophh = 0
    local troop_add = 0
    --记录要显示的
    self._datas = {}
    for sid,army in pairs(dd.cfgSoldier) do
        local count = self:getBusyArmys(sid) + self:getFreeArmys(sid)
        if count > 0 then
            nums = nums + 1
            self._datas[table.getn(self._datas) + 1] = sid
        end
    end
    --按星级排序
    table.sort(self._datas,function(v1,v2) return dd.cfgSoldier[v1]['step'] > dd.cfgSoldier[v2]['step'] end)
    troophh = nums*145

    --城防list
    local wallshh  = 0
    local wallnums = 0
    local wall_add = 0
    for i=1,dd.myWall:rowCount() do
        if dd.myWall:getLong(i,"count") > 0 then
            wallnums = wallnums + 1
        end
    end
    wallshh = wallnums * 145

    --伤兵list
    local hurtshh  = 0
    local hurtnums = 0
    local hurt_add = 0
    self._hurtdatas = {}
    for i=1,dd.soliders:rowCount() do
        if dd.soliders:getLong(i,"hurtcount") > 0 then
            hurtnums = hurtnums + 1
            self._hurtdatas[table.getn(self._hurtdatas) + 1] = dd.soliders:getLong(i,"soldierid")
        end
    end 
    table.sort(self._hurtdatas,function(v1,v2) return dd.cfgSoldier[v1]['step'] > dd.cfgSoldier[v2]['step'] end)
    hurtshh = hurtnums * 145
    
    if nums > 0 then
        self:getChildByName("list"):getChildByName("trooptitle"):setVisible(true)
        troop_add = 55
    else
        self:getChildByName("list"):getChildByName("trooptitle"):setVisible(false)
    end

    if wallnums > 0 then
        self:getChildByName("list"):getChildByName("walltitle"):setVisible(true)
        wall_add = 55
    else
        self:getChildByName("list"):getChildByName("walltitle"):setVisible(false)
    end

    if hurtnums > 0 then
        self:getChildByName("list"):getChildByName("hurtstitle"):setVisible(true)
        hurt_add = 55
    else
        self:getChildByName("list"):getChildByName("hurtstitle"):setVisible(false)
    end

    ihh = troophh + wallshh + hurtshh + 270 + troop_add + wall_add + hurt_add
    if ihh < hh then
        ihh = hh
    end

    if nums == 0 and wallnums == 0 and hurtnums == 0 then
        self:getChildByName("list"):getChildByName("warning"):setVisible(true)
        self:getChildByName("list"):getChildByName("warning"):setPositionY(ihh - 270 - 200)
    else
        self:getChildByName("list"):getChildByName("warning"):setVisible(false)
    end

    self:getChildByName("list"):setInnerContainerSize(cc.size(720,ihh))
    
    self:getChildByName("list"):getChildByName("topbox"):setPositionY(ihh - 270)

    self:getChildByName("list"):getChildByName("trooptitle"):setPositionY(ihh - 270 - troop_add)    
    self:getChildByName("list"):getChildByName("trooplist"):setContentSize(cc.size(720, troophh))
    self:getChildByName("list"):getChildByName("trooplist"):setPositionY(ihh - 270 - troop_add - troophh)

    self:getChildByName("list"):getChildByName("walltitle"):setPositionY(ihh - 270 - troop_add - wall_add- troophh)
    self:getChildByName("list"):getChildByName("walllist"):setContentSize(cc.size(720, wallshh))
    self:getChildByName("list"):getChildByName("walllist"):setPositionY(ihh - 270 - troop_add - wall_add - troophh - wallshh)

    self:getChildByName("list"):getChildByName("hurtstitle"):setPositionY(ihh - 270 - troop_add - wall_add - hurt_add - troophh - wallshh)
    self:getChildByName("list"):getChildByName("hurtslist"):setContentSize(cc.size(720, hurtshh))
    self:getChildByName("list"):getChildByName("hurtslist"):setPositionY(ihh - 270 - troop_add - wall_add - hurt_add - troophh - wallshh - hurtshh)

    return {troophh,wallshh,hurtshh}
end


function gatherdLayer:updateTop()
    local count = 10
    for i=1,dd.myeffect:rowCount() do
        if dd.myeffect:getLong(i,"id") == 14 then
            count = count + dd.myeffect:getLong(i,"param")
            break
        end
    end

    local armys = 0
    local troops = dd.myTroops:rowCount()
    local npcCount = 0
    local npcDeq = 0
    local keepfood = dd.myResOut:getLong(1,"keepfood")
    local walls = 0
    local walls_max = 0
    local hurts = 0
    local hospital_max = 0
    --部队总数
    for i=1,dd.soliders:rowCount() do
        armys = armys + dd.soliders:getLong(i,"count")
    end
    for j=1,dd.myTroops:rowCount() do
        armys = armys + dd.myTroops:getLong(j,"b1")
        armys = armys + dd.myTroops:getLong(j,"b2")
        armys = armys + dd.myTroops:getLong(j,"b3")
        armys = armys + dd.myTroops:getLong(j,"b4")
        armys = armys + dd.myTroops:getLong(j,"b5")
        armys = armys + dd.myTroops:getLong(j,"b6")

        armys = armys + dd.myTroops:getLong(j,"q1")
        armys = armys + dd.myTroops:getLong(j,"q2")
        armys = armys + dd.myTroops:getLong(j,"q3")
        armys = armys + dd.myTroops:getLong(j,"q4")
        armys = armys + dd.myTroops:getLong(j,"q5")
        armys = armys + dd.myTroops:getLong(j,"q6")

        armys = armys + dd.myTroops:getLong(j,"g1")
        armys = armys + dd.myTroops:getLong(j,"g2")
        armys = armys + dd.myTroops:getLong(j,"g3")
        armys = armys + dd.myTroops:getLong(j,"g4")
        armys = armys + dd.myTroops:getLong(j,"g5")
        armys = armys + dd.myTroops:getLong(j,"g6")

        armys = armys + dd.myTroops:getLong(j,"w1")
        armys = armys + dd.myTroops:getLong(j,"w2")
        armys = armys + dd.myTroops:getLong(j,"w3")
        armys = armys + dd.myTroops:getLong(j,"w4")
        armys = armys + dd.myTroops:getLong(j,"w5")
        armys = armys + dd.myTroops:getLong(j,"w6")
    end 
    --出兵队列
    for i=1,dd.myeffect:rowCount() do
        if dd.myeffect:getLong(i,"id") == 1 then
            npcCount = dd.myeffect:getLong(i,"param")
        end
        if dd.myeffect:getLong(i,"id") == 2 then
            npcDeq = dd.myeffect:getLong(i,"param")
        end
    end
    --城防数量
    walls_max = 10
    local addlv = 0
    for i=1,dd.myeffect:rowCount() do
        if dd.myeffect:getLong(i,"id") == 15 then
            walls_max = dd.myeffect:getLong(i,"param")
        end
        if dd.myeffect:getLong(i,"id") == 231 then
            addlv = dd.myeffect:getLong(i,"param")
        end
    end
    walls_max = math.floor(walls_max * (1 + addlv/1000))

    for i=1,dd.myWall:rowCount() do
        walls = walls + dd.myWall:getLong(i,"count")
    end

    --伤兵
    for i=1,dd.soliders:rowCount() do
        hurts = hurts + dd.soliders:getLong(i,"hurtcount")
    end
    for i=1,dd.myeffect:rowCount() do
        if dd.myeffect:getLong(i,"id") == 16 then
            hospital_max = dd.myeffect:getLong(i,"param")
            break
        end
    end
    local p1 = 0
    for i=1,dd.myeffect:rowCount() do
        if dd.myeffect:getLong(i,"id") == 405 then
            p1 = dd.myeffect:getLong(i,"param")
        end
    end
    hospital_max = math.floor(hospital_max * (1 + p1/1000))
    self:getChildByName("list"):getChildByName("topbox"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(dd.myinfo:getLong(1,"face")),0)
    self:getChildByName("list"):getChildByName("topbox"):getChildByName("troops"):setString(ff.getFormatMoney(armys))
    self:getChildByName("list"):getChildByName("topbox"):getChildByName("queues"):setString(troops.."/"..npcDeq)
    self:getChildByName("list"):getChildByName("topbox"):getChildByName("foods"):setString(ff.getFormatMoney(keepfood).."/h")
    self:getChildByName("list"):getChildByName("topbox"):getChildByName("walls"):setString(ff.getFormatMoney(walls).."/"..ff.getFormatMoney(walls_max))
    self:getChildByName("list"):getChildByName("topbox"):getChildByName("hurts"):setString(ff.getFormatMoney(hurts).."/"..ff.getFormatMoney(hospital_max))

    self:getChildByName("list"):getChildByName("topbox"):getChildByName("troops_tip"):setString(ff.langString("部队总数")..":")
    self:getChildByName("list"):getChildByName("topbox"):getChildByName("queues_tip"):setString(ff.langString("出战队列")..":")
    self:getChildByName("list"):getChildByName("topbox"):getChildByName("foods_tip"):setString(ff.langString("消耗总计")..":")
    self:getChildByName("list"):getChildByName("topbox"):getChildByName("walls_tip"):setString(ff.langString("城防总数")..":")
    self:getChildByName("list"):getChildByName("topbox"):getChildByName("hurts_tip"):setString(ff.langString("受伤士兵")..":")
end

function gatherdLayer:updateArmysList(lhh)
    --隐藏items
    for i,v in ipairs(self._armys) do
        if tolua.isnull(v) then
            self._armys[i] = nil
        else
            v:setVisible(false)
        end
    end

    local count = 1
    for i=1,table.getn(self._datas) do
        local sid = self._datas[i]
        local total_count = self:getBusyArmys(sid) + self:getFreeArmys(sid)
        local cur_count   = self:getFreeArmys(sid)
        if total_count > 0 then            
            local item = self._armys[count]
            if item == nil then
                item = self:getChildByName("item"):clone()
                self._armys[count] = item
                self:getChildByName("list"):getChildByName("trooplist"):addChild(item)
            end
            
            item:setTag(sid)
            item.type = 1

            item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getArmyIcon(sid),0)
            item:getChildByName("name"):setString(ff.langString(dd.cfgSoldier[sid]['soldierName']))
            item:getChildByName("number"):setString( ff.getFormatMoney(cur_count).."/"..ff.getFormatMoney(total_count) )
            
            local str = ""
            for j=1,dd.cfgSoldier[sid]['step'] do
                str = str.."0"
            end
            item:getChildByName("stars"):setString(str)

            local keepfood = dd.cfgSoldier[sid]['keepFood']*total_count
            keepfood = keepfood*(1-self._plus)
            keepfood = math.ceil(keepfood/100)
            item:getChildByName("food"):setString(dd.showKM(keepfood,4).."/h")
            item:setPositionY(lhh - count*145)
            item:setVisible(true)
            count = count + 1
        end
    end
end

function gatherdLayer:updateWallsList(whh)
    --隐藏items
    for i,v in ipairs(self._walls) do
        if tolua.isnull(v) then
            self._walls[i] = nil
        else
            v:setVisible(false)
        end
    end

    local count = 1
    for i=1,dd.myWall:rowCount() do
        if dd.myWall:getLong(i,"count") > 0 then
            local item = self._walls[count]
            if item == nil then
                item = self:getChildByName("item2"):clone()
                self._walls[count] = item
                self:getChildByName("list"):getChildByName("walllist"):addChild(item)
            end
            local wid = dd.myWall:getLong(i,"wallid")
            item:setTag(wid)
            item.type = 2

            item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getArmyIcon(wid),0)
            item:getChildByName("name"):setString(ff.langString(dd.cfgSoldier[wid]['soldierName']))
            item:getChildByName("number"):setString( ff.getFormatMoney(dd.myWall:getLong(i,"count") ))
            
            local str = ""
            for j=1,dd.cfgSoldier[wid]['step'] do
                str = str.."0"
            end
            item:getChildByName("stars"):setString(str)

            item:setPositionY(whh - count*145)
            item:setVisible(true)
            count = count + 1
        end
    end
end

function gatherdLayer:updateHurtsList(hhh)
    --隐藏items
    for i,v in ipairs(self._hurts) do
        if tolua.isnull(v) then
            self._hurts[i] = nil
        else
            v:setVisible(false)
        end
    end

    local count = 1
 
    for i=1,table.getn(self._hurtdatas) do
        local sid = self._hurtdatas[i]
        local num = self:getHurtArmys(sid)
        if num > 0 then
            local item = self._hurts[count]
            if item == nil then
                item = self:getChildByName("item"):clone()
                self._hurts[count] = item
                self:getChildByName("list"):getChildByName("hurtslist"):addChild(item)
            end
            item:setTag(sid)
            item.type = 3

            item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getArmyIcon(sid),0)
            item:getChildByName("name"):setString(ff.langString(dd.cfgSoldier[sid]['soldierName']))
            item:getChildByName("number"):setString( ff.getFormatMoney(num))
            
            local str = ""
            for j=1,dd.cfgSoldier[sid]['step'] do
                str = str.."0"
            end
            item:getChildByName("stars"):setString(str)
            local keepfood = dd.cfgSoldier[sid]['keepFood']*num
            keepfood = keepfood*(1-self._plus)
            keepfood = math.ceil(keepfood/100)
            item:getChildByName("food"):setString(dd.showKM(keepfood,4).."/h")

            item:setPositionY(hhh - count*145)
            item:setVisible(true)
            count = count + 1
        end
    end
end

function gatherdLayer:getFreeArmys(sid)
    local count = 0
    for i=1,dd.soliders:rowCount() do
        if dd.soliders:getLong(i,"soldierid") == sid then
            count = dd.soliders:getLong(i,"count")
            break
        end
    end
    return count
end

function gatherdLayer:getBusyArmys(sid)
    local data = dd.myTroops
    local count = 0
    for j=1,dd.myTroops:rowCount() do
        count = count + dd.myTroops:getLong(j,dd.cfgSoldierIndex[sid])
    end
    return count
end

function gatherdLayer:getHurtArmys(sid)
    local count = 0
    for i=1,dd.soliders:rowCount() do
        if dd.soliders:getLong(i,"soldierid") == sid then
            count = dd.soliders:getLong(i,"hurtcount")
            break
        end
    end
    return count
end
--浮层
function gatherdLayer:initPop()
    local function onAdd(sender, eventType)
        local speed = 0
        local step  = 5

        local function addCount(flag)    
            if speed == step or flag == true then
                self._solidernum = self._solidernum + 1
                if self._solidernum > self._sliderMax then
                    self._solidernum = self._sliderMax
                    sender:stopAllActions()              
                end 
                self:updateSliderByNum(self._solidernum)
                step  = step - 1
                if step < 1 then
                    step = 1
                end 
                speed = 0
            end
            speed = speed + 1 
        end
        if eventType==ccui.TouchEventType.began then   
            speed = 0
            schedule(sender,addCount,0.01)  
        elseif eventType==ccui.TouchEventType.ended then   
            addCount(true)
            speed = 0
            step  = 5
            sender:stopAllActions() 
        elseif eventType == ccui.TouchEventType.canceled then
            speed = 0
            step  = 5
            sender:stopAllActions() 
        end

        -- if eventType==ccui.TouchEventType.ended then
        --     self:updateSliderByNum(self._solidernum + 1)
        -- end
    end
    local function onSub(sender, eventType)
        local speed = 0
        local step  = 5

        local function subCount(flag)    
            if speed == step or flag == true then
                self._solidernum = self._solidernum - 1
                if self._solidernum < 0 then
                    self._solidernum = 0
                    sender:stopAllActions()              
                end 
                self:updateSliderByNum(self._solidernum)
                step  = step - 1
                if step < 1 then
                    step = 1
                end 
                speed = 0
            end
            speed = speed + 1 
        end
        if eventType==ccui.TouchEventType.began then   
            speed = 0
            schedule(sender,subCount,0.01)  
        elseif eventType==ccui.TouchEventType.ended then   
            subCount(true)
            speed = 0
            step  = 5
            sender:stopAllActions() 
        elseif eventType == ccui.TouchEventType.canceled then
            speed = 0
            step  = 5
            sender:stopAllActions() 
        end
        -- if eventType==ccui.TouchEventType.ended then
        --     self:updateSliderByNum(self._solidernum - 1)
        -- end
    end
    local pop = self:getChildByName("besure"):getChildByName("warning")
    pop:getChildByName("slider"):getChildByName("slider"):setCorrect(33,297)    
    pop:getChildByName("slider"):getChildByName("slider"):addEventListener(self.sliderEvent)
    local size = cc.size(120,35)
    local editBox = dd.addEditBox(
        pop:getChildByName("slider"):getChildByName("panel_input")
        , size
        , "images/ui/alpha.png"
        , 20000
        , cc.p(0,0)
        , cc.p(10,0)
        , cc.c3b(161,175,175)
        , 20
        , 2
        , 4
        , 1
        , 9
        , true
        , true
        , true
    )
    editBox:setName("editbox")
    editBox:registerScriptEditBoxHandler(self.editBoxTextEventHandle)

    pop:getChildByName("slider"):getChildByName("btn_add"):addTouchEventListener(onAdd)
    pop:getChildByName("slider"):getChildByName("btn_sub"):addTouchEventListener(onSub)
    pop:getChildByName("sure"):addTouchEventListener(self.onSureDismis)
end

function gatherdLayer:updatePop(sid,type)
    local pop = self:getChildByName("besure")
    local count = 0
    if type == 1 then       --部队
        for i=1,dd.soliders:rowCount() do
            if dd.soliders:getLong(i,"soldierid") == sid then
                count = dd.soliders:getLong(i,"count")
                break
            end
        end 
    elseif type == 2 then
        for i=1,dd.myWall:rowCount() do
            if dd.myWall:getLong(i,"wallid") == sid then
                count = dd.myWall:getLong(i,"count")
                break
            end
        end 
    elseif type == 3 then
        count = self:getHurtArmys(sid)
    else
        cclog("还没做 怎么可能呢!!!!!!!!!!")
    end 
    pop:getChildByName("warning"):getChildByName("tip_panel"):getChildByName("tips"):setString(ff.langString("是否确认要解散"))  --..ff.langString(dd.cfgSoldier[sid]['soldierName']
    pop:getChildByName("warning"):getChildByName("tip_panel"):requestDoLayout()
    if count > 0 then
        pop:getChildByName("warning"):getChildByName("slider"):getChildByName("nums_1"):setString(1)
    else
        pop:getChildByName("warning"):getChildByName("slider"):getChildByName("nums_1"):setString(0)
    end
    pop:getChildByName("warning"):getChildByName("slider"):getChildByName("nums_2"):setString(ff.getFormatMoney(count))
    pop:getChildByName("warning"):getChildByName("slider"):getChildByName("nums"):setString(0)

    pop:getChildByName("warning"):getChildByName("slider"):getChildByName("slider"):setPercent(0)
    
    self._type = type
    self._soliderid = sid
    self._solidernum = 0
    self._sliderMax = count
    self:updateSliderByNum(0)
end

function gatherdLayer.openPop(sender, eventType) 
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        AudioEngine.playEffect(ff.sounds[109])
        local widget = pop.getDialog("gatherd")
        if sender.type == 1 and widget:getFreeArmys(sender:getTag()) <= 0 then     
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有可以解散的士兵"))
        else
            widget:updatePop(sender:getTag(),sender.type)
            pop.showPopEffect(99,widget:getChildByName("besure"))
        end
    end    
end

function gatherdLayer.closePop(sender, touchEventType)
    if touchEventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("gatherd")
        widget:getChildByName("besure"):setVisible(false)   
    end
end

function gatherdLayer.onSureDismis(sender,eventType)
    if eventType==ccui.TouchEventType.ended then    
        local widget = pop.getDialog("gatherd")
        if widget ~= nil then
            if widget._solidernum <= 0 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("数量不能为0"))
            else
                function onSureDismis()
                    local message = ff.net:createMessage()
                    if widget._type == 1 then            
                        message:addCmd(0x106)
                    elseif widget._type == 2 then  
                        message:addCmd(0x107)              --城防
                    elseif widget._type == 3 then   
                        message:addCmd(0x108)              --伤兵                     
                    end             
                    message:addLong(dd.uid)
                    message:addLong(91)
                    message:addLong(widget._soliderid)
                    message:addLong(widget._solidernum)
                    ff.net:rpc(message,false)
                end
                widget.closePop(nil, ccui.TouchEventType.ended)
                dd.currentLayer._widget:onShowSure(ff.langString("是否确认要解散"),ff.langString("解散部队不会退还资源，请慎重考虑"),onSureDismis,false,2)
            end    
        end    
    end
end

function gatherdLayer.sliderEvent( ref, type )
    if type == ccui.SliderEventType.percentChanged then
        local widget = pop.getDialog("gatherd")
        local percent = ref:getPercent()
        
        local curNum  = math.floor(percent * widget._sliderMax/100)
        widget:getChildByName("besure"):getChildByName("warning"):getChildByName("slider"):getChildByName("nums"):setString(ff.getFormatMoney(curNum))
        local editbox = widget:getChildByName("besure"):getChildByName("warning"):getChildByName("slider"):getChildByName("panel_input"):getChildByName("editbox")
        editbox:setText(curNum)
        widget._solidernum = curNum
        widget:updateSliderByNum(curNum)
    end
end

function gatherdLayer.editBoxTextEventHandle(strEventName,pSender)    
    if strEventName == "began" then
    elseif strEventName == "ended" then
    elseif strEventName == "return" then
        local widget = pop.getDialog("gatherd")
        local count   = pSender:getText()
        if tonumber(count) ~= nil then
            if tonumber(count) > widget._sliderMax then
                count = widget._sliderMax
            else
                count = tonumber(count)
            end
        else
            count = 0
        end
        local percent = 100*count/widget._sliderMax
        widget:getChildByName("besure"):getChildByName("warning"):getChildByName("slider"):getChildByName("nums"):setString(ff.getFormatMoney(count))
        widget:getChildByName("besure"):getChildByName("warning"):getChildByName("slider"):getChildByName("slider"):setPercent(percent)
        widget._solidernum = count
        widget:updateSliderByNum(count)
    end
end

function gatherdLayer:updateSliderByNum(num)
    if num < 0 then
        num = 0
    end
    if num > self._sliderMax then
        num = self._sliderMax
    end
    local percent = 100*num/self._sliderMax
    local posx = 148 + 2.97*math.floor(percent)
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("slider"):getChildByName("nums"):setString(ff.getFormatMoney(num))
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("slider"):getChildByName("nums"):setPositionX(posx)
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("slider"):getChildByName("slider"):setPercent(percent)
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("slider"):getChildByName("panel_input"):getChildByName("editbox"):setText(num)
    self._solidernum = num
    --self:updateBtnsByNum(num)
end

function gatherdLayer:updateBtnsByNum(num)
    if num <= 0 then
        self:setBtnLight(self:getChildByName("besure"):getChildByName("warning"):getChildByName("slider"):getChildByName("btn_sub"),false)
    else
        self:setBtnLight(self:getChildByName("besure"):getChildByName("warning"):getChildByName("slider"):getChildByName("btn_sub"),true)
    end

    if num >= self._sliderMax then
        self:setBtnLight(self:getChildByName("besure"):getChildByName("warning"):getChildByName("slider"):getChildByName("btn_add"),false)
    else
        self:setBtnLight(self:getChildByName("besure"):getChildByName("warning"):getChildByName("slider"):getChildByName("btn_add"),true)
    end
end

function gatherdLayer:setBtnLight(node, light)
    if light == true then
        node:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        node:setTouchEnabled(true)
    else 
        local effect = ff.Effect:effectGrey()    
        node:getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        node:setTouchEnabled(false)
    end
end

function gatherdLayer:onArmyAction(params)
    local code = params[1]
    if code == 0 then
        self:updates()
        self.closePop(nil,ccui.TouchEventType.ended)
        AudioEngine.playEffect(ff.sounds[207])
        if dd.cityLayer ~= nil then
            dd.cityLayer:updateCityArmys()
        end
    else   
        dd.mainUI:onShowCodeTips(code)
    end
end

--接口
function gatherdLayer.onBack(sender,eventType)       
    if eventType==ccui.TouchEventType.ended then  
        local widget = pop.getDialog("gatherd")
        if widget ~= nil then
            if widget:getChildByName("besure"):isVisible() == true then
                widget.closePop(sender,ccui.TouchEventType.ended)
            else
                pop.onClosePopDialog("gatherd")
            end
        end    
    end
end

function gatherdLayer.onStart(sender)
    ff.net:bindProperty(2517,"gold",sender.updateGold)
    ff.net:registerEvent(10,dd.Tjf_Queue_ArmysAction,function (message)sender:onArmyAction(message)end)
    ff.net:registerEvent(10,dd.Tjf_Queue_WallAction,function (message)sender:onArmyAction(message)end)
    ff.net:registerEvent(10,dd.Tjf_Queue_HealsAction,function (message)sender:onArmyAction(message)end)
    sender:updates()
end

function gatherdLayer.onEnd(sender)
    dd.delBackEvent()
    ff.net:unbindProperty("gold",2517)
    ff.net:removeEvent(10,dd.Tjf_Queue_ArmysAction)
    ff.net:removeEvent(10,dd.Tjf_Queue_WallAction)
    ff.net:removeEvent(10,dd.Tjf_Queue_HealsAction)
    if ff.platform ~= 1 then
        sender:getChildByName("list"):getChildByName("topbox"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        for i,item in ipairs(sender._armys) do
            if item then
                item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end
        for i,item in ipairs(sender._walls) do
            if item then
                item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end
        for i,item in ipairs(sender._hurts) do
            if item then
                item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end
    end
end

function gatherdLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))    
end

function gatherdLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("gatherd")
    if widget ~= nil then
        if widget:getChildByName("besure"):isVisible() == true then
            widget.closePop(sender,ccui.TouchEventType.ended)
        else
            pop.onClosePopDialog("gatherd")
        end
    end
end

function onShowGatherdLayer(widget)
    local layer = gatherdLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onAutoSize()
    layer:onInit()
    return layer
end