require "GuiConstants"
require "Cocos2d"
local lotteryLayer   = class("lotteryLayer")
lotteryLayer._name = "lottery"
lotteryLayer._init = false
lotteryLayer.state = 1
lotteryLayer.org_slot = cc.p(0, 0)
lotteryLayer.isRolling = false
lotteryLayer.toparea = nil
lotteryLayer.mainarea = nil
lotteryLayer.buttomarea = nil
lotteryLayer.lottery = nil
lotteryLayer.list = {}
lotteryLayer.jeton = 1
lotteryLayer.item = {}
lotteryLayer.title = nil
lotteryLayer.rotatebg = nil
lotteryLayer.round = nil
lotteryLayer.Prize = {}
lotteryLayer.ii = 1
lotteryLayer.curNum = 0
lotteryLayer.popview = nil
lotteryLayer.prizePic = {}
lotteryLayer.rollTimes = 0
lotteryLayer.cryget = {0}
lotteryLayer.starPos = {cc.p(182, 1230 - 192), cc.p(195, 1230 - 176), cc.p(217, 1230 - 203), cc.p(337, 1230 - 234), cc.p(331, 1230 - 234),cc.p(223, 1230 - 178),
cc.p(421, 1230 - 195),cc.p(310, 1230 - 234),cc.p(266, 1230 - 178),cc.p(442, 1230 - 177),cc.p(371, 1230 - 192),cc.p(403, 1230 - 214),cc.p(478, 1230 - 178),
cc.p(491, 1230 - 178),cc.p(693, 1230 - 200),cc.p(576, 1230 - 297)}
lotteryLayer.star = {}
lotteryLayer.schedule = nil


function lotteryLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, lotteryLayer)
    return target
end
function lotteryLayer.onStart(sender)
    ff.net:registerEvent(2,dd.Tjf_lottery,function (message)sender:MessageListener(message) end)
    ff.net:registerEvent(2,dd.Tjf_prop_buy,function (message)sender:Buylistener(message) end)
    ff.net:bindProperty(2701,"gold",sender.updateGold)   
    --关闭可能打开在那边的3层窗口
    pop.closeOtherNow(3,nil)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("i_goldCoin"),sender:getChildByName("topArea"):getChildByName("b_moneyAdd"))
end
function lotteryLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("lottery")
    if widget ~= nil then
        widget:getChildByName("topArea"):getChildByName("a_goadNum"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("topArea"):getChildByName("a_goadNum"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("topArea"):requestDoLayout()
    end
end 
function lotteryLayer:onInit()
    if self._init == false then
        self.toparea = self:getChildByName("topArea")
        self.mainarea = self:getChildByName("mainArea")
        self.buttomarea = self.mainarea:getChildByName("buttomArea")
        self.lottery = self.mainarea:getChildByName("i_lotteryBG")

        self.toparea:setPositionY(ff.height - 105)
        self.mainarea:setPositionY(ff.height - 105 - 1080)

        self.list[1] = self.lottery:getChildByName("left"):getChildByName("list")
        self.list[2] = self.lottery:getChildByName("midel"):getChildByName("list")
        self.list[3] = self.lottery:getChildByName("right"):getChildByName("list")

        self.item[1] = self.list[1]:getChildByName("i3"):getChildByName("icon")
        self.item[2] = self.list[2]:getChildByName("i3"):getChildByName("icon")
        self.item[3] = self.list[3]:getChildByName("i3"):getChildByName("icon")

        self.title = self.mainarea:getChildByName("i_lotteryBG"):getChildByName("Led"):getChildByName("i_title")
        self.rotatebg = self.mainarea:getChildByName("i_round")
        self.rotatebg:setPositionY(self.rotatebg:getPositionY() - 50)

        --self.toparea:getChildByName("l_title"):enableOutline(cc.c4b(0,0,0,255),3)
       self:getChildByName("prizePanel"):setVisible(false)

       
       self._init = true
    end
    
    self.updateGold()
    --cclog("laohujilucky"..dd.myinfo:getLong(1, "lucky"))
    --self.round = dd.newSpriteFromUI("round05.png")
    self.round = self.mainarea:getChildByName("luky")
    if dd.myinfo:getLong(1, "lucky") >= 19 or dd.myinfo:getLong(1, "lucky") == 0 then 
        self.round:loadTexture(dd.getPathFromUI("round01.png", 1))
    else
        self.round:loadTexture(
            dd.getPathFromUI("round0"..math.ceil(dd.myinfo:getLong(1, "lucky") / 2)..".png",1) )
    end
    
    self.mainarea:getChildByName("l_bagSize"):setString(dd.myCrystals:rowCount())

    self.mainarea:getChildByName("jetonInfo"):getChildByName("a_jetonNum"):setStringValue(dd.getToolsCount(1024))
    self.mainarea:getChildByName("jetonInfo"):requestDoLayout()
    --self.toparea:getChildByName("a_goadNum"):setStringValue(dd.gold())
  --  self.buttomarea:getChildByName("c_10"):setSelectedState(true)
  --  self.buttomarea:getChildByName("c_50"):setSelectedState(false)
   -- self.buttomarea:getChildByName("c_100"):setSelectedState(false)

    --button
    self.toparea:getChildByName("b_back"):addTouchEventListener(self.onReturn)
    self.buttomarea:getChildByName("b_buy"):addTouchEventListener(self.BuyJetton) 
    if dd.cfgProp[1024]['shop']  == 1 then
--        self.buttomarea:getChildByName("b_buy"):getChildByName("Label_221"):setString(dd.cfgProp[1024]['value'])
    end
    self.toparea:getChildByName("b_moneyAdd"):addTouchEventListener(dd.onPay)

    --
    self:AddEffects()
    self:InitSlot()
    self:InitCheckBox()
    self._init = true
    self:getChildByName("buyView"):setVisible(false)
    
end
function lotteryLayer:showBuyView()
    self:getChildByName("buyView"):setVisible(true)
    self.popview = self:getChildByName("buyView"):getChildByName("panel_buyItem")
    self.popview:setPositionX(0)
    self.popview:setPositionY(-self.popview:getContentSize().height)
    self.popview:stopAllActions()
    self.popview:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,0)))))

    local imgBg = self.popview:getChildByName("img_icon_bg")
    local lab_itemNum = self.popview:getChildByName("lab_num")
    local img_icon = imgBg:getChildByName("img_icon")

    local lab_itemName = self.popview:getChildByName("infos"):getChildByName("lab_itemName")
    local lab_itemInfo = self.popview:getChildByName("infos"):getChildByName("lab_itemInfo")
    lab_itemName:setString(ff.langString(dd.cfgProp[1024]["name"],{dd.cfgProp[1024]["name1_lan"]}))
    lab_itemInfo:setString(ff.langString(dd.cfgProp[1024]["tips"],{dd.cfgProp[1024]["tips1_lan"]}))
    --lab_itemNum:setString(dd.cfgProp[1024]["num"])
    lab_itemNum:setString(dd.getToolsCount(1024))

    img_icon:loadTexture(dd.getToolsIcon(1024),0)
    --img_icon:loadTexture("images/icon/tools/1.png")

    local slider = self.popview:getChildByName("panel_slider"):getChildByName("slider")
    slider:setPercent(0)

    local btn_close = self.popview:getChildByName("btn_close")
    local btn_sub = self.popview:getChildByName("btn_sub")
    local btn_add = self.popview:getChildByName("btn_add")
    local btn_commit = self.popview:getChildByName("btn_commit")
    local lab_comBuy = btn_commit:getChildByName("lab_buy")
    local lab_cost = btn_commit:getChildByName("lab_cost")
    local img_coin = btn_commit:getChildByName("Image_77")

    local panel_input = self.popview:getChildByName("panel_input")
    local tf_input = panel_input:getChildByName("lab_input")

    self.curNum = 1    
    local userCoin = 0 
    local price = dd.cfgProp[1024]['value']
    local maxNum = 0

    local function setCommitButtonWithPrice()
        if self.curNum < 1 then
            self.curNum = 1
        end
        local curCost = math.floor(self.curNum) * price
        if curCost > userCoin then
            lab_cost:setColor(cc.c3b(255,0,0))
        else
            lab_cost:setColor(cc.c3b(255,255,255))
        end
        lab_cost:setString(math.floor(curCost))
        slider:setPercent((self.curNum / maxNum)*100)
        local bgWidth = btn_commit:getContentSize().width
        --lab_cost:setPositionX(bgWidth/2 + lab_cost:getContentSize().width/2)
        --img_coin:setPositionX(lab_cost:getPositionX()+img_coin:getContentSize().width/2)

        tf_input:setString(math.floor(self.curNum))
        -- cclog("lab_cost ===================="..lab_cost:getContentSize().width)
    end
    
    local function buttonClick(sender, touchType)
        if touchType == ccui.TouchEventType.ended then
            if sender == btn_sub then
                self.curNum = self.curNum - 1
                if self.curNum < 1 then
                    self.curNum = 1
                end
                cclog("curNum: "..self.curNum)
                setCommitButtonWithPrice()
            elseif sender == btn_add then
                self.curNum = self.curNum + 1
                if self.curNum > maxNum then
                    self.curNum = maxNum
                end
                setCommitButtonWithPrice()
            elseif sender == btn_close then
                local moveto = cc.EaseBackOut:create(cc.MoveTo:create(1, cc.p(0, -self.popview:getContentSize().height-10)))
                local callf  = cc.CallFunc:create(function () end)
                self.popview:runAction(cc.Sequence:create(moveto, callf))
            elseif sender == btn_commit then
                
                if self.curNum*price > userCoin then
                    local function sure()
                        pop.onShowPopDialog("charge")
                    end
                    dd.mainUI:onShowSure(ff.langString("金币不足"),ff.langString("充值可以让你立即拥有大量金币.\n是否现在就去?"),sure,true,2,2,ff.langString("充值"))
                    --dd.showTips(ff.langString("金币不足"), 30, cc.c3b(255,0,0))
                else
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000121)
                    message:addLong(dd.uid)
                    message:addLong(1024)
                    message:addLong(self.curNum)
                    ff.net:rpc(message, false)
                end
                
            end
        end
    end
    btn_add:addTouchEventListener(buttonClick)
    btn_sub:addTouchEventListener(buttonClick)
    btn_commit:addTouchEventListener(buttonClick)
    btn_close:addTouchEventListener(buttonClick)

    local function percentChangedEvent(sender,eventType)
        if eventType == ccui.SliderEventType.percentChanged then
            local percent = slider:getPercent()
            if maxNum > 99 then
                maxNum = 99
            end
            self.curNum = (percent/100) * maxNum
            setCommitButtonWithPrice()
        end
    end  
    slider:addEventListener(percentChangedEvent)


    userCoin = dd.myinfo:getLong(1, "gold") --dd.myUnion:getLong(1, "nAllyFunds")
    lab_comBuy:setString(ff.langString("购买"))
    --self.popview:getChildByName("lab_viewInfo"):setString(ff.langString("购买道具"))
     maxNum = 99
    lab_cost:setVisible(true)
    img_coin:setVisible(true)
    
    setCommitButtonWithPrice()

    --init editbox
    if panel_input:getChildByTag(10091) == nil then
        local editBox = dd.addEditBox(
             panel_input
            , panel_input:getContentSize()
            , "images/ui/alpha.png"
            , 10091
            , cc.p(0,0)
            , cc.p(self.popview:getChildByName("panel_input"):getChildByName("lab_input"):getPositionX()-32,self.popview:getChildByName("panel_input"):getChildByName("lab_input"):getPositionY())
            , cc.c3b(255,255,255)
            , 20
            , 2
            , 4
            , 1
            , 5
            , true
            , true
            , true
        )
        local function editBoxTextEventHandle(strEventName,pSender)
            local edit = pSender
            local strFmt 
            if strEventName == "began" then
                tf_input:setVisible(false)
            elseif strEventName == "ended" or strEventName == "return" then
                local text = edit:getText()
                tf_input:setVisible(true)
                if text ~= "" then
                    local tt = tonumber(text)
                    if tt > 99 then
                        tt = 99
                    end
                    tf_input:setText(tt)
                    self.curNum = tt
                    setCommitButtonWithPrice()
                end
                edit:setText("")
            elseif strEventName == "changed" then
                tf_input:setVisible(true)
            end
        end
        editBox:registerScriptEditBoxHandler(editBoxTextEventHandle)
        slider:setCorrect(35,316)
    end
end
function lotteryLayer.BuyJetton(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
       -- if sender.popview == nil then
           pop.getDialog("lottery"):showBuyView()
       -- end
     end
end
function lotteryLayer:SendMessage()     
    local message = ff.net:createMessage()
    message:addCmd(0x0000015e)
    message:addLong(dd.uid)
    message:addLong(0)
    message:addLong(self.jeton)
    ff.net:rpc(message, false) 
end
function lotteryLayer:MessageListener(params)
    local code = params[1]       
    if code == 0 then
        if params[3] == 0 or params[3] == 1 then
            --启动前先处理数据
            self.cryget = {0} 
            if params[6] >= 19 or params[6] == 0 then
                self.round:loadTexture(dd.getPathFromUI("round01.png", 1))
            else
                self.round:loadTexture(dd.getPathFromUI("round0"..math.ceil(params[6] / 2)..".png",1))
                cclog(math.ceil(params[6] / 2))
            end
            local iiii = 1
            for i = 1, params[5] do
                self.Prize[i] = {}
                self.Prize[i]["tiems"] = params[4]:getLong(i, "tiems")
                self.Prize[i]["id"] = params[4]:getLong(i, "id")
                self.Prize[i]["getnum"] = params[4]:getLong(i, "getnum")
                for j = 1, self.Prize[i]["getnum"] do
                    self.cryget[iiii] = self.Prize[i]["id"]
                    iiii = iiii + 1
                end               
            end

           --启动老虎机       
           self:LaunchLotter()
       end
       if params[3] == 9 then
       end
       
    else
        if code == 101024 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("筹码不足"))
        else
            dd.mainUI:onShowCodeTips(code)
        end
        
        self.isRolling = false
    end
    
end
function lotteryLayer:LaunchLotter()

    self.rollTimes = 0
    self.isRolling = true       
    --依次启动3列     
    self:Roll(1)
    self:runAction(cc.Sequence:create(cc.DelayTime:create(0.5), cc.CallFunc:create(function () self:Roll(2) end)))
    self:runAction(cc.Sequence:create(cc.DelayTime:create(1.0), cc.CallFunc:create(function () self:Roll(3) end)))
    self.mainarea:getChildByName("jetonInfo"):getChildByName("a_jetonNum"):setStringValue(dd.getToolsCount(1024))
    self.mainarea:getChildByName("jetonInfo"):requestDoLayout()

    --预设奖品显示图片
    self.rollTimes = self.rollTimes + 1
    self.prizePic[self.rollTimes] = {}

    self.prizePic[self.rollTimes][1] = {}   
    local num =  math.floor((math.random() * 999999)% 5) + 1             
    self.prizePic[self.rollTimes][1][1] = "pin"..num..".png"   --1 - 1
    num = math.floor(self.Prize[self.rollTimes]["id"] / 100 )   cclog("pin  "..num)
    self.prizePic[self.rollTimes][1][2] = "pin"..num..".png"   --1 - 2 颜色
    num =  math.floor((math.random() * 999999)% 5) + 1
    self.prizePic[self.rollTimes][1][3] = "pin"..num..".png"   --1 - 3

    self.prizePic[self.rollTimes][2] = {}   
    num =  math.floor((math.random() * 999999)% 9) + 1   
    self.prizePic[self.rollTimes][2][1] = "type"..num..".png"  --2 - 1
    num = self.Prize[self.rollTimes]["id"] % 100   if  num == 0 then num = 9 end          cclog("type  "..num)
    self.prizePic[self.rollTimes][2][2] = "type"..num..".png"  --2 - 2 类型
    num =  math.floor((math.random() * 999999)% 9) + 1
    self.prizePic[self.rollTimes][2][3] = "type"..num..".png"  --2 - 3

    self.prizePic[self.rollTimes][3] = {}   
    num =  math.floor((math.random() * 999999)% 3) + 1
    self.prizePic[self.rollTimes][3][1] = "bei"..num..".png"
    self.prizePic[self.rollTimes][3][2] = "bei"..self.Prize[self.rollTimes]["getnum"]..".png"
    num =  math.floor((math.random() * 999999)% 3) + 1
    self.prizePic[self.rollTimes][3][3] = "bei"..num..".png"
  
    --标题移动
    self:TitleMove(false)

    --显示奖品
    self.mainarea:runAction(cc.Sequence:create(cc.DelayTime:create(8), cc.CallFunc:create(
        function () 
            self.rollTimes = 0
            self:showPrize() 
            --AudioEngine.playEffect(ff.sounds[200])
        end)))

    --ÔÝÊ±Òþ²Ø½±Æ·½çÃæ
    self:getChildByName("prizePanel"):getChildByName("prizeone"):setVisible(false)

    AudioEngine.playEffect(ff.sounds[200])
end
function lotteryLayer:Buylistener(params)
    if params[1] == 0 then
        self.mainarea:getChildByName("jetonInfo"):getChildByName("a_jetonNum"):setStringValue(dd.getToolsCount(1024))
        self.toparea:getChildByName("a_goadNum"):setStringValue(dd.gold())
        self.mainarea:getChildByName("jetonInfo"):requestDoLayout()

        local moveto = cc.EaseBackOut:create(cc.MoveTo:create(1, cc.p(0, -self.popview:getContentSize().height-10)))
        local callf  = cc.CallFunc:create(function ()  end)
        self.popview:runAction(cc.Sequence:create(moveto, callf))
    else
        dd.mainUI:onShowCodeTips(params[1])
    end 
end
function lotteryLayer:TitleMove(stop)
    if stop == true then
        self.title:stopAllActions()
        self.title:setPositionX(360)
    else
        local moveto = cc.MoveTo:create(2, cc.p(-720, 32))
        local callf  = cc.CallFunc:create(function () self.title:setPositionX(720) end)
        self.title:runAction(cc.RepeatForever:create(cc.Sequence:create(moveto, callf)))
    end
    
end
function lotteryLayer:Roll(i)
    self.list[i]:setPositionY(-130)
    local action0 = cc.EaseOut:create(cc.MoveBy:create(0.25, cc.p(0, 30)), 1.4)
    local action1 = cc.Sequence:create(cc.EaseIn:create(
        cc.MoveBy:create(2, cc.p(0, -1280)), 1.7), 
        cc.CallFunc:create(function () self.list[i]:setPositionY(-130) end)
        )--action1 end
    local action2 = cc.Sequence:create(
        cc.MoveBy:create(0.425, cc.p(0, -585)), 
        cc.CallFunc:create(
            function ()
                for j = 1, 3 do
                    self.list[i]:getChildByName("i"..j+1):getChildByName("icon"):loadTexture(
                        dd.getPathFromUI(self.prizePic[self.rollTimes][i][j], 1))
                    self.list[i]:getChildByName("i"..j+10):getChildByName("icon"):loadTexture(
                        dd.getPathFromUI(self.prizePic[self.rollTimes][i][j], 1))
                end
            end),
        cc.MoveBy:create(0.425, cc.p(0, -585)), 
        cc.CallFunc:create(
            function () 
                self.list[i]:setPositionY(-130) 
            end))--action2 end
    local action3 = cc.Sequence:create(
        cc.MoveBy:create(0.7, cc.p(0, -1170)), 
        cc.CallFunc:create(function () self.list[i]:setPositionY(-130) end)
        )--action3 end
    local action5 = cc.EaseOut:create(cc.MoveBy:create(1.5, cc.p(0, -1200)), 1.4)
    local action6 = cc.Sequence:create(
        cc.CallFunc:create(
                function () 
                    AudioEngine.playEffect(ff.sounds[201]) 
                end),
        cc.MoveBy:create(0.35, cc.p(0, 30)), 
        cc.CallFunc:create(
            function ()
                local action7 = cc.Sequence:create(
                    cc.ScaleTo:create(0.3, 1.3), 
                    cc.ScaleTo:create(0.3, 1), 
                    cc.ScaleTo:create(0.3, 1.3), 
                    cc.ScaleTo:create(0.3, 1))
                self.item[i]:runAction(action7)
            end
    ))--action6 end
    self.list[i]:runAction(cc.Sequence:create(action0, action1, action2, action3, action5, action6))
    if i == 3 then
        self.mainarea:runAction(cc.Sequence:create(cc.DelayTime:create(8), cc.CallFunc:create(
            function ()                 
                self.isRolling = false self:TitleMove(true)
                self.mainarea:getChildByName("l_bagSize"):setString(dd.myCrystals:rowCount()) 
            end)))
    end
end

function lotteryLayer:showPrize()
    local PrizePanel = self:getChildByName("prizePanel")
    local close = PrizePanel:getChildByName("taptoclose")
    PrizePanel:setVisible(true)
    PrizePanel:setZOrder(10)
    local n = 1
    for i = 1, 31 do
        local item = PrizePanel:getChildByTag(100+i)
        if item ~= nil then
            item:removeFromParent(true)
        end
    end
    local x =  PrizePanel:getChildByName("prizeone"):getChildByTag(100)
    if x ~= nil then
        x:removeFromParent(true)
    end
    for i = 1, 31 do
        if self.cryget[i] == nil then
            n = i - 1
            break
        end
    end
    local isShowPrize = true;
    if n == 1 then
       PrizePanel:getChildByName("prizeone"):getChildByName("Image_863"):loadTexture(dd.getHuizhangIcon(self.Prize[1]["id"]), 0)
       PrizePanel:getChildByName("prizeone"):getChildByName("Image_863"):setScale(1)
       PrizePanel:getChildByName("prizeone"):setVisible(true)
 
            if dd.cfgCrystal[self.Prize[1]["id"]] ~= nil then
                local sprite = sp.SkeletonAnimation:create("images/equipsp/laohuji.json", "images/equipsp/laohuji.atlas")
                sprite:setAnchorPoint(cc.p(0.5,0.5))
                local x = PrizePanel:getChildByName("prizeone"):getChildByName("Image_863"):getPositionX()
                local y = PrizePanel:getChildByName("prizeone"):getChildByName("Image_863"):getPositionY()
                sprite:setPosition(cc.p(x+90,y+90))
                if dd.cfgCrystal[self.Prize[1]["id"]]['color'] == 1 then
                    sprite:setAnimation(0, "White_animation", true)
                elseif dd.cfgCrystal[self.Prize[1]["id"]]['color'] == 2 then
                    sprite:setAnimation(0, "Green_animation", true)
                elseif   dd.cfgCrystal[self.Prize[1]["id"]]['color'] == 3 then
                    sprite:setAnimation(0, "Blue_animation", true)
                elseif dd.cfgCrystal[self.Prize[1]["id"]]['color'] == 4 then
                    sprite:setAnimation(0, "Purple_animation", true)
                elseif dd.cfgCrystal[self.Prize[1]["id"]]['color'] == 5 then
                    sprite:setAnimation(0, "Orange_animation", true)
                end
                PrizePanel:getChildByName("prizeone"):addChild(sprite, 1,100)
                            --cclog("==========="..n)
            end
    AudioEngine.playEffect(ff.sounds[919])
       close:setVisible(true)
       close:runAction(cc.RepeatForever:create(cc.Blink:create(2, 2)))
    elseif n > 1 then        
        local m = 1
        if n > 6 then
            m = 2
        elseif n > 12 then
            m = 3
        elseif n > 18 then
            m = 4
        elseif n > 24 then
            m = 5
        end
        for i = 1, n do
            local sp = cc.Sprite:create(dd.getHuizhangIcon(self.cryget[i]));
            sp:setPosition(50, 50);
            local s = i
            local k = 1
            if i > 24 then
                s = i - 24
                k = 5
            elseif i > 18 then
                s = i - 18
                k = 4
            elseif i > 12 then
                s = i - 12
                k = 3
            elseif i > 6 then
                s = i - 6
                k = 2
            end
            PrizePanel:getChildByName("p"..k.."_"..s):setScale(3)
            PrizePanel:getChildByName("p"..k.."_"..s):addChild(sp)
            PrizePanel:getChildByName("p"..k.."_"..s):setVisible(false)
            
        end
        PrizePanel:setVisible(true)

        self.ii = 1
        PrizePanel:getChildByName("p1_1"):setVisible(true)  
        local delay = cc.DelayTime:create(0.2)
        local callf = cc.CallFunc:create(
            function () 
                local h = math.ceil(self.ii / 6)
                local s = self.ii - (h - 1) * 6            
                PrizePanel:getChildByName("p"..h.."_"..s):setVisible(true) 
                AudioEngine.playEffect(ff.sounds[201]) 
                PrizePanel:getChildByName("p"..h.."_"..s):runAction(cc.ScaleTo:create(0.2, 1))
                if self.cryget[self.ii] ~= nil then
                        if dd.cfgCrystal[self.cryget[self.ii]] ~= nil then
                            local sprite = sp.SkeletonAnimation:create("images/equipsp/laohuji.json", "images/equipsp/laohuji.atlas")
                            sprite:setAnchorPoint(cc.p(0,0))
                            local x = PrizePanel:getChildByName("p"..h.."_"..s):getPositionX()
                            local y = PrizePanel:getChildByName("p"..h.."_"..s):getPositionY()
                            sprite:setPosition(cc.p(x+50,y+50))
                            if dd.cfgCrystal[self.cryget[self.ii]]['color'] == 1 then
                                sprite:setAnimation(0, "White_animation", true)
                            elseif dd.cfgCrystal[self.cryget[self.ii]]['color'] == 2 then
                                sprite:setAnimation(0, "Green_animation", true)
                            elseif   dd.cfgCrystal[self.cryget[self.ii]]['color'] == 3 then
                                sprite:setAnimation(0, "Blue_animation", true)
                            elseif dd.cfgCrystal[self.cryget[self.ii]]['color'] == 4 then
                                sprite:setAnimation(0, "Purple_animation", true)
                            elseif dd.cfgCrystal[self.cryget[self.ii]]['color'] == 5 then
                                sprite:setAnimation(0, "Orange_animation", true)
                            end
                            PrizePanel:addChild(sprite, 1,100+self.ii)
                            --cclog("==========="..n)
                        end
                    end
                self.ii = self.ii + 1
                if self.ii > n then
                    close:runAction(cc.RepeatForever:create(cc.Blink:create(2, 2)))
                    PrizePanel:stopAllActions()

                    self.ii = 1
                    isShowPrize = false
                end      
            end)
        PrizePanel:runAction(cc.RepeatForever:create(cc.Sequence:create(delay, callf)))
        
        close:setVisible(true)
        close:runAction(cc.RepeatForever:create(cc.Blink:create(2, 2)))
    end

    local eventDispatcher = PrizePanel:getEventDispatcher()
    local listener = cc.EventListenerTouchOneByOne:create()
    local function onTouchBegan(touch, event)
        return true
    end
    local function onTouchEnded(touch, event)
        if isShowPrize == true then
            PrizePanel:stopAllActions()
            self.ii = 1
            for ll = 1, 5 do
                for kk = 1, 6 do
                    PrizePanel:getChildByName("p"..ll.."_"..kk):setVisible(true)
                    PrizePanel:getChildByName("p"..ll.."_"..kk):setScale(1)
                    
                end
            end  
            isShowPrize = false           
        else
            PrizePanel:setVisible(false)
            PrizePanel:setZOrder(-1)
            PrizePanel:getChildByName("prizeone"):setVisible(false)
            PrizePanel:getChildByName("taptoclose"):setVisible(false)
            PrizePanel:getChildByName("taptoclose"):stopAllActions()
            for l = 1, 5 do
                for k = 1, 6 do
                    PrizePanel:getChildByName("p"..l.."_"..k):removeAllChildren()
                    self.Prize = {}
                    eventDispatcher:removeEventListener(listener)
                end
            end 
        end
             
    end

    
    listener:setSwallowTouches(false)
    listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN )
    listener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED )
       
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener, close)
    
end
function lotteryLayer:AddEffects()

    -- rotate background
    local angle = 0
    local bg = self.mainarea:getChildByName("i_round")
    bg:setScale(0.8)
    bg:loadTexture(dd.getPathFromUI("rotatelight.png",1))
    local function ratote()
        angle = angle + 1
        bg:setRotation(angle)
    end
    schedule(bg, ratote, 0)

    -- stars
    
    function update()
        -- perduce random number

        local valu = math.floor((math.random() * 999999)% 16) + 1
        local dir = math.floor((math.random() * 999999)% 2) + 1

        -- create star sprite
        if self.star[valu] == nil then
            self.star[valu] = dd.newSpriteFromUI("lightEffect.png")
            self.star[valu]:setPosition(self.starPos[valu])
            self.star[valu]:setScale(0.1)
            self.mainarea:addChild(self.star[valu], 1)

            -- create action
            local scto1 = cc.ScaleTo:create(1, 1.6)
            local delay = cc.DelayTime:create(0.5)
            local scto2 = cc.ScaleTo:create(1, 0.2)
            local remove = cc.CallFunc:create(function () self.star[valu]:removeFromParent(true) self.star[valu] = nil end)

            local rotation = nil
            if dir == 2 then
                rotation = cc.RotateTo:create(2.5, 900)    
            else
                rotation = cc.RotateTo:create(2.5, -900)
            end

            local seq1 = cc.Sequence:create(scto1, delay, scto2, remove)

            self.star[valu]:runAction(seq1)
            self.star[valu]:runAction(rotation)
        end
    end
    schedule(self.mainarea, update, 0.5)
end
function lotteryLayer:InitSlot()
    local slot  = self.mainarea:getChildByName("i_Slot")
    local lagan = self.mainarea:getChildByName("lagan")
    local lagan1 = lagan:getChildByName("lagan1")
    local lagan2 = lagan:getChildByName("lagan2")


    local xx,yy = slot:getPosition()
    cclog("xx:"..xx..",yy:"..yy)
    self.org_slot = cc.p(xx, yy)


    local function relase(sender)
        local size = lagan:getContentSize()
        local posX,posY = slot:getPosition()
        local height = 100 - (self.org_slot.y - posY)
        lagan:setContentSize(cc.size(100,height))
        if height >= 100 then
            lagan:setContentSize(cc.size(100,100))
            lagan1:setPosition(cc.p(24,27)) 
            lagan1:setVisible(true)
            lagan2:setVisible(false)
            sender:stopAllActions()
        else
            if size.height == height then
                return
            end    
            
            local bh =(100 - height)/5
            if height >= 0 then
                lagan1:setVisible(true)
                lagan2:setVisible(false)
                lagan1:setPosition(cc.p(24,27 - bh)) 
            else
                lagan1:setVisible(false)
                lagan2:setVisible(true)
                lagan2:setPosition(cc.p(24,0 - bh)) 
            end    
        end    
    end

    local function onTouchBegan(touch, event)
        local target = event:getCurrentTarget()

        target:getPosition()
        local locationInNode = target:convertToNodeSpace(touch:getLocation())
        local s = target:getContentSize()
        local rect = cc.rect(0, 0, s.width, s.height)
        if cc.rectContainsPoint(rect, locationInNode) then
            slot:setPosition(self.org_slot)
            lagan:setContentSize(cc.size(50,100))
            lagan1:setPositionY(27) 

            lagan1:setVisible(true)
            lagan2:setVisible(false)
            return true
        end
        return false
    end
    local function onTouchMoved(touch, event)
        local target = event:getCurrentTarget()
        local posX,posY = target:getPosition()
        local delta = touch:getDelta()

        if posY + delta.y > self.org_slot.y then
            target:setPosition(cc.p(self.org_slot.x ,self.org_slot.y))
        elseif posY + delta.y < self.org_slot.y - 200 then
            target:setPosition(cc.p(posX ,self.org_slot.y - 200))
        else              
            target:setPosition(cc.p(self.org_slot.x , posY + delta.y))          
        end  
        --根据球的位置更新杆的位置
        posX,posY = target:getPosition()
        local height = 100 - (self.org_slot.y - (posY + 1))
        lagan:setContentSize(cc.size(100,height))
        local bh =(100 - height)/5
            if height >= 0 then
                lagan1:setVisible(true)
                lagan2:setVisible(false)
                lagan1:setPositionY(27 - bh) 
            else
                lagan1:setVisible(false)
                lagan2:setVisible(true)
                lagan2:setPositionY(10 - bh) 
            end      
    end

    local function onTouchEnded(touch, event)
        local size = lagan:getContentSize()
        if size.height < 20 then
            slot:runAction(cc.EaseIn:create(cc.MoveTo:create(0.2, self.org_slot),0.5))
            if ff.currentLayer ~= nil then
                ff.currentLayer:getChildByTag(90002):beginRoll()
            end 
            if self.isRolling == false then
                self:SendMessage()
            end   
        else    
            slot:runAction(cc.EaseIn:create(cc.MoveTo:create(0.2, self.org_slot),1))
        end    
        schedule(slot,relase,0.00)
    end 
    local function onTouchCancel(touch,event)
        local size = lagan:getContentSize()
        if size.height < 0 then
            slot:runAction(cc.EaseIn:create(cc.MoveTo:create(0.5, cc.p(368,55)),0.5))
        else    
            slot:runAction(cc.EaseIn:create(cc.MoveTo:create(0.5, cc.p(368,55)),1))
        end    
        schedule(slot,relase,0.01)
    end

    local listener = cc.EventListenerTouchOneByOne:create()
    listener:setSwallowTouches(true)
    listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN )
    listener:registerScriptHandler(onTouchMoved,cc.Handler.EVENT_TOUCH_MOVED )
    listener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED )
    listener:registerScriptHandler(onTouchCancel,cc.Handler.EVENT_TOUCH_CANCELLED )

    local eventDispatcher = self:getEventDispatcher()
   -- eventDispatcher:addEventListenerWithSceneGraphPriority(listener, slot)
end
function lotteryLayer:InitCheckBox()
    local button1 =  self.buttomarea:getChildByName("c_1")
    local button2 =  self.buttomarea:getChildByName("c_10")

    button1:addTouchEventListener(
        function (sender,eventType)
            if eventType == ccui.TouchEventType.ended then     
                self.jeton = 1 
                self:SlotAction()
            end
        end)

    button2:addTouchEventListener(
        function (sender,eventType)
            if eventType == ccui.TouchEventType.ended then     
                self.jeton = 10 
                self:SlotAction()
            end
        end)
end
function lotteryLayer:SlotAction()
    local slot  = self.mainarea:getChildByName("i_Slot")
    local lagan = self.mainarea:getChildByName("lagan")
    local lagan1 = lagan:getChildByName("lagan1")
    local lagan2 = lagan:getChildByName("lagan2")
    lagan2:setVisible(true)
 
    local time = 0
    local height = 100
    local size = lagan:getContentSize()
    function update(dt)
        time = time + dt
        if time > 0 and time < 0.2 then
            height = height - dt * 1000
            lagan:setContentSize(cc.size(100, height))
        elseif time > 0.2 and time < 0.32 then
            height = height + dt * 1000
            lagan:setContentSize(cc.size(100, height))
        elseif time > 0.33 then
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.schedule)
            self.schedule = nil
            lagan:setContentSize(size)
            lagan2:setVisible(false)
        end
    end 
    if self.schedule == nil and self.isRolling == false then
        self.schedule  = cc.Director:getInstance():getScheduler():scheduleScriptFunc(update, 0, false)
        slot:runAction(cc.Sequence:create(cc.MoveBy:create(0.2, cc.p( 0, - 200)), cc.MoveBy:create(0.12, cc.p(0, 200))))
        self:SendMessage()
    end
end
function lotteryLayer:onClose()
    if self.state ~= 1 then
        self:goToMain()
        --»Øµ½Ö÷½çÃæ
        return true
    else
        return false
    end
    return false
end
function lotteryLayer.onEnd(sender,btns)
    if btns == nil then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:unSelectBtns()
        end 
    end

    ff.net:removeEvent(2,dd.Tjf_lottery)
    ff.net:removeEvent(2,dd.Tjf_prop_buy)

    dd.delBackEvent()
    sender.mainarea:stopAllActions()
    sender.list[1]:stopAllActions()
    sender.list[1]:setPositionY(-390)
    sender.list[2]:stopAllActions()
    sender.list[2]:setPositionY(-390)
    sender.list[3]:stopAllActions()
    sender.list[3]:setPositionY(-390)
    sender.isRolling = false
    sender:stopAllActions()
    sender.jeton = 1
    sender.title:stopAllActions()
    sender.title:setPositionX(360)
    sender.ii = 1

     for i = 1, 16 do 
        if sender.star[i] ~= nil then
            sender.star[i]:removeFromParent(true)
            sender.star[i] = nil
        end
     end
    for i = 1, 31 do
        local item = sender:getChildByName("prizePanel"):getChildByTag(100+i)
        if item ~= nil then
            item:removeFromParent(true)
        end
    end
    local x =  sender:getChildByName("prizePanel"):getChildByName("prizeone"):getChildByTag(100)
    if x ~= nil then
        x:removeFromParent(true)
    end
     for l = 1, 5 do
            for k = 1, 6 do
                sender:getChildByName("prizePanel"):getChildByName("p"..l.."_"..k):removeAllChildren()  
            end
     end  
end
function lotteryLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("lottery")
        if widget~=nil and widget:onClose() == false then
            pop.onClosePopDialog("lottery")
        end    
    end
end
function onShowLottery(widget)
    local layer = lotteryLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end
