fightRepLayer = class("fightRepLayer")
fightRepLayer._name = "fightRep"
fightRepLayer._init = false
fightRepLayer._id = 0
fightRepLayer._info = nil
fightRepLayer._isAll = false
fightRepLayer._compare = false
fightRepLayer._fromView = false

function fightRepLayer.extend( target )
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,fightRepLayer)
	return target
	-- body
end

function onShowFightRep( widget,id ,isAll,fromView,info)
	-- body
	local layer = fightRepLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
	layer:onInit(id,isAll,fromView,info)
	return layer
end

function fightRepLayer.onReturn( sender,eventType )
	-- body
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("fightRep")
		if widget == nil then
			return
		end
        pop.onClosePopDialog("fightRep")
    end
end

function fightRepLayer.deletereport( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then   
        local widget = pop.getDialog("fightRep")
        if widget == nil then
            return
        end

        local message = ff.net:createMessage()
        message:addCmd(0x00000136)
        message:addLong(dd.uid)
            
        message:addLong(1)
        message:addLong(1)
        message:addLong(1) 
        message:addSuperLong(widget._id)

        ff.net:rpc(message,false)
        pop.onClosePopDialog("fightRep")
    end
end

function fightRepLayer:AutoSize(  )
	-- body
	local hh = ff.height
	self:setContentSize(cc.size(720,hh))
	self:setPositionY(0)
    self:getChildByName("show"):setContentSize(cc.size(720,hh))
    self:getChildByName("show"):setPositionY(0)
	self:getChildByName("back"):setContentSize(cc.size(720,hh))
	self:getChildByName("top"):setPositionY(hh - 105)

    --self:getChildByName("top"):getChildByName("chu_title"):setString(ff.langString("战报"))
    --self:getChildByName("top"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)

    self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    --self:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
    self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    self:getChildByName("title"):setPositionY(hh - 105 - 320)
    self:getChildByName("strinfo"):setPositionY(hh - 105 - 320 - 150)
    self:getChildByName("title"):getChildByName("clear"):addTouchEventListener(self.deletereport)

    self:getChildByName("back"):setPositionY(0)
    self:getChildByName("scrollview"):setContentSize(cc.size(720,hh-110 - 330))
    self:getChildByName("scrollview"):setPositionY(0)
end

function fightRepLayer:onInit( id ,isAll,fromView,info)
	-- body
	if self._init == false then
		self:AutoSize()
		self._init = true 
	end
	self._id = id 
    self._isAll = isAll
    self._compare = false
    self._info = info
    self._fromView = fromView
    if fromView == true then
        local effect = ff.Effect:effectGrey()    
       self:getChildByName("title"):getChildByName("clear"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
       self:getChildByName("title"):getChildByName("clear"):setTouchEnabled(false)
    else
        self:getChildByName("title"):getChildByName("clear"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        self:getChildByName("title"):getChildByName("clear"):setTouchEnabled(true)
    end
	self.updateGold()

end

function fightRepLayer.onEnd( sender )
	-- body
    ff.net:removeEvent(2,dd.Tjf_Get_Fight_Report)
    sender:getChildByName("show"):setVisible(false)
    dd.delBackEvent()
    --sender:getChildByName("scrollview"):removeAllChildren(true)
	
    if sender._info ~= nil then
    	if sender._info.Ainfo ~= nil then
    		sender._info.Ainfo:clear()
    	end
    	if sender._info.Binfo ~= nil then
    		sender._info.Binfo:clear()
    	end
    	if sender._info.amyInfo ~= nil then
    		sender._info.amyInfo:clear()
    	end
    	if sender._info.NPCInfo ~= nil then
    		sender._info.NPCInfo:clear()
    	end

        if sender._info.resInfo ~= nil then
            sender._info.resInfo:clear()
        end
    end

    sender:getChildByName("strinfo"):setVisible(false)
    local title = sender:getChildByName("title")
    title:getChildByName("red"):setVisible(false)
    title:getChildByName("lv"):setVisible(false)
    title:getChildByName("title"):setString("")
    title:getChildByName("info"):getChildByName("pos"):setString("")
    title:getChildByName("info"):getChildByName("time"):setString("")
    if ff.platform ~= 1 then
	   title:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
    sender:getChildByName("scrollview"):removeAllChildren(true)
    ff.net:unbindProperty("gold",2309)
end

function fightRepLayer.onStart( sender )
	-- body
    --sender:getChildByName("scrollview"):removeAllChildren(true)
    if sender._info == nil then
    	local message = ff.net:createMessage()
    	message:addCmd(0x00000027)
        message:addLong(dd.uid)
        message:addSuperLong(sender._id)
        message:addLong(0)
        ff.net:rpc(message,false)
    else
        sender:getChildByName("scrollview"):removeAllChildren(true)
        sender:showInfo()
    end
    ff.net:bindProperty(2309,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
end

function fightRepLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("fightRep")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end

function fightRepLayer:onGetFightInfo( params )
	-- body
	local code = params[1]
    if code == 0 then
        self._info = params[2]
        if self._info ~= nil and self._info.amyInfo ~= nil then
            for i=1,self._info.amyInfo:rowCount() do
                local index = self._info.amyInfo:rowCount()-i
                for j=1,index do
                    if tonumber(dd.cfgSoldier[self._info.amyInfo:getLong(j,"id")]["step"]) >  tonumber(dd.cfgSoldier[self._info.amyInfo:getLong(j+1,"id")]["step"]) then
                        local id = self._info.amyInfo:getLong(j,"id")
                        local playerid = self._info.amyInfo:getLong(j,"playerid")
                        
                        local power =  self._info.amyInfo:getLong(j,"power")
                        local powerlose =  self._info.amyInfo:getLong(j,"powerlose")
                        local medcnt =  self._info.amyInfo:getLong(j,"medcnt")

                        self._info.amyInfo:setLong(j,"id",self._info.amyInfo:getLong(j+1,"id"))
                        self._info.amyInfo:setLong(j,"playerid",self._info.amyInfo:getLong(j+1,"playerid"))
                        self._info.amyInfo:setLong(j,"power",self._info.amyInfo:getLong(j+1,"power"))
                        self._info.amyInfo:setLong(j,"powerlose",self._info.amyInfo:getLong(j+1,"powerlose"))
                        self._info.amyInfo:setLong(j,"medcnt",self._info.amyInfo:getLong(j+1,"medcnt"))
                        self._info.amyInfo:setLong(j+1,"id",id)
                        self._info.amyInfo:setLong(j+1,"playerid",playerid)
                        self._info.amyInfo:setLong(j+1,"power",power)
                        self._info.amyInfo:setLong(j+1,"powerlose",powerlose)
                        self._info.amyInfo:setLong(j+1,"medcnt",medcnt)
                    end
                end
            end
        end
        self:getChildByName("scrollview"):removeAllChildren(true)
        self:showInfo()
    else
        
        self.onReturn()
        dd.currentLayer._widget:onShowTips(ff.langString("该战报已被删除"))
        
        --dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(code))
    end
end

function fightRepLayer:showInfo(  )
	-- body
    local title = self:getChildByName("title")
	--local item = self:getChildByName("wininfo"):clone()
	--item:setVisible(true)
	--item:setTag(1)

    if self._isAll ~= 0 then
        self:getChildByName("strinfo"):setVisible(true)
        title:getChildByName("red"):setVisible(true)
        title:getChildByName("lv"):setVisible(false)
        title:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/battle/type/loss.png",0)
        title:getChildByName("title"):setString(ff.langString("你溃败了").."!") 
        local dateStr = ff.showData(self._info.time)

        title:getChildByName("info"):getChildByName('time'):setString(dateStr)
        local mapsite=dd.MapidToXY(self._info.pos)
        title:getChildByName("info"):getChildByName("pos"):setString(ff.langString("战斗坐标").." ("..mapsite.x..","..mapsite.y..")")   
        local message = ff.net:createMessage()
            message:addCmd(0x00000136)
            message:addLong(dd.uid)
            
            message:addLong(2)
            message:addLong(1)
            message:addLong(1)
            message:addSuperLong(self._id)
 
            ff.net:rpc(message,false)       
        return
    else
        local playerA = {}
        local playerB = {}
        local playerAID = 0
        local playerBID = 0
        if self._info.Ainfo ~= nil then
            if self._info.A_hero_Master_ID == 0 then
                playerA.ico = self._info.Ainfo:getLong(1,"ico")
                playerA.pos = self._info.Ainfo:getLong(1,"pos")
                playerA.name = self._info.Ainfo:getString(1,"name")
                playerA.powerUp = self._info.Ainfo:getLong(1,"powerUp")
                playerA.powerLose = self._info.Ainfo:getLong(1,"powerLose")
                playerA.official = self._info.Ainfo:getLong(1,"office")
            else
                for i=1,self._info.Ainfo:rowCount() do
                    if self._info.Ainfo:getLong(i,"id") == self._info.A_hero_Master_ID then
                        playerA.ico = self._info.Ainfo:getLong(i,"ico")
                        playerA.pos = self._info.Ainfo:getLong(i,"pos")
                        playerA.name = self._info.Ainfo:getString(i,"name")
                        playerA.powerUp = self._info.Ainfo:getLong(i,"powerUp")
                        playerA.powerLose = self._info.Ainfo:getLong(i,"powerLose")
                        playerA.official = self._info.Ainfo:getLong(i,"office")
                        break
                    end
                end
            end

            if self._info.A_hero_Master_ID > 0 then
                playerAID = self._info.A_hero_Master_ID
            else
                playerAID = self._info.Ainfo:getLong(1,"id")
            end
            playerA.getshi = 0
            playerA.getmu = 0
            playerA.gettie = 0
            playerA.getliang = 0
            playerA.getyin = 0
            playerA.getitem = 0
            playerA.getitemCnt = 0
         
           if self._info.resInfo ~= nil then
            for i=1,self._info.resInfo:rowCount() do

                if self._info.resInfo:getLong(i,"playerid") == playerAID then

                    local type =  self._info.resInfo:getLong(i,"itemType")
                    --cclog("=="..playerAID.."=="..type.."=="..self._info.resInfo:getLong(i,"itemCnt")) 
                    if tonumber(type) == 1 then
                        playerA.getitem = self._info.resInfo:getLong(i,"itemId")
                        playerA.getitemCnt = self._info.resInfo:getLong(i,"itemCnt")
                    elseif tonumber(type) == 2 then
                        playerA.getshi = self._info.resInfo:getLong(i,"itemCnt")
                    elseif tonumber(type) == 3 then
                        playerA.getmu = self._info.resInfo:getLong(i,"itemCnt")
                    elseif tonumber(type) == 4 then
                        playerA.gettie = self._info.resInfo:getLong(i,"itemCnt")
                    elseif tonumber(type) == 5 then
                        playerA.getliang = self._info.resInfo:getLong(i,"itemCnt")
                    elseif tonumber(type) == 6 then
                        playerA.getyin = self._info.resInfo:getLong(i,"itemCnt")
                    end
                end
             end   --print(i)
            end

        end


        if self._info.Binfo ~= nil then
   
            if self._info.Binfo:rowCount() > 0 then
                playerBID = self._info.Binfo:getLong(1,"id")
                playerB.ico = self._info.Binfo:getLong(1,"ico")
                playerB.pos = self._info.Binfo:getLong(1,"pos")
                playerB.name = self._info.Binfo:getString(1,"name")
                playerB.powerUp = self._info.Binfo:getLong(1,"powerUp")
                playerB.powerLose = self._info.Binfo:getLong(1,"powerLose")
                playerB.official = self._info.Binfo:getLong(1,"office")
                
            end
        end
        if playerA.getshi > 0 or playerA.getmu > 0 or playerA.gettie > 0 or playerA.getliang > 0 or playerA.getyin > 0 then
            local item4 = self:getChildByName("res1"):clone()
            item4:setVisible(true)
            local level = dd.myinfo:getLong(1,"level")
            if level <= 10 then
                item4:getChildByName("res1"):getChildByName("res1"):setPositionX(999)
                item4:getChildByName("res1"):getChildByName("res3"):setPositionX(999)
                item4:getChildByName("res1"):getChildByName("res5"):setPositionX(354)
            elseif level> 10 and level<= 14 then
                item4:getChildByName("res1"):getChildByName("res1"):setPositionX(354)
                item4:getChildByName("res1"):getChildByName("res3"):setPositionX(999)
                item4:getChildByName("res1"):getChildByName("res5"):setPositionX(495)
            else
                item4:getChildByName("res1"):getChildByName("res1"):setPositionX(354)
                item4:getChildByName("res1"):getChildByName("res3"):setPositionX(495)
                item4:getChildByName("res1"):getChildByName("res5"):setPositionX(636)
            end
            if playerA.getshi > 0 then
                item4:getChildByName("res1"):getChildByName("res1"):getChildByName("count"):setString("+"..dd.showKM(playerA.getshi,5))
            else
                item4:getChildByName("res1"):getChildByName("res1"):getChildByName("count"):setString("0")
            end
            if playerA.getmu > 0 then
                item4:getChildByName("res1"):getChildByName("res2"):getChildByName("count"):setString("+"..dd.showKM(playerA.getmu,5))
            else
                item4:getChildByName("res1"):getChildByName("res2"):getChildByName("count"):setString("0")
            end
            if playerA.gettie > 0 then
                item4:getChildByName("res1"):getChildByName("res3"):getChildByName("count"):setString("+"..dd.showKM(playerA.gettie,5))
            else
                item4:getChildByName("res1"):getChildByName("res3"):getChildByName("count"):setString("0")
            end
            if playerA.getliang > 0 then
                item4:getChildByName("res1"):getChildByName("res4"):getChildByName("count"):setString("+"..dd.showKM(playerA.getliang,5))
            else
                item4:getChildByName("res1"):getChildByName("res4"):getChildByName("count"):setString("0")
            end
            if playerA.getyin > 0 then
                item4:getChildByName("res1"):getChildByName("res5"):getChildByName("count"):setString("+"..dd.showKM(playerA.getyin,5))
            else
                item4:getChildByName("res1"):getChildByName("res5"):getChildByName("count"):setString("0")
            end
            self:getChildByName("scrollview"):pushBackCustomItem(item4)
        end

        if playerA.getitem > 0 and playerA.getitemCnt > 0 then
            local item41 = self:getChildByName("res2"):clone()
            item41:setVisible(true)
            item41:getChildByName("res1"):getChildByName("res1"):loadTexture(dd.getToolsIcon(playerA.getitem),0)
            item41:getChildByName("res1"):getChildByName("res1"):getChildByName("count"):setString("+"..dd.showKM(playerA.getitemCnt,5))
            
            self:getChildByName("scrollview"):pushBackCustomItem(item41)
        end

        self._info.compare.A_name = playerA.name
        self._info.compare.A_pos = playerA.pos
        self._info.compare.B_pos = playerB.pos
        self._info.compare.B_name = playerB.name
        self._info.compare.AIco = playerA.ico
        self._info.compare.BIco = playerB.ico

        
        
        local playerALeft = true
        if playerBID == dd.uid then
            playerALeft = false
        end

        if self._info.zhuajiang > 0 then
            cclog("zhuajiangzhuajiangzhuajiangzhuajiang="..self._info.zhuajiang)
            local item_0 = self:getChildByName("item_0"):clone()
            item_0:setVisible(true)
            self:getChildByName("scrollview"):pushBackCustomItem(item_0)
            if self._info.zhuajiang == 1 then
                if playerALeft == true then
                    item_0:getChildByName("player"):getChildByName("ico2"):loadTexture(dd.getPathFromUI("report_1.png",1))
                    item_0:getChildByName("heroInfo"):setString(ff.langString("你的英雄被抓走了！"))
                else
                    item_0:getChildByName("player"):getChildByName("ico2"):loadTexture(dd.getPathFromUI("report_2.png",1))
                    item_0:getChildByName("heroInfo"):setString(ff.langString("你抓获了目标的英雄！"))
                end
                item_0:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getHeroIcon(self._info.A_hero_ID),0)
            else
                if playerALeft == false then
                    item_0:getChildByName("player"):getChildByName("ico2"):loadTexture(dd.getPathFromUI("report_1.png",1))
                    item_0:getChildByName("heroInfo"):setString(ff.langString("你的英雄被抓走了！"))
                else
                    item_0:getChildByName("player"):getChildByName("ico2"):loadTexture(dd.getPathFromUI("report_2.png",1))
                    item_0:getChildByName("heroInfo"):setString(ff.langString("你抓获了目标的英雄！"))
                end
                item_0:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getHeroIcon(self._info.B_hero_ID),0)
            end

        end
        



        local button = self:getChildByName("button"):clone()
        button:setVisible(true)

        button:getChildByName("Button1"):setTag(1)
        button:getChildByName("Button1"):addTouchEventListener(self.RepEvent)
         local effect = ff.Effect:effectGrey()    
           button:getChildByName("Button2"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
           button:getChildByName("Button2"):setTouchEnabled(false)
        --button:getChildByName("Button2"):setTag(2)
        --button:getChildByName("Button2"):addTouchEventListener(self.RepEvent)
        if self._fromView == true then
            local effect = ff.Effect:effectGrey()    
           button:getChildByName("btnShare"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
           button:getChildByName("btnShare"):setTouchEnabled(false)
        else
            button:getChildByName("btnShare"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            button:getChildByName("btnShare"):setTouchEnabled(true)
        end
        button:getChildByName("btnShare"):addTouchEventListener(self.showShare)
        button:getChildByName("btnDetail"):addTouchEventListener(self.showOthers)


        self:getChildByName("scrollview"):pushBackCustomItem(button)
        self._info.compare.ALeft = playerALeft
        local wininfo = self:getChildByName("wininfo"):clone()
        wininfo:setVisible(true)

        self:getChildByName("scrollview"):pushBackCustomItem(wininfo)
        local itemA = wininfo:getChildByName("itemA")
        local itemB = wininfo:getChildByName("itemB")

        local dateStr = ff.showData(self._info.time)

        title:getChildByName("info"):getChildByName('time'):setString(dateStr)
        local mapsite=dd.MapidToXY(self._info.pos)
        title:getChildByName("info"):getChildByName("pos"):setString(ff.langString("战斗坐标").." ("..mapsite.x..","..mapsite.y..")")

        if playerALeft == true then
            itemA:getChildByName("icon"):loadTexture(dd.getPathFromUI("report_attack.png",1))
            itemB:getChildByName("icon"):loadTexture(dd.getPathFromUI("report_attack2.png",1))
            if self._info.result == 1 then
                title:getChildByName("red"):setVisible(false)
                title:getChildByName("lv"):setVisible(true)
                if self._info.Ainfo:rowCount() > 1 then
                    title:getChildByName("title"):setString(ff.langString("联合攻击成功"))
                else
                    title:getChildByName("title"):setString(ff.langString("攻击成功"))
                end
                title:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/battle/type/win.png",0)
                local effect = ff.Effect:effectGrey() 
                itemB:getChildByName("player"):getChildByName("ico"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
            else
                title:getChildByName("red"):setVisible(true)
                title:getChildByName("lv"):setVisible(false)
                if self._info.Ainfo:rowCount() > 1 then
                    title:getChildByName("title"):setString(ff.langString("联合攻击失败"))
                else
                    title:getChildByName("title"):setString(ff.langString("攻击失败"))
                end
                title:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/battle/type/loss.png",0)
                local effect = ff.Effect:effectGrey()    
                itemA:getChildByName("player"):getChildByName("ico"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())          
            end

            itemA:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(playerA.ico),0)
            
            local mapsite=dd.MapidToXY(playerA.pos)
            itemA:getChildByName("pos"):setString("("..mapsite.x..","..mapsite.y..")")

            if self._info.type ~= 5 and self._info.type ~= 15 and self._info.type ~= 14 then
                local mapsiteB=dd.MapidToXY(playerB.pos)
                itemB:getChildByName("pos"):setString("("..mapsiteB.x..","..mapsiteB.y..")")
            end
            
            if string.len(self._info.A_union_Name2 ) >0 then
                itemA:getChildByName("unionFlag"):setString("["..self._info.A_union_Name2.."]")
                self._info.compare.A_union_Name = self._info.A_union_Name2
            else
                itemA:getChildByName("unionFlag"):setString(ff.langString("暂无联盟"))
            end
            if string.len(self._info.B_union_Name2) > 0 then
                self._info.compare.B_union_Name = self._info.B_union_Name2
                itemB:getChildByName("unionFlag"):setString("["..self._info.B_union_Name2.."]")
            else
                itemB:getChildByName("unionFlag"):setString(ff.langString("暂无联盟"))
            end

            itemA:getChildByName("name"):setString(playerA.name)
            --cclog("===11111111111111111111111==========="..self._info.type)
            self._info.compare.type = self._info.type
            if self._info.type ~= 15 then
                itemB:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(playerB.ico),0)
                itemB:getChildByName("name"):setString(playerB.name)
            else
                itemB:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(1005),0)
                itemB:getChildByName("name"):setString(ff.langString("黑杰克"))
            end
            

            itemA:getChildByName("power"):setString("Power:"..dd.showKM(playerA.powerUp,6))
            itemB:getChildByName("power"):setString("Power:"..dd.showKM(playerB.powerUp,6))

            itemA:getChildByName("powerUse"):setString(ff.langString("战损")..":"..dd.showKM(playerA.powerLose,6))
            itemB:getChildByName("powerUse"):setString(ff.langString("战损")..":"..dd.showKM(playerB.powerLose,6))

            wininfo:getChildByName("Image_154"):getChildByName("Label"):setString(ff.langString("进攻方"))
            wininfo:getChildByName("Image_154_0"):getChildByName("Label"):setString(ff.langString("防御方"))
            wininfo:getChildByName("Image_160"):getChildByName("Label"):setString(ff.langString("进攻方总览"))
            wininfo:getChildByName("Image_160_0"):getChildByName("Label"):setString(ff.langString("防御方总览"))

            local panel = self:getChildByName("panel"):clone()
            panel:setVisible(true)
            panel:setContentSize(cc.size(700,465))
            local Achuzhan = 0
            local Ajisha = 0
            local Azhenwang = 0
            local Acuihui = 0
            local Bchuzhan = 0
            local Bzhenwang = 0
            local Bshoushang = 0
            local Bfangyugongshi = 0
            local Bchengfangsunshi = 0
                for i=1,self._info.amyInfo:rowCount() do
                    for j=1,self._info.Ainfo:rowCount() do
                        if self._info.Ainfo:getLong(j,"type") == 1 and self._info.amyInfo:getLong(i,"playerid") == self._info.Ainfo:getLong(j,"id") then
                            if dd.cfgSoldier[self._info.amyInfo:getLong(i,"id")]['type'] >= 10 then
                                Achuzhan = Achuzhan + self._info.amyInfo:getLong(i,"power")
                                Azhenwang = Azhenwang + self._info.amyInfo:getLong(i,"powerlose")
                                --Ashoushang = Ashoushang + self._info.amyInfo:getLong(i,"medcnt")
                            else
                                Achuzhan = Achuzhan + self._info.amyInfo:getLong(i,"power")
                                Azhenwang = Azhenwang + self._info.amyInfo:getLong(i,"powerlose")
                                --Ashoushang = Ashoushang + self._info.amyInfo:getLong(i,"medcnt")
                            end
                        end
                    end
                    if self._info.Binfo ~= nil then
                        for m=1,self._info.Binfo:rowCount() do
                            if self._info.Binfo:getLong(m,"type") == 1 and self._info.amyInfo:getLong(i,"playerid") == self._info.Binfo:getLong(m,"id") then
                                if dd.cfgSoldier[self._info.amyInfo:getLong(i,"id")]['type'] >= 10 and dd.cfgSoldier[self._info.amyInfo:getLong(i,"id")]['type'] < 20 then
                                    Bfangyugongshi = Bfangyugongshi + self._info.amyInfo:getLong(i,"power")
                                    Bchengfangsunshi = Bchengfangsunshi + self._info.amyInfo:getLong(i,"powerlose")
                                    Bchengfangsunshi = Bchengfangsunshi + self._info.amyInfo:getLong(i,"medcnt")
                                else
                                    Bchuzhan = Bchuzhan + self._info.amyInfo:getLong(i,"power")
                                    Bzhenwang = Bzhenwang + self._info.amyInfo:getLong(i,"powerlose")
                                    Bshoushang = Bshoushang + self._info.amyInfo:getLong(i,"medcnt")
                                end
                            end
                        end
                    end
                end
             self._info.compare.Achuzhan = Achuzhan
             self._info.compare.Bchuzhan = Bchuzhan
            local item8 = nil
            local item9 = nil
            if self._info.A_hero_level > 0 and self._info.A_hero_ID > 0 then
                local item7 = self:getChildByName("item"):clone()
                item7:setVisible(true)
                panel:addChild(item7)
                item7:setPosition(cc.p(1,360))
            
                item7:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getHeroIcon(self._info.A_hero_ID),0)
                item7:getChildByName("heroInfo"):setString(ff.langString(dd.cfgHero[self._info.A_hero_ID]['name']).."LV."..self._info.A_hero_level)
                item7:getChildByName("Exp"):setString("EXP + "..self._info.A_hero_exp)

                item8 = self:getChildByName("info"):clone()
                item8:setVisible(true)
                panel:addChild(item8)
                item8:setPosition(cc.p(1,0))
                
            else
                local item7 = self:getChildByName("item"):clone()
                item7:setVisible(true)
                panel:addChild(item7)
                item7:setPosition(cc.p(1,360))
                item7:getChildByName("player"):setVisible(false)
                item7:getChildByName("heroInfo"):setString(ff.langString("无英雄出战"))

                item8 = self:getChildByName("info"):clone()
                item8:setVisible(true)
                panel:addChild(item8)
                item8:setPosition(cc.p(1,0))
            end 
            if self._info.B_hero_level > 0 and self._info.B_hero_ID > 0 then
                local item7 = self:getChildByName("item"):clone()
                item7:setVisible(true)
                panel:addChild(item7)
                item7:setPosition(cc.p(354,360))
            
                item7:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getHeroIcon(self._info.B_hero_ID),0)
                item7:getChildByName("heroInfo"):setString(ff.langString(dd.cfgHero[self._info.B_hero_ID]['name']).."LV."..self._info.B_hero_level)
                item7:getChildByName("Exp"):setString("EXP + "..self._info.B_hero_exp)

                item9 = self:getChildByName("info"):clone()
                item9:setVisible(true)
                panel:addChild(item9)
                item9:setPosition(cc.p(354,0))
                
            else
                local item7 = self:getChildByName("item"):clone()
                item7:setVisible(true)
                panel:addChild(item7)
                item7:setPosition(cc.p(354,360))
                item7:getChildByName("player"):setVisible(false)
                item7:getChildByName("heroInfo"):setString(ff.langString("无英雄出战"))

                item9 = self:getChildByName("info"):clone()
                item9:setVisible(true)
                panel:addChild(item9)
                item9:setPosition(cc.p(354,0))
            end
            item8:getChildByName("ite1"):getChildByName("name"):setString(ff.langString("出战")..":")
            item8:getChildByName("ite1"):getChildByName("count"):setString(Achuzhan)
            item8:getChildByName("ite2"):getChildByName("name"):setString(ff.langString("击杀")..":")
            item8:getChildByName("ite2"):getChildByName("count"):setString(Bzhenwang)
            item8:getChildByName("ite3"):getChildByName("name"):setString(ff.langString("阵亡")..":")
            item8:getChildByName("ite3"):getChildByName("count"):setString(Azhenwang)
            item8:getChildByName("ite4"):getChildByName("name"):setString(ff.langString("摧毁")..":")
            item8:getChildByName("ite4"):getChildByName("count"):setString(Bchengfangsunshi)
            item8:getChildByName("ite5"):setVisible(false)
            item8:getChildByName("ite6"):setVisible(false)
            item8:getChildByName("ite7"):setVisible(false)
            item9:getChildByName("ite1"):getChildByName("name"):setString(ff.langString("出战")..":")
            item9:getChildByName("ite1"):getChildByName("count"):setString(Bchuzhan)
            item9:getChildByName("ite2"):getChildByName("name"):setString(ff.langString("击杀")..":")
            item9:getChildByName("ite2"):getChildByName("count"):setString(Azhenwang)
            item9:getChildByName("ite3"):getChildByName("name"):setString(ff.langString("阵亡")..":")
            item9:getChildByName("ite3"):getChildByName("count"):setString(Bzhenwang)
            item9:getChildByName("ite4"):getChildByName("name"):setString(ff.langString("受伤")..":")
            item9:getChildByName("ite4"):getChildByName("count"):setString(Bshoushang)
            item9:getChildByName("ite5"):getChildByName("name"):setString(ff.langString("防御工事")..":")
            item9:getChildByName("ite5"):getChildByName("count"):setString(Bfangyugongshi)
            item9:getChildByName("ite6"):getChildByName("name"):setString(ff.langString("城防损失")..":")
            item9:getChildByName("ite6"):getChildByName("count"):setString(Bchengfangsunshi)
            item9:getChildByName("ite7"):getChildByName("name"):setString(ff.langString("城防值")..":")
            item9:getChildByName("ite7"):getChildByName("count"):setString(self._info.nowcf)

            self:getChildByName("scrollview"):pushBackCustomItem(panel)
        else
            itemB:getChildByName("icon"):loadTexture(dd.getPathFromUI("report_attack.png",1))
            itemA:getChildByName("icon"):loadTexture(dd.getPathFromUI("report_attack2.png",1))
            if self._info.result == 1 then
                title:getChildByName("red"):setVisible(true)
                title:getChildByName("lv"):setVisible(false)
                if self._info.Binfo:rowCount() > 1 then
                    title:getChildByName("title"):setString(ff.langString("防御失败"))
                else
                    title:getChildByName("title"):setString(ff.langString("防御失败"))
                end
                local effect = ff.Effect:effectGrey()    
                title:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/battle/type/loss.png",0)
                itemA:getChildByName("player"):getChildByName("ico"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
            else
                title:getChildByName("red"):setVisible(false)
                title:getChildByName("lv"):setVisible(true)
                if self._info.Binfo:rowCount() > 1 then
                    title:getChildByName("title"):setString(ff.langString("防御成功"))
                else
                    title:getChildByName("title"):setString(ff.langString("防御成功"))
                end
                title:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/battle/type/win.png",0)
                local effect = ff.Effect:effectGrey()    
                itemB:getChildByName("player"):getChildByName("ico"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
            end

            itemB:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(playerA.ico),0)
            itemA:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(playerB.ico),0)
            local mapsite=dd.MapidToXY(playerA.pos)
            itemB:getChildByName("pos"):setString("("..mapsite.x..","..mapsite.y..")")
            local mapsiteB=dd.MapidToXY(playerB.pos)
            itemA:getChildByName("pos"):setString("("..mapsiteB.x..","..mapsiteB.y..")")

            if string.len(self._info.A_union_Name2 ) >0 then
                itemB:getChildByName("unionFlag"):setString("["..self._info.A_union_Name2.."]")
                self._info.compare.A_union_Name = self._info.A_union_Name2
            else
                itemB:getChildByName("unionFlag"):setString(ff.langString("暂无联盟"))
            end
            if string.len(self._info.B_union_Name2) > 0 then
                self._info.compare.B_union_Name = self._info.B_union_Name2
                itemA:getChildByName("unionFlag"):setString("["..self._info.B_union_Name2.."]")
            else
                itemA:getChildByName("unionFlag"):setString(ff.langString("暂无联盟"))
            end

            itemB:getChildByName("name"):setString(playerA.name)
            itemA:getChildByName("name"):setString(playerB.name)

            itemB:getChildByName("power"):setString("Power:"..dd.showKM(playerA.powerUp,6))
            itemA:getChildByName("power"):setString("Power:"..dd.showKM(playerB.powerUp,6))

            itemB:getChildByName("powerUse"):setString(ff.langString("战损")..":"..dd.showKM(playerA.powerLose,6))
            itemA:getChildByName("powerUse"):setString(ff.langString("战损")..":"..dd.showKM(playerB.powerLose,6))

            wininfo:getChildByName("Image_154_0"):getChildByName("Label"):setString(ff.langString("进攻方"))
            wininfo:getChildByName("Image_154"):getChildByName("Label"):setString(ff.langString("防御方"))
            wininfo:getChildByName("Image_160"):getChildByName("Label"):setString(ff.langString("防御方总览"))
            wininfo:getChildByName("Image_160_0"):getChildByName("Label"):setString(ff.langString("进攻方总览"))

            local panel = self:getChildByName("panel"):clone()
            panel:setVisible(true)
            panel:setContentSize(cc.size(700,465))
            local Achuzhan = 0
            local Ajisha = 0
            local Azhenwang = 0
            local Acuihui = 0
            local Bchuzhan = 0
            local Bzhenwang = 0
            local Bshoushang = 0
            local Bfangyugongshi = 0
            local Bchengfangsunshi = 0
                for i=1,self._info.amyInfo:rowCount() do
                    for j=1,self._info.Ainfo:rowCount() do
                        if self._info.Ainfo:getLong(j,"type") == 1 and self._info.amyInfo:getLong(i,"playerid") == self._info.Ainfo:getLong(j,"id") then
                            if dd.cfgSoldier[self._info.amyInfo:getLong(i,"id")]['type'] >= 10 then
                                Achuzhan = Achuzhan + self._info.amyInfo:getLong(i,"power")
                                Azhenwang = Azhenwang + self._info.amyInfo:getLong(i,"powerlose")
                                --Ashoushang = Ashoushang + self._info.amyInfo:getLong(i,"medcnt")
                            else
                                Achuzhan = Achuzhan + self._info.amyInfo:getLong(i,"power")
                                Azhenwang = Azhenwang + self._info.amyInfo:getLong(i,"powerlose")
                               -- Ashoushang = Ashoushang + self._info.amyInfo:getLong(i,"medcnt")
                            end
                        end
                    end
                    for m=1,self._info.Binfo:rowCount() do
                        if self._info.Binfo:getLong(m,"type") == 1 and self._info.amyInfo:getLong(i,"playerid") == self._info.Binfo:getLong(m,"id") then
                            if dd.cfgSoldier[self._info.amyInfo:getLong(i,"id")]['type'] >= 10 and dd.cfgSoldier[self._info.amyInfo:getLong(i,"id")]['type'] < 20 then
                                Bfangyugongshi = Bfangyugongshi + self._info.amyInfo:getLong(i,"power")
                                Bchengfangsunshi = Bchengfangsunshi + self._info.amyInfo:getLong(i,"powerlose")
                                Bchengfangsunshi = Bchengfangsunshi + self._info.amyInfo:getLong(i,"medcnt")
                            else
                                Bchuzhan = Bchuzhan + self._info.amyInfo:getLong(i,"power")
                                Bzhenwang = Bzhenwang + self._info.amyInfo:getLong(i,"powerlose")
                                Bshoushang = Bshoushang + self._info.amyInfo:getLong(i,"medcnt")
                            end
                        end
                    end
                end
            self._info.compare.Achuzhan = Achuzhan
            self._info.compare.Bchuzhan = Bchuzhan
            local item8 = nil
            local item9 = nil
            if self._info.A_hero_level > 0 and self._info.A_hero_ID > 0 then
                local item7 = self:getChildByName("item"):clone()
                item7:setVisible(true)
                panel:addChild(item7)
                item7:setPosition(cc.p(354,360))
            
                item7:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getHeroIcon(self._info.A_hero_ID),0)
                item7:getChildByName("heroInfo"):setString(ff.langString(dd.cfgHero[self._info.A_hero_ID]['name']).."LV."..self._info.A_hero_level)
                item7:getChildByName("Exp"):setString("EXP + "..self._info.A_hero_exp)

                item8 = self:getChildByName("info"):clone()
                item8:setVisible(true)
                panel:addChild(item8)
                item8:setPosition(cc.p(354,0))
                
            else
                local item7 = self:getChildByName("item"):clone()
                item7:setVisible(true)
                panel:addChild(item7)
                item7:setPosition(cc.p(354,360))
                item7:getChildByName("player"):setVisible(false)
                item7:getChildByName("heroInfo"):setString(ff.langString("无英雄出战"))

                item8 = self:getChildByName("info"):clone()
                item8:setVisible(true)
                panel:addChild(item8)
                item8:setPosition(cc.p(354,0))
            end 
            if self._info.B_hero_level > 0 and self._info.B_hero_ID > 0 then
                local item7 = self:getChildByName("item"):clone()
                item7:setVisible(true)
                panel:addChild(item7)
                item7:setPosition(cc.p(1,360))
            
                item7:getChildByName("player"):getChildByName("ico"):loadTexture(dd.getHeroIcon(self._info.B_hero_ID),0)
                item7:getChildByName("heroInfo"):setString(ff.langString(dd.cfgHero[self._info.B_hero_ID]['name']).."LV."..self._info.B_hero_level)
                item7:getChildByName("Exp"):setString("EXP + "..self._info.B_hero_exp)

                item9 = self:getChildByName("info"):clone()
                item9:setVisible(true)
                panel:addChild(item9)
                item9:setPosition(cc.p(1,0))
                
            else
                local item7 = self:getChildByName("item"):clone()
                item7:setVisible(true)
                panel:addChild(item7)
                item7:setPosition(cc.p(1,360))
                item7:getChildByName("player"):setVisible(false)
                item7:getChildByName("heroInfo"):setString(ff.langString("无英雄出战"))

                item9 = self:getChildByName("info"):clone()
                item9:setVisible(true)
                panel:addChild(item9)
                item9:setPosition(cc.p(1,0))
            end
            item8:getChildByName("ite1"):getChildByName("name"):setString(ff.langString("出战")..":")
            item8:getChildByName("ite1"):getChildByName("count"):setString(Achuzhan)
            item8:getChildByName("ite2"):getChildByName("name"):setString(ff.langString("击杀")..":")
            item8:getChildByName("ite2"):getChildByName("count"):setString(Bzhenwang)
            item8:getChildByName("ite3"):getChildByName("name"):setString(ff.langString("阵亡")..":")
            item8:getChildByName("ite3"):getChildByName("count"):setString(Azhenwang)
            item8:getChildByName("ite4"):getChildByName("name"):setString(ff.langString("摧毁")..":")
            item8:getChildByName("ite4"):getChildByName("count"):setString(Bchengfangsunshi)
            item8:getChildByName("ite5"):setVisible(false)
            item8:getChildByName("ite6"):setVisible(false)
            item8:getChildByName("ite7"):setVisible(false)
            item9:getChildByName("ite1"):getChildByName("name"):setString(ff.langString("出战")..":")
            item9:getChildByName("ite1"):getChildByName("count"):setString(Bchuzhan)
            item9:getChildByName("ite2"):getChildByName("name"):setString(ff.langString("击杀")..":")
            item9:getChildByName("ite2"):getChildByName("count"):setString(Azhenwang)
            item9:getChildByName("ite3"):getChildByName("name"):setString(ff.langString("阵亡")..":")
            item9:getChildByName("ite3"):getChildByName("count"):setString(Bzhenwang)
            item9:getChildByName("ite4"):getChildByName("name"):setString(ff.langString("受伤")..":")
            item9:getChildByName("ite4"):getChildByName("count"):setString(Bshoushang)
            item9:getChildByName("ite5"):getChildByName("name"):setString(ff.langString("防御工事")..":")
            item9:getChildByName("ite5"):getChildByName("count"):setString(Bfangyugongshi)
            item9:getChildByName("ite6"):getChildByName("name"):setString(ff.langString("城防损失")..":")
            item9:getChildByName("ite6"):getChildByName("count"):setString(Bchengfangsunshi)
            item9:getChildByName("ite7"):getChildByName("name"):setString(ff.langString("城防值")..":")
            item9:getChildByName("ite7"):getChildByName("count"):setString(self._info.nowcf)

            self:getChildByName("scrollview"):pushBackCustomItem(panel)

        end

    end


end

function fightRepLayer.onBefore( sender )
    ff.net:registerEvent(2,dd.Tjf_Get_Fight_Report,function (message)sender:onGetFightInfo(message)end)
    
end

function fightRepLayer.showOthers( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog('fightRep')
        if widget ~= nil then
            pop.onShowPopDialog("fightShowOthers",widget._info)
        end
    end
end

function fightRepLayer.showShare( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog('fightRep')
        if widget ~= nil then
           widget:getChildByName("show"):setVisible(true)
           dd.currentLayer._widget:showShare(widget._info,true)
        end
    end
end

function fightRepLayer.RepEvent( sender,eventType )
	-- body
	if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog('fightRep')
        
        if widget ~= nil then
            if sender:getName() == "Button1" then
                if widget._info.compare.canCompare ~= 0 then
                    if widget._compare == false then
                        pop.onShowPopDialog("fightCompare",widget._info.compare)
                        widget._compare = true
                    end
                else
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("此次战斗不能对比"))
                end
            elseif sender:getName() == "Button2" then
                dd.yunClose(4,widget._info,false)
            elseif sender:getName() == "Button3" then
             --dd.yunClose(4,widget._info,false)
            
            local have = false
                for i=1,dd.mybuilds:rowCount() do
                    if dd.mybuilds:getLong(i,"bid") == 22 then
                        if pop.isShowing("fightRep") then
                           pop.onClosePopDialog('fightRep')
                        end
                        if pop.isShowing("mail") then
                            pop.onClosePopDialog('mail')
                        end  
                        onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"))
                        have= true
                        return
                    end
                end
                if have == false then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("你没有医院，请建造一个医院来容纳伤员"))
                end
               
            end
        end
    end
end


function fightRepLayer.RepEvent2( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog('fightRep')
        
        
        dd.yunClose(4,widget._info,false)
    end
end