--邮件面板
mailLayer = class("mailLayer")
mailLayer._name = "mail"
mailLayer._init = false
--type 一级目录 1，报告2，收件箱，3，发件箱，4，通知
mailLayer._type = 2
--special 1,个人，2联盟，3，收藏
mailLayer._specialType = 1
--reptype 1,报告2，收藏
mailLayer._repType = 1
mailLayer._userMailCount = -1
mailLayer._unionMailCount = -1
mailLayer._isGet = false
mailLayer._userRecvID = -1
mailLayer._showData = nil

---报告用
mailLayer._repCount = 0
mailLayer._unSNCnt = 0
mailLayer._unRepCnt = 0
mailLayer._unResourceCnt = 0
mailLayer._unPveCnt = 0
mailLayer._repData = nil

--通知用
mailLayer._noticeCount = 0
mailLayer._NoticeData = nil

mailLayer._enemy = {}
mailLayer._animFrames = {}
mailLayer._tips = {}
mailLayer._Cfg_Activity = {}
    --self._infoEx = {}
--mailLayer._Cfg_ActivityEx = {}
mailLayer._canGet = true


require "view/mail/mailView"


function mailLayer.extend(target)
    local  t = tolua.getpeer(target)
    if not t then 
        t = {}
        tolua.setpeer(target,t)
    -- body
    end
    setmetatable(t,mailLayer)
    return target
end

function mailLayer:updateSqlMail(info)

    local tname = "client_recv_mail"
     
    for index=1, info:rowCount() do
        local row = ff.dbmanager:sql_fetch_rows("select * from client_recv_mail where `id`=='"..info:getSuperLong(index,"id" ).."' ")
        if row ~= nil and row:rowCount() >= 1 then
            spl  = "update "..tname.."(`id`,`time`,`mail_type`,`sender_uid`,`sender`,`sender_union`,`title`,`content`,`detail`,`read_flag`,`to_uid` ) values ("
        ..info:getSuperLong(index,"id")..","
        ..info:getLong(index,"time")..","
        ..info:getLong(index,"mail_type")..","
        ..info:getLong(index,"sender_uid")..",'"
        ..info:getString(index,"sender").."','"
        ..info:getString(index,"sender_union").."','"
        ..info:getString(index,"title").."','"
        ..info:getString(index,"content").."',"
        ..info:getString(index,"content").."',"
        ..info:getLong(index,"read_flag")..","
        ..dd.uid..")"
        else
           sql = "replace into "..tname.."(`id`,`time`,`mail_type`,`sender_uid`,`sender`,`sender_union`,`title`,`content`,`detail`,`read_flag`,`to_uid`) values ("
        ..info:getSuperLong(index,"id")..","
        ..info:getLong(index,"time")..","
        ..info:getLong(index,"mail_type")..","
        ..info:getLong(index,"sender_uid")..",'"
        ..info:getString(index,"sender").."','"
        ..info:getString(index,"sender_union").."','"
        ..info:getString(index,"title").."','"
        ..info:getString(index,"content").."',"
        ..info:getString(index,"content").."',"
        ..info:getLong(index,"read_flag")..","
        ..dd.uid..")"
        end

        ff.dbmanager:sql_query(sql)
    end
end

function mailLayer.onReturn( sender,eventType )
    -- body
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("mailReceive")
        if pop.isShowing("mailReceive") then
            if widget then
                widget.onReturn()
                return
            end
        else
            pop.onClosePopDialog("mail")
        end
    end
end

function mailLayer:showWaiting(play,needUp)
    self:getChildByName("waiting"):getChildByName("icon"):getVirtualRenderer():stopAllActions()
    if play == true and needUp ~= nil and needUp ~= 0 then
        
        local animation = cc.Animation:createWithSpriteFrames(self._animFrames, 0.1)
        self:getChildByName("waiting"):getChildByName("icon"):getVirtualRenderer():runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
        self:getChildByName("waiting"):setVisible(true) 
    else        
        function showMove()
            self:getChildByName("scrollview"):getInnerContainer():runAction(cc.MoveBy:create(0.5,cc.p(0,20)))
        end
        --if needUp ~= nil and needUp ~= 0 then
           -- self:runAction(cc.CallFunc:create(showMove))
        --end
        
        self:getChildByName("waiting"):setVisible(false)
    end
end


function mailLayer:initData( )
    self._userMailCount = -1
    self._unionMailCount = -1
    self._userRecvID = -1

    self._repCount = 0

    self._unSNCnt = 0
    self._unRepCnt = 0
    self._unResourceCnt = 0
    self._unPveCnt = 0
    self._noticeCount = 0
    self._tips = {0,0,0}
    self._tips[1] = dd.myinfo:getLong(1,"urumail")
    --显示数据绑定
    self._showData = ff.NetTable:create()
    self._showData:addStreamCol("id",ff.NET_SUPER_LONG)
    self._showData:addStreamCol("time",ff.NET_LONG)
    self._showData:addStreamCol("mail_type",ff.NET_LONG)
    self._showData:addStreamCol("sender_uid",ff.NET_LONG)
    self._showData:addStreamCol("sender",ff.NET_STRING,15)
    self._showData:addStreamCol("sender_union",ff.NET_STRING,3)
    self._showData:addStreamCol("title",ff.NET_STRING,63)
    self._showData:addStreamCol("content",ff.NET_STRING,31)
    self._showData:addStreamCol("to_uid",ff.NET_LONG)
    self._showData:addStreamCol("selected",ff.NET_LONG)
    self._showData:addStreamCol("read_flag",ff.NET_LONG)
    self._showData:addStreamCol("move",ff.NET_LONG)

    self._repData = ff.NetTable:create()
    self._repData:addStreamCol("id",ff.NET_SUPER_LONG)
    self._repData:addStreamCol("time",ff.NET_LONG)
    self._repData:addStreamCol("state",ff.NET_LONG)
    self._repData:addStreamCol("type",ff.NET_LONG)
    self._repData:addStreamCol("content",ff.NET_STRING,512)
    self._repData:addStreamCol("awardTime",ff.NET_LONG)
    self._repData:addStreamCol("awardStr",ff.NET_STRING,512)
    self._repData:addStreamCol("selected",ff.NET_LONG)
    self._repData:addStreamCol("selected2",ff.NET_LONG)

    self._NoticeData = ff.NetTable:create()
    self._NoticeData:addStreamCol("id",ff.NET_SUPER_LONG)
    self._NoticeData:addStreamCol("time",ff.NET_LONG)
    self._NoticeData:addStreamCol("state",ff.NET_LONG)
    self._NoticeData:addStreamCol("type",ff.NET_LONG)
    self._NoticeData:addStreamCol("content",ff.NET_STRING,512)
    self._NoticeData:addStreamCol("awardTime",ff.NET_LONG)
    self._NoticeData:addStreamCol("awardStr",ff.NET_STRING,512)
    self._NoticeData:addStreamCol("selected",ff.NET_LONG)
    self._NoticeData:addStreamCol("selected2",ff.NET_LONG)
    -- body
    local rows = ff.dbmanager:sql_fetch_rows("select * from cfg_enemy_inf")
        self._enemy = {}
        --cclog("========================"..rows:rowCount())
        for i=1,rows:rowCount() do
            local id = tonumber(rows:getString(i,"enemyid"))
            self._enemy[id] = {}
            if ff.lang == -1 then
                self._enemy[id]["name"] = rows:getString(i,"name")
                self._enemy[id]["tips"] = rows:getString(i,"disc")
            else
                self._enemy[id]["name"] = tonumber(rows:getString(i,"name_lan"))
                self._enemy[id]["tips"] = tonumber(rows:getString(i,"disc_lan"))
            end
            self._enemy[id]["image"] = tonumber(rows:getString(i,"pic"))
        end
    rows:clear()
     self._Cfg_Activity = {}
    --self._infoEx = {}
    --self._Cfg_ActivityEx = {}
    local propData1 = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_level_activity`")
    for i=1, propData1:rowCount() do
       local id = tonumber(propData1:getString(i, "id"))
       self._Cfg_Activity[id]={}
       self._Cfg_Activity[id]['target1'] = tonumber(propData1:getString(i, "target1"))
       self._Cfg_Activity[id]['num1'] = tonumber(propData1:getString(i, "number1"))
       self._Cfg_Activity[id]['reward1'] = tonumber(propData1:getString(i, "reward1"))
       self._Cfg_Activity[id]['target2'] = tonumber(propData1:getString(i, "target2"))
       self._Cfg_Activity[id]['num2'] = tonumber(propData1:getString(i, "number2"))
       self._Cfg_Activity[id]['reward2'] = tonumber(propData1:getString(i, "reward2"))
       self._Cfg_Activity[id]['target3'] = tonumber(propData1:getString(i, "target3"))
       self._Cfg_Activity[id]['num3'] = tonumber(propData1:getString(i, "number3"))
       self._Cfg_Activity[id]['reward3'] = tonumber(propData1:getString(i, "reward3"))
       self._Cfg_Activity[id]['target4'] = tonumber(propData1:getString(i, "target4"))
       self._Cfg_Activity[id]['num4'] = tonumber(propData1:getString(i, "number4"))
       self._Cfg_Activity[id]['reward4'] = tonumber(propData1:getString(i, "reward4"))
       self._Cfg_Activity[id]['target5'] = tonumber(propData1:getString(i, "target5"))
       self._Cfg_Activity[id]['num5'] = tonumber(propData1:getString(i, "number5"))
       self._Cfg_Activity[id]['reward5'] = tonumber(propData1:getString(i, "reward5"))
       self._Cfg_Activity[id]['target6'] = tonumber(propData1:getString(i, "target6"))
       self._Cfg_Activity[id]['num6'] = tonumber(propData1:getString(i, "number6"))
       self._Cfg_Activity[id]['reward6'] = tonumber(propData1:getString(i, "reward6"))
       self._Cfg_Activity[id]['target7'] = tonumber(propData1:getString(i, "target7"))
       self._Cfg_Activity[id]['num7'] = tonumber(propData1:getString(i, "number7"))
       self._Cfg_Activity[id]['reward7'] = tonumber(propData1:getString(i, "reward7"))
       self._Cfg_Activity[id]['target8'] = tonumber(propData1:getString(i, "target8"))
       self._Cfg_Activity[id]['num8'] = tonumber(propData1:getString(i, "number8"))
       self._Cfg_Activity[id]['reward8'] = tonumber(propData1:getString(i, "reward8"))

       if ff.lang == -1 then
            self._Cfg_Activity[id]['name']   = propData1:getString(i, "name")
            self._Cfg_Activity[id]['disc1']   = propData1:getString(i, "description1")
            self._Cfg_Activity[id]['disc2']   = propData1:getString(i, "description2")
            self._Cfg_Activity[id]['info']   = propData1:getString(i, "help4")
        else    
            self._Cfg_Activity[id]['name']   = tonumber(propData1:getString(i, "name_lan"))
            self._Cfg_Activity[id]['disc1']   = tonumber(propData1:getString(i, "description_lan1"))
            self._Cfg_Activity[id]['disc2']   = tonumber(propData1:getString(i, "description_lan2"))
            self._Cfg_Activity[id]['info']   = tonumber(propData1:getString(i, "help4_lan"))
         
        end
    end
    propData1:clear()

end


function mailLayer:unselectType()
    -- body
    self:getChildByName("topNavi"):getChildByName("btreport"):setSelectedState(false)
    self:getChildByName("topNavi"):getChildByName("receive"):setSelectedState(false)
    self:getChildByName("topNavi"):getChildByName("send"):setSelectedState(false)
    self:getChildByName("topNavi"):getChildByName("report"):setSelectedState(false)

    self:getChildByName("topNavi"):getChildByName("btreport"):getChildByName("chu_Label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi"):getChildByName("receive"):getChildByName("chu_Label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi"):getChildByName("send"):getChildByName("chu_Label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi"):getChildByName("report"):getChildByName("chu_Label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("string"):setString("");
    self:getChildByName("string"):setVisible(false)
end

function mailLayer:unselectSpecialType()
    self:getChildByName("mail_top"):getChildByName("user"):setSelectedState(false)
    self:getChildByName("mail_top"):getChildByName("union"):setSelectedState(false)
    self:getChildByName("mail_top"):getChildByName("collect"):setSelectedState(false)

    self:getChildByName("mail_top"):getChildByName("user"):getChildByName("Label"):setColor(cc.c3b(97,117,123))
    self:getChildByName("mail_top"):getChildByName("union"):getChildByName("Label"):setColor(cc.c3b(97,117,123))
    self:getChildByName("mail_top"):getChildByName("collect"):getChildByName("Label"):setColor(cc.c3b(97,117,123))
    -- body
end

function mailLayer:unselectRepType( )
    -- body
    self:getChildByName("mail_top_rep"):getChildByName("fight"):setSelectedState(false)
    self:getChildByName("mail_top_rep"):getChildByName("collect"):setSelectedState(false)

    self:getChildByName("mail_top_rep"):getChildByName("fight"):getChildByName("Label"):setColor(cc.c3b(97,117,123))
    self:getChildByName("mail_top_rep"):getChildByName("collect"):getChildByName("Label"):setColor(cc.c3b(97,117,123))
end

function mailLayer.selecRepType(sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog('mail')
        if widget ~= nil then
            widget:unselectRepType()
            if sender:getName() == "Label" then
                sender:setColor(cc.c3b(223,239,244))
                sender:getParent():setSelectedState(true)
            else
                sender:getChildByName("Label"):setColor(cc.c3b(223,239,244))
            end
            
            local RepType = sender:getTag()
            if widget._repType == RepType then
                return
            else
                widget._repType = RepType
                --widget:updateBtns()
                widget:getChildByName("mBtm"):setVisible(false)
                widget:getChildByName("oper"):getChildByName("checkAll"):setSelectedState(false)
            end
            if widget._type == 1 then
                widget:showReps()
            elseif widget._type == 4 then
                widget:showNotice()
            end
            --widget:showReps()
            --开界面

        end
    end
end

--上面4个类型选择控件
function mailLayer.selectType(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("mail")
        if widget ~= nil then
            widget:unselectType()
            sender:getChildByName("chu_Label"):setColor(cc.c3b(239,223,223))
            local type  = sender:getTag()
            if widget._type == type then
                return
            else
                if widget._type ~= 4 and type == 4 then
                    local hh = ff.height
                    widget:getChildByName("oper"):setPositionY(hh - 214 - 105 - 87-80)
                    widget:getChildByName("scrollview"):setContentSize(cc.size(720,hh - 214 - 105 - 87 -80))
                else
                    local hh = ff.height
                    widget:getChildByName("oper"):setPositionY(hh - 214 - 105 - 87 -100-80)
                    widget:getChildByName("scrollview"):setContentSize(cc.size(720,hh - 214 - 105 - 87 -100-80))
                end
                widget._type = type
                widget:getChildByName("mBtm"):setVisible(false)
                widget:getChildByName("oper"):getChildByName("checkAll"):setSelectedState(false)
            end
            widget._specialType = 1
            widget._repType = 1
            widget:unselectRepType()
            if widget._repType == 1 then
                widget:getChildByName("mail_top_rep"):getChildByName("fight"):getChildByName("Label"):setColor(cc.c3b(223,239,244))
                widget:getChildByName("mail_top_rep"):getChildByName("fight"):setSelectedState(true)
            end
            widget:unselectSpecialType()
            if widget._specialType == 1 then
                widget:getChildByName("mail_top"):getChildByName("user"):getChildByName("Label"):setColor(cc.c3b(223,239,244))
                widget:getChildByName("mail_top"):getChildByName("user"):setSelectedState(true)
            end
            --根据type进入不用界面
            if widget._type == 2   then
                
                widget:getChildByName("oper"):getChildByName("write"):setVisible(true)
                widget:getChildByName("oper"):getChildByName("write"):setTouchEnabled(true)
                widget:showSendMails()
                widget:getChildByName("mail_top"):getChildByName("collect"):setVisible(true)
                widget:getChildByName("mail_top"):getChildByName("collect"):setTouchEnabled(true)
               
            elseif widget._type == 3 then
                widget:getChildByName("oper"):getChildByName("write"):setVisible(true)
                widget:getChildByName("oper"):getChildByName("write"):setTouchEnabled(true)
                widget:getChildByName("mail_top"):getChildByName("collect"):setVisible(false)
                widget:getChildByName("mail_top"):getChildByName("collect"):setTouchEnabled(false)
               
                widget:showSendMails()
            elseif widget._type == 1 then
                widget:getChildByName("oper"):getChildByName("write"):setVisible(false)
                widget:getChildByName("oper"):getChildByName("write"):setTouchEnabled(false)
                widget:getChildByName("mail_top_rep"):getChildByName("collect"):setVisible(true)
                if widget:getChildByName("oper"):isVisible() == false then
                    local hh = ff.height
                    widget:getChildByName("scrollview"):setContentSize(cc.size(720,hh - 214 - 105 - 87 -110))
                end
                widget:showReps()
            elseif widget._type == 4 then
                widget:getChildByName("oper"):getChildByName("write"):setVisible(false)
                widget:getChildByName("oper"):getChildByName("write"):setTouchEnabled(false)
                --widget:getChildByName("mail_top_rep"):getChildByName("collect"):setVisible(false)
                widget:showNotice()
            end
           --widget:checkBtnAll()
        end
    end
    -- body
end

function mailLayer.selectSpecialType( sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog('mail')
        if widget ~= nil then
            widget:unselectSpecialType()
            if sender:getName() == "Label" then
                sender:setColor(cc.c3b(223,239,244))
                sender:getParent():setSelectedState(true)
            else
                sender:getChildByName("Label"):setColor(cc.c3b(223,239,244))
            end
            
            local specialType = sender:getTag()
            if widget._specialType == specialType then
                return
            else
                widget._specialType = specialType
                --widget:updateBtns()
                widget:getChildByName("mBtm"):setVisible(false)
                widget:getChildByName("oper"):getChildByName("checkAll"):setSelectedState(false)
            end
            widget:showSendMails()
            --开界面
            --widget:checkBtnAll()
        end
    end
    -- body
end

--1,个人收件
--2,联盟收件
--3,收藏收件
--4，个人发件
--5，联盟发件
--6，收藏发件

function mailLayer:getMailListByType(  needUp)
    local maxid = 0
    local minid = 0

   if self._userMailCount == -1 then
        maxid = 0
        minid = 0
    else
        maxid = self._userRecvID
        minid = 0
    end    

    cclog("type "..maxid.."special"..minid)
    

    local getMailListMsg = ff.net:createMessage()

    if self._type == 2   then
        if self._specialType == 3 then
            getMailListMsg:addCmd(0xE0C)
            getMailListMsg:addLong(dd.uid)
            getMailListMsg:addLong(0)
            getMailListMsg:addLong(0)
            getMailListMsg:addLong(1)
        else
            getMailListMsg:addCmd(0xE0A)
            getMailListMsg:addLong(dd.uid)
            getMailListMsg:addSuperLong(maxid)
            getMailListMsg:addSuperLong(minid)
            getMailListMsg:addLong(self._specialType)
            getMailListMsg:addLong(1)
        end
        
    elseif self._type == 3 then
        if self._specialType == 3 then
            getMailListMsg:addCmd(0xE0C)
            getMailListMsg:addLong(dd.uid)
            getMailListMsg:addLong(0)
            getMailListMsg:addLong(0)
            getMailListMsg:addLong(1)
        else
            getMailListMsg:addCmd(0xE0A)
            getMailListMsg:addLong(dd.uid)
            getMailListMsg:addSuperLong(maxid)
            getMailListMsg:addSuperLong(minid)
            getMailListMsg:addLong(self._specialType)
            getMailListMsg:addLong(2)
        end
    end
    ff.net:rpc(getMailListMsg,false)
    self:showWaiting(true,needUp)
    self._isGet = true
    -- body
end

function mailLayer:getRepListByType( needUp )
    -- body
    local max = self._repCount
    local min = 0
   
    local getRepMsg = ff.net:createMessage()
    getRepMsg:addCmd(0x00000045)
    getRepMsg:addLong(dd.uid)
    getRepMsg:addLong(2)
    if self._repType == 2 then
        getRepMsg:addLong(1)
        --cclog("===nimei+!!!!!!!!!!!!!!!!!!!")
    else
        getRepMsg:addLong(0)
    end
    getRepMsg:addSuperLong(max)
    getRepMsg:addSuperLong(min)
    --cclog("max="..max.."min="..min)
    ff.net:rpc(getRepMsg,false)
    self:showWaiting(true,needUp)
    self._isGet = true
end

function mailLayer:getNoticeListByType( needUp )
    -- body
    local max = self._noticeCount
    local min = 0

    local getRepMsg = ff.net:createMessage()
    getRepMsg:addCmd(0x00000045)
    getRepMsg:addLong(dd.uid)
    getRepMsg:addLong(1)
    if self._repType == 2 then
        getRepMsg:addLong(1)
        --cclog("===nimei+!!!!!!!!!!!!!!!!!!!")
    else
        getRepMsg:addLong(0)
    end
    getRepMsg:addSuperLong(max)
    getRepMsg:addSuperLong(min)
    --cclog("max="..max.."min="..min)
    ff.net:rpc(getRepMsg,false)
    self:showWaiting(true,needUp)
end

function mailLayer.BtnDeleteEvent(sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        widget:getChildByName("oper"):getChildByName("checkAll"):setSelectedState(false)
        if widget._type == 2 or widget._type == 3 then        
            if widget._showData:rowCount() > 0 then
                local message = ff.net:createMessage()
                message:addCmd(0xF09)
                message:addLong(dd.uid)
                if widget._type == 2 then
                    message:addLong(1)
                elseif widget._type == 3 then
                    message:addLong(3)
                end

                local count = 0
                for i=1,widget._showData:rowCount() do
                   if widget._showData:getLong(i,"selected") == 1 then
                        count = count + 1
                   end
                end
                cclog("要删除的邮件数："..count)
                message:addLong(count)

                for var=1, widget._showData:rowCount() do
                    if widget._showData:getLong(var,'selected') == 1 then
                        message:addSuperLong(widget._showData:getSuperLong(var,"id"))
                        message:addLong(0)
                    end
                end
                
                ff.net:rpc(message,false)
            end   
            widget:clearSelect() 
        elseif widget._type == 1 then
            if widget._repData:rowCount() > 0 then
            local message = ff.net:createMessage()
            message:addCmd(0x00000136)
            message:addLong(dd.uid)
            
            message:addLong(1)
            message:addLong(1)
            local count = 0
            for i=1,widget._repData:rowCount() do
               if widget._repData:getLong(i,"selected2") == 1 then
                    count = count + 1
               end
            end
            --cclog("要报告的邮件数："..count)
            message:addLong(count)

            for var=1, widget._repData:rowCount() do
                if widget._repData:getLong(var,'selected2') == 1 then
                    message:addSuperLong(widget._repData:getSuperLong(var,"id"))
                    --cclog("=="..widget._repData:getSuperLong(var,"id"))
                end
            end
            ff.net:rpc(message,false)
            end  
            widget:clearRepSelect() 
        elseif widget._type == 4 then
            if widget._NoticeData:rowCount() > 0 then
            local message = ff.net:createMessage()
            message:addCmd(0x00000136)
            message:addLong(dd.uid)
            
            message:addLong(1)
            message:addLong(1)
            local count = 0
            local haveAward = false
            for i=1,widget._NoticeData:rowCount() do
               if widget._NoticeData:getLong(i,"selected2") == 1 then
                    count = count + 1
                    if widget._NoticeData:getLong(i,"awardTime") == 0 then
                        haveAward = true
                    end
               end
            end
            --cclog("要报告的邮件数："..count)
            message:addLong(count)

            for var=1, widget._NoticeData:rowCount() do
                if widget._NoticeData:getLong(var,'selected2') == 1 then
                    message:addSuperLong(widget._NoticeData:getSuperLong(var,"id"))
                    --cclog("=="..widget._repData:getSuperLong(var,"id"))
                end
            end
            if haveAward == true then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("有通知中包含未领取奖励，无法删除"))
                return
            else
                ff.net:rpc(message,false)
            end
            
            
            end  
            widget:clearRepSelect() 
        end
    end
end

function mailLayer:clearSelect()
    if self._showData:rowCount() > 0 then
        for var=1, self._showData:rowCount() do
            if self._showData:getLong(var,'selected') == 1 then
                self._showData:setLong(var,"selected",0)
            end
            local item = self:getChildByName("scrollview"):getChildByTag(var)
            if item ~= nil then
                item:getChildByName("checkbox"):setSelectedState(false)
            end
        end
    end
     self:updateBtns()
     --self:showMails()
    -- body
end

function mailLayer:clearRepSelect()
    if self._type == 1 then
    if self._repData:rowCount() > 0 then
        for var=1, self._repData:rowCount() do
            if self._repData:getLong(var,'selected2') == 1 then
                self._repData:setLong(var,"selected2",0)
            end
            local item = self:getChildByName("scrollview"):getChildByTag(var)
            if item ~= nil then
                item:getChildByName("checkbox"):setSelectedState(false)
            end
        end
    end
    elseif self._type == 4 then
        if self._NoticeData:rowCount() > 0 then
        for var=1, self._NoticeData:rowCount() do
            if self._NoticeData:getLong(var,'selected2') == 1 then
                self._NoticeData:setLong(var,"selected2",0)
            end
            local item = self:getChildByName("scrollview"):getChildByTag(var)
            if item ~= nil then
                item:getChildByName("checkbox"):setSelectedState(false)
            end
        end
    end
    end
     self:updateBtns()
     --self:onShowReps()
    -- body
end

function mailLayer.BtnReadEvent( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then   
        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        widget:getChildByName("oper"):getChildByName("checkAll"):setSelectedState(false)
        if widget._type == 2 or widget._type == 3 then
        if widget._showData:rowCount() > 0 then
            local message = ff.net:createMessage()
            message:addCmd(0xF09)
            message:addLong(dd.uid)
            message:addLong(2)

            local count = 0
            for i=1,widget._showData:rowCount() do
               if widget._showData:getLong(i,"selected") == 1 then
                    count = count + 1
                    widget:setMailRead(i)
               end
            end
           -- cclog("要标记已读的邮件数："..count)
            message:addLong(count)

            for var=1, widget._showData:rowCount() do
                if widget._showData:getLong(var,'selected') == 1 then
                    message:addSuperLong(widget._showData:getSuperLong(var,"id"))
                    message:addLong(widget._showData:getLong(var,"read_flag"))
                end
            end
            ff.net:rpc(message,false)
        end    
        widget:clearSelect() 
    elseif widget._type == 1 then
        if widget._repData:rowCount() > 0 then
            local message = ff.net:createMessage()
            message:addCmd(0x00000136)
            message:addLong(dd.uid)
            
            message:addLong(2)
            message:addLong(1)
            local count = 0
            for i=1,widget._repData:rowCount() do
               if widget._repData:getLong(i,"selected2") == 1 then
                    count = count + 1
               end
            end
            --cclog("要报告的邮件数："..count)
            message:addLong(count)

            for var=1, widget._repData:rowCount() do
                if widget._repData:getLong(var,'selected2') == 1 then
                    message:addSuperLong(widget._repData:getSuperLong(var,"id"))
                    --cclog("=="..widget._repData:getSuperLong(var,"id"))
                end
            end
            --local num = widget._showData:rowCount()
            --for var=1 ,num do
                --for i=1,widget._showData:rowCount() do
                    --if widget._showData:getLong(i,"selected") == 1 then
                       -- widget._showData:delRow(i)
                    --break
                    --end
                --end
            --end
            
            ff.net:rpc(message,false)
            end  
            widget:clearRepSelect() 
    elseif widget._type == 4 then
        if widget._NoticeData:rowCount() > 0 then
            local message = ff.net:createMessage()
            message:addCmd(0x00000136)
            message:addLong(dd.uid)
            
            message:addLong(2)
            message:addLong(1)
            local count = 0
            for i=1,widget._NoticeData:rowCount() do
               if widget._NoticeData:getLong(i,"selected2") == 1 then
                    count = count + 1
               end
            end
            --cclog("要报告的邮件数："..count)
            message:addLong(count)

            for var=1, widget._NoticeData:rowCount() do
                if widget._NoticeData:getLong(var,'selected2') == 1 then
                    message:addSuperLong(widget._NoticeData:getSuperLong(var,"id"))
                    --cclog("=="..widget._repData:getSuperLong(var,"id"))
                end
            end
            --local num = widget._showData:rowCount()
            --for var=1 ,num do
                --for i=1,widget._showData:rowCount() do
                    --if widget._showData:getLong(i,"selected") == 1 then
                       -- widget._showData:delRow(i)
                    --break
                    --end
                --end
            --end
            
            ff.net:rpc(message,false)
        end  
            widget:clearRepSelect() 
        end
    end
end

function mailLayer.BtnALLEvent( sender,eventType  )
    -- body
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        local isAll = true
        isAll = ((sender:getSelectedState() == true) and true) or false
        if widget._type == 2 or widget._type == 3 and widget._showData ~= nil then 
            for i=1,widget._showData:rowCount() do
                local item = widget:getChildByName("scrollview"):getChildByTag(i)
                if isAll ~= true then
                    widget._showData:setLong(i,"selected",1)
                    if item ~= nil then
                        item:getChildByName("checkbox"):setSelectedState(true)
                    end
                else
                    widget._showData:setLong(i,"selected",0)
                    if item ~= nil then
                        item:getChildByName("checkbox"):setSelectedState(false)
                    end
                end
            end
        elseif widget._type == 1 and widget._repData ~= nil then
            --cclog("nimeiaaa==="..widget._repData:rowCount())
            for i=1,widget._repData:rowCount() do
                
                local type = widget._repData:getLong(i,"type")
                if type ~= 201 and type ~= 211 and type ~= 214 and type ~= 215 and type ~= 216 and type ~= 217 and type ~= 218  then
                    --cclog("type===="..type)
                    local item = widget:getChildByName("scrollview"):getChildByTag(i)
                    if isAll ~= true then
                        widget._repData:setLong(i,"selected2",1)
                        
                        --cclog("count=="..i)
                        if item ~= nil then
                            item:getChildByName("checkbox"):setSelectedState(true)
                        end
                    else
                        widget._repData:setLong(i,"selected2",0)
                        
                        --cclog("count=="..i)
                        if item ~= nil then
                            item:getChildByName("checkbox"):setSelectedState(false)
                        end
                    end
                    
                end
            end
         elseif widget._type == 4 and widget._NoticeData ~= nil then
            for i=1,widget._NoticeData:rowCount() do
                local item = widget:getChildByName("scrollview"):getChildByTag(i)
                if isAll ~= true then
                    widget._NoticeData:setLong(i,"selected2",1)
                    if item ~= nil then
                        item:getChildByName("checkbox"):setSelectedState(true)
                    end
                else
                    widget._NoticeData:setLong(i,"selected2",0)
                    if item ~= nil then
                        item:getChildByName("checkbox"):setSelectedState(false)
                    end
               end
            end
        end
        widget:updateBtns()
    end
end

function mailLayer.BtnALLEventEx( sender,eventType  )
    -- body
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end

        widget.BtnALLEvent(widget:getChildByName("oper"):getChildByName("checkAll"),eventType)
        if widget:getChildByName("oper"):getChildByName("checkAll"):getSelectedState() == true then
            widget:getChildByName("oper"):getChildByName("checkAll"):setSelectedState(false)
        else
            widget:getChildByName("oper"):getChildByName("checkAll"):setSelectedState(true)
        end
    end
end

function mailLayer:addUiEvent( )
    local function updateReceiveMsg( mailList )
        if mailList == nil then
            return
        end
        local count = 1
        if self._userMailCount == -1 then
            count = 0
        end
        local viewmails  = 0
        if mailList.info ~= nil then
           self:updateMails(mailList)
           function showMove()
                self:getChildByName("scrollview"):getInnerContainer():runAction(cc.MoveBy:create(0.5,cc.p(0,20)))
            end
            if self._showData:rowCount() > 10 then
                self:runAction(cc.CallFunc:create(showMove))
            else
                self:getChildByName("scrollview"):jumpToTop()
            end
        end
        self:checkBtnAll()

        if self._type == 2  or self._type == 3 then
            if mailList.mtype == 1 then
                if self._userMailCount ~= -1 then
                    
                end
                self._userMailCount = mailList.allMailNum

            elseif mailList.mtype == 2 then
                if self._unionMailCount ~= -1 then
                    function showMove()
                        self:getChildByName("scrollview"):getInnerContainer():runAction(cc.MoveBy:create(0.5,cc.p(0,20)))
                    end
                    --self:runAction(cc.CallFunc:create(showMove))
                end
                self._unionMailCount = mailList.allMailNum
            end

        end

        if self._isGet == true then
            self._isGet = false
        end
        
        self:showWaiting(false)
        -- body
    end

    local function updateSaveView(mailList)
        if mailList == nil then
            return
        end   

        local viewmails = 0
        if mailList.mtype == 1 then
            if self._userMailCount ~= -1 then
                function showMove()
                    self:getChildByName("scrollview"):getInnerContainer():runAction(cc.MoveBy:create(0.5,cc.p(0,20)))
                end
            end
            self._userMailCount = mailList.allMailNum
        end 
        viewmails = self:updateMails(mailList)
        if mailList.info ~= nil then
            mailList.info:clear()
            mailList.info = nil
        end   
        self:showWaiting(false) 
    end

    local function updateMailAction(info)
        if info == nil then
            return
        end
        if info.opType == 1 or info.opType == 3 then

             for row=1,info.info:rowCount() do
                local id = info.info:getSuperLong(row,"id")
                if self._showData ~= nil then
                    for i=1,self._showData:rowCount() do
                        if id == self._showData:getSuperLong(i,"id") then
                            if ff._and(self._showData:getLong(i,"read_flag"),1)  ~= 1 then
                                if self._showData:getLong(i,"mail_type") == 1 then
                                    dd.myinfo:setLong(1,"uruionmail",(dd.myinfo:getLong(1,"uruionmail")  -1 ))

                                end
                                    dd.myinfo:setLong(1,"urumail",(dd.myinfo:getLong(1,"urumail")  -1 ))
                                --end
                            end
                            
                            self._showData:delRow(i)

                            ff.dbmanager:sql_query("delete from client_recv_mail where `id`='"..id.."'")
                            break
                        end
                    end
                end
            end
            self:showSendMails()
        elseif info.opType == 2 then
            for row=1,info.info:rowCount() do
                local id = info.info:getSuperLong(row,"id")
                if self._showData ~= nil then
                    for i=1,self._showData:rowCount() do
                        if id == self._showData:getSuperLong(i,"id") then
                            if ff._and(self._showData:getLong(i,"read_flag"),1) ~= 1 then
                                if self._showData:getLong(i,"mail_type") == 1 then
                                    dd.myinfo:setLong(1,"uruionmail",(dd.myinfo:getLong(1,"uruionmail")  -1 ))
                                    
                                end
                                    dd.myinfo:setLong(1,"urumail",(dd.myinfo:getLong(1,"urumail")  -1 ))
                                --end
                                self:setMailRead(i)
                            end
                            self._showData:setLong(i,"read_flag",1)
                            ff.dbmanager:sql_query("update  client_recv_mail set 'read_flag' = '1' where `id`='"..id.."'")
                            break
                        end
                    end
                end
            end
        end
        self:clearSelect()
    end

    local function updateMailColloct(info)
        if info == nil then
            return
        end

        if info.type == 1 then

            if self._showData ~= nil then
                for i=1,self._showData:rowCount() do
                    if info.id == self._showData:getSuperLong(i,"id") then
                        self._showData:setLong(i,"read_flag",3)
                        local item = self:getChildByName("scrollview"):getChildByTag(i)
                            if item ~= nil then

                                if info.op == 1 then
                                    if item:getChildByName("iscollect"):getSelectedState() == false then
                                        item:getChildByName("iscollect"):setSelectedState(true)
                                    end
                                elseif info.op == 2 then
                                    if item:getChildByName("iscollect"):getSelectedState() == true then
                                        item:getChildByName("iscollect"):setSelectedState(false)
                                    end
                                end
                            end        
                        break
                    end
                end
            end
        end
    end

    local function updateRepAction(info)
        if info == nil then
            return
        end
        if self._type == 1 then
        if info.opType == 1  then

             for row=1,info.info:rowCount() do
                local id = info.info:getSuperLong(row,"id")
                if self._repData ~= nil then
                    for i=1,self._repData:rowCount() do
                        if id == self._repData:getSuperLong(i,"id") then
                            self._repData:delRow(i)
                            break
                        end
                    end
                end
            end
            self:showReps()
        elseif info.opType == 2 then
            for row=1,info.info:rowCount() do
                local id = info.info:getSuperLong(row,"id")
                if self._repData ~= nil then
                    for i=1,self._repData:rowCount() do
                        if id == self._repData:getSuperLong(i,"id") then
                            local state = self._repData:getLong(i,"state")
                            self._repData:setLong(i,"state",info.state)
                            local item = self:getChildByName("scrollview"):getChildByTag(i)
                            if item ~= nil then
                                if self._repData:getLong(i,"state") == 0 then
                                    --item:getChildByName("read"):setVisible(true)
                                    item:getChildByName("iscollect"):setSelectedState(false)
                                elseif self._repData:getLong(i,"state") == 3 then
                                    --item:getChildByName("read"):setVisible(false)
                                    
                                    item:getChildByName("iscollect"):setSelectedState(true)
                                    self:setRpRead(i)
                                elseif self._repData:getLong(i,"state") == 1 then
                                    if state == 3 then
                                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("取消收藏成功"),true)
                                    end
                                    self:setRpRead(i)
                                    --item:getChildByName("read"):setVisible(false)
                                    item:getChildByName("iscollect"):setSelectedState(false)
                                end
                            end
                            break
                        end
                    end
                end
            end
        end
        self:clearRepSelect()
        elseif self._type == 4 then
            if info.opType == 1  then

             for row=1,info.info:rowCount() do
                local id = info.info:getSuperLong(row,"id")
                if self._NoticeData ~= nil then
                    for i=1,self._NoticeData:rowCount() do
                        if id == self._NoticeData:getSuperLong(i,"id") then
                            self._NoticeData:delRow(i)
                            break
                        end
                    end
                end

            end
            self:showNotice()
        elseif info.opType == 2 then
           
            for row=1,info.info:rowCount() do
                local id = info.info:getSuperLong(row,"id")
                if self._NoticeData ~= nil then
                    for i=1,self._NoticeData:rowCount() do
                        if id == self._NoticeData:getSuperLong(i,"id") then
                            if info.state == 1 or info.state == 3 then
                                self:setMailRead(i)
                            end
                            self._NoticeData:setLong(i,"state",info.state)
                        end
                    end
                end
            end
        end
        info.info:clear()
        self:clearRepSelect()
       
        end
        
    end

    local function getRepList( table )
        -- body

        if table == nil then
            return
        end
        local count = 0
        if table.type == 2 then
            count = self._repCount
        elseif table.type == 1 then
            count = self._noticeCount
        end

        if table.info == nil or table.info:rowCount() < 10 then
            self._canGet = false
        else
            self._canGet = true
        end

        if table.info ~= nil and table.info:rowCount() > 0 and count > 10  then
            
            function showMove()
                self:getChildByName("scrollview"):getInnerContainer():runAction(cc.MoveBy:create(0.5,cc.p(0,20)))
            end
            self:runAction(cc.CallFunc:create(showMove))
        end
        
        if table.info ~= nil then
           self:updateReps(table)
        end

               
        self:checkBtnAll()
        self._unSNCnt = table.unSNCnt
        self._unRepCnt = table.unRepCnt
        self._unResourceCnt = table.unResourceCnt
        self._unPveCnt = table.unPveCnt
        
        if self._isGet == true then
            self._isGet = false
        end
        self:showWaiting(false)

        if count <= 10 then
            self:getChildByName("scrollview"):jumpToTop()
            --cclog("================jump!!!!!!!!!!!!!!!")
        end
    end 

    local function updatereceive(parma)
        if parma ~= 0  then
            return
        end   

        if self._type == 3   then
            if self._specialType == 1 then
                self:showSendMails()
            end
        end
        
    end

    ff.net:registerEvent(1,dd.Tjf_Mail_GetMailList,updateReceiveMsg)
    ff.net:registerEvent(1,dd.Tjf_Mail_MailAction,updateMailAction)
    ff.net:registerEvent(1,dd.Tjf_Mail_SaveMail,updateMailColloct)
    ff.net:registerEvent(1,dd.Tjf_Mail_GetSavedMailList,updateSaveView)
    ff.net:registerEvent(1,dd.Tjf_User_Report_GetList,getRepList)
    ff.net:registerEvent(1,dd.Tjf_User_Report_Action,updateRepAction)
    ff.net:registerEvent(1,dd.Tjf_Mail_SendMail,updatereceive)
    -- body
end

function mailLayer:collectMail( id )
    if self._showData:rowCount() <1 then
        return
    end

    for i=1,self._showData:rowCount() do
        if id == self._showData:getSuperLong(i,"id") then
            local message = ff.net:createMessage()
            message:addCmd(0xF0A)
            message:addLong(dd.uid)
            if ff._and(self._showData:getLong(i,"read_flag"),2) == 2 then
                message:addLong(2)
            else
                message:addLong(1)
            end
            message:addLong(1)
            message:addSuperLong(self._showData:getSuperLong(i,"id"))
            message:addLong(self._showData:getLong(i,"time"))
            message:addLong(0)
            message:addLong(self._showData:getLong(i,"sender_uid"))
            message:addString(self._showData:getString(i,"sender"),15)
            message:addString(self._showData:getString(i,"sender_union"),3)
            message:addString(self._showData:getString(i,"title"),63)
            message:addString(self._showData:getString(i,"content"),31)
            ff.net:postMessage(message)
            break
        end
    end
    -- body
end

function mailLayer:onInit( index )
    -- body
   -- mail_addEventListener()
    self:addUiEvent()
    self:showWaiting(false)
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,hh - 214))
        self:getChildByName("top"):setPositionY(hh - 214 -105)
        self:getChildByName("topNavi"):setPositionY(hh - 214 - 105 - 87)
        self:getChildByName("mail_top"):setPositionY(hh - 214 - 105 - 87 -100)
        self:getChildByName("mail_top_rep"):setPositionY(hh - 214 - 105 - 87 -100)
        self:getChildByName("oper"):setPositionY(hh - 214 - 105 - 87 -100-80)
        self:getChildByName("waiting"):setPositionY(0)
        self:getChildByName("mBtm"):setPositionY(0)
        --self:getChildByName("top"):getChildByName("chu_title"):setString(ff.langString("邮件"))
        --self:getChildByName("top"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
        --self:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))

        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("images/mv/normaleffect.plist")
        for j = 1, 12 do
            local frame = nil
            if j < 10 then
                frame = cache:getSpriteFrame("of_native_loader_progress_0"..j..".png")
            else    
                frame = cache:getSpriteFrame("of_native_loader_progress_"..j..".png")
            end 
            self._animFrames[j] = frame
        end
        self:getChildByName("waiting"):getChildByName("icon"):loadTexture("of_native_loader_progress_01.png",1)

        

        self:getChildByName("scrollview"):setMaxLine(50)
        self:getChildByName("scrollview"):setItemsMargin(5)

        self:getChildByName("back"):setContentSize(cc.size(ff.width,ff.height))
        self:getChildByName("back"):setPosition(cc.p(0,0))

        self:getChildByName("topNavi"):getChildByName("btreport"):setTag(1)
        self:getChildByName("topNavi"):getChildByName("receive"):setTag(2)
        self:getChildByName("topNavi"):getChildByName("send"):setTag(3)
        self:getChildByName("topNavi"):getChildByName("report"):setTag(4)

        self:getChildByName("mail_top"):getChildByName("user"):setTag(1)
        self:getChildByName("mail_top"):getChildByName("union"):setTag(2)
        self:getChildByName("mail_top"):getChildByName("collect"):setTag(3)

        self:getChildByName("mail_top"):getChildByName("user"):getChildByName("Label"):setTag(1)
        self:getChildByName("mail_top"):getChildByName("union"):getChildByName("Label"):setTag(2)
        self:getChildByName("mail_top"):getChildByName("collect"):getChildByName("Label"):setTag(3)

        self:getChildByName("mail_top_rep"):getChildByName("fight"):setTag(1)
        self:getChildByName("mail_top_rep"):getChildByName("fight"):getChildByName("Label"):setTag(1)
        self:getChildByName("mail_top_rep"):getChildByName("collect"):setTag(2)
        self:getChildByName("mail_top_rep"):getChildByName("collect"):getChildByName("Image"):setTag(2)
        self:getChildByName("mail_top_rep"):getChildByName("collect"):getChildByName("Label"):setTag(2)
        
        --按钮事件
        self:getChildByName("topNavi"):getChildByName("btreport"):addTouchEventListener(self.selectType)
        self:getChildByName("topNavi"):getChildByName("receive"):addTouchEventListener(self.selectType)
        self:getChildByName("topNavi"):getChildByName("send"):addTouchEventListener(self.selectType)
        self:getChildByName("topNavi"):getChildByName("report"):addTouchEventListener(self.selectType)

        self:getChildByName("mail_top"):getChildByName("user"):addTouchEventListener(self.selectSpecialType)
        self:getChildByName("mail_top"):getChildByName("union"):addTouchEventListener(self.selectSpecialType)
        self:getChildByName("mail_top"):getChildByName("collect"):addTouchEventListener(self.selectSpecialType)
        self:getChildByName("mail_top"):getChildByName("user"):getChildByName("Label"):addTouchEventListener(self.selectSpecialType)
        self:getChildByName("mail_top"):getChildByName("union"):getChildByName("Label"):addTouchEventListener(self.selectSpecialType)
        self:getChildByName("mail_top"):getChildByName("collect"):getChildByName("Label"):addTouchEventListener(self.selectSpecialType)

        self:getChildByName("mail_top_rep"):getChildByName("collect"):addTouchEventListener(self.selecRepType)
        self:getChildByName("mail_top_rep"):getChildByName("collect"):getChildByName("Image"):addTouchEventListener(self.selecRepType)
        self:getChildByName("mail_top_rep"):getChildByName("collect"):getChildByName("Label"):addTouchEventListener(self.selecRepType)
        self:getChildByName("mail_top_rep"):getChildByName("fight"):addTouchEventListener(self.selecRepType)
        self:getChildByName("mail_top_rep"):getChildByName("fight"):getChildByName("Label"):addTouchEventListener(self.selecRepType)

        self:getChildByName("mBtm"):getChildByName("Button_Delete"):addTouchEventListener(self.BtnDeleteEvent)
        self:getChildByName("mBtm"):getChildByName("receive"):getChildByName("delete"):addTouchEventListener(self.BtnDeleteEvent)
        self:getChildByName("mBtm"):getChildByName("receive"):getChildByName("read"):addTouchEventListener(self.BtnReadEvent)
        self:getChildByName("oper"):getChildByName("checkAll"):addTouchEventListener(self.BtnALLEvent)
        self:getChildByName("oper"):getChildByName("check"):addTouchEventListener(self.BtnALLEventEx)

        self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
        self:getChildByName("oper"):getChildByName("write"):addTouchEventListener(self.onMailWrite)
        self:getChildByName("scrollview"):addScrollViewEventListener(self.scrollViewEvent)
        self._init = true
    end
    

    local hh = ff.height
    self:getChildByName("scrollview"):setVisible(true)

    self:getChildByName("scrollview"):setContentSize(cc.size(720,hh - 214 - 105 - 87 -100-80))
    self:getChildByName("scrollview"):setPositionY(0)
    self:getChildByName("scrollview"):removeAllChildren(true)
    self:getChildByName("string"):setPositionY((hh - 214 - 105 - 87 -100-80) /2)

    self:unselectType()
    self:unselectSpecialType()
    self._type = index
    self._specialType = 1
    self._repType = 1
    self._canGet = true
    if self._type == 2 then
        self:getChildByName("oper"):setPositionY(hh - 214 - 105 - 87 -100-80)
        self:getChildByName("scrollview"):setContentSize(cc.size(720,hh - 214 - 105 - 87 -100-80))
        self:getChildByName("topNavi"):getChildByName("receive"):setSelectedState(true)
        self:getChildByName("topNavi"):getChildByName("receive"):getChildByName("chu_Label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("oper"):getChildByName("write"):setVisible(true)
        self:getChildByName("oper"):getChildByName("write"):setTouchEnabled(true)
        self:getChildByName("mail_top"):getChildByName("collect"):setVisible(true)
        self:getChildByName("mail_top"):getChildByName("collect"):setTouchEnabled(true)
        self:showSendMails()
    elseif self._type == 1 then
        self:getChildByName("oper"):setPositionY(hh - 214 - 105 - 87 -100-80)
        self:getChildByName("scrollview"):setContentSize(cc.size(720,hh - 214 - 105 - 87 -100-80))
        self:getChildByName("topNavi"):getChildByName("btreport"):setSelectedState(true)
        self:getChildByName("topNavi"):getChildByName("btreport"):getChildByName("chu_Label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("oper"):getChildByName("write"):setVisible(false)
        self:getChildByName("oper"):getChildByName("write"):setTouchEnabled(false)
        self:getChildByName("mail_top_rep"):getChildByName("collect"):setVisible(true)
        self:showReps()
    elseif self._type == 4 then
        self:getChildByName("oper"):setPositionY(hh - 214 - 105 - 87-80)
        self:getChildByName("scrollview"):setContentSize(cc.size(720,hh - 214 - 105 - 87 -80))
        self:getChildByName("topNavi"):getChildByName("report"):setSelectedState(true)
        self:getChildByName("topNavi"):getChildByName("report"):getChildByName("chu_Label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("oper"):getChildByName("write"):setVisible(false)
        self:getChildByName("oper"):getChildByName("write"):setTouchEnabled(false)
        --self:getChildByName("mail_top_rep"):getChildByName("collect"):setVisible(true)
        self:getChildByName("oper"):getChildByName("write"):setVisible(false)
        self:getChildByName("oper"):getChildByName("write"):setTouchEnabled(false)
        self:showNotice()
    end
    if self._specialType == 1 then
        self:getChildByName("mail_top"):getChildByName("user"):getChildByName("Label"):setColor(cc.c3b(223,239,244))
        self:getChildByName("mail_top"):getChildByName("user"):setSelectedState(true)
    end

    if self._repType == 1 then
        self:getChildByName("mail_top_rep"):getChildByName("fight"):getChildByName("Label"):setColor(cc.c3b(223,239,244))
        self:getChildByName("mail_top_rep"):getChildByName("fight"):setSelectedState(true)
    end
    
    self:updateBtns()
    self.updateGold()
    self:getChildByName("string"):setVisible(false)
end

function mailLayer.update(sender )
    -- body
    local  count = dd.myinfo:getLong(1,"urumail") --+ dd.myinfo:getLong(1,"ursmail") 
    if sender._tips[1] == 0 and count > 0 then
        sender._tips[1]= count 
        if sender._type == 2  and sender._isGet == false then
            if sender._showData ~= nil and sender._showData:rowCount()> 0 then
            else
                sender:showSendMails()
            end
        end
    else
        if sender._tips[1] < count and sender._type == 2 and sender._isGet == false then
            sender:showSendMails()
        end
        sender._tips[1]= count 
    end
    if count > 0 then
        sender:getChildByName("topNavi"):getChildByName("receive"):getChildByName("tag"):getChildByName("Label"):setString(count)
        sender:getChildByName("topNavi"):getChildByName("receive"):getChildByName("tag"):setVisible(true)
    else
        sender:getChildByName("topNavi"):getChildByName("receive"):getChildByName("tag"):setVisible(false)
    end

    local  count99 = dd.myinfo:getLong(1,"uruionmail") 
    if count99 > 0 then
        sender:getChildByName("mail_top"):getChildByName("union"):getChildByName("tag"):getChildByName("Label"):setString(count99)
        sender:getChildByName("mail_top"):getChildByName("union"):getChildByName("tag"):setVisible(true)
    else
        sender:getChildByName("mail_top"):getChildByName("union"):getChildByName("tag"):setVisible(false)
    end

    local count2 = dd.myinfo:getLong(1,"ursys")
    if sender._tips[3] == 0 and count2 >0 then
        sender._tips[3]= count2 
        if sender._type ==4 then
            sender:showNotice()
        end
    else
        if sender._tips[3] < count2 and sender._type ==4 then
            sender:showNotice()
        end
        sender._tips[3]= count2 
    end
    if count2 > 0 then
        sender:getChildByName("topNavi"):getChildByName("report"):getChildByName("tag"):getChildByName("Label"):setString(count2)
        sender:getChildByName("topNavi"):getChildByName("report"):getChildByName("tag"):setVisible(true)
    else
        sender:getChildByName("topNavi"):getChildByName("report"):getChildByName("tag"):setVisible(false)
    end

    local count3 = dd.myinfo:getLong(1,"urreport") --+ dd.myinfo:getLong(1,"urpve") + dd.myinfo:getLong(1,"urcj")
    if sender._tips[2] == 0 and count3 >0 then
        sender._tips[2]= count3 
        if sender._type ==1 and sender._isGet == false then
            if sender._repData ~= nil and sender._repData:rowCount()>0 then
            else
                
                sender:showReps()
            end
        end
    else
        if sender._tips[2] < count3 and sender._type ==1 and sender._isGet == false then
 
            sender:showReps()
        end
        sender._tips[2]= count3 
    end
    if count3 > 0 then
        sender:getChildByName("topNavi"):getChildByName("btreport"):getChildByName("tag"):getChildByName("Label"):setString(count3)
        sender:getChildByName("topNavi"):getChildByName("btreport"):getChildByName("tag"):setVisible(true)
    else
        sender:getChildByName("topNavi"):getChildByName("btreport"):getChildByName("tag"):setVisible(false)
    end

     sender:getChildByName("topNavi"):getChildByName("send"):getChildByName("tag"):setVisible(false)

    if sender._type == 1 then
        if sender._repData ~= nil and sender._repData:rowCount()>0 then
            for i=1,sender._repData:rowCount() do
                local item = sender:getChildByName("scrollview"):getChildByTag(i)
                if sender._repData:getLong(i,"type") == 211 then
                    
                    if item ~= nil then
                        if dd.myinfo:getLong(1,"urpve") > 0 then
                            item:getChildByName("tag"):setVisible(true)
                            item:getChildByName("tag"):getChildByName("Label"):setString(dd.myinfo:getLong(1,"urpve"))
                        else
                            item:getChildByName("tag"):setVisible(false)
                        end
                    end
                elseif sender._repData:getLong(i,"type") == 201 then
                    if item ~= nil then
                        if dd.myinfo:getLong(1,"urcj") > 0 then
                            item:getChildByName("tag"):setVisible(true)
                            item:getChildByName("tag"):getChildByName("Label"):setString(dd.myinfo:getLong(1,"urcj"))
                        else
                            item:getChildByName("tag"):setVisible(false)
                        end
                    end
                elseif sender._repData:getLong(i,"type") == 214 then
                    if item ~= nil then
                        if dd.myinfo:getLong(1,"uryg") > 0 then
                            item:getChildByName("tag"):setVisible(true)
                            item:getChildByName("tag"):getChildByName("Label"):setString(dd.myinfo:getLong(1,"uryg"))
                        else
                            item:getChildByName("tag"):setVisible(false)
                        end
                    end
                elseif sender._repData:getLong(i,"type") == 215 then
                    if item ~= nil then
                        if dd.myinfo:getLong(1,"urboss") > 0 then
                            item:getChildByName("tag"):setVisible(true)
                            item:getChildByName("tag"):getChildByName("Label"):setString(dd.myinfo:getLong(1,"urboss"))
                        else
                            item:getChildByName("tag"):setVisible(false)
                        end
                    end
                elseif sender._repData:getLong(i,"type") == 216 then
                    if item ~= nil then
                        if dd.myinfo:getLong(1,"urgc") > 0 then
                            item:getChildByName("tag"):setVisible(true)
                            item:getChildByName("tag"):getChildByName("Label"):setString(dd.myinfo:getLong(1,"urgc"))
                        else
                            item:getChildByName("tag"):setVisible(false)
                        end
                    end
                elseif sender._repData:getLong(i,"type") == 217 then
                    if item ~= nil then
                        if dd.myinfo:getLong(1,"urZB") > 0 then
                            item:getChildByName("tag"):setVisible(true)
                            item:getChildByName("tag"):getChildByName("Label"):setString(dd.myinfo:getLong(1,"urZB"))
                        else
                            item:getChildByName("tag"):setVisible(false)
                        end
                    end
                elseif sender._repData:getLong(i,"type") == 218 then
                    if item ~= nil then
                        if dd.myinfo:getLong(1,"urRboss") > 0 then
                            item:getChildByName("tag"):setVisible(true)
                            item:getChildByName("tag"):getChildByName("Label"):setString(dd.myinfo:getLong(1,"urRboss"))
                        else
                            item:getChildByName("tag"):setVisible(false)
                        end
                    end
                end

            end
        end
    end
    sender:checkBtnAll()
     --cclog("=="..dd.myinfo:getLong(1,"urreport").."=="..dd.myinfo:getLong(1,"urpve").."=="..dd.myinfo:getLong(1,"urcj").."=="..dd.myinfo:getLong(1,"ursys"))
end

function mailLayer:checkBtnAll(  )
    -- body

    local hh = ff.height
    if self._type == 2 or self._type == 3 then
        self:getChildByName("oper"):setVisible(true)
        if self._showData ~= nil and self._showData:rowCount() > 0 then
            if self:getChildByName("oper"):getChildByName("checkAll"):isVisible() == false then
                self:getChildByName("oper"):getChildByName("checkAll"):setVisible(true)
            end
            if self:getChildByName("string"):isVisible() == true then
                self:getChildByName("string"):setString("");
                self:getChildByName("string"):setVisible(false)
            end
        else
            if self:getChildByName("string"):isVisible() == false then
                self:getChildByName("string"):setString(ff.langString("没有邮件"));
                self:getChildByName("string"):setVisible(true)
            end
            
            if self:getChildByName("oper"):getChildByName("checkAll"):isVisible() == true then
                self:getChildByName("oper"):getChildByName("checkAll"):setVisible(false)
            end
        end
    elseif self._type == 1 then
        local visible = false
        if self._repData ~= nil and self._repData:rowCount()>0 then
            
            for i=1,self._repData:rowCount() do
                if self._repData:getLong(i,"type") ~= 201 and self._repData:getLong(i,"type") ~= 211 and self._repData:getLong(i,"type") ~= 214 and self._repData:getLong(i,"type") ~= 215 and self._repData:getLong(i,"type") ~= 216 and self._repData:getLong(i,"type") ~= 217 and self._repData:getLong(i,"type") ~= 218 then
                   -- cclog("================="..self._repData:rowCount().."==="..self._repData:getLong(i,"type"))
                    visible = true 
                    break
                end
            end
            if self:getChildByName("string"):isVisible() == true then
                self:getChildByName("string"):setString("");
                self:getChildByName("string"):setVisible(false)
            end
        else
            if self:getChildByName("string"):isVisible() == false then
                self:getChildByName("string"):setString(ff.langString("没有报告"));
                self:getChildByName("string"):setVisible(true)
            end
            visible = false
        end
        if visible == true then
            if self:getChildByName("oper"):isVisible() == false then
                self:getChildByName("oper"):getChildByName("checkAll"):setVisible(true)
                self:getChildByName("oper"):setVisible(true)
                self:getChildByName("scrollview"):setContentSize(cc.size(720,hh - 214 - 105 - 87 -100- 80))
            else
                if self:getChildByName("oper"):getChildByName("checkAll"):isVisible() == false then
                    self:getChildByName("oper"):getChildByName("checkAll"):setVisible(true)
                end
            end
        else
            if self:getChildByName("oper"):isVisible() == true then
                self:getChildByName("oper"):setVisible(false)
                self:getChildByName("scrollview"):setContentSize(cc.size(720,hh - 214 - 105 - 87 -110))
            end
        end
    elseif self._type == 4 then
        if self._NoticeData ~= nil and self._NoticeData:rowCount() > 0 then
            if self:getChildByName("oper"):isVisible() == false then
                self:getChildByName("oper"):setVisible(true)
                self:getChildByName("oper"):getChildByName("checkAll"):setVisible(true)
                self:getChildByName("scrollview"):setContentSize(cc.size(720,hh - 214 - 105 - 87 - 80))
            else
                if self:getChildByName("oper"):getChildByName("checkAll"):isVisible() == false then
                    self:getChildByName("oper"):getChildByName("checkAll"):setVisible(true)
                end
            end
            if self:getChildByName("string"):isVisible() == true then
                self:getChildByName("string"):setString("");
                self:getChildByName("string"):setVisible(false)
            end
        else
            if self:getChildByName("string"):isVisible() == false then
                self:getChildByName("string"):setString(ff.langString("没有通知"));
                self:getChildByName("string"):setVisible(true)
            end
            if self:getChildByName("oper"):isVisible() == true then
                self:getChildByName("oper"):setVisible(false)
                self:getChildByName("scrollview"):setContentSize(cc.size(720,hh - 214 - 105 - 90 ))
            end
            
        end
    end

end

function mailLayer.onMailWrite(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        if not pop.isShowing("mailWrite") then
            pop.onShowPopDialog("mailWrite",false,-1,'','','ch',{},0)
            --pop.onShowPopDialog("mailWrite",-1,'','','ch',{})
        end
    end
end

function mailLayer:updateBtns( )
    -- body

    if self._showData == nil and self._repData == nil and self._NoticeData == nil  then
        self:getChildByName("mBtm"):setVisible(false)
        return
    end

    local visible = false
    if self._type == 2  or self._type == 3 then
        for i=1,self._showData:rowCount() do
            if self._showData:getLong(i,'selected') == 1 then
                visible = true
            end
        end
    elseif self._type == 1 then
        for i=1,self._repData:rowCount() do
            if self._repData:getLong(i,'selected2') == 1 then
                visible = true
            end
        end
    elseif self._type == 4 then
        for i=1,self._NoticeData:rowCount() do
            if self._NoticeData:getLong(i,'selected2') == 1 then
                visible = true
            end
        end
    end

    self:getChildByName("mBtm"):setVisible(visible)

    if visible then
        if self._type == 2 or self._type == 1 or self._type == 4 then
            self:getChildByName("mBtm"):getChildByName("receive"):setVisible(true)
            self:getChildByName("mBtm"):getChildByName("Button_Delete"):setVisible(false)
        else
            self:getChildByName("mBtm"):getChildByName("receive"):setVisible(false)
            self:getChildByName("mBtm"):getChildByName("Button_Delete"):setVisible(true)
        end
    end
end

function mailLayer.checkEvent( sender,eventType )
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        local isSet
        if sender:getName() == "checkbox2" then
        if sender:getParent():getChildByName("checkbox"):getSelectedState() == true then
            isSet = false
        else
           isSet = true
        end
            --isSet = ((sender:getParent():getChildByName("checkbox"):getSelectedState() == true) and false) or true
            sender:getParent():getChildByName("checkbox"):setSelectedState(isSet)
            isSet = (not isSet)
        else
            isSet = sender:getSelectedState()

        end
        local  key = sender:getTag() - 1
        --cclog("sdf=="..key)
        if widget._showData:rowCount() >= key then
            if isSet == true then
                widget._showData:setLong(key,"selected",0)
            else
                widget._showData:setLong(key,"selected",1)
               -- cclog("-----"..key)
            end
            widget:updateBtns()
        end    
    end
    -- body
end

function mailLayer.checkRepEvent(sender,eventType)
    -- body
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        local isSet
        if sender:getName() == "checkbox2" then
        if sender:getParent():getChildByName("checkbox"):getSelectedState() == true then
            isSet = false
        else
           isSet = true
        end
            --isSet = ((sender:getParent():getChildByName("checkbox"):getSelectedState() == true) and false) or true
            sender:getParent():getChildByName("checkbox"):setSelectedState(isSet)
            isSet = (not isSet)
        else
            isSet = sender:getSelectedState()

        end
        local  key = sender:getTag()    
        if widget._type == 1 then
            if widget._repData:rowCount() >= key then
            --local selected = sender:getSelectedState()
                if isSet == true then
                    widget._repData:setLong(key,"selected2",0)
                else
                    widget._repData:setLong(key,"selected2",1)
               -- cclog("-----"..key)
                end
                widget:updateBtns()
            end    
        elseif widget._type == 4 then
            if widget._NoticeData:rowCount() >= key then
            --local selected = sender:getSelectedState()
            if isSet == true then
                widget._NoticeData:setLong(key,"selected2",0)
            else
                widget._NoticeData:setLong(key,"selected2",1)
               -- cclog("-----"..key)
            end
            widget:updateBtns()
        end   
        end
    end
end

function mailLayer.collectEvent( sender,eventType )
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        local isSet
        if sender:getName() == "iscollect2" then
        if sender:getParent():getChildByName("iscollect"):getSelectedState() == true then
            isSet = false
        else
           isSet = true
        end
            --isSet = ((sender:getParent():getChildByName("checkbox"):getSelectedState() == true) and false) or true
            sender:getParent():getChildByName("iscollect"):setSelectedState(isSet)
            isSet = (not isSet)
        else
            isSet = sender:getSelectedState()

        end
        local  key = sender:getTag()
        if widget._showData:rowCount() >= key then
            
            if isSet == true then
                widget._showData:setLong(key,"read_flag",3)
            else
                widget._showData:setLong(key,"read_flag",1)
            end
            widget:updateBtns()
        end    
        widget:collectMail(widget._showData:getSuperLong(key,"id"))
    end
    -- body
end

function mailLayer.collectRepEvent( sender,eventType )
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        local isSet
        if sender:getName() == "iscollect2" then
        if sender:getParent():getChildByName("iscollect"):getSelectedState() == true then
            isSet = false
        else
           isSet = true
        end
            --isSet = ((sender:getParent():getChildByName("checkbox"):getSelectedState() == true) and false) or true
            sender:getParent():getChildByName("iscollect"):setSelectedState(isSet)
            isSet = (not isSet)
        else
            isSet = sender:getSelectedState()

        end
        local  key = sender:getTag()
        local state = 3
        if widget._repData:rowCount() >= key then
            --local selected = sender:getSelectedState()
            if isSet == true then
                widget._repData:setLong(key,"sate",1)
                state = 1
            else
                widget._repData:setLong(key,"sate",3)
                state = 3
            end
            widget:updateBtns()
        end    

        local message = ff.net:createMessage()
        message:addCmd(0x00000136)
        message:addLong(dd.uid)  
        message:addLong(2)
        message:addLong(state)
        message:addLong(1)
        message:addSuperLong(widget._repData:getSuperLong(key,"id"))    
        ff.net:rpc(message,false)
        --cclog("aa"..widget._repData:getSuperLong(key,"id"))
    end
    -- body
end

function mailLayer:setMailRead( tag )
    -- body
    local item = self:getChildByName("scrollview"):getChildByTag(tag)
    if item ~= nil then
        item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
        item:getChildByName("title"):setColor(cc.c3b(122,136,141))
        item:getChildByName("text"):setColor(cc.c3b(122,136,141))
        for i=1,7 do
            local back = item:getChildByTag(100+i)
            if back ~= nil then
                back:removeFromParent()
            end
        end
    end
end

function mailLayer:setRpRead( tag )
    -- body
    local item = self:getChildByName("scrollview"):getChildByTag(tag)
    if item ~= nil then
        for i=1,7 do
            local back = item:getChildByTag(100+i)
            if back ~= nil then
                back:removeFromParent()
            end
        end
        item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
        --item:getChildByName("read"):setVisible(true)

        item:getChildByName("info"):removeAllChildren(true)
        local type = self._repData:getLong(tag,"type")
        if type == 213 then

            local info =  item:getChildByName("info")
            local richText=ccui.RichText:create()
            richText:ignoreContentAdaptWithSize(false)
            richText:setContentSize(cc.size(400 ,100))    
            richText:setAutoHeight()

            local typeStr = nil
            local unionStr = nil
            local nameStr = nil
            local stateStr = nil
            local table = Split(self._repData:getString(tag,"content"),"%\\")

            if tonumber(table[1]) == 1 then
                typeStr = ccui.RichElementText:create(1, cc.c3b(183,197,199), 255, ff.langString("侦查").." ", "Helvetica", 25)
                if tonumber(table[2]) == 2 then
                    stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("失败"), "Helvetica", 25)       
                elseif tonumber(table[2]) == 0 then
                    stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("目标已经转移"), "Helvetica", 25)
                else
                    
                    stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("成功"), "Helvetica", 25)
                end
                if string.len(table[11])  > 1 then
                        
                    unionStr = ccui.RichElementText:create(2, cc.c3b(141,60,64), 255,"["..table[11].."]", "Helvetica", 25)

                end
                local name = table[12]
                nameStr = ccui.RichElementText:create(3, cc.c3b(183,197,199), 255,name, "Helvetica", 25)     
            else
                typeStr = ccui.RichElementText:create(1, cc.c3b(183,197,199), 255, ff.langString("被侦查").." ", "Helvetica", 25)
                if tonumber(table[2]) == 2 then
                    stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("失败"), "Helvetica", 25)
                elseif tonumber(table[2]) == 0 then
                    stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("目标已经转移"), "Helvetica", 25)
                else
                    
                    stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("成功"), "Helvetica", 25)
                end
                if string.len(table[5]) > 1 then
                        
                    unionStr = ccui.RichElementText:create(2, cc.c3b(141,60,64), 255,"["..table[5].."]", "Helvetica", 25)
                        
                end
                local name =table[6]
            
                nameStr = ccui.RichElementText:create(3, cc.c3b(183,197,199), 255,name, "Helvetica", 25)
            end

            richText:pushBackElement(typeStr)
            if unionStr ~= nil then
                richText:pushBackElement(unionStr)
            end
            if nameStr ~= nil then
                richText:pushBackElement(nameStr)
            end
            if stateStr ~= nil then
                richText:pushBackElement(stateStr)
            end

            richText:formatText()
            info:addChild(richText,999,999)
        else
            local info =  item:getChildByName("info")

            local richText=ccui.RichText:create()
            richText:ignoreContentAdaptWithSize(false)
            richText:setContentSize(cc.size(400 ,100))    
            richText:setAutoHeight()

            local typeStr = nil
            local unionStr = nil
            local nameStr = nil
            local stateStr = nil

            local table = Split(self._repData:getString(tag,"content"),"%\\")

            if tonumber(table[1]) == 1 then
                typeStr = ccui.RichElementText:create(1, cc.c3b(183,197,199), 255, ff.langString("攻击").." ", "Helvetica", 25)
                if table[12] ~= nil and string.len(table[12]) > 1 then
                    unionStr = ccui.RichElementText:create(2, cc.c3b(141,60,64), 255,"["..table[12].."]", "Helvetica", 25)
                end
                local name = ""
                if tonumber(table[3]) == 5 or tonumber(table[3]) == 15 then
                    name = ff.langString("哨塔")
                elseif tonumber(table[3]) == 14 then
                    name = ff.langString("据点")
                else
                    name = table[13] -- table[7]
                end
                nameStr = ccui.RichElementText:create(3, cc.c3b(183,197,199), 255,name, "Helvetica", 25)

                if tonumber(table[2]) == 2 then
                    stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("失败"), "Helvetica", 25)

                elseif tonumber(table[2]) == 3 then
                    stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("被全灭"), "Helvetica", 25)
                else
                    stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("成功"), "Helvetica", 25)
                end
            else
                
                typeStr = ccui.RichElementText:create(1, cc.c3b(183,197,199), 255, ff.langString("防御").." ", "Helvetica", 25)

                if table[6] ~= nil and string.len(table[6]) > 1 then

                    unionStr = ccui.RichElementText:create(2, cc.c3b(141,60,64), 255,"["..table[6].."]", "Helvetica", 25)
                end
                local name =table[7] -- table[7]

                nameStr = ccui.RichElementText:create(3, cc.c3b(183,197,199), 255,name, "Helvetica", 25)
       
 
                if tonumber(table[2]) == 2 then
                    stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, ff.langString("成功").." ", "Helvetica", 25)
                
                elseif tonumber(table[2]) == 3 then
                    
                    stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, ff.langString("被全灭").." ", "Helvetica", 25)
                
                else
                   
                    stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, ff.langString("失败").." ", "Helvetica", 25)
                
                end
            end

            richText:pushBackElement(typeStr)
            
            if unionStr ~= nil then
                richText:pushBackElement(unionStr)

            end
            if nameStr ~= nil then
                richText:pushBackElement(nameStr)
            end
            if stateStr ~= nil then
                richText:pushBackElement(stateStr)
            end

            richText:formatText()
            info:addChild(richText,999,999)
        end
        
    end
end

function mailLayer.openReceiveEvent(sender,eventType)
    -- body
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        
        local key = sender:getTag()
        local cont = widget._showData:rowCount()
        if cont >= key then
            widget:setMailRead(key)
            AudioEngine.playEffect(ff.sounds[109])
            --cclog("0====================0000000000000000000="..widget._showData:getLong(key,"mail_type"))
                if widget._showData:getLong(key,"mail_type") == 0 or widget._showData:getLong(key,"mail_type") == 1 or widget._showData:getLong(key,"mail_type") == 2 then

                    if not pop.isShowing("mailReceive") then
                        local widget1 = pop.getDialog("mailReceive")
                        if widget1 then
                            widget1:stopAllActions()
                        end
                        local id = widget._showData:getSuperLong(key,"id")
                        --if widget._showData:getLong(key,"read_flag") == 0 then
                        --    dd.myinfo:setLong(1,"urumail",(dd.myinfo:getLong(1,"urumail")  -1 ))
                        --end
                        widget._showData:setLong(key,"read_flag",1)
                        pop.popDialog("mailReceive",widget,id,key,cont)
                    end    
                else

                    if widget._showData:getLong(key,"mail_type") == 20 then
                        local chatCo = Split(widget._showData:getString(key,"content"),'%,')
                        local function close( event )
                            local widget = pop.getDialog("mail")
                            widget.onReturn()
                        end 
                        local function toFight(event)
     
                            pop.onShowPopDialog("fightRep",tonumber(chatCo[6]),0,true,nil)
                            
                        end
                        performWithDelay(sender, toFight,0.5)
                    else
                        local chatCo = Split(widget._showData:getString(key,"content"),'%,')
                        local function close( event )
                            local widget = pop.getDialog("mail")

                            widget.onReturn()
                        end 
                        local function toMap(event)
                            if ff._and(widget._showData:getLong(key,"read_flag"),1) ~= 1 then
                                local message = ff.net:createMessage()
                                message:addCmd(0xF09)
                                message:addLong(dd.uid)
                                message:addLong(2)

                                message:addLong(1)
                                message:addSuperLong(widget._showData:getSuperLong(key,"id"))
                                message:addLong(widget._showData:getLong(key,"read_flag"))
                                --cclog("============"..widget._showData:getSuperLong(key,"id"))
                                ff.net:rpc(message,false)
                            end
                           if dd.currentLayer._name ~= "WorldUILayer" then
                            dd.yunClose(2,nil,nil,tonumber(chatCo[1]))
                            else
                                if dd.worldLayer ~= nil then
                                    WorldControl:getInstance():closePannel()
                                    performWithDelay(sender, close,0.5)
                                    dd.worldLayer:setSceneCenterByGid(tonumber(chatCo[1])-1,true)   
                                end
                            end
                        end
                        performWithDelay(sender, toMap,0.5)
                    end
                    local function read( event )
                        if ff._and(widget._showData:getLong(key,"read_flag"),1) ~= 1 then
                            local message = ff.net:createMessage()
                            message:addCmd(0xF09)
                            message:addLong(dd.uid)
                            message:addLong(2)

                            message:addLong(1)
                            message:addSuperLong(widget._showData:getSuperLong(key,"id"))
                            message:addLong(widget._showData:getLong(key,"read_flag"))
                            --cclog("============"..widget._showData:getSuperLong(key,"id"))
                            ff.net:rpc(message,false)
                        end
                    end 
                    performWithDelay(sender, read,0.5)
                end
            return
        end
    end
end

function mailLayer.openScoutRepEvent(sender,eventType)
    -- body
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        
        local key = sender:getTag()
        local cont = widget._repData:rowCount()
        if cont >= key then
            widget:setRpRead(key)
            AudioEngine.playEffect(ff.sounds[109])
            if not pop.isShowing("scoutRep") then
                local widget1 = pop.getDialog("scoutRep")
                if widget1 then
                    widget1:stopAllActions()
                end
                local id = widget._repData:getSuperLong(key,"id")
                --cclog("====id===="..id)
                --widget._repData:setString(key,"content","1\2\30934\5\yte\hero563399\1004\48905\30967\5\ftb\hero201212\1010\51464")
                local info = widget._repData:getString(key,"content")
                local time = widget._repData:getLong(key,"time")
                pop.onShowPopDialog("scoutRep",id,info,time)
            end    
            return
        end
    end
end

function mailLayer.openNoticeEvent(sender,eventType)
    -- body
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        
        local key = sender:getTag()
        local cont = widget._NoticeData:rowCount()
        if cont >= key then
            widget:setMailRead(key)
            AudioEngine.playEffect(ff.sounds[109])
            if not pop.isShowing("notice") then
                local widget1 = pop.getDialog("notice")
                if widget1 then
                    widget1:stopAllActions()
                end

                --local id = widget._NoticeData:getLong(key,"type")
                --widget._repData:setString(key,"content","1\2\30934\5\yte\hero563399\1004\48905\30967\5\ftb\hero201212\1010\51464")
                --local info = widget._NoticeData:getString(key,"content")
                --local time = widget._NoticeData:getString(key,"time")
                pop.onShowPopDialog("notice",key,cont)
            end    
            return
        end
    end
end

function mailLayer.openResRepEvent(sender,eventType)
    -- body
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        --if sender:getParent() ~= nil then
         --   sender:getParent():getChildByName("tag"):setVisible(false)
        --end
        AudioEngine.playEffect(ff.sounds[109])
        pop.onShowPopDialog("repView",201)
    end
end

function mailLayer.openPVERepEvent(sender,eventType)
    -- body
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        --if sender:getParent() ~= nil then
        --    sender:getParent():getChildByName("tag"):setVisible(false)
        --end
        AudioEngine.playEffect(ff.sounds[109])
        pop.onShowPopDialog("repView",211)
    end
end

function mailLayer.openYGRepEvent(sender,eventType)
    -- body
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        --if sender:getParent() ~= nil then
        --    sender:getParent():getChildByName("tag"):setVisible(false)
        --end
        AudioEngine.playEffect(ff.sounds[109])
        pop.onShowPopDialog("repView",214)
    end
end

function mailLayer.openGCRepEvent(sender,eventType)
    -- body
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        --if sender:getParent() ~= nil then
        --    sender:getParent():getChildByName("tag"):setVisible(false)
        --end
        AudioEngine.playEffect(ff.sounds[109])
        pop.onShowPopDialog("repView",216)
    end
end

function mailLayer.openZBRepEvent(sender,eventType)
    -- body
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        --if sender:getParent() ~= nil then
        --    sender:getParent():getChildByName("tag"):setVisible(false)
        --end
        AudioEngine.playEffect(ff.sounds[109])
        pop.onShowPopDialog("repView",217)
    end
end

function mailLayer.openBossRepEvent(sender,eventType)
    -- body
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        --if sender:getParent() ~= nil then
        --    sender:getParent():getChildByName("tag"):setVisible(false)
        --end
        cclog("===2222222")
        AudioEngine.playEffect(ff.sounds[109])
        pop.onShowPopDialog("repView",215)
    end
end

function mailLayer.openBossRepEventEx(sender,eventType)
    -- body
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        --if sender:getParent() ~= nil then
        --    sender:getParent():getChildByName("tag"):setVisible(false)
        --end
        cclog("===33333")
        AudioEngine.playEffect(ff.sounds[109])
        pop.onShowPopDialog("repView",218)
    end
end

function mailLayer.openFightRepEvent(sender,eventType)
    -- body
    if eventType == ccui.TouchEventType.ended then

        local widget = pop.getDialog("mail")
        if widget == nil then
            return
        end
        
        local key = sender:getTag()
        local cont = widget._repData:rowCount()
        if cont >= key then
            widget:setRpRead(key)
            AudioEngine.playEffect(ff.sounds[109])
            if not pop.isShowing("fightRep") then
                local widget1 = pop.getDialog("fightRep")
                if widget1 then
                    widget1:stopAllActions()
                end
                local id = widget._repData:getSuperLong(key,"id")
                local table = Split(widget._repData:getString(key,"content"),"%\\")
                local type = tonumber(table[2])
                if type ~= 3 then
                    type = 0
                end
                pop.onShowPopDialog("fightRep",id,type,false,nil)
            end    
            return
        end
    end
end

function mailLayer.scrollViewEvent(sender, evenType)
    if evenType == ccui.ScrollviewEventType.bounceBottom then
    
        --cclog("====================")
        
        local widget = pop.getDialog("mail")
        if widget._type == 2 or widget._type == 3 then
            if widget._showData ~= nil and widget._showData:rowCount() < widget._userMailCount then
                if widget ~= nil and widget._isGet == false then
                    widget:getMailListByType(1)
                    widget._isGet = true
                end
            end
        elseif widget._type == 1 and widget._isGet == false then
            if widget._canGet == true then
                widget:getRepListByType(1)
                widget._isGet = true
            end
        elseif widget._type == 4 and widget._isGet == false then
            if widget._canGet == true then
                widget:getNoticeListByType(1)
                widget._isGet = true
            end
        end
    end
end

function mailLayer.onEnd( sender,btns )
    dd.delBackEvent(sender.onReturn)
    sender:stopAllActions()
    sender:getChildByName("scrollview"):removeAllChildren(true)

    if sender._showData ~= nil then 
        sender._showData:clear()
        sender._showData = nil
    end
    if sender._repData ~= nil then 
        sender._repData:clear()
        sender._repData = nil
    end
    if sender._NoticeData ~= nil then 
        sender._NoticeData:clear()
        sender._NoticeData = nil
    end

    ff.net:removeEvent(1,dd.Tjf_Mail_GetMailList)
    ff.net:removeEvent(1,dd.Tjf_Mail_MailAction)
    ff.net:removeEvent(1,dd.Tjf_Mail_GetSavedMailList)
    ff.net:removeEvent(1,dd.Tjf_User_Report_GetList)
    ff.net:removeEvent(1,dd.Tjf_User_Report_Action)
    ff.net:removeEvent(1,dd.Tjf_Mail_SendMail)
    ff.net:removeEvent(1,dd.Tjf_Get_Report_Get_Bonus)
    ff.net:removeEvent(1,dd.Tjf_Mail_SaveMail)
    -- body
    if btns == nil then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:unSelectBtns()
        end    
    end
    ff.net:unbindProperty("gold",2307)
end

function mailLayer.onBefore( sender )
    -- body
    sender:initData()
    schedule(sender,sender.update,1)
    ff.dbmanager:sql_query("delete from client_recv_user_mail")
    
    ff.net:registerEvent(1,dd.Tjf_Get_Report_Get_Bonus,function (message)sender:updateReporBonus(message)end)
end

function mailLayer:updateReporBonus( parma )
    -- body
    if parma[1] == 0 then
        if self._type == 4 then
            if self._NoticeData:rowCount() > 0 then
                for i=1,self._NoticeData:rowCount() do
                    if self._NoticeData:getSuperLong(i,"id") == tonumber(parma[2]) then
                        self._NoticeData:setLong(i,"awardTime",1)
                        local item =  self:getChildByName("scrollview"):getChildByTag(i)
                        if item ~= nil then
                            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i15_mail.png",1))
                        end
                    end
                end
            end
        end
    end
end

function onShowMail(widget,index )
    -- body
    local  layer = mailLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit(index)
    return layer
end

function mailLayer.onStart( sender )
    -- body
    sender.update(sender)
    ff.net:bindProperty(2307,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
end

function mailLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("mail")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end