function mailLayer:showSendMails()

    self._userMailCount = -1
    self._userRecvID = -1
    self._noticeCount = 0 
    self._repCount = 0
    self:getChildByName("scrollview"):removeAllChildren(true)
    self:getChildByName("mail_top"):setVisible(true)
    self:getChildByName("mail_top"):setTouchEnabled(true)
    self:getChildByName("mail_top_rep"):setVisible(false)
    self:getChildByName("mail_top_rep"):setTouchEnabled(false)
    self:getChildByName("oper"):getChildByName("checkAll"):setSelectedState(false)
    if self._showData ~= nil then
        self._showData:delRows()
    end

    if self._repData ~= nil then
        self._repData:delRows()
    end

    if self._NoticeData ~= nil  then
        self._NoticeData:delRows()
    end

    self:getMailListByType()
end

function mailLayer:showReps( )
    -- body
    self._userMailCount = -1
    self._userRecvID = -1
    self._repCount = 0
    self._noticeCount = 0 
    self:getChildByName("scrollview"):removeAllChildren(true)
    self:getChildByName("mail_top"):setVisible(false)
    self:getChildByName("mail_top"):setTouchEnabled(false)
    self:getChildByName("mail_top_rep"):setVisible(true)
    self:getChildByName("mail_top_rep"):setTouchEnabled(true)
    self:getChildByName("oper"):getChildByName("checkAll"):setSelectedState(false)
    if self._showData ~= nil then
       self._showData:delRows()
    end

    if self._repData ~= nil then
        self._repData:delRows()
    end

    if self._NoticeData ~= nil  then
        self._NoticeData:delRows()
    end

    self:getRepListByType()
end

function mailLayer:showNotice( )
    -- body
    self._userMailCount = -1
    self._userRecvID = -1
    self._repCount = 0
    self._noticeCount = 0 
    self:getChildByName("scrollview"):removeAllChildren(true)
    self:getChildByName("mail_top"):setVisible(false)
    self:getChildByName("mail_top"):setTouchEnabled(false)
    self:getChildByName("oper"):getChildByName("checkAll"):setSelectedState(false)
    if self._type ~= 4 then
        self:getChildByName("mail_top_rep"):setVisible(true)
        self:getChildByName("mail_top_rep"):setTouchEnabled(true)
    else
        self:getChildByName("mail_top_rep"):setVisible(false)
        self:getChildByName("mail_top_rep"):setTouchEnabled(false)
    end
    if self._showData ~= nil then
       self._showData:delRows()
    end

    if self._repData ~= nil then
        self._repData:delRows()
    end

    if self._NoticeData ~= nil  then
        self._NoticeData:delRows()
    end

    self:getNoticeListByType()
end

function mailLayer:showMails()
    if self._showData == nil or self._type == 1 then
        return 
    end
    self:getChildByName("scrollview"):removeAllChildren(true)
    self:getChildByName("scrollview"):setVisible(true)
    --self:getChildByName("scrollview"):setItemsMargin(5)

    for i=1,self._showData:rowCount() do
        local item = nil

        item = self:getChildByName("mailinfo"):clone()
        if self._showData:getLong(i,"selected") == 1 then          
            item:getChildByName("checkbox"):setSelectedState(true)
        end
    
        item:setVisible(true)
        item:setTouchEnabled(true)
        item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
        if self._specialType == 2 then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i18_mail.png",1))
        else
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i17_mail.png",1))
        end
        if self._type == 2 or self._type == 3 then
            local info = item:getChildByName("info")

            if self._showData:getLong(i,"sender_uid") == 0 then
                item:getChildByName("name"):setString(ff.langString('运营团队'))
                local str = self._showData:getString(i,"content")
                local str11 = string.gsub(str,"%d,","")
                self._showData:setString(i,"content",str11)
                str = self._showData:getString(i,"title")
                str11 = string.gsub(str,"%d,","")
                self._showData:setString(i,"title",str11)
            else
                local name = self._showData:getString(i,"sender")
                item:getChildByName("name"):setString(name)
            end


            if self._type == 2 then
                local  str =ff.gameCore:getUTFString(self._showData:getString(i,"title"),16)-- self._showData:getString(i,"title")

                item:getChildByName("text"):setString(str.."...")

                item:getChildByName("title"):setString(str)
            elseif self._type == 3 then
                local  str =ff.gameCore:getUTFString(self._showData:getString(i,"title"),16)
                
                item:getChildByName("text"):setString(str.."...")
                item:getChildByName("title"):setString(str)
                item:getChildByName("iscollect"):setVisible(false)
            end

            if self._showData:getString(i,"content") == nil then
                if self._showData:getString(i,"content") ~= nil then
                    local  str =ff.gameCore:getUTFString(self._showData:getString(i,"content"),16)
                    item:getChildByName("text"):setString(str.."...")
                end
            else
                if self._showData:getLong(i,"mail_type") == 0 or self._showData:getLong(i,"mail_type") == 1 or self._showData:getLong(i,"mail_type") == 2 then

                    local  str =ff.gameCore:getUTFString(self._showData:getString(i,"content"),16)
                    item:getChildByName("text"):setString(str.."...")
                else
                    local title = ff.langString("{0} 发起了分享",{self._showData:getString(i,"sender")})
                    --cclog(title.."=="..string.len(title))
                    if string.len(title) > 36 then
                        title = ff.gameCore:getUTFString(title,26).."..."
                    end
                    item:getChildByName("title"):setString(title)
                    if self._showData:getLong(i,"mail_type") == 20 then
                        local chatCo = Split(self._showData:getString(i,"content"),'%,')
                        
                        local chatStr = ff.langString("分享")..":"
                        if tonumber(chatCo[3]) == 1 then
                            chatStr = chatStr..ff.langString("攻击")..chatCo[4]..ff.langString("的战报")
                        else
                            chatStr = chatStr..ff.langString("防御")..chatCo[4]..ff.langString("的战报")
                        end
                        item:getChildByName("text"):setString(chatStr.."...")
                    elseif self._showData:getLong(i,"mail_type") == 11 then
                        local chatCo = Split(self._showData:getString(i,"content"),'%,')
                        local mapsite=dd.MapidToXY(tonumber(chatCo[1]))
                        local chatStr = ff.langString("分享")..":"..chatCo[2]..ff.langString("的城市").."LV."..chatCo[3]
                        item:getChildByName("text"):setString(chatStr.."...")
                    elseif self._showData:getLong(i,"mail_type") == 12 then
                        local chatCo = Split(self._showData:getString(i,"content"),'%,')
                        local mapsite=dd.MapidToXY(tonumber(chatCo[1]))
                        local chatStr = ff.langString("分享")..":"..chatCo[2]..ff.langString("的营帐").."LV."..chatCo[3]
                        item:getChildByName("text"):setString(chatStr.."...")
                    elseif self._showData:getLong(i,"mail_type") == 13 then
                        local chatCo = Split(self._showData:getString(i,"content"),'%,')
                        local mapsite=dd.MapidToXY(tonumber(chatCo[1]))
                        local chatStr = ff.langString("分享")..":"..ff.langString(dd.cfgWorldRes[tonumber(chatCo[2])]['name']).."LV."..chatCo[3]
                        item:getChildByName("text"):setString(chatStr.."...")

                    elseif self._showData:getLong(i,"mail_type") == 14 then
                        local chatCo = Split(self._showData:getString(i,"content"),'%,')
                        local mapsite=dd.MapidToXY(tonumber(chatCo[1]))
                        local chatStr = ff.langString("分享")..":"..ff.langString("空地").."(X:"..mapsite.x..",Y:"..mapsite.y..")"

                        item:getChildByName("text"):setString(chatStr.."...")
                    end
                end
            end
            if self._specialType == 3 then
                item:getChildByName("iscollect"):setSelectedState(true)
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
            else
                
                if ff._and(self._showData:getLong(i,"read_flag"),2) == 2 then
                    item:getChildByName("iscollect"):setSelectedState(true)
                end
            end

            if self._type == 3 or self._specialType == 3 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
            else
                if ff._and(self._showData:getLong(i,"read_flag"),1) ==1 then
                    item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                else
                    item:getChildByName("title"):setColor(cc.c3b(207,201,152))
                    item:getChildByName("text"):setColor(cc.c3b(207,201,152))
                    item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic05_mail.png",1))
                    for i=1,7 do
                       local back = item:getChildByName("back"):clone()
                       item:addChild(back)
                       back:setTag(100+i)
                    end
                end
            end            

            local dateStr = ff.showData(self._showData:getLong(i,"time"))
            item:getChildByName('time'):setString(dateStr)
        end

        item:getChildByName("touch"):addTouchEventListener(self.openReceiveEvent)
        item:setTag(i)
        item:getChildByName("touch"):setTag(i)

        item:getChildByName("checkbox"):setTag(i+1)
        item:getChildByName("checkbox2"):setTag(i+1)
        item:getChildByName("checkbox"):addTouchEventListener(self.checkEvent)
        item:getChildByName("checkbox2"):addTouchEventListener(self.checkEvent)

        item:getChildByName("iscollect"):setTag(i)
        item:getChildByName("iscollect2"):setTag(i)
        if self._type ~= 3 then
            item:getChildByName("iscollect"):addTouchEventListener(self.collectEvent)
            item:getChildByName("iscollect2"):addTouchEventListener(self.collectEvent)
        end

        self:getChildByName("scrollview"):pushBackCustomItem(item)
    end
    self:getChildByName("scrollview"):refreshView()
    -- body
end

function mailLayer:onShowReps(removeAll  )
    -- body
    if self._repData == nil then
        return
    end
    local count = 1
    if removeAll ==true then
        self:getChildByName("scrollview"):removeAllChildren(true)

    else
        count  = table.getn(self:getChildByName("scrollview"):getItems())+1
    end
     
    self:getChildByName("scrollview"):setVisible(true)

    for i=count,self._repData:rowCount() do
        local item = nil
        local type = self._repData:getLong(i,"type")
        if type == 213 then
            item = self:getChildByName("attackInfo"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            local info =  item:getChildByName("info")
            local richText=ccui.RichText:create()
            richText:ignoreContentAdaptWithSize(false)
            richText:setContentSize(cc.size(400 ,100))    
            richText:setAutoHeight()

            local typeStr = nil
            local unionStr = nil
            local nameStr = nil
            local stateStr = nil
            if self._repData:getLong(i,"state") == 0 then
                --info:getChildByName("type"):setColor(cc.c3b(207,201,152))
                
                --info:getChildByName("name"):setColor(cc.c3b(207,201,152))
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic05_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
                for i=1,7 do
                    local back = item:getChildByName("back"):clone()
                    item:addChild(back)
                    back:setTag(100+i)
                end
            elseif self._repData:getLong(i,"state") == 3 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(true)
            elseif self._repData:getLong(i,"state") == 1 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
            end

            local dateStr = ff.showData(self._repData:getLong(i,"time"))
            item:getChildByName('time'):setString(dateStr)

            local table = Split(self._repData:getString(i,"content"),"%\\")

            if tonumber(table[1]) == 1 then
                if tonumber(table[2]) == 1 then
                    item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i11_mail.png",1))
                else
                    item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i12_mail.png",1))
                end
            elseif tonumber(table[1]) == 2 then
                if tonumber(table[2]) == 1 then
                    item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i21_mail.png",1))
                else
                    item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i22_mail.png",1))
                end
            end
            

            if tonumber(table[1]) == 1 then
                --info:getChildByName("type"):setString()
                if self._repData:getLong(i,"state") == 0 then
                    typeStr = ccui.RichElementText:create(1, cc.c3b(207,201,152), 255, ff.langString("侦查").." ", "Helvetica", 25)
                else
                    typeStr = ccui.RichElementText:create(1, cc.c3b(183,197,199), 255, ff.langString("侦查").." ", "Helvetica", 25)
                end
                if tonumber(table[2]) == 2 then
                    if self._repData:getLong(i,"state") == 0 then
                        stateStr = ccui.RichElementText:create(4, cc.c3b(207,201,152), 255, " "..ff.langString("失败"), "Helvetica", 25)
                    else
                        stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("失败"), "Helvetica", 25)
                    end
                    
                elseif tonumber(table[2]) == 0 then
                    if self._repData:getLong(i,"state") == 0 then
                        stateStr = ccui.RichElementText:create(4, cc.c3b(207,201,152), 255, " "..ff.langString("目标已经转移"), "Helvetica", 25)
                    else
                        stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("目标已经转移"), "Helvetica", 25)
                    end
                else
                    
                    if self._repData:getLong(i,"state") == 0 then
                        stateStr = ccui.RichElementText:create(4, cc.c3b(207,201,152), 255, " "..ff.langString("成功"), "Helvetica", 25)
                    else
                        stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("成功"), "Helvetica", 25)
                    end

                end
                if string.len(table[11])  > 1 then
                        
                    unionStr = ccui.RichElementText:create(2, cc.c3b(141,60,64), 255,"["..table[11].."]", "Helvetica", 25)
            
                end
                local name =  table[12]
                
                if self._repData:getLong(i,"state") == 0 then
                    nameStr = ccui.RichElementText:create(3, cc.c3b(207,201,152), 255,name, "Helvetica", 25)
            
                else
                    nameStr = ccui.RichElementText:create(3, cc.c3b(183,197,199), 255,name, "Helvetica", 25)
                   
                end       
            else
                
                if self._repData:getLong(i,"state") == 0 then
                    typeStr = ccui.RichElementText:create(1, cc.c3b(207,201,152), 255, ff.langString("被侦查").." ", "Helvetica", 25)
                else
                    typeStr = ccui.RichElementText:create(1, cc.c3b(183,197,199), 255, ff.langString("被侦查").." ", "Helvetica", 25)
                end
                if tonumber(table[2]) == 2 then
                    if self._repData:getLong(i,"state") == 0 then
                        stateStr = ccui.RichElementText:create(4, cc.c3b(207,201,152), 255, " "..ff.langString("失败"), "Helvetica", 25)
                    else
                        stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("失败"), "Helvetica", 25)
                    end
                elseif tonumber(table[2]) == 0 then
                    if self._repData:getLong(i,"state") == 0 then
                        stateStr = ccui.RichElementText:create(4, cc.c3b(207,201,152), 255, " "..ff.langString("目标已经转移"), "Helvetica", 25)
                    else
                        stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("目标已经转移"), "Helvetica", 25)
                    end
                else
                    
                    
                    if self._repData:getLong(i,"state") == 0 then
                        stateStr = ccui.RichElementText:create(4, cc.c3b(207,201,152), 255, " "..ff.langString("成功"), "Helvetica", 25)
                    else
                        stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("成功"), "Helvetica", 25)
                    end
                end
                if string.len(table[5]) > 1 then
                        
                    unionStr = ccui.RichElementText:create(2, cc.c3b(141,60,64), 255,"["..table[5].."]", "Helvetica", 25)
                    
                end
                local name =table[6]
                
                if self._repData:getLong(i,"state") == 0 then
                    nameStr = ccui.RichElementText:create(3, cc.c3b(207,201,152), 255,name, "Helvetica", 25)
                else
                    nameStr = ccui.RichElementText:create(3, cc.c3b(183,197,199), 255,name, "Helvetica", 25)
                end   

            end

            richText:pushBackElement(typeStr)
            if unionStr ~= nil then
                richText:pushBackElement(unionStr)
            end
            if nameStr ~= nil then
                richText:pushBackElement(nameStr)
            end
            if stateStr ~= nil then
                richText:pushBackElement(stateStr)
            end

            richText:formatText()
            info:addChild(richText,999,999)

            item:getChildByName("touch"):addTouchEventListener(self.openScoutRepEvent)
            item:getChildByName("touch"):setTag(i)
            item:setTag(i)

            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):addTouchEventListener(self.checkRepEvent)
            item:getChildByName("checkbox2"):setTag(i)
            item:getChildByName("checkbox2"):addTouchEventListener(self.checkRepEvent)

            item:getChildByName("iscollect"):setTag(i)
            item:getChildByName("iscollect"):addTouchEventListener(self.collectRepEvent)
            item:getChildByName("iscollect2"):setTag(i)
            item:getChildByName("iscollect2"):addTouchEventListener(self.collectRepEvent)
            self:getChildByName("scrollview"):pushBackCustomItem(item)

        elseif type == 212 then
            item = self:getChildByName("attackInfo"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            local info =  item:getChildByName("info")
            --info:getChildByName("type"):setString("")
            --info:getChildByName("union"):setString("")
            --info:getChildByName("name"):setString("")
            --info:getChildByName("state"):setString("")
            local richText=ccui.RichText:create()
            richText:ignoreContentAdaptWithSize(false)
            richText:setContentSize(cc.size(400 ,100))    
            richText:setAutoHeight()

            local typeStr = nil
            local unionStr = nil
            local nameStr = nil
            local stateStr = nil
            if self._repData:getLong(i,"state") == 0 then
                --info:getChildByName("type"):setColor(cc.c3b(207,201,152))
                
                --info:getChildByName("name"):setColor(cc.c3b(207,201,152))
                --info:getChildByName("state"):setColor(cc.c3b(207,201,152))
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic05_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
                for i=1,7 do
                    local back = item:getChildByName("back"):clone()
                    item:addChild(back)
                    back:setTag(100+i)
                end
            elseif self._repData:getLong(i,"state") == 3 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(true)
            elseif self._repData:getLong(i,"state") == 1 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
            end

            local dateStr = ff.showData(self._repData:getLong(i,"time"))
            item:getChildByName('time'):setString(dateStr)

            local table = Split(self._repData:getString(i,"content"),"%\\")

            if tonumber(table[1]) == 1 then
                if self._repData:getLong(i,"state") == 0 then
                    typeStr = ccui.RichElementText:create(1, cc.c3b(207,201,152), 255, ff.langString("攻击").." ", "Helvetica", 25)
                else
                    typeStr = ccui.RichElementText:create(1, cc.c3b(183,197,199), 255, ff.langString("攻击").." ", "Helvetica", 25)
                end
                --info:getChildByName("type"):setString(ff.langString("攻击").." ")
                if table[12] ~= nil and string.len(table[12]) > 1 then
                	unionStr = ccui.RichElementText:create(2, cc.c3b(141,60,64), 255,"["..table[12].."]", "Helvetica", 25)
            	end
                local name = ""
                if tonumber(table[3]) == 5 or tonumber(table[3]) == 15 then
                    name = ff.langString("哨塔")
                elseif tonumber(table[3]) == 14 then
                    name = ff.langString("据点")
                else
                    name = table[13] -- table[7]
                end

                if self._repData:getLong(i,"state") == 0 then
                    nameStr = ccui.RichElementText:create(3, cc.c3b(207,201,152), 255,name, "Helvetica", 25)
                else
                    nameStr = ccui.RichElementText:create(3, cc.c3b(183,197,199), 255,name, "Helvetica", 25)
                end   

                if tonumber(table[2]) == 2 then
                    --info:getChildByName("state"):setString(" "..ff.langString("失败"))
                    if self._repData:getLong(i,"state") == 0 then
                        stateStr = ccui.RichElementText:create(4, cc.c3b(207,201,152), 255, " "..ff.langString("失败"), "Helvetica", 25)
                    else
                        stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("失败"), "Helvetica", 25)
                    end
                    item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i04_mail.png",1))
                elseif tonumber(table[2]) == 3 then
                    if self._repData:getLong(i,"state") == 0 then
                        stateStr = ccui.RichElementText:create(4, cc.c3b(207,201,152), 255, " "..ff.langString("被全灭"), "Helvetica", 25)
                    else
                        stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("被全灭"), "Helvetica", 25)
                    end
                    --info:getChildByName("state"):setString(" "..ff.langString("被全灭"))
                    item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i04_mail.png",1))
                else
                    if self._repData:getLong(i,"state") == 0 then
                        stateStr = ccui.RichElementText:create(4, cc.c3b(207,201,152), 255, " "..ff.langString("成功"), "Helvetica", 25)
                    else
                        stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, " "..ff.langString("成功"), "Helvetica", 25)
                    end
                    --info:getChildByName("state"):setString(" "..ff.langString("成功"))
                    item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i03_mail.png",1))
                end
            else
                if self._repData:getLong(i,"state") == 0 then
                    typeStr = ccui.RichElementText:create(1, cc.c3b(207,201,152), 255, ff.langString("防御").." ", "Helvetica", 25)
                else
                    typeStr = ccui.RichElementText:create(1, cc.c3b(183,197,199), 255, ff.langString("防御").." ", "Helvetica", 25)
                end
               -- info:getChildByName("type"):setString(ff.langString("防御").." ")
                if table[6] ~= nil and string.len(table[6]) > 1 then

                    unionStr = ccui.RichElementText:create(2, cc.c3b(141,60,64), 255,"["..table[6].."]", "Helvetica", 25)
            	end
                local name =table[7] -- table[7]

                if self._repData:getLong(i,"state") == 0 then
                    nameStr = ccui.RichElementText:create(3, cc.c3b(207,201,152), 255,name, "Helvetica", 25)
                else
                    nameStr = ccui.RichElementText:create(3, cc.c3b(183,197,199), 255,name, "Helvetica", 25)
                end   
 
                if tonumber(table[2]) == 2 then
                    if self._repData:getLong(i,"state") == 0 then
                    stateStr = ccui.RichElementText:create(4, cc.c3b(207,201,152), 255, ff.langString("成功").." ", "Helvetica", 25)
                else
                    stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, ff.langString("成功").." ", "Helvetica", 25)
                end
                   -- info:getChildByName("state"):setString(" "..ff.langString("成功"))
                    item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i07_mail.png",1))
                elseif tonumber(table[2]) == 3 then
                    if self._repData:getLong(i,"state") == 0 then
                    stateStr = ccui.RichElementText:create(4, cc.c3b(207,201,152), 255, ff.langString("被全灭").." ", "Helvetica", 25)
                else
                    stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, ff.langString("被全灭").." ", "Helvetica", 25)
                end
                   -- info:getChildByName("state"):setString(" "..ff.langString("被全灭"))
                    item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i08_mail.png",1))
                else
                    if self._repData:getLong(i,"state") == 0 then
                    stateStr = ccui.RichElementText:create(4, cc.c3b(207,201,152), 255, ff.langString("失败").." ", "Helvetica", 25)
                else
                    stateStr = ccui.RichElementText:create(4, cc.c3b(183,197,199), 255, ff.langString("失败").." ", "Helvetica", 25)
                end
                   -- info:getChildByName("state"):setString(" "..ff.langString("失败"))
                    item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i08_mail.png",1))
                end
            end

            richText:pushBackElement(typeStr)
            
            if unionStr ~= nil then
                richText:pushBackElement(unionStr)

            end
            if nameStr ~= nil then
                richText:pushBackElement(nameStr)
            end
            if stateStr ~= nil then
                richText:pushBackElement(stateStr)
            end

            richText:formatText()
            info:addChild(richText,999,999)

            item:getChildByName("touch"):addTouchEventListener(self.openFightRepEvent)
            item:getChildByName("touch"):setTag(i)
            item:setTag(i)

            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):addTouchEventListener(self.checkRepEvent)
            item:getChildByName("checkbox2"):setTag(i)
            item:getChildByName("checkbox2"):addTouchEventListener(self.checkRepEvent)

            item:getChildByName("iscollect"):setTag(i)
            item:getChildByName("iscollect"):addTouchEventListener(self.collectRepEvent)
            item:getChildByName("iscollect2"):setTag(i)
            item:getChildByName("iscollect2"):addTouchEventListener(self.collectRepEvent)
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        elseif type == 211 then
             item = self:getChildByName("complexInfo"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            if dd.myinfo:getLong(1,"urpve") > 0 then
                item:getChildByName("tag"):setVisible(true)
                item:getChildByName("tag"):getChildByName("Label"):setString(dd.myinfo:getLong(1,"urpve"))
            end
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i14_mail.png",1))

            local dateStr = ff.showData(self._repData:getLong(i,"time"))

            item:getChildByName('time'):setString(dateStr)

            local table1 = Split(self._repData:getString(i,"content"),"%\\")

            if tonumber(table1[7]) == 1 then
                item:getChildByName("info"):getChildByName("state"):setString(" "..ff.langString("成功"))
            else
                item:getChildByName("info"):getChildByName("state"):setString(" "..ff.langString("失败"))
            end

            item:getChildByName("info"):getChildByName("name"):setString(ff.langString(self._enemy[tonumber(table1[4])]["name"]).."LV."..table1[2])
            if table1[10] ~= nil and tonumber(table1[10]) > 0 then
                item:getChildByName("text"):setString(ff.langString("执行者").."："..ff.langString(dd.cfgHero[tonumber(table1[10])]['name']).."(LV."..table1[11]..")")
            else
                item:getChildByName("text"):setString("") 
            end
            item:getChildByName("touch"):addTouchEventListener(self.openPVERepEvent)
            item:getChildByName("touch"):setTag(i)
            item:setTag(i)
            item:getChildByName("button"):addTouchEventListener(self.openPVERepEvent)
            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):setVisible(false) 
            item:getChildByName("checkbox2"):setTag(i)


            self:getChildByName("scrollview"):pushBackCustomItem(item)
        elseif type == 214 then
             item = self:getChildByName("complexInfo"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            if dd.myinfo:getLong(1,"uryg") > 0 then
                item:getChildByName("tag"):setVisible(true)
                item:getChildByName("tag"):getChildByName("Label"):setString(dd.myinfo:getLong(1,"uryg"))
            end
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i20_mail.png",1))

            local dateStr = ff.showData(self._repData:getLong(i,"time"))

            item:getChildByName('time'):setString(dateStr)
            cclog(self._repData:getString(i,"content"))
            local table1 = Split(self._repData:getString(i,"content"),"%\\")

            if tonumber(table1[1]) == 1 then
                item:getChildByName("info"):getChildByName("state"):setString(" "..ff.langString("成功"))
            else
                item:getChildByName("info"):getChildByName("state"):setString(" "..ff.langString("失败"))
            end

            item:getChildByName("info"):getChildByName("name"):setString(ff.langString(dd.cfgNpc[tonumber(table1[2])]["name"]).."  LV."..dd.cfgNpc[tonumber(table1[2])]["level"])

            local mapsite=dd.MapidToXY(tonumber(table1[3]))

        
            item:getChildByName("text"):setString("From (x:"..mapsite.x..",y:"..mapsite.y..")")
            
            item:getChildByName("touch"):addTouchEventListener(self.openYGRepEvent)
            item:getChildByName("touch"):setTag(i)
            item:setTag(i)
            item:getChildByName("button"):addTouchEventListener(self.openYGRepEvent)
            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):setVisible(false) 
            item:getChildByName("checkbox2"):setTag(i)


            self:getChildByName("scrollview"):pushBackCustomItem(item)
        elseif type == 216 then
             item = self:getChildByName("complexInfo"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            if dd.myinfo:getLong(1,"urgc") > 0 then
                item:getChildByName("tag"):setVisible(true)
                item:getChildByName("tag"):getChildByName("Label"):setString(dd.myinfo:getLong(1,"urgc"))
            end
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i24_mail.png",1))

            local dateStr = ff.showData(self._repData:getLong(i,"time"))

            item:getChildByName('time'):setString(dateStr)
            cclog(self._repData:getString(i,"content"))
            local table1 = Split(self._repData:getString(i,"content"),"%\\")

            if tonumber(table1[1]) == 1 then
                item:getChildByName("info"):getChildByName("state"):setString(" "..ff.langString("成功"))
            else
                item:getChildByName("info"):getChildByName("state"):setString(" "..ff.langString("失败"))
            end

            item:getChildByName("info"):getChildByName("name"):setString(ff.langString("百鬼来袭").." "..ff.langString("第{0}波",{table1[9]}))

            local mapsite=dd.MapidToXY(tonumber(table1[3]))

        
            item:getChildByName("text"):setString("From (x:"..mapsite.x..",y:"..mapsite.y..")")
            
            item:getChildByName("touch"):addTouchEventListener(self.openGCRepEvent)
            item:getChildByName("touch"):setTag(i)
            item:setTag(i)
            item:getChildByName("button"):addTouchEventListener(self.openGCRepEvent)
            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):setVisible(false) 
            item:getChildByName("checkbox2"):setTag(i)


            self:getChildByName("scrollview"):pushBackCustomItem(item)
        elseif type == 217 then
             item = self:getChildByName("complexInfo"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            if dd.myinfo:getLong(1,"urZB") > 0 then
                item:getChildByName("tag"):setVisible(true)
                item:getChildByName("tag"):getChildByName("Label"):setString(dd.myinfo:getLong(1,"urZB"))
            end
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i25_mail.png",1))

            local dateStr = ff.showData(self._repData:getLong(i,"time"))

            item:getChildByName('time'):setString(dateStr)
            cclog(self._repData:getString(i,"content"))
            local table1 = Split(self._repData:getString(i,"content"),"%\\")

            if tonumber(table1[1]) == 1 then
                item:getChildByName("info"):getChildByName("state"):setString(" "..ff.langString("成功"))
            else
                item:getChildByName("info"):getChildByName("state"):setString(" "..ff.langString("失败"))
            end

            item:getChildByName("info"):getChildByName("name"):setString(ff.langString("地下城堡").." "..ff.langString("第{0}波",{table1[7]}))

            local mapsite=dd.MapidToXY(tonumber(table1[2]))

        
            item:getChildByName("text"):setString("From (x:"..mapsite.x..",y:"..mapsite.y..")")
            
            item:getChildByName("touch"):addTouchEventListener(self.openZBRepEvent)
            item:getChildByName("touch"):setTag(i)
            item:setTag(i)
            item:getChildByName("button"):addTouchEventListener(self.openZBRepEvent)
            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):setVisible(false) 
            item:getChildByName("checkbox2"):setTag(i)


            self:getChildByName("scrollview"):pushBackCustomItem(item)
        elseif type == 215 then
             item = self:getChildByName("complexInfo"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)

            --if self._repData:getLong(i,"state") == 0 then
           --     item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic05_mail.png",1))                
            --elseif self._repData:getLong(i,"state") == 1 then
            --    item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                
           -- end
            
            if dd.myinfo:getLong(1,"urboss") > 0 then
                item:getChildByName("tag"):setVisible(true)
                item:getChildByName("tag"):getChildByName("Label"):setString(dd.myinfo:getLong(1,"urboss"))
            end
                
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i23_mail.png",1))

            local dateStr = ff.showData(self._repData:getLong(i,"time"))

            item:getChildByName('time'):setString(dateStr)
            cclog(self._repData:getString(i,"content"))
            local table1 = Split(self._repData:getString(i,"content"),"%\\")

            if tonumber(table1[1]) == 1 then
                item:getChildByName("info"):getChildByName("state"):setString(" "..ff.langString("成功"))
            else
                item:getChildByName("info"):getChildByName("state"):setString(" "..ff.langString("失败"))
            end

            item:getChildByName("info"):getChildByName("name"):setString(ff.langString(dd.cfgNpc[tonumber(table1[2])]["name"]).."  LV."..dd.cfgNpc[tonumber(table1[2])]["level"])

            local mapsite=dd.MapidToXY(tonumber(table1[3]))

        
            item:getChildByName("text"):setString("From (x:"..mapsite.x..",y:"..mapsite.y..")")
            
            item:getChildByName("touch"):addTouchEventListener(self.openBossRepEvent)
            item:getChildByName("touch"):setTag(i)
            item:setTag(i)
            item:getChildByName("button"):addTouchEventListener(self.openBossRepEvent)
            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):setVisible(false) 
            item:getChildByName("checkbox2"):setTag(i)


            self:getChildByName("scrollview"):pushBackCustomItem(item)
        elseif type == 218 then
             item = self:getChildByName("complexInfo"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)

            --if self._repData:getLong(i,"state") == 0 then
            --    item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic05_mail.png",1))                
           -- elseif self._repData:getLong(i,"state") == 1 then
           --     item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                
            --end
            --cclog("00000000000000000000==="..dd.myinfo:getLong(1,"urRboss"))
            if dd.myinfo:getLong(1,"urRboss") > 0 then
                item:getChildByName("tag"):setVisible(true)
                item:getChildByName("tag"):getChildByName("Label"):setString(dd.myinfo:getLong(1,"urRboss"))
            end
                
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i26_mail.png",1))

            local dateStr = ff.showData(self._repData:getLong(i,"time"))

            item:getChildByName('time'):setString(dateStr)
            cclog(self._repData:getString(i,"content"))
            local table1 = Split(self._repData:getString(i,"content"),"%\\")

            if tonumber(table1[1]) == 1 then
                item:getChildByName("info"):getChildByName("state"):setString(" "..ff.langString("成功"))
            else
                item:getChildByName("info"):getChildByName("state"):setString(" "..ff.langString("失败"))
            end

            item:getChildByName("info"):getChildByName("name"):setString(ff.langString(dd.cfgNpc[tonumber(table1[2])]["name"]).."  LV."..dd.cfgNpc[tonumber(table1[2])]["level"])

            local mapsite=dd.MapidToXY(tonumber(table1[3]))

        
            item:getChildByName("text"):setString("From (x:"..mapsite.x..",y:"..mapsite.y..")")
            
            item:getChildByName("touch"):addTouchEventListener(self.openBossRepEventEx)
            item:getChildByName("touch"):setTag(i)
            item:setTag(i)
            item:getChildByName("button"):addTouchEventListener(self.openBossRepEventEx)
            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):setVisible(false) 
            item:getChildByName("checkbox2"):setTag(i)


            self:getChildByName("scrollview"):pushBackCustomItem(item)
        elseif type == 201 then
            item = self:getChildByName("collectInfo"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i13_mail.png",1))


            if dd.myinfo:getLong(1,"urcj") > 0 then
                item:getChildByName("tag"):setVisible(true)
                item:getChildByName("tag"):getChildByName("Label"):setString(dd.myinfo:getLong(1,"urcj"))
            end

            local dateStr = ff.showData(self._repData:getLong(i,"time"))

            item:getChildByName('time'):setString(dateStr)
            item:getChildByName("award2"):setVisible(false)
            local table = Split(self._repData:getString(i,"content"),"%\\")

            local giftInfo = Split(table[3],'|')
            for key, var in pairs(giftInfo) do
                local gift = Split(var,'%^')
                if key == 1 then
                    if tonumber(gift[1]) <= 7 and tonumber(gift[1]) ~= 1 then
                        local id = tonumber(gift[1])
                        if id == 2 then
                            item:getChildByName("award"):getChildByName("image"):
                                loadTexture(dd.getPathFromUI("public/v2/res_ic01.png",1))
                        elseif id == 3 then
                            item:getChildByName("award"):getChildByName("image"):
                                loadTexture(dd.getPathFromUI("public/v2/res_ic02.png",1))
                        elseif id == 4 then
                            item:getChildByName("award"):getChildByName("image"):
                                loadTexture(dd.getPathFromUI("public/v2/res_ic03.png",1))
                        elseif id ==5 then
                            item:getChildByName("award"):getChildByName("image"):
                                loadTexture(dd.getPathFromUI("public/v2/res_ic04.png",1))
                        elseif id == 6 then
                            item:getChildByName("award"):getChildByName("image"):
                                loadTexture(dd.getPathFromUI("public/v2/res_ic05.png",1))
                        elseif id == 7 then
                            item:getChildByName("award"):getChildByName("image"):
                                loadTexture(dd.getPathFromUI("public/v2/res_ic06.png",1))
                        end
                    else
                        item:getChildByName("award"):getChildByName("image"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                        
                    end
                    item:getChildByName("award"):getChildByName("number"):setString(ff.getFormatMoney(gift[3]))
                else
                    if tonumber(gift[1]) == 1 then
                        item:getChildByName("award2"):setVisible(true)
                        item:getChildByName("award2"):getChildByName("number"):setString("X "..ff.getFormatMoney(gift[3]))
                        item:getChildByName("award2"):getChildByName("image"):loadTexture(dd.getToolsIcon(tonumber(gift[2])),0)
                    end
                end
        
            end

            local mapsite=dd.MapidToXY(tonumber(table[2]))

            local info =  item:getChildByName("info")
            info:getChildByName("point"):setString("(x:"..mapsite.x..",y:"..mapsite.y..")")

            item:getChildByName("touch"):addTouchEventListener(self.openResRepEvent)
            item:getChildByName("touch"):setTag(i)
            item:setTag(i)
            item:getChildByName("button"):addTouchEventListener(self.openResRepEvent)
            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):setVisible(false)
            item:getChildByName("checkbox2"):setTag(i)
        

            self:getChildByName("scrollview"):pushBackCustomItem(item)
        end 
    end
    --self:getChildByName("scrollview"):refreshView()
end

function mailLayer:updateMails(mailList)
    local mails = mailList.info

    local viewmails = 0
    if mailList.info ~= nil then
        self:updateSqlMail(mailList.info)
    end
    if mails ~= nil then
        for i=1,mails:rowCount() do
            local row = self._showData:addRow()
            self._showData:setSuperLong(row,"id",mails:getSuperLong(i,"id"))
            self._showData:setLong(row,"time",mails:getLong(i,"time"))
            self._showData:setLong(row,"mail_type",mails:getLong(i,"mail_type"))
            self._showData:setLong(row,"sender_uid",mails:getLong(i,"sender_uid"))
            self._showData:setString(row,"sender",mails:getString(i,"sender"))
            self._showData:setString(row,"sender_union",mails:getString(i,"sender_union"))
            self._showData:setString(row,"title",mails:getString(i,"title"))
            self._showData:setString(row,"content",mails:getString(i,"content"))
            self._showData:setLong(row,"read_flag",mails:getLong(i,"read_flag"))
            self._showData:setLong(row,"selected",mails:getLong(i,"receiveid"))
          
            self._userRecvID = mails:getSuperLong(i,"id")

        end
        viewmails = mails:rowCount()
        mailList.info:clear()
        mailList.info = nil
    end
    self:showMails()
    return viewmails
end

function mailLayer:updateReps( table)
    -- body
    local replist = table.info
   
    if table.type == 2 then
        if replist ~= nil then
        
        for i=1,replist:rowCount() do
            
                local row = self._repData:addRow()
                self._repData:setSuperLong(row,"id",replist:getSuperLong(i,"id"))
                self._repData:setLong(row,"time",replist:getLong(i,"time"))
                self._repData:setLong(row,"state",replist:getLong(i,"state"))
                self._repData:setLong(row,"type",replist:getLong(i,"type"))
                self._repData:setString(row,"content",replist:getString(i,"content"))
                self._repData:setString(row,"awardStr",replist:getString(i,"awardStr"))
                self._repData:setLong(row,"awardTime",replist:getLong(i,"awardTime"))
                self._repData:setLong(row,"selected",replist:getLong(i,"receiveid"))
                self._repData:setLong(row,"selected2",0)
                self._repCount = replist:getSuperLong(i,"id")
            
        end
        
        table.info:clear()
        table.info = nil
        end

        self:onShowReps()
    elseif table.type == 1 then
      
        if replist ~= nil then
        for i=1,replist:rowCount() do
            local row = self._NoticeData:addRow()
            self._NoticeData:setSuperLong(row,"id",replist:getSuperLong(i,"id"))
            self._NoticeData:setLong(row,"time",replist:getLong(i,"time"))
            self._NoticeData:setLong(row,"state",replist:getLong(i,"state"))
            self._NoticeData:setLong(row,"type",replist:getLong(i,"type"))
            self._NoticeData:setString(row,"content",replist:getString(i,"content"))
            self._NoticeData:setString(row,"awardStr",replist:getString(i,"awardStr"))
            self._NoticeData:setLong(row,"awardTime",replist:getLong(i,"awardTime"))
            self._NoticeData:setLong(row,"selected",replist:getLong(i,"receiveid"))
            self._NoticeData:setLong(row,"selected2",0)
            self._noticeCount = replist:getSuperLong(i,"id")
            
        end
        table.info:clear()
        table.info = nil
        end

        self:onShowNotices()
    end
    
    return

end



function mailLayer:onShowNotices(  )
    -- body
    if self._NoticeData == nil then
        return
    end

    self:getChildByName("scrollview"):removeAllChildren(true)
    self:getChildByName("scrollview"):setVisible(true)
    
    for i=1,self._NoticeData:rowCount() do
        local haveAward = false
        if self._NoticeData:getLong(i,"awardTime") == 0 then
            haveAward = true
        end
        local item = nil
        local type = self._NoticeData:getLong(i,"type")

        if type == 101 then
            item = self:getChildByName("mailinfoex"):clone()
            if self._NoticeData:getLong(i,"selected2") == 1 then
                item:getChildByName("checkbox"):setSelectedState(true)
            end
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            if self._NoticeData:getLong(i,"state") == 0 then
                item:getChildByName("title"):setColor(cc.c3b(207,201,152))
                item:getChildByName("text"):setColor(cc.c3b(207,201,152))
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic05_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
                for i=1,7 do
                    local back = item:getChildByName("back"):clone()
                    item:addChild(back)
                    back:setTag(100+i)
                end
            elseif self._NoticeData:getLong(i,"state") == 3 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(true)
            elseif self._NoticeData:getLong(i,"state") == 1 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
            end

            local dateStr = ff.showData(self._NoticeData:getLong(i,"time"))
            item:getChildByName('time'):setString(dateStr)

            local num = 0 
            local content = '' 
            content,num = string.gsub(self._NoticeData:getString(i,"content"),"/n"," ") 
            local table = Split(content,"%\\")
          
            if haveAward  == true then
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i19_mail.png",1))
            else
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i15_mail.png",1))
            end
           

            item:getChildByName("name"):setString(table[1])

            
            item:getChildByName("text"):setString(table[2])

            item:getChildByName("touch"):addTouchEventListener(self.openNoticeEvent)
            item:getChildByName("touch"):setTag(i)

            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):addTouchEventListener(self.checkRepEvent)
            item:getChildByName("checkbox2"):setTag(i)
            item:getChildByName("checkbox2"):addTouchEventListener(self.checkRepEvent)

            item:getChildByName("iscollect"):setTag(i)
            item:getChildByName("iscollect"):addTouchEventListener(self.collectRepEvent)
            item:getChildByName("iscollect2"):setTag(i)
            item:getChildByName("iscollect2"):addTouchEventListener(self.collectRepEvent)
            self:getChildByName("scrollview"):pushBackCustomItem(item)

        elseif type == 102 then
            item = self:getChildByName("mailinfoex"):clone()
            if self._NoticeData:getLong(i,"selected2") == 1 then
                item:getChildByName("checkbox"):setSelectedState(true)
            end
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            if self._NoticeData:getLong(i,"state") == 0 then
                item:getChildByName("title"):setColor(cc.c3b(207,201,152))
                item:getChildByName("text"):setColor(cc.c3b(207,201,152))
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic05_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
                for i=1,7 do
                    local back = item:getChildByName("back"):clone()
                    item:addChild(back)
                    back:setTag(100+i)
                end
            elseif self._NoticeData:getLong(i,"state") == 3 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(true)
            elseif self._NoticeData:getLong(i,"state") == 1 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
            end

            local dateStr = ff.showData(self._NoticeData:getLong(i,"time"))
            item:getChildByName('time'):setString(dateStr)

            local table = Split(self._NoticeData:getString(i,"content"),"%\\")
            
            if haveAward  == true then
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i19_mail.png",1))
            else
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i15_mail.png",1))
            end
           
            item:getChildByName("name"):setString(table[1])

            item:getChildByName("text"):setString(table[2])

            item:getChildByName("touch"):addTouchEventListener(self.openNoticeEvent)
            item:getChildByName("touch"):setTag(i)

            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):addTouchEventListener(self.checkRepEvent)
            item:getChildByName("checkbox2"):setTag(i)
            item:getChildByName("checkbox2"):addTouchEventListener(self.checkRepEvent)

            item:getChildByName("iscollect"):setTag(i)
            item:getChildByName("iscollect"):addTouchEventListener(self.collectRepEvent)
            item:getChildByName("iscollect2"):setTag(i)
            item:getChildByName("iscollect2"):addTouchEventListener(self.collectRepEvent)
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        elseif type == 103 then
            item = self:getChildByName("mailinfoex"):clone()
            if self._NoticeData:getLong(i,"selected2") == 1 then
                item:getChildByName("checkbox"):setSelectedState(true)
            end
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            if self._NoticeData:getLong(i,"state") == 0 then
                item:getChildByName("title"):setColor(cc.c3b(207,201,152))
                item:getChildByName("text"):setColor(cc.c3b(207,201,152))
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic05_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
                for i=1,7 do
                    local back = item:getChildByName("back"):clone()
                    item:addChild(back)
                    back:setTag(100+i)
                end
            elseif self._NoticeData:getLong(i,"state") == 3 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(true)
            elseif self._NoticeData:getLong(i,"state") == 1 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
            end

            local dateStr = ff.showData(self._NoticeData:getLong(i,"time"))
            item:getChildByName('time'):setString(dateStr)

            local table = Split(self._NoticeData:getString(i,"content"),"%\\")
            
            if haveAward  == true then
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i19_mail.png",1))
            else
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i15_mail.png",1))
            end
           

            item:getChildByName("name"):setString(table[1])


            item:getChildByName("text"):setString(table[2])

            item:getChildByName("touch"):addTouchEventListener(self.openNoticeEvent)
            item:getChildByName("touch"):setTag(i)

            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):addTouchEventListener(self.checkRepEvent)
            item:getChildByName("checkbox2"):setTag(i)
            item:getChildByName("checkbox2"):addTouchEventListener(self.checkRepEvent)

            item:getChildByName("iscollect"):setTag(i)
            item:getChildByName("iscollect"):addTouchEventListener(self.collectRepEvent)
            item:getChildByName("iscollect2"):setTag(i)
            item:getChildByName("iscollect2"):addTouchEventListener(self.collectRepEvent)
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        elseif type == 111 then
            item = self:getChildByName("mailinfoex"):clone()
            if self._NoticeData:getLong(i,"selected2") == 1 then
                item:getChildByName("checkbox"):setSelectedState(true)
            end
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            if self._NoticeData:getLong(i,"state") == 0 then
                item:getChildByName("title"):setColor(cc.c3b(207,201,152))
                item:getChildByName("text"):setColor(cc.c3b(207,201,152))
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic05_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
                for i=1,7 do
                    local back = item:getChildByName("back"):clone()
                    item:addChild(back)
                    back:setTag(100+i)
                end
            elseif self._NoticeData:getLong(i,"state") == 3 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(true)
            elseif self._NoticeData:getLong(i,"state") == 1 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
            end

            local dateStr = ff.showData(self._NoticeData:getLong(i,"time"))
            item:getChildByName('time'):setString(dateStr)

            local table = Split(self._NoticeData:getString(i,"content"),"%\\")
            cclog("id:"..self._NoticeData:getSuperLong(i,"id"))
            cclog(self._NoticeData:getString(i,"content"))
            
            if haveAward  == true then
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i19_mail.png",1))
            else
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i15_mail.png",1))
            end

            item:getChildByName("name"):setString(ff.langString("充值"))

            local totle = tonumber(table[3])+tonumber(table[4])
            if dd.cfgCharge[tonumber(table[2])] ~= nil then
                item:getChildByName("text"):setString(ff.langString(dd.cfgCharge[tonumber(table[2])]['name']).." "..ff.langString("充值成功")..ff.langString("获得金币")..totle)
            end
        
            item:getChildByName("touch"):addTouchEventListener(self.openNoticeEvent)
            item:getChildByName("touch"):setTag(i)

            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):addTouchEventListener(self.checkRepEvent)
            item:getChildByName("checkbox2"):setTag(i)
            item:getChildByName("checkbox2"):addTouchEventListener(self.checkRepEvent)

            item:getChildByName("iscollect"):setTag(i)
            item:getChildByName("iscollect"):addTouchEventListener(self.collectRepEvent)
            item:getChildByName("iscollect2"):setTag(i)
            item:getChildByName("iscollect2"):addTouchEventListener(self.collectRepEvent)
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        elseif type == 112 then
            item = self:getChildByName("mailinfoex"):clone()
            if self._NoticeData:getLong(i,"selected2") == 1 then
                item:getChildByName("checkbox"):setSelectedState(true)
            end
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            if self._NoticeData:getLong(i,"state") == 0 then
                item:getChildByName("title"):setColor(cc.c3b(207,201,152))
                item:getChildByName("text"):setColor(cc.c3b(207,201,152))
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic05_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
                for i=1,7 do
                    local back = item:getChildByName("back"):clone()
                    item:addChild(back)
                    back:setTag(100+i)
                end
            elseif self._NoticeData:getLong(i,"state") == 3 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(true)
            elseif self._NoticeData:getLong(i,"state") == 1 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
            end

            local dateStr = ff.showData(self._NoticeData:getLong(i,"time"))
            item:getChildByName('time'):setString(dateStr)

            local table = Split(self._NoticeData:getString(i,"content"),"%\\")
            --cclog(self._repData:getString(i,"content"))
            
            if haveAward  == true then
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i19_mail.png",1))
            else
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i15_mail.png",1))
            end

            item:getChildByName("name"):setString(ff.langString("司令部"))

            item:getChildByName("text"):setString(ff.langString("恭喜！你的司令部升级到LV{0}",{table[1]}))

            item:getChildByName("touch"):addTouchEventListener(self.openNoticeEvent)
            item:getChildByName("touch"):setTag(i)

            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):addTouchEventListener(self.checkRepEvent)
            item:getChildByName("checkbox2"):setTag(i)
            item:getChildByName("checkbox2"):addTouchEventListener(self.checkRepEvent)

            item:getChildByName("iscollect"):setTag(i)
            item:getChildByName("iscollect"):addTouchEventListener(self.collectRepEvent)
            item:getChildByName("iscollect2"):setTag(i)
            item:getChildByName("iscollect2"):addTouchEventListener(self.collectRepEvent)
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        elseif type == 117 then
            item = self:getChildByName("mailinfoex"):clone()
            if self._NoticeData:getLong(i,"selected2") == 1 then
                item:getChildByName("checkbox"):setSelectedState(true)
            end
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            if self._NoticeData:getLong(i,"state") == 0 then
                item:getChildByName("title"):setColor(cc.c3b(207,201,152))
                item:getChildByName("text"):setColor(cc.c3b(207,201,152))
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic05_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
                for i=1,7 do
                    local back = item:getChildByName("back"):clone()
                    item:addChild(back)
                    back:setTag(100+i)
                end
            elseif self._NoticeData:getLong(i,"state") == 3 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(true)
            elseif self._NoticeData:getLong(i,"state") == 1 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
            end

            local dateStr = ff.showData(self._NoticeData:getLong(i,"time"))
            item:getChildByName('time'):setString(dateStr)

            local table = Split(self._NoticeData:getString(i,"content"),"%\\")
            --cclog(self._repData:getString(i,"content"))
            
            if haveAward  == true then
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i19_mail.png",1))
            else
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i15_mail.png",1))
            end

            item:getChildByName("name"):setString(ff.langString("登陆奖励"))
            
            item:getChildByName("text"):setString(ff.langString("请领取登陆奖励"))

            item:getChildByName("touch"):addTouchEventListener(self.openNoticeEvent)
            item:getChildByName("touch"):setTag(i)

            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):addTouchEventListener(self.checkRepEvent)
            item:getChildByName("checkbox2"):setTag(i)
            item:getChildByName("checkbox2"):addTouchEventListener(self.checkRepEvent)

            item:getChildByName("iscollect"):setTag(i)
            item:getChildByName("iscollect"):addTouchEventListener(self.collectRepEvent)
            item:getChildByName("iscollect2"):setTag(i)
            item:getChildByName("iscollect2"):addTouchEventListener(self.collectRepEvent)
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        elseif type == 115 then
            item = self:getChildByName("mailinfoex"):clone()
            if self._NoticeData:getLong(i,"selected2") == 1 then
                item:getChildByName("checkbox"):setSelectedState(true)
            end
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            if self._NoticeData:getLong(i,"state") == 0 then
                item:getChildByName("title"):setColor(cc.c3b(207,201,152))
                item:getChildByName("text"):setColor(cc.c3b(207,201,152))
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic05_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
                for i=1,7 do
                    local back = item:getChildByName("back"):clone()
                    item:addChild(back)
                    back:setTag(100+i)
                end
            elseif self._NoticeData:getLong(i,"state") == 3 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(true)
            elseif self._NoticeData:getLong(i,"state") == 1 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
            end

            local dateStr = ff.showData(self._NoticeData:getLong(i,"time"))
            item:getChildByName('time'):setString(dateStr)

            local table = Split(self._NoticeData:getString(i,"content"),"%\\")
            --cclog(self._repData:getString(i,"content"))
            
            if haveAward  == true then
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i19_mail.png",1))
            else
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i15_mail.png",1))
            end

            item:getChildByName("name"):setString(ff.langString("运送通知"))

            item:getChildByName("text"):setString(ff.langString("你运送的资源已经到达！"))

            item:getChildByName("touch"):addTouchEventListener(self.openNoticeEvent)
            item:getChildByName("touch"):setTag(i)

            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):addTouchEventListener(self.checkRepEvent)
            item:getChildByName("checkbox2"):setTag(i)
            item:getChildByName("checkbox2"):addTouchEventListener(self.checkRepEvent)

            item:getChildByName("iscollect"):setTag(i)
            item:getChildByName("iscollect"):addTouchEventListener(self.collectRepEvent)
            item:getChildByName("iscollect2"):setTag(i)
            item:getChildByName("iscollect2"):addTouchEventListener(self.collectRepEvent)
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        elseif type == 116 then
            item = self:getChildByName("mailinfoex"):clone()
            if self._NoticeData:getLong(i,"selected2") == 1 then
                item:getChildByName("checkbox"):setSelectedState(true)
            end
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            if self._NoticeData:getLong(i,"state") == 0 then
                item:getChildByName("title"):setColor(cc.c3b(207,201,152))
                item:getChildByName("text"):setColor(cc.c3b(207,201,152))
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic05_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
                for i=1,7 do
                    local back = item:getChildByName("back"):clone()
                    item:addChild(back)
                    back:setTag(100+i)
                end
            elseif self._NoticeData:getLong(i,"state") == 3 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(true)
            elseif self._NoticeData:getLong(i,"state") == 1 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
            end

            local dateStr = ff.showData(self._NoticeData:getLong(i,"time"))
            item:getChildByName('time'):setString(dateStr)

            local table = Split(self._NoticeData:getString(i,"content"),"%\\")
            --cclog(self._repData:getString(i,"content"))
            
            if haveAward  == true then
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i19_mail.png",1))
            else
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i15_mail.png",1))
            end

            item:getChildByName("name"):setString(ff.langString("运送通知"))

            item:getChildByName("text"):setString(ff.langString("来自好友{0}的资源已到达！",{table[1]}))

            item:getChildByName("touch"):addTouchEventListener(self.openNoticeEvent)
            item:getChildByName("touch"):setTag(i)

            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):addTouchEventListener(self.checkRepEvent)
            item:getChildByName("checkbox2"):setTag(i)
            item:getChildByName("checkbox2"):addTouchEventListener(self.checkRepEvent)

            item:getChildByName("iscollect"):setTag(i)
            item:getChildByName("iscollect"):addTouchEventListener(self.collectRepEvent)
            item:getChildByName("iscollect2"):setTag(i)
            item:getChildByName("iscollect2"):addTouchEventListener(self.collectRepEvent)
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        elseif type == 113 then
            item = self:getChildByName("mailinfoex"):clone()
            if self._NoticeData:getLong(i,"selected2") == 1 then
                item:getChildByName("checkbox"):setSelectedState(true)
            end
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            if self._NoticeData:getLong(i,"state") == 0 then
                item:getChildByName("title"):setColor(cc.c3b(207,201,152))
                item:getChildByName("text"):setColor(cc.c3b(207,201,152))
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic05_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
                for i=1,7 do
                    local back = item:getChildByName("back"):clone()
                    item:addChild(back)
                    back:setTag(100+i)
                end
            elseif self._NoticeData:getLong(i,"state") == 3 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(true)
            elseif self._NoticeData:getLong(i,"state") == 1 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
            end

            local dateStr = ff.showData(self._NoticeData:getLong(i,"time"))
            item:getChildByName('time'):setString(dateStr)

            local table = Split(self._NoticeData:getString(i,"content"),"%\\")
            --cclog("===="..self._NoticeData:getString(i,"content"))
            
            if haveAward  == true then
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i19_mail.png",1))
            else
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i15_mail.png",1))
            end
           
            --local info =  item:getChildByName("info")
            --info:getChildByName("type"):setString("")
            --info:getChildByName("union"):setString("")
       
            --info:getChildByName("info"):setString("")
            --cclog("==============================================="..tonumber(table[1]))
            if tonumber(table[1]) == 1 then
                item:getChildByName("name"):setString(ff.langString("{0}奖励发放",{ff.langString(self._Cfg_Activity[tonumber(table[2])]["name"])}))
                item:getChildByName("text"):setString(ff.langString("你在{0}中表现出色，获得以下奖励，请再接再厉",{ff.langString(self._Cfg_Activity[tonumber(table[2])]["name"])}))
            elseif tonumber(table[1]) == 23 then
                item:getChildByName("name"):setString(ff.langString("{0}(跨服)奖励发放",{ff.langString(dd.Cfg_Activity_type[tonumber(table[2])]["name"])}))
                item:getChildByName("text"):setString(ff.langString("你在{0}中表现出色，获得以下奖励，请再接再厉",{ff.langString(dd.Cfg_Activity_type[tonumber(table[2])]["name"])}))
            else
                item:getChildByName("name"):setString(ff.langString("{0}奖励发放",{ff.langString(dd.Cfg_Activity_type[tonumber(table[2])]["name"])}))
                item:getChildByName("text"):setString(ff.langString("你在{0}中表现出色，获得以下奖励，请再接再厉",{ff.langString(dd.Cfg_Activity_type[tonumber(table[2])]["name"])}))
            end

            item:getChildByName("touch"):addTouchEventListener(self.openNoticeEvent)
            item:getChildByName("touch"):setTag(i)

            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):addTouchEventListener(self.checkRepEvent)
            item:getChildByName("checkbox2"):setTag(i)
            item:getChildByName("checkbox2"):addTouchEventListener(self.checkRepEvent)

            item:getChildByName("iscollect"):setTag(i)
            item:getChildByName("iscollect"):addTouchEventListener(self.collectRepEvent)
            item:getChildByName("iscollect2"):setTag(i)
            item:getChildByName("iscollect2"):addTouchEventListener(self.collectRepEvent)
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        elseif type == 114 then
            item = self:getChildByName("mailinfoex"):clone()
            if self._NoticeData:getLong(i,"selected2") == 1 then
                item:getChildByName("checkbox"):setSelectedState(true)
            end
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            if self._NoticeData:getLong(i,"state") == 0 then
                item:getChildByName("title"):setColor(cc.c3b(207,201,152))
                item:getChildByName("text"):setColor(cc.c3b(207,201,152))
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic05_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
                for i=1,7 do
                    local back = item:getChildByName("back"):clone()
                    item:addChild(back)
                    back:setTag(100+i)
                end
            elseif self._NoticeData:getLong(i,"state") == 3 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(true)
            elseif self._NoticeData:getLong(i,"state") == 1 then
                item:getChildByName("read"):loadTexture(dd.getPathFromUI("ic06_mail.png",1))
                item:getChildByName("iscollect"):setSelectedState(false)
            end

            local dateStr = ff.showData(self._NoticeData:getLong(i,"time"))
            item:getChildByName('time'):setString(dateStr)
            local num = 0 
            local content = '' 
            content,num = string.gsub(self._NoticeData:getString(i,"content"),"/n"," ")  
            local table = Split(content,"%\\")
            
            if haveAward  == true then
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i19_mail.png",1))
            else
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("i15_mail.png",1))
            end
            
            local type = tonumber(table[1])

            if type ~= nil then 
                item:getChildByName("name"):setString(ff.langString(notify[tonumber(table[1])]))
                local str11 = Split(table[2],",")
                local tt = ""
                if tonumber(table[1]) == 67 or tonumber(table[1]) == 69 then
                    tt = ff.langString(notify[tonumber(str11[1])],{str11[2],ff.langString(dd.official[tonumber(str11[3])])})
                    item:getChildByName("text"):setString(tt)
                else
                    tt = {
                    [1] = ff.langString(notify[tonumber(str11[1])]),
                    [2] = ff.langString(notify[tonumber(str11[1])],{str11[2]}),
                    [3] = ff.langString(notify[tonumber(str11[1])],{str11[2],str11[3]}),
                    [4] = ff.langString(notify[tonumber(str11[1])],{str11[2],str11[3],str11[4]}),
                    [5] = ff.langString(notify[tonumber(str11[1])],{str11[2],str11[3],str11[4],str11[5]}),
                    [6] = ff.langString(notify[tonumber(str11[1])],{str11[2],str11[3],str11[4],str11[5],str11[6]}),
                }
                    if #(str11) < 7 then
                        item:getChildByName("text"):setString(tt[#(str11)])
                    end
                end
                
                

            else

                local str11 = SplitEx(table[1],",",1)
                if str11[2] ~= nil then
                    if tonumber(str11[1]) == 0 then
                        item:getChildByName("name"):setString(str11[2])
                    end
                else
                    item:getChildByName("name"):setString(table[1])
                    item:getChildByName("text"):setString(table[2])
                end
                local str22 = SplitEx(table[2],",",1)
                if str22[2] ~= nil then
                    if tonumber(str22[1]) == 0 then
                        item:getChildByName("text"):setString(str22[2])
                    end
                else
                    item:getChildByName("text"):setString(table[2])
                end
            end

            item:getChildByName("touch"):addTouchEventListener(self.openNoticeEvent)
            item:getChildByName("touch"):setTag(i)

            item:getChildByName("checkbox"):setTag(i)
            item:getChildByName("checkbox"):addTouchEventListener(self.checkRepEvent)
            item:getChildByName("checkbox2"):setTag(i)
            item:getChildByName("checkbox2"):addTouchEventListener(self.checkRepEvent)

            item:getChildByName("iscollect"):setTag(i)
            item:getChildByName("iscollect"):addTouchEventListener(self.collectRepEvent)
            item:getChildByName("iscollect2"):setTag(i)
            item:getChildByName("iscollect2"):addTouchEventListener(self.collectRepEvent)
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        end 
    end
    --self:getChildByName("scrollview"):refreshView()
end