--写邮件面板

mailWriteLayer = class("mailWriteLayer")
mailWriteLayer._name = "mailWrite"
mailWriteLayer._init = false
mailWriteLayer._toUid = 0
mailWriteLayer._toUsers = {}
mailWriteLayer._lanType = nil
mailWriteLayer._rId = 0
mailWriteLayer.wmail = nil
mailWriteLayer._titleBox = nil
mailWriteLayer._nameBox = nil
mailWriteLayer._infoBox = nil
mailWriteLayer._isFriendOpen = false
mailWriteLayer._isFriendInited = false
mailWriteLayer._ismail = 0

require "view/mail/mailFriend"

function mailWriteLayer.extend( target )
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,mailWriteLayer)
	return target
	-- body
end
--big全屏幕,send_Uid对方UID,name对方名字,title标题,lType（cn ro en ）,users（用户）,mailtype(0邮件，1联盟),Rid（回复哪封邮件）
function onShowMailWrite(widget ,big,send_Uid,name,title,lType,users,mailtype,Rid)
	--cclog("=====mailllllll")
	local layer = mailWriteLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
	--cclog("==laile!!!!!!!!!!!!!!!")
	layer:onInit(big,send_Uid,name,title,lType,users,mailtype,Rid)
	return layer
	-- body
end

function mailWriteLayer.onReturn(sender,eventType)
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("mailWrite")
		if widget == nil then
			return
		end
		if widget._isFriendOpen then
			widget:closeFriend()
		else
        	pop.onClosePopDialog("mailWrite")
    	end
    end
end

function mailWriteLayer.sendMail(sender,eventType)
	-- body
	if eventType == ccui.TouchEventType.ended then
		platform_clearAllInputText()
		local widget = pop.getDialog("mailWrite")
		if widget == nil then
			return
		end


		local write = widget:getChildByName("write")
		local titleInput = write:getChildByName("titleInputB"):getChildByName("titleInput")
		local nameInput = write:getChildByName("nameInputB"):getChildByName("nameInput")
		local infoInput = widget:getChildByName("infoB"):getChildByName("info")

		if widget._nameBox:getText() == '' or widget._infoBox:getText() == '' then
			dd.currentLayer._widget:onShowTips("\t"..ff.langString("发送邮件信息不完整"))
            return
        end

        if widget._toUid == dd.uid or widget._nameBox:getText() == dd.myinfo:getString(1,"name") then 
        	dd.currentLayer._widget:onShowTips("\t"..ff.langString("不能给自己发邮件"))
            return
        end

        local getMailListMg = ff.net:createMessage()            
            getMailListMg:addCmd(0xF08)
            getMailListMg:addLong(dd.uid)
            getMailListMg:addLong(widget._ismail)
            --cclog("=========="..widget._ismail)
            getMailListMg:addString(widget._titleBox:getText(),63)
            getMailListMg:addString(widget._infoBox:getText(),511)
            getMailListMg:addString("ch",15)
            if widget._ismail == 1 then
            	getMailListMg:addSuperLong(0)
            	getMailListMg:addLong(0)
            	getMailListMg:addLong(0)
            	getMailListMg:addString("",15)
            else
            	getMailListMg:addSuperLong(widget._rId)
            --cclog("idididididdidididid===="..widget._rId)
            	if widget._toUid > 0 then
            	    getMailListMg:addLong(1)
            	    getMailListMg:addLong(widget._toUid)
            	    getMailListMg:addString(widget._nameBox:getText(),15)
            	else    
            	    local count = 0
            	    for uid, name in pairs(widget._toUsers) do
            	            count = count + 1
            	        end   
            	    if count > 0 then
            	        getMailListMg:addLong(count)
            	        for uid, name in pairs(widget._toUsers) do
            	            getMailListMg:addLong(tonumber(uid))        
            	            getMailListMg:addString(name,15)  
            	       --     cclog(count.."============"..uid)
            	         --   cclog(count.."============="..name)
            	        end   
            	    else
            	    	if widget._nameBox:getText() == '' then
            	        	cclog("没有收件对象")
            	        	getMailListMg:clear()
            	        	return     
            	        else
            	        	getMailListMg:addLong(1)
            	   	 		getMailListMg:addLong(0)
            	    		getMailListMg:addString(widget._nameBox:getText(),15)
            	        end
            	    end
            	end    
            end    
            --[[
            	if widget.wmail == nil then
            	    widget.wmail = ff.NetTable:create()
            	    widget.wmail:addStreamCol("mail_type",ff.NET_LONG)
            	    widget.wmail:addStreamCol("title",ff.NET_STRING,64)
            	    widget.wmail:addStreamCol("sender",ff.NET_STRING,256)
            	    widget.wmail:addStreamCol("detail",ff.NET_STRING,511)
            	    widget.wmail:addStreamCol("lang",ff.NET_STRING,16)
            	    widget.wmail:addStreamCol("sender_union",ff.NET_STRING,16)
            	    widget.wmail:addStreamCol("type",ff.NET_LONG)
            	else
            	    widget.wmail:delRow(1)    
            	end
            	widget.wmail:addRow()
           		widget.wmail:setLong(1,"mail_type",1)
           	 	widget.wmail:setString(1,"title",widget._titleBox:getText())
           		widget.wmail:setString(1,"detail",widget._infoBox:getText())
            	widget.wmail:setString(1,"lang","ch")
            	widget.wmail:setString(1,"sender",widget._nameBox:getText())
            	widget.wmail:setLong(1,"type",1)
            	]]
            	ff.net:rpc(getMailListMg)             	
    end
end

function mailWriteLayer.onFriend( sender,eventType )
	if eventType == ccui.TouchEventType.ended then
		local widget = pop.getDialog("mailWrite")
		if widget == nil then
			return
		end

        --widget:showFriend()
        pop.onShowPopDialog("Friend",widget.initData2,nil)
        
    end
	-- body
end

function mailWriteLayer.initData2( users )
	-- body
	local widget = pop.getDialog("mailWrite")
	widget:initData(0,'',widget._titleBox:getText(),'ch',users,0)
end

function mailWriteLayer:AutoSize( big )
	-- body
	if --[[big ==]] true then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		self:getChildByName("back"):setContentSize(cc.size(720,hh))
		self:getChildByName("back"):setPositionY(0)
		--self:getChildByName("friendpanel"):setContentSize(cc.size(720,hh-105))
		--self:getChildByName("friendpanel"):setPositionY(0)
		--self:getChildByName("friendpanel"):getChildByName("back"):setContentSize(cc.size(720,hh))
		--self:getChildByName("friendpanel"):getChildByName("back"):setPositionY(0)
		--self:getChildByName("friendpanel"):getChildByName("friendlist"):setContentSize(cc.size(720,hh-105))
		--self:getChildByName("friendpanel"):getChildByName("friendlist"):setPositionY(0)
		self:getChildByName("top"):setPositionY(hh  - 105)
		self:getChildByName("write"):setPositionY(hh  - 105 - 255)
		
		self:getChildByName("Image_back"):setPositionY(177)
		self:getChildByName("Image_back"):setContentSize(cc.size(700,hh - 105 - 255 - 177))

		self:getChildByName("scrollview"):setVisible(true)
		local  ph = self:getContentSize().height
		self:getChildByName("scrollview"):setContentSize(cc.size(720,ph - 105 - 255 - 177))
		self:getChildByName("scrollview"):setPositionY(177)
		--self:getChildByName("send"):setPositionY(0)

		--事件

		--if not Rid then
		local  ph = self:getContentSize().height
		self:getChildByName("infoB"):setContentSize(cc.size(650,ph - 105 - 255-187))
		self:getChildByName("back1"):setContentSize(cc.size(650,ph - 105 - 255-198))
		self:getChildByName("back1"):setPositionY(187)
		self:getChildByName("infoB"):getChildByName("info"):setContentSize(cc.size(630,ph - 105 - 255-190))
		self:getChildByName("infoB"):setPositionY(187)
		self:getChildByName("infoB"):getChildByName("info"):setPositionY((ph - 105 - 255-187)/2)
		--self:getChildByName("top"):getChildByName("chu_title"):setString(ff.langString("邮件"))
		--self:getChildByName("top"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
        self:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
	else
		local hh = ff.height
		self:setContentSize(cc.size(720,hh-220))
		self:getChildByName("back"):setContentSize(cc.size(720,hh-220))
		self:getChildByName("back"):setPositionY(0)
		self:getChildByName("friendpanel"):setContentSize(cc.size(720,hh-220-105))
		self:getChildByName("friendpanel"):setPositionY(0)
		self:getChildByName("friendpanel"):getChildByName("back"):setContentSize(cc.size(720,hh))
		self:getChildByName("friendpanel"):getChildByName("back"):setPositionY(0)
		self:getChildByName("friendpanel"):getChildByName("friendlist"):setContentSize(cc.size(720,hh-220-105))
		self:getChildByName("friendpanel"):getChildByName("friendlist"):setPositionY(0)
		self:getChildByName("top"):setPositionY(hh - 220 - 105)
		self:getChildByName("write"):setPositionY(hh - 220 - 105 - 140)
		
		self:getChildByName("Image_back"):setPositionY(48)
		self:getChildByName("Image_back"):setContentSize(cc.size(700,hh -220 - 105 - 140 - 48))

		self:getChildByName("scrollview"):setVisible(true)
		local  ph = self:getContentSize().height
		self:getChildByName("scrollview"):setContentSize(cc.size(720,ph - 105 - 140 - 115))
		self:getChildByName("scrollview"):setPositionY(40)
		--self:getChildByName("send"):setPositionY(0)

		--if not Rid then
		local  ph = self:getContentSize().height
		self:getChildByName("infoB"):setContentSize(cc.size(700,ph - 105 - 140-58))
		self:getChildByName("infoB"):getChildByName("info"):setContentSize(cc.size(700,ph - 105 - 140-58))
		self:getChildByName("infoB"):setPositionY(78)
		self:getChildByName("infoB"):getChildByName("info"):setPositionY((ph - 105 - 140-58)/2)
	end
	local  ph = self:getContentSize().height

	--cclog("hhhh==="..(ph - 105 - 140-48).."hhhhhh=="..((ph - 105 - 140-48)/2))
end

function mailWriteLayer:onInit(big,send_Uid,name,title,lType,users,mailtype,Rid)
	self:AutoSize(big)
	if self._init == false then
		
		--else 
			--local hh = ff.height
			---self:getChildByName("infoB"):setContentSize(cc.size(700,230))
			--self:getChildByName("infoB"):getChildByName("info"):setContentSize(cc.size(700,230))
			--self:getChildByName("infoB"):setPositionY(hh - 220 - 105 - 140 - 115-230)
		--end
		self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
		self:getChildByName("write"):getChildByName("add"):addTouchEventListener(self.onFriend)
		self:getChildByName("send"):getChildByName("send"):addTouchEventListener(self.sendMail)
		self._init = true
	end
	if mailtype == 1 then
		self:getChildByName("write"):getChildByName("add"):setVisible(false)
		self:getChildByName("write"):getChildByName("add"):setTouchEnabled(false)
		--self:getChildByName("write"):getChildByName("nameInputB"):setTouchEnabled(false)
		--self:getChildByName("write"):getChildByName("nameInputB"):getChildByName("nameInput"):setTouchEnabled(false)
	else
		self:getChildByName("write"):getChildByName("add"):setVisible(true)
		self:getChildByName("write"):getChildByName("add"):setTouchEnabled(true)
		--self:getChildByName("write"):getChildByName("nameInputB"):getChildByName("nameInput"):setTouchEnabled(true)
	end
	if send_Uid == -1 then
		self:initEditBox(mailtype)
		
	else
		self:getChildByName("write"):getChildByName("add"):setVisible(false)
		self:getChildByName("write"):getChildByName("add"):setTouchEnabled(false)
		self:initEditBox(1)
		
	end
	self:initData(send_Uid,name,title,lType,users,mailtype,Rid)
	self.updateGold()
end

function mailWriteLayer:initData(send_Uid,name,title,lType,users,mailtype,Rid)
	self._toUid = send_Uid
	self._toUsers = users

	self:getChildByName("back"):setContentSize(cc.size(ff.width,ff.height))
    self:getChildByName("back"):setPositionY(0)

	if send_Uid ~= -1 then
		self._titleBox:setText(title)
	else
		self._titleBox:setText("")
	end

	--self._infoBox:setText("")

	if self._toUid == 0 then
		name = ''
		for uid,user_name in pairs(users) do
			if name == '' then
				name = user_name
			else
				name = name..','..user_name
			end
		end
	end

	self._nameBox:setText(name)

	if lType ~= nil then
		self._lanType = lType
	else
		self._lanType = 'en'
	end

	self._ismail = tonumber(mailtype)

	if self._ismail == 1 then
		self._nameBox:setText(ff.langString("联盟全体成员"))
	end

	self._rId = tonumber(Rid)
	-- body
end

function mailWriteLayer.onEnd( sender )
	-- body
	--[[
	if sender._titleBox ~= nil then
		sender._titleBox:removeFromParent(true)
		sender._titleBox = nil
	end

	if sender._nameBox ~= nil then
		sender._nameBox:removeFromParent(true)
		sender._nameBox = nil
	end

	if sender._infoBox ~= nil then
		sender._infoBox:removeFromParent(true)
		sender._infoBox = nil
	end
	]]
	if sender._infoBox ~= nil then
		sender._infoBox:setText("")
	end
	--sender:removeFromParent()
	dd.delBackEvent()
	platform_clearAllInputText()
	ff.net:unbindProperty("gold",2311)
end

function mailWriteLayer:initEditBox( mailtype )
	-- body
	local function hideInput(sender,eventType)
		-- body
		if eventType == ccui.TouchEventType.ended then
			platform_clearAllInputText()
		end
	end

	if self._titleBox ~= nil then
		self._titleBox:removeFromParent(true)
		self._titleBox = nil
	end

	if self._nameBox ~= nil then
		self._nameBox:removeFromParent(true)
		self._nameBox = nil
	end

	if self._infoBox ~= nil then
		self._infoBox:removeFromParent(true)
		self._infoBox = nil
	end

	self:addTouchEventListener(hideInput)

	local write = self:getChildByName("write")
	local titleCon = write:getChildByName("titleInputB")
	local nameCon = write:getChildByName("nameInputB")
	local infoCon = self:getChildByName("infoB")

	local editBoxSize = titleCon:getContentSize()   
    self._titleBox =  dd.addEditBox(titleCon,cc.size(editBoxSize.width - 20,editBoxSize.height - 10),'images/editbox.png',110001,cc.p(0.5,0.5),cc.p(editBoxSize.width/2,editBoxSize.height/2+4),cc.c3b(255,255,255),24,6,4,5,60,true,true,true)
    local editBoxSize2 = nameCon:getContentSize()
    if mailtype  ~= 1 then
    	self._nameBox =   dd.addEditBox(nameCon,cc.size(editBoxSize2.width - 20,editBoxSize2.height - 10),'images/editbox.png',110002,cc.p(0.5,0.5),cc.p(editBoxSize2.width/2,editBoxSize2.height/2+4),cc.c3b(255,255,255),24,6,4,5,16,true,true,true)
    else
    	self._nameBox =   dd.addEditBox(nameCon,cc.size(editBoxSize2.width - 20,editBoxSize2.height - 10),'images/editbox.png',110002,cc.p(0.5,0.5),cc.p(editBoxSize2.width/2,editBoxSize2.height/2+4),cc.c3b(255,255,255),24,6,4,5,16,true,false,false)
    end
    local editBoxSize3 = infoCon:getChildByName("info"):getContentSize()

    self._infoBox =   dd.addEditBox(infoCon,cc.size(editBoxSize3.width - 2,editBoxSize3.height - 20),'images/editbox.png',110003,cc.p(0.5,0.5),cc.p(infoCon:getChildByName("info"):getPosition()),cc.c3b(255,255,255),20,0,4,1,500,true,true,true)
   	platform_setMultilinePro(7,5)
end 

function mailWriteLayer.onStart( sender )
    -- body
    ff.net:bindProperty(2311,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
end

function mailWriteLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("mailWrite")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end