noticeLayer = class("noticeLayer")
noticeLayer._name = "notice"
noticeLayer._init = false
noticeLayer._index = 0 
noticeLayer._indexMax = 0
noticeLayer._hqmail = {}
noticeLayer._animroll = {}
noticeLayer._animstar = {}
noticeLayer._Cfg_Activity = {}
    --self._infoEx = {}
--noticeLayer._Cfg_ActivityEx = {}


function noticeLayer.extend( target )
    -- body
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target,t)
    end
    setmetatable(t,noticeLayer)
    return target
end

function onShowNotice( widget,index,indexMax)
    -- body
    local layer = noticeLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:initDate()
    layer:onInit(index,indexMax)
    return layer
end

function noticeLayer.onReturn( sender,eventType )
    -- body
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("notice")
        if widget == nil then
            return
        end
        pop.onClosePopDialog("notice")
    end
end

function noticeLayer.deleteEvent( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then   
        local widget = pop.getDialog("notice")
        if widget == nil then
            return
        end
        local widget1 = pop.getDialog("mail")
        if widget1 == nil or widget1._NoticeData == nil then
            return
        end

        local message = ff.net:createMessage()
        message:addCmd(0x00000136)
        message:addLong(dd.uid)
        message:addLong(1)
        message:addLong(1)
            
        message:addLong(1)
        message:addSuperLong(widget1._NoticeData:getSuperLong(widget._index,"id"))
       
        ff.net:rpc(message,false)
        pop.onClosePopDialog("notice")
    end
end

function noticeLayer.nextMail( sender,eventType )
    if eventType == ccui.TouchEventType.ended then   
        local widget = pop.getDialog("mail")
        if widget == nil or widget._NoticeData == nil then
            return
        end
        local widget1 = pop.getDialog("notice")
        if widget1 == nil then
            return
        end

        if widget1._index >= widget._NoticeData:rowCount()  then 
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有邮件了"))
        else
            widget1:onInit(widget1._index+1,widget._NoticeData:rowCount())
        end
    end
    -- body
end

function noticeLayer.upMail( sender,eventType )
    if eventType == ccui.TouchEventType.ended then   
        local widget = pop.getDialog("mail")
        if widget == nil or widget._NoticeData == nil then
            return
        end
        local widget1 = pop.getDialog("notice")
        if widget1 == nil then
            return
        end
        
        if widget1._index <= 1  then 
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有邮件了"))
        else
            widget1:onInit(widget1._index-1,widget._NoticeData:rowCount())
        end
    end
    -- body
end

function noticeLayer.getAward( sender,eventType )
    if eventType == ccui.TouchEventType.ended then   
        local widget = pop.getDialog("mail")
        if widget == nil or widget._NoticeData == nil then
            return
        end
        local widget1 = pop.getDialog("notice")
        if widget1 == nil then
            return
        end
       -- widget1:updateReporBonus({0})

        if widget._NoticeData:getLong(widget1._index,"awardTime") ~= 0 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("不包含奖励，或者已被领取！"))
            return
        end
        
        local getAward = ff.net:createMessage()
        getAward:addCmd(0x00000161)
        getAward:addLong(dd.uid)
        getAward:addSuperLong(widget._NoticeData:getSuperLong(widget1._index,"id"))
       
        ff.net:rpc(getAward,false)

    end
    -- body
end

function noticeLayer.GoTo( sender,eventType )
    if eventType == ccui.TouchEventType.ended then   
        local widget = pop.getDialog("mail")
        if widget == nil or widget._NoticeData == nil then
            return
        end
        local widget1 = pop.getDialog("notice")
        if widget1 == nil then
            return
        end
       

        local table = Split(widget._NoticeData:getString(widget1._index,"content"),"%\\")
        if table[3] ~= nil and tonumber(table[3]) ~= 0 then
            if tonumber(table[3])  == 999 then
                platform_goMarket()
            elseif tonumber(table[3])  == 998 and table[4] ~= nil then
                platform_openUrl(table[4])
            end
        end
    end
end


function noticeLayer:AutoSize(  )
    -- body
    local hh = ff.height
    self:setContentSize(cc.size(720,hh ))
    self:setPositionY(0)
    self:getChildByName("back"):setContentSize(cc.size(720,hh))
    self:getChildByName("topArea"):setPositionY(hh - 105)
    --self:getChildByName("topArea"):getChildByName("chu_title"):setString(ff.langString("系统"))
    --self:getChildByName("topArea"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
    self:getChildByName("topArea"):getChildByName("return"):addTouchEventListener(self.onReturn)

    self:getChildByName("back"):setPositionY(0)
    self:getChildByName("oper"):setPositionY(0)
    self:getChildByName("oper"):getChildByName("delete"):addTouchEventListener(self.deleteEvent)
    self:getChildByName("info"):setPositionY(hh-105 - 190)
    self:getChildByName("info"):getChildByName("up"):addTouchEventListener(self.upMail)
    self:getChildByName("info"):getChildByName("down"):addTouchEventListener(self.nextMail)
    self:getChildByName("topArea"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    self:getChildByName("scrollview"):setContentSize(cc.size(720,hh-105 - 170-190))
    self:getChildByName("scrollview"):setPositionY(170)
    self:getChildByName("oper"):getChildByName("Button_81"):addTouchEventListener(self.getAward)
    self:getChildByName("mainArea"):getChildByName("Button_82"):addTouchEventListener(self.GoTo)

end

function noticeLayer:onInit( index,indexMax)
    -- body
    if self._init == false then
        self:AutoSize()
        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("images/effect/charge/goldroll.plist")
        cache:addSpriteFrames("images/effect/charge/goldstar.plist")
        for i = 1, 9 do                                           --少了个0
            self._animroll[i] = cache:getSpriteFrame("charge_jinbi_"..i..".png")  
        end
        for i = 1, 20 do                                          
            self._animstar[i] = cache:getSpriteFrame("xing_"..i..".png")  
        end
        local spr = dd.newSpriteFromUI("public/alpha.png")
        spr:setPosition(cc.p(37,37))
        spr:setVisible(false)
        self:getChildByName("topArea"):getChildByName("gold"):addChild(spr,0,101)
        self._init = true 
    end
    local propData1 = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_hqmail`  ORDER BY `lv` ASC")
    for i=1, propData1:rowCount() do
        local pId = tonumber(propData1:getString(i, "lv"))
        self._hqmail[pId] = {}
        if ff.lang == -1 then
            self._hqmail[pId]['tips1'] = propData1:getString(i, "l1_1")
            self._hqmail[pId]['tips2'] = propData1:getString(i, "l1_2")
            self._hqmail[pId]['tips3'] = propData1:getString(i, "l1_3")
            self._hqmail[pId]['tips4'] = propData1:getString(i, "l1_4")
            self._hqmail[pId]['tips5'] = propData1:getString(i, "l1_5")
        else
            self._hqmail[pId]['tips1'] = tonumber(propData1:getString(i, "l0_1"))
            self._hqmail[pId]['tips2'] = tonumber(propData1:getString(i, "l0_2"))
            self._hqmail[pId]['tips3'] = tonumber(propData1:getString(i, "l0_3"))
            self._hqmail[pId]['tips4'] = tonumber(propData1:getString(i, "l0_4"))
            self._hqmail[pId]['tips5'] = tonumber(propData1:getString(i, "l0_5"))
        end
    end
    propData1:clear()
    self._index = index
    self._indexMax = indexMax
    --self:getChildByName("topArea"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
    self:onShow()
    local widget = pop.getDialog("mail")
    if widget == nil or widget._NoticeData == nil then
        return
    else
        if widget._NoticeData:getLong(self._index,"state") == 0 then
            widget:setMailRead(self._index)
            local message = ff.net:createMessage()
            message:addCmd(0x00000136)
            message:addLong(dd.uid)
            
            message:addLong(2)
            message:addLong(1)
            message:addLong(1)
            message:addSuperLong(widget._NoticeData:getSuperLong(self._index,"id"))
 
            ff.net:rpc(message,false)  
        end
    end
    local item = self:getChildByName("scrollview"):getChildByTag(99)

    self:getChildByName("tips"):setVisible(false)

    if index == indexMax then
        local effect = ff.Effect:effectGrey()    
        self:getChildByName("info"):getChildByName("down"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        self:getChildByName("info"):getChildByName("down"):setTouchEnabled(false)
        
    else
        self:getChildByName("info"):getChildByName("down"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        self:getChildByName("info"):getChildByName("down"):setTouchEnabled(true)
    
    end
    if index == 1 then
        local effect = ff.Effect:effectGrey()    
        self:getChildByName("info"):getChildByName("up"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        self:getChildByName("info"):getChildByName("up"):setTouchEnabled(false)
        
    else
        self:getChildByName("info"):getChildByName("up"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        self:getChildByName("info"):getChildByName("up"):setTouchEnabled(true)
   
    end
    self.updateGold()
end

function noticeLayer.onEnd( sender )
    -- body
    sender:getChildByName("scrollview"):removeAllChildren(true)
    dd.delBackEvent()
    ff.net:unbindProperty("gold",2316)
    ff.net:removeEvent(1,dd.Tjf_Get_Report_Get_Bonus)
end

function noticeLayer:showTips( type, id, count, pos )
    -- body
    local ret  = dd.getGiftsTips(type, id, count)
    local name = ret[1]
    local str  = ret[2]
    local item = self:getChildByName("scrollview"):getChildByTag(99)
    if item == nil  then
        return
    end
    local tips = self:getChildByName("tips")
    local wid  = 360

    tips:setVisible(true)
    tips:getChildByName("tips"):removeAllChildren(true)

    local richText = ccui.RichText:create()
    richText:ignoreContentAdaptWithSize(false)
    richText:setContentSize(cc.size(wid-30,600))    
    richText:setAutoHeight()

    local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, str, "Helvetica", 20)
    richText:insertElement(chat,0)
    richText:formatText()

    local size = richText:getContentSize()
    richText:setPosition(cc.p(172,size.height/2 + 15))
    tips:setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):addChild(richText)

    tips:getChildByName("name"):setString(name) 
    tips:getChildByName("name"):setPositionY(size.height + 40)

    tips:setPositionX(pos.x)
    tips:setPositionY(pos.y)
    if pos.x < 250 then
        tips:setAnchorPoint(cc.p(0.2,0))
        tips:getChildByName("flag"):setPositionX(wid*0.2)
    elseif pos.x > 550 then
        tips:setAnchorPoint(cc.p(0.8,0))
        tips:getChildByName("flag"):setPositionX(wid*0.8)
    else
        tips:setAnchorPoint(cc.p(0.5,0))
        tips:getChildByName("flag"):setPositionX(wid*0.5)
    end  
end

function noticeLayer.onShowTips( sender,eventType  )
    -- body
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("notice")
        local widget1 = pop.getDialog("mail")
        if widget ~= nil then
           local tag = sender:getTag()
           cclog("============"..tag)
           local x,y = widget:getWorldPos(sender)--sender:getPosition()
            if widget1._NoticeData:getLong(widget._index,"type") == 111 then
                
                local num = 0 
                local content = '' 
                content,num = string.gsub(widget1._NoticeData:getString(widget._index,"content"),"/n","\n")  
                local table = Split(content,"%\\")

                local giftInfo = Split(table[5],'|')
                local count = 1
                for key, var in pairs(giftInfo) do
                    if tag == key then
                        local gift = Split(var,'%^')
                        --cclog("=="..tag.."=="..tonumber(gift[1]).."=="..tonumber(gift[2]).."=="..tonumber(gift[3]))
                        widget:showTips(tonumber(gift[1]),tonumber(gift[2]),tonumber(gift[3]),cc.p(x,y))  
                        break
                    end
                    count = count + 1
                end
            elseif  widget1._NoticeData:getLong(widget._index,"awardTime") ~= -1 then
                --widget:showTips(1,widget._cfglottery[tag]['propid'],1,cc.p(x,y))
                local giftInfo = Split(widget1._NoticeData:getString(widget._index,"awardStr"),'|')
                local count = 1
                for key, var in pairs(giftInfo) do
                    if tag == key then
                        local gift = Split(var,'%^')
                        --cclog("=="..tag.."=="..tonumber(gift[1]).."=="..tonumber(gift[2]).."=="..tonumber(gift[3]))
                        widget:showTips(tonumber(gift[1]),tonumber(gift[2]),tonumber(gift[3]),cc.p(x,y))  
                        break
                    end
                    count = count + 1
                end
            end
        end
    end
end

function noticeLayer.unShowTips( sender,eventType  )
    -- body
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("notice")
        if widget ~= nil then
           widget:getChildByName("tips"):setVisible(false)
        end
    end
end

function noticeLayer:onShow()
    -- body
    local item = self:getChildByName("scrollview"):getChildByTag(99)
    

    local widget = pop.getDialog("mail")
    if widget == nil or widget._NoticeData == nil then
        return
    end

    if item == nil then
        item = self:getChildByName("mainArea"):clone()
        item:setTag(99)
        
        self:getChildByName("scrollview"):pushBackCustomItem(item)
        item:getChildByName("back"):addTouchEventListener(self.unShowTips)
    else
        item:getChildByName("award"):removeAllChildren(true)
        item:getChildByName("text"):setString("")
    end
    item:setVisible(true)
    item:getChildByName("award"):setVisible(false)
    local num = 0 
    local content = '' 
    content,num = string.gsub(widget._NoticeData:getString(self._index,"content"),"/n","\n")  
    local table = Split(content,"%\\")
    --cclog(widget._NoticeData:getString(self._index,"content").."============="..widget._NoticeData:getLong(self._index,"type"))
    local len_one_line = 35
    if ff.lang == 0 then
        len_one_line = 60
    end
    local hh = math.ceil((string.len(widget._NoticeData:getString(self._index,"content")) - 1)/len_one_line) * 30
    hh = hh + num * 30 
    if hh > 150 then
        item:getChildByName("text"):setContentSize(cc.size(655,hh)) 
    else
        item:getChildByName("text"):setContentSize(cc.size(655,150))
    end
    item:requestDoLayout()
    local haveAward = false
    if widget._NoticeData:getLong(self._index,"awardTime") ~= -1 then
        haveAward = true
    end

    self:getChildByName("oper"):getChildByName("Button_81"):setVisible(false)
    self:getChildByName("oper"):getChildByName("Button_81"):setTouchEnabled(false)
    item:getChildByName("Button_82"):setVisible(false)
    item:getChildByName("Button_82"):setTouchEnabled(false)
    self:getChildByName("oper"):getChildByName("Image_93"):setVisible(true)

    if widget._NoticeData:getLong(self._index,"type") == 101 then
        self:getChildByName("info"):getChildByName("des"):setString(table[1].." ("..self._index.."/"..self._indexMax..")")
        item:getChildByName("text"):setString(table[2])
        if table[3] ~= nil and tonumber(table[3]) ~= 0 then
            item:getChildByName("Button_82"):setVisible(true)
            item:getChildByName("Button_82"):setTouchEnabled(true)
         
        end
    elseif widget._NoticeData:getLong(self._index,"type") == 102 then
        self:getChildByName("info"):getChildByName("des"):setString(table[1].." ("..self._index.."/"..self._indexMax..")")
        item:getChildByName("text"):setString(table[2])
        if table[3] ~= nil and tonumber(table[3]) ~= 0 then
            item:getChildByName("Button_82"):setVisible(true)
            item:getChildByName("Button_82"):setTouchEnabled(true)
   
        end
    elseif widget._NoticeData:getLong(self._index,"type") == 114 then
        
        local type = tonumber(table[1])

        if type ~= nil then 
            self:getChildByName("info"):getChildByName("des"):setString(ff.langString(notify[tonumber(table[1])]).." ("..self._index.."/"..self._indexMax..")")
            local str11 = Split(table[2],",")
            local tt = ""
            if tonumber(table[1]) == 67 or tonumber(table[1]) == 69 then
                tt = ff.langString(notify[tonumber(str11[1])],{str11[2],ff.langString(dd.official[tonumber(str11[3])])})
                item:getChildByName("text"):setString(tt)
            else
                tt = {
                [1] = ff.langString(notify[tonumber(str11[1])]),
                [2] = ff.langString(notify[tonumber(str11[1])],{str11[2]}),
                [3] = ff.langString(notify[tonumber(str11[1])],{str11[2],str11[3]}),
                [4] = ff.langString(notify[tonumber(str11[1])],{str11[2],str11[3],str11[4]}),
                [5] = ff.langString(notify[tonumber(str11[1])],{str11[2],str11[3],str11[4],str11[5]}),
                [6] = ff.langString(notify[tonumber(str11[1])],{str11[2],str11[3],str11[4],str11[5],str11[6]}),
            }
                if #(str11) < 7 then
                    item:getChildByName("text"):setString(tt[#(str11)])
                end
            end

            
            
            --item:getChildByName("text"):setString(tt)
        else
            local str11 = SplitEx(table[1],",",1)
            if str11[2] ~= nil then
                if tonumber(str11[1]) == 0 then
                    self:getChildByName("info"):getChildByName("des"):setString(str11[2])
                end
            else
                self:getChildByName("info"):getChildByName("des"):setString(table[1])
                item:getChildByName("text"):setString(table[2])
            end
            local str22 = SplitEx(table[2],",",1)
            if str22[2] ~= nil then
                if tonumber(str22[1]) == 0 then
                    item:getChildByName("text"):setString(str22[2])
                end
            else
                item:getChildByName("text"):setString(table[2])
            end
        end
        if table[3] ~= nil and tonumber(table[3]) ~= 0 then
            item:getChildByName("Button_82"):setVisible(true)
            item:getChildByName("Button_82"):setTouchEnabled(true)
           
        end
        
    elseif widget._NoticeData:getLong(self._index,"type") == 103 then
        self:getChildByName("info"):getChildByName("des"):setString(table[1].." ("..self._index.."/"..self._indexMax..")")
        item:getChildByName("text"):setString(table[2])
        if table[3] ~= nil and tonumber(table[3]) ~= 0 then
            item:getChildByName("Button_82"):setVisible(true)
            item:getChildByName("Button_82"):setTouchEnabled(true)
   
        end
    elseif widget._NoticeData:getLong(self._index,"type") == 111 then
        self:getChildByName("info"):getChildByName("des"):setString(ff.langString("充值成功").." ("..self._index.."/"..self._indexMax..")")
        local totle = tonumber(table[3])+tonumber(table[4])
        item:getChildByName("text"):setString(ff.langString("您购买的'{0}'充值已到账，你获得{1}金币和以下道具",{ff.langString(dd.cfgCharge[tonumber(table[2])]['name']),totle}))
        if table[5]  ~= nil then
            item:getChildByName("award"):setVisible(true)
            self:getChildByName("oper"):getChildByName("Button_81"):setVisible(false)
            self:getChildByName("oper"):getChildByName("Image_93"):setVisible(true)
            local giftInfo = Split(table[5],'|')
            local count = 1
            for key, var in pairs(giftInfo) do
                local gift = Split(var,'%^')
                local giftItem = item:getChildByName("item"):clone()
                if giftItem ~= nil then
                    giftItem:getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                    if tonumber(gift[1]) == 18 then
                        giftItem:getChildByName("count"):setString("1")
                    else
                        giftItem:getChildByName("count"):setString(gift[3])
                    end
                    
                    giftItem:addTouchEventListener(self.onShowTips)
                    giftItem:setTag(count)
                    giftItem:setVisible(true)
                    item:getChildByName("award"):addChild(giftItem)
                end
                count = count + 1
            end
        end
    elseif widget._NoticeData:getLong(self._index,"type") == 112 then
        self:getChildByName("info"):getChildByName("des"):setString(ff.langString("恭喜！你的司令部升级到LV{0}",{table[1]}).." ("..self._index.."/"..self._indexMax..")")
        local str = ""
        for i=1,5 do
            if string.len(self._hqmail[tonumber(table[1])]["tips"..tostring(i)]) >1  then
                --cclog(i.."=================="..self._hqmail[tonumber(table[1])]["tips"..tostring(i)])
                str = str..ff.langString(self._hqmail[tonumber(table[1])]["tips"..tostring(i)]).."\n".."\n"
            end
        end

        item:getChildByName("text"):setContentSize(cc.size(655,500)) 
        item:getChildByName("text"):setString(str)
    elseif widget._NoticeData:getLong(self._index,"type") == 117 then
        self:getChildByName("info"):getChildByName("des"):setString(ff.langString("登陆奖励").." ("..self._index.."/"..self._indexMax..")")
        local str = ""
        if tonumber(table[1]) == 2 then
            str = str..ff.langString("指挥官，欢迎回到Z War。这里是{0}金币，请继续发展。",{table[3]}).."\n"
            str = str..ff.langString("下一次登陆奖励将在第四天发放")
        elseif tonumber(table[1]) == 4 then
            str = str..ff.langString("指挥官，今天你来到Z War的第四天了，请收下你的奖励{0}金币。",{table[3]}).."\n"
            str = str..ff.langString("下一次登陆奖励将在第八天发放")
        elseif tonumber(table[1]) == 8 then
            str = str..ff.langString("指挥官，很高兴再次与你见面，由于你的努力，城市正蓬勃发展，为此奖励你{0}金币！",{table[3]}).."\n"
        end

        item:getChildByName("text"):setContentSize(cc.size(655,300)) 
        item:getChildByName("text"):setString(str)
    elseif widget._NoticeData:getLong(self._index,"type") == 115 then
        self:getChildByName("info"):getChildByName("des"):setString(ff.langString("运送通知").." ("..self._index.."/"..self._indexMax..")")
        item:getChildByName("text"):setString(ff.langString("你运送的资源已经到达！"))

        item:getChildByName("award"):setVisible(true)
        
        --self:getChildByName("oper"):getChildByName("Button_81"):setVisible(false)
        --self:getChildByName("oper"):getChildByName("Button_81"):setTouchEnabled(false)
        --self:getChildByName("oper"):getChildByName("Image_93"):setVisible(true)
        local level = dd.myinfo:getLong(1,"level")

        local index = 1
        local count = tonumber(table[3])
        if count > 0 then
            local giftItem = item:getChildByName("item"):clone()
            if giftItem ~= nil then
                giftItem:getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(3), 0)[1],dd.getGiftsIcon(tonumber(3), 0)[2])
                giftItem:getChildByName("count"):setString(count)
                giftItem:setVisible(true)
                giftItem:setTag(index)
                giftItem:addTouchEventListener(self.onShowTips)
                item:getChildByName("award"):addChild(giftItem)
            end
            index = index + 1
        end
        count = tonumber(table[5])
        if count > 0 then
            local giftItem = item:getChildByName("item"):clone()
            if giftItem ~= nil then
                giftItem:getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(5), 0)[1],dd.getGiftsIcon(tonumber(5), 0)[2])
                giftItem:getChildByName("count"):setString(count)
                giftItem:setVisible(true)
                giftItem:setTag(index)
                giftItem:addTouchEventListener(self.onShowTips)
                item:getChildByName("award"):addChild(giftItem)
            end
            index = index + 1
        end
        count = tonumber(table[2])
        if count > 0 and level > 10 then
            local giftItem = item:getChildByName("item"):clone()
            if giftItem ~= nil then
                giftItem:getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(2), 0)[1],dd.getGiftsIcon(tonumber(2), 0)[2])
                giftItem:getChildByName("count"):setString(count)
                giftItem:setVisible(true)
                giftItem:setTag(index)
                giftItem:addTouchEventListener(self.onShowTips)
                item:getChildByName("award"):addChild(giftItem)
            end
            index = index + 1
        end
        count = tonumber(table[4])
        if count > 0 and level > 14 then
            local giftItem = item:getChildByName("item"):clone()
            if giftItem ~= nil then
                giftItem:getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(4), 0)[1],dd.getGiftsIcon(tonumber(4), 0)[2])
                giftItem:getChildByName("count"):setString(count)
                giftItem:setVisible(true)
                giftItem:setTag(index)
                giftItem:addTouchEventListener(self.onShowTips)
                item:getChildByName("award"):addChild(giftItem)
            end
            index = index + 1
        end
        count = tonumber(table[6])
        if count > 0 then
            local giftItem = item:getChildByName("item"):clone()
            if giftItem ~= nil then
                giftItem:getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(6), 0)[1],dd.getGiftsIcon(tonumber(6), 0)[2])
                giftItem:getChildByName("count"):setString(count)
                giftItem:setVisible(true)
                giftItem:setTag(index)
                giftItem:addTouchEventListener(self.onShowTips)
                item:getChildByName("award"):addChild(giftItem)
            end
            index = index + 1
        end

    elseif widget._NoticeData:getLong(self._index,"type") == 116 then
        self:getChildByName("info"):getChildByName("des"):setString(ff.langString("运送通知").." ("..self._index.."/"..self._indexMax..")")
        item:getChildByName("text"):setString(ff.langString("来自好友{0}的资源已到达！",{table[1]}))

        item:getChildByName("award"):setVisible(true)
        
        --self:getChildByName("oper"):getChildByName("Button_81"):setVisible(false)
        --self:getChildByName("oper"):getChildByName("Button_81"):setTouchEnabled(false)
        --self:getChildByName("oper"):getChildByName("Image_93"):setVisible(true)
        local level = dd.myinfo:getLong(1,"level")

        local index = 1
        local count = tonumber(table[3])
        if count > 0 then
            local giftItem = item:getChildByName("item"):clone()
            if giftItem ~= nil then
                giftItem:getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(3), 0)[1],dd.getGiftsIcon(tonumber(3), 0)[2])
                giftItem:getChildByName("count"):setString(count)
                giftItem:setVisible(true)
                giftItem:setTag(index)
                giftItem:addTouchEventListener(self.onShowTips)
                item:getChildByName("award"):addChild(giftItem)
            end
            index = index + 1
        end
        count = tonumber(table[5])
        if count > 0 then
            local giftItem = item:getChildByName("item"):clone()
            if giftItem ~= nil then
                giftItem:getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(5), 0)[1],dd.getGiftsIcon(tonumber(5), 0)[2])
                giftItem:getChildByName("count"):setString(count)
                giftItem:setVisible(true)
                giftItem:setTag(index)
                giftItem:addTouchEventListener(self.onShowTips)
                item:getChildByName("award"):addChild(giftItem)
            end
            index = index + 1
        end
        count = tonumber(table[2])
        if count > 0 and level > 10 then
            local giftItem = item:getChildByName("item"):clone()
            if giftItem ~= nil then
                giftItem:getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(2), 0)[1],dd.getGiftsIcon(tonumber(2), 0)[2])
                giftItem:getChildByName("count"):setString(count)
                giftItem:setVisible(true)
                giftItem:setTag(index)
                giftItem:addTouchEventListener(self.onShowTips)
                item:getChildByName("award"):addChild(giftItem)
            end
            index = index + 1
        end
        count = tonumber(table[4])
        if count > 0 and level > 14 then
            local giftItem = item:getChildByName("item"):clone()
            if giftItem ~= nil then
                giftItem:getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(4), 0)[1],dd.getGiftsIcon(tonumber(4), 0)[2])
                giftItem:getChildByName("count"):setString(count)
                giftItem:setVisible(true)
                giftItem:setTag(index)
                giftItem:addTouchEventListener(self.onShowTips)
                item:getChildByName("award"):addChild(giftItem)
            end
            index = index + 1
        end
        count = tonumber(table[6])
        if count > 0 then
            local giftItem = item:getChildByName("item"):clone()
            if giftItem ~= nil then
                giftItem:getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(6), 0)[1],dd.getGiftsIcon(tonumber(6), 0)[2])
                giftItem:getChildByName("count"):setString(count)
                giftItem:setVisible(true)
                giftItem:setTag(index)
                giftItem:addTouchEventListener(self.onShowTips)
                item:getChildByName("award"):addChild(giftItem)
            end
            index = index + 1
        end
        

    elseif widget._NoticeData:getLong(self._index,"type") == 113 then
        if tonumber(table[1]) == 1 then
            self:getChildByName("info"):getChildByName("des"):setString(ff.langString("{0}奖励发放",{ff.langString(self._Cfg_Activity[tonumber(table[2])]["name"])}).." ("..self._index.."/"..self._indexMax..")")
            
            item:getChildByName("text"):setString(ff.langString("你在{0}中表现出色，获得以下奖励，请再接再厉",{ff.langString(self._Cfg_Activity[tonumber(table[2])]["name"])}))
          
        elseif tonumber(table[1]) == 21 then
            self:getChildByName("info"):getChildByName("des"):setString(ff.langString("{0}奖励发放",{ff.langString(dd.Cfg_Activity_type[tonumber(table[2])]["name"])}).." ("..self._index.."/"..self._indexMax..")")
            
            item:getChildByName("text"):setString(ff.langString("你在{0}中表现出色，获得以下奖励，请再接再厉",{ff.langString(dd.Cfg_Activity_type[tonumber(table[2])]["name"])}))
          
        elseif tonumber(table[1]) == 22 then

            self:getChildByName("info"):getChildByName("des"):setString(ff.langString("{0}奖励发放",{ff.langString(dd.Cfg_Activity_type[tonumber(table[2])]["name"])}).." ("..self._index.."/"..self._indexMax..")")
            
            item:getChildByName("text"):setString(ff.langString("恭喜你在活动[{0}]取得了第{1}名的名次",{ff.langString(dd.Cfg_Activity_type[tonumber(table[2])]["name"]),table[4]}))
        elseif tonumber(table[1]) == 23 then

            self:getChildByName("info"):getChildByName("des"):setString(ff.langString("{0}(跨服)奖励发放",{ff.langString(dd.Cfg_Activity_type[tonumber(table[2])]["name"])}).." ("..self._index.."/"..self._indexMax..")")
            
            item:getChildByName("text"):setString(ff.langString("恭喜你在活动[{0}]取得了第{1}名的名次",{ff.langString(dd.Cfg_Activity_type[tonumber(table[2])]["name"]),table[4]}))
        
        end
        
        
    end
    if haveAward == true then
        item:getChildByName("award"):setVisible(true)
        if widget._NoticeData:getLong(self._index,"awardTime") == 0 then
            self:getChildByName("oper"):getChildByName("Button_81"):setVisible(true)
            self:getChildByName("oper"):getChildByName("Button_81"):setTouchEnabled(true)
            self:getChildByName("oper"):getChildByName("Image_93"):setVisible(false)
        else
            self:getChildByName("oper"):getChildByName("Button_81"):setVisible(false)
            self:getChildByName("oper"):getChildByName("Button_81"):setTouchEnabled(false)
            self:getChildByName("oper"):getChildByName("Image_93"):setVisible(true)
        end
        local giftInfo = Split(widget._NoticeData:getString(self._index,"awardStr"),'|')
        local count = 1
        for key, var in pairs(giftInfo) do
            local gift = Split(var,'%^')
            local giftItem = item:getChildByName("item"):clone()
            if giftItem ~= nil then
                giftItem:getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                giftItem:getChildByName("count"):setString(gift[3])
                giftItem:setVisible(true)
                giftItem:addTouchEventListener(self.onShowTips)
                giftItem:setTag(count)
                item:getChildByName("award"):addChild(giftItem)
            end
            count = count + 1
        end
    end
    local dateStr = ff.showData(tonumber(widget._NoticeData:getLong(self._index,"time")))
    self:getChildByName("info"):getChildByName('time'):setString(dateStr)
    item:getChildByName("info"):getChildByName("name"):setString(dd.myinfo:getString(1,"name"))
    self:getChildByName("info"):getChildByName("info"):getChildByName("info"):getChildByName("from"):setString("TO: ")
    self:getChildByName("info"):getChildByName("info"):getChildByName("info"):getChildByName("name"):setString(dd.myinfo:getString(1,"name"))
    if dd.myUnion ~= nil and string.len(dd.myUnion:getString(1,"unionflag"))>0 then
        item:getChildByName("info"):getChildByName("union"):setString("["..dd.myUnion:getString(1,"unionflag").."]")
        self:getChildByName("info"):getChildByName("info"):getChildByName("info"):getChildByName("union"):setString("["..dd.myUnion:getString(1,"unionflag").."]")
    else
        item:getChildByName("info"):getChildByName("union"):setString("")
    end
    
    self:getChildByName("scrollview"):refreshView()
    self:getChildByName("scrollview"):jumpToTop()
    --self:getChildByName("oper"):getChildByName("Button_81"):setVisible(true)
    --self:getChildByName("oper"):getChildByName("Button_81"):setTouchEnabled(true)
    --self:getChildByName("oper"):getChildByName("delete"):setTouchEnabled(false)
end

function noticeLayer:initDate(  )
    self._Cfg_Activity = {}
    --self._infoEx = {}
    --self._Cfg_ActivityEx = {}
    local propData1 = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_level_activity`")
    for i=1, propData1:rowCount() do
       local id = tonumber(propData1:getString(i, "id"))
       self._Cfg_Activity[id]={}
       self._Cfg_Activity[id]['target1'] = tonumber(propData1:getString(i, "target1"))
       self._Cfg_Activity[id]['num1'] = tonumber(propData1:getString(i, "number1"))
       self._Cfg_Activity[id]['reward1'] = tonumber(propData1:getString(i, "reward1"))
       self._Cfg_Activity[id]['target2'] = tonumber(propData1:getString(i, "target2"))
       self._Cfg_Activity[id]['num2'] = tonumber(propData1:getString(i, "number2"))
       self._Cfg_Activity[id]['reward2'] = tonumber(propData1:getString(i, "reward2"))
       self._Cfg_Activity[id]['target3'] = tonumber(propData1:getString(i, "target3"))
       self._Cfg_Activity[id]['num3'] = tonumber(propData1:getString(i, "number3"))
       self._Cfg_Activity[id]['reward3'] = tonumber(propData1:getString(i, "reward3"))
       self._Cfg_Activity[id]['target4'] = tonumber(propData1:getString(i, "target4"))
       self._Cfg_Activity[id]['num4'] = tonumber(propData1:getString(i, "number4"))
       self._Cfg_Activity[id]['reward4'] = tonumber(propData1:getString(i, "reward4"))
       self._Cfg_Activity[id]['target5'] = tonumber(propData1:getString(i, "target5"))
       self._Cfg_Activity[id]['num5'] = tonumber(propData1:getString(i, "number5"))
       self._Cfg_Activity[id]['reward5'] = tonumber(propData1:getString(i, "reward5"))
       self._Cfg_Activity[id]['target6'] = tonumber(propData1:getString(i, "target6"))
       self._Cfg_Activity[id]['num6'] = tonumber(propData1:getString(i, "number6"))
       self._Cfg_Activity[id]['reward6'] = tonumber(propData1:getString(i, "reward6"))
       self._Cfg_Activity[id]['target7'] = tonumber(propData1:getString(i, "target7"))
       self._Cfg_Activity[id]['num7'] = tonumber(propData1:getString(i, "number7"))
       self._Cfg_Activity[id]['reward7'] = tonumber(propData1:getString(i, "reward7"))
       self._Cfg_Activity[id]['target8'] = tonumber(propData1:getString(i, "target8"))
       self._Cfg_Activity[id]['num8'] = tonumber(propData1:getString(i, "number8"))
       self._Cfg_Activity[id]['reward8'] = tonumber(propData1:getString(i, "reward8"))

       if ff.lang == -1 then
            self._Cfg_Activity[id]['name']   = propData1:getString(i, "name")
            self._Cfg_Activity[id]['disc1']   = propData1:getString(i, "description1")
            self._Cfg_Activity[id]['disc2']   = propData1:getString(i, "description2")
            self._Cfg_Activity[id]['info']   = propData1:getString(i, "help4")
        else    
            self._Cfg_Activity[id]['name']   = tonumber(propData1:getString(i, "name_lan"))
            self._Cfg_Activity[id]['disc1']   = tonumber(propData1:getString(i, "description_lan1"))
            self._Cfg_Activity[id]['disc2']   = tonumber(propData1:getString(i, "description_lan2"))
            self._Cfg_Activity[id]['info']   = tonumber(propData1:getString(i, "help4_lan"))
         
        end
    end
    propData1:clear()

end

function noticeLayer.onStart( sender )
    -- body
    ff.net:bindProperty(2316,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addgold"))
end

function noticeLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("notice")
    if widget ~= nil then
        widget:getChildByName("topArea"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("topArea"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("topArea"):requestDoLayout()
    end
end

function noticeLayer:updateReporBonus( parma )
    -- body
    if parma[1] == 0 then
        local widget = pop.getDialog("mail")
        if widget == nil or widget._NoticeData == nil then
            return
        end
        widget:updateReporBonus(parma)
        local dropInfos = {}
        local giftInfo = Split(widget._NoticeData:getString(self._index,"awardStr"),'|')
        if giftInfo ~= nil then
            local endPos = cc.p(200,100)
            local count = table.getn(giftInfo)
            local num   = count
            if count > 9 then
                num = 9
                count = 9
            end
            for i=1,num do
                local gift = Split(giftInfo[i],'%^')
                local item = self:getChildByName("scrollview"):getChildByTag(99):getChildByName("award")
                if item ~= nil then
                    if tonumber(gift[1]) ==  7 then
                        local node = item:getChildByTag(i)--:getChildByName("ico")
                        local endnode =  self:getChildByName("topArea"):getChildByName("gold")
                        --cclog("------------------------")
                        if node ~= nil then 
                            --cclog("=============sdf==================================")
                            node:runAction(cc.Sequence:create(
                                cc.CallFunc:create(function() self:addAnimation(i,endnode,50,0) end)
                                ,cc.DelayTime:create(0.1)
                                ,cc.CallFunc:create(function() self:addAnimation(i,endnode,10,30) end)
                                ,cc.DelayTime:create(0.1)
                                ,cc.CallFunc:create(function() self:addAnimation(i,endnode,100,50) end)
                                ,cc.DelayTime:create(0.1)
                                ,cc.CallFunc:create(function() self:addAnimation(i,endnode,30,100) end)
                                ,cc.DelayTime:create(0.1)
                                ,cc.CallFunc:create(function() self:addAnimation(i,endnode,50,0) end)
                                ,cc.DelayTime:create(0.1)
                                ,cc.CallFunc:create(function() self:addAnimation(i,endnode,10,30) end)
                            ))    
                        end
                    else
                        if item:getChildByTag(i) ~= nil then
                            local icon = item:getChildByTag(i):getChildByName("ico"):clone()
                            local pos  = item:convertToWorldSpace(cc.p(0.5 * 101,0.5 * 82))
                            dd.mainUI:getChildByName("effect"):addChild(icon)
                            if i <= 5 then
                                pos.x =pos.x  +((i - 1)  * 140) + 70
                            else
                                pos.x =pos.x+((i - 6)  * 140) + 70
                                pos.y = pos.y-100
                            end
                            --cclog(i.."==============="..pos.x.."==============="..pos.y)
                            icon:setPosition(cc.p(pos.x,pos.y))
                            local moveup  = cc.EaseExponentialOut:create( cc.MoveTo:create(0.1, cc.p(pos.x,pos.y + 30)) )
                            local movedown = cc.EaseExponentialIn:create(cc.MoveTo:create(0.8,endPos))
                            local seq  = cc.Sequence:create(cc.DelayTime:create(0.5),cc.FadeOut:create(0.3))
                            local spaw = cc.Spawn:create(movedown,seq)
                            local sequence = cc.Sequence:create(moveup,spaw,cc.RemoveSelf:create())
                            icon:runAction(sequence)
                        end
                    end
                end 
                count = count - 1
            end
            --pop.onShowPopDialog("reward",dropInfos)
        end
        self:getChildByName("oper"):getChildByName("Button_81"):setVisible(false)
        self:getChildByName("oper"):getChildByName("Button_81"):setTouchEnabled(false)
        self:getChildByName("oper"):getChildByName("Image_93"):setVisible(true)
    end            
end

function noticeLayer.onBefore( sender )
    -- body
    ff.net:registerEvent(1,dd.Tjf_Get_Report_Get_Bonus,function (message)sender:updateReporBonus(message)end)
end

function noticeLayer:addAnimation(nodestart, nodeend, dx, dy)
    if self:getChildByName("scrollview"):getChildByTag(99) == nil then
        return
    end
    local startp = self:getChildByName("scrollview"):getChildByTag(99):getChildByName("award"):convertToWorldSpace(cc.p(0.5 * 101,0.5 * 82))
    if nodestart <= 5 then
        startp.x =startp.x  +((nodestart - 1)  * 140) + 70
    else
        startp.x =startp.x+((nodestart - 6)  * 140) + 70
        startp.y = startp.y-100
    end
    --local startp = self:convertToNodeSpace(self:getWorldPos(nodestart))
    startp = cc.p(startp.x + dx, startp.y + dy)
    local endp   = self:convertToNodeSpace(self:getWorldPos(nodeend))
    local dis = cc.pGetDistance(endp,startp) 
    local time = dis/1000
    --翻转
    local spr = cc.Sprite:createWithSpriteFrameName("charge_jinbi_0.png")
    self:addChild(spr,10,123)
    spr:setPosition(startp)
    spr:setRotation(-60)
    if startp.y +30> ff.height - 105 then
        spr:setVisible(false)
    end
    local animation = cc.Animation:createWithSpriteFrames(self._animroll, 0.05)
    spr:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
    --fun
    local function endFun()
        spr:removeFromParent(true)
    end
    --move
    spr:runAction(cc.Sequence:create(
                     cc.MoveTo:create(time, cc.p(endp.x -70, endp.y - 70))
                    ,cc.CallFunc:create(function() 
                            spr:setVisible(false)
                            self:playToScal()
                            performWithDelay(self,endFun, 0.1)
                            end)
                     ))
                     
end

function noticeLayer:getWorldPos(node)
    local anr   = node:getAnchorPoint()
    local size  = node:getContentSize()
    local p = node:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
    return p
end

function noticeLayer:playToScal()
    local node = self:getChildByName("topArea"):getChildByName("gold")
    local spr = self:getChildByName("topArea"):getChildByName("gold"):getChildByTag(101)
    local animation = cc.Animation:createWithSpriteFrames(self._animstar, 0.1)
    if spr ~= nil and spr:isVisible() == false then
        spr:setVisible(true)
        spr:runAction(cc.Sequence:create(cc.Animate:create(animation),cc.CallFunc:create(function() spr:setVisible(false) end)))
    end
    node:runAction( cc.Sequence:create(
        cc.ScaleTo:create(0.02,1.1)
        ,cc.CallFunc:create(function() self:playLight(node, true) end)
        ,cc.ScaleTo:create(0.02,1)
        ,cc.CallFunc:create(function() self:playLight(node, false) end)
    ))
    AudioEngine.playEffect(ff.sounds[213])
end
function noticeLayer:playLight(node, type)
    if type == true then
        node:getVirtualRenderer():setGLProgramState(ff.Effect:effectHighLight():getGLProgramState())
    else
        node:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
    end
end