--onlineReward
local onlineRewardLayer = class("onlineReward")
onlineRewardLayer._name = "onlineReward"
onlineRewardLayer._init = false
onlineRewardLayer._tap  = 1                         --1:每日目标  2:在线奖励

onlineRewardLayer._onitems = {}
onlineRewardLayer._taskitems = {}
onlineRewardLayer._giftitems = {}

onlineRewardLayer._cfgOnline = {}
onlineRewardLayer._onlineId = 0

onlineRewardLayer._daytasks = {}                    --存储服务端传来的列表
onlineRewardLayer._dayboxs  = {}                     --存储服务端传来的宝箱内容
onlineRewardLayer._haveCount = 0                    --已领取宝箱数量 
onlineRewardLayer._endTime = 0
onlineRewardLayer._canGetBox = 0

onlineRewardLayer._namearr = {"采集任务", "军事任务", "发展任务", "联盟任务", "英雄任务"}
onlineRewardLayer._tiparr = {"采集资源{0}", "训练获得战力{0}", "提升建筑&科技获得战力{0}", "捐献获得联盟贡献{0}", "清扫僵尸获得经验{0}"}
onlineRewardLayer._justopen = false
--在线箱子图标 写死的item:getChildByName("icon"):loadTexture("images/icon/tools/130522"..i..".png",0)
function onlineRewardLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, onlineRewardLayer)
    return target
end

function onlineRewardLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("masking"):setContentSize(cc.size(720,hh))
        self:getChildByName("masking"):setPositionY(0)
        self:getChildByName("bg"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("bg"):setPositionY(0)
        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("topNavi"):setPositionY(hh - 105 - 85 -1)
        self:getChildByName("top"):setPositionY(hh - 105 - 85 -1 - 49)
        --1
        self:getChildByName("online"):setContentSize(cc.size(720, hh - 240))
        self:getChildByName("online"):getChildByName("list1"):setContentSize(cc.size(720, hh - 240 - 5))
        --2
        self:getChildByName("daytask"):setContentSize(cc.size(720, hh - 240))
        self:getChildByName("daytask"):getChildByName("top2"):setPositionY(hh - 240 - 205)
        self:getChildByName("daytask"):getChildByName("list2"):setContentSize(cc.size(720, hh - 445 - 5))
    end
end

function onlineRewardLayer:onInit()
    if self._init == false then   
        --tab button   
        local function onSelect(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if sender:getSelectedState() == true then
                    self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)
                    self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)     
                    return
                end    
                self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)
                self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)     
                if sender:getName() == "navi1" then
                    self:showByType(1)
                    self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
                    self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                else
                    self:showByType(2)
                    self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
                    self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
                end
            end
        end    
        local function onget(sender,eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then    
                doaction = true
            end
            if doaction == true then
                local message = ff.net:createMessage()
                message:addCmd(0x00000132)
                message:addLong(dd.uid)
                ff.net:rpc(message,false)                
            end
        end
        --点击箱子
        local function onBox(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local index = sender:getTag()
                if index == 4 then
                    self:updatePop3()
                    self.openPop3(sender,eventType)
                else
                    self:updatePop2(index)
                    self.openPop2(sender,eventType)
                end
            end
        end
        --领取箱子
        local function getBox(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if sender:getTag() == 4 then
                    local message = ff.net:createMessage()
                    message:addCmd(0x0000016d)
                    message:addLong(dd.uid)
                    ff.net:rpc(message, false)
                else
                    self:getDaytaskReward(0)
                end
            end
        end
        --每日目标奖励领取
        local function onTaskGet(sender,eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then    
                doaction = true
            end
            if doaction == true then
                self:getDaytaskReward(sender:getTag())
            end
        end
        --tips
        local function clickItem(sender, eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then    
                doaction = true
            end
            if doaction == true then
                local index = sender:getTag()
                local pos   = self:getWorldPos(sender)
                pos = self:convertToNodeSpace(pos)
                if self._tap == 1 then
                    pos = cc.p(pos.x,pos.y + 40)
                else
                    pos = cc.p(pos.x + 70,pos.y + 150)
                end
                self:showTips(sender.type, sender.id, sender.count, pos)
            end
        end

        self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(true)
        self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3)
        
        self:getChildByName("topNavi"):getChildByName("navi1"):addTouchEventListener(onSelect)
        self:getChildByName("topNavi"):getChildByName("navi2"):addTouchEventListener(onSelect)
        --topArea
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
             
        --online
        self:getChildByName("top"):getChildByName("help"):addTouchEventListener(self.openPop)
        self:getChildByName("pop"):getChildByName("close"):addTouchEventListener(self.closePop)
        self:getChildByName("item2"):getChildByName("getbtn"):addTouchEventListener(onget)
        self:getChildByName("pop3"):getChildByName("left"):addTouchEventListener(self.showPrePage)
        self:getChildByName("pop3"):getChildByName("right"):addTouchEventListener(self.showNextPage)
        self:getChildByName("pop3"):getChildByName("sure"):addTouchEventListener(self.goldSure)
        --daytask
        for i=1,4 do
            self:getChildByName("daytask"):getChildByName("top2"):getChildByName("box"..i):getChildByName("icon"):addTouchEventListener(onBox)
            self:getChildByName("daytask"):getChildByName("top2"):getChildByName("box"..i):getChildByName("icon"):setTag(i)
            self:getChildByName("daytask"):getChildByName("top2"):getChildByName("box"..i):getChildByName("getbtn"):addTouchEventListener(getBox)
            self:getChildByName("daytask"):getChildByName("top2"):getChildByName("box"..i):getChildByName("getbtn"):setTag(i)
            self:getChildByName("daytask"):getChildByName("top2"):getChildByName("box"..i):getChildByName("getbtn"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
            self:getChildByName("daytask"):getChildByName("top2"):getChildByName("box"..i):getChildByName("getbtn"):getChildByName("chu_label"):setString(ff.langString("领取"))
        end
        self:getChildByName("item1"):getChildByName("getbtn"):addTouchEventListener(onTaskGet)
        self:getChildByName("pop2"):getChildByName("close"):addTouchEventListener(self.closePop2)
        self:getChildByName("pop3"):getChildByName("close"):addTouchEventListener(self.closePop3)
        self:getChildByName("pop2"):getChildByName("getbtn"):addTouchEventListener(getBox)
        self:getChildByName("pop2"):getChildByName("item"):setVisible(false)

        --加粗
        self:getChildByName("top"):getChildByName("chu_tips"):getVirtualRenderer():enableBold(true)
        self:getChildByName("item2"):getChildByName("chu_time"):getVirtualRenderer():enableBold(true)
        self:getChildByName("item1"):getChildByName("chu_name"):getVirtualRenderer():enableBold(true)
        self:getChildByName("pop"):getChildByName("block1"):getChildByName("chu_tips"):getVirtualRenderer():enableBold(true)
        
        local function onTouchBegan(touch, event)
            self:unshowTips()
            return false
        end
        local listener = cc.EventListenerTouchOneByOne:create()
        listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
        self:getChildByName("touch"):getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self:getChildByName("touch"))
        
        self:getChildByName("item2"):getChildByName("gift1"):addTouchEventListener(clickItem)
        self:getChildByName("item2"):getChildByName("gift2"):addTouchEventListener(clickItem)
        self:getChildByName("item2"):getChildByName("gift3"):addTouchEventListener(clickItem)
        self:getChildByName("item1"):getChildByName("icon"):addTouchEventListener(clickItem)
        self:getChildByName("pop3"):getChildByName("PageView"):addEventListener(self.exchangePage)
        self:getChildByName("pop2"):getChildByName("item"):getChildByName("back"):getChildByName("icon"):addTouchEventListener(clickItem)
        --self:getChildByName("pop3"):getChildByName("item"):addTouchEventListener(self.clickTask)

        self:initCfg()
        self._init = true
    end
    self:initPageView()
    self.updateGold()
end

function onlineRewardLayer.exchangePage(sender, eventType)
    if eventType == ccui.PageViewEventType.turning then
        local pageView = sender
        local widget = pop.getDialog("onlineReward")
        local index = 0
        if widget ~= nil then
            index = tonumber(pageView:getCurPageIndex())
            widget:showItemByIndex(index)
        end

    end
end

function onlineRewardLayer:initPageView()
    -- body
    local page = self:getChildByName("pop3"):getChildByName("PageView")
    local index = 0
    --self:getChildByName("topView"):getChildByName("icon"):loadTexture(self:getGoldtaskIcon(id),0)
    local fresh = false
    for i=1,3 do
        if 1 == i then

            local item = page:getPage(0)
            if item == nil then
                item = self:getChildByName("pop3"):getChildByName("item"):clone()
                item:setVisible(true)
                item:setTag(i)

                item:setPosition(cc.p(0,0))
                page:insertPage(item,0)
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("online_gold3.png",1))
                item:getChildByName("start"):setString("5")
            end
        end
        if 2 == i then
            local item = page:getPage(1)
            if item == nil then
                item = self:getChildByName("pop3"):getChildByName("item"):clone()
                item:setVisible(true)
                item:setTag(i)

                item:setPosition(cc.p(0,0))
                page:insertPage(item,1)
                item:getChildByName("start"):setString("10")
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("online_gold2.png",1))
                
            end
        end
        if 3 == i then
            local item = page:getPage(2)
            if item == nil then
                item = self:getChildByName("pop3"):getChildByName("item"):clone()
                item:setVisible(true)
                item:setTag(i)

                item:setPosition(cc.p(0,0))
                page:insertPage(item,2)
                item:getChildByName("start"):setString("15")
                item:getChildByName("ico"):loadTexture(dd.getPathFromUI("online_gold1.png",1))
                
            end
        end

    end
    --page:scrollToPage(0,false)
    self:AutoGetPage()
    self:showItemByIndex(page:getCurPageIndex())
end

function onlineRewardLayer:showItemByIndex(index)
    self:getChildByName("pop3"):getChildByName("sure"):getChildByName("chu_Label"):setString(ff.langString("确定"))
    self:setBtnLight(self:getChildByName("pop3"):getChildByName("sure"),false)
    local item = self:getChildByName("pop3"):getChildByName("PageView"):getPage(index)
    local time = dd.myDayTask:getLong(1,"time")-dd.getServerTime() - 86400
    if item ~= nil then
        self:getChildByName("pop3"):getChildByName("left"):setVisible(index>0)
        self:getChildByName("pop3"):getChildByName("right"):setVisible(index<2)
        if dd.myDayTask:getLong(1,"time") ~= 0 and dd.myDayTask:getLong(1,"time") ~= 1 then
            if index == 0 then
                if dd.myDayTask:getLong(1,"getStep") == 5 and time < 0 then
                    self:getChildByName("pop3"):getChildByName("sure"):getChildByName("chu_Label"):setString(ff.langString("领奖"))
                    self:setBtnLight(self:getChildByName("pop3"):getChildByName("sure"),true)
                end
            elseif index == 1 then
                if dd.myDayTask:getLong(1,"getStep") == 10 and time < 0 then
                    self:getChildByName("pop3"):getChildByName("sure"):getChildByName("chu_Label"):setString(ff.langString("领奖"))
                    self:setBtnLight(self:getChildByName("pop3"):getChildByName("sure"),true)
                end
            else
                if dd.myDayTask:getLong(1,"getStep") == 15 and time < 0 then
                    self:getChildByName("pop3"):getChildByName("sure"):getChildByName("chu_Label"):setString(ff.langString("领奖"))
                    self:setBtnLight(self:getChildByName("pop3"):getChildByName("sure"),true)
                end
            end
        end
        index = index + 1 
        for i=1,3 do
            self:getChildByName("pop3"):getChildByName("cb"..tostring(i)):setSelectedState(index == i)
        end

    end
    
end

function onlineRewardLayer:initCfg()
    local online = ff.dbmanager:sql_fetch_rows("select * from cfg_zaixian")
    for i=1, online:rowCount() do
        local id = tonumber(online:getString(i, "id"))
        self._cfgOnline[id] = {}
        self._cfgOnline[id]['time'] = tonumber(online:getString(i, "time"))
        self._cfgOnline[id]['next'] = tonumber(online:getString(i, "next"))
        self._cfgOnline[id]['jiangli'] = online:getString(i, "jiangli")
    end
    online:clear()   
    self._taskitems = {}
    self._giftitems = {} 
end

function onlineRewardLayer:initByType(type)
    cclog("========="..type)
    self:getChildByName("bg"):setVisible(true)
    self:getChildByName("topArea"):setVisible(true)
    self:getChildByName("masking"):setVisible(false)
    self:getChildByName("pop3"):setVisible(false)
    self:getChildByName("topNavi"):setVisible(true)
    if type == nil then
        self:getChildByName("daytask"):setVisible(true)
        self:getChildByName("online"):setVisible(false)
        self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(true)
        self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
        self:getChildByName("top"):getChildByName("chu_tips"):setString(ff.langString("完成所有任务明日可开启黄金宝箱"))
        self._tap = 1
    elseif type == 1 then
        self:getChildByName("daytask"):setVisible(true)
        self:getChildByName("online"):setVisible(false)
        self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(true)
        self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
        self:getChildByName("top"):getChildByName("chu_tips"):setString(ff.langString("完成所有任务明日可开启黄金宝箱"))
        self._tap = 1
    elseif type == 2 then
        self:getChildByName("daytask"):setVisible(false)
        self:getChildByName("online"):setVisible(true)
        self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)
        self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(true)
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("top"):getChildByName("chu_tips"):setString(ff.langString("累计在线时间获取奖励"))
        self._tap = 2
    elseif type == 3 then
        self:getChildByName("daytask"):setVisible(false)
        self:getChildByName("online"):setVisible(false)
        self:getChildByName("topNavi"):setVisible(false)
        self:getChildByName("top"):setVisible(false)
        self:getChildByName("bg"):setVisible(false)
        self:getChildByName("topArea"):setVisible(false)
        self:getChildByName("pop3"):setVisible(true)
        self:getChildByName("masking"):setVisible(true)
        self._tap = 3
    end
end

function onlineRewardLayer:showByType(type)
    cclog("=====3===="..type)
    if type == nil then
        self:getChildByName("daytask"):setVisible(true)
        self:getChildByName("online"):setVisible(false)
        self:getChildByName("top"):getChildByName("chu_tips"):setString(ff.langString("完成所有任务明日可开启黄金宝箱"))
        self._tap = 1
        self:updateDaytask()
    elseif type == 1 then
        self:getChildByName("daytask"):setVisible(true)
        self:getChildByName("online"):setVisible(false)
        self:getChildByName("top"):getChildByName("chu_tips"):setString(ff.langString("完成所有任务明日可开启黄金宝箱"))
        self._tap = 1
        --self:updateDaytask()
    elseif type == 2 then
        self:getChildByName("daytask"):setVisible(false)
        self:getChildByName("online"):setVisible(true)
        self:getChildByName("top"):getChildByName("chu_tips"):setString(ff.langString("累计在线时间获取奖励"))
        self._tap = 2
        self:updateList2()
    elseif type == 3 then
        self:getChildByName("daytask"):setVisible(false)
        self:getChildByName("online"):setVisible(false)
        self:getChildByName("topNavi"):setVisible(false)
        self:getChildByName("top"):setVisible(false)
        self._tap = 3
    end
end

function onlineRewardLayer.updateGold()
    local widget = pop.getDialog("onlineReward")
    widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
    widget:getChildByName("topArea"):requestDoLayout()

    local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
    w = 720 - (w + 94 + 75 + 104)
    widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
    widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
end

function onlineRewardLayer:updateList2()
    if self._tap == 2 then
        self:stopAllActions()
    end
    local hh = self:getChildByName("online"):getChildByName("list1"):getContentSize().height
    local num = 0
    local ihh = 0
    
    for id,v in pairs(self._cfgOnline) do
        num = num + 1
    end    
    ihh = num * 210
    
    for i,v in ipairs(self._onitems) do
        if tolua.isnull(v) then
            self._onitems[i] = nil
        else
            v:setVisible(false)
            v:setTag(0)
        end
    end
    
    if ihh < hh then
        ihh = hh
    end    
    self:getChildByName("online"):getChildByName("list1"):setInnerContainerSize(cc.size(720,ihh))
    
    for id,v in pairs(self._cfgOnline) do
        self:addOnItem(ihh,id)
    end
    self._justopen = false
end

function onlineRewardLayer:addOnItem(ihh,i)

    local item = self._onitems[i]
    if item == nil then
        item = self:getChildByName("item2"):clone()
        self._onitems[i] = item
        self:getChildByName("online"):getChildByName("list1"):addChild(item)
    end  
    item:setVisible(true)
    item:setPositionX(0)
    item:setPositionY(ihh - 205 - 210*(i-1))
    
    local rews  = Split(self._cfgOnline[i]['jiangli'],"|")
    for k=1,table.getn(rews) do
        local rew = Split(rews[k],"%^")
        local ctype = tonumber(rew[1])
        local tid = tonumber(rew[2])
        local num = tonumber(rew[3])
        item:getChildByName("gift"..k):getChildByName("count"):getChildByName("count"):setString(num)
        item:getChildByName("gift"..k):getChildByName("back"):getChildByName("icon"):loadTexture(dd.getGiftsIcon(ctype, tid)[1],dd.getGiftsIcon(ctype, tid)[2])
        item:getChildByName("gift"..k).type = ctype
        item:getChildByName("gift"..k).id = tid
        item:getChildByName("gift"..k).count = num
    end
    item:getChildByName("icon"):loadTexture("images/icon/tools/130522"..i..".png",0)

    item:getChildByName("iconback"):removeAllChildren(true)
    if i < dd.mygifts:getLong(1,"onlinepackid") then                           --已领取
        item:getChildByName("collected"):setVisible(true)
        item:getChildByName("getbtn"):setVisible(false)
        item:getChildByName("chu_time"):setVisible(true)
        item:getChildByName("chu_time"):setString(ff.langString("已完成"))         
    elseif i == dd.mygifts:getLong(1,"onlinepackid") then                    
        local time = dd.mygifts:getLong(1,"onlinepack")-dd.getServerTime()
        if time > 0 then       
            self._onlineId = i                                               --倒计时
            schedule(self, self.showAction,1)
            item:getChildByName("collected"):setVisible(false)
            item:getChildByName("getbtn"):setVisible(false)
            item:getChildByName("chu_time"):setVisible(true)
            item:getChildByName("chu_time"):setString(ff.getLeftTime(time,":")) 
        else                                                           --可领取
            item:getChildByName("collected"):setVisible(false)
            item:getChildByName("getbtn"):setVisible(true)
            item:getChildByName("chu_time"):setVisible(false)
            
            local sprite = sp.SkeletonAnimation:create("images/pve/PveAnimation/zhuchengshengji.json", "images/pve/PveAnimation/zhuchengshengji.atlas")
            sprite:setPosition(cc.p(70, 70))
            sprite:setAnimation(0, "Guangquan_animation", true)
            item:getChildByName("iconback"):addChild(sprite,0,101)
        end
        if self._justopen == true then
            --判断是否需要定位     
            local hh = self:getChildByName("online"):getChildByName("list1"):getContentSize().height       
            local itemposy = item:getPositionY()
            local innposy  = hh/2 - itemposy
            if innposy < (hh - ihh) then
                innposy = hh - ihh
            elseif innposy > 0 then
                innposy = 0
            end
            self:getChildByName("online"):getChildByName("list1"):getInnerContainer():setPositionY(innposy)
            self._justopen = false
        end
            
    elseif dd.mygifts:getLong(1,"onlinepackid") == 0 then
        item:getChildByName("collected"):setVisible(true)
        item:getChildByName("getbtn"):setVisible(false)
        item:getChildByName("chu_time"):setVisible(true)
        item:getChildByName("chu_time"):setString(ff.langString("已完成")) 
    else
        item:getChildByName("collected"):setVisible(false)
        item:getChildByName("getbtn"):setVisible(false)
        item:getChildByName("chu_time"):setVisible(true)
        item:getChildByName("chu_time"):setString(ff.langString("奖励").." #"..i) 
    end    
       
    if item:getChildByName("collected"):isVisible() == true then
        self:setNodeLight(item:getChildByName("gift1"):getChildByName("back"):getChildByName("icon"),false)
        self:setNodeLight(item:getChildByName("gift2"):getChildByName("back"):getChildByName("icon"),false)
        self:setNodeLight(item:getChildByName("gift3"):getChildByName("back"):getChildByName("icon"),false)
    else
        self:setNodeLight(item:getChildByName("gift1"):getChildByName("back"):getChildByName("icon"),true)
        self:setNodeLight(item:getChildByName("gift2"):getChildByName("back"):getChildByName("icon"),true)
        self:setNodeLight(item:getChildByName("gift3"):getChildByName("back"):getChildByName("icon"),true)
    end
    item:setTag(i)
end
--每日目标
function onlineRewardLayer:updateDaytask()
    self:updateDaytaskTop()
    self:updateList1()
end
function onlineRewardLayer:updateDaytaskTop()
    if self._tap == 1 then
        self:stopAllActions()
    end
    local top = self:getChildByName("daytask"):getChildByName("top2")
    local count = self:getHaveStarsCount()
    local count1 = count
    local count2 = count
    if count > 5 then
        count1 = 5
    end
    if count > 10 then
        count2 = 10
    end
    top:getChildByName("box1"):getChildByName("count"):setString(count1.."/5")
    top:getChildByName("box2"):getChildByName("count"):setString(count2.."/10")
    top:getChildByName("box3"):getChildByName("count"):setString(count.."/15")
    --是否可领 + 蓝光
    for i=1,3 do
        top:getChildByName("box"..i):removeChildByTag(101)
        if self:isBoxCanbe(i) == true then 
            local sprite = sp.SkeletonAnimation:create("images/pve/PveAnimation/zhuchengshengji.json", "images/pve/PveAnimation/zhuchengshengji.atlas")
            sprite:setPosition(cc.p(80, 100))
            sprite:setAnimation(0, "Guangquan_animation", true)
            top:getChildByName("box"..i):addChild(sprite,0,101)
            top:getChildByName("box"..i):getChildByName("getbtn"):setVisible(true)
        else
            top:getChildByName("box"..i):getChildByName("getbtn"):setVisible(false)
        end
    end
    --是否倒计时
    
    cclog("sss  ===== "..dd.myDayTask:getLong(1,"time"))
    

    top:getChildByName("box4"):removeChildByTag(101)
    top:getChildByName("box4"):getChildByName("getbtn"):setVisible(false)
    if dd.myDayTask:getLong(1,"time") == 0 then
        top:getChildByName("box4"):getChildByName("name"):setVisible(true)
        top:getChildByName("box4"):getChildByName("time"):setVisible(false)
        top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box041_online.png",1))
    elseif dd.myDayTask:getLong(1,"time") == 1 then 
        top:getChildByName("box4"):getChildByName("name"):setVisible(true)
        top:getChildByName("box4"):getChildByName("time"):setVisible(false)
        top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box041_online.png",1))
    else
        local time = dd.myDayTask:getLong(1,"time")-dd.getServerTime()

        if time > 86400 then            
            top:getChildByName("box4"):getChildByName("name"):setVisible(false)
            top:getChildByName("box4"):getChildByName("time"):setVisible(true)
            self.showAction()
            schedule(self, self.showAction,1) 
            if dd.myDayTask:getLong(1,"getStep") == 10 then
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box043_online.png",1))
            elseif dd.myDayTask:getLong(1,"getStep") == 15 then
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box043_online.png",1))
            else
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box042_online.png",1))
            end
            top:getChildByName("box4"):getChildByName("name"):setVisible(false)
            top:getChildByName("box4"):getChildByName("time"):setVisible(true)
        elseif time > 0 and dd.myDayTask:getLong(1,"time") ~= 1 and time < 86400 and dd.myDayTask:getLong(1,"time") ~= 0 then
            if dd.myDayTask:getLong(1,"getStep") == 10 then
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box042_online.png",1))
            elseif dd.myDayTask:getLong(1,"getStep") == 15 then
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box043_online.png",1))
            else
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box041_online.png",1))
            end
            local sprite = sp.SkeletonAnimation:create("images/pve/PveAnimation/zhuchengshengji.json", "images/pve/PveAnimation/zhuchengshengji.atlas")
            sprite:setPosition(cc.p(80, 100))
            sprite:setAnimation(0, "Guangquan_animation", true)
            top:getChildByName("box4"):addChild(sprite,0,101)
            top:getChildByName("box4"):getChildByName("name"):setVisible(true)
            top:getChildByName("box4"):getChildByName("time"):setVisible(false)
            top:getChildByName("box4"):getChildByName("getbtn"):setVisible(true)

        else
            top:getChildByName("box4"):getChildByName("name"):setVisible(false)
            top:getChildByName("box4"):getChildByName("time"):setVisible(true)
            
            top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box041_online.png",1))

        end           
    end    
end
function onlineRewardLayer:updateList1()
    local hh = self:getChildByName("daytask"):getChildByName("list2"):getContentSize().height
    local num = table.getn(self._daytasks)
    local ihh = 0
    
    for i,v in ipairs(self._taskitems) do
        if tolua.isnull(v) then
            self._taskitems[i] = nil
        else
            v:setVisible(false)
            v:setTag(0)
        end
    end
    
    ihh = 157*num
    if ihh < hh then
        ihh = hh
    end
    self:getChildByName("daytask"):getChildByName("list2"):setInnerContainerSize(cc.size(720,ihh))
    for i=1, num do
        self:addTaskItem(ihh, i)
    end
    self._justopen = false
end

function onlineRewardLayer:addTaskItem(ihh, i)
    local star        = self._daytasks[i]["curstar"]
    local progress    = self._daytasks[i]["progress"]
    local curgoal     = self._daytasks[i]["curgoal"]
    local rewardtype  = self._daytasks[i]["rewardtype"]
    local rewardtid   = self._daytasks[i]["rewardtid"]
    local rewardcount = self._daytasks[i]["rewardcount"]
    local star2 = star                          --1/3
    if star2 < 3 then
        star2 = star2 + 1
    end
    local percent = math.ceil(progress*100/curgoal)
    if percent > 100 then
        percent = 100
    end
    local item = self._taskitems[i]
    if item == nil then
        item = self:getChildByName("item1"):clone()
        self._taskitems[i] = item
        self:getChildByName("daytask"):getChildByName("list2"):addChild(item)
    end  
    item:setVisible(true)
    item:setPositionX(0)
    item:setPositionY(ihh - 150 - 157*(i-1))
    self:setStar(item:getChildByName("star"),star)
    item:getChildByName("chu_name"):setString( ff.langString(self._namearr[i]).."("..star2.."/3"..")")
    item:getChildByName("tips"):setString( ff.langString(self._tiparr[i],{curgoal}))
    item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getGiftsIcon(rewardtype, rewardtid)[1],dd.getGiftsIcon(rewardtype, rewardtid)[2])

    item:getChildByName("icon").type = rewardtype
    item:getChildByName("icon").id = rewardtid
    item:getChildByName("icon").count = rewardcount

    item:getChildByName("face"):loadTexture(self.getDaytaskIcon(i))
    item:getChildByName("count"):getChildByName("count"):setString(rewardcount)
    item:getChildByName("progress"):getChildByName("exp"):setString(ff.getFormatMoney(progress).."/"..ff.getFormatMoney(curgoal))
    item:getChildByName("progress"):getChildByName("progress"):setPercent(percent)
    if star < 3 then
        if progress == curgoal then
            item:getChildByName("progress"):setVisible(false)
            item:getChildByName("getbtn"):setVisible(true)
            if self._justopen == true then
                --判断是否需要定位     
                local hh = self:getChildByName("daytask"):getChildByName("list2"):getContentSize().height       
                local itemposy = item:getPositionY()
                local innposy  = hh/2 - itemposy
                if innposy < (hh - ihh) then
                    innposy = hh - ihh
                elseif innposy > 0 then
                    innposy = 0
                end
                self:getChildByName("daytask"):getChildByName("list2"):getInnerContainer():setPositionY(innposy)
                self._justopen = false
            end

        else
            item:getChildByName("progress"):setVisible(true)
            item:getChildByName("getbtn"):setVisible(false)
        end
        item:getChildByName("complete"):setVisible(false)
        self:setNodeLight(item:getChildByName("icon"):getChildByName("icon"),true)
    else
        item:getChildByName("progress"):setVisible(true)
        item:getChildByName("getbtn"):setVisible(false)
        item:getChildByName("complete"):setVisible(true)
        self:setNodeLight(item:getChildByName("icon"):getChildByName("icon"),false)
    end
    item:getChildByName("getbtn"):setTag(i)
    item:setTag(i)
end
--只用于自定义标签的star设置
function onlineRewardLayer:setStar(node,star)
    if star == 0 then
        node:setString("111")
    elseif star == 1 then
        node:setString("011")
    elseif star == 2 then
        node:setString("001")
    elseif star == 3 then
        node:setString("000")
    end
end

function onlineRewardLayer.closePop(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("onlineReward") 
        widget:getChildByName("masking"):setVisible(false)
        widget:getChildByName("pop"):setVisible(false)
    end
end

function onlineRewardLayer.goldSure(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("onlineReward") 
        if dd.myDayTask:getLong(1,"time") == 0 then
            widget:getChildByName("masking"):setVisible(false)
            widget:getChildByName("pop3"):setVisible(false)
            return
        end
        local time = dd.myDayTask:getLong(1,"time")-dd.getServerTime()
        if time > 86400 then            
            widget:getChildByName("masking"):setVisible(false)
            widget:getChildByName("pop3"):setVisible(false)
        elseif time > 0 and time ~= 1 and time < 86400 then
            local message = ff.net:createMessage()
            message:addCmd(0x0000016d)
            message:addLong(dd.uid)
            ff.net:rpc(message, false)
        else
            widget:getChildByName("masking"):setVisible(false)
            widget:getChildByName("pop3"):setVisible(false)
        end           
        
    end
end

function onlineRewardLayer.openPop(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then  
        local widget = pop.getDialog("onlineReward") 
        if widget._tap == 1 then
            widget:getChildByName("pop"):getChildByName("block1"):getChildByName("chu_tips"):setString(ff.langString("每日目标"))
            widget:getChildByName("pop"):getChildByName("block1"):getChildByName("content"):setString(ff.langString("完成任务可累积星数，集齐足够的星数即可开启对应的宝箱。完成全部任务后明日可额外开启黄金宝箱。每日目标服务器时间0点将刷新。"))
        else
            widget:getChildByName("pop"):getChildByName("block1"):getChildByName("chu_tips"):setString(ff.langString("在线奖励"))
            widget:getChildByName("pop"):getChildByName("block1"):getChildByName("content"):setString(ff.langString("累积在线即可领取奖励，每日奖励会在服务器时间0点更新。累积在线时间每日刷新，无法带入次日"))
        end
        widget:getChildByName("masking"):setVisible(true)
        pop.showPopEffect(12,widget:getChildByName("pop"))
    end
end

function onlineRewardLayer.showPrePage(sender, eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("onlineReward")
        if widget == nil then
            return
        end  
        local pageIndex = widget:getChildByName("pop3"):getChildByName("PageView"):getCurPageIndex()

        if pageIndex > 0 then
            widget:getChildByName("pop3"):getChildByName("PageView"):scrollToPage(pageIndex - 1)
        end
    end   
end

function onlineRewardLayer.showNextPage(sender, eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("onlineReward")
        if widget == nil then
            return
        end  
        local pageIndex = widget:getChildByName("pop3"):getChildByName("PageView"):getCurPageIndex()

        if pageIndex < 2 then
            widget:getChildByName("pop3"):getChildByName("PageView"):scrollToPage(pageIndex + 1)
        end
    end           
end

function onlineRewardLayer.closePop2(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("onlineReward") 
        widget:getChildByName("masking"):setVisible(false)
        widget:getChildByName("pop2"):setVisible(false)
    end
end

function onlineRewardLayer.openPop2(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then  
        local widget = pop.getDialog("onlineReward") 
        widget:getChildByName("masking"):setVisible(true)
        pop.showPopEffect(12,widget:getChildByName("pop2"))
    end
end

function onlineRewardLayer.closePop3(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("onlineReward") 
        widget:getChildByName("masking"):setVisible(false)
        widget:getChildByName("pop3"):setVisible(false)
        if widget._tap == 3 then
            pop.onClosePopDialog("onlineReward")
        end
    end
end

function onlineRewardLayer.openPop3(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then  
        local widget = pop.getDialog("onlineReward") 
        widget:getChildByName("masking"):setVisible(true)
        widget:AutoGetPage()
        pop.showPopEffect(12,widget:getChildByName("pop3"))
    end
end

function onlineRewardLayer:updatePop2(type)
    local gifts = self._dayboxs[type]
    local num = table.getn(gifts)
    for i=1,num do
        local ctype = gifts[i]["type"]
        local tid = gifts[i]["tid"]
        local count = gifts[i]["count"]
        local item = self._giftitems[i]
        if item == nil then
            item = self:getChildByName("pop2"):getChildByName("item"):clone()
            self._giftitems[i] = item
            self:getChildByName("pop2"):getChildByName("info"):addChild(item)
        end
        item:getChildByName("back"):getChildByName("icon"):loadTexture(dd.getGiftsIcon(ctype, tid)[1],dd.getGiftsIcon(ctype, tid)[2])
        item:getChildByName("count"):getChildByName("count"):setString(count)  
        item:setVisible(true)
        item:setPositionX(10 + 140*(i-1))
        item:setPositionY(20)
        item:getChildByName("back"):getChildByName("icon").type = ctype
        item:getChildByName("back"):getChildByName("icon").id = tid
        item:getChildByName("back"):getChildByName("icon").count = count
        item:getChildByName("back"):getChildByName("icon"):setTouchEnabled(true)
    end
    for i=num+1,5 do
        local item = self._giftitems[i]
        if item == nil then
            item = self:getChildByName("pop2"):getChildByName("item"):clone()
            self._giftitems[i] = item
            self:getChildByName("pop2"):getChildByName("info"):addChild(item)
        end
        item:getChildByName("back"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        item:getChildByName("count"):getChildByName("count"):setString("")
        item:setVisible(true)
        item:setPositionX(10 + 140*(i-1))
        item:setPositionY(20)
        item:getChildByName("back"):getChildByName("icon"):setTouchEnabled(false)
    end
    if self:isBoxCanbe(type) == true then
        self:setBtnLight(self:getChildByName("pop2"):getChildByName("getbtn"),true)
    else
        self:setBtnLight(self:getChildByName("pop2"):getChildByName("getbtn"),false)
    end  
    self:getChildByName("pop2"):getChildByName("getbtn"):setTag(type)
end

function onlineRewardLayer:updatePop3()
   
end

function onlineRewardLayer.getDaytaskIcon(type)
    if type < 6 then
        return "images/icon/task/meirimubiao/"..type..".png"
    else
        return "images/icon/task/meirimubiao/1.png"
    end
end

function onlineRewardLayer:getHaveStarsCount()
    local count = 0
    for i=1,5 do
        count = count + self._daytasks[i]["curstar"]
    end
    return count
end
--箱子是否可领
function onlineRewardLayer:isBoxCanbe(type)
    cclog("已领箱子 == "..self._haveCount)
    local iscanbe = false
    if type == 4 then
        local time = dd.myDayTask:getLong(1,"time")-dd.getServerTime()
        if dd.myDayTask:getLong(1,"time") ~= 0 and dd.myDayTask:getLong(1,"time") ~= 1 then
            if time < 86400 then
                iscanbe = true
            else    
                iscanbe = false
            end
        else
            iscanbe = false
        end
    else
        if self:getHaveStarsCount() >= type*5 and type - self._haveCount == 1 then
            iscanbe = true
        else
            iscanbe = false
        end
    end
    return iscanbe
end

function onlineRewardLayer:onGetReward(params)
    local code = params[1]
    if code == 0 then      
        local pid = params[2]
        --pid == 0 时 上次领取的id == 7
        if pid < 1 then
            pid = 8
        end
        local item = self:getChildByName("online"):getChildByName("list1"):getChildByTag(pid-1)
        if item ~= nil then
            item:getChildByName("collected"):setVisible(true)
            item:getChildByName("collected"):setScale(1.0)
            item:getChildByName("collected"):runAction(cc.Sequence:create(cc.ScaleTo:create(0.1,2),cc.ScaleTo:create(0.1, 1), cc.CallFunc:create(function() self:updateList2() end)))
        else
            self:updateList2()
        end
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功领取奖励 ！"),true)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
--查询每日目标列表
function onlineRewardLayer:onDaytaskGetlist(params)
    local code = params[1]
    if code == 0 then  
        self._daytasks  = params[2]  
        self._haveCount = params[3]
        self._dayboxs   = params[4]
        self._endTime   = params[5]
        self:updateDaytask()
        self:updatePageView()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function onlineRewardLayer:updatePageView(  )
    local top = self:getChildByName("daytask"):getChildByName("top2")

    if dd.myDayTask:getLong(1,"time") == 0 then
        top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box041_online.png",1))
    elseif dd.myDayTask:getLong(1,"time") == 1 then 
        top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box041_online.png",1))
    else
        local time = dd.myDayTask:getLong(1,"time")-dd.getServerTime()

        if time > 86400 then            
            
            if dd.myDayTask:getLong(1,"getStep") == 10 then
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box043_online.png",1))
            elseif dd.myDayTask:getLong(1,"getStep") == 15 then
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box043_online.png",1))
            else
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box042_online.png",1))
            end
           
        elseif time > 0 and dd.myDayTask:getLong(1,"time") ~= 1 and time < 86400 and dd.myDayTask:getLong(1,"time") ~= 0 then
            if dd.myDayTask:getLong(1,"getStep") == 10 then
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box042_online.png",1))
            elseif dd.myDayTask:getLong(1,"getStep") == 15 then
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box043_online.png",1))
            else
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box041_online.png",1))
            end
           
        else
           
            top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box041_online.png",1))

        end     
    end      
    for j=1,3 do
        local item = self:getChildByName("pop3"):getChildByName("PageView"):getPage(j -1 )
        if item ~= nil then
            local index = 3+ j
            local gifts = self._dayboxs[index]
            local num = table.getn(gifts)
            for i=1,num do
                local ctype = gifts[i]["type"]
                local tid = gifts[i]["tid"]
                local count = gifts[i]["count"]
                item:getChildByName("itemlist"):getChildByName("item"..tostring(i)):getChildByName("back"):getChildByName("icon"):loadTexture(dd.getGiftsIcon(ctype, tid)[1],dd.getGiftsIcon(ctype, tid)[2])
                item:getChildByName("itemlist"):getChildByName("item"..tostring(i)):getChildByName("count"):getChildByName("count"):setString(count)  
            end
        end
    end
    -- body
end

function onlineRewardLayer:AutoGetPage(  )
    -- body
    local index = 0
    if dd.myDayTask:getLong(1,"time") == 0 then
        index = 0
    elseif dd.myDayTask:getLong(1,"time") == 1 then 
        index = 0
    else
        local time = dd.myDayTask:getLong(1,"time")-dd.getServerTime()
        
        if time > 86400 then            
            
            if dd.myDayTask:getLong(1,"getStep") == 10 then
                index = 2
            elseif dd.myDayTask:getLong(1,"getStep") == 15 then
                index = 2
            else
                index = 1
            end
           
        elseif time > 0 and dd.myDayTask:getLong(1,"time") ~= 1 and time < 86400 and dd.myDayTask:getLong(1,"time") ~= 0 then
            if dd.myDayTask:getLong(1,"getStep") == 10 then
                index = 1
            elseif dd.myDayTask:getLong(1,"getStep") == 15 then
                index = 2
            else
                index = 0
            end
           
        else
           
            index = 2

        end     
    end      
    self:getChildByName("pop3"):getChildByName("PageView"):scrollToPage(index)
end

function onlineRewardLayer:onDaytaskGetReward(params)
    local code = params[1]
    if code == 0 then
        local type = params[2]
        local info = params[3]
        local havecount = params[4]
        self._haveCount = havecount
        if type == 0 then
            self.closePop2(nil,ccui.TouchEventType.ended)
            self:updateDaytask()
            if self._dayboxs[self._haveCount] ~= nil then
                local info = {}
                local gifts = self._dayboxs[self._haveCount]
                local num = table.getn(gifts)
                for i=1,num do
                    info[i]={}
                    info[i]["type"] = gifts[i]["type"]
                    info[i]["id"] = gifts[i]["tid"]
                    info[i]["count"] = gifts[i]["count"]
                end
                pop.onShowPopDialog("reward",info,ff.langString("每日目标"))
            end
        else
            self._daytasks[type]["curstar"] = info["curstar"]
            self._daytasks[type]["progress"] = info["progress"] 
            self._daytasks[type]["curgoal"] = info["curgoal"]         --当前目标
            self._daytasks[type]["rewardtype"] = info["rewardtype"]
            self._daytasks[type]["rewardtid"] = info["rewardtid"]
            self._daytasks[type]["rewardcount"] = info["rewardcount"]
            
            if self._daytasks[type]["curstar"] >= 3 then
                local item = self:getChildByName("daytask"):getChildByName("list2"):getChildByTag(type)
                if item ~= nil then
                    item:getChildByName("complete"):setVisible(true)
                    item:getChildByName("complete"):setScale(2.0)
                    item:getChildByName("complete"):runAction(cc.Sequence:create(cc.ScaleTo:create(0.2, 1), cc.CallFunc:create(function() self:updateDaytask() end)))
                end
            else
                self:updateDaytask()
            end
        end       
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功领取奖励 ！"),true)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function onlineRewardLayer:onDaytaskGetNext(params)
    local code = params[1]
    if code == 0 then  
        self._endTime = params[2]
        self.closePop2(nil,ccui.TouchEventType.ended)
        self:updateDaytask()
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功领取奖励 ！"),true)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function onlineRewardLayer:daytaskNotice(params)
    cclog("在线奖励通知到了====")
    self._endTime = params[1]
    self:updateDaytask()
    local top = self:getChildByName("daytask"):getChildByName("top2")
    if dd.myDayTask:getLong(1,"time") == 0 then
        top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box041_online.png",1))
    elseif dd.myDayTask:getLong(1,"time") == 1 then 
        top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box041_online.png",1))
    else
        local time = dd.myDayTask:getLong(1,"time")-dd.getServerTime()
        cclog("================"..dd.myDayTask:getLong(1,"time"))
        cclog("================"..time)
        cclog("================"..dd.myDayTask:getLong(1,"getStep"))
        if time > 86400 then            
            
            if dd.myDayTask:getLong(1,"getStep") == 10 then
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box043_online.png",1))
            elseif dd.myDayTask:getLong(1,"getStep") == 15 then
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box043_online.png",1))
            else
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box042_online.png",1))
            end
           
        elseif time > 0 and dd.myDayTask:getLong(1,"time") ~= 1 and time < 86400 and dd.myDayTask:getLong(1,"time") ~= 0 then
            if dd.myDayTask:getLong(1,"getStep") == 10 then
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box042_online.png",1))
            elseif dd.myDayTask:getLong(1,"getStep") == 15 then
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box043_online.png",1))
            else
                top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box041_online.png",1))
            end
           
        else
           
            top:getChildByName("box4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("box042_online.png",1))

        end     
    end      

end

function onlineRewardLayer:newdayNotice(params)
    cclog("零点通知下来了=======>")
    self:updateList2()
end

function onlineRewardLayer:getDaytaskList()
    local message = ff.net:createMessage()
    message:addCmd(0x00000053)
    message:addLong(dd.uid)
    ff.net:rpc(message,false)
end

function onlineRewardLayer:getDaytaskReward(type)
    cclog("type == "..type)
    local message = ff.net:createMessage()
    message:addCmd(0x0000016b)
    message:addLong(dd.uid)
    message:addLong(type)             --0-宝箱奖励    1-5 5种目标奖励
    ff.net:rpc(message, false)
end

function onlineRewardLayer:setNodeLight(node, light)
    if light == true then
        node:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
    else 
        local effect = ff.Effect:effectGrey()    
        node:getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
    end
end

function onlineRewardLayer:setBtnLight(node, light)
    if light == true then
        node:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        node:setTouchEnabled(true)
    else 
        local effect = ff.Effect:effectGrey()    
        node:getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        node:setTouchEnabled(false)
    end
end

function onlineRewardLayer.showAction()
    local widget = pop.getDialog("onlineReward")
    if widget == nil then
        return
    end
    if widget._tap == 2 then
        local item = widget:getChildByName("online"):getChildByName("list1"):getChildByTag(widget._onlineId)
        if item ~= nil then
            local time = dd.mygifts:getLong(1,"onlinepack")-dd.getServerTime()
            if time > 0 then
                item:getChildByName("chu_time"):setString(ff.getLeftTime(time,":"))
            else
                widget:updateList2()
            end
        end
    else
        if dd.myDayTask:getLong(1,"time")  > 0 and dd.myDayTask:getLong(1,"time") ~= 1 then
            local time = dd.myDayTask:getLong(1,"time")  - dd.getServerTime() - 86400
            if time > 0 then
                time = dd.serverTime.zero + 86400 - dd.getServerTime()
                widget:getChildByName("daytask"):getChildByName("top2"):getChildByName("box4"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
            else
                widget:updateDaytask()
            end
        end
    end

end

function onlineRewardLayer:showTips(type, id, count, pos)
    local ret  = dd.getGiftsTips(type, id, count)
    local name = ret[1]
    local str  = ret[2]
    local tips = self:getChildByName("tips")
    local wid  = 360

    tips:setVisible(true)
    tips:getChildByName("tips"):removeAllChildren(true)

    local richText = ccui.RichText:create()
    richText:ignoreContentAdaptWithSize(false)
    richText:setContentSize(cc.size(wid-30,600))    
    richText:setAutoHeight()

    local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, str, "Helvetica", 20)
    richText:insertElement(chat,0)
    richText:formatText()

    local size = richText:getContentSize()
    richText:setPosition(cc.p(172,size.height/2 + 15))
    tips:setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):addChild(richText)

    tips:getChildByName("name"):setString(name) 
    tips:getChildByName("name"):setPositionY(size.height + 40)

    tips:setPosition(pos)
    if pos.x < 100 then
        tips:setAnchorPoint(cc.p(0.2,0))
        tips:getChildByName("flag"):setPositionX(wid*0.2)
    elseif pos.x > 550 then
        tips:setAnchorPoint(cc.p(0.8,0))
        tips:getChildByName("flag"):setPositionX(wid*0.8)
    else
        tips:setAnchorPoint(cc.p(0.5,0))
        tips:getChildByName("flag"):setPositionX(wid*0.5)
    end  
end

function onlineRewardLayer:unshowTips()
    self:getChildByName("tips"):setVisible(false)
end

function onlineRewardLayer:getWorldPos(node)
    local anr   = node:getAnchorPoint()
    local size  = node:getContentSize()
    local p = node:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
    return p
end
--判断哪个能领取
function onlineRewardLayer:whichOne()
    if self._tap ~= 3 then
        self._tap = 2
        if dd.mygifts:getLong(1,"onlinepackid") ~= 0 then
            local time = dd.mygifts:getLong(1,"onlinepack")-dd.getServerTime()
            if time <= 0 then 
                self._tap = 2
            elseif dd.myDayTask:getLong(1,"canReceive") ~= 0 then
                self._tap = 1
            end
        else
            if dd.myDayTask:getLong(1,"canReceive") ~= 0 then
                self._tap = 1
            end        
        end
    end
end
--接口
function onlineRewardLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        
        local widget = pop.getDialog("onlineReward")
        if widget ~= nil then            
            if widget:getChildByName("pop"):isVisible() == true then
                widget.closePop(sender,ccui.TouchEventType.ended)
                return
            elseif widget:getChildByName("pop2"):isVisible() == true then
                widget.closePop2(sender,ccui.TouchEventType.ended)
                return
            elseif widget:getChildByName("pop3"):isVisible() == true then
                widget.closePop3(sender,ccui.TouchEventType.ended)
                if widget._tap == 3 then
                    pop.onClosePopDialog("onlineReward")
                end
                return
            end
            pop.onClosePopDialog("onlineReward")
        end
    end
end

function onlineRewardLayer.onStart(sender)
    ff.net:bindProperty(2514,"gold",sender.updateGold)
    ff.net:registerEvent(2,dd.Tjf_online_GetReward, function (message)sender:onGetReward(message)end)
    ff.net:registerEvent(2,dd.Tjf_daytask_GetList, function (message)sender:onDaytaskGetlist(message)end)
    ff.net:registerEvent(2,dd.Tjf_daytask_GetReward, function (message)sender:onDaytaskGetReward(message)end)
    ff.net:registerEvent(2,dd.Tjf_daytask_GetNextBox, function (message)sender:onDaytaskGetNext(message)end)
    --领取第15个箱子应该会通知吧
    ff.net:registerEvent(2,dd.Tjf_notify_SNDailyUserActivity, function (message)sender:daytaskNotice(message)end)
    ff.net:registerEvent(2,dd.Tjf_notify_SNNewDay, function (message)sender:newdayNotice(message)end)
    
    sender:getDaytaskList()
    sender:getChildByName("online"):getChildByName("list1"):jumpToTop()
    sender._justopen = true
    --sender:updateList2()
    sender:showByType(sender._tap)
    --sender._justopen = false
end

function onlineRewardLayer.onEnd(sender)
    ff.net:unbindProperty("gold",2514)
    ff.net:removeEvent(2,dd.Tjf_online_GetReward)
    ff.net:removeEvent(2,dd.Tjf_daytask_GetList)
    ff.net:removeEvent(2,dd.Tjf_daytask_GetReward)
    ff.net:removeEvent(2,dd.Tjf_daytask_GetNextBox)
    ff.net:removeEvent(2,dd.Tjf_notify_SNDailyUserActivity)
    ff.net:removeEvent(2,dd.Tjf_notify_SNNewDay)
    dd.delBackEvent()
    sender:stopAllActions()

    if ff.platform ~= 1 then 
        for i,item in ipairs(sender._onitems) do
            if item then
                item:getChildByName("iconback"):removeAllChildren(true)
                item:getChildByName("getbtn"):setVisible(false)
                item:getChildByName("gift1"):getChildByName("back"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("gift2"):getChildByName("back"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("gift3"):getChildByName("back"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end
        for i,item in ipairs(sender._taskitems) do
            if item then
                item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("face"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end
        for i,item in ipairs(sender:getChildByName("pop2"):getChildByName("info"):getChildren()) do
            if item then
                item:getChildByName("back"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end
    end

end

function onlineRewardLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    sender:whichOne()
    sender:initByType(sender._tap)
    
    return true
end

function onlineRewardLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("onlineReward")
    if widget ~= nil then            
        if widget:getChildByName("pop"):isVisible() == true then
            widget.closePop(sender,ccui.TouchEventType.ended)
            return
        elseif widget:getChildByName("pop2"):isVisible() == true then
            widget.closePop2(sender,ccui.TouchEventType.ended)
            return
        elseif widget:getChildByName("pop3"):isVisible() == true then
            widget.closePop3(sender,ccui.TouchEventType.ended)
            if widget._tap == 3 then
                pop.onClosePopDialog("onlineReward")
            end
            return
        end
        pop.onClosePopDialog("onlineReward")
    end
end

function onShowOnlineRewardLayer(widget)
    local layer = onlineRewardLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onAutoSize()
   
    layer:onInit()
    return layer
end