--查看战斗力
local powerLayer = class("powerInfo")
powerLayer._name = "powerInfo"
powerLayer._init = false
powerLayer._userInfo = {}
powerLayer._cfglog = {}

function powerLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, powerLayer)
    return target
end

function powerLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("bg"):setContentSize(cc.size(720,hh))
        self:getChildByName("bg"):setPositionY(0)

        self:getChildByName("masking"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("masking"):setPositionY(0)

        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("topNavi"):setPositionY(hh - 105 - 85 -1)
    
        self:getChildByName("view"):setContentSize(cc.size(720,hh -105 - 85))
        self:getChildByName("view"):setPositionY(0)
        self:getChildByName("boosts"):setContentSize(cc.size(720,hh -105 - 85))
        self:getChildByName("boosts"):getChildByName("back"):setContentSize(cc.size(720,hh -105 - 85))
        self:getChildByName("boosts"):setPositionY(0)
        self:getChildByName("boosts"):getChildByName("main"):setContentSize(cc.size(720, hh -105 - 95))
        
        local hh2 = hh -105 - 85        
        --scrollView
        self:getChildByName("view"):getChildByName("view"):setContentSize(cc.size(720, hh2 - 272 - 55))
        --位置设置
        self:getChildByName("view"):getChildByName("top"):setPositionY(hh2 - 272)
        self:getChildByName("view"):getChildByName("title"):setPositionY(hh2 - 272 - 30)
    end
end

function powerLayer:onInit()
    if self._init == false then        
        --topArea
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
     
        --修改名字
        local function onChangName(sender, touchEventType)
            if touchEventType == ccui.TouchEventType.ended then       
                AudioEngine.playEffect(ff.sounds[101])
                pop.onShowPopDialog("changeName",2)
                self:getChildByName("masking"):setVisible(true)
            end
        end
        --查看联盟
        local function onLookUnion(sender, touchEventType)
            if touchEventType == ccui.TouchEventType.ended then 
                pop.onShowPopDialog("unionInfo",self,dd.myUnion:getString(1,"unionflag"))                    
            end
        end
        --Join
        local function onJoin(sender, touchEventType)
            if touchEventType == ccui.TouchEventType.ended then 
                self:onClose()
                if not pop.isShowing("noUnion") then
                    pop.onShowPopDialog("noUnion",1)
                end  
                local widget = pop.getDialog("noUnion")
                widget:showJoinView()
                --延时调用  等待网络注册
                local function sched()
                    local wi = pop.getDialog("noUnion")
                    wi:showUnionJoin()
                end 
                performWithDelay(widget,sched,1)
            end
        end
        --face
        local function onFace(sender, touchEventType)
            if touchEventType == ccui.TouchEventType.ended then 
                AudioEngine.playEffect(ff.sounds[101])
                dd.mainUI.onChangeFace(sender,touchEventType)
            end
        end
        local function showTips(sender, touchEventType)
            if touchEventType == ccui.TouchEventType.ended then 
                self:getChildByName("view"):getChildByName("top"):getChildByName("icon"):getChildByName("tips"):stopAllActions()
                local actice = 0
                local show = false
                local plus_552 = 0
                for i=1,dd.myeffect:rowCount() do
                    if dd.myeffect:getLong(i,"id") == 552 then
                        plus_552 = dd.myeffect:getLong(i,"param")
                        show = true
                        break
                    end
                end
                local time = 360
                if show == true then
                    time =  time / (1 + plus_552 / 1000)
                end
                local point = (dd.getServerTime() -  dd.myinfo:getLong(1,"ActiveTime")) / time
                --local point = (dd.getServerTime() -  dd.myinfo:getLong(1,"ActiveTime")) /360
                --cclog("==============="..point)
                actice =math.floor(point)+ dd.myinfo:getLong(1,"NowActive")
                if actice > dd.myinfo:getLong(1,"MaxActive") then
                    if dd.myinfo:getLong(1,"NowActive") > dd.myinfo:getLong(1,"MaxActive")  then
                        actice = dd.myinfo:getLong(1,"NowActive") 
                    else
                        actice = dd.myinfo:getLong(1,"MaxActive") 
                    end
                end
                local string = ""
                string = string..ff.langString("行动力").."："..tostring(actice).."/"..tostring(dd.myinfo:getLong(1,"MaxActive")).."\n"..ff.langString("行动力每6分钟恢复1点")
                self:getChildByName("view"):getChildByName("top"):getChildByName("icon"):getChildByName("tips"):getChildByName("name"):setString(string)

                self:getChildByName("view"):getChildByName("top"):getChildByName("icon"):getChildByName("tips"):setVisible(true)
                local function sched()
                    self:getChildByName("view"):getChildByName("top"):getChildByName("icon"):getChildByName("tips"):setVisible(false)
                end 

                performWithDelay(self:getChildByName("view"):getChildByName("top"):getChildByName("icon"):getChildByName("tips"),sched,1.5) 
            end
        end
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
        self:getChildByName("view"):getChildByName("top"):getChildByName("icon"):addTouchEventListener(onFace)
        self:getChildByName("view"):getChildByName("top"):getChildByName("icon"):getChildByName("touch"):addTouchEventListener(showTips)
        local top = self:getChildByName("view"):getChildByName("top")        
        top:getChildByName("name"):addTouchEventListener(onChangName)        
        --nounion
        top:getChildByName("nounion"):getChildByName("join"):addTouchEventListener(onJoin)
        --yesunion
        top:getChildByName("yesunion"):getChildByName("go_union"):addTouchEventListener(onLookUnion)
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3)
        --加粗
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setString("Boosts")
        self:onInitTopNavi()
        self._init = true
    end
    self.updateGold() 
    self:updates()
end

function powerLayer.update( sender )
    local actice = 0
    local show = false
    local plus_552 = 0
    for i=1,dd.myeffect:rowCount() do
        if dd.myeffect:getLong(i,"id") == 552 then
            plus_552 = dd.myeffect:getLong(i,"param")
            show = true
            break
        end
    end
    local time = 360
    if show == true then
        time =  time / (1 + plus_552 / 1000)
    end
    local point = (dd.getServerTime() -  dd.myinfo:getLong(1,"ActiveTime")) / time
    --cclog("==============="..point)
    actice =math.floor(point)+ dd.myinfo:getLong(1,"NowActive")
    if actice > dd.myinfo:getLong(1,"MaxActive") then
        if dd.myinfo:getLong(1,"NowActive") > dd.myinfo:getLong(1,"MaxActive") then
            actice = dd.myinfo:getLong(1,"NowActive") 
        else
            actice = dd.myinfo:getLong(1,"MaxActive") 
        end
    end
    if sender:getChildByName("view"):getChildByName("top"):getChildByName("icon"):getChildByName("tips"):isVisible() == true then
        local string = ""
        string = string..ff.langString("行动力").."："..tostring(actice).."/"..tostring(dd.myinfo:getLong(1,"MaxActive")).."\n"..ff.langString("行动力每6分钟恢复1点")
        sender:getChildByName("view"):getChildByName("top"):getChildByName("icon"):getChildByName("tips"):getChildByName("name"):setString(string)
    end
    local per = actice * 100 / dd.myinfo:getLong(1,"MaxActive") 
    if per > 100 then
        per = 100
    end
    sender:getChildByName("view"):getChildByName("top"):getChildByName("icon"):getChildByName("hp_bar"):setPercent(per)

end

function powerLayer:defaultShow(type)
    if type == nil then
        self:getChildByName("view"):setVisible(true)
        self:getChildByName("view"):setPositionY(0)
        self:getChildByName("boosts"):setVisible(false)
        self:getChildByName("boosts"):setPositionY(0)
        self:getChildByName("view"):getChildByName("view"):setVisible(false)
        self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(true)
        self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    elseif type == 1 then
        self:getChildByName("view"):setVisible(false)
        self:getChildByName("view"):setPositionY(0)
        self:getChildByName("boosts"):setVisible(true)
        self:getChildByName("boosts"):setPositionY(0)
        --self:getChildByName("view"):getChildByName("view"):setVisible(false)

        self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)
        self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(true)
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
    end
end

function powerLayer:onInitTopNavi()
    local function onSelect(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            if sender:getSelectedState() == true then
                self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)
                self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)     
                return
            end    
            self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)
            self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)     
            if sender:getName() == "navi1" then
                self:getChildByName("view"):setVisible(true)
                self:getChildByName("boosts"):setVisible(false)
                self:onShowPower()
                self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
                self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
            else
                self:getChildByName("view"):setVisible(false)
                self:getChildByName("boosts"):setVisible(true)
                self:getChildByName("boosts"):setVisible(true)
                self:showItems()
                self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
                self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
            end
        end
    end    
    self:getChildByName("topNavi"):getChildByName("navi1"):addTouchEventListener(onSelect)
    self:getChildByName("topNavi"):getChildByName("navi2"):addTouchEventListener(onSelect)
end

function powerLayer.updateList( sender )
    -- body
    local level = dd.myinfo:getLong(1,"level")
    for i,v in ipairs(dd.cfgBuffShow) do    
        local item = sender:getChildByName("boosts"):getChildByName("main"):getChildByTag(i)
        if i < 13 then
            if item ~= nil then
                item:getChildByName("info"):setString(ff.langString(dd.cfgBuffShow[i]['disc']))
                item:getChildByName("progress"):setVisible(false)
                for j=1,dd.myplus:rowCount() do
                    if dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[i]['effect']) then
                        local time = 0
                        local per = 0
                        local start = dd.myplus:getLong(j,"start")
                        local endtime   = dd.myplus:getLong(j,"end")
                        if (endtime - start )>0 then
                            per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                        end
                        time = dd.myplus:getLong(j,"end") - dd.getServerTime()

                        item:getChildByName("progress"):getChildByName("progress"):getChildByName("progress"):setPercent(per)
                        item:getChildByName("progress"):setVisible(true)
                        item:getChildByName("progress"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                        break
                    end
                  
                end
            elseif item == nil and i == 10 and level > 10 then
                local item = sender:getChildByName("boosts"):getChildByName("item"):clone()
                item:setVisible(true)
                item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getEffectIcon(i),0)
                item:getChildByName("name"):setString(ff.langString(dd.cfgBuffShow[i]['name']))
                item:getChildByName("go"):setTag(tonumber(dd.cfgBuffShow[i]['showtype']))
                item:getChildByName("go"):addTouchEventListener(sender.onOpenMulTools)
                item:getChildByName("goex"):setTag(tonumber(dd.cfgBuffShow[i]['showtype']))
                item:getChildByName("goex"):addTouchEventListener(sender.onOpenMulTools)
                item:getChildByName("info"):setString(ff.langString(dd.cfgBuffShow[i]['disc']))
                item:getChildByName("progress"):setVisible(false)
                item:setTag(i)
                for j=1,dd.myplus:rowCount() do
                    if dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[i]['effect']) then

                        local time = 0
                        local per = 0
                        local start = dd.myplus:getLong(j,"start")
                        local endtime   = dd.myplus:getLong(j,"end")
                        if (endtime - start )>0 then
                            per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                        end
                        time = dd.myplus:getLong(j,"end") - dd.getServerTime()
                        
                        item:getChildByName("progress"):getChildByName("progress"):getChildByName("progress"):setPercent(per)
                        item:getChildByName("progress"):setVisible(true)
                        item:getChildByName("progress"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                        break
                    end
                    
                end
                  sender:getChildByName("boosts"):getChildByName("main"):insertCustomItem(item,9)
                  sender:getChildByName("boosts"):getChildByName("main"):refreshView()
                  
            elseif item == nil and i == 11 and level > 14 then
                local item = sender:getChildByName("boosts"):getChildByName("item"):clone()
                item:setVisible(true)
                item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getEffectIcon(i),0)
                item:getChildByName("name"):setString(ff.langString(dd.cfgBuffShow[i]['name']))
                item:getChildByName("go"):setTag(tonumber(dd.cfgBuffShow[i]['showtype']))
                item:getChildByName("go"):addTouchEventListener(sender.onOpenMulTools)
                item:getChildByName("goex"):setTag(tonumber(dd.cfgBuffShow[i]['showtype']))
                item:getChildByName("goex"):addTouchEventListener(sender.onOpenMulTools)
                item:getChildByName("info"):setString(ff.langString(dd.cfgBuffShow[i]['disc']))
                item:getChildByName("progress"):setVisible(false)
                item:setTag(i)
                for j=1,dd.myplus:rowCount() do
                    if dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[i]['effect']) then

                        local time = 0
                        local per = 0
                        local start = dd.myplus:getLong(j,"start")
                        local endtime   = dd.myplus:getLong(j,"end")
                        if (endtime - start )>0 then
                            per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                        end
                        time = dd.myplus:getLong(j,"end") - dd.getServerTime()
                          
                        item:getChildByName("progress"):getChildByName("progress"):getChildByName("progress"):setPercent(per)
                        item:getChildByName("progress"):setVisible(true)
                        item:getChildByName("progress"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                        break
                    end
                    
                end
                sender:getChildByName("boosts"):getChildByName("main"):insertCustomItem(item,10)
                sender:getChildByName("boosts"):getChildByName("main"):refreshView()
            end
        else
            local show = false
            for j=1,dd.myplus:rowCount() do
                if dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[i]['effect']) then
                    show = true
                    break
                end  
            end
            if show == true then
                if item ~= nil then
                    item:getChildByName("info"):setString(ff.langString(dd.cfgBuffShow[i]['disc']))
                    item:getChildByName("progress"):setVisible(false)
                    for j=1,dd.myplus:rowCount() do
                        if dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[i]['effect']) then
                            local time = 0
                            local per = 0
                            local start = dd.myplus:getLong(j,"start")
                            local endtime   = dd.myplus:getLong(j,"end")
                            if (endtime - start )>0 then
                                per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                            end
                            time = dd.myplus:getLong(j,"end") - dd.getServerTime()

                            item:getChildByName("progress"):getChildByName("progress"):getChildByName("progress"):setPercent(per)
                            item:getChildByName("progress"):setVisible(true)
                            item:getChildByName("progress"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                            break
                        end
                    end
                else
                    local item = sender:getChildByName("boosts"):getChildByName("item"):clone()
                    item:setVisible(true)
                    item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getEffectIcon(i),0)
                    item:getChildByName("name"):setString(ff.langString(dd.cfgBuffShow[i]['name']))
                    item:getChildByName("go"):setTag(tonumber(dd.cfgBuffShow[i]['showtype']))
                    item:getChildByName("go"):addTouchEventListener(sender.onOpenMulTools)
                    item:getChildByName("goex"):setTag(tonumber(dd.cfgBuffShow[i]['showtype']))
                    item:getChildByName("goex"):addTouchEventListener(sender.onOpenMulTools)
                    item:getChildByName("info"):setString(ff.langString(dd.cfgBuffShow[i]['disc']))
                    item:getChildByName("progress"):setVisible(false)
                    item:setTag(i)
                    for j=1,dd.myplus:rowCount() do
                          if dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[i]['effect']) then

                            local time = 0
                            local per = 0
                            local start = dd.myplus:getLong(j,"start")
                            local endtime   = dd.myplus:getLong(j,"end")
                            if (endtime - start )>0 then
                                per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                            end
                            time = dd.myplus:getLong(j,"end") - dd.getServerTime()
                            
                            item:getChildByName("progress"):getChildByName("progress"):getChildByName("progress"):setPercent(per)
                            item:getChildByName("progress"):setVisible(true)
                            item:getChildByName("progress"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                            break
                          end
                        
                    end
                    sender:getChildByName("boosts"):getChildByName("main"):insertCustomItem(item,9)
                    sender:getChildByName("boosts"):getChildByName("main"):refreshView()
                end
            else
                if item ~= nil then
                    sender:getChildByName("boosts"):getChildByName("main"):removeChild(item)
                    sender:getChildByName("boosts"):getChildByName("main"):refreshView()
                end
            end
            
        end

    end
     
end

function powerLayer:showItems(  )
    -- body
    --self:getChildByName("boosts"):getChildByName("main"):removeAllChildren(true)
    local count = self:getChildByName("boosts"):getChildByName("main"):getChildrenCount()
    for i,v in ipairs(dd.cfgBuffShow) do    
    repeat
        local level = dd.myinfo:getLong(1,"level")
        if i == 10 and level <= 10 then
            break
        elseif i == 11 and level <=  15 then
            break
        end
        local show = false
        if i < 13 then
            show = true
        else
            for j=1,dd.myplus:rowCount() do
                if dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[i]['effect']) then
                    show = true
                    break
                end
            end
        end
        if show == true then
            local item = self:getChildByName("boosts"):getChildByName("main"):getChildByTag(i)
            if item == nil then
                item = self:getChildByName("boosts"):getChildByName("item"):clone()
                if count > 9 then
                    if i == 10 then
                        self:getChildByName("boosts"):getChildByName("main"):insertCustomItem(item,9)
                    elseif i == 11 then
                        self:getChildByName("boosts"):getChildByName("main"):insertCustomItem(item,10)
                    end
                else
                    self:getChildByName("boosts"):getChildByName("main"):pushBackCustomItem(item)
                end
            end
            item:setVisible(true)
            item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getEffectIcon(i),0)
            item:getChildByName("name"):setString(ff.langString(dd.cfgBuffShow[i]['name']))
            item:getChildByName("go"):setTag(tonumber(dd.cfgBuffShow[i]['showtype']))
            item:getChildByName("go"):addTouchEventListener(self.onOpenMulTools)
            item:getChildByName("goex"):setTag(tonumber(dd.cfgBuffShow[i]['showtype']))
            item:getChildByName("goex"):addTouchEventListener(self.onOpenMulTools)
            item:getChildByName("info"):setString(ff.langString(dd.cfgBuffShow[i]['disc']))
            item:getChildByName("progress"):setVisible(false)
            item:setTag(i)
            for j=1,dd.myplus:rowCount() do
                if dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[i]['effect']) then
                    local time = 0
                    local per = 0
                    local start = dd.myplus:getLong(j,"start")
                    local endtime   = dd.myplus:getLong(j,"end")
                    if (endtime - start )>0 then
                        per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                    end
                    time = dd.myplus:getLong(j,"end") - dd.getServerTime()
                            
                    item:getChildByName("progress"):getChildByName("progress"):getChildByName("progress"):setPercent(per)
                    item:getChildByName("progress"):setVisible(true)
                    item:getChildByName("progress"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                    break
                end
            end
        end
        --self:getChildByName("boosts"):getChildByName("main"):pushBackCustomItem(item)
    until true
    end
    self:getChildByName("boosts"):getChildByName("main"):refreshView()
    self:getChildByName("boosts"):getChildByName("main"):jumpToTop()
end

function powerLayer:updates()
    self:updateName()
    self:onInitUnion()
end

function powerLayer:updateName()
    self:getChildByName("view"):getChildByName("top"):getChildByName("icon"):getChildByName("level"):getChildByName("level"):setString("LV."..dd.myinfo:getLong(1,"level"))
    self:getChildByName("view"):getChildByName("top"):getChildByName("name"):getChildByName("name"):setString(dd.myinfo:getString(1,"name"))
    self:getChildByName("view"):getChildByName("top"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(dd.myinfo:getLong(1,"face")),0)
end

function powerLayer:onInitUnion()
    local top = self:getChildByName("view"):getChildByName("top")
    top:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(dd.myinfo:getLong(1,"face")),0)
    --未加入联盟
    if dd.myUnion:getLong(1,"unionid") <= 0 then
        top:getChildByName("nounion"):setVisible(true)
        top:getChildByName("yesunion"):setVisible(false)
    else
        top:getChildByName("nounion"):setVisible(false)
        top:getChildByName("yesunion"):setVisible(true)
        
        local yesunion = self:getChildByName("view"):getChildByName("top"):getChildByName("yesunion")
        yesunion:getChildByName("pics"):getChildByName("offic_alt"):setString(dd.myUnion:getLong(1,"unionofficial"))
        yesunion:getChildByName("pics"):getChildByName("logo"):loadTexture(dd.getUnionIcon(dd.myUnion:getLong(1,"totem")),0)
        yesunion:getChildByName("pics"):getChildByName("uback"):loadTexture(
                    dd.getPathFromUI("off_r"..dd.myUnion:getLong(1,"unionofficial")..".png",1) )
        yesunion:getChildByName("tips"):getChildByName("union_name"):setString("["..dd.myUnion:getString(1,"unionflag").."] "..dd.myUnion:getString(1,"unionname"))
        yesunion:getChildByName("tips"):getChildByName("power"):setString(ff.getFormatMoney(dd.myUnion:getSuperLong(1,"power")))
        yesunion:getChildByName("tips"):getChildByName("rank"):setString(dd.myUnion:getLong(1,"rank")) 
        yesunion:getChildByName("tips"):getChildByName("uin"):setString("UID:"..dd.uid)
    end
end

function powerLayer:onInitView()
    local view = self:getChildByName("view"):getChildByName("view")
    local hh = view:getContentSize().height
    local ihh = 0
    --view:jumpToTop()
    view:removeAllChildren(true)
    local num = 0
    local posy = 0
    local count = 0
    local winning = 0
    local rankshow = false
    local offset = 27

    if (self._userInfo._atklost + self._userInfo._atkwon + self._userInfo._defwon+self._userInfo._deflost) ~= 0 then
        winning = 100*(self._userInfo._atkwon+self._userInfo._defwon)/(self._userInfo._atklost + self._userInfo._atkwon+ self._userInfo._defwon+self._userInfo._deflost)
    end
    winning = winning-winning%0.1
    if dd.myUnion:getLong(1,"unionid") <= 0 then
        rankshow = false
    else
        --rankshow = true
    end
    local arr1 = {
                  {"总战斗力",self._userInfo._totalpower},
                  { "军队战斗力",self._userInfo._soldierpower},
                  { "英雄战斗力",self._userInfo._heropower},
                  { "城防战斗力",self._userInfo._citypower},
                  { "科技战斗力",self._userInfo._tecpower},
                  { "建筑战斗力",self._userInfo._buildpower}
                 }
    local arr2 = {
                  {"胜利次数",ff.getFormatMoney(self._userInfo._atkwon+self._userInfo._defwon)}, 
                  {"失败次数",ff.getFormatMoney(self._userInfo._atklost+self._userInfo._deflost)}, 
                  {"胜率",winning.."%"}, 
                  {"击杀士兵",ff.getFormatMoney(self._userInfo._soldierkill)}, 
                  {"损失士兵",ff.getFormatMoney(self._userInfo._soldierlost)} , 
                  {"摧毁城防",ff.getFormatMoney(self._userInfo._citykill)}, 
                  {"损失城防",ff.getFormatMoney(self._userInfo._citylost)}
                  }
    num = 2 + table.getn(arr1) + table.getn(arr2)
    ihh = 51*num
    if ihh < hh then
        ihh = hh
    end
    view:setInnerContainerSize(cc.size(720, ihh))    
    --head1
    local powerItem = self:getChildByName("view"):getChildByName("power_item"):clone()
    powerItem:setVisible(true)
    powerItem:setPositionY(ihh - offset - 51*count)
    powerItem:getChildByName("chu_rank"):setVisible(rankshow)
    view:addChild(powerItem)
    count = count + 1
    --item1
    for i, it in pairs(arr1) do
        local item = self:getChildByName("view"):getChildByName("item_mode"):clone()
        item:setVisible(true)
        item:setPositionY(ihh - offset - 51*count)
        
        item:getChildByName("name"):setString(ff.langString(it[1]))
        item:getChildByName("value"):setString(ff.getFormatMoney(it[2]))
        item:getChildByName("rank"):setVisible(rankshow)
        if i%2 == 0 then
            item:loadTexture(dd.getPathFromUI("public/v2/title3.png",1))
        end
        view:addChild(item)
        count = count + 1
    end
    
    --head
    local powerItem = self:getChildByName("view"):getChildByName("sum_item"):clone()
    powerItem:setVisible(true)
    powerItem:setPositionY(ihh - offset - 51*count)
    powerItem:getChildByName("chu_rank"):setVisible(rankshow)
    view:addChild(powerItem)
    count = count + 1
    --item2
    for i, it in pairs(arr2) do
        local item = self:getChildByName("view"):getChildByName("item_mode"):clone()
        item:setVisible(true)
        item:setPositionY(ihh - offset - 51*count)

        item:getChildByName("name"):setString(ff.langString(it[1]))
        item:getChildByName("value"):setString(it[2])
        item:getChildByName("rank"):setVisible(rankshow)
        if i%2 == 0 then
            item:loadTexture(dd.getPathFromUI("public/v2/title3.png",1))
        end
        view:addChild(item)
        count = count + 1
    end
end

function powerLayer:getUserInfo(uid, name)
    local message = ff.net:createMessage()
    message:addCmd(0x00f)
    message:addLong(dd.uid) 
    message:addLong(uid)
    message:addString(name, 15)  
    ff.net:rpc(message,false)
end

function powerLayer:getMyUnionInfo()
    local message = ff.net:createMessage()
    message:addCmd(0x011)
    message:addLong(dd.uid) 
    ff.net:rpc(message,false)
end

function powerLayer:onNetgetUserInfo(params)
    if table.getn(params) == 1 then
        local code = params[1]
        if code ~= 0 then
            dd.mainUI:onShowCodeTips(code)
            return
        end
        return
    end
    self._userInfo = params[2] 
    
    self:onInitView()
    self:getChildByName("view"):getChildByName("view"):setVisible(true)
end

function powerLayer:onNetgetmyUnionInfo(params)
    self:onInitUnion()
end

function powerLayer:onChangeName(params)
    local code = params[1]
    if code == 0 then
        local widget = pop.getDialog("powerInfo")
        widget:updateName()
    end
end

function powerLayer:closeMasking()
    self:getChildByName("masking"):setVisible(false)
end

function powerLayer.updateGold()
    local widget = pop.getDialog("powerInfo")
    widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
    widget:getChildByName("topArea"):requestDoLayout()

    local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
    w = 720 - (w + 94 + 75 + 104)
    widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
    widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
end
function powerLayer:onUpdateView()
    self.onEnd(self)
    self:onInit()
    self.onBefore(self)
    self.onStart(self)
end
--统治力部分
function powerLayer:initLog()    
    
end

function powerLayer:onShowPower() 
    pop.showPopEffect(99,self:getChildByName("view"),true)
end

function powerLayer:onShowLog()
    self:getChildByName("view"):setVisible(false)
end
function powerLayer:setBtnLight(node,light)
    if light == true then
        node:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        node:setTouchEnabled(true)
        --node:getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
    else 
        local effect = ff.Effect:effectGrey()    
        node:getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        node:setTouchEnabled(false)
        --node:getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
    end
end
--接口

function powerLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
            
        local widget = pop.getDialog("powerInfo")
        if widget ~= nil then
            --如果弹出了联盟信息面板，则先关闭它
            if pop.getDialog("unionInfo") and widget:getChildByTag(10008) ~= nil then
                if pop.isShowing("unionInfo") then
                    pop.onClosePopDialog("unionInfo")
                    return
                end            
            end   
            --如果弹出了修改名字面板
            if pop.isShowing("changeName") == true then
                pop.onClosePopDialog("changeName")   
                return           
            end    
            pop.onClosePopDialog("powerInfo")
        end
    end
end

function powerLayer:onClose()
    local widget = pop.getDialog("powerInfo")
    if widget ~= nil then
        --如果弹出了联盟信息面板，则先关闭它
        if pop.getDialog("unionInfo") and widget:getChildByTag(10008) ~= nil then
            if pop.isShowing("unionInfo") then
                pop.onClosePopDialog("unionInfo")
            end            
        end   
        --如果弹出了修改名字面板
        if pop.isShowing("changeName") == true then
            pop.onClosePopDialog("changeName")   
            return           
        end  
        pop.onClosePopDialog("powerInfo")
    end
end

function powerLayer.onStart(sender)
    ff.net:registerEvent(2,dd.Tjf_City_UserInfo,function (message)sender:onNetgetUserInfo(message)end)
    ff.net:registerEvent(2,dd.Tjf_union_GetMyAllyInfo,function (message)sender:onNetgetmyUnionInfo(message)end)
    ff.net:registerEvent(3,dd.Tjf_User_ChangeName,function (message)sender:onChangeName(message)end)
    ff.net:bindProperty(2501,"gold",sender.updateGold)
    sender:getUserInfo(dd.uid, dd.myinfo:getString(1,"name"))
    --未加入联盟
    if dd.myUnion:getLong(1,"unionid") <= 0 then
    else
        --sender:getMyUnionInfo()
    end
    sender:showItems()
    schedule(sender, sender.updateList,1)
end
function powerLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    schedule(sender, sender.update,1)
    sender.update(sender)
    return true
end

function powerLayer.onOpenMulTools( sender,eventType )
    if eventType == ccui.TouchEventType.ended then   
        local tag = sender:getTag()
        if tag ~= 0 then
            dd.currentLayer._widget:onShowMulTools(tag,0,nil,true)
        else
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("暂未开放"))
        end
    end
end
function powerLayer.onEnd(sender)
    dd.delBackEvent()
    ff.net:removeEvent(2,dd.Tjf_City_UserInfo)
    ff.net:removeEvent(2,dd.Tjf_union_GetMyAllyInfo)
    ff.net:removeEvent(3,dd.Tjf_User_ChangeName)
    ff.net:unbindProperty("gold",2501)
    sender:closeMasking()
    sender:stopAllActions()
    if ff.platform ~= 1 then
        sender:getChildByName("view"):getChildByName("top"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("view"):getChildByName("top"):getChildByName("yesunion"):getChildByName("pics"):getChildByName("logo"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("view"):getChildByName("top"):getChildByName("yesunion"):getChildByName("pics"):getChildByName("uback"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
end

function powerLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("powerInfo")
    if widget ~= nil then
        --如果弹出了联盟信息面板，则先关闭它
        if pop.getDialog("unionInfo") and widget:getChildByTag(10008) ~= nil then
            if pop.isShowing("unionInfo") then
                pop.onClosePopDialog("unionInfo")
                return
            end            
        end   
        --如果弹出了修改名字面板
        if pop.isShowing("changeName") then
            pop.onClosePopDialog("changeName")   
            return           
        end
        pop.onClosePopDialog("powerInfo")
    end
end

function onShowPowerLayer(widget, type)
    local layer = powerLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onAutoSize()
    layer:onInit()
    layer:defaultShow(type)
    return layer
end