--[[
	好友信息面板
	self.isFriend 是否好友
	self.isBlack 是否黑名单
    self.unionIsOpen 对方的联盟信息面板是否打开
]]
local uinfolayer = class("uinfolayer")
uinfolayer._name = "power2"
uinfolayer._init = false
uinfolayer._parent = nil

function uinfolayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, uinfolayer)
    return target
end

function uinfolayer:init(uid)
    self.uid=uid

    if self._init == false then
        self:setContentSize(cc.size(720,ff.height))
        self:getChildByName("bg"):setContentSize(cc.size(720,ff.height - 105))
        self:getChildByName('bg'):setPositionY(0)
        self:getChildByName("topArea"):setPositionY(ff.height - 105)
        
        self:getChildByName("mainArea"):setContentSize(cc.size(720,ff.height - 105-5))
        self:getChildByName("mainArea"):setPositionY(0)

        self:getChildByName("mainArea"):getChildByName("listcontain"):setContentSize(cc.size(720,ff.height - 110-360))
        
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onClose)  
        
        self:getChildByName("mainArea"):getChildByName("btnArea"):getChildByName("mailbtn"):addTouchEventListener(self.onMail)
        self:getChildByName("mainArea"):getChildByName("btnArea"):getChildByName("addbtn"):addTouchEventListener(self.btn1fun)
        self:getChildByName("mainArea"):getChildByName("btnArea"):getChildByName("shieldbtn"):addTouchEventListener(self.btn2fun)  
        self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("joinbtn"):addTouchEventListener(self.join)
        self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("union_yes"):getChildByName("infobtn"):addTouchEventListener(self.showUnion)
        
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
        
        --加粗
        self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("joinbtn"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
        self:getChildByName("mainArea"):getChildByName("btnArea"):getChildByName("addbtn"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
        self:getChildByName("mainArea"):getChildByName("btnArea"):getChildByName("shieldbtn"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
        
        self._init = true
    end 
    self:addUinfoListener()
    self.updateGold()
end
function uinfolayer.updateGold()
    local widget = pop.getDialog("power2")
    widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
    widget:getChildByName("topArea"):requestDoLayout()

    
    local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
    w = 720 - (w + 94 + 75 + 104)
    widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
    widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
end
function uinfolayer.onClose(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
         pop.onClosePopDialog("power2")
    end
end

--按钮1
function uinfolayer.btn1fun(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local uinfo=pop.getDialog("power2")

        --不是好友，加为好友
        if (not ChatControl.checkIsFriend(uinfo.uid)) then
            friendSetting(1,{uinfo.uid})
        else
             --打开私聊面板
            uinfo.onClose(sender,eventType)
            pop.CloseAll()

            local params = {}
            params['uid'] = uinfo.uid
            params['name']= uinfo.name
            pop.onShowPopDialog("chat",1,params)

        end
    end
end
--按钮2
function uinfolayer.btn2fun(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        
        local uinfo=pop.getDialog("power2")
        if(not ChatControl.checkIsInBlack(uinfo.uid)) then
            friendSetting(6,{uinfo.uid})--加入黑名单
        else
            friendSetting(7,{uinfo.uid})--删除黑名单
        end
    end
end
--发送邮件
function uinfolayer.onMail(sender,eventType)
    if eventType == ccui.TouchEventType.ended then    
        local uinfo=pop.getDialog("power2")       
        pop.onShowPopDialog("mailWrite",false,uinfo.uid,uinfo.name,'','ch',{},0,0)
        
    end
end

--邀请
function uinfolayer.join(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local uinfo=pop.getDialog("power2")
        --print("uinfo.hasUnion==",uinfo.hasUnion)
        if(uinfo.hasUnion) then
            --邀请对方加入自己联盟
            local unionofficial=dd.myUnion:getLong(1,"unionofficial")
            if(unionofficial>=3) then
                cmd.iviteToGroup(uinfo.name)
            else
                --dd.showTips("您没有邀请的权限!",30,cc.c3b(255,0,0))
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("您没有邀请的权限"))
            end
        else
            --申请加入对方联盟
            cmd.joinToGroup(uinfo.unionID)
        end
    end
end

--查看对方联盟
function uinfolayer.showUnion(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local uinfo=pop.getDialog("power2")
        pop.onShowPopDialog("unionInfo",uinfo,uinfo.unionShort)
        uinfo.unionIsOpen=true
    end
end 

--查询好友信息返回
function uinfolayer:getUinfoDataBack(data)
    local code = data[1]
	if code == 0 then
        local message=data[2]
		local uid  = message._uid
        local face = message._pic
        self.unionShort = message._unionflag
        self.name = message._name
        self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("face"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(face),0)
        self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("face"):getChildByName("level"):getChildByName("level"):setString("LV."..message._level)
        
        if message._unionid == 0 then
            self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("union_yes"):setVisible(false)
            self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("union_no"):setVisible(true)
            local unionno = self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("union_no")
            unionno:getChildByName("name"):setString(message._name)
            unionno:requestDoLayout()
            if dd.myUnion:getLong(1,"unionid") <= 0 then
                self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("joinbtn"):setVisible(false)
            else
                self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("joinbtn"):setVisible(true)
                self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("joinbtn"):getChildByName("chu_label"):setString(ff.langString("邀请"))
            end
        else
            self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("union_yes"):setVisible(true)
            self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("union_no"):setVisible(false)
            local unionyes = self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("union_yes")
            unionyes:getChildByName("words"):getChildByName("name"):setString(message._name)
            unionyes:getChildByName("words"):getChildByName("unionname"):setString("["..message._unionflag.."] "..message._unionname)
            unionyes:getChildByName("words"):getChildByName("rank"):setString(ff.getFormatMoney(message._relicpower))
            unionyes:getChildByName("words"):getChildByName("power"):setString(ff.getFormatMoney(message._totalpower))
            unionyes:getChildByName("words"):getChildByName("uin"):setString("UID:"..uid)
            unionyes:getChildByName("pics"):getChildByName("icon"):loadTexture(dd.getUnionIcon(message._totem),0)
            unionyes:getChildByName("pics"):getChildByName("uback"):loadTexture(dd.getPathFromUI("power_r"..message._uionoff..".png",1))
            unionyes:getChildByName("pics"):getChildByName("office"):setString(message._uionoff)
            if dd.myUnion:getLong(1,"unionid") <= 0 then
                self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("joinbtn"):setVisible(true)
                self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("joinbtn"):getChildByName("chu_label"):setString(ff.langString("加入"))
            else
                self:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("joinbtn"):setVisible(false)
            end
        end
        
        local _unionID=message._unionid
        --print("_unionID====",_unionID)
        self.unionID=_unionID  
        local hasUnion=false
        if(dd.myUnion) then
            local unionid=dd.myUnion:getLong(1,"unionid")
            if(unionid~=0) then
                hasUnion=true
            end
        end
        self.hasUnion=hasUnion          
        
        local isFriend = ChatControl.checkIsFriend(uid)
        local addfriendbtn=self:getChildByName("mainArea"):getChildByName("btnArea"):getChildByName("addbtn")
        if(isFriend) then
            self:getChildByName("mainArea"):getChildByName("btnArea"):getChildByName("addbtn"):getChildByName("chu_label"):setString(ff.langString("发起聊天"))
        else
            self:getChildByName("mainArea"):getChildByName("btnArea"):getChildByName("addbtn"):getChildByName("chu_label"):setString(ff.langString("加为好友"))
        end
        self:setShieldText()
        
        local listcontain=self:getChildByName("mainArea"):getChildByName("listcontain")
        listcontain:getChildByName("td05"):getChildByName("value"):setString(ff.getFormatMoney(message._totalpower))


        listcontain:getChildByName("td02"):getChildByName("value"):setString("?")
        listcontain:getChildByName("td03"):getChildByName("value"):setString("?")
        listcontain:getChildByName("td04"):getChildByName("value"):setString("?")
        listcontain:getChildByName("td07"):getChildByName("value"):setString("?")



        --listcontain:getChildByName("td08"):getChildByName("value"):setString(message._citypower)
        --listcontain:getChildByName("td09"):getChildByName("value"):setString(message._relicpower)--已变成所属联盟排名

        --统计
        listcontain:getChildByName("td10"):getChildByName("value"):setString(ff.getFormatMoney(message._atkwon + message._defwon))
        listcontain:getChildByName("td11"):getChildByName("value"):setString(ff.getFormatMoney(message._atklost + message._deflost))

        local successPercent=0
        if((message._atkwon+message._atklost)>0) then
            successPercent=(message._atkwon+message._defwon)/(message._atkwon+message._atklost+message._defwon+message._deflost)
        else
            successPercent=0
        end
        successPercent = successPercent-successPercent%0.001
        successPercent=successPercent*100
        listcontain:getChildByName("td12"):getChildByName("value"):setString(successPercent.."%")--胜率
        listcontain:getChildByName("td13"):getChildByName("value"):setString(ff.getFormatMoney(message._soldierkill))
        listcontain:getChildByName("td14"):getChildByName("value"):setString(ff.getFormatMoney(message._soldierlost))
        listcontain:getChildByName("td15"):getChildByName("value"):setString(ff.getFormatMoney(message._citykill))
        listcontain:getChildByName("td16"):getChildByName("value"):setString(ff.getFormatMoney(message._citylost))
        
	end
end

function uinfolayer:setShieldText()
    local isBlack=ChatControl.checkIsInBlack(self.uid)

    --print("isBlack",isBlack,dd.blacklist[self.uid])

    local shieldbtn=self:getChildByName("mainArea"):getChildByName("btnArea"):getChildByName("shieldbtn")
    if(isBlack) then
        shieldbtn:getChildByName("chu_label"):setString(ff.langString("取消屏蔽"))
    else
        shieldbtn:getChildByName("chu_label"):setString(ff.langString("屏蔽"))
    end
end

function uinfolayer:addUinfoListener()
    --获取个人信息
	--ff.net:registerEvent(1,dd.Tjf_GetUinfo,function (message) self:getUinfoDataBack(message) end)
    ff.net:registerEvent(5,dd.Tjf_City_UserInfo,function (message) self:getUinfoDataBack(message) end)

    --好友操作 添加删除黑名单监听
    ff.net:registerEvent(5,dd.Tjf_ChatFriendSetting,function (message) self:friendSettingBack(message) end)

    --申请加入返回
    ff.net:registerEvent(5,dd.Tjf_NewAllyApply,function (message) self:joinGroupBack(message) end)
    ff.net:registerEvent(10,dd.Tjf_Chat_FriendListBack,function (message) self:friendListBack(message) end)
    
    ff.net:bindProperty(2508,"gold",self.updateGold)
end
function uinfolayer:removeUinfoListener()
--    ff.net:removeEvent(1,dd.Tjf_GetUserOverview)
    ff.net:removeEvent(5,dd.Tjf_ChatFriendSetting)
    ff.net:removeEvent(5,dd.Tjf_City_UserInfo)
    ff.net:removeEvent(5,dd.Tjf_NewAllyApply)
    ff.net:removeEvent(10,dd.Tjf_Chat_FriendListBack)
    ff.net:unbindProperty("gold",2508)
end

--好友设置返回--
function uinfolayer:friendSettingBack(data)
    cclog("friendSettingBack........")
    if(data) then
        if data[1] == 0 then
            local type=data[2]
            if(type==6 or type==7) then--添加黑名单
                local uid=data[3][1]
                print(self.uid,uid)
                if(self.uid==uid) then
                    self:setShieldText()
                end
                if type == 6 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("屏蔽成功"),true)
                else
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("取消屏蔽成功"),true)
                end
            elseif type == 1 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功发送好友邀请"),true)
            end
        else
            dd.mainUI:onShowCodeTips(data[1])
        end    
    end
end


function uinfolayer:joinGroupBack(data)
    if data[1] == 0 then
        if data[2]['join_suc'] == 1 then
            pop.onShowPopDialog("union",1)
            --关闭自己和聊天界面 打开联盟界面
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("申请成功，您已加入该联盟"),true)
        else
            --dd.showTips("申请加入成功!",30,cc.c3b(0,255,0))
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("申请已发出，请等待审核"),true)
        end
    end
end

function uinfolayer:friendListBack(message)
    local isFriend = ChatControl.checkIsFriend(self.uid)
    local addfriendbtn=self:getChildByName("mainArea"):getChildByName("btnArea"):getChildByName("addbtn")
    if(isFriend) then
        self:getChildByName("mainArea"):getChildByName("btnArea"):getChildByName("addbtn"):getChildByName("chu_label"):setString(ff.langString("发起聊天"))
    else
        self:getChildByName("mainArea"):getChildByName("btnArea"):getChildByName("addbtn"):getChildByName("chu_label"):setString(ff.langString("加为好友"))
    end
end

function uinfolayer.onReturn(sender,eventType)
    pop.onClosePopDialog("power2")
end

function uinfolayer.onStart(sender)
    sender:getChildByName("bg"):setPositionY(0)

end

function uinfolayer.onEnd(sender)
    dd.delBackEvent()
    if ff.platform ~= 1 then
        sender:getChildByName("mainArea"):getChildByName("maininfo"):getChildByName("face"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
    sender:quit()
end


function uinfolayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))

    local message = ff.net:createMessage()
    message:addCmd(0x0000000f)
    message:addLong(dd.uid)
    message:addLong(sender.uid)
    message:addString("",15)
    ff.net:rpc(message)
    return true
end

function uinfolayer:quit()
    cclog("quit uinfo......")
    self:removeUinfoListener()
end


function uinfolayer:onAutoSize()
    local hh = ff.height
    local ww = ff.width
    self:setContentSize(cc.size(ww,hh))


    local headheight=105

    local mainArea=self:getChildByName("mainArea")
    local size=mainArea:getContentSize()
   
    
    local mainAreaHeight=hh-headheight
    size.height=mainAreaHeight

    mainArea:setContentSize(size)
    mainArea:setPositionY(0)


    --local topNavi=self:getChildByName("topNavi")
    --local y=topNavi:getPositionY()


    local maininfo=mainArea:getChildByName("maininfo")
    maininfo:setPositionY(hh-headheight-maininfo:getContentSize().height)


    local btnArea=mainArea:getChildByName("btnArea")
    btnArea:setPositionY(maininfo:getPositionY()-btnArea:getContentSize().height)

    
    local listcontain=mainArea:getChildByName("listcontain")
    size=listcontain:getContentSize()
    local listHeight=hh-headheight-maininfo:getContentSize().height-btnArea:getContentSize().height
    size.height=listHeight
    listcontain:setContentSize(size)

    listcontain:setPositionY(btnArea:getPositionY()-listHeight)

end

function onShowNoUinfo(widget,parent,uid)
	local layer = uinfolayer.extend(widget)
	layer._parent = parent
    dd.regeditBackEvent(layer.onReturn)
    --layer:onAutoSize()
    layer:init(uid)
    return layer
end

