local sampleLayer   = class("sampleLayer")
sampleLayer._name = "sample"
sampleLayer._init = false

function sampleLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, sampleLayer)
    return target
end

function sampleLayer.onTest(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        sender:runAction(cc.Sequence:create(cc.EaseExponentialIn:create(cc.ScaleTo:create(0.2,1,1.2)),cc.EaseExponentialOut:create(cc.ScaleTo:create(0.1, 1))))
    end
end

function sampleLayer.onClose(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
    	pop.onClosePopDialog('sample6')
        pop.onClosePopDialog('sample7')
        pop.onClosePopDialog('sample8')
        pop.onClosePopDialog('sample9')
    end
end

function sampleLayer:onInit()
    local function  close()
    end
	if self._init == false then
        local close = self:getChildByName("close")
        close:addTouchEventListener(onClose)

        local btn = self:getChildByName("btn")
        btn:addTouchEventListener(self.onTest)

        self._init = true
	end
end

--界面被关闭
function sampleLayer.onEnd(sender)

end
--界面出现后调用
function sampleLayer.onStart(sender)
end
--界面即将出现前调用
function sampleLayer.onBefore(sender)

    return true
end

--手机回退健处理
function sampleLayer.onCallBack()
    local sender = pop.getDialog("sample")
    if sender ~= nil then
    end
end

--入口
function onShowSample(widget)
    local layer = sampleLayer.extend(widget)
    dd.regeditBackEvent(layer.onCallBack)
	layer:onInit()
	return layer
end