local gameSetLayer   = class("gameSetLayer")
gameSetLayer._name = "gameSet"
gameSetLayer._init = false
gameSetLayer.state = 1
gameSetLayer.input_mail = ''
gameSetLayer.selLan = 4
gameSetLayer.selTranLan = 4

gameSetLayer.feed_state = 1
gameSetLayer.feed_type = 1
gameSetLayer.feed_str = {"程序错误","翻译错误","声音","充值","其他"} 
gameSetLayer.feed_mail = ''
gameSetLayer.feed_info = ''

gameSetLayer.mailBox = nil
gameSetLayer.repBox = nil
gameSetLayer.infoBox = nil
gameSetLayer.lanPicker = nil
gameSetLayer.lanState = 1--1=语言2=翻译语言
gameSetLayer._name_input = nil
gameSetLayer.startState = 1
gameSetLayer._box = nil

gameSetLayer.selectLans = {}

platform = {} or platform
platform.google_callbplatformack_state = false
platform.google_callback_name = {}
gameSetLayer._view   = nil
gameSetLayer._servers   = {}
gameSetLayer._serverCnt = 0



function gameSetLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, gameSetLayer)
    return target
end
function gameSetLayer:onInit()
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,hh - 214))  
        self:getChildByName("back"):setContentSize(cc.size(720,hh - 214))
        self:getChildByName("mainArea"):setContentSize(cc.size(720,hh - 214 - 120))
        self:getChildByName("mainArea"):setPositionY(0)
        self:getChildByName("topArea"):setPositionY(ff.height -214 - 105)
        self:getChildByName("bind_mail"):setPositionY((ff.height - 214 - 105 - 615)/2)
        self:getChildByName("input_name"):setPositionY((ff.height - 214 - 105 - 500)/2)

        self:getChildByName("input_name"):getChildByName("close"):addTouchEventListener(self.closeInputName)
        self:getChildByName("input_name"):getChildByName("sureBtn"):addTouchEventListener(self.sureInputName)
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("pro_bug"):setTag(1)
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("trans_bug"):setTag(2)
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("sound"):setTag(3)
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("money"):setTag(4)
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("other"):setTag(5)
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("pro_bug"):getChildByName("chu_Label_120"):setString(ff.langString("程序错误"))
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("trans_bug"):getChildByName("chu_Label_120"):setString(ff.langString("充值问题"))
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("sound"):getChildByName("chu_Label_120"):setString(ff.langString("活动问题"))
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("money"):getChildByName("chu_Label_120"):setString(ff.langString("输入法问题"))
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("other"):getChildByName("chu_Label_120"):setString(ff.langString("其他"))
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("pro_bug"):addTouchEventListener(self.helpShift)
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("trans_bug"):addTouchEventListener(self.helpShift)
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("sound"):addTouchEventListener(self.helpShift)
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("money"):addTouchEventListener(self.helpShift)
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("other"):addTouchEventListener(self.helpShift)

        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("pro_bug"):setTag(1)
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("trans_bug"):setTag(2)
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("sound"):setTag(3)
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("money"):setTag(4)
        self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("other"):setTag(5)

        
        self:getChildByName("mainArea"):getChildByName("feedback"):getChildByName("back_btn"):addTouchEventListener(self.showFeedback)   
        self:getChildByName("mainArea"):getChildByName("privates"):getChildByName("back_btn"):addTouchEventListener(self.showPrivate)   
        self:getChildByName("mainArea"):getChildByName("privates_0"):getChildByName("back_btn"):addTouchEventListener(self.showPrivate2)   
        --self:getChildByName("mainArea"):getChildByName("privates"):getChildByName("chu_label"):setString(ff.langString("服务条款")) 

        self:getChildByName("connect"):getChildByName("mainArea"):getChildByName("uid"):getVirtualRenderer():enableBold(true)
        self:getChildByName("connect"):getChildByName("mainArea"):getChildByName("uid"):setString("UID:"..dd.uid)
        
        self:getChildByName("server"):setContentSize(cc.size(720,hh - 214))
        self:getChildByName("feedback1"):setContentSize(cc.size(720,hh - 214))
        self:getChildByName("server"):getChildByName("mainArea"):setContentSize(cc.size(720,hh - 214 - 120))
        self:getChildByName("feedback1"):getChildByName("Image_113"):setPositionY(hh - 214 - 120 - 7)
        self:getChildByName("feedback1"):getChildByName("mainArea"):setPositionY(0)
        self:getChildByName("feedback1"):getChildByName("mainArea"):setContentSize(cc.size(720,hh - 214 - 120 - 14))
        self:getChildByName("server"):getChildByName("mainArea"):getChildByName("server_list"):setContentSize(cc.size(720,hh - 214 - 120 - 245))
        self:getChildByName("server"):getChildByName("mainArea"):getChildByName("server_list"):setInnerContainerSize(cc.size(720,hh - 214 - 120 - 245))
        local tableView = cc.TableView:create(self:getChildByName("server"):getChildByName("mainArea"):getChildByName("server_list"):getContentSize())
        tableView:setTag(1)
        tableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
        tableView:setDelegate()
        tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
        tableView:setPosition(cc.p(0, 0))
        self:getChildByName("server"):getChildByName("mainArea"):addChild(tableView)

        --tableView:registerScriptHandler(self.scrollViewDidScroll,cc.SCROLLVIEW_SCRIPT_SCROLL)
        tableView:registerScriptHandler(self.tableCellTouched,cc.TABLECELL_TOUCHED)
        tableView:registerScriptHandler(self.cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
        tableView:registerScriptHandler(self.tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
        tableView:registerScriptHandler(self.numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
        self._view = tableView
        self:getChildByName("connect"):setContentSize(cc.size(720,hh - 214))
        self:getChildByName("connect"):getChildByName("mainArea"):setContentSize(cc.size(720,hh - 214 - 120))
        self:getChildByName("connect"):getChildByName("mainArea"):setInnerContainerSize(cc.size(720,665))
        self:getChildByName("connect"):getChildByName("google_conn"):setContentSize(cc.size(720,hh - 214 - 120))
        self:getChildByName("connect"):getChildByName("google_conn"):setInnerContainerSize(cc.size(720,665))
        self:getChildByName("setLan"):setContentSize(cc.size(720,hh - 214))  
        self:getChildByName("setLan"):getChildByName("mainArea"):setContentSize(cc.size(720,hh - 214 - 110))   
        self:getChildByName("sound"):setContentSize(cc.size(720,hh - 214))
        self:getChildByName("sound"):getChildByName("mainArea"):setContentSize(cc.size(720,hh - 214 - 110))
        self:getChildByName("warning"):setContentSize(cc.size(720,hh - 214))
        self:getChildByName("warning"):getChildByName("mainArea"):setContentSize(cc.size(720,hh - 214 - 110))
        self:getChildByName("tuisong"):setContentSize(cc.size(720,hh - 214))
        self:getChildByName("tuisong"):getChildByName("mainArea"):setContentSize(cc.size(720,hh - 214 - 110))   
        self:getChildByName("tuisong"):getChildByName("mainArea"):setInnerContainerSize(cc.size(720,800))
        self:getChildByName("mask"):setContentSize(cc.size(720,hh - 214)) 
        --self:getChildByName("mainArea"):getChildByName("award"):setVisible(true)  
        self:getChildByName("pop2"):getChildByName("award"):getChildByName("save_btn"):addTouchEventListener(self.onSend)
        self:getChildByName("pop2"):getChildByName("award"):getChildByName("close"):addTouchEventListener(self.onClosePop)
        self:getChildByName("pop2"):getChildByName("award"):getChildByName("chu_name_text"):setString(ff.langString("请输入礼物码"))
        self:getChildByName("pop2"):getChildByName("award"):getChildByName("Label_266"):setString(ff.langString("我们会不定期的举办线下活动，活动获得者可以获得可以获得礼物码，用来兑换奖励"))
        local input      = self:getChildByName("pop2"):getChildByName("award"):getChildByName("pos_op"):getChildByName("Label_31_0")
        local editBoxSize= input:getContentSize()
        local function editBoxTextEventHandle(strEventName,pSender)
            if strEventName == "began" then
                pSender:setText("")
            elseif strEventName == "ended" or strEventName == "return" then
            elseif strEventName == "changed" then
            end
        end

        self._box    = dd.addEditBox(input,editBoxSize,"images/editbox.png",110101,cc.p(0,0),cc.p(5,4),cc.c3b(255,255,255),20,6,4,1,120,true,true,true)
        self._box:registerScriptEditBoxHandler(editBoxTextEventHandle)
        self:getChildByName("mainArea"):getChildByName("award"):getChildByName("back_btn"):addTouchEventListener(self.showAward)   
        self._bind = false
    end
    if self._box ~= nil then
        self._box:setText(ff.langString("请输入礼物码"))
    end
    self.updateGold()
end
function gameSetLayer.updateGold(name,row,old,value)
    local sender = pop.getDialog("gameSet")
    if sender ~= nil then
        sender:getChildByName("topArea"):getChildByName("gold_text"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("topArea"):getChildByName("gold_text"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("topArea"):requestDoLayout()
    end
end
function gameSetLayer:addLanPicker()

end
function gameSetLayer:initInfo()
    self:getChildByName("warning"):getChildByName("mainArea"):getChildByName("help"):getChildByName("setBtn"):setSelectedState(ff.set_warn_help==1)
    self:getChildByName("warning"):getChildByName("mainArea"):getChildByName("battle"):getChildByName("setBtn"):setSelectedState(ff.set_warn_battle==1)
    self:getChildByName("sound"):getChildByName("mainArea"):getChildByName("music"):getChildByName("setBtn"):setSelectedState(ff.set_music == true)
    self:getChildByName("sound"):getChildByName("mainArea"):getChildByName("sound"):getChildByName("setBtn"):setSelectedState(ff.set_sound==1)
    self:getChildByName("sound"):getChildByName("mainArea"):getChildByName("3d"):getChildByName("setBtn"):setSelectedState(ff.set_3d==1)
    self:getChildByName("tuisong"):getChildByName("mainArea"):getChildByName("battle"):getChildByName("setBtn"):setSelectedState(ff.set_battle==1)
    self:getChildByName("tuisong"):getChildByName("mainArea"):getChildByName("schdule"):getChildByName("setBtn"):setSelectedState(ff.set_schedule==1)
    self:getChildByName("tuisong"):getChildByName("mainArea"):getChildByName("alliance"):getChildByName("setBtn"):setSelectedState(ff.set_alliance==1)
    self:getChildByName("tuisong"):getChildByName("mainArea"):getChildByName("system"):getChildByName("setBtn"):setSelectedState(ff.set_system==1)
    self.selLan = ff.set_lan
    self.selTranLan = ff.set_trans_lan
    self.feed_mail = ff.set_bind_mail
    self:getChildByName("setLan"):getChildByName("mainArea"):getChildByName("lan"):getChildByName("chu_lan_text"):setString(dd.languageArr[ff.lang+1])
    self:getChildByName("setLan"):getChildByName("mainArea"):getChildByName("tran_lan"):getChildByName("chu_lan_text"):setString(dd.languageArr[ff.set_trans_lan + 1])

end

function gameSetLayer.onSend(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("gameSet")  
        if string.len(widget._box:getText()) > 0 then
            local message = ff.net:createMessage()
            message:addCmd(0x00000123)
            message:addLong(dd.uid)
            message:addString(widget._box:getText(),8)
            message:addLong(0)
            message:addLong(0)
            ff.net:rpc(message,false)
            widget._box:setText("")
        end
    end
end

function gameSetLayer.onClosePop( sender,eventType )
    if eventType==ccui.TouchEventType.ended then  
        local widget = pop.getDialog("gameSet")
        if widget ~= nil then
            widget:getChildByName("pop2"):setVisible(false)
        end
    end
end

function gameSetLayer.clearGame(sender,eventType)
    local function callback()
        if hif.clearAccount() == false then
            dd.mainUI:onShowTips("\t"..ff.langString("服务忙，请稍后再试。"))
        else
            if ff.platform == 1 then
                platform_restart()
            else
                platform_showDialog(ff.langString("重置成功"),ff.langString("重置成功，点击确认按钮后游戏将自动重启。"),11,0)
            end
        end
    end
    if eventType==ccui.TouchEventType.ended then     
        if dd.mainUI ~= nil then
            if dd.mygifts:getLong(1,"nHasTopuped") == 1 or dd.myinfo:getLong(1,"level") >= 10 then
                dd.mainUI:onShowSure(ff.langString("警告"),ff.langString("重置后将在本服重新开始游戏，当前进度将无法找回"),callback,false,2)

            else
                --local widget = pop.getDialog("gameSet")
                --widget:ShowNameVerify()
                dd.mainUI:onShowSure(ff.langString("警告"),ff.langString("重置后将在本服重新开始游戏，当前进度将无法找回"),callback,false,2)
            end
        end
    end
end
function gameSetLayer:addEditBox()
    local layer = self:getChildByName("bind_mail")
    local mailInput = layer:getChildByName("mailBg")
    local repInput = layer:getChildByName("againBg")
    if mailInput:getChildByTag(140000) == nil then
        dd.addEditBox(mailInput,cc.size(mailInput:getContentSize().width - 20,mailInput:getContentSize().height - 10),'images/ui/alpha.png',140000,cc.p(0.5,0.5),cc.p(mailInput:getContentSize().width/2,mailInput:getContentSize().height/2 + 5),cc.c3b(161,175,175),20,6,4,5,50,true,true,true)
        mailInput:getChildByTag(140000):setText("")
    end
    
    if repInput:getChildByTag(140001) == nil then
        dd.addEditBox(repInput,cc.size(repInput:getContentSize().width - 20,repInput:getContentSize().height - 10),'images/ui/alpha.png',140001,cc.p(0.5,0.5),cc.p(repInput:getContentSize().width/2,repInput:getContentSize().height/2 + 5),cc.c3b(161,175,175),20,6,4,1,50,true,true,true)
        repInput:getChildByTag(140001):setText(ff.langString(""))
    end

    local inputname = self:getChildByName("input_name"):getChildByName("mailBg")
    if self._name_input == nil then
        dd.addEditBox(inputname,cc.size(inputname:getContentSize().width - 20,inputname:getContentSize().height - 10),'images/ui/alpha.png',140005,cc.p(0.5,0.5),cc.p(inputname:getContentSize().width/2,inputname:getContentSize().height/2),cc.c3b(161,175,175),18,0,4,1,16,true,true,true)
        inputname:getChildByTag(140005):setText("")
    end

    self.mailBox = mailInput:getChildByTag(140000)
    self.repBox = repInput:getChildByTag(140001)
    self._name_input = inputname:getChildByTag(140005)
end

--显示输入用户名确定框
function gameSetLayer:ShowNameVerify()
    self:getChildByName("mask"):setVisible(true)
    self:getChildByName("mask"):setEnabled(true)
    self:getChildByName("input_name"):setVisible(true)
    if self._name_input ~= nil then
        self._name_input:setText("")
    end    
end

function gameSetLayer.closeInputName(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  
        local widget = pop.getDialog("gameSet")
        if widget ~= nil then
            widget:getChildByName("input_name"):setVisible(false)
            widget:getChildByName("mask"):setVisible(false)
        end
    end
end
function gameSetLayer.sureInputName(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  
        local widget = pop.getDialog("gameSet")
        if widget ~= nil then
            widget:getChildByName("input_name"):setVisible(false)
            widget:getChildByName("mask"):setVisible(false)
        end
    end
end

function gameSetLayer.showAward( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then      
        local widget = pop.getDialog("gameSet")
        pop.showPopEffect(99,widget:getChildByName("pop2"))
    end
end

--帐号管理
function gameSetLayer.showAccout(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then      
        local widget = pop.getDialog("gameSet")
        widget.state = sender:getTag()
        widget:getChildByName("connect"):setVisible(true)
        widget:getChildByName("connect"):setEnabled(true)       
        widget:onShowAccout()
    end
end
function gameSetLayer:onShowAccout()
    cclog("here...onShowAccout")   self:disAll()
    self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("账号"))
    self:getChildByName("connect"):getChildByName("mainArea"):setVisible(true)
    self:getChildByName("connect"):getChildByName("mainArea"):setEnabled(true) 
    self:getChildByName("connect"):getChildByName("google_conn"):setVisible(false)
    self:getChildByName("connect"):getChildByName("google_conn"):setEnabled(false)
    
    if string.len(ff.email) > 0 then
        self:getChildByName("connect"):getChildByName("mainArea"):getChildByName("set_mail"):getChildByName("setBtn"):setVisible(false)
        self:getChildByName("connect"):getChildByName("mainArea"):getChildByName("set_mail"):getChildByName("setBtn"):setEnabled(false)
        self:getChildByName("connect"):getChildByName("mainArea"):getChildByName("set_mail"):getChildByName("mail_text"):setString(ff.email)
    else
        self:getChildByName("connect"):getChildByName("mainArea"):getChildByName("set_mail"):getChildByName("setBtn"):setVisible(true)
        self:getChildByName("connect"):getChildByName("mainArea"):getChildByName("set_mail"):getChildByName("setBtn"):setEnabled(true)
        self:getChildByName("connect"):getChildByName("mainArea"):getChildByName("set_mail"):getChildByName("mail_text"):setString("")
    end
    self:getChildByName("connect"):setVisible(true)
end
function gameSetLayer.showGameCenter(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then      
        local widget = pop.getDialog("gameSet")
        widget:onShowGameCenter()
    end
end
function gameSetLayer.showGoogle(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then      
        local widget = pop.getDialog("gameSet")
        widget:onShowGoogle()
    end
end
function gameSetLayer.showFacebook(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then      
        local widget = pop.getDialog("gameSet")
        widget.state = sender:getTag()
        widget:onShowFaceBook()
    end
end

function gameSetLayer.changeGoogle(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then      
        local widget = pop.getDialog("gameSet")
        widget:onChangeGoogle()
    end
end


function gameSetLayer:onChangeGoogle()
    cclog("onChangeGoogle")
    local type = self:getChildByName("connect"):getChildByName("google_conn"):getTag()
    if cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then  
        hif.checkGooglePlus(4,"69315940@qq.com69315940@qq.comqq","69315940@qq.com")
    else    
        local function callback()
            local action = schedule(self,self.loginBack,0.1)
            if action ~= nil then
                action:setTag(89)
                platform.google_callbplatformack_state = false
            end
            function beginCall()
                platform_googleplay(type,get_google_login_callback)
            end
            performWithDelay(self,beginCall,1)
            platform_showWaiting(1,0)
        end

        local binded = false
        local google     = cc.UserDefault:getInstance():getStringForKey("google","")
        local facebook   = cc.UserDefault:getInstance():getStringForKey("facebook","")
        local gamecenter = cc.UserDefault:getInstance():getStringForKey("gamecenter","")
        if ff.platform == 1 then
            if string.len(gamecenter) == 32 or string.len(facebook) == 32 then
                binded = true
            end
        else
            if string.len(google) == 32 or string.len(facebook) == 32 then
                binded = true
            end
        end

        if binded == false then
            if ff.platform == 1 then
                dd.mainUI:onShowSure(ff.langString("警告"),ff.langString("切换其他账号将放弃当前进度，如需保留当前进度请绑定GameCenter账号。"),callback,false,2)
            else
                dd.mainUI:onShowSure(ff.langString("警告"),ff.langString("切换其他账号将放弃当前进度，如需保留当前进度请绑定Google Play账号。"),callback,false,2)
            end    
        else
            callback()    
        end
    end
end



function get_google_login_callback(name)
    cclog("get_google_login_callback:"..name)
    platform.google_callbplatformack_name = Split(name,",fatality,")
    platform.google_callbplatformack_state = true
end

function gameSetLayer.bindGoogle(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then      
        local widget = pop.getDialog("gameSet")
        platform_showWaiting(1,0)
        cclog("alias tag:"..sender:getTag())
        if sender:getTag() == 4 then
            local alias = cc.UserDefault:getInstance():getStringForKey("login_alias")
            if alias == "" or alias == nil then
                widget:onBindGoogle(4)
            else
                widget:onUnBindGoogle(4)
            end
        elseif sender:getTag() == 5 then
            local alias = cc.UserDefault:getInstance():getStringForKey("fb_alias")
            cclog("alias:"..alias)
            if alias == "" or alias == nil then
                cclog("alias1:"..alias)
                widget:onBindGoogle(5)
            else
                cclog("alias2:"..alias)
                widget:onUnBindGoogle(5)
            end        
        elseif sender:getTag() == 6 then
            local alias = cc.UserDefault:getInstance():getStringForKey("gc_alias")
            if alias == "" or alias == nil then
                widget:onBindGoogle(6)
            else
                widget:onUnBindGoogle(6)
            end        
        end
    end
end
function gameSetLayer:onUnBindGoogle(type)
    local ret = hif.unbindGoolePlus(type)
    if ret == 0 then
        if type == 4 then
            self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("尚未绑定G+帐号"))
        elseif type == 5 then
            self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("尚未绑定FaceBook帐号"))
        else            
            self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("尚未绑定GameCenter帐号"))
        end
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setColor(cc.c3b(161,175,175))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):loadTextureNormal(dd.getPathFromUI("public/v2/normal.png",1))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):getChildByName("chu_Label_138"):setString(ff.langString("立即绑定"))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):requestDoLayout()
    else
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("服务忙，请稍后再试。"))
    end
    platform_showWaiting(0,0)
end
--绑定g+和facebook
function gameSetLayer:onBindGoogle(type)
    cclog("onBindGoogle1")
    if cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then  
        hif.bindGooglePlus(type,"69315940@qq.com69315940@qq.comqq","69315940@qq.com")        
    else    
        platform.google_callbplatformack_state = false
        local action = schedule(self,self.bindBack,0.1)
        if action ~= nil then
            action:setTag(90)
        end
        function beginCall()
            if platform_googleplay(type,get_google_account_callback) == true then
            else
                if action ~= nil then
                    platform_showWaiting(0,0)
                    self:stopAction(action)    
                end
            end
        end
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("请稍后")..".....")
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):requestDoLayout()
        performWithDelay(self,beginCall,1)
        platform_showWaiting(1,0)
    end
end
function get_google_account_callback(name)
    platform.google_callbplatformack_name = Split(name,",fatality,")
    platform.google_callbplatformack_state = true
end
--g+绑定
function gameSetLayer.bindBack(sender)
    if platform.google_callbplatformack_state == true then 
        if platform.google_callbplatformack_name ~= nil and table.getn(platform.google_callbplatformack_name) >= 3 then
            local type = tonumber(platform.google_callbplatformack_name[1])
            local login_alias = platform.google_callbplatformack_name[2]
            local login_name  = platform.google_callbplatformack_name[3]

            local ret = hif.bindGooglePlus(type,login_name,login_alias)
            if ret == 0 then
                if type == 4 then
                    sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("已绑定").." "..cc.UserDefault:getInstance():getStringForKey("login_alias"))
                elseif type == 5 then
                    sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("已绑定").." "..cc.UserDefault:getInstance():getStringForKey("fb_alias"))
                else                    
                    sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("已绑定").." "..cc.UserDefault:getInstance():getStringForKey("gc_alias"))
                end
                sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setColor(cc.c3b(7,159,0))

                sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):loadTextureNormal(dd.getPathFromUI("public/v2/btn21.png",1))
                sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):getChildByName("chu_Label_138"):setString(ff.langString("解除绑定"))
                sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):requestDoLayout()

                --发送绑定成功
                local message = ff.net:createMessage()
                message:addCmd(0x0000013c)
                message:addLong(dd.uid)
                message:addLong(2)
                ff.net:postMessage(message)   
            else
                if ret == -4 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("该账户已经绑定其他帐号。"))
                elseif ret == -5 then    
                    if type == 4 then
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("该G+账户已经绑定其他帐号。"))
                    elseif type == 5 then    
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("该FaceBook账户已经绑定其他帐号。"))
                    else    
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("该GameCenter账户已经绑定其他帐号。"))
                    end
                else
                    --dd.currentLayer._widget:onShowTips("\t"..ff.langString("服务忙，请稍后再试。"))
                end
                if type == 4 then
                    sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("尚未绑定G+帐号"))
                elseif type == 5 then    
                    sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("尚未绑定FaceBook帐号"))
                else                    
                    sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("尚未绑定GameCenter帐号"))
                end
                sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setColor(cc.c3b(161,175,175))
                sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):requestDoLayout()
            end
        else
            if tonumber(platform.google_callbplatformack_name[1]) == -2 then
                --自己取消的操作
            else
                --dd.currentLayer._widget:onShowTips("\t"..ff.langString("服务忙，请稍后再试。"))
            end
            if sender:getChildByName("connect"):getChildByName("google_conn"):getTag() == 4 then
                sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("尚未绑定G+帐号"))
            elseif sender:getChildByName("connect"):getChildByName("google_conn"):getTag() == 5 then
                sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("尚未绑定FaceBook帐号"))
            else
                sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("尚未绑定GameCenter帐号"))
            end
            sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setColor(cc.c3b(161,175,175))
            sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):requestDoLayout()
        end

        local widget = pop.getDialog("gameSet")
        if widget ~= nil then
            widget:stopAction(widget:getActionByTag(90))
        end

        platform.google_callbplatformack_state = false
        cclog("here....platform_showWaiting")
        platform_showWaiting(0,0)
        platform_showFull()
    end
end
--g+登录
function gameSetLayer.loginBack(sender)
    if platform.google_callbplatformack_state == true then
        if platform.google_callbplatformack_name ~= nil and table.getn(platform.google_callbplatformack_name) >= 3 then
            local type = tonumber(platform.google_callbplatformack_name[1])
            local login_alias = platform.google_callbplatformack_name[2]
            local login_name  = platform.google_callbplatformack_name[3]

            --print("login_alias:"..login_alias..","..login_name)
            local ret = hif.checkGooglePlus(type,login_name,login_alias)
            if ret == 0 then
                platform_showDialog(ff.langString("切换成功"),ff.langString("切换成功，点击确定按钮后游戏将自动重启。"),1,0)
            else
                if ret == -1001 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("帐号绑定失败"))
                elseif ret == -101 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("无效账户"))
                elseif ret == -12 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("无效账户"))
                end
            end
        else
            if tonumber(platform.google_callbplatformack_name[1]) == -2 then
            else
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("服务忙，请稍后再试。"))
            end
        end
        local widget = pop.getDialog("gameSet")
        if widget ~= nil then
            widget:stopAction(widget:getActionByTag(89))
        end
        platform.google_callbplatformack_state = false
        platform_showWaiting(0,0)
        platform_showFull()        
    end
end

function gameSetLayer:onShowGoogle()
    cclog("showgoogle")
    self:getChildByName("connect"):getChildByName("mainArea"):setVisible(false)
    self:getChildByName("connect"):getChildByName("mainArea"):setEnabled(false) 
    self:getChildByName("connect"):getChildByName("google_conn"):setVisible(true)
    self:getChildByName("connect"):getChildByName("google_conn"):setEnabled(true)
    self:getChildByName("connect"):getChildByName("google_conn"):setTag(4)
    self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("google"):getChildByName("change_tip"):setString(ff.langString("使用另一个Google play上的资料进行游戏"))
    
    local alias = cc.UserDefault:getInstance():getStringForKey("login_alias")
    if alias == "" then
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("尚未绑定G+帐号"))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setColor(cc.c3b(161,175,175))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):loadTextureNormal(dd.getPathFromUI("public/v2/normal.png",1))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):getChildByName("chu_Label_138"):setString(ff.langString("立即绑定"))
    else
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("已绑定").." "..cc.UserDefault:getInstance():getStringForKey("login_alias"))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setColor(cc.c3b(7,159,0))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):loadTextureNormal(dd.getPathFromUI("public/v2/btn21.png",1))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):getChildByName("chu_Label_138"):setString(ff.langString("解除绑定"))
    end
    self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):requestDoLayout()
    self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):setTag(4)
    self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("google"):getChildByName("changeBtn"):setTag(4)
end

function gameSetLayer:onShowFaceBook()
    cclog("onShowFaceBook")
    self:getChildByName("connect"):getChildByName("mainArea"):setVisible(false)
    self:getChildByName("connect"):getChildByName("mainArea"):setEnabled(false) 
    self:getChildByName("connect"):getChildByName("google_conn"):setVisible(true)
    self:getChildByName("connect"):getChildByName("google_conn"):setEnabled(true)
    self:getChildByName("connect"):getChildByName("google_conn"):setTag(5)
    self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("google"):getChildByName("change_tip"):setString(ff.langString("使用另一个 FaceBook 上的资料进行游戏"))

    local alias = cc.UserDefault:getInstance():getStringForKey("fb_alias")
    if alias == "" then
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("尚未绑定FaceBook帐号"))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setColor(cc.c3b(161,175,175))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):loadTextureNormal(dd.getPathFromUI("public/v2/normal.png",1))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):getChildByName("chu_Label_138"):setString(ff.langString("立即绑定"))
    else
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("已绑定").." "..cc.UserDefault:getInstance():getStringForKey("fb_alias"))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setColor(cc.c3b(7,159,0))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):loadTextureNormal(dd.getPathFromUI("public/v2/btn21.png",1))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):getChildByName("chu_Label_138"):setString(ff.langString("解除绑定"))
    end
    self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):requestDoLayout()
    self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):setTag(5)
    self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("google"):getChildByName("changeBtn"):setTag(5)
end

function gameSetLayer:onShowGameCenter()
    cclog("showgamecenter")
    self:getChildByName("connect"):getChildByName("mainArea"):setVisible(false)
    self:getChildByName("connect"):getChildByName("mainArea"):setEnabled(false) 
    self:getChildByName("connect"):getChildByName("google_conn"):setVisible(true)
    self:getChildByName("connect"):getChildByName("google_conn"):setEnabled(true)
    self:getChildByName("connect"):getChildByName("google_conn"):setTag(6)
    self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("google"):getChildByName("change_tip"):setString(ff.langString("使用另一个GameCenter上的资料进行游戏"))
    
    local alias = cc.UserDefault:getInstance():getStringForKey("gc_alias")
    if alias == "" then
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("尚未绑定GameCenter帐号"))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setColor(cc.c3b(161,175,175))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):loadTextureNormal(dd.getPathFromUI("public/v2/normal.png",1))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):getChildByName("chu_Label_138"):setString(ff.langString("立即绑定"))
    else
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setString(ff.langString("已绑定").." "..cc.UserDefault:getInstance():getStringForKey("gc_alias"))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("Label_121"):setColor(cc.c3b(7,159,0))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):loadTextureNormal(dd.getPathFromUI("public/v2/btn21.png",1))
        self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):getChildByName("chu_Label_138"):setString(ff.langString("解除绑定"))
    end
    self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):requestDoLayout()
    self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):setTag(6)
    self:getChildByName("connect"):getChildByName("google_conn"):getChildByName("google"):getChildByName("changeBtn"):setTag(6)
end


function gameSetLayer.showServer(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then              
        local widget = pop.getDialog("gameSet")
        widget.state = sender:getTag()
        widget:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("服务器"))
        widget:disAll()
        widget:getChildByName("server"):setVisible(true)
        widget:getChildByName("server"):setEnabled(true)
        
        platform_showWaiting(1,0)
	    local result = hif.getServerList()
        if result[1] == true then
            platform_showWaiting(0)
            widget:showServerList(result[3])
            widget._servers = result[3]
            widget._serverCnt = table.getn(widget._servers)
            cclog("-----------------"..table.getn(widget._servers))
            widget._view:reloadData()
            
            
        else
            platform_showWaiting(0)
        end
    end
end
function gameSetLayer.showWarning(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then           
        local widget = pop.getDialog("gameSet")
        widget.state = sender:getTag()
        widget:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("警报"))
        widget:disAll()
        widget:getChildByName("warning"):setVisible(true)
        widget:getChildByName("warning"):setEnabled(true)
    end

end
function gameSetLayer.showSound(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then           
        local widget = pop.getDialog("gameSet")
        widget.state = sender:getTag()
        widget:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("音效"))
        widget:disAll()
        widget:getChildByName("sound"):setVisible(true)
        widget:getChildByName("sound"):setEnabled(true)
    end
end
function gameSetLayer.showTui(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then         
        local widget = pop.getDialog("gameSet")
        widget.state = sender:getTag()
        widget:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("推送"))
        widget:disAll()
        widget:getChildByName("tuisong"):setVisible(true)
        widget:getChildByName("tuisong"):setEnabled(true)
    end
end
function gameSetLayer.showLanguage(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then                   
        local widget = pop.getDialog("gameSet")
        if widget ~= nil then
            widget.state = sender:getTag()
            widget:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("语言"))
            widget:disAll()
            widget:getChildByName("setLan"):setVisible(true)
            widget:getChildByName("setLan"):setEnabled(true)
        end
    end
end
function gameSetLayer.showFeedback(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then
        --platform_feedback()     
        local widget = pop.getDialog("gameSet")
        widget.state = 3
        widget:showFeed()
    end
end

function gameSetLayer:showFeed()
    self:disAll()
    self:getChildByName("feedback1"):setVisible(true)
    self:getChildByName("feedback1"):setEnabled(true)
end

function gameSetLayer.showMod(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then
        platform_feedback()           
    end
end
function gameSetLayer.showPrivate(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then
        platform_openUrl("http://www.feelingtouch.com/terms.html")
    end
end

function gameSetLayer.showPrivate2(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then
        platform_openUrl("http://www.feelingtouch.com/feelingtouch_privacy.html")
    end
end


function gameSetLayer.setGameLan(key)
    local widget = pop.getDialog("gameSet")
    if widget.lanState == 1 then
        ff.set_lan = widget.selLan
    else
        ff.set_trans_lan = widget.selTranLan
    end
    dd.initSet(false)
end
function gameSetLayer.showLanSel(sender,eventType)    
    if eventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("gameSet")
        widget:lanSelect()
    end
end

function gameSetLayer.helpShift(sender,eventType)    
    if eventType==ccui.TouchEventType.ended then   
        local  tag = sender:getTag()
        local  str = ""
        local name = {"bug","recharge","event","ime","others"}
        if dd.mygifts:getLong(1,"nHasTopuped")==1 then
            str = "UID|"..dd.uid..",Server|"..ff.serverid..",tags|paid user^"..name[tag]
        else
            str = "UID|"..dd.uid..",Server|"..ff.serverid..",tags|"..name[tag]
        end
        local login_alias = cc.UserDefault:getInstance():getStringForKey("login_alias")
        if login_alias == "" then
            str = str..",name|"..dd.myinfo:getString(1,"name")
        else
            str = str..",name|"..dd.myinfo:getString(1,"name")..",mail|"..login_alias
        end

        local function call()
            pop.onClosePopDialog("gameSet")
            cclog("call:")
            platform_helpShift(2,str)
        end
        performWithDelay(sender, call, 0.1)
    end
end

function gameSetLayer:lanSelect()
    local function selectTransLan( index )
        ff.set_trans_lan = index
        cc.UserDefault:getInstance():setIntegerForKey("set_trans_lan",ff.set_trans_lan)
        self:getChildByName("setLan"):getChildByName("mainArea"):getChildByName("tran_lan"):getChildByName("chu_lan_text"):setString(dd.languageArr[ff.set_trans_lan + 1])
    end
    pop.onShowPopDialog("selectScroll",dd.languageArr,selectTransLan,ff.langString("翻译语言"),ff.set_trans_lan)
end




function gameSetLayer:initListener()
    local function setChLan(index)
        cclog("index:"..index)
        local selectIndex = ff.lang
        for i=1,table.getn(dd.languageArr) do
            if dd.languageArr[i] == self.selectLans[index + 1] then
                selectIndex = i
                cclog("lang name:"..dd.languageArr[i])
                break
            end
        end
        cclog("lang:"..ff.lang..","..selectIndex)
        if ff.languageUse[selectIndex] == -1 then
            selectIndex = 0
        else
            selectIndex = selectIndex - 1
        end
        if ff.lang ~= selectIndex then
            ff.lang = selectIndex
            cclog("lang2:"..ff.lang)
            cc.UserDefault:getInstance():setIntegerForKey("lang",ff.lang)         
            dd.initSet(false)
            self:getChildByName("setLan"):getChildByName("mainArea"):getChildByName("lan"):getChildByName("chu_lan_text"):setString(self.selectLans[index + 1])
            platform_restart()
        end
    end    
    local function showChLan(sender,eventType)
        if eventType==ccui.TouchEventType.ended then   
            for i=1,table.getn(self.selectLans) do
                if self.selectLans[i] == dd.languageArr[ff.lang + 1] then
                    pop.onShowPopDialog("selectScroll",self.selectLans,setChLan,ff.langString("语言"),i-1)
                    break
                end
            end
        end
    end
 
    self:getChildByName("setLan"):getChildByName("mainArea"):getChildByName("lan"):getChildByName("setBtn"):addTouchEventListener(showChLan)
    self:getChildByName("setLan"):getChildByName("mainArea"):getChildByName("tran_lan"):getChildByName("setBtn"):addTouchEventListener(self.showLanSel)
    self:getChildByName("topArea"):getChildByName("return"):addTouchEventListener(self.onReturn)
    local function connectGP(sender,eventType)
        if eventType==ccui.TouchEventType.ended then      
        end
    end
    local function setMail(sender,eventType)
        if eventType==ccui.TouchEventType.ended then    
            self:getChildByName("mask"):setVisible(true)
            self:getChildByName("mask"):setEnabled(true)
            self:getChildByName("bind_mail"):setVisible(true)
            self:getChildByName("bind_mail"):setEnabled(true)
            self.mailBox:setVisible(true)
            self.mailBox:setEnabled(true)
            self.repBox:setVisible(true)
            self.repBox:setEnabled(true)
        end
    end
    self:getChildByName("connect"):getChildByName("mainArea"):getChildByName("set_mail"):getChildByName("setBtn"):addTouchEventListener(setMail)
    --self:getChildByName("connect"):getChildByName("mainArea"):getChildByName("reset"):getChildByName("resetBtn"):addTouchEventListener(self.clearGame)
    local function doBind(sender,eventType)
        if eventType==ccui.TouchEventType.ended then    
            local mail1 = self.mailBox:getText()
            local mail2 = self.repBox:getText()
            if mail1 == "" or mail2 == "" then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("输入的邮箱地址不能为空"))
                return
            end
            if mail1 ~= mail2 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("输入的邮箱地址不一致"))
                return
            end
            local parts1 = Split(mail1,'@')
            local parts2 = Split(mail2,'@')
            if table.getn(parts1) ~= 2 or table.getn(parts2) ~= 2 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("邮箱的格式不对"))
                return
            end
            local ret = hif.bindEmail(mail1) 
            if ret == 0 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("邮箱绑定成功"),true)
                self.mailBox:setVisible(false)
                self.mailBox:setEnabled(false)
                self.repBox:setVisible(false)
                self.repBox:setEnabled(false)            
                self.mailBox:setText("")
                self.repBox:setText("")
                --关闭界面
                self:getChildByName("mask"):setVisible(false)
                self:getChildByName("mask"):setEnabled(false)
                self:getChildByName("bind_mail"):setVisible(false)
                self:getChildByName("bind_mail"):setEnabled(false)
                --更新
                self:getChildByName("connect"):getChildByName("mainArea"):getChildByName("set_mail"):getChildByName("setBtn"):setVisible(false)
                self:getChildByName("connect"):getChildByName("mainArea"):getChildByName("set_mail"):getChildByName("setBtn"):setEnabled(false)
                self:getChildByName("connect"):getChildByName("mainArea"):getChildByName("set_mail"):getChildByName("mail_text"):setString(ff.set_bind_mail)

                --发送绑定成功
                local message = ff.net:createMessage()
                message:addCmd(0x0000013c)
                message:addLong(dd.uid)
                message:addLong(1)
                ff.net:postMessage(message)   
            else       
                if ret == -4 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("该邮箱已绑定其他账户")) 
                elseif ret == -3 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("邮箱不能为空"))
                else
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("绑定失败")) 
                end            
            end
        end  
    end
    local function closeBindMail(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            self:getChildByName("mask"):setVisible(false)
            self:getChildByName("mask"):setEnabled(false)
            self:getChildByName("bind_mail"):setVisible(false)
            self:getChildByName("bind_mail"):setEnabled(false)
            self.mailBox:setVisible(false)
            self.mailBox:setEnabled(false)
            self.repBox:setVisible(false)
            self.repBox:setEnabled(false)            
            self.mailBox:setText("")
            self.repBox:setText("")
        end  
    end
    self:getChildByName("bind_mail"):getChildByName("sureBtn"):addTouchEventListener(doBind)
    self:getChildByName("bind_mail"):getChildByName("close"):addTouchEventListener(closeBindMail)
 
    local function showNextFeed(sender,eventType)
        if eventType==ccui.TouchEventType.ended then   
            local name = sender:getName()
            if self.feed_state == 1 and name == "nextBtn" then
                self.feed_state = 2
                self:showFeed()
            elseif self.feed_state == 2 and name == "sendBtn" then
                local text = self.infoBox:getText()
                if ff.set_bind_mail == "" then 
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("你尚未绑定邮箱，必须输入一个备用邮箱地址"))
                    return
                end
                if string.len(text) <= 0 or text == "" then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("请先输入反馈信息"))
                    return
                end
                --发送反馈报告，然后退出界面
                local message = ff.net:createMessage()
                message:addCmd(0x00000168)
                message:addLong(dd.uid)
                message:addLong(cc.UserDefault:getInstance():getIntegerForKey("testacount"))
                message:addLong(cc.UserDefault:getInstance():getIntegerForKey("dbversion"))
                message:addLong(cc.UserDefault:getInstance():getIntegerForKey("version"))
                message:addLong(self.feed_type)
                message:addLong(cc.Application:getInstance():getTargetPlatform())
                message:addLong(getVersion2()) 
                message:addLong(ff.serverid)
                message:addLong(1)
                message:addString(tostring(text),512)
                ff.net:postMessage(message)   
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("反馈成功，感谢您为Z war 做的贡献！"),true)
                self.infoBox:setText("")
                self:goToMain()
            end
        end  
    end
    local function selFeedType(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            local tag = sender:getTag()
            if tag == self.feed_type then
                return
            end
            self.feed_type = tag
            self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("pro_bug"):getChildByName("checkBtn"):setSelectedState(false)
            self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("pro_bug"):getChildByName("checkBtn"):setTouchEnabled(self.feed_type~=1)            
            self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("trans_bug"):getChildByName("checkBtn"):setSelectedState(false)
            self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("trans_bug"):getChildByName("checkBtn"):setTouchEnabled(self.feed_type~=2)
            self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("sound"):getChildByName("checkBtn"):setSelectedState(false)
            self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("sound"):getChildByName("checkBtn"):setTouchEnabled(self.feed_type~=3)
            self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("money"):getChildByName("checkBtn"):setSelectedState(false)
            self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("money"):getChildByName("checkBtn"):setTouchEnabled(self.feed_type~=4)
            self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("other"):getChildByName("checkBtn"):setSelectedState(false)
            self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("other"):getChildByName("checkBtn"):setTouchEnabled(self.feed_type~=5)
            if sender:getName() ~= "checkBtn" then
                self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("pro_bug"):getChildByName("checkBtn"):setSelectedState(self.feed_type==1)
                self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("trans_bug"):getChildByName("checkBtn"):setSelectedState(self.feed_type==2)
                self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("sound"):getChildByName("checkBtn"):setSelectedState(self.feed_type==3)
                self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("money"):getChildByName("checkBtn"):setSelectedState(self.feed_type==4)
                self:getChildByName("feedback1"):getChildByName("mainArea"):getChildByName("info"):getChildByName("other"):getChildByName("checkBtn"):setSelectedState(self.feed_type==5)       
                AudioEngine.playEffect(ff.sounds[109])
            end
        end
    end
    local function showSetMail(sender,eventType)
        if eventType==ccui.TouchEventType.ended then
            self.feed_state = 1
            self.feed_type = 1
            self:getChildByName("feedback2"):setVisible(false)
            self.state = 2
            self:getChildByName("connect"):setVisible(true)
            self:getChildByName("connect"):setEnabled(true)
            self:onShowAccout()
        end     
    end

    local function saveSet(sender,eventType)
        if eventType==ccui.TouchEventType.ended then  
            local tag = sender:getTag()
            if tag == 1 then
                if sender:getSelectedState() == true then
                    ff.set_sound = 0
                else
                    ff.set_sound = 1
                end
                cc.UserDefault:getInstance():setIntegerForKey("set_sound",ff.set_sound)
                cclog("sound:"..ff.set_sound)
            end
            if tag == 2 then
                if sender:getSelectedState() == true then
                    ff.set_music = false
                    cc.UserDefault:getInstance():setBoolForKey("set_music",ff.set_music)
                    dd.playBackMusic(0,false)
                    cclog("music:0")
                else
                    ff.set_music = true
                    cc.UserDefault:getInstance():setBoolForKey("set_music",ff.set_music)
                    if dd.currentLayer == dd.cityLayer then
                        dd.playBackMusic(dd.mainUI._lastMusicID,false)
                        if dd.mainUI._lastMusicID == 912 then
                            dd.mainUI._lastMusic = 147 + 15
                        else
                            dd.mainUI._lastMusic = 47 + 15
                        end
                    elseif dd.currentLayer._name == "worldLayer" then
                        dd.playBackMusic(911,true)
                    else
                        dd.playBackMusic(914,true)
                    end
                end
            end
            if tag == 3 then
                if sender:getSelectedState() == true then
                    ff.set_battle = 0
                else
                    ff.set_battle = 1
                end
                cclog("battle:"..ff.set_battle)
            end
            if tag == 4 then
                if sender:getSelectedState() == true then
                    ff.set_schedule = 0
                else
                    ff.set_schedule = 1
                end
                cclog("schedule:"..ff.set_schedule)
            end
            if tag == 5 then
                if sender:getSelectedState() == true then
                    ff.set_alliance = 0
                else
                    ff.set_alliance = 1
                end
                cclog("alliance:"..ff.set_alliance)
            end
            if tag == 6 then
                if sender:getSelectedState() == true then
                    ff.set_system = 0
                else
                    ff.set_system = 1
                end
                cclog("system:"..ff.set_system)
            end
            if tag == 7 then
                if sender:getSelectedState() == true then
                    ff.set_warn_help = 0
                else
                    ff.set_warn_help = 1
                end
                cclog("set_warn_help:"..ff.set_warn_help)
            end
            if tag == 8 then
                if sender:getSelectedState() == true then
                    ff.set_warn_battle = 0
                else
                    ff.set_warn_battle = 1
                end
                cclog("set_warn_battle:"..ff.set_warn_battle)
            end
            if tag == 9 then
                if sender:getSelectedState() == true then
                    ff.set_3d = 0
                    dd.openGrid = false
                    dd.setWorldGridEnable(false)
                else
                    ff.set_3d = 1
                    dd.openGrid = true
                    dd.setWorldGridEnable(true)
                end

                cc.UserDefault:getInstance():setIntegerForKey("set_3d",ff.set_3d)
                cclog("set_warn_battle:"..ff.set_warn_battle)
            end

            --设置推送标志
            local push = 0
            if ff.set_battle == 1 then
                push = push + 1
            end
            if ff.set_schedule == 1 then
                push = push + 2
            end
            if ff.set_alliance == 1 then
                push = push + 4
            end
            if ff.set_system == 1 then
                push = push + 8
            end
            local message = ff.net:createMessage()
            message:addCmd(0x0000016f)
            message:addLong(dd.uid)
            message:addLong(push)
            ff.net:postMessage(message)   
            
            dd.initSet(false)
        end  
    end
    self:getChildByName("sound"):getChildByName("mainArea"):getChildByName("music"):getChildByName("setBtn"):addTouchEventListener(saveSet)
    self:getChildByName("sound"):getChildByName("mainArea"):getChildByName("sound"):getChildByName("setBtn"):addTouchEventListener(saveSet)
    self:getChildByName("sound"):getChildByName("mainArea"):getChildByName("3d"):getChildByName("setBtn"):addTouchEventListener(saveSet)
    self:getChildByName("tuisong"):getChildByName("mainArea"):getChildByName("battle"):getChildByName("setBtn"):addTouchEventListener(saveSet)
    self:getChildByName("tuisong"):getChildByName("mainArea"):getChildByName("schdule"):getChildByName("setBtn"):addTouchEventListener(saveSet)
    self:getChildByName("tuisong"):getChildByName("mainArea"):getChildByName("alliance"):getChildByName("setBtn"):addTouchEventListener(saveSet)
    self:getChildByName("tuisong"):getChildByName("mainArea"):getChildByName("system"):getChildByName("setBtn"):addTouchEventListener(saveSet)

    self:getChildByName("warning"):getChildByName("mainArea"):getChildByName("help"):getChildByName("setBtn"):addTouchEventListener(saveSet)
    self:getChildByName("warning"):getChildByName("mainArea"):getChildByName("battle"):getChildByName("setBtn"):addTouchEventListener(saveSet)
    --多语言
    for i=1,table.getn(dd.languageArr) do
        if ff.languageUse[i] ~= -1 then
            self.selectLans[table.getn(self.selectLans) + 1] = dd.languageArr[i]
        end
    end
end

function gameSetLayer:disAll()
    self:getChildByName("mainArea"):setVisible(false)
    self:getChildByName("server"):setVisible(false)
    self:getChildByName("connect"):setVisible(false)
    self:getChildByName("setLan"):setVisible(false)
    self:getChildByName("sound"):setVisible(false)
    self:getChildByName("tuisong"):setVisible(false)
    self:getChildByName("bind_mail"):setVisible(false)
    self:getChildByName("mask"):setVisible(false)
    self:getChildByName("warning"):setVisible(false)
    self:getChildByName("feedback1"):setVisible(false)
    if self.mailBox~= nil then
        self.mailBox:setVisible(false)
        self.mailBox:setEnabled(false)
    end
    if self.repBox~= nil then
        self.repBox:setVisible(false)
        self.repBox:setEnabled(false)
    end
    if self.infoBox~= nil then
        self.infoBox:setVisible(false)
        self.infoBox:setEnabled(false)
    end
    self._serverCnt = 0
    pop.onClosePopDialog("selectScroll")
end

function gameSetLayer:goToMain()
    self:disAll()
    self.state = 1
    self:getChildByName("mainArea"):setVisible(true)
    self:getChildByName("mainArea"):setEnabled(true)
    self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("设置"))
end


function gameSetLayer.tableCellTouched(table,cell)
    
end

function gameSetLayer.cellSizeForTable(table)
    return 136,720
end

function gameSetLayer.tableCellAtIndex(view,idx)
    

    local widget = pop.getDialog("gameSet")
    if widget == nil then
        return nil
    end
    if idx < 0 or idx >= widget._serverCnt then
        return nil
    end

    local cell = view:dequeueCell()
    local item = nil

    local params = widget._servers[idx+1]
    local serverid = tonumber(params["serverid"])
    if nil == cell then
        cell = cc.TableViewCell:new()
        local servername = params["serverName"]
        local state = tonumber(params["status"])
        local language = tonumber(params["language"])
        local birthday = tonumber(params["birthday"])
        local image = tonumber(params["image"])
        local isfirst = tonumber(params["isFirst"])
        item = widget:getChildByName("server"):getChildByName("server_item"):clone()
        item:setVisible(true)
        item:setPosition(cc.p(360,68))
        local time = os.date("%x", birthday)
        local tab = Split(time, "/")        
        item:getChildByName("chu_name"):setString(servername)
        item:getChildByName("time_text"):setString(tab[1].."-"..tab[2].."-"..tab[3].." "..ff.langString("开服"))  
        if isfirst == 1 then
            item:getChildByName("Image_126"):setVisible(true)
        else
            item:getChildByName("Image_126"):setVisible(false)
        end      
        if state == 0 then            
            item:getChildByName("hot_text"):setVisible(false)
            item:getChildByName("hot_icon"):setVisible(false)
            item:getChildByName("free_icon"):setVisible(true)
        else
            item:getChildByName("hot_text"):setVisible(true)
            item:getChildByName("hot_icon"):setVisible(true)
            item:getChildByName("free_icon"):setVisible(true)
        end 
        item:setTag(1)
        item:getChildByName("select"):setTag(serverid)
        item:getChildByName("select2"):setTag(serverid)
        item:getChildByName("select"):addTouchEventListener(widget.clickServer)
        item:getChildByName("select2"):addTouchEventListener(widget.clickServer)
    
        cell:addChild(item)
    else
        item=cell:getChildByTag(1)
        local servername = params["serverName"]
        local state = tonumber(params["status"])
        local language = tonumber(params["language"])
        local birthday = tonumber(params["birthday"])
        local image = tonumber(params["image"])
        local isfirst = tonumber(params["isFirst"])
        if item == nil then
            item = widget:getChildByName("server"):getChildByName("server_item"):clone()
        end
        item:setTag(1)
        item:setVisible(true)
        item:getChildByName("select"):setTag(serverid)
        item:getChildByName("select2"):setTag(serverid)
      
        local time = os.date("%x", birthday)
        local tab = Split(time, "/")        
        item:getChildByName("chu_name"):setString(servername)
        item:getChildByName("time_text"):setString(tab[1].."-"..tab[2].."-"..tab[3].." "..ff.langString("开服"))  
        if isfirst == 1 then
            item:getChildByName("Image_126"):setVisible(true)
        else
            item:getChildByName("Image_126"):setVisible(false)
        end      
        if state == 0 then            
            item:getChildByName("hot_text"):setVisible(false)
            item:getChildByName("hot_icon"):setVisible(false)
            item:getChildByName("free_icon"):setVisible(true)
        else
            item:getChildByName("hot_text"):setVisible(true)
            item:getChildByName("hot_icon"):setVisible(true)
            item:getChildByName("free_icon"):setVisible(true)
        end 

    end
    return cell
end
    
function gameSetLayer.numberOfCellsInTableView(table)
    
    local widget = pop.getDialog("gameSet")
    if widget == nil then
        return 0
    end
    if widget._servers == nil or next(widget._servers) == nil then
        return 0
    end
    
    return widget._serverCnt
end

--server list
function gameSetLayer:showServerList(servers)
    
    local size = table.getn(servers)

    for i=1, size do
        local params = servers[i]
        local serverid = tonumber(params["serverid"])
        local servername = params["serverName"]
        local state = tonumber(params["status"])
        local language = tonumber(params["language"])
        local birthday = tonumber(params["birthday"])
        local image = tonumber(params["image"])
        local isfirst = tonumber(params["isFirst"])
        local time = os.date("%x", birthday)
        local tab = Split(time, "/") 
        if serverid == ff.serverid then
            local myserver = self:getChildByName("server"):getChildByName("mainArea"):getChildByName("myServer")
            myserver:getChildByName("chu_name"):setString(servername)
            myserver:getChildByName("time_text"):setString(tab[1].."-"..tab[2].."-"..tab[3].." "..ff.langString("开服"))  
            if isfirst == 1 then
                myserver:getChildByName("Image_126"):setVisible(true)
            else
                myserver:getChildByName("Image_126"):setVisible(false)
            end   

            myserver:getChildByName("restart"):addTouchEventListener(self.clearGame)
            myserver:getChildByName("icon"):loadTexture(dd.getPathFromUI("img04.png",1))
        end
    end
end
function gameSetLayer.clickServer(sender, eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        cclog("点击切换服务器")
        AudioEngine.playEffect(ff.sounds[109])
        if sender:getTag() == ff.serverid then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("你已在该服务器中"))
        else
            local function callback()
                if hif.changeServer(sender:getTag()) == true then
                    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("切换服务器成功，即将重启游戏。"),true)
                        platform_restart()
                    else
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("切换服务器成功，即将重启游戏。"),true)   
                        platform_restart() 
                    end
                else   
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("操作失败"))     
                end
            end
            dd.mainUI:onShowSure(ff.langString("警告"),ff.langString("是否要切换到该服务器？"),callback,false,1)
        end
    end
end
--界面显示后调用
function gameSetLayer.onStart(sender)
    if sender._init == false then
        sender:getChildByName("mainArea"):getChildByName("warning"):getChildByName("back_btn"):addTouchEventListener(sender.showWarning)
        sender:getChildByName("mainArea"):getChildByName("account"):getChildByName("back_btn"):addTouchEventListener(sender.showAccout)
        sender:getChildByName("mainArea"):getChildByName("server"):getChildByName("back_btn"):addTouchEventListener(sender.showServer)
        sender:getChildByName("mainArea"):getChildByName("sound"):getChildByName("back_btn"):addTouchEventListener(sender.showSound)
        sender:getChildByName("mainArea"):getChildByName("tui"):getChildByName("back_btn"):addTouchEventListener(sender.showTui)
        sender:getChildByName("mainArea"):getChildByName("language"):getChildByName("back_btn"):addTouchEventListener(sender.showLanguage)
        sender:getChildByName("topArea"):getChildByName("add_btn"):addTouchEventListener(dd.onPay)

        if ff.platform == 1 then
            sender:getChildByName("connect"):getChildByName("mainArea"):getChildByName("google"):getChildByName("connectBtn"):addTouchEventListener(sender.showGameCenter)
        else
            sender:getChildByName("connect"):getChildByName("mainArea"):getChildByName("google"):getChildByName("connectBtn"):addTouchEventListener(sender.showGoogle)
        end
        sender:getChildByName("connect"):getChildByName("mainArea"):getChildByName("facebook"):getChildByName("connectBtn"):addTouchEventListener(sender.showFacebook)

        sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("google"):getChildByName("changeBtn"):addTouchEventListener(sender.changeGoogle)
        sender:getChildByName("connect"):getChildByName("google_conn"):getChildByName("reset"):getChildByName("bindBtn"):addTouchEventListener(sender.bindGoogle)
        sender:initListener()
        sender._init = true
    end

    ff.net:bindProperty(2405,"gold",sender.updateGold) 
    sender:addEditBox()
    sender:initInfo()
    sender:addLanPicker()
    sender:disAll()
    if sender.startState == 7 then
        sender.state = sender.startState
        sender:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("反馈"))
        sender:disAll()
        sender.feed_state = 1
        sender:showFeed()
    else 
        sender:goToMain()
    end
end

--界面关闭效果结束后调用
function gameSetLayer.onEnd(sender,btns)
    platform_showWaiting(0,0)
    ff.net:removeEvent(2,dd.Tjf_notify_SNGetBonus)
    dd.delBackEvent(sender.onReturn)
    ff.net:unbindProperty("gold",2405) 
    sender.startState = 1
    sender.state = 1
    sender.input_mail = ''
    sender.feed_state = 1
    sender.feed_type = 1
    sender.feed_mail = ''
    sender.feed_info = ''
    sender:disAll()
    if btns == nil then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:unSelectBtns()
        end 
    end
    if ff.platform ~= 1 then 
        sender:getChildByName("server"):getChildByName("mainArea"):
            getChildByName("myServer"):getChildByName("icon"):
            loadTexture(dd.getPathFromUI("public/alpha.png", 1))
    end
    sender:getChildByName("server"):getChildByName("mainArea"):getChildByName("server_list"):removeAllChildren(true)
end
--界面即将播放显示缓动时调用，返回false界面显示将终止
function gameSetLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("icon"),sender:getChildByName("topArea"):getChildByName("add_btn"))
    ff.net:registerEvent(2,dd.Tjf_notify_SNGetBonus, function (message) sender:popRewardDialog(message) end)
    
    return true
end 

function gameSetLayer:popRewardDialog(infos)
    if table.getn(infos) > 0 then
        --商店里，是购买的才提示
        if infos[1]["from"] == 22 then
            cclog("prop Count : "..table.getn(infos))
            pop.onShowPopDialog("reward",infos)
        end
    else
        return 
    end
end

function gameSetLayer:onClose()
    if self.state ~= 1 then
        if self.state == 7 and self.feed_state == 2 then
            self.feed_state = 1
            self:showFeed()
        elseif self.state == 2 and self:getChildByName("connect"):getChildByName("mainArea"):isVisible() == false then
            self:onShowAccout()
        else
            self:goToMain()
        end
        --回到主界面
        return true
    else
        return false
    end
    return false
end

function gameSetLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("gameSet")
        if widget~=nil and widget:onClose() == false then
            if widget:getChildByName("pop2"):isVisible() == true then
                widget:getChildByName("pop2"):setVisible(false)
                return
            end
            pop.onClosePopDialog("gameSet")
        end    
    end
end
function onShowGameSet(widget,state)
    local layer = gameSetLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    layer.startState = state
    return layer
end