ActiveUseLayer = class("ActiveUseLayer")
ActiveUseLayer._name = "ActiveUse"
ActiveUseLayer._init = false
ActiveUseLayer._id = 0
ActiveUseLayer._iskua = 0


function ActiveUseLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,ActiveUseLayer)
	return target
end

function ActiveUseLayer:onInit(  )
	-- body
	if self._init == false then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		self:setPositionY(0)
		self:getChildByName("back"):setContentSize(cc.size(720,hh))
		self:getChildByName("back"):addTouchEventListener(self.onReturn)
		self:getChildByName("back"):getChildByName("join"):addTouchEventListener(self.onJoin)
		self:getChildByName("back"):getChildByName("join_0"):addTouchEventListener(self.onJoinEx)
		self:getChildByName("back"):getChildByName("join_0_0"):addTouchEventListener(self.onJoinExEx)
		self:getChildByName("back"):getChildByName("join"):getChildByName("Label_8"):setString(ff.langString("宣战"))
		self:getChildByName("back"):getChildByName("join_0"):getChildByName("Label_8"):setString(ff.langString("前往"))
		self:getChildByName("back"):getChildByName("join_0_0"):getChildByName("Label_8"):setString(ff.langString("报名"))
		--self:getChildByName("back"):getChildByName("img_arrow"):addTouchEventListener(self.onNothing)
		--self:getChildByName("back"):getChildByName("img_arrow"):getChildByName("title"):setString(ff.langString("加入联盟"))
		
		self._init = true
	end
	if self._id == 126 then
		self:getChildByName("back"):getChildByName("join"):setVisible(false)
		self:getChildByName("back"):getChildByName("join_0"):setVisible(false)
		self:getChildByName("back"):getChildByName("join_0_0"):setVisible(true)
		self:getChildByName("back"):getChildByName("img_arrow"):getChildByName("chu_title"):setString(ff.langString("勇士竞技场"))
		self:getChildByName("back"):getChildByName("img_arrow"):getChildByName("Label1"):setString(ff.langString("我们将同时开启多个跨服战场，并将实力相近的服务器划分到同一个跨服战场，展开竞争。联盟R5及以上成员可提前前往勇士竞技场进行报名。跨服战场活动——遗迹激战持续2小时，12级以上指挥官可参加。"))
	else
		self:getChildByName("back"):getChildByName("join"):setVisible(true)
		self:getChildByName("back"):getChildByName("join_0"):setVisible(true)
		self:getChildByName("back"):getChildByName("join_0_0"):setVisible(false)

		self:getChildByName("back"):getChildByName("img_arrow"):getChildByName("chu_title"):setString(ff.langString("百鬼来袭"))
		self:getChildByName("back"):getChildByName("img_arrow"):getChildByName("Label1"):setString(ff.langString("百鬼来袭是一个联盟防御类的活动，在活动期间内，盟主可手动宣战，宣战后会有大批僵尸攻击成员的城市。坚守城市并赢取奖励！"))
	end
end

function ActiveUseLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("ActiveUse")
		if widget == nil then
			return
		end
        pop.onClosePopDialog("ActiveUse")
    end
end

function ActiveUseLayer.onJoin( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then  
    	local message = ff.net:createMessage()
	    message:addCmd(0x178)
	    message:addLong(dd.uid)
	    
	    ff.net:rpc(message,false)

    end
end

function ActiveUseLayer.onJoinEx( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then  
    	local widget = pop.getDialog("ActiveUse")
		if widget == nil then
			return
		end
        sender:setTouchEnabled(false)
        pop.onClosePopDialog("ActiveUse")
        --cclog("==========="..widget._id)
        pop.onShowPopDialog("ActivityneiEx",widget._id,widget._iskua)

        local function sched()
            sender:setTouchEnabled(true)
        end 
        performWithDelay(sender,sched,1.5)

    end
end

function ActiveUseLayer.onJoinExEx( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then  
    	if dd.myUnion:getLong(1,"unionid") <= 0 then 
	        dd.currentLayer._widget:onShowTips("\t"..ff.langString("这是一个联盟活动，请先加入一个联盟。"))
	        return
	    end
	    if dd.KFRoomInfo == nil then
	    	dd.currentLayer._widget:onShowTips("\t"..ff.langString("活动尚未开始"))
	        return
	    else
	    	if dd.KFRoomInfo:rowCount() > 0 then
                local index = dd.KFRoomInfo:rowCount()
		    	local message = ff.net:createMessage()
			    message:addCmd(0x301)
			    message:addLong(dd.uid)
			    message:addLong(dd.KFRoomInfo:getLong(index,"roomid"))
			    message:addLong(0)
			    message:addLong(0)
			    message:addLong(0)
			    message:addLong(0)
			    ff.net:rpc(message,false)
			else
				dd.currentLayer._widget:onShowTips("\t"..ff.langString("活动尚未开始"))
	        	return
			end
		end
		sender:setTouchEnabled(false)
        pop.onClosePopDialog("ActiveUse")
        
        local function sched()
            sender:setTouchEnabled(true)
        end 
        performWithDelay(sender,sched,1.5)


    end
end

function ActiveUseLayer.onEnd( sender )
    -- body
    dd.delBackEvent()
end

function onShowActiveUse(widget,id,iskua)
	-- body
	local layer = ActiveUseLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
	layer._id = id
	layer._iskua = iskua
    layer:onInit()
    return layer
end