StrongholdInfoShowLayer = class("StrongholdInfoShowLayer")
StrongholdInfoShowLayer._name = "StrongholdInfoShow"
StrongholdInfoShowLayer._init = false
StrongholdInfoShowLayer._type = 1


function StrongholdInfoShowLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,StrongholdInfoShowLayer)
	return target
end

function StrongholdInfoShowLayer:onInit(  )
	-- body
    local hh = ff.height
	if self._init == false then
		
		self:setContentSize(cc.size(720,hh))
		self:setPositionY(0)
		self:getChildByName("back"):setContentSize(cc.size(720,hh))
		self:getChildByName("back"):addTouchEventListener(self.onReturn)
		self:getChildByName("top"):setPositionY(hh - 105)
		
    	self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    	self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
        self:getChildByName("oper"):getChildByName("join"):addTouchEventListener(self.onJoin)
    	
		self._init = true
	end
    if self._type == 3 then
        self:getChildByName("scrollview"):setContentSize(cc.size(720,hh-105 - 160))
        self:getChildByName("scrollview"):setPositionY(160)
        self:getChildByName("oper"):setVisible(true)
        self:getChildByName("oper"):setPositionY(0)
        self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("勇士竞技场"))
        self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
        self:getChildByName("top"):getChildByName("title"):requestDoLayout()
    elseif self._type == 4 then
        self:getChildByName("scrollview"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("scrollview"):setPositionY(0)
        self:getChildByName("oper"):setVisible(false)
        self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("勇士竞技场"))
        self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
        self:getChildByName("top"):getChildByName("title"):requestDoLayout()
    else
        self:getChildByName("scrollview"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("scrollview"):setPositionY(0)
        self:getChildByName("oper"):setVisible(false)
        self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("攻城略地"))
        self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
        self:getChildByName("top"):getChildByName("title"):requestDoLayout()
    end
	self.updateGold()
end

function StrongholdInfoShowLayer.onStart( sender )
	ff.net:bindProperty(2330,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))   
    sender:showList()
end

function StrongholdInfoShowLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("StrongholdInfoShow")
		if widget == nil then
			return
		end
        pop.onClosePopDialog("StrongholdInfoShow")
    end
end

function StrongholdInfoShowLayer.onJoin( sender,eventType )

    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("StrongholdInfoShow")
        if widget ~= nil then
            if dd.KFRoomInfo == nil then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("活动尚未开始"))
                return
            else
                if dd.KFRoomInfo:rowCount() > 0 then
                    local index = dd.KFRoomInfo:rowCount()
                    
                    if dd.KFRoomInfo:getLong(index,"isin") > 0 then
                        if dd.KFRoomInfo:getLong(index,"startime") > dd.getServerTime() then
                            dd.currentLayer._widget:onShowTips("\t"..ff.langString("活动尚未开始"))
                            return
                        end
                        if dd.KSRoom == 0 then
                            local function sure()
                                local message = ff.net:createMessage()
                                message:addCmd(0x00000302)
                                message:addLong(dd.uid)
                                message:addLong(dd.KFRoomInfo:getLong(index,"roomid"))
                                message:addLong(0)
                                message:addLong(0)
                                message:addLong(0)
                                message:addLong(0)
                                ff.net:rpc(message,false)
                            end
                            dd.mainUI:onShowSure(ff.langString("警告"),ff.langString("是否确定进入跨服战场？请注意期间不可中途退出活动。"),sure,true,2,1)
                        else
                            if dd.currentLayer._name ~= "WorldUILayer"then
                                dd.yunClose(2)
                            end
                        end
                    else
                        --cclog("====123==="..dd.KFRoomInfo:getLong(index,"startime").."="..dd.getServerTime())
                        if dd.KFRoomInfo:getLong(index,"startime") < dd.getServerTime() then
                            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您的联盟没有报名参加跨服战场活动"))
                            return
                        end
                        pop.onShowPopDialog("ActiveUse",126,1)
                    end
                else
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("活动尚未开始"))
                    return
                end
            end
            
            return
        end
    end
    
end

function StrongholdInfoShowLayer.onEnd( sender )
    -- body
    dd.delBackEvent()
    sender:stopAllActions()
    sender:getChildByName("scrollview"):removeAllChildren(true)
    ff.net:unbindProperty("gold",2330)
end

function onShowStrongholdInfoShow(widget,type)
	-- body
	local layer = StrongholdInfoShowLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
    if type == nil then
        layer._type = 1
    else
        layer._type = type
    end
    layer:onInit()
    return layer
end

function StrongholdInfoShowLayer.update( sender )
    -- body
    if sender._type == 3 then
        if dd.KFRoomInfo == nil then
            sender:getChildByName("oper"):getChildByName("time"):setString("")
            sender:getChildByName("oper"):getChildByName("join"):getChildByName("Label"):setString(ff.langString("报名"))
        else
            if dd.KFRoomInfo:rowCount() > 0 then
                local index = dd.KFRoomInfo:rowCount()
                if dd.KFRoomInfo:getLong(index,"isin") > 0 then
                    sender:getChildByName("oper"):getChildByName("join"):getChildByName("Label"):setString(ff.langString("进入"))
                else
                    sender:getChildByName("oper"):getChildByName("join"):getChildByName("Label"):setString(ff.langString("报名"))
                end
                if dd.KFRoomInfo:getLong(index,"startime") > dd.getServerTime() then
                    local time = dd.KFRoomInfo:getLong(index,"startime")- dd.getServerTime()
                    if time > 0 then
                        sender:getChildByName("oper"):getChildByName("time"):setString(ff.langString("活动尚未开始")..": "..ff.getLeftTime(time,":"))
                    end
                else
                    local time = dd.KFRoomInfo:getLong(index,"endtime") - dd.getServerTime()
                    if time > 0 then
                        sender:getChildByName("oper"):getChildByName("join"):getChildByName("Label"):setString(ff.langString("进入"))
                        sender:getChildByName("oper"):getChildByName("time"):setString(ff.langString("距离活动结束")..": "..ff.getLeftTime(time,":"))
                    else
                        sender:getChildByName("oper"):getChildByName("time"):setString("")
                    end
                end
                
            else
                sender:getChildByName("oper"):getChildByName("time"):setString("")
                sender:getChildByName("oper"):getChildByName("join"):getChildByName("Label"):setString(ff.langString("报名"))
                
            end
        end
        sender:getChildByName("oper"):getChildByName("join"):getChildByName("Label"):getVirtualRenderer():enableBold(true)
        sender:getChildByName("oper"):requestDoLayout()
    end
end


function StrongholdInfoShowLayer.onBefore( sender)
    if sender._type == 3 then
        schedule(sender, sender.update,1)
    end
end


function StrongholdInfoShowLayer:showList(  )
    if self._type == 1 then
    	local title = self:getChildByName("title"):clone()
    	title:setVisible(true)
    	title:setTag(1)
    	title:getChildByName("ico"):loadTexture("images/bank/bank_back2.jpg",0)
    	title:getChildByName("Image_195"):loadTexture("images/active/active_di.png",0)
    	self:getChildByName("scrollview"):pushBackCustomItem(title)

    	local block1 = self:getChildByName("block2"):clone()
    	block1:setVisible(true)
    	local string = ""
    	string = string..ff.langString("驻守据点的集结部队将获得“坚固壁垒”的额外效果，驻守时间越久，额外效果越强。如果驻守部队被击败，将退出据点，同时重置“坚固壁垒”的效果。").."\n"..ff.langString("据点争夺战开放，派遣部队占领据点，根据占领时间获取buff增益，坚持至争夺阶段结束，即可赢取据点的使用权。").."\n"..ff.langString("联盟可同时占领多个据点，数量与联盟主科技等级相关，同时占领多个据点可使据点占领后的奖励增加。")
    	block1:getChildByName("heroname"):setString(string)
        block1:getChildByName("heroname_0"):setString(ff.langString("据点争霸"))
        local sp = cc.Sprite:create("images/icon/Stronghold/sh_ico_1.png") 
        sp:setPosition(cc.p(350,80))
        block1:addChild(sp,1,1)
    	self:getChildByName("scrollview"):pushBackCustomItem(block1)

        local block2 = self:getChildByName("block2"):clone()
        block2:setVisible(true)
        local string = ""
        string = string..ff.langString("向据点发动联合攻击兵击败据点中的其他玩家后，即可占领据点，据点中可驻守士兵数量与占领者玩家联合作战中心相关。请让一名联合作战中等级足够高的玩家来发动对据点的联合攻击。").."\n"..ff.langString("坚守据点至争夺阶段结束后，玩家所在联盟获得据点的使用权。")
        block2:getChildByName("heroname"):setString(string)
        block2:getChildByName("heroname_0"):setString(ff.langString("如何攻打据点"))

        local sp2 = cc.Sprite:create("images/icon/Stronghold/sh_ico_2.png")
        sp2:setPosition(cc.p(350,125))
        block2:addChild(sp2,1,1)
        self:getChildByName("scrollview"):pushBackCustomItem(block2)

        local block3 = self:getChildByName("block1"):clone()
        block3:setVisible(true)
        local string3 = ""
        string3 = string3..ff.langString("成功占领据点后，在占领期间，每日可用联盟贡献换取以下奖励！如果占领多个据点，奖励将会增加").."\n"..ff.langString("1.所有成员每日可在据点兑换超值的道具箱 \n 2.所有成员每日可在据点兑换超级资源矿，补充自己所需的资源。 \n 3.更多据点功能即将推出，敬请期待")
        block3:getChildByName("heroname"):setString(string3)
        block3:getChildByName("heroname_0"):setString(ff.langString("奖励查看"))
        self:getChildByName("scrollview"):pushBackCustomItem(block3)
    elseif self._type == 2 then
        local title = self:getChildByName("title"):clone()
        title:setVisible(true)
        title:setTag(1)
        title:getChildByName("ico"):loadTexture("images/bank/bank_back3.jpg",0)
        title:getChildByName("Image_195"):loadTexture("images/active/active_di.png",0)
        self:getChildByName("scrollview"):pushBackCustomItem(title)

        local block3 = self:getChildByName("block3"):clone()
        block3:setVisible(true)
        local string3 = ""
        string3 = string3..ff.langString("摧毁城区周围的4个哨塔后，可以进攻核心").."\n"..ff.langString("持续占领核心8H，来获取城区的使用权。")
        block3:getChildByName("heroname"):setString(string3)
        block3:getChildByName("heroname_0"):setString(ff.langString("如何占领中立的城区"))
        self:getChildByName("scrollview"):pushBackCustomItem(block3)

        local block4 = self:getChildByName("block3"):clone()
        block4:setVisible(true)
        local string4 = ""
        string4 = string4..ff.langString("摧毁敌对联盟城区周围的任意哨塔后，在哨塔卫兵恢复前，可进攻城区内的玩家城市。").."\n"..ff.langString("摧毁敌对联盟城区周围的4个哨塔，并赶在哨塔卫兵恢复前占领核心，持续占领核心8H，来夺取城区的使用权。")
        block4:getChildByName("heroname"):setString(string4)
        block4:getChildByName("heroname_0"):setString(ff.langString("如何占领其他联盟的城区"))
        self:getChildByName("scrollview"):pushBackCustomItem(block4)

        local block5 = self:getChildByName("block3"):clone()
        block5:setVisible(true)
        local string5 = ""
        string5 = string5..ff.langString("在城区核心中，选择科技进行捐献，来强化城区的防御能力。").."\n"..ff.langString("在核心中驻防部队，保护城区不被敌人夺走。")
        block5:getChildByName("heroname"):setString(string5)
        block5:getChildByName("heroname_0"):setString(ff.langString("如何保护你的城区"))
        self:getChildByName("scrollview"):pushBackCustomItem(block5)

        local block6 = self:getChildByName("block3"):clone()
        block6:setVisible(true)
        local string6 = ""
        string6 = string6..ff.langString("你可以将你的城市迁徙到城区内，获得BUFF增益，效果如下。城内所有资源产量及容量+50%，部队行军速度+100%")

        block6:getChildByName("heroname"):setString(string6)
        block6:getChildByName("heroname_0"):setString(ff.langString("占领城区可以获得什么优势？"))
        self:getChildByName("scrollview"):pushBackCustomItem(block6)
    elseif self._type == 3 then
        if dd.KFRoomInfo == nil then
            self:getChildByName("oper"):getChildByName("time"):setString("")
            self:getChildByName("oper"):getChildByName("join"):getChildByName("Label"):setString(ff.langString("报名"))
        else
            if dd.KFRoomInfo:rowCount() > 0 then
                local index = dd.KFRoomInfo:rowCount()
                if dd.KFRoomInfo:getLong(index,"isin") > 0 then
                    self:getChildByName("oper"):getChildByName("join"):getChildByName("Label"):setString(ff.langString("进入"))
                else
                    self:getChildByName("oper"):getChildByName("join"):getChildByName("Label"):setString(ff.langString("报名"))
                end
                if dd.KFRoomInfo:getLong(index,"startime") > dd.getServerTime() then
                    local time = dd.KFRoomInfo:getLong(index,"startime")- dd.getServerTime()
                    if time > 0 then
                        self:getChildByName("oper"):getChildByName("time"):setString(ff.langString("活动尚未开始")..": "..ff.getLeftTime(time,":"))
                    end
                else
                    self:getChildByName("oper"):getChildByName("join"):getChildByName("Label"):setString(ff.langString("进入"))
                    local time = dd.KFRoomInfo:getLong(index,"endtime") - dd.getServerTime()
                    if time > 0 then
                        self:getChildByName("oper"):getChildByName("time"):setString(ff.langString("距离活动结束")..": "..ff.getLeftTime(time,":"))
                    end
                end
                
            else
                self:getChildByName("oper"):getChildByName("time"):setString("")
                self:getChildByName("oper"):getChildByName("join"):getChildByName("Label"):setString(ff.langString("报名"))
            end
        end

        local title = self:getChildByName("title"):clone()
        title:setVisible(true)
        title:setTag(1)
        title:getChildByName("ico"):loadTexture("images/active/active_back3.jpg",0)
        title:getChildByName("Image_195"):loadTexture("images/active/active_di.png",0)
        self:getChildByName("scrollview"):pushBackCustomItem(title)

        local block3 = self:getChildByName("block3"):clone()
        block3:setVisible(true)
        local string3 = ""
        string3 = string3..ff.langString("我们将同时开启多个跨服战场，并将实力相近的服务器划分到同一个跨服战场，展开竞争。联盟R5及以上成员可提前前往勇士竞技场进行报名。跨服战场活动——遗迹激战持续2小时，12级以上指挥官可参加。")
        block3:getChildByName("heroname"):setString(string3)
        block3:getChildByName("heroname_0"):setString(ff.langString("时间及分组"))
        self:getChildByName("scrollview"):pushBackCustomItem(block3)

        local block4 = self:getChildByName("block3"):clone()
        block4:setVisible(true)
        local string4 = ""
        string4 = string4..ff.langString("遗迹激战是所有Zwar指挥官参与的跨服战争，为了让大家能享受跨服战斗，我们做出了以下调整：在跨服战场中，不允许使用保护道具，医院容量无上限，治疗伤兵的消耗-80%，治疗速度+80%，不能抓捕武将，不会损失资源，治疗增益的BUFF会持续到跨服活动结束后2小时。")
        block4:getChildByName("heroname"):setString(string4)
        block4:getChildByName("heroname_0"):setString(ff.langString("跨服战场说明"))
        self:getChildByName("scrollview"):pushBackCustomItem(block4)

        local block5 = self:getChildByName("block3"):clone()
        block5:setVisible(true)
        local string5 = ""
        string5 = string5..ff.langString("个人排名：击杀敌军，可获得击杀积分，活动结束后，我们将根据击杀积分，进行个人排名。\n 联盟排名：采集墓穴可获得稀有资源遗骸，但遗骸也可被其他玩家掠夺，活动结束后，我们将根据联盟玩家持有的遗骸总数，进行联盟排名。")
        block5:getChildByName("heroname"):setString(string5)
        block5:getChildByName("heroname_0"):setString(ff.langString("积分及排名说明"))
        self:getChildByName("scrollview"):pushBackCustomItem(block5)

        local block6 = self:getChildByName("block3"):clone()
        block6:setVisible(true)
        local string6 = ""
        string6 = string6..ff.langString("跨服战场中有5处女神遗迹，分别包含不同的神力，占领遗迹可使所有联盟成员获得女神的祝福。")

        block6:getChildByName("heroname"):setString(string6)
        block6:getChildByName("heroname_0"):setString(ff.langString("占领女神获取强大增益"))
        self:getChildByName("scrollview"):pushBackCustomItem(block6)

    elseif self._type == 4 then
        local title = self:getChildByName("title"):clone()
        title:setVisible(true)
        title:setTag(1)
        title:getChildByName("ico"):loadTexture("images/active/active_back3.jpg",0)
        title:getChildByName("Image_195"):loadTexture("images/active/active_di.png",0)
        self:getChildByName("scrollview"):pushBackCustomItem(title)

        local block3 = self:getChildByName("block3"):clone()
        block3:setVisible(true)
        local string3 = ""
        string3 = string3..ff.langString("我们将同时开启多个跨服战场，并将实力相近的服务器划分到同一个跨服战场，展开竞争。联盟R5及以上成员可提前前往勇士竞技场进行报名。跨服战场活动——遗迹激战持续2小时，12级以上指挥官可参加。")
        block3:getChildByName("heroname"):setString(string3)
        block3:getChildByName("heroname_0"):setString(ff.langString("时间及分组"))
        self:getChildByName("scrollview"):pushBackCustomItem(block3)

        local block4 = self:getChildByName("block3"):clone()
        block4:setVisible(true)
        local string4 = ""
        string4 = string4..ff.langString("遗迹激战是所有Zwar指挥官参与的跨服战争，为了让大家能享受跨服战斗，我们做出了以下调整：在跨服战场中，不允许使用保护道具，医院容量无上限，治疗伤兵的消耗-80%，治疗速度+80%，不能抓捕武将，不会损失资源，治疗增益的BUFF会持续到跨服活动结束后2小时。")
        block4:getChildByName("heroname"):setString(string4)
        block4:getChildByName("heroname_0"):setString(ff.langString("跨服战场说明"))
        self:getChildByName("scrollview"):pushBackCustomItem(block4)

        local block5 = self:getChildByName("block3"):clone()
        block5:setVisible(true)
        local string5 = ""
        string5 = string5..ff.langString("个人排名：击杀敌军，可获得击杀积分，活动结束后，我们将根据击杀积分，进行个人排名。\n 联盟排名：采集墓穴可获得稀有资源遗骸，但遗骸也可被其他玩家掠夺，活动结束后，我们将根据联盟玩家持有的遗骸总数，进行联盟排名。")
        block5:getChildByName("heroname"):setString(string5)
        block5:getChildByName("heroname_0"):setString(ff.langString("积分及排名说明"))
        self:getChildByName("scrollview"):pushBackCustomItem(block5)

        local block6 = self:getChildByName("block3"):clone()
        block6:setVisible(true)
        local string6 = ""
        string6 = string6..ff.langString("跨服战场中有5处女神遗迹，分别包含不同的神力，占领遗迹可使所有联盟成员获得女神的祝福。")

        block6:getChildByName("heroname"):setString(string6)
        block6:getChildByName("heroname_0"):setString(ff.langString("占领女神获取强大增益"))
        self:getChildByName("scrollview"):pushBackCustomItem(block6)

        
    end
end

function StrongholdInfoShowLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("StrongholdInfoShow")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end