TowerXmasLayer = class("TowerXmasLayer")
TowerXmasLayer._name = "TowerXmas"
TowerXmasLayer._init = false
TowerXmasLayer._Difficulty = 1 
TowerXmasLayer._zhang = 1
TowerXmasLayer._Towerid = 0
TowerXmasLayer._fightId = 0
TowerXmasLayer._info = {}
TowerXmasLayer._record = {}
TowerXmasLayer._list = {}
TowerXmasLayer._christmas = {}
TowerXmasLayer._christmas_reward = {}
TowerXmasLayer._isShow = false

function TowerXmasLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,TowerXmasLayer)
	return target
end

function TowerXmasLayer:onInit(  )
	-- body
	if self._init == false then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		self:setPositionY(0)
		self:getChildByName("bg"):setContentSize(cc.size(720,hh))
        self:getChildByName("pop1"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("pop2"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("win"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("lose"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("pop1"):getChildByName("mask"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("pop2"):getChildByName("mask"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("win"):getChildByName("mask"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("lose"):getChildByName("mask"):setContentSize(cc.size(720,hh-105))

        self:getChildByName("win"):getChildByName("info"):getChildByName("close"):addTouchEventListener(self.onCloseWin)
        self:getChildByName("lose"):getChildByName("lose"):getChildByName("close"):addTouchEventListener(self.onCloseLose)


	    self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onClosePop1)
		self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("close"):addTouchEventListener(self.onClosePop2)
        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("topNavi"):setPositionY(hh - 105 - 85)
        self:getChildByName("info"):setPositionY(hh - 105 - 38 - 85)
        self:getChildByName("top"):setPositionY(hh - 105 - 38 - 100 - 85)
        self:getChildByName("oper"):setPositionY(5)
        self:getChildByName("item"):setPositionY(143)

        self:getChildByName("item"):setContentSize(cc.size(720,hh - 105 - 38 - 100 - 143 - 85))
        self:getChildByName("item"):getChildByName("list"):setContentSize(cc.size(520,hh - 105 - 38 - 100 - 143 - 85))
    
        
        
        self:getChildByName("back"):setContentSize(cc.size(720,hh - 105 - 38 - 100 - 143 - 85))
        self:getChildByName("back"):setPositionY(143)
    	self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onReturn)
    	self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
        
        self:getChildByName("topNavi"):getChildByName("navi1"):setTag(1)
        self:getChildByName("topNavi"):getChildByName("navi2"):setTag(2)
        self:getChildByName("topNavi"):getChildByName("navi3"):setTag(3)
        self:getChildByName("topNavi"):getChildByName("navi1"):addTouchEventListener(self.onSelectDif)
        self:getChildByName("topNavi"):getChildByName("navi2"):addTouchEventListener(self.onSelectDif)
        self:getChildByName("topNavi"):getChildByName("navi3"):addTouchEventListener(self.onSelectDif)

        self:getChildByName("item"):getChildByName("left"):addTouchEventListener(self.onLeft)
        self:getChildByName("item"):getChildByName("left"):getChildByName("button"):addTouchEventListener(self.onLeft)
        self:getChildByName("item"):getChildByName("right"):addTouchEventListener(self.onRight)
        self:getChildByName("item"):getChildByName("right"):getChildByName("button"):addTouchEventListener(self.onRight)
        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):addTouchEventListener(self.onFightButton)
        self:getChildByName("itemin"):getChildByName("item1"):setTag(1)
        self:getChildByName("itemin"):getChildByName("item2"):setTag(2)
        self:getChildByName("itemin"):getChildByName("item3"):setTag(3)
        self:getChildByName("itemin"):getChildByName("item4"):setTag(4)

        self:getChildByName("itemin"):getChildByName("item1"):addTouchEventListener(self.onSendArmy)
        self:getChildByName("itemin"):getChildByName("item2"):addTouchEventListener(self.onSendArmy)
        self:getChildByName("itemin"):getChildByName("item3"):addTouchEventListener(self.onSendArmy)
        self:getChildByName("itemin"):getChildByName("item4"):addTouchEventListener(self.onSendArmy)

        self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("sure"):addTouchEventListener(self.onSure)

        self:getChildByName("top"):getChildByName("spine"):addTouchEventListener(self.onOpenPop2)
        self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("PageView"):addEventListener(self.exchangePage)
		
        for i=1,4 do
            self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("droplists"):getChildByName("item"..i):getChildByName("item"):addTouchEventListener(self.onShowTips)
            self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):getChildByName("item"..i):getChildByName("item"):addTouchEventListener(self.onShowTips)
            
        end

        self._init = true
	end
    self:InitData()
    self:initPageView()
	self.updateGold()
end

function TowerXmasLayer.onShowTips(sender, eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then        
        local widget = pop.getDialog("TowerXmas")
        if widget ~= nil then
            local pos2word = widget:getWorldPos(sender)
            local pos = widget:convertToNodeSpace(pos2word) 
            pos = cc.p(pos.x, pos.y+30)
            if tonumber(sender.type) > 0 then
                widget:showTips(tonumber(sender.type), tonumber(sender.id), tonumber(sender.count), pos)
            end
        end
    end
end

function TowerXmasLayer:getWorldPos(node)
    local anr   = node:getAnchorPoint()
    local size  = node:getContentSize()
    local p = node:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
    return p
end


function TowerXmasLayer:showTips(type, id, count, pos)
    local ret  = dd.getGiftsTips(type, id, count)
    local name = ret[1]
    local str  = ret[2]
    
    local tips = self:getChildByName("tips")
    local wid  = 360
    tips:stopAllActions()
    tips:setVisible(true)
    tips:getChildByName("tips"):removeAllChildren(true)

    local richText = ccui.RichText:create()
    richText:ignoreContentAdaptWithSize(false)
    richText:setContentSize(cc.size(wid-30,600))    
    richText:setAutoHeight()

    local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, str, "Helvetica", 20)
    richText:insertElement(chat,0)
    richText:formatText()

    local size = richText:getContentSize()
    richText:setPosition(cc.p(172,size.height/2 + 15))
    tips:setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):addChild(richText)

    tips:getChildByName("name"):setString(name) 
    tips:getChildByName("name"):setPositionY(size.height + 40)

    tips:setPosition(pos)
    if pos.x < 300 then
        tips:setAnchorPoint(cc.p(0.2,0))
        tips:getChildByName("flag"):setPositionX(wid*0.2)
    elseif pos.x > 550 then
        tips:setAnchorPoint(cc.p(0.8,0))
        tips:getChildByName("flag"):setPositionX(wid*0.8)
    else
        tips:setAnchorPoint(cc.p(0.5,0))
        tips:getChildByName("flag"):setPositionX(wid*0.5)
    end       
    local function sched()
        tips:setVisible(false)
    end 

    performWithDelay(tips,sched,1.5) 
end


function TowerXmasLayer.exchangePage(sender, eventType)
    if eventType == ccui.PageViewEventType.turning then
        local pageView = sender
        local widget = pop.getDialog("TowerXmas")
        local index = 0
        if widget ~= nil then
            index = tonumber(pageView:getCurPageIndex())
            widget:showItemByIndex(index)
        end

    end
end

function TowerXmasLayer:setBtnLight(node, light)
    if light == true then
        node:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        node:setTouchEnabled(true)
    else 
        local effect = ff.Effect:effectGrey()    
        node:getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        node:setTouchEnabled(false)
    end
end

function TowerXmasLayer:showItemByIndex(index)
    self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("sure"):getChildByName("chu_Label"):setString(ff.langString("确定"))
    self:setBtnLight(self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("sure"),false)
    local count = table.getn(self._christmas_reward)/3
    local item = self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("PageView"):getPage(index)
    if item ~= nil then
        self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("left"):setVisible(index>0)
        self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("right"):setVisible(index<(count-1))
    end
    local show = 0
    show = self._Difficulty * 10 + index + 1
    local id = 0
    for i,v in ipairs(self._christmas_reward) do
        if show == v["diff"] then
            id = i
            break
        end
    end

    for k,v in pairs(self._record) do
        if self._Difficulty  == v["Diff"] then
            if v["havestar"] >= self._christmas_reward[id]['star_num'] and v["awardstar"] < self._christmas_reward[id]['star_num'] then
                self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("sure"):getChildByName("chu_Label"):setString(ff.langString("领取"))
                self:setBtnLight(self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("sure"),true)
            end
            break
        end
    end

    if self._christmas_reward[id] ~= nil then
        item:getChildByName("start"):setString(self._christmas_reward[id]['star_num'])
        local giftInfo = Split(self._christmas_reward[id]['reward'],'|')
        local index1 = 1
        for k,v in pairs(giftInfo) do
            local gift = Split(v,'%^')
            if item:getChildByName("itemlist"):getChildByName("item"..index1) ~= nil  then
                item:getChildByName("itemlist"):getChildByName("item"..index1):getChildByName("back"):getChildByName("icon"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                item:getChildByName("itemlist"):getChildByName("item"..index1):getChildByName("count"):getChildByName("count"):setString(gift[3])
                
                index1 = index1 +1
            end
        end
        if index1 <= 5 then
            for i=index1,5 do
                item:getChildByName("itemlist"):getChildByName("item"..i):getChildByName("back"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("itemlist"):getChildByName("item"..i):getChildByName("count"):getChildByName("count"):setString("")
            end
        end
    end
end

function TowerXmasLayer:showPop1( guan )
    local id = self._Difficulty * 100 + self._zhang * 1000 + guan
    if self._christmas[id] ~= nil then
        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setTag(id)
        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("icon"):loadTexture("images/world/icon/npc/"..dd.cfgNpc[self._christmas[id]["npcid"]]['image']..".png")
        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("info"):getChildByName("tips"):setString(ff.langString(self._christmas[id]["tips"]))
        local giftInfo = Split(self._christmas[id]['reward'],'|')
        local index = 1
        for k,v in pairs(giftInfo) do
            local gift = Split(v,'%^')
            if self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("droplists"):getChildByName("item"..tostring(k)) ~= nil  then
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("droplists"):getChildByName("item"..tostring(k)):getChildByName("item"):getChildByName("icon"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("droplists"):getChildByName("item"..tostring(k)):getChildByName("count"):getChildByName("count"):setString(gift[3])
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("droplists"):getChildByName("item"..tostring(k)):getChildByName("item").type = gift[1]
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("droplists"):getChildByName("item"..tostring(k)):getChildByName("item").id = gift[2]
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("droplists"):getChildByName("item"..tostring(k)):getChildByName("item").count = gift[3]

                index = index +1
            end
        end
        if index <= 4 then
            for i=index,4 do
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("droplists"):getChildByName("item"..tostring(i)):getChildByName("count"):getChildByName("count"):setString("")
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("droplists"):getChildByName("item"..tostring(i)):getChildByName("item").type = 0
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("droplists"):getChildByName("item"..tostring(i)):getChildByName("item").id = 0
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("droplists"):getChildByName("item"..tostring(i)):getChildByName("item").count = 0
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("droplists"):getChildByName("item"..tostring(i)):getChildByName("item"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end


        local nowzhang = 0
        local nowguan = 0
        
        for k,v in pairs(self._record) do
            if self._Difficulty  == v["Diff"] then
                nowzhang = math.floor(v["pass"] / 1000)
                nowguan = math.floor(v["pass"] % 10)
                break
            end
        end

        local lowzhang = 0
        local lowguan = 0

        if self._Difficulty > 1 then
            for k,v in pairs(self._record) do
                if (self._Difficulty - 1)  == v["Diff"] then
                    lowzhang = math.floor(v["pass"] / 1000)
                    lowguan = math.floor(v["pass"] % 10)
                    break
                end
            end
        end
        if self._zhang < nowzhang then
            self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("chu_label_0"):setString(ff.langString("已通关"))
            self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("time"):setString("")
            self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(false)
        elseif self._zhang == nowzhang then
            if guan <= nowguan then
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("chu_label_0"):setString(ff.langString("已通关"))
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("time"):setString("")
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(false)

            elseif guan == (nowguan + 1) then
                if self._Difficulty > 1 then
                    if (nowzhang < lowzhang) or ((nowzhang == lowzhang) and(guan <= lowguan) ) then
                        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(true) 
                    else
                        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("chu_label_0"):setString(ff.langString("关卡尚未解锁"))
                        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("time"):setString("")
                        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(false)      
                    end
                else
                    self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(true) 
                    
                end
            else
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("chu_label_0"):setString(ff.langString("关卡尚未解锁"))
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("time"):setString("")
                self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(false)      
            end
        else
            if nowzhang == 0 and self._zhang == 1 then
                if self._Difficulty > 1 then
                    if guan == 1 then
                        if nowzhang < lowzhang then
                            self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(true) 
                        else
                            self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("chu_label_0"):setString(ff.langString("关卡尚未解锁"))
                            self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("time"):setString("")
                            self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(false)      
                            
                        end
                    else
                        
                        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("chu_label_0"):setString(ff.langString("关卡尚未解锁"))
                        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("time"):setString("")
                        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(false)      
                    end
                    
                else
                    if guan == 1 then
                        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(true) 
                    else
                        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("chu_label_0"):setString(ff.langString("关卡尚未解锁"))
                        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("time"):setString("")
                        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(false)      
                    end
                end
                
            else
                
                if (self._zhang == (nowzhang + 1) and nowguan == 4 )and guan == 1 then
                    if self._Difficulty > 1 then
                        if nowzhang < lowzhang then
                            self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(true) 
                        else
                            self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("chu_label_0"):setString(ff.langString("关卡尚未解锁"))
                            self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("time"):setString("")
                            self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(false)      

                        end
                    else
                        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(true) 
                    end
                    
                else
                    self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("chu_label_0"):setString(ff.langString("关卡尚未解锁"))
                    self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("time"):setString("")
                    self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(false)      
                end
           
            end 
        end  
    end
end

function TowerXmasLayer:initPageView()
    -- body
    local page = self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("PageView")
    local index = 0
    local count = table.getn(self._christmas_reward)/3
    --cclog("------------------"..count.."---"..table.getn(self._christmas_reward).."=="..#self._christmas_reward)
    local row  = 0
    for i=1,count do
        row = i - 1
        local item = page:getPage(row)
        if item == nil then
            item = self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("item"):clone()
            item:setVisible(true)
            item:setTag(i)

            item:setPosition(cc.p(0,0))
            page:insertPage(item,row)
        end
    
    end
    --self:showItemByIndex(page:getCurPageIndex())
end

function TowerXmasLayer.onLeft( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("TowerXmas")
        if widget ~= nil then
            widget._zhang = widget._zhang - 1 
            if widget._zhang == 0 then
                widget._zhang = 10
            end
            widget:getChildByName("item"):getChildByName("list"):getChildByTag(1):stopAllActions()
            widget:showList()
        end
    end
end

function TowerXmasLayer.onHelp( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        pop.onShowPopDialog("hospitalHelp")
    end
end

function TowerXmasLayer.onCloseLose( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("TowerXmas")
        if widget ~= nil then
            widget:getChildByName("lose"):setVisible(false)
        end
    end
end

function TowerXmasLayer.onCloseWin( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("TowerXmas")
        if widget ~= nil then
            widget:getChildByName("win"):setVisible(false)
            local id = widget._info.Towerid%10
            widget:getChildByName()
  
            local itemin = widget:getChildByName("item"):getChildByName("list"):getChildByTag(1)
            
            if id ~= 4 then
                
                if itemin ~= nil then
                    if itemin:getChildByName("jiao"..tostring(id)) ~= nil  then
                        itemin:stopAllActions()
                        for j=1,5 do
                            itemin:getChildByName("jiao"..tostring(id)):getChildByName(tostring(j)):setVisible(false)
                        end
                        itemin:getChildByName("jiao"..tostring(id)):setVisible(true)
                        local index = 1
                        local function showjiao( )
                            if itemin:getChildByName("jiao"..tostring(id)):getChildByName(tostring(index)) ~= nil then
                                itemin:getChildByName("jiao"..tostring(id)):getChildByName(tostring(index)):setVisible(true)
                                index = index + 1
                            else
                                itemin:stopAllActions()
                                local spine = itemin:getChildByName("item"..tostring(id)):getChildByName("rong"):getChildByTag(1)
                                if spine ~= nil then
                                    spine:setToSetupPose()
                                    spine:setAnimation(0,"yigongda_play",true)
                                end
                                if id < 4 then
                                    local spine2 = itemin:getChildByName("item"..tostring(id+1)):getChildByName("rong"):getChildByTag(1)
                                    if spine2 ~= nil then
                                        spine2:setToSetupPose()
                                        spine2:setAnimation(0,"kegongda_play",true)
                                    end
                                end
                            end
                        end
                        schedule(itemin, showjiao,0.5)
                    else
                        itemin:stopAllActions()
                        local spine = itemin:getChildByName("item"..tostring(id)):getChildByName("rong"):getChildByTag(1)
                        if spine ~= nil then
                            spine:setToSetupPose()
                            spine:setAnimation(0,"yigongda_play",true)
                        end
                        if id < 4 then
                            local spine2 = itemin:getChildByName("item"..tostring(id+1)):getChildByName("rong"):getChildByTag(1)
                            if spine2 ~= nil then
                                spine2:setToSetupPose()
                                spine2:setAnimation(0,"kegongda_play",true)
                            end
                        end
                    end
                end
            else
                if itemin ~= nil then
                    local spine = itemin:getChildByName("item"..tostring(id)):getChildByName("rong"):getChildByTag(1)
                    if spine ~= nil then
                        spine:setToSetupPose()
                        spine:setAnimation(0,"yigongda_play",true)
                    end
                    if id < 4 then
                        local spine2 = itemin:getChildByName("item"..tostring(id+1)):getChildByName("rong"):getChildByTag(1)
                        if spine2 ~= nil then
                            spine2:setToSetupPose()
                            spine2:setAnimation(0,"kegongda_play",true)
                        end
                    end
                end
            end
        end
    end
end

function TowerXmasLayer.onClosePop2( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("TowerXmas")
        if widget ~= nil then
            if widget:getChildByName("pop2"):isVisible() == true then
                widget:getChildByName("pop2"):setVisible(false)
            end
        end
    end
end

function TowerXmasLayer.onClosePop1( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("TowerXmas")
        if widget ~= nil then
            if widget:getChildByName("pop1"):isVisible() == true then
                if widget._isShow == true then
                    widget:getChildByName("pop1"):stopAllActions()
                    widget:showList()
                end
                widget:getChildByName("pop1"):setVisible(false)
            end
        end
    end
end

function TowerXmasLayer.onSendArmy( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("TowerXmas")
        if widget ~= nil then
            local guan = sender:getTag()
            widget:showPop1( guan )
            pop.showPopEffect(99,widget:getChildByName("pop1"))
        
        end
    end
end

function TowerXmasLayer.onFightButton( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("TowerXmas")
        if widget ~= nil then
            widget._fightId = sender:getTag()
            local params = {}
            params.cid = 0
            
            params.uid = 0
            params.unionid = dd.myUnion:getLong(1,"unionid")
            params.short =dd.myUnion:getString(1,"unionflag") 
            params.ulevel=dd.myUnion:getLong(1,"level")
            params.name = dd.myUnion:getString(1,"unionname")  
            params.level= dd.myinfo:getLong(1,"level")

            params.count=0
            params.res  = 0
            params.friend=0
            params.protect=0
            params.maxarmys = 99999999
            pop.onShowPopDialog("chuzhen",88,params,widget.onFight)
        end
    end
end

function TowerXmasLayer.onOpenPop2( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("TowerXmas")
        if widget ~= nil then
            widget:showItemByIndex(widget:getChildByName("pop2"):getChildByName("pop2"):getChildByName("PageView"):getCurPageIndex())
            pop.showPopEffect(99,widget:getChildByName("pop2"))
        end
    end
end

function TowerXmasLayer.onRight( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("TowerXmas")
        if widget ~= nil then
            widget._zhang = widget._zhang + 1 
            if widget._zhang == 11 then
                widget._zhang = 1
            end
            widget:getChildByName("item"):getChildByName("list"):getChildByTag(1):stopAllActions()
            widget:showList()
        end
    end
end

function TowerXmasLayer.onSure( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("TowerXmas")
        if widget ~= nil then
            local message = ff.net:createMessage()
            message:addCmd(0x0000011f)
            message:addLong(dd.uid)
            message:addLong(9)
            message:addLong(widget._Difficulty -1)
            message:addLong(0)

            message:addLong(0)

            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            message:addLong(0)
            for i=1,16 do
                message:addLong(0)
            end
            ff.net:rpc(message,false)

            widget:getChildByName("pop2"):setVisible(false)
        end
    end
end

function TowerXmasLayer.onSelectDif( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("TowerXmas")
        if widget ~= nil then
            local tag = sender:getTag()
            if tag ~= widget._Difficulty then
                widget._Difficulty = sender:getTag()
                widget:selectDiff()
            end
        end
    end
end

function TowerXmasLayer:selectDiff( sender)
    --self:getChildByName("item"):getChildByName("list"):getChildByTag(1):stopAllActions()
    self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)

    self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)

    self:getChildByName("topNavi"):getChildByName("navi3"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi"):getChildByName("navi3"):setSelectedState(false)
    
    if self._Difficulty == 1 then
        self:getChildByName("oper"):getChildByName("Label"):setString(ff.langString("通关简单难度来解救第一个迷失的圣诞老人，并为联盟全体成员赢取一份圣诞礼物。"))
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(239, 223, 223))
    elseif self._Difficulty == 2 then
        self:getChildByName("oper"):getChildByName("Label"):setString(ff.langString("通关普通难度来解救第二个迷失的圣诞老人，并为联盟全体成员赢取一份圣诞礼物。"))

        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(239, 223, 223))
    elseif self._Difficulty == 3 then
        self:getChildByName("oper"):getChildByName("Label"):setString(ff.langString("通关困难难度来解救第三个迷失的圣诞老人，并为联盟全体成员赢取一份圣诞礼物。"))

        self:getChildByName("topNavi"):getChildByName("navi3"):getChildByName("chu_label"):setColor(cc.c3b(239, 223, 223))
    end
    if sender ~= nil then
        sender:setSelectedState(true)
    end

    local nowzhang = 0
    local nowguan = 0
    for k,v in pairs(self._record) do
        if self._Difficulty == v["Diff"] then
            nowzhang = math.floor(v["pass"] / 1000)
            nowguan = math.floor(v["pass"] % 10)
            break
        end
    end
    if nowguan == 4 then
        self._zhang = nowzhang + 1
        if self._zhang > 10 then
            self._zhang = 10
        end
    end
    self._zhang = 1
    self:updateJiang()
    self:xuanzhang()
    self:showList()
    
end

function TowerXmasLayer:InitData()
    self._Difficulty = 1 
    self._zhang = 1
    self._Towerid = 0
    self._fightId = 0
    self._isShow = false

    self._info = {}
    self._record = {}
    self._list = {}
    self._christmas = {}
    self._christmas_reward = {}
    local rows = ff.dbmanager:sql_fetch_rows("select * from cfg_christmas_copy")
    self._christmas = {}
    --cclog("========================"..rows:rowCount())
    for i=1,rows:rowCount() do
        local id = tonumber(rows:getString(i,"id"))
        self._christmas[id] = {}
        self._christmas[id]["diff"] = tonumber(rows:getString(i,"difficulty"))
        self._christmas[id]["zhang"] = tonumber(rows:getString(i,"chapterid"))
        self._christmas[id]["checkpoint_id"] = tonumber(rows:getString(i,"checkpoint_id"))
        self._christmas[id]["npcid"] = tonumber(rows:getString(i,"npcid"))
        self._christmas[id]['reward']   = rows:getString(i, "reward_content")
        if ff.lang == -1 then
            self._christmas[id]['tips'] = rows:getString(i, "tips")
            
        else    
            self._christmas[id]['tips'] = tonumber(rows:getString(i, "tips_lan"))

        end
    end
    rows:clear()

    local rows2 = ff.dbmanager:sql_fetch_rows("select * from cfg_christmas_copy_reward")
    self._christmas_reward = {}
    --cclog("========33333333333================"..rows2:rowCount())
    for i=1,rows2:rowCount() do
        local id = tonumber(rows2:getString(i,"id"))
        self._christmas_reward[id] = {}
        self._christmas_reward[id]["diff"] = tonumber(rows2:getString(i,"difficulty"))
        self._christmas_reward[id]["star_num"] = tonumber(rows2:getString(i,"star_num"))
        
        self._christmas_reward[id]['reward']   = rows2:getString(i, "reward_content")
    end
    rows2:clear()
    -------------------------
    self:getChildByName("back"):loadTexture("images/active/TowerXmas_back2.jpg",0)
    self:getChildByName("win"):getChildByName("result"):loadTexture("images/battle/result/img03_fight.png",0)
    self:getChildByName("lose"):getChildByName("lose"):getChildByName("Image_269"):loadTexture("images/battle/result/img04_fight.png",0)
    local  Max_count = 0
    for i=1,dd.myeffect:rowCount() do
        if dd.myeffect:getLong(i,"id") == 16 then
            Max_count = dd.myeffect:getLong(i,"param")
            break
        end
    end
    local p1 = 0
    for i=1,dd.myeffect:rowCount() do
        if dd.myeffect:getLong(i,"id") == 405 then
            p1 = dd.myeffect:getLong(i,"param")
        end
    end
    Max_count = math.floor(Max_count * (1 + p1/1000))
    self:getChildByName("info"):getChildByName("tips"):setString(ff.langString("单次治疗上限").."："..Max_count)
end

function TowerXmasLayer.onStart( sender )
    sender:getInfo()
	ff.net:bindProperty(2331,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    sender._Difficulty = 1
    sender:selectDiff(sender:getChildByName("topNavi"):getChildByName("navi1"))
    sender:getChildByName("pop2"):getChildByName("pop2"):getChildByName("PageView"):scrollToPage(0)
end

function TowerXmasLayer:getInfo(  )
    local message = ff.net:createMessage()
    message:addCmd(0x0000011f)
    message:addLong(dd.uid)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)

    message:addLong(0)

    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    for i=1,16 do
        message:addLong(0)
    end
    ff.net:rpc(message,false)
end

function TowerXmasLayer:getAward( type )
    local message = ff.net:createMessage()
    message:addCmd(0x0000011f)
    message:addLong(dd.uid)
    message:addLong(9)
    message:addLong(type)
    message:addLong(0)

    message:addLong(0)

    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    for i=1,16 do
        message:addLong(0)
    end
    ff.net:rpc(message,false)
end

function TowerXmasLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("TowerXmas")
		if widget == nil then
			return
		end
        if widget:getChildByName("pop1"):isVisible() == true then
            if widget._isShow == true then
                widget:getChildByName("pop1"):stopAllActions()
                widget:showList()
            end
            widget:getChildByName("pop1"):setVisible(false)
            return
        end
        if widget:getChildByName("pop2"):isVisible() == true then
            widget:getChildByName("pop2"):setVisible(false)
            return
        end
        if widget:getChildByName("win"):isVisible() == true then
            if widget._isShow == true then
                widget:getChildByName("pop1"):stopAllActions()
                widget:showList()
            end
            widget:getChildByName("win"):setVisible(false)
            return
        end
        if widget:getChildByName("lose"):isVisible() == true then
            widget:getChildByName("lose"):setVisible(false)
            return
        end
        pop.onClosePopDialog("TowerXmas")
    end
end


function TowerXmasLayer.onEnd( sender )
    -- body

    local jiangspine = sender:getChildByName("top"):getChildByName("spine"):getChildByTag(1)
    if jiangspine ~= nil then
        jiangspine:removeAllChildren(true)
    end
    local itemin = sender:getChildByName("item"):getChildByName("list"):getChildByTag(1)
    
    if itemin ~= nil then
        itemin:stopAllActions()
        for i=1,4 do
            local spine = itemin:getChildByName("item"..tostring(i)):getChildByName("rong"):getChildByTag(1)
            if spine ~= nil then
                spine:removeAllChildren(true)
            end
        end
    end
    
    dd.delBackEvent()
    sender:getChildByName("item"):getChildByName("list"):removeAllChildren(true)
    ff.net:unbindProperty("gold",2331)
    ff.net:removeEvent(2,dd.Tjf_TowerXmasAction)
end

function onShowTowerXmas(widget)
	-- body
	local layer = TowerXmasLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end

function TowerXmasLayer:xuanzhang(  )
    local nowzhang = 0
    local nowguan = 0
    for k,v in pairs(self._record) do
        if self._Difficulty == v["Diff"] then
            nowzhang = math.floor(v["pass"] / 1000)
            nowguan = math.floor(v["pass"] % 10)
            break
        end
    end

    if nowguan == 4 then
        self._zhang = nowzhang + 1
    else
        self._zhang  = nowzhang
    end
    if self._zhang > 10 then
        self._zhang = 10
    end
    if self._zhang < 1 then
        self._zhang = 1
    end
    
end

function TowerXmasLayer:onTowerXmasAction(  params)
    local code = params[1]
    if code == 0 then   
        self._info = params[2]
        self._record = params[3]
        self._list = params[4]
        if self._info.type == 0 then
            
            self:xuanzhang()
            self:showList()
        end
        if self._info.type == 0 or self._info.type == 9 then
            local jiangspine = self:getChildByName("top"):getChildByName("spine"):getChildByTag(1)
            if jiangspine == nil then
                jiangspine = sp.SkeletonAnimation:create("images/active/masling.json", "images/active/masling.atlas")
                jiangspine:setAnchorPoint(cc.p(0.5,0.5))           
                self:getChildByName("top"):getChildByName("spine"):addChild(jiangspine,0,1)
                jiangspine:setPosition(cc.p(jiangspine:getContentSize().width/2+80,jiangspine:getContentSize().height/2+80))
            end

            jiangspine:setAnimation(0,"shengdanlingjiang_idle",true)

        end
        if self._info.type == 1 then
            
            self:showWin()
        
        end

        if self._info.type == 9 then
            if dd.currentLayer._widget ~= nil then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功领取奖励 ！"),true)
            end
        end
        self:updateJiang()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function TowerXmasLayer:updateJiang(  )
    local have = false
    local havestar = 0
    local awardstar = 0
    for k,v in pairs(self._record) do
        if self._Difficulty  == v["Diff"] then
            havestar = v["havestar"]
            awardstar = v["awardstar"]
            break
        end
    end

    for i,v in ipairs(self._christmas_reward) do
        if self._Difficulty  == math.floor(v["diff"]/10) then
            cclog(havestar.."=111="..awardstar.."==33=="..v["star_num"])
            if havestar >= v["star_num"] and awardstar < v["star_num"] then

                have = true
            end
        end
    end

    local jiangspine = self:getChildByName("top"):getChildByName("spine"):getChildByTag(1)
    if jiangspine ~= nil then
        if have == true then
  
            jiangspine:setToSetupPose()
            jiangspine:setAnimation(0,"shengdanlingjiang_play",true)
        else
   
            jiangspine:setToSetupPose()
            jiangspine:setAnimation(0,"shengdanlingjiang_idle",true)
        end
    end

end

function TowerXmasLayer.onBefore( sender)
    ff.net:registerEvent(2,dd.Tjf_TowerXmasAction, function (message)sender:onTowerXmasAction(message)end)        
end

function TowerXmasLayer:showWin(  )
    self:getChildByName("pop1"):setVisible(true)
    self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(false)
    local time = 3
    self:getChildByName("pop1"):stopAllActions()
    self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("chu_label_0"):setString(ff.langString("正在与僵尸激烈战斗"))
    self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("time"):setString("("..time..")")
    self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(false)
    
  
    local function update( )
        time = time - 1
        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("chu_label_0"):setString(ff.langString("正在与僵尸激烈战斗"))
        self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("time"):setString("("..time..")")
        if time == 0 then
            self:getChildByName("pop1"):stopAllActions()
            self:getChildByName("pop1"):setVisible(false)
            self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("chu_label_0"):setString("")
            self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("time"):setString("")
            self:getChildByName("pop1"):getChildByName("pop1"):getChildByName("view"):getChildByName("battle"):setVisible(true)
            if self._info.result == 1 then
        
                local index1  = 1
                for k,v in pairs(self._list) do
                    cclog("=111111111111111111111111111111")
                    if self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):getChildByName("item"..index1) ~= nil  then
                        self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):getChildByName("item"..index1):getChildByName("item"):getChildByName("icon"):loadTexture(dd.getGiftsIcon(tonumber(v["type"]), tonumber(v["id"]))[1],dd.getGiftsIcon(tonumber(v["type"]), tonumber(v["id"]))[2])
                        self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):getChildByName("item"..index1):getChildByName("count"):getChildByName("count"):setString(v["count"])
                        self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):getChildByName("item"..index1):getChildByName("item").type = v["type"]
                        self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):getChildByName("item"..index1):getChildByName("item").id = v["id"]
                        self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):getChildByName("item"..index1):getChildByName("item").count = v["count"]
                        index1 = index1 +1
                    end
                end
                if index1 <= 4 then
                    for i=index1,4 do
                        self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):getChildByName("item"..i):getChildByName("item"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):getChildByName("item"..i):getChildByName("count"):getChildByName("count"):setString("")
                        self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):getChildByName("item"..i):getChildByName("item").type = 0
                        self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):getChildByName("item"..i):getChildByName("item").id = 0
                        self:getChildByName("win"):getChildByName("info"):getChildByName("droplists"):getChildByName("item"..i):getChildByName("item").count = 0
                    end
                end
                self:getChildByName("win"):getChildByName("Label_128"):setString(ff.langString("士兵损失：{0}",{self._info.hurtAll + self._info.deadAll}))
                local nowStar = 0
                for k,v in pairs(self._record) do
                    if self._Difficulty  == v["Diff"] then           
                        nowStar = v["havestar"]
                        break
                    end
                end
                self:getChildByName("top"):getChildByName("star"):setString(nowStar)
                pop.showPopEffect(99,self:getChildByName("win"))
            elseif self._info.result == 2 then
                --cclog("=====3333333333333333333333333333333333======"..self._info.starthp.."=="..self._info.endhp)
                local per = math.floor((self._info.starthp -  self._info.endhp)*100 / self._info.starthp )
                self:getChildByName("lose"):getChildByName("lose"):getChildByName("sha"):setString(ff.langString("击杀僵尸：{0}%",{per}))
                self:getChildByName("lose"):getChildByName("lose"):getChildByName("shang"):setString(ff.langString("士兵损失：{0}",{self._info.hurtAll + self._info.deadAll}))
                pop.showPopEffect(99,self:getChildByName("lose"))
            end
        end
    end 
    schedule(self:getChildByName("pop1"), update,1)
end

function TowerXmasLayer.onFight( hid,soliders ,lianjin)
    local widget = pop.getDialog("TowerXmas")

    local message = ff.net:createMessage()
    message:addCmd(0x0000011f)
    message:addLong(dd.uid)
    message:addLong(1)

    message:addLong(widget._Difficulty-1)
    
    message:addLong(widget._fightId)
    
    message:addLong(hid)

    local armys = ff.dbmanager:sql_fetch_rows("select `soldierid` from cfg_soldier where `type` in ('1','2','3','21') and `step`<='6' order by `type` asc,`step` asc")
    if armys ~= nil then
        for i=1,armys:rowCount() do
            local sid = tonumber(armys:getString(i,"soldierid"))
            if soliders[sid] == nil then
                message:addLong(0)
            else
                message:addLong(soliders[sid])
            end 
        end
        --工程车预留3级
        message:addLong(0)
        message:addLong(0)
        --message:addLong(0)
        if lianjin == true then
            message:addLong(1)
        else
            message:addLong(0)
        end
        for i=1,15 do
            message:addLong(0)
        end
        ff.net:rpc(message,false)
        armys:clear()
    end
    widget._isShow = true
    
end


function TowerXmasLayer:showList(  )
    if next(self._record) == nil then
        return
    end

    local nowzhang = 0
    local nowStar = 0
    local nowguan = 0
    
    for k,v in pairs(self._record) do
        if self._Difficulty  == v["Diff"] then

            nowzhang = math.floor(v["pass"] / 1000)
            nowguan = math.floor(v["pass"] % 10)
            nowStar = v["havestar"]
         
            break
        end
    end

    local lowzhang = 0
    local lowguan = 0

    if self._Difficulty > 1 then
        for k,v in pairs(self._record) do
            if (self._Difficulty - 1)  == v["Diff"] then
                lowzhang = math.floor(v["pass"] / 1000)
                lowguan = math.floor(v["pass"] % 10)
                break
            end
        end
    end

    self:getChildByName("top"):getChildByName("star"):setString(nowStar)
    local stringzhang = {ff.langString("第一章"),ff.langString("第二章"),
                        ff.langString("第三章"),ff.langString("第四章"),
                        ff.langString("第五章"),ff.langString("第六章"),
                        ff.langString("第七章"),ff.langString("第八章"),
                        ff.langString("第九章"),ff.langString("第十章")}

    self:getChildByName("top"):getChildByName("zhang"):setString(stringzhang[self._zhang])

    local itemin = self:getChildByName("item"):getChildByName("list"):getChildByTag(1)
    
    if itemin == nil then
      
        itemin = self:getChildByName("itemin"):clone()
        itemin:setVisible(true)
        itemin:setTag(1)
        self:getChildByName("item"):getChildByName("list"):pushBackCustomItem(itemin)
    end
    itemin:stopAllActions()
    

    for i=1,4 do
        local spine = itemin:getChildByName("item"..tostring(i)):getChildByName("rong"):getChildByTag(1)
        if spine == nil then
            spine = sp.SkeletonAnimation:create("images/active/zhang.json", "images/active/zhang.atlas")
            spine:setAnchorPoint(cc.p(0.5,0.5))           
            itemin:getChildByName("item"..tostring(i)):getChildByName("rong"):addChild(spine,0,1)
            spine:setPosition(cc.p(spine:getContentSize().width/2+80,spine:getContentSize().height/2+80))
        end
        --spine:stopAllActions()
        if self._zhang < nowzhang then
            spine:setToSetupPose()
            spine:setAnimation(0,"yigongda_play",true)
            if i > 1 then
                itemin:getChildByName("jiao"..tostring(i-1)):setVisible(true)
                for j=1,5 do
                    itemin:getChildByName("jiao"..tostring(i-1)):getChildByName(tostring(j)):setVisible(true)
                end
            end
        elseif self._zhang == nowzhang then
            if i <= nowguan then
                spine:setToSetupPose()
                spine:setAnimation(0,"yigongda_play",true)
                if i > 1 then
                    itemin:getChildByName("jiao"..tostring(i-1)):setVisible(true)
                    for j=1,5 do
                        itemin:getChildByName("jiao"..tostring(i-1)):getChildByName(tostring(j)):setVisible(true)
                    end
                end
            elseif (i == (nowguan + 1)) then
                if self._Difficulty > 1 then
                    if (nowzhang < lowzhang) or ((nowzhang == lowzhang) and(i <= lowguan) ) then
                        cclog("=11231231233")
                        spine:setToSetupPose()
                        spine:setAnimation(0,"kegongda_play",true)
                        if i > 1 then
                            itemin:getChildByName("jiao"..tostring(i-1)):setVisible(true)
                            for j=1,5 do
                                itemin:getChildByName("jiao"..tostring(i-1)):getChildByName(tostring(j)):setVisible(true)
                            end
                        end
                    else
                        cclog("=144444444444444443")
                        spine:setToSetupPose()
                        spine:setAnimation(0,"weikaifang_play",true)
                        if i > 1 then
                            itemin:getChildByName("jiao"..tostring(i-1)):setVisible(false)
                            for j=1,5 do
                                itemin:getChildByName("jiao"..tostring(i-1)):getChildByName(tostring(j)):setVisible(false)
                            end
                        end
                    end
                else
                    spine:setToSetupPose()
                    spine:setAnimation(0,"kegongda_play",true)
                    if i > 1 then
                        itemin:getChildByName("jiao"..tostring(i-1)):setVisible(true)
                        for j=1,5 do
                            itemin:getChildByName("jiao"..tostring(i-1)):getChildByName(tostring(j)):setVisible(true)
                        end
                    end
                end
                
            else
                cclog("=123")
                spine:setToSetupPose()
                spine:setAnimation(0,"weikaifang_play",true)
                if i > 1 then
                    itemin:getChildByName("jiao"..tostring(i-1)):setVisible(false)
                    for j=1,5 do
                        itemin:getChildByName("jiao"..tostring(i-1)):getChildByName(tostring(j)):setVisible(false)
                    end
                end
            end
        else
            if nowzhang == 0 and self._zhang == 1 then
                if self._Difficulty > 1 then
                    if i == 1 then
                        if nowzhang < lowzhang then
                            spine:setToSetupPose()
                            spine:setAnimation(0,"kegongda_play",true)
                        else
                            spine:setToSetupPose()
                            spine:setAnimation(0,"weikaifang_play",true)
                            if i > 1 then
                                itemin:getChildByName("jiao"..tostring(i-1)):setVisible(false)
                                for j=1,5 do
                                    itemin:getChildByName("jiao"..tostring(i-1)):getChildByName(tostring(j)):setVisible(false)
                                end
                            end
                        end
                    else
                        
                        spine:setToSetupPose()
                        spine:setAnimation(0,"weikaifang_play",true)
                        if i > 1 then
                            itemin:getChildByName("jiao"..tostring(i-1)):setVisible(false)
                            for j=1,5 do
                                itemin:getChildByName("jiao"..tostring(i-1)):getChildByName(tostring(j)):setVisible(false)
                            end
                        end
                        
                    end
                    
                else
                    if i == 1 then
                        spine:setToSetupPose()
                        spine:setAnimation(0,"kegongda_play",true)
                    else
                        spine:setToSetupPose()
                        spine:setAnimation(0,"weikaifang_play",true)
                        if i > 1 then
                            itemin:getChildByName("jiao"..tostring(i-1)):setVisible(false)
                            for j=1,5 do
                                itemin:getChildByName("jiao"..tostring(i-1)):getChildByName(tostring(j)):setVisible(false)
                            end
                        end
                    
                    end
                end
                
            else
                
                if (self._zhang == (nowzhang + 1) and nowguan == 4 )and i == 1 then
                    if self._Difficulty > 1 then
                        if nowzhang < lowzhang then
                            spine:setToSetupPose()
                            spine:setAnimation(0,"kegongda_play",true)

                        else
                            spine:setToSetupPose()
                            spine:setAnimation(0,"weikaifang_play",true)

                        end
                    else
                        spine:setToSetupPose()
                        spine:setAnimation(0,"kegongda_play",true)
                    end
                    
                else
                    spine:setToSetupPose()
                    spine:setAnimation(0,"weikaifang_play",true)
                end
           
                if i > 1 then
                    itemin:getChildByName("jiao"..tostring(i-1)):setVisible(false)
                    for j=1,5 do
                        itemin:getChildByName("jiao"..tostring(i-1)):getChildByName(tostring(j)):setVisible(false)
                    end
                end
            end            
        end 
    end
end



function TowerXmasLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("TowerXmas")
    if widget ~= nil then
        widget:getChildByName("topArea"):getChildByName("money"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("topArea"):requestDoLayout()
    end
end