hechengexLayer = class("hechengexLayer")
hechengexLayer._name = "hechengex"
hechengexLayer._init = false
hechengexLayer._index = 0

function hechengexLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,hechengexLayer)
	return target
end

function hechengexLayer:onInit(  )
	-- body
	if self._init == false then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		self:setPositionY(0)
		self:getChildByName("back"):setContentSize(cc.size(720,hh))
		self:getChildByName("back"):addTouchEventListener(self.onReturn)
		self:getChildByName("top"):setPositionY(hh - 105)
        self:getChildByName("title"):setPositionY(hh - 105 - 240)
        self:getChildByName("block1"):setPositionY(hh - 105 - 240 - 250)
		self:getChildByName("main"):setContentSize(cc.size(700,hh-105- 240 - 250))
    	self:getChildByName("main"):setPositionY(0)
        self:getChildByName("list"):getChildByName("Image_57"):addTouchEventListener(self.selectItem)
    	self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    	self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
        self:getChildByName("main"):getChildByName("tips"):getChildByName("info"):getChildByName("hecheng"):addTouchEventListener(self.onHeCheng)
    	
        --self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("圣诞节"))
		--self:getChildByName("item"):getChildByName("sure"):addTouchEventListener(self.onHeCheng)
        --self:getChildByName("item"):getChildByName("fsdf"):addTouchEventListener(self.onHeCheng)
        self._init = true
	end
    local title = self:getChildByName("title")
    title:getChildByName("ico"):loadTexture("images/icon/battle/type/active_3.jpg",0)
    title:getChildByName("Image_195"):loadTexture("images/active/active_di.png",0)
    self:getChildByName("block1"):getChildByName("heroname_0"):setString(ff.langString("拼字游戏"))
    self:getChildByName("block1"):getChildByName("heroname"):setString(ff.langString("采集，击杀世界地图野怪有概率获得字母，集齐特定的字母组兑换指定奖励"))
	self.updateGold()
end

function hechengexLayer.selectItem(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
           
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("hechengex")
        if widget ~= nil then
            local tag = sender:getTag()

            if tag == widget._index then
                widget:getChildByName("main"):getChildByName("tips"):setVisible(false)
                widget:getChildByName("main"):getChildByName("tips"):setTag(0)
                widget:getChildByName("main"):getChildByName("tips"):getChildByName("info"):getChildByName("hecheng"):setTag(0)
                widget._index = 0
            else
                widget._index = tag
                widget:setInfo()
            end    
            widget:updatePosition()      
        end
    end
end

function hechengexLayer:setInfo( )
    for k,v in pairs(dd.cfgPropsynthersis) do
        local id = v['target_id']
        if id == self._index and dd.cfgProp[id] ~= nil then

            local tips = self:getChildByName("main"):getChildByName("tips")
            tips:setTag(id+10000)
            tips:getChildByName("info"):getChildByName("hecheng"):setTag(id+10000)
            tips:getChildByName("info"):getChildByName("chu_name"):setString(ff.langString(dd.cfgProp[id]['name']))
            tips:getChildByName("info"):getChildByName("sx"):setString(ff.langString(dd.cfgProp[id]['tips'],{dd.cfgProp[id]['tips1_lan']}))
            tips:getChildByName("info"):getChildByName("value"):setString("")
            tips:setVisible(true)
            break
        end
    end
end

function hechengexLayer.onStart( sender )
	ff.net:bindProperty(2336,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
    sender:showList()
end

function hechengexLayer.onHeCheng( sender,eventType )
	
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then     
        local widget = pop.getDialog("hechengex")
        if widget == nil then
            return
        end  
        local id = sender:getTag()-10000
        local index = 0

        for i,v in pairs(dd.cfgPropsynthersis) do
            if v['target_id'] == id then
                index = i
                break
            end
        end

        if dd.cfgPropsynthersis[index] == nil then
            return
        end
--[[
        if dd.cfgPropsynthersis[index]['target_id'] == 1101 and dd.getToolsCount(1101) > 0 then
            dd.mainUI:onShowTips(ff.langString("该道具只可合成一件")) 
            return
        end
        if dd.cfgPropsynthersis[index]['target_id'] == 1102 and dd.getToolsCount(1102) > 0 then
            dd.mainUI:onShowTips(ff.langString("该道具只可合成一件")) 
            return
        end
]]
        if dd.cfgPropsynthersis[index]['Material1'] > 0 and dd.cfgPropsynthersis[index]['Material1_num'] > 0 then
            if dd.getToolsCount(dd.cfgPropsynthersis[index]['Material1']) < dd.cfgPropsynthersis[index]['Material1_num'] then
                dd.mainUI:onShowTips(ff.langString("材料不足！")) 
                return
            end
        end
        if dd.cfgPropsynthersis[index]['Material2'] > 0 and dd.cfgPropsynthersis[index]['Material2_num'] > 0 then
            if dd.getToolsCount(dd.cfgPropsynthersis[index]['Material2']) < dd.cfgPropsynthersis[index]['Material2_num'] then
                dd.mainUI:onShowTips(ff.langString("材料不足！")) 
                return
            end
        end
        if dd.cfgPropsynthersis[index]['Material3'] > 0 and dd.cfgPropsynthersis[index]['Material3_num'] > 0 then
            if dd.getToolsCount(dd.cfgPropsynthersis[index]['Material3']) < dd.cfgPropsynthersis[index]['Material3_num'] then
                dd.mainUI:onShowTips(ff.langString("材料不足！")) 
                return
            end
        end
        
        local message = ff.net:createMessage()
        message:addCmd(0x0000014a)
        message:addLong(dd.uid)
        message:addLong(index)
        
        ff.net:rpc(message,false)
    end   
    
end

function hechengexLayer.onBefore( sender )
    ff.net:registerEvent(3,dd.Tjf_ItemExchange,function (message)sender:onItemExchange(message)end)
end

function hechengexLayer:onItemExchange(params)
    local code = params[1]
    if code == 0 then      
        self:showList()
        AudioEngine.playEffect(ff.sounds[601])
        if dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("合成成功！"),true)
        end
    else
        --dd.mainUI:onShowCodeTips(code)
    end
end

function hechengexLayer.onReturn( sender,eventType )
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("hechengex")
        if widget == nil then
            return
        end
        if dd.currentLayer._widget ~= nil then
            if dd.currentLayer._widget:getChildByName("hecheng"):isVisible() == true then
                dd.currentLayer._widget:getChildByName("hecheng"):setVisible(false)
                return
            end
        end
        pop.onClosePopDialog("hechengex")
    end
end

function hechengexLayer.onEnd( sender )
    -- body
    ff.net:removeEvent(3,dd.Tjf_ItemExchange)
    dd.delBackEvent(sender.onReturn)
    sender:stopAllActions()
    sender:getChildByName("main"):getChildByName("tips"):setVisible(false)
    sender._index = 0

    --sender:getChildByName("scrollview"):removeAllChildren(true)
    ff.net:unbindProperty("gold",2336)
end

function onShowhechengex(widget)
	-- body
	local layer = hechengexLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end

function hechengexLayer:showList(  )
    
    for k,v in pairs(dd.cfgPropsynthersis) do
        local id = v['target_id']
        if id >= 5521 and id <= 5524 then
            local item = self:getChildByName("main"):getChildByTag(id)
            if item == nil then
        
                item = self:getChildByName("list"):clone()
                item:setVisible(true)
                item:setTag(id)
                item:getChildByName("Image_57"):setTag(id)
                self:getChildByName("main"):addChild(item)
            end
            item:getChildByName("block1"):getChildByName("ico"):loadTexture(dd.getToolsIcon(v['target_id']),0)
            
            if v['Material1_num'] > dd.getToolsCount(v['Material1']) then
                item:getChildByName("block2"):getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getToolsIcon(v['Material1']+10000),0)
            else
                item:getChildByName("block2"):getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getToolsIcon(v['Material1']),0)
            end
            if v['Material2_num'] > dd.getToolsCount(v['Material2']) then
                item:getChildByName("block3"):getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getToolsIcon(v['Material2']+10000),0)
            else
                item:getChildByName("block3"):getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getToolsIcon(v['Material2']),0)
            end
            if v['Material3_num'] > dd.getToolsCount(v['Material3']) then
                item:getChildByName("block4"):getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getToolsIcon(v['Material3']+10000),0)
            else
                item:getChildByName("block4"):getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getToolsIcon(v['Material3']),0)
            end
            if v['Material4_num'] > dd.getToolsCount(v['Material4']) then
                item:getChildByName("block5"):getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getToolsIcon(v['Material4']+10000),0)
            else
                item:getChildByName("block5"):getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getToolsIcon(v['Material4']),0)
            end
            
        end
    end
    self:updatePosition()

end

function hechengexLayer:updatePosition()
    local list = self:getChildByName("main")
    local line = self:getChildByName("main"):getChildrenCount()
    local tips = self:getChildByName("main"):getChildByName("tips")
    local min  = ff.height - 105- 240 - 250
    local hh   = (line - 1) * 170
    if tips:isVisible() == true then
        hh = hh + 110
    end
    if min < hh then
        min = hh
    end
    self:getChildByName("main"):setInnerContainerSize(cc.size(700,min))
    local index = tips:getTag()-10000
    for k,v in pairs(dd.cfgPropsynthersis) do
        local id = v['target_id']
        if id >= 5521 and id <= 5524 then
            local item = self:getChildByName("main"):getChildByTag(id)
            if item ~= nil then
                local  h  = 5525 - id
                item:setPositionX(0)
                if tips:isVisible() == true then
                    if index > id then
                        item:setPositionY(min - h * 170 -110)
                    elseif index == id then
                        item:setPositionY(min - h * 170)
                        tips:setPositionY(min - h * 170 -110)
                    else
                        item:setPositionY(min - h * 170)
                    end
                else
                    item:setPositionY(min - h * 170)
                end
                
            end
            
        end
    end

    if tips:isVisible() == true then
        cclog("y:"..self:getChildByName("main"):getInnerContainer():getPositionY()..",tips:"..tips:getPositionY())
        local fixy = self:getChildByName("main"):getInnerContainer():getPositionY() + tips:getPositionY()
        if fixy < 0 then
            self:getChildByName("main"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,-fixy)))
        end
    end
end

function hechengexLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("hechengex")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end