local taskLayer  = class("taskLayer")
taskLayer._name  = "task"
taskLayer._init  = false
taskLayer._type  = 0
--建筑、科技、英雄、其他
taskLayer.info   = {}

taskLayer.flag =  0
taskLayer.succuce = nil
taskLayer._itemDatas = {}
function taskLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, taskLayer)
    return target
end

function taskLayer.onReturn(sender,eventType)
    --
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        pop.onClosePopDialog("task")
    end
end

function taskLayer:getData()
    if dd.myTasks ~= nil then
        self.info.builds = dd.myTasks:getLong(1,"builds")
        self.info.buildsState = dd.myTasks:getLong(1,"buildsState")
        self.info.tec = dd.myTasks:getLong(1,"tec")
        self.info.tecState = dd.myTasks:getLong(1,"tecState")
        self.info.heros = dd.myTasks:getLong(1,"heros")
        self.info.herosState = dd.myTasks:getLong(1,"herosState")
        self.info.army = dd.myTasks:getLong(1,"others")
        self.info.armyState = dd.myTasks:getLong(1,"othersState")

        self.info.buildsPro = dd.myTasks:getLong(1,"buildsPro")
        self.info.tecPro = dd.myTasks:getLong(1,"tecPro")
        self.info.herosPro = dd.myTasks:getLong(1,"herosPro")
        self.info.armyPro = dd.myTasks:getLong(1,"othersPro")
        self:initUI()
    end
end

function taskLayer:onInit()
	if self._init == false then
        self._init = true
        local hh = ff.height-214
        self:setContentSize(cc.size(720,hh))  
        self:getChildByName("bgLayer"):setContentSize(cc.size(720, hh))
        self:getChildByName("bgLayer"):setPositionY(0)

        self:getChildByName("top"):setPositionY(hh - 105)
        self:getChildByName("main"):setPositionY(hh - 105 - 271)
        self:getChildByName("view"):setContentSize(cc.size(720,hh - 105 - 280))
        self:getChildByName("view"):setPositionY(0)

        self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
	end
    self._type = 1
    self.updateGold()
    self:getChildByName("item"):setVisible(false)
end

function taskLayer:getTaskStateAndProgress()
    local taskStates = {}
    table.insert(taskStates, 1, self.info.buildsState)
    table.insert(taskStates, 2, self.info.tecState)
    table.insert(taskStates, 3, self.info.herosState)
    table.insert(taskStates, 4, self.info.armyState)
    
    local taskProgress = {}
    table.insert(taskProgress, 1, self.info.buildsPro)
    table.insert(taskProgress, 2, self.info.tecPro)
    table.insert(taskProgress, 3, self.info.herosPro)
    table.insert(taskProgress, 4, self.info.armyPro)

    return taskStates,taskProgress
end

function taskLayer:getQueryDatas()
    local conn1 = "SELECT * FROM `cfg_basetask` WHERE `taskid`="..self.info.builds
    local conn2 = " or `taskid`="..self.info.tec.." or `taskid`="..self.info.heros
    local conn3 = " or `taskid`="..self.info.army.." ORDER BY `taskid`"
    local strSQL = conn1..conn2..conn3

    local data = ff.dbmanager:sql_fetch_rows(strSQL)
    return data
end
--设置推荐任务里面项的高度
--[[function taskLayer:setHeight(item,value)
    local btn_award = item:getChildByName("btnAward")

    local t_type = item:getChildByName("chu_type")
    local t_name = item:getChildByName("name")
    local icon = item:getChildByName("image")
    local label = item:getChildByName("label")
    --cclog("============value: "..value)
    if value == 1 or value == 9 then
        t_type:setPositionY(self.t_typeY - 20)
        t_name:setPositionY(self.t_nameY - 20)

        icon:setPositionY(self.iconY + 20)
        label:setPositionY(self.labelY + 20)
        btn_award:setPositionY(self.btnY + 45)
    elseif value == 0 then
        t_type:setPositionY(self.t_typeY)
        t_name:setPositionY(self.t_nameY)

        icon:setPositionY(self.iconY)
        label:setPositionY(self.labelY)
        btn_award:setPositionY(self.btnY)
    end
end]]

function taskLayer:initUI()
    self._itemDatas = {}
    local state,progress = self:getTaskStateAndProgress()

    local data = self:getQueryDatas()
    for i=1,data:rowCount() do
        if data == nil then
            cclog("data is nil...")
            return
        end
        local item = nil
        local data_type = tonumber(data:getString(i,"type"))
        if data_type == 1 then
            self:isFinished(state[i], i)
            item = self:getChildByName("main"):getChildByName("item")
            --self:setHeight(item,state[1])
        else
            item = self:getChildByName("view"):getChildByTag(i)
            if item == nil then
                item = self:getChildByName("item"):clone()
                self:getChildByName("view"):pushBackCustomItem(item)
            end
            self:isFinished(state[i], i,item)
        end
        self._itemDatas[i] = item
        item.id = data:getString(i,"taskid")
        local ico = item:getChildByName("ico")
        local type = item:getChildByName("chu_type")
        local name = item:getChildByName("name")
        local value = tonumber(data:getString(i,"value2"))
        --progress infor
        local progressLabel = item:getChildByName("prog"):getChildByName("pro_disc")
        local progressBar = item:getChildByName("prog"):getChildByName("progress")
        if state[i] == 1 then
            progressBar:setPercent(100)
            progressLabel:setString(value.."/"..value)
        elseif state[i] == 9 then
            progressBar:setPercent(100)
            progressLabel:setString(value.."/"..value)
        else
            progressBar:setPercent(progress[i] / value * 100)
            progressLabel:setString(progress[i].."/"..value)
        end
        local tips = ff.langString(tonumber(data:getString(i,"disc_lan")),{data:getString(i,"value2"),data:getString(i,"value3")})
        name:setString(tips)
        ico:loadTexture("images/icon/task/taskIco/img0"..i.."_task.png",0)
        item:getChildByName("linkid"):setString(data:getString(i,"Link"))
        if data_type == 1 then
            type:setString(ff.langString("推荐任务"))
        elseif data_type == 2 then
            type:setString(ff.langString("科技"))
        elseif data_type == 3 then
            type:setString(ff.langString("训练"))
        elseif data_type == 4 then
            type:setString(ff.langString("杂项"))
        end
        type:getVirtualRenderer():enableBold(true)
        local sp = nil
        local function btnClick(sender,eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition() 
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end
            if eventType == ccui.TouchEventType.began then
                sp = sender:getTouchBeganPosition()
            end
            if eventType == ccui.TouchEventType.ended then
                local ep = sender:getTouchEndPosition()
                if sender:getTag() == 1 and item == sender then
                    if math.abs(sp.y - ep.y) <= 10 and math.abs(sp.x - ep.x) <= 10 then
                        doaction = true
                    else
                        doaction = false
                    end
                else
                    doaction = true
                end
            end
            if doaction == true then
                if item:getChildByName("btnAward") == sender then
                    --1.领取奖励；
                    local taskType = sender:getTag()
                    self:clientToServer(taskType)
                    local task_id = item.id
                elseif sender == item or sender == item:getChildByName("btnSee") then
                    self.flag = item:getTag()
                    pop.onShowPopDialog("taskInfo")
                    AudioEngine.playEffect(ff.sounds[109])
                end
            end
        end        

        item:setTag(i)
        item:addTouchEventListener(btnClick)
        item:getChildByName("btnSee"):addTouchEventListener(btnClick)
        item:getChildByName("btnAward"):addTouchEventListener(btnClick)
        item:setVisible(true)
        if data_type == 1 then
            local giftInfo = data:getString(i,"rewshow")
            local gift = Split(giftInfo,'%^')
            local intValue = tonumber(gift[1])
            if intValue == 7 then
                item:getChildByName("image"):setScale(1.2)
            end
            item:getChildByName("image"):loadTexture(dd.getPathFromUI("public/v2/res_ic0"..(intValue-1)..".png",1))
            item:getChildByName("label"):setString("+"..tonumber(gift[3]))
        end
    end
    if data ~= nil then
        data:clear()
    end 
end

function taskLayer:isFinished(value, tag,target)

    cclog("value:"..value..",tag:"..tag)
    local item = nil
    if tag == 1 then
        item = self:getChildByName("main"):getChildByName("item")
    else
        item = target
    end
    local btn_see = item:getChildByName("btnSee")
    local btn_award = item:getChildByName("btnAward")
    local progress = item:getChildByName("prog")

    local t_type = item:getChildByName("chu_type")
    local t_name = item:getChildByName("name")
    local icon = item:getChildByName("image")
    local label = item:getChildByName("label")


    if value == 1 then
        btn_award:setVisible(true)
        --btn_award:setBright(true)
        if tag == 1 then
            btn_see:setVisible(true)
        else
            btn_see:setVisible(false)
        end
        btn_award:setTouchEnabled(true)
        btn_award:setTag(tag)
        --progress:setVisible(false)
    elseif value == 0 then
        btn_award:setVisible(false)
        progress:setVisible(true)
        btn_see:setVisible(true)
    elseif value == 9 then
        btn_award:setVisible(true)
        btn_award:setBright(false)
        btn_see:setVisible(false)
        btn_award:setTouchEnabled(false)
        --progress:setVisible(false)

        btn_award:getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
    end
end

function taskLayer:onGetTaskInfo(params)
    local code = params[1]
    if code == 0 then 
        cclog("onGetTaskInfo")
        self.succuce = true    
        self:getData()
        if self.succuce ~= nil then
            if pop.getDialog("taskInfo") ~= nil then
                pop.getDialog("taskInfo"):onAutoSize()
                pop.getDialog("taskInfo"):initMethods()
            end
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function taskLayer.onEnd(sender,btns)
    dd.delBackEvent(sender.onReturn)
    ff.net:removeEvent(2,dd.Tjf_task_take_bonus)
    ff.net:removeEvent(3,dd.Tjf_notify_SNGetBonus)
    ff.net:unbindProperty("gold",2601)


    if btns == nil then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:unSelectBtns()
        end 
    end
    local reward = pop.getDialog("reward")
    if reward ~= nil and reward:isVisible() == true then
        pop.onClosePopDialog("reward")
    end
end

function taskLayer:clientToServer(tType)
    local message = ff.net:createMessage()
    message:addCmd(0x00000164)
    message:addLong(dd.uid)
    message:addLong(tType)
    ff.net:rpc(message, false)
end

function taskLayer:popRewardDialog(message)
    if table.getn(message) > 0 then
        if message[1]["from"] == 3 then
            pop.onShowPopDialog("reward",message)
        end
    else
        return 
    end
end

function taskLayer.onBefore(sender)
    ff.net:registerEvent(2,dd.Tjf_task_take_bonus, function (message)sender:onGetTaskInfo(message)end)
    ff.net:registerEvent(3,dd.Tjf_notify_SNGetBonus, function (message) sender:popRewardDialog(message) end)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("img"),sender:getChildByName("top"):getChildByName("addgold"))
    sender:getData()
end

function taskLayer.onStart(sender) 
    ff.net:bindProperty(2601,"gold",sender.updateGold)     
end

function taskLayer.updateGold()
    local sender = pop.getDialog("task")
    if sender ~= nil then
        sender:getChildByName("top"):getChildByName("number"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("top"):getChildByName("number"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("top"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("top"):requestDoLayout()
    end
end

function showUpdateBuilding(params)
    local pos = params[1]
    local param1 = params[2]
    local param2 = params[3]
    cclog("showUpdateBuilding:"..pos..",param1:"..param1)
    if dd.currentLayer._building ~= nil then
        local build = dd.currentLayer._building:getChildByTag(pos)
        local x = dd.cfgPos[pos]['x']
        local y = 2208- dd.cfgPos[pos]['y']
        --301 : 城墙 --101 ：司令部
        if pos == 301 then
            x = 2000
            y = 1000
        end

        if param1 == 0 or param1 == 1 then
            dd._saveparam = {pos,nil,param2}
        else
            dd._saveparam = {pos,2,param2}
        end
        dd.currentLayer:runAction(
            cc.Sequence:create(
                cc.CallFunc:create(function() dd.MoveMapPointToScreenCenter(cc.p(x,y),1,pos) end),
                cc.DelayTime:create(0.5),
                cc.CallFunc:create(function() 
                                                build:flash(true) 
                                           end))
        )
    end
end
--建筑还没造
function skipCreateBuildLayer(params)
    local bid = params[1]
    local build_type = dd.cfgBuilding[bid]['type']
    local build_mod = dd.cfgBuilding[bid]['mod']

    local order = nil
    if dd.cfgPosOrder[bid] == nil then
        order = dd.cfgPosOrder[1000]
    else
        order = dd.cfgPosOrder[bid]
    end
    for i,_pos in ipairs(order) do
        if dd.cfgPos[_pos]['type'] == build_type then
            if dd.cfgPos[_pos]['mod'] == build_mod then
                if dd.cfgPos[_pos]['lv'] <= dd.myinfo:getLong(1,"level") then
                    for i=1,dd.mybuilds:rowCount() do  
                        if _pos == dd.mybuilds:getLong(i,"pos") then     
                             _pos = nil
                             break
                        end
                    end
                    if dd.currentLayer._building ~= nil then
                        if _pos ~= nil then
                            local build = dd.currentLayer._building:getChildByTag(_pos)
                            cclog("bid1:".._pos)
                            local x = dd.cfgPos[_pos]['x']
                            local y = 2208- dd.cfgPos[_pos]['y']
                            
                            build._newbie = bid
                            dd.currentLayer:runAction(
                                cc.Sequence:create(
                                    cc.CallFunc:create(function() dd.MoveMapPointToScreenCenter(cc.p(x,y),1,_pos) end),
                                    cc.DelayTime:create(0.5),
                                    cc.CallFunc:create(function() build:flash(true) end))
                                    --cc.CallFunc:create(function() onShowBuildsList(dd.currentLayer._widget,_pos) end))
                            )
                            return true
                        end
                    end
                end
            end
        end
    end
    return false
end

function onShowTask(widget,tid,linkid)
    local tick = ff.gameCore:getTick()
    if tid == nil and linkid == nil then
        cclog("Opening task dialog...")
        local layer = taskLayer.extend(widget)
        dd.regeditBackEvent(layer.onReturn)
        layer:onInit()
        return layer
    else
        local have = true
        local function commonEntry(bid,show,param)
            for i=1,dd.mybuilds:rowCount() do
                if dd.mybuilds:getLong(i,"bid") == bid then
                    onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"),show,param)   
                    have = false
                    break
                end
            end
        end
        if linkid == nil then
            local strSQL = "SELECT * FROM `cfg_basetask` WHERE `taskid`="..tid
            local data = ff.dbmanager:sql_fetch_rows(strSQL)
            if data ~= nil then
                if data:rowCount() == 1 then
                    linkid =  tonumber(data:getString(1,"Link"))
                    data:clear()
                else
                    data:clear()
                    return
                end
            else
                return
            end
        end
        local taskLink = "SELECT `linkid`, `type`, `id`, `param1`, `param2` FROM `cfg_task_link` WHERE linkid="..linkid
        local linkInfo = ff.dbmanager:sql_fetch_rows(taskLink)
        if linkInfo == nil then
            return
        end
        local type   = tonumber(linkInfo:getString(1,"type"))
        local id     = tonumber(linkInfo:getString(1,"id"))
        local param1 = tonumber(linkInfo:getString(1,"param1"))
        local param2 = tonumber(linkInfo:getString(1,"param2"))

        if linkInfo ~= nil then
            linkInfo:clear()
        end         
        cclog("linkid:"..linkid)
        --cclog("type: "..type.."==id: "..id.."==param1: "..param1)
        if type == 1 then
            --已经造了，打开界面
            if tid ~= nil then
                local row = ff.dbmanager:sql_fetch_rows("select `value1`,`value2`,`value3` from cfg_basetask where `taskid`='"..tid.."'")
                if row ~= nil then
                    if row:rowCount() == 1 then
                        local value2 = tonumber(row:getString(1,"value2"))--几个
                        local value3 = tonumber(row:getString(1,"value3"))--几级
                        --只有一个参数，表示升级到
                        if value3 == 0 then
                            value3 = value2
                            value2 = 1
                        end
                        row:clear()
                        cclog(value2..","..value3)
                        --先升级
                        local count1 = 0
                        local count2 = 0
                        for i=1,dd.mybuilds:rowCount() do
                            if dd.mybuilds:getLong(i,"bid") == id then
                                count1 = count1 + 1
                                if dd.mybuilds:getLong(i,"level") >= value3 then
                                    count2 = count2 + 1
                                end
                            end                            
                        end
                        if dd.cityLayer ~= nil then
                            if count2 < value2 then
                                local maxlevel = 0
                                for i=1,dd.mybuilds:rowCount() do
                                    if dd.mybuilds:getLong(i,"bid") == id and dd.mybuilds:getLong(i,"level") < value3 then
                                        if maxlevel < dd.mybuilds:getLong(i,"level") then
                                            maxlevel = dd.mybuilds:getLong(i,"level")
                                        end
                                    end
                                end
                                for i=1,dd.mybuilds:rowCount() do
                                    if dd.mybuilds:getLong(i,"bid") == id and dd.mybuilds:getLong(i,"level") == maxlevel then
                                        local pos = dd.mybuilds:getLong(i,"pos")
                                        local build = dd.cityLayer._building:getChildByTag(pos)
                                        build._newbie = id
                                        dd._saveparam = {pos,2,id}
                                        dd.currentLayer:runAction(
                                            cc.Sequence:create(
                                                cc.CallFunc:create(function() dd.MoveMapPointToScreenCenter(cc.p(0,0),1,pos) end),
                                                cc.DelayTime:create(0.5),
                                                cc.CallFunc:create(function() build:flash(true) end))
                                        )
                                        return
                                    end
                                end
                            end
                            if count1 < value2 then
                                skipCreateBuildLayer({id})
                                return                                
                            end
                            return
                        end
                    end
                    return
                end
            else
                for i=1,dd.mybuilds:rowCount() do
                    if dd.mybuilds:getLong(i,"bid") == id then
                        if dd.currentLayer._name ~= "CityLayer" then
                            dd.yunClose(1)
                            dd.regCallBack(1,1,showUpdateBuilding,{dd.mybuilds:getLong(i,"pos"),param1,param2})
                        else
                            cclog("pos:"..dd.mybuilds:getLong(i,"pos"))
                            showUpdateBuilding({dd.mybuilds:getLong(i,"pos"),param1,param2})
                        end            
                        return
                    end
                end
            end
        elseif type == 2 then
            if param1 == 0 then
                --join union
                pop.onShowPopDialog("noUnion",1)
            else
                if dd.myUnion:getLong(1,"unionid") <= 0 then
                    pop.onShowPopDialog("noUnion",1)
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("请先加入联盟 ！"))
                else
                    if param1 == 1 then
                    --Oversee
                    if param2 == 1 then
                        pop.onShowPopDialog("unionMember")
                    elseif param2 == 2 then
                        pop.onShowPopDialog("unionTec")
                    elseif param2 == 3 then
                        pop.onShowPopDialog("unionHelp")
                    elseif param2 == 4 then
                        pop.onShowPopDialog("unionOption")
                    end
                    elseif param1 == 2 then
                    --union shop
                    elseif param1 == 3 then
                    --Deplomacy
                    end
                end
            end
        elseif type == 3 then
            if dd.currentLayer._name ~= "WorldUILayer"then
                dd.yunClose(2)
            end
        elseif type == 4 then
            if dd.currentLayer._name ~= "pve" then
                dd.yunClose(3)
                return
            end
        elseif type == 5 then
            pop.onShowPopDialog("lottery")
        elseif type == 6 then
            if dd.currentLayer._name ~= "CityLayer" then
                dd.yunClose(1)
                dd.regCallBack(1,6,showUpdateBuilding,{104,0,id})
            else
                showUpdateBuilding({104,0,id})
            end            
            return
            --commonEntry(11,nil,id) --科技
        elseif type == 7 then
            local pos = 0
            for i=1,dd.mybuilds:rowCount() do
                if dd.mybuilds:getLong(i,"bid") == id then
                    pos = dd.mybuilds:getLong(i,"pos")
                    break
                end
            end            
            if pos > 0 then
                if dd.currentLayer._name ~= "CityLayer" then
                    dd.yunClose(1)
                    dd.regCallBack(1,7,showUpdateBuilding,{pos,0,id})
                else
                    showUpdateBuilding({pos,0,id})
                end            
                return
            end
            have = true
            --兵营、城墙、军械库
            --commonEntry(id,nil,param1)
        elseif type == 8 then
            skipCreateBuildLayer({id})
            return
        elseif type == 9 then
            pop.onShowPopDialog("charge")
        elseif type == 10 then
            pop.onShowPopDialog("powerInfo")
        elseif type == 11 then
            pop.onShowPopDialog("gameSet")
        elseif type == 12 then
            --产量达到
            --推荐升级，没的升了，推荐任意一个建筑
            local tjpos = 0
            if dd.cityLayer ~= nil and dd.cityLayer._level ~= nil then
                for i=1,dd.mybuilds:rowCount() do
                    if dd.mybuilds:getLong(i,"bid") == id then
                        local item = dd.cityLayer._level:getChildByTag(dd.mybuilds:getLong(i,"pos") * 1000 + 2)
                        if item ~= nil then
                            local pos = dd.mybuilds:getLong(i,"pos")
                            local build = dd.cityLayer._building:getChildByTag(pos)
                            build._newbie = id
                            dd._saveparam = {pos,2,id}
                            dd.currentLayer:runAction(
                                cc.Sequence:create(
                                    cc.CallFunc:create(function() dd.MoveMapPointToScreenCenter(cc.p(0,0),1,pos) end),
                                    cc.DelayTime:create(0.5),
                                    cc.CallFunc:create(function() build:flash(true) end))
                            )
                            return
                        end
                        tjpos = dd.mybuilds:getLong(i,"pos")
                    end
                end
                if skipCreateBuildLayer({id}) == false then
                    local build = dd.cityLayer._building:getChildByTag(tjpos)
                    build._newbie = id
                    dd._saveparam = {tjpos,2,id}
                    dd.currentLayer:runAction(
                        cc.Sequence:create(
                            cc.CallFunc:create(function() dd.MoveMapPointToScreenCenter(cc.p(0,0),1,tjpos) end),
                            cc.DelayTime:create(0.5),
                            cc.CallFunc:create(function() build:flash(true) end))
                    )
                end
              
                return
            end
        elseif type == 13 then
            if dd.currentLayer._building ~= nil then
                if id ~= nil then
                    local build = dd.currentLayer._building:getChildByTag(id)
                    if build ~= nil then
                        dd.currentLayer:runAction(
                            cc.Sequence:create(
                                cc.CallFunc:create(function() dd.MoveMapPointToScreenCenter(cc.p(0,0),1,id) end),
                                cc.DelayTime:create(0.5),
                                cc.CallFunc:create(function() build:flash(true) end))
                        )
                    end
                    return
                end
            end
            return
        end
        if type == 2 or type ==3 or type == 4 or type == 5 or type == 9 or type == 10 or type == 11 then
            have = false
        end
        if have == true then
            have = false
            if dd.currentLayer._name ~= "CityLayer" then
                dd.yunClose(1)
                dd.regCallBack(1,2,skipCreateBuildLayer,{id})
            else
                skipCreateBuildLayer({id})
            end
        end

    end
end
--在创建的时候调用
function onCreateTaskPannel(widget)
    local layer = taskLayer.extend(widget)
    if layer._init == false then
        layer._init = true
        local hh = ff.height-214
        layer:setContentSize(cc.size(720,hh))  
        layer:getChildByName("bgLayer"):setContentSize(cc.size(720, hh))
        layer:getChildByName("bgLayer"):setPositionY(0)

        layer:getChildByName("top"):setPositionY(hh - 105)
        layer:getChildByName("main"):setPositionY(hh - 105 - 271)
        layer:getChildByName("view"):setContentSize(cc.size(720,hh - 105 - 280))
        layer:getChildByName("view"):setPositionY(0)

        layer:getChildByName("top"):getChildByName("return"):addTouchEventListener(layer.onReturn)
        layer:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)

        layer.t_typeY = layer:getChildByName("main"):getChildByName("item"):getChildByName("chu_type"):getPositionY()
        layer.t_nameY = layer:getChildByName("main"):getChildByName("item"):getChildByName("name"):getPositionY()
        layer.iconY = layer:getChildByName("main"):getChildByName("item"):getChildByName("image"):getPositionY()
        layer.labelY = layer:getChildByName("main"):getChildByName("item"):getChildByName("label"):getPositionY()
        layer.btnY = layer:getChildByName("main"):getChildByName("item"):getChildByName("btnAward"):getPositionY()

        layer:getData()
    end
    return layer
end
