towerfightLayer = class("towerfightLayer")
towerfightLayer._name = "towerfight"
towerfightLayer._init = false
towerfightLayer._params = nil
towerfightLayer._npc={}
towerfightLayer._isget = false
towerfightLayer._first = true

function towerfightLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,towerfightLayer)
	return target
end

function towerfightLayer:onInit(  )
	-- body
	if self._init == false then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		self:setPositionY(0)
        self:getChildByName("top"):setPositionY(hh - 105)
		self:getChildByName("back"):setContentSize(cc.size(720,1280))
        self:getChildByName("back"):loadTexture("images/active/tower_fight_back.png",0)
        self:getChildByName("reward"):setPositionY(hh - 104 -105)
        self:getChildByName("oper"):setPositionY(0)
        self:getChildByName("touch"):setPositionY((hh - 104 -105 )/2 - 250)
        self:getChildByName("chu_Label1"):setPositionY((hh - 104 -105 )/2+250)
        self:getChildByName("chu_Label2"):setPositionY((hh - 104 -105 )/2+250)
        self:getChildByName("npc"):setPositionY(200)
        self:getChildByName("help"):setPositionY(200)
        self:getChildByName("box"):setPositionY(200)
        self:getChildByName("reward"):getChildByName("item"):addTouchEventListener(self.onItem)
        self:getChildByName("oper"):getChildByName("help"):getChildByName("hit"):addTouchEventListener(self.onHelp)
        self:getChildByName("oper"):getChildByName("Button_27"):addTouchEventListener(self.onAddT)
        self:getChildByName("npc"):getChildByName("troop"):addTouchEventListener(self.onTroop)
        self:getChildByName("oper"):getChildByName("hit"):getChildByName("hit"):addTouchEventListener(self.onHit)
        self:getChildByName("oper"):getChildByName("hit"):getChildByName("hit2"):addTouchEventListener(self.onHit2)
        self:getChildByName("touch"):addTouchEventListener(self.onTouch)
        self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
        self._init = true
	end
    self._isget = false
    self._first = true
	self.updateGold()
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("images/pve/PveAnimation/PveAnimation0.png", "images/pve/PveAnimation/PveAnimation0.plist" , "images/pve/PveAnimation/PveAnimation.ExportJson")
end

function towerfightLayer.onHit( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("towerfight")
        if widget ~= nil then
            if widget._params == nil then
                local params = {}
                params.cid = 0
                
                params.uid = 0
                params.unionid = dd.myUnion:getLong(1,"unionid")
                params.short =dd.myUnion:getString(1,"unionflag") 
                params.ulevel=dd.myUnion:getLong(1,"level")
                params.name = dd.myUnion:getString(1,"unionname")  
                params.level= dd.myinfo:getLong(1,"level")

                params.count=0
                params.res  = 0
                params.friend=0
                params.protect=0
                params.maxarmys = 99999999
                pop.onShowPopDialog("chuzhen",88,params,widget.setTroops)
            else
                if widget:checkTi() == true then
                    widget._isget = true
                    widget:Hit(0)
                    widget:NpcFuck(1)
                end
            end
        end
    end
end

function towerfightLayer.onHelp( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("towerfight")
        if widget ~= nil then
            if widget:checkTi() == true then
                widget._isget = true
                widget:showHelp(2)
                local function sched()
                    widget:goHelp()
                end 
                performWithDelay(widget,sched,1.5)
            end
        end
    end
end

function towerfightLayer:goHelp(  )
    local message = ff.net:createMessage()
    message:addCmd(0x00000145)
    message:addLong(dd.uid)
    message:addLong(13)
    message:addLong(0)
    message:addLong(0)

    message:addLong(0)
    message:addLong(0)
    message:addLong(0)

    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    for i=1,16 do
        message:addLong(0)
    end
    ff.net:rpc(message,false)
end

function towerfightLayer.onAddT( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("towerfight")
        if widget ~= nil then
            local function callback()
                local message = ff.net:createMessage()
                message:addCmd(0x00000145)
                message:addLong(dd.uid)
                message:addLong(9)
                message:addLong(0)
                message:addLong(0)

                message:addLong(0)
                message:addLong(0)
                message:addLong(0)

                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                for i=1,16 do
                    message:addLong(0)
                end
                ff.net:rpc(message,false)
            end
            
            if dd.getToolsCount(1256) < 1 then

                dd.currentLayer._widget:onShowSure(ff.langString("警告"),ff.langString("你的水饺不足，是否使用{0}金币回复耐力",{dd.cfgProp[1256]['value']}),callback,true,2)
            else
                widget._isget = true
                callback()
            end

            
        end
    end
end

function towerfightLayer.onItem( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("towerfight")
        if widget ~= nil then
            local id = sender:getTag()
            pop.onShowPopDialog("SurpriseRecharge",7,id)
        end
    end
end

function towerfightLayer.onTroop( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("towerfight")
        if widget ~= nil then
           
            local params = {}
            params.cid = 0
            
            params.uid = 0
            params.unionid = dd.myUnion:getLong(1,"unionid")
            params.short =dd.myUnion:getString(1,"unionflag") 
            params.ulevel=dd.myUnion:getLong(1,"level")
            params.name = dd.myUnion:getString(1,"unionname")  
            params.level= dd.myinfo:getLong(1,"level")

            params.count=0
            params.res  = 0
            params.friend=0
            params.protect=0
            params.maxarmys = 99999999
            pop.onShowPopDialog("chuzhen",88,params,widget.setTroops)
            
        end
    end
end

function towerfightLayer.onHit2( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("towerfight")
        if widget ~= nil then
            if widget._params == nil then
                local params = {}
                params.cid = 0
                
                params.uid = 0
                params.unionid = dd.myUnion:getLong(1,"unionid")
                params.short =dd.myUnion:getString(1,"unionflag") 
                params.ulevel=dd.myUnion:getLong(1,"level")
                params.name = dd.myUnion:getString(1,"unionname")  
                params.level= dd.myinfo:getLong(1,"level")

                params.count=0
                params.res  = 0
                params.friend=0
                params.protect=0
                params.maxarmys = 99999999
                pop.onShowPopDialog("chuzhen",88,params,widget.setTroops)
            else
                if widget:checkTi() == true then
                    widget._isget = true
                    widget:Hit(1)
                    widget:NpcFuck(2)
                end
            end
        end
    end
end


function towerfightLayer:Hit( type )
    
    local message = ff.net:createMessage()
    message:addCmd(0x00000145)
    message:addLong(dd.uid)
    message:addLong(12)


    message:addLong(type)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    
    message:addLong(self._params.hid)

    local armys = ff.dbmanager:sql_fetch_rows("select `soldierid` from cfg_soldier where `type` in ('1','2','3','21') and `step`<='6' order by `type` asc,`step` asc")
    if armys ~= nil then
        for i=1,armys:rowCount() do
            local sid = tonumber(armys:getString(i,"soldierid"))
            if self._params.soliders[sid] == nil then
                message:addLong(0)
            else
                message:addLong(self._params.soliders[sid])
            end 
        end
        --工程车预留3级
        message:addLong(0)
        message:addLong(0)
        --message:addLong(0)
        if self._params.lianjin == true then
            message:addLong(1)
        else
            message:addLong(0)
        end
        for i=1,15 do
            message:addLong(0)
        end
        ff.net:rpc(message,false)
        armys:clear()
    end

end

function towerfightLayer:checkTi( )
     local now = dd.myTowerInfo:getLong(1,"nowTi") + math.floor((dd.getServerTime() - dd.myTowerInfo:getLong(1,"TimeTi"))/1800)
    if self._isget == true then
        return false
    end
    if now < 1 then
        dd.mainUI:onShowTips(ff.langString("耐力不足"))
        return false
    else
        return true
    end
end


function towerfightLayer.setTroops( hid,soliders ,lianjin )
    local widget = pop.getDialog("towerfight")
        if widget ~= nil then
        widget._params = {}
        widget._params.hid = hid 
        widget._params.soliders = soliders
        widget._params.lianjin = lianjin
    end
end

function towerfightLayer.onTouch( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("towerfight")
        if widget ~= nil then
            if dd.myTowerInfo:getLong(1,"state") == 0 then
                if dd.myTowerInfo:getLong(1,"bu") == 0 and dd.myTowerInfo:getLong(1,"ceng") ~= 1 then
                    if widget:getChildByName("chu_Label2"):isVisible() == true then
                        widget:getChildByName("chu_Label2"):setVisible(false)
                        widget:getChildByName("chu_Label1"):setVisible(true)
                        widget:yunOpen()
                        return
                    
                    end
 
                end
                if widget:checkTi() == true then
                    widget._isget = true
                    widget:getChildByName("chu_Label1"):setVisible(false)
                    widget:gogogo()
                    local function sched()
                        widget:goNext()
                    end 
                    performWithDelay(widget,sched,2.5)
                end
                return
            elseif dd.myTowerInfo:getLong(1,"state") == 2 then
                if widget:checkTi() == true then
                    widget._isget = true
                    widget:getChildByName("chu_Label1"):setVisible(false)
                    
                    widget:gogogo()
                    local function sched()
                        widget:goNext()
                    end 
                    performWithDelay(widget,sched,2.5)
                end
                return
            end
            if dd.myTowerInfo:getLong(1,"chang") == 0 then
                
            elseif dd.myTowerInfo:getLong(1,"chang") == 1 then
                
                if dd.myTowerInfo:getLong(1,"state") == 1 then
                    if widget:checkTi() == true then
                        widget._isget = true
                        widget:showBox(2)
                        local function sched()
                            widget:getBox()
                        end 
                        performWithDelay(widget,sched,2)
                    end
                end
            elseif dd.myTowerInfo:getLong(1,"chang") == 2 then
                
            elseif dd.myTowerInfo:getLong(1,"chang") == 3 then
                
            end
        end
    end
end


function towerfightLayer.onStart( sender )
    
	ff.net:bindProperty(2339,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
    sender:getinfo()
    schedule(sender,sender.update,1)
end


function towerfightLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("towerfight")
		if widget == nil then
			return
		end
        pop.onClosePopDialog("towerfight")
    end
end


function towerfightLayer.onEnd( sender )
    -- body
    sender:getChildByName("reward"):getChildByName("ScrollView"):removeAllChildren(true)
    sender:getChildByName("back"):stopAllActions()
    sender:getChildByName("npc"):getChildByName("nom"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    sender:getChildByName("npc"):getChildByName("nom"):stopAllActions()

    sender:getChildByName("help"):getChildByName("npc"):getVirtualRenderer():stopAllActions()
    sender:stopAllActions()
    dd.delBackEvent()
    ff.net:unbindProperty("gold",2339)
    ff.net:removeEvent(2,dd.Tjf_towerfightAction)
    ff.net:removeEvent(2,dd.Tjf_notify_SNEvtTower)
    ff.net:removeEvent(5,dd.Tjf_notify_SNGetBonus)
    ff.net:removeEvent(1,dd.Tjf_notify_SNEvtMall)
    ff.net:removeEvent(1,dd.Tjf_notify_EvtMallBuy)
    
    
    
end

function onShowtowerfight(widget)
	-- body
	local layer = towerfightLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end

function towerfightLayer:getinfo(  )
    local message = ff.net:createMessage()
    message:addCmd(0x00000145)
    message:addLong(dd.uid)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)

    message:addLong(0)
    message:addLong(0)
    message:addLong(0)

    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    for i=1,16 do
        message:addLong(0)
    end
    ff.net:rpc(message,false)
end

function towerfightLayer:NpcFuck(type  )
    if type ==  1 then
        local function addBaoji()
            local attackEF = ccs.Armature:create("PveAnimation")
            attackEF:getAnimation():play("baoji")
            attackEF:setPosition(300, 630)
            attackEF:setAnchorPoint(cc.p(0.5, 5/6))
            attackEF:setScale(2)
            self:getChildByName("npc"):addChild(attackEF, 10)

            local dk = cc.Sprite:create("images/pve/dankong.png");
            dk:setPosition(300, 630)
            dk:setScale(1.5)
            self:getChildByName("npc"):addChild(dk, 9)
            local xj = cc.Sprite:create("images/pve/xueji.png");
            xj:setPosition(150, 520)
            xj:setScale(5)
            self:getChildByName("npc"):addChild(xj, 10)

            --LShake_(self.battleBG)
            dd.shake(self:getChildByName("npc"))
            self:runAction(cc.Sequence:create(
                cc.DelayTime:create(1),
                cc.CallFunc:create(function () attackEF:removeFromParent()  dk:removeFromParent() xj:removeFromParent() end)
            ))
        end
        local sprite = sp.SkeletonAnimation:create("images/pve/Final_1_0.json", "images/pve/Final_1_0.atlas")
        sprite:setPosition(300, 630)
        sprite:setAnimation(0, "juji_animation", false)
        self:getChildByName("npc"):addChild(sprite, 5)
        performWithDelay(sprite, function()  addBaoji() sprite:removeFromParent() end, 0.5)

    
        AudioEngine.playEffect(ff.sounds[303]) 
    else
        local sprite = sp.SkeletonAnimation:create("images/pve/skeleton.json", "images/pve/skeleton.atlas")
        sprite:setPosition(cc.p(360, 300))
        sprite:setAnimation(0, "Headshot_animation", false)
        self:getChildByName("npc"):addChild(sprite, 5)
        performWithDelay(sprite, function()  sprite:removeFromParent() end, 2)

        local pram = 0
        local attackEF = {}
        attackEF[1] = {}
        attackEF[2] = {}
        local zombiePosX, zombiePosY = self:getChildByName("npc"):getPosition()
        function addEF()
            pram = pram + 1  
            if pram > 6 then
                return 
            end             
            local randomPosX, randomPosY = zombiePosX + math.random(-300, 300) +360, zombiePosY + math.random(50, 400)                
            attackEF[1][pram] = ccs.Armature:create("PveAnimation")
            attackEF[1][pram]:getAnimation():play("attack")
            attackEF[1][pram]:setPosition(cc.p(randomPosX, randomPosY))
            attackEF[1][pram]:setAnchorPoint(cc.p(0.7, 0.5))
            attackEF[1][pram]:setScale(math.random(300, 500) / 100)
            self:getChildByName("npc"):addChild(attackEF[1][pram], 9)
                
            attackEF[2][pram] = cc.Sprite:create("images/pve/dankong.png")
            attackEF[2][pram]:setPosition(cc.p(randomPosX, randomPosY))
            attackEF[2][pram]:setScale(math.random(40, 100) / 100)
            self:getChildByName("npc"):addChild(attackEF[2][pram], 10)

            --LShake_(self.battleBG)
            dd.shake(self:getChildByName("npc"))
            attackEF[2][pram]:runAction(cc.Sequence:create(cc.FadeOut:create(1), cc.CallFunc:create(
                function ()
                    for i = 1, 6 do
                        if attackEF[1][i] ~= nil then
                            attackEF[1][i]:removeFromParent()
                            attackEF[1][i] = nil
                        end
                        if attackEF[2][i] ~= nil then
                            attackEF[2][i]:removeFromParent()
                            attackEF[2][i] = nil
                        end    
                    end
                end)))     
            AudioEngine.playEffect(ff.sounds[302])              
        end
        self:runAction(cc.Repeat:create(cc.Sequence:create(cc.CallFunc:create(addEF), cc.DelayTime:create(0.15)), 6))
    end
end

function towerfightLayer:helpFuck(  )
    
        local pram = 0
        local attackEF = {}
        attackEF[1] = {}
        attackEF[2] = {}
        local zombiePosX, zombiePosY = self:getChildByName("help"):getPosition()
        function addEF()
            pram = pram + 1  
            if pram > 1 then
                return 
            end             
            local randomPosX, randomPosY = zombiePosX + 360, zombiePosY + 400               
            attackEF[1][pram] = ccs.Armature:create("PveAnimation")
            attackEF[1][pram]:getAnimation():play("attack")
            attackEF[1][pram]:setPosition(cc.p(randomPosX, randomPosY))
            attackEF[1][pram]:setAnchorPoint(cc.p(0.7, 0.5))
            attackEF[1][pram]:setScale(math.random(300, 500) / 100)
            self:getChildByName("help"):addChild(attackEF[1][pram], 9)
                
            attackEF[2][pram] = cc.Sprite:create("images/pve/dankong.png")
            attackEF[2][pram]:setPosition(cc.p(randomPosX, randomPosY))
            attackEF[2][pram]:setScale(math.random(40, 100) / 100)
            self:getChildByName("help"):addChild(attackEF[2][pram], 10)

            --LShake_(self.battleBG)
            dd.shake(self:getChildByName("help"))
            attackEF[2][pram]:runAction(cc.Sequence:create(cc.FadeOut:create(1), cc.CallFunc:create(
                function ()
                    for i = 1, 1 do
                        if attackEF[1][i] ~= nil then
                            attackEF[1][i]:removeFromParent()
                            attackEF[1][i] = nil
                        end
                        if attackEF[2][i] ~= nil then
                            attackEF[2][i]:removeFromParent()
                            attackEF[2][i] = nil
                        end    
                    end
                end)))     
            AudioEngine.playEffect(ff.sounds[302])              
        end
        self:runAction(cc.CallFunc:create(addEF))
end

function towerfightLayer.onBefore( sender)
    ff.net:registerEvent(1,dd.Tjf_notify_EvtMallBuy, function (message)sender:onEvtMallBuy(message)end)
    ff.net:registerEvent(1,dd.Tjf_notify_SNEvtMall, function (message)sender:onSNEvtMall(message)end)  
    ff.net:registerEvent(5,dd.Tjf_notify_SNGetBonus, function (message) sender:popRewardDialog(message) end)
    ff.net:registerEvent(2,dd.Tjf_towerfightAction, function (message)sender:ontowerfightAction(message)end)
    ff.net:registerEvent(2,dd.Tjf_notify_SNEvtTower, function (message)sender:onSNEvtTower(message)end)                
end

function towerfightLayer:onEvtMallBuy(params)
    if params[1] == 0 then
        local id = params[2]
        local item = self:getChildByName("reward"):getChildByName("ScrollView"):getChildByTag(id)
        if item ~= nil then
            item:removeFromParent(true)
        end
        local index = 0
        for i=1,dd.myEvtMall:rowCount() do
            if dd.myEvtMall:getLong(i,"id") == id then
                index = i
            end
        end
        if index > 0 then
            dd.myEvtMall:delRow(index)
        end
    end
    
end

function towerfightLayer:popRewardDialog(infos)
    if table.getn(infos) > 0 then
        --商店里，是购买的才提示
        if infos[1]["from"] == 25 or  infos[1]["from"] == 26 then
            
            pop.onShowPopDialog("reward",infos)
        end
    else
        return 
    end
end

function towerfightLayer:ontowerfightAction(  params)
    local code = params[1]
    if code == 0 then   

        self._info = params[2]

        if dd.myTowerInfo:getLong(1,"chang") == 2 then
            if dd.myTowerInfo:getLong(1,"state") == 0 then
                self._npc.startHp = 0
                self._npc.endHp = 0
            elseif dd.myTowerInfo:getLong(1,"state") == 2 then
                if self._info.type == 12 then
                    pop.onShowPopDialog("reward",self._info.list)
                end
            else
                if self._info.startHp ~= 0 then
                    self._npc.startHp = self._info.startHp
                    self._npc.endHp = self._info.endHp
                end
            end

        else
            self._npc = {}
        end
        self:refreshUI()
        
    else
        dd.mainUI:onShowCodeTips(code)
    end
    self._isget = false
end

function towerfightLayer.update( sender )
    local now = dd.myTowerInfo:getLong(1,"nowTi") + math.floor((dd.getServerTime() - dd.myTowerInfo:getLong(1,"TimeTi"))/1800)
    sender:getChildByName("oper"):getChildByName("number"):setString(now.."/"..dd.myTowerInfo:getLong(1,"maxTi"))
    local index = 0
    if dd.myEvtMall == nil then
        return
    end
    for i=1,dd.myEvtMall:rowCount() do
        local tag = dd.myEvtMall:getLong(i,"id")
        if dd.myEvtMall:getLong(i,"latetime") < dd.getServerTime() then
            local item = sender:getChildByName("reward"):getChildByName("ScrollView"):getChildByTag(tag)
            if item ~= nil then
                item:removeFromParent(true)
            end
        else

            local item = sender:getChildByName("reward"):getChildByName("ScrollView"):getChildByTag(tag)
            if item == nil then
                item = sender:getChildByName("reward"):getChildByName("item"):clone()
                item:setTag(tag)
                item:setVisible(true)

                sender:getChildByName("reward"):getChildByName("ScrollView"):addChild(item)
            end
            item:setPositionX(90*index)
            index = index +1
            local time = dd.myEvtMall:getLong(i,"latetime") - dd.getServerTime()
            item:getChildByName("time"):setString(ff.getLeftTime(time,":"))
        end 
    end
    sender:getChildByName("reward"):getChildByName("ScrollView"):setInnerContainerSize(cc.size(100 * index,100))
end

function towerfightLayer:refreshUI(  )
    if dd.myTowerInfo == nil then
        return
    end
    local ceng = dd.myTowerInfo:getLong(1,"ceng")
    if dd.myTowerInfo:getLong(1,"bu") == 0 then
        ceng = ceng -1 
    end
    self:getChildByName("reward"):getChildByName("zhang"):setString(ff.langString("第{0}层",{ceng}))
    local now = dd.myTowerInfo:getLong(1,"nowTi") + math.floor((dd.getServerTime() - dd.myTowerInfo:getLong(1,"TimeTi"))/1800)
    self:getChildByName("oper"):getChildByName("number"):setString(now.."/"..dd.myTowerInfo:getLong(1,"maxTi"))

    if dd.myTowerInfo:getLong(1,"chang") == 2 then
        if self._info ~= nil then
            local hp = self:getChildByName("npc"):getChildByName("hp")
            if self._npc.startHp == nil then
                hp:setVisible(false)
            else
                hp:setVisible(true)
                hp:getChildByName("number"):setString(self._npc.endHp.."/"..self._npc.startHp)
                local per = self._npc.endHp/self._npc.startHp*100
                if per < 0 then
                    per = 0
                end
                if per > 100 then
                    per = 100 
                end
                hp:getChildByName("hp"):setPercent(per)
            end

        end

        if dd.getToolsCount(1257) > 0 then
            self:getChildByName("oper"):getChildByName("hit"):getChildByName("hit2"):getChildByName("ico"):loadTexture(dd.getToolsIcon(1257),0)
            self:getChildByName("oper"):getChildByName("hit"):getChildByName("hit2"):getChildByName("number"):setString("1")
        else
            self:getChildByName("oper"):getChildByName("hit"):getChildByName("hit2"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/img01_dead.png",1))
            self:getChildByName("oper"):getChildByName("hit"):getChildByName("hit2"):getChildByName("number"):setString(dd.cfgProp[1257]['value'])
        end
    end

end

function towerfightLayer:onSNEvtTower( params )
    self:refreshUI()
    if params[1] == 1 or self._first == true then
        self._first = false
        self:checkStep()
    end
end

function towerfightLayer:onSNEvtMall( params )
    if params[1] == 1 then
        --self:getMall()
        if dd.myEvtMall:rowCount() > 0 then
            pop.onShowPopDialog("SurpriseRecharge",7,dd.myEvtMall:getLong(dd.myEvtMall:rowCount(),"id"),self.getMall)
        end
    end
end

function towerfightLayer.getMall(  )
    local widget = pop.getDialog("towerfight")
    if widget == nil then
        return
    end
    local endPos = cc.p(360,ff.height - 205)

    local icon = widget:getChildByName("reward"):getChildByName("item"):clone()
    icon:setScale(1.6)
    icon:setVisible(true)
    local pos  = cc.p(ff.width/2,ff.height/2)
    dd.mainUI:getChildByName("effect"):addChild(icon)
    icon:setPosition(cc.p(pos.x,pos.y))
    local moveup  = cc.EaseExponentialOut:create( cc.MoveTo:create(0.1, cc.p(pos.x,pos.y + 30)) )
    --local movedown = cc.MoveTo:create(0.8,endPos)
    local movedown = cc.EaseExponentialIn:create(cc.MoveTo:create(0.8,endPos))
    local seq  = cc.Sequence:create(cc.DelayTime:create(0.5),cc.FadeOut:create(0.3))
    local spaw = cc.Spawn:create(movedown,seq)
    local sequence = cc.Sequence:create(moveup,spaw,cc.RemoveSelf:create())
    icon:runAction(sequence)
end


function towerfightLayer:goNext(  )
    local message = ff.net:createMessage()
    message:addCmd(0x00000145)
    message:addLong(dd.uid)
    message:addLong(1)
    message:addLong(0)
    message:addLong(0)

    message:addLong(0)
    message:addLong(0)
    message:addLong(0)

    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    for i=1,16 do
        message:addLong(0)
    end
    ff.net:rpc(message,false)
end

function towerfightLayer:getBox(  )
    local message = ff.net:createMessage()
    message:addCmd(0x00000145)
    message:addLong(dd.uid)
    message:addLong(11)
    message:addLong(0)
    message:addLong(0)

    message:addLong(0)
    message:addLong(0)
    message:addLong(0)

    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    for i=1,16 do
        message:addLong(0)
    end
    ff.net:rpc(message,false)
end

function towerfightLayer:checkStep(  )
    if dd.myTowerInfo == nil then
        return
    end

    self:getChildByName("oper"):getChildByName("hit"):setVisible(false)
    self:getChildByName("oper"):getChildByName("help"):setVisible(false)
    if dd.myTowerInfo:getLong(1,"state") == 0 then
        self:getChildByName("npc"):setVisible(false)
        self:getChildByName("help"):setVisible(false)
        self:getChildByName("box"):setVisible(false)
        self:getChildByName("chu_Label2"):setVisible(false)
        self:getChildByName("chu_Label1"):setVisible(true)
        if dd.myTowerInfo:getLong(1,"bu") == 0 and dd.myTowerInfo:getLong(1,"ceng") ~= 1 then
            
            self:getChildByName("chu_Label2"):setVisible(true)
            self:getChildByName("chu_Label1"):setVisible(false)
        end
    elseif dd.myTowerInfo:getLong(1,"state") == 2 then
        if dd.myTowerInfo:getLong(1,"chang") == 2 then
            
                self:NpcOut()
            
            local function sched()
                self:getChildByName("npc"):setVisible(false)
                self:getChildByName("help"):setVisible(false)
                self:getChildByName("box"):setVisible(false)
                self:getChildByName("chu_Label2"):setVisible(false)
                self:getChildByName("chu_Label1"):setVisible(true)
            end 
            performWithDelay(self,sched,2)
        else
            self:getChildByName("npc"):setVisible(false)
            self:getChildByName("help"):setVisible(false)
            self:getChildByName("box"):setVisible(false)
            self:getChildByName("chu_Label2"):setVisible(false)
            self:getChildByName("chu_Label1"):setVisible(true)
        end
    else
        self:getChildByName("chu_Label2"):setVisible(false)
        self:getChildByName("chu_Label1"):setVisible(false)
        self:getChildByName("npc"):setVisible(false)
        self:getChildByName("help"):setVisible(false)
        self:getChildByName("box"):setVisible(false)
        self:checkSence()
    end
    
end

function towerfightLayer:showBox( step )
    local box = self:getChildByName("box"):getChildByTag(1)
    if box == nil then
        box = sp.SkeletonAnimation:create("images/active/posuibaoxiang.json", "images/active/posuibaoxiang.atlas")
        box:setVisible(true)
        box:setTag(1)
        box:setPosition(cc.p(360,300))
        --box:setAnimation(0, "Guangquan_animation", true)
        self:getChildByName("box"):addChild(box,1,1)
    end
    if step == 1 then
        box:setAnimation(0,"idle",true)
    else
        box:setAnimation(0,"ani",false)
    end
end

function towerfightLayer:showHelp( step )
    if step ==  1 then
        local lay = cc.LayerColor:create(cc.c4b(0,0,0,255))  
        local scene = cc.Director:getInstance():getRunningScene()
        scene:addChild(lay,99999999,99999999)
        local lab = cc.Label:createWithSystemFont("", "", 24)
        lab:setColor(cc.c3b(255,255,255))
        lab:setString(ff.langString("前方传来呼救声......"))
        lab:setPosition(cc.p(100, ff.height - 200))
        lab:setAnchorPoint(0, 0.5)
        lab:setTag(1)
        lay:addChild(lab)
        --local lay = scene:getChildByTag(99999999)
        if lay ~= nil then
            --lay:getChildByTag(1):setVisible(false)
            lay:runAction(cc.Sequence:create(cc.DelayTime:create(0.7),cc.FadeOut:create(1),cc.RemoveSelf:create()))        
        end

        self:getChildByName("help"):getChildByName("npc"):loadTexture("images/world/effects/200011_1.png",0)
        local frame = {}
        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("images/active/npc.plist")
        for i=1,8 do
            if i < 5 then
                frame[i] = cache:getSpriteFrame("200011_"..i..".png")
            else
                local j = i - 4
                frame[i] = cache:getSpriteFrame("200012_"..j..".png")
            end
        end
        local animation = cc.Animation:createWithSpriteFrames(frame, 0.2)
        self:getChildByName("help"):getChildByName("npc"):getVirtualRenderer():stopAllActions()
        self:getChildByName("help"):getChildByName("npc"):getVirtualRenderer():runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
        self:getChildByName("help"):getChildByName("tips"):getChildByName("name"):setString("Help")
    elseif step == 2 then
        self:helpFuck()
        self:getChildByName("help"):getChildByName("tips"):getChildByName("name"):setString("Thank You!")
        self:getChildByName("help"):getChildByName("npc"):loadTexture("images/world/effects/200013_1.png",0)
        local frame = {}
        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("images/active/npc2.plist")
        for i=1,4 do
            
            frame[i] = cache:getSpriteFrame("200013_"..i..".png")
            
        end
        local animation = cc.Animation:createWithSpriteFrames(frame, 0.2)
        self:getChildByName("help"):getChildByName("npc"):getVirtualRenderer():stopAllActions()
        self:getChildByName("help"):getChildByName("npc"):getVirtualRenderer():runAction(cc.Animate:create(animation))
    end
end

function towerfightLayer:gogogo(  )
    local item = self:getChildByName("back")
    item:runAction(cc.Sequence:create(
        cc.Spawn:create(cc.ScaleTo:create(0.5, 1.2),cc.MoveTo:create(0.5, cc.p(350, 525))),
        cc.ScaleTo:create(0.3, 1),
        cc.Spawn:create(cc.ScaleTo:create(0.5, 1.4),cc.MoveTo:create(0.5, cc.p(340, 520))),
        cc.ScaleTo:create(0.3, 1.2),
        cc.Spawn:create(cc.ScaleTo:create(0.5, 1.6),cc.MoveTo:create(0.5, cc.p(330, 515))),
        cc.ScaleTo:create(0.3, 1.4),
        cc.Spawn:create(cc.ScaleTo:create(0.1, 1),cc.MoveTo:create(0.1, cc.p(360, 531)))))
end

function towerfightLayer:yunOpen(  )
    local scene = cc.Director:getInstance():getRunningScene()
    local yun = scene:getChildByTag(9988)
    if yun == nil then
        yun = dd.mainUI:getChildByName("builds"):getChildByName("mask"):clone()
        yun:setVisible(true)
        sprite = sp.SkeletonAnimation:create("images/city/yun.json", "images/city/yun.atlas")
        sprite:setPositionX(360)
        sprite:setPositionY(ff.height/2)
        yun:addChild(sprite,1,1)
        scene:addChild(yun,9988,9988)
    end
    
    local function nextCall(event)
        
        yun:getChildByTag(1):unregisterSpineEventHandler(SP_ANIMATION_COMPLETE)
        dd.yunOpen()

        self:getChildByName("reward"):getChildByName("zhang"):setString(ff.langString("第{0}层",{dd.myTowerInfo:getLong(1,"ceng")}))
    end

    yun:setVisible(true)
    yun:getChildByTag(1):setAnimation(0, "Close_animation", false)
 
    yun:getChildByTag(1):registerSpineEventHandler(nextCall,SP_ANIMATION_COMPLETE)
end

function towerfightLayer:checkSence(  )
    if dd.myTowerInfo == nil then
        return
    end
    
    if dd.myTowerInfo:getLong(1,"chang") == 0 then
        self:getChildByName("npc"):setVisible(false)
        self:getChildByName("box"):setVisible(false)
        self:getChildByName("help"):setVisible(false)
    elseif dd.myTowerInfo:getLong(1,"chang") == 1 then
        self:getChildByName("npc"):setVisible(false)
        self:getChildByName("help"):setVisible(false)
        self:getChildByName("box"):setVisible(true)
        if dd.myTowerInfo:getLong(1,"state") == 1 then
            self:showBox( 1 )
        else
            self:showBox( 2 )
        end
    elseif dd.myTowerInfo:getLong(1,"chang") == 2 then
        self:getChildByName("box"):setVisible(false)
        self:getChildByName("help"):setVisible(false)
        self:getChildByName("npc"):setVisible(true)
        self:getChildByName("oper"):getChildByName("hit"):setVisible(true)
        --self:getChildByName("oper"):getChildByName("help"):setVisible(true)
        if dd.myTowerInfo:getLong(1,"can") >= 15000 and dd.myTowerInfo:getLong(1,"can") < 16000 then
            self:showNpc(1)
        elseif dd.myTowerInfo:getLong(1,"can") >= 16000 and dd.myTowerInfo:getLong(1,"can") < 17000 then
            self:showNpc(2)
        elseif dd.myTowerInfo:getLong(1,"can") >= 17000 and dd.myTowerInfo:getLong(1,"can") < 18000 then
            self:showNpc(2)
        elseif dd.myTowerInfo:getLong(1,"can") >= 18000 and dd.myTowerInfo:getLong(1,"can") < 19000 then
            self:showNpc(2)
        end
    elseif dd.myTowerInfo:getLong(1,"chang") == 3 then
        self:getChildByName("npc"):setVisible(false)
        self:getChildByName("box"):setVisible(false)
        self:getChildByName("help"):setVisible(true)
        self:getChildByName("oper"):getChildByName("help"):setVisible(true)
        self:showHelp(1)
    end
end

function towerfightLayer:showNpc( type )
    local npc = nil
    local name = {"1","3","5","104"}
    
    self:getChildByName("npc"):getChildByName("nom"):setVisible(true)
    npc = self:getChildByName("npc"):getChildByName("nom")
    npc:loadTexture("images/world/icon/npc/"..name[type]..".png",0)


    if npc ~= nil then
        npc:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.ScaleTo:create(2, 1.5),cc.ScaleTo:create(2, 1.2))))
    end
end

function towerfightLayer:NpcOut( type )
    local npc = nil
    self._npc = {}
 
        
        self:getChildByName("npc"):getChildByName("nom"):setVisible(false)
        self:getChildByName("npc"):getChildByName("nom"):stopAllActions()
        npc = self:getChildByName("npc"):getChildByName("nom"):clone()
    

    if npc ~= nil then
        npc:setVisible(true)
        npc:setPosition(cc.p(360,0))
        npc:setScale(1.5)
        self:getChildByName("npc"):addChild(npc,1,1)
        npc:runAction(cc.Sequence:create(cc.Spawn:create(
                        cc.MoveBy:create(1, cc.p(0,40)),
                        cc.FadeOut:create(2)
                        ),cc.RemoveSelf:create()))
            
    end
end

function towerfightLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("towerfight")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end