ChristmasTreeLayer = class("ChristmasTreeLayer")
ChristmasTreeLayer._name = "ChristmasTree"
ChristmasTreeLayer._init = false
ChristmasTreeLayer._reward = {}
ChristmasTreeLayer._info  = {}

function ChristmasTreeLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,ChristmasTreeLayer)
	return target
end

function ChristmasTreeLayer:onInit(  )
	-- body
	if self._init == false then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		self:setPositionY(0)
		self:getChildByName("bg"):setContentSize(cc.size(720,hh))
        self:getChildByName("info"):setPositionY(hh - 105 - 38)
        self:getChildByName("list"):setPositionY(200)
        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("list"):setContentSize(cc.size(720,hh - 105 - 38 - 200 ))
        self:getChildByName("oper"):setPositionY(0)
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onReturn)
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
        self:getChildByName("oper"):getChildByName("Button"):addTouchEventListener(self.onJuan)
        self:getChildByName("item"):getChildByName("Button"):addTouchEventListener(self.onOpenPop2)
        self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("PageView"):addEventListener(self.exchangePage)
		self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("close"):addTouchEventListener(self.onClosePop)
        self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("sure"):addTouchEventListener(self.onClosePop)
        self:getChildByName("info"):getChildByName("tips"):setString(ff.langString("如何使圣诞树成长"))
        self:getChildByName("info"):getChildByName("help"):addTouchEventListener(self.onHelp)
        self:getChildByName("pop"):getChildByName("block1"):getChildByName("content"):setString(ff.langString("圣诞活动期间，玩家消耗行动力，采集资源，消费金币，都可以获得“拐杖糖”，消耗“拐杖糖”可提升联盟圣诞树的等级。每次升级联盟全体成员赢取一份圣诞礼物。"))
        self:getChildByName("pop"):getChildByName("close"):addTouchEventListener(self.onClosePop1)
        self._init = true
	end
    self:InitData()
    self:initPageView()
	self.updateGold()
end

function ChristmasTreeLayer:initPageView()
    -- body
    local page = self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("PageView")
    local index = 0
    local count = table.getn(self._reward)
    --cclog("------------------"..count.."---"..table.getn(self._christmas_reward).."=="..#self._christmas_reward)
    local row  = 0
    for i=1,count do
        row = i - 1
        local item = page:getPage(row)
        if item == nil then
            item = self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("item"):clone()
            item:setVisible(true)
            item:setTag(i)

            item:setPosition(cc.p(0,0))
            page:insertPage(item,row)
        end
    
    end
    self:showItemByIndex(page:getCurPageIndex())
end

function ChristmasTreeLayer:showItemByIndex(index)
    self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("sure"):getChildByName("chu_Label"):setString(ff.langString("确定"))
    --self:setBtnLight(self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("sure"),false)
    local count = table.getn(self._reward)
    local item = self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("PageView"):getPage(index)
    if item ~= nil then
        self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("left"):setVisible(index>0)
        self:getChildByName("pop2"):getChildByName("pop2"):getChildByName("right"):setVisible(index<(count-1))
        item:getChildByName("Label_206"):setString(ff.langString("提升圣诞树至Lv.{0}可获得",{index+1}))
    end
    local nowindex = 1 + index

    if self._reward[nowindex] ~= nil then
        
        local giftInfo = Split(self._reward[nowindex]['reward'],'|')
        local index1 = 1
        for k,v in pairs(giftInfo) do
            local gift = Split(v,'%^')
            if item:getChildByName("itemlist"):getChildByName("item"..index1) ~= nil  then
                item:getChildByName("itemlist"):getChildByName("item"..index1):getChildByName("back"):getChildByName("icon"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                item:getChildByName("itemlist"):getChildByName("item"..index1):getChildByName("count"):getChildByName("count"):setString(gift[3])
                index1 = index1 +1
            end
        end
        if index1 <= 5 then
            for i=index1,5 do
                item:getChildByName("itemlist"):getChildByName("item"..i):getChildByName("back"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("itemlist"):getChildByName("item"..i):getChildByName("count"):getChildByName("count"):setString("")
            end
        end
    end
end

function ChristmasTreeLayer.onHelp( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("ChristmasTree")
        if widget ~= nil then
            pop.showPopEffect(99,widget:getChildByName("pop"))
        end
    end
end

function ChristmasTreeLayer.exchangePage(sender, eventType)
    if eventType == ccui.PageViewEventType.turning then
        local pageView = sender
        local widget = pop.getDialog("ChristmasTree")
        local index = 0
        if widget ~= nil then
            index = tonumber(pageView:getCurPageIndex())
            widget:showItemByIndex(index)
        end

    end
end

function ChristmasTreeLayer.onClosePop(sender, eventType)
    if eventType == ccui.PageViewEventType.turning then
        local pageView = sender
        local widget = pop.getDialog("ChristmasTree")
        local index = 0
        if widget ~= nil then
            widget:getChildByName("pop2"):setVisible(false)
        end

    end
end


function ChristmasTreeLayer.onClosePop1(sender, eventType)
    if eventType == ccui.PageViewEventType.turning then
        local pageView = sender
        local widget = pop.getDialog("ChristmasTree")
        local index = 0
        if widget ~= nil then
            widget:getChildByName("pop"):setVisible(false)
        end

    end
end

function ChristmasTreeLayer.onOpenPop2( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("ChristmasTree")
        if widget ~= nil then
            pop.showPopEffect(99,widget:getChildByName("pop2"))
        end
    end
end

function ChristmasTreeLayer.onJuan( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then
        local message = ff.net:createMessage()
        message:addCmd(0x00000120)
        message:addLong(dd.uid)
        message:addLong(1)
        message:addLong(0)
        
        ff.net:rpc(message,false)
    end
end

function ChristmasTreeLayer:InitData()
    local rows = ff.dbmanager:sql_fetch_rows("select * from cfg_christmas_tree")
    self._reward = {}
    --cclog("========================"..rows:rowCount())
    for i=1,rows:rowCount() do
        local id = tonumber(rows:getString(i,"level"))
        self._reward[id] = {}
        self._reward[id]["needstar"] = tonumber(rows:getString(i,"needstar"))
        --self._reward[id]["zhang"] = tonumber(rows:getString(i,"chapterid"))
       -- self._reward[id]["checkpoint_id"] = tonumber(rows:getString(i,"checkpoint_id"))
        --self._reward[id]["npcid"] = tonumber(rows:getString(i,"npcid"))
        self._reward[id]['reward']   = rows:getString(i, "reward")
    end
    rows:clear()
end

function ChristmasTreeLayer.onStart( sender )
    sender:getInfo()
	ff.net:bindProperty(2332,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    
end

function ChristmasTreeLayer:getInfo(  )
    local message = ff.net:createMessage()
    message:addCmd(0x00000120)
    message:addLong(dd.uid)
    message:addLong(0)
    message:addLong(0)
    
    ff.net:rpc(message,false)
end

function ChristmasTreeLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("ChristmasTree")
		if widget == nil then
			return
		end
        if widget:getChildByName("pop2"):isVisible() == true then
            widget:getChildByName("pop2"):setVisible(false)
            return
        end
        if widget:getChildByName("pop"):isVisible() == true then
            widget:getChildByName("pop"):setVisible(false)
            return
        end
        pop.onClosePopDialog("ChristmasTree")
    end
end


function ChristmasTreeLayer.onEnd( sender )
    -- body
    local item = sender:getChildByName("list"):getChildByTag(1) 
    if item ~= nil then
        local spine = item:getChildByName("item"):getChildByTag(1)
        if spine ~= nil then
            spine:stopAllActions()
            spine:removeFromParent(true)
        end
        
    end
    
    sender:getChildByName("list"):removeAllChildren(true)
   
    dd.delBackEvent()
   
    ff.net:unbindProperty("gold",2332)

end

function onShowChristmasTree(widget)
	-- body
	local layer = ChristmasTreeLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end

function ChristmasTreeLayer:onAllyXmasTreeAction(  params)
    local code = params[1]
    if code == 0 then   
        self._info = params[2]
        if self._info.type == 1 then
            if dd.currentLayer._widget ~= nil then
              dd.currentLayer._widget:onShowTips("\t"..ff.langString("圣诞快乐"),true)
            end
        end
        self:showList()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function ChristmasTreeLayer.onBefore( sender)
    ff.net:registerEvent(2,dd.Tjf_AllyXmasTreeAction, function (message)sender:onAllyXmasTreeAction(message)end)     
end



function ChristmasTreeLayer:showList(  )
   local item = self:getChildByName("list"):getChildByTag(1) 
   if item == nil then
        item = self:getChildByName("item"):clone()
        item:setVisible(true)
        item:setTag(1)
        self:getChildByName("list"):pushBackCustomItem(item)

   end
   
    local spine = item:getChildByTag(1)
    if spine == nil then
        spine = sp.SkeletonAnimation:create("images/active/tree.json", "images/active/tree.atlas")
        spine:setAnchorPoint(cc.p(0,0))           
        item:getChildByName("item"):addChild(spine,0,1)
        spine:setPosition(cc.p(spine:getContentSize().width/2,spine:getContentSize().height/2-80))
    end
    if self._info.nowlevel <= 3 then
        spine:setToSetupPose()
        spine:setAnimation(0,"dianliangshengdanshu1_play",true)
    elseif self._info.nowlevel > 3 and self._info.nowlevel <= 6 then
        spine:setToSetupPose()
        spine:setAnimation(0,"dianliangshengdanshu2_play",true)
    elseif self._info.nowlevel > 6 then
        spine:setToSetupPose()
        spine:setAnimation(0,"dianliangshengdanshu3_play",true)
    end
    

    self:getChildByName("oper"):getChildByName("num"):setString(dd.getToolsCount(self._info.tid))
    local level = self._info.nowlevel +1 
    if level > 16 then
        level = 16 
    end

    local per = self._info.nowjifen / self._reward[level]["needstar"] *100
    item:getChildByName("progress"):getChildByName("progress"):setPercent(per)
    item:getChildByName("progress"):getChildByName("level"):setString("Lv."..self._info.nowlevel)
    item:getChildByName("progress"):getChildByName("jinyan"):setString(self._info.nowjifen.."/"..self._reward[level]["needstar"] )
end



function ChristmasTreeLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("ChristmasTree")
    if widget ~= nil then
        widget:getChildByName("topArea"):getChildByName("money"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("topArea"):requestDoLayout()
    end
end