local unionLayer   = class("unionLayer")
unionLayer._name = "union"
unionLayer._init = false
unionLayer._index= 0
unionLayer._widget = nil
unionLayer._managerIndex = 1
unionLayer._noticeedit = nil
unionLayer._ad = nil
unionLayer._message = nil
unionLayer._adinfo = {-1,""}
unionLayer._lastid = 0
unionLayer._messageid = {0,0}
unionLayer.allApplyNum = 0
unionLayer.applyList = {}
unionLayer.applyKey = 0
unionLayer._giftItems = {}
unionLayer._countDown = 0
unionLayer.applyBaseSize = nil
unionLayer._lastShowBattle = 0


function unionLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, unionLayer)
    return target
end
function unionLayer:returnBack()
    if self._type == 1 then
        pop.onClosePopDialog("task")
    end    
end

function unionLayer:onInit(index)
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,hh - 214))
        self:getChildByName("top"):setPositionY(hh - 214 - 105)
        self:getChildByName("btns"):setPositionY(hh - 214 - 190)
        self:getChildByName("mask"):setContentSize(cc.size(720,hh - 214 - 105))

        self:getChildByName("mBtm"):setPositionY(0)
        self:getChildByName("mBtm1"):setPositionY(0)
        self:getChildByName("mask"):setPositionY(0)


        local manager = self:getChildByName("manager")
        manager:setContentSize(cc.size(720,hh - 214 - 190 - 135))
        manager:setPositionY(135)

        local sch = hh - 214 - 190 - 135
        local vhh = 741
        local noticeh = 115
        local vg  = 5
        --266 + 115 + 5 + 115 + 5 + 190 + 10 = 706
        cclog("sch:"..sch)
        if sch < 706 then
            vhh = 706
        else
            if sch - 706 >= 20 then
                vg = 10            
                noticeh = 115 + sch - 726
            else
                vg  = 5 + (sch - 706)/4
            end
            vhh = sch
        end
        

        manager:getChildByName("view"):setContentSize(cc.size(720,sch))
        manager:getChildByName("view"):setPositionY(0)
        manager:getChildByName("view"):setInnerContainerSize(cc.size(720,vhh))
        manager:getChildByName("view"):getInnerContainer():setPositionY(vhh - sch)

        manager:getChildByName("view"):getChildByName("notice"):setContentSize(cc.size(700,noticeh))
        manager:getChildByName("view"):getChildByName("notice"):getChildByName("info"):setContentSize(cc.size(670,60 + (noticeh - 115)))
        manager:getChildByName("view"):getChildByName("notice"):getChildByName("info"):addTouchEventListener(self.onShowNotice)
        manager:getChildByName("view"):getChildByName("notice"):requestDoLayout()

        manager:getChildByName("view"):getChildByName("info"):setPositionY(vhh - 266)
        manager:getChildByName("view"):getChildByName("notice"):setPositionY(vhh - 266 - vg - noticeh)

        manager:getChildByName("view"):getChildByName("messages"):setPositionY(vhh - 266 - vg - noticeh - 115 - vg)
        manager:getChildByName("view"):getChildByName("battle"):setPositionY(vhh - 266 - vg - noticeh - 115 - vg - 190 - vg)
        manager:getChildByName("view"):getChildByName("gift"):setPositionY(vhh - 266 - vg - noticeh - 115 - vg - 190 - vg)

        

        self:getChildByName("mBtm"):getChildByName("btns"):getChildByName("btn1"):addTouchEventListener(self.onManagerSelect)
        self:getChildByName("mBtm"):getChildByName("btns"):getChildByName("btn2"):addTouchEventListener(self.onManagerSelect)
        self:getChildByName("mBtm"):getChildByName("btns"):getChildByName("btn3"):addTouchEventListener(self.onManagerSelect)
        self:getChildByName("mBtm"):getChildByName("btns"):getChildByName("btn4"):addTouchEventListener(self.onManagerSelect)
        self:getChildByName("mBtm"):getChildByName("btns"):getChildByName("btn5"):addTouchEventListener(self.onManagerSelect)
        self:getChildByName("mBtm1"):getChildByName("btns"):getChildByName("btn1"):addTouchEventListener(self.onManagerSelect)
        self:getChildByName("mBtm1"):getChildByName("btns"):getChildByName("btn2"):addTouchEventListener(self.onManagerSelect)
        self:getChildByName("mBtm1"):getChildByName("btns"):getChildByName("btn3"):addTouchEventListener(self.onManagerSelect)
        self:getChildByName("mBtm1"):getChildByName("btns"):getChildByName("btn4"):addTouchEventListener(self.onManagerSelect)
        self:getChildByName("mBtm1"):getChildByName("btns"):getChildByName("btn5"):addTouchEventListener(self.onManagerSelect)
        self:getChildByName("mBtm1"):getChildByName("btns"):getChildByName("btn6"):addTouchEventListener(self.onManagerSelect)
        --按钮
        manager:getChildByName("view"):getChildByName("notice"):getChildByName("addnotice"):addTouchEventListener(self.onShowNotice)
        manager:getChildByName("view"):getChildByName("info"):getChildByName("advert"):addTouchEventListener(self.onShowAD)
        manager:getChildByName("view"):getChildByName("messages"):getChildByName("info"):addTouchEventListener(self.onShowMessage)
        manager:getChildByName("view"):getChildByName("messages"):getChildByName("addnotice"):addTouchEventListener(self.onShowMessage)

        self:getChildByName("ad"):getChildByName("close"):addTouchEventListener(self.closeAD)
        self:getChildByName("notice"):getChildByName("close"):addTouchEventListener(self.closeNotice)
        

        self:getChildByName("notice"):getChildByName("clear"):addTouchEventListener(self.clearNotice)
        self:getChildByName("notice"):getChildByName("save"):addTouchEventListener(self.saveNotice)

        self:getChildByName("ad"):getChildByName("clear"):addTouchEventListener(self.clearAd)
        self:getChildByName("ad"):getChildByName("save"):addTouchEventListener(self.saveAd)
        self:getChildByName("ad"):getChildByName("send"):addTouchEventListener(self.adUnion)

        self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
        self:getChildByName("btns"):getChildByName("shop"):addTouchEventListener(self.selectIndex)
        self:getChildByName("btns"):getChildByName("manager"):addTouchEventListener(self.selectIndex)
        self:getChildByName("btns"):getChildByName("rank"):addTouchEventListener(self.selectIndex)

        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
        manager:getChildByName("view"):getChildByName("battle"):addTouchEventListener(self.showUnionBattlePannel)

        --输入
        local size = self:getChildByName("notice"):getChildByName("input"):getChildByName("input"):getContentSize()
        local editBox = dd.addEditBox(
             self:getChildByName("notice"):getChildByName("input")
            , size
            , "images/editbox.png"
            , 11011
            , cc.p(0,0)
            , cc.p(self:getChildByName("notice"):getChildByName("input"):getChildByName("input"):getPosition())
            , cc.c3b(255,255,255)
            , 20
            , 0
            , 4
            , 0
            , 250
            , true
            , true
            , true
        )
        self._noticeedit = editBox
        local size = self:getChildByName("ad"):getChildByName("input"):getChildByName("input"):getContentSize()
        local editBox = dd.addEditBox(
             self:getChildByName("ad"):getChildByName("input")
            , size
            , "images/editbox.png"
            , 11012
            , cc.p(0,0)
            , cc.p(self:getChildByName("ad"):getChildByName("input"):getChildByName("input"):getPosition())
            , cc.c3b(255,255,255)
            , 20
            , 0
            , 4
            , 0
            , 250
            , true
            , true
            , true
        )
        self._ad = editBox

        self:initGift()
        self._init = true
    end

    local ulevel = dd.myUnion:getLong(1,"unionofficial")
    cclog("=======ulevel: "..ulevel)
    if ulevel < 4 then
        self:getChildByName("ad"):getChildByName("clear"):setTouchEnabled(false)
        self:getChildByName("ad"):getChildByName("clear"):setBright(false)
        self:getChildByName("ad"):getChildByName("save"):setTouchEnabled(false)
        self:getChildByName("ad"):getChildByName("save"):setBright(false)
        self:getChildByName("ad"):getChildByName("send"):setTouchEnabled(false)
        self:getChildByName("ad"):getChildByName("send"):setBright(false)

        self:getChildByName("notice"):getChildByName("clear"):setTouchEnabled(false)
        self:getChildByName("notice"):getChildByName("clear"):setBright(false)
        self:getChildByName("notice"):getChildByName("save"):setTouchEnabled(false)
        self:getChildByName("notice"):getChildByName("save"):setBright(false)
        self:getChildByName("manager"):getChildByName("view"):getChildByName("notice"):getChildByName("addnotice"):setVisible(false)
        self:getChildByName("manager"):getChildByName("view"):getChildByName("info"):getChildByName("advert"):setVisible(false)
    else
        self:getChildByName("ad"):getChildByName("clear"):setTouchEnabled(true)
        self:getChildByName("ad"):getChildByName("clear"):setBright(true)
        self:getChildByName("ad"):getChildByName("save"):setTouchEnabled(true)
        self:getChildByName("ad"):getChildByName("save"):setBright(true)
        self:getChildByName("ad"):getChildByName("send"):setTouchEnabled(true)
        self:getChildByName("ad"):getChildByName("send"):setBright(true)

        self:getChildByName("notice"):getChildByName("clear"):setTouchEnabled(true)
        self:getChildByName("notice"):getChildByName("clear"):setBright(true)
        self:getChildByName("notice"):getChildByName("save"):setTouchEnabled(true)
        self:getChildByName("notice"):getChildByName("save"):setBright(true)
        self:getChildByName("manager"):getChildByName("view"):getChildByName("info"):getChildByName("advert"):setVisible(true)
        self:getChildByName("manager"):getChildByName("view"):getChildByName("notice"):getChildByName("addnotice"):setVisible(true)
    end

    ff.net:registerEvent(2,dd.Tjf_union_unReadAllyComment,self.unReadAllyComment)      
    ff.net:registerEvent(1,dd.Tjf_union_GetMyAllyInfo,self.onGetMyAllyInfo)      
    ff.net:registerEvent(2,dd.Tjf_union_GetAllyCommentList,self.updateUMessage)
    ff.net:registerEvent(2,dd.Tjf_union_EditAllyBBS,self.onEditAllyBBS)
    ff.net:registerEvent(2,dd.Tjf_union_AllyAdvertise,self.onAllyAdvertise)
    ff.net:registerEvent(2,dd.Tjf_union_AllyLeaderChange,self.onAllyLeaderChange)
    ff.net:registerEvent(2,dd.Tjf_union_unionGiftAction, function (message)self:onUnionGiftAction(message)end)
    ff.net:registerEvent(503,dd.Tjf_charge_TestCharge, function (message)self:onTestCharge(message)end)
    ff.net:registerEvent(2,dd.Tjf_union_GetUnionGiftsList, function (message)self:onGetGiftList(message)end)
    ff.net:bindProperty(2016,"gold",function ()self.updateGold() end) 
    ff.net:bindProperty(2018,"nAllyFunds",function ()self:updateFunds() end) 
    
    self:getChildByName("mask"):setVisible(false)
    self:getChildByName("ad"):setVisible(false)
    self:getChildByName("notice"):setVisible(false)

    if index <= 0 then
        index = 1
    end
    self._index = 0

    --查询联盟宣传
    local message = ff.net:createMessage()
    message:addCmd(0x13f)
    message:addLong(dd.uid)
    message:addLong(0)
    message:addString("",256)
    ff.net:postMessage(message)

    local message = ff.net:createMessage()
    message:addCmd(0xE0E)
    message:addLong(dd.uid)
    message:addLong(ff.serverid)
    message:addLong(dd.myUnion:getLong(1,"unionid"))
    message:addLong(0)
    message:addLong(0)
    message:addLong(1)
    ff.net:postMessage(message)


    self:unSelect()
    if index == 1 then
        self:selectMainMenu()
        self:getChildByName("btns"):getChildByName("manager"):setSelectedState(true)
    elseif index == 2 then
        self:selectShop()
        self:getChildByName("btns"):getChildByName("shop"):setSelectedState(true)
    else
        self:selectRank()
        self:getChildByName("btns"):getChildByName("rank"):setSelectedState(true)
    end   
    self.updateGold()         
end
function unionLayer.updateGold(name,row,old,value)
    local sender = pop.getDialog("union")
    if sender ~= nil then
        sender:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("top"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("top"):requestDoLayout()
    end
end
function unionLayer:updateFunds()
    local info = self:getChildByName("manager"):getChildByName("view"):getChildByName("info")
    info:getChildByName("funds"):setString(ff.getFormatMoney(dd.myUnion:getLong(1,"nAllyFunds")))
    info:requestDoLayout()
end
function unionLayer:initGift()
    
    local function help(sender,eventType)
        if eventType==ccui.TouchEventType.ended then  
            pop.popDialog("unionGift",self,1)

            local widget = pop.getDialog("unionGift")
            widget:stopAllActions()
            widget:setLocalZOrder(3)
            pop.showPopEffect(10,widget,true) 
            self:getChildByName("mask"):setVisible(true)
        end 
    end
    self:getChildByName("manager"):getChildByName("view"):getChildByName("gift"):getChildByName("icon"):addTouchEventListener(help)
    
end
function unionLayer:updateGiftList()
    local view = self:getChildByName("manager"):getChildByName("view"):getChildByName("gift")
    local num = 0
    local row = 0
    local count = 0
    local innerhh = 0
    local ishave = false
    self._countDown = 0
    for i,v in ipairs(self._giftItems) do
        if tolua.isnull(v) then
            self._giftItems[i] = nil
        else
            v:setVisible(false)
            v:setTag(i)
        end
    end
    for i=1, dd.myUnionGifts:rowCount() do
        if dd.myUnionGifts:getLong(i,"start") == 0 then --未开启
            local time = dd.myUnionGifts:getLong(i,"endtime")-dd.getServerTime()
            if time > 0 then
                num = num + 1
                if ishave == false then
                    ishave = true
                    view:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getUnionGiftIcon(dd.myUnionGifts:getLong(i,"tid")),0)
                end
            end
        end
    end
    view:getChildByName("icon"):getChildByName("tag"):getChildByName("count"):setString(num)
    if ishave == false then
        view:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/uniongift/1.png",0)
    end
end
function unionLayer.onOpenGift(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        local message = ff.net:createMessage()
        message:addCmd(0x141)
        message:addLong(dd.uid)
        message:addLong(1) 
        message:addLong(sender._gid)
        ff.net:rpc(message,false)
    end
end
function unionLayer.dealAction()
    local sender = pop.getDialog("union")
    --礼包
    local view = sender:getChildByName("manager"):getChildByName("view"):getChildByName("gift"):getChildByName("view")
    for i=1, sender._countDown do
        local item = view:getChildByTag(1000 + i)
        if item ~= nil then
            if dd.myUnionGifts:getLong(item.idex,"start") == 0 then --未开启
                local time = dd.myUnionGifts:getLong(item.idex,"endtime")-dd.getServerTime()
                if time > 0 then
                    item:getChildByName("time"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                else
                    sender:updateGiftList()
                end
            end
        end
    end
    --联盟战争
    if dd.myUnionBattle == nil or dd.myUnionBattle:rowCount() == 0 then
        sender:getChildByName("manager"):getChildByName("view"):getChildByName("battle"):getChildByName("icon"):loadTexture("images/icon/unionbattle/unbattle.png",0)
        sender:getChildByName("manager"):getChildByName("view"):getChildByName("battle"):getChildByName("info"):getChildByName("time"):setString(ff.langString("暂无战事"))
        sender:getChildByName("manager"):getChildByName("view"):getChildByName("battle"):getChildByName("icon"):setTag(0)
    else
        local row = sender:getChildByName("manager"):getChildByName("view"):getChildByName("battle"):getChildByName("icon"):getTag()
        if dd.getServerTime() >= sender._lastShowBattle + 15 then
            row = row + 1
            sender._lastShowBattle = dd.getServerTime()
        end
        if dd.myUnionBattle:rowCount() < row then
            row = 1
        end

        sender:getChildByName("manager"):getChildByName("view"):getChildByName("battle"):getChildByName("icon"):setTag(row)
        if dd.myUnionBattle:getLong(row,"unionid") == dd.myUnion:getLong(1,"unionid") then
            local time = ff.getLeftTime(dd.myUnionBattle:getLong(row,"statusEnd") - dd.getServerTime(),":")
            if dd.myUnionBattle:getLong(row,"status") == 0 then
                sender:getChildByName("manager"):getChildByName("view"):getChildByName("battle"):getChildByName("icon"):loadTexture("images/icon/unionbattle/ubattle_1.jpg",0)
                sender:getChildByName("manager"):getChildByName("view"):getChildByName("battle"):getChildByName("info"):getChildByName("time"):setString(ff.langString("{0}的联军集结中",{dd.myUnionBattle:getString(row,"attackUname")}).."  "..time)
            elseif dd.myUnionBattle:getLong(row,"status") == 1 then     
                sender:getChildByName("manager"):getChildByName("view"):getChildByName("battle"):getChildByName("icon"):loadTexture("images/icon/unionbattle/ubattle_1.jpg",0)           
                sender:getChildByName("manager"):getChildByName("view"):getChildByName("battle"):getChildByName("info"):getChildByName("time"):setString(ff.langString("{0}的联军行进中",{dd.myUnionBattle:getString(row,"attackUname")}).."  "..time)
            elseif   dd.myUnionBattle:getLong(row,"status") == 2 then        
                sender:getChildByName("manager"):getChildByName("view"):getChildByName("battle"):getChildByName("icon"):loadTexture("images/icon/unionbattle/ubattle_1.jpg",0)
                local time = ff.getLeftTime(dd.getServerTime() - dd.myUnionBattle:getLong(row,"statusStart"),":")
                sender:getChildByName("manager"):getChildByName("view"):getChildByName("battle"):getChildByName("info"):getChildByName("time"):setString(ff.langString("{0}的联军等待中",{dd.myUnionBattle:getString(row,"attackUname")}).."  "..time)
            else
                sender:getChildByName("manager"):getChildByName("view"):getChildByName("battle"):getChildByName("icon"):loadTexture("images/icon/unionbattle/ubattle_1.png",0)
                sender:getChildByName("manager"):getChildByName("view"):getChildByName("battle"):getChildByName("info"):getChildByName("time"):setString(ff.langString("{0}的联军驻守中",{dd.myUnionBattle:getString(row,"attackUname")}).."  "..time)
            end                
            
        else
            local time = ff.getLeftTime(dd.myUnionBattle:getLong(row,"statusEnd") - dd.getServerTime(),":")
            sender:getChildByName("manager"):getChildByName("view"):getChildByName("battle"):getChildByName("info"):getChildByName("time"):setString(ff.langString("{0}即将受到攻击".."  "..time,{dd.myUnionBattle:getString(row,"attackedUname")}))
            sender:getChildByName("manager"):getChildByName("view"):getChildByName("battle"):getChildByName("icon"):loadTexture("images/icon/unionbattle/ubattle_1.png",0)
        end
    end
end

function unionLayer:closeGiftClear()
    self:getChildByName("mask"):setVisible(false)
end

function unionLayer.onShowNotice(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("union")
        if widget ~= nil then
            widget:showNotice()            
        end
    end
end
function unionLayer.closeNotice(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("union")
        if widget ~= nil then
            widget:getChildByName("notice"):stopAllActions()
            pop.onCloseEffect(99,widget:getChildByName("notice"))
            widget:getChildByName("mask"):setVisible(false)
        end
    end
end
function unionLayer.onShowAD(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("union")
        if widget ~= nil then
            widget:showAD()            
        end
    end
end
function unionLayer.closeAD(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("union")
        if widget ~= nil then
            pop.onCloseEffect(99,widget:getChildByName("ad"))
            widget:getChildByName("mask"):setVisible(false)
        end
    end
end

function unionLayer.clearNotice(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        if dd.myUnion:getLong(1,"unionofficial") < 4 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您的联盟权限不足"))
        else
            local widget = pop.getDialog("union")
            widget._noticeedit:setText("")
        end
    end
end
function unionLayer.saveNotice(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        if dd.myUnion:getLong(1,"unionofficial") < 4 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您的联盟权限不足"))
        else
            local widget = pop.getDialog("union")
            local newnotice = widget._noticeedit:getText()

            local message = ff.net:createMessage()
            message:addCmd(0x129)
            message:addLong(dd.uid)
            message:addString(newnotice,256)
            ff.net:rpc(message,false)
            dd.myUnion:setString(1,"nAllyBBS",newnotice)
            widget:getChildByName("notice"):stopAllActions()
            pop.onCloseEffect(99,widget:getChildByName("notice")) 
            widget:getChildByName("mask"):setVisible(false)       
        end
    end
end
function unionLayer.clearAd(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("union")
        widget._ad:setText("")
    end
end
function unionLayer.saveAd(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("union")
        local txt    = widget._ad:getText()
        if txt ~= widget._adinfo[2] then
            local message = ff.net:createMessage()
            message:addCmd(0x13f)
            message:addLong(dd.uid)
            message:addLong(1)
            message:addString(txt,256)
            ff.net:rpc(message,false)
        else
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("广告保存成功"),true) 
        end
    end
end
function unionLayer.adUnion(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local message = ff.net:createMessage()
        message:addCmd(0x13f)
        message:addLong(dd.uid)
        message:addLong(2)
        message:addString("",256)
        ff.net:rpc(message,false)
    end
end
function unionLayer:showNotice()
    local notice = self:getChildByName("notice")
    self._noticeedit:setText(dd.myUnion:getString(1,"nAllyBBS"))
    notice:stopAllActions()
    pop.showPopEffect(12,notice)    
    self:getChildByName("mask"):setVisible(true)
end
function unionLayer:showAD()
    local ad = self:getChildByName("ad")
    ad:stopAllActions()
    local message = ff.net:createMessage()
    message:addCmd(0x13f)
    message:addLong(dd.uid)
    message:addLong(0)
    message:addString("",256)
    ff.net:rpc(message,false)
    pop.showPopEffect(12,ad)    
    self:getChildByName("mask"):setVisible(true)
end
function unionLayer.updateUMessage(params)
    local code    = params[1]
    local unionid = params[2]
    if code == 0 and unionid == dd.myUnion:getLong(1,"unionid") then 
        local widget = pop.getDialog("union")
        widget:updateMessage()
    end
end
function unionLayer:updateMessage()
    local item = self:getChildByName("manager"):getChildByName("view"):getChildByName("messages"):getChildByName("info")
    local row = ff.dbmanager:sql_fetch_rows("select * from client_union_message where `unionid`='"..dd.myUnion:getLong(1,"unionid").."' order by `id` desc limit 1")
    if row ~= nil then
        if row:rowCount() == 1 then
            item:getChildByName("time"):setString(ff.getTimeTips(dd.getChatServerTime() - tonumber(row:getString(1,"time"))).."  ")
            local unionid = tonumber(row:getString(1,"unionid"))
            if unionid > 0 then
                item:getChildByName("ulevel"):setString(row:getString(1,"ulevel"))
                if string.len(row:getString(1,"short")) > 0 then
                    item:getChildByName("name"):setString("["..row:getString(1,"short").."]"..row:getString(1,"name").."：")
                else
                    item:getChildByName("name"):setString(row:getString(1,"name").."：")
                end
                item:getChildByName("label"):setString(row:getString(1,"message"))
                item:getChildByName("label"):setContentSize(cc.size(340,60))
            else
                item:getChildByName("ulevel"):setString("")
                item:getChildByName("name"):setString(row:getString(1,"name").."：")
                item:getChildByName("label"):setString(row:getString(1,"message"))
                item:getChildByName("label"):setContentSize(cc.size(440,60))
            end
            item:requestDoLayout()
            self._lastid = tonumber(row:getString(1,"id"))
        else
            item:getChildByName("time"):setString(ff.langString("暂无任何留言"))
            item:getChildByName("ulevel"):setString("")
            item:getChildByName("name"):setString("")
            item:getChildByName("label"):setString("")
            item:requestDoLayout()
        end    
        row:clear()
    else    
        item:getChildByName("time"):setString(ff.langString("暂无任何留言"))
        item:getChildByName("ulevel"):setString("")
        item:getChildByName("name"):setString("")
        item:getChildByName("label"):setString("")        
        item:requestDoLayout()
    end
end
function unionLayer.onEditAllyBBS(code)
    if code == 0 then
        local widget = pop.getDialog("union")
        widget:getChildByName("manager"):getChildByName("view"):getChildByName("notice"):getChildByName("info"):setString(dd.myUnion:getString(1,"nAllyBBS"))
    end
end

function unionLayer.onAllyLeaderChange(code)
    if code == 0 then
        local widget = pop.getDialog("union")
        if widget ~= nil then
            widget:unSelect()
            widget:selectHome()
            widget:getChildByName("btns"):getChildByName("manager"):setSelectedState(true)
        end
    end
end
function unionLayer.onAllyAdvertise(params)
    local widget = pop.getDialog("union")
    local code = params[1]
    if code == 0 then
        widget._adinfo[1] = params[3]
        widget._adinfo[2] = params[4]
        widget._ad:setText(widget._adinfo[2])
        widget.updateAD()
        if params[2] == 0 then
            schedule(widget:getChildByName("ad"),widget.updateAD,1)
        end
        if params[2] == 1 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("广告保存成功"),true) 
        end   
        if params[2] == 2 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功发送联盟广告"),true)
            if widget ~= nil then
                pop.onCloseEffect(99,widget:getChildByName("ad"))
                widget:getChildByName("mask"):setVisible(false)
            end 
        end  
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
function unionLayer:onUnionGiftAction(params)
    local code = params[1]
    if code == 0 then
        local type = params[2]
        local gid = params[3]
        local arr1 = { "道具",
            "石油",  --2
            "木材",  --3
            "钢铁",  --4
            "粮食",  --5
            "银币",  --6
            "金币",  --7
            "士兵",  --8
            "英雄经验",--9
            "联盟贡献",--10
            "VIP点数",--11
            "联盟礼物",--12
            "联盟商店",--13
            "联盟基金",--
            "晶体"
        }
        self:updateGiftList()
        if type == 1 then
            for i=1,dd.myUnionGifts:rowCount() do
                if dd.myUnionGifts:getLong(i,"id") == gid then
                    local ttype = dd.myUnionGifts:getLong(i,"type")
                    local count = dd.myUnionGifts:getLong(i,"count")
                    local gold = dd.myUnionGifts:getLong(i,"gold")
                    local dropid = dd.myUnionGifts:getLong(i,"dropid")
                    local name = ""
                    if ttype == 1 then
                        name = ff.langString(dd.cfgProp[dropid]['name'],{dd.cfgProp[dropid]['name1_lan']})  
                    else
                        name = ff.langString(arr1[ttype])                  
                    end
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("领取成功,获得 {0} x{1},金币 x{2}",{name,count,gold}),true)
                    break
                end
            end  
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function unionLayer:onTestCharge(params)
    local code = params[1]
    if code == 0 then
        self:updateGiftList()
    end
end

function unionLayer:onGetGiftList(params)
    local code = params[1]
    if code == 0 then
        self:updateInfo()
        self:updateGiftList()
    end
end

function unionLayer.updateAD()
    local widget = pop.getDialog("union")
    if widget._adinfo[1] < 0 then
        return
    end
    if widget._adinfo[1] >= dd.getServerTime() or string.len(widget._adinfo[2]) == 0 then
        widget:getChildByName("ad"):getChildByName("time"):setString(ff.getLeftTime(widget._adinfo[1]-dd.getServerTime(),":"))        
        widget:getChildByName("manager"):getChildByName("view"):getChildByName("info"):getChildByName("advert"):getChildByName("time"):setString(ff.getLeftTime(widget._adinfo[1]-dd.getServerTime(),":"))        
        widget:getChildByName("ad"):getChildByName("send"):setTouchEnabled(false)
        widget:getChildByName("ad"):getChildByName("send"):setBright(false)
        if widget._adinfo[1] == dd.getServerTime() then
            widget:getChildByName("ad"):stopAllActions()
        end
    else
        widget:getChildByName("ad"):getChildByName("time"):setString("00:00:00")
        widget:getChildByName("manager"):getChildByName("view"):getChildByName("info"):getChildByName("advert"):getChildByName("time"):setString("00:00:00")

        local ulevel = dd.myUnion:getLong(1,"unionofficial")
        if ulevel >= 4 then        
            widget:getChildByName("ad"):getChildByName("send"):setTouchEnabled(true)
            widget:getChildByName("ad"):getChildByName("send"):setBright(true)
        else
            widget:getChildByName("ad"):getChildByName("send"):setTouchEnabled(false)
            widget:getChildByName("ad"):getChildByName("send"):setBright(false)
        end
    end
end


function unionLayer:closeManager()
    if self._managerIndex == 1 then
        self:getChildByName("manager"):stopAllActions()
        pop.onCloseEffect(99,self:getChildByName("manager"))
    elseif self._managerIndex == 2 then
        local widget = pop.getDialog("unionMember")
        if widget ~= nil then
            widget:stopAllActions()
        end
        pop.onClosePopDialog("unionMember") 
    elseif self._managerIndex == 3 then
        local widget = pop.getDialog("unionTec")
        if widget ~= nil then
            widget:stopAllActions()
        end
        pop.onClosePopDialog("unionTec")    
    elseif self._managerIndex == 5 then
        local widget = pop.getDialog("unionOption")
        if widget ~= nil then
            widget:stopAllActions()
        end
        pop.onClosePopDialog("unionOption")    
    elseif self._managerIndex == 6 then
        local widget = pop.getDialog("unionHelp")
        if widget ~= nil then
            widget:stopAllActions()
        end
        pop.onClosePopDialog("unionHelp")   
    elseif self._managerIndex == 7 then
        local widget = pop.getDialog("unionInnerRank")
        if widget ~= nil then
            widget:stopAllActions()
        end
        pop.onClosePopDialog("unionInnerRank")    
    end    
end

function unionLayer:selectMember()
    pop.onShowPopDialog("unionMember")
    self._managerIndex = 2
end
function unionLayer:selectTecs()
    local btns = self:getChildByName("mBtm"):getChildByName("btns")   
    pop.onShowPopDialog("unionTec")
    self._managerIndex = 3
end
function unionLayer:selectPoints()
    pop.onShowPopDialog("unionHelp")
    self._managerIndex = 6
end
function unionLayer:selectOption()
    pop.onShowPopDialog("unionOption")
    self._managerIndex = 5
end

function unionLayer.onManagerSelect(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("union")
        if widget ~= nil then
            if sender:getTag() == 1 then
                widget:selectInnerRank()
           elseif sender:getTag() == 2 then
                widget:selectMember()
            elseif sender:getTag() == 3 then
                widget:selectTecs()
            elseif sender:getTag() == 4 then
                widget:selectPoints()                                
            elseif sender:getTag() == 5 then    
                widget:selectOption()
            elseif sender:getTag() == 6 then    
                pop.onShowPopDialog("ChristmasTree")
            end    
        end
    end
end
function unionLayer:selectInnerRank()
    pop.onShowPopDialog("unionInnerRank")
    self._managerIndex = 7
end
function unionLayer:unSelect()
    self:getChildByName("btns"):getChildByName("shop"):setSelectedState(false)
    self:getChildByName("btns"):getChildByName("manager"):setSelectedState(false)
    self:getChildByName("btns"):getChildByName("rank"):setSelectedState(false)
    self:getChildByName("btns"):getChildByName("shop"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("btns"):getChildByName("manager"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("btns"):getChildByName("rank"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
end
function unionLayer.selectIndex(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("union")
        if widget ~= nil then
            if sender:getSelectedState() == true then
                sender:setSelectedState(false)
                return
            end
            widget:unSelect()
            if sender:getTag() == 1 then
                widget:selectMainMenu()
            elseif sender:getTag() == 2 then
                widget:selectShop()
            else    
                widget:selectRank()
            end    
        end
    end
end

function unionLayer:selectMainMenu()
    cclog("unionLayer:selectMainMenu")
    if self._index == 1 then
        return
    end
    if self._widget ~= nil then
        self._widget:stopAllActions()
    end    
    if self._index == 2 then
        pop.onClosePopDialog("unionShop")
    end
    if self._index == 3 then
        pop.onClosePopDialog("unionDiplomacy")
    end
    self:selectHome()
end
function unionLayer:selectHome()

    self:closeManager()
    self:getChildByName("manager"):stopAllActions()
    self:getChildByName("manager"):setVisible(true)
    if dd.myinfo:getLong(1,"treeBegin") < dd.getServerTime() and dd.getServerTime() < dd.myinfo:getLong(1,"treeEnd") then
        self:getChildByName("mBtm"):setVisible(false)
        self:getChildByName("mBtm1"):setVisible(true)
    else
        self:getChildByName("mBtm1"):setVisible(false)
        self:getChildByName("mBtm"):setVisible(true)
    end

    self._widget = self:getChildByName("manager")
    self._managerIndex = 1
    self:getChildByName("btns"):getChildByName("manager"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
    self._index = 1
end
function unionLayer:selectShop()
    if self._index == 2 then
        return
    end
    self._widget:stopAllActions()

    if self._index == 1 then
        pop.onCloseEffect(99,self:getChildByName("manager"))
        self:getChildByName("mBtm"):setVisible(false)
        self:getChildByName("mBtm1"):setVisible(false)
    elseif self._index == 3 then
        pop.onClosePopDialog("unionDiplomacy")     
    end
    self:closeManager()    
    pop.popDialog("unionShop", self)
    self._widget = pop.getDialog("unionShop")
    pop.showPopEffect(99, self._widget, true)
    self:getChildByName("btns"):getChildByName("shop"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
    self._index = 2
end
function unionLayer:selectRank()
    cclog("unionLayer:selectRank")
    if self._index == 3 then
        return
    end
    self._widget:stopAllActions()
    if self._index == 1 then
        pop.onCloseEffect(99,self:getChildByName("manager"))
        self:getChildByName("mBtm1"):setVisible(false)
        self:getChildByName("mBtm"):setVisible(false)
    elseif self._index == 2 then
        pop.onClosePopDialog("unionShop")             
    end    
    self:closeManager()
    --显示排名
    self._widget = pop.getDialog("unionDiplomacy")
    if self._widget ~= nil then
        self._widget:stopAllActions()
    end
    pop.popDialog("unionDiplomacy",self)
    self._widget = pop.getDialog("unionDiplomacy")
    pop.showPopEffect(99,self._widget,true)   
    self:getChildByName("btns"):getChildByName("rank"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
    self._index = 3
end
function unionLayer.onEnd(sender,btns)
    sender:stopAllActions()
    dd.delBackEvent(sender.onReturn)
    ff.net:removeEvent(1,dd.Tjf_union_GetMyAllyInfo)
    ff.net:removeEvent(2,dd.Tjf_union_GetAllyCommentList)
    ff.net:removeEvent(2,dd.Tjf_union_EditAllyBBS)
    ff.net:removeEvent(2,dd.Tjf_union_AllyAdvertise)
    ff.net:removeEvent(2,dd.Tjf_union_AllyLeaderChange)
    ff.net:removeEvent(2,dd.Tjf_union_unionGiftAction)
    ff.net:removeEvent(503,dd.Tjf_charge_TestCharge)
    ff.net:removeEvent(2,dd.Tjf_union_GetUnionGiftsList)
    ff.net:unbindProperty("gold",2016)
    ff.net:unbindProperty("nAllyFunds",2018) 
    sender:getChildByName("ad"):stopAllActions() 
    if ff.platform ~= 1 then
        sender:getChildByName("manager"):getChildByName("view"):getChildByName("gift"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
    if sender._index == 2 then
        pop.onClosePopDialog("unionShop")
    elseif sender._index == 3 then
        pop.onClosePopDialog("unionDiplomacy")
    end    

    --是否自己点的关闭
    if btns == nil then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:unSelectBtns()
        end    
    end
end

function unionLayer.onStart(sender)
    local message = ff.net:createMessage()
    message:addCmd(0x11)
    message:addLong(dd.uid)
    ff.net:rpc(message,false)

    sender:updateGiftList()
    sender.updateGold()
    sender.dealAction()
    sender:updateMessage()
    schedule(sender, sender.dealAction,1)
end
--联盟留言界面
function unionLayer.onShowMessage(sender,eventType)
    if eventType==ccui.TouchEventType.ended then    
        pop.onShowPopDialog("unionMessage",dd.myUnion:getLong(1,"unionid"))
    end
end
function unionLayer.sendUnionMessage(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("union")
        if widget ~= nil then
            local txt = widget._message:getText()
            if string.len(txt) > 0 then
                local message = ff.net:createMessage()
                message:addCmd(0xF0B)
                message:addLong(dd.uid)
                message:addLong(ff.serverid)
                message:addLong(dd.myUnion:getLong(1,"unionid"))
                message:addString(txt,511)
                message:addString("cn",15)
                ff.net:rpc(message,false)
                cclog("here...................")
                widget:getChildByName("umsg"):stopAllActions()
                pop.onCloseEffect(99,widget:getChildByName("umsg"))
                widget:getChildByName("mask"):setVisible(false)     
            else
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("留言内容不能为空"))
            end    
        end
    end
end

function unionLayer.showUnionBattlePannel(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        for i=1,dd.mybuilds:rowCount() do
            if dd.mybuilds:getLong(i,"bid") == 15 then
                local widget = pop.getDialog("union")
                widget:onClose(true)
                pop.onClosePopDialog("union")
                onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos")) 
                return
            end
        end
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("请先建造{0}",{ff.langString(dd.cfgBuilding[15]['name'])}),true)
    end
end

function unionLayer.onGetMyAllyInfo(code)
    if code == 0 then
        local widget = pop.getDialog("union")
        if widget ~= nil then
            widget:getChildByName("btns"):getChildByName("shop"):setTouchEnabled(true)
            widget:getChildByName("btns"):getChildByName("manager"):setTouchEnabled(true)
            widget:getChildByName("btns"):getChildByName("rank"):setTouchEnabled(true)
            widget:updateInfo(false)
        end
    end
end
function unionLayer:updateInfo(update)
    local info = self:getChildByName("manager"):getChildByName("view"):getChildByName("info")
    info:getChildByName("short"):setString("["..dd.myUnion:getString(1,"unionflag").."]")
    info:getChildByName("name"):setString(dd.myUnion:getString(1,"unionname"))
    info:getChildByName("rank"):setString(dd.myUnion:getLong(1,"rank"))
    info:getChildByName("power"):setString(ff.getFormatMoney(dd.myUnion:getSuperLong(1,"power")))
    info:getChildByName("funds"):setString(ff.getFormatMoney(dd.myUnion:getLong(1,"nAllyFunds")))
    info:getChildByName("member"):setString(dd.myUnion:getLong(1,"member").."/"..dd.myUnion:getLong(1,"memberMax"))
    info:getChildByName("leader"):setString(dd.myUnion:getString(1,"master"))
    info:getChildByName("icon"):loadTexture(dd.getUnionIcon(dd.myUnion:getLong(1,"totem")),0)
    info:requestDoLayout()

    local bbs = dd.myUnion:getString(1,"nAllyBBS")
    if string.len(bbs) <= 0 then
        bbs = ff.langString("尚未设置联盟公告")
    end    
    self:getChildByName("manager"):getChildByName("view"):getChildByName("notice"):getChildByName("info"):setString(bbs)
    self:getChildByName("manager"):getChildByName("view"):getChildByName("gift"):getChildByName("level"):setString("Gift LV."..dd.myUnion:getLong(1,"boxlevel"))
    local pre = math.ceil(dd.myUnion:getLong(1,"boxexp") * 100/dd.myUnion:getLong(1,"boxtotal"))
    if pre >100 then
        pre = 100
    end
    self:getChildByName("manager"):getChildByName("view"):getChildByName("gift"):getChildByName("progress"):getChildByName("progress"):setPercent(pre)

    if dd.myUnion:getLong(1,"unionofficial") < 4 then
         self:getChildByName("manager"):getChildByName("view"):getChildByName("notice"):getChildByName("addnotice"):setVisible(false)
    else
         self:getChildByName("manager"):getChildByName("view"):getChildByName("notice"):getChildByName("addnotice"):setVisible(true)
    end

    if update == false then
        return
    end

    if self._managerIndex == 1 then
        self:selectHome()
    elseif self._managerIndex == 2 then    
        self:selectMember()
    elseif self._managerIndex == 3 then    
        self:selectTecs()
    elseif self._managerIndex == 4 then    
        self:selectPoints()
    elseif self._managerIndex == 7 then    
        self:selectInnerRank()
    else    
        self:selectOption()
    end
end
function unionLayer.onMail(sender,eventType)
    if eventType==ccui.TouchEventType.ended then    
        if dd.myUnion:getLong(1,"unionofficial") >= 3 then
            local widget = pop.getDialog("union")
            if widget ~= nil then
                pop.onShowPopDialog("mailWrite",false,dd.myUnion:getLong(1,"unionid"),dd.myUnion:getString(1,"name"),'','ch',{},1,0)
            end    
        else
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您的联盟权限不足"))
        end
    end    
end
function unionLayer.onBefore(sender)   
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("icon"),sender:getChildByName("top"):getChildByName("addgold"))
    local message2 = ff.net:createMessage()
    message2:addCmd(0x00000032)
    message2:addLong(dd.uid)
    ff.net:postMessage(message2)
    sender:getChildByName("btns"):getChildByName("shop"):setTouchEnabled(false)
    sender:getChildByName("btns"):getChildByName("manager"):setTouchEnabled(false)
    sender:getChildByName("btns"):getChildByName("rank"):setTouchEnabled(false)
    return true
end
function unionLayer:onClose(force)
    if force == nil then
        force = false
    end
    --如果弹出了联盟礼包面板，则先关闭它
    if pop.getDialog("unionGift") and self:getChildByTag(10001) ~= nil then
        if pop.isShowing("unionGift") then
            pop.onClosePopDialog("unionGift") 
            self:getChildByName("mask"):setVisible(false)  
            if force == false then
                return true      
            end
        end         
    end
    cclog("self._index:"..self._index)
    if self._index == 1 then
        local ad = self:getChildByName("ad")
        if ad:isVisible() == true and ad:getPositionY() == 0 then
            pop.onCloseEffect(99,ad)
            self:getChildByName("mask"):setVisible(false)
            if force == false then
                return true
            end
        end
        local notice = self:getChildByName("notice")
        if notice:isVisible() == true and notice:getPositionY() == 0 then
            pop.onCloseEffect(99,notice)
            self:getChildByName("mask"):setVisible(false)
            if force == false then
                return true
            end
        end
        if self._managerIndex == 5 then
            local widget = pop.getDialog("unionOption")
            if widget ~= nil then
                if widget:onReturn(widget) == true then
                    if force == false then
                        return true
                    end
                end
            end
        elseif self._managerIndex == 2 then    
            local widget = pop.getDialog("unionMember")
            if widget ~= nil then
                if widget:onReturn(widget) == true then
                    if force == false then
                        return true
                    end
                end
            end
        elseif self._managerIndex == 3 then    
            local widget = pop.getDialog("unionTec")
            if widget ~= nil then
                if widget:onClose() == true then
                    if force == false then
                        return true
                    end
                end
            end
        elseif self._managerIndex == 6 then
            local widget = pop.getDialog("unionHelp")
            if widget ~= nil then
                if widget:onReturn(widget) == true then
                    if force == false then
                        return true
                    end
                end
            end  
        elseif self._managerIndex == 7 then
            local widget = pop.getDialog("unionInnerRank")
            if widget ~= nil then
                if widget:onReturn(widget) == true then
                    if force == false then
                        return true
                    end
                end
            end      
        end
        return false
    elseif self._index == 3 then
        --先关闭排行内部的面板
        local widget = pop.getDialog("unionDiplomacy")
        if widget ~= nil then
            if widget:onClose() == true then
                if force == false then
                    return true
                end
            end
        end
        return false
    else
        return false
    end    
end

function unionLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("union")
        if widget:onClose() == false then
            pop.onClosePopDialog("union")
        end    
    end
end 
function onShowUnion(widget,index)
    local layer = unionLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
	layer:onInit(index)
	return layer
end