--联盟信息
local unionHelpLayer = class("unionHelp")
unionHelpLayer._name = "unionHelp"
unionHelpLayer._init = false
unionHelpLayer._parent = nil

function unionHelpLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, unionHelpLayer)
    return target
end

function unionHelpLayer:onAutoSize()
    local hh = ff.height
    self:setContentSize(cc.size(720,hh))
    self:getChildByName("mainArea"):setContentSize(cc.size(720,hh - 105 - 10 - 50))
    self:getChildByName("mainArea"):setPositionY(0)
    self:getChildByName("back"):setContentSize(cc.size(720,hh))
    self:getChildByName("back"):setPositionY(0)
    self:getChildByName("mask"):setContentSize(cc.size(720,hh - 105 - 10 - 50))
    self:getChildByName("mask"):setPositionY(0)
    self:getChildByName("bar"):setPositionY(hh - 105 - 51)
    self:getChildByName("mainArea"):getChildByName("helpArea"):setContentSize(cc.size(720,hh - 105 - 10 - 50 - 115))
end
function unionHelpLayer:onInit()
    if self._init == false then
        self:onAutoSize()
        local function oneKeyDealHelp(sender,eventType)
            if eventType==ccui.TouchEventType.ended then   
                if table.getn(dd.unionHelpList) <= 0 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有需要帮助的盟友"))
                    return
                end
                local message = ff.net:createMessage()
                message:addCmd(0x148)
                message:addLong(dd.uid)
                ff.net:rpc(message,false)
            end
        end
        --top条
        self:getChildByName("top"):setPositionY(ff.height - 105)
        self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onClose)
        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
        self:getChildByName("mainArea"):getChildByName("goBtn"):addTouchEventListener(oneKeyDealHelp)
        self:getChildByName("bar"):getChildByName("point_text"):setString(ff.getFormatMoney(dd.myUnion:getLong(1,'unionpoint')))
        self:getChildByName("mask"):setVisible(false)
        self._init = true
    end
    self.updateGold()
end
function unionHelpLayer.updateGold(name,row,old,value)
    local sender = pop.getDialog("unionHelp")
    if sender ~= nil then
        sender:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("top"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("top"):requestDoLayout()
    end    
end

function unionHelpLayer:initMyHelp()
    if dd.myHelp['buildHelp'] ~= nil or dd.myHelp['tecHelp'] ~= nil or dd.myHelp['buildHelp1'] ~= nil then
        self:getChildByName("mainArea"):getChildByName("chu_no_tip"):setVisible(false)
        if dd.myHelp['buildHelp'] ~= nil then
            dd.myHelper[1] = dd.myHelp['buildHelp']['curHelp']
            local help_1 = self:getChildByName("myHelpItem"):clone()
            help_1:setVisible(true)
            help_1:getChildByName("face"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(dd.myinfo:getLong(1,'face')),0)
            help_1:getChildByName("name_text"):setString(dd.myinfo:getString(1,'name'))
            if dd.myHelp['buildHelp']['buildLv'] == 0 then
                help_1:getChildByName("help_text"):setString(ff.langString("帮助我拆除Lv.{0} {1}",{dd.myHelp['buildHelp']['buildLv'],ff.langString(dd.cfgBuilding[dd.myHelp['buildHelp']['bid']]['name'])}))
            else
                help_1:getChildByName("help_text"):setString(ff.langString("帮助我升级Lv.{0} {1}",{dd.myHelp['buildHelp']['buildLv'],ff.langString(dd.cfgBuilding[dd.myHelp['buildHelp']['bid']]['name'])}))
            end
            help_1:getChildByName("help"):getChildByName("help_text"):setString("HELP "..dd.myHelp['buildHelp']['curHelp'].."/"..dd.myHelp['buildHelp']['maxHelp'])
            help_1:getChildByName("help"):getChildByName("progressBar"):setPercent(dd.myHelp['buildHelp']['curHelp']*100/dd.myHelp['buildHelp']['maxHelp'])
            self:getChildByName("mainArea"):getChildByName("helpArea"):addChild(help_1)
            help_1:setTag(1)
        end
        if dd.myHelp['tecHelp'] ~= nil then
            dd.myHelper[2] = dd.myHelp['tecHelp']['curHelp']
            local help_2 = self:getChildByName("myHelpItem"):clone()
            help_2:setVisible(true)       
            help_2:getChildByName("face"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(dd.myinfo:getLong(1,'face')),0)
            help_2:getChildByName("name_text"):setString(dd.myinfo:getString(1,'name'))
            help_2:getChildByName("help_text"):setString(ff.langString("帮助我升级Lv.{0} {1}",{dd.myHelp['tecHelp']['tecLv'],ff.langString(dd.cfgTec[dd.myHelp['tecHelp']['tid']]['tec_name'])}))
            help_2:getChildByName("help"):getChildByName("help_text"):setString("HELP "..dd.myHelp['tecHelp']['curHelp'].."/"..dd.myHelp['tecHelp']['maxHelp'])
            help_2:getChildByName("help"):getChildByName("progressBar"):setPercent(dd.myHelp['tecHelp']['curHelp']*100/dd.myHelp['tecHelp']['maxHelp'])            
            self:getChildByName("mainArea"):getChildByName("helpArea"):addChild(help_2)
            help_2:setTag(2)
        end
        if dd.myHelp['buildHelp1'] ~= nil then
            dd.myHelper[13] = dd.myHelp['buildHelp1']['curHelp']
            local help_3 = self:getChildByName("myHelpItem"):clone()
            help_3:setVisible(true)
            help_3:getChildByName("face"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(dd.myinfo:getLong(1,'face')),0)
            help_3:getChildByName("name_text"):setString(dd.myinfo:getString(1,'name'))
            if dd.myHelp['buildHelp1']['buildLv'] == 0 then
                help_3:getChildByName("help_text"):setString(ff.langString("帮助我拆除Lv.{0} {1}",{dd.myHelp['buildHelp1']['buildLv'],ff.langString(dd.cfgBuilding[dd.myHelp['buildHelp1']['bid']]['name'])}))
            else
                help_3:getChildByName("help_text"):setString(ff.langString("帮助我升级Lv.{0} {1}",{dd.myHelp['buildHelp1']['buildLv'],ff.langString(dd.cfgBuilding[dd.myHelp['buildHelp1']['bid']]['name'])}))
            end
            help_3:getChildByName("help"):getChildByName("help_text"):setString("HELP "..dd.myHelp['buildHelp1']['curHelp'].."/"..dd.myHelp['buildHelp1']['maxHelp'])
            help_3:getChildByName("help"):getChildByName("progressBar"):setPercent(dd.myHelp['buildHelp1']['curHelp']*100/dd.myHelp['buildHelp1']['maxHelp'])
            self:getChildByName("mainArea"):getChildByName("helpArea"):addChild(help_3)
            help_3:setTag(3)
        end
        self:getChildByName("mainArea"):getChildByName("helpArea"):refreshView()
    else
        if table.getn(dd.unionHelpList) <= 0 then
            self:getChildByName("mainArea"):getChildByName("chu_no_tip"):setVisible(true)           
        else
            self:getChildByName("mainArea"):getChildByName("chu_no_tip"):setVisible(false)
        end
    end
    self:updateBtmBtn()
end
function unionHelpLayer:updateBtmBtn()
    local flag = false
    if table.getn(dd.unionHelpList) > 0 then
        flag = true
    end
    self:getChildByName("mainArea"):getChildByName("goBtn"):setBright(flag)
    self:getChildByName("mainArea"):getChildByName("goBtn"):setTouchEnabled(flag)
    if flag == true then
        cclog("true")
        self:getChildByName("mainArea"):getChildByName("goBtn"):getChildByName("chu_Label_470"):setColor(cc.c3b(255,255,255))
    else
        cclog("false")
        self:getChildByName("mainArea"):getChildByName("goBtn"):getChildByName("chu_Label_470"):setColor(cc.c3b(116,123,125))
    end
end
function unionHelpLayer:backGetAllyHelpLists()
    self:initHelpList()
end
function unionHelpLayer:initHelpList()
    local layer = self:getChildByName("mainArea"):getChildByName("helpArea")
    layer:removeAllChildren(true)
    self:initMyHelp()
    local function showMemberInfo(sender,eventType)
        if eventType==ccui.TouchEventType.ended then  
            local tag = sender:getTag()
            pop.onShowPopDialog("power2",self,dd.unionHelpList[tag]["uid"])
        end
    end
    for var=1, table.getn(dd.unionHelpList) do
        local item = self:getChildByName("helpItem"):clone()
        item:getChildByName("face"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(dd.unionHelpList[var]['face']),0)
        item:getChildByName("name_text"):setString(dd.unionHelpList[var]['name'])

        if dd.unionHelpList[var]["hType"] == 1 or dd.unionHelpList[var]["hType"] == 13 then
            if dd.unionHelpList[var]['lv'] == 0 then
                item:getChildByName("help_text"):setString(ff.langString("帮助我拆除Lv.{0} {1}",{dd.unionHelpList[var]['lv'],ff.langString(dd.cfgBuilding[dd.unionHelpList[var]['hid']]['name'])}))   
            else
                item:getChildByName("help_text"):setString(ff.langString("帮助我升级Lv.{0} {1}",{dd.unionHelpList[var]['lv'],ff.langString(dd.cfgBuilding[dd.unionHelpList[var]['hid']]['name'])}))   
            end
        elseif dd.unionHelpList[var]["hType"] == 2 then           
            item:getChildByName("help_text"):setString(ff.langString("帮助我升级Lv.{0} {1}",{dd.unionHelpList[var]['lv'],ff.langString(dd.cfgTec[dd.unionHelpList[var]['hid']]['tec_name'])}))
        end
        item:getChildByName("help"):getChildByName("help_text"):setString("HELP "..dd.unionHelpList[var]['curHelp'].."/"..dd.unionHelpList[var]['maxHelp'])      
        item:getChildByName("help"):getChildByName("progressBar"):setPercent(dd.unionHelpList[var]['curHelp']*100/dd.unionHelpList[var]['maxHelp'])
        item:setVisible(true)
        item:setTag(var+3)
        item:getChildByName("face"):getChildByName("icon"):setTag(var)
        layer:addChild(item)
        item:getChildByName("face"):getChildByName("icon"):addTouchEventListener(showMemberInfo)
    end
    layer:refreshView()
end

function unionHelpLayer:backAllyHelpAction(ret)
    if ret[1] == 0 then
        self:getChildByName("bar"):getChildByName("point_text"):setString(ff.getFormatMoney(dd.myUnion:getLong(1,'unionpoint')))
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功帮助盟友"),true)
      
        if ret[2] > 0 then        
           dd.mainUI:showGiftNotice(10,0,ret[2],cc.p(360,ff.height/2),1)  
        end
        self:initHelpList()
    else
        dd.mainUI:onShowCodeTips(ret[1])
    end
end
function unionHelpLayer:noticeMyView()
    self:initHelpList()
    if dd.myHelp['buildHelp'] == nil and dd.myHelp['tecHelp'] == nil and dd.myHelp['buildHelp1'] == nil then
        if table.getn(dd.unionHelpList) <= 0 then
            self:getChildByName("mainArea"):getChildByName("chu_no_tip"):setVisible(true)
        else
            self:getChildByName("mainArea"):getChildByName("chu_no_tip"):setVisible(false)
        end
    end
    self:updateBtmBtn()
end
function unionHelpLayer:updateMyView(ret)
    local help_1 = self:getChildByName("mainArea"):getChildByName("helpArea"):getChildByTag(1)
    local help_2 = self:getChildByName("mainArea"):getChildByName("helpArea"):getChildByTag(2)
    local help_3 = self:getChildByName("mainArea"):getChildByName("helpArea"):getChildByTag(3)
    dd.myHelper[ret['type']] = ret['curHelp']
    if ret['type'] == 1 then
        dd.myHelp['buildHelp'] = {}
        dd.myHelp['buildHelp']['bid'] = ret['hid']
        dd.myHelp['buildHelp']['buildLv'] = ret['lv']
        dd.myHelp['buildHelp']['curHelp'] = ret['curHelp']
        dd.myHelp['buildHelp']['maxHelp'] = ret['maxHelp']
        dd.myHelp['buildHelp']['end'] = ret['endTime']
        help_1:setVisible(true)
        help_1:getChildByName("face"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(dd.myinfo:getLong(1,'face')),0)
        help_1:getChildByName("name_text"):setString(dd.myinfo:getString(1,'name'))
        if dd.myHelp['buildHelp']['buildLv'] == 0 then
            help_1:getChildByName("help_text"):setString(ff.langString("帮助我拆除Lv.{0} {1}",{dd.myHelp['buildHelp']['buildLv'],ff.langString(dd.cfgBuilding[dd.myHelp['buildHelp']['bid']]['name'])}))
        else
            help_1:getChildByName("help_text"):setString(ff.langString("帮助我升级Lv.{0} {1}",{dd.myHelp['buildHelp']['buildLv'],ff.langString(dd.cfgBuilding[dd.myHelp['buildHelp']['bid']]['name'])}))
        end
        help_1:getChildByName("help"):getChildByName("help_text"):setString("HELP "..dd.myHelp['buildHelp']['curHelp'].."/"..dd.myHelp['buildHelp']['maxHelp'])
        help_1:getChildByName("help"):getChildByName("progressBar"):setPercent(dd.myHelp['buildHelp']['curHelp']*100/dd.myHelp['buildHelp']['maxHelp'])

    elseif ret['type'] == 2 then
        dd.myHelp['tecHelp'] = {}
        dd.myHelp['tecHelp']['tid'] = ret['hid']
        dd.myHelp['tecHelp']['tecLv'] = ret['lv']
        dd.myHelp['tecHelp']['curHelp'] = ret['curHelp']
        dd.myHelp['tecHelp']['maxHelp'] = ret['maxHelp']
        dd.myHelp['tecHelp']['end'] = ret['endTime']
        help_2:setVisible(true)
        help_2:getChildByName("face"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(dd.myinfo:getLong(1,'face')),0)
        help_2:getChildByName("name_text"):setString(dd.myinfo:getString(1,'name'))
        help_2:getChildByName("help_text"):setString(ff.langString("帮助我升级Lv.{0} {1}",{dd.myHelp['tecHelp']['tecLv'],ff.langString(dd.cfgTec[dd.myHelp['tecHelp']['tid']]['tec_name'])}))
        help_2:getChildByName("help"):getChildByName("help_text"):setString("HELP "..dd.myHelp['tecHelp']['curHelp'].."/"..dd.myHelp['tecHelp']['maxHelp'])
        help_2:getChildByName("help"):getChildByName("progressBar"):setPercent(dd.myHelp['tecHelp']['curHelp']*100/dd.myHelp['tecHelp']['maxHelp'])            
    elseif ret['type'] == 13 then
        dd.myHelp['buildHelp1'] = {}
        dd.myHelp['buildHelp1']['bid'] = ret['hid']
        dd.myHelp['buildHelp1']['buildLv'] = ret['lv']
        dd.myHelp['buildHelp1']['curHelp'] = ret['curHelp']
        dd.myHelp['buildHelp1']['maxHelp'] = ret['maxHelp']
        dd.myHelp['buildHelp1']['end'] = ret['endTime']
        help_3:setVisible(true)
        help_3:getChildByName("face"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(dd.myinfo:getLong(1,'face')),0)
        help_3:getChildByName("name_text"):setString(dd.myinfo:getString(1,'name'))
        if dd.myHelp['buildHelp1']['buildLv'] == 0 then
            help_3:getChildByName("help_text"):setString(ff.langString("帮助我拆除Lv.{0} {1}",{dd.myHelp['buildHelp1']['buildLv'],ff.langString(dd.cfgBuilding[dd.myHelp['buildHelp1']['bid']]['name'])}))
        else
            help_3:getChildByName("help_text"):setString(ff.langString("帮助我升级Lv.{0} {1}",{dd.myHelp['buildHelp1']['buildLv'],ff.langString(dd.cfgBuilding[dd.myHelp['buildHelp1']['bid']]['name'])}))
        end
        help_3:getChildByName("help"):getChildByName("help_text"):setString("HELP "..dd.myHelp['buildHelp1']['curHelp'].."/"..dd.myHelp['buildHelp1']['maxHelp'])
        help_3:getChildByName("help"):getChildByName("progressBar"):setPercent(dd.myHelp['buildHelp1']['curHelp']*100/dd.myHelp['buildHelp1']['maxHelp'])

    end
    self:getChildByName("mainArea"):getChildByName("helpArea"):refreshView()
end
function unionHelpLayer:updateOtherView(ret)
    self:initHelpList()
    if table.getn(dd.unionHelpList) <= 0 and dd.myHelp['buildHelp'] == nil and dd.myHelp['tecHelp'] == nil and dd.myHelp['buildHelp1'] == nil then
        self:getChildByName("mainArea"):getChildByName("chu_no_tip"):setVisible(true)
    else
        self:getChildByName("mainArea"):getChildByName("chu_no_tip"):setVisible(false) 
    end
    self:updateBtmBtn()
end
function unionHelpLayer:deleteMyView(ret)
    dd.myHelper[ret['type']] = -1
    if ret['type'] == 1 then
        dd.myHelp['buildHelp'] = nil
    elseif ret['type'] == 2 then
        dd.myHelp['tecHelp'] = nil
    elseif ret['type'] == 13 then
        dd.myHelp['buildHelp1'] = nil
    end
    self:initHelpList()
    if dd.myHelp['buildHelp1'] == nil and dd.myHelp['buildHelp'] == nil and dd.myHelp['tecHelp'] == nil and table.getn(dd.unionHelpList) <= 0 then
        self:getChildByName("mainArea"):getChildByName("chu_no_tip"):setVisible(true)
    else
        self:getChildByName("mainArea"):getChildByName("chu_no_tip"):setVisible(false)
    end
    self:updateBtmBtn()
end
function unionHelpLayer:deleteOtherView(ret)
    self:initHelpList()
end
function unionHelpLayer:backSNAllyHelp(ret)
    cclog("reason:"..ret[1]['reason'])
    if ret[1]['reason'] == 0 then
        if ret[1]['uid'] == dd.uid then
            self:updateMyView(ret[1])
        else            
            self:updateOtherView(ret)
        end     
    elseif ret[1]['reason'] == 1 then
        if ret[1]['uid'] == dd.uid then
            self:deleteMyView(ret[1])
        else
            self:deleteOtherView(ret[1])
        end   
    end
end
function unionHelpLayer:addRegisterEvent()
    ff.net:registerEvent(1,dd.Tjf_union_AllyHelpAction,function (message)self:backAllyHelpAction(message)end)
    ff.net:registerEvent(1,dd.Tjf_notify_SNAllyHelp,function (message)self:backSNAllyHelp(message)end)
end

function unionHelpLayer.onEnd(sender)
    ff.net:unbindProperty("gold",105) 
    dd.delBackEvent()
    ff.net:removeEvent(1,dd.Tjf_union_AllyHelpAction)
    ff.net:removeEvent(1,dd.Tjf_notify_SNAllyHelp)
    sender:getChildByName("mainArea"):getChildByName("helpArea"):removeAllChildren()
end

function unionHelpLayer.onStart(sender)
    ff.net:bindProperty(105,"gold",sender.updateGold)  
    sender:addRegisterEvent()
    sender:backGetAllyHelpLists()
end

--界面即将播放
function unionHelpLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("icon"),sender:getChildByName("top"):getChildByName("addgold"))  

    return true
end

function unionHelpLayer.onClose(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionHelp")
        if widget~=nil then
            widget.onReturn(widget)
        end
    end
end
function unionHelpLayer.onReturn(sender)
    pop.onClosePopDialog("unionHelp")
    local union = pop.getDialog("union")
    if union ~= nil and union:isVisible() then
        union._managerIndex = 1
    end
    return false
end
function onShowUnionHelp(widget)
    local layer = unionHelpLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end
