--司令部升级
local unionInnerRankLayer   = class("unionInnerRankLayer")
unionInnerRankLayer._name = "unionInnerRank"
unionInnerRankLayer._init = false
unionInnerRankLayer.fType = 1 -- 1=捐献排名 2=战力排行 
unionInnerRankLayer.sType = 1 -- 1=今日 2=本周 3=历史
unionInnerRankLayer.infoList = {} 
unionInnerRankLayer.animFrames = {}
unionInnerRankLayer.myRank = 0 --当前显示的排行中我的排名
unionInnerRankLayer.cd = 0
unionInnerRankLayer.lastID = 0
unionInnerRankLayer.pageNum = 10 -- 每次最多显示多少条数据
unionInnerRankLayer.selectUid = 0
unionInnerRankLayer.selectKey = 0
unionInnerRankLayer.members = {}
function unionInnerRankLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, unionInnerRankLayer)
    return target
end
function unionInnerRankLayer:onInit()
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("rankInfo"):setContentSize(cc.size(720,hh - 105))
        self:getChildByName("rankInfo"):getChildByName("top"):setContentSize(cc.size(697,60))
        local infoH = hh - 105
        self:getChildByName("rankInfo"):getChildByName("topNavi"):setPositionY(infoH - 85)
        self:getChildByName("rankInfo"):getChildByName("panel_top"):setPositionY(infoH - 85 - 80)
        self:getChildByName("rankInfo"):getChildByName("top"):setPositionY(infoH - 85 - 80 - 30)
        self:getChildByName("rankInfo"):getChildByName("info"):setPositionY(infoH - 85 - 80 - 30 - 60)  
        self:getChildByName("rankInfo"):getChildByName("rankArea"):setContentSize(cc.size(720,ff.height - 105 - 285))
        self:getChildByName("mask"):setContentSize(cc.size(720,hh - 105))
        self:getChildByName("mask"):setPositionY(0)
        self:getChildByName("user"):setPositionY(0)
        self:initListener()
    end
    self.updateGold()
    self:addEvent()
end
function unionInnerRankLayer.updateGold(name,row,old,value)
    local sender = pop.getDialog("unionInnerRank")
    if sender ~= nil then
        sender:getChildByName("topArea"):getChildByName("gold_text"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("topArea"):getChildByName("gold_text"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("topArea"):requestDoLayout()
    end
end

function unionInnerRankLayer:getMainRankInfo()
    local message = ff.net:createMessage()
    message:addCmd(0x50)
    message:addLong(dd.uid)
    message:addLong(self.fType)
    message:addLong(self.sType)
    ff.net:rpc(message,false)
end

function unionInnerRankLayer:getRankData()
    local message = ff.net:createMessage()
    message:addCmd(0x50)
    message:addLong(dd.uid)
    message:addLong(self.fType)
    message:addLong(self.sType)    
    ff.net:rpc(message,false)
end
function unionInnerRankLayer.closeUser(sender,eventType)  
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionInnerRank")
        if widget ~= nil then
            widget:getChildByName("user"):setVisible(false)
            widget:getChildByName("mask"):setVisible(false)
            widget.selectUid = 0
        end
    end 
end
function unionInnerRankLayer:onCloseUser()
    self:getChildByName("user"):setVisible(false)
    self:getChildByName("mask"):setVisible(false)
    self.selectUid = 0
end

function unionInnerRankLayer.kickMember(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        if dd.myUnion:getLong(1,"unionofficial") < 5 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您没有足够的联盟权限！"))
            return
        end
        local widget = pop.getDialog("unionInnerRank")
        if widget ~= nil then
            local message = ff.net:createMessage()
            message:addCmd(0x0000011a)
            message:addLong(dd.uid)
            message:addLong(4)
            message:addLong(widget.selectUid)
            ff.net:rpc(message,false)
        end
    end  
end
function unionInnerRankLayer.levelUp(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        if dd.myUnion:getLong(1,"unionofficial") < 4 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您没有足够的联盟权限！"))
            return
        end

        local widget = pop.getDialog("unionInnerRank")
        local lv = widget.members[widget.selectUid]['ulevel']
        lv = tonumber(lv)
        if lv == 5 then
            if dd.myUnion:getLong(1,"unionofficial") < 6 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("您没有足够的联盟权限！"))
                return
            end
            local name = widget.members[widget.selectUid]['name']
            dd.currentLayer._widget:onShowSure(ff.langString("警告"),ff.langString("确定要将`{0}`提升为新的盟主吗？",{name}),function()
                local message = ff.net:createMessage()
                message:addCmd(0x12b)
                message:addLong(dd.uid)
                message:addString(name,15)
                ff.net:rpc(message,false)
            end,false,1)
            return
        end
        if widget ~= nil then
            local message = ff.net:createMessage()
            message:addCmd(0x11a)
            message:addLong(dd.uid)
            message:addLong(1)
            message:addLong(widget.selectUid)
            ff.net:rpc(message,false)
        end
    end  
end
function unionInnerRankLayer.levelDown(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        if dd.myUnion:getLong(1,"unionofficial") < 4 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您没有足够的联盟权限！"))
            return
        end
        local widget = pop.getDialog("unionInnerRank")
        if widget ~= nil then
            local message = ff.net:createMessage()
            message:addCmd(0x0000011a)
            message:addLong(dd.uid)
            message:addLong(2)
            message:addLong(widget.selectUid)
            ff.net:rpc(message,false)
        end
    end  
end
function unionInnerRankLayer.addArmys(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionInnerRank")
        if widget ~= nil then
            local row = widget.members[widget.selectUid]
            if row ~= nil then
                local params = {}
                params.cid = row["cid"]
                params.uid = widget.selectUid
                params.unionid = dd.myUnion:getLong(1,"unionid")
                params.short = dd.myUnion:getString(1,"unionflag")
                params.ulevel= row["ulevel"]
                params.name = row["name"]
                params.level= row["level"]
                params.type = 4
                pop.onShowPopDialog("chuzhen",4,params)
            end
            widget:onCloseUser()
        end
    end  
end
function unionInnerRankLayer.showInfo(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionInnerRank")
        if widget ~= nil then
            if widget.selectUid == 0 then
                return
            end
            if widget.selectUid == dd.uid then
                pop.onShowPopDialog("powerInfo")
            else
                pop.onShowPopDialog("power2",widget._parent,widget.selectUid)
            end
        end
    end  
end
function unionInnerRankLayer.transport(sender,eventType)
    if eventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("unionInnerRank")  
        local row = widget.members[widget.selectUid]
        if row ~= nil then
            local params = {}
            params.touid = widget.selectUid
            params.totem = dd.myUnion:getLong(1,"totem")
            params.level= dd.myinfo:getLong(1,"level")
            params.name = row["name"]
            params.cid = row["cid"]
            pop.onShowPopDialog("transport",params)
        end
    end
end
function unionInnerRankLayer:initListener()
    self:getChildByName("topArea"):getChildByName("return"):addTouchEventListener(self.onReturn)
    self:getChildByName("user"):getChildByName("close"):addTouchEventListener(self.closeUser)
    self:getChildByName("user"):getChildByName("view"):getChildByName("levelup"):addTouchEventListener(self.levelUp)
    self:getChildByName("user"):getChildByName("view"):getChildByName("leveldown"):addTouchEventListener(self.levelDown)
    self:getChildByName("user"):getChildByName("view"):getChildByName("kick"):addTouchEventListener(self.kickMember)
    self:getChildByName("user"):getChildByName("view"):getChildByName("addarmys"):addTouchEventListener(self.addArmys)
    self:getChildByName("user"):getChildByName("view"):getChildByName("detail"):addTouchEventListener(self.showInfo)
    self:getChildByName("user"):getChildByName("view"):getChildByName("trans_btn"):addTouchEventListener(self.transport)
    local function showJuanRank(sender,eventType)
        if eventType==ccui.TouchEventType.ended then 
            self.fType = 1
            self.sType = 1
            self:setRankType()
            self:freshView()
            self:getRankData()
            self:getChildByName("rankInfo"):getChildByName("rankArea"):scrollToTop(0.01,false)
            self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi1"):setSelectedState(true)
        end  
    end
    local function showFightRank(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            self.fType = 2
            self.sType = 1

            self:setRankType()
            self:freshView()
            self:getRankData()
            self:getChildByName("rankInfo"):getChildByName("rankArea"):scrollToTop(0.01,false)
            self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi1"):setSelectedState(true)
        end  
    end
    self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("kill"):addTouchEventListener(showFightRank)
    self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("fight"):addTouchEventListener(showJuanRank)
    local function showToday(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            self.sType = 1
            self:setSecType()
            self:freshView()
            self:freshItem()
            self:getRankData()
            self:getChildByName("rankInfo"):getChildByName("rankArea"):scrollToTop(0.01,false)
        end  
    end
    local function showWeek(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            self.sType = 2
            self:setSecType()
            self:freshView()
            self:freshItem()
            self:getRankData()
            self:getChildByName("rankInfo"):getChildByName("rankArea"):scrollToTop(0.01,false)
        end  
    end
    local function showAll(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            self.sType = 3
            self:setSecType()
            self:freshView()
            self:freshItem()
            self:getRankData()
            self:getChildByName("rankInfo"):getChildByName("rankArea"):scrollToTop(0.01,false)
        end  
    end
    self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi1"):addTouchEventListener(showToday)
    self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi2"):addTouchEventListener(showWeek)
    self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi3"):addTouchEventListener(showAll)
    self:getChildByName("rankInfo"):getChildByName("rankArea"):addScrollViewEventListener(self.scrollViewEvent)
    self:getChildByName("topArea"):getChildByName("add_btn"):addTouchEventListener(dd.onPay)
end
function unionInnerRankLayer:freshView()   
    for var=1,10 do
        local item = self:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(var)
        if item ~= nil then
            item:getChildByName("rank_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            item:getChildByName("mark_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            item:getChildByName("back"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            item:setVisible(false)
        end
    end
    for var=1,table.getn(self.infoList) do
        if var > 10 and var <= self.lastID then
            self:getChildByName("rankInfo"):getChildByName("rankArea"):removeChildByTag(var)           
        end
    end
    self.infoList = {} 
    self:getChildByName("rankInfo"):getChildByName("rankArea"):setInnerContainerSize(cc.size(720,111 * 10))
    self:getChildByName("rankInfo"):getChildByName("rankArea"):refreshView()
    self:getChildByName("rankInfo"):getChildByName("rankArea"):jumpToTop()
    self.lastID = 0
end
function unionInnerRankLayer:setSecType()
    self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi1"):setTouchEnabled(true)
    self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi1"):setSelectedState(false)
    self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi1"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
    self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi2"):setTouchEnabled(true)
    self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi2"):setSelectedState(false)
    self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi2"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
    self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi3"):setTouchEnabled(true)
    self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi3"):setSelectedState(false)
    self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi3"):getChildByName("chu_label"):setColor(cc.c3b(97,117,123))
    self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi"..self.sType):setTouchEnabled(false)
    self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi"..self.sType):getChildByName("chu_label"):setColor(cc.c3b(223,239,244))

end
function unionInnerRankLayer:setRankType()
    self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("fight"):setTouchEnabled(true)
    self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("fight"):setSelectedState(false)
    self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("fight"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("kill"):setTouchEnabled(true)
    self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("kill"):setSelectedState(false)
    self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("kill"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))    

    if self.fType == 1 then
        self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("fight"):setTouchEnabled(false)
        self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("fight"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("rankInfo"):getChildByName("info"):getChildByName("chu_fight_tip"):setString(ff.langString("联盟贡献"))

        self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi1"):getChildByName("chu_label"):setString(ff.langString("今日排名"))
        self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi2"):getChildByName("chu_label"):setString(ff.langString("本周排名"))
        self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi3"):getChildByName("chu_label"):setString(ff.langString("历史排名"))
    elseif self.fType == 2 then
        self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("kill"):setTouchEnabled(false)
        self:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("kill"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("rankInfo"):getChildByName("info"):getChildByName("chu_fight_tip"):setString(ff.langString("战力"))

        self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi1"):getChildByName("chu_label"):setString(ff.langString("今日榜"))
        self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi2"):getChildByName("chu_label"):setString(ff.langString("本周榜"))
        self:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi3"):getChildByName("chu_label"):setString(ff.langString("战力总榜"))
    end
    self:setSecType()
    self:freshItem()
end
function unionInnerRankLayer.lastLogin(secends)
    if secends == 0 then
        return ""
    elseif dd.getServerTime() - secends < 3600 * 24 then
        return ff.langString("{0}天之内",{1})
    elseif dd.getServerTime() - secends < 3600 * 24 * 3 then   
        return ff.langString("{0}天前",{1})
    elseif dd.getServerTime() - secends < 3600 * 24 * 7 then   
        return ff.langString("{0}天前",{3})
    else
        return ff.langString("{0}天前",{7})
    end  
end
function unionInnerRankLayer:updateBtnLevel(ulevel,target,uid)
    local user = self:getChildByName("user"):getChildByName("view")
    if target == 6 then
        user:getChildByName("levelup"):getChildByName("chu_jc_label"):setVisible(true)
        user:getChildByName("levelup"):getChildByName("chu_label"):setVisible(false)
        user:getChildByName("levelup"):getChildByName("chu_rank"):setVisible(false)
        user:getChildByName("levelup"):getChildByName("chu_jc_label"):setString(ff.langString("已是最高"))
    elseif target == 5 then
        user:getChildByName("levelup"):getChildByName("chu_jc_label"):setVisible(true)
        user:getChildByName("levelup"):getChildByName("chu_label"):setVisible(false)
        user:getChildByName("levelup"):getChildByName("chu_rank"):setVisible(false)
        user:getChildByName("levelup"):getChildByName("chu_jc_label"):setString(ff.langString("继承"))
    else
        user:getChildByName("levelup"):getChildByName("chu_jc_label"):setVisible(false)
        user:getChildByName("levelup"):getChildByName("chu_label"):setVisible(true)
        user:getChildByName("levelup"):getChildByName("chu_rank"):setVisible(true)
        user:getChildByName("levelup"):getChildByName("chu_label"):setString(ff.langString("提升到"))
        user:getChildByName("levelup"):getChildByName("chu_rank"):setString("Rank"..(target + 1))
    end

    if target == 1 then
        user:getChildByName("leveldown"):getChildByName("chu_jc_label"):setVisible(true)
        user:getChildByName("leveldown"):getChildByName("chu_label"):setVisible(false)
        user:getChildByName("leveldown"):getChildByName("chu_rank"):setVisible(false)
        user:getChildByName("leveldown"):getChildByName("chu_jc_label"):setString(ff.langString("已是最低"))

    else
        user:getChildByName("leveldown"):getChildByName("chu_jc_label"):setVisible(false)
        user:getChildByName("leveldown"):getChildByName("chu_label"):setVisible(true)
        user:getChildByName("leveldown"):getChildByName("chu_rank"):setVisible(true)
        user:getChildByName("leveldown"):getChildByName("chu_label"):setString(ff.langString("降职为"))
        if target == 5 then
            user:getChildByName("leveldown"):getChildByName("chu_rank"):setString("Rank3")
        else
            user:getChildByName("leveldown"):getChildByName("chu_rank"):setString("Rank"..(target - 1))
        end
    end

    if ulevel >= 5 then
        if  ulevel > target then
            user:getChildByName("levelup"):setBright(true)
            user:getChildByName("levelup"):getChildByName("chu_jc_label"):setColor(cc.c3b(255,255,255))
            user:getChildByName("levelup"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
            user:getChildByName("levelup"):getChildByName("chu_rank"):setColor(cc.c3b(255,255,255))
            user:getChildByName("levelup"):setTouchEnabled(true)
            user:getChildByName("leveldown"):setBright(true)
            user:getChildByName("leveldown"):getChildByName("chu_jc_label"):setColor(cc.c3b(255,255,255))
            user:getChildByName("leveldown"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
            user:getChildByName("leveldown"):getChildByName("chu_rank"):setColor(cc.c3b(255,255,255))
            user:getChildByName("leveldown"):setTouchEnabled(true)
            user:getChildByName("kick"):setBright(true)
            user:getChildByName("kick"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
            user:getChildByName("kick"):setTouchEnabled(true)
        else
            user:getChildByName("levelup"):setBright(false)      
            user:getChildByName("levelup"):getChildByName("chu_jc_label"):setColor(cc.c3b(116,123,125))
            user:getChildByName("levelup"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
            user:getChildByName("levelup"):getChildByName("chu_rank"):setColor(cc.c3b(116,123,125))      
            user:getChildByName("leveldown"):setBright(false)
            user:getChildByName("leveldown"):getChildByName("chu_jc_label"):setColor(cc.c3b(116,123,125))
            user:getChildByName("leveldown"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
            user:getChildByName("leveldown"):getChildByName("chu_rank"):setColor(cc.c3b(116,123,125))
            user:getChildByName("kick"):setBright(false)
            user:getChildByName("kick"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))

            user:getChildByName("leveldown"):setTouchEnabled(false)
            user:getChildByName("levelup"):setTouchEnabled(false)
            user:getChildByName("kick"):setTouchEnabled(false)
        end
        user:getChildByName("update_tips"):setVisible(true)
        user:getChildByName("tag"):setVisible(true)
    else    
        user:getChildByName("levelup"):setBright(false)
        user:getChildByName("leveldown"):setBright(false)
        user:getChildByName("kick"):setBright(false)
        user:getChildByName("levelup"):getChildByName("chu_jc_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("levelup"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("levelup"):getChildByName("chu_rank"):setColor(cc.c3b(116,123,125))
        user:getChildByName("leveldown"):getChildByName("chu_jc_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("leveldown"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("leveldown"):getChildByName("chu_rank"):setColor(cc.c3b(116,123,125))
        user:getChildByName("kick"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        
        user:getChildByName("leveldown"):setTouchEnabled(false)
        user:getChildByName("levelup"):setTouchEnabled(false)
        user:getChildByName("kick"):setTouchEnabled(false)
        user:getChildByName("update_tips"):setVisible(false)
        user:getChildByName("tag"):setVisible(false)
    end  

    if target == 1 then
        user:getChildByName("leveldown"):setBright(false)
        user:getChildByName("leveldown"):getChildByName("chu_jc_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("leveldown"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("leveldown"):getChildByName("chu_rank"):setColor(cc.c3b(116,123,125))
        user:getChildByName("leveldown"):setTouchEnabled(false)
    end   
    if uid == dd.uid then
        user:getChildByName("addarmys"):setBright(false)
        user:getChildByName("addarmys"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("trans_btn"):setBright(false)
        user:getChildByName("trans_btn"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        user:getChildByName("addarmys"):setTouchEnabled(false)
        user:getChildByName("trans_btn"):setTouchEnabled(false)
    else
        user:getChildByName("addarmys"):setBright(true)
        user:getChildByName("addarmys"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
        user:getChildByName("trans_btn"):setBright(true)
        user:getChildByName("trans_btn"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
        user:getChildByName("addarmys"):setTouchEnabled(true)
        user:getChildByName("trans_btn"):setTouchEnabled(true)
    end
end
function unionInnerRankLayer:showUser(info)
    cclog("showUser uid:"..info['uid']) 
    local user = self:getChildByName("user"):getChildByName("view")
    user:getChildByName("name"):setString(info["name"])
    user:getChildByName("level"):setString(info["level"])
    user:getChildByName("power"):setString(ff.getFormatMoney(info["power"]))
    user:getChildByName("kills"):setString(ff.getFormatMoney(info["kills"]))
    user:getChildByName("tag"):setString(self.lastLogin(info["lastupdate"]))

    user:getChildByName("face"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(info["face"]),0)

    local ulevel = dd.myUnion:getLong(1,"unionofficial")
    local target = info["ulevel"]

    self:updateBtnLevel(ulevel,target,info["uid"])

    if self:getChildByName("user"):isVisible() == false then
        self:getChildByName("user"):setVisible(true)
        self:getChildByName("mask"):setVisible(true)
        self:getChildByName("user"):setPosition(cc.p(0,0))
    end
    if ulevel >= 5 then
        self:getChildByName("user"):setContentSize(cc.size(720,540))
        self:getChildByName("user"):getChildByName("view"):setContentSize(cc.size(720,540))
        self:getChildByName("user"):getChildByName("close"):setPositionY(515)
    else
        self:getChildByName("user"):setContentSize(cc.size(720,440))
        self:getChildByName("user"):getChildByName("view"):setContentSize(cc.size(720,440))
        self:getChildByName("user"):getChildByName("close"):setPositionY(415)
    end
    self.selectUid = info['uid']
end

function unionInnerRankLayer:freshItem()
    local it = self:getChildByName("rankItem") 
    if self.fType == 2 and self.sType < 3 then
        for var=1,10 do
            local item = self:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(var)
            if var <= 10 and item ~= nil then
                item:getChildByName("name"):setVisible(true)
                item:getChildByName("rank"):setVisible(true)
                item:getChildByName("user_name"):setVisible(false)
                item:getChildByName("user_rank"):setVisible(false)
                item:getChildByName("fight_tip"):setVisible(true)
                item:getChildByName("fight_text"):setVisible(true)   
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1)) 
                item:getChildByName("icon"):setVisible(true)  
                item:getChildByName("honor_text"):setColor(cc.c3b(161,175,175))     
            end
        end
        it:getChildByName("name"):setVisible(true)
        it:getChildByName("rank"):setVisible(true)
        it:getChildByName("user_name"):setVisible(false)
        it:getChildByName("user_rank"):setVisible(false)
        it:getChildByName("fight_tip"):setVisible(true)
        it:getChildByName("fight_text"):setVisible(true)  
        it:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))   
        it:getChildByName("icon"):setVisible(true)  
    elseif self.fType == 1 then
        for var=1,10 do
            local item = self:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(var)
            if var <= 10 and item ~= nil then
                item:getChildByName("name"):setVisible(false)
                item:getChildByName("rank"):setVisible(false)
                item:getChildByName("user_name"):setVisible(true)
                item:getChildByName("user_rank"):setVisible(true)
                item:getChildByName("fight_tip"):setVisible(false)
                item:getChildByName("fight_text"):setVisible(false)   
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/ic13.png",1))  
                item:getChildByName("icon"):setVisible(true)   
                item:getChildByName("honor_text"):setColor(cc.c3b(161,175,175))            
            end
        end
        it:getChildByName("name"):setVisible(false)
        it:getChildByName("rank"):setVisible(false)
        it:getChildByName("user_name"):setVisible(true)
        it:getChildByName("user_rank"):setVisible(true)
        it:getChildByName("fight_tip"):setVisible(false)
        it:getChildByName("fight_text"):setVisible(false)   
        it:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/ic13.png",1))
        it:getChildByName("icon"):setVisible(true)  
    elseif self.fType == 2 and self.sType == 3 then
        for var=1,10 do
            local item = self:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(var)
            if var <= 10 and item ~= nil then
                item:getChildByName("name"):setVisible(false)
                item:getChildByName("rank"):setVisible(false)
                item:getChildByName("user_name"):setVisible(true)
                item:getChildByName("user_rank"):setVisible(true)
                item:getChildByName("fight_tip"):setVisible(false)
                item:getChildByName("fight_text"):setVisible(false)   
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))  
                item:getChildByName("icon"):setVisible(false)   
                item:getChildByName("honor_text"):setColor(cc.c3b(161,175,175))     
            end
        end
        it:getChildByName("name"):setVisible(false)
        it:getChildByName("rank"):setVisible(false)
        it:getChildByName("user_name"):setVisible(true)
        it:getChildByName("user_rank"):setVisible(true)
        it:getChildByName("fight_tip"):setVisible(false)
        it:getChildByName("fight_text"):setVisible(false)   
        it:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        it:getChildByName("icon"):setVisible(false)
    end
end
function unionInnerRankLayer:freshMyRank()
    self:getChildByName("rankInfo"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setVisible(true)    
    if self.sType < 3 then
        self:getChildByName("rankInfo"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setString(ff.langString("重置时间")..": "..dd.getTimeStr2(self.cd - dd.getServerTime()))
    else
        if self.myRank <= 0 then                    
            self:getChildByName("rankInfo"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setString(ff.langString("您尚未进入此排名"))        
        else
            self:getChildByName("rankInfo"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setString(ff.langString("我的排名")..":"..self.myRank)        
        end
    end
end

function unionInnerRankLayer:showWaiting(play)
    self:getChildByName("waiting"):getChildByTag(1):stopAllActions()
    if play == true then
        local animation = cc.Animation:createWithSpriteFrames(self.animFrames, 0.1)
        self:getChildByName("waiting"):getChildByTag(1):runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
        self:getChildByName("waiting"):setVisible(true) 
    else        
        self:getChildByName("waiting"):setVisible(false)
    end
end

function unionInnerRankLayer:getRankIcon(rank)
    if rank <= 3 then
        return "images/icon/rank/"..rank..".png"
    elseif rank <= 10 then
        return "images/icon/rank/tag01_rank.png"
    elseif rank <= 100 then
        return "images/icon/rank/tag02_rank.png"
    elseif rank <= 999 then
        return "images/icon/rank/tag03_rank.png"
    end
end

function unionInnerRankLayer:getMarkIcon(i)
   return dd.getPlayerIcon(self.infoList[i]["face"])
end

function unionInnerRankLayer:backGetAllyStatRank(params)
    cclog(".................")
    local code = params[1]
    if code == 0 then
        local datas = params[2]
        self.myRank = 0
        self.cd = params[3]
        cclog(" data num:"..datas:rowCount().."cd:"..self.cd)
        if datas ~= nil then
            for i=1,datas:rowCount() do
                local row = table.getn(self.infoList) + 1
                self.infoList[row] = {}
                self.infoList[row]["rank"] = datas:getLong(i,"rank")
                self.infoList[row]["uid"] = datas:getLong(i,"uid")
                if self.infoList[row]["uid"] == dd.uid then
                    self.myRank = self.infoList[row]["rank"]
                end
                self.infoList[row]["name"] = datas:getString(i,"name")
                self.infoList[row]["face"] = datas:getLong(i,"face")
                self.infoList[row]["fight"] = datas:getLong(i,"fight")             
                self.infoList[row]["value"] = datas:getLong(i,"value")
                self.infoList[row]["office"] = datas:getLong(i,"office")
                self.infoList[row]["del"] = 0
            end
        end
        self:freshMyRank()
        if datas ~= nil then
            self:updatePage()
        else
            self:showWaiting(false)
        end    
    else
        dd.showPopTip(code)        
    end
end
function unionInnerRankLayer.scrollViewEvent(sender, evenType)
    if evenType == ccui.ScrollviewEventType.bounceBottom then
        local rank = pop.getDialog("unionInnerRank")
        if rank:getChildByName("waiting"):isVisible() == false and rank:isVisible() == true  then
            rank:checkUpdate()
        end    
    elseif evenType ==  ccui.ScrollviewEventType.scrollToTop then
    end
end
function unionInnerRankLayer:checkUpdate()  
    if self.lastID < table.getn(self.infoList) then
        self:showWaiting(true)
        self:updatePage(true)
        self.pageNum = 10
    end
end

function unionInnerRankLayer:getMemberInfo(uid)
    local message = ff.net:createMessage()
    message:addCmd(0x15)
    message:addLong(dd.uid)
    message:addLong(uid)
    ff.net:rpc(message,false)
end
function unionInnerRankLayer:updatePage(flag)
    local nextpage = false
    if flag ~= nil then
        nextpage = flag
    end

    local function showUnionInfo(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then        
            local key = sender:getTag() 
            local info = self.infoList[key]

            self:getMemberInfo(info['uid'])
            AudioEngine.playEffect(ff.sounds[109])
        end
    end
    local beforey = self:getChildByName("rankInfo"):getChildByName("rankArea"):getInnerContainer():getPositionY()

    for i=1,table.getn(self.infoList) do
        if i > self.lastID and i <= self.lastID + self.pageNum and self.infoList[i]["del"] == 0 then
            local rank = self.infoList[i]["rank"]
            local item = self:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(i)
            if item == nil then
                item = self:getChildByName("rankItem"):clone()
                item:setVisible(true)
                item:setTag(i)
                self:getChildByName("rankInfo"):getChildByName("rankArea"):addChild(item)
            end   
            if rank > 999 then
                item:getChildByName("rank_icon"):setVisible(false)
                item:getChildByName("rank_panel"):getChildByName("rank_text"):setVisible(true)   
                item:getChildByName("rank_panel"):getChildByName("rank_text"):setString(rank)
                item:getChildByName("back"):setVisible(false)        
            else
                item:getChildByName("rank_icon"):setVisible(true)
                item:getChildByName("rank_icon"):loadTexture(self:getRankIcon(rank),0)
                if rank > 3 then
                    item:getChildByName("rank_panel"):getChildByName("rank_text"):setVisible(true)            
                    item:getChildByName("rank_panel"):getChildByName("rank_text"):setString(rank)
                    item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionX(38)
                    if rank > 100 then
                        item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionY(50)
                    else
                        item:getChildByName("rank_panel"):getChildByName("rank_text"):setPositionY(43)
                    end
                    item:getChildByName("back"):setVisible(false)     
                else
                    item:getChildByName("back"):setVisible(true)
                    item:getChildByName("back"):loadTexture("images/icon/rank/back_"..rank..".png",0)
                    item:getChildByName("rank_panel"):getChildByName("rank_text"):setVisible(false)
                end
            end
            item:getChildByName("mark_icon"):loadTexture(self:getMarkIcon(i),0)
            if self.fType == 1 then
                item:getChildByName("user_name"):setString(self.infoList[i]["name"])  
                item:getChildByName("user_rank"):setString(self.infoList[i]["office"])     
                item:getChildByName("honor_text"):setString(ff.getFormatMoney(self.infoList[i]["value"]))
            elseif self.fType == 2 and self.sType < 3 then
                item:getChildByName("name"):setString(self.infoList[i]["name"])   
                item:getChildByName("rank"):setString(self.infoList[i]["office"])         
                item:getChildByName("fight_text"):setString(ff.getFormatMoney(self.infoList[i]["fight"]))
                if self.infoList[i]["value"] < 0 then
                    item:getChildByName("icon"):loadTexture(dd.getPathFromUI("down.png",1))
                    item:getChildByName("honor_text"):setString(ff.getFormatMoney(self.infoList[i]["value"]*(-1)))
                    item:getChildByName("honor_text"):setColor(cc.c3b(237,101,101))
                elseif self.infoList[i]["value"] > 0 then
                    item:getChildByName("icon"):loadTexture(dd.getPathFromUI("up.png",1))
                    item:getChildByName("honor_text"):setString(ff.getFormatMoney(self.infoList[i]["value"]))
                    item:getChildByName("honor_text"):setColor(cc.c3b(161,175,175))
                else
                    item:getChildByName("icon"):loadTexture(dd.getPathFromUI("arrow.png",1))
                    item:getChildByName("honor_text"):setString(ff.getFormatMoney(self.infoList[i]["value"]))
                    item:getChildByName("honor_text"):setColor(cc.c3b(161,175,175))
                end
            else
                item:getChildByName("user_name"):setString(self.infoList[i]["name"])   
                item:getChildByName("user_rank"):setString(self.infoList[i]["office"]) 
                item:getChildByName("honor_text"):setString(ff.getFormatMoney(self.infoList[i]["fight"]))
            end
    
            item:setVisible(true)
            item:addTouchEventListener(showUnionInfo)
        elseif i > self.lastID and i <= self.lastID + self.pageNum and self.infoList[i]["del"] == 1 then
            self.pageNum = self.pageNum + 1
        end   
    end    
    self.lastID  = self.lastID + self.pageNum 
    if self.lastID > table.getn(self.infoList) then
        self.lastID = table.getn(self.infoList)    
    end    
    if nextpage then
        self:getChildByName("rankInfo"):getChildByName("rankArea"):getInnerContainer():setPositionY(beforey)     
        self:getChildByName("rankInfo"):getChildByName("rankArea"):refreshView()
        if table.getn(self.infoList) > 0 then
            local function func()
                self:showWaiting(false)   
            end
            local seq = cc.Sequence:create(cc.MoveBy:create(0.3,cc.p(0,20)),cc.CallFunc:create(func))
            self:getChildByName("rankInfo"):getChildByName("rankArea"):getInnerContainer():runAction(seq)
        end
    else
        self:showWaiting(false)   
    end
end
function unionInnerRankLayer:backAllyMemberAction(ret)
    if ret[1] == 0 then
        local lv = self.members[ret[3]]['ulevel']
        if ret[2] == 1 then
            self.members[ret[3]]['ulevel'] = self.members[ret[3]]['ulevel'] + 1
            if lv == 5 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("该成员已成功继任为会长！"),true)
            else
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("该成员的官职已被提升一级！"),true)
            end
            for i=1,table.getn(self.infoList) do
                if self.infoList[i]['uid'] == ret[3] then
                    self.infoList[i]['office'] = self.infoList[i]['office'] + 1
                    local item = self:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(i)
                    if item ~= nil then
                        item:getChildByName("user_rank"):setString(self.infoList[i]['office'])                     
                    end
                    break
                end
            end
            self:updateBtnLevel(dd.myUnion:getLong(1,'unionofficial'),lv+1,ret[3])  
        elseif ret[2] == 2 then
            local newLv = lv-1
            if lv == 5 then
                newLv = 3
            end
            self.members[ret[3]]['ulevel'] = newLv
            for i=1,table.getn(self.infoList) do
                if self.infoList[i]['uid'] == ret[3] then
                    self.infoList[i]['office'] = newLv
                    local item = self:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(i)
                    if item ~= nil then
                        item:getChildByName("user_rank"):setString(newLv)                     
                    end
                    break
                end
            end
            self:updateBtnLevel(dd.myUnion:getLong(1,'unionofficial'),newLv,ret[3])           
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("该成员的官职已被降低一级！"))
        elseif ret[2] == 4 then
            self:onCloseUser() 
            for i=1,table.getn(self.infoList) do
                if self.infoList[i]['uid'] == ret[3] then
                    self.infoList[i]['del'] = 1 
                    local item = self:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(i)
                    if item ~= nil then
                       self:getChildByName("rankInfo"):getChildByName("rankArea"):removeChild(item,true) 
                       self:getChildByName("rankInfo"):getChildByName("rankArea"):refreshView()                   
                    end
                    break
                end
            end
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("该成员已被踢出联盟！"))
        end
    else
        dd.mainUI:onShowCodeTips(ret[1])
        return
    end
end
function unionInnerRankLayer:backGetAllyMemberBrief(ret)
    if ret['code'] == 0 then
        self:showUser(ret)
        self.members[ret["uid"]] = ret 
    else
        dd.mainUI:onShowCodeTips(ret['code'])
        --dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(ret[1]))
        return
    end
end
function unionInnerRankLayer:addEvent()
    ff.net:registerEvent(2,dd.Tjf_union_AllyMemberAction, function (message)self:backAllyMemberAction(message)end)
    ff.net:registerEvent(1,dd.Tjf_GetAllyStatRank,function (message)self:backGetAllyStatRank(message)end)
    ff.net:registerEvent(1,dd.Tjf_GetAllyMemberBrief,function (message)self:backGetAllyMemberBrief(message)end)
    ff.net:bindProperty(2409,"gold",function ()self.updateGold() end) 
end
--界面显示后调用
function unionInnerRankLayer.onStart(sender)
    if sender._init == false then       
        --先添加10条
        sender:getChildByName("rankItem"):getChildByName("fight_tip"):setString(ff.langString("战力")..":")
        for i=1,10 do
            local item = sender:getChildByName("rankItem"):clone()
            item:setTag(i)
            sender:getChildByName("rankInfo"):getChildByName("rankArea"):addChild(item)
        end
        sender:getChildByName("rankInfo"):getChildByName("rankArea"):refreshView()

        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("images/mv/normaleffect.plist")

        local mv = cc.Sprite:createWithSpriteFrameName("of_native_loader_progress_01.png")
        local xx = sender:getChildByName("waiting"):getChildByName("label"):getPositionX()
        mv:setContentSize(cc.size(30,30))
        mv:setPosition(cc.p(xx - 30,15))
        mv:setScale(0.4)

        sender:getChildByName("waiting"):addChild(mv,1,1)
        for j = 1, 12 do
            local frame = nil
            if j < 10 then
                frame = cache:getSpriteFrame("of_native_loader_progress_0"..j..".png")
            else    
                frame = cache:getSpriteFrame("of_native_loader_progress_"..j..".png")
            end 
            sender.animFrames[j] = frame
        end
        sender._init = true
    end
    sender:setRankType()
    sender:freshView() 
    sender:getMainRankInfo()  
    sender:getChildByName("rankInfo"):getChildByName("panel_top"):getChildByName("btn_navi1"):setSelectedState(true)
    sender:getChildByName("rankInfo"):getChildByName("topNavi"):getChildByName("fight"):setSelectedState(true)
    schedule(sender, sender.updateCD,1)
end
function unionInnerRankLayer.updateCD(sender)
    if sender ~= nil then
        if sender.sType < 3 then
            if sender.cd > dd.getServerTime() then
                sender:getChildByName("rankInfo"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setString(ff.langString("重置时间")..": "..dd.getTimeStr2(sender.cd - dd.getServerTime()))
            else
                sender:getChildByName("rankInfo"):getChildByName("top"):getChildByName("chu_no_rank_tip"):setString(ff.langString("重置时间")..": "..dd.getTimeStr2(0))
            end
        end
    end
end
--界面关闭效果结束后调用
function unionInnerRankLayer.onEnd(sender,btns)
    cclog("onEnd:unionInnerRankLayer")
    dd.delBackEvent()
    ff.net:removeEvent(2,dd.Tjf_union_AllyMemberAction)
    ff.net:removeEvent(1,dd.Tjf_GetAllyStatRank)
    ff.net:removeEvent(1,dd.Tjf_GetAllyMemberBrief)
    ff.net:unbindProperty("gold",2409) 

    for var=1,table.getn(sender.infoList) do
        local item = sender:getChildByName("rankInfo"):getChildByName("rankArea"):getChildByTag(var)
        if item ~= nil then
            if ff.platform ~= 1 then
                item:getChildByName("rank_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("mark_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("back"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
            item:setVisible(false)
            if var > 10 then
                sender:getChildByName("rankInfo"):getChildByName("rankArea"):removeChild(item,true)
            end        
        end
    end
    sender.fType = 1
    sender.sType = 1
    sender.infoList = {} 
    sender.animFrames = {}  
    sender.members = {} 
    sender:getChildByName("rankInfo"):getChildByName("rankArea"):jumpToTop()
    sender:stopAllActions()
    sender.cd = 0 
    sender.selectUid = 0
    sender.selectKey = 0
    sender.lastID = 0
    sender:onCloseUser()
end
--界面即将播放显示缓动时调用，返回false界面显示将终止
function unionInnerRankLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("icon"),sender:getChildByName("topArea"):getChildByName("add_btn"))
    return true
end

function unionInnerRankLayer:onClose()
    return false
end
function unionInnerRankLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("unionInnerRank")
        if widget~=nil and widget:getChildByName("waiting"):isVisible() then
            return
        end
        if widget:getChildByName("user"):isVisible() == true and widget:getChildByName("user"):getPositionY() == 0 then
            widget:onCloseUser()
            return true
        end
        if widget~=nil and widget:onClose() == false then
            pop.onClosePopDialog("unionInnerRank")
            local union = pop.getDialog("union")
            if union ~= nil and union:isVisible() then
                union._managerIndex = 1
            end
        end    
    end
end
function onShowUnionInnerRank(widget)
    local layer = unionInnerRankLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end