--联盟科技
local unionTecLayer   = class("unionTec")
unionTecLayer._name = "unionTec"
unionTecLayer._init = false
unionTecLayer._tecs = {}
unionTecLayer._tecmaxlv = 11          --主科技最大等级
unionTecLayer._techlvup = {}
unionTecLayer._old_time = {}
--成员变量下面还有呢

function unionTecLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, unionTecLayer)
    return target
end

function unionTecLayer:onInit()
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))        
        self:getChildByName("view"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("masking"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("masking"):setPositionY(0)
        self:getChildByName("bg"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("bg"):setPositionY(0)
        self:getChildByName("topArea"):setPositionY(hh - 105)
        
        self:getChildByName("view"):getChildByName("view"):setContentSize(cc.size(720,hh-105-50-4))
        self:getChildByName("besure"):setContentSize(cc.size(720,hh))
        self:getChildByName("besure"):setPositionY(0)
        
        self:getChildByName("top"):setPositionY(hh - 50 - 105)
        self:getChildByName("view"):getChildByName("view"):setPositionY(0)
        
        --pop2
        local function openPop2(sender,touchEventType)
            if touchEventType==ccui.TouchEventType.ended then   
                pop.showPopEffect(12,self:getChildByName("pop2"))  
                self:getChildByName("masking"):setVisible(true)                
            end             
        end
        self:getChildByName("top"):getChildByName("help"):addTouchEventListener(openPop2)
        self:getChildByName("pop2"):getChildByName("close"):addTouchEventListener(self.closePop2)
        
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
        --view    
        self:getChildByName("view"):getChildByName("view"):getChildByName("mtec"):getChildByName("tec101"):addTouchEventListener(self.selectTec)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec102"):addTouchEventListener(self.selectTec)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec103"):addTouchEventListener(self.selectTec)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec104"):addTouchEventListener(self.selectTec)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec105"):addTouchEventListener(self.selectTec)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec106"):addTouchEventListener(self.selectTec)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec107"):addTouchEventListener(self.selectTec)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec108"):addTouchEventListener(self.selectTec)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec109"):addTouchEventListener(self.selectTec)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec110"):addTouchEventListener(self.selectTec)
        self:getChildByName("view"):getChildByName("view"):getChildByName("mtec"):getChildByName("tec101"):setTag(101)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec102"):setTag(102)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec103"):setTag(103)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec104"):setTag(104)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec105"):setTag(105)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec106"):setTag(106)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec107"):setTag(107)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec108"):setTag(108)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec109"):setTag(109)
        self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec110"):setTag(110)
        --加粗
        self:getChildByName("utecinfo"):getChildByName("board"):getChildByName("name"):getChildByName("chu_name"):getVirtualRenderer():enableBold(true)
        self:getChildByName("utecinfo"):getChildByName("board"):getChildByName("effect"):getChildByName("title_1"):getVirtualRenderer():enableBold(true)
        self:getChildByName("utecinfo"):getChildByName("board"):getChildByName("effect"):getChildByName("title_2"):getVirtualRenderer():enableBold(true)
        --联盟科技信息
        self:initTecInfo()
        self:initBesure()
    end    
    self.updateGold()
    self._expUp = false
end

function unionTecLayer:initBesure()
    local function resetCD(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local message = ff.net:createMessage()
            message:addCmd(0x0000016e)
            message:addLong(dd.uid)
            ff.net:rpc(message,false)
        end
    end
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("sure"):addTouchEventListener(resetCD)
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):addTouchEventListener(self.closeBesure)
end

function unionTecLayer:onInitCfg()
    --升级表
    local tecslvup = ff.dbmanager:sql_fetch_rows("select * from cfg_league_tech_levelup")
    for i=1, tecslvup:rowCount() do
        local tec_id = tonumber(tecslvup:getString(i, "id"))
        local info = {}
        info['id'] = tonumber(tecslvup:getString(i, "id"))
        info['techid'] = tonumber(tecslvup:getString(i, "techid"))
        info['level'] = tonumber(tecslvup:getString(i, "level"))
        info['unionlevel'] = tonumber(tecslvup:getString(i, "unionlevel"))
        info['exp'] = tonumber(tecslvup:getString(i, "exp"))
        info['fund1'] = tonumber(tecslvup:getString(i, "fund1"))
        info['fund2'] = tonumber(tecslvup:getString(i, "fund2"))
        info['fund3'] = tonumber(tecslvup:getString(i, "fund3"))
        info['effect1'] = tonumber(tecslvup:getString(i, "effect1"))
        info['params1'] = tonumber(tecslvup:getString(i, "params1"))
        info['effect2'] = tonumber(tecslvup:getString(i, "effect2"))
        info['params2'] = tonumber(tecslvup:getString(i, "params2"))
        info['effect3'] = tonumber(tecslvup:getString(i, "effect3"))
        info['params3'] = tonumber(tecslvup:getString(i, "params3"))   
        info['effect4'] = tonumber(tecslvup:getString(i, "effect4"))
        info['params4'] = tonumber(tecslvup:getString(i, "params4"))     
        
        info['leffect1'] = tonumber(tecslvup:getString(i, "leffect1"))
        info['lparams1'] = tonumber(tecslvup:getString(i, "lparams1"))
        info['leffect2'] = tonumber(tecslvup:getString(i, "leffect2"))
        info['lparams2'] = tonumber(tecslvup:getString(i, "lparams2"))
        info['leffect3'] = tonumber(tecslvup:getString(i, "leffect3"))
        info['lparams3'] = tonumber(tecslvup:getString(i, "lparams3"))   
        info['leffect4'] = tonumber(tecslvup:getString(i, "leffect4"))
        info['lparams4'] = tonumber(tecslvup:getString(i, "lparams4"))  
        self._techlvup[info['techid']] = self._techlvup[info['techid']] or {}
        self._techlvup[info['techid']][info['level']] = info
    end
    tecslvup:clear()
    
    self._tecmaxlv = dd.cfgUnionTec[101]['maxlevel']
end

function unionTecLayer:updateInfo()
    self:stopAllActions()
    local view = self:getChildByName("view"):getChildByName("view")
    local tecs = view:getChildByName("ctec")
    --联盟等级 = 主科技等级
    view:getChildByName("mtec"):getChildByName("level"):getChildByName("unionlv"):setString(self._tecs[101]["level"].."/"..self._tecmaxlv)
    view:getChildByName("mtec"):getChildByName("level"):getChildByName("teclv"):setString(self._tecs[101]["level"])
    view:getChildByName("mtec"):getChildByName("level"):requestDoLayout()
    view:getChildByName("mtec"):getChildByName("exppro"):getChildByName("level"):setString("LV."..self._tecs[101]["level"])
    local percent101 = 0
    if self._techlvup[101][self._tecs[101]["level"]+1] ~= nil then
        percent101 = math.floor(100*self._tecs[101]["exp"]/self._techlvup[101][self._tecs[101]["level"]+1]["exp"]) 
        view:getChildByName("mtec"):getChildByName("exppro"):getChildByName("exp"):setString(self._tecs[101]["exp"].."/"..self._techlvup[101][self._tecs[101]["level"]+1]["exp"])
    else
        view:getChildByName("mtec"):getChildByName("exppro"):getChildByName("exp"):setString(self._tecs[101]["exp"].."/".."0")
    end
    if percent101 > 100 then
        percent101 = 100
    end
    view:getChildByName("mtec"):getChildByName("exppro"):getChildByName("pro"):setPercent(percent101)
    
    view:getChildByName("mtec"):getChildByName("tec101"):getChildByName("icon"):loadTexture(dd.getUnionTecIcon(101), 0)
    
    --子科技      i是科技id
    local have = false
    for i, item in pairs(dd.cfgUnionTec) do
        if i ~= 101 then
            local percent = 0
            local time = self._tecs[i]["endtime"] - dd.getServerTime()
            if self._techlvup[i][self._tecs[i]["level"]+1] ~= nil then
                percent = math.floor(100*self._tecs[i]["exp"]/self._techlvup[i][self._tecs[i]["level"]+1]["exp"]) 
            end
            if percent > 100 then
                percent = 100
            end
            tecs:getChildByName("tec"..i):getChildByName("level"):getChildByName("level"):setString("LV."..self._tecs[i]["level"])
            tecs:getChildByName("tec"..i):getChildByName("level"):getChildByName("exppro"):setPercent(percent)
            view:getChildByName("ctec"):getChildByName("tec"..i):getChildByName("icon"):loadTexture(dd.getUnionTecIcon(i), 0)
            if time > 0 then
                local total = self._tecs[i]["endtime"] - self._tecs[i]["startime"]
                local cur   = self._tecs[i]["endtime"] - dd.getServerTime()
                view:getChildByName("ctec"):getChildByName("tec"..i):getChildByName("time"):setVisible(true)
                view:getChildByName("ctec"):getChildByName("tec"..i):getChildByName("time"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                view:getChildByName("ctec"):getChildByName("tec"..i):getChildByName("time"):getChildByName("pro"):setPercent(100*cur/total)
                self:addSpineAnimation(i)
                have = true
            else
                view:getChildByName("ctec"):getChildByName("tec"..i):getChildByName("time"):setVisible(false)
                self:unShowSpineAnimation(i)
            end
        end
    end
    if have == true then
        schedule(self, self.showAction,1)
    end
end

function unionTecLayer.selectTec(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("unionTec")
        unionTecLayer:donateTec(0, sender:getTag())  
    end
end

function unionTecLayer:getMyAllyTec()
    local message = ff.net:createMessage()
    message:addCmd(0x035)
    message:addLong(dd.uid)
    ff.net:rpc(message,false)
end

function unionTecLayer:onGetMyAllyTec(params)
    local code = params[1]
    if code == 0 then
        self:updateMainPage()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
function unionTecLayer.showAction()
    local sender = pop.getDialog("unionTec")
	local ctec = sender:getChildByName("view"):getChildByName("view"):getChildByName("ctec")
	for i=1,dd.myUnionTecs:rowCount() do
		local id = dd.myUnionTecs:getLong(i,"id")
		local startime = dd.myUnionTecs:getLong(i,"startime")
		local endtime = dd.myUnionTecs:getLong(i,"endtime")
		local time = endtime - dd.getServerTime()
		if time > 0 then
			local total = endtime - startime
			local cur = endtime - dd.getServerTime()
			if id == 102 then
				ctec:getChildByName("tec102"):getChildByName("time"):getChildByName("pro"):setPercent(100*cur/total)
				ctec:getChildByName("tec102"):getChildByName("time"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
			elseif id == 103 then
				ctec:getChildByName("tec103"):getChildByName("time"):getChildByName("pro"):setPercent(100*cur/total)
				ctec:getChildByName("tec103"):getChildByName("time"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
			elseif id == 104 then
				ctec:getChildByName("tec104"):getChildByName("time"):getChildByName("pro"):setPercent(100*cur/total)
				ctec:getChildByName("tec104"):getChildByName("time"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
            elseif id == 105 then
                ctec:getChildByName("tec105"):getChildByName("time"):getChildByName("pro"):setPercent(100*cur/total)
                ctec:getChildByName("tec105"):getChildByName("time"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
            elseif id == 106 then
                ctec:getChildByName("tec106"):getChildByName("time"):getChildByName("pro"):setPercent(100*cur/total)
                ctec:getChildByName("tec106"):getChildByName("time"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
            elseif id == 107 then
                ctec:getChildByName("tec107"):getChildByName("time"):getChildByName("pro"):setPercent(100*cur/total)
                ctec:getChildByName("tec107"):getChildByName("time"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
			end
            if id == sender._tid then
                if sender:getChildByName("utecinfo"):isVisible() == true then
                    local infotime = sender:getChildByName("utecinfo"):getChildByName("board"):getChildByName("time")
                    infotime:getChildByName("time"):setString(ff.getLeftTime(time,":"))
                    infotime:getChildByName("progress"):setPercent(100*cur/total)                    
                end
            end
		else
            if sender._old_time[i] ~= nil and sender._old_time[i] >= 0 then
                sender._old_time[i] = time
			    sender:updateInfo()
                break
            end
		end
        sender._old_time[i] = time
	end
	if sender:getChildByName("utecinfo"):isVisible() == true then
        local cdtime = sender._cdtime - dd.getServerTime()
    	if cdtime > 0 then
            sender:getChildByName("utecinfo"):getChildByName("time"):getChildByName("time"):setString(ff.getLeftTime(cdtime,":"))
            if cdtime > 4*60*60 then
                sender:getChildByName("utecinfo"):getChildByName("time"):getChildByName("time"):setColor(cc.c3b(255,0,0))
            else
                sender:getChildByName("utecinfo"):getChildByName("time"):getChildByName("time"):setColor(cc.c3b(223,239,244))
            end
    	end
	end
end

function unionTecLayer:updateData()
    self._tecs = {} 
    for i=1,dd.myUnionTecs:rowCount() do
        cclog("ssss == "..i)
        local tid = dd.myUnionTecs:getLong(i,"id")
        self._tecs[tid] = {}
        self._tecs[tid]["level"] = dd.myUnionTecs:getLong(i,"level")
        self._tecs[tid]["exp"] = dd.myUnionTecs:getLong(i,"exp")
        self._tecs[tid]["endtime"] = dd.myUnionTecs:getLong(i,"endtime")
        self._tecs[tid]["startime"]= dd.myUnionTecs:getLong(i,"startime")
    end
    for id, item in pairs(dd.cfgUnionTec) do
        cclog("tid == "..id)
        if self._tecs[id] == nil then
            self._tecs[id] = {}
            self._tecs[id]["level"] = 0
            self._tecs[id]["exp"] = 0
            self._tecs[id]["endtime"]  = 0
            self._tecs[id]["startime"]= 0
        end
    end
end

function unionTecLayer.updateGold()
    local widget = pop.getDialog("unionTec")
    if widget ~= nil then
        widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
        widget:getChildByName("topArea"):requestDoLayout()

        local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
    end
end

function unionTecLayer:onClose()
    local widget = pop.getDialog("unionTec")
    if widget ~= nil then
        pop.onClosePopDialog("unionTec")
    end
    return false
end
--========联盟科技信息
unionTecLayer._tid = 101
unionTecLayer._level = 0
unionTecLayer._maxlevel = 0
unionTecLayer._times = 10800
unionTecLayer._cdtime = 0
unionTecLayer._expUp  = false    --标识进度条是否动画

function unionTecLayer:initTecInfo()
    local function close(sender, eventType)
        if eventType==ccui.TouchEventType.ended then 
            self:onCloseTecInfo()
        end
    end
    --增效
    local function onBuffer(sender, eventType)
        if eventType==ccui.TouchEventType.ended then 
            self.openPop()
        end
    end
    --捐献
    local function onSend(sender, eventType)
        if eventType==ccui.TouchEventType.ended then 
            local type = 0                  --0是查询
            if sender:getName() == "btn_res_1" then
                type = 1
            elseif sender:getName() == "btn_res_2" then
                type = 2
            elseif sender:getName() == "btn_res_3" then
                type = 3
            end    
                    
            if self._level < self._maxlevel then
                local cdtime = self._cdtime - dd.getServerTime()
                if cdtime > 4*60*60 then
                    self:openBesure()
                    --dd.currentLayer._widget:onShowTips("\t"..ff.langString("捐献正在CD"))
                else
                    self:donateTec(type, self._tid)
                end
            else
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("请升级主科技等级"))
            end
        end
    end
    --升级
    local function onUpgrade(sender, eventType)
        if eventType==ccui.TouchEventType.ended then     
            local message = ff.net:createMessage()
            message:addCmd(0x15c)
            message:addLong(dd.uid) 
            message:addLong(self._tid)  --联盟科技号  
            ff.net:rpc(message,false)
            cclog("升级的id == "..self._tid)
        end
    end
    
    local info = self:getChildByName("utecinfo")
    info:getChildByName("close"):addTouchEventListener(close)
    info:getChildByName("board"):getChildByName("activebtn"):addTouchEventListener(onBuffer)
    info:getChildByName("button"):getChildByName("btn_res_1"):addTouchEventListener(onSend)
    info:getChildByName("button"):getChildByName("btn_res_2"):addTouchEventListener(onSend)
    info:getChildByName("button"):getChildByName("btn_res_3"):addTouchEventListener(onSend)
    info:getChildByName("progress"):getChildByName("upgradebtn"):addTouchEventListener(onUpgrade)
    
    self:initPop()
end

function unionTecLayer:initPop()
    local pop = self:getChildByName("utecinfo"):getChildByName("pop")

    --单选框
    local function onSelect(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            if sender:getSelectedState() == true then
                pop:getChildByName("timer1"):setSelectedState(false)
                pop:getChildByName("timer2"):setSelectedState(false)
                pop:getChildByName("timer3"):setSelectedState(false)     
                return
            end    

            pop:getChildByName("timer1"):setSelectedState(false)
            pop:getChildByName("timer2"):setSelectedState(false)
            pop:getChildByName("timer3"):setSelectedState(false)     
            if sender:getName() == "timer1" then
                self._times = 10800
            elseif sender:getName() == "timer2" then
                self._times = 28800
            elseif sender:getName() == "timer3" then
                self._times = 86400
            end
            self:updatePop()
        end
    end

    --addeffect      
    local function onAddEffect(sender, eventType)
        if eventType==ccui.TouchEventType.ended then   
            local message = ff.net:createMessage()
            message:addCmd(0x115)
            message:addLong(dd.uid) 
            message:addLong(self._tid)  --联盟科技号  
            message:addLong(self._times)           --时间
            ff.net:rpc(message,false)
        end
    end

    pop:getChildByName("close"):addTouchEventListener(self.closePop)
    pop:getChildByName("actbtn"):addTouchEventListener(onAddEffect)
    pop:getChildByName("timer1"):addTouchEventListener(onSelect)
    pop:getChildByName("timer2"):addTouchEventListener(onSelect)
    pop:getChildByName("timer3"):addTouchEventListener(onSelect)

    pop:getChildByName("timer1"):setSelectedState(true)
end


function unionTecLayer:updateTecInfo(tid, info)
    cclog("刷新显示联盟科技信息 ==== updateTecInfo   id == "..tid)
    local lv = 0
    local exps = 0
    local endtime = 0
    for i=1,dd.myUnionTecs:rowCount() do
        if dd.myUnionTecs:getLong(i,"id") == tid then
            lv = dd.myUnionTecs:getLong(i,"level")
            exps = dd.myUnionTecs:getLong(i,"exp")
            endtime = dd.myUnionTecs:getLong(i,"endtime")
        end
        if dd.myUnionTecs:getLong(i,"id") == 101 then
            self._maxlevel = dd.myUnionTecs:getLong(i,"level")
        end
    end
    local time = endtime - dd.getServerTime()
    local cdtime = self._cdtime - dd.getServerTime()
    local percent = 0
    
    --更新选中科技id,等级,等级上限
    self._level = lv
    if tid == 101 then
        self._maxlevel = self._tecmaxlv
    end
    
    if self._techlvup[tid][lv+1] ~= nil then
        percent = math.floor(100*exps/self._techlvup[tid][lv+1]["exp"]) 
        self:getChildByName("utecinfo"):getChildByName("progress"):getChildByName("exp"):setString(exps.."/"..self._techlvup[tid][lv+1]["exp"])
        if exps >= self._techlvup[tid][lv+1]["exp"] then
            self:setBtnLight(self:getChildByName("utecinfo"):getChildByName("progress"):getChildByName("upgradebtn"), true)
            percent = 100
        else
            self:setBtnLight(self:getChildByName("utecinfo"):getChildByName("progress"):getChildByName("upgradebtn"), false)
        end
    else
        self:getChildByName("utecinfo"):getChildByName("progress"):getChildByName("exp"):setString(exps.."/".."999k...")
    end
    cclog("exp =="..exps)

    local board = self:getChildByName("utecinfo"):getChildByName("board")
    board:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getUnionTecIcon(tid), 0)
    board:getChildByName("name"):getChildByName("chu_name"):setString(ff.langString(dd.cfgUnionTec[tid]['techname']))
    
    self:getChildByName("utecinfo"):getChildByName("progress"):getChildByName("level"):setString("LV."..lv)
    --官员才能看到升级\激活按钮
    if dd.myUnion:getLong(1,"unionofficial") > 3 then
        self:getChildByName("utecinfo"):getChildByName("progress"):getChildByName("progress_1"):setVisible(false)
        self:getChildByName("utecinfo"):getChildByName("progress"):getChildByName("progress_2"):setVisible(true)
        self:getChildByName("utecinfo"):getChildByName("progress"):getChildByName("upgradebtn"):setVisible(true)
        board:getChildByName("activebtn"):setVisible(true)        
        local progress = self:getChildByName("utecinfo"):getChildByName("progress"):getChildByName("progress_2")
        progress:stopAllActions()
        if self._expUp == true then
            --此处只会0次
            dd.myProgressTo(progress,0, percent, 2)
        else
            progress:setPercent(percent)
        end
        self._expUp = false
    else
        self:getChildByName("utecinfo"):getChildByName("progress"):getChildByName("progress_1"):setVisible(true)
        self:getChildByName("utecinfo"):getChildByName("progress"):getChildByName("progress_2"):setVisible(false)
        self:getChildByName("utecinfo"):getChildByName("progress"):getChildByName("upgradebtn"):setVisible(false)
        board:getChildByName("activebtn"):setVisible(false)
        local progress = self:getChildByName("utecinfo"):getChildByName("progress"):getChildByName("progress_1")
        progress:stopAllActions()
        if self._expUp == true then
            --此处只会0次
            dd.myProgressTo(progress,0, percent, 2)
        else
            progress:setPercent(percent)
        end
        self._expUp = false
    end
    cclog("percent == "..percent)
    --效果tips          --初始0级,固定显示效果
    local flevel = lv
    if lv == 0 then                   
        flevel = 1
    end
    if tid == 101 then
        board:getChildByName("effect"):getChildByName("title_1"):setVisible(true)
        board:getChildByName("effect"):getChildByName("title_2"):setVisible(false)
        board:getChildByName("effect"):getChildByName("deffect"):setVisible(false)
        board:getChildByName("activebtn"):setVisible(false)
        if self._techlvup[tid][flevel] ~= nil then            
            for i=1,4 do
                local effid = self._techlvup[tid][flevel]["effect"..i]
                local value = self._techlvup[tid][flevel]["params"..i]
                board:getChildByName("effect"):getChildByName("deffect"..i):setVisible(false)
                if lv == 0 then
                    value = 0
                end
                if effid ~= 0 then
                    board:getChildByName("effect"):getChildByName("effect"..i):setVisible(true)
                    board:getChildByName("effect"):getChildByName("effect"..i):setString(self.getEffectTips(effid, value))
                else
                    board:getChildByName("effect"):getChildByName("effect"..i):setVisible(false)
                end   
            end
        end
    else
        board:getChildByName("effect"):getChildByName("title_1"):setVisible(true)
        board:getChildByName("effect"):getChildByName("title_2"):setVisible(true)
        if self._techlvup[tid][flevel] ~= nil then
            for i=1,4 do
                local effid = self._techlvup[tid][flevel]["effect"..i]
                local value = self._techlvup[tid][flevel]["params"..i]
                local leffid = 0 --self._techlvup[tid][flevel]["leffect"..i]
                local lvalue = 0 --self._techlvup[tid][flevel]["lparams"..i]
                if lv == 0 then
                    value = 0
                    lvalue = 0
                end
                if effid ~= 0 then
                    board:getChildByName("effect"):getChildByName("effect"..i):setVisible(true)
                    board:getChildByName("effect"):getChildByName("effect"..i):setString(self.getEffectTips(effid, value))
                else
                    board:getChildByName("effect"):getChildByName("effect"..i):setVisible(false)
                end   
                if leffid ~= 0 then
                    board:getChildByName("effect"):getChildByName("deffect"..i):setVisible(true)
                    board:getChildByName("effect"):getChildByName("deffect"..i):setString(self.getEffectTips(leffid, lvalue))
                else
                    board:getChildByName("effect"):getChildByName("deffect"..i):setVisible(false)
                end  
            end
            --特殊处理文字过长 当激活效果多个的时候 此代码要改
            local eid  = self._techlvup[tid][flevel]["leffect1"]
            local eval = self._techlvup[tid][flevel]["lparams1"]
            if eid ~= 0 then
                board:getChildByName("effect"):getChildByName("deffect"):setVisible(true)
                board:getChildByName("effect"):getChildByName("deffect"):setString(self.getEffectTips(eid, eval))
            else
                board:getChildByName("effect"):getChildByName("deffect"):setVisible(false)
            end 
        end
    end
    --可以捐献的物品 buttons
    local buttons = self:getChildByName("utecinfo"):getChildByName("button")
    for i=1,table.getn(info) do
        local type = info[i]["type"]
        local tid = info[i]["id"]
        local btn = buttons:getChildByName("btn_res_"..i)
        if type ~= 0 then
            btn:getChildByName("chu_label"):setVisible(false)
            btn:getChildByName("icon"):setVisible(true)
            btn:getChildByName("value"):setVisible(true)
            if type == 7 then
                btn:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/img01_dead.png",1))
            else
                btn:getChildByName("icon"):loadTexture(dd.getGiftsIcon(type, tid)[1],dd.getGiftsIcon(type, tid)[2])
            end
            btn:getChildByName("value"):setString(info[i]["count"])
            self:setBtnLight(btn, true)
        else
            btn:getChildByName("chu_label"):setVisible(true)
            btn:getChildByName("icon"):setVisible(false)
            btn:getChildByName("value"):setVisible(false)
            self:setBtnLight(btn, false)
        end
        if percent >= 100 then
            self:setBtnLight(btn, false)
        end
        buttons:getChildByName("gifts"..i):getChildByName("pt_value"):setString(info[i]["fund"])
        buttons:getChildByName("gifts"..i):getChildByName("exp_value"):setString(info[i]["exp"])
    end
    --倒计时
    if time > 0 then
        board:getChildByName("time"):setVisible(true)
        self:setBtnLight(board:getChildByName("activebtn"), false)
        self.showAction()
        schedule(self, self.showAction,1)
    else
        board:getChildByName("time"):setVisible(false)
        if lv > 0 then
            self:setBtnLight(board:getChildByName("activebtn"), true)
        else
            self:setBtnLight(board:getChildByName("activebtn"), false)
        end
    end
    if cdtime > 0 then
        self.showAction()
        schedule(self, self.showAction,1)
    else
        self:getChildByName("utecinfo"):getChildByName("time"):getChildByName("time"):setString("00:00:00")
        self:getChildByName("utecinfo"):getChildByName("time"):getChildByName("time"):setColor(cc.c3b(223,239,244))
    end
end

function unionTecLayer:updatePop()      
    local tid = self._tid
    local pop = self:getChildByName("utecinfo"):getChildByName("pop")
    if self._techlvup[tid][self._level] ~= nil then
        if self._times == 10800 then
            pop:getChildByName("actbtn"):getChildByName("num"):setString(self._techlvup[tid][self._level]["fund1"])
        elseif self._times == 28800 then
            pop:getChildByName("actbtn"):getChildByName("num"):setString(self._techlvup[tid][self._level]["fund2"])
        elseif self._times == 86400 then
            pop:getChildByName("actbtn"):getChildByName("num"):setString(self._techlvup[tid][self._level]["fund3"])
        end
    end
end

function unionTecLayer:setBtnLight(node, light)
    if light == true then
        node:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        node:setTouchEnabled(true)
        node:getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
    else 
        local effect = ff.Effect:effectGrey()    
        node:getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        node:setTouchEnabled(false)
        if node:getName() ~= "activebtn" then
            node:getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
        end
    end
end
function unionTecLayer.getEffectTips(effectid,value)
    local evalue = dd.cfgEffect[effectid]['value']    
    if evalue ~= 0 then
        value = value/evalue
    end
    return ff.langString(dd.cfgEffect[effectid]['tips1'], {value})
end

function unionTecLayer:onUpUnionTec(params)
    local code = params[1]
    if code == 0 then
        local id = params[2]
        local info = params[3]
        local operation = params[4]
        self._cdtime = params[5]      
        if self:getChildByName("utecinfo"):isVisible() == false then
            self._tid = id 
            self:getChildByName("masking"):setVisible(true)
            pop.showPopEffect(12,self:getChildByName("utecinfo"))  
        else
            if operation ~= 0 then
                self._expUp = true
                local addpoint = params[6]
                local addfund  = params[7]
                if dd.mainUI ~= nil then
                    dd.mainUI:showGiftNotice(10,0,addpoint,cc.p(360,250))
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("捐献成功").." "..ff.langString("获得联盟贡献x{0}",{addpoint}),true)
                end
            end
        end       
        self:updateMainPage()
        self:updateTecInfo(id, info)   
    else
        if code > 100000 then
            --dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(100000))
            dd.mainUI:onShowCodeTips(100000)
        else
            dd.mainUI:onShowCodeTips(code)
        end
    end
end

function unionTecLayer:onActUnionTec(params)
    local code = params[1]
    if code == 0 then
        self.closePop(self,ccui.TouchEventType.ended)
        self:donateTec(0, self._tid) 
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("激活成功"),true)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
function unionTecLayer:onUpgradeUnionTec(params)
    local code = params[1]
    if code == 0 then
        self:donateTec(0, self._tid) 
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("升级成功"),true)
    else
        dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(code))
    end
end

function unionTecLayer:onResetTecCD(params)
    local code = params[1]
    if code == 0 then
        self.closeBesure(self, ccui.TouchEventType.ended)
        self:donateTec(0, self._tid)
        AudioEngine.playEffect(ff.sounds[212])           --212消耗金币声音
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("重置成功"),true)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function unionTecLayer:onNotifyUniontTec()
    if self:getChildByName("utecinfo"):isVisible() == true then
        self:donateTec(0, self._tid)
    else
        self:updateMainPage()
    end
end

function unionTecLayer.openPop()
    local widget = pop.getDialog("unionTec") 
    widget:updatePop()
    pop.showPopEffect(12,widget:getChildByName("utecinfo"):getChildByName("pop"))
end
function unionTecLayer.closePop(sender,touchEventType)
    local function unShow()
        local widget = pop.getDialog("unionTec")
        widget:getChildByName("utecinfo"):getChildByName("pop"):setVisible(false)
    end    

    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("unionTec") 
        widget:getChildByName("utecinfo"):getChildByName("pop"):setPosition(cc.p(0,0))
        widget:getChildByName("utecinfo"):getChildByName("pop"):setVisible(false)
        --[[
        if widget ~= nil then
            widget:getChildByName("utecinfo"):getChildByName("pop"):runAction(cc.Sequence:create(cc.MoveTo:create(0.5, cc.p(0,-535)),cc.CallFunc:create(unShow)))
        end 
        --]]                        
    end    
end
function unionTecLayer.closePop2(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("unionTec")
        widget:getChildByName("pop2"):setVisible(false)   
        widget:getChildByName("masking"):setVisible(false)                 
    end  
end
function unionTecLayer:onCloseTecInfo()
    local utecInfo = self:getChildByName("utecinfo")
    self:updateMainPage()
    local function unShow()
        utecInfo:setVisible(false)
        self:getChildByName("masking"):setVisible(false)
    end    
    utecInfo:setVisible(false)
    self:getChildByName("masking"):setVisible(false)
    --[[
    utecInfo:runAction(cc.Sequence:create(cc.MoveTo:create(0.5, cc.p(0,-utecInfo:getContentSize().height)),cc.CallFunc:create(unShow)))
    --]]
end

--cd重置的
function unionTecLayer:openBesure() 
    local cdtime = self._cdtime - dd.getServerTime()
    local gold = math.ceil(dd.getRealGoodp(cdtime))
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("sure"):getChildByName("count"):setString(gold)
    pop.showPopEffect(99,self:getChildByName("besure"))
end

function unionTecLayer.closeBesure(sender, touchEventType)
    if touchEventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("unionTec")
        widget:getChildByName("besure"):setVisible(false)   
    end
end

function unionTecLayer:updateMainPage()
    --self:getChildByName("top"):getChildByName("fund"):setString(ff.getFormatMoney(dd.myUnion:getLong(1, "nAllyFunds") ))--unionpoint
    --(需求改成:所有成员可见)
    if dd.myUnion:getLong(1,"unionofficial") > 0 then
        self:getChildByName("top"):getChildByName("offier"):setVisible(true)  --官
        self:getChildByName("top"):getChildByName("people"):setVisible(false)
        self:getChildByName("top"):getChildByName("offier"):getChildByName("value1"):setString(ff.getFormatMoney(dd.myUnion:getLong(1, "nAllyFunds") ))
        self:getChildByName("top"):getChildByName("offier"):getChildByName("value2"):setString(ff.getFormatMoney(dd.myUnion:getLong(1, "unionpoint") ))
    else
        self:getChildByName("top"):getChildByName("offier"):setVisible(false)
        self:getChildByName("top"):getChildByName("people"):setVisible(true)   --民
        self:getChildByName("top"):getChildByName("people"):getChildByName("value"):setString(ff.getFormatMoney(dd.myUnion:getLong(1, "unionpoint") ))
    end
    self:updateData()
    self:updateInfo()
end

function unionTecLayer:donateTec(type, id)
    local message = ff.net:createMessage()
    message:addCmd(0x00000146)
    message:addLong(dd.uid)
    message:addLong(id)
    message:addLong(type)
    ff.net:rpc(message,false)
end

function unionTecLayer:addSpineAnimation(tid)
    local item = self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec"..tid)
    local animation = item:getChildByTag(101)
    local size = item:getContentSize()
    if animation ~= nil then
        animation:setVisible(true)
    else
        animation = sp.SkeletonAnimation:create("images/effect/lianmengkeji/lianmengkeji.json", "images/effect/lianmengkeji/lianmengkeji.atlas")
        item:addChild(animation,10,101)
        animation:setVisible(true)
        animation:setAnimation(0,"Zikeji_animation",true)
        animation:setPosition(cc.p(size.width/2, size.height/2))
    end
end
function unionTecLayer:unShowSpineAnimation(tid)
    local item = self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec"..tid)
    local animation = item:getChildByTag(101)
    if animation ~= nil then
        animation:setVisible(false)
    end
end
function unionTecLayer:removeSpineAnimation(tid)
    local item = self:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec"..tid)
    local animation = item:getChildByTag(101)
    if animation ~= nil then
        animation:removeFromParent(true)
    end
end
--接口
function unionTecLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionTec")
        if widget ~= nil then
            if widget:getChildByName("besure"):isVisible() == true then
                widget.closeBesure(sender,ccui.TouchEventType.ended)
            elseif widget:getChildByName("utecinfo"):isVisible() == true then
                if widget:getChildByName("utecinfo"):getChildByName("pop"):isVisible() == true then
                    widget.closePop(sender,ccui.TouchEventType.ended)
                else
                    widget:onCloseTecInfo()
                end
            elseif widget:getChildByName("pop2"):isVisible() == true then
                widget.closePop2(sender,ccui.TouchEventType.ended)
            else
                pop.onClosePopDialog("unionTec")
            end
        end
    end
end

function unionTecLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("unionTec")
    if widget ~= nil then
        if widget:getChildByName("besure"):isVisible() == true then
            widget.closeBesure(sender,ccui.TouchEventType.ended)
        elseif widget:getChildByName("utecinfo"):isVisible() == true then
            if widget:getChildByName("utecinfo"):getChildByName("pop"):isVisible() == true then
                widget.closePop(sender,ccui.TouchEventType.ended)
            else
                widget:onCloseTecInfo()
            end
        elseif widget:getChildByName("pop2"):isVisible() == true then
            widget.closePop2(sender,ccui.TouchEventType.ended)
        else
            pop.onClosePopDialog("unionTec")
        end
    end
end

function unionTecLayer.onStart(sender)
    ff.net:registerEvent(2,dd.Tjf_union_GetMyAllyTec, function (message)sender:onGetMyAllyTec(message)end)
    ff.net:registerEvent(2,dd.Tjf_union_upUnionTec,function (message)sender:onUpUnionTec(message)end)
    ff.net:registerEvent(2,dd.Tjf_union_actUnionTec,function (message)sender:onActUnionTec(message)end)
    ff.net:registerEvent(2,dd.Tjf_union_upgradeUnionTec,function (message)sender:onUpgradeUnionTec(message)end)
    ff.net:registerEvent(2,dd.Tjf_union_ResetTecCD,function (message)sender:onResetTecCD(message)end)
    ff.net:registerEvent(2,dd.Tjf_notify_SNUnionTec,function (message)sender:onNotifyUniontTec()end)
    ff.net:bindProperty(2509,"gold",sender.updateGold)
    if sender._init == false then
        sender:onInitCfg()
        sender._init = true
    end
    sender:updateMainPage()
end
function unionTecLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    return true
end
function unionTecLayer.onEnd(sender)
	sender:stopAllActions()
    dd.delBackEvent()
    ff.net:removeEvent(2,dd.Tjf_union_upUnionTec)
    ff.net:removeEvent(2,dd.Tjf_union_actUnionTec)
    ff.net:removeEvent(2,dd.Tjf_union_upgradeUnionTec)
    ff.net:removeEvent(2,dd.Tjf_union_GetMyAllyTec)
    ff.net:removeEvent(2,dd.Tjf_union_ResetTecCD)
    ff.net:removeEvent(2,dd.Tjf_notify_SNUnionTec)	
    ff.net:unbindProperty("gold",2509)

    if ff.platform ~= 1 then
    	sender:getChildByName("view"):getChildByName("view"):getChildByName("mtec"):getChildByName("tec101"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    	sender:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec102"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    	sender:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec103"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    	sender:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec104"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec105"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec106"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("view"):getChildByName("view"):getChildByName("ctec"):getChildByName("tec107"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    	
        
        sender:getChildByName("utecinfo"):getChildByName("board"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("utecinfo"):getChildByName("button"):getChildByName("btn_res_1"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("utecinfo"):getChildByName("button"):getChildByName("btn_res_2"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("utecinfo"):getChildByName("button"):getChildByName("btn_res_3"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
    sender:removeSpineAnimation(102)
    sender:removeSpineAnimation(103)
    sender:removeSpineAnimation(104)
    sender:removeSpineAnimation(105)
    sender:removeSpineAnimation(106)
    sender:removeSpineAnimation(107)
end
function onShowUnionTec(widget)
    local layer = unionTecLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end