StrongTowerLayer = class("StrongTowerLayer")
StrongTowerLayer._name = "StrongTower"
StrongTowerLayer._init = false
StrongTowerLayer._id = 0
StrongTowerLayer._info = {}


function StrongTowerLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,StrongTowerLayer)
	return target
end

function StrongTowerLayer:onInit(  )
	-- body
	if self._init == false then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		self:setPositionY(0)
		self:getChildByName("bg"):setContentSize(cc.size(720,hh))
		self:getChildByName("bg"):addTouchEventListener(self.onReturn)
		self:getChildByName("topArea"):setPositionY(hh - 105)
		self:getChildByName("list"):setContentSize(cc.size(720,hh- 105  - 38))
    	self:getChildByName("list"):setPositionY(0)

        self:getChildByName("info"):setPositionY(hh - 105 - 38)
       
        self:getChildByName("pop"):setPositionY(0)
        self:getChildByName("pop"):getChildByName("close"):addTouchEventListener(self.closePop)
        self:getChildByName("info"):getChildByName("help"):addTouchEventListener(self.openPop)
        self:getChildByName("info"):getChildByName("tips"):setString(ff.langString("玩法说明"))
        
    	self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onReturn)
    	self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
    	
		self:getChildByName("pop"):getChildByName("block1"):getChildByName("content"):setString(ff.langString("如何占领其他联盟的城区").."\n"..ff.langString("摧毁敌对联盟城区周围的任意哨塔后，在哨塔卫兵恢复前，可进攻城区内的玩家城市。")..ff.langString("摧毁敌对联盟城区周围的4个哨塔，并赶在哨塔卫兵恢复前占领核心，持续占领核心8H，来夺取城区的使用权。"))
        self._init = true
	end
	self.updateGold()
    self:showList()
end

function StrongTowerLayer.openPop(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then  
        local widget = pop.getDialog("StrongTower") 
        pop.showPopEffect(12,widget:getChildByName("pop"))
    end
end

function StrongTowerLayer.onStart( sender )
	ff.net:bindProperty(2335,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
end

function StrongTowerLayer.closePop(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("StrongTower") 
        widget:getChildByName("pop"):setVisible(false)
    end
end


function StrongTowerLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("StrongTower")
		if widget == nil then
			return
		end
        if widget:getChildByName("pop"):isVisible() == true then
            widget.closePop(sender,ccui.TouchEventType.ended)
            return
        end
        pop.onClosePopDialog("StrongTower")
    end
end


function StrongTowerLayer.onEnd( sender )
    -- body
    dd.delBackEvent()
    --ff.net:removeEvent(2,dd.Tjf_GetStrongholdWarDetail)
    sender:stopAllActions()
    sender:getChildByName("list"):removeAllChildren(true)
    ff.net:unbindProperty("gold",2335)
end

function onShowStrongTower(widget,info,id)
	-- body
	local layer = StrongTowerLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
    layer._info = info
    layer._id = id
    layer:onInit()
    return layer
end

function StrongTowerLayer.onBefore( sender)
    
end

function StrongTowerLayer:showList(  )
    if next(self._info) == nil then
        return
    end

	local item1 = self:getChildByName("list"):getChildByTag(1)
    if item1 == nil then
        item1 = self:getChildByName("block1"):clone()
        item1:setVisible(true)
        item1:setTag(1)
        item1:getChildByName("Image_71"):loadTexture("images/active/702.png",0)
        self:getChildByName("list"):pushBackCustomItem(item1)
    end
    local name = ""
    if self._id == 20 then
        name = ff.langString("斯塔灵")
    elseif self._id == 30 then
        name = ff.langString("白石城")
    elseif self._id == 40 then
        name = ff.langString("哥谭")
    else
        name = ff.langString("斯莫威尔")
    end
    item1:getChildByName("name"):setString(name)
    item1:getChildByName("zbd"):setString(ff.langString("欢迎来到{0}，黑杰克会帮助你守护这里，在核心可以对黑杰克进行强化。",{name}))
    local item2 = self:getChildByName("list"):getChildByTag(2)
    if item2 == nil then
        item2 = self:getChildByName("item"):clone()
        item2:setVisible(true)
        item2:setTag(2)
        self:getChildByName("list"):pushBackCustomItem(item2)
    end

    item2:getChildByName("name"):setString(ff.langString("黑杰克"))
    item2:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(1005),0)
    item2:getChildByName("info"):setString(self._info["nowbing"].."/"..self._info["maxbing"])

    local item3 = self:getChildByName("list"):getChildByTag(3)
    if item3 == nil then
        item3 = self:getChildByName("string"):clone()
        item3:setVisible(true)
        item3:setTag(3)
        self:getChildByName("list"):pushBackCustomItem(item3)
    end

    item3:getChildByName("string"):setString(ff.langString("黑杰克的兵力会缓慢恢复，但如果被彻底击败，恢复需要更长的时间。"))

    
end

function StrongTowerLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("StrongTower")
    if widget ~= nil then
        widget:getChildByName("topArea"):getChildByName("money"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("topArea"):requestDoLayout()
    end
end