StrongholdInfoEEXLayer = class("StrongholdInfoEEXLayer")
StrongholdInfoEEXLayer._name = "StrongholdInfoEEX"
StrongholdInfoEEXLayer._init = false
StrongholdInfoEEXLayer._id = 0
StrongholdInfoEEXLayer._info = {}
StrongholdInfoEEXLayer._type = 1
StrongholdInfoEEXLayer._tecCfg = {}
StrongholdInfoEEXLayer._tec={}
StrongholdInfoEEXLayer._gid = 0

function StrongholdInfoEEXLayer.extend( target )
    -- body
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target,t)
    end
    setmetatable(t,StrongholdInfoEEXLayer)
    return target
end

function StrongholdInfoEEXLayer:onInit(  )
    -- body
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:setPositionY(0)
        self:getChildByName("bg"):setContentSize(cc.size(720,hh))
        self:getChildByName("bg"):addTouchEventListener(self.onReturn)
        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("list"):setContentSize(cc.size(720,hh- 105 - 85 - 38-120))
        self:getChildByName("list"):setPositionY(120)
        self:getChildByName("topNavi"):setPositionY(hh - 105 - 85)

        self:getChildByName("info"):setPositionY(hh - 105 - 85 - 38)
        self:getChildByName("topNavi"):getChildByName("navi1"):addTouchEventListener(self.onSelectType)
        self:getChildByName("topNavi"):getChildByName("navi2"):addTouchEventListener(self.onSelectType)
        self:getChildByName("topNavi"):getChildByName("navi1"):setTag(1)
        self:getChildByName("topNavi"):getChildByName("navi2"):setTag(2)
       
        self:getChildByName("pop"):setPositionY(0)
        self:getChildByName("masking"):setPositionY(0)
        self:getChildByName("masking"):setVisible(false)
        self:getChildByName("utecinfo"):setPositionY(0)
        self:getChildByName("oper"):setPositionY(0)
        self:getChildByName("oper"):getChildByName("join"):addTouchEventListener(self.onJoin)
        self:getChildByName("masking"):setContentSize(cc.size(720,hh))
        self:getChildByName("pop"):getChildByName("close"):addTouchEventListener(self.closePop)
        self:getChildByName("info"):getChildByName("help"):addTouchEventListener(self.openPop)
        self:getChildByName("info"):getChildByName("tips"):setString(ff.langString("如何保护你的城区"))
        
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onReturn)
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
        
        self:getChildByName("pop"):getChildByName("block1"):getChildByName("content"):setString(ff.langString("在城区核心中，选择科技进行捐献，来强化城区的防御能力。").."\n"..ff.langString("在核心中驻防部队，保护城区不被敌人夺走。"))
        self:getChildByName("item"):getChildByName("down"):addTouchEventListener(self.onDown)
        self:getChildByName("item"):getChildByName("up"):addTouchEventListener(self.onOpen)
        self:getChildByName("utecinfo"):getChildByName("close"):addTouchEventListener(self.onCloseTec)
        self:getChildByName("utecinfo"):getChildByName("btn_res"):addTouchEventListener(self.onJuan)
        self._init = true
    end
    self:initData()
    self.updateGold()
    self:showList()
end
function StrongholdInfoEEXLayer.onSelectType( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("StrongholdInfoEEX")
        if widget ~= nil and widget._info ~= nil  then
            local tag = sender:getTag()
            if tag ~= widget._type then
                widget._type = sender:getTag()
                widget:selectType()
            else
                widget:selectType()
            end
        end
    end
end

function StrongholdInfoEEXLayer.onCloseTec( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("StrongholdInfoEEX")
        if widget ~= nil and widget._info ~= nil  then
            widget:getChildByName("masking"):setVisible(false)
            widget:getChildByName("utecinfo"):setVisible(false)
        end
    end
end

function StrongholdInfoEEXLayer.onJoin( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("StrongholdInfoEEX")
        if widget ~= nil and widget._info ~= nil  then
            local cache={}
            cache['cid']   = widget._gid
            cache['id'] = widget._id
         
            cache['uid']   = widget._id
            cache['type'] = 23
            cache['res_type']  = 0
            cache['res_id']    = 0

            cache['avatar']= 0
            cache['level'] = 0
            cache['cur']   = 0
            cache['cary']  = 0
            cache['unionid']  = 0
            cache['uname']    = ""
            cache['short']    = ""
            cache['ulevel']   = 0
            cache['name']     = ""
            cache['count']    = 0
            cache['res']      = 0
            cache['friend']   = 0
            cache['protect']  = 0
            cache['troopid']  = 0
            cache['npctype']  = 0
            pop.onShowPopDialog("chuzhen",24,cache)
        end
    end
end

function StrongholdInfoEEXLayer.onJuan( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("StrongholdInfoEEX")
        if widget ~= nil and widget._info ~= nil  then
            local tag = sender:getTag()
            local message = ff.net:createMessage()
            message:addCmd(0x00000147)
            message:addLong(dd.uid)
            message:addLong(1)
            message:addLong(widget._id)
            message:addLong(tag)
            ff.net:rpc(message,false)
        end
    end
end

function StrongholdInfoEEXLayer.onDown( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("StrongholdInfoEEX")
        if widget ~= nil and widget._info ~= nil  then
            local tag = sender:getTag()
            if widget._type == 1 then
                local Panel = widget:getChildByName("list"):getChildByTag(tag)
                if Panel ~= nil then
                    local item = Panel:getChildByTag(1)
                    if item ~= nil then
                        item:getChildByName("down"):setVisible(false)
                        item:getChildByName("up"):setVisible(true)
                    end
                    local index = tag - 10
                    local hh = 0
                    if widget._info.amy[index] ~= nil then
                        local itemcnt = 1
                        local amycnt = 1
                        local hh = 0
                        for i=1,6 do
                            local j = i
                            if widget._info.amy[index]["bu"..j] > 0 then
                                if amycnt == 6 then
                                    itemcnt = itemcnt + 1
                                    amycnt = 1
                                end
                                local amy = Panel:getChildByTag(itemcnt+1)
                                if amy == nil then
                                    amy = widget:getChildByName("item2"):clone()
                                    amy:setVisible(true)
                              
                                    amy:setTag(itemcnt+1)
                                    --amy:setPosition(cc.p(10,hh))
                                    Panel:addChild(amy)
                        
                                    hh = hh + 180
                                end
                                amy:getChildByName("item"..amycnt):setVisible(true)
                                amy:getChildByName("item"..amycnt):getChildByName("icon"):loadTexture(dd.getArmyIcon(dd.cfgSoldierIndex2["b"..j]),0)
                                amy:getChildByName("item"..amycnt):getChildByName("count"):setString(widget._info.amy[index]["bu"..j])
                                amycnt = amycnt + 1
                            end
                            if widget._info.amy[index]["qi"..j] > 0 then
                                if amycnt == 6 then
                                    itemcnt = itemcnt + 1
                                    amycnt = 1
                                end
                                local amy = Panel:getChildByTag(itemcnt+1)
                                if amy == nil then
                                    amy = widget:getChildByName("item2"):clone()
                                    amy:setVisible(true)
                                    amy:setTag(itemcnt+1)
                           
                                    --amy:setPosition(cc.p(10,hh))
                                    Panel:addChild(amy)
                    
                                    hh = hh + 180
                                end
                                amy:getChildByName("item"..amycnt):setVisible(true)
                                amy:getChildByName("item"..amycnt):getChildByName("icon"):loadTexture(dd.getArmyIcon(dd.cfgSoldierIndex2["q"..j]),0)
                                amy:getChildByName("item"..amycnt):getChildByName("count"):setString(widget._info.amy[index]["qi"..j])
                                amycnt = amycnt + 1
                            end
                            if widget._info.amy[index]["gong"..j] > 0 then
                                if amycnt == 6 then
                                    itemcnt = itemcnt + 1
                                    amycnt = 1
                                end
                                local amy = Panel:getChildByTag(itemcnt+1)
                                if amy == nil then
                         
                                    amy = widget:getChildByName("item2"):clone()
                                    amy:setVisible(true)
                                    amy:setTag(itemcnt+1)
                                    --amy:setPosition(cc.p(10,hh))
                                    Panel:addChild(amy)
                        
                                    hh = hh + 180
                                end
                                amy:getChildByName("item"..amycnt):setVisible(true)
                                amy:getChildByName("item"..amycnt):getChildByName("icon"):loadTexture(dd.getArmyIcon(dd.cfgSoldierIndex2["g"..j]),0)
                                amy:getChildByName("item"..amycnt):getChildByName("count"):setString(widget._info.amy[index]["gong"..j])
                                amycnt = amycnt + 1
                            end
                            if j <= 4 and widget._info.amy[index]["che"..j] > 0 then
                                if amycnt == 6 then
                                    itemcnt = itemcnt + 1
                                    amycnt = 1
                                end
                                local amy = Panel:getChildByTag(itemcnt+1)
                                if amy == nil then
                                    amy = widget:getChildByName("item2"):clone()
                                    amy:setVisible(true)
                                    amy:setTag(itemcnt+1)
                                    --amy:setPosition(cc.p(10,hh))
                                    Panel:addChild(amy)
                                    hh = hh + 180
                                end
                                amy:getChildByName("item"..amycnt):setVisible(true)
                                amy:getChildByName("item"..amycnt):getChildByName("icon"):loadTexture(dd.getArmyIcon(dd.cfgSoldierIndex2["w"..j]),0)
                                amy:getChildByName("item"..amycnt):getChildByName("count"):setString(widget._info.amy[index]["che"..j])
                                amycnt = amycnt + 1
                            end
                        end
                        for i=1,itemcnt do
                            local index = itemcnt+ 2 - i
                            cclog("i="..i.."itemcnt="..itemcnt.."index="..index)
                            local pai = Panel:getChildByTag(index)
                            if pai ~= nil then
                                local paih = hh -  180 * (index - 1)
                                pai:setPosition(cc.p(10,paih))
                            end
                        end
                        item:setPosition(cc.p(10,hh))
                        hh = hh + 180
                     
                        Panel:setContentSize(cc.size(720,hh))
                        widget:getChildByName("list"):refreshView()
                    end
                end
            else
                widget:setPopInfo(tag - 10)
                widget:getChildByName("masking"):setVisible(true)
                pop.showPopEffect(12,widget:getChildByName("utecinfo"))

            end
        end
    end
end

function StrongholdInfoEEXLayer:setPopInfo( id )
    local utecinfo = self:getChildByName("utecinfo")
    
    if self._tec.tec ~= nil and self._tec.tec[id] ~= nil then
        utecinfo:getChildByName("board"):getChildByName("name"):getChildByName("chu_name"):setString(ff.langString(self._tecCfg[tonumber(id)]["name"]))
        utecinfo:getChildByName("board"):getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/tec/"..self._tecCfg[tonumber(id)]["icon"]..".png",0)
        utecinfo:getChildByName("progress"):getChildByName("level"):setString("Lv"..self._tec.tec[id]["level"])
        if self._tec.tec[id]["level"] == 20 then
            utecinfo:getChildByName("progress"):getChildByName("exp"):setString("")
            utecinfo:getChildByName("progress"):getChildByName("progress_1"):setPercent(100)
        else
            utecinfo:getChildByName("progress"):getChildByName("exp"):setString(self._tec.tec[id]["exp"].."/"..self._tec.tec[id]["nextexp"])

            local percent = math.floor(100*self._tec.tec[id]["exp"]/self._tec.tec[id]["nextexp"]) 
            utecinfo:getChildByName("progress"):getChildByName("progress_1"):setPercent(percent)
        end
        utecinfo:getChildByName("btn_res"):setTag(id)
        if id ~= 3 then
            utecinfo:getChildByName("board"):getChildByName("deffect"):setString(ff.langString(self._tecCfg[tonumber(id)]["tips"],{self._tec.tec[id]["can"]/10}))
        else
            utecinfo:getChildByName("board"):getChildByName("deffect"):setString(ff.langString(self._tecCfg[tonumber(id)]["tips"],{self._tec.tec[id]["can"]}))
        end
    end
end

function StrongholdInfoEEXLayer.onOpen( sender,eventType )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then

        local widget = pop.getDialog("StrongholdInfoEEX")
        if widget ~= nil and widget._info ~= nil  then
            local tag = sender:getTag()
            if widget._type == 1 then
                local Panel = widget:getChildByName("list"):getChildByTag(tag)
                if Panel ~= nil then
                    local item = Panel:getChildByTag(1)
                    if item ~= nil then
                        item:getChildByName("down"):setVisible(true)
                        item:getChildByName("up"):setVisible(false)
                    end
                    for i=2,7 do
                        local item = Panel:getChildByTag(i)
                        if item ~= nil then
                            item:removeFromParent(true)
                        end
                        
                    end
                    Panel:getChildByTag(1):setPosition(cc.p(10,0))
                    Panel:setContentSize(cc.size(720,180))
                    widget:getChildByName("list"):refreshView()
                end
            else
            end
        end
    end
end

function StrongholdInfoEEXLayer:selectType(sender)
    self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)

    self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)
    local hh = ff.height
    if self._type == 1 then
        self:getChildByName("list"):setContentSize(cc.size(720,hh- 105 - 85 - 38-120))
        self:getChildByName("list"):setPositionY(120)
        self:getChildByName("oper"):setVisible(true)
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("chu_label"):setColor(cc.c3b(239, 223, 223))
    elseif self._type == 2 then
        self:getChildByName("list"):setContentSize(cc.size(720,hh- 105 - 85 - 38))
        self:getChildByName("list"):setPositionY(0)
        self:getChildByName("oper"):setVisible(false)
        self:getTecList()
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("chu_label"):setColor(cc.c3b(239, 223, 223))
    end
    if sender ~= nil then
        sender:setSelectedState(true)
    end
    self:getChildByName("list"):removeAllChildren(true)
    self:showList()
   
end
function StrongholdInfoEEXLayer.openPop(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then  
        local widget = pop.getDialog("StrongholdInfoEEX") 
        pop.showPopEffect(12,widget:getChildByName("pop"))
    end
end

function StrongholdInfoEEXLayer.onStart( sender )
    ff.net:bindProperty(2334,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
end

function StrongholdInfoEEXLayer.closePop(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("StrongholdInfoEEX") 
        widget:getChildByName("pop"):setVisible(false)
    end
end


function StrongholdInfoEEXLayer.onReturn( sender,eventType )
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("StrongholdInfoEEX")
        if widget == nil then
            return
        end
        if widget:getChildByName("pop"):isVisible() == true then
            widget.closePop(sender,ccui.TouchEventType.ended)
            return
        end
        if widget:getChildByName("utecinfo"):isVisible() == true then
            widget:getChildByName("masking"):setVisible(false)
            widget:getChildByName("utecinfo"):setVisible(false)
            return
        end
        pop.onClosePopDialog("StrongholdInfoEEX")
    end
end


function StrongholdInfoEEXLayer.onEnd( sender )
    -- body
    dd.delBackEvent()
    sender._info={}
    ff.net:removeEvent(102,dd.Tjg_GetLCStrongholdG2Detail)
    ff.net:removeEvent(102,dd.Tjg_LCStrongholdG2TechAction)
    sender:stopAllActions()
    sender:getChildByName("list"):removeAllChildren(true)
    ff.net:unbindProperty("gold",2334)
end

function onShowStrongholdInfoEEX(widget,id,gid)
    -- body
    local layer = StrongholdInfoEEXLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer._id = id
    layer._gid = gid
    layer:onInit()
    return layer
end

function StrongholdInfoEEXLayer:getTaskList()
    local message = ff.net:createMessage()
    message:addCmd(0x00000061)
    message:addLong(dd.uid)
    message:addLong(self._id)
    ff.net:rpc(message,false)
end

function StrongholdInfoEEXLayer:getTecList()
    local message = ff.net:createMessage()
    message:addCmd(0x00000147)
    message:addLong(dd.uid)
    message:addLong(0)
    message:addLong(self._id)
    message:addLong(0)
    ff.net:rpc(message,false)
end

function StrongholdInfoEEXLayer.onBefore( sender)
    sender._type = 1
    sender:selectType(sender:getChildByName("topNavi"):getChildByName("navi1"))
    ff.net:registerEvent(102,dd.Tjg_GetLCStrongholdG2Detail,function (params)sender:GetLCStrongholdG2Detail(params)end)
    ff.net:registerEvent(102,dd.Tjg_LCStrongholdG2TechAction,function (params)sender:LCStrongholdG2TechAction(params)end)
    sender:getTaskList()
end

--guide end
function StrongholdInfoEEXLayer:GetLCStrongholdG2Detail(params)
    local code = params[1]
    if code == 0 then
        self._info = params[2]
        self:showList()
    end
end

function StrongholdInfoEEXLayer:LCStrongholdG2TechAction(params)
    local code = params[1]
    if code == 0 then
        self._tec = params[2]
        if self:getChildByName("utecinfo"):isVisible() == true then
            cclog("=11111111111111111111112222222222333333333333=="..self._tec.tecid)
            self:setPopInfo(self._tec.tecid)
        end
        self:showList()
    end
end

function StrongholdInfoEEXLayer:showList(  )
    if self._type == 1 then
        if next(self._info) == nil then
            return
        end
        local item1 = self:getChildByName("list"):getChildByTag(1)
        if item1 == nil then
            item1 = self:getChildByName("block1"):clone()
            item1:setVisible(true)
            item1:setTag(1)
            item1:getChildByName("Image_71"):loadTexture("images/active/861.png",0)
            self:getChildByName("list"):pushBackCustomItem(item1)
        end
        if self._info.unionId > 0 then
            item1:getChildByName("union"):setString("["..self._info.unionFlag.."]")
            item1:getChildByName("name"):setString(self._info.unionname..ff.langString("占领中"))
            item1:getChildByName("zbd"):setString(ff.langString("当前驻守")..":"..self._info.nowBing.."/"..self._info.maxBing)
            item1:getChildByName("power"):setString("")
        else
            item1:getChildByName("union"):setString("")
            item1:getChildByName("name"):setString(ff.langString("无人占领"))
            item1:getChildByName("zbd"):setString(ff.langString("当前驻守")..":0")
            item1:getChildByName("power"):setString("")
        end
        item1:requestDoLayout()
        if self._info.amy ~= nil and next(self._info.amy) ~= nil then
            for i,v in ipairs(self._info.amy) do
                local item = self:getChildByName("list"):getChildByTag(10+i)
                if item == nil then
                    item = self:getChildByName("Panel"):clone()
                    item:setVisible(true)
                    item:setTag(10 + i)
                    self:getChildByName("list"):pushBackCustomItem(item)
                end
                local player = item:getChildByTag(1)
                if player == nil then
                    player = self:getChildByName("item"):clone()
                    player:setVisible(true)
                    player:setTag(1)
                    player:setPosition(cc.p(10,0))
                    item:addChild(player,1,1)
                end
                player:getChildByName("down"):setTag(10+i)
                player:getChildByName("up"):setTag(10+i)
                player:getChildByName("down"):setVisible(true)
                player:getChildByName("up"):setVisible(false)
                item:setContentSize(cc.size(720,180))
                player:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(v["pic"]),0)
                player:getChildByName("name"):setString(v["name"])
                local total = tonumber(v["bu1"]) + tonumber(v["bu2"])+tonumber(v["bu3"]) +tonumber(v["bu4"]) +tonumber(v["bu5"]) +tonumber(v["bu6"]) +tonumber(v["qi1"])+tonumber(v["qi2"]) +tonumber(v["qi3"]) +tonumber(v["qi4"]) +tonumber(v["qi5"]) +tonumber(v["qi6"]) +tonumber(v["gong1"]) +tonumber(v["gong2"]) +tonumber(v["gong3"]) +tonumber(v["gong4"]) +tonumber(v["gong5"]) +tonumber(v["gong6"]) +tonumber(v["che1"]) +tonumber(v["che2"]) +tonumber(v["che3"]) +tonumber(v["che4"]) 
                player:getChildByName("info"):setString(ff.langString("总兵力")..":"..total)
            end
        end
    else
        local item1 = self:getChildByName("list"):getChildByTag(1)
        if item1 == nil then
            item1 = self:getChildByName("block2"):clone()
            item1:setVisible(true)
            item1:setTag(1)
            item1:getChildByName("Image_71"):loadTexture("images/active/861.png",0)
            self:getChildByName("list"):pushBackCustomItem(item1)
        end
        local name = ""
        if self._id == 20 then
            name = ff.langString("斯塔灵")
        elseif self._id == 30 then
            name = ff.langString("白石城")
        elseif self._id == 40 then
            name = ff.langString("哥谭")
        else
            name = ff.langString("斯莫威尔")
        end
        item1:getChildByName("name"):setString(name)
        item1:getChildByName("info"):setString(ff.langString("如果城区被其他联盟夺走，城区科技将重置！"))

        if self._tec.tec ~= nil and next(self._tec.tec) ~= nil then
            for i,v in ipairs(self._tec.tec) do
                local item = self:getChildByName("list"):getChildByTag(10+i)
                if item == nil then
                    item = self:getChildByName("Panel"):clone()
                    item:setVisible(true)
                    item:setTag(10 + i)
                    self:getChildByName("list"):pushBackCustomItem(item)
                end
                local player = item:getChildByTag(1)
                if player == nil then
                    player = self:getChildByName("item"):clone()
                    player:setVisible(true)
                    player:setTag(1)
                    player:setPosition(cc.p(10,0))
                    item:addChild(player,1,1)
                end
                player:getChildByName("down"):setTag(10+i)
                player:getChildByName("up"):setTag(10+i)
                player:getChildByName("down"):setVisible(true)
                player:getChildByName("up"):setVisible(false)
                item:setContentSize(cc.size(720,180))
                player:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/tec/"..self._tecCfg[tonumber(i)]["icon"]..".png",0)
                player:getChildByName("name"):setString(ff.langString(self._tecCfg[i]["name"]))
                player:getChildByName("info"):setString("Lv"..v["level"].."   "..v["exp"].."/"..v["nextexp"])
            end
        end
    end
end

function StrongholdInfoEEXLayer:initData(  )
    local rows = ff.dbmanager:sql_fetch_rows("select * from cfg_tec_stronghold")
    self._tecCfg = {}

    for i=1,rows:rowCount() do
        local id = tonumber(rows:getString(i,"tec_id"))
        self._tecCfg[id] = {}
        self._tecCfg[id]["icon"] = tonumber(rows:getString(i,"icon"))
        self._tecCfg[id]["limit"] = tonumber(rows:getString(i,"lv_limit"))
        if ff.lang == -1 then
            self._tecCfg[id]['tips'] = rows:getString(i, "tec_tip")
            self._tecCfg[id]["name"] = rows:getString(i,"tec_name")
        else    
            self._tecCfg[id]['tips'] = tonumber(rows:getString(i, "tip_lan"))
            self._tecCfg[id]["name"] = tonumber(rows:getString(i,"name_lan"))
        end
    end
    rows:clear()

end

function StrongholdInfoEEXLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("StrongholdInfoEEX")
    if widget ~= nil then
        widget:getChildByName("topArea"):getChildByName("money"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("topArea"):requestDoLayout()
    end
end