local colPopLayer   = class("colPopLayer")
colPopLayer._name = "colPop"
colPopLayer._init = false
colPopLayer.parent = nil
colPopLayer.info = nil
function colPopLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, colPopLayer)
    return target
end
function colPopLayer:onInit()
    if self._init == false then
        self:initListener()
        self._init = true
    end
end

function colPopLayer:addEditBox()
    local layer = self:getChildByName("pos_op")
    local mailInput = layer:getChildByName("input_bg")
    if mailInput:getChildByTag(150000) == nil then
        dd.addEditBox(mailInput,cc.size(mailInput:getContentSize().width - 20,mailInput:getContentSize().height - 15),'images/ui/alpha.png',150000,cc.p(0.5,0.5),cc.p(mailInput:getContentSize().width/2,mailInput:getContentSize().height/2 + 7),cc.c3b(161,175,175),25,6,4,1,32,true,true,true)
        mailInput:getChildByTag(150000):setText("")
    else
        mailInput:getChildByTag(150000):setText("")
    end
    if self.info['res'] == 0 then
        mailInput:getChildByTag(150000):setText(ff.langString("空地").." LV."..self.info['level'])
    elseif self.info['res'] == 7 then
        
        mailInput:getChildByTag(150000):setText(ff.langString("{0}的城市",{self.info['name']}))
    elseif self.info['res'] == 8 then
  
        mailInput:getChildByTag(150000):setText(ff.langString("{0}的营帐",{self.info['name']}))
    else
        if self.info['name'] ~= '' then
            if self.info['type'] == 2 then
                mailInput:getChildByTag(150000):setText(ff.langString("{0}的城市",{self.info['name']}))
            elseif self.info['type'] == 3 then
                mailInput:getChildByTag(150000):setText(ff.langString("{0}的营帐",{self.info['name']}))
            else
                if self.info['avatar'] == nil or dd.cfgWorldRes[math.floor(self.info['avatar']/10000)] == nil then
                    if self.info['avatar'] == nil then
                        cclog3("error:addEditBox 1")
                    else
                        cclog3("error:addEditBox:"..self.info['avatar'])
                    end
                else    
                    mailInput:getChildByTag(150000):setText(ff.langString(dd.cfgWorldRes[math.floor(self.info['avatar']/10000)]['name']).." Lv."..self.info['level'])
                end
            end
        else
            mailInput:getChildByTag(150000):setText(ff.langString(dd.cfgWorldRes[math.floor(self.info['avatar']/10000)]['name']).." Lv."..self.info['level'])
        end
    end
    local function editBoxTextEventHandle(strEventName,pSender)
        local edit = pSender
        local strFmt 
        if strEventName == "began" then

        elseif strEventName == "ended" or strEventName == "return" then
            local text = edit:getText()
            if text == "" or string.len(text) <= 0 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("输入的名称不能为空"))
                return
            end
        elseif strEventName == "changed" then

        end
    end
    mailInput:getChildByTag(150000):registerScriptEditBoxHandler(editBoxTextEventHandle)
end

function colPopLayer:initListener()
    local function closePop(sender,eventType)
        if eventType==ccui.TouchEventType.ended then    
            pop.onClosePopDialog("colPop") 
        end  
    end
    local function saveCol(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            local text = self:getChildByName("pos_op"):getChildByName("input_bg"):getChildByTag(150000):getText()
            if text == "" or string.len(text) <= 0 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("输入的名称不能为空"))
                return
            end
            local message = ff.net:createMessage()
            message:addCmd(0x124)
            message:addLong(dd.uid)
            message:addLong(1)
            message:addLong(1)
            message:addLong(self.info['cid'])
            message:addString(text,32)
            ff.net:rpc(message,false)
        end  
    end
    self:getChildByName("close"):addTouchEventListener(closePop)
    self:getChildByName("save_btn"):addTouchEventListener(saveCol)
end

function colPopLayer:backBookMarkAction(ret)
    if ret[1] == 0 then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("收藏成功"),true)
            pop.onClosePopDialog("colPop")
        end
    else
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(ret[1]))
        end    
    end
end

--界面显示后调用
function colPopLayer.onStart(sender)
    ff.net:registerEvent(1,dd.Tjf_map_BookMarkAction,function (message)sender:backBookMarkAction(message)end)
    if sender.info['res'] == 0 then
        sender:getChildByName("chu_name_text"):setString(ff.langString("空地").."("..sender.parent:getCidStr(sender.info['cid'])..")")
    else
        if sender.info['name'] ~= '' then
            sender:getChildByName("chu_name_text"):setString(sender.info['name'].."("..sender.parent:getCidStr(sender.info['cid'])..")")
        else
            sender:getChildByName("chu_name_text"):setString(ff.langString(dd.cfgWorldRes[math.floor(sender.info['avatar']/10000)]['name']).."("..sender.parent:getCidStr(sender.info['cid'])..")")
        end
    end
    sender:getChildByName("pos_op"):getChildByName("lv_text"):setString("Lv."..sender.info['level'])
    local image = sender.parent._worldUILayer._curMapLayer:getCidImage(sender.parent._worldUILayer:getCid(sender.info['cid']-1))
    if image == "" then
        sender:getChildByName("pos_op"):getChildByName("pos_bg"):getChildByName("pos_icon"):loadTexture("world/701.png",1)
    else
        sender:getChildByName("pos_op"):getChildByName("pos_bg"):getChildByName("pos_icon"):loadTexture(image,1)
    end
    sender:addEditBox()
end

--界面关闭效果结束后调用
function colPopLayer.onEnd(sender)
    platform_clearAllInputText()
    ff.net:removeEvent(1,dd.Tjf_map_BookMarkAction)  
    if ff.platform ~= 1 then
        sender:getChildByName("pos_op"):getChildByName("pos_bg"):getChildByName("pos_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
end
--界面即将播放显示缓动时调用，返回false界面显示将终止
function colPopLayer.onBefore(sender)
    return true
end

function colPopLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("colPop")
        if widget~=nil and widget:onClose() == false then
            pop.onClosePopDialog("colPop")
        end    
    end
end
function onShowColPop(widget,info,parent)
    local layer = colPopLayer.extend(widget)
    layer.parent = parent
    layer.info = info
    layer:onInit()
    return layer
end