local mapnpcLayer = class("mapnpcLayer")
mapnpcLayer._name = "mapnpcLayer"
mapnpcLayer._init = false
mapnpcLayer._id   = 0
mapnpcLayer._param = nil
mapnpcLayer._endTime = 0
mapnpcLayer._state = 0

function mapnpcLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, mapnpcLayer)
    return target
end
function mapnpcLayer:onInit()
    if self._init == false then
    	self:getChildByName("view"):getChildByName("back"):loadTexture("images/ui/npcback.jpg",0)
    	self:getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onClose)
    	self:getChildByName("view"):getChildByName("battle"):addTouchEventListener(self.gogogo)
        self:getChildByName("tool"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onClose)
        self:getChildByName("tool"):getChildByName("view"):getChildByName("sure"):addTouchEventListener(self.onSure)

        self:getChildByName("view"):getChildByName("droplists"):getChildByName("item1"):getChildByName("item"):setTag(1)
        self:getChildByName("view"):getChildByName("droplists"):getChildByName("item2"):getChildByName("item"):setTag(2)
        self:getChildByName("view"):getChildByName("droplists"):getChildByName("item3"):getChildByName("item"):setTag(3)
        self:getChildByName("view"):getChildByName("droplists"):getChildByName("item4"):getChildByName("item"):setTag(4)

        self:getChildByName("view"):getChildByName("droplists"):getChildByName("item1"):getChildByName("item"):addTouchEventListener(self.onTips)
        self:getChildByName("view"):getChildByName("droplists"):getChildByName("item2"):getChildByName("item"):addTouchEventListener(self.onTips)
        self:getChildByName("view"):getChildByName("droplists"):getChildByName("item3"):getChildByName("item"):addTouchEventListener(self.onTips)
        self:getChildByName("view"):getChildByName("droplists"):getChildByName("item4"):getChildByName("item"):addTouchEventListener(self.onTips)


    	
    	self:getChildByName("view"):getChildByName("droplists"):getChildByName("item2"):getChildByName("item"):getChildByName("icon"):loadTexture("images/world/icon/2.png",0)
        self:getChildByName("view"):getChildByName("droplists"):getChildByName("item3"):getChildByName("item"):getChildByName("icon"):loadTexture("images/icon/charge/gold.png",0)
    	self:getChildByName("view"):getChildByName("droplists"):getChildByName("item4"):getChildByName("item"):getChildByName("icon"):loadTexture("images/world/icon/4.png",0)

        self._init = true
    end

    if self._id > 300 and self._id < 400 then
        self:getChildByName("view"):getChildByName("droplists"):getChildByName("item1"):getChildByName("item"):getChildByName("icon"):loadTexture("images/world/icon/5.png",0)
    elseif self._id > 610 and self._id < 615 then
        self:getChildByName("view"):getChildByName("droplists"):getChildByName("item1"):getChildByName("item"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/ic013.png",1))
    else
        self:getChildByName("view"):getChildByName("droplists"):getChildByName("item1"):getChildByName("item"):getChildByName("icon"):loadTexture("images/world/icon/1.png",0) 
    end

    self:getChildByName("tool"):setVisible(false)
    self:getChildByName("view"):setVisible(true)
    self:getChildByName("view"):getChildByName("progresshp"):setVisible(false)
    self:getChildByName("view"):getChildByName("info"):getChildByName("chu_name"):getVirtualRenderer():enableBold(true)
    self:getChildByName("view"):getChildByName("info"):getChildByName("chu_name"):setString(ff.langString(dd.cfgNpc[self._id]['name']).." Lv."..dd.cfgNpc[self._id]['level'])
    self:getChildByName("view"):getChildByName("info"):getChildByName("tips"):setString(ff.langString(dd.cfgNpc[self._id]['tips']))

    local x = (self._param.cid-1)%ff.world_maplayerSize.width
    local y = math.floor((self._param.cid-1 - x)/ff.world_maplayerSize.width)
    self:getChildByName("view"):getChildByName("info"):getChildByName("cid"):setString("["..(x+1)..","..(y+1).."]")
    --self:getChildByName("view"):getChildByName("progresshp"):setVisible(true)
    if dd.myinfo:getLong(1,"npclevel") >= dd.cfgNpc[self._id]['level'] - 1 or (dd.cfgNpc[self._id]['npcmode'] == 2 ) then
    	self:getChildByName("view"):getChildByName("battle"):setBright(true)
    	self:getChildByName("view"):getChildByName("battle"):setTouchEnabled(true)
    	self:getChildByName("view"):getChildByName("error_2"):setVisible(true)
    	

        local actice = 0
        local show = false
        local plus_552 = 0

        for i=1,dd.myeffect:rowCount() do
            if dd.myeffect:getLong(i,"id") == 552 then
                plus_552 = dd.myeffect:getLong(i,"param")
                show = true
                break
            end
        end
        local time = 360
        if show == true then
            time =  time / (1 + plus_552 / 1000)
        end
        local point = (dd.getServerTime() -  dd.myinfo:getLong(1,"ActiveTime")) / time
        
        --local point = (dd.getServerTime() -  dd.myinfo:getLong(1,"ActiveTime")) /360
        --cclog("==============="..point)
        actice =math.floor(point)+ dd.myinfo:getLong(1,"NowActive")

        if actice > dd.myinfo:getLong(1,"MaxActive") then
            if dd.myinfo:getLong(1,"NowActive") > dd.myinfo:getLong(1,"MaxActive")  then
                actice = dd.myinfo:getLong(1,"NowActive")
            else
                actice = dd.myinfo:getLong(1,"MaxActive") 
            end
        end
        local need = 12
        if dd.cfgNpc[self._id] ~= nil then
            need = dd.cfgNpc[self._id]['propquantity']
        end

        if actice < need then
            self:getChildByName("view"):getChildByName("error_2"):getChildByName("label"):setColor(cc.c3b(255,0,0))
        else    
            self:getChildByName("view"):getChildByName("error_2"):getChildByName("label"):setColor(cc.c3b(255,159,0))
        end

        --if dd.cfgNpc[self._id]['npcmode'] == 2  then
         --   self:getChildByName("view"):getChildByName("error_2"):getChildByName("label"):setString(ff.langString("击杀电锯怪人并赢取活动奖励。"))
        --else
            self:getChildByName("view"):getChildByName("error_2"):getChildByName("label"):setString(ff.langString("攻击{2}需要消耗{0}“行动力”（剩余{1}）",{need,actice,ff.langString(dd.cfgNpc[self._id]['name'])}))
       -- end
    	
    	self:getChildByName("view"):getChildByName("error_1"):setVisible(false)     
    else
    	self:getChildByName("view"):getChildByName("battle"):setBright(false)
    	self:getChildByName("view"):getChildByName("battle"):setTouchEnabled(false)
    	self:getChildByName("view"):getChildByName("error_1"):setVisible(true)
    	self:getChildByName("view"):getChildByName("error_1"):getChildByName("label"):setString(ff.langString("You must defeat a Lv{0} monster before you can challenge lv{1} manster.",{dd.myinfo:getLong(1,"npclevel") + 1,dd.cfgNpc[self._id]['level']}))
    	self:getChildByName("view"):getChildByName("error_2"):setVisible(false)
    end
    self._state = 0
    self._endTime = 0
end

function mapnpcLayer.updateActice( sender )
    -- body
    if dd.myinfo:getLong(1,"npclevel") >= dd.cfgNpc[sender._id]['level'] - 1 then
        local actice = 0
        local show = false
        local plus_552 = 0
        for i=1,dd.myeffect:rowCount() do
            if dd.myeffect:getLong(i,"id") == 552 then
                plus_552 = dd.myeffect:getLong(i,"param")
                show = true
                break
            end
        end
        local time = 360
        if show == true then
            time =  time / (1 + plus_552 / 1000)
        end
        local point = (dd.getServerTime() -  dd.myinfo:getLong(1,"ActiveTime")) / time
        actice =math.floor(point)+ dd.myinfo:getLong(1,"NowActive")
        if actice > dd.myinfo:getLong(1,"MaxActive") then
            if dd.myinfo:getLong(1,"NowActive") > dd.myinfo:getLong(1,"MaxActive") then
                actice = dd.myinfo:getLong(1,"NowActive") 
            else
                actice = dd.myinfo:getLong(1,"MaxActive") 
            end
        end
        local need = 12
        if dd.cfgNpc[sender._id] ~= nil then
            need = dd.cfgNpc[sender._id]['propquantity']
        end

        sender:getChildByName("view"):getChildByName("error_2"):getChildByName("label"):setString(ff.langString("攻击{2}需要消耗{0}“行动力”（剩余{1}）",{need,actice,ff.langString(dd.cfgNpc[sender._id]['name'])}))
    end
    if sender._state == 9 then
        local time  = sender._endTime - dd.getServerTime()
        sender:getChildByName("view"):getChildByName("battle"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
    else
        sender:getChildByName("view"):getChildByName("battle"):getChildByName("time"):setString("")
    end
end

function mapnpcLayer.onClose(sender,eventType)
    if eventType==ccui.TouchEventType.ended then 
    	pop.onClosePopDialog("mapNpc")
	end
end

function mapnpcLayer.onSure(sender,eventType)
    if eventType==ccui.TouchEventType.ended then 
        pop.onClosePopDialog("mapNpc")
        local message = ff.net:createMessage()
            message:addCmd(0x0000010a)
            message:addLong(dd.uid)
            message:addLong(1025)
            message:addLong(1)
            message:addLong(0)   
            message:addLong(0)
            ff.net:rpc(message,false)
        --pop.onShowPopDialog("onlineReward")     
    end
end

function mapnpcLayer.gogogo(sender,eventType)
    if eventType==ccui.TouchEventType.ended then 
    	local widget = pop.getDialog("mapNpc")
    	if widget ~= nil then
            local actice = 0
            local show = false
            local plus_552 = 0
            for i=1,dd.myeffect:rowCount() do
                if dd.myeffect:getLong(i,"id") == 552 then
                    plus_552 = dd.myeffect:getLong(i,"param")
                    show = true
                    break
                end
            end
            local time = 360
            if show == true then
                time =  time / (1 + plus_552 / 1000)
            end
            local point = (dd.getServerTime() -  dd.myinfo:getLong(1,"ActiveTime")) / time
            actice =math.floor(point)+ dd.myinfo:getLong(1,"NowActive")
            if actice > dd.myinfo:getLong(1,"MaxActive") then
                actice = dd.myinfo:getLong(1,"MaxActive") 
            end
            local need = 12
            if dd.cfgNpc[widget._id] ~= nil then
                need = dd.cfgNpc[widget._id]['propquantity']
            end
            --if widget._id > 300 and widget._id < 400 then
            --    need = 20 
            ---end
            if actice < need then
                local tid = 1025--dd.cfgNpc[widget._id]['propstype']
                local view = widget:getChildByName("tool"):getChildByName("view")
                view:getChildByName("tools"):getChildByName("icon"):loadTexture(dd.getToolsIcon(tid),0)
                view:getChildByName("count"):setString("x"..dd.getToolsCount(tid))
                view:getChildByName("name"):setString(ff.langString(dd.cfgProp[tid]['name'],{dd.cfgProp[tid]['name1_lan']}))
                view:getChildByName("tips"):setString(ff.langString(dd.cfgProp[tid]['tips'],{dd.cfgProp[tid]['tips1_lan']}))
                widget:getChildByName("tool"):setVisible(true)
                widget:getChildByName("view"):setVisible(false)
                if dd.getToolsCount(tid) < 1 then
                    local effect = ff.Effect:effectGrey()    
                    view:getChildByName("sure"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
                    view:getChildByName("sure"):setTouchEnabled(false)
                else
                    view:getChildByName("sure"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
                    view:getChildByName("sure"):setTouchEnabled(true)
                end
                --dd.currentLayer._widget:onShowMulTools(36,0,nil,true)
            else    
                
                if dd.cfgNpc[widget._id]['attackmode'] == 2 then
                    if dd.myUnion:getLong(1,"unionid") <= 0 then
                        dd.currentLayer._widget:onShowTips("\t"..ff.langString("必须先加入联盟，才能发起联合攻击。"))                
                    else          
                        local build = false
                        for i=1,dd.mybuilds:rowCount() do
                            if dd.mybuilds:getLong(i,"bid") == 15 then
                                if dd.myinfo:getLong(1,"level") < dd.cfgPos[dd.mybuilds:getLong(i,"pos")]['lv'] then      
                                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("司令部等级达{0}级开放",{dd.cfgPos[dd.mybuilds:getLong(i,"pos")]['lv']}))
                                    build = true
                                else
                                    local maxarmys = dd.cfgBuildingUp[15][dd.mybuilds:getLong(i,"level")]['value1']
                                    widget._param['maxarmys'] = maxarmys
    								pop.onClosePopDialog("mapNpc")
                                    pop.onShowPopDialog("chuzhen",22,widget._param)
                                    --WorldControl:getInstance():closeAll()
                                    build = true
                                end
                                break
                            end
                        end
                        if build == false then
                            dd.currentLayer._widget:onShowTips("\t"..ff.langString("必须先建造 战争会所"))
                        end
                    end
                else
					pop.onClosePopDialog("mapNpc")
                    pop.onShowPopDialog("chuzhen",21,widget._param)
                end
                
            end
		end
	end
end



function mapnpcLayer.onTips(sender,eventType)
    local function theEnd()
        local widget = pop.getDialog("mapNpc")
        if widget ~= nil then
            widget:getChildByName("view"):getChildByName("tips"):setVisible(false)
        end
    end
    if eventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("mapNpc")
        if widget ~= nil then
            local tag = sender:getTag()
            cclog("ontips:"..tag)
            if tag == 1 then
                if widget._id > 300 and widget._id < 400  then
                    widget:getChildByName("view"):getChildByName("tips"):getChildByName("label"):setString(ff.langString("击杀僵尸必然获得一个资源物品(种类随机)"))
                else
                    widget:getChildByName("view"):getChildByName("tips"):getChildByName("label"):setString(ff.langString("击杀僵尸必然获得一个资源物品(种类随机)"))
                end
                local size = widget:getChildByName("view"):getChildByName("tips"):getChildByName("label"):getContentSize()
                widget:getChildByName("view"):getChildByName("tips"):setContentSize(cc.size(size.width + 20,30))                
                widget:getChildByName("view"):getChildByName("tips"):getChildByName("label"):setPositionX((size.width + 20) /2)
                widget:getChildByName("view"):getChildByName("tips"):setPositionX(50)
                widget:getChildByName("view"):getChildByName("tips"):getChildByName("Image_51"):setPositionX(70)
            elseif tag == 2 then    
                widget:getChildByName("view"):getChildByName("tips"):getChildByName("label"):setString(ff.langString("击杀僵尸必然获得英雄经验道具"))
                local size = widget:getChildByName("view"):getChildByName("tips"):getChildByName("label"):getContentSize()
                widget:getChildByName("view"):getChildByName("tips"):setContentSize(cc.size(size.width + 20,30))                
                widget:getChildByName("view"):getChildByName("tips"):getChildByName("label"):setPositionX((size.width + 20) /2)
                widget:getChildByName("view"):getChildByName("tips"):setPositionX(200)
                widget:getChildByName("view"):getChildByName("tips"):getChildByName("Image_51"):setPositionX(70)
            elseif tag == 3 then
                widget:getChildByName("view"):getChildByName("tips"):getChildByName("label"):setString(ff.langString("击杀僵尸有概率获得金币"))
                local size = widget:getChildByName("view"):getChildByName("tips"):getChildByName("label"):getContentSize()
                widget:getChildByName("view"):getChildByName("tips"):setContentSize(cc.size(size.width + 20,30))                
                widget:getChildByName("view"):getChildByName("tips"):getChildByName("label"):setPositionX((size.width + 20) /2)
                widget:getChildByName("view"):getChildByName("tips"):setPositionX(370)                
                widget:getChildByName("view"):getChildByName("tips"):getChildByName("Image_51"):setPositionX(70)
                --dd.showTips(ff.langString("击杀僵尸有概率获得金币"),20,cc.c3b(255,255,255))    
            else
                widget:getChildByName("view"):getChildByName("tips"):getChildByName("label"):setString(ff.langString("击杀僵尸有概率获得其他随机奖励"))
                local size = widget:getChildByName("view"):getChildByName("tips"):getChildByName("label"):getContentSize()
                widget:getChildByName("view"):getChildByName("tips"):setContentSize(cc.size(size.width + 20,30))                
                widget:getChildByName("view"):getChildByName("tips"):getChildByName("label"):setPositionX((size.width + 20) /2)
                widget:getChildByName("view"):getChildByName("tips"):setPositionX(720 - (size.width + 30))                
                widget:getChildByName("view"):getChildByName("tips"):getChildByName("Image_51"):setPositionX(size.width - 80)
            end
            widget:getChildByName("view"):getChildByName("tips"):setVisible(true)
            widget:getChildByName("view"):getChildByName("tips"):stopAllActions()
            widget:getChildByName("view"):getChildByName("tips"):runAction(cc.Sequence:create(cc.DelayTime:create(2),cc.CallFunc:create(theEnd)))
        end
    end
end

function mapnpcLayer:getBossInfo(  )
    local message = ff.net:createMessage()
    message:addCmd(0x00e)
    message:addLong(dd.uid)
    message:addLong(0)
    message:addLong(0)
    message:addLong(self._param.cid)
    ff.net:rpc(message,false)
end

--界面显示后调用
function mapnpcLayer.onStart(sender)
    if dd.cfgNpc[sender._id]['npcmode'] == 2  or sender._id == 999 then
        sender:getBossInfo()
    end
	sender:getChildByName("view"):getChildByName("icon"):loadTexture("images/world/icon/npc/"..dd.cfgNpc[sender._id]['image']..".png")
    schedule(sender,sender.updateActice,1)
end

function mapnpcLayer:onGetBoss(params)
    local code = params[1]
    if code == 0 then
        if self._id == tonumber(params[2]) then
            if self._id ~= 999 then
                self:getChildByName("view"):getChildByName("progresshp"):setVisible(true)
                local per = tonumber(params[3])/tonumber(params[4])*100
                self:getChildByName("view"):getChildByName("progresshp"):getChildByName("progress"):setPercent(per)
                self:getChildByName("view"):getChildByName("progresshp"):getChildByName("exp"):setString(params[3].."/"..params[4])
            end
            self._state = tonumber(params[5])
            self._endTime = tonumber(params[6])
        end

        if tonumber(params[5]) == 9 then
            self:getChildByName("view"):getChildByName("battle"):setBright(false)
            self:getChildByName("view"):getChildByName("battle"):setTouchEnabled(false)
            local time  = self._endTime - dd.getServerTime()
            self:getChildByName("view"):getChildByName("battle"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
        elseif tonumber(params[5]) == 1 then
            self._endTime = 0 
            self:getChildByName("view"):getChildByName("battle"):setBright(true)
            self:getChildByName("view"):getChildByName("battle"):setTouchEnabled(true)
            self:getChildByName("view"):getChildByName("battle"):getChildByName("time"):setString("")
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end


--界面关闭效果结束后调用
function mapnpcLayer.onEnd(sender)
    if ff.platform ~= 1 then
        sender:getChildByName("view"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
    sender:stopAllActions()
    ff.net:removeEvent(2,dd.Tjf_MapGetMonsterDetail)
end
--界面即将播放显示缓动时调用，返回false界面显示将终止
function mapnpcLayer.onBefore(sender)
    ff.net:registerEvent(2,dd.Tjf_MapGetMonsterDetail, function (message)sender:onGetBoss(message)end)
    if dd.cfgNpc[sender._id]['attackmode'] == 2 then
        sender:getChildByName("view"):getChildByName("battle"):getChildByName("chu_label"):setString(ff.langString("联合攻击"))
    else
        sender:getChildByName("view"):getChildByName("battle"):getChildByName("chu_label"):setString(ff.langString("攻击"))

    end

    return true
end
function mapnpcLayer.onReturn(sender)
	local widget = pop.getDialog("mapNpc")
	if widget ~= nil and widget:isVisible() == true then
		pop.onClosePopDialog("mapNpc")
		return true
	end
	return false
end

function onShowMapNpc(widget,params)
    local layer = mapnpcLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer._param = params
    layer._id = params.npcid
    cclog("_id:"..layer._id)
    layer:onInit()
    return layer
end
